---
title: slope.core
---

<div>
    <main class="pdoc">
            <section class="module-info">
                    <h1 class="modulename">
slope<wbr>.core    </h1>

                
                        <input id="mod-core-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">

                        <label class="view-source-button" for="mod-core-view-source"><span>View Source</span></label>

                        <div class="pdoc-code codehilite"><pre><span></span><span id="L-1"><a href="#L-1"><span class="linenos">   1</span></a><span class="kn">from</span> <span class="nn">pathlib</span> <span class="kn">import</span> <span class="n">Path</span>
</span><span id="L-2"><a href="#L-2"><span class="linenos">   2</span></a><span class="kn">import</span> <span class="nn">os</span>
</span><span id="L-3"><a href="#L-3"><span class="linenos">   3</span></a><span class="kn">import</span> <span class="nn">json</span>
</span><span id="L-4"><a href="#L-4"><span class="linenos">   4</span></a><span class="kn">from</span> <span class="nn">typing</span> <span class="kn">import</span> <span class="p">(</span>
</span><span id="L-5"><a href="#L-5"><span class="linenos">   5</span></a>    <span class="n">Callable</span><span class="p">,</span>
</span><span id="L-6"><a href="#L-6"><span class="linenos">   6</span></a>    <span class="n">NamedTuple</span><span class="p">,</span>
</span><span id="L-7"><a href="#L-7"><span class="linenos">   7</span></a>    <span class="n">Dict</span><span class="p">,</span>
</span><span id="L-8"><a href="#L-8"><span class="linenos">   8</span></a>    <span class="n">Hashable</span><span class="p">,</span>
</span><span id="L-9"><a href="#L-9"><span class="linenos">   9</span></a>    <span class="n">List</span><span class="p">,</span>
</span><span id="L-10"><a href="#L-10"><span class="linenos">  10</span></a>    <span class="n">Any</span><span class="p">,</span>
</span><span id="L-11"><a href="#L-11"><span class="linenos">  11</span></a>    <span class="n">Iterable</span><span class="p">,</span>
</span><span id="L-12"><a href="#L-12"><span class="linenos">  12</span></a>    <span class="n">Sequence</span><span class="p">,</span>
</span><span id="L-13"><a href="#L-13"><span class="linenos">  13</span></a>    <span class="n">Iterator</span><span class="p">,</span>
</span><span id="L-14"><a href="#L-14"><span class="linenos">  14</span></a>    <span class="n">Type</span><span class="p">,</span>
</span><span id="L-15"><a href="#L-15"><span class="linenos">  15</span></a>    <span class="n">Tuple</span><span class="p">,</span>
</span><span id="L-16"><a href="#L-16"><span class="linenos">  16</span></a>    <span class="n">Optional</span><span class="p">,</span>
</span><span id="L-17"><a href="#L-17"><span class="linenos">  17</span></a>    <span class="n">Union</span><span class="p">,</span>
</span><span id="L-18"><a href="#L-18"><span class="linenos">  18</span></a>    <span class="n">Dict</span><span class="p">,</span>
</span><span id="L-19"><a href="#L-19"><span class="linenos">  19</span></a>    <span class="n">Set</span><span class="p">,</span>
</span><span id="L-20"><a href="#L-20"><span class="linenos">  20</span></a>    <span class="n">DefaultDict</span><span class="p">,</span>
</span><span id="L-21"><a href="#L-21"><span class="linenos">  21</span></a>    <span class="n">Final</span><span class="p">,</span>
</span><span id="L-22"><a href="#L-22"><span class="linenos">  22</span></a><span class="p">)</span>
</span><span id="L-23"><a href="#L-23"><span class="linenos">  23</span></a><span class="kn">import</span> <span class="nn">weakref</span>
</span><span id="L-24"><a href="#L-24"><span class="linenos">  24</span></a><span class="kn">import</span> <span class="nn">types</span>
</span><span id="L-25"><a href="#L-25"><span class="linenos">  25</span></a><span class="kn">from</span> <span class="nn">contextlib</span> <span class="kn">import</span> <span class="n">contextmanager</span><span class="p">,</span> <span class="n">ContextDecorator</span>
</span><span id="L-26"><a href="#L-26"><span class="linenos">  26</span></a><span class="kn">import</span> <span class="nn">itertools</span>
</span><span id="L-27"><a href="#L-27"><span class="linenos">  27</span></a><span class="kn">import</span> <span class="nn">weakref</span>
</span><span id="L-28"><a href="#L-28"><span class="linenos">  28</span></a><span class="kn">import</span> <span class="nn">operator</span> <span class="k">as</span> <span class="nn">operator_py</span>
</span><span id="L-29"><a href="#L-29"><span class="linenos">  29</span></a><span class="kn">import</span> <span class="nn">numpy</span> <span class="k">as</span> <span class="nn">np</span>
</span><span id="L-30"><a href="#L-30"><span class="linenos">  30</span></a><span class="kn">import</span> <span class="nn">math</span>
</span><span id="L-31"><a href="#L-31"><span class="linenos">  31</span></a><span class="kn">import</span> <span class="nn">inspect</span>
</span><span id="L-32"><a href="#L-32"><span class="linenos">  32</span></a><span class="kn">from</span> <span class="nn">functools</span> <span class="kn">import</span> <span class="n">partial</span><span class="p">,</span> <span class="n">lru_cache</span>
</span><span id="L-33"><a href="#L-33"><span class="linenos">  33</span></a><span class="kn">import</span> <span class="nn">mmap</span>
</span><span id="L-34"><a href="#L-34"><span class="linenos">  34</span></a><span class="kn">import</span> <span class="nn">traceback</span>
</span><span id="L-35"><a href="#L-35"><span class="linenos">  35</span></a><span class="kn">import</span> <span class="nn">importlib</span>
</span><span id="L-36"><a href="#L-36"><span class="linenos">  36</span></a><span class="kn">import</span> <span class="nn">time</span>
</span><span id="L-37"><a href="#L-37"><span class="linenos">  37</span></a><span class="kn">import</span> <span class="nn">cProfile</span>
</span><span id="L-38"><a href="#L-38"><span class="linenos">  38</span></a><span class="kn">import</span> <span class="nn">pstats</span>
</span><span id="L-39"><a href="#L-39"><span class="linenos">  39</span></a>
</span><span id="L-40"><a href="#L-40"><span class="linenos">  40</span></a><span class="c1"># =================================</span>
</span><span id="L-41"><a href="#L-41"><span class="linenos">  41</span></a><span class="c1">#   Utils</span>
</span><span id="L-42"><a href="#L-42"><span class="linenos">  42</span></a><span class="c1"># =================================</span>
</span><span id="L-43"><a href="#L-43"><span class="linenos">  43</span></a>
</span><span id="L-44"><a href="#L-44"><span class="linenos">  44</span></a>
</span><span id="L-45"><a href="#L-45"><span class="linenos">  45</span></a><span class="k">class</span> <span class="nc">Timing</span><span class="p">(</span><span class="n">ContextDecorator</span><span class="p">):</span>
</span><span id="L-46"><a href="#L-46"><span class="linenos">  46</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">prefix</span><span class="o">=</span><span class="s2">&quot;&quot;</span><span class="p">,</span> <span class="n">on_exit</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">enabled</span><span class="o">=</span><span class="kc">True</span><span class="p">):</span>
</span><span id="L-47"><a href="#L-47"><span class="linenos">  47</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">prefix</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">on_exit</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">enabled</span> <span class="o">=</span> <span class="n">prefix</span><span class="p">,</span> <span class="n">on_exit</span><span class="p">,</span> <span class="n">enabled</span>
</span><span id="L-48"><a href="#L-48"><span class="linenos">  48</span></a>
</span><span id="L-49"><a href="#L-49"><span class="linenos">  49</span></a>    <span class="k">def</span> <span class="fm">__enter__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-50"><a href="#L-50"><span class="linenos">  50</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">st</span> <span class="o">=</span> <span class="n">time</span><span class="o">.</span><span class="n">perf_counter_ns</span><span class="p">()</span>
</span><span id="L-51"><a href="#L-51"><span class="linenos">  51</span></a>
</span><span id="L-52"><a href="#L-52"><span class="linenos">  52</span></a>    <span class="k">def</span> <span class="fm">__exit__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="n">exc</span><span class="p">):</span>
</span><span id="L-53"><a href="#L-53"><span class="linenos">  53</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">et</span> <span class="o">=</span> <span class="n">time</span><span class="o">.</span><span class="n">perf_counter_ns</span><span class="p">()</span> <span class="o">-</span> <span class="bp">self</span><span class="o">.</span><span class="n">st</span>
</span><span id="L-54"><a href="#L-54"><span class="linenos">  54</span></a>        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">enabled</span><span class="p">:</span>
</span><span id="L-55"><a href="#L-55"><span class="linenos">  55</span></a>            <span class="nb">print</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">prefix</span><span class="si">}{</span><span class="bp">self</span><span class="o">.</span><span class="n">et</span><span class="o">*</span><span class="mf">1e-6</span><span class="si">:</span><span class="s2">6.2f</span><span class="si">}</span><span class="s2"> ms&quot;</span> <span class="o">+</span> <span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">on_exit</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">et</span><span class="p">)</span> <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">on_exit</span> <span class="k">else</span> <span class="s2">&quot;&quot;</span><span class="p">))</span>
</span><span id="L-56"><a href="#L-56"><span class="linenos">  56</span></a>
</span><span id="L-57"><a href="#L-57"><span class="linenos">  57</span></a>
</span><span id="L-58"><a href="#L-58"><span class="linenos">  58</span></a><span class="k">def</span> <span class="nf">colored</span><span class="p">(</span><span class="n">st</span><span class="p">,</span> <span class="n">color</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="nb">str</span><span class="p">],</span> <span class="n">background</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>
</span><span id="L-59"><a href="#L-59"><span class="linenos">  59</span></a>    <span class="k">return</span> <span class="p">(</span>
</span><span id="L-60"><a href="#L-60"><span class="linenos">  60</span></a>        <span class="sa">f</span><span class="s2">&quot;</span><span class="se">\u001b</span><span class="s2">[</span><span class="si">{</span><span class="mi">10</span><span class="o">*</span><span class="n">background</span><span class="o">+</span><span class="mi">60</span><span class="o">*</span><span class="p">(</span><span class="n">color</span><span class="o">.</span><span class="n">upper</span><span class="p">()</span><span class="w"> </span><span class="o">==</span><span class="w"> </span><span class="n">color</span><span class="p">)</span><span class="o">+</span><span class="mi">30</span><span class="o">+</span><span class="p">[</span><span class="s1">&#39;black&#39;</span><span class="p">,</span><span class="w"> </span><span class="s1">&#39;red&#39;</span><span class="p">,</span><span class="w"> </span><span class="s1">&#39;green&#39;</span><span class="p">,</span><span class="w"> </span><span class="s1">&#39;yellow&#39;</span><span class="p">,</span><span class="w"> </span><span class="s1">&#39;blue&#39;</span><span class="p">,</span><span class="w"> </span><span class="s1">&#39;magenta&#39;</span><span class="p">,</span><span class="w"> </span><span class="s1">&#39;cyan&#39;</span><span class="p">,</span><span class="w"> </span><span class="s1">&#39;white&#39;</span><span class="p">]</span><span class="o">.</span><span class="n">index</span><span class="p">(</span><span class="n">color</span><span class="o">.</span><span class="n">lower</span><span class="p">())</span><span class="si">}</span><span class="s2">m</span><span class="si">{</span><span class="n">st</span><span class="si">}</span><span class="se">\u001b</span><span class="s2">[0m&quot;</span>
</span><span id="L-61"><a href="#L-61"><span class="linenos">  61</span></a>        <span class="k">if</span> <span class="n">color</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span>
</span><span id="L-62"><a href="#L-62"><span class="linenos">  62</span></a>        <span class="k">else</span> <span class="n">st</span>
</span><span id="L-63"><a href="#L-63"><span class="linenos">  63</span></a>    <span class="p">)</span>  <span class="c1"># replace the termcolor library with one line  # noqa: E501</span>
</span><span id="L-64"><a href="#L-64"><span class="linenos">  64</span></a>
</span><span id="L-65"><a href="#L-65"><span class="linenos">  65</span></a>
</span><span id="L-66"><a href="#L-66"><span class="linenos">  66</span></a><span class="k">def</span> <span class="nf">_format_fcn</span><span class="p">(</span><span class="n">fcn</span><span class="p">):</span>
</span><span id="L-67"><a href="#L-67"><span class="linenos">  67</span></a>    <span class="k">return</span> <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">fcn</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="si">}</span><span class="s2">:</span><span class="si">{</span><span class="n">fcn</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span><span class="si">}</span><span class="s2">:</span><span class="si">{</span><span class="n">fcn</span><span class="p">[</span><span class="mi">2</span><span class="p">]</span><span class="si">}</span><span class="s2">&quot;</span>
</span><span id="L-68"><a href="#L-68"><span class="linenos">  68</span></a>
</span><span id="L-69"><a href="#L-69"><span class="linenos">  69</span></a>
</span><span id="L-70"><a href="#L-70"><span class="linenos">  70</span></a><span class="k">class</span> <span class="nc">Profiling</span><span class="p">(</span><span class="n">ContextDecorator</span><span class="p">):</span>
</span><span id="L-71"><a href="#L-71"><span class="linenos">  71</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">enabled</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">sort</span><span class="o">=</span><span class="s2">&quot;cumtime&quot;</span><span class="p">,</span> <span class="n">frac</span><span class="o">=</span><span class="mf">0.2</span><span class="p">,</span> <span class="n">fn</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">ts</span><span class="o">=</span><span class="mi">1</span><span class="p">):</span>
</span><span id="L-72"><a href="#L-72"><span class="linenos">  72</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">enabled</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">sort</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">frac</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">fn</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">time_scale</span> <span class="o">=</span> <span class="n">enabled</span><span class="p">,</span> <span class="n">sort</span><span class="p">,</span> <span class="n">frac</span><span class="p">,</span> <span class="n">fn</span><span class="p">,</span> <span class="mf">1e3</span> <span class="o">/</span> <span class="n">ts</span>
</span><span id="L-73"><a href="#L-73"><span class="linenos">  73</span></a>
</span><span id="L-74"><a href="#L-74"><span class="linenos">  74</span></a>    <span class="k">def</span> <span class="fm">__enter__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-75"><a href="#L-75"><span class="linenos">  75</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">pr</span> <span class="o">=</span> <span class="n">cProfile</span><span class="o">.</span><span class="n">Profile</span><span class="p">()</span>
</span><span id="L-76"><a href="#L-76"><span class="linenos">  76</span></a>        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">enabled</span><span class="p">:</span>
</span><span id="L-77"><a href="#L-77"><span class="linenos">  77</span></a>            <span class="bp">self</span><span class="o">.</span><span class="n">pr</span><span class="o">.</span><span class="n">enable</span><span class="p">()</span>
</span><span id="L-78"><a href="#L-78"><span class="linenos">  78</span></a>
</span><span id="L-79"><a href="#L-79"><span class="linenos">  79</span></a>    <span class="k">def</span> <span class="fm">__exit__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="n">exc</span><span class="p">):</span>
</span><span id="L-80"><a href="#L-80"><span class="linenos">  80</span></a>        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">enabled</span><span class="p">:</span>
</span><span id="L-81"><a href="#L-81"><span class="linenos">  81</span></a>            <span class="bp">self</span><span class="o">.</span><span class="n">pr</span><span class="o">.</span><span class="n">disable</span><span class="p">()</span>
</span><span id="L-82"><a href="#L-82"><span class="linenos">  82</span></a>            <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">fn</span><span class="p">:</span>
</span><span id="L-83"><a href="#L-83"><span class="linenos">  83</span></a>                <span class="bp">self</span><span class="o">.</span><span class="n">pr</span><span class="o">.</span><span class="n">dump_stats</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">fn</span><span class="p">)</span>
</span><span id="L-84"><a href="#L-84"><span class="linenos">  84</span></a>            <span class="n">stats</span> <span class="o">=</span> <span class="n">pstats</span><span class="o">.</span><span class="n">Stats</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">pr</span><span class="p">)</span><span class="o">.</span><span class="n">strip_dirs</span><span class="p">()</span><span class="o">.</span><span class="n">sort_stats</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">sort</span><span class="p">)</span>
</span><span id="L-85"><a href="#L-85"><span class="linenos">  85</span></a>            <span class="k">for</span> <span class="n">fcn</span> <span class="ow">in</span> <span class="n">stats</span><span class="o">.</span><span class="n">fcn_list</span><span class="p">[</span><span class="mi">0</span> <span class="p">:</span> <span class="nb">int</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">stats</span><span class="o">.</span><span class="n">fcn_list</span><span class="p">)</span> <span class="o">*</span> <span class="bp">self</span><span class="o">.</span><span class="n">frac</span><span class="p">)]:</span>  <span class="c1"># type: ignore[attr-defined]</span>
</span><span id="L-86"><a href="#L-86"><span class="linenos">  86</span></a>                <span class="p">(</span><span class="n">_primitive_calls</span><span class="p">,</span> <span class="n">num_calls</span><span class="p">,</span> <span class="n">tottime</span><span class="p">,</span> <span class="n">cumtime</span><span class="p">,</span> <span class="n">callers</span><span class="p">)</span> <span class="o">=</span> <span class="n">stats</span><span class="o">.</span><span class="n">stats</span><span class="p">[</span><span class="n">fcn</span><span class="p">]</span>  <span class="c1"># type: ignore[attr-defined]</span>
</span><span id="L-87"><a href="#L-87"><span class="linenos">  87</span></a>                <span class="n">scallers</span> <span class="o">=</span> <span class="nb">sorted</span><span class="p">(</span><span class="n">callers</span><span class="o">.</span><span class="n">items</span><span class="p">(),</span> <span class="n">key</span><span class="o">=</span><span class="k">lambda</span> <span class="n">x</span><span class="p">:</span> <span class="o">-</span><span class="n">x</span><span class="p">[</span><span class="mi">1</span><span class="p">][</span><span class="mi">2</span><span class="p">])</span>
</span><span id="L-88"><a href="#L-88"><span class="linenos">  88</span></a>                <span class="nb">print</span><span class="p">(</span>
</span><span id="L-89"><a href="#L-89"><span class="linenos">  89</span></a>                    <span class="sa">f</span><span class="s2">&quot;n:</span><span class="si">{</span><span class="n">num_calls</span><span class="si">:</span><span class="s2">8d</span><span class="si">}</span><span class="s2">  tm:</span><span class="si">{</span><span class="n">tottime</span><span class="o">*</span><span class="bp">self</span><span class="o">.</span><span class="n">time_scale</span><span class="si">:</span><span class="s2">7.2f</span><span class="si">}</span><span class="s2">ms  tot:</span><span class="si">{</span><span class="n">cumtime</span><span class="o">*</span><span class="bp">self</span><span class="o">.</span><span class="n">time_scale</span><span class="si">:</span><span class="s2">7.2f</span><span class="si">}</span><span class="s2">ms&quot;</span><span class="p">,</span>
</span><span id="L-90"><a href="#L-90"><span class="linenos">  90</span></a>                    <span class="n">colored</span><span class="p">(</span><span class="n">_format_fcn</span><span class="p">(</span><span class="n">fcn</span><span class="p">),</span> <span class="s2">&quot;yellow&quot;</span><span class="p">)</span> <span class="o">+</span> <span class="s2">&quot; &quot;</span> <span class="o">*</span> <span class="p">(</span><span class="mi">50</span> <span class="o">-</span> <span class="nb">len</span><span class="p">(</span><span class="n">_format_fcn</span><span class="p">(</span><span class="n">fcn</span><span class="p">))),</span>
</span><span id="L-91"><a href="#L-91"><span class="linenos">  91</span></a>                    <span class="n">colored</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;&lt;- </span><span class="si">{</span><span class="p">(</span><span class="n">scallers</span><span class="p">[</span><span class="mi">0</span><span class="p">][</span><span class="mi">1</span><span class="p">][</span><span class="mi">2</span><span class="p">]</span><span class="o">/</span><span class="n">tottime</span><span class="p">)</span><span class="o">*</span><span class="mi">100</span><span class="si">:</span><span class="s2">3.0f</span><span class="si">}</span><span class="s2">% </span><span class="si">{</span><span class="n">_format_fcn</span><span class="p">(</span><span class="n">scallers</span><span class="p">[</span><span class="mi">0</span><span class="p">][</span><span class="mi">0</span><span class="p">])</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">,</span> <span class="s2">&quot;BLACK&quot;</span><span class="p">)</span> <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">scallers</span><span class="p">)</span> <span class="k">else</span> <span class="s2">&quot;&quot;</span><span class="p">,</span>
</span><span id="L-92"><a href="#L-92"><span class="linenos">  92</span></a>                <span class="p">)</span>
</span><span id="L-93"><a href="#L-93"><span class="linenos">  93</span></a>
</span><span id="L-94"><a href="#L-94"><span class="linenos">  94</span></a>
</span><span id="L-95"><a href="#L-95"><span class="linenos">  95</span></a><span class="k">def</span> <span class="nf">dblog</span><span class="p">(</span><span class="o">*</span><span class="n">msg</span><span class="p">,</span> <span class="n">enable</span><span class="o">=</span><span class="kc">True</span><span class="p">):</span>
</span><span id="L-96"><a href="#L-96"><span class="linenos">  96</span></a>    <span class="k">if</span> <span class="n">enable</span><span class="p">:</span>
</span><span id="L-97"><a href="#L-97"><span class="linenos">  97</span></a>        <span class="nb">print</span><span class="p">(</span><span class="o">*</span><span class="n">msg</span><span class="p">)</span>
</span><span id="L-98"><a href="#L-98"><span class="linenos">  98</span></a>
</span><span id="L-99"><a href="#L-99"><span class="linenos">  99</span></a>
</span><span id="L-100"><a href="#L-100"><span class="linenos"> 100</span></a><span class="k">def</span> <span class="nf">unzip2</span><span class="p">(</span><span class="n">pairs</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Tuple</span><span class="p">[</span><span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">],</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">]]:</span>
</span><span id="L-101"><a href="#L-101"><span class="linenos"> 101</span></a>    <span class="n">lst1</span><span class="p">,</span> <span class="n">lst2</span> <span class="o">=</span> <span class="p">[],</span> <span class="p">[]</span>
</span><span id="L-102"><a href="#L-102"><span class="linenos"> 102</span></a>    <span class="k">for</span> <span class="n">i1</span><span class="p">,</span> <span class="n">i2</span> <span class="ow">in</span> <span class="n">pairs</span><span class="p">:</span>
</span><span id="L-103"><a href="#L-103"><span class="linenos"> 103</span></a>        <span class="n">lst1</span> <span class="o">+=</span> <span class="p">[</span><span class="n">i1</span><span class="p">]</span>
</span><span id="L-104"><a href="#L-104"><span class="linenos"> 104</span></a>        <span class="n">lst2</span> <span class="o">+=</span> <span class="p">[</span><span class="n">i2</span><span class="p">]</span>
</span><span id="L-105"><a href="#L-105"><span class="linenos"> 105</span></a>    <span class="k">return</span> <span class="n">lst1</span><span class="p">,</span> <span class="n">lst2</span>
</span><span id="L-106"><a href="#L-106"><span class="linenos"> 106</span></a>
</span><span id="L-107"><a href="#L-107"><span class="linenos"> 107</span></a>
</span><span id="L-108"><a href="#L-108"><span class="linenos"> 108</span></a><span class="k">def</span> <span class="nf">list_map</span><span class="p">(</span><span class="n">f</span><span class="p">:</span> <span class="n">Callable</span><span class="p">,</span> <span class="o">*</span><span class="n">xs</span><span class="p">:</span> <span class="n">Iterable</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">]:</span>
</span><span id="L-109"><a href="#L-109"><span class="linenos"> 109</span></a>    <span class="k">return</span> <span class="nb">list</span><span class="p">(</span><span class="nb">map</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="o">*</span><span class="n">xs</span><span class="p">))</span>
</span><span id="L-110"><a href="#L-110"><span class="linenos"> 110</span></a>
</span><span id="L-111"><a href="#L-111"><span class="linenos"> 111</span></a>
</span><span id="L-112"><a href="#L-112"><span class="linenos"> 112</span></a><span class="k">def</span> <span class="nf">list_zip</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">])</span> <span class="o">-&gt;</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">]:</span>
</span><span id="L-113"><a href="#L-113"><span class="linenos"> 113</span></a>    <span class="n">fst</span><span class="p">,</span> <span class="o">*</span><span class="n">rest</span> <span class="o">=</span> <span class="n">args</span> <span class="o">=</span> <span class="n">list_map</span><span class="p">(</span><span class="nb">list</span><span class="p">,</span> <span class="n">args</span><span class="p">)</span>
</span><span id="L-114"><a href="#L-114"><span class="linenos"> 114</span></a>    <span class="n">n</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">fst</span><span class="p">)</span>
</span><span id="L-115"><a href="#L-115"><span class="linenos"> 115</span></a>    <span class="k">for</span> <span class="n">arg</span> <span class="ow">in</span> <span class="n">rest</span><span class="p">:</span>
</span><span id="L-116"><a href="#L-116"><span class="linenos"> 116</span></a>        <span class="k">assert</span> <span class="nb">len</span><span class="p">(</span><span class="n">arg</span><span class="p">)</span> <span class="o">==</span> <span class="n">n</span>
</span><span id="L-117"><a href="#L-117"><span class="linenos"> 117</span></a>    <span class="k">return</span> <span class="nb">list</span><span class="p">(</span><span class="nb">zip</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">))</span>
</span><span id="L-118"><a href="#L-118"><span class="linenos"> 118</span></a>
</span><span id="L-119"><a href="#L-119"><span class="linenos"> 119</span></a>
</span><span id="L-120"><a href="#L-120"><span class="linenos"> 120</span></a><span class="k">def</span> <span class="nf">split_half</span><span class="p">(</span><span class="n">lst</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">])</span> <span class="o">-&gt;</span> <span class="n">Tuple</span><span class="p">[</span><span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">],</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">]]:</span>
</span><span id="L-121"><a href="#L-121"><span class="linenos"> 121</span></a>    <span class="k">assert</span> <span class="ow">not</span> <span class="nb">len</span><span class="p">(</span><span class="n">lst</span><span class="p">)</span> <span class="o">%</span> <span class="mi">2</span>
</span><span id="L-122"><a href="#L-122"><span class="linenos"> 122</span></a>    <span class="k">return</span> <span class="n">split_list</span><span class="p">(</span><span class="n">lst</span><span class="p">,</span> <span class="nb">len</span><span class="p">(</span><span class="n">lst</span><span class="p">)</span> <span class="o">//</span> <span class="mi">2</span><span class="p">)</span>
</span><span id="L-123"><a href="#L-123"><span class="linenos"> 123</span></a>
</span><span id="L-124"><a href="#L-124"><span class="linenos"> 124</span></a>
</span><span id="L-125"><a href="#L-125"><span class="linenos"> 125</span></a><span class="k">def</span> <span class="nf">merge_lists</span><span class="p">(</span><span class="n">which</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="nb">bool</span><span class="p">],</span> <span class="n">l1</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">],</span> <span class="n">l2</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">])</span> <span class="o">-&gt;</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">]:</span>
</span><span id="L-126"><a href="#L-126"><span class="linenos"> 126</span></a>    <span class="n">l1</span><span class="p">,</span> <span class="n">l2</span> <span class="o">=</span> <span class="nb">iter</span><span class="p">(</span><span class="n">l1</span><span class="p">),</span> <span class="nb">iter</span><span class="p">(</span><span class="n">l2</span><span class="p">)</span>
</span><span id="L-127"><a href="#L-127"><span class="linenos"> 127</span></a>    <span class="n">out</span> <span class="o">=</span> <span class="p">[</span><span class="nb">next</span><span class="p">(</span><span class="n">l2</span><span class="p">)</span> <span class="k">if</span> <span class="n">b</span> <span class="k">else</span> <span class="nb">next</span><span class="p">(</span><span class="n">l1</span><span class="p">)</span> <span class="k">for</span> <span class="n">b</span> <span class="ow">in</span> <span class="n">which</span><span class="p">]</span>
</span><span id="L-128"><a href="#L-128"><span class="linenos"> 128</span></a>    <span class="k">assert</span> <span class="nb">next</span><span class="p">(</span><span class="n">l1</span><span class="p">,</span> <span class="kc">None</span><span class="p">)</span> <span class="ow">is</span> <span class="nb">next</span><span class="p">(</span><span class="n">l2</span><span class="p">,</span> <span class="kc">None</span><span class="p">)</span> <span class="ow">is</span> <span class="kc">None</span>
</span><span id="L-129"><a href="#L-129"><span class="linenos"> 129</span></a>    <span class="k">return</span> <span class="n">out</span>
</span><span id="L-130"><a href="#L-130"><span class="linenos"> 130</span></a>
</span><span id="L-131"><a href="#L-131"><span class="linenos"> 131</span></a>
</span><span id="L-132"><a href="#L-132"><span class="linenos"> 132</span></a><span class="k">def</span> <span class="nf">split_list</span><span class="p">(</span><span class="n">lst</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">],</span> <span class="n">n</span><span class="p">:</span> <span class="nb">int</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Tuple</span><span class="p">[</span><span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">],</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">]]:</span>
</span><span id="L-133"><a href="#L-133"><span class="linenos"> 133</span></a>    <span class="k">assert</span> <span class="mi">0</span> <span class="o">&lt;=</span> <span class="n">n</span> <span class="o">&lt;=</span> <span class="nb">len</span><span class="p">(</span><span class="n">lst</span><span class="p">)</span>
</span><span id="L-134"><a href="#L-134"><span class="linenos"> 134</span></a>    <span class="k">return</span> <span class="n">lst</span><span class="p">[:</span><span class="n">n</span><span class="p">],</span> <span class="n">lst</span><span class="p">[</span><span class="n">n</span><span class="p">:]</span>
</span><span id="L-135"><a href="#L-135"><span class="linenos"> 135</span></a>
</span><span id="L-136"><a href="#L-136"><span class="linenos"> 136</span></a>
</span><span id="L-137"><a href="#L-137"><span class="linenos"> 137</span></a><span class="c1"># def partition_list(bs: List[bool], l: List[Any]) -&gt; Tuple[List[Any], List[Any]]:</span>
</span><span id="L-138"><a href="#L-138"><span class="linenos"> 138</span></a><span class="c1">#     assert len(bs) == len(l)</span>
</span><span id="L-139"><a href="#L-139"><span class="linenos"> 139</span></a><span class="c1">#     lists = lst1, lst2 = [], []</span>
</span><span id="L-140"><a href="#L-140"><span class="linenos"> 140</span></a><span class="c1">#     for b, x in list_zip(bs, l):</span>
</span><span id="L-141"><a href="#L-141"><span class="linenos"> 141</span></a><span class="c1">#         lst = lists[int(b)]</span>
</span><span id="L-142"><a href="#L-142"><span class="linenos"> 142</span></a><span class="c1">#         lst += [x]</span>
</span><span id="L-143"><a href="#L-143"><span class="linenos"> 143</span></a><span class="c1">#     breakpoint()</span>
</span><span id="L-144"><a href="#L-144"><span class="linenos"> 144</span></a><span class="c1">#     return lst1, lst2</span>
</span><span id="L-145"><a href="#L-145"><span class="linenos"> 145</span></a>
</span><span id="L-146"><a href="#L-146"><span class="linenos"> 146</span></a>
</span><span id="L-147"><a href="#L-147"><span class="linenos"> 147</span></a><span class="k">def</span> <span class="nf">split_list</span><span class="p">(</span><span class="n">lst</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">],</span> <span class="n">n</span><span class="p">:</span> <span class="nb">int</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Tuple</span><span class="p">[</span><span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">],</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">]]:</span>
</span><span id="L-148"><a href="#L-148"><span class="linenos"> 148</span></a>    <span class="k">assert</span> <span class="mi">0</span> <span class="o">&lt;=</span> <span class="n">n</span> <span class="o">&lt;=</span> <span class="nb">len</span><span class="p">(</span><span class="n">lst</span><span class="p">)</span>
</span><span id="L-149"><a href="#L-149"><span class="linenos"> 149</span></a>    <span class="k">return</span> <span class="n">lst</span><span class="p">[:</span><span class="n">n</span><span class="p">],</span> <span class="n">lst</span><span class="p">[</span><span class="n">n</span><span class="p">:]</span>
</span><span id="L-150"><a href="#L-150"><span class="linenos"> 150</span></a>
</span><span id="L-151"><a href="#L-151"><span class="linenos"> 151</span></a>
</span><span id="L-152"><a href="#L-152"><span class="linenos"> 152</span></a><span class="k">def</span> <span class="nf">partition_list</span><span class="p">(</span><span class="n">bs</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="nb">bool</span><span class="p">],</span> <span class="n">l</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">])</span> <span class="o">-&gt;</span> <span class="n">Tuple</span><span class="p">[</span><span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">],</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">]]:</span>
</span><span id="L-153"><a href="#L-153"><span class="linenos"> 153</span></a>    <span class="k">assert</span> <span class="nb">len</span><span class="p">(</span><span class="n">bs</span><span class="p">)</span> <span class="o">==</span> <span class="nb">len</span><span class="p">(</span><span class="n">l</span><span class="p">)</span>
</span><span id="L-154"><a href="#L-154"><span class="linenos"> 154</span></a>    <span class="n">lists</span> <span class="o">=</span> <span class="n">lst1</span><span class="p">,</span> <span class="n">lst2</span> <span class="o">=</span> <span class="p">[],</span> <span class="p">[]</span>
</span><span id="L-155"><a href="#L-155"><span class="linenos"> 155</span></a>    <span class="k">for</span> <span class="n">b</span><span class="p">,</span> <span class="n">x</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">bs</span><span class="p">,</span> <span class="n">l</span><span class="p">):</span>
</span><span id="L-156"><a href="#L-156"><span class="linenos"> 156</span></a>        <span class="n">lists</span><span class="p">[</span><span class="n">b</span><span class="p">]</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">x</span><span class="p">)</span>
</span><span id="L-157"><a href="#L-157"><span class="linenos"> 157</span></a>    <span class="k">return</span> <span class="n">lst1</span><span class="p">,</span> <span class="n">lst2</span>
</span><span id="L-158"><a href="#L-158"><span class="linenos"> 158</span></a>
</span><span id="L-159"><a href="#L-159"><span class="linenos"> 159</span></a>
</span><span id="L-160"><a href="#L-160"><span class="linenos"> 160</span></a><span class="k">def</span> <span class="nf">lru_cache_verbose</span><span class="p">(</span>
</span><span id="L-161"><a href="#L-161"><span class="linenos"> 161</span></a>    <span class="n">maxsize</span><span class="p">:</span> <span class="nb">int</span> <span class="o">=</span> <span class="mi">100</span><span class="p">,</span>
</span><span id="L-162"><a href="#L-162"><span class="linenos"> 162</span></a>    <span class="n">typed</span><span class="p">:</span> <span class="nb">bool</span> <span class="o">=</span> <span class="kc">False</span><span class="p">,</span>
</span><span id="L-163"><a href="#L-163"><span class="linenos"> 163</span></a>    <span class="n">tb_start</span><span class="p">:</span> <span class="nb">int</span> <span class="o">=</span> <span class="o">-</span><span class="mi">12</span><span class="p">,</span>
</span><span id="L-164"><a href="#L-164"><span class="linenos"> 164</span></a>    <span class="n">tb_end</span><span class="p">:</span> <span class="nb">int</span> <span class="o">=</span> <span class="o">-</span><span class="mi">7</span><span class="p">,</span>
</span><span id="L-165"><a href="#L-165"><span class="linenos"> 165</span></a><span class="p">):</span>
</span><span id="L-166"><a href="#L-166"><span class="linenos"> 166</span></a>    <span class="k">def</span> <span class="nf">decorator</span><span class="p">(</span><span class="n">fn</span><span class="p">:</span> <span class="n">Callable</span><span class="p">):</span>
</span><span id="L-167"><a href="#L-167"><span class="linenos"> 167</span></a>        <span class="nd">@lru_cache</span><span class="p">(</span><span class="n">maxsize</span><span class="o">=</span><span class="n">maxsize</span><span class="p">,</span> <span class="n">typed</span><span class="o">=</span><span class="n">typed</span><span class="p">)</span>
</span><span id="L-168"><a href="#L-168"><span class="linenos"> 168</span></a>        <span class="k">def</span> <span class="nf">wrapper</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Callable</span><span class="p">:</span>
</span><span id="L-169"><a href="#L-169"><span class="linenos"> 169</span></a>            <span class="k">return</span> <span class="n">fn</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">)</span>
</span><span id="L-170"><a href="#L-170"><span class="linenos"> 170</span></a>
</span><span id="L-171"><a href="#L-171"><span class="linenos"> 171</span></a>        <span class="k">def</span> <span class="nf">decorated_function</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Any</span><span class="p">:</span>
</span><span id="L-172"><a href="#L-172"><span class="linenos"> 172</span></a>            <span class="n">result</span> <span class="o">=</span> <span class="n">wrapper</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">)</span>
</span><span id="L-173"><a href="#L-173"><span class="linenos"> 173</span></a>            <span class="n">cache_info</span> <span class="o">=</span> <span class="n">wrapper</span><span class="o">.</span><span class="n">cache_info</span><span class="p">()</span>
</span><span id="L-174"><a href="#L-174"><span class="linenos"> 174</span></a>
</span><span id="L-175"><a href="#L-175"><span class="linenos"> 175</span></a>            <span class="n">dblog</span><span class="p">(</span>
</span><span id="L-176"><a href="#L-176"><span class="linenos"> 176</span></a>                <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">fn</span><span class="o">.</span><span class="vm">__name__</span><span class="si">}</span><span class="s2">.</span><span class="si">{</span><span class="n">cache_info</span><span class="si">}</span><span class="s2"> </span><span class="si">{</span><span class="n">args</span><span class="o">.</span><span class="fm">__hash__</span><span class="p">()</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">,</span>
</span><span id="L-177"><a href="#L-177"><span class="linenos"> 177</span></a>                <span class="n">enable</span><span class="o">=</span><span class="n">backend</span><span class="o">.</span><span class="n">LOG_LRU</span><span class="p">,</span>
</span><span id="L-178"><a href="#L-178"><span class="linenos"> 178</span></a>            <span class="p">)</span>
</span><span id="L-179"><a href="#L-179"><span class="linenos"> 179</span></a>            <span class="n">tb</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">traceback</span><span class="o">.</span><span class="n">format_list</span><span class="p">(</span><span class="n">traceback</span><span class="o">.</span><span class="n">extract_stack</span><span class="p">())[</span><span class="n">tb_start</span><span class="p">:</span><span class="n">tb_end</span><span class="p">])</span><span class="o">.</span><span class="n">replace</span><span class="p">(</span><span class="s2">&quot;</span><span class="se">\n</span><span class="s2">    &quot;</span><span class="p">,</span> <span class="s2">&quot;:</span><span class="se">\t</span><span class="s2">&quot;</span><span class="p">)</span> <span class="o">+</span> <span class="s2">&quot;-&quot;</span> <span class="o">*</span> <span class="mi">20</span> <span class="o">+</span> <span class="s2">&quot;</span><span class="se">\n</span><span class="s2">&quot;</span>
</span><span id="L-180"><a href="#L-180"><span class="linenos"> 180</span></a>            <span class="n">dblog</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">tb</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">,</span> <span class="n">enable</span><span class="o">=</span><span class="n">backend</span><span class="o">.</span><span class="n">LOG_LRU</span><span class="p">)</span>
</span><span id="L-181"><a href="#L-181"><span class="linenos"> 181</span></a>
</span><span id="L-182"><a href="#L-182"><span class="linenos"> 182</span></a>            <span class="k">return</span> <span class="n">result</span>
</span><span id="L-183"><a href="#L-183"><span class="linenos"> 183</span></a>
</span><span id="L-184"><a href="#L-184"><span class="linenos"> 184</span></a>        <span class="n">decorated_function</span><span class="o">.</span><span class="n">cache_info</span> <span class="o">=</span> <span class="n">wrapper</span><span class="o">.</span><span class="n">cache_info</span>
</span><span id="L-185"><a href="#L-185"><span class="linenos"> 185</span></a>        <span class="n">decorated_function</span><span class="o">.</span><span class="n">fn</span> <span class="o">=</span> <span class="n">fn</span>
</span><span id="L-186"><a href="#L-186"><span class="linenos"> 186</span></a>        <span class="k">return</span> <span class="n">decorated_function</span>
</span><span id="L-187"><a href="#L-187"><span class="linenos"> 187</span></a>
</span><span id="L-188"><a href="#L-188"><span class="linenos"> 188</span></a>    <span class="k">return</span> <span class="n">decorator</span>
</span><span id="L-189"><a href="#L-189"><span class="linenos"> 189</span></a>
</span><span id="L-190"><a href="#L-190"><span class="linenos"> 190</span></a>
</span><span id="L-191"><a href="#L-191"><span class="linenos"> 191</span></a><span class="k">def</span> <span class="nf">cuda_is_available</span><span class="p">():</span>
</span><span id="L-192"><a href="#L-192"><span class="linenos"> 192</span></a>    <span class="k">try</span><span class="p">:</span>
</span><span id="L-193"><a href="#L-193"><span class="linenos"> 193</span></a>        <span class="kn">import</span> <span class="nn">subprocess</span>
</span><span id="L-194"><a href="#L-194"><span class="linenos"> 194</span></a>        <span class="kn">import</span> <span class="nn">platform</span>
</span><span id="L-195"><a href="#L-195"><span class="linenos"> 195</span></a>
</span><span id="L-196"><a href="#L-196"><span class="linenos"> 196</span></a>        <span class="n">cmd</span> <span class="o">=</span> <span class="sa">f</span><span class="s2">&quot;nvidia-smi</span><span class="si">{</span><span class="s1">&#39;.exe&#39;</span><span class="w"> </span><span class="k">if</span><span class="w"> </span><span class="n">platform</span><span class="o">.</span><span class="n">system</span><span class="w"> </span><span class="o">==</span><span class="w"> </span><span class="s1">&#39;Windows&#39;</span><span class="w"> </span><span class="k">else</span><span class="w"> </span><span class="s1">&#39;&#39;</span><span class="si">}</span><span class="s2">&quot;</span>
</span><span id="L-197"><a href="#L-197"><span class="linenos"> 197</span></a>        <span class="n">result</span> <span class="o">=</span> <span class="n">subprocess</span><span class="o">.</span><span class="n">run</span><span class="p">([</span><span class="n">cmd</span><span class="p">],</span> <span class="n">stdout</span><span class="o">=</span><span class="n">subprocess</span><span class="o">.</span><span class="n">PIPE</span><span class="p">)</span>
</span><span id="L-198"><a href="#L-198"><span class="linenos"> 198</span></a>        <span class="n">output</span> <span class="o">=</span> <span class="n">result</span><span class="o">.</span><span class="n">stdout</span><span class="o">.</span><span class="n">decode</span><span class="p">(</span><span class="s2">&quot;utf-8&quot;</span><span class="p">)</span>
</span><span id="L-199"><a href="#L-199"><span class="linenos"> 199</span></a>        <span class="k">return</span> <span class="kc">True</span> <span class="k">if</span> <span class="s2">&quot;NVIDIA-SMI&quot;</span> <span class="ow">in</span> <span class="n">output</span> <span class="k">else</span> <span class="kc">False</span>
</span><span id="L-200"><a href="#L-200"><span class="linenos"> 200</span></a>    <span class="k">except</span> <span class="ne">FileNotFoundError</span><span class="p">:</span>
</span><span id="L-201"><a href="#L-201"><span class="linenos"> 201</span></a>        <span class="k">return</span> <span class="kc">False</span>
</span><span id="L-202"><a href="#L-202"><span class="linenos"> 202</span></a>
</span><span id="L-203"><a href="#L-203"><span class="linenos"> 203</span></a>
</span><span id="L-204"><a href="#L-204"><span class="linenos"> 204</span></a><span class="k">class</span> <span class="nc">Hashed</span><span class="p">:</span>
</span><span id="L-205"><a href="#L-205"><span class="linenos"> 205</span></a>    <span class="n">val</span><span class="p">:</span> <span class="n">Any</span>
</span><span id="L-206"><a href="#L-206"><span class="linenos"> 206</span></a>
</span><span id="L-207"><a href="#L-207"><span class="linenos"> 207</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">val</span><span class="p">):</span>
</span><span id="L-208"><a href="#L-208"><span class="linenos"> 208</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">val</span> <span class="o">=</span> <span class="n">val</span>
</span><span id="L-209"><a href="#L-209"><span class="linenos"> 209</span></a>
</span><span id="L-210"><a href="#L-210"><span class="linenos"> 210</span></a>    <span class="k">def</span> <span class="fm">__hash__</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="nb">int</span><span class="p">:</span>
</span><span id="L-211"><a href="#L-211"><span class="linenos"> 211</span></a>        <span class="k">return</span> <span class="nb">hash</span><span class="p">((</span><span class="bp">self</span><span class="o">.</span><span class="n">val</span><span class="p">,))</span>
</span><span id="L-212"><a href="#L-212"><span class="linenos"> 212</span></a>
</span><span id="L-213"><a href="#L-213"><span class="linenos"> 213</span></a>    <span class="k">def</span> <span class="fm">__eq__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">other</span><span class="p">):</span>
</span><span id="L-214"><a href="#L-214"><span class="linenos"> 214</span></a>        <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">other</span><span class="p">,</span> <span class="n">Hashed</span><span class="p">):</span>
</span><span id="L-215"><a href="#L-215"><span class="linenos"> 215</span></a>            <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">val</span><span class="p">,</span> <span class="n">Tensor</span><span class="p">)</span> <span class="ow">and</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">other</span><span class="o">.</span><span class="n">val</span><span class="p">,</span> <span class="n">Tensor</span><span class="p">):</span>
</span><span id="L-216"><a href="#L-216"><span class="linenos"> 216</span></a>                <span class="c1"># because Tensor.__eq__ already for Tensor.equal</span>
</span><span id="L-217"><a href="#L-217"><span class="linenos"> 217</span></a>                <span class="k">return</span> <span class="nb">id</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">val</span><span class="p">)</span> <span class="o">==</span> <span class="nb">id</span><span class="p">(</span><span class="n">other</span><span class="o">.</span><span class="n">val</span><span class="p">)</span>
</span><span id="L-218"><a href="#L-218"><span class="linenos"> 218</span></a>            <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">val</span> <span class="o">==</span> <span class="n">other</span><span class="o">.</span><span class="n">val</span>
</span><span id="L-219"><a href="#L-219"><span class="linenos"> 219</span></a>        <span class="k">return</span> <span class="kc">False</span>
</span><span id="L-220"><a href="#L-220"><span class="linenos"> 220</span></a>
</span><span id="L-221"><a href="#L-221"><span class="linenos"> 221</span></a>    <span class="k">def</span> <span class="fm">__repr__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-222"><a href="#L-222"><span class="linenos"> 222</span></a>        <span class="k">return</span> <span class="sa">f</span><span class="s2">&quot;Hashed: </span><span class="si">{</span><span class="nb">repr</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">val</span><span class="p">)</span><span class="si">}</span><span class="s2">&quot;</span>
</span><span id="L-223"><a href="#L-223"><span class="linenos"> 223</span></a>
</span><span id="L-224"><a href="#L-224"><span class="linenos"> 224</span></a>
</span><span id="L-225"><a href="#L-225"><span class="linenos"> 225</span></a><span class="c1"># =================================</span>
</span><span id="L-226"><a href="#L-226"><span class="linenos"> 226</span></a><span class="c1">#   Tensors</span>
</span><span id="L-227"><a href="#L-227"><span class="linenos"> 227</span></a><span class="c1"># =================================</span>
</span><span id="L-228"><a href="#L-228"><span class="linenos"> 228</span></a>
</span><span id="L-229"><a href="#L-229"><span class="linenos"> 229</span></a>
</span><span id="L-230"><a href="#L-230"><span class="linenos"> 230</span></a><span class="k">class</span> <span class="nc">DType</span><span class="p">(</span><span class="n">NamedTuple</span><span class="p">):</span>
</span><span id="L-231"><a href="#L-231"><span class="linenos"> 231</span></a>    <span class="n">priority</span><span class="p">:</span> <span class="nb">int</span>
</span><span id="L-232"><a href="#L-232"><span class="linenos"> 232</span></a>    <span class="n">itemsize</span><span class="p">:</span> <span class="nb">int</span>
</span><span id="L-233"><a href="#L-233"><span class="linenos"> 233</span></a>    <span class="n">name</span><span class="p">:</span> <span class="nb">str</span>
</span><span id="L-234"><a href="#L-234"><span class="linenos"> 234</span></a>    <span class="n">mlir</span><span class="p">:</span> <span class="nb">str</span>
</span><span id="L-235"><a href="#L-235"><span class="linenos"> 235</span></a>    <span class="n">numpy</span><span class="p">:</span> <span class="nb">type</span>
</span><span id="L-236"><a href="#L-236"><span class="linenos"> 236</span></a>
</span><span id="L-237"><a href="#L-237"><span class="linenos"> 237</span></a>    <span class="nd">@property</span>
</span><span id="L-238"><a href="#L-238"><span class="linenos"> 238</span></a>    <span class="k">def</span> <span class="nf">format_code</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-239"><a href="#L-239"><span class="linenos"> 239</span></a>        <span class="k">return</span> <span class="sa">f</span><span class="s2">&quot;slope.</span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">&quot;</span>
</span><span id="L-240"><a href="#L-240"><span class="linenos"> 240</span></a>
</span><span id="L-241"><a href="#L-241"><span class="linenos"> 241</span></a>    <span class="k">def</span> <span class="fm">__repr__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-242"><a href="#L-242"><span class="linenos"> 242</span></a>        <span class="k">return</span> <span class="sa">f</span><span class="s2">&quot;&lt;DType: </span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">&gt;&quot;</span>
</span><span id="L-243"><a href="#L-243"><span class="linenos"> 243</span></a>
</span><span id="L-244"><a href="#L-244"><span class="linenos"> 244</span></a>
</span><span id="L-245"><a href="#L-245"><span class="linenos"> 245</span></a><span class="k">class</span> <span class="nc">dtypes</span><span class="p">:</span>
</span><span id="L-246"><a href="#L-246"><span class="linenos"> 246</span></a>    <span class="n">float32</span><span class="p">:</span> <span class="n">Final</span><span class="p">[</span><span class="n">DType</span><span class="p">]</span> <span class="o">=</span> <span class="n">DType</span><span class="p">(</span><span class="mi">4</span><span class="p">,</span> <span class="mi">4</span><span class="p">,</span> <span class="s2">&quot;float32&quot;</span><span class="p">,</span> <span class="s2">&quot;f32&quot;</span><span class="p">,</span> <span class="n">np</span><span class="o">.</span><span class="n">float32</span><span class="p">)</span>
</span><span id="L-247"><a href="#L-247"><span class="linenos"> 247</span></a>    <span class="n">uint8</span><span class="p">:</span> <span class="n">Final</span><span class="p">[</span><span class="n">DType</span><span class="p">]</span> <span class="o">=</span> <span class="n">DType</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="mi">1</span><span class="p">,</span> <span class="s2">&quot;uint8&quot;</span><span class="p">,</span> <span class="s2">&quot;u8&quot;</span><span class="p">,</span> <span class="n">np</span><span class="o">.</span><span class="n">uint8</span><span class="p">)</span>
</span><span id="L-248"><a href="#L-248"><span class="linenos"> 248</span></a>    <span class="n">int8</span><span class="p">:</span> <span class="n">Final</span><span class="p">[</span><span class="n">DType</span><span class="p">]</span> <span class="o">=</span> <span class="n">DType</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="mi">1</span><span class="p">,</span> <span class="s2">&quot;int8&quot;</span><span class="p">,</span> <span class="s2">&quot;i8&quot;</span><span class="p">,</span> <span class="n">np</span><span class="o">.</span><span class="n">int8</span><span class="p">)</span>
</span><span id="L-249"><a href="#L-249"><span class="linenos"> 249</span></a>    <span class="nb">bool</span><span class="p">:</span> <span class="n">Final</span><span class="p">[</span><span class="n">DType</span><span class="p">]</span> <span class="o">=</span> <span class="n">DType</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="mi">1</span><span class="p">,</span> <span class="s2">&quot;bool&quot;</span><span class="p">,</span> <span class="s2">&quot;i1&quot;</span><span class="p">,</span> <span class="nb">bool</span><span class="p">)</span>
</span><span id="L-250"><a href="#L-250"><span class="linenos"> 250</span></a>    <span class="n">int32</span><span class="p">:</span> <span class="n">Final</span><span class="p">[</span><span class="n">DType</span><span class="p">]</span> <span class="o">=</span> <span class="n">DType</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span> <span class="mi">4</span><span class="p">,</span> <span class="s2">&quot;int32&quot;</span><span class="p">,</span> <span class="s2">&quot;i32&quot;</span><span class="p">,</span> <span class="n">np</span><span class="o">.</span><span class="n">int32</span><span class="p">)</span>
</span><span id="L-251"><a href="#L-251"><span class="linenos"> 251</span></a>    <span class="n">int64</span><span class="p">:</span> <span class="n">Final</span><span class="p">[</span><span class="n">DType</span><span class="p">]</span> <span class="o">=</span> <span class="n">DType</span><span class="p">(</span><span class="mi">2</span><span class="p">,</span> <span class="mi">8</span><span class="p">,</span> <span class="s2">&quot;int64&quot;</span><span class="p">,</span> <span class="s2">&quot;i64&quot;</span><span class="p">,</span> <span class="n">np</span><span class="o">.</span><span class="n">int64</span><span class="p">)</span>
</span><span id="L-252"><a href="#L-252"><span class="linenos"> 252</span></a>    <span class="n">uint64</span><span class="p">:</span> <span class="n">Final</span><span class="p">[</span><span class="n">DType</span><span class="p">]</span> <span class="o">=</span> <span class="n">DType</span><span class="p">(</span><span class="mi">2</span><span class="p">,</span> <span class="mi">8</span><span class="p">,</span> <span class="s2">&quot;uint64&quot;</span><span class="p">,</span> <span class="s2">&quot;ui64&quot;</span><span class="p">,</span> <span class="n">np</span><span class="o">.</span><span class="n">uint64</span><span class="p">)</span>
</span><span id="L-253"><a href="#L-253"><span class="linenos"> 253</span></a>    <span class="n">float16</span><span class="p">:</span> <span class="n">Final</span><span class="p">[</span><span class="n">DType</span><span class="p">]</span> <span class="o">=</span> <span class="n">DType</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="mi">2</span><span class="p">,</span> <span class="s2">&quot;float16&quot;</span><span class="p">,</span> <span class="s2">&quot;f16&quot;</span><span class="p">,</span> <span class="n">np</span><span class="o">.</span><span class="n">float16</span><span class="p">)</span>
</span><span id="L-254"><a href="#L-254"><span class="linenos"> 254</span></a>
</span><span id="L-255"><a href="#L-255"><span class="linenos"> 255</span></a>    <span class="n">all_dtypes</span> <span class="o">=</span> <span class="p">(</span><span class="nb">bool</span><span class="p">,</span> <span class="n">float16</span><span class="p">,</span> <span class="n">float32</span><span class="p">,</span> <span class="n">int8</span><span class="p">,</span> <span class="n">int32</span><span class="p">,</span> <span class="n">int64</span><span class="p">,</span> <span class="n">uint8</span><span class="p">,</span> <span class="n">uint64</span><span class="p">)</span>
</span><span id="L-256"><a href="#L-256"><span class="linenos"> 256</span></a>    <span class="n">name_dtype_map</span> <span class="o">=</span> <span class="p">{</span><span class="n">k</span><span class="o">.</span><span class="n">name</span><span class="p">:</span> <span class="n">k</span> <span class="k">for</span> <span class="n">k</span> <span class="ow">in</span> <span class="n">all_dtypes</span><span class="p">}</span>
</span><span id="L-257"><a href="#L-257"><span class="linenos"> 257</span></a>    <span class="n">name_dtype_map_inv</span> <span class="o">=</span> <span class="p">{</span><span class="n">v</span><span class="p">:</span> <span class="n">k</span> <span class="k">for</span> <span class="n">k</span><span class="p">,</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">name_dtype_map</span><span class="o">.</span><span class="n">items</span><span class="p">()}</span>
</span><span id="L-258"><a href="#L-258"><span class="linenos"> 258</span></a>    <span class="n">mlir_dtype_map</span> <span class="o">=</span> <span class="p">{</span><span class="n">k</span><span class="o">.</span><span class="n">mlir</span><span class="p">:</span> <span class="n">k</span> <span class="k">for</span> <span class="n">k</span> <span class="ow">in</span> <span class="n">all_dtypes</span><span class="p">}</span>
</span><span id="L-259"><a href="#L-259"><span class="linenos"> 259</span></a>    <span class="n">mlir_dtype_map_inv</span> <span class="o">=</span> <span class="p">{</span><span class="n">v</span><span class="p">:</span> <span class="n">k</span> <span class="k">for</span> <span class="n">k</span><span class="p">,</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">mlir_dtype_map</span><span class="o">.</span><span class="n">items</span><span class="p">()}</span>
</span><span id="L-260"><a href="#L-260"><span class="linenos"> 260</span></a>
</span><span id="L-261"><a href="#L-261"><span class="linenos"> 261</span></a>    <span class="nd">@classmethod</span>
</span><span id="L-262"><a href="#L-262"><span class="linenos"> 262</span></a>    <span class="k">def</span> <span class="nf">is_int</span><span class="p">(</span><span class="bp">cls</span><span class="p">,</span> <span class="n">dtype</span><span class="p">):</span>
</span><span id="L-263"><a href="#L-263"><span class="linenos"> 263</span></a>        <span class="k">return</span> <span class="n">dtype</span> <span class="ow">in</span> <span class="p">(</span><span class="bp">cls</span><span class="o">.</span><span class="n">uint8</span><span class="p">,</span> <span class="bp">cls</span><span class="o">.</span><span class="n">int8</span><span class="p">,</span> <span class="bp">cls</span><span class="o">.</span><span class="n">int32</span><span class="p">,</span> <span class="bp">cls</span><span class="o">.</span><span class="n">uint64</span><span class="p">,</span> <span class="bp">cls</span><span class="o">.</span><span class="n">int64</span><span class="p">)</span>
</span><span id="L-264"><a href="#L-264"><span class="linenos"> 264</span></a>
</span><span id="L-265"><a href="#L-265"><span class="linenos"> 265</span></a>    <span class="nd">@classmethod</span>
</span><span id="L-266"><a href="#L-266"><span class="linenos"> 266</span></a>    <span class="k">def</span> <span class="nf">is_float</span><span class="p">(</span><span class="bp">cls</span><span class="p">,</span> <span class="n">dtype</span><span class="p">):</span>
</span><span id="L-267"><a href="#L-267"><span class="linenos"> 267</span></a>        <span class="k">return</span> <span class="n">dtype</span> <span class="ow">in</span> <span class="p">(</span><span class="bp">cls</span><span class="o">.</span><span class="n">float16</span><span class="p">,</span> <span class="bp">cls</span><span class="o">.</span><span class="n">float32</span><span class="p">)</span>
</span><span id="L-268"><a href="#L-268"><span class="linenos"> 268</span></a>
</span><span id="L-269"><a href="#L-269"><span class="linenos"> 269</span></a>
</span><span id="L-270"><a href="#L-270"><span class="linenos"> 270</span></a><span class="k">class</span> <span class="nc">Device</span><span class="p">(</span><span class="n">NamedTuple</span><span class="p">):</span>
</span><span id="L-271"><a href="#L-271"><span class="linenos"> 271</span></a>    <span class="n">name</span><span class="p">:</span> <span class="nb">str</span>
</span><span id="L-272"><a href="#L-272"><span class="linenos"> 272</span></a>    <span class="n">idx</span><span class="p">:</span> <span class="nb">int</span>
</span><span id="L-273"><a href="#L-273"><span class="linenos"> 273</span></a>
</span><span id="L-274"><a href="#L-274"><span class="linenos"> 274</span></a>    <span class="nd">@property</span>
</span><span id="L-275"><a href="#L-275"><span class="linenos"> 275</span></a>    <span class="k">def</span> <span class="nf">format_code</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-276"><a href="#L-276"><span class="linenos"> 276</span></a>        <span class="k">return</span> <span class="sa">f</span><span class="s2">&quot;&#39;</span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">:</span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">idx</span><span class="si">}</span><span class="s2">&#39;&quot;</span>
</span><span id="L-277"><a href="#L-277"><span class="linenos"> 277</span></a>
</span><span id="L-278"><a href="#L-278"><span class="linenos"> 278</span></a>    <span class="k">def</span> <span class="fm">__repr__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-279"><a href="#L-279"><span class="linenos"> 279</span></a>        <span class="k">return</span> <span class="sa">f</span><span class="s2">&quot;&lt;Device: </span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">format_code</span><span class="si">}</span><span class="s2">&gt;&quot;</span>
</span><span id="L-280"><a href="#L-280"><span class="linenos"> 280</span></a>
</span><span id="L-281"><a href="#L-281"><span class="linenos"> 281</span></a>
</span><span id="L-282"><a href="#L-282"><span class="linenos"> 282</span></a><span class="k">class</span> <span class="nc">devices</span><span class="p">:</span>
</span><span id="L-283"><a href="#L-283"><span class="linenos"> 283</span></a>    <span class="n">cpu</span><span class="p">:</span> <span class="n">Final</span><span class="p">[</span><span class="n">Device</span><span class="p">]</span> <span class="o">=</span> <span class="n">Device</span><span class="p">(</span><span class="s2">&quot;cpu&quot;</span><span class="p">,</span> <span class="mi">0</span><span class="p">)</span>
</span><span id="L-284"><a href="#L-284"><span class="linenos"> 284</span></a>    <span class="n">metal</span><span class="p">:</span> <span class="n">Final</span><span class="p">[</span><span class="n">Device</span><span class="p">]</span> <span class="o">=</span> <span class="n">Device</span><span class="p">(</span><span class="s2">&quot;metal&quot;</span><span class="p">,</span> <span class="mi">0</span><span class="p">)</span>
</span><span id="L-285"><a href="#L-285"><span class="linenos"> 285</span></a>    <span class="n">cuda0</span><span class="p">:</span> <span class="n">Final</span><span class="p">[</span><span class="n">Device</span><span class="p">]</span> <span class="o">=</span> <span class="n">Device</span><span class="p">(</span><span class="s2">&quot;cuda&quot;</span><span class="p">,</span> <span class="mi">0</span><span class="p">)</span>
</span><span id="L-286"><a href="#L-286"><span class="linenos"> 286</span></a>    <span class="c1"># TODO: programmatically define this class attrs to support other setup</span>
</span><span id="L-287"><a href="#L-287"><span class="linenos"> 287</span></a>    <span class="n">cuda</span> <span class="o">=</span> <span class="n">cuda0</span>
</span><span id="L-288"><a href="#L-288"><span class="linenos"> 288</span></a>    <span class="n">all_devices</span> <span class="o">=</span> <span class="p">(</span><span class="n">cpu</span><span class="p">,</span> <span class="n">metal</span><span class="p">,</span> <span class="n">cuda0</span><span class="p">)</span>
</span><span id="L-289"><a href="#L-289"><span class="linenos"> 289</span></a>    <span class="n">name_idx_device_map</span> <span class="o">=</span> <span class="p">{</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">k</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">:</span><span class="si">{</span><span class="n">k</span><span class="o">.</span><span class="n">idx</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">:</span> <span class="n">k</span> <span class="k">for</span> <span class="n">k</span> <span class="ow">in</span> <span class="n">all_devices</span><span class="p">}</span>
</span><span id="L-290"><a href="#L-290"><span class="linenos"> 290</span></a>    <span class="n">name_idx_device_map_inv</span> <span class="o">=</span> <span class="p">{</span><span class="n">v</span><span class="p">:</span> <span class="n">k</span> <span class="k">for</span> <span class="n">k</span><span class="p">,</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">name_idx_device_map</span><span class="o">.</span><span class="n">items</span><span class="p">()}</span>
</span><span id="L-291"><a href="#L-291"><span class="linenos"> 291</span></a>
</span><span id="L-292"><a href="#L-292"><span class="linenos"> 292</span></a>
</span><span id="L-293"><a href="#L-293"><span class="linenos"> 293</span></a><span class="k">class</span> <span class="nc">TensorBuffer</span><span class="p">:</span>
</span><span id="L-294"><a href="#L-294"><span class="linenos"> 294</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">val</span><span class="p">):</span>
</span><span id="L-295"><a href="#L-295"><span class="linenos"> 295</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">val</span> <span class="o">=</span> <span class="n">val</span>
</span><span id="L-296"><a href="#L-296"><span class="linenos"> 296</span></a>
</span><span id="L-297"><a href="#L-297"><span class="linenos"> 297</span></a>
</span><span id="L-298"><a href="#L-298"><span class="linenos"> 298</span></a><span class="k">class</span> <span class="nc">Tensor</span><span class="p">:</span>
</span><span id="L-299"><a href="#L-299"><span class="linenos"> 299</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">val</span><span class="p">:</span> <span class="n">TensorBuffer</span><span class="p">):</span>
</span><span id="L-300"><a href="#L-300"><span class="linenos"> 300</span></a>        <span class="k">assert</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">val</span><span class="p">,</span> <span class="n">TensorBuffer</span><span class="p">)</span>
</span><span id="L-301"><a href="#L-301"><span class="linenos"> 301</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">buf</span> <span class="o">=</span> <span class="n">val</span>
</span><span id="L-302"><a href="#L-302"><span class="linenos"> 302</span></a>
</span><span id="L-303"><a href="#L-303"><span class="linenos"> 303</span></a>    <span class="nd">@property</span>
</span><span id="L-304"><a href="#L-304"><span class="linenos"> 304</span></a>    <span class="k">def</span> <span class="nf">symval</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-305"><a href="#L-305"><span class="linenos"> 305</span></a>        <span class="k">return</span> <span class="n">SymbolicTensor</span><span class="o">.</span><span class="n">like</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span>
</span><span id="L-306"><a href="#L-306"><span class="linenos"> 306</span></a>
</span><span id="L-307"><a href="#L-307"><span class="linenos"> 307</span></a>    <span class="nd">@property</span>
</span><span id="L-308"><a href="#L-308"><span class="linenos"> 308</span></a>    <span class="k">def</span> <span class="nf">default_dtype</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-309"><a href="#L-309"><span class="linenos"> 309</span></a>        <span class="k">return</span> <span class="n">backend</span><span class="o">.</span><span class="n">default_dtype</span>
</span><span id="L-310"><a href="#L-310"><span class="linenos"> 310</span></a>
</span><span id="L-311"><a href="#L-311"><span class="linenos"> 311</span></a>    <span class="k">def</span> <span class="nf">is_int</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="nb">bool</span><span class="p">:</span>
</span><span id="L-312"><a href="#L-312"><span class="linenos"> 312</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">dtype</span> <span class="ow">in</span> <span class="p">(</span>
</span><span id="L-313"><a href="#L-313"><span class="linenos"> 313</span></a>            <span class="n">dtypes</span><span class="o">.</span><span class="n">int8</span><span class="p">,</span>
</span><span id="L-314"><a href="#L-314"><span class="linenos"> 314</span></a>            <span class="n">dtypes</span><span class="o">.</span><span class="n">uint8</span><span class="p">,</span>
</span><span id="L-315"><a href="#L-315"><span class="linenos"> 315</span></a>            <span class="n">dtypes</span><span class="o">.</span><span class="n">uint64</span><span class="p">,</span>
</span><span id="L-316"><a href="#L-316"><span class="linenos"> 316</span></a>            <span class="n">dtypes</span><span class="o">.</span><span class="n">int32</span><span class="p">,</span>
</span><span id="L-317"><a href="#L-317"><span class="linenos"> 317</span></a>            <span class="n">dtypes</span><span class="o">.</span><span class="n">int64</span><span class="p">,</span>
</span><span id="L-318"><a href="#L-318"><span class="linenos"> 318</span></a>        <span class="p">)</span>
</span><span id="L-319"><a href="#L-319"><span class="linenos"> 319</span></a>
</span><span id="L-320"><a href="#L-320"><span class="linenos"> 320</span></a>    <span class="k">def</span> <span class="nf">is_float</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="nb">bool</span><span class="p">:</span>
</span><span id="L-321"><a href="#L-321"><span class="linenos"> 321</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">dtype</span> <span class="ow">in</span> <span class="p">(</span><span class="n">dtypes</span><span class="o">.</span><span class="n">float16</span><span class="p">,</span> <span class="n">dtypes</span><span class="o">.</span><span class="n">float32</span><span class="p">)</span>
</span><span id="L-322"><a href="#L-322"><span class="linenos"> 322</span></a>
</span><span id="L-323"><a href="#L-323"><span class="linenos"> 323</span></a>    <span class="k">def</span> <span class="nf">is_unsigned</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="nb">bool</span><span class="p">:</span>
</span><span id="L-324"><a href="#L-324"><span class="linenos"> 324</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">dtype</span> <span class="ow">is</span> <span class="n">dtypes</span><span class="o">.</span><span class="n">uint8</span>
</span><span id="L-325"><a href="#L-325"><span class="linenos"> 325</span></a>
</span><span id="L-326"><a href="#L-326"><span class="linenos"> 326</span></a>    <span class="k">def</span> <span class="nf">to_bool</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-327"><a href="#L-327"><span class="linenos"> 327</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">cast</span><span class="p">(</span><span class="n">dtypes</span><span class="o">.</span><span class="n">bool</span><span class="p">)</span>
</span><span id="L-328"><a href="#L-328"><span class="linenos"> 328</span></a>
</span><span id="L-329"><a href="#L-329"><span class="linenos"> 329</span></a>    <span class="k">def</span> <span class="nf">short</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-330"><a href="#L-330"><span class="linenos"> 330</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">cast</span><span class="p">(</span><span class="n">dtypes</span><span class="o">.</span><span class="n">int8</span><span class="p">)</span>
</span><span id="L-331"><a href="#L-331"><span class="linenos"> 331</span></a>
</span><span id="L-332"><a href="#L-332"><span class="linenos"> 332</span></a>    <span class="k">def</span> <span class="nf">int</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-333"><a href="#L-333"><span class="linenos"> 333</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">cast</span><span class="p">(</span><span class="n">dtypes</span><span class="o">.</span><span class="n">int32</span><span class="p">)</span>
</span><span id="L-334"><a href="#L-334"><span class="linenos"> 334</span></a>
</span><span id="L-335"><a href="#L-335"><span class="linenos"> 335</span></a>    <span class="k">def</span> <span class="nf">long</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-336"><a href="#L-336"><span class="linenos"> 336</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">cast</span><span class="p">(</span><span class="n">dtypes</span><span class="o">.</span><span class="n">int64</span><span class="p">)</span>
</span><span id="L-337"><a href="#L-337"><span class="linenos"> 337</span></a>
</span><span id="L-338"><a href="#L-338"><span class="linenos"> 338</span></a>    <span class="k">def</span> <span class="nf">half</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-339"><a href="#L-339"><span class="linenos"> 339</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">cast</span><span class="p">(</span><span class="n">dtypes</span><span class="o">.</span><span class="n">float16</span><span class="p">)</span>
</span><span id="L-340"><a href="#L-340"><span class="linenos"> 340</span></a>
</span><span id="L-341"><a href="#L-341"><span class="linenos"> 341</span></a>    <span class="k">def</span> <span class="nf">float</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-342"><a href="#L-342"><span class="linenos"> 342</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">cast</span><span class="p">(</span><span class="n">dtypes</span><span class="o">.</span><span class="n">float32</span><span class="p">)</span>
</span><span id="L-343"><a href="#L-343"><span class="linenos"> 343</span></a>
</span><span id="L-344"><a href="#L-344"><span class="linenos"> 344</span></a>    <span class="k">def</span> <span class="fm">__getattr__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">attr</span><span class="p">):</span>
</span><span id="L-345"><a href="#L-345"><span class="linenos"> 345</span></a>        <span class="k">if</span> <span class="n">attr</span> <span class="ow">in</span> <span class="nb">vars</span><span class="p">(</span><span class="n">backend</span><span class="o">.</span><span class="n">operator_set</span><span class="p">)</span><span class="o">.</span><span class="n">keys</span><span class="p">():</span>
</span><span id="L-346"><a href="#L-346"><span class="linenos"> 346</span></a>            <span class="n">op</span> <span class="o">=</span> <span class="nb">getattr</span><span class="p">(</span><span class="n">backend</span><span class="o">.</span><span class="n">operator_set</span><span class="p">,</span> <span class="n">attr</span><span class="p">)</span>
</span><span id="L-347"><a href="#L-347"><span class="linenos"> 347</span></a>            <span class="k">return</span> <span class="n">partial</span><span class="p">(</span><span class="n">op</span><span class="p">,</span> <span class="bp">self</span><span class="p">)</span>
</span><span id="L-348"><a href="#L-348"><span class="linenos"> 348</span></a>        <span class="k">elif</span> <span class="n">attr</span> <span class="ow">in</span> <span class="nb">vars</span><span class="p">(</span><span class="n">backend</span><span class="o">.</span><span class="n">procedure_set</span><span class="p">)</span><span class="o">.</span><span class="n">keys</span><span class="p">():</span>
</span><span id="L-349"><a href="#L-349"><span class="linenos"> 349</span></a>            <span class="n">procedure</span> <span class="o">=</span> <span class="nb">getattr</span><span class="p">(</span><span class="n">backend</span><span class="o">.</span><span class="n">procedure_set</span><span class="p">,</span> <span class="n">attr</span><span class="p">)</span>
</span><span id="L-350"><a href="#L-350"><span class="linenos"> 350</span></a>            <span class="k">assert</span> <span class="ow">not</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">procedure</span><span class="p">,</span> <span class="nb">classmethod</span><span class="p">),</span> <span class="sa">f</span><span class="s2">&quot;use </span><span class="si">{</span><span class="n">attr</span><span class="si">}</span><span class="s2"> instead of self.</span><span class="si">{</span><span class="n">attr</span><span class="si">}</span><span class="s2">&quot;</span>
</span><span id="L-351"><a href="#L-351"><span class="linenos"> 351</span></a>            <span class="k">return</span> <span class="n">partial</span><span class="p">(</span><span class="n">procedure</span><span class="p">,</span> <span class="bp">self</span><span class="p">)</span>
</span><span id="L-352"><a href="#L-352"><span class="linenos"> 352</span></a>        <span class="k">else</span><span class="p">:</span>
</span><span id="L-353"><a href="#L-353"><span class="linenos"> 353</span></a>            <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="fm">__getattribute__</span><span class="p">(</span><span class="n">attr</span><span class="p">)</span>
</span><span id="L-354"><a href="#L-354"><span class="linenos"> 354</span></a>
</span><span id="L-355"><a href="#L-355"><span class="linenos"> 355</span></a>    <span class="k">def</span> <span class="fm">__getitem__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">idx</span><span class="p">):</span>
</span><span id="L-356"><a href="#L-356"><span class="linenos"> 356</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">getitem</span><span class="p">(</span><span class="n">idx</span><span class="p">)</span>
</span><span id="L-357"><a href="#L-357"><span class="linenos"> 357</span></a>
</span><span id="L-358"><a href="#L-358"><span class="linenos"> 358</span></a>    <span class="k">def</span> <span class="fm">__setitem__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">idx</span><span class="p">,</span> <span class="n">item</span><span class="p">):</span>
</span><span id="L-359"><a href="#L-359"><span class="linenos"> 359</span></a>        <span class="k">raise</span> <span class="ne">NotImplementedError</span>
</span><span id="L-360"><a href="#L-360"><span class="linenos"> 360</span></a>
</span><span id="L-361"><a href="#L-361"><span class="linenos"> 361</span></a>    <span class="k">def</span> <span class="nf">str_short</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-362"><a href="#L-362"><span class="linenos"> 362</span></a>        <span class="k">return</span> <span class="sa">f</span><span class="s2">&quot;&lt;Tensor: shape=</span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">shape</span><span class="si">}</span><span class="s2">, dtype=</span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">dtype</span><span class="si">}</span><span class="s2">&gt;&quot;</span>
</span><span id="L-363"><a href="#L-363"><span class="linenos"> 363</span></a>
</span><span id="L-364"><a href="#L-364"><span class="linenos"> 364</span></a>    <span class="fm">__neg__</span> <span class="o">=</span> <span class="k">lambda</span> <span class="bp">self</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">neg</span><span class="p">()</span>
</span><span id="L-365"><a href="#L-365"><span class="linenos"> 365</span></a>    <span class="fm">__add__</span> <span class="o">=</span> <span class="k">lambda</span> <span class="bp">self</span><span class="p">,</span> <span class="n">other</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">other</span><span class="p">)</span>
</span><span id="L-366"><a href="#L-366"><span class="linenos"> 366</span></a>    <span class="fm">__radd__</span> <span class="o">=</span> <span class="k">lambda</span> <span class="bp">self</span><span class="p">,</span> <span class="n">other</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">other</span><span class="p">)</span>
</span><span id="L-367"><a href="#L-367"><span class="linenos"> 367</span></a>    <span class="fm">__sub__</span> <span class="o">=</span> <span class="k">lambda</span> <span class="bp">self</span><span class="p">,</span> <span class="n">other</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">sub</span><span class="p">(</span><span class="n">other</span><span class="p">)</span>
</span><span id="L-368"><a href="#L-368"><span class="linenos"> 368</span></a>    <span class="fm">__rsub__</span> <span class="o">=</span> <span class="k">lambda</span> <span class="bp">self</span><span class="p">,</span> <span class="n">other</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">sub</span><span class="o">.</span><span class="n">func</span><span class="p">(</span><span class="n">other</span><span class="p">,</span> <span class="bp">self</span><span class="p">)</span>
</span><span id="L-369"><a href="#L-369"><span class="linenos"> 369</span></a>    <span class="fm">__mul__</span> <span class="o">=</span> <span class="k">lambda</span> <span class="bp">self</span><span class="p">,</span> <span class="n">other</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">mul</span><span class="p">(</span><span class="n">other</span><span class="p">)</span>
</span><span id="L-370"><a href="#L-370"><span class="linenos"> 370</span></a>    <span class="fm">__rmul__</span> <span class="o">=</span> <span class="k">lambda</span> <span class="bp">self</span><span class="p">,</span> <span class="n">other</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">mul</span><span class="p">(</span><span class="n">other</span><span class="p">)</span>
</span><span id="L-371"><a href="#L-371"><span class="linenos"> 371</span></a>    <span class="n">__div__</span> <span class="o">=</span> <span class="k">lambda</span> <span class="bp">self</span><span class="p">,</span> <span class="n">other</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">div</span><span class="p">(</span><span class="n">other</span><span class="p">)</span>
</span><span id="L-372"><a href="#L-372"><span class="linenos"> 372</span></a>    <span class="n">__rdiv__</span> <span class="o">=</span> <span class="k">lambda</span> <span class="bp">self</span><span class="p">,</span> <span class="n">other</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">div</span><span class="o">.</span><span class="n">func</span><span class="p">(</span><span class="n">other</span><span class="p">,</span> <span class="bp">self</span><span class="p">)</span>
</span><span id="L-373"><a href="#L-373"><span class="linenos"> 373</span></a>    <span class="fm">__truediv__</span> <span class="o">=</span> <span class="n">__div__</span>
</span><span id="L-374"><a href="#L-374"><span class="linenos"> 374</span></a>    <span class="n">__truerdiv__</span> <span class="o">=</span> <span class="n">__rdiv__</span>
</span><span id="L-375"><a href="#L-375"><span class="linenos"> 375</span></a>    <span class="fm">__pow__</span> <span class="o">=</span> <span class="k">lambda</span> <span class="bp">self</span><span class="p">,</span> <span class="n">other</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">pow</span><span class="p">(</span><span class="n">other</span><span class="p">)</span>
</span><span id="L-376"><a href="#L-376"><span class="linenos"> 376</span></a>    <span class="fm">__rpow__</span> <span class="o">=</span> <span class="k">lambda</span> <span class="bp">self</span><span class="p">,</span> <span class="n">other</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">pow</span><span class="o">.</span><span class="n">func</span><span class="p">(</span><span class="n">other</span><span class="p">,</span> <span class="bp">self</span><span class="p">)</span>
</span><span id="L-377"><a href="#L-377"><span class="linenos"> 377</span></a>    <span class="fm">__matmul__</span> <span class="o">=</span> <span class="k">lambda</span> <span class="bp">self</span><span class="p">,</span> <span class="n">other</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">matmul</span><span class="p">(</span><span class="n">other</span><span class="p">)</span>
</span><span id="L-378"><a href="#L-378"><span class="linenos"> 378</span></a>    <span class="fm">__rmatmul__</span> <span class="o">=</span> <span class="k">lambda</span> <span class="bp">self</span><span class="p">,</span> <span class="n">other</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">matmul</span><span class="o">.</span><span class="n">func</span><span class="p">(</span><span class="n">other</span><span class="p">,</span> <span class="bp">self</span><span class="p">)</span>
</span><span id="L-379"><a href="#L-379"><span class="linenos"> 379</span></a>    <span class="fm">__invert__</span> <span class="o">=</span> <span class="k">lambda</span> <span class="bp">self</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">invert</span><span class="p">()</span>
</span><span id="L-380"><a href="#L-380"><span class="linenos"> 380</span></a>    <span class="fm">__eq__</span> <span class="o">=</span> <span class="k">lambda</span> <span class="bp">self</span><span class="p">,</span> <span class="n">other</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">equal</span><span class="p">(</span><span class="n">other</span><span class="p">)</span>
</span><span id="L-381"><a href="#L-381"><span class="linenos"> 381</span></a>    <span class="fm">__ne__</span> <span class="o">=</span> <span class="k">lambda</span> <span class="bp">self</span><span class="p">,</span> <span class="n">other</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">not_equal</span><span class="p">(</span><span class="n">other</span><span class="p">)</span>
</span><span id="L-382"><a href="#L-382"><span class="linenos"> 382</span></a>    <span class="fm">__ge__</span> <span class="o">=</span> <span class="k">lambda</span> <span class="bp">self</span><span class="p">,</span> <span class="n">other</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">greater_equal</span><span class="p">(</span><span class="n">other</span><span class="p">)</span>
</span><span id="L-383"><a href="#L-383"><span class="linenos"> 383</span></a>    <span class="fm">__le__</span> <span class="o">=</span> <span class="k">lambda</span> <span class="bp">self</span><span class="p">,</span> <span class="n">other</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">less_equal</span><span class="p">(</span><span class="n">other</span><span class="p">)</span>
</span><span id="L-384"><a href="#L-384"><span class="linenos"> 384</span></a>    <span class="fm">__gt__</span> <span class="o">=</span> <span class="k">lambda</span> <span class="bp">self</span><span class="p">,</span> <span class="n">other</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">greater</span><span class="p">(</span><span class="n">other</span><span class="p">)</span>
</span><span id="L-385"><a href="#L-385"><span class="linenos"> 385</span></a>    <span class="fm">__lt__</span> <span class="o">=</span> <span class="k">lambda</span> <span class="bp">self</span><span class="p">,</span> <span class="n">other</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">less</span><span class="p">(</span><span class="n">other</span><span class="p">)</span>
</span><span id="L-386"><a href="#L-386"><span class="linenos"> 386</span></a>
</span><span id="L-387"><a href="#L-387"><span class="linenos"> 387</span></a>    <span class="k">def</span> <span class="fm">__hash__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-388"><a href="#L-388"><span class="linenos"> 388</span></a>        <span class="k">return</span> <span class="nb">id</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">val</span><span class="p">)</span>
</span><span id="L-389"><a href="#L-389"><span class="linenos"> 389</span></a>
</span><span id="L-390"><a href="#L-390"><span class="linenos"> 390</span></a>    <span class="n">val</span> <span class="o">=</span> <span class="nb">property</span><span class="p">(</span><span class="k">lambda</span> <span class="bp">self</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">buf</span><span class="o">.</span><span class="n">val</span><span class="p">)</span>
</span><span id="L-391"><a href="#L-391"><span class="linenos"> 391</span></a>
</span><span id="L-392"><a href="#L-392"><span class="linenos"> 392</span></a>    <span class="k">def</span> <span class="nf">size</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">i</span><span class="p">):</span>
</span><span id="L-393"><a href="#L-393"><span class="linenos"> 393</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">shape</span><span class="p">[</span><span class="n">i</span><span class="p">]</span>
</span><span id="L-394"><a href="#L-394"><span class="linenos"> 394</span></a>
</span><span id="L-395"><a href="#L-395"><span class="linenos"> 395</span></a>    <span class="nd">@property</span>
</span><span id="L-396"><a href="#L-396"><span class="linenos"> 396</span></a>    <span class="k">def</span> <span class="nf">dtype</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-397"><a href="#L-397"><span class="linenos"> 397</span></a>        <span class="k">return</span> <span class="n">backend</span><span class="o">.</span><span class="n">dtype_of</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span>
</span><span id="L-398"><a href="#L-398"><span class="linenos"> 398</span></a>
</span><span id="L-399"><a href="#L-399"><span class="linenos"> 399</span></a>    <span class="nd">@property</span>
</span><span id="L-400"><a href="#L-400"><span class="linenos"> 400</span></a>    <span class="k">def</span> <span class="nf">device</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-401"><a href="#L-401"><span class="linenos"> 401</span></a>        <span class="k">return</span> <span class="n">backend</span><span class="o">.</span><span class="n">device_of</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span>
</span><span id="L-402"><a href="#L-402"><span class="linenos"> 402</span></a>
</span><span id="L-403"><a href="#L-403"><span class="linenos"> 403</span></a>    <span class="k">def</span> <span class="nf">numpy</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">memmap</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>
</span><span id="L-404"><a href="#L-404"><span class="linenos"> 404</span></a>        <span class="k">return</span> <span class="n">backend</span><span class="o">.</span><span class="n">numpy_of</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">memmap</span><span class="p">)</span>
</span><span id="L-405"><a href="#L-405"><span class="linenos"> 405</span></a>
</span><span id="L-406"><a href="#L-406"><span class="linenos"> 406</span></a>    <span class="nd">@property</span>
</span><span id="L-407"><a href="#L-407"><span class="linenos"> 407</span></a>    <span class="k">def</span> <span class="nf">shape</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-408"><a href="#L-408"><span class="linenos"> 408</span></a>        <span class="k">return</span> <span class="n">backend</span><span class="o">.</span><span class="n">shape_of</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span>
</span><span id="L-409"><a href="#L-409"><span class="linenos"> 409</span></a>
</span><span id="L-410"><a href="#L-410"><span class="linenos"> 410</span></a>    <span class="nd">@property</span>
</span><span id="L-411"><a href="#L-411"><span class="linenos"> 411</span></a>    <span class="k">def</span> <span class="nf">ndim</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-412"><a href="#L-412"><span class="linenos"> 412</span></a>        <span class="k">return</span> <span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span>
</span><span id="L-413"><a href="#L-413"><span class="linenos"> 413</span></a>
</span><span id="L-414"><a href="#L-414"><span class="linenos"> 414</span></a>    <span class="k">def</span> <span class="nf">numel</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-415"><a href="#L-415"><span class="linenos"> 415</span></a>        <span class="k">return</span> <span class="n">math</span><span class="o">.</span><span class="n">prod</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span>
</span><span id="L-416"><a href="#L-416"><span class="linenos"> 416</span></a>
</span><span id="L-417"><a href="#L-417"><span class="linenos"> 417</span></a>    <span class="k">def</span> <span class="nf">element_size</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-418"><a href="#L-418"><span class="linenos"> 418</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">dtype</span><span class="o">.</span><span class="n">itemsize</span>
</span><span id="L-419"><a href="#L-419"><span class="linenos"> 419</span></a>
</span><span id="L-420"><a href="#L-420"><span class="linenos"> 420</span></a>    <span class="k">def</span> <span class="nf">nbytes</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-421"><a href="#L-421"><span class="linenos"> 421</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">numel</span><span class="p">()</span> <span class="o">*</span> <span class="bp">self</span><span class="o">.</span><span class="n">element_size</span><span class="p">()</span>
</span><span id="L-422"><a href="#L-422"><span class="linenos"> 422</span></a>
</span><span id="L-423"><a href="#L-423"><span class="linenos"> 423</span></a>    <span class="k">def</span> <span class="fm">__repr__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-424"><a href="#L-424"><span class="linenos"> 424</span></a>        <span class="k">return</span> <span class="sa">f</span><span class="s2">&quot;&lt;Tensor: val=</span><span class="se">\n</span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">numpy</span><span class="p">()</span><span class="si">}</span><span class="se">\n</span><span class="s2">shape=</span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">shape</span><span class="si">}</span><span class="s2">, dtype=</span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">dtype</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">, device=</span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">device</span><span class="o">.</span><span class="n">format_code</span><span class="si">}</span><span class="s2">&gt;&quot;</span>
</span><span id="L-425"><a href="#L-425"><span class="linenos"> 425</span></a>
</span><span id="L-426"><a href="#L-426"><span class="linenos"> 426</span></a>
</span><span id="L-427"><a href="#L-427"><span class="linenos"> 427</span></a><span class="k">class</span> <span class="nc">SymbolicTensor</span><span class="p">(</span><span class="n">Tensor</span><span class="p">):</span>
</span><span id="L-428"><a href="#L-428"><span class="linenos"> 428</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">shape</span><span class="p">,</span> <span class="n">dtype</span><span class="p">,</span> <span class="n">device</span><span class="p">):</span>
</span><span id="L-429"><a href="#L-429"><span class="linenos"> 429</span></a>        <span class="k">assert</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">dtype</span><span class="p">,</span> <span class="n">DType</span><span class="p">)</span>
</span><span id="L-430"><a href="#L-430"><span class="linenos"> 430</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">_shape</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="nb">int</span><span class="p">(</span><span class="n">i</span><span class="p">)</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="n">shape</span><span class="p">)</span>
</span><span id="L-431"><a href="#L-431"><span class="linenos"> 431</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">_dtype</span> <span class="o">=</span> <span class="n">dtype</span>
</span><span id="L-432"><a href="#L-432"><span class="linenos"> 432</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">_device</span> <span class="o">=</span> <span class="n">device</span>
</span><span id="L-433"><a href="#L-433"><span class="linenos"> 433</span></a>
</span><span id="L-434"><a href="#L-434"><span class="linenos"> 434</span></a>    <span class="nd">@property</span>
</span><span id="L-435"><a href="#L-435"><span class="linenos"> 435</span></a>    <span class="k">def</span> <span class="nf">symval</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-436"><a href="#L-436"><span class="linenos"> 436</span></a>        <span class="k">return</span> <span class="bp">self</span>
</span><span id="L-437"><a href="#L-437"><span class="linenos"> 437</span></a>
</span><span id="L-438"><a href="#L-438"><span class="linenos"> 438</span></a>    <span class="nd">@property</span>
</span><span id="L-439"><a href="#L-439"><span class="linenos"> 439</span></a>    <span class="k">def</span> <span class="nf">val</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-440"><a href="#L-440"><span class="linenos"> 440</span></a>        <span class="k">raise</span> <span class="ne">RuntimeError</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;SymbolicTensor actually has no val, from </span><span class="si">{</span><span class="n">trace_stack</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span><span class="si">=}</span><span class="s2">, &quot;</span><span class="p">)</span>
</span><span id="L-441"><a href="#L-441"><span class="linenos"> 441</span></a>
</span><span id="L-442"><a href="#L-442"><span class="linenos"> 442</span></a>    <span class="nd">@property</span>
</span><span id="L-443"><a href="#L-443"><span class="linenos"> 443</span></a>    <span class="k">def</span> <span class="nf">shape</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-444"><a href="#L-444"><span class="linenos"> 444</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">_shape</span>
</span><span id="L-445"><a href="#L-445"><span class="linenos"> 445</span></a>
</span><span id="L-446"><a href="#L-446"><span class="linenos"> 446</span></a>    <span class="nd">@property</span>
</span><span id="L-447"><a href="#L-447"><span class="linenos"> 447</span></a>    <span class="k">def</span> <span class="nf">dtype</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-448"><a href="#L-448"><span class="linenos"> 448</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">_dtype</span>
</span><span id="L-449"><a href="#L-449"><span class="linenos"> 449</span></a>
</span><span id="L-450"><a href="#L-450"><span class="linenos"> 450</span></a>    <span class="nd">@property</span>
</span><span id="L-451"><a href="#L-451"><span class="linenos"> 451</span></a>    <span class="k">def</span> <span class="nf">device</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-452"><a href="#L-452"><span class="linenos"> 452</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">_device</span>
</span><span id="L-453"><a href="#L-453"><span class="linenos"> 453</span></a>
</span><span id="L-454"><a href="#L-454"><span class="linenos"> 454</span></a>    <span class="k">def</span> <span class="nf">like</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">**</span><span class="n">but</span><span class="p">):</span>
</span><span id="L-455"><a href="#L-455"><span class="linenos"> 455</span></a>        <span class="n">shape</span> <span class="o">=</span> <span class="n">but</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;shape&quot;</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span>
</span><span id="L-456"><a href="#L-456"><span class="linenos"> 456</span></a>        <span class="n">dtype</span> <span class="o">=</span> <span class="n">but</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;dtype&quot;</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">dtype</span><span class="p">)</span>
</span><span id="L-457"><a href="#L-457"><span class="linenos"> 457</span></a>        <span class="n">device</span> <span class="o">=</span> <span class="n">but</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;device&quot;</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">device</span><span class="p">)</span>
</span><span id="L-458"><a href="#L-458"><span class="linenos"> 458</span></a>        <span class="k">return</span> <span class="n">SymbolicTensor</span><span class="p">(</span><span class="n">shape</span><span class="p">,</span> <span class="n">dtype</span><span class="p">,</span> <span class="n">device</span><span class="p">)</span>
</span><span id="L-459"><a href="#L-459"><span class="linenos"> 459</span></a>
</span><span id="L-460"><a href="#L-460"><span class="linenos"> 460</span></a>    <span class="k">def</span> <span class="nf">str_short</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-461"><a href="#L-461"><span class="linenos"> 461</span></a>        <span class="k">return</span> <span class="sa">f</span><span class="s1">&#39;</span><span class="si">{</span><span class="nb">str</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">dtype</span><span class="p">)</span><span class="si">}</span><span class="s1">[</span><span class="si">{</span><span class="s2">&quot;,&quot;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="nb">str</span><span class="p">(</span><span class="n">d</span><span class="p">)</span><span class="w"> </span><span class="k">for</span><span class="w"> </span><span class="n">d</span><span class="w"> </span><span class="ow">in</span><span class="w"> </span><span class="bp">self</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span><span class="si">}</span><span class="s1">]&#39;</span>
</span><span id="L-462"><a href="#L-462"><span class="linenos"> 462</span></a>
</span><span id="L-463"><a href="#L-463"><span class="linenos"> 463</span></a>    <span class="k">def</span> <span class="fm">__hash__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-464"><a href="#L-464"><span class="linenos"> 464</span></a>        <span class="k">return</span> <span class="nb">hash</span><span class="p">((</span><span class="bp">self</span><span class="o">.</span><span class="n">shape</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">dtype</span><span class="p">))</span>
</span><span id="L-465"><a href="#L-465"><span class="linenos"> 465</span></a>
</span><span id="L-466"><a href="#L-466"><span class="linenos"> 466</span></a>    <span class="k">def</span> <span class="fm">__eq__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">other</span><span class="p">):</span>
</span><span id="L-467"><a href="#L-467"><span class="linenos"> 467</span></a>        <span class="k">if</span> <span class="nb">type</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span> <span class="o">!=</span> <span class="nb">type</span><span class="p">(</span><span class="n">other</span><span class="p">):</span>
</span><span id="L-468"><a href="#L-468"><span class="linenos"> 468</span></a>            <span class="k">return</span> <span class="kc">False</span>
</span><span id="L-469"><a href="#L-469"><span class="linenos"> 469</span></a>        <span class="k">return</span> <span class="nb">tuple</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span> <span class="o">==</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">other</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span> <span class="ow">and</span> <span class="bp">self</span><span class="o">.</span><span class="n">dtype</span> <span class="o">==</span> <span class="n">other</span><span class="o">.</span><span class="n">dtype</span>
</span><span id="L-470"><a href="#L-470"><span class="linenos"> 470</span></a>
</span><span id="L-471"><a href="#L-471"><span class="linenos"> 471</span></a>    <span class="k">def</span> <span class="fm">__repr__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-472"><a href="#L-472"><span class="linenos"> 472</span></a>        <span class="k">return</span> <span class="sa">f</span><span class="s2">&quot;&lt;SymbolicTensor: shape=</span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">shape</span><span class="si">}</span><span class="s2">, dtype=</span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">dtype</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">, device=</span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">device</span><span class="si">}</span><span class="s2">&gt;&quot;</span>
</span><span id="L-473"><a href="#L-473"><span class="linenos"> 473</span></a>
</span><span id="L-474"><a href="#L-474"><span class="linenos"> 474</span></a>
</span><span id="L-475"><a href="#L-475"><span class="linenos"> 475</span></a><span class="c1"># =================================</span>
</span><span id="L-476"><a href="#L-476"><span class="linenos"> 476</span></a><span class="c1">#   Operator</span>
</span><span id="L-477"><a href="#L-477"><span class="linenos"> 477</span></a><span class="c1"># =================================</span>
</span><span id="L-478"><a href="#L-478"><span class="linenos"> 478</span></a>
</span><span id="L-479"><a href="#L-479"><span class="linenos"> 479</span></a>
</span><span id="L-480"><a href="#L-480"><span class="linenos"> 480</span></a><span class="k">class</span> <span class="nc">Operator</span><span class="p">:</span>
</span><span id="L-481"><a href="#L-481"><span class="linenos"> 481</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">name</span><span class="p">,</span> <span class="n">variadic_inputs</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">nary_outputs</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>
</span><span id="L-482"><a href="#L-482"><span class="linenos"> 482</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">name</span> <span class="o">=</span> <span class="n">name</span>
</span><span id="L-483"><a href="#L-483"><span class="linenos"> 483</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">variadic_inputs</span> <span class="o">=</span> <span class="n">variadic_inputs</span>
</span><span id="L-484"><a href="#L-484"><span class="linenos"> 484</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">nary_outputs</span> <span class="o">=</span> <span class="n">nary_outputs</span>
</span><span id="L-485"><a href="#L-485"><span class="linenos"> 485</span></a>        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">variadic_inputs</span><span class="p">:</span>
</span><span id="L-486"><a href="#L-486"><span class="linenos"> 486</span></a>            <span class="bp">self</span><span class="o">.</span><span class="n">reorg_args</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">reorg_args_nary</span>
</span><span id="L-487"><a href="#L-487"><span class="linenos"> 487</span></a>
</span><span id="L-488"><a href="#L-488"><span class="linenos"> 488</span></a>    <span class="k">def</span> <span class="fm">__hash__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-489"><a href="#L-489"><span class="linenos"> 489</span></a>        <span class="k">return</span> <span class="nb">hash</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">name</span><span class="p">)</span>
</span><span id="L-490"><a href="#L-490"><span class="linenos"> 490</span></a>
</span><span id="L-491"><a href="#L-491"><span class="linenos"> 491</span></a>    <span class="k">def</span> <span class="fm">__eq__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">other</span><span class="p">):</span>
</span><span id="L-492"><a href="#L-492"><span class="linenos"> 492</span></a>        <span class="k">if</span> <span class="ow">not</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">other</span><span class="p">,</span> <span class="n">Operator</span><span class="p">):</span>
</span><span id="L-493"><a href="#L-493"><span class="linenos"> 493</span></a>            <span class="k">return</span> <span class="kc">False</span>
</span><span id="L-494"><a href="#L-494"><span class="linenos"> 494</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">name</span> <span class="o">==</span> <span class="n">other</span><span class="o">.</span><span class="n">name</span>
</span><span id="L-495"><a href="#L-495"><span class="linenos"> 495</span></a>
</span><span id="L-496"><a href="#L-496"><span class="linenos"> 496</span></a>    <span class="k">def</span> <span class="nf">args_fixer</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="L-497"><a href="#L-497"><span class="linenos"> 497</span></a>        <span class="k">return</span> <span class="n">args</span><span class="p">,</span> <span class="n">params</span>
</span><span id="L-498"><a href="#L-498"><span class="linenos"> 498</span></a>
</span><span id="L-499"><a href="#L-499"><span class="linenos"> 499</span></a>    <span class="k">def</span> <span class="fm">__call__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="L-500"><a href="#L-500"><span class="linenos"> 500</span></a>        <span class="n">args</span><span class="p">,</span> <span class="n">params</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">reorg_args</span><span class="p">(</span><span class="n">args</span><span class="p">,</span> <span class="n">params</span><span class="p">)</span>
</span><span id="L-501"><a href="#L-501"><span class="linenos"> 501</span></a>        <span class="n">args</span><span class="p">,</span> <span class="n">params</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">args_fixer</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)</span>
</span><span id="L-502"><a href="#L-502"><span class="linenos"> 502</span></a>        <span class="n">ret</span> <span class="o">=</span> <span class="n">bind</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)</span>
</span><span id="L-503"><a href="#L-503"><span class="linenos"> 503</span></a>        <span class="k">if</span> <span class="ow">not</span> <span class="bp">self</span><span class="o">.</span><span class="n">nary_outputs</span><span class="p">:</span>
</span><span id="L-504"><a href="#L-504"><span class="linenos"> 504</span></a>            <span class="n">ret</span> <span class="o">=</span> <span class="n">ret</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span>
</span><span id="L-505"><a href="#L-505"><span class="linenos"> 505</span></a>        <span class="k">return</span> <span class="n">ret</span>
</span><span id="L-506"><a href="#L-506"><span class="linenos"> 506</span></a>
</span><span id="L-507"><a href="#L-507"><span class="linenos"> 507</span></a>    <span class="k">def</span> <span class="fm">__repr__</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="nb">str</span><span class="p">:</span>
</span><span id="L-508"><a href="#L-508"><span class="linenos"> 508</span></a>        <span class="k">return</span> <span class="sa">f</span><span class="s2">&quot;&lt;</span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">&gt;&quot;</span>
</span><span id="L-509"><a href="#L-509"><span class="linenos"> 509</span></a>
</span><span id="L-510"><a href="#L-510"><span class="linenos"> 510</span></a>    <span class="k">def</span> <span class="nf">typecheck</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="L-511"><a href="#L-511"><span class="linenos"> 511</span></a>        <span class="k">raise</span> <span class="ne">NotImplementedError</span>
</span><span id="L-512"><a href="#L-512"><span class="linenos"> 512</span></a>
</span><span id="L-513"><a href="#L-513"><span class="linenos"> 513</span></a>    <span class="k">def</span> <span class="nf">jvp</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="L-514"><a href="#L-514"><span class="linenos"> 514</span></a>        <span class="k">raise</span> <span class="ne">NotImplementedError</span>
</span><span id="L-515"><a href="#L-515"><span class="linenos"> 515</span></a>
</span><span id="L-516"><a href="#L-516"><span class="linenos"> 516</span></a>    <span class="k">def</span> <span class="nf">T</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="L-517"><a href="#L-517"><span class="linenos"> 517</span></a>        <span class="k">raise</span> <span class="ne">NotImplementedError</span>
</span><span id="L-518"><a href="#L-518"><span class="linenos"> 518</span></a>
</span><span id="L-519"><a href="#L-519"><span class="linenos"> 519</span></a>    <span class="k">def</span> <span class="nf">vmap</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="L-520"><a href="#L-520"><span class="linenos"> 520</span></a>        <span class="k">raise</span> <span class="ne">NotImplementedError</span>
</span><span id="L-521"><a href="#L-521"><span class="linenos"> 521</span></a>
</span><span id="L-522"><a href="#L-522"><span class="linenos"> 522</span></a>    <span class="k">def</span> <span class="nf">reorg_args</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">args</span><span class="p">,</span> <span class="n">params</span><span class="p">):</span>
</span><span id="L-523"><a href="#L-523"><span class="linenos"> 523</span></a>        <span class="n">sig</span> <span class="o">=</span> <span class="n">inspect</span><span class="o">.</span><span class="n">signature</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">typecheck</span><span class="p">)</span>
</span><span id="L-524"><a href="#L-524"><span class="linenos"> 524</span></a>        <span class="n">args_strs</span> <span class="o">=</span> <span class="p">[</span><span class="n">k</span> <span class="k">for</span> <span class="n">k</span><span class="p">,</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">sig</span><span class="o">.</span><span class="n">parameters</span><span class="o">.</span><span class="n">items</span><span class="p">()</span> <span class="k">if</span> <span class="n">v</span><span class="o">.</span><span class="n">kind</span> <span class="o">==</span> <span class="n">inspect</span><span class="o">.</span><span class="n">Parameter</span><span class="o">.</span><span class="n">POSITIONAL_OR_KEYWORD</span> <span class="ow">and</span> <span class="n">k</span> <span class="o">!=</span> <span class="s2">&quot;self&quot;</span><span class="p">]</span>
</span><span id="L-525"><a href="#L-525"><span class="linenos"> 525</span></a>        <span class="n">params_strs</span> <span class="o">=</span> <span class="p">[</span><span class="n">k</span> <span class="k">for</span> <span class="n">k</span><span class="p">,</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">sig</span><span class="o">.</span><span class="n">parameters</span><span class="o">.</span><span class="n">items</span><span class="p">()</span> <span class="k">if</span> <span class="n">v</span><span class="o">.</span><span class="n">kind</span> <span class="o">==</span> <span class="n">inspect</span><span class="o">.</span><span class="n">Parameter</span><span class="o">.</span><span class="n">KEYWORD_ONLY</span> <span class="ow">and</span> <span class="n">k</span> <span class="o">!=</span> <span class="s2">&quot;self&quot;</span><span class="p">]</span>
</span><span id="L-526"><a href="#L-526"><span class="linenos"> 526</span></a>
</span><span id="L-527"><a href="#L-527"><span class="linenos"> 527</span></a>        <span class="k">if</span> <span class="n">args</span><span class="p">:</span>
</span><span id="L-528"><a href="#L-528"><span class="linenos"> 528</span></a>            <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">args</span><span class="p">)</span> <span class="o">&gt;</span> <span class="nb">len</span><span class="p">(</span><span class="n">args_strs</span><span class="p">):</span>
</span><span id="L-529"><a href="#L-529"><span class="linenos"> 529</span></a>                <span class="n">args</span><span class="p">,</span> <span class="n">rest</span> <span class="o">=</span> <span class="n">args</span><span class="p">[:</span> <span class="nb">len</span><span class="p">(</span><span class="n">args_strs</span><span class="p">)],</span> <span class="n">args</span><span class="p">[</span><span class="nb">len</span><span class="p">(</span><span class="n">args_strs</span><span class="p">)</span> <span class="p">:]</span>
</span><span id="L-530"><a href="#L-530"><span class="linenos"> 530</span></a>                <span class="k">if</span> <span class="n">params_strs</span><span class="p">:</span>
</span><span id="L-531"><a href="#L-531"><span class="linenos"> 531</span></a>                    <span class="n">new_params</span> <span class="o">=</span> <span class="p">{</span><span class="n">k</span><span class="p">:</span> <span class="n">rest_arg</span> <span class="k">for</span> <span class="n">k</span><span class="p">,</span> <span class="n">rest_arg</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">params_strs</span><span class="p">,</span> <span class="n">rest</span><span class="p">)</span> <span class="k">if</span> <span class="n">k</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">params</span><span class="p">}</span>
</span><span id="L-532"><a href="#L-532"><span class="linenos"> 532</span></a>                    <span class="n">params</span> <span class="o">=</span> <span class="p">{</span><span class="o">**</span><span class="n">new_params</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">}</span>
</span><span id="L-533"><a href="#L-533"><span class="linenos"> 533</span></a>            <span class="k">else</span><span class="p">:</span>
</span><span id="L-534"><a href="#L-534"><span class="linenos"> 534</span></a>                <span class="n">args</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">([</span><span class="n">params</span><span class="p">[</span><span class="n">k</span><span class="p">]</span> <span class="k">if</span> <span class="n">k</span> <span class="ow">in</span> <span class="n">params</span> <span class="k">else</span> <span class="n">arg</span> <span class="k">for</span> <span class="n">k</span><span class="p">,</span> <span class="n">arg</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">args_strs</span><span class="p">,</span> <span class="n">args</span><span class="p">)])</span>
</span><span id="L-535"><a href="#L-535"><span class="linenos"> 535</span></a>                <span class="k">assert</span> <span class="nb">len</span><span class="p">(</span><span class="n">args</span><span class="p">)</span> <span class="o">==</span> <span class="nb">len</span><span class="p">(</span><span class="n">args_strs</span><span class="p">)</span>
</span><span id="L-536"><a href="#L-536"><span class="linenos"> 536</span></a>        <span class="k">return</span> <span class="n">args</span><span class="p">,</span> <span class="n">params</span>
</span><span id="L-537"><a href="#L-537"><span class="linenos"> 537</span></a>
</span><span id="L-538"><a href="#L-538"><span class="linenos"> 538</span></a>    <span class="k">def</span> <span class="nf">reorg_args_nary</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">args</span><span class="p">,</span> <span class="n">params</span><span class="p">):</span>
</span><span id="L-539"><a href="#L-539"><span class="linenos"> 539</span></a>        <span class="k">return</span> <span class="n">args</span><span class="p">,</span> <span class="n">params</span>
</span><span id="L-540"><a href="#L-540"><span class="linenos"> 540</span></a>
</span><span id="L-541"><a href="#L-541"><span class="linenos"> 541</span></a>    <span class="k">def</span> <span class="nf">partial_run</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">trace</span><span class="p">,</span> <span class="n">tracers</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="L-542"><a href="#L-542"><span class="linenos"> 542</span></a>        <span class="n">tracers_in</span> <span class="o">=</span> <span class="p">[</span><span class="n">trace</span><span class="o">.</span><span class="n">instantiate_const</span><span class="p">(</span><span class="n">t</span><span class="p">)</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">tracers</span><span class="p">]</span>
</span><span id="L-543"><a href="#L-543"><span class="linenos"> 543</span></a>        <span class="n">symvals_in</span> <span class="o">=</span> <span class="p">[</span><span class="n">t</span><span class="o">.</span><span class="n">symval</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">tracers_in</span><span class="p">]</span>
</span><span id="L-544"><a href="#L-544"><span class="linenos"> 544</span></a>        <span class="n">symvals_out</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">typecheck</span><span class="p">(</span><span class="o">*</span><span class="n">symvals_in</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)</span>
</span><span id="L-545"><a href="#L-545"><span class="linenos"> 545</span></a>        <span class="n">tracers_out</span> <span class="o">=</span> <span class="p">[</span><span class="n">PartialRunTraceTensor</span><span class="p">(</span><span class="n">trace</span><span class="p">,</span> <span class="n">make_unknown_pval</span><span class="p">(</span><span class="n">symval</span><span class="p">),</span> <span class="kc">None</span><span class="p">)</span> <span class="k">for</span> <span class="n">symval</span> <span class="ow">in</span> <span class="n">symvals_out</span><span class="p">]</span>
</span><span id="L-546"><a href="#L-546"><span class="linenos"> 546</span></a>        <span class="n">instruction</span> <span class="o">=</span> <span class="n">InstructionDraft</span><span class="p">(</span>
</span><span id="L-547"><a href="#L-547"><span class="linenos"> 547</span></a>            <span class="bp">self</span><span class="p">,</span>
</span><span id="L-548"><a href="#L-548"><span class="linenos"> 548</span></a>            <span class="n">tracers_in</span><span class="p">,</span>
</span><span id="L-549"><a href="#L-549"><span class="linenos"> 549</span></a>            <span class="n">params</span><span class="p">,</span>
</span><span id="L-550"><a href="#L-550"><span class="linenos"> 550</span></a>            <span class="n">symvals_out</span><span class="p">,</span>
</span><span id="L-551"><a href="#L-551"><span class="linenos"> 551</span></a>            <span class="n">list_map</span><span class="p">(</span><span class="n">weakref</span><span class="o">.</span><span class="n">ref</span><span class="p">,</span> <span class="n">tracers_out</span><span class="p">),</span>
</span><span id="L-552"><a href="#L-552"><span class="linenos"> 552</span></a>        <span class="p">)</span>
</span><span id="L-553"><a href="#L-553"><span class="linenos"> 553</span></a>        <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">tracers_out</span><span class="p">:</span>
</span><span id="L-554"><a href="#L-554"><span class="linenos"> 554</span></a>            <span class="n">t</span><span class="o">.</span><span class="n">draft</span> <span class="o">=</span> <span class="n">instruction</span>
</span><span id="L-555"><a href="#L-555"><span class="linenos"> 555</span></a>        <span class="k">return</span> <span class="n">tracers_out</span>
</span><span id="L-556"><a href="#L-556"><span class="linenos"> 556</span></a>
</span><span id="L-557"><a href="#L-557"><span class="linenos"> 557</span></a>    <span class="k">def</span> <span class="nf">partial_run_instruction</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">unks_in</span><span class="p">,</span> <span class="n">instruction</span><span class="p">):</span>
</span><span id="L-558"><a href="#L-558"><span class="linenos"> 558</span></a>        <span class="k">if</span> <span class="nb">any</span><span class="p">(</span><span class="n">unks_in</span><span class="p">):</span>
</span><span id="L-559"><a href="#L-559"><span class="linenos"> 559</span></a>            <span class="n">instruction1</span> <span class="o">=</span> <span class="kc">None</span>
</span><span id="L-560"><a href="#L-560"><span class="linenos"> 560</span></a>            <span class="n">instruction2</span> <span class="o">=</span> <span class="n">Instruction</span><span class="p">(</span>
</span><span id="L-561"><a href="#L-561"><span class="linenos"> 561</span></a>                <span class="n">instruction</span><span class="o">.</span><span class="n">op</span><span class="p">,</span>
</span><span id="L-562"><a href="#L-562"><span class="linenos"> 562</span></a>                <span class="n">instruction</span><span class="o">.</span><span class="n">inputs</span><span class="p">,</span>
</span><span id="L-563"><a href="#L-563"><span class="linenos"> 563</span></a>                <span class="n">instruction</span><span class="o">.</span><span class="n">params</span><span class="p">,</span>
</span><span id="L-564"><a href="#L-564"><span class="linenos"> 564</span></a>                <span class="n">instruction</span><span class="o">.</span><span class="n">out_binders</span><span class="p">,</span>
</span><span id="L-565"><a href="#L-565"><span class="linenos"> 565</span></a>            <span class="p">)</span>
</span><span id="L-566"><a href="#L-566"><span class="linenos"> 566</span></a>            <span class="n">unks_out</span> <span class="o">=</span> <span class="p">[</span><span class="kc">True</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="n">instruction</span><span class="o">.</span><span class="n">out_binders</span><span class="p">]</span>
</span><span id="L-567"><a href="#L-567"><span class="linenos"> 567</span></a>            <span class="n">res</span> <span class="o">=</span> <span class="p">[</span><span class="n">v</span> <span class="k">for</span> <span class="n">unk</span><span class="p">,</span> <span class="n">v</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">unks_in</span><span class="p">,</span> <span class="n">instruction</span><span class="o">.</span><span class="n">inputs</span><span class="p">)</span> <span class="k">if</span> <span class="p">((</span><span class="ow">not</span> <span class="n">unk</span><span class="p">)</span> <span class="ow">and</span> <span class="nb">type</span><span class="p">(</span><span class="n">v</span><span class="p">)</span> <span class="ow">is</span> <span class="n">Var</span><span class="p">)]</span>
</span><span id="L-568"><a href="#L-568"><span class="linenos"> 568</span></a>        <span class="k">else</span><span class="p">:</span>
</span><span id="L-569"><a href="#L-569"><span class="linenos"> 569</span></a>            <span class="n">instruction1</span> <span class="o">=</span> <span class="n">instruction</span>
</span><span id="L-570"><a href="#L-570"><span class="linenos"> 570</span></a>            <span class="n">instruction2</span> <span class="o">=</span> <span class="kc">None</span>
</span><span id="L-571"><a href="#L-571"><span class="linenos"> 571</span></a>            <span class="n">unks_out</span> <span class="o">=</span> <span class="p">[</span><span class="kc">False</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="n">instruction</span><span class="o">.</span><span class="n">out_binders</span><span class="p">]</span>
</span><span id="L-572"><a href="#L-572"><span class="linenos"> 572</span></a>            <span class="n">res</span> <span class="o">=</span> <span class="kc">None</span>
</span><span id="L-573"><a href="#L-573"><span class="linenos"> 573</span></a>
</span><span id="L-574"><a href="#L-574"><span class="linenos"> 574</span></a>        <span class="k">return</span> <span class="n">instruction1</span><span class="p">,</span> <span class="n">instruction2</span><span class="p">,</span> <span class="n">unks_out</span><span class="p">,</span> <span class="n">res</span>
</span><span id="L-575"><a href="#L-575"><span class="linenos"> 575</span></a>
</span><span id="L-576"><a href="#L-576"><span class="linenos"> 576</span></a>
</span><span id="L-577"><a href="#L-577"><span class="linenos"> 577</span></a><span class="k">class</span> <span class="nc">MetaOperator</span><span class="p">(</span><span class="n">Operator</span><span class="p">):</span>
</span><span id="L-578"><a href="#L-578"><span class="linenos"> 578</span></a>    <span class="k">def</span> <span class="nf">meta_impl</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">):</span>
</span><span id="L-579"><a href="#L-579"><span class="linenos"> 579</span></a>        <span class="k">raise</span> <span class="ne">NotImplementedError</span>
</span><span id="L-580"><a href="#L-580"><span class="linenos"> 580</span></a>
</span><span id="L-581"><a href="#L-581"><span class="linenos"> 581</span></a>
</span><span id="L-582"><a href="#L-582"><span class="linenos"> 582</span></a><span class="k">class</span> <span class="nc">UnaryOperator</span><span class="p">(</span><span class="n">Operator</span><span class="p">):</span>
</span><span id="L-583"><a href="#L-583"><span class="linenos"> 583</span></a>    <span class="k">def</span> <span class="nf">vmap</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">x</span><span class="p">,</span> <span class="o">*</span><span class="p">,</span> <span class="n">dim_size</span><span class="p">,</span> <span class="n">vals_in</span><span class="p">,</span> <span class="n">dims_in</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="L-584"><a href="#L-584"><span class="linenos"> 584</span></a>        <span class="p">(</span><span class="n">x</span><span class="p">,),</span> <span class="p">(</span><span class="n">x_bdim</span><span class="p">,)</span> <span class="o">=</span> <span class="n">vals_in</span><span class="p">,</span> <span class="n">dims_in</span>
</span><span id="L-585"><a href="#L-585"><span class="linenos"> 585</span></a>        <span class="k">return</span> <span class="p">[</span><span class="bp">self</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)],</span> <span class="p">[</span><span class="n">x_bdim</span><span class="p">]</span>
</span><span id="L-586"><a href="#L-586"><span class="linenos"> 586</span></a>
</span><span id="L-587"><a href="#L-587"><span class="linenos"> 587</span></a>    <span class="k">def</span> <span class="nf">typecheck</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">x</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="L-588"><a href="#L-588"><span class="linenos"> 588</span></a>        <span class="k">return</span> <span class="p">[</span><span class="n">x</span><span class="o">.</span><span class="n">like</span><span class="p">()]</span>
</span><span id="L-589"><a href="#L-589"><span class="linenos"> 589</span></a>
</span><span id="L-590"><a href="#L-590"><span class="linenos"> 590</span></a>    <span class="k">def</span> <span class="nf">jvp</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">primals</span><span class="p">,</span> <span class="n">tangents</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="L-591"><a href="#L-591"><span class="linenos"> 591</span></a>        <span class="p">(</span><span class="n">x</span><span class="p">,),</span> <span class="p">(</span><span class="n">x_dot</span><span class="p">,)</span> <span class="o">=</span> <span class="n">primals</span><span class="p">,</span> <span class="n">tangents</span>
</span><span id="L-592"><a href="#L-592"><span class="linenos"> 592</span></a>        <span class="k">return</span> <span class="p">[</span><span class="bp">self</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)],</span> <span class="p">[</span><span class="bp">self</span><span class="p">(</span><span class="n">x_dot</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)]</span>
</span><span id="L-593"><a href="#L-593"><span class="linenos"> 593</span></a>
</span><span id="L-594"><a href="#L-594"><span class="linenos"> 594</span></a>
</span><span id="L-595"><a href="#L-595"><span class="linenos"> 595</span></a><span class="k">class</span> <span class="nc">BinaryOperator</span><span class="p">(</span><span class="n">Operator</span><span class="p">):</span>
</span><span id="L-596"><a href="#L-596"><span class="linenos"> 596</span></a>    <span class="n">boolean_output</span> <span class="o">=</span> <span class="kc">False</span>
</span><span id="L-597"><a href="#L-597"><span class="linenos"> 597</span></a>
</span><span id="L-598"><a href="#L-598"><span class="linenos"> 598</span></a>    <span class="k">def</span> <span class="nf">args_fixer</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">x</span><span class="p">,</span> <span class="n">w</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="L-599"><a href="#L-599"><span class="linenos"> 599</span></a>        <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">UndefinedPrimal</span><span class="p">)</span> <span class="ow">or</span> <span class="nb">type</span><span class="p">(</span><span class="n">w</span><span class="p">)</span> <span class="ow">is</span> <span class="n">UndefinedPrimal</span><span class="p">:</span>
</span><span id="L-600"><a href="#L-600"><span class="linenos"> 600</span></a>            <span class="k">assert</span> <span class="n">x</span><span class="o">.</span><span class="n">shape</span> <span class="o">==</span> <span class="n">w</span><span class="o">.</span><span class="n">shape</span>
</span><span id="L-601"><a href="#L-601"><span class="linenos"> 601</span></a>            <span class="k">return</span> <span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">w</span><span class="p">),</span> <span class="n">params</span>
</span><span id="L-602"><a href="#L-602"><span class="linenos"> 602</span></a>
</span><span id="L-603"><a href="#L-603"><span class="linenos"> 603</span></a>        <span class="k">if</span> <span class="nb">type</span><span class="p">(</span><span class="n">x</span><span class="p">)</span> <span class="ow">in</span> <span class="n">TraceTensor</span><span class="o">.</span><span class="n">PYTHON_TYPES</span><span class="p">:</span>
</span><span id="L-604"><a href="#L-604"><span class="linenos"> 604</span></a>            <span class="n">x</span> <span class="o">=</span> <span class="n">backend</span><span class="o">.</span><span class="n">full</span><span class="p">(</span><span class="n">shape</span><span class="o">=</span><span class="p">(),</span> <span class="n">fill_value</span><span class="o">=</span><span class="n">x</span><span class="p">,</span> <span class="n">dtype</span><span class="o">=</span><span class="n">w</span><span class="o">.</span><span class="n">dtype</span><span class="p">)</span>
</span><span id="L-605"><a href="#L-605"><span class="linenos"> 605</span></a>        <span class="k">elif</span> <span class="nb">type</span><span class="p">(</span><span class="n">w</span><span class="p">)</span> <span class="ow">in</span> <span class="n">TraceTensor</span><span class="o">.</span><span class="n">PYTHON_TYPES</span><span class="p">:</span>
</span><span id="L-606"><a href="#L-606"><span class="linenos"> 606</span></a>            <span class="n">w</span> <span class="o">=</span> <span class="n">backend</span><span class="o">.</span><span class="n">full</span><span class="p">(</span><span class="n">shape</span><span class="o">=</span><span class="p">(),</span> <span class="n">fill_value</span><span class="o">=</span><span class="n">w</span><span class="p">,</span> <span class="n">dtype</span><span class="o">=</span><span class="n">x</span><span class="o">.</span><span class="n">dtype</span><span class="p">)</span>
</span><span id="L-607"><a href="#L-607"><span class="linenos"> 607</span></a>
</span><span id="L-608"><a href="#L-608"><span class="linenos"> 608</span></a>        <span class="n">shape_delta</span> <span class="o">=</span> <span class="n">x</span><span class="o">.</span><span class="n">ndim</span> <span class="o">-</span> <span class="n">w</span><span class="o">.</span><span class="n">ndim</span>
</span><span id="L-609"><a href="#L-609"><span class="linenos"> 609</span></a>        <span class="k">if</span> <span class="n">shape_delta</span> <span class="o">&gt;</span> <span class="mi">0</span><span class="p">:</span>
</span><span id="L-610"><a href="#L-610"><span class="linenos"> 610</span></a>            <span class="n">w</span> <span class="o">=</span> <span class="n">w</span><span class="o">.</span><span class="n">reshape</span><span class="p">((</span><span class="mi">1</span><span class="p">,)</span> <span class="o">*</span> <span class="n">shape_delta</span> <span class="o">+</span> <span class="n">w</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span>
</span><span id="L-611"><a href="#L-611"><span class="linenos"> 611</span></a>        <span class="k">elif</span> <span class="n">shape_delta</span> <span class="o">&lt;</span> <span class="mi">0</span><span class="p">:</span>
</span><span id="L-612"><a href="#L-612"><span class="linenos"> 612</span></a>            <span class="n">x</span> <span class="o">=</span> <span class="n">x</span><span class="o">.</span><span class="n">reshape</span><span class="p">((</span><span class="mi">1</span><span class="p">,)</span> <span class="o">*</span> <span class="o">-</span><span class="n">shape_delta</span> <span class="o">+</span> <span class="n">x</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span>
</span><span id="L-613"><a href="#L-613"><span class="linenos"> 613</span></a>
</span><span id="L-614"><a href="#L-614"><span class="linenos"> 614</span></a>        <span class="n">shape_ret</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">([</span><span class="nb">max</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">w</span><span class="p">)</span> <span class="k">for</span> <span class="n">x</span><span class="p">,</span> <span class="n">w</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">shape</span><span class="p">,</span> <span class="n">w</span><span class="o">.</span><span class="n">shape</span><span class="p">)])</span>
</span><span id="L-615"><a href="#L-615"><span class="linenos"> 615</span></a>        <span class="k">if</span> <span class="n">x</span><span class="o">.</span><span class="n">shape</span> <span class="o">!=</span> <span class="n">shape_ret</span><span class="p">:</span>
</span><span id="L-616"><a href="#L-616"><span class="linenos"> 616</span></a>            <span class="n">x</span> <span class="o">=</span> <span class="n">x</span><span class="o">.</span><span class="n">expand</span><span class="p">(</span><span class="n">shape_ret</span><span class="p">)</span>
</span><span id="L-617"><a href="#L-617"><span class="linenos"> 617</span></a>        <span class="k">if</span> <span class="n">w</span><span class="o">.</span><span class="n">shape</span> <span class="o">!=</span> <span class="n">shape_ret</span><span class="p">:</span>
</span><span id="L-618"><a href="#L-618"><span class="linenos"> 618</span></a>            <span class="n">w</span> <span class="o">=</span> <span class="n">w</span><span class="o">.</span><span class="n">expand</span><span class="p">(</span><span class="n">shape_ret</span><span class="p">)</span>
</span><span id="L-619"><a href="#L-619"><span class="linenos"> 619</span></a>
</span><span id="L-620"><a href="#L-620"><span class="linenos"> 620</span></a>        <span class="k">if</span> <span class="nb">type</span><span class="p">(</span><span class="n">x</span><span class="p">)</span> <span class="ow">is</span> <span class="n">Tensor</span> <span class="ow">and</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">w</span><span class="p">,</span> <span class="n">TraceTensor</span><span class="p">):</span>
</span><span id="L-621"><a href="#L-621"><span class="linenos"> 621</span></a>            <span class="n">x</span> <span class="o">=</span> <span class="n">w</span><span class="o">.</span><span class="n">_trace</span><span class="o">.</span><span class="n">pure</span><span class="p">(</span><span class="n">x</span><span class="p">)</span>
</span><span id="L-622"><a href="#L-622"><span class="linenos"> 622</span></a>        <span class="k">elif</span> <span class="nb">type</span><span class="p">(</span><span class="n">w</span><span class="p">)</span> <span class="ow">is</span> <span class="n">Tensor</span> <span class="ow">and</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">TraceTensor</span><span class="p">):</span>
</span><span id="L-623"><a href="#L-623"><span class="linenos"> 623</span></a>            <span class="n">w</span> <span class="o">=</span> <span class="n">x</span><span class="o">.</span><span class="n">_trace</span><span class="o">.</span><span class="n">pure</span><span class="p">(</span><span class="n">w</span><span class="p">)</span>
</span><span id="L-624"><a href="#L-624"><span class="linenos"> 624</span></a>        <span class="c1"># TODO: https://jax.readthedocs.io/en/latest/type_promotion.html</span>
</span><span id="L-625"><a href="#L-625"><span class="linenos"> 625</span></a>        <span class="k">if</span> <span class="n">x</span><span class="o">.</span><span class="n">dtype</span> <span class="o">!=</span> <span class="n">w</span><span class="o">.</span><span class="n">dtype</span><span class="p">:</span>
</span><span id="L-626"><a href="#L-626"><span class="linenos"> 626</span></a>            <span class="c1"># {int, bool} -&gt; float</span>
</span><span id="L-627"><a href="#L-627"><span class="linenos"> 627</span></a>            <span class="k">if</span> <span class="n">dtypes</span><span class="o">.</span><span class="n">is_float</span><span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">dtype</span><span class="p">)</span> <span class="o">^</span> <span class="n">dtypes</span><span class="o">.</span><span class="n">is_float</span><span class="p">(</span><span class="n">w</span><span class="o">.</span><span class="n">dtype</span><span class="p">):</span>
</span><span id="L-628"><a href="#L-628"><span class="linenos"> 628</span></a>                <span class="k">if</span> <span class="n">dtypes</span><span class="o">.</span><span class="n">is_float</span><span class="p">(</span><span class="n">w</span><span class="o">.</span><span class="n">dtype</span><span class="p">):</span>
</span><span id="L-629"><a href="#L-629"><span class="linenos"> 629</span></a>                    <span class="n">x</span> <span class="o">=</span> <span class="n">x</span><span class="o">.</span><span class="n">cast</span><span class="p">(</span><span class="n">w</span><span class="o">.</span><span class="n">dtype</span><span class="p">)</span>
</span><span id="L-630"><a href="#L-630"><span class="linenos"> 630</span></a>                <span class="k">elif</span> <span class="n">dtypes</span><span class="o">.</span><span class="n">is_float</span><span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">dtype</span><span class="p">):</span>
</span><span id="L-631"><a href="#L-631"><span class="linenos"> 631</span></a>                    <span class="n">w</span> <span class="o">=</span> <span class="n">w</span><span class="o">.</span><span class="n">cast</span><span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">dtype</span><span class="p">)</span>
</span><span id="L-632"><a href="#L-632"><span class="linenos"> 632</span></a>            <span class="c1"># bool -&gt; int</span>
</span><span id="L-633"><a href="#L-633"><span class="linenos"> 633</span></a>            <span class="k">elif</span> <span class="n">dtypes</span><span class="o">.</span><span class="n">is_int</span><span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">dtype</span><span class="p">)</span> <span class="o">^</span> <span class="n">dtypes</span><span class="o">.</span><span class="n">is_int</span><span class="p">(</span><span class="n">w</span><span class="o">.</span><span class="n">dtype</span><span class="p">):</span>
</span><span id="L-634"><a href="#L-634"><span class="linenos"> 634</span></a>                <span class="k">if</span> <span class="n">dtypes</span><span class="o">.</span><span class="n">is_int</span><span class="p">(</span><span class="n">w</span><span class="o">.</span><span class="n">dtype</span><span class="p">):</span>
</span><span id="L-635"><a href="#L-635"><span class="linenos"> 635</span></a>                    <span class="n">x</span> <span class="o">=</span> <span class="n">x</span><span class="o">.</span><span class="n">cast</span><span class="p">(</span><span class="n">w</span><span class="o">.</span><span class="n">dtype</span><span class="p">)</span>
</span><span id="L-636"><a href="#L-636"><span class="linenos"> 636</span></a>                <span class="k">elif</span> <span class="n">dtypes</span><span class="o">.</span><span class="n">is_int</span><span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">dtype</span><span class="p">):</span>
</span><span id="L-637"><a href="#L-637"><span class="linenos"> 637</span></a>                    <span class="n">w</span> <span class="o">=</span> <span class="n">w</span><span class="o">.</span><span class="n">cast</span><span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">dtype</span><span class="p">)</span>
</span><span id="L-638"><a href="#L-638"><span class="linenos"> 638</span></a>            <span class="k">else</span><span class="p">:</span>  <span class="c1"># TODO: fine-grained type promotions</span>
</span><span id="L-639"><a href="#L-639"><span class="linenos"> 639</span></a>                <span class="k">raise</span> <span class="ne">NotImplementedError</span><span class="p">(</span><span class="s2">&quot;No other type promotion rules&quot;</span><span class="p">)</span>
</span><span id="L-640"><a href="#L-640"><span class="linenos"> 640</span></a>
</span><span id="L-641"><a href="#L-641"><span class="linenos"> 641</span></a>        <span class="k">return</span> <span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">w</span><span class="p">),</span> <span class="n">params</span>
</span><span id="L-642"><a href="#L-642"><span class="linenos"> 642</span></a>
</span><span id="L-643"><a href="#L-643"><span class="linenos"> 643</span></a>    <span class="k">def</span> <span class="nf">vmap</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">dim_size</span><span class="p">,</span> <span class="n">vals_in</span><span class="p">,</span> <span class="n">dims_in</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="L-644"><a href="#L-644"><span class="linenos"> 644</span></a>        <span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">w</span><span class="p">),</span> <span class="p">(</span><span class="n">x_bdim</span><span class="p">,</span> <span class="n">w_bdim</span><span class="p">)</span> <span class="o">=</span> <span class="n">vals_in</span><span class="p">,</span> <span class="n">dims_in</span>
</span><span id="L-645"><a href="#L-645"><span class="linenos"> 645</span></a>        <span class="k">if</span> <span class="n">x_bdim</span> <span class="o">!=</span> <span class="n">w_bdim</span><span class="p">:</span>
</span><span id="L-646"><a href="#L-646"><span class="linenos"> 646</span></a>            <span class="k">if</span> <span class="n">x_bdim</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
</span><span id="L-647"><a href="#L-647"><span class="linenos"> 647</span></a>                <span class="n">x</span> <span class="o">=</span> <span class="n">VMapTrace</span><span class="o">.</span><span class="n">move_vmap_dim</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">dim_size</span><span class="p">,</span> <span class="n">x_bdim</span><span class="p">,</span> <span class="n">w_bdim</span><span class="p">)</span>
</span><span id="L-648"><a href="#L-648"><span class="linenos"> 648</span></a>                <span class="n">x_bdim</span> <span class="o">=</span> <span class="n">w_bdim</span>
</span><span id="L-649"><a href="#L-649"><span class="linenos"> 649</span></a>            <span class="k">else</span><span class="p">:</span>
</span><span id="L-650"><a href="#L-650"><span class="linenos"> 650</span></a>                <span class="n">w</span> <span class="o">=</span> <span class="n">VMapTrace</span><span class="o">.</span><span class="n">move_vmap_dim</span><span class="p">(</span><span class="n">w</span><span class="p">,</span> <span class="n">dim_size</span><span class="p">,</span> <span class="n">w_bdim</span><span class="p">,</span> <span class="n">x_bdim</span><span class="p">)</span>
</span><span id="L-651"><a href="#L-651"><span class="linenos"> 651</span></a>        <span class="k">return</span> <span class="p">[</span><span class="bp">self</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">w</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)],</span> <span class="p">[</span><span class="n">x_bdim</span><span class="p">]</span>
</span><span id="L-652"><a href="#L-652"><span class="linenos"> 652</span></a>
</span><span id="L-653"><a href="#L-653"><span class="linenos"> 653</span></a>    <span class="k">def</span> <span class="nf">typecheck</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">x</span><span class="p">:</span> <span class="n">SymbolicTensor</span><span class="p">,</span> <span class="n">y</span><span class="p">:</span> <span class="n">SymbolicTensor</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">List</span><span class="p">[</span><span class="n">SymbolicTensor</span><span class="p">]:</span>
</span><span id="L-654"><a href="#L-654"><span class="linenos"> 654</span></a>        <span class="k">if</span> <span class="ow">not</span> <span class="nb">type</span><span class="p">(</span><span class="n">x</span><span class="p">)</span> <span class="ow">in</span> <span class="p">(</span><span class="n">Tensor</span><span class="p">,</span> <span class="n">SymbolicTensor</span><span class="p">)</span> <span class="ow">or</span> <span class="ow">not</span> <span class="nb">type</span><span class="p">(</span><span class="n">x</span><span class="p">)</span> <span class="ow">in</span> <span class="p">(</span>
</span><span id="L-655"><a href="#L-655"><span class="linenos"> 655</span></a>            <span class="n">Tensor</span><span class="p">,</span>
</span><span id="L-656"><a href="#L-656"><span class="linenos"> 656</span></a>            <span class="n">SymbolicTensor</span><span class="p">,</span>
</span><span id="L-657"><a href="#L-657"><span class="linenos"> 657</span></a>        <span class="p">):</span>
</span><span id="L-658"><a href="#L-658"><span class="linenos"> 658</span></a>            <span class="k">raise</span> <span class="ne">TypeError</span>
</span><span id="L-659"><a href="#L-659"><span class="linenos"> 659</span></a>        <span class="n">symx</span> <span class="o">=</span> <span class="n">SymbolicTensor</span><span class="o">.</span><span class="n">like</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">dtype</span><span class="o">=</span><span class="n">dtypes</span><span class="o">.</span><span class="n">bool</span> <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">boolean_output</span> <span class="k">else</span> <span class="n">x</span><span class="o">.</span><span class="n">dtype</span><span class="p">)</span>
</span><span id="L-660"><a href="#L-660"><span class="linenos"> 660</span></a>        <span class="n">symy</span> <span class="o">=</span> <span class="n">SymbolicTensor</span><span class="o">.</span><span class="n">like</span><span class="p">(</span><span class="n">y</span><span class="p">,</span> <span class="n">dtype</span><span class="o">=</span><span class="n">dtypes</span><span class="o">.</span><span class="n">bool</span> <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">boolean_output</span> <span class="k">else</span> <span class="n">y</span><span class="o">.</span><span class="n">dtype</span><span class="p">)</span>
</span><span id="L-661"><a href="#L-661"><span class="linenos"> 661</span></a>        <span class="k">if</span> <span class="n">x</span><span class="o">.</span><span class="n">dtype</span> <span class="o">!=</span> <span class="n">y</span><span class="o">.</span><span class="n">dtype</span><span class="p">:</span>
</span><span id="L-662"><a href="#L-662"><span class="linenos"> 662</span></a>            <span class="k">raise</span> <span class="ne">TypeError</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;x.dtype (</span><span class="si">{</span><span class="n">x</span><span class="o">.</span><span class="n">dtype</span><span class="si">}</span><span class="s2">) != y.dtype (</span><span class="si">{</span><span class="n">y</span><span class="o">.</span><span class="n">dtype</span><span class="si">}</span><span class="s2">)&quot;</span><span class="p">)</span>
</span><span id="L-663"><a href="#L-663"><span class="linenos"> 663</span></a>        <span class="k">if</span> <span class="n">symx</span> <span class="o">==</span> <span class="n">symy</span><span class="p">:</span>
</span><span id="L-664"><a href="#L-664"><span class="linenos"> 664</span></a>            <span class="k">return</span> <span class="p">[</span><span class="n">symx</span><span class="p">]</span>
</span><span id="L-665"><a href="#L-665"><span class="linenos"> 665</span></a>        <span class="n">shape_delta</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">symx</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span> <span class="o">-</span> <span class="nb">len</span><span class="p">(</span><span class="n">symy</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span>
</span><span id="L-666"><a href="#L-666"><span class="linenos"> 666</span></a>        <span class="k">if</span> <span class="n">shape_delta</span> <span class="o">&gt;</span> <span class="mi">0</span><span class="p">:</span>
</span><span id="L-667"><a href="#L-667"><span class="linenos"> 667</span></a>            <span class="n">symy</span> <span class="o">=</span> <span class="n">symy</span><span class="o">.</span><span class="n">like</span><span class="p">(</span><span class="n">shape</span><span class="o">=</span><span class="p">(</span><span class="mi">1</span><span class="p">,)</span> <span class="o">*</span> <span class="n">shape_delta</span> <span class="o">+</span> <span class="n">symy</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span>
</span><span id="L-668"><a href="#L-668"><span class="linenos"> 668</span></a>        <span class="k">elif</span> <span class="n">shape_delta</span> <span class="o">&lt;</span> <span class="mi">0</span><span class="p">:</span>
</span><span id="L-669"><a href="#L-669"><span class="linenos"> 669</span></a>            <span class="n">x</span> <span class="o">=</span> <span class="n">x</span><span class="o">.</span><span class="n">reshape</span><span class="p">((</span><span class="mi">1</span><span class="p">,)</span> <span class="o">*</span> <span class="o">-</span><span class="n">shape_delta</span> <span class="o">+</span> <span class="n">symx</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span>
</span><span id="L-670"><a href="#L-670"><span class="linenos"> 670</span></a>            <span class="n">symx</span> <span class="o">=</span> <span class="n">symx</span><span class="o">.</span><span class="n">like</span><span class="p">(</span><span class="n">shape</span><span class="o">=</span><span class="p">(</span><span class="mi">1</span><span class="p">,)</span> <span class="o">*</span> <span class="o">-</span><span class="n">shape_delta</span> <span class="o">+</span> <span class="n">symx</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span>
</span><span id="L-671"><a href="#L-671"><span class="linenos"> 671</span></a>        <span class="k">if</span> <span class="n">symx</span> <span class="o">==</span> <span class="n">symy</span><span class="p">:</span>
</span><span id="L-672"><a href="#L-672"><span class="linenos"> 672</span></a>            <span class="k">return</span> <span class="p">[</span><span class="n">symx</span><span class="p">]</span>
</span><span id="L-673"><a href="#L-673"><span class="linenos"> 673</span></a>        <span class="k">else</span><span class="p">:</span>
</span><span id="L-674"><a href="#L-674"><span class="linenos"> 674</span></a>            <span class="n">shape_ret</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">([</span><span class="nb">max</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">w</span><span class="p">)</span> <span class="k">for</span> <span class="n">x</span><span class="p">,</span> <span class="n">w</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">symx</span><span class="o">.</span><span class="n">shape</span><span class="p">,</span> <span class="n">symy</span><span class="o">.</span><span class="n">shape</span><span class="p">)])</span>
</span><span id="L-675"><a href="#L-675"><span class="linenos"> 675</span></a>            <span class="k">if</span> <span class="n">symx</span><span class="o">.</span><span class="n">shape</span> <span class="o">!=</span> <span class="n">shape_ret</span><span class="p">:</span>
</span><span id="L-676"><a href="#L-676"><span class="linenos"> 676</span></a>                <span class="n">symx</span> <span class="o">=</span> <span class="n">symx</span><span class="o">.</span><span class="n">like</span><span class="p">(</span><span class="n">shape</span><span class="o">=</span><span class="n">shape_ret</span><span class="p">)</span>
</span><span id="L-677"><a href="#L-677"><span class="linenos"> 677</span></a>            <span class="k">if</span> <span class="n">symy</span><span class="o">.</span><span class="n">shape</span> <span class="o">!=</span> <span class="n">shape_ret</span><span class="p">:</span>
</span><span id="L-678"><a href="#L-678"><span class="linenos"> 678</span></a>                <span class="n">symy</span> <span class="o">=</span> <span class="n">symx</span><span class="o">.</span><span class="n">like</span><span class="p">(</span><span class="n">shape</span><span class="o">=</span><span class="n">shape_ret</span><span class="p">)</span>
</span><span id="L-679"><a href="#L-679"><span class="linenos"> 679</span></a>            <span class="k">if</span> <span class="n">symx</span> <span class="o">!=</span> <span class="n">symy</span><span class="p">:</span>
</span><span id="L-680"><a href="#L-680"><span class="linenos"> 680</span></a>                <span class="k">raise</span> <span class="ne">TypeError</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;symx (</span><span class="si">{</span><span class="n">symx</span><span class="si">}</span><span class="s2">) != symy (</span><span class="si">{</span><span class="n">symy</span><span class="si">}</span><span class="s2">)&quot;</span><span class="p">)</span>
</span><span id="L-681"><a href="#L-681"><span class="linenos"> 681</span></a>            <span class="k">return</span> <span class="p">[</span><span class="n">symx</span><span class="p">]</span>
</span><span id="L-682"><a href="#L-682"><span class="linenos"> 682</span></a>
</span><span id="L-683"><a href="#L-683"><span class="linenos"> 683</span></a>    <span class="k">def</span> <span class="nf">jvp</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">primals</span><span class="p">,</span> <span class="n">tangents</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="L-684"><a href="#L-684"><span class="linenos"> 684</span></a>        <span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">w</span><span class="p">),</span> <span class="p">(</span><span class="n">x_dot</span><span class="p">,</span> <span class="n">w_dot</span><span class="p">)</span> <span class="o">=</span> <span class="n">primals</span><span class="p">,</span> <span class="n">tangents</span>
</span><span id="L-685"><a href="#L-685"><span class="linenos"> 685</span></a>        <span class="k">return</span> <span class="p">[</span><span class="bp">self</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">w</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)],</span> <span class="p">[</span><span class="bp">self</span><span class="p">(</span><span class="n">x_dot</span><span class="p">,</span> <span class="n">w_dot</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)]</span>
</span><span id="L-686"><a href="#L-686"><span class="linenos"> 686</span></a>
</span><span id="L-687"><a href="#L-687"><span class="linenos"> 687</span></a>    <span class="k">def</span> <span class="nf">T</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">cotangents</span><span class="p">,</span> <span class="n">x</span><span class="p">,</span> <span class="n">w</span><span class="p">):</span>
</span><span id="L-688"><a href="#L-688"><span class="linenos"> 688</span></a>        <span class="p">(</span><span class="n">gL_y</span><span class="p">,)</span> <span class="o">=</span> <span class="n">cotangents</span>
</span><span id="L-689"><a href="#L-689"><span class="linenos"> 689</span></a>        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">boolean_output</span><span class="p">:</span>
</span><span id="L-690"><a href="#L-690"><span class="linenos"> 690</span></a>            <span class="n">gL_y</span> <span class="o">=</span> <span class="n">gL_y</span><span class="o">.</span><span class="n">cast</span><span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">dtype</span><span class="p">)</span>
</span><span id="L-691"><a href="#L-691"><span class="linenos"> 691</span></a>        <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">UndefinedPrimal</span><span class="p">):</span>
</span><span id="L-692"><a href="#L-692"><span class="linenos"> 692</span></a>            <span class="k">return</span> <span class="p">[</span><span class="n">gL_y</span><span class="p">,</span> <span class="n">NullCotangent</span><span class="p">]</span>
</span><span id="L-693"><a href="#L-693"><span class="linenos"> 693</span></a>        <span class="k">elif</span> <span class="nb">type</span><span class="p">(</span><span class="n">w</span><span class="p">)</span> <span class="ow">is</span> <span class="n">UndefinedPrimal</span><span class="p">:</span>
</span><span id="L-694"><a href="#L-694"><span class="linenos"> 694</span></a>            <span class="k">return</span> <span class="p">[</span><span class="n">NullCotangent</span><span class="p">,</span> <span class="n">gL_y</span><span class="p">]</span>
</span><span id="L-695"><a href="#L-695"><span class="linenos"> 695</span></a>
</span><span id="L-696"><a href="#L-696"><span class="linenos"> 696</span></a>
</span><span id="L-697"><a href="#L-697"><span class="linenos"> 697</span></a><span class="k">class</span> <span class="nc">ReduceOperator</span><span class="p">(</span><span class="n">Operator</span><span class="p">):</span>
</span><span id="L-698"><a href="#L-698"><span class="linenos"> 698</span></a>    <span class="k">def</span> <span class="nf">args_fixer</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">x</span><span class="p">,</span> <span class="o">*</span><span class="p">,</span> <span class="n">dim</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">keepdim</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>
</span><span id="L-699"><a href="#L-699"><span class="linenos"> 699</span></a>        <span class="k">if</span> <span class="n">dim</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
</span><span id="L-700"><a href="#L-700"><span class="linenos"> 700</span></a>            <span class="n">dim</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="nb">range</span><span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">ndim</span><span class="p">))</span>
</span><span id="L-701"><a href="#L-701"><span class="linenos"> 701</span></a>        <span class="k">elif</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">dim</span><span class="p">,</span> <span class="nb">int</span><span class="p">):</span>
</span><span id="L-702"><a href="#L-702"><span class="linenos"> 702</span></a>            <span class="n">dim</span> <span class="o">=</span> <span class="p">(</span><span class="n">dim</span><span class="p">,)</span>
</span><span id="L-703"><a href="#L-703"><span class="linenos"> 703</span></a>        <span class="n">dim</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">a</span> <span class="k">if</span> <span class="n">a</span> <span class="o">&gt;=</span> <span class="mi">0</span> <span class="k">else</span> <span class="n">a</span> <span class="o">+</span> <span class="nb">len</span><span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span> <span class="k">for</span> <span class="n">a</span> <span class="ow">in</span> <span class="n">dim</span><span class="p">)</span>
</span><span id="L-704"><a href="#L-704"><span class="linenos"> 704</span></a>        <span class="k">return</span> <span class="p">(</span><span class="n">x</span><span class="p">,),</span> <span class="nb">dict</span><span class="p">(</span><span class="n">dim</span><span class="o">=</span><span class="n">dim</span><span class="p">,</span> <span class="n">keepdim</span><span class="o">=</span><span class="n">keepdim</span><span class="p">)</span>
</span><span id="L-705"><a href="#L-705"><span class="linenos"> 705</span></a>
</span><span id="L-706"><a href="#L-706"><span class="linenos"> 706</span></a>    <span class="k">def</span> <span class="nf">vmap</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">dim_size</span><span class="p">,</span> <span class="n">vals_in</span><span class="p">,</span> <span class="n">dims_in</span><span class="p">,</span> <span class="o">*</span><span class="p">,</span> <span class="n">dim</span><span class="p">,</span> <span class="n">keepdim</span><span class="p">):</span>
</span><span id="L-707"><a href="#L-707"><span class="linenos"> 707</span></a>        <span class="p">(</span><span class="n">x</span><span class="p">,),</span> <span class="p">(</span><span class="n">x_bdim</span><span class="p">,)</span> <span class="o">=</span> <span class="n">vals_in</span><span class="p">,</span> <span class="n">dims_in</span>
</span><span id="L-708"><a href="#L-708"><span class="linenos"> 708</span></a>        <span class="n">dim</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">a</span> <span class="o">+</span> <span class="p">(</span><span class="n">x_bdim</span> <span class="o">&lt;=</span> <span class="n">a</span><span class="p">)</span> <span class="k">for</span> <span class="n">a</span> <span class="ow">in</span> <span class="n">dim</span><span class="p">)</span>
</span><span id="L-709"><a href="#L-709"><span class="linenos"> 709</span></a>        <span class="n">out_bdim</span> <span class="o">=</span> <span class="n">x_bdim</span> <span class="o">-</span> <span class="nb">sum</span><span class="p">(</span><span class="n">a</span> <span class="o">&lt;</span> <span class="n">x_bdim</span> <span class="k">for</span> <span class="n">a</span> <span class="ow">in</span> <span class="n">dim</span><span class="p">)</span>
</span><span id="L-710"><a href="#L-710"><span class="linenos"> 710</span></a>        <span class="k">return</span> <span class="p">[</span><span class="bp">self</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">dim</span><span class="o">=</span><span class="n">dim</span><span class="p">,</span> <span class="n">keepdim</span><span class="o">=</span><span class="n">keepdim</span><span class="p">)],</span> <span class="p">[</span><span class="n">out_bdim</span><span class="p">]</span>
</span><span id="L-711"><a href="#L-711"><span class="linenos"> 711</span></a>
</span><span id="L-712"><a href="#L-712"><span class="linenos"> 712</span></a>    <span class="k">def</span> <span class="nf">typecheck</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">x</span><span class="p">:</span> <span class="n">SymbolicTensor</span><span class="p">,</span> <span class="o">*</span><span class="p">,</span> <span class="n">dim</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">keepdim</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">List</span><span class="p">[</span><span class="n">SymbolicTensor</span><span class="p">]:</span>
</span><span id="L-713"><a href="#L-713"><span class="linenos"> 713</span></a>        <span class="n">dim</span> <span class="o">=</span> <span class="p">[</span><span class="n">a</span> <span class="o">+</span> <span class="nb">len</span><span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span> <span class="k">if</span> <span class="n">a</span> <span class="o">&lt;</span> <span class="mi">0</span> <span class="k">else</span> <span class="n">a</span> <span class="k">for</span> <span class="n">a</span> <span class="ow">in</span> <span class="n">dim</span><span class="p">]</span>
</span><span id="L-714"><a href="#L-714"><span class="linenos"> 714</span></a>        <span class="n">dim_</span> <span class="o">=</span> <span class="nb">set</span><span class="p">(</span><span class="n">dim</span><span class="p">)</span>
</span><span id="L-715"><a href="#L-715"><span class="linenos"> 715</span></a>        <span class="k">if</span> <span class="n">keepdim</span><span class="p">:</span>
</span><span id="L-716"><a href="#L-716"><span class="linenos"> 716</span></a>            <span class="n">new_shape</span> <span class="o">=</span> <span class="p">[</span><span class="n">d</span> <span class="k">if</span> <span class="n">i</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">dim_</span> <span class="k">else</span> <span class="mi">1</span> <span class="k">for</span> <span class="n">i</span><span class="p">,</span> <span class="n">d</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">shape</span><span class="p">)]</span>
</span><span id="L-717"><a href="#L-717"><span class="linenos"> 717</span></a>        <span class="k">else</span><span class="p">:</span>
</span><span id="L-718"><a href="#L-718"><span class="linenos"> 718</span></a>            <span class="n">new_shape</span> <span class="o">=</span> <span class="p">[</span><span class="n">d</span> <span class="k">for</span> <span class="n">i</span><span class="p">,</span> <span class="n">d</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span> <span class="k">if</span> <span class="n">i</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">dim_</span><span class="p">]</span>
</span><span id="L-719"><a href="#L-719"><span class="linenos"> 719</span></a>        <span class="k">return</span> <span class="p">[</span><span class="n">x</span><span class="o">.</span><span class="n">like</span><span class="p">(</span><span class="n">shape</span><span class="o">=</span><span class="nb">tuple</span><span class="p">(</span><span class="n">new_shape</span><span class="p">))]</span>
</span><span id="L-720"><a href="#L-720"><span class="linenos"> 720</span></a>
</span><span id="L-721"><a href="#L-721"><span class="linenos"> 721</span></a>
</span><span id="L-722"><a href="#L-722"><span class="linenos"> 722</span></a><span class="k">class</span> <span class="nc">InitOperator</span><span class="p">(</span><span class="n">Operator</span><span class="p">):</span>
</span><span id="L-723"><a href="#L-723"><span class="linenos"> 723</span></a>    <span class="k">def</span> <span class="nf">vmap</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">dim_size</span><span class="p">,</span> <span class="n">vals_in</span><span class="p">,</span> <span class="n">dims_in</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="L-724"><a href="#L-724"><span class="linenos"> 724</span></a>        <span class="p">(</span><span class="n">x_bdim</span><span class="p">,)</span> <span class="o">=</span> <span class="n">dims_in</span>
</span><span id="L-725"><a href="#L-725"><span class="linenos"> 725</span></a>        <span class="n">y</span> <span class="o">=</span> <span class="bp">self</span><span class="p">(</span><span class="o">**</span><span class="n">params</span><span class="p">)</span>
</span><span id="L-726"><a href="#L-726"><span class="linenos"> 726</span></a>        <span class="n">y</span> <span class="o">=</span> <span class="n">y</span><span class="o">.</span><span class="n">unsqueeze</span><span class="p">(</span><span class="n">x_bdim</span><span class="p">)</span>
</span><span id="L-727"><a href="#L-727"><span class="linenos"> 727</span></a>        <span class="k">return</span> <span class="p">[</span><span class="n">y</span><span class="p">],</span> <span class="p">[</span><span class="n">x_bdim</span><span class="p">]</span>
</span><span id="L-728"><a href="#L-728"><span class="linenos"> 728</span></a>
</span><span id="L-729"><a href="#L-729"><span class="linenos"> 729</span></a>    <span class="k">def</span> <span class="nf">jvp</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">primals</span><span class="p">,</span> <span class="n">tangents</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="L-730"><a href="#L-730"><span class="linenos"> 730</span></a>        <span class="n">y</span> <span class="o">=</span> <span class="bp">self</span><span class="p">(</span><span class="o">**</span><span class="n">params</span><span class="p">)</span>
</span><span id="L-731"><a href="#L-731"><span class="linenos"> 731</span></a>        <span class="n">y_dot</span> <span class="o">=</span> <span class="n">NullCotangent</span><span class="p">(</span><span class="n">y</span><span class="o">.</span><span class="n">symval</span><span class="p">)</span>
</span><span id="L-732"><a href="#L-732"><span class="linenos"> 732</span></a>        <span class="c1"># y_dot = y.ones_like()</span>
</span><span id="L-733"><a href="#L-733"><span class="linenos"> 733</span></a>        <span class="k">return</span> <span class="p">[</span><span class="n">y</span><span class="p">],</span> <span class="p">[</span><span class="n">y_dot</span><span class="p">]</span>
</span><span id="L-734"><a href="#L-734"><span class="linenos"> 734</span></a>
</span><span id="L-735"><a href="#L-735"><span class="linenos"> 735</span></a>    <span class="k">def</span> <span class="nf">T</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">cotangents</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="L-736"><a href="#L-736"><span class="linenos"> 736</span></a>        <span class="k">return</span> <span class="p">[</span><span class="n">NullCotangent</span><span class="p">(</span><span class="n">cotangents</span><span class="p">[</span><span class="mi">0</span><span class="p">])]</span>
</span><span id="L-737"><a href="#L-737"><span class="linenos"> 737</span></a>
</span><span id="L-738"><a href="#L-738"><span class="linenos"> 738</span></a>
</span><span id="L-739"><a href="#L-739"><span class="linenos"> 739</span></a><span class="k">class</span> <span class="nc">ShapeOperator</span><span class="p">(</span><span class="n">Operator</span><span class="p">):</span>
</span><span id="L-740"><a href="#L-740"><span class="linenos"> 740</span></a>    <span class="k">pass</span>
</span><span id="L-741"><a href="#L-741"><span class="linenos"> 741</span></a>
</span><span id="L-742"><a href="#L-742"><span class="linenos"> 742</span></a>
</span><span id="L-743"><a href="#L-743"><span class="linenos"> 743</span></a><span class="k">class</span> <span class="nc">GeneralReduceOperator</span><span class="p">(</span><span class="n">Operator</span><span class="p">):</span>
</span><span id="L-744"><a href="#L-744"><span class="linenos"> 744</span></a>    <span class="k">pass</span>
</span><span id="L-745"><a href="#L-745"><span class="linenos"> 745</span></a>
</span><span id="L-746"><a href="#L-746"><span class="linenos"> 746</span></a>
</span><span id="L-747"><a href="#L-747"><span class="linenos"> 747</span></a><span class="k">class</span> <span class="nc">OperatorSet</span><span class="p">:</span>
</span><span id="L-748"><a href="#L-748"><span class="linenos"> 748</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-749"><a href="#L-749"><span class="linenos"> 749</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">register</span><span class="p">(</span><span class="s2">&quot;jit_op&quot;</span><span class="p">)(</span><span class="n">JitOp</span><span class="p">)</span>
</span><span id="L-750"><a href="#L-750"><span class="linenos"> 750</span></a>
</span><span id="L-751"><a href="#L-751"><span class="linenos"> 751</span></a>    <span class="k">def</span> <span class="nf">register</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">name</span><span class="p">,</span> <span class="n">variadic_inputs</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">nary_outputs</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">aliases</span><span class="o">=</span><span class="p">()):</span>
</span><span id="L-752"><a href="#L-752"><span class="linenos"> 752</span></a>        <span class="k">def</span> <span class="nf">wrap</span><span class="p">(</span><span class="n">op_cls</span><span class="p">):</span>
</span><span id="L-753"><a href="#L-753"><span class="linenos"> 753</span></a>            <span class="k">assert</span> <span class="n">name</span> <span class="ow">not</span> <span class="ow">in</span> <span class="nb">vars</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span>
</span><span id="L-754"><a href="#L-754"><span class="linenos"> 754</span></a>            <span class="n">op</span> <span class="o">=</span> <span class="n">op_cls</span><span class="p">(</span><span class="n">name</span><span class="p">,</span> <span class="n">variadic_inputs</span><span class="p">,</span> <span class="n">nary_outputs</span><span class="p">)</span>
</span><span id="L-755"><a href="#L-755"><span class="linenos"> 755</span></a>            <span class="nb">setattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">name</span><span class="p">,</span> <span class="n">op</span><span class="p">)</span>
</span><span id="L-756"><a href="#L-756"><span class="linenos"> 756</span></a>            <span class="k">for</span> <span class="n">a</span> <span class="ow">in</span> <span class="n">aliases</span><span class="p">:</span>
</span><span id="L-757"><a href="#L-757"><span class="linenos"> 757</span></a>                <span class="nb">setattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">a</span><span class="p">,</span> <span class="n">op</span><span class="p">)</span>
</span><span id="L-758"><a href="#L-758"><span class="linenos"> 758</span></a>            <span class="k">return</span> <span class="n">op_cls</span>
</span><span id="L-759"><a href="#L-759"><span class="linenos"> 759</span></a>
</span><span id="L-760"><a href="#L-760"><span class="linenos"> 760</span></a>        <span class="k">return</span> <span class="n">wrap</span>
</span><span id="L-761"><a href="#L-761"><span class="linenos"> 761</span></a>
</span><span id="L-762"><a href="#L-762"><span class="linenos"> 762</span></a>
</span><span id="L-763"><a href="#L-763"><span class="linenos"> 763</span></a><span class="k">class</span> <span class="nc">ProcedureSet</span><span class="p">:</span>
</span><span id="L-764"><a href="#L-764"><span class="linenos"> 764</span></a>    <span class="k">def</span> <span class="nf">register</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">aliases</span><span class="o">=</span><span class="p">()):</span>
</span><span id="L-765"><a href="#L-765"><span class="linenos"> 765</span></a>        <span class="k">def</span> <span class="nf">wrap</span><span class="p">(</span><span class="n">f</span><span class="p">):</span>
</span><span id="L-766"><a href="#L-766"><span class="linenos"> 766</span></a>            <span class="k">assert</span> <span class="n">f</span><span class="o">.</span><span class="vm">__name__</span> <span class="ow">not</span> <span class="ow">in</span> <span class="nb">vars</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span>
</span><span id="L-767"><a href="#L-767"><span class="linenos"> 767</span></a>            <span class="nb">setattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">f</span><span class="o">.</span><span class="vm">__name__</span><span class="p">,</span> <span class="n">f</span><span class="p">)</span>
</span><span id="L-768"><a href="#L-768"><span class="linenos"> 768</span></a>            <span class="k">for</span> <span class="n">a</span> <span class="ow">in</span> <span class="n">aliases</span><span class="p">:</span>
</span><span id="L-769"><a href="#L-769"><span class="linenos"> 769</span></a>                <span class="nb">setattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">a</span><span class="p">,</span> <span class="n">f</span><span class="p">)</span>
</span><span id="L-770"><a href="#L-770"><span class="linenos"> 770</span></a>            <span class="k">return</span> <span class="n">f</span>
</span><span id="L-771"><a href="#L-771"><span class="linenos"> 771</span></a>
</span><span id="L-772"><a href="#L-772"><span class="linenos"> 772</span></a>        <span class="k">return</span> <span class="n">wrap</span>
</span><span id="L-773"><a href="#L-773"><span class="linenos"> 773</span></a>
</span><span id="L-774"><a href="#L-774"><span class="linenos"> 774</span></a>
</span><span id="L-775"><a href="#L-775"><span class="linenos"> 775</span></a><span class="k">class</span> <span class="nc">CodegenOutput</span><span class="p">(</span><span class="n">NamedTuple</span><span class="p">):</span>
</span><span id="L-776"><a href="#L-776"><span class="linenos"> 776</span></a>    <span class="n">code_lines</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="nb">str</span><span class="p">]</span>
</span><span id="L-777"><a href="#L-777"><span class="linenos"> 777</span></a>    <span class="n">fn_defs</span><span class="p">:</span> <span class="n">Dict</span><span class="p">[</span><span class="nb">str</span><span class="p">,</span> <span class="n">List</span><span class="p">[</span><span class="nb">str</span><span class="p">]]</span>
</span><span id="L-778"><a href="#L-778"><span class="linenos"> 778</span></a>    <span class="n">in_binders</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="s2">&quot;ProgramEnvVar&quot;</span><span class="p">]</span>
</span><span id="L-779"><a href="#L-779"><span class="linenos"> 779</span></a>    <span class="n">outs</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="s2">&quot;ProgramEnvVar&quot;</span><span class="p">]</span>
</span><span id="L-780"><a href="#L-780"><span class="linenos"> 780</span></a>
</span><span id="L-781"><a href="#L-781"><span class="linenos"> 781</span></a>
</span><span id="L-782"><a href="#L-782"><span class="linenos"> 782</span></a><span class="k">class</span> <span class="nc">Backend</span><span class="p">:</span>
</span><span id="L-783"><a href="#L-783"><span class="linenos"> 783</span></a>    <span class="n">LOG_LRU</span> <span class="o">=</span> <span class="nb">int</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">environ</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;LOG_LRU&quot;</span><span class="p">,</span> <span class="mi">0</span><span class="p">))</span>
</span><span id="L-784"><a href="#L-784"><span class="linenos"> 784</span></a>    <span class="n">LOG_JIT</span> <span class="o">=</span> <span class="nb">int</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">environ</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;LOG_JIT&quot;</span><span class="p">,</span> <span class="mi">0</span><span class="p">))</span>
</span><span id="L-785"><a href="#L-785"><span class="linenos"> 785</span></a>    <span class="n">LOG_TREE</span> <span class="o">=</span> <span class="nb">int</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">environ</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;LOG_TREE&quot;</span><span class="p">,</span> <span class="mi">0</span><span class="p">))</span>
</span><span id="L-786"><a href="#L-786"><span class="linenos"> 786</span></a>    <span class="n">LOG_BACKEND</span> <span class="o">=</span> <span class="nb">int</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">environ</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;LOG_BACKEND&quot;</span><span class="p">,</span> <span class="mi">0</span><span class="p">))</span>
</span><span id="L-787"><a href="#L-787"><span class="linenos"> 787</span></a>    <span class="n">LOG_PROGRAM</span> <span class="o">=</span> <span class="nb">int</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">environ</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;LOG_PROGRAM&quot;</span><span class="p">,</span> <span class="mi">0</span><span class="p">))</span>
</span><span id="L-788"><a href="#L-788"><span class="linenos"> 788</span></a>    <span class="n">LOG_INIT</span> <span class="o">=</span> <span class="nb">int</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">environ</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;LOG_INIT&quot;</span><span class="p">,</span> <span class="mi">1</span><span class="p">))</span>
</span><span id="L-789"><a href="#L-789"><span class="linenos"> 789</span></a>    <span class="n">device_var</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">environ</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;DEFAULT_DEVICE&quot;</span><span class="p">,</span> <span class="s2">&quot;cpu:0&quot;</span><span class="p">)</span>
</span><span id="L-790"><a href="#L-790"><span class="linenos"> 790</span></a>    <span class="k">if</span> <span class="n">device_var</span><span class="p">[</span><span class="o">-</span><span class="mi">2</span><span class="p">]</span> <span class="o">!=</span> <span class="s2">&quot;:&quot;</span><span class="p">:</span>
</span><span id="L-791"><a href="#L-791"><span class="linenos"> 791</span></a>        <span class="n">device_var</span> <span class="o">+=</span> <span class="s2">&quot;:0&quot;</span>
</span><span id="L-792"><a href="#L-792"><span class="linenos"> 792</span></a>    <span class="n">DEFAULT_DEVICE</span> <span class="o">=</span> <span class="n">devices</span><span class="o">.</span><span class="n">name_idx_device_map</span><span class="p">[</span><span class="n">device_var</span><span class="p">]</span>
</span><span id="L-793"><a href="#L-793"><span class="linenos"> 793</span></a>    <span class="n">DEFAULT_DTYPE</span> <span class="o">=</span> <span class="n">dtypes</span><span class="o">.</span><span class="n">name_dtype_map</span><span class="p">[</span><span class="n">os</span><span class="o">.</span><span class="n">environ</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;DEFAULT_DTYPE&quot;</span><span class="p">,</span> <span class="s2">&quot;float32&quot;</span><span class="p">)]</span>
</span><span id="L-794"><a href="#L-794"><span class="linenos"> 794</span></a>    <span class="n">dtype_for_indices</span><span class="p">:</span> <span class="n">DType</span> <span class="o">=</span> <span class="kc">None</span>  <span class="c1"># need to override</span>
</span><span id="L-795"><a href="#L-795"><span class="linenos"> 795</span></a>
</span><span id="L-796"><a href="#L-796"><span class="linenos"> 796</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span>
</span><span id="L-797"><a href="#L-797"><span class="linenos"> 797</span></a>        <span class="bp">self</span><span class="p">,</span>
</span><span id="L-798"><a href="#L-798"><span class="linenos"> 798</span></a>        <span class="n">operator_set</span><span class="p">:</span> <span class="n">OperatorSet</span><span class="p">,</span>
</span><span id="L-799"><a href="#L-799"><span class="linenos"> 799</span></a>        <span class="n">procedure_set</span><span class="p">:</span> <span class="n">ProcedureSet</span><span class="p">,</span>
</span><span id="L-800"><a href="#L-800"><span class="linenos"> 800</span></a>    <span class="p">):</span>
</span><span id="L-801"><a href="#L-801"><span class="linenos"> 801</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">operator_set</span> <span class="o">=</span> <span class="n">operator_set</span>
</span><span id="L-802"><a href="#L-802"><span class="linenos"> 802</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">procedure_set</span> <span class="o">=</span> <span class="n">procedure_set</span>
</span><span id="L-803"><a href="#L-803"><span class="linenos"> 803</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">node_types</span> <span class="o">=</span> <span class="nb">dict</span><span class="p">()</span>
</span><span id="L-804"><a href="#L-804"><span class="linenos"> 804</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">impls</span> <span class="o">=</span> <span class="nb">dict</span><span class="p">()</span>
</span><span id="L-805"><a href="#L-805"><span class="linenos"> 805</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">register_node</span><span class="p">(</span><span class="nb">tuple</span><span class="p">,</span> <span class="k">lambda</span> <span class="n">t</span><span class="p">:</span> <span class="p">(</span><span class="kc">None</span><span class="p">,</span> <span class="n">t</span><span class="p">),</span> <span class="k">lambda</span> <span class="n">_</span><span class="p">,</span> <span class="n">xs</span><span class="p">:</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">xs</span><span class="p">),</span> <span class="s2">&quot;tuple&quot;</span><span class="p">)</span>
</span><span id="L-806"><a href="#L-806"><span class="linenos"> 806</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">register_node</span><span class="p">(</span><span class="nb">list</span><span class="p">,</span> <span class="k">lambda</span> <span class="n">l</span><span class="p">:</span> <span class="p">(</span><span class="kc">None</span><span class="p">,</span> <span class="n">l</span><span class="p">),</span> <span class="k">lambda</span> <span class="n">_</span><span class="p">,</span> <span class="n">xs</span><span class="p">:</span> <span class="nb">list</span><span class="p">(</span><span class="n">xs</span><span class="p">),</span> <span class="s2">&quot;list&quot;</span><span class="p">)</span>
</span><span id="L-807"><a href="#L-807"><span class="linenos"> 807</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">register_node</span><span class="p">(</span>
</span><span id="L-808"><a href="#L-808"><span class="linenos"> 808</span></a>            <span class="nb">dict</span><span class="p">,</span>
</span><span id="L-809"><a href="#L-809"><span class="linenos"> 809</span></a>            <span class="k">lambda</span> <span class="n">d</span><span class="p">:</span> <span class="n">list_map</span><span class="p">(</span><span class="nb">tuple</span><span class="p">,</span> <span class="n">unzip2</span><span class="p">(</span><span class="nb">sorted</span><span class="p">(</span><span class="n">d</span><span class="o">.</span><span class="n">items</span><span class="p">()))),</span>
</span><span id="L-810"><a href="#L-810"><span class="linenos"> 810</span></a>            <span class="k">lambda</span> <span class="n">keys</span><span class="p">,</span> <span class="n">vals</span><span class="p">:</span> <span class="nb">dict</span><span class="p">(</span><span class="n">list_zip</span><span class="p">(</span><span class="n">keys</span><span class="p">,</span> <span class="n">vals</span><span class="p">)),</span>
</span><span id="L-811"><a href="#L-811"><span class="linenos"> 811</span></a>            <span class="s2">&quot;dict&quot;</span><span class="p">,</span>
</span><span id="L-812"><a href="#L-812"><span class="linenos"> 812</span></a>        <span class="p">)</span>
</span><span id="L-813"><a href="#L-813"><span class="linenos"> 813</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">register_node</span><span class="p">(</span>
</span><span id="L-814"><a href="#L-814"><span class="linenos"> 814</span></a>            <span class="n">UndefinedPrimal</span><span class="p">,</span>
</span><span id="L-815"><a href="#L-815"><span class="linenos"> 815</span></a>            <span class="k">lambda</span> <span class="n">u</span><span class="p">:</span> <span class="p">(</span><span class="n">u</span><span class="o">.</span><span class="n">symval</span><span class="p">,</span> <span class="p">()),</span>
</span><span id="L-816"><a href="#L-816"><span class="linenos"> 816</span></a>            <span class="k">lambda</span> <span class="n">symval</span><span class="p">,</span> <span class="n">_</span><span class="p">:</span> <span class="n">UndefinedPrimal</span><span class="p">(</span><span class="n">symval</span><span class="p">),</span>
</span><span id="L-817"><a href="#L-817"><span class="linenos"> 817</span></a>            <span class="s2">&quot;UndefinedPrimal&quot;</span><span class="p">,</span>
</span><span id="L-818"><a href="#L-818"><span class="linenos"> 818</span></a>        <span class="p">)</span>
</span><span id="L-819"><a href="#L-819"><span class="linenos"> 819</span></a>
</span><span id="L-820"><a href="#L-820"><span class="linenos"> 820</span></a>    <span class="k">def</span> <span class="nf">set_impl</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">op</span><span class="p">:</span> <span class="n">Union</span><span class="p">[</span><span class="n">types</span><span class="o">.</span><span class="n">LambdaType</span><span class="p">,</span> <span class="n">types</span><span class="o">.</span><span class="n">FunctionType</span><span class="p">]):</span>
</span><span id="L-821"><a href="#L-821"><span class="linenos"> 821</span></a>        <span class="k">def</span> <span class="nf">set_impl_</span><span class="p">(</span><span class="n">fn</span><span class="p">):</span>
</span><span id="L-822"><a href="#L-822"><span class="linenos"> 822</span></a>            <span class="bp">self</span><span class="o">.</span><span class="n">impls</span><span class="p">[</span><span class="n">op</span><span class="p">]</span> <span class="o">=</span> <span class="n">types</span><span class="o">.</span><span class="n">MethodType</span><span class="p">(</span><span class="n">fn</span><span class="p">,</span> <span class="bp">self</span><span class="p">)</span>
</span><span id="L-823"><a href="#L-823"><span class="linenos"> 823</span></a>
</span><span id="L-824"><a href="#L-824"><span class="linenos"> 824</span></a>        <span class="k">return</span> <span class="n">set_impl_</span>
</span><span id="L-825"><a href="#L-825"><span class="linenos"> 825</span></a>
</span><span id="L-826"><a href="#L-826"><span class="linenos"> 826</span></a>    <span class="k">def</span> <span class="nf">register_node</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">ty</span><span class="p">:</span> <span class="n">Type</span><span class="p">,</span> <span class="n">to_iter</span><span class="p">:</span> <span class="n">Callable</span><span class="p">,</span> <span class="n">from_iter</span><span class="p">:</span> <span class="n">Callable</span><span class="p">,</span> <span class="n">name</span><span class="o">=</span><span class="kc">None</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="kc">None</span><span class="p">:</span>
</span><span id="L-827"><a href="#L-827"><span class="linenos"> 827</span></a>        <span class="k">if</span> <span class="n">name</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
</span><span id="L-828"><a href="#L-828"><span class="linenos"> 828</span></a>            <span class="n">name</span> <span class="o">=</span> <span class="nb">str</span><span class="p">(</span><span class="n">ty</span><span class="p">)</span>
</span><span id="L-829"><a href="#L-829"><span class="linenos"> 829</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">node_types</span><span class="p">[</span><span class="n">ty</span><span class="p">]</span> <span class="o">=</span> <span class="n">NodeType</span><span class="p">(</span><span class="n">name</span><span class="p">,</span> <span class="n">to_iter</span><span class="p">,</span> <span class="n">from_iter</span><span class="p">)</span>
</span><span id="L-830"><a href="#L-830"><span class="linenos"> 830</span></a>
</span><span id="L-831"><a href="#L-831"><span class="linenos"> 831</span></a>    <span class="k">def</span> <span class="fm">__getattr__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">attr</span><span class="p">):</span>
</span><span id="L-832"><a href="#L-832"><span class="linenos"> 832</span></a>        <span class="k">try</span><span class="p">:</span>
</span><span id="L-833"><a href="#L-833"><span class="linenos"> 833</span></a>            <span class="n">dblog</span><span class="p">(</span>
</span><span id="L-834"><a href="#L-834"><span class="linenos"> 834</span></a>                <span class="sa">f</span><span class="s2">&quot;Looking </span><span class="si">{</span><span class="bp">self</span><span class="si">}</span><span class="s2">.</span><span class="si">{</span><span class="n">attr</span><span class="si">}</span><span class="s2"> in operator_set&quot;</span><span class="p">,</span>
</span><span id="L-835"><a href="#L-835"><span class="linenos"> 835</span></a>                <span class="n">enable</span><span class="o">=</span><span class="n">backend</span><span class="o">.</span><span class="n">LOG_BACKEND</span><span class="p">,</span>
</span><span id="L-836"><a href="#L-836"><span class="linenos"> 836</span></a>            <span class="p">)</span>
</span><span id="L-837"><a href="#L-837"><span class="linenos"> 837</span></a>            <span class="k">return</span> <span class="nb">getattr</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">operator_set</span><span class="p">,</span> <span class="n">attr</span><span class="p">)</span>
</span><span id="L-838"><a href="#L-838"><span class="linenos"> 838</span></a>        <span class="k">except</span><span class="p">:</span>
</span><span id="L-839"><a href="#L-839"><span class="linenos"> 839</span></a>            <span class="k">pass</span>
</span><span id="L-840"><a href="#L-840"><span class="linenos"> 840</span></a>        <span class="k">try</span><span class="p">:</span>
</span><span id="L-841"><a href="#L-841"><span class="linenos"> 841</span></a>            <span class="n">dblog</span><span class="p">(</span>
</span><span id="L-842"><a href="#L-842"><span class="linenos"> 842</span></a>                <span class="sa">f</span><span class="s2">&quot;Looking </span><span class="si">{</span><span class="bp">self</span><span class="si">}</span><span class="s2">.</span><span class="si">{</span><span class="n">attr</span><span class="si">}</span><span class="s2"> in procedure_set&quot;</span><span class="p">,</span>
</span><span id="L-843"><a href="#L-843"><span class="linenos"> 843</span></a>                <span class="n">enable</span><span class="o">=</span><span class="n">backend</span><span class="o">.</span><span class="n">LOG_BACKEND</span><span class="p">,</span>
</span><span id="L-844"><a href="#L-844"><span class="linenos"> 844</span></a>            <span class="p">)</span>
</span><span id="L-845"><a href="#L-845"><span class="linenos"> 845</span></a>            <span class="k">return</span> <span class="nb">getattr</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">procedure_set</span><span class="p">,</span> <span class="n">attr</span><span class="p">)</span>
</span><span id="L-846"><a href="#L-846"><span class="linenos"> 846</span></a>        <span class="k">except</span><span class="p">:</span>
</span><span id="L-847"><a href="#L-847"><span class="linenos"> 847</span></a>            <span class="k">pass</span>
</span><span id="L-848"><a href="#L-848"><span class="linenos"> 848</span></a>        <span class="n">dblog</span><span class="p">(</span>
</span><span id="L-849"><a href="#L-849"><span class="linenos"> 849</span></a>            <span class="sa">f</span><span class="s2">&quot;Fallback to default </span><span class="si">{</span><span class="bp">self</span><span class="si">}</span><span class="s2"> getattribute&quot;</span><span class="p">,</span>
</span><span id="L-850"><a href="#L-850"><span class="linenos"> 850</span></a>            <span class="n">enable</span><span class="o">=</span><span class="n">backend</span><span class="o">.</span><span class="n">LOG_BACKEND</span><span class="p">,</span>
</span><span id="L-851"><a href="#L-851"><span class="linenos"> 851</span></a>        <span class="p">)</span>
</span><span id="L-852"><a href="#L-852"><span class="linenos"> 852</span></a>        <span class="nb">super</span><span class="p">()</span><span class="o">.</span><span class="fm">__getattribute__</span><span class="p">(</span><span class="n">attr</span><span class="p">)</span>
</span><span id="L-853"><a href="#L-853"><span class="linenos"> 853</span></a>
</span><span id="L-854"><a href="#L-854"><span class="linenos"> 854</span></a>    <span class="k">def</span> <span class="nf">tensor</span><span class="p">(</span>
</span><span id="L-855"><a href="#L-855"><span class="linenos"> 855</span></a>        <span class="bp">self</span><span class="p">,</span>
</span><span id="L-856"><a href="#L-856"><span class="linenos"> 856</span></a>        <span class="n">val</span><span class="p">:</span> <span class="n">Union</span><span class="p">[</span><span class="nb">list</span><span class="p">,</span> <span class="nb">tuple</span><span class="p">,</span> <span class="n">np</span><span class="o">.</span><span class="n">ndarray</span><span class="p">,</span> <span class="s2">&quot;TensorBuffer&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span>
</span><span id="L-857"><a href="#L-857"><span class="linenos"> 857</span></a>        <span class="n">dtype</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="n">Any</span><span class="p">]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span>
</span><span id="L-858"><a href="#L-858"><span class="linenos"> 858</span></a>        <span class="n">device</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span>
</span><span id="L-859"><a href="#L-859"><span class="linenos"> 859</span></a>    <span class="p">):</span>
</span><span id="L-860"><a href="#L-860"><span class="linenos"> 860</span></a>        <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">val</span><span class="p">,</span> <span class="n">TensorBuffer</span><span class="p">):</span>
</span><span id="L-861"><a href="#L-861"><span class="linenos"> 861</span></a>            <span class="k">return</span> <span class="n">Tensor</span><span class="p">(</span><span class="n">val</span><span class="p">)</span>
</span><span id="L-862"><a href="#L-862"><span class="linenos"> 862</span></a>        <span class="k">elif</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">val</span><span class="p">,</span> <span class="n">Tensor</span><span class="p">):</span>
</span><span id="L-863"><a href="#L-863"><span class="linenos"> 863</span></a>            <span class="k">return</span> <span class="n">val</span>
</span><span id="L-864"><a href="#L-864"><span class="linenos"> 864</span></a>        <span class="k">if</span> <span class="nb">type</span><span class="p">(</span><span class="n">val</span><span class="p">)</span> <span class="ow">is</span> <span class="nb">bytes</span><span class="p">:</span>
</span><span id="L-865"><a href="#L-865"><span class="linenos"> 865</span></a>            <span class="n">val</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">frombuffer</span><span class="p">(</span><span class="n">val</span><span class="p">,</span> <span class="n">dtype</span><span class="o">=</span><span class="n">dtype</span><span class="p">)</span>
</span><span id="L-866"><a href="#L-866"><span class="linenos"> 866</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">from_numpy</span><span class="p">(</span><span class="n">val</span><span class="p">,</span> <span class="n">dtype</span><span class="p">,</span> <span class="n">device</span><span class="p">)</span>
</span><span id="L-867"><a href="#L-867"><span class="linenos"> 867</span></a>
</span><span id="L-868"><a href="#L-868"><span class="linenos"> 868</span></a>    <span class="k">def</span> <span class="nf">symbolic_tensor</span><span class="p">(</span>
</span><span id="L-869"><a href="#L-869"><span class="linenos"> 869</span></a>        <span class="bp">self</span><span class="p">,</span>
</span><span id="L-870"><a href="#L-870"><span class="linenos"> 870</span></a>        <span class="n">shape</span><span class="p">:</span> <span class="n">Union</span><span class="p">[</span><span class="nb">list</span><span class="p">,</span> <span class="nb">tuple</span><span class="p">,</span> <span class="n">np</span><span class="o">.</span><span class="n">ndarray</span><span class="p">,</span> <span class="s2">&quot;TensorBuffer&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span>
</span><span id="L-871"><a href="#L-871"><span class="linenos"> 871</span></a>        <span class="n">dtype</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="n">Any</span><span class="p">]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span>
</span><span id="L-872"><a href="#L-872"><span class="linenos"> 872</span></a>        <span class="n">device</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span>
</span><span id="L-873"><a href="#L-873"><span class="linenos"> 873</span></a>    <span class="p">):</span>
</span><span id="L-874"><a href="#L-874"><span class="linenos"> 874</span></a>        <span class="n">dtype</span> <span class="o">=</span> <span class="n">dtype</span> <span class="ow">or</span> <span class="bp">self</span><span class="o">.</span><span class="n">DEFAULT_DTYPE</span>
</span><span id="L-875"><a href="#L-875"><span class="linenos"> 875</span></a>        <span class="n">device</span> <span class="o">=</span> <span class="n">device</span> <span class="ow">or</span> <span class="bp">self</span><span class="o">.</span><span class="n">DEFAULT_DEVICE</span>
</span><span id="L-876"><a href="#L-876"><span class="linenos"> 876</span></a>        <span class="k">return</span> <span class="n">SymbolicTensor</span><span class="p">(</span><span class="n">shape</span><span class="p">,</span> <span class="n">dtype</span><span class="p">,</span> <span class="n">device</span><span class="p">)</span>
</span><span id="L-877"><a href="#L-877"><span class="linenos"> 877</span></a>
</span><span id="L-878"><a href="#L-878"><span class="linenos"> 878</span></a>    <span class="k">def</span> <span class="nf">seed</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">seed</span><span class="p">):</span>
</span><span id="L-879"><a href="#L-879"><span class="linenos"> 879</span></a>        <span class="k">raise</span> <span class="ne">NotImplementedError</span>
</span><span id="L-880"><a href="#L-880"><span class="linenos"> 880</span></a>
</span><span id="L-881"><a href="#L-881"><span class="linenos"> 881</span></a>    <span class="nd">@property</span>
</span><span id="L-882"><a href="#L-882"><span class="linenos"> 882</span></a>    <span class="k">def</span> <span class="nf">default_dtype_value</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-883"><a href="#L-883"><span class="linenos"> 883</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">dtype_map</span><span class="p">[</span><span class="n">backend</span><span class="o">.</span><span class="n">DEFAULT_DTYPE</span><span class="p">]</span>
</span><span id="L-884"><a href="#L-884"><span class="linenos"> 884</span></a>
</span><span id="L-885"><a href="#L-885"><span class="linenos"> 885</span></a>    <span class="k">def</span> <span class="nf">set_method</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">method</span><span class="p">):</span>
</span><span id="L-886"><a href="#L-886"><span class="linenos"> 886</span></a>        <span class="nb">setattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">method</span><span class="o">.</span><span class="vm">__name__</span><span class="p">,</span> <span class="n">types</span><span class="o">.</span><span class="n">MethodType</span><span class="p">(</span><span class="n">method</span><span class="p">,</span> <span class="bp">self</span><span class="p">))</span>
</span><span id="L-887"><a href="#L-887"><span class="linenos"> 887</span></a>
</span><span id="L-888"><a href="#L-888"><span class="linenos"> 888</span></a>    <span class="k">def</span> <span class="nf">from_numpy</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">val</span><span class="p">,</span> <span class="n">device</span><span class="p">):</span>
</span><span id="L-889"><a href="#L-889"><span class="linenos"> 889</span></a>        <span class="k">raise</span> <span class="ne">NotImplementedError</span>
</span><span id="L-890"><a href="#L-890"><span class="linenos"> 890</span></a>
</span><span id="L-891"><a href="#L-891"><span class="linenos"> 891</span></a>    <span class="k">def</span> <span class="nf">numpy_of</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">tensor</span><span class="p">):</span>
</span><span id="L-892"><a href="#L-892"><span class="linenos"> 892</span></a>        <span class="k">raise</span> <span class="ne">NotImplementedError</span>
</span><span id="L-893"><a href="#L-893"><span class="linenos"> 893</span></a>
</span><span id="L-894"><a href="#L-894"><span class="linenos"> 894</span></a>    <span class="k">def</span> <span class="nf">device_of</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">tensor</span><span class="p">):</span>
</span><span id="L-895"><a href="#L-895"><span class="linenos"> 895</span></a>        <span class="k">raise</span> <span class="ne">NotImplementedError</span>
</span><span id="L-896"><a href="#L-896"><span class="linenos"> 896</span></a>
</span><span id="L-897"><a href="#L-897"><span class="linenos"> 897</span></a>    <span class="k">def</span> <span class="nf">shape_of</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">tensor</span><span class="p">):</span>
</span><span id="L-898"><a href="#L-898"><span class="linenos"> 898</span></a>        <span class="k">raise</span> <span class="ne">NotImplementedError</span>
</span><span id="L-899"><a href="#L-899"><span class="linenos"> 899</span></a>
</span><span id="L-900"><a href="#L-900"><span class="linenos"> 900</span></a>    <span class="k">def</span> <span class="nf">dtype_of</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">tensor</span><span class="p">):</span>
</span><span id="L-901"><a href="#L-901"><span class="linenos"> 901</span></a>        <span class="k">raise</span> <span class="ne">NotImplementedError</span>
</span><span id="L-902"><a href="#L-902"><span class="linenos"> 902</span></a>
</span><span id="L-903"><a href="#L-903"><span class="linenos"> 903</span></a>    <span class="nd">@lru_cache_verbose</span><span class="p">()</span>
</span><span id="L-904"><a href="#L-904"><span class="linenos"> 904</span></a>    <span class="k">def</span> <span class="nf">jit_program</span><span class="p">(</span>
</span><span id="L-905"><a href="#L-905"><span class="linenos"> 905</span></a>        <span class="bp">self</span><span class="p">,</span>
</span><span id="L-906"><a href="#L-906"><span class="linenos"> 906</span></a>        <span class="n">hashed_program</span><span class="p">:</span> <span class="n">Hashed</span><span class="p">,</span>
</span><span id="L-907"><a href="#L-907"><span class="linenos"> 907</span></a>        <span class="n">hashed_consts</span><span class="p">:</span> <span class="n">Tuple</span><span class="p">[</span><span class="n">Hashed</span><span class="p">,</span> <span class="o">...</span><span class="p">],</span>
</span><span id="L-908"><a href="#L-908"><span class="linenos"> 908</span></a>    <span class="p">):</span>
</span><span id="L-909"><a href="#L-909"><span class="linenos"> 909</span></a>        <span class="n">program</span><span class="p">:</span> <span class="n">Program</span> <span class="o">=</span> <span class="n">hashed_program</span><span class="o">.</span><span class="n">val</span>
</span><span id="L-910"><a href="#L-910"><span class="linenos"> 910</span></a>        <span class="n">typecheck_program</span><span class="p">(</span><span class="n">program</span><span class="p">)</span>
</span><span id="L-911"><a href="#L-911"><span class="linenos"> 911</span></a>        <span class="n">consts</span> <span class="o">=</span> <span class="p">[</span><span class="n">x</span><span class="o">.</span><span class="n">val</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">hashed_consts</span><span class="p">]</span>
</span><span id="L-912"><a href="#L-912"><span class="linenos"> 912</span></a>        <span class="n">in_symvals</span> <span class="o">=</span> <span class="p">[</span><span class="n">v</span><span class="o">.</span><span class="n">symval</span> <span class="k">for</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">program</span><span class="o">.</span><span class="n">in_binders</span><span class="p">[</span><span class="nb">len</span><span class="p">(</span><span class="n">consts</span><span class="p">)</span> <span class="p">:]]</span>
</span><span id="L-913"><a href="#L-913"><span class="linenos"> 913</span></a>        <span class="n">codegen_output</span><span class="p">:</span> <span class="n">CodegenOutput</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">codegen</span><span class="p">(</span><span class="n">program</span><span class="p">,</span> <span class="n">consts</span> <span class="o">+</span> <span class="n">in_symvals</span><span class="p">,</span> <span class="n">fn_name</span><span class="o">=</span><span class="s2">&quot;main&quot;</span><span class="p">)</span>
</span><span id="L-914"><a href="#L-914"><span class="linenos"> 914</span></a>        <span class="n">fn</span><span class="p">,</span> <span class="n">code</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">compile</span><span class="p">(</span><span class="n">codegen_output</span><span class="p">)</span>
</span><span id="L-915"><a href="#L-915"><span class="linenos"> 915</span></a>        <span class="n">jit_output</span> <span class="o">=</span> <span class="n">JitOutput</span><span class="p">(</span><span class="n">program</span><span class="p">,</span> <span class="n">codegen_output</span><span class="p">,</span> <span class="n">fn</span><span class="p">,</span> <span class="n">code</span><span class="p">,</span> <span class="n">consts</span><span class="p">)</span>
</span><span id="L-916"><a href="#L-916"><span class="linenos"> 916</span></a>        <span class="k">return</span> <span class="n">jit_output</span>
</span><span id="L-917"><a href="#L-917"><span class="linenos"> 917</span></a>
</span><span id="L-918"><a href="#L-918"><span class="linenos"> 918</span></a>    <span class="k">def</span> <span class="nf">codegen</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">program</span><span class="p">:</span> <span class="s2">&quot;Program&quot;</span><span class="p">,</span> <span class="n">args</span><span class="p">:</span> <span class="n">Tuple</span><span class="p">,</span> <span class="n">in_symvals</span><span class="p">:</span> <span class="n">Tuple</span><span class="p">,</span> <span class="n">name</span><span class="p">:</span> <span class="nb">str</span><span class="p">):</span>
</span><span id="L-919"><a href="#L-919"><span class="linenos"> 919</span></a>        <span class="s2">&quot;Returns compiler IR from the Program&quot;</span>
</span><span id="L-920"><a href="#L-920"><span class="linenos"> 920</span></a>        <span class="k">raise</span> <span class="ne">NotImplementedError</span>
</span><span id="L-921"><a href="#L-921"><span class="linenos"> 921</span></a>
</span><span id="L-922"><a href="#L-922"><span class="linenos"> 922</span></a>    <span class="k">def</span> <span class="nf">compile</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">program</span><span class="p">:</span> <span class="s2">&quot;Program&quot;</span><span class="p">,</span> <span class="n">args</span><span class="p">:</span> <span class="n">Tuple</span><span class="p">,</span> <span class="n">in_symvals</span><span class="p">:</span> <span class="n">Tuple</span><span class="p">,</span> <span class="n">name</span><span class="p">:</span> <span class="nb">str</span><span class="p">):</span>
</span><span id="L-923"><a href="#L-923"><span class="linenos"> 923</span></a>        <span class="s2">&quot;Compiles compiler IR to a Python callable function&quot;</span>
</span><span id="L-924"><a href="#L-924"><span class="linenos"> 924</span></a>        <span class="k">raise</span> <span class="ne">NotImplementedError</span>
</span><span id="L-925"><a href="#L-925"><span class="linenos"> 925</span></a>
</span><span id="L-926"><a href="#L-926"><span class="linenos"> 926</span></a>    <span class="k">def</span> <span class="nf">export</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">jit_output</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="L-927"><a href="#L-927"><span class="linenos"> 927</span></a>        <span class="k">raise</span> <span class="ne">NotImplementedError</span>
</span><span id="L-928"><a href="#L-928"><span class="linenos"> 928</span></a>
</span><span id="L-929"><a href="#L-929"><span class="linenos"> 929</span></a>    <span class="k">def</span> <span class="nf">load</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">path</span><span class="p">,</span> <span class="n">single_key</span><span class="o">=</span><span class="s2">&quot;_tensor&quot;</span><span class="p">):</span>
</span><span id="L-930"><a href="#L-930"><span class="linenos"> 930</span></a>        <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">path</span><span class="p">,</span> <span class="n">mode</span><span class="o">=</span><span class="s2">&quot;rb&quot;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
</span><span id="L-931"><a href="#L-931"><span class="linenos"> 931</span></a>            <span class="k">with</span> <span class="n">mmap</span><span class="o">.</span><span class="n">mmap</span><span class="p">(</span><span class="n">f</span><span class="o">.</span><span class="n">fileno</span><span class="p">(),</span> <span class="n">length</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">access</span><span class="o">=</span><span class="n">mmap</span><span class="o">.</span><span class="n">ACCESS_READ</span><span class="p">)</span> <span class="k">as</span> <span class="n">m</span><span class="p">:</span>
</span><span id="L-932"><a href="#L-932"><span class="linenos"> 932</span></a>                <span class="n">json_len</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">int64</span><span class="p">(</span><span class="n">m</span><span class="p">[</span><span class="mi">0</span><span class="p">])</span>
</span><span id="L-933"><a href="#L-933"><span class="linenos"> 933</span></a>                <span class="n">start</span> <span class="o">=</span> <span class="mi">8</span> <span class="o">+</span> <span class="n">json_len</span>
</span><span id="L-934"><a href="#L-934"><span class="linenos"> 934</span></a>                <span class="n">metadata</span> <span class="o">=</span> <span class="n">json</span><span class="o">.</span><span class="n">loads</span><span class="p">(</span><span class="n">m</span><span class="p">[</span><span class="mi">8</span><span class="p">:</span><span class="n">start</span><span class="p">])</span>
</span><span id="L-935"><a href="#L-935"><span class="linenos"> 935</span></a>                <span class="n">ret</span> <span class="o">=</span> <span class="p">{}</span>
</span><span id="L-936"><a href="#L-936"><span class="linenos"> 936</span></a>                <span class="k">for</span> <span class="n">k</span><span class="p">,</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">metadata</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
</span><span id="L-937"><a href="#L-937"><span class="linenos"> 937</span></a>                    <span class="k">if</span> <span class="n">k</span> <span class="o">!=</span> <span class="s2">&quot;__metadata__&quot;</span><span class="p">:</span>
</span><span id="L-938"><a href="#L-938"><span class="linenos"> 938</span></a>                        <span class="n">dtype</span> <span class="o">=</span> <span class="n">Tensor</span><span class="o">.</span><span class="n">mlir_dtype_map</span><span class="p">[(</span><span class="n">v</span><span class="p">[</span><span class="s2">&quot;dtype&quot;</span><span class="p">])]</span>
</span><span id="L-939"><a href="#L-939"><span class="linenos"> 939</span></a>                        <span class="n">data_start</span> <span class="o">=</span> <span class="n">start</span> <span class="o">+</span> <span class="n">v</span><span class="p">[</span><span class="s2">&quot;data_offsets&quot;</span><span class="p">][</span><span class="mi">0</span><span class="p">]</span>
</span><span id="L-940"><a href="#L-940"><span class="linenos"> 940</span></a>                        <span class="n">data_end</span> <span class="o">=</span> <span class="n">start</span> <span class="o">+</span> <span class="n">v</span><span class="p">[</span><span class="s2">&quot;data_offsets&quot;</span><span class="p">][</span><span class="mi">1</span><span class="p">]</span>
</span><span id="L-941"><a href="#L-941"><span class="linenos"> 941</span></a>                        <span class="n">t_np</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">frombuffer</span><span class="p">(</span><span class="n">m</span><span class="p">[</span><span class="n">data_start</span><span class="p">:</span><span class="n">data_end</span><span class="p">],</span> <span class="n">dtype</span><span class="o">=</span><span class="n">dtype</span><span class="o">.</span><span class="n">numpy</span><span class="p">())</span>
</span><span id="L-942"><a href="#L-942"><span class="linenos"> 942</span></a>                        <span class="n">t</span> <span class="o">=</span> <span class="n">backend</span><span class="o">.</span><span class="n">tensor</span><span class="p">(</span><span class="n">t_np</span><span class="p">,</span> <span class="n">dtype</span><span class="o">=</span><span class="n">dtype</span><span class="p">)</span>
</span><span id="L-943"><a href="#L-943"><span class="linenos"> 943</span></a>                        <span class="n">t</span> <span class="o">=</span> <span class="n">t</span><span class="o">.</span><span class="n">reshape</span><span class="p">(</span><span class="nb">tuple</span><span class="p">(</span><span class="n">v</span><span class="p">[</span><span class="s2">&quot;shape&quot;</span><span class="p">]))</span>
</span><span id="L-944"><a href="#L-944"><span class="linenos"> 944</span></a>                        <span class="n">ret</span><span class="p">[</span><span class="n">k</span><span class="p">]</span> <span class="o">=</span> <span class="n">t</span>
</span><span id="L-945"><a href="#L-945"><span class="linenos"> 945</span></a>                <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">ret</span><span class="p">)</span> <span class="o">==</span> <span class="mi">1</span> <span class="ow">and</span> <span class="n">single_key</span> <span class="ow">in</span> <span class="n">ret</span><span class="o">.</span><span class="n">keys</span><span class="p">():</span>
</span><span id="L-946"><a href="#L-946"><span class="linenos"> 946</span></a>                    <span class="k">return</span> <span class="n">ret</span><span class="p">[</span><span class="n">single_key</span><span class="p">]</span>
</span><span id="L-947"><a href="#L-947"><span class="linenos"> 947</span></a>                <span class="k">return</span> <span class="n">ret</span>
</span><span id="L-948"><a href="#L-948"><span class="linenos"> 948</span></a>
</span><span id="L-949"><a href="#L-949"><span class="linenos"> 949</span></a>    <span class="k">def</span> <span class="nf">save</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">tensors</span><span class="p">:</span> <span class="n">Dict</span><span class="p">[</span><span class="nb">str</span><span class="p">,</span> <span class="n">Tensor</span><span class="p">],</span> <span class="n">path</span><span class="p">:</span> <span class="nb">str</span><span class="p">,</span> <span class="n">single_key</span><span class="o">=</span><span class="s2">&quot;_tensor&quot;</span><span class="p">):</span>
</span><span id="L-950"><a href="#L-950"><span class="linenos"> 950</span></a>        <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">tensors</span><span class="p">,</span> <span class="n">Tensor</span><span class="p">):</span>
</span><span id="L-951"><a href="#L-951"><span class="linenos"> 951</span></a>            <span class="n">tensors</span> <span class="o">=</span> <span class="p">{</span><span class="n">single_key</span><span class="p">:</span> <span class="n">tensors</span><span class="p">}</span>
</span><span id="L-952"><a href="#L-952"><span class="linenos"> 952</span></a>        <span class="k">else</span><span class="p">:</span>
</span><span id="L-953"><a href="#L-953"><span class="linenos"> 953</span></a>            <span class="k">assert</span> <span class="nb">all</span><span class="p">((</span><span class="nb">isinstance</span><span class="p">(</span><span class="n">k</span><span class="p">,</span> <span class="nb">str</span><span class="p">)</span> <span class="ow">and</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">v</span><span class="p">,</span> <span class="n">Tensor</span><span class="p">))</span> <span class="k">for</span> <span class="n">k</span><span class="p">,</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">tensors</span><span class="o">.</span><span class="n">items</span><span class="p">())</span>
</span><span id="L-954"><a href="#L-954"><span class="linenos"> 954</span></a>
</span><span id="L-955"><a href="#L-955"><span class="linenos"> 955</span></a>        <span class="n">metadata</span><span class="p">,</span> <span class="n">offset</span> <span class="o">=</span> <span class="p">{},</span> <span class="mi">0</span>
</span><span id="L-956"><a href="#L-956"><span class="linenos"> 956</span></a>        <span class="k">for</span> <span class="n">k</span><span class="p">,</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">tensors</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
</span><span id="L-957"><a href="#L-957"><span class="linenos"> 957</span></a>            <span class="n">metadata</span><span class="p">[</span><span class="n">k</span><span class="p">]</span> <span class="o">=</span> <span class="p">{</span>
</span><span id="L-958"><a href="#L-958"><span class="linenos"> 958</span></a>                <span class="s2">&quot;dtype&quot;</span><span class="p">:</span> <span class="n">v</span><span class="o">.</span><span class="n">dtype</span><span class="o">.</span><span class="n">mlir</span><span class="p">,</span>
</span><span id="L-959"><a href="#L-959"><span class="linenos"> 959</span></a>                <span class="s2">&quot;shape&quot;</span><span class="p">:</span> <span class="nb">list</span><span class="p">(</span><span class="n">v</span><span class="o">.</span><span class="n">shape</span><span class="p">),</span>
</span><span id="L-960"><a href="#L-960"><span class="linenos"> 960</span></a>                <span class="s2">&quot;data_offsets&quot;</span><span class="p">:</span> <span class="p">[</span><span class="n">offset</span><span class="p">,</span> <span class="n">offset</span> <span class="o">+</span> <span class="n">v</span><span class="o">.</span><span class="n">nbytes</span><span class="p">()],</span>
</span><span id="L-961"><a href="#L-961"><span class="linenos"> 961</span></a>            <span class="p">}</span>
</span><span id="L-962"><a href="#L-962"><span class="linenos"> 962</span></a>            <span class="n">offset</span> <span class="o">+=</span> <span class="n">v</span><span class="o">.</span><span class="n">nbytes</span><span class="p">()</span>
</span><span id="L-963"><a href="#L-963"><span class="linenos"> 963</span></a>        <span class="n">j</span> <span class="o">=</span> <span class="n">json</span><span class="o">.</span><span class="n">dumps</span><span class="p">(</span><span class="n">metadata</span><span class="p">,</span> <span class="n">separators</span><span class="o">=</span><span class="p">(</span><span class="s2">&quot;,&quot;</span><span class="p">,</span> <span class="s2">&quot;:&quot;</span><span class="p">))</span>
</span><span id="L-964"><a href="#L-964"><span class="linenos"> 964</span></a>        <span class="n">Path</span><span class="p">(</span><span class="n">path</span><span class="p">)</span><span class="o">.</span><span class="n">unlink</span><span class="p">(</span><span class="n">missing_ok</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
</span><span id="L-965"><a href="#L-965"><span class="linenos"> 965</span></a>        <span class="n">jbytes</span> <span class="o">=</span> <span class="n">j</span><span class="o">.</span><span class="n">encode</span><span class="p">(</span><span class="s2">&quot;utf-8&quot;</span><span class="p">)</span>
</span><span id="L-966"><a href="#L-966"><span class="linenos"> 966</span></a>        <span class="n">start</span> <span class="o">=</span> <span class="mi">8</span> <span class="o">+</span> <span class="nb">len</span><span class="p">(</span><span class="n">jbytes</span><span class="p">)</span>
</span><span id="L-967"><a href="#L-967"><span class="linenos"> 967</span></a>        <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">path</span><span class="p">,</span> <span class="n">mode</span><span class="o">=</span><span class="s2">&quot;wb&quot;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>  <span class="c1"># make empty file, fill with enough space</span>
</span><span id="L-968"><a href="#L-968"><span class="linenos"> 968</span></a>            <span class="n">f</span><span class="o">.</span><span class="n">write</span><span class="p">(</span><span class="sa">b</span><span class="s2">&quot;</span><span class="se">\x00</span><span class="s2">&quot;</span> <span class="o">*</span> <span class="p">(</span><span class="n">start</span> <span class="o">+</span> <span class="n">offset</span><span class="p">))</span>
</span><span id="L-969"><a href="#L-969"><span class="linenos"> 969</span></a>        <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">path</span><span class="p">,</span> <span class="n">mode</span><span class="o">=</span><span class="s2">&quot;r+b&quot;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
</span><span id="L-970"><a href="#L-970"><span class="linenos"> 970</span></a>            <span class="k">with</span> <span class="n">mmap</span><span class="o">.</span><span class="n">mmap</span><span class="p">(</span><span class="n">f</span><span class="o">.</span><span class="n">fileno</span><span class="p">(),</span> <span class="n">length</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">access</span><span class="o">=</span><span class="n">mmap</span><span class="o">.</span><span class="n">ACCESS_WRITE</span><span class="p">)</span> <span class="k">as</span> <span class="n">m</span><span class="p">:</span>
</span><span id="L-971"><a href="#L-971"><span class="linenos"> 971</span></a>                <span class="n">m</span><span class="p">[</span><span class="mi">0</span><span class="p">:</span><span class="mi">8</span><span class="p">]</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">int64</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">j</span><span class="p">))</span><span class="o">.</span><span class="n">tobytes</span><span class="p">()</span>
</span><span id="L-972"><a href="#L-972"><span class="linenos"> 972</span></a>                <span class="n">m</span><span class="p">[</span><span class="mi">8</span><span class="p">:</span><span class="n">start</span><span class="p">]</span> <span class="o">=</span> <span class="n">jbytes</span>
</span><span id="L-973"><a href="#L-973"><span class="linenos"> 973</span></a>                <span class="k">for</span> <span class="n">t</span><span class="p">,</span> <span class="n">tm</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">tensors</span><span class="o">.</span><span class="n">values</span><span class="p">(),</span> <span class="n">metadata</span><span class="o">.</span><span class="n">values</span><span class="p">()):</span>
</span><span id="L-974"><a href="#L-974"><span class="linenos"> 974</span></a>                    <span class="n">data_start</span><span class="p">,</span> <span class="n">data_end</span> <span class="o">=</span> <span class="n">tm</span><span class="p">[</span><span class="s2">&quot;data_offsets&quot;</span><span class="p">]</span>
</span><span id="L-975"><a href="#L-975"><span class="linenos"> 975</span></a>                    <span class="n">m</span><span class="p">[</span><span class="n">start</span> <span class="o">+</span> <span class="n">data_start</span> <span class="p">:</span> <span class="n">start</span> <span class="o">+</span> <span class="n">data_end</span><span class="p">]</span> <span class="o">=</span> <span class="n">t</span><span class="o">.</span><span class="n">numpy</span><span class="p">()</span><span class="o">.</span><span class="n">tobytes</span><span class="p">()</span>
</span><span id="L-976"><a href="#L-976"><span class="linenos"> 976</span></a>
</span><span id="L-977"><a href="#L-977"><span class="linenos"> 977</span></a>
</span><span id="L-978"><a href="#L-978"><span class="linenos"> 978</span></a><span class="c1"># =================================</span>
</span><span id="L-979"><a href="#L-979"><span class="linenos"> 979</span></a><span class="c1">#   Program</span>
</span><span id="L-980"><a href="#L-980"><span class="linenos"> 980</span></a><span class="c1"># =================================</span>
</span><span id="L-981"><a href="#L-981"><span class="linenos"> 981</span></a>
</span><span id="L-982"><a href="#L-982"><span class="linenos"> 982</span></a>
</span><span id="L-983"><a href="#L-983"><span class="linenos"> 983</span></a><span class="k">class</span> <span class="nc">Var</span><span class="p">:</span>
</span><span id="L-984"><a href="#L-984"><span class="linenos"> 984</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">symval</span><span class="p">):</span>
</span><span id="L-985"><a href="#L-985"><span class="linenos"> 985</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">symval</span> <span class="o">=</span> <span class="n">symval</span>
</span><span id="L-986"><a href="#L-986"><span class="linenos"> 986</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">val</span> <span class="o">=</span> <span class="kc">None</span>
</span><span id="L-987"><a href="#L-987"><span class="linenos"> 987</span></a>
</span><span id="L-988"><a href="#L-988"><span class="linenos"> 988</span></a>
</span><span id="L-989"><a href="#L-989"><span class="linenos"> 989</span></a><span class="k">class</span> <span class="nc">Lit</span><span class="p">:</span>
</span><span id="L-990"><a href="#L-990"><span class="linenos"> 990</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">val</span><span class="p">):</span>
</span><span id="L-991"><a href="#L-991"><span class="linenos"> 991</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">symval</span> <span class="o">=</span> <span class="n">SymbolicTensor</span><span class="o">.</span><span class="n">like</span><span class="p">(</span><span class="n">get_symval</span><span class="p">(</span><span class="n">val</span><span class="p">))</span>
</span><span id="L-992"><a href="#L-992"><span class="linenos"> 992</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">val</span> <span class="o">=</span> <span class="n">val</span>
</span><span id="L-993"><a href="#L-993"><span class="linenos"> 993</span></a>
</span><span id="L-994"><a href="#L-994"><span class="linenos"> 994</span></a>
</span><span id="L-995"><a href="#L-995"><span class="linenos"> 995</span></a><span class="n">Atom</span> <span class="o">=</span> <span class="n">Union</span><span class="p">[</span><span class="n">Var</span><span class="p">,</span> <span class="n">Lit</span><span class="p">]</span>
</span><span id="L-996"><a href="#L-996"><span class="linenos"> 996</span></a>
</span><span id="L-997"><a href="#L-997"><span class="linenos"> 997</span></a>
</span><span id="L-998"><a href="#L-998"><span class="linenos"> 998</span></a><span class="k">class</span> <span class="nc">Instruction</span><span class="p">(</span><span class="n">NamedTuple</span><span class="p">):</span>
</span><span id="L-999"><a href="#L-999"><span class="linenos"> 999</span></a>    <span class="n">op</span><span class="p">:</span> <span class="n">Operator</span>
</span><span id="L-1000"><a href="#L-1000"><span class="linenos">1000</span></a>    <span class="n">inputs</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">Atom</span><span class="p">]</span>
</span><span id="L-1001"><a href="#L-1001"><span class="linenos">1001</span></a>    <span class="n">params</span><span class="p">:</span> <span class="n">Dict</span><span class="p">[</span><span class="nb">str</span><span class="p">,</span> <span class="n">Any</span><span class="p">]</span>
</span><span id="L-1002"><a href="#L-1002"><span class="linenos">1002</span></a>    <span class="n">out_binders</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">Atom</span><span class="p">]</span>
</span><span id="L-1003"><a href="#L-1003"><span class="linenos">1003</span></a>
</span><span id="L-1004"><a href="#L-1004"><span class="linenos">1004</span></a>
</span><span id="L-1005"><a href="#L-1005"><span class="linenos">1005</span></a><span class="k">class</span> <span class="nc">ProgramEnvVar</span><span class="p">(</span><span class="n">NamedTuple</span><span class="p">):</span>
</span><span id="L-1006"><a href="#L-1006"><span class="linenos">1006</span></a>    <span class="n">name</span><span class="p">:</span> <span class="nb">str</span>
</span><span id="L-1007"><a href="#L-1007"><span class="linenos">1007</span></a>    <span class="n">symval</span><span class="p">:</span> <span class="n">SymbolicTensor</span>
</span><span id="L-1008"><a href="#L-1008"><span class="linenos">1008</span></a>    <span class="n">is_const</span><span class="p">:</span> <span class="nb">bool</span> <span class="o">=</span> <span class="kc">False</span>
</span><span id="L-1009"><a href="#L-1009"><span class="linenos">1009</span></a>
</span><span id="L-1010"><a href="#L-1010"><span class="linenos">1010</span></a>    <span class="nd">@property</span>
</span><span id="L-1011"><a href="#L-1011"><span class="linenos">1011</span></a>    <span class="k">def</span> <span class="nf">shape</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-1012"><a href="#L-1012"><span class="linenos">1012</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">symval</span><span class="o">.</span><span class="n">shape</span>
</span><span id="L-1013"><a href="#L-1013"><span class="linenos">1013</span></a>
</span><span id="L-1014"><a href="#L-1014"><span class="linenos">1014</span></a>    <span class="nd">@property</span>
</span><span id="L-1015"><a href="#L-1015"><span class="linenos">1015</span></a>    <span class="k">def</span> <span class="nf">dtype</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-1016"><a href="#L-1016"><span class="linenos">1016</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">symval</span><span class="o">.</span><span class="n">dtype</span>
</span><span id="L-1017"><a href="#L-1017"><span class="linenos">1017</span></a>
</span><span id="L-1018"><a href="#L-1018"><span class="linenos">1018</span></a>    <span class="nd">@property</span>
</span><span id="L-1019"><a href="#L-1019"><span class="linenos">1019</span></a>    <span class="k">def</span> <span class="nf">device</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-1020"><a href="#L-1020"><span class="linenos">1020</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">symval</span><span class="o">.</span><span class="n">device</span>
</span><span id="L-1021"><a href="#L-1021"><span class="linenos">1021</span></a>
</span><span id="L-1022"><a href="#L-1022"><span class="linenos">1022</span></a>    <span class="nd">@property</span>
</span><span id="L-1023"><a href="#L-1023"><span class="linenos">1023</span></a>    <span class="k">def</span> <span class="nf">ndim</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-1024"><a href="#L-1024"><span class="linenos">1024</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">symval</span><span class="o">.</span><span class="n">ndim</span>
</span><span id="L-1025"><a href="#L-1025"><span class="linenos">1025</span></a>
</span><span id="L-1026"><a href="#L-1026"><span class="linenos">1026</span></a>    <span class="k">def</span> <span class="nf">numpy</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-1027"><a href="#L-1027"><span class="linenos">1027</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">symval</span><span class="o">.</span><span class="n">numpy</span><span class="p">()</span>
</span><span id="L-1028"><a href="#L-1028"><span class="linenos">1028</span></a>
</span><span id="L-1029"><a href="#L-1029"><span class="linenos">1029</span></a>    <span class="k">def</span> <span class="fm">__repr__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-1030"><a href="#L-1030"><span class="linenos">1030</span></a>        <span class="k">return</span> <span class="sa">f</span><span class="s2">&quot;&lt;ProgramEnvVar: name=</span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">, symval=</span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">symval</span><span class="si">}</span><span class="s2">&gt;&quot;</span>
</span><span id="L-1031"><a href="#L-1031"><span class="linenos">1031</span></a>
</span><span id="L-1032"><a href="#L-1032"><span class="linenos">1032</span></a>    <span class="n">str_short</span> <span class="o">=</span> <span class="fm">__repr__</span>
</span><span id="L-1033"><a href="#L-1033"><span class="linenos">1033</span></a>
</span><span id="L-1034"><a href="#L-1034"><span class="linenos">1034</span></a>
</span><span id="L-1035"><a href="#L-1035"><span class="linenos">1035</span></a><span class="k">class</span> <span class="nc">Program</span><span class="p">:</span>
</span><span id="L-1036"><a href="#L-1036"><span class="linenos">1036</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span>
</span><span id="L-1037"><a href="#L-1037"><span class="linenos">1037</span></a>        <span class="bp">self</span><span class="p">,</span>
</span><span id="L-1038"><a href="#L-1038"><span class="linenos">1038</span></a>        <span class="n">in_binders</span><span class="p">:</span> <span class="n">Any</span><span class="p">,</span>
</span><span id="L-1039"><a href="#L-1039"><span class="linenos">1039</span></a>        <span class="n">instructions</span><span class="p">:</span> <span class="n">Tuple</span><span class="p">[</span><span class="n">Instruction</span><span class="p">],</span>
</span><span id="L-1040"><a href="#L-1040"><span class="linenos">1040</span></a>        <span class="n">outs</span><span class="p">:</span> <span class="n">Any</span><span class="p">,</span>
</span><span id="L-1041"><a href="#L-1041"><span class="linenos">1041</span></a>        <span class="n">num_consts</span><span class="p">:</span> <span class="nb">int</span> <span class="o">=</span> <span class="mi">0</span><span class="p">,</span>
</span><span id="L-1042"><a href="#L-1042"><span class="linenos">1042</span></a>        <span class="n">static_args</span><span class="p">:</span> <span class="n">Any</span> <span class="o">=</span> <span class="p">(),</span>
</span><span id="L-1043"><a href="#L-1043"><span class="linenos">1043</span></a>        <span class="n">name</span><span class="p">:</span> <span class="nb">str</span> <span class="o">=</span> <span class="s2">&quot;my_program&quot;</span><span class="p">,</span>
</span><span id="L-1044"><a href="#L-1044"><span class="linenos">1044</span></a>        <span class="n">indent_amount</span><span class="o">=</span><span class="mi">4</span><span class="p">,</span>
</span><span id="L-1045"><a href="#L-1045"><span class="linenos">1045</span></a>    <span class="p">):</span>
</span><span id="L-1046"><a href="#L-1046"><span class="linenos">1046</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">in_binders</span><span class="p">:</span> <span class="n">Any</span> <span class="o">=</span> <span class="n">in_binders</span>
</span><span id="L-1047"><a href="#L-1047"><span class="linenos">1047</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">outs</span><span class="p">:</span> <span class="n">Any</span> <span class="o">=</span> <span class="n">outs</span>
</span><span id="L-1048"><a href="#L-1048"><span class="linenos">1048</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">instructions</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">prune_instructions</span><span class="p">(</span><span class="n">instructions</span><span class="p">,</span> <span class="n">outs</span><span class="p">)</span>
</span><span id="L-1049"><a href="#L-1049"><span class="linenos">1049</span></a>        <span class="c1"># self.instructions = instructions</span>
</span><span id="L-1050"><a href="#L-1050"><span class="linenos">1050</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">num_consts</span><span class="p">:</span> <span class="nb">int</span> <span class="o">=</span> <span class="n">num_consts</span>
</span><span id="L-1051"><a href="#L-1051"><span class="linenos">1051</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">static_args</span> <span class="o">=</span> <span class="n">static_args</span>
</span><span id="L-1052"><a href="#L-1052"><span class="linenos">1052</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">name</span><span class="p">:</span> <span class="nb">str</span> <span class="o">=</span> <span class="n">name</span>
</span><span id="L-1053"><a href="#L-1053"><span class="linenos">1053</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">indent_amount</span><span class="p">:</span> <span class="nb">int</span> <span class="o">=</span> <span class="n">indent_amount</span>
</span><span id="L-1054"><a href="#L-1054"><span class="linenos">1054</span></a>
</span><span id="L-1055"><a href="#L-1055"><span class="linenos">1055</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">env</span><span class="p">:</span> <span class="n">Dict</span><span class="p">[</span><span class="n">ProgramEnvVar</span><span class="p">,</span> <span class="n">Any</span><span class="p">]</span> <span class="o">=</span> <span class="nb">dict</span><span class="p">()</span>
</span><span id="L-1056"><a href="#L-1056"><span class="linenos">1056</span></a>        <span class="k">for</span> <span class="n">inb</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">in_binders</span><span class="p">:</span>
</span><span id="L-1057"><a href="#L-1057"><span class="linenos">1057</span></a>            <span class="n">prefix</span> <span class="o">=</span> <span class="s2">&quot;x&quot;</span> <span class="k">if</span> <span class="nb">type</span><span class="p">(</span><span class="n">inb</span><span class="o">.</span><span class="n">symval</span><span class="p">)</span> <span class="ow">is</span> <span class="n">SymbolicTensor</span> <span class="k">else</span> <span class="s2">&quot;c&quot;</span>
</span><span id="L-1058"><a href="#L-1058"><span class="linenos">1058</span></a>            <span class="n">idx</span> <span class="o">=</span> <span class="nb">sum</span><span class="p">([</span><span class="mi">1</span> <span class="k">if</span> <span class="n">v</span><span class="o">.</span><span class="n">name</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="o">==</span> <span class="n">prefix</span> <span class="k">else</span> <span class="mi">0</span> <span class="k">for</span> <span class="n">v</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">env</span><span class="o">.</span><span class="n">values</span><span class="p">()])</span>
</span><span id="L-1059"><a href="#L-1059"><span class="linenos">1059</span></a>            <span class="bp">self</span><span class="o">.</span><span class="n">env</span><span class="p">[</span><span class="n">inb</span><span class="p">]</span> <span class="o">=</span> <span class="n">ProgramEnvVar</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">prefix</span><span class="si">}{</span><span class="n">idx</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">,</span> <span class="n">inb</span><span class="o">.</span><span class="n">symval</span><span class="p">,</span> <span class="kc">True</span> <span class="k">if</span> <span class="n">prefix</span> <span class="o">==</span> <span class="s2">&quot;c&quot;</span> <span class="k">else</span> <span class="kc">False</span><span class="p">)</span>
</span><span id="L-1060"><a href="#L-1060"><span class="linenos">1060</span></a>        <span class="k">for</span> <span class="n">instruction</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">instructions</span><span class="p">:</span>
</span><span id="L-1061"><a href="#L-1061"><span class="linenos">1061</span></a>            <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">instruction</span><span class="o">.</span><span class="n">out_binders</span><span class="p">)</span> <span class="o">==</span> <span class="mi">0</span><span class="p">:</span>
</span><span id="L-1062"><a href="#L-1062"><span class="linenos">1062</span></a>                <span class="k">continue</span>
</span><span id="L-1063"><a href="#L-1063"><span class="linenos">1063</span></a>            <span class="k">for</span> <span class="n">outb</span> <span class="ow">in</span> <span class="n">instruction</span><span class="o">.</span><span class="n">out_binders</span><span class="p">:</span>
</span><span id="L-1064"><a href="#L-1064"><span class="linenos">1064</span></a>                <span class="n">prefix</span> <span class="o">=</span> <span class="s2">&quot;y&quot;</span> <span class="k">if</span> <span class="n">outb</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">outs</span> <span class="k">else</span> <span class="s2">&quot;z&quot;</span>
</span><span id="L-1065"><a href="#L-1065"><span class="linenos">1065</span></a>                <span class="n">idx</span> <span class="o">=</span> <span class="nb">sum</span><span class="p">([</span><span class="mi">1</span> <span class="k">if</span> <span class="n">v</span><span class="o">.</span><span class="n">name</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="o">==</span> <span class="n">prefix</span> <span class="k">else</span> <span class="mi">0</span> <span class="k">for</span> <span class="n">v</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">env</span><span class="o">.</span><span class="n">values</span><span class="p">()])</span>
</span><span id="L-1066"><a href="#L-1066"><span class="linenos">1066</span></a>                <span class="bp">self</span><span class="o">.</span><span class="n">env</span><span class="p">[</span><span class="n">outb</span><span class="p">]</span> <span class="o">=</span> <span class="n">ProgramEnvVar</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">prefix</span><span class="si">}{</span><span class="n">idx</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">,</span> <span class="n">outb</span><span class="o">.</span><span class="n">symval</span><span class="p">)</span>
</span><span id="L-1067"><a href="#L-1067"><span class="linenos">1067</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">curr_repr</span> <span class="o">=</span> <span class="nb">repr</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span>
</span><span id="L-1068"><a href="#L-1068"><span class="linenos">1068</span></a>
</span><span id="L-1069"><a href="#L-1069"><span class="linenos">1069</span></a>    <span class="k">def</span> <span class="nf">pprint_shape</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">symval</span><span class="p">,</span> <span class="n">scalar_as_empty_array</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>
</span><span id="L-1070"><a href="#L-1070"><span class="linenos">1070</span></a>        <span class="n">xdtype</span> <span class="o">=</span> <span class="n">symval</span><span class="o">.</span><span class="n">dtype</span><span class="o">.</span><span class="n">mlir</span>
</span><span id="L-1071"><a href="#L-1071"><span class="linenos">1071</span></a>        <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">symval</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span> <span class="o">&gt;</span> <span class="mi">0</span><span class="p">:</span>
</span><span id="L-1072"><a href="#L-1072"><span class="linenos">1072</span></a>            <span class="n">xshape</span> <span class="o">=</span> <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="s1">&#39;, &#39;</span><span class="o">.</span><span class="n">join</span><span class="p">((</span><span class="nb">repr</span><span class="p">(</span><span class="n">i</span><span class="p">)</span><span class="w"> </span><span class="k">for</span><span class="w"> </span><span class="n">i</span><span class="w"> </span><span class="ow">in</span><span class="w"> </span><span class="n">symval</span><span class="o">.</span><span class="n">shape</span><span class="p">))</span><span class="si">}</span><span class="s2">&quot;</span>
</span><span id="L-1073"><a href="#L-1073"><span class="linenos">1073</span></a>            <span class="k">return</span> <span class="sa">f</span><span class="s2">&quot;[</span><span class="si">{</span><span class="n">xshape</span><span class="si">}</span><span class="s2">, </span><span class="si">{</span><span class="n">xdtype</span><span class="si">}</span><span class="s2">]&quot;</span>
</span><span id="L-1074"><a href="#L-1074"><span class="linenos">1074</span></a>        <span class="k">else</span><span class="p">:</span>
</span><span id="L-1075"><a href="#L-1075"><span class="linenos">1075</span></a>            <span class="k">return</span> <span class="sa">f</span><span class="s2">&quot;[</span><span class="si">{</span><span class="n">xdtype</span><span class="si">}</span><span class="s2">]&quot;</span>
</span><span id="L-1076"><a href="#L-1076"><span class="linenos">1076</span></a>
</span><span id="L-1077"><a href="#L-1077"><span class="linenos">1077</span></a>    <span class="k">def</span> <span class="nf">pprint_sig</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">in_symvals</span><span class="p">,</span> <span class="n">out_symvals</span><span class="p">,</span> <span class="n">unpack_unary_output</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>
</span><span id="L-1078"><a href="#L-1078"><span class="linenos">1078</span></a>        <span class="n">in_code</span> <span class="o">=</span> <span class="s2">&quot;, &quot;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">pprint_shape</span><span class="p">(</span><span class="n">t</span><span class="p">)</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">in_symvals</span><span class="p">)</span>
</span><span id="L-1079"><a href="#L-1079"><span class="linenos">1079</span></a>        <span class="n">in_code</span> <span class="o">=</span> <span class="sa">f</span><span class="s2">&quot;(</span><span class="si">{</span><span class="n">in_code</span><span class="si">}</span><span class="s2">)&quot;</span> <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">in_symvals</span><span class="p">)</span> <span class="o">&gt;</span> <span class="mi">1</span> <span class="k">else</span> <span class="n">in_code</span>
</span><span id="L-1080"><a href="#L-1080"><span class="linenos">1080</span></a>        <span class="n">out_code</span> <span class="o">=</span> <span class="s2">&quot;, &quot;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">pprint_shape</span><span class="p">(</span><span class="n">t</span><span class="p">)</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">out_symvals</span><span class="p">)</span>
</span><span id="L-1081"><a href="#L-1081"><span class="linenos">1081</span></a>        <span class="n">out_code</span> <span class="o">=</span> <span class="sa">f</span><span class="s2">&quot;(</span><span class="si">{</span><span class="n">out_code</span><span class="si">}</span><span class="s2">)&quot;</span> <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">out_symvals</span><span class="p">)</span> <span class="o">&gt;</span> <span class="mi">1</span> <span class="ow">or</span> <span class="n">unpack_unary_output</span> <span class="k">else</span> <span class="n">out_code</span>
</span><span id="L-1082"><a href="#L-1082"><span class="linenos">1082</span></a>        <span class="n">typing_code</span> <span class="o">=</span> <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">in_code</span><span class="si">}</span><span class="s2"> -&gt; </span><span class="si">{</span><span class="n">out_code</span><span class="si">}</span><span class="s2">&quot;</span>
</span><span id="L-1083"><a href="#L-1083"><span class="linenos">1083</span></a>        <span class="k">return</span> <span class="n">typing_code</span>
</span><span id="L-1084"><a href="#L-1084"><span class="linenos">1084</span></a>
</span><span id="L-1085"><a href="#L-1085"><span class="linenos">1085</span></a>    <span class="k">def</span> <span class="fm">__repr__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-1086"><a href="#L-1086"><span class="linenos">1086</span></a>        <span class="n">fn_defs</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">instructions_as_code</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="nb">dict</span><span class="p">())</span>
</span><span id="L-1087"><a href="#L-1087"><span class="linenos">1087</span></a>        <span class="k">return</span> <span class="s2">&quot;</span><span class="se">\n</span><span class="s2">&quot;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">line</span> <span class="k">for</span> <span class="n">code_lines</span> <span class="ow">in</span> <span class="n">fn_defs</span><span class="o">.</span><span class="n">values</span><span class="p">()</span> <span class="k">for</span> <span class="n">line</span> <span class="ow">in</span> <span class="n">code_lines</span><span class="p">)</span>
</span><span id="L-1088"><a href="#L-1088"><span class="linenos">1088</span></a>
</span><span id="L-1089"><a href="#L-1089"><span class="linenos">1089</span></a>    <span class="k">def</span> <span class="nf">save</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="n">dir_path</span><span class="o">=</span><span class="s2">&quot;/tmp/slope_program&quot;</span><span class="p">,</span> <span class="n">dry_run</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>
</span><span id="L-1090"><a href="#L-1090"><span class="linenos">1090</span></a>        <span class="n">os</span><span class="o">.</span><span class="n">makedirs</span><span class="p">(</span><span class="n">dir_path</span><span class="p">,</span> <span class="n">exist_ok</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
</span><span id="L-1091"><a href="#L-1091"><span class="linenos">1091</span></a>        <span class="n">head_code_lines</span> <span class="o">=</span> <span class="p">[</span><span class="sa">f</span><span class="s2">&quot;import slope # backend=</span><span class="si">{</span><span class="n">backend</span><span class="o">.</span><span class="vm">__class__</span><span class="o">.</span><span class="vm">__name__</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">]</span>
</span><span id="L-1092"><a href="#L-1092"><span class="linenos">1092</span></a>        <span class="n">fn_defs</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">instructions_as_code</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="nb">dict</span><span class="p">())</span>
</span><span id="L-1093"><a href="#L-1093"><span class="linenos">1093</span></a>        <span class="n">in_binders_vars</span> <span class="o">=</span> <span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">env</span><span class="p">[</span><span class="n">i</span><span class="p">]</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">in_binders</span><span class="p">]</span>
</span><span id="L-1094"><a href="#L-1094"><span class="linenos">1094</span></a>        <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">in_binders</span><span class="p">)):</span>
</span><span id="L-1095"><a href="#L-1095"><span class="linenos">1095</span></a>            <span class="n">ibv</span> <span class="o">=</span> <span class="n">in_binders_vars</span><span class="p">[</span><span class="n">i</span><span class="p">]</span>
</span><span id="L-1096"><a href="#L-1096"><span class="linenos">1096</span></a>            <span class="k">if</span> <span class="n">ibv</span><span class="o">.</span><span class="n">is_const</span><span class="p">:</span>
</span><span id="L-1097"><a href="#L-1097"><span class="linenos">1097</span></a>                <span class="n">const_filename</span> <span class="o">=</span> <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">ibv</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">.safetensors&quot;</span>
</span><span id="L-1098"><a href="#L-1098"><span class="linenos">1098</span></a>                <span class="n">const_path</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">dir_path</span><span class="p">,</span> <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">const_filename</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">)</span>
</span><span id="L-1099"><a href="#L-1099"><span class="linenos">1099</span></a>                <span class="k">if</span> <span class="ow">not</span> <span class="n">dry_run</span><span class="p">:</span>
</span><span id="L-1100"><a href="#L-1100"><span class="linenos">1100</span></a>                    <span class="n">backend</span><span class="o">.</span><span class="n">save</span><span class="p">(</span><span class="n">args</span><span class="p">[</span><span class="n">i</span><span class="p">],</span> <span class="n">const_path</span><span class="p">)</span>
</span><span id="L-1101"><a href="#L-1101"><span class="linenos">1101</span></a>                <span class="n">dblog</span><span class="p">(</span>
</span><span id="L-1102"><a href="#L-1102"><span class="linenos">1102</span></a>                    <span class="sa">f</span><span class="s2">&quot;Saved </span><span class="si">{</span><span class="n">ibv</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2"> at </span><span class="si">{</span><span class="n">const_path</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">,</span>
</span><span id="L-1103"><a href="#L-1103"><span class="linenos">1103</span></a>                    <span class="n">enable</span><span class="o">=</span><span class="n">backend</span><span class="o">.</span><span class="n">LOG_BACKEND</span><span class="p">,</span>
</span><span id="L-1104"><a href="#L-1104"><span class="linenos">1104</span></a>                <span class="p">)</span>
</span><span id="L-1105"><a href="#L-1105"><span class="linenos">1105</span></a>                <span class="n">head_code_lines</span> <span class="o">+=</span> <span class="p">[</span><span class="sa">f</span><span class="s2">&quot;&quot;&quot;</span><span class="si">{</span><span class="n">ibv</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2"> = slope.load(&quot;./</span><span class="si">{</span><span class="n">const_filename</span><span class="si">}</span><span class="s2">&quot;)&quot;&quot;&quot;</span><span class="p">]</span>
</span><span id="L-1106"><a href="#L-1106"><span class="linenos">1106</span></a>        <span class="n">head_code_lines</span> <span class="o">+=</span> <span class="p">[</span><span class="s2">&quot;&quot;</span><span class="p">]</span>
</span><span id="L-1107"><a href="#L-1107"><span class="linenos">1107</span></a>        <span class="n">code</span> <span class="o">=</span> <span class="s2">&quot;</span><span class="se">\n</span><span class="s2">&quot;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">head_code_lines</span> <span class="o">+</span> <span class="p">[</span><span class="n">line</span> <span class="k">for</span> <span class="n">code_lines</span> <span class="ow">in</span> <span class="n">fn_defs</span><span class="o">.</span><span class="n">values</span><span class="p">()</span> <span class="k">for</span> <span class="n">line</span> <span class="ow">in</span> <span class="n">code_lines</span><span class="p">])</span>
</span><span id="L-1108"><a href="#L-1108"><span class="linenos">1108</span></a>        <span class="n">dblog</span><span class="p">(</span>
</span><span id="L-1109"><a href="#L-1109"><span class="linenos">1109</span></a>            <span class="sa">f</span><span class="s2">&quot;Contents of </span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">:</span><span class="se">\n</span><span class="s2">```</span><span class="se">\n</span><span class="si">{</span><span class="n">code</span><span class="si">}</span><span class="se">\n</span><span class="s2">```&quot;</span><span class="p">,</span>
</span><span id="L-1110"><a href="#L-1110"><span class="linenos">1110</span></a>            <span class="n">enable</span><span class="o">=</span><span class="n">backend</span><span class="o">.</span><span class="n">LOG_BACKEND</span><span class="p">,</span>
</span><span id="L-1111"><a href="#L-1111"><span class="linenos">1111</span></a>        <span class="p">)</span>
</span><span id="L-1112"><a href="#L-1112"><span class="linenos">1112</span></a>        <span class="n">program_path</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">dir_path</span><span class="p">,</span> <span class="s2">&quot;main.py&quot;</span><span class="p">)</span>
</span><span id="L-1113"><a href="#L-1113"><span class="linenos">1113</span></a>        <span class="k">if</span> <span class="ow">not</span> <span class="n">dry_run</span><span class="p">:</span>
</span><span id="L-1114"><a href="#L-1114"><span class="linenos">1114</span></a>            <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">program_path</span><span class="p">,</span> <span class="s2">&quot;w&quot;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
</span><span id="L-1115"><a href="#L-1115"><span class="linenos">1115</span></a>                <span class="n">f</span><span class="o">.</span><span class="n">write</span><span class="p">(</span><span class="n">code</span><span class="p">)</span>
</span><span id="L-1116"><a href="#L-1116"><span class="linenos">1116</span></a>        <span class="n">dblog</span><span class="p">(</span>
</span><span id="L-1117"><a href="#L-1117"><span class="linenos">1117</span></a>            <span class="sa">f</span><span class="s2">&quot;Saved program </span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2"> at </span><span class="si">{</span><span class="n">program_path</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">,</span>
</span><span id="L-1118"><a href="#L-1118"><span class="linenos">1118</span></a>            <span class="n">enable</span><span class="o">=</span><span class="n">backend</span><span class="o">.</span><span class="n">LOG_BACKEND</span><span class="p">,</span>
</span><span id="L-1119"><a href="#L-1119"><span class="linenos">1119</span></a>        <span class="p">)</span>
</span><span id="L-1120"><a href="#L-1120"><span class="linenos">1120</span></a>        <span class="n">ls_contents</span> <span class="o">=</span> <span class="s2">&quot;</span><span class="se">\n\t</span><span class="s2">&quot;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">listdir</span><span class="p">(</span><span class="n">dir_path</span><span class="p">))</span>
</span><span id="L-1121"><a href="#L-1121"><span class="linenos">1121</span></a>        <span class="n">dblog</span><span class="p">(</span>
</span><span id="L-1122"><a href="#L-1122"><span class="linenos">1122</span></a>            <span class="sa">f</span><span class="s2">&quot;Contents of </span><span class="si">{</span><span class="n">dir_path</span><span class="si">}</span><span class="s2">:</span><span class="se">\n\t</span><span class="si">{</span><span class="n">ls_contents</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">,</span>
</span><span id="L-1123"><a href="#L-1123"><span class="linenos">1123</span></a>            <span class="n">enable</span><span class="o">=</span><span class="n">backend</span><span class="o">.</span><span class="n">LOG_BACKEND</span><span class="p">,</span>
</span><span id="L-1124"><a href="#L-1124"><span class="linenos">1124</span></a>        <span class="p">)</span>
</span><span id="L-1125"><a href="#L-1125"><span class="linenos">1125</span></a>
</span><span id="L-1126"><a href="#L-1126"><span class="linenos">1126</span></a>    <span class="k">def</span> <span class="fm">__hash__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-1127"><a href="#L-1127"><span class="linenos">1127</span></a>        <span class="k">return</span> <span class="nb">hash</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">curr_repr</span><span class="p">)</span>
</span><span id="L-1128"><a href="#L-1128"><span class="linenos">1128</span></a>
</span><span id="L-1129"><a href="#L-1129"><span class="linenos">1129</span></a>    <span class="k">def</span> <span class="fm">__eq__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">other</span><span class="p">):</span>
</span><span id="L-1130"><a href="#L-1130"><span class="linenos">1130</span></a>        <span class="k">return</span> <span class="bp">self</span> <span class="ow">is</span> <span class="n">other</span>
</span><span id="L-1131"><a href="#L-1131"><span class="linenos">1131</span></a>
</span><span id="L-1132"><a href="#L-1132"><span class="linenos">1132</span></a>    <span class="nd">@classmethod</span>
</span><span id="L-1133"><a href="#L-1133"><span class="linenos">1133</span></a>    <span class="k">def</span> <span class="nf">instructions_as_code</span><span class="p">(</span><span class="bp">cls</span><span class="p">,</span> <span class="n">program</span><span class="p">,</span> <span class="n">fn_defs</span><span class="p">):</span>
</span><span id="L-1134"><a href="#L-1134"><span class="linenos">1134</span></a>        <span class="k">def</span> <span class="nf">indent</span><span class="p">(</span><span class="n">code</span><span class="p">,</span> <span class="n">indent_amount</span><span class="p">):</span>
</span><span id="L-1135"><a href="#L-1135"><span class="linenos">1135</span></a>            <span class="n">spaces</span> <span class="o">=</span> <span class="s2">&quot; &quot;</span> <span class="o">*</span> <span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">code</span><span class="p">)</span> <span class="o">-</span> <span class="nb">len</span><span class="p">(</span><span class="n">code</span><span class="o">.</span><span class="n">lstrip</span><span class="p">()))</span>
</span><span id="L-1136"><a href="#L-1136"><span class="linenos">1136</span></a>            <span class="n">spaces</span> <span class="o">+=</span> <span class="s2">&quot; &quot;</span> <span class="o">*</span> <span class="n">indent_amount</span>
</span><span id="L-1137"><a href="#L-1137"><span class="linenos">1137</span></a>            <span class="k">return</span> <span class="s2">&quot;</span><span class="se">\n</span><span class="s2">&quot;</span><span class="o">.</span><span class="n">join</span><span class="p">([</span><span class="n">spaces</span> <span class="o">+</span> <span class="n">line</span> <span class="k">for</span> <span class="n">line</span> <span class="ow">in</span> <span class="n">code</span><span class="o">.</span><span class="n">strip</span><span class="p">()</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="s2">&quot;</span><span class="se">\n</span><span class="s2">&quot;</span><span class="p">)])</span>
</span><span id="L-1138"><a href="#L-1138"><span class="linenos">1138</span></a>
</span><span id="L-1139"><a href="#L-1139"><span class="linenos">1139</span></a>        <span class="n">in_binders_vars</span> <span class="o">=</span> <span class="p">[</span><span class="n">program</span><span class="o">.</span><span class="n">env</span><span class="p">[</span><span class="n">i</span><span class="p">]</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="n">program</span><span class="o">.</span><span class="n">in_binders</span><span class="p">]</span>
</span><span id="L-1140"><a href="#L-1140"><span class="linenos">1140</span></a>        <span class="n">body_code_lines</span> <span class="o">=</span> <span class="p">[]</span>
</span><span id="L-1141"><a href="#L-1141"><span class="linenos">1141</span></a>        <span class="k">for</span> <span class="n">instruction</span> <span class="ow">in</span> <span class="n">program</span><span class="o">.</span><span class="n">instructions</span><span class="p">:</span>
</span><span id="L-1142"><a href="#L-1142"><span class="linenos">1142</span></a>            <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">instruction</span><span class="o">.</span><span class="n">out_binders</span><span class="p">)</span> <span class="o">==</span> <span class="mi">0</span><span class="p">:</span>
</span><span id="L-1143"><a href="#L-1143"><span class="linenos">1143</span></a>                <span class="k">continue</span>
</span><span id="L-1144"><a href="#L-1144"><span class="linenos">1144</span></a>            <span class="n">params</span> <span class="o">=</span> <span class="n">instruction</span><span class="o">.</span><span class="n">params</span><span class="o">.</span><span class="n">copy</span><span class="p">()</span>
</span><span id="L-1145"><a href="#L-1145"><span class="linenos">1145</span></a>            <span class="k">for</span> <span class="n">param_name</span><span class="p">,</span> <span class="n">param</span> <span class="ow">in</span> <span class="n">params</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
</span><span id="L-1146"><a href="#L-1146"><span class="linenos">1146</span></a>                <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">param</span><span class="p">,</span> <span class="n">Program</span><span class="p">):</span>
</span><span id="L-1147"><a href="#L-1147"><span class="linenos">1147</span></a>                    <span class="n">sub_program</span> <span class="o">=</span> <span class="n">param</span>
</span><span id="L-1148"><a href="#L-1148"><span class="linenos">1148</span></a>                    <span class="n">fn_defs</span> <span class="o">=</span> <span class="bp">cls</span><span class="o">.</span><span class="n">instructions_as_code</span><span class="p">(</span><span class="n">sub_program</span><span class="p">,</span> <span class="n">fn_defs</span><span class="p">)</span>
</span><span id="L-1149"><a href="#L-1149"><span class="linenos">1149</span></a>                    <span class="n">program_in_vals</span> <span class="o">=</span> <span class="s2">&quot;, &quot;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">program</span><span class="o">.</span><span class="n">env</span><span class="p">[</span><span class="n">x</span><span class="p">]</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">&quot;</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">instruction</span><span class="o">.</span><span class="n">inputs</span><span class="p">)</span>
</span><span id="L-1150"><a href="#L-1150"><span class="linenos">1150</span></a>                    <span class="n">params</span><span class="p">[</span><span class="n">param_name</span><span class="p">]</span> <span class="o">=</span> <span class="sa">f</span><span class="s2">&quot;slope.make_program(</span><span class="si">{</span><span class="n">sub_program</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">, </span><span class="si">{</span><span class="n">program_in_vals</span><span class="si">}</span><span class="s2">)[0]&quot;</span>
</span><span id="L-1151"><a href="#L-1151"><span class="linenos">1151</span></a>                <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">param</span><span class="p">,</span> <span class="n">DType</span><span class="p">):</span>
</span><span id="L-1152"><a href="#L-1152"><span class="linenos">1152</span></a>                    <span class="n">params</span><span class="p">[</span><span class="n">param_name</span><span class="p">]</span> <span class="o">=</span> <span class="sa">f</span><span class="s2">&quot;slope.</span><span class="si">{</span><span class="n">param</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">&quot;</span>
</span><span id="L-1153"><a href="#L-1153"><span class="linenos">1153</span></a>            <span class="n">param_vals</span> <span class="o">=</span> <span class="s2">&quot;, &quot;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">param_name</span><span class="si">}</span><span class="s2">=</span><span class="si">{</span><span class="n">param</span><span class="si">}</span><span class="s2">&quot;</span> <span class="k">for</span> <span class="n">param_name</span><span class="p">,</span> <span class="n">param</span> <span class="ow">in</span> <span class="n">params</span><span class="o">.</span><span class="n">items</span><span class="p">())</span>
</span><span id="L-1154"><a href="#L-1154"><span class="linenos">1154</span></a>            <span class="n">in_vals</span> <span class="o">=</span> <span class="s2">&quot;, &quot;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">program</span><span class="o">.</span><span class="n">env</span><span class="p">[</span><span class="n">x</span><span class="p">]</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">&quot;</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">instruction</span><span class="o">.</span><span class="n">inputs</span><span class="p">)</span>
</span><span id="L-1155"><a href="#L-1155"><span class="linenos">1155</span></a>            <span class="n">out_vals</span> <span class="o">=</span> <span class="s2">&quot;, &quot;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">program</span><span class="o">.</span><span class="n">env</span><span class="p">[</span><span class="n">z</span><span class="p">]</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">&quot;</span> <span class="k">for</span> <span class="n">z</span> <span class="ow">in</span> <span class="n">instruction</span><span class="o">.</span><span class="n">out_binders</span><span class="p">)</span>
</span><span id="L-1156"><a href="#L-1156"><span class="linenos">1156</span></a>            <span class="n">sig</span> <span class="o">=</span> <span class="n">program</span><span class="o">.</span><span class="n">pprint_sig</span><span class="p">(</span>
</span><span id="L-1157"><a href="#L-1157"><span class="linenos">1157</span></a>                <span class="p">[</span><span class="n">program</span><span class="o">.</span><span class="n">env</span><span class="p">[</span><span class="n">x</span><span class="p">]</span><span class="o">.</span><span class="n">symval</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">instruction</span><span class="o">.</span><span class="n">inputs</span><span class="p">],</span>
</span><span id="L-1158"><a href="#L-1158"><span class="linenos">1158</span></a>                <span class="p">[</span><span class="n">program</span><span class="o">.</span><span class="n">env</span><span class="p">[</span><span class="n">y</span><span class="p">]</span><span class="o">.</span><span class="n">symval</span> <span class="k">for</span> <span class="n">y</span> <span class="ow">in</span> <span class="n">instruction</span><span class="o">.</span><span class="n">out_binders</span><span class="p">],</span>
</span><span id="L-1159"><a href="#L-1159"><span class="linenos">1159</span></a>            <span class="p">)</span>
</span><span id="L-1160"><a href="#L-1160"><span class="linenos">1160</span></a>            <span class="n">line</span> <span class="o">=</span> <span class="sa">f</span><span class="s2">&quot;&quot;&quot;</span><span class="si">{</span><span class="n">out_vals</span><span class="si">}</span><span class="s2"> = slope.</span><span class="si">{</span><span class="n">instruction</span><span class="o">.</span><span class="n">op</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">(</span><span class="si">{</span><span class="n">in_vals</span><span class="si">}{</span><span class="s2">&quot;, &quot;</span><span class="w"> </span><span class="k">if</span><span class="w"> </span><span class="p">(</span><span class="n">param_vals</span><span class="w"> </span><span class="ow">and</span><span class="w"> </span><span class="n">in_vals</span><span class="p">)</span><span class="w"> </span><span class="k">else</span><span class="w"> </span><span class="s2">&quot;&quot;</span><span class="si">}{</span><span class="n">param_vals</span><span class="si">}</span><span class="s2">) # </span><span class="si">{</span><span class="n">sig</span><span class="si">}</span><span class="s2">&quot;&quot;&quot;</span>
</span><span id="L-1161"><a href="#L-1161"><span class="linenos">1161</span></a>            <span class="n">body_code_lines</span> <span class="o">+=</span> <span class="p">[</span><span class="n">indent</span><span class="p">(</span><span class="n">line</span><span class="p">,</span> <span class="n">program</span><span class="o">.</span><span class="n">indent_amount</span><span class="p">)]</span>
</span><span id="L-1162"><a href="#L-1162"><span class="linenos">1162</span></a>
</span><span id="L-1163"><a href="#L-1163"><span class="linenos">1163</span></a>        <span class="n">fn_args_str</span> <span class="o">=</span> <span class="s2">&quot;, &quot;</span><span class="o">.</span><span class="n">join</span><span class="p">([</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">i</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">&quot;</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="n">in_binders_vars</span><span class="p">])</span>
</span><span id="L-1164"><a href="#L-1164"><span class="linenos">1164</span></a>        <span class="c1"># fn_static_args_str = &quot;, &quot;.join([f&quot;{a}={a_val}&quot; for a, a_val in program.static_args])</span>
</span><span id="L-1165"><a href="#L-1165"><span class="linenos">1165</span></a>        <span class="n">out_vars</span> <span class="o">=</span> <span class="p">[</span><span class="n">program</span><span class="o">.</span><span class="n">env</span><span class="p">[</span><span class="n">o</span><span class="p">]</span> <span class="k">for</span> <span class="n">o</span> <span class="ow">in</span> <span class="n">program</span><span class="o">.</span><span class="n">outs</span><span class="p">]</span>
</span><span id="L-1166"><a href="#L-1166"><span class="linenos">1166</span></a>        <span class="n">fn_sig</span> <span class="o">=</span> <span class="n">program</span><span class="o">.</span><span class="n">pprint_sig</span><span class="p">(</span>
</span><span id="L-1167"><a href="#L-1167"><span class="linenos">1167</span></a>            <span class="p">[</span><span class="n">i</span><span class="o">.</span><span class="n">symval</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="n">in_binders_vars</span><span class="p">],</span>
</span><span id="L-1168"><a href="#L-1168"><span class="linenos">1168</span></a>            <span class="p">[</span><span class="n">o</span><span class="o">.</span><span class="n">symval</span> <span class="k">for</span> <span class="n">o</span> <span class="ow">in</span> <span class="n">out_vars</span><span class="p">],</span>
</span><span id="L-1169"><a href="#L-1169"><span class="linenos">1169</span></a>        <span class="p">)</span>
</span><span id="L-1170"><a href="#L-1170"><span class="linenos">1170</span></a>        <span class="n">head_code_line</span> <span class="o">=</span> <span class="p">[</span><span class="sa">f</span><span class="s2">&quot;def </span><span class="si">{</span><span class="n">program</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">(</span><span class="si">{</span><span class="n">fn_args_str</span><span class="si">}</span><span class="s2">): # </span><span class="si">{</span><span class="n">fn_sig</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">]</span>
</span><span id="L-1171"><a href="#L-1171"><span class="linenos">1171</span></a>        <span class="n">out_str</span> <span class="o">=</span> <span class="s2">&quot;, &quot;</span><span class="o">.</span><span class="n">join</span><span class="p">([</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">o</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">&quot;</span> <span class="k">for</span> <span class="n">o</span> <span class="ow">in</span> <span class="n">out_vars</span><span class="p">])</span>
</span><span id="L-1172"><a href="#L-1172"><span class="linenos">1172</span></a>        <span class="n">tail_code_line</span> <span class="o">=</span> <span class="p">[</span><span class="n">indent</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;return </span><span class="si">{</span><span class="n">out_str</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">,</span> <span class="n">program</span><span class="o">.</span><span class="n">indent_amount</span><span class="p">)]</span>
</span><span id="L-1173"><a href="#L-1173"><span class="linenos">1173</span></a>        <span class="n">code_lines</span> <span class="o">=</span> <span class="n">head_code_line</span> <span class="o">+</span> <span class="n">body_code_lines</span> <span class="o">+</span> <span class="n">tail_code_line</span> <span class="o">+</span> <span class="p">[</span><span class="s2">&quot;</span><span class="se">\n</span><span class="s2">&quot;</span><span class="p">]</span>
</span><span id="L-1174"><a href="#L-1174"><span class="linenos">1174</span></a>
</span><span id="L-1175"><a href="#L-1175"><span class="linenos">1175</span></a>        <span class="n">fn_defs</span><span class="p">[</span><span class="n">program</span><span class="o">.</span><span class="n">name</span><span class="p">]</span> <span class="o">=</span> <span class="n">code_lines</span>
</span><span id="L-1176"><a href="#L-1176"><span class="linenos">1176</span></a>        <span class="k">return</span> <span class="n">fn_defs</span>
</span><span id="L-1177"><a href="#L-1177"><span class="linenos">1177</span></a>
</span><span id="L-1178"><a href="#L-1178"><span class="linenos">1178</span></a>    <span class="nd">@staticmethod</span>
</span><span id="L-1179"><a href="#L-1179"><span class="linenos">1179</span></a>    <span class="k">def</span> <span class="nf">prune_instructions</span><span class="p">(</span><span class="n">instructions</span><span class="p">,</span> <span class="n">outs</span><span class="p">):</span>
</span><span id="L-1180"><a href="#L-1180"><span class="linenos">1180</span></a>        <span class="n">graph</span> <span class="o">=</span> <span class="nb">dict</span><span class="p">()</span>
</span><span id="L-1181"><a href="#L-1181"><span class="linenos">1181</span></a>        <span class="k">for</span> <span class="n">instruction</span> <span class="ow">in</span> <span class="n">instructions</span><span class="p">:</span>
</span><span id="L-1182"><a href="#L-1182"><span class="linenos">1182</span></a>            <span class="n">parent_nodes</span><span class="p">,</span> <span class="n">child_nodes</span> <span class="o">=</span> <span class="n">instruction</span><span class="o">.</span><span class="n">out_binders</span><span class="p">,</span> <span class="n">instruction</span><span class="o">.</span><span class="n">inputs</span>
</span><span id="L-1183"><a href="#L-1183"><span class="linenos">1183</span></a>            <span class="k">for</span> <span class="n">parent</span> <span class="ow">in</span> <span class="n">parent_nodes</span><span class="p">:</span>
</span><span id="L-1184"><a href="#L-1184"><span class="linenos">1184</span></a>                <span class="k">if</span> <span class="n">parent</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">graph</span><span class="p">:</span>
</span><span id="L-1185"><a href="#L-1185"><span class="linenos">1185</span></a>                    <span class="n">graph</span><span class="p">[</span><span class="n">parent</span><span class="p">]</span> <span class="o">=</span> <span class="nb">set</span><span class="p">()</span>
</span><span id="L-1186"><a href="#L-1186"><span class="linenos">1186</span></a>                <span class="k">for</span> <span class="n">child</span> <span class="ow">in</span> <span class="n">child_nodes</span><span class="p">:</span>
</span><span id="L-1187"><a href="#L-1187"><span class="linenos">1187</span></a>                    <span class="n">graph</span><span class="p">[</span><span class="n">parent</span><span class="p">]</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">child</span><span class="p">)</span>
</span><span id="L-1188"><a href="#L-1188"><span class="linenos">1188</span></a>        <span class="n">visited_from_terminal</span> <span class="o">=</span> <span class="nb">set</span><span class="p">()</span>
</span><span id="L-1189"><a href="#L-1189"><span class="linenos">1189</span></a>
</span><span id="L-1190"><a href="#L-1190"><span class="linenos">1190</span></a>        <span class="k">def</span> <span class="nf">dfs</span><span class="p">(</span><span class="n">node</span><span class="p">,</span> <span class="n">visited</span><span class="p">):</span>
</span><span id="L-1191"><a href="#L-1191"><span class="linenos">1191</span></a>            <span class="n">visited</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">node</span><span class="p">)</span>
</span><span id="L-1192"><a href="#L-1192"><span class="linenos">1192</span></a>            <span class="k">if</span> <span class="n">node</span> <span class="ow">in</span> <span class="n">graph</span><span class="p">:</span>
</span><span id="L-1193"><a href="#L-1193"><span class="linenos">1193</span></a>                <span class="k">for</span> <span class="n">neighbor</span> <span class="ow">in</span> <span class="n">graph</span><span class="p">[</span><span class="n">node</span><span class="p">]:</span>
</span><span id="L-1194"><a href="#L-1194"><span class="linenos">1194</span></a>                    <span class="k">if</span> <span class="n">neighbor</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">visited</span><span class="p">:</span>
</span><span id="L-1195"><a href="#L-1195"><span class="linenos">1195</span></a>                        <span class="n">dfs</span><span class="p">(</span><span class="n">neighbor</span><span class="p">,</span> <span class="n">visited</span><span class="p">)</span>
</span><span id="L-1196"><a href="#L-1196"><span class="linenos">1196</span></a>
</span><span id="L-1197"><a href="#L-1197"><span class="linenos">1197</span></a>        <span class="k">for</span> <span class="n">terminal_node</span> <span class="ow">in</span> <span class="n">outs</span><span class="p">:</span>
</span><span id="L-1198"><a href="#L-1198"><span class="linenos">1198</span></a>            <span class="n">dfs</span><span class="p">(</span><span class="n">terminal_node</span><span class="p">,</span> <span class="n">visited_from_terminal</span><span class="p">)</span>
</span><span id="L-1199"><a href="#L-1199"><span class="linenos">1199</span></a>        <span class="n">unreachable_nodes</span> <span class="o">=</span> <span class="nb">set</span><span class="p">(</span><span class="n">graph</span><span class="o">.</span><span class="n">keys</span><span class="p">())</span> <span class="o">-</span> <span class="n">visited_from_terminal</span>
</span><span id="L-1200"><a href="#L-1200"><span class="linenos">1200</span></a>
</span><span id="L-1201"><a href="#L-1201"><span class="linenos">1201</span></a>        <span class="n">instructions_to_prune</span> <span class="o">=</span> <span class="p">[]</span>
</span><span id="L-1202"><a href="#L-1202"><span class="linenos">1202</span></a>        <span class="k">for</span> <span class="n">instruction</span> <span class="ow">in</span> <span class="n">instructions</span><span class="p">:</span>
</span><span id="L-1203"><a href="#L-1203"><span class="linenos">1203</span></a>            <span class="n">parent_nodes</span><span class="p">,</span> <span class="n">child_nodes</span> <span class="o">=</span> <span class="n">instruction</span><span class="o">.</span><span class="n">out_binders</span><span class="p">,</span> <span class="n">instruction</span><span class="o">.</span><span class="n">inputs</span>
</span><span id="L-1204"><a href="#L-1204"><span class="linenos">1204</span></a>            <span class="k">if</span> <span class="nb">any</span><span class="p">(</span><span class="n">node</span> <span class="ow">in</span> <span class="n">unreachable_nodes</span> <span class="k">for</span> <span class="n">node</span> <span class="ow">in</span> <span class="n">parent_nodes</span><span class="p">)</span> <span class="ow">or</span> <span class="nb">any</span><span class="p">(</span><span class="n">node</span> <span class="ow">in</span> <span class="n">unreachable_nodes</span> <span class="k">for</span> <span class="n">node</span> <span class="ow">in</span> <span class="n">child_nodes</span><span class="p">):</span>
</span><span id="L-1205"><a href="#L-1205"><span class="linenos">1205</span></a>                <span class="n">instructions_to_prune</span> <span class="o">+=</span> <span class="p">[</span><span class="n">instruction</span><span class="p">]</span>
</span><span id="L-1206"><a href="#L-1206"><span class="linenos">1206</span></a>        <span class="n">new_instructions</span> <span class="o">=</span> <span class="p">[</span><span class="n">inst</span> <span class="k">for</span> <span class="n">inst</span> <span class="ow">in</span> <span class="n">instructions</span> <span class="k">if</span> <span class="n">inst</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">instructions_to_prune</span><span class="p">]</span>
</span><span id="L-1207"><a href="#L-1207"><span class="linenos">1207</span></a>        <span class="k">if</span> <span class="n">backend</span><span class="o">.</span><span class="n">LOG_PROGRAM</span><span class="p">:</span>
</span><span id="L-1208"><a href="#L-1208"><span class="linenos">1208</span></a>            <span class="n">LI</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">instructions</span><span class="p">)</span>
</span><span id="L-1209"><a href="#L-1209"><span class="linenos">1209</span></a>            <span class="n">LNI</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">new_instructions</span><span class="p">)</span>
</span><span id="L-1210"><a href="#L-1210"><span class="linenos">1210</span></a>            <span class="n">DIFF</span> <span class="o">=</span> <span class="n">LI</span> <span class="o">-</span> <span class="n">LNI</span>
</span><span id="L-1211"><a href="#L-1211"><span class="linenos">1211</span></a>            <span class="n">UN</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">unreachable_nodes</span><span class="p">)</span>
</span><span id="L-1212"><a href="#L-1212"><span class="linenos">1212</span></a>            <span class="n">dblog</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;Before: </span><span class="si">{</span><span class="n">LI</span><span class="si">}</span><span class="se">\t</span><span class="s2">After: </span><span class="si">{</span><span class="n">LNI</span><span class="si">}</span><span class="se">\t</span><span class="s2">Diff vs Unreachables: </span><span class="si">{</span><span class="n">DIFF</span><span class="si">}</span><span class="s2"> == </span><span class="si">{</span><span class="n">UN</span><span class="si">}</span><span class="s2"> = </span><span class="si">{</span><span class="n">DIFF</span><span class="o">==</span><span class="n">UN</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">)</span>
</span><span id="L-1213"><a href="#L-1213"><span class="linenos">1213</span></a>        <span class="k">return</span> <span class="n">new_instructions</span>
</span><span id="L-1214"><a href="#L-1214"><span class="linenos">1214</span></a>
</span><span id="L-1215"><a href="#L-1215"><span class="linenos">1215</span></a>
</span><span id="L-1216"><a href="#L-1216"><span class="linenos">1216</span></a><span class="k">class</span> <span class="nc">ProgramType</span><span class="p">(</span><span class="n">NamedTuple</span><span class="p">):</span>
</span><span id="L-1217"><a href="#L-1217"><span class="linenos">1217</span></a>    <span class="n">in_types</span><span class="p">:</span> <span class="n">Tuple</span><span class="p">[</span><span class="n">SymbolicTensor</span><span class="p">]</span>
</span><span id="L-1218"><a href="#L-1218"><span class="linenos">1218</span></a>    <span class="n">out_types</span><span class="p">:</span> <span class="n">Tuple</span><span class="p">[</span><span class="n">SymbolicTensor</span><span class="p">]</span>
</span><span id="L-1219"><a href="#L-1219"><span class="linenos">1219</span></a>
</span><span id="L-1220"><a href="#L-1220"><span class="linenos">1220</span></a>    <span class="k">def</span> <span class="fm">__repr__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-1221"><a href="#L-1221"><span class="linenos">1221</span></a>        <span class="n">in_types</span> <span class="o">=</span> <span class="s2">&quot;, &quot;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">symval</span><span class="o">.</span><span class="n">str_short</span><span class="p">()</span> <span class="k">for</span> <span class="n">symval</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">in_types</span><span class="p">)</span>
</span><span id="L-1222"><a href="#L-1222"><span class="linenos">1222</span></a>        <span class="n">out_types</span> <span class="o">=</span> <span class="s2">&quot;, &quot;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">symval</span><span class="o">.</span><span class="n">str_short</span><span class="p">()</span> <span class="k">for</span> <span class="n">symval</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">out_types</span><span class="p">)</span>
</span><span id="L-1223"><a href="#L-1223"><span class="linenos">1223</span></a>        <span class="k">return</span> <span class="sa">f</span><span class="s2">&quot;(</span><span class="si">{</span><span class="n">in_types</span><span class="si">}</span><span class="s2">) -&gt; (</span><span class="si">{</span><span class="n">out_types</span><span class="si">}</span><span class="s2">)&quot;</span>
</span><span id="L-1224"><a href="#L-1224"><span class="linenos">1224</span></a>
</span><span id="L-1225"><a href="#L-1225"><span class="linenos">1225</span></a>
</span><span id="L-1226"><a href="#L-1226"><span class="linenos">1226</span></a><span class="c1"># =================================</span>
</span><span id="L-1227"><a href="#L-1227"><span class="linenos">1227</span></a><span class="c1">#   Tracer and Trace</span>
</span><span id="L-1228"><a href="#L-1228"><span class="linenos">1228</span></a><span class="c1"># =================================</span>
</span><span id="L-1229"><a href="#L-1229"><span class="linenos">1229</span></a>
</span><span id="L-1230"><a href="#L-1230"><span class="linenos">1230</span></a>
</span><span id="L-1231"><a href="#L-1231"><span class="linenos">1231</span></a><span class="k">class</span> <span class="nc">Empty</span><span class="p">:</span>
</span><span id="L-1232"><a href="#L-1232"><span class="linenos">1232</span></a>    <span class="k">pass</span>
</span><span id="L-1233"><a href="#L-1233"><span class="linenos">1233</span></a>
</span><span id="L-1234"><a href="#L-1234"><span class="linenos">1234</span></a>
</span><span id="L-1235"><a href="#L-1235"><span class="linenos">1235</span></a><span class="n">empty</span> <span class="o">=</span> <span class="n">Empty</span><span class="p">()</span>
</span><span id="L-1236"><a href="#L-1236"><span class="linenos">1236</span></a>
</span><span id="L-1237"><a href="#L-1237"><span class="linenos">1237</span></a>
</span><span id="L-1238"><a href="#L-1238"><span class="linenos">1238</span></a><span class="k">class</span> <span class="nc">Store</span><span class="p">:</span>
</span><span id="L-1239"><a href="#L-1239"><span class="linenos">1239</span></a>    <span class="n">val</span> <span class="o">=</span> <span class="n">empty</span>
</span><span id="L-1240"><a href="#L-1240"><span class="linenos">1240</span></a>
</span><span id="L-1241"><a href="#L-1241"><span class="linenos">1241</span></a>    <span class="k">def</span> <span class="nf">set_value</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">val</span><span class="p">):</span>
</span><span id="L-1242"><a href="#L-1242"><span class="linenos">1242</span></a>        <span class="k">assert</span> <span class="bp">self</span><span class="o">.</span><span class="n">val</span> <span class="ow">is</span> <span class="n">empty</span>
</span><span id="L-1243"><a href="#L-1243"><span class="linenos">1243</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">val</span> <span class="o">=</span> <span class="n">val</span>
</span><span id="L-1244"><a href="#L-1244"><span class="linenos">1244</span></a>
</span><span id="L-1245"><a href="#L-1245"><span class="linenos">1245</span></a>    <span class="k">def</span> <span class="fm">__call__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-1246"><a href="#L-1246"><span class="linenos">1246</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">val</span>
</span><span id="L-1247"><a href="#L-1247"><span class="linenos">1247</span></a>
</span><span id="L-1248"><a href="#L-1248"><span class="linenos">1248</span></a>
</span><span id="L-1249"><a href="#L-1249"><span class="linenos">1249</span></a><span class="k">class</span> <span class="nc">NodeType</span><span class="p">(</span><span class="n">NamedTuple</span><span class="p">):</span>
</span><span id="L-1250"><a href="#L-1250"><span class="linenos">1250</span></a>    <span class="n">name</span><span class="p">:</span> <span class="nb">str</span>
</span><span id="L-1251"><a href="#L-1251"><span class="linenos">1251</span></a>    <span class="n">flatten</span><span class="p">:</span> <span class="n">Callable</span>
</span><span id="L-1252"><a href="#L-1252"><span class="linenos">1252</span></a>    <span class="n">unflatten</span><span class="p">:</span> <span class="n">Callable</span>
</span><span id="L-1253"><a href="#L-1253"><span class="linenos">1253</span></a>
</span><span id="L-1254"><a href="#L-1254"><span class="linenos">1254</span></a>
</span><span id="L-1255"><a href="#L-1255"><span class="linenos">1255</span></a><span class="k">class</span> <span class="nc">TreeDef</span><span class="p">(</span><span class="n">NamedTuple</span><span class="p">):</span>
</span><span id="L-1256"><a href="#L-1256"><span class="linenos">1256</span></a>    <span class="n">node_type</span><span class="p">:</span> <span class="n">NodeType</span>
</span><span id="L-1257"><a href="#L-1257"><span class="linenos">1257</span></a>    <span class="n">node_metadata</span><span class="p">:</span> <span class="n">Hashable</span>
</span><span id="L-1258"><a href="#L-1258"><span class="linenos">1258</span></a>    <span class="n">child_treedefs</span><span class="p">:</span> <span class="n">Tuple</span><span class="p">[</span><span class="s2">&quot;TreeDef&quot;</span><span class="p">,</span> <span class="o">...</span><span class="p">]</span>
</span><span id="L-1259"><a href="#L-1259"><span class="linenos">1259</span></a>
</span><span id="L-1260"><a href="#L-1260"><span class="linenos">1260</span></a>    <span class="k">def</span> <span class="fm">__repr__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-1261"><a href="#L-1261"><span class="linenos">1261</span></a>        <span class="n">ret</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">tree_repr</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span>
</span><span id="L-1262"><a href="#L-1262"><span class="linenos">1262</span></a>        <span class="k">return</span> <span class="n">ret</span>
</span><span id="L-1263"><a href="#L-1263"><span class="linenos">1263</span></a>
</span><span id="L-1264"><a href="#L-1264"><span class="linenos">1264</span></a>    <span class="k">def</span> <span class="nf">tree_repr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">tree</span><span class="p">,</span> <span class="n">indent</span><span class="o">=</span><span class="s2">&quot;  &quot;</span><span class="p">,</span> <span class="n">prefix</span><span class="o">=</span><span class="s2">&quot;&quot;</span><span class="p">,</span> <span class="n">last</span><span class="o">=</span><span class="kc">True</span><span class="p">):</span>
</span><span id="L-1265"><a href="#L-1265"><span class="linenos">1265</span></a>        <span class="n">ret</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span>
</span><span id="L-1266"><a href="#L-1266"><span class="linenos">1266</span></a>
</span><span id="L-1267"><a href="#L-1267"><span class="linenos">1267</span></a>        <span class="k">def</span> <span class="nf">_tree_repr</span><span class="p">(</span><span class="n">tree</span><span class="p">,</span> <span class="n">indent</span><span class="p">,</span> <span class="n">prefix</span><span class="p">,</span> <span class="n">last</span><span class="p">):</span>
</span><span id="L-1268"><a href="#L-1268"><span class="linenos">1268</span></a>            <span class="k">nonlocal</span> <span class="n">ret</span>
</span><span id="L-1269"><a href="#L-1269"><span class="linenos">1269</span></a>            <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">tree</span><span class="p">,</span> <span class="n">TreeDef</span><span class="p">):</span>
</span><span id="L-1270"><a href="#L-1270"><span class="linenos">1270</span></a>                <span class="n">ret</span> <span class="o">+=</span> <span class="sa">f</span><span class="s1">&#39;</span><span class="si">{</span><span class="n">prefix</span><span class="si">}</span><span class="s1"> </span><span class="si">{</span><span class="p">(</span><span class="s2">&quot;└─&quot;</span><span class="w"> </span><span class="k">if</span><span class="w"> </span><span class="n">last</span><span class="w"> </span><span class="k">else</span><span class="w"> </span><span class="s2">&quot;├─&quot;</span><span class="p">)</span><span class="si">}</span><span class="s1"> </span><span class="si">{</span><span class="n">tree</span><span class="o">.</span><span class="n">node_type</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="se">\n</span><span class="s1">&#39;</span>
</span><span id="L-1271"><a href="#L-1271"><span class="linenos">1271</span></a>                <span class="k">for</span> <span class="n">i</span><span class="p">,</span> <span class="n">item</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">tree</span><span class="o">.</span><span class="n">child_treedefs</span><span class="p">):</span>
</span><span id="L-1272"><a href="#L-1272"><span class="linenos">1272</span></a>                    <span class="n">new_prefix</span> <span class="o">=</span> <span class="n">prefix</span> <span class="o">+</span> <span class="p">(</span><span class="n">indent</span> <span class="k">if</span> <span class="ow">not</span> <span class="n">last</span> <span class="k">else</span> <span class="s2">&quot;   &quot;</span><span class="p">)</span>
</span><span id="L-1273"><a href="#L-1273"><span class="linenos">1273</span></a>                    <span class="n">new_last</span> <span class="o">=</span> <span class="n">i</span> <span class="o">==</span> <span class="nb">len</span><span class="p">(</span><span class="n">tree</span><span class="o">.</span><span class="n">child_treedefs</span><span class="p">)</span> <span class="o">-</span> <span class="mi">1</span>
</span><span id="L-1274"><a href="#L-1274"><span class="linenos">1274</span></a>                    <span class="n">_tree_repr</span><span class="p">(</span><span class="n">item</span><span class="p">,</span> <span class="n">indent</span><span class="p">,</span> <span class="n">new_prefix</span><span class="p">,</span> <span class="n">new_last</span><span class="p">)</span>
</span><span id="L-1275"><a href="#L-1275"><span class="linenos">1275</span></a>            <span class="k">else</span><span class="p">:</span>
</span><span id="L-1276"><a href="#L-1276"><span class="linenos">1276</span></a>                <span class="n">ret</span> <span class="o">+=</span> <span class="sa">f</span><span class="s1">&#39;</span><span class="si">{</span><span class="n">prefix</span><span class="si">}</span><span class="s1"> </span><span class="si">{</span><span class="p">(</span><span class="s2">&quot;└─&quot;</span><span class="w"> </span><span class="k">if</span><span class="w"> </span><span class="n">last</span><span class="w"> </span><span class="k">else</span><span class="w"> </span><span class="s2">&quot;├─&quot;</span><span class="p">)</span><span class="si">}</span><span class="s1"> </span><span class="si">{</span><span class="n">tree</span><span class="si">}</span><span class="se">\n</span><span class="s1">&#39;</span>
</span><span id="L-1277"><a href="#L-1277"><span class="linenos">1277</span></a>
</span><span id="L-1278"><a href="#L-1278"><span class="linenos">1278</span></a>        <span class="n">_tree_repr</span><span class="p">(</span><span class="n">tree</span><span class="p">,</span> <span class="n">indent</span><span class="o">=</span><span class="s2">&quot;  &quot;</span><span class="p">,</span> <span class="n">prefix</span><span class="o">=</span><span class="s2">&quot;&quot;</span><span class="p">,</span> <span class="n">last</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
</span><span id="L-1279"><a href="#L-1279"><span class="linenos">1279</span></a>        <span class="k">return</span> <span class="n">ret</span>
</span><span id="L-1280"><a href="#L-1280"><span class="linenos">1280</span></a>
</span><span id="L-1281"><a href="#L-1281"><span class="linenos">1281</span></a>    <span class="nd">@property</span>
</span><span id="L-1282"><a href="#L-1282"><span class="linenos">1282</span></a>    <span class="k">def</span> <span class="nf">num_leaves</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-1283"><a href="#L-1283"><span class="linenos">1283</span></a>        <span class="k">def</span> <span class="nf">get_num_leaves</span><span class="p">(</span><span class="n">x</span><span class="p">):</span>
</span><span id="L-1284"><a href="#L-1284"><span class="linenos">1284</span></a>            <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">Leaf</span><span class="p">):</span>
</span><span id="L-1285"><a href="#L-1285"><span class="linenos">1285</span></a>                <span class="k">return</span> <span class="mi">1</span>
</span><span id="L-1286"><a href="#L-1286"><span class="linenos">1286</span></a>            <span class="k">else</span><span class="p">:</span>
</span><span id="L-1287"><a href="#L-1287"><span class="linenos">1287</span></a>                <span class="k">return</span> <span class="nb">sum</span><span class="p">(</span><span class="n">get_num_leaves</span><span class="p">(</span><span class="n">sub_x</span><span class="p">)</span> <span class="k">for</span> <span class="n">sub_x</span> <span class="ow">in</span> <span class="n">x</span><span class="o">.</span><span class="n">child_treedefs</span><span class="p">)</span>
</span><span id="L-1288"><a href="#L-1288"><span class="linenos">1288</span></a>
</span><span id="L-1289"><a href="#L-1289"><span class="linenos">1289</span></a>        <span class="k">return</span> <span class="nb">sum</span><span class="p">(</span><span class="n">get_num_leaves</span><span class="p">(</span><span class="n">x</span><span class="p">)</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">child_treedefs</span><span class="p">)</span>
</span><span id="L-1290"><a href="#L-1290"><span class="linenos">1290</span></a>
</span><span id="L-1291"><a href="#L-1291"><span class="linenos">1291</span></a>
</span><span id="L-1292"><a href="#L-1292"><span class="linenos">1292</span></a><span class="k">class</span> <span class="nc">Leaf</span><span class="p">:</span>
</span><span id="L-1293"><a href="#L-1293"><span class="linenos">1293</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">val</span><span class="p">):</span>
</span><span id="L-1294"><a href="#L-1294"><span class="linenos">1294</span></a>        <span class="k">if</span> <span class="nb">hasattr</span><span class="p">(</span><span class="n">val</span><span class="p">,</span> <span class="s2">&quot;shape&quot;</span><span class="p">):</span>
</span><span id="L-1295"><a href="#L-1295"><span class="linenos">1295</span></a>            <span class="n">val</span> <span class="o">=</span> <span class="n">SymbolicTensor</span><span class="o">.</span><span class="n">like</span><span class="p">(</span><span class="n">val</span><span class="p">)</span>
</span><span id="L-1296"><a href="#L-1296"><span class="linenos">1296</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">val</span> <span class="o">=</span> <span class="n">val</span>
</span><span id="L-1297"><a href="#L-1297"><span class="linenos">1297</span></a>
</span><span id="L-1298"><a href="#L-1298"><span class="linenos">1298</span></a>    <span class="k">def</span> <span class="fm">__repr__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-1299"><a href="#L-1299"><span class="linenos">1299</span></a>        <span class="n">ret</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">val</span><span class="o">.</span><span class="n">str_short</span><span class="p">()</span> <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">val</span><span class="p">,</span> <span class="n">SymbolicTensor</span><span class="p">)</span> <span class="k">else</span> <span class="nb">repr</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">val</span><span class="p">)</span>
</span><span id="L-1300"><a href="#L-1300"><span class="linenos">1300</span></a>        <span class="k">return</span> <span class="sa">f</span><span class="s2">&quot;&lt;Leaf: </span><span class="si">{</span><span class="n">ret</span><span class="si">}</span><span class="s2">&gt;&quot;</span>
</span><span id="L-1301"><a href="#L-1301"><span class="linenos">1301</span></a>
</span><span id="L-1302"><a href="#L-1302"><span class="linenos">1302</span></a>    <span class="k">def</span> <span class="fm">__hash__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-1303"><a href="#L-1303"><span class="linenos">1303</span></a>        <span class="k">return</span> <span class="nb">hash</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">val</span><span class="p">)</span>
</span><span id="L-1304"><a href="#L-1304"><span class="linenos">1304</span></a>
</span><span id="L-1305"><a href="#L-1305"><span class="linenos">1305</span></a>    <span class="k">def</span> <span class="fm">__eq__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">other</span><span class="p">):</span>
</span><span id="L-1306"><a href="#L-1306"><span class="linenos">1306</span></a>        <span class="k">return</span> <span class="kc">True</span>  <span class="c1"># make TreeDef __eq__ don&#39;t care Leaf</span>
</span><span id="L-1307"><a href="#L-1307"><span class="linenos">1307</span></a>        <span class="c1"># if isinstance(other, Leaf): # TODO: test above assumption</span>
</span><span id="L-1308"><a href="#L-1308"><span class="linenos">1308</span></a>        <span class="c1">#     return self.val == other.val</span>
</span><span id="L-1309"><a href="#L-1309"><span class="linenos">1309</span></a>
</span><span id="L-1310"><a href="#L-1310"><span class="linenos">1310</span></a>
</span><span id="L-1311"><a href="#L-1311"><span class="linenos">1311</span></a><span class="c1"># =================================</span>
</span><span id="L-1312"><a href="#L-1312"><span class="linenos">1312</span></a><span class="c1">#   jit operator</span>
</span><span id="L-1313"><a href="#L-1313"><span class="linenos">1313</span></a><span class="c1"># =================================</span>
</span><span id="L-1314"><a href="#L-1314"><span class="linenos">1314</span></a>
</span><span id="L-1315"><a href="#L-1315"><span class="linenos">1315</span></a>
</span><span id="L-1316"><a href="#L-1316"><span class="linenos">1316</span></a><span class="k">class</span> <span class="nc">JitOutput</span><span class="p">:</span>
</span><span id="L-1317"><a href="#L-1317"><span class="linenos">1317</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">program</span><span class="p">:</span> <span class="n">Program</span><span class="p">,</span> <span class="n">codegen_output</span><span class="p">:</span> <span class="n">CodegenOutput</span><span class="p">,</span> <span class="n">fn</span><span class="p">,</span> <span class="n">code</span><span class="p">:</span> <span class="nb">str</span><span class="p">,</span> <span class="n">consts</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">]):</span>
</span><span id="L-1318"><a href="#L-1318"><span class="linenos">1318</span></a>        <span class="nb">super</span><span class="p">()</span><span class="o">.</span><span class="fm">__init__</span><span class="p">()</span>
</span><span id="L-1319"><a href="#L-1319"><span class="linenos">1319</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">program</span> <span class="o">=</span> <span class="n">program</span>
</span><span id="L-1320"><a href="#L-1320"><span class="linenos">1320</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">code</span> <span class="o">=</span> <span class="n">code</span>
</span><span id="L-1321"><a href="#L-1321"><span class="linenos">1321</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">codegen_output</span> <span class="o">=</span> <span class="n">codegen_output</span>
</span><span id="L-1322"><a href="#L-1322"><span class="linenos">1322</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">fn</span><span class="p">:</span> <span class="n">Callable</span> <span class="o">=</span> <span class="n">fn</span>
</span><span id="L-1323"><a href="#L-1323"><span class="linenos">1323</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">consts</span> <span class="o">=</span> <span class="n">consts</span>
</span><span id="L-1324"><a href="#L-1324"><span class="linenos">1324</span></a>
</span><span id="L-1325"><a href="#L-1325"><span class="linenos">1325</span></a>    <span class="k">def</span> <span class="fm">__call__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="L-1326"><a href="#L-1326"><span class="linenos">1326</span></a>        <span class="n">args</span><span class="p">,</span> <span class="n">in_tree</span> <span class="o">=</span> <span class="n">tree_flatten</span><span class="p">(</span><span class="n">args</span><span class="p">)</span>
</span><span id="L-1327"><a href="#L-1327"><span class="linenos">1327</span></a>        <span class="n">args</span> <span class="o">=</span> <span class="n">tree_map</span><span class="p">(</span><span class="k">lambda</span> <span class="n">a</span><span class="p">:</span> <span class="n">a</span><span class="o">.</span><span class="n">val</span> <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">a</span><span class="p">,</span> <span class="n">Tensor</span><span class="p">)</span> <span class="k">else</span> <span class="n">a</span><span class="p">,</span> <span class="n">args</span><span class="p">)</span>
</span><span id="L-1328"><a href="#L-1328"><span class="linenos">1328</span></a>        <span class="k">try</span><span class="p">:</span>
</span><span id="L-1329"><a href="#L-1329"><span class="linenos">1329</span></a>            <span class="n">outs</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">fn</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)</span>
</span><span id="L-1330"><a href="#L-1330"><span class="linenos">1330</span></a>            <span class="k">if</span> <span class="ow">not</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">outs</span><span class="p">,</span> <span class="nb">tuple</span><span class="p">):</span>  <span class="c1"># TODO: IREE FunctionInvoker destructure 1-tuple, need to undo</span>
</span><span id="L-1331"><a href="#L-1331"><span class="linenos">1331</span></a>                <span class="n">outs</span> <span class="o">=</span> <span class="p">(</span><span class="n">outs</span><span class="p">,)</span>
</span><span id="L-1332"><a href="#L-1332"><span class="linenos">1332</span></a>        <span class="k">except</span> <span class="ne">Exception</span> <span class="k">as</span> <span class="n">e</span><span class="p">:</span>
</span><span id="L-1333"><a href="#L-1333"><span class="linenos">1333</span></a>            <span class="n">dblog</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">code</span><span class="p">,</span> <span class="n">enable</span><span class="o">=</span><span class="n">backend</span><span class="o">.</span><span class="n">LOG_JIT</span><span class="p">)</span>
</span><span id="L-1334"><a href="#L-1334"><span class="linenos">1334</span></a>            <span class="k">raise</span>
</span><span id="L-1335"><a href="#L-1335"><span class="linenos">1335</span></a>        <span class="k">return</span> <span class="p">[</span><span class="n">backend</span><span class="o">.</span><span class="n">tensor</span><span class="p">(</span><span class="n">TensorBuffer</span><span class="p">(</span><span class="n">o</span><span class="p">))</span> <span class="k">for</span> <span class="n">o</span> <span class="ow">in</span> <span class="n">outs</span><span class="p">]</span>
</span><span id="L-1336"><a href="#L-1336"><span class="linenos">1336</span></a>
</span><span id="L-1337"><a href="#L-1337"><span class="linenos">1337</span></a>
</span><span id="L-1338"><a href="#L-1338"><span class="linenos">1338</span></a><span class="k">class</span> <span class="nc">JitOp</span><span class="p">(</span><span class="n">MetaOperator</span><span class="p">):</span>
</span><span id="L-1339"><a href="#L-1339"><span class="linenos">1339</span></a>    <span class="k">def</span> <span class="nf">meta_impl</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="n">program</span><span class="p">:</span> <span class="n">Program</span><span class="p">,</span> <span class="o">**</span><span class="n">_</span><span class="p">):</span>
</span><span id="L-1340"><a href="#L-1340"><span class="linenos">1340</span></a>        <span class="n">hashed_program</span> <span class="o">=</span> <span class="n">Hashed</span><span class="p">(</span><span class="n">program</span><span class="p">)</span>
</span><span id="L-1341"><a href="#L-1341"><span class="linenos">1341</span></a>        <span class="n">num_consts</span> <span class="o">=</span> <span class="n">program</span><span class="o">.</span><span class="n">num_consts</span>
</span><span id="L-1342"><a href="#L-1342"><span class="linenos">1342</span></a>        <span class="n">consts</span><span class="p">,</span> <span class="n">args</span> <span class="o">=</span> <span class="n">args</span><span class="p">[:</span><span class="n">num_consts</span><span class="p">],</span> <span class="n">args</span><span class="p">[</span><span class="n">num_consts</span><span class="p">:]</span>
</span><span id="L-1343"><a href="#L-1343"><span class="linenos">1343</span></a>        <span class="n">hashed_consts</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="nb">map</span><span class="p">(</span><span class="n">Hashed</span><span class="p">,</span> <span class="n">consts</span><span class="p">))</span>
</span><span id="L-1344"><a href="#L-1344"><span class="linenos">1344</span></a>        <span class="n">jit_output</span> <span class="o">=</span> <span class="n">backend</span><span class="o">.</span><span class="n">jit_program</span><span class="p">(</span><span class="n">hashed_program</span><span class="p">,</span> <span class="n">hashed_consts</span><span class="p">)</span>
</span><span id="L-1345"><a href="#L-1345"><span class="linenos">1345</span></a>        <span class="n">ret</span> <span class="o">=</span> <span class="n">jit_output</span><span class="p">(</span><span class="o">*</span><span class="n">consts</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">)</span>
</span><span id="L-1346"><a href="#L-1346"><span class="linenos">1346</span></a>        <span class="k">return</span> <span class="n">ret</span>
</span><span id="L-1347"><a href="#L-1347"><span class="linenos">1347</span></a>
</span><span id="L-1348"><a href="#L-1348"><span class="linenos">1348</span></a>    <span class="k">def</span> <span class="nf">reorg_args</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">args</span><span class="p">,</span> <span class="n">params</span><span class="p">):</span>
</span><span id="L-1349"><a href="#L-1349"><span class="linenos">1349</span></a>        <span class="k">return</span> <span class="n">args</span><span class="p">,</span> <span class="n">params</span>
</span><span id="L-1350"><a href="#L-1350"><span class="linenos">1350</span></a>
</span><span id="L-1351"><a href="#L-1351"><span class="linenos">1351</span></a>    <span class="k">def</span> <span class="nf">typecheck</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="n">in_types</span><span class="p">,</span> <span class="n">program</span><span class="p">:</span> <span class="n">Program</span><span class="p">):</span>
</span><span id="L-1352"><a href="#L-1352"><span class="linenos">1352</span></a>        <span class="n">program_type</span> <span class="o">=</span> <span class="n">typecheck_program</span><span class="p">(</span><span class="n">program</span><span class="p">)</span>
</span><span id="L-1353"><a href="#L-1353"><span class="linenos">1353</span></a>        <span class="k">if</span> <span class="ow">not</span> <span class="nb">all</span><span class="p">(</span><span class="n">t1</span> <span class="o">==</span> <span class="n">t2</span> <span class="k">for</span> <span class="n">t1</span><span class="p">,</span> <span class="n">t2</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">program_type</span><span class="o">.</span><span class="n">in_types</span><span class="p">,</span> <span class="n">in_types</span><span class="p">)):</span>
</span><span id="L-1354"><a href="#L-1354"><span class="linenos">1354</span></a>            <span class="n">ret</span> <span class="o">=</span> <span class="s2">&quot;Type mismatch program.in_types vs in_types:</span><span class="se">\n</span><span class="s2">&quot;</span>
</span><span id="L-1355"><a href="#L-1355"><span class="linenos">1355</span></a>            <span class="k">for</span> <span class="n">i</span><span class="p">,</span> <span class="n">j</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">program_type</span><span class="o">.</span><span class="n">in_types</span><span class="p">,</span> <span class="n">in_types</span><span class="p">):</span>
</span><span id="L-1356"><a href="#L-1356"><span class="linenos">1356</span></a>                <span class="n">ret</span> <span class="o">+=</span> <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">i</span><span class="si">}</span><span class="s2">, </span><span class="si">{</span><span class="n">j</span><span class="si">}</span><span class="s2">, </span><span class="si">{</span><span class="n">i</span><span class="w"> </span><span class="o">==</span><span class="w"> </span><span class="n">j</span><span class="si">}</span><span class="s2">&quot;</span>
</span><span id="L-1357"><a href="#L-1357"><span class="linenos">1357</span></a>            <span class="k">raise</span> <span class="ne">TypeError</span><span class="p">(</span><span class="n">ret</span><span class="p">)</span>
</span><span id="L-1358"><a href="#L-1358"><span class="linenos">1358</span></a>        <span class="k">return</span> <span class="n">program_type</span><span class="o">.</span><span class="n">out_types</span>
</span><span id="L-1359"><a href="#L-1359"><span class="linenos">1359</span></a>
</span><span id="L-1360"><a href="#L-1360"><span class="linenos">1360</span></a>    <span class="k">def</span> <span class="nf">vmap</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">dim_size</span><span class="p">,</span> <span class="n">vals_in</span><span class="p">,</span> <span class="n">dims_in</span><span class="p">,</span> <span class="n">program</span><span class="p">:</span> <span class="n">Program</span><span class="p">):</span>
</span><span id="L-1361"><a href="#L-1361"><span class="linenos">1361</span></a>        <span class="n">program</span><span class="p">,</span> <span class="n">consts</span> <span class="o">=</span> <span class="n">vmap_program</span><span class="p">(</span><span class="n">program</span><span class="p">,</span> <span class="n">dim_size</span><span class="p">,</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">dims_in</span><span class="p">))</span>
</span><span id="L-1362"><a href="#L-1362"><span class="linenos">1362</span></a>        <span class="n">outs</span> <span class="o">=</span> <span class="bp">self</span><span class="p">(</span><span class="o">*</span><span class="n">consts</span><span class="p">,</span> <span class="o">*</span><span class="n">vals_in</span><span class="p">,</span> <span class="n">program</span><span class="o">=</span><span class="n">program</span><span class="p">)</span>
</span><span id="L-1363"><a href="#L-1363"><span class="linenos">1363</span></a>        <span class="k">if</span> <span class="ow">not</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">outs</span><span class="p">,</span> <span class="nb">tuple</span><span class="p">):</span>
</span><span id="L-1364"><a href="#L-1364"><span class="linenos">1364</span></a>            <span class="n">outs</span> <span class="o">=</span> <span class="p">(</span><span class="n">outs</span><span class="p">,)</span>
</span><span id="L-1365"><a href="#L-1365"><span class="linenos">1365</span></a>        <span class="k">return</span> <span class="n">outs</span><span class="p">,</span> <span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="o">*</span> <span class="nb">len</span><span class="p">(</span><span class="n">outs</span><span class="p">)</span>
</span><span id="L-1366"><a href="#L-1366"><span class="linenos">1366</span></a>
</span><span id="L-1367"><a href="#L-1367"><span class="linenos">1367</span></a>    <span class="k">def</span> <span class="nf">jvp</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">primals</span><span class="p">,</span> <span class="n">tangents</span><span class="p">,</span> <span class="o">*</span><span class="p">,</span> <span class="n">program</span><span class="p">):</span>
</span><span id="L-1368"><a href="#L-1368"><span class="linenos">1368</span></a>        <span class="n">new_program</span><span class="p">,</span> <span class="n">new_consts</span> <span class="o">=</span> <span class="n">jvp_program</span><span class="p">(</span><span class="n">program</span><span class="p">)</span>
</span><span id="L-1369"><a href="#L-1369"><span class="linenos">1369</span></a>        <span class="n">outs</span> <span class="o">=</span> <span class="n">bind</span><span class="p">(</span>
</span><span id="L-1370"><a href="#L-1370"><span class="linenos">1370</span></a>            <span class="bp">self</span><span class="p">,</span>
</span><span id="L-1371"><a href="#L-1371"><span class="linenos">1371</span></a>            <span class="o">*</span><span class="n">new_consts</span><span class="p">,</span>
</span><span id="L-1372"><a href="#L-1372"><span class="linenos">1372</span></a>            <span class="o">*</span><span class="n">primals</span><span class="p">,</span>
</span><span id="L-1373"><a href="#L-1373"><span class="linenos">1373</span></a>            <span class="o">*</span><span class="n">tangents</span><span class="p">,</span>
</span><span id="L-1374"><a href="#L-1374"><span class="linenos">1374</span></a>            <span class="n">program</span><span class="o">=</span><span class="n">new_program</span><span class="p">,</span>
</span><span id="L-1375"><a href="#L-1375"><span class="linenos">1375</span></a>        <span class="p">)</span>
</span><span id="L-1376"><a href="#L-1376"><span class="linenos">1376</span></a>        <span class="n">n</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">outs</span><span class="p">)</span> <span class="o">//</span> <span class="mi">2</span>
</span><span id="L-1377"><a href="#L-1377"><span class="linenos">1377</span></a>        <span class="n">primals_out</span><span class="p">,</span> <span class="n">tangents_out</span> <span class="o">=</span> <span class="n">outs</span><span class="p">[:</span><span class="n">n</span><span class="p">],</span> <span class="n">outs</span><span class="p">[</span><span class="n">n</span><span class="p">:]</span>
</span><span id="L-1378"><a href="#L-1378"><span class="linenos">1378</span></a>        <span class="k">return</span> <span class="n">primals_out</span><span class="p">,</span> <span class="n">tangents_out</span>
</span><span id="L-1379"><a href="#L-1379"><span class="linenos">1379</span></a>
</span><span id="L-1380"><a href="#L-1380"><span class="linenos">1380</span></a>    <span class="k">def</span> <span class="nf">T</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">cotangents</span><span class="p">,</span> <span class="o">*</span><span class="n">invals</span><span class="p">,</span> <span class="n">program</span><span class="p">):</span>
</span><span id="L-1381"><a href="#L-1381"><span class="linenos">1381</span></a>        <span class="n">undef_primals</span> <span class="o">=</span> <span class="p">[</span><span class="nb">isinstance</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">UndefinedPrimal</span><span class="p">)</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">invals</span><span class="p">]</span>
</span><span id="L-1382"><a href="#L-1382"><span class="linenos">1382</span></a>        <span class="n">transposed_program</span><span class="p">,</span> <span class="n">new_consts</span> <span class="o">=</span> <span class="n">transpose_program</span><span class="p">(</span><span class="n">program</span><span class="p">,</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">undef_primals</span><span class="p">))</span>
</span><span id="L-1383"><a href="#L-1383"><span class="linenos">1383</span></a>
</span><span id="L-1384"><a href="#L-1384"><span class="linenos">1384</span></a>        <span class="n">residuals</span><span class="p">,</span> <span class="n">_</span> <span class="o">=</span> <span class="n">partition_list</span><span class="p">(</span><span class="n">undef_primals</span><span class="p">,</span> <span class="n">invals</span><span class="p">)</span>
</span><span id="L-1385"><a href="#L-1385"><span class="linenos">1385</span></a>        <span class="n">outs</span> <span class="o">=</span> <span class="n">bind</span><span class="p">(</span>
</span><span id="L-1386"><a href="#L-1386"><span class="linenos">1386</span></a>            <span class="bp">self</span><span class="p">,</span>
</span><span id="L-1387"><a href="#L-1387"><span class="linenos">1387</span></a>            <span class="o">*</span><span class="n">new_consts</span><span class="p">,</span>
</span><span id="L-1388"><a href="#L-1388"><span class="linenos">1388</span></a>            <span class="o">*</span><span class="n">residuals</span><span class="p">,</span>
</span><span id="L-1389"><a href="#L-1389"><span class="linenos">1389</span></a>            <span class="o">*</span><span class="n">cotangents</span><span class="p">,</span>
</span><span id="L-1390"><a href="#L-1390"><span class="linenos">1390</span></a>            <span class="n">program</span><span class="o">=</span><span class="n">transposed_program</span><span class="p">,</span>
</span><span id="L-1391"><a href="#L-1391"><span class="linenos">1391</span></a>        <span class="p">)</span>
</span><span id="L-1392"><a href="#L-1392"><span class="linenos">1392</span></a>        <span class="n">outs</span> <span class="o">=</span> <span class="nb">iter</span><span class="p">(</span><span class="n">outs</span><span class="p">)</span>
</span><span id="L-1393"><a href="#L-1393"><span class="linenos">1393</span></a>
</span><span id="L-1394"><a href="#L-1394"><span class="linenos">1394</span></a>        <span class="k">return</span> <span class="p">[</span><span class="nb">next</span><span class="p">(</span><span class="n">outs</span><span class="p">)</span> <span class="k">if</span> <span class="n">undef</span> <span class="k">else</span> <span class="kc">None</span> <span class="k">for</span> <span class="n">undef</span> <span class="ow">in</span> <span class="n">undef_primals</span><span class="p">]</span>
</span><span id="L-1395"><a href="#L-1395"><span class="linenos">1395</span></a>
</span><span id="L-1396"><a href="#L-1396"><span class="linenos">1396</span></a>    <span class="k">def</span> <span class="nf">partial_run</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">trace</span><span class="p">,</span> <span class="n">tracers</span><span class="p">,</span> <span class="o">*</span><span class="p">,</span> <span class="n">program</span><span class="p">):</span>
</span><span id="L-1397"><a href="#L-1397"><span class="linenos">1397</span></a>        <span class="n">in_unknowns</span> <span class="o">=</span> <span class="p">[</span><span class="ow">not</span> <span class="n">t</span><span class="o">.</span><span class="n">pval</span><span class="o">.</span><span class="n">is_known</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">tracers</span><span class="p">]</span>
</span><span id="L-1398"><a href="#L-1398"><span class="linenos">1398</span></a>        <span class="n">program1</span><span class="p">,</span> <span class="n">program2</span><span class="p">,</span> <span class="n">out_unknowns</span><span class="p">,</span> <span class="n">num_res</span> <span class="o">=</span> <span class="n">partial_run_program</span><span class="p">(</span><span class="n">program</span><span class="p">,</span> <span class="n">in_unknowns</span><span class="p">)</span>
</span><span id="L-1399"><a href="#L-1399"><span class="linenos">1399</span></a>        <span class="n">known_tracers</span><span class="p">,</span> <span class="n">unknown_tracers</span> <span class="o">=</span> <span class="n">partition_list</span><span class="p">(</span><span class="n">in_unknowns</span><span class="p">,</span> <span class="n">tracers</span><span class="p">)</span>
</span><span id="L-1400"><a href="#L-1400"><span class="linenos">1400</span></a>        <span class="n">known_vals</span> <span class="o">=</span> <span class="p">[</span><span class="n">t</span><span class="o">.</span><span class="n">pval</span><span class="o">.</span><span class="n">const</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">known_tracers</span><span class="p">]</span>
</span><span id="L-1401"><a href="#L-1401"><span class="linenos">1401</span></a>        <span class="n">outs1_res</span> <span class="o">=</span> <span class="n">bind</span><span class="p">(</span><span class="n">backend</span><span class="o">.</span><span class="n">jit_op</span><span class="p">,</span> <span class="o">*</span><span class="n">known_vals</span><span class="p">,</span> <span class="n">program</span><span class="o">=</span><span class="n">program1</span><span class="p">)</span>
</span><span id="L-1402"><a href="#L-1402"><span class="linenos">1402</span></a>        <span class="n">outs1</span><span class="p">,</span> <span class="n">res</span> <span class="o">=</span> <span class="n">split_list</span><span class="p">(</span><span class="n">outs1_res</span><span class="p">,</span> <span class="nb">len</span><span class="p">(</span><span class="n">program1</span><span class="o">.</span><span class="n">outs</span><span class="p">)</span> <span class="o">-</span> <span class="n">num_res</span><span class="p">)</span>
</span><span id="L-1403"><a href="#L-1403"><span class="linenos">1403</span></a>        <span class="n">res_tracers</span> <span class="o">=</span> <span class="p">[</span><span class="n">trace</span><span class="o">.</span><span class="n">instantiate_const</span><span class="p">(</span><span class="n">full_raise</span><span class="p">(</span><span class="n">trace</span><span class="p">,</span> <span class="n">x</span><span class="p">))</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">res</span><span class="p">]</span>
</span><span id="L-1404"><a href="#L-1404"><span class="linenos">1404</span></a>        <span class="n">outs2</span> <span class="o">=</span> <span class="p">[</span><span class="n">PartialRunTraceTensor</span><span class="p">(</span><span class="n">trace</span><span class="p">,</span> <span class="n">make_unknown_pval</span><span class="p">(</span><span class="n">v</span><span class="o">.</span><span class="n">symval</span><span class="p">),</span> <span class="kc">None</span><span class="p">)</span> <span class="k">for</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">program2</span><span class="o">.</span><span class="n">outs</span><span class="p">]</span>
</span><span id="L-1405"><a href="#L-1405"><span class="linenos">1405</span></a>        <span class="n">instruction</span> <span class="o">=</span> <span class="n">InstructionDraft</span><span class="p">(</span>
</span><span id="L-1406"><a href="#L-1406"><span class="linenos">1406</span></a>            <span class="bp">self</span><span class="p">,</span>
</span><span id="L-1407"><a href="#L-1407"><span class="linenos">1407</span></a>            <span class="n">res_tracers</span> <span class="o">+</span> <span class="n">unknown_tracers</span><span class="p">,</span>
</span><span id="L-1408"><a href="#L-1408"><span class="linenos">1408</span></a>            <span class="nb">dict</span><span class="p">(</span><span class="n">program</span><span class="o">=</span><span class="n">program2</span><span class="p">),</span>
</span><span id="L-1409"><a href="#L-1409"><span class="linenos">1409</span></a>            <span class="p">[</span><span class="n">v</span><span class="o">.</span><span class="n">symval</span> <span class="k">for</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">program2</span><span class="o">.</span><span class="n">outs</span><span class="p">],</span>
</span><span id="L-1410"><a href="#L-1410"><span class="linenos">1410</span></a>            <span class="n">list_map</span><span class="p">(</span><span class="n">weakref</span><span class="o">.</span><span class="n">ref</span><span class="p">,</span> <span class="n">outs2</span><span class="p">),</span>
</span><span id="L-1411"><a href="#L-1411"><span class="linenos">1411</span></a>        <span class="p">)</span>
</span><span id="L-1412"><a href="#L-1412"><span class="linenos">1412</span></a>        <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">outs2</span><span class="p">:</span>
</span><span id="L-1413"><a href="#L-1413"><span class="linenos">1413</span></a>            <span class="n">t</span><span class="o">.</span><span class="n">draft</span> <span class="o">=</span> <span class="n">instruction</span>
</span><span id="L-1414"><a href="#L-1414"><span class="linenos">1414</span></a>
</span><span id="L-1415"><a href="#L-1415"><span class="linenos">1415</span></a>        <span class="k">return</span> <span class="n">merge_lists</span><span class="p">(</span><span class="n">out_unknowns</span><span class="p">,</span> <span class="n">outs1</span><span class="p">,</span> <span class="n">outs2</span><span class="p">)</span>
</span><span id="L-1416"><a href="#L-1416"><span class="linenos">1416</span></a>
</span><span id="L-1417"><a href="#L-1417"><span class="linenos">1417</span></a>    <span class="k">def</span> <span class="nf">partial_run_instruction</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">unks_in</span><span class="p">,</span> <span class="n">instruction</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Tuple</span><span class="p">[</span><span class="n">Instruction</span><span class="p">,</span> <span class="n">Instruction</span><span class="p">,</span> <span class="n">List</span><span class="p">[</span><span class="nb">bool</span><span class="p">],</span> <span class="n">List</span><span class="p">[</span><span class="n">Var</span><span class="p">]]:</span>
</span><span id="L-1418"><a href="#L-1418"><span class="linenos">1418</span></a>        <span class="n">program</span> <span class="o">=</span> <span class="n">instruction</span><span class="o">.</span><span class="n">params</span><span class="p">[</span><span class="s2">&quot;program&quot;</span><span class="p">]</span>
</span><span id="L-1419"><a href="#L-1419"><span class="linenos">1419</span></a>        <span class="n">program1</span><span class="p">,</span> <span class="n">program2</span><span class="p">,</span> <span class="n">out_unknowns</span><span class="p">,</span> <span class="n">num_res</span> <span class="o">=</span> <span class="n">partial_run_program</span><span class="p">(</span><span class="n">program</span><span class="p">,</span> <span class="n">unks_in</span><span class="p">)</span>
</span><span id="L-1420"><a href="#L-1420"><span class="linenos">1420</span></a>        <span class="n">ins1</span><span class="p">,</span> <span class="n">ins2</span> <span class="o">=</span> <span class="n">partition_list</span><span class="p">(</span><span class="n">unks_in</span><span class="p">,</span> <span class="n">instruction</span><span class="o">.</span><span class="n">inputs</span><span class="p">)</span>
</span><span id="L-1421"><a href="#L-1421"><span class="linenos">1421</span></a>        <span class="n">out_binders1</span><span class="p">,</span> <span class="n">out_binders2</span> <span class="o">=</span> <span class="n">partition_list</span><span class="p">(</span><span class="n">out_unknowns</span><span class="p">,</span> <span class="n">instruction</span><span class="o">.</span><span class="n">out_binders</span><span class="p">)</span>
</span><span id="L-1422"><a href="#L-1422"><span class="linenos">1422</span></a>        <span class="n">res</span> <span class="o">=</span> <span class="p">[</span><span class="n">Var</span><span class="p">(</span><span class="n">v</span><span class="o">.</span><span class="n">symval</span><span class="p">)</span> <span class="k">for</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">program2</span><span class="o">.</span><span class="n">in_binders</span><span class="p">[:</span><span class="n">num_res</span><span class="p">]]</span>
</span><span id="L-1423"><a href="#L-1423"><span class="linenos">1423</span></a>        <span class="n">instruction1</span> <span class="o">=</span> <span class="n">Instruction</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">ins1</span><span class="p">,</span> <span class="nb">dict</span><span class="p">(</span><span class="n">program</span><span class="o">=</span><span class="n">program1</span><span class="p">),</span> <span class="n">out_binders1</span> <span class="o">+</span> <span class="n">res</span><span class="p">)</span>
</span><span id="L-1424"><a href="#L-1424"><span class="linenos">1424</span></a>        <span class="n">instruction2</span> <span class="o">=</span> <span class="n">Instruction</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">res</span> <span class="o">+</span> <span class="n">ins2</span><span class="p">,</span> <span class="nb">dict</span><span class="p">(</span><span class="n">program</span><span class="o">=</span><span class="n">program2</span><span class="p">),</span> <span class="n">out_binders2</span><span class="p">)</span>
</span><span id="L-1425"><a href="#L-1425"><span class="linenos">1425</span></a>        <span class="k">return</span> <span class="n">instruction1</span><span class="p">,</span> <span class="n">instruction2</span><span class="p">,</span> <span class="n">out_unknowns</span><span class="p">,</span> <span class="n">res</span>
</span><span id="L-1426"><a href="#L-1426"><span class="linenos">1426</span></a>
</span><span id="L-1427"><a href="#L-1427"><span class="linenos">1427</span></a>
</span><span id="L-1428"><a href="#L-1428"><span class="linenos">1428</span></a><span class="c1"># =================================</span>
</span><span id="L-1429"><a href="#L-1429"><span class="linenos">1429</span></a><span class="c1">#   Compiler</span>
</span><span id="L-1430"><a href="#L-1430"><span class="linenos">1430</span></a><span class="c1"># =================================</span>
</span><span id="L-1431"><a href="#L-1431"><span class="linenos">1431</span></a>
</span><span id="L-1432"><a href="#L-1432"><span class="linenos">1432</span></a>
</span><span id="L-1433"><a href="#L-1433"><span class="linenos">1433</span></a><span class="k">class</span> <span class="nc">MainTrace</span><span class="p">(</span><span class="n">NamedTuple</span><span class="p">):</span>
</span><span id="L-1434"><a href="#L-1434"><span class="linenos">1434</span></a>    <span class="n">level</span><span class="p">:</span> <span class="nb">int</span>
</span><span id="L-1435"><a href="#L-1435"><span class="linenos">1435</span></a>    <span class="n">trace_type</span><span class="p">:</span> <span class="n">Type</span><span class="p">[</span><span class="s2">&quot;Trace&quot;</span><span class="p">]</span>
</span><span id="L-1436"><a href="#L-1436"><span class="linenos">1436</span></a>    <span class="n">global_data</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="n">Any</span><span class="p">]</span>
</span><span id="L-1437"><a href="#L-1437"><span class="linenos">1437</span></a>
</span><span id="L-1438"><a href="#L-1438"><span class="linenos">1438</span></a>
</span><span id="L-1439"><a href="#L-1439"><span class="linenos">1439</span></a><span class="k">class</span> <span class="nc">Trace</span><span class="p">:</span>
</span><span id="L-1440"><a href="#L-1440"><span class="linenos">1440</span></a>    <span class="n">main</span><span class="p">:</span> <span class="n">MainTrace</span>
</span><span id="L-1441"><a href="#L-1441"><span class="linenos">1441</span></a>
</span><span id="L-1442"><a href="#L-1442"><span class="linenos">1442</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">main</span><span class="p">:</span> <span class="n">MainTrace</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="kc">None</span><span class="p">:</span>
</span><span id="L-1443"><a href="#L-1443"><span class="linenos">1443</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">main</span> <span class="o">=</span> <span class="n">main</span>
</span><span id="L-1444"><a href="#L-1444"><span class="linenos">1444</span></a>
</span><span id="L-1445"><a href="#L-1445"><span class="linenos">1445</span></a>    <span class="k">def</span> <span class="nf">pure</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">val</span><span class="p">):</span>
</span><span id="L-1446"><a href="#L-1446"><span class="linenos">1446</span></a>        <span class="k">raise</span> <span class="ne">NotImplementedError</span>
</span><span id="L-1447"><a href="#L-1447"><span class="linenos">1447</span></a>
</span><span id="L-1448"><a href="#L-1448"><span class="linenos">1448</span></a>    <span class="k">def</span> <span class="nf">run_op</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">op</span><span class="p">,</span> <span class="n">tracers</span><span class="p">,</span> <span class="n">params</span><span class="p">):</span>
</span><span id="L-1449"><a href="#L-1449"><span class="linenos">1449</span></a>        <span class="k">raise</span> <span class="ne">NotImplementedError</span>
</span><span id="L-1450"><a href="#L-1450"><span class="linenos">1450</span></a>
</span><span id="L-1451"><a href="#L-1451"><span class="linenos">1451</span></a>
</span><span id="L-1452"><a href="#L-1452"><span class="linenos">1452</span></a><span class="k">class</span> <span class="nc">RunTrace</span><span class="p">(</span><span class="n">Trace</span><span class="p">):</span>
</span><span id="L-1453"><a href="#L-1453"><span class="linenos">1453</span></a>    <span class="n">pure</span> <span class="o">=</span> <span class="k">lambda</span> <span class="bp">self</span><span class="p">,</span> <span class="n">x</span><span class="p">:</span> <span class="n">x</span>
</span><span id="L-1454"><a href="#L-1454"><span class="linenos">1454</span></a>
</span><span id="L-1455"><a href="#L-1455"><span class="linenos">1455</span></a>    <span class="k">def</span> <span class="nf">run_op</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">op</span><span class="p">:</span> <span class="n">Operator</span><span class="p">,</span> <span class="n">args</span><span class="p">,</span> <span class="n">params</span><span class="p">):</span>
</span><span id="L-1456"><a href="#L-1456"><span class="linenos">1456</span></a>        <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">op</span><span class="p">,</span> <span class="n">MetaOperator</span><span class="p">):</span>
</span><span id="L-1457"><a href="#L-1457"><span class="linenos">1457</span></a>            <span class="n">args</span><span class="p">,</span> <span class="n">params</span> <span class="o">=</span> <span class="n">op</span><span class="o">.</span><span class="n">reorg_args</span><span class="p">(</span><span class="n">args</span><span class="p">,</span> <span class="n">params</span><span class="p">)</span>
</span><span id="L-1458"><a href="#L-1458"><span class="linenos">1458</span></a>            <span class="n">args</span><span class="p">,</span> <span class="n">params</span> <span class="o">=</span> <span class="n">op</span><span class="o">.</span><span class="n">args_fixer</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)</span>
</span><span id="L-1459"><a href="#L-1459"><span class="linenos">1459</span></a>            <span class="n">ret</span> <span class="o">=</span> <span class="n">op</span><span class="o">.</span><span class="n">meta_impl</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)</span>
</span><span id="L-1460"><a href="#L-1460"><span class="linenos">1460</span></a>        <span class="k">else</span><span class="p">:</span>
</span><span id="L-1461"><a href="#L-1461"><span class="linenos">1461</span></a>            <span class="n">fn</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">get_fn</span><span class="p">(</span><span class="n">op</span><span class="p">,</span> <span class="o">*</span><span class="nb">tuple</span><span class="p">(</span><span class="n">SymbolicTensor</span><span class="o">.</span><span class="n">like</span><span class="p">(</span><span class="n">a</span><span class="p">)</span> <span class="k">for</span> <span class="n">a</span> <span class="ow">in</span> <span class="n">args</span><span class="p">),</span> <span class="o">**</span><span class="n">params</span><span class="p">)</span>
</span><span id="L-1462"><a href="#L-1462"><span class="linenos">1462</span></a>            <span class="c1"># with Timing(f&quot;RUN {op}&quot;):ret = jit(</span>
</span><span id="L-1463"><a href="#L-1463"><span class="linenos">1463</span></a>            <span class="n">ret</span> <span class="o">=</span> <span class="n">jit</span><span class="p">(</span>
</span><span id="L-1464"><a href="#L-1464"><span class="linenos">1464</span></a>                <span class="n">fn</span><span class="p">,</span>
</span><span id="L-1465"><a href="#L-1465"><span class="linenos">1465</span></a>                <span class="n">static_argnames</span><span class="o">=</span><span class="p">(</span><span class="s2">&quot;params&quot;</span><span class="p">,),</span>
</span><span id="L-1466"><a href="#L-1466"><span class="linenos">1466</span></a>                <span class="n">name</span><span class="o">=</span><span class="n">jit</span><span class="o">.</span><span class="n">get_jit_name</span><span class="p">(</span><span class="n">args</span><span class="p">,</span> <span class="n">params</span><span class="p">,</span> <span class="n">op</span><span class="o">.</span><span class="n">name</span><span class="p">),</span>
</span><span id="L-1467"><a href="#L-1467"><span class="linenos">1467</span></a>            <span class="p">)(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)</span>
</span><span id="L-1468"><a href="#L-1468"><span class="linenos">1468</span></a>
</span><span id="L-1469"><a href="#L-1469"><span class="linenos">1469</span></a>        <span class="k">return</span> <span class="n">ret</span>
</span><span id="L-1470"><a href="#L-1470"><span class="linenos">1470</span></a>
</span><span id="L-1471"><a href="#L-1471"><span class="linenos">1471</span></a>    <span class="nd">@staticmethod</span>
</span><span id="L-1472"><a href="#L-1472"><span class="linenos">1472</span></a>    <span class="nd">@lru_cache_verbose</span><span class="p">()</span>
</span><span id="L-1473"><a href="#L-1473"><span class="linenos">1473</span></a>    <span class="k">def</span> <span class="nf">get_fn</span><span class="p">(</span><span class="n">op</span><span class="p">,</span> <span class="o">*</span><span class="n">symval_args</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="L-1474"><a href="#L-1474"><span class="linenos">1474</span></a>        <span class="k">def</span> <span class="nf">fn</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="L-1475"><a href="#L-1475"><span class="linenos">1475</span></a>            <span class="k">return</span> <span class="p">[</span><span class="n">op</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)]</span>
</span><span id="L-1476"><a href="#L-1476"><span class="linenos">1476</span></a>
</span><span id="L-1477"><a href="#L-1477"><span class="linenos">1477</span></a>        <span class="k">return</span> <span class="n">fn</span>
</span><span id="L-1478"><a href="#L-1478"><span class="linenos">1478</span></a>
</span><span id="L-1479"><a href="#L-1479"><span class="linenos">1479</span></a>
</span><span id="L-1480"><a href="#L-1480"><span class="linenos">1480</span></a><span class="k">class</span> <span class="nc">SymbolicRunTrace</span><span class="p">(</span><span class="n">Trace</span><span class="p">):</span>
</span><span id="L-1481"><a href="#L-1481"><span class="linenos">1481</span></a>    <span class="c1"># pure = lambda self, x: x</span>
</span><span id="L-1482"><a href="#L-1482"><span class="linenos">1482</span></a>    <span class="k">def</span> <span class="nf">pure</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">val</span><span class="p">:</span> <span class="n">Any</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">SymbolicTensor</span><span class="p">:</span>
</span><span id="L-1483"><a href="#L-1483"><span class="linenos">1483</span></a>        <span class="k">return</span> <span class="n">val</span><span class="o">.</span><span class="n">symval</span>
</span><span id="L-1484"><a href="#L-1484"><span class="linenos">1484</span></a>
</span><span id="L-1485"><a href="#L-1485"><span class="linenos">1485</span></a>    <span class="k">def</span> <span class="nf">run_op</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">op</span><span class="p">,</span> <span class="n">tracers</span><span class="p">,</span> <span class="n">params</span><span class="p">):</span>
</span><span id="L-1486"><a href="#L-1486"><span class="linenos">1486</span></a>        <span class="n">symvals_in</span> <span class="o">=</span> <span class="n">tree_map</span><span class="p">(</span><span class="k">lambda</span> <span class="n">x</span><span class="p">:</span> <span class="n">x</span><span class="o">.</span><span class="n">symval</span><span class="p">,</span> <span class="n">tracers</span><span class="p">)</span>
</span><span id="L-1487"><a href="#L-1487"><span class="linenos">1487</span></a>        <span class="n">symvals_out</span> <span class="o">=</span> <span class="n">op</span><span class="o">.</span><span class="n">typecheck</span><span class="p">(</span><span class="o">*</span><span class="n">symvals_in</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)</span>
</span><span id="L-1488"><a href="#L-1488"><span class="linenos">1488</span></a>        <span class="k">return</span> <span class="n">symvals_out</span>
</span><span id="L-1489"><a href="#L-1489"><span class="linenos">1489</span></a>
</span><span id="L-1490"><a href="#L-1490"><span class="linenos">1490</span></a>
</span><span id="L-1491"><a href="#L-1491"><span class="linenos">1491</span></a><span class="k">class</span> <span class="nc">TraceTensor</span><span class="p">(</span><span class="n">Tensor</span><span class="p">):</span>
</span><span id="L-1492"><a href="#L-1492"><span class="linenos">1492</span></a>    <span class="n">PYTHON_TYPES</span> <span class="o">=</span> <span class="p">{</span>
</span><span id="L-1493"><a href="#L-1493"><span class="linenos">1493</span></a>        <span class="nb">bool</span><span class="p">,</span>
</span><span id="L-1494"><a href="#L-1494"><span class="linenos">1494</span></a>        <span class="nb">int</span><span class="p">,</span>
</span><span id="L-1495"><a href="#L-1495"><span class="linenos">1495</span></a>        <span class="nb">float</span><span class="p">,</span>
</span><span id="L-1496"><a href="#L-1496"><span class="linenos">1496</span></a>    <span class="p">}</span>
</span><span id="L-1497"><a href="#L-1497"><span class="linenos">1497</span></a>    <span class="n">_trace</span><span class="p">:</span> <span class="s2">&quot;Trace&quot;</span>
</span><span id="L-1498"><a href="#L-1498"><span class="linenos">1498</span></a>
</span><span id="L-1499"><a href="#L-1499"><span class="linenos">1499</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">):</span>
</span><span id="L-1500"><a href="#L-1500"><span class="linenos">1500</span></a>        <span class="k">raise</span> <span class="ne">NotImplementedError</span>
</span><span id="L-1501"><a href="#L-1501"><span class="linenos">1501</span></a>
</span><span id="L-1502"><a href="#L-1502"><span class="linenos">1502</span></a>    <span class="n">symval</span> <span class="o">=</span> <span class="nb">property</span><span class="p">(</span><span class="k">lambda</span> <span class="bp">self</span><span class="p">:</span> <span class="n">get_symval</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">val</span><span class="p">))</span>
</span><span id="L-1503"><a href="#L-1503"><span class="linenos">1503</span></a>    <span class="n">dtype</span> <span class="o">=</span> <span class="nb">property</span><span class="p">(</span><span class="k">lambda</span> <span class="bp">self</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">symval</span><span class="o">.</span><span class="n">dtype</span><span class="p">)</span>
</span><span id="L-1504"><a href="#L-1504"><span class="linenos">1504</span></a>    <span class="n">shape</span> <span class="o">=</span> <span class="nb">property</span><span class="p">(</span><span class="k">lambda</span> <span class="bp">self</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">symval</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span>
</span><span id="L-1505"><a href="#L-1505"><span class="linenos">1505</span></a>    <span class="n">device</span> <span class="o">=</span> <span class="nb">property</span><span class="p">(</span><span class="k">lambda</span> <span class="bp">self</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">symval</span><span class="o">.</span><span class="n">device</span><span class="p">)</span>
</span><span id="L-1506"><a href="#L-1506"><span class="linenos">1506</span></a>
</span><span id="L-1507"><a href="#L-1507"><span class="linenos">1507</span></a>    <span class="nd">@property</span>
</span><span id="L-1508"><a href="#L-1508"><span class="linenos">1508</span></a>    <span class="k">def</span> <span class="nf">val</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-1509"><a href="#L-1509"><span class="linenos">1509</span></a>        <span class="k">raise</span> <span class="ne">NotImplementedError</span>
</span><span id="L-1510"><a href="#L-1510"><span class="linenos">1510</span></a>
</span><span id="L-1511"><a href="#L-1511"><span class="linenos">1511</span></a>    <span class="k">def</span> <span class="fm">__str__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-1512"><a href="#L-1512"><span class="linenos">1512</span></a>        <span class="k">return</span> <span class="nb">repr</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span>
</span><span id="L-1513"><a href="#L-1513"><span class="linenos">1513</span></a>
</span><span id="L-1514"><a href="#L-1514"><span class="linenos">1514</span></a>    <span class="k">def</span> <span class="nf">full_lower</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-1515"><a href="#L-1515"><span class="linenos">1515</span></a>        <span class="k">return</span> <span class="bp">self</span>
</span><span id="L-1516"><a href="#L-1516"><span class="linenos">1516</span></a>
</span><span id="L-1517"><a href="#L-1517"><span class="linenos">1517</span></a>    <span class="nd">@property</span>
</span><span id="L-1518"><a href="#L-1518"><span class="linenos">1518</span></a>    <span class="k">def</span> <span class="nf">ndim</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-1519"><a href="#L-1519"><span class="linenos">1519</span></a>        <span class="k">return</span> <span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span>
</span><span id="L-1520"><a href="#L-1520"><span class="linenos">1520</span></a>
</span><span id="L-1521"><a href="#L-1521"><span class="linenos">1521</span></a>    <span class="k">def</span> <span class="fm">__repr__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-1522"><a href="#L-1522"><span class="linenos">1522</span></a>        <span class="k">return</span> <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="vm">__class__</span><span class="o">.</span><span class="vm">__name__</span><span class="si">}</span><span class="s2">(</span><span class="si">{</span><span class="nb">repr</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">symval</span><span class="p">)</span><span class="si">}</span><span class="s2">)&quot;</span>
</span><span id="L-1523"><a href="#L-1523"><span class="linenos">1523</span></a>
</span><span id="L-1524"><a href="#L-1524"><span class="linenos">1524</span></a>
</span><span id="L-1525"><a href="#L-1525"><span class="linenos">1525</span></a><span class="k">class</span> <span class="nc">VMapTraceTensor</span><span class="p">(</span><span class="n">TraceTensor</span><span class="p">):</span>
</span><span id="L-1526"><a href="#L-1526"><span class="linenos">1526</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">trace</span><span class="p">,</span> <span class="n">val</span><span class="p">,</span> <span class="n">vmap_dim</span><span class="p">):</span>
</span><span id="L-1527"><a href="#L-1527"><span class="linenos">1527</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">_trace</span> <span class="o">=</span> <span class="n">trace</span>
</span><span id="L-1528"><a href="#L-1528"><span class="linenos">1528</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">_val</span> <span class="o">=</span> <span class="n">val</span>
</span><span id="L-1529"><a href="#L-1529"><span class="linenos">1529</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">vmap_dim</span> <span class="o">=</span> <span class="n">vmap_dim</span>
</span><span id="L-1530"><a href="#L-1530"><span class="linenos">1530</span></a>
</span><span id="L-1531"><a href="#L-1531"><span class="linenos">1531</span></a>    <span class="nd">@property</span>
</span><span id="L-1532"><a href="#L-1532"><span class="linenos">1532</span></a>    <span class="k">def</span> <span class="nf">val</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-1533"><a href="#L-1533"><span class="linenos">1533</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">_val</span>
</span><span id="L-1534"><a href="#L-1534"><span class="linenos">1534</span></a>
</span><span id="L-1535"><a href="#L-1535"><span class="linenos">1535</span></a>    <span class="nd">@property</span>
</span><span id="L-1536"><a href="#L-1536"><span class="linenos">1536</span></a>    <span class="k">def</span> <span class="nf">symval</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-1537"><a href="#L-1537"><span class="linenos">1537</span></a>        <span class="n">symval</span> <span class="o">=</span> <span class="n">get_symval</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">val</span><span class="p">)</span>
</span><span id="L-1538"><a href="#L-1538"><span class="linenos">1538</span></a>        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">vmap_dim</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
</span><span id="L-1539"><a href="#L-1539"><span class="linenos">1539</span></a>            <span class="k">return</span> <span class="n">symval</span>
</span><span id="L-1540"><a href="#L-1540"><span class="linenos">1540</span></a>        <span class="k">else</span><span class="p">:</span>
</span><span id="L-1541"><a href="#L-1541"><span class="linenos">1541</span></a>            <span class="n">shape</span> <span class="o">=</span> <span class="nb">list</span><span class="p">(</span><span class="n">symval</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span>
</span><span id="L-1542"><a href="#L-1542"><span class="linenos">1542</span></a>            <span class="k">del</span> <span class="n">shape</span><span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">vmap_dim</span><span class="p">]</span>
</span><span id="L-1543"><a href="#L-1543"><span class="linenos">1543</span></a>            <span class="k">return</span> <span class="n">symval</span><span class="o">.</span><span class="n">like</span><span class="p">(</span><span class="n">shape</span><span class="o">=</span><span class="nb">tuple</span><span class="p">(</span><span class="n">shape</span><span class="p">))</span>
</span><span id="L-1544"><a href="#L-1544"><span class="linenos">1544</span></a>
</span><span id="L-1545"><a href="#L-1545"><span class="linenos">1545</span></a>    <span class="k">def</span> <span class="nf">full_lower</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-1546"><a href="#L-1546"><span class="linenos">1546</span></a>        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">vmap_dim</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
</span><span id="L-1547"><a href="#L-1547"><span class="linenos">1547</span></a>            <span class="k">return</span> <span class="n">full_lower</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">val</span><span class="p">)</span>
</span><span id="L-1548"><a href="#L-1548"><span class="linenos">1548</span></a>        <span class="k">else</span><span class="p">:</span>
</span><span id="L-1549"><a href="#L-1549"><span class="linenos">1549</span></a>            <span class="k">return</span> <span class="bp">self</span>
</span><span id="L-1550"><a href="#L-1550"><span class="linenos">1550</span></a>
</span><span id="L-1551"><a href="#L-1551"><span class="linenos">1551</span></a>
</span><span id="L-1552"><a href="#L-1552"><span class="linenos">1552</span></a><span class="k">class</span> <span class="nc">VMapTrace</span><span class="p">(</span><span class="n">Trace</span><span class="p">):</span>
</span><span id="L-1553"><a href="#L-1553"><span class="linenos">1553</span></a>    <span class="n">pure</span> <span class="o">=</span> <span class="k">lambda</span> <span class="bp">self</span><span class="p">,</span> <span class="n">val</span><span class="p">:</span> <span class="n">VMapTraceTensor</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">val</span><span class="p">,</span> <span class="kc">None</span><span class="p">)</span>
</span><span id="L-1554"><a href="#L-1554"><span class="linenos">1554</span></a>
</span><span id="L-1555"><a href="#L-1555"><span class="linenos">1555</span></a>    <span class="nd">@property</span>
</span><span id="L-1556"><a href="#L-1556"><span class="linenos">1556</span></a>    <span class="k">def</span> <span class="nf">dim_size</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-1557"><a href="#L-1557"><span class="linenos">1557</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">main</span><span class="o">.</span><span class="n">global_data</span>
</span><span id="L-1558"><a href="#L-1558"><span class="linenos">1558</span></a>
</span><span id="L-1559"><a href="#L-1559"><span class="linenos">1559</span></a>    <span class="k">def</span> <span class="nf">run_op</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">op</span><span class="p">,</span> <span class="n">tracers</span><span class="p">,</span> <span class="n">params</span><span class="p">):</span>
</span><span id="L-1560"><a href="#L-1560"><span class="linenos">1560</span></a>        <span class="n">vals_in</span><span class="p">,</span> <span class="n">bdims_in</span> <span class="o">=</span> <span class="n">unzip2</span><span class="p">((</span><span class="n">t</span><span class="o">.</span><span class="n">val</span><span class="p">,</span> <span class="n">t</span><span class="o">.</span><span class="n">vmap_dim</span><span class="p">)</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">tracers</span><span class="p">)</span>
</span><span id="L-1561"><a href="#L-1561"><span class="linenos">1561</span></a>        <span class="n">val_outs</span><span class="p">,</span> <span class="n">bdim_outs</span> <span class="o">=</span> <span class="n">op</span><span class="o">.</span><span class="n">vmap</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">dim_size</span><span class="p">,</span> <span class="n">vals_in</span><span class="p">,</span> <span class="n">bdims_in</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)</span>
</span><span id="L-1562"><a href="#L-1562"><span class="linenos">1562</span></a>        <span class="k">return</span> <span class="p">[</span><span class="n">VMapTraceTensor</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">x</span><span class="p">,</span> <span class="n">bd</span><span class="p">)</span> <span class="k">for</span> <span class="n">x</span><span class="p">,</span> <span class="n">bd</span> <span class="ow">in</span> <span class="n">list_zip</span><span class="p">(</span><span class="n">val_outs</span><span class="p">,</span> <span class="n">bdim_outs</span><span class="p">)]</span>
</span><span id="L-1563"><a href="#L-1563"><span class="linenos">1563</span></a>
</span><span id="L-1564"><a href="#L-1564"><span class="linenos">1564</span></a>    <span class="nd">@staticmethod</span>
</span><span id="L-1565"><a href="#L-1565"><span class="linenos">1565</span></a>    <span class="k">def</span> <span class="nf">move_vmap_dim</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">dim_size</span><span class="p">,</span> <span class="n">src</span><span class="p">:</span> <span class="nb">int</span><span class="p">,</span> <span class="n">dst</span><span class="p">:</span> <span class="nb">int</span><span class="p">):</span>
</span><span id="L-1566"><a href="#L-1566"><span class="linenos">1566</span></a>        <span class="k">if</span> <span class="n">src</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>  <span class="c1"># unsqueeze and expand</span>
</span><span id="L-1567"><a href="#L-1567"><span class="linenos">1567</span></a>            <span class="n">target_shape</span> <span class="o">=</span> <span class="nb">list</span><span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span>
</span><span id="L-1568"><a href="#L-1568"><span class="linenos">1568</span></a>            <span class="n">target_shape</span><span class="o">.</span><span class="n">insert</span><span class="p">(</span><span class="n">dst</span><span class="p">,</span> <span class="n">dim_size</span><span class="p">)</span>
</span><span id="L-1569"><a href="#L-1569"><span class="linenos">1569</span></a>            <span class="n">unsqueeze_shape</span> <span class="o">=</span> <span class="p">[</span><span class="mi">1</span> <span class="k">if</span> <span class="n">d</span> <span class="o">==</span> <span class="n">dst</span> <span class="k">else</span> <span class="n">target_shape</span><span class="p">[</span><span class="n">d</span><span class="p">]</span> <span class="k">for</span> <span class="n">d</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">target_shape</span><span class="p">))]</span>
</span><span id="L-1570"><a href="#L-1570"><span class="linenos">1570</span></a>            <span class="n">x</span> <span class="o">=</span> <span class="n">x</span><span class="o">.</span><span class="n">reshape</span><span class="p">(</span><span class="nb">tuple</span><span class="p">(</span><span class="n">unsqueeze_shape</span><span class="p">))</span>
</span><span id="L-1571"><a href="#L-1571"><span class="linenos">1571</span></a>            <span class="n">x</span> <span class="o">=</span> <span class="n">x</span><span class="o">.</span><span class="n">expand</span><span class="p">(</span><span class="nb">tuple</span><span class="p">(</span><span class="n">target_shape</span><span class="p">))</span>
</span><span id="L-1572"><a href="#L-1572"><span class="linenos">1572</span></a>            <span class="k">return</span> <span class="n">x</span>
</span><span id="L-1573"><a href="#L-1573"><span class="linenos">1573</span></a>        <span class="k">elif</span> <span class="n">src</span> <span class="o">==</span> <span class="n">dst</span><span class="p">:</span>
</span><span id="L-1574"><a href="#L-1574"><span class="linenos">1574</span></a>            <span class="k">return</span> <span class="n">x</span>
</span><span id="L-1575"><a href="#L-1575"><span class="linenos">1575</span></a>        <span class="k">else</span><span class="p">:</span>
</span><span id="L-1576"><a href="#L-1576"><span class="linenos">1576</span></a>            <span class="n">perm</span> <span class="o">=</span> <span class="p">[</span><span class="n">i</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">shape</span><span class="p">))</span> <span class="k">if</span> <span class="n">i</span> <span class="o">!=</span> <span class="n">src</span><span class="p">]</span>
</span><span id="L-1577"><a href="#L-1577"><span class="linenos">1577</span></a>            <span class="n">perm</span><span class="o">.</span><span class="n">insert</span><span class="p">(</span><span class="n">dst</span><span class="p">,</span> <span class="n">src</span><span class="p">)</span>
</span><span id="L-1578"><a href="#L-1578"><span class="linenos">1578</span></a>            <span class="k">return</span> <span class="n">x</span><span class="o">.</span><span class="n">permute</span><span class="p">(</span><span class="nb">tuple</span><span class="p">(</span><span class="n">perm</span><span class="p">))</span>
</span><span id="L-1579"><a href="#L-1579"><span class="linenos">1579</span></a>
</span><span id="L-1580"><a href="#L-1580"><span class="linenos">1580</span></a>
</span><span id="L-1581"><a href="#L-1581"><span class="linenos">1581</span></a><span class="k">class</span> <span class="nc">JVPTraceTensor</span><span class="p">(</span><span class="n">TraceTensor</span><span class="p">):</span>
</span><span id="L-1582"><a href="#L-1582"><span class="linenos">1582</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">trace</span><span class="p">,</span> <span class="n">primal</span><span class="p">,</span> <span class="n">tangent</span><span class="p">):</span>
</span><span id="L-1583"><a href="#L-1583"><span class="linenos">1583</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">_trace</span> <span class="o">=</span> <span class="n">trace</span>
</span><span id="L-1584"><a href="#L-1584"><span class="linenos">1584</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">primal</span> <span class="o">=</span> <span class="n">primal</span>
</span><span id="L-1585"><a href="#L-1585"><span class="linenos">1585</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">tangent</span> <span class="o">=</span> <span class="n">tangent</span>
</span><span id="L-1586"><a href="#L-1586"><span class="linenos">1586</span></a>
</span><span id="L-1587"><a href="#L-1587"><span class="linenos">1587</span></a>    <span class="nd">@property</span>
</span><span id="L-1588"><a href="#L-1588"><span class="linenos">1588</span></a>    <span class="k">def</span> <span class="nf">symval</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-1589"><a href="#L-1589"><span class="linenos">1589</span></a>        <span class="k">return</span> <span class="n">get_symval</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">primal</span><span class="p">)</span>
</span><span id="L-1590"><a href="#L-1590"><span class="linenos">1590</span></a>
</span><span id="L-1591"><a href="#L-1591"><span class="linenos">1591</span></a>    <span class="nd">@property</span>
</span><span id="L-1592"><a href="#L-1592"><span class="linenos">1592</span></a>    <span class="k">def</span> <span class="nf">val</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-1593"><a href="#L-1593"><span class="linenos">1593</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">primal</span>
</span><span id="L-1594"><a href="#L-1594"><span class="linenos">1594</span></a>
</span><span id="L-1595"><a href="#L-1595"><span class="linenos">1595</span></a>    <span class="nd">@property</span>
</span><span id="L-1596"><a href="#L-1596"><span class="linenos">1596</span></a>    <span class="k">def</span> <span class="nf">dtype</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-1597"><a href="#L-1597"><span class="linenos">1597</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">primal</span><span class="o">.</span><span class="n">dtype</span>
</span><span id="L-1598"><a href="#L-1598"><span class="linenos">1598</span></a>
</span><span id="L-1599"><a href="#L-1599"><span class="linenos">1599</span></a>
</span><span id="L-1600"><a href="#L-1600"><span class="linenos">1600</span></a><span class="k">class</span> <span class="nc">JVPTrace</span><span class="p">(</span><span class="n">Trace</span><span class="p">):</span>
</span><span id="L-1601"><a href="#L-1601"><span class="linenos">1601</span></a>    <span class="k">def</span> <span class="nf">pure</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">val</span><span class="p">):</span>
</span><span id="L-1602"><a href="#L-1602"><span class="linenos">1602</span></a>        <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">val</span><span class="p">,</span> <span class="n">PartialRunTrace</span><span class="p">):</span>
</span><span id="L-1603"><a href="#L-1603"><span class="linenos">1603</span></a>            <span class="n">val</span> <span class="o">=</span> <span class="n">val</span><span class="o">.</span><span class="n">pval</span><span class="o">.</span><span class="n">const</span>
</span><span id="L-1604"><a href="#L-1604"><span class="linenos">1604</span></a>        <span class="k">return</span> <span class="n">JVPTraceTensor</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">val</span><span class="p">,</span> <span class="n">backend</span><span class="o">.</span><span class="n">zeros_like</span><span class="p">(</span><span class="n">val</span><span class="p">))</span>
</span><span id="L-1605"><a href="#L-1605"><span class="linenos">1605</span></a>
</span><span id="L-1606"><a href="#L-1606"><span class="linenos">1606</span></a>    <span class="k">def</span> <span class="nf">run_op</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">op</span><span class="p">,</span> <span class="n">tracers</span><span class="p">,</span> <span class="n">params</span><span class="p">):</span>
</span><span id="L-1607"><a href="#L-1607"><span class="linenos">1607</span></a>        <span class="n">primals_in</span><span class="p">,</span> <span class="n">tangents_in</span> <span class="o">=</span> <span class="n">unzip2</span><span class="p">((</span><span class="n">t</span><span class="o">.</span><span class="n">primal</span><span class="p">,</span> <span class="n">t</span><span class="o">.</span><span class="n">tangent</span><span class="p">)</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">tracers</span><span class="p">)</span>
</span><span id="L-1608"><a href="#L-1608"><span class="linenos">1608</span></a>        <span class="n">primals_out</span><span class="p">,</span> <span class="n">tangents_out</span> <span class="o">=</span> <span class="n">op</span><span class="o">.</span><span class="n">jvp</span><span class="p">(</span><span class="n">primals_in</span><span class="p">,</span> <span class="n">tangents_in</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)</span>
</span><span id="L-1609"><a href="#L-1609"><span class="linenos">1609</span></a>        <span class="k">return</span> <span class="p">[</span><span class="n">JVPTraceTensor</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">x</span><span class="p">,</span> <span class="n">t</span><span class="p">)</span> <span class="k">for</span> <span class="n">x</span><span class="p">,</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">list_zip</span><span class="p">(</span><span class="n">primals_out</span><span class="p">,</span> <span class="n">tangents_out</span><span class="p">)]</span>
</span><span id="L-1610"><a href="#L-1610"><span class="linenos">1610</span></a>
</span><span id="L-1611"><a href="#L-1611"><span class="linenos">1611</span></a>
</span><span id="L-1612"><a href="#L-1612"><span class="linenos">1612</span></a><span class="k">class</span> <span class="nc">ProgramTraceTensor</span><span class="p">(</span><span class="n">TraceTensor</span><span class="p">):</span>
</span><span id="L-1613"><a href="#L-1613"><span class="linenos">1613</span></a>    <span class="vm">__slots__</span> <span class="o">=</span> <span class="p">[</span><span class="s2">&quot;symval&quot;</span><span class="p">]</span>
</span><span id="L-1614"><a href="#L-1614"><span class="linenos">1614</span></a>    <span class="n">symval</span><span class="p">:</span> <span class="n">SymbolicTensor</span>
</span><span id="L-1615"><a href="#L-1615"><span class="linenos">1615</span></a>
</span><span id="L-1616"><a href="#L-1616"><span class="linenos">1616</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">trace</span><span class="p">,</span> <span class="n">symval</span><span class="p">):</span>
</span><span id="L-1617"><a href="#L-1617"><span class="linenos">1617</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">_trace</span> <span class="o">=</span> <span class="n">trace</span>
</span><span id="L-1618"><a href="#L-1618"><span class="linenos">1618</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">symval</span> <span class="o">=</span> <span class="n">symval</span>
</span><span id="L-1619"><a href="#L-1619"><span class="linenos">1619</span></a>
</span><span id="L-1620"><a href="#L-1620"><span class="linenos">1620</span></a>
</span><span id="L-1621"><a href="#L-1621"><span class="linenos">1621</span></a><span class="k">class</span> <span class="nc">ProgramTrace</span><span class="p">(</span><span class="n">Trace</span><span class="p">):</span>
</span><span id="L-1622"><a href="#L-1622"><span class="linenos">1622</span></a>    <span class="nd">@property</span>
</span><span id="L-1623"><a href="#L-1623"><span class="linenos">1623</span></a>    <span class="k">def</span> <span class="nf">builder</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-1624"><a href="#L-1624"><span class="linenos">1624</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">main</span><span class="o">.</span><span class="n">global_data</span>
</span><span id="L-1625"><a href="#L-1625"><span class="linenos">1625</span></a>
</span><span id="L-1626"><a href="#L-1626"><span class="linenos">1626</span></a>    <span class="k">def</span> <span class="nf">new_arg</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">symval</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">ProgramTraceTensor</span><span class="p">:</span>
</span><span id="L-1627"><a href="#L-1627"><span class="linenos">1627</span></a>        <span class="n">symval</span> <span class="o">=</span> <span class="n">SymbolicTensor</span><span class="o">.</span><span class="n">like</span><span class="p">(</span><span class="n">symval</span><span class="p">)</span>
</span><span id="L-1628"><a href="#L-1628"><span class="linenos">1628</span></a>        <span class="n">tracer</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">builder</span><span class="o">.</span><span class="n">new_tracer</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">symval</span><span class="p">)</span>
</span><span id="L-1629"><a href="#L-1629"><span class="linenos">1629</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">builder</span><span class="o">.</span><span class="n">tracer_to_var</span><span class="p">[</span><span class="nb">id</span><span class="p">(</span><span class="n">tracer</span><span class="p">)]</span> <span class="o">=</span> <span class="n">Var</span><span class="p">(</span><span class="n">symval</span><span class="p">)</span>
</span><span id="L-1630"><a href="#L-1630"><span class="linenos">1630</span></a>
</span><span id="L-1631"><a href="#L-1631"><span class="linenos">1631</span></a>        <span class="k">return</span> <span class="n">tracer</span>
</span><span id="L-1632"><a href="#L-1632"><span class="linenos">1632</span></a>
</span><span id="L-1633"><a href="#L-1633"><span class="linenos">1633</span></a>    <span class="k">def</span> <span class="nf">pure</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">val</span><span class="p">:</span> <span class="n">Any</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">ProgramTraceTensor</span><span class="p">:</span>
</span><span id="L-1634"><a href="#L-1634"><span class="linenos">1634</span></a>        <span class="c1"># get_or_make_const_tracer</span>
</span><span id="L-1635"><a href="#L-1635"><span class="linenos">1635</span></a>        <span class="n">tracer</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">builder</span><span class="o">.</span><span class="n">const_tracers</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="nb">id</span><span class="p">(</span><span class="n">val</span><span class="p">))</span>
</span><span id="L-1636"><a href="#L-1636"><span class="linenos">1636</span></a>        <span class="k">if</span> <span class="n">tracer</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
</span><span id="L-1637"><a href="#L-1637"><span class="linenos">1637</span></a>            <span class="n">tracer</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">builder</span><span class="o">.</span><span class="n">new_tracer</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">get_symval</span><span class="p">(</span><span class="n">val</span><span class="p">))</span>
</span><span id="L-1638"><a href="#L-1638"><span class="linenos">1638</span></a>            <span class="bp">self</span><span class="o">.</span><span class="n">builder</span><span class="o">.</span><span class="n">add_const</span><span class="p">(</span><span class="n">tracer</span><span class="p">,</span> <span class="n">val</span><span class="p">)</span>
</span><span id="L-1639"><a href="#L-1639"><span class="linenos">1639</span></a>        <span class="c1"># print(self.builder.const_tracers)</span>
</span><span id="L-1640"><a href="#L-1640"><span class="linenos">1640</span></a>        <span class="k">return</span> <span class="n">tracer</span>
</span><span id="L-1641"><a href="#L-1641"><span class="linenos">1641</span></a>
</span><span id="L-1642"><a href="#L-1642"><span class="linenos">1642</span></a>    <span class="k">def</span> <span class="nf">run_op</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">op</span><span class="p">,</span> <span class="n">tracers</span><span class="p">,</span> <span class="n">params</span><span class="p">):</span>
</span><span id="L-1643"><a href="#L-1643"><span class="linenos">1643</span></a>        <span class="n">symvals_in</span> <span class="o">=</span> <span class="n">tree_map</span><span class="p">(</span><span class="k">lambda</span> <span class="n">x</span><span class="p">:</span> <span class="n">x</span><span class="o">.</span><span class="n">symval</span><span class="p">,</span> <span class="n">tracers</span><span class="p">)</span>
</span><span id="L-1644"><a href="#L-1644"><span class="linenos">1644</span></a>        <span class="n">symvals_out</span> <span class="o">=</span> <span class="n">op</span><span class="o">.</span><span class="n">typecheck</span><span class="p">(</span><span class="o">*</span><span class="n">symvals_in</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)</span>
</span><span id="L-1645"><a href="#L-1645"><span class="linenos">1645</span></a>
</span><span id="L-1646"><a href="#L-1646"><span class="linenos">1646</span></a>        <span class="n">out_tracers</span> <span class="o">=</span> <span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">builder</span><span class="o">.</span><span class="n">new_tracer</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">a</span><span class="p">)</span> <span class="k">for</span> <span class="n">a</span> <span class="ow">in</span> <span class="n">symvals_out</span><span class="p">]</span>
</span><span id="L-1647"><a href="#L-1647"><span class="linenos">1647</span></a>        <span class="n">inputs</span> <span class="o">=</span> <span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">builder</span><span class="o">.</span><span class="n">getvar</span><span class="p">(</span><span class="n">t</span><span class="p">)</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">tracers</span><span class="p">]</span>
</span><span id="L-1648"><a href="#L-1648"><span class="linenos">1648</span></a>        <span class="n">outvars</span> <span class="o">=</span> <span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">builder</span><span class="o">.</span><span class="n">add_var</span><span class="p">(</span><span class="n">t</span><span class="p">)</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">out_tracers</span><span class="p">]</span>
</span><span id="L-1649"><a href="#L-1649"><span class="linenos">1649</span></a>
</span><span id="L-1650"><a href="#L-1650"><span class="linenos">1650</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">builder</span><span class="o">.</span><span class="n">add_instruction</span><span class="p">(</span><span class="n">Instruction</span><span class="p">(</span><span class="n">op</span><span class="p">,</span> <span class="n">inputs</span><span class="p">,</span> <span class="n">params</span><span class="p">,</span> <span class="n">outvars</span><span class="p">))</span>
</span><span id="L-1651"><a href="#L-1651"><span class="linenos">1651</span></a>        <span class="k">return</span> <span class="n">out_tracers</span>
</span><span id="L-1652"><a href="#L-1652"><span class="linenos">1652</span></a>
</span><span id="L-1653"><a href="#L-1653"><span class="linenos">1653</span></a>
</span><span id="L-1654"><a href="#L-1654"><span class="linenos">1654</span></a><span class="k">class</span> <span class="nc">ProgramBuilder</span><span class="p">:</span>
</span><span id="L-1655"><a href="#L-1655"><span class="linenos">1655</span></a>    <span class="n">instructions</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">Instruction</span><span class="p">]</span>
</span><span id="L-1656"><a href="#L-1656"><span class="linenos">1656</span></a>    <span class="n">tracer_to_var</span><span class="p">:</span> <span class="n">Dict</span><span class="p">[</span><span class="nb">int</span><span class="p">,</span> <span class="n">Var</span><span class="p">]</span>
</span><span id="L-1657"><a href="#L-1657"><span class="linenos">1657</span></a>    <span class="n">const_tracers</span><span class="p">:</span> <span class="n">Dict</span><span class="p">[</span><span class="nb">int</span><span class="p">,</span> <span class="n">TraceTensor</span><span class="p">]</span>
</span><span id="L-1658"><a href="#L-1658"><span class="linenos">1658</span></a>    <span class="n">constvals</span><span class="p">:</span> <span class="n">Dict</span><span class="p">[</span><span class="n">Var</span><span class="p">,</span> <span class="n">Any</span><span class="p">]</span>
</span><span id="L-1659"><a href="#L-1659"><span class="linenos">1659</span></a>    <span class="n">tracers</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">ProgramTraceTensor</span><span class="p">]</span>
</span><span id="L-1660"><a href="#L-1660"><span class="linenos">1660</span></a>
</span><span id="L-1661"><a href="#L-1661"><span class="linenos">1661</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-1662"><a href="#L-1662"><span class="linenos">1662</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">instructions</span> <span class="o">=</span> <span class="p">[]</span>
</span><span id="L-1663"><a href="#L-1663"><span class="linenos">1663</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">tracer_to_var</span> <span class="o">=</span> <span class="p">{}</span>
</span><span id="L-1664"><a href="#L-1664"><span class="linenos">1664</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">const_tracers</span> <span class="o">=</span> <span class="p">{}</span>
</span><span id="L-1665"><a href="#L-1665"><span class="linenos">1665</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">constvals</span> <span class="o">=</span> <span class="p">{}</span>
</span><span id="L-1666"><a href="#L-1666"><span class="linenos">1666</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">tracers</span> <span class="o">=</span> <span class="p">[]</span>
</span><span id="L-1667"><a href="#L-1667"><span class="linenos">1667</span></a>
</span><span id="L-1668"><a href="#L-1668"><span class="linenos">1668</span></a>    <span class="k">def</span> <span class="nf">new_tracer</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">trace</span><span class="p">:</span> <span class="n">ProgramTrace</span><span class="p">,</span> <span class="n">symval</span><span class="p">:</span> <span class="n">SymbolicTensor</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">ProgramTraceTensor</span><span class="p">:</span>
</span><span id="L-1669"><a href="#L-1669"><span class="linenos">1669</span></a>        <span class="n">tracer</span> <span class="o">=</span> <span class="n">ProgramTraceTensor</span><span class="p">(</span><span class="n">trace</span><span class="p">,</span> <span class="n">symval</span><span class="p">)</span>
</span><span id="L-1670"><a href="#L-1670"><span class="linenos">1670</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">tracers</span> <span class="o">+=</span> <span class="p">[</span><span class="n">tracer</span><span class="p">]</span>
</span><span id="L-1671"><a href="#L-1671"><span class="linenos">1671</span></a>        <span class="k">return</span> <span class="n">tracer</span>
</span><span id="L-1672"><a href="#L-1672"><span class="linenos">1672</span></a>
</span><span id="L-1673"><a href="#L-1673"><span class="linenos">1673</span></a>    <span class="k">def</span> <span class="nf">add_instruction</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">instruction</span><span class="p">:</span> <span class="n">Instruction</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="kc">None</span><span class="p">:</span>
</span><span id="L-1674"><a href="#L-1674"><span class="linenos">1674</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">instructions</span> <span class="o">+=</span> <span class="p">[</span><span class="n">instruction</span><span class="p">]</span>
</span><span id="L-1675"><a href="#L-1675"><span class="linenos">1675</span></a>
</span><span id="L-1676"><a href="#L-1676"><span class="linenos">1676</span></a>    <span class="k">def</span> <span class="nf">add_var</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">tracer</span><span class="p">:</span> <span class="n">ProgramTraceTensor</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Var</span><span class="p">:</span>
</span><span id="L-1677"><a href="#L-1677"><span class="linenos">1677</span></a>        <span class="k">assert</span> <span class="nb">id</span><span class="p">(</span><span class="n">tracer</span><span class="p">)</span> <span class="ow">not</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">tracer_to_var</span>
</span><span id="L-1678"><a href="#L-1678"><span class="linenos">1678</span></a>        <span class="n">var</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">tracer_to_var</span><span class="p">[</span><span class="nb">id</span><span class="p">(</span><span class="n">tracer</span><span class="p">)]</span> <span class="o">=</span> <span class="n">Var</span><span class="p">(</span><span class="n">tracer</span><span class="o">.</span><span class="n">symval</span><span class="p">)</span>
</span><span id="L-1679"><a href="#L-1679"><span class="linenos">1679</span></a>        <span class="k">return</span> <span class="n">var</span>
</span><span id="L-1680"><a href="#L-1680"><span class="linenos">1680</span></a>
</span><span id="L-1681"><a href="#L-1681"><span class="linenos">1681</span></a>    <span class="k">def</span> <span class="nf">getvar</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">tracer</span><span class="p">:</span> <span class="n">ProgramTraceTensor</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Var</span><span class="p">:</span>
</span><span id="L-1682"><a href="#L-1682"><span class="linenos">1682</span></a>        <span class="n">var</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">tracer_to_var</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="nb">id</span><span class="p">(</span><span class="n">tracer</span><span class="p">))</span>
</span><span id="L-1683"><a href="#L-1683"><span class="linenos">1683</span></a>        <span class="k">assert</span> <span class="n">var</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span>
</span><span id="L-1684"><a href="#L-1684"><span class="linenos">1684</span></a>        <span class="k">return</span> <span class="n">var</span>
</span><span id="L-1685"><a href="#L-1685"><span class="linenos">1685</span></a>
</span><span id="L-1686"><a href="#L-1686"><span class="linenos">1686</span></a>    <span class="k">def</span> <span class="nf">add_const</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">tracer</span><span class="p">:</span> <span class="n">ProgramTraceTensor</span><span class="p">,</span> <span class="n">val</span><span class="p">:</span> <span class="n">Any</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Var</span><span class="p">:</span>
</span><span id="L-1687"><a href="#L-1687"><span class="linenos">1687</span></a>        <span class="n">var</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">add_var</span><span class="p">(</span><span class="n">tracer</span><span class="p">)</span>
</span><span id="L-1688"><a href="#L-1688"><span class="linenos">1688</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">const_tracers</span><span class="p">[</span><span class="nb">id</span><span class="p">(</span><span class="n">val</span><span class="p">)]</span> <span class="o">=</span> <span class="n">tracer</span>
</span><span id="L-1689"><a href="#L-1689"><span class="linenos">1689</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">constvals</span><span class="p">[</span><span class="n">var</span><span class="p">]</span> <span class="o">=</span> <span class="n">val</span>
</span><span id="L-1690"><a href="#L-1690"><span class="linenos">1690</span></a>        <span class="k">return</span> <span class="n">var</span>
</span><span id="L-1691"><a href="#L-1691"><span class="linenos">1691</span></a>
</span><span id="L-1692"><a href="#L-1692"><span class="linenos">1692</span></a>    <span class="k">def</span> <span class="nf">build</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">in_tracers</span><span class="p">:</span> <span class="n">Any</span><span class="p">,</span> <span class="n">out_tracers</span><span class="p">:</span> <span class="n">Any</span><span class="p">,</span> <span class="n">static_args</span><span class="p">,</span> <span class="n">name</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Tuple</span><span class="p">[</span><span class="n">Program</span><span class="p">,</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">]]:</span>
</span><span id="L-1693"><a href="#L-1693"><span class="linenos">1693</span></a>        <span class="n">constvars</span><span class="p">,</span> <span class="n">constvals</span> <span class="o">=</span> <span class="n">unzip2</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">constvals</span><span class="o">.</span><span class="n">items</span><span class="p">())</span>
</span><span id="L-1694"><a href="#L-1694"><span class="linenos">1694</span></a>        <span class="n">t2v</span> <span class="o">=</span> <span class="k">lambda</span> <span class="n">t</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">tracer_to_var</span><span class="p">[</span><span class="nb">id</span><span class="p">(</span><span class="n">t</span><span class="p">)]</span>
</span><span id="L-1695"><a href="#L-1695"><span class="linenos">1695</span></a>        <span class="n">in_binders</span> <span class="o">=</span> <span class="n">constvars</span> <span class="o">+</span> <span class="p">[</span><span class="n">t2v</span><span class="p">(</span><span class="n">t</span><span class="p">)</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">in_tracers</span><span class="p">]</span>
</span><span id="L-1696"><a href="#L-1696"><span class="linenos">1696</span></a>        <span class="n">out_vars</span> <span class="o">=</span> <span class="p">[</span><span class="n">t2v</span><span class="p">(</span><span class="n">t</span><span class="p">)</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">out_tracers</span><span class="p">]</span>
</span><span id="L-1697"><a href="#L-1697"><span class="linenos">1697</span></a>        <span class="n">program</span> <span class="o">=</span> <span class="n">Program</span><span class="p">(</span>
</span><span id="L-1698"><a href="#L-1698"><span class="linenos">1698</span></a>            <span class="n">in_binders</span><span class="p">,</span>
</span><span id="L-1699"><a href="#L-1699"><span class="linenos">1699</span></a>            <span class="bp">self</span><span class="o">.</span><span class="n">instructions</span><span class="p">,</span>
</span><span id="L-1700"><a href="#L-1700"><span class="linenos">1700</span></a>            <span class="n">out_vars</span><span class="p">,</span>
</span><span id="L-1701"><a href="#L-1701"><span class="linenos">1701</span></a>            <span class="nb">len</span><span class="p">(</span><span class="n">constvals</span><span class="p">),</span>
</span><span id="L-1702"><a href="#L-1702"><span class="linenos">1702</span></a>            <span class="n">static_args</span><span class="p">,</span>
</span><span id="L-1703"><a href="#L-1703"><span class="linenos">1703</span></a>            <span class="n">name</span><span class="p">,</span>
</span><span id="L-1704"><a href="#L-1704"><span class="linenos">1704</span></a>        <span class="p">)</span>
</span><span id="L-1705"><a href="#L-1705"><span class="linenos">1705</span></a>        <span class="n">typecheck_program</span><span class="p">(</span><span class="n">program</span><span class="p">)</span>
</span><span id="L-1706"><a href="#L-1706"><span class="linenos">1706</span></a>        <span class="n">program</span><span class="p">,</span> <span class="n">constvals</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">_inline_literals</span><span class="p">(</span><span class="n">program</span><span class="p">,</span> <span class="n">constvals</span><span class="p">)</span>
</span><span id="L-1707"><a href="#L-1707"><span class="linenos">1707</span></a>        <span class="n">typecheck_program</span><span class="p">(</span><span class="n">program</span><span class="p">)</span>
</span><span id="L-1708"><a href="#L-1708"><span class="linenos">1708</span></a>        <span class="c1"># dblog(program, enable=backend.LOG_PROGRAM)</span>
</span><span id="L-1709"><a href="#L-1709"><span class="linenos">1709</span></a>        <span class="k">return</span> <span class="n">program</span><span class="p">,</span> <span class="n">constvals</span>
</span><span id="L-1710"><a href="#L-1710"><span class="linenos">1710</span></a>
</span><span id="L-1711"><a href="#L-1711"><span class="linenos">1711</span></a>    <span class="k">def</span> <span class="nf">_inline_literals</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">program</span><span class="p">:</span> <span class="n">Program</span><span class="p">,</span> <span class="n">consts</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">])</span> <span class="o">-&gt;</span> <span class="n">Tuple</span><span class="p">[</span><span class="n">Program</span><span class="p">,</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">]]:</span>
</span><span id="L-1712"><a href="#L-1712"><span class="linenos">1712</span></a>        <span class="n">const_binders</span><span class="p">,</span> <span class="n">other_binders</span> <span class="o">=</span> <span class="n">split_list</span><span class="p">(</span><span class="n">program</span><span class="o">.</span><span class="n">in_binders</span><span class="p">,</span> <span class="nb">len</span><span class="p">(</span><span class="n">consts</span><span class="p">))</span>
</span><span id="L-1713"><a href="#L-1713"><span class="linenos">1713</span></a>        <span class="n">scalars</span> <span class="o">=</span> <span class="p">[</span><span class="nb">type</span><span class="p">(</span><span class="n">x</span><span class="p">)</span> <span class="ow">in</span> <span class="n">TraceTensor</span><span class="o">.</span><span class="n">PYTHON_TYPES</span> <span class="ow">and</span> <span class="ow">not</span> <span class="n">get_symval</span><span class="p">(</span><span class="n">x</span><span class="p">)</span><span class="o">.</span><span class="n">shape</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">consts</span><span class="p">]</span>
</span><span id="L-1714"><a href="#L-1714"><span class="linenos">1714</span></a>        <span class="n">new_const_binders</span><span class="p">,</span> <span class="n">lit_binders</span> <span class="o">=</span> <span class="n">partition_list</span><span class="p">(</span><span class="n">scalars</span><span class="p">,</span> <span class="n">const_binders</span><span class="p">)</span>
</span><span id="L-1715"><a href="#L-1715"><span class="linenos">1715</span></a>        <span class="n">new_consts</span><span class="p">,</span> <span class="n">lit_vals</span> <span class="o">=</span> <span class="n">partition_list</span><span class="p">(</span><span class="n">scalars</span><span class="p">,</span> <span class="n">consts</span><span class="p">)</span>
</span><span id="L-1716"><a href="#L-1716"><span class="linenos">1716</span></a>        <span class="n">literals</span> <span class="o">=</span> <span class="nb">dict</span><span class="p">(</span><span class="n">list_zip</span><span class="p">(</span><span class="n">lit_binders</span><span class="p">,</span> <span class="n">list_map</span><span class="p">(</span><span class="n">Lit</span><span class="p">,</span> <span class="n">lit_vals</span><span class="p">)))</span>
</span><span id="L-1717"><a href="#L-1717"><span class="linenos">1717</span></a>        <span class="n">new_outs</span> <span class="o">=</span> <span class="p">[</span><span class="n">literals</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">x</span><span class="p">)</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">program</span><span class="o">.</span><span class="n">outs</span><span class="p">]</span>
</span><span id="L-1718"><a href="#L-1718"><span class="linenos">1718</span></a>        <span class="n">new_instructions</span> <span class="o">=</span> <span class="p">[</span>
</span><span id="L-1719"><a href="#L-1719"><span class="linenos">1719</span></a>            <span class="n">Instruction</span><span class="p">(</span>
</span><span id="L-1720"><a href="#L-1720"><span class="linenos">1720</span></a>                <span class="n">instruction</span><span class="o">.</span><span class="n">op</span><span class="p">,</span>
</span><span id="L-1721"><a href="#L-1721"><span class="linenos">1721</span></a>                <span class="p">[</span><span class="n">literals</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">x</span><span class="p">)</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">instruction</span><span class="o">.</span><span class="n">inputs</span><span class="p">],</span>
</span><span id="L-1722"><a href="#L-1722"><span class="linenos">1722</span></a>                <span class="n">instruction</span><span class="o">.</span><span class="n">params</span><span class="p">,</span>
</span><span id="L-1723"><a href="#L-1723"><span class="linenos">1723</span></a>                <span class="n">instruction</span><span class="o">.</span><span class="n">out_binders</span><span class="p">,</span>
</span><span id="L-1724"><a href="#L-1724"><span class="linenos">1724</span></a>            <span class="p">)</span>
</span><span id="L-1725"><a href="#L-1725"><span class="linenos">1725</span></a>            <span class="k">for</span> <span class="n">instruction</span> <span class="ow">in</span> <span class="n">program</span><span class="o">.</span><span class="n">instructions</span>
</span><span id="L-1726"><a href="#L-1726"><span class="linenos">1726</span></a>        <span class="p">]</span>
</span><span id="L-1727"><a href="#L-1727"><span class="linenos">1727</span></a>        <span class="n">new_program</span> <span class="o">=</span> <span class="n">Program</span><span class="p">(</span>
</span><span id="L-1728"><a href="#L-1728"><span class="linenos">1728</span></a>            <span class="n">new_const_binders</span> <span class="o">+</span> <span class="n">other_binders</span><span class="p">,</span>
</span><span id="L-1729"><a href="#L-1729"><span class="linenos">1729</span></a>            <span class="n">new_instructions</span><span class="p">,</span>
</span><span id="L-1730"><a href="#L-1730"><span class="linenos">1730</span></a>            <span class="n">new_outs</span><span class="p">,</span>
</span><span id="L-1731"><a href="#L-1731"><span class="linenos">1731</span></a>            <span class="nb">len</span><span class="p">(</span><span class="n">new_consts</span><span class="p">),</span>
</span><span id="L-1732"><a href="#L-1732"><span class="linenos">1732</span></a>            <span class="n">program</span><span class="o">.</span><span class="n">static_args</span><span class="p">,</span>
</span><span id="L-1733"><a href="#L-1733"><span class="linenos">1733</span></a>            <span class="n">program</span><span class="o">.</span><span class="n">name</span><span class="p">,</span>
</span><span id="L-1734"><a href="#L-1734"><span class="linenos">1734</span></a>        <span class="p">)</span>
</span><span id="L-1735"><a href="#L-1735"><span class="linenos">1735</span></a>        <span class="k">return</span> <span class="n">new_program</span><span class="p">,</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">new_consts</span><span class="p">)</span>
</span><span id="L-1736"><a href="#L-1736"><span class="linenos">1736</span></a>
</span><span id="L-1737"><a href="#L-1737"><span class="linenos">1737</span></a>    <span class="k">def</span> <span class="nf">get_current_scope_info</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-1738"><a href="#L-1738"><span class="linenos">1738</span></a>        <span class="n">current_frame</span> <span class="o">=</span> <span class="n">inspect</span><span class="o">.</span><span class="n">currentframe</span><span class="p">()</span>
</span><span id="L-1739"><a href="#L-1739"><span class="linenos">1739</span></a>        <span class="n">current_function_name</span> <span class="o">=</span> <span class="n">current_frame</span><span class="o">.</span><span class="n">f_code</span><span class="o">.</span><span class="n">co_name</span>
</span><span id="L-1740"><a href="#L-1740"><span class="linenos">1740</span></a>        <span class="n">current_module_name</span> <span class="o">=</span> <span class="n">inspect</span><span class="o">.</span><span class="n">getmodulename</span><span class="p">(</span><span class="n">current_frame</span><span class="o">.</span><span class="n">f_code</span><span class="o">.</span><span class="n">co_filename</span><span class="p">)</span>
</span><span id="L-1741"><a href="#L-1741"><span class="linenos">1741</span></a>        <span class="n">current_class_name</span> <span class="o">=</span> <span class="kc">None</span>
</span><span id="L-1742"><a href="#L-1742"><span class="linenos">1742</span></a>        <span class="k">for</span> <span class="n">frame_info</span> <span class="ow">in</span> <span class="n">inspect</span><span class="o">.</span><span class="n">getouterframes</span><span class="p">(</span><span class="n">current_frame</span><span class="p">):</span>
</span><span id="L-1743"><a href="#L-1743"><span class="linenos">1743</span></a>            <span class="nb">print</span><span class="p">(</span><span class="n">frame_info</span><span class="p">)</span>
</span><span id="L-1744"><a href="#L-1744"><span class="linenos">1744</span></a>            <span class="n">frame_locals</span> <span class="o">=</span> <span class="n">frame_info</span><span class="o">.</span><span class="n">frame</span><span class="o">.</span><span class="n">f_locals</span>
</span><span id="L-1745"><a href="#L-1745"><span class="linenos">1745</span></a>            <span class="nb">print</span><span class="p">(</span><span class="n">frame_locals</span><span class="p">)</span>
</span><span id="L-1746"><a href="#L-1746"><span class="linenos">1746</span></a>            <span class="k">if</span> <span class="s2">&quot;self&quot;</span> <span class="ow">in</span> <span class="n">frame_locals</span><span class="p">:</span>
</span><span id="L-1747"><a href="#L-1747"><span class="linenos">1747</span></a>                <span class="n">current_class_name</span> <span class="o">=</span> <span class="n">frame_locals</span><span class="p">[</span><span class="s2">&quot;self&quot;</span><span class="p">]</span><span class="o">.</span><span class="vm">__class__</span><span class="o">.</span><span class="vm">__name__</span>
</span><span id="L-1748"><a href="#L-1748"><span class="linenos">1748</span></a>                <span class="k">break</span>
</span><span id="L-1749"><a href="#L-1749"><span class="linenos">1749</span></a>        <span class="k">return</span> <span class="p">{</span>
</span><span id="L-1750"><a href="#L-1750"><span class="linenos">1750</span></a>            <span class="s2">&quot;Function&quot;</span><span class="p">:</span> <span class="n">current_function_name</span><span class="p">,</span>
</span><span id="L-1751"><a href="#L-1751"><span class="linenos">1751</span></a>            <span class="s2">&quot;Module&quot;</span><span class="p">:</span> <span class="n">current_module_name</span><span class="p">,</span>
</span><span id="L-1752"><a href="#L-1752"><span class="linenos">1752</span></a>            <span class="s2">&quot;Class&quot;</span><span class="p">:</span> <span class="n">current_class_name</span><span class="p">,</span>
</span><span id="L-1753"><a href="#L-1753"><span class="linenos">1753</span></a>        <span class="p">}</span>
</span><span id="L-1754"><a href="#L-1754"><span class="linenos">1754</span></a>
</span><span id="L-1755"><a href="#L-1755"><span class="linenos">1755</span></a>
</span><span id="L-1756"><a href="#L-1756"><span class="linenos">1756</span></a><span class="k">class</span> <span class="nc">UndefinedPrimal</span><span class="p">(</span><span class="n">NamedTuple</span><span class="p">):</span>
</span><span id="L-1757"><a href="#L-1757"><span class="linenos">1757</span></a>    <span class="n">symval</span><span class="p">:</span> <span class="n">SymbolicTensor</span>
</span><span id="L-1758"><a href="#L-1758"><span class="linenos">1758</span></a>
</span><span id="L-1759"><a href="#L-1759"><span class="linenos">1759</span></a>    <span class="nd">@property</span>
</span><span id="L-1760"><a href="#L-1760"><span class="linenos">1760</span></a>    <span class="k">def</span> <span class="nf">shape</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-1761"><a href="#L-1761"><span class="linenos">1761</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">symval</span><span class="o">.</span><span class="n">shape</span>
</span><span id="L-1762"><a href="#L-1762"><span class="linenos">1762</span></a>
</span><span id="L-1763"><a href="#L-1763"><span class="linenos">1763</span></a>    <span class="nd">@property</span>
</span><span id="L-1764"><a href="#L-1764"><span class="linenos">1764</span></a>    <span class="k">def</span> <span class="nf">dtype</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-1765"><a href="#L-1765"><span class="linenos">1765</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">symval</span><span class="o">.</span><span class="n">dtype</span>
</span><span id="L-1766"><a href="#L-1766"><span class="linenos">1766</span></a>
</span><span id="L-1767"><a href="#L-1767"><span class="linenos">1767</span></a>    <span class="nd">@property</span>
</span><span id="L-1768"><a href="#L-1768"><span class="linenos">1768</span></a>    <span class="k">def</span> <span class="nf">device</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-1769"><a href="#L-1769"><span class="linenos">1769</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">symval</span><span class="o">.</span><span class="n">device</span>
</span><span id="L-1770"><a href="#L-1770"><span class="linenos">1770</span></a>
</span><span id="L-1771"><a href="#L-1771"><span class="linenos">1771</span></a>    <span class="nd">@property</span>
</span><span id="L-1772"><a href="#L-1772"><span class="linenos">1772</span></a>    <span class="k">def</span> <span class="nf">ndim</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-1773"><a href="#L-1773"><span class="linenos">1773</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">symval</span><span class="o">.</span><span class="n">ndim</span>
</span><span id="L-1774"><a href="#L-1774"><span class="linenos">1774</span></a>
</span><span id="L-1775"><a href="#L-1775"><span class="linenos">1775</span></a>    <span class="k">def</span> <span class="fm">__repr__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-1776"><a href="#L-1776"><span class="linenos">1776</span></a>        <span class="k">return</span> <span class="sa">f</span><span class="s2">&quot;&lt;UndefinedPrimal: symval=</span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">symval</span><span class="si">}</span><span class="s2">&gt;&quot;</span>
</span><span id="L-1777"><a href="#L-1777"><span class="linenos">1777</span></a>
</span><span id="L-1778"><a href="#L-1778"><span class="linenos">1778</span></a>    <span class="n">str_short</span> <span class="o">=</span> <span class="fm">__repr__</span>
</span><span id="L-1779"><a href="#L-1779"><span class="linenos">1779</span></a>
</span><span id="L-1780"><a href="#L-1780"><span class="linenos">1780</span></a>
</span><span id="L-1781"><a href="#L-1781"><span class="linenos">1781</span></a><span class="k">class</span> <span class="nc">PartialValue</span><span class="p">(</span><span class="n">NamedTuple</span><span class="p">):</span>
</span><span id="L-1782"><a href="#L-1782"><span class="linenos">1782</span></a>    <span class="n">symval</span><span class="p">:</span> <span class="n">SymbolicTensor</span>
</span><span id="L-1783"><a href="#L-1783"><span class="linenos">1783</span></a>    <span class="n">const</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="n">Any</span><span class="p">]</span>
</span><span id="L-1784"><a href="#L-1784"><span class="linenos">1784</span></a>
</span><span id="L-1785"><a href="#L-1785"><span class="linenos">1785</span></a>    <span class="n">is_known</span> <span class="o">=</span> <span class="nb">property</span><span class="p">(</span><span class="k">lambda</span> <span class="bp">self</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">const</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">)</span>
</span><span id="L-1786"><a href="#L-1786"><span class="linenos">1786</span></a>    <span class="n">is_unknown</span> <span class="o">=</span> <span class="nb">property</span><span class="p">(</span><span class="k">lambda</span> <span class="bp">self</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">const</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">)</span>
</span><span id="L-1787"><a href="#L-1787"><span class="linenos">1787</span></a>
</span><span id="L-1788"><a href="#L-1788"><span class="linenos">1788</span></a>
</span><span id="L-1789"><a href="#L-1789"><span class="linenos">1789</span></a><span class="k">class</span> <span class="nc">LambdaBindingDraft</span><span class="p">(</span><span class="n">NamedTuple</span><span class="p">):</span>
</span><span id="L-1790"><a href="#L-1790"><span class="linenos">1790</span></a>    <span class="k">pass</span>
</span><span id="L-1791"><a href="#L-1791"><span class="linenos">1791</span></a>
</span><span id="L-1792"><a href="#L-1792"><span class="linenos">1792</span></a>
</span><span id="L-1793"><a href="#L-1793"><span class="linenos">1793</span></a><span class="k">class</span> <span class="nc">ConstDraft</span><span class="p">(</span><span class="n">NamedTuple</span><span class="p">):</span>
</span><span id="L-1794"><a href="#L-1794"><span class="linenos">1794</span></a>    <span class="n">val</span><span class="p">:</span> <span class="n">Any</span>
</span><span id="L-1795"><a href="#L-1795"><span class="linenos">1795</span></a>
</span><span id="L-1796"><a href="#L-1796"><span class="linenos">1796</span></a>
</span><span id="L-1797"><a href="#L-1797"><span class="linenos">1797</span></a><span class="k">class</span> <span class="nc">InstructionDraft</span><span class="p">(</span><span class="n">NamedTuple</span><span class="p">):</span>
</span><span id="L-1798"><a href="#L-1798"><span class="linenos">1798</span></a>    <span class="n">prim</span><span class="p">:</span> <span class="n">Operator</span>
</span><span id="L-1799"><a href="#L-1799"><span class="linenos">1799</span></a>    <span class="n">tracers_in</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="s2">&quot;PartialRunTraceTensor&quot;</span><span class="p">]</span>
</span><span id="L-1800"><a href="#L-1800"><span class="linenos">1800</span></a>    <span class="n">params</span><span class="p">:</span> <span class="n">Dict</span><span class="p">[</span><span class="nb">str</span><span class="p">,</span> <span class="n">Any</span><span class="p">]</span>
</span><span id="L-1801"><a href="#L-1801"><span class="linenos">1801</span></a>    <span class="n">symvals_out</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">SymbolicTensor</span><span class="p">]</span>
</span><span id="L-1802"><a href="#L-1802"><span class="linenos">1802</span></a>    <span class="n">tracer_refs_out</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">weakref</span><span class="o">.</span><span class="n">ReferenceType</span><span class="p">[</span><span class="s2">&quot;PartialRunTraceTensor&quot;</span><span class="p">]]</span>
</span><span id="L-1803"><a href="#L-1803"><span class="linenos">1803</span></a>
</span><span id="L-1804"><a href="#L-1804"><span class="linenos">1804</span></a>
</span><span id="L-1805"><a href="#L-1805"><span class="linenos">1805</span></a><span class="n">ProgramDraft</span> <span class="o">=</span> <span class="n">Union</span><span class="p">[</span><span class="n">LambdaBindingDraft</span><span class="p">,</span> <span class="n">ConstDraft</span><span class="p">,</span> <span class="n">InstructionDraft</span><span class="p">]</span>
</span><span id="L-1806"><a href="#L-1806"><span class="linenos">1806</span></a>
</span><span id="L-1807"><a href="#L-1807"><span class="linenos">1807</span></a>
</span><span id="L-1808"><a href="#L-1808"><span class="linenos">1808</span></a><span class="k">class</span> <span class="nc">PartialRunTraceTensor</span><span class="p">(</span><span class="n">TraceTensor</span><span class="p">):</span>
</span><span id="L-1809"><a href="#L-1809"><span class="linenos">1809</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">trace</span><span class="p">,</span> <span class="n">pval</span><span class="p">,</span> <span class="n">draft</span><span class="p">):</span>
</span><span id="L-1810"><a href="#L-1810"><span class="linenos">1810</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">_trace</span> <span class="o">=</span> <span class="n">trace</span>
</span><span id="L-1811"><a href="#L-1811"><span class="linenos">1811</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">pval</span> <span class="o">=</span> <span class="n">pval</span>
</span><span id="L-1812"><a href="#L-1812"><span class="linenos">1812</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">draft</span> <span class="o">=</span> <span class="n">draft</span>
</span><span id="L-1813"><a href="#L-1813"><span class="linenos">1813</span></a>
</span><span id="L-1814"><a href="#L-1814"><span class="linenos">1814</span></a>    <span class="n">symval</span> <span class="o">=</span> <span class="nb">property</span><span class="p">(</span><span class="k">lambda</span> <span class="bp">self</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">pval</span><span class="o">.</span><span class="n">symval</span><span class="p">)</span>
</span><span id="L-1815"><a href="#L-1815"><span class="linenos">1815</span></a>    <span class="n">val</span> <span class="o">=</span> <span class="nb">property</span><span class="p">(</span><span class="k">lambda</span> <span class="bp">self</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">pval</span><span class="o">.</span><span class="n">const</span><span class="p">)</span>
</span><span id="L-1816"><a href="#L-1816"><span class="linenos">1816</span></a>
</span><span id="L-1817"><a href="#L-1817"><span class="linenos">1817</span></a>    <span class="k">def</span> <span class="nf">full_lower</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="L-1818"><a href="#L-1818"><span class="linenos">1818</span></a>        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">pval</span><span class="o">.</span><span class="n">is_known</span><span class="p">:</span>
</span><span id="L-1819"><a href="#L-1819"><span class="linenos">1819</span></a>            <span class="k">return</span> <span class="n">full_lower</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">pval</span><span class="o">.</span><span class="n">const</span><span class="p">)</span>
</span><span id="L-1820"><a href="#L-1820"><span class="linenos">1820</span></a>        <span class="k">return</span> <span class="bp">self</span>
</span><span id="L-1821"><a href="#L-1821"><span class="linenos">1821</span></a>
</span><span id="L-1822"><a href="#L-1822"><span class="linenos">1822</span></a>
</span><span id="L-1823"><a href="#L-1823"><span class="linenos">1823</span></a><span class="k">class</span> <span class="nc">PartialRunTrace</span><span class="p">(</span><span class="n">Trace</span><span class="p">):</span>
</span><span id="L-1824"><a href="#L-1824"><span class="linenos">1824</span></a>    <span class="k">def</span> <span class="nf">new_arg</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">pval</span><span class="p">:</span> <span class="n">PartialValue</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Any</span><span class="p">:</span>
</span><span id="L-1825"><a href="#L-1825"><span class="linenos">1825</span></a>        <span class="k">return</span> <span class="n">PartialRunTraceTensor</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">pval</span><span class="p">,</span> <span class="n">LambdaBindingDraft</span><span class="p">())</span>
</span><span id="L-1826"><a href="#L-1826"><span class="linenos">1826</span></a>
</span><span id="L-1827"><a href="#L-1827"><span class="linenos">1827</span></a>    <span class="k">def</span> <span class="nf">pure</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">val</span><span class="p">:</span> <span class="n">Any</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">PartialRunTraceTensor</span><span class="p">:</span>
</span><span id="L-1828"><a href="#L-1828"><span class="linenos">1828</span></a>        <span class="k">return</span> <span class="n">PartialRunTraceTensor</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">make_known_pval</span><span class="p">(</span><span class="n">val</span><span class="p">),</span> <span class="kc">None</span><span class="p">)</span>
</span><span id="L-1829"><a href="#L-1829"><span class="linenos">1829</span></a>
</span><span id="L-1830"><a href="#L-1830"><span class="linenos">1830</span></a>    <span class="k">def</span> <span class="nf">instantiate_const</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">tracer</span><span class="p">:</span> <span class="n">PartialRunTraceTensor</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">PartialRunTraceTensor</span><span class="p">:</span>
</span><span id="L-1831"><a href="#L-1831"><span class="linenos">1831</span></a>        <span class="k">if</span> <span class="n">tracer</span><span class="o">.</span><span class="n">pval</span><span class="o">.</span><span class="n">is_unknown</span><span class="p">:</span>
</span><span id="L-1832"><a href="#L-1832"><span class="linenos">1832</span></a>            <span class="k">return</span> <span class="n">tracer</span>
</span><span id="L-1833"><a href="#L-1833"><span class="linenos">1833</span></a>        <span class="k">else</span><span class="p">:</span>
</span><span id="L-1834"><a href="#L-1834"><span class="linenos">1834</span></a>            <span class="n">pval</span> <span class="o">=</span> <span class="n">make_unknown_pval</span><span class="p">(</span><span class="n">SymbolicTensor</span><span class="o">.</span><span class="n">like</span><span class="p">(</span><span class="n">tracer</span><span class="o">.</span><span class="n">symval</span><span class="p">))</span>
</span><span id="L-1835"><a href="#L-1835"><span class="linenos">1835</span></a>            <span class="k">return</span> <span class="n">PartialRunTraceTensor</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">pval</span><span class="p">,</span> <span class="n">ConstDraft</span><span class="p">(</span><span class="n">tracer</span><span class="o">.</span><span class="n">pval</span><span class="o">.</span><span class="n">const</span><span class="p">))</span>
</span><span id="L-1836"><a href="#L-1836"><span class="linenos">1836</span></a>
</span><span id="L-1837"><a href="#L-1837"><span class="linenos">1837</span></a>    <span class="k">def</span> <span class="nf">run_op</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">op</span><span class="p">,</span> <span class="n">tracers</span><span class="p">,</span> <span class="n">params</span><span class="p">):</span>
</span><span id="L-1838"><a href="#L-1838"><span class="linenos">1838</span></a>        <span class="n">is_knowns</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">t</span><span class="o">.</span><span class="n">pval</span><span class="o">.</span><span class="n">is_known</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">tracers</span><span class="p">)</span>
</span><span id="L-1839"><a href="#L-1839"><span class="linenos">1839</span></a>
</span><span id="L-1840"><a href="#L-1840"><span class="linenos">1840</span></a>        <span class="k">if</span> <span class="nb">all</span><span class="p">(</span><span class="n">is_knowns</span><span class="p">):</span>
</span><span id="L-1841"><a href="#L-1841"><span class="linenos">1841</span></a>            <span class="k">return</span> <span class="n">bind</span><span class="p">(</span><span class="n">op</span><span class="p">,</span> <span class="o">*</span><span class="n">list_map</span><span class="p">(</span><span class="n">full_lower</span><span class="p">,</span> <span class="n">tracers</span><span class="p">),</span> <span class="o">**</span><span class="n">params</span><span class="p">)</span>
</span><span id="L-1842"><a href="#L-1842"><span class="linenos">1842</span></a>        <span class="k">return</span> <span class="n">op</span><span class="o">.</span><span class="n">partial_run</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">tracers</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)</span>
</span><span id="L-1843"><a href="#L-1843"><span class="linenos">1843</span></a>
</span><span id="L-1844"><a href="#L-1844"><span class="linenos">1844</span></a>
</span><span id="L-1845"><a href="#L-1845"><span class="linenos">1845</span></a><span class="n">trace_stack</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">MainTrace</span><span class="p">]</span> <span class="o">=</span> <span class="p">[]</span>
</span><span id="L-1846"><a href="#L-1846"><span class="linenos">1846</span></a><span class="n">stashed_trace</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="n">MainTrace</span><span class="p">]</span> <span class="o">=</span> <span class="kc">None</span>
</span><span id="L-1847"><a href="#L-1847"><span class="linenos">1847</span></a><span class="n">trace_stack</span> <span class="o">+=</span> <span class="p">[</span><span class="n">MainTrace</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="n">RunTrace</span><span class="p">,</span> <span class="kc">None</span><span class="p">)]</span>
</span><span id="L-1848"><a href="#L-1848"><span class="linenos">1848</span></a>
</span><span id="L-1849"><a href="#L-1849"><span class="linenos">1849</span></a>
</span><span id="L-1850"><a href="#L-1850"><span class="linenos">1850</span></a><span class="k">class</span> <span class="nc">UndefBackend</span><span class="p">:</span>
</span><span id="L-1851"><a href="#L-1851"><span class="linenos">1851</span></a>    <span class="k">def</span> <span class="fm">__getattr__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">attr</span><span class="p">):</span>
</span><span id="L-1852"><a href="#L-1852"><span class="linenos">1852</span></a>        <span class="k">raise</span> <span class="ne">NotImplementedError</span><span class="p">(</span><span class="s2">&quot;Backend not init yet with slope.core.set_backend(backend)&quot;</span><span class="p">)</span>
</span><span id="L-1853"><a href="#L-1853"><span class="linenos">1853</span></a>
</span><span id="L-1854"><a href="#L-1854"><span class="linenos">1854</span></a>
</span><span id="L-1855"><a href="#L-1855"><span class="linenos">1855</span></a><span class="n">backend</span> <span class="o">=</span> <span class="n">UndefBackend</span><span class="p">()</span>
</span><span id="L-1856"><a href="#L-1856"><span class="linenos">1856</span></a>
</span><span id="L-1857"><a href="#L-1857"><span class="linenos">1857</span></a>
</span><span id="L-1858"><a href="#L-1858"><span class="linenos">1858</span></a><span class="k">def</span> <span class="nf">set_backend</span><span class="p">(</span><span class="n">name</span><span class="p">,</span> <span class="n">where</span><span class="o">=</span><span class="s2">&quot;slope.backends&quot;</span><span class="p">):</span>
</span><span id="L-1859"><a href="#L-1859"><span class="linenos">1859</span></a>    <span class="k">global</span> <span class="n">backend</span>
</span><span id="L-1860"><a href="#L-1860"><span class="linenos">1860</span></a>    <span class="n">backend</span> <span class="o">=</span> <span class="n">importlib</span><span class="o">.</span><span class="n">import_module</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">where</span><span class="si">}</span><span class="s2">.</span><span class="si">{</span><span class="n">name</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">)</span><span class="o">.</span><span class="n">backend</span>
</span><span id="L-1861"><a href="#L-1861"><span class="linenos">1861</span></a>    <span class="kn">import</span> <span class="nn">slope.nn</span> <span class="k">as</span> <span class="nn">nn</span>
</span><span id="L-1862"><a href="#L-1862"><span class="linenos">1862</span></a>    <span class="c1"># backend.register_node(nn.Module, nn.Module.flatten, nn.Module.unflatten, &quot;Module&quot;)</span>
</span><span id="L-1863"><a href="#L-1863"><span class="linenos">1863</span></a>
</span><span id="L-1864"><a href="#L-1864"><span class="linenos">1864</span></a>    <span class="n">dblog</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;slope backend is </span><span class="si">{</span><span class="n">backend</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">,</span> <span class="n">enable</span><span class="o">=</span><span class="n">backend</span><span class="o">.</span><span class="n">LOG_INIT</span><span class="p">)</span>
</span><span id="L-1865"><a href="#L-1865"><span class="linenos">1865</span></a>
</span><span id="L-1866"><a href="#L-1866"><span class="linenos">1866</span></a>
</span><span id="L-1867"><a href="#L-1867"><span class="linenos">1867</span></a><span class="k">def</span> <span class="nf">stack_str</span><span class="p">():</span>
</span><span id="L-1868"><a href="#L-1868"><span class="linenos">1868</span></a>    <span class="n">ret</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span>
</span><span id="L-1869"><a href="#L-1869"><span class="linenos">1869</span></a>    <span class="k">for</span> <span class="n">trace</span> <span class="ow">in</span> <span class="n">trace_stack</span><span class="p">:</span>
</span><span id="L-1870"><a href="#L-1870"><span class="linenos">1870</span></a>        <span class="n">ret</span> <span class="o">+=</span> <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">trace</span><span class="o">.</span><span class="n">level</span><span class="si">}</span><span class="s2">: </span><span class="si">{</span><span class="n">trace</span><span class="o">.</span><span class="n">trace_type</span><span class="o">.</span><span class="vm">__name__</span><span class="si">}</span><span class="se">\t</span><span class="si">{</span><span class="n">trace</span><span class="o">.</span><span class="n">global_data</span><span class="si">=}</span><span class="se">\n</span><span class="s2">&quot;</span>
</span><span id="L-1871"><a href="#L-1871"><span class="linenos">1871</span></a>    <span class="k">return</span> <span class="n">ret</span>
</span><span id="L-1872"><a href="#L-1872"><span class="linenos">1872</span></a>
</span><span id="L-1873"><a href="#L-1873"><span class="linenos">1873</span></a>
</span><span id="L-1874"><a href="#L-1874"><span class="linenos">1874</span></a><span class="k">def</span> <span class="nf">make_known_pval</span><span class="p">(</span><span class="n">val</span><span class="p">:</span> <span class="n">Any</span><span class="p">):</span>
</span><span id="L-1875"><a href="#L-1875"><span class="linenos">1875</span></a>    <span class="k">return</span> <span class="n">PartialValue</span><span class="p">(</span><span class="n">get_symval</span><span class="p">(</span><span class="n">val</span><span class="p">),</span> <span class="n">val</span><span class="p">)</span>
</span><span id="L-1876"><a href="#L-1876"><span class="linenos">1876</span></a>
</span><span id="L-1877"><a href="#L-1877"><span class="linenos">1877</span></a>
</span><span id="L-1878"><a href="#L-1878"><span class="linenos">1878</span></a><span class="k">def</span> <span class="nf">make_unknown_pval</span><span class="p">(</span><span class="n">symval</span><span class="p">:</span> <span class="n">SymbolicTensor</span><span class="p">):</span>
</span><span id="L-1879"><a href="#L-1879"><span class="linenos">1879</span></a>    <span class="k">return</span> <span class="n">PartialValue</span><span class="p">(</span><span class="n">symval</span><span class="p">,</span> <span class="kc">None</span><span class="p">)</span>
</span><span id="L-1880"><a href="#L-1880"><span class="linenos">1880</span></a>
</span><span id="L-1881"><a href="#L-1881"><span class="linenos">1881</span></a>
</span><span id="L-1882"><a href="#L-1882"><span class="linenos">1882</span></a><span class="k">def</span> <span class="nf">get_symval</span><span class="p">(</span><span class="n">x</span><span class="p">):</span>
</span><span id="L-1883"><a href="#L-1883"><span class="linenos">1883</span></a>    <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">TraceTensor</span><span class="p">):</span>
</span><span id="L-1884"><a href="#L-1884"><span class="linenos">1884</span></a>        <span class="k">return</span> <span class="n">x</span><span class="o">.</span><span class="n">symval</span>
</span><span id="L-1885"><a href="#L-1885"><span class="linenos">1885</span></a>    <span class="k">elif</span> <span class="nb">type</span><span class="p">(</span><span class="n">x</span><span class="p">)</span> <span class="ow">in</span> <span class="n">TraceTensor</span><span class="o">.</span><span class="n">PYTHON_TYPES</span><span class="p">:</span>
</span><span id="L-1886"><a href="#L-1886"><span class="linenos">1886</span></a>        <span class="k">return</span> <span class="n">backend</span><span class="o">.</span><span class="n">tensor</span><span class="p">(</span><span class="n">x</span><span class="p">)</span>
</span><span id="L-1887"><a href="#L-1887"><span class="linenos">1887</span></a>    <span class="k">elif</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">Tensor</span><span class="p">):</span>
</span><span id="L-1888"><a href="#L-1888"><span class="linenos">1888</span></a>        <span class="k">return</span> <span class="n">x</span>
</span><span id="L-1889"><a href="#L-1889"><span class="linenos">1889</span></a>    <span class="k">elif</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">SymbolicTensor</span><span class="p">):</span>
</span><span id="L-1890"><a href="#L-1890"><span class="linenos">1890</span></a>        <span class="k">return</span> <span class="n">x</span>
</span><span id="L-1891"><a href="#L-1891"><span class="linenos">1891</span></a>    <span class="k">else</span><span class="p">:</span>
</span><span id="L-1892"><a href="#L-1892"><span class="linenos">1892</span></a>        <span class="k">raise</span> <span class="ne">TypeError</span><span class="p">(</span><span class="nb">type</span><span class="p">(</span><span class="n">x</span><span class="p">))</span>
</span><span id="L-1893"><a href="#L-1893"><span class="linenos">1893</span></a>
</span><span id="L-1894"><a href="#L-1894"><span class="linenos">1894</span></a>
</span><span id="L-1895"><a href="#L-1895"><span class="linenos">1895</span></a><span class="k">def</span> <span class="nf">tree_flatten</span><span class="p">(</span><span class="n">x</span><span class="p">:</span> <span class="n">Any</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Any</span><span class="p">:</span>
</span><span id="L-1896"><a href="#L-1896"><span class="linenos">1896</span></a>    <span class="k">def</span> <span class="nf">_tree_flatten</span><span class="p">(</span><span class="n">x_</span><span class="p">:</span> <span class="n">Any</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Tuple</span><span class="p">[</span><span class="n">Iterable</span><span class="p">,</span> <span class="n">Union</span><span class="p">[</span><span class="n">TreeDef</span><span class="p">,</span> <span class="n">Leaf</span><span class="p">]]:</span>
</span><span id="L-1897"><a href="#L-1897"><span class="linenos">1897</span></a>        <span class="n">node_type</span> <span class="o">=</span> <span class="kc">None</span>
</span><span id="L-1898"><a href="#L-1898"><span class="linenos">1898</span></a>        <span class="k">for</span> <span class="n">k</span> <span class="ow">in</span> <span class="n">backend</span><span class="o">.</span><span class="n">node_types</span><span class="o">.</span><span class="n">keys</span><span class="p">():</span>
</span><span id="L-1899"><a href="#L-1899"><span class="linenos">1899</span></a>            <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">x_</span><span class="p">,</span> <span class="n">k</span><span class="p">):</span>
</span><span id="L-1900"><a href="#L-1900"><span class="linenos">1900</span></a>                <span class="n">node_type</span> <span class="o">=</span> <span class="n">backend</span><span class="o">.</span><span class="n">node_types</span><span class="p">[</span><span class="n">k</span><span class="p">]</span>
</span><span id="L-1901"><a href="#L-1901"><span class="linenos">1901</span></a>
</span><span id="L-1902"><a href="#L-1902"><span class="linenos">1902</span></a>        <span class="k">if</span> <span class="n">node_type</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
</span><span id="L-1903"><a href="#L-1903"><span class="linenos">1903</span></a>            <span class="n">node_metadata</span><span class="p">,</span> <span class="n">children</span> <span class="o">=</span> <span class="n">node_type</span><span class="o">.</span><span class="n">flatten</span><span class="p">(</span><span class="n">x_</span><span class="p">)</span>
</span><span id="L-1904"><a href="#L-1904"><span class="linenos">1904</span></a>            <span class="n">children_flat</span><span class="p">,</span> <span class="n">child_trees</span> <span class="o">=</span> <span class="n">unzip2</span><span class="p">(</span><span class="n">list_map</span><span class="p">(</span><span class="n">_tree_flatten</span><span class="p">,</span> <span class="n">children</span><span class="p">))</span>
</span><span id="L-1905"><a href="#L-1905"><span class="linenos">1905</span></a>            <span class="n">children_iter</span> <span class="o">=</span> <span class="n">itertools</span><span class="o">.</span><span class="n">chain</span><span class="o">.</span><span class="n">from_iterable</span><span class="p">(</span><span class="n">children_flat</span><span class="p">)</span>
</span><span id="L-1906"><a href="#L-1906"><span class="linenos">1906</span></a>            <span class="n">treedef</span> <span class="o">=</span> <span class="n">TreeDef</span><span class="p">(</span><span class="n">node_type</span><span class="p">,</span> <span class="n">node_metadata</span><span class="p">,</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">child_trees</span><span class="p">))</span>
</span><span id="L-1907"><a href="#L-1907"><span class="linenos">1907</span></a>            <span class="k">return</span> <span class="n">children_iter</span><span class="p">,</span> <span class="n">treedef</span>
</span><span id="L-1908"><a href="#L-1908"><span class="linenos">1908</span></a>        <span class="k">else</span><span class="p">:</span>
</span><span id="L-1909"><a href="#L-1909"><span class="linenos">1909</span></a>            <span class="k">return</span> <span class="p">(</span><span class="n">x_</span><span class="p">,),</span> <span class="n">Leaf</span><span class="p">(</span><span class="n">x_</span><span class="p">)</span>
</span><span id="L-1910"><a href="#L-1910"><span class="linenos">1910</span></a>
</span><span id="L-1911"><a href="#L-1911"><span class="linenos">1911</span></a>    <span class="n">children_iter</span><span class="p">,</span> <span class="n">treedef</span> <span class="o">=</span> <span class="n">_tree_flatten</span><span class="p">(</span><span class="n">x</span><span class="p">)</span>
</span><span id="L-1912"><a href="#L-1912"><span class="linenos">1912</span></a>    <span class="k">return</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">children_iter</span><span class="p">),</span> <span class="n">treedef</span>
</span><span id="L-1913"><a href="#L-1913"><span class="linenos">1913</span></a>
</span><span id="L-1914"><a href="#L-1914"><span class="linenos">1914</span></a>
</span><span id="L-1915"><a href="#L-1915"><span class="linenos">1915</span></a><span class="k">def</span> <span class="nf">tree_unflatten</span><span class="p">(</span><span class="n">treedef</span><span class="p">:</span> <span class="n">TreeDef</span><span class="p">,</span> <span class="n">xs</span><span class="p">:</span> <span class="n">Tuple</span><span class="p">[</span><span class="n">Any</span><span class="p">])</span> <span class="o">-&gt;</span> <span class="n">Any</span><span class="p">:</span>
</span><span id="L-1916"><a href="#L-1916"><span class="linenos">1916</span></a>    <span class="k">def</span> <span class="nf">_tree_unflatten</span><span class="p">(</span><span class="n">treedef_</span><span class="p">:</span> <span class="n">TreeDef</span><span class="p">,</span> <span class="n">xs_</span><span class="p">:</span> <span class="n">Iterator</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Any</span><span class="p">:</span>
</span><span id="L-1917"><a href="#L-1917"><span class="linenos">1917</span></a>        <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">treedef_</span><span class="p">,</span> <span class="n">Leaf</span><span class="p">):</span>
</span><span id="L-1918"><a href="#L-1918"><span class="linenos">1918</span></a>            <span class="n">dblog</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;    tree leaf found: </span><span class="si">{</span><span class="n">xs_</span><span class="si">}</span><span class="se">\n</span><span class="s2">&quot;</span><span class="p">,</span> <span class="n">enable</span><span class="o">=</span><span class="n">backend</span><span class="o">.</span><span class="n">LOG_TREE</span><span class="p">)</span>
</span><span id="L-1919"><a href="#L-1919"><span class="linenos">1919</span></a>            <span class="k">return</span> <span class="nb">next</span><span class="p">(</span><span class="n">xs_</span><span class="p">)</span>
</span><span id="L-1920"><a href="#L-1920"><span class="linenos">1920</span></a>        <span class="k">else</span><span class="p">:</span>
</span><span id="L-1921"><a href="#L-1921"><span class="linenos">1921</span></a>            <span class="n">dblog</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;    now</span><span class="se">\n</span><span class="s2">  </span><span class="si">{</span><span class="n">treedef_</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">,</span> <span class="n">enable</span><span class="o">=</span><span class="n">backend</span><span class="o">.</span><span class="n">LOG_TREE</span><span class="p">)</span>
</span><span id="L-1922"><a href="#L-1922"><span class="linenos">1922</span></a>            <span class="n">children</span> <span class="o">=</span> <span class="p">(</span><span class="n">_tree_unflatten</span><span class="p">(</span><span class="n">t</span><span class="p">,</span> <span class="n">xs_</span><span class="p">)</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">treedef_</span><span class="o">.</span><span class="n">child_treedefs</span><span class="p">)</span>
</span><span id="L-1923"><a href="#L-1923"><span class="linenos">1923</span></a>            <span class="n">dblog</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">children</span><span class="si">=}</span><span class="se">\n</span><span class="s2">&quot;</span><span class="p">,</span> <span class="n">enable</span><span class="o">=</span><span class="n">backend</span><span class="o">.</span><span class="n">LOG_TREE</span><span class="p">)</span>
</span><span id="L-1924"><a href="#L-1924"><span class="linenos">1924</span></a>            <span class="k">return</span> <span class="n">treedef_</span><span class="o">.</span><span class="n">node_type</span><span class="o">.</span><span class="n">unflatten</span><span class="p">(</span><span class="n">treedef_</span><span class="o">.</span><span class="n">node_metadata</span><span class="p">,</span> <span class="n">children</span><span class="p">)</span>
</span><span id="L-1925"><a href="#L-1925"><span class="linenos">1925</span></a>
</span><span id="L-1926"><a href="#L-1926"><span class="linenos">1926</span></a>    <span class="n">dblog</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;unflattening </span><span class="si">{</span><span class="n">treedef</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">,</span> <span class="n">enable</span><span class="o">=</span><span class="n">backend</span><span class="o">.</span><span class="n">LOG_TREE</span><span class="p">)</span>
</span><span id="L-1927"><a href="#L-1927"><span class="linenos">1927</span></a>    <span class="k">return</span> <span class="n">_tree_unflatten</span><span class="p">(</span><span class="n">treedef</span><span class="p">,</span> <span class="nb">iter</span><span class="p">(</span><span class="n">xs</span><span class="p">))</span>
</span><span id="L-1928"><a href="#L-1928"><span class="linenos">1928</span></a>    <span class="c1"># with Timing(f&quot;\nTREE:\n{treedef}&quot;):</span>
</span><span id="L-1929"><a href="#L-1929"><span class="linenos">1929</span></a>    <span class="c1">#     ret = _tree_unflatten(treedef, iter(xs))</span>
</span><span id="L-1930"><a href="#L-1930"><span class="linenos">1930</span></a>    <span class="c1"># return ret</span>
</span><span id="L-1931"><a href="#L-1931"><span class="linenos">1931</span></a>
</span><span id="L-1932"><a href="#L-1932"><span class="linenos">1932</span></a>
</span><span id="L-1933"><a href="#L-1933"><span class="linenos">1933</span></a><span class="k">def</span> <span class="nf">tree_transpose</span><span class="p">(</span>
</span><span id="L-1934"><a href="#L-1934"><span class="linenos">1934</span></a>    <span class="n">outer_treedef</span><span class="p">:</span> <span class="n">TreeDef</span><span class="p">,</span>
</span><span id="L-1935"><a href="#L-1935"><span class="linenos">1935</span></a>    <span class="n">inner_treedef</span><span class="p">:</span> <span class="n">TreeDef</span><span class="p">,</span>
</span><span id="L-1936"><a href="#L-1936"><span class="linenos">1936</span></a>    <span class="n">tree_to_transpose</span><span class="p">:</span> <span class="n">Any</span><span class="p">,</span>
</span><span id="L-1937"><a href="#L-1937"><span class="linenos">1937</span></a><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Any</span><span class="p">:</span>
</span><span id="L-1938"><a href="#L-1938"><span class="linenos">1938</span></a>    <span class="n">flat</span><span class="p">,</span> <span class="n">treedef</span> <span class="o">=</span> <span class="n">tree_flatten</span><span class="p">(</span><span class="n">tree_to_transpose</span><span class="p">)</span>
</span><span id="L-1939"><a href="#L-1939"><span class="linenos">1939</span></a>    <span class="n">inner_size</span> <span class="o">=</span> <span class="n">inner_treedef</span><span class="o">.</span><span class="n">num_leaves</span>
</span><span id="L-1940"><a href="#L-1940"><span class="linenos">1940</span></a>    <span class="n">outer_size</span> <span class="o">=</span> <span class="n">outer_treedef</span><span class="o">.</span><span class="n">num_leaves</span>
</span><span id="L-1941"><a href="#L-1941"><span class="linenos">1941</span></a>    <span class="k">if</span> <span class="n">treedef</span><span class="o">.</span><span class="n">num_leaves</span> <span class="o">!=</span> <span class="p">(</span><span class="n">inner_size</span> <span class="o">*</span> <span class="n">outer_size</span><span class="p">):</span>
</span><span id="L-1942"><a href="#L-1942"><span class="linenos">1942</span></a>        <span class="k">raise</span> <span class="ne">TypeError</span>
</span><span id="L-1943"><a href="#L-1943"><span class="linenos">1943</span></a>    <span class="n">iter_flat</span> <span class="o">=</span> <span class="nb">iter</span><span class="p">(</span><span class="n">flat</span><span class="p">)</span>
</span><span id="L-1944"><a href="#L-1944"><span class="linenos">1944</span></a>    <span class="n">lol</span> <span class="o">=</span> <span class="p">[[</span><span class="nb">next</span><span class="p">(</span><span class="n">iter_flat</span><span class="p">)</span> <span class="k">for</span> <span class="n">_</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">inner_size</span><span class="p">)]</span> <span class="k">for</span> <span class="n">__</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">outer_size</span><span class="p">)]</span>
</span><span id="L-1945"><a href="#L-1945"><span class="linenos">1945</span></a>    <span class="n">permuted_lol</span> <span class="o">=</span> <span class="nb">zip</span><span class="p">(</span><span class="o">*</span><span class="n">lol</span><span class="p">)</span>
</span><span id="L-1946"><a href="#L-1946"><span class="linenos">1946</span></a>    <span class="n">subtrees</span> <span class="o">=</span> <span class="nb">map</span><span class="p">(</span><span class="n">partial</span><span class="p">(</span><span class="n">tree_unflatten</span><span class="p">,</span> <span class="n">outer_treedef</span><span class="p">),</span> <span class="n">permuted_lol</span><span class="p">)</span>
</span><span id="L-1947"><a href="#L-1947"><span class="linenos">1947</span></a>    <span class="k">return</span> <span class="n">tree_unflatten</span><span class="p">(</span><span class="n">inner_treedef</span><span class="p">,</span> <span class="n">subtrees</span><span class="p">)</span>
</span><span id="L-1948"><a href="#L-1948"><span class="linenos">1948</span></a>
</span><span id="L-1949"><a href="#L-1949"><span class="linenos">1949</span></a>
</span><span id="L-1950"><a href="#L-1950"><span class="linenos">1950</span></a><span class="k">def</span> <span class="nf">flatten_fn</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="n">in_tree</span><span class="p">,</span> <span class="o">*</span><span class="p">,</span> <span class="n">has_aux</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>
</span><span id="L-1951"><a href="#L-1951"><span class="linenos">1951</span></a>    <span class="n">store</span> <span class="o">=</span> <span class="n">Store</span><span class="p">()</span>
</span><span id="L-1952"><a href="#L-1952"><span class="linenos">1952</span></a>
</span><span id="L-1953"><a href="#L-1953"><span class="linenos">1953</span></a>    <span class="k">def</span> <span class="nf">flat_fn</span><span class="p">(</span><span class="o">*</span><span class="n">args_flat</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="L-1954"><a href="#L-1954"><span class="linenos">1954</span></a>        <span class="n">tree_args</span> <span class="o">=</span> <span class="n">tree_unflatten</span><span class="p">(</span><span class="n">in_tree</span><span class="p">,</span> <span class="n">args_flat</span><span class="p">)</span>
</span><span id="L-1955"><a href="#L-1955"><span class="linenos">1955</span></a>        <span class="n">out</span> <span class="o">=</span> <span class="n">f</span><span class="p">(</span><span class="o">*</span><span class="n">tree_args</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)</span>
</span><span id="L-1956"><a href="#L-1956"><span class="linenos">1956</span></a>        <span class="k">if</span> <span class="n">has_aux</span><span class="p">:</span>
</span><span id="L-1957"><a href="#L-1957"><span class="linenos">1957</span></a>            <span class="n">out</span><span class="p">,</span> <span class="n">aux</span> <span class="o">=</span> <span class="n">out</span>
</span><span id="L-1958"><a href="#L-1958"><span class="linenos">1958</span></a>        <span class="n">out_flat</span><span class="p">,</span> <span class="n">out_tree</span> <span class="o">=</span> <span class="n">tree_flatten</span><span class="p">(</span><span class="n">out</span><span class="p">)</span>
</span><span id="L-1959"><a href="#L-1959"><span class="linenos">1959</span></a>        <span class="n">store</span><span class="o">.</span><span class="n">set_value</span><span class="p">(</span><span class="n">out_tree</span><span class="p">)</span>
</span><span id="L-1960"><a href="#L-1960"><span class="linenos">1960</span></a>        <span class="k">return</span> <span class="p">(</span><span class="n">out_flat</span><span class="p">,</span> <span class="n">aux</span><span class="p">)</span> <span class="k">if</span> <span class="n">has_aux</span> <span class="k">else</span> <span class="n">out_flat</span>
</span><span id="L-1961"><a href="#L-1961"><span class="linenos">1961</span></a>
</span><span id="L-1962"><a href="#L-1962"><span class="linenos">1962</span></a>    <span class="k">return</span> <span class="n">flat_fn</span><span class="p">,</span> <span class="n">store</span>
</span><span id="L-1963"><a href="#L-1963"><span class="linenos">1963</span></a>
</span><span id="L-1964"><a href="#L-1964"><span class="linenos">1964</span></a>
</span><span id="L-1965"><a href="#L-1965"><span class="linenos">1965</span></a><span class="k">def</span> <span class="nf">tree_map</span><span class="p">(</span><span class="n">f</span><span class="p">:</span> <span class="n">Callable</span><span class="p">[</span><span class="o">...</span><span class="p">,</span> <span class="n">Any</span><span class="p">],</span> <span class="n">tree</span><span class="p">,</span> <span class="o">*</span><span class="n">rest</span><span class="p">,</span> <span class="n">out_leaf</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Any</span><span class="p">:</span>
</span><span id="L-1966"><a href="#L-1966"><span class="linenos">1966</span></a>    <span class="n">leaves</span><span class="p">,</span> <span class="n">treedef</span> <span class="o">=</span> <span class="n">tree_flatten</span><span class="p">(</span><span class="n">tree</span><span class="p">)</span>
</span><span id="L-1967"><a href="#L-1967"><span class="linenos">1967</span></a>    <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">rest</span><span class="p">)</span> <span class="o">==</span> <span class="mi">0</span><span class="p">:</span>
</span><span id="L-1968"><a href="#L-1968"><span class="linenos">1968</span></a>        <span class="n">out_tree_flat</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">f</span><span class="p">(</span><span class="n">leaf</span><span class="p">)</span> <span class="k">for</span> <span class="n">leaf</span> <span class="ow">in</span> <span class="n">leaves</span><span class="p">)</span>
</span><span id="L-1969"><a href="#L-1969"><span class="linenos">1969</span></a>        <span class="n">out_tree</span> <span class="o">=</span> <span class="n">tree_unflatten</span><span class="p">(</span><span class="n">treedef</span><span class="p">,</span> <span class="n">out_tree_flat</span><span class="p">)</span>
</span><span id="L-1970"><a href="#L-1970"><span class="linenos">1970</span></a>    <span class="k">else</span><span class="p">:</span>
</span><span id="L-1971"><a href="#L-1971"><span class="linenos">1971</span></a>        <span class="n">all_leaves</span> <span class="o">=</span> <span class="p">[</span><span class="n">leaves</span><span class="p">]</span>
</span><span id="L-1972"><a href="#L-1972"><span class="linenos">1972</span></a>        <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">rest</span><span class="p">:</span>
</span><span id="L-1973"><a href="#L-1973"><span class="linenos">1973</span></a>            <span class="n">t_leaves</span><span class="p">,</span> <span class="n">t_treedef</span> <span class="o">=</span> <span class="n">tree_flatten</span><span class="p">(</span><span class="n">t</span><span class="p">)</span>
</span><span id="L-1974"><a href="#L-1974"><span class="linenos">1974</span></a>            <span class="k">assert</span> <span class="n">t_treedef</span> <span class="o">==</span> <span class="n">treedef</span>
</span><span id="L-1975"><a href="#L-1975"><span class="linenos">1975</span></a>            <span class="n">all_leaves</span> <span class="o">+=</span> <span class="p">[</span><span class="n">t_leaves</span><span class="p">]</span>
</span><span id="L-1976"><a href="#L-1976"><span class="linenos">1976</span></a>
</span><span id="L-1977"><a href="#L-1977"><span class="linenos">1977</span></a>        <span class="n">out_tree_flat</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">f</span><span class="p">(</span><span class="o">*</span><span class="n">xs</span><span class="p">)</span> <span class="k">for</span> <span class="n">xs</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="o">*</span><span class="n">all_leaves</span><span class="p">))</span>
</span><span id="L-1978"><a href="#L-1978"><span class="linenos">1978</span></a>        <span class="n">out_tree</span> <span class="o">=</span> <span class="n">tree_unflatten</span><span class="p">(</span><span class="n">treedef</span><span class="p">,</span> <span class="n">out_tree_flat</span><span class="p">)</span>
</span><span id="L-1979"><a href="#L-1979"><span class="linenos">1979</span></a>    <span class="n">ret</span> <span class="o">=</span> <span class="n">out_tree</span>
</span><span id="L-1980"><a href="#L-1980"><span class="linenos">1980</span></a>    <span class="k">if</span> <span class="n">out_leaf</span><span class="p">:</span>
</span><span id="L-1981"><a href="#L-1981"><span class="linenos">1981</span></a>        <span class="n">ret</span> <span class="o">=</span> <span class="p">(</span><span class="n">ret</span><span class="p">,</span> <span class="n">tree_flatten</span><span class="p">(</span><span class="n">out_tree_flat</span><span class="p">[</span><span class="mi">0</span><span class="p">]))</span>
</span><span id="L-1982"><a href="#L-1982"><span class="linenos">1982</span></a>    <span class="k">return</span> <span class="n">ret</span>
</span><span id="L-1983"><a href="#L-1983"><span class="linenos">1983</span></a>
</span><span id="L-1984"><a href="#L-1984"><span class="linenos">1984</span></a>
</span><span id="L-1985"><a href="#L-1985"><span class="linenos">1985</span></a><span class="nd">@contextmanager</span>
</span><span id="L-1986"><a href="#L-1986"><span class="linenos">1986</span></a><span class="k">def</span> <span class="nf">new_main_trace</span><span class="p">(</span><span class="n">trace_type</span><span class="p">:</span> <span class="n">Type</span><span class="p">[</span><span class="s2">&quot;Trace&quot;</span><span class="p">],</span> <span class="n">global_data</span><span class="o">=</span><span class="kc">None</span><span class="p">):</span>
</span><span id="L-1987"><a href="#L-1987"><span class="linenos">1987</span></a>    <span class="k">global</span> <span class="n">trace_stack</span>
</span><span id="L-1988"><a href="#L-1988"><span class="linenos">1988</span></a>    <span class="n">level</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">trace_stack</span><span class="p">)</span>
</span><span id="L-1989"><a href="#L-1989"><span class="linenos">1989</span></a>    <span class="n">main</span> <span class="o">=</span> <span class="n">MainTrace</span><span class="p">(</span><span class="n">level</span><span class="p">,</span> <span class="n">trace_type</span><span class="p">,</span> <span class="n">global_data</span><span class="p">)</span>
</span><span id="L-1990"><a href="#L-1990"><span class="linenos">1990</span></a>    <span class="n">trace_stack</span> <span class="o">+=</span> <span class="p">[</span><span class="n">main</span><span class="p">]</span>
</span><span id="L-1991"><a href="#L-1991"><span class="linenos">1991</span></a>
</span><span id="L-1992"><a href="#L-1992"><span class="linenos">1992</span></a>    <span class="k">try</span><span class="p">:</span>
</span><span id="L-1993"><a href="#L-1993"><span class="linenos">1993</span></a>        <span class="k">yield</span> <span class="n">main</span>
</span><span id="L-1994"><a href="#L-1994"><span class="linenos">1994</span></a>    <span class="k">finally</span><span class="p">:</span>
</span><span id="L-1995"><a href="#L-1995"><span class="linenos">1995</span></a>        <span class="n">trace_stack</span><span class="o">.</span><span class="n">pop</span><span class="p">()</span>
</span><span id="L-1996"><a href="#L-1996"><span class="linenos">1996</span></a>
</span><span id="L-1997"><a href="#L-1997"><span class="linenos">1997</span></a>
</span><span id="L-1998"><a href="#L-1998"><span class="linenos">1998</span></a><span class="k">def</span> <span class="nf">bind</span><span class="p">(</span><span class="n">op</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="L-1999"><a href="#L-1999"><span class="linenos">1999</span></a>    <span class="n">top_trace</span> <span class="o">=</span> <span class="n">find_top_trace</span><span class="p">(</span><span class="n">args</span><span class="p">)</span>
</span><span id="L-2000"><a href="#L-2000"><span class="linenos">2000</span></a>    <span class="n">tracers</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">([</span><span class="n">full_raise</span><span class="p">(</span><span class="n">top_trace</span><span class="p">,</span> <span class="n">arg</span><span class="p">)</span> <span class="k">for</span> <span class="n">arg</span> <span class="ow">in</span> <span class="n">args</span><span class="p">])</span>
</span><span id="L-2001"><a href="#L-2001"><span class="linenos">2001</span></a>    <span class="n">outs</span> <span class="o">=</span> <span class="n">top_trace</span><span class="o">.</span><span class="n">run_op</span><span class="p">(</span><span class="n">op</span><span class="p">,</span> <span class="n">tracers</span><span class="p">,</span> <span class="n">params</span><span class="p">)</span>
</span><span id="L-2002"><a href="#L-2002"><span class="linenos">2002</span></a>    <span class="n">lowered</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">([</span><span class="n">full_lower</span><span class="p">(</span><span class="n">out</span><span class="p">)</span> <span class="k">for</span> <span class="n">out</span> <span class="ow">in</span> <span class="n">outs</span><span class="p">])</span>
</span><span id="L-2003"><a href="#L-2003"><span class="linenos">2003</span></a>    <span class="k">return</span> <span class="n">lowered</span>
</span><span id="L-2004"><a href="#L-2004"><span class="linenos">2004</span></a>
</span><span id="L-2005"><a href="#L-2005"><span class="linenos">2005</span></a>
</span><span id="L-2006"><a href="#L-2006"><span class="linenos">2006</span></a><span class="k">def</span> <span class="nf">find_top_trace</span><span class="p">(</span><span class="n">xs</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Trace</span><span class="p">:</span>
</span><span id="L-2007"><a href="#L-2007"><span class="linenos">2007</span></a>    <span class="n">arrs</span> <span class="o">=</span> <span class="p">[]</span>
</span><span id="L-2008"><a href="#L-2008"><span class="linenos">2008</span></a>
</span><span id="L-2009"><a href="#L-2009"><span class="linenos">2009</span></a>    <span class="k">def</span> <span class="nf">get_arr_from_seq</span><span class="p">(</span><span class="n">seq</span><span class="p">):</span>
</span><span id="L-2010"><a href="#L-2010"><span class="linenos">2010</span></a>        <span class="k">nonlocal</span> <span class="n">arrs</span>
</span><span id="L-2011"><a href="#L-2011"><span class="linenos">2011</span></a>        <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">seq</span><span class="p">:</span>
</span><span id="L-2012"><a href="#L-2012"><span class="linenos">2012</span></a>            <span class="k">if</span> <span class="nb">type</span><span class="p">(</span><span class="n">x</span><span class="p">)</span> <span class="ow">in</span> <span class="p">(</span><span class="nb">tuple</span><span class="p">,</span> <span class="nb">list</span><span class="p">):</span>
</span><span id="L-2013"><a href="#L-2013"><span class="linenos">2013</span></a>                <span class="n">get_arr_from_seq</span><span class="p">(</span><span class="n">x</span><span class="p">)</span>
</span><span id="L-2014"><a href="#L-2014"><span class="linenos">2014</span></a>            <span class="k">elif</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">TraceTensor</span><span class="p">):</span>
</span><span id="L-2015"><a href="#L-2015"><span class="linenos">2015</span></a>                <span class="n">arrs</span> <span class="o">+=</span> <span class="p">[</span><span class="n">x</span><span class="p">]</span>
</span><span id="L-2016"><a href="#L-2016"><span class="linenos">2016</span></a>
</span><span id="L-2017"><a href="#L-2017"><span class="linenos">2017</span></a>    <span class="n">get_arr_from_seq</span><span class="p">(</span><span class="n">xs</span><span class="p">)</span>
</span><span id="L-2018"><a href="#L-2018"><span class="linenos">2018</span></a>    <span class="n">arrs</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">arrs</span><span class="p">)</span>
</span><span id="L-2019"><a href="#L-2019"><span class="linenos">2019</span></a>    <span class="n">top_main</span> <span class="o">=</span> <span class="nb">max</span><span class="p">(</span>
</span><span id="L-2020"><a href="#L-2020"><span class="linenos">2020</span></a>        <span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">_trace</span><span class="o">.</span><span class="n">main</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">arrs</span><span class="p">),</span>
</span><span id="L-2021"><a href="#L-2021"><span class="linenos">2021</span></a>        <span class="n">default</span><span class="o">=</span><span class="n">trace_stack</span><span class="p">[</span><span class="mi">0</span><span class="p">],</span>
</span><span id="L-2022"><a href="#L-2022"><span class="linenos">2022</span></a>        <span class="n">key</span><span class="o">=</span><span class="n">operator_py</span><span class="o">.</span><span class="n">attrgetter</span><span class="p">(</span><span class="s2">&quot;level&quot;</span><span class="p">),</span>
</span><span id="L-2023"><a href="#L-2023"><span class="linenos">2023</span></a>    <span class="p">)</span>
</span><span id="L-2024"><a href="#L-2024"><span class="linenos">2024</span></a>    <span class="k">if</span> <span class="n">stashed_trace</span> <span class="ow">and</span> <span class="n">stashed_trace</span><span class="o">.</span><span class="n">level</span> <span class="o">&gt;</span> <span class="n">top_main</span><span class="o">.</span><span class="n">level</span><span class="p">:</span>
</span><span id="L-2025"><a href="#L-2025"><span class="linenos">2025</span></a>        <span class="n">top_main</span> <span class="o">=</span> <span class="n">stashed_trace</span>
</span><span id="L-2026"><a href="#L-2026"><span class="linenos">2026</span></a>    <span class="k">return</span> <span class="n">top_main</span><span class="o">.</span><span class="n">trace_type</span><span class="p">(</span><span class="n">top_main</span><span class="p">)</span>
</span><span id="L-2027"><a href="#L-2027"><span class="linenos">2027</span></a>
</span><span id="L-2028"><a href="#L-2028"><span class="linenos">2028</span></a>
</span><span id="L-2029"><a href="#L-2029"><span class="linenos">2029</span></a><span class="k">def</span> <span class="nf">full_raise</span><span class="p">(</span><span class="n">trace</span><span class="p">:</span> <span class="n">Trace</span><span class="p">,</span> <span class="n">val</span><span class="p">:</span> <span class="n">Any</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">TraceTensor</span><span class="p">:</span>
</span><span id="L-2030"><a href="#L-2030"><span class="linenos">2030</span></a>    <span class="k">if</span> <span class="ow">not</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">val</span><span class="p">,</span> <span class="n">TraceTensor</span><span class="p">):</span>
</span><span id="L-2031"><a href="#L-2031"><span class="linenos">2031</span></a>        <span class="k">return</span> <span class="n">trace</span><span class="o">.</span><span class="n">pure</span><span class="p">(</span><span class="n">val</span><span class="p">)</span>
</span><span id="L-2032"><a href="#L-2032"><span class="linenos">2032</span></a>    <span class="n">level</span> <span class="o">=</span> <span class="n">trace</span><span class="o">.</span><span class="n">main</span><span class="o">.</span><span class="n">level</span>
</span><span id="L-2033"><a href="#L-2033"><span class="linenos">2033</span></a>    <span class="k">if</span> <span class="n">val</span><span class="o">.</span><span class="n">_trace</span><span class="o">.</span><span class="n">main</span> <span class="ow">is</span> <span class="n">trace</span><span class="o">.</span><span class="n">main</span><span class="p">:</span>
</span><span id="L-2034"><a href="#L-2034"><span class="linenos">2034</span></a>        <span class="k">return</span> <span class="n">val</span>
</span><span id="L-2035"><a href="#L-2035"><span class="linenos">2035</span></a>    <span class="k">elif</span> <span class="n">val</span><span class="o">.</span><span class="n">_trace</span><span class="o">.</span><span class="n">main</span><span class="o">.</span><span class="n">level</span> <span class="o">&lt;</span> <span class="n">level</span><span class="p">:</span>
</span><span id="L-2036"><a href="#L-2036"><span class="linenos">2036</span></a>        <span class="k">return</span> <span class="n">trace</span><span class="o">.</span><span class="n">pure</span><span class="p">(</span><span class="n">val</span><span class="p">)</span>
</span><span id="L-2037"><a href="#L-2037"><span class="linenos">2037</span></a>    <span class="k">elif</span> <span class="n">val</span><span class="o">.</span><span class="n">_trace</span><span class="o">.</span><span class="n">main</span><span class="o">.</span><span class="n">level</span> <span class="o">&gt;</span> <span class="n">level</span><span class="p">:</span>
</span><span id="L-2038"><a href="#L-2038"><span class="linenos">2038</span></a>        <span class="k">raise</span> <span class="ne">Exception</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;Can&#39;t lift level </span><span class="si">{</span><span class="n">val</span><span class="o">.</span><span class="n">_trace</span><span class="o">.</span><span class="n">main</span><span class="o">.</span><span class="n">level</span><span class="si">}</span><span class="s2"> to </span><span class="si">{</span><span class="n">level</span><span class="si">}</span><span class="s2">.&quot;</span><span class="p">)</span>
</span><span id="L-2039"><a href="#L-2039"><span class="linenos">2039</span></a>    <span class="k">else</span><span class="p">:</span>
</span><span id="L-2040"><a href="#L-2040"><span class="linenos">2040</span></a>        <span class="k">raise</span> <span class="ne">Exception</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;Different traces at same level: </span><span class="si">{</span><span class="n">val</span><span class="o">.</span><span class="n">_trace</span><span class="si">}</span><span class="s2">, </span><span class="si">{</span><span class="n">trace</span><span class="si">}</span><span class="s2">.&quot;</span><span class="p">)</span>
</span><span id="L-2041"><a href="#L-2041"><span class="linenos">2041</span></a>
</span><span id="L-2042"><a href="#L-2042"><span class="linenos">2042</span></a>
</span><span id="L-2043"><a href="#L-2043"><span class="linenos">2043</span></a><span class="k">def</span> <span class="nf">full_lower</span><span class="p">(</span><span class="n">val</span><span class="p">:</span> <span class="n">Any</span><span class="p">):</span>
</span><span id="L-2044"><a href="#L-2044"><span class="linenos">2044</span></a>    <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">val</span><span class="p">,</span> <span class="n">TraceTensor</span><span class="p">):</span>
</span><span id="L-2045"><a href="#L-2045"><span class="linenos">2045</span></a>        <span class="k">return</span> <span class="n">val</span><span class="o">.</span><span class="n">full_lower</span><span class="p">()</span>
</span><span id="L-2046"><a href="#L-2046"><span class="linenos">2046</span></a>    <span class="k">elif</span> <span class="nb">type</span><span class="p">(</span><span class="n">val</span><span class="p">)</span> <span class="ow">in</span> <span class="p">(</span><span class="nb">list</span><span class="p">,</span> <span class="nb">tuple</span><span class="p">):</span>
</span><span id="L-2047"><a href="#L-2047"><span class="linenos">2047</span></a>        <span class="k">return</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">full_lower</span><span class="p">(</span><span class="n">v</span><span class="p">)</span> <span class="k">for</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">val</span><span class="p">)</span>
</span><span id="L-2048"><a href="#L-2048"><span class="linenos">2048</span></a>    <span class="k">else</span><span class="p">:</span>
</span><span id="L-2049"><a href="#L-2049"><span class="linenos">2049</span></a>        <span class="k">return</span> <span class="n">val</span>
</span><span id="L-2050"><a href="#L-2050"><span class="linenos">2050</span></a>
</span><span id="L-2051"><a href="#L-2051"><span class="linenos">2051</span></a>
</span><span id="L-2052"><a href="#L-2052"><span class="linenos">2052</span></a><span class="k">def</span> <span class="nf">typecheck_program</span><span class="p">(</span><span class="n">program</span><span class="p">:</span> <span class="n">Program</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">ProgramType</span><span class="p">:</span>
</span><span id="L-2053"><a href="#L-2053"><span class="linenos">2053</span></a>    <span class="n">env</span><span class="p">:</span> <span class="n">Set</span><span class="p">[</span><span class="n">Var</span><span class="p">]</span> <span class="o">=</span> <span class="nb">set</span><span class="p">()</span>
</span><span id="L-2054"><a href="#L-2054"><span class="linenos">2054</span></a>
</span><span id="L-2055"><a href="#L-2055"><span class="linenos">2055</span></a>    <span class="k">for</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">program</span><span class="o">.</span><span class="n">in_binders</span><span class="p">:</span>
</span><span id="L-2056"><a href="#L-2056"><span class="linenos">2056</span></a>        <span class="k">if</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">env</span><span class="p">:</span>
</span><span id="L-2057"><a href="#L-2057"><span class="linenos">2057</span></a>            <span class="k">raise</span> <span class="ne">TypeError</span>
</span><span id="L-2058"><a href="#L-2058"><span class="linenos">2058</span></a>        <span class="n">env</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">v</span><span class="p">)</span>
</span><span id="L-2059"><a href="#L-2059"><span class="linenos">2059</span></a>
</span><span id="L-2060"><a href="#L-2060"><span class="linenos">2060</span></a>    <span class="k">for</span> <span class="n">instruction</span> <span class="ow">in</span> <span class="n">program</span><span class="o">.</span><span class="n">instructions</span><span class="p">:</span>
</span><span id="L-2061"><a href="#L-2061"><span class="linenos">2061</span></a>        <span class="n">in_types</span> <span class="o">=</span> <span class="p">[</span><span class="n">typecheck_atom</span><span class="p">(</span><span class="n">env</span><span class="p">,</span> <span class="n">x</span><span class="p">)</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">instruction</span><span class="o">.</span><span class="n">inputs</span><span class="p">]</span>
</span><span id="L-2062"><a href="#L-2062"><span class="linenos">2062</span></a>        <span class="n">out_types</span> <span class="o">=</span> <span class="n">instruction</span><span class="o">.</span><span class="n">op</span><span class="o">.</span><span class="n">typecheck</span><span class="p">(</span><span class="o">*</span><span class="n">in_types</span><span class="p">,</span> <span class="o">**</span><span class="n">instruction</span><span class="o">.</span><span class="n">params</span><span class="p">)</span>
</span><span id="L-2063"><a href="#L-2063"><span class="linenos">2063</span></a>        <span class="k">for</span> <span class="n">out_binder</span><span class="p">,</span> <span class="n">out_type</span> <span class="ow">in</span> <span class="n">list_zip</span><span class="p">(</span><span class="n">instruction</span><span class="o">.</span><span class="n">out_binders</span><span class="p">,</span> <span class="n">out_types</span><span class="p">):</span>
</span><span id="L-2064"><a href="#L-2064"><span class="linenos">2064</span></a>            <span class="k">if</span> <span class="ow">not</span> <span class="n">out_type</span> <span class="o">==</span> <span class="n">out_binder</span><span class="o">.</span><span class="n">symval</span><span class="p">:</span>
</span><span id="L-2065"><a href="#L-2065"><span class="linenos">2065</span></a>                <span class="k">raise</span> <span class="ne">TypeError</span>
</span><span id="L-2066"><a href="#L-2066"><span class="linenos">2066</span></a>        <span class="k">for</span> <span class="n">out_binder</span> <span class="ow">in</span> <span class="n">instruction</span><span class="o">.</span><span class="n">out_binders</span><span class="p">:</span>
</span><span id="L-2067"><a href="#L-2067"><span class="linenos">2067</span></a>            <span class="k">if</span> <span class="n">out_binder</span> <span class="ow">in</span> <span class="n">env</span><span class="p">:</span>
</span><span id="L-2068"><a href="#L-2068"><span class="linenos">2068</span></a>                <span class="k">raise</span> <span class="ne">TypeError</span>
</span><span id="L-2069"><a href="#L-2069"><span class="linenos">2069</span></a>            <span class="n">env</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">out_binder</span><span class="p">)</span>
</span><span id="L-2070"><a href="#L-2070"><span class="linenos">2070</span></a>
</span><span id="L-2071"><a href="#L-2071"><span class="linenos">2071</span></a>    <span class="n">in_types</span> <span class="o">=</span> <span class="p">[</span><span class="n">v</span><span class="o">.</span><span class="n">symval</span> <span class="k">for</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">program</span><span class="o">.</span><span class="n">in_binders</span><span class="p">]</span>
</span><span id="L-2072"><a href="#L-2072"><span class="linenos">2072</span></a>    <span class="n">out_types</span> <span class="o">=</span> <span class="p">[</span><span class="n">typecheck_atom</span><span class="p">(</span><span class="n">env</span><span class="p">,</span> <span class="n">x</span><span class="p">)</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">program</span><span class="o">.</span><span class="n">outs</span><span class="p">]</span>
</span><span id="L-2073"><a href="#L-2073"><span class="linenos">2073</span></a>    <span class="k">return</span> <span class="n">ProgramType</span><span class="p">(</span><span class="nb">tuple</span><span class="p">(</span><span class="n">in_types</span><span class="p">),</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">out_types</span><span class="p">))</span>
</span><span id="L-2074"><a href="#L-2074"><span class="linenos">2074</span></a>
</span><span id="L-2075"><a href="#L-2075"><span class="linenos">2075</span></a>
</span><span id="L-2076"><a href="#L-2076"><span class="linenos">2076</span></a><span class="k">def</span> <span class="nf">typecheck_atom</span><span class="p">(</span><span class="n">env</span><span class="p">:</span> <span class="n">Set</span><span class="p">[</span><span class="n">Var</span><span class="p">],</span> <span class="n">x</span><span class="p">:</span> <span class="n">Atom</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">SymbolicTensor</span><span class="p">:</span>
</span><span id="L-2077"><a href="#L-2077"><span class="linenos">2077</span></a>    <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">Var</span><span class="p">):</span>
</span><span id="L-2078"><a href="#L-2078"><span class="linenos">2078</span></a>        <span class="k">if</span> <span class="n">x</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">env</span><span class="p">:</span>
</span><span id="L-2079"><a href="#L-2079"><span class="linenos">2079</span></a>            <span class="k">raise</span> <span class="ne">TypeError</span><span class="p">(</span><span class="s2">&quot;unbound variable&quot;</span><span class="p">)</span>
</span><span id="L-2080"><a href="#L-2080"><span class="linenos">2080</span></a>        <span class="k">return</span> <span class="n">x</span><span class="o">.</span><span class="n">symval</span>
</span><span id="L-2081"><a href="#L-2081"><span class="linenos">2081</span></a>    <span class="k">elif</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">Lit</span><span class="p">):</span>
</span><span id="L-2082"><a href="#L-2082"><span class="linenos">2082</span></a>        <span class="k">return</span> <span class="n">get_symval</span><span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">val</span><span class="p">)</span>
</span><span id="L-2083"><a href="#L-2083"><span class="linenos">2083</span></a>    <span class="k">else</span><span class="p">:</span>
</span><span id="L-2084"><a href="#L-2084"><span class="linenos">2084</span></a>        <span class="k">assert</span> <span class="kc">False</span>
</span><span id="L-2085"><a href="#L-2085"><span class="linenos">2085</span></a>
</span><span id="L-2086"><a href="#L-2086"><span class="linenos">2086</span></a>
</span><span id="L-2087"><a href="#L-2087"><span class="linenos">2087</span></a><span class="k">def</span> <span class="nf">run_program</span><span class="p">(</span><span class="n">program</span><span class="p">:</span> <span class="n">Program</span><span class="p">,</span> <span class="n">args</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">])</span> <span class="o">-&gt;</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">]:</span>
</span><span id="L-2088"><a href="#L-2088"><span class="linenos">2088</span></a>    <span class="n">env</span><span class="p">:</span> <span class="n">Dict</span><span class="p">[</span><span class="n">Var</span><span class="p">,</span> <span class="n">Any</span><span class="p">]</span> <span class="o">=</span> <span class="p">{}</span>
</span><span id="L-2089"><a href="#L-2089"><span class="linenos">2089</span></a>
</span><span id="L-2090"><a href="#L-2090"><span class="linenos">2090</span></a>    <span class="k">def</span> <span class="nf">read</span><span class="p">(</span><span class="n">x</span><span class="p">:</span> <span class="n">Atom</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Any</span><span class="p">:</span>
</span><span id="L-2091"><a href="#L-2091"><span class="linenos">2091</span></a>        <span class="k">return</span> <span class="n">env</span><span class="p">[</span><span class="n">x</span><span class="p">]</span> <span class="k">if</span> <span class="nb">type</span><span class="p">(</span><span class="n">x</span><span class="p">)</span> <span class="ow">is</span> <span class="n">Var</span> <span class="k">else</span> <span class="n">x</span><span class="o">.</span><span class="n">val</span>
</span><span id="L-2092"><a href="#L-2092"><span class="linenos">2092</span></a>
</span><span id="L-2093"><a href="#L-2093"><span class="linenos">2093</span></a>    <span class="k">def</span> <span class="nf">write</span><span class="p">(</span><span class="n">v</span><span class="p">:</span> <span class="n">Var</span><span class="p">,</span> <span class="n">val</span><span class="p">:</span> <span class="n">Any</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="kc">None</span><span class="p">:</span>
</span><span id="L-2094"><a href="#L-2094"><span class="linenos">2094</span></a>        <span class="k">assert</span> <span class="n">v</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">env</span>  <span class="c1"># single-assignment</span>
</span><span id="L-2095"><a href="#L-2095"><span class="linenos">2095</span></a>        <span class="n">env</span><span class="p">[</span><span class="n">v</span><span class="p">]</span> <span class="o">=</span> <span class="n">val</span>
</span><span id="L-2096"><a href="#L-2096"><span class="linenos">2096</span></a>
</span><span id="L-2097"><a href="#L-2097"><span class="linenos">2097</span></a>    <span class="n">list_map</span><span class="p">(</span><span class="n">write</span><span class="p">,</span> <span class="n">program</span><span class="o">.</span><span class="n">in_binders</span><span class="p">,</span> <span class="n">args</span><span class="p">)</span>
</span><span id="L-2098"><a href="#L-2098"><span class="linenos">2098</span></a>    <span class="k">for</span> <span class="n">instruction</span> <span class="ow">in</span> <span class="n">program</span><span class="o">.</span><span class="n">instructions</span><span class="p">:</span>
</span><span id="L-2099"><a href="#L-2099"><span class="linenos">2099</span></a>        <span class="n">in_vals</span> <span class="o">=</span> <span class="n">list_map</span><span class="p">(</span><span class="n">read</span><span class="p">,</span> <span class="n">instruction</span><span class="o">.</span><span class="n">inputs</span><span class="p">)</span>
</span><span id="L-2100"><a href="#L-2100"><span class="linenos">2100</span></a>        <span class="n">outs</span> <span class="o">=</span> <span class="n">bind</span><span class="p">(</span><span class="n">instruction</span><span class="o">.</span><span class="n">op</span><span class="p">,</span> <span class="o">*</span><span class="n">in_vals</span><span class="p">,</span> <span class="o">**</span><span class="n">instruction</span><span class="o">.</span><span class="n">params</span><span class="p">)</span>
</span><span id="L-2101"><a href="#L-2101"><span class="linenos">2101</span></a>        <span class="n">list_map</span><span class="p">(</span><span class="n">write</span><span class="p">,</span> <span class="n">instruction</span><span class="o">.</span><span class="n">out_binders</span><span class="p">,</span> <span class="n">outs</span><span class="p">)</span>
</span><span id="L-2102"><a href="#L-2102"><span class="linenos">2102</span></a>    <span class="k">return</span> <span class="n">list_map</span><span class="p">(</span><span class="n">read</span><span class="p">,</span> <span class="n">program</span><span class="o">.</span><span class="n">outs</span><span class="p">)</span>
</span><span id="L-2103"><a href="#L-2103"><span class="linenos">2103</span></a>
</span><span id="L-2104"><a href="#L-2104"><span class="linenos">2104</span></a>
</span><span id="L-2105"><a href="#L-2105"><span class="linenos">2105</span></a><span class="k">def</span> <span class="nf">program_as_fun</span><span class="p">(</span><span class="n">program</span><span class="p">:</span> <span class="n">Program</span><span class="p">):</span>
</span><span id="L-2106"><a href="#L-2106"><span class="linenos">2106</span></a>    <span class="k">return</span> <span class="k">lambda</span> <span class="o">*</span><span class="n">args</span><span class="p">:</span> <span class="n">run_program</span><span class="p">(</span><span class="n">program</span><span class="p">,</span> <span class="n">args</span><span class="p">)</span>
</span><span id="L-2107"><a href="#L-2107"><span class="linenos">2107</span></a>
</span><span id="L-2108"><a href="#L-2108"><span class="linenos">2108</span></a>
</span><span id="L-2109"><a href="#L-2109"><span class="linenos">2109</span></a><span class="k">def</span> <span class="nf">vmap_flat</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="n">in_dim</span><span class="p">,</span> <span class="n">out_dim</span><span class="p">,</span> <span class="n">dim_size</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">):</span>
</span><span id="L-2110"><a href="#L-2110"><span class="linenos">2110</span></a>    <span class="k">if</span> <span class="n">dim_size</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
</span><span id="L-2111"><a href="#L-2111"><span class="linenos">2111</span></a>        <span class="n">dims</span> <span class="o">=</span> <span class="nb">set</span><span class="p">([</span><span class="n">x</span><span class="o">.</span><span class="n">shape</span><span class="p">[</span><span class="n">d</span><span class="p">]</span> <span class="k">for</span> <span class="n">x</span><span class="p">,</span> <span class="n">d</span> <span class="ow">in</span> <span class="n">list_zip</span><span class="p">(</span><span class="n">args</span><span class="p">,</span> <span class="n">in_dim</span><span class="p">)</span> <span class="k">if</span> <span class="n">d</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">])</span>
</span><span id="L-2112"><a href="#L-2112"><span class="linenos">2112</span></a>        <span class="k">assert</span> <span class="nb">len</span><span class="p">(</span><span class="n">dims</span><span class="p">)</span> <span class="o">==</span> <span class="mi">1</span>
</span><span id="L-2113"><a href="#L-2113"><span class="linenos">2113</span></a>        <span class="p">(</span><span class="n">dim_size</span><span class="p">,)</span> <span class="o">=</span> <span class="n">dims</span>
</span><span id="L-2114"><a href="#L-2114"><span class="linenos">2114</span></a>    <span class="k">with</span> <span class="n">new_main_trace</span><span class="p">(</span><span class="n">VMapTrace</span><span class="p">,</span> <span class="n">dim_size</span><span class="p">)</span> <span class="k">as</span> <span class="n">main</span><span class="p">:</span>
</span><span id="L-2115"><a href="#L-2115"><span class="linenos">2115</span></a>        <span class="n">trace</span> <span class="o">=</span> <span class="n">VMapTrace</span><span class="p">(</span><span class="n">main</span><span class="p">)</span>
</span><span id="L-2116"><a href="#L-2116"><span class="linenos">2116</span></a>        <span class="n">tracers_in</span> <span class="o">=</span> <span class="p">[</span><span class="n">VMapTraceTensor</span><span class="p">(</span><span class="n">trace</span><span class="p">,</span> <span class="n">x</span><span class="p">,</span> <span class="n">dim</span><span class="p">)</span> <span class="k">if</span> <span class="n">dim</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span> <span class="k">else</span> <span class="n">x</span> <span class="k">for</span> <span class="n">x</span><span class="p">,</span> <span class="n">dim</span> <span class="ow">in</span> <span class="n">list_zip</span><span class="p">(</span><span class="n">args</span><span class="p">,</span> <span class="n">in_dim</span><span class="p">)]</span>
</span><span id="L-2117"><a href="#L-2117"><span class="linenos">2117</span></a>        <span class="n">outs</span> <span class="o">=</span> <span class="n">f</span><span class="p">(</span><span class="o">*</span><span class="n">tracers_in</span><span class="p">)</span>
</span><span id="L-2118"><a href="#L-2118"><span class="linenos">2118</span></a>        <span class="n">tracers_out</span> <span class="o">=</span> <span class="p">[</span><span class="n">full_raise</span><span class="p">(</span><span class="n">trace</span><span class="p">,</span> <span class="n">out</span><span class="p">)</span> <span class="k">for</span> <span class="n">out</span> <span class="ow">in</span> <span class="n">outs</span><span class="p">]</span>
</span><span id="L-2119"><a href="#L-2119"><span class="linenos">2119</span></a>        <span class="n">vals_out</span><span class="p">,</span> <span class="n">y_vmap_dims</span> <span class="o">=</span> <span class="n">unzip2</span><span class="p">((</span><span class="n">t</span><span class="o">.</span><span class="n">val</span><span class="p">,</span> <span class="n">t</span><span class="o">.</span><span class="n">vmap_dim</span><span class="p">)</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">tracers_out</span><span class="p">)</span>
</span><span id="L-2120"><a href="#L-2120"><span class="linenos">2120</span></a>    <span class="n">ret</span> <span class="o">=</span> <span class="p">[</span><span class="n">VMapTrace</span><span class="o">.</span><span class="n">move_vmap_dim</span><span class="p">(</span><span class="n">val_out</span><span class="p">,</span> <span class="n">dim_size</span><span class="p">,</span> <span class="n">bdim</span><span class="p">,</span> <span class="n">out_dim</span><span class="p">)</span> <span class="k">for</span> <span class="n">val_out</span><span class="p">,</span> <span class="n">bdim</span><span class="p">,</span> <span class="n">out_dim</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">vals_out</span><span class="p">,</span> <span class="n">y_vmap_dims</span><span class="p">,</span> <span class="n">out_dim</span><span class="p">)]</span>
</span><span id="L-2121"><a href="#L-2121"><span class="linenos">2121</span></a>    <span class="k">return</span> <span class="n">ret</span>
</span><span id="L-2122"><a href="#L-2122"><span class="linenos">2122</span></a>
</span><span id="L-2123"><a href="#L-2123"><span class="linenos">2123</span></a>
</span><span id="L-2124"><a href="#L-2124"><span class="linenos">2124</span></a><span class="k">def</span> <span class="nf">vmap</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="n">in_dim</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">out_dim</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">dim_size</span><span class="o">=</span><span class="kc">None</span><span class="p">):</span>
</span><span id="L-2125"><a href="#L-2125"><span class="linenos">2125</span></a>    <span class="k">def</span> <span class="nf">batched_f</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">):</span>
</span><span id="L-2126"><a href="#L-2126"><span class="linenos">2126</span></a>        <span class="k">nonlocal</span> <span class="n">in_dim</span><span class="p">,</span> <span class="n">out_dim</span><span class="p">,</span> <span class="n">dim_size</span>
</span><span id="L-2127"><a href="#L-2127"><span class="linenos">2127</span></a>        <span class="n">args_flat</span><span class="p">,</span> <span class="n">in_tree</span> <span class="o">=</span> <span class="n">tree_flatten</span><span class="p">(</span><span class="n">args</span><span class="p">)</span>
</span><span id="L-2128"><a href="#L-2128"><span class="linenos">2128</span></a>        <span class="n">in_dim</span> <span class="o">=</span> <span class="p">(</span><span class="n">in_dim</span><span class="p">,)</span> <span class="o">*</span> <span class="nb">len</span><span class="p">(</span><span class="n">args</span><span class="p">)</span> <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">in_dim</span><span class="p">,</span> <span class="nb">int</span><span class="p">)</span> <span class="k">else</span> <span class="n">in_dim</span>
</span><span id="L-2129"><a href="#L-2129"><span class="linenos">2129</span></a>        <span class="n">out_dim</span> <span class="o">=</span> <span class="p">(</span><span class="n">out_dim</span><span class="p">,)</span> <span class="o">*</span> <span class="nb">len</span><span class="p">(</span><span class="n">args</span><span class="p">)</span> <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">out_dim</span><span class="p">,</span> <span class="nb">int</span><span class="p">)</span> <span class="k">else</span> <span class="n">out_dim</span>
</span><span id="L-2130"><a href="#L-2130"><span class="linenos">2130</span></a>        <span class="n">in_dim_flat</span><span class="p">,</span> <span class="n">in_dim_tree</span> <span class="o">=</span> <span class="n">tree_flatten</span><span class="p">(</span><span class="n">in_dim</span><span class="p">)</span>
</span><span id="L-2131"><a href="#L-2131"><span class="linenos">2131</span></a>        <span class="n">out_dim_flat</span><span class="p">,</span> <span class="n">out_dim_tree</span> <span class="o">=</span> <span class="n">tree_flatten</span><span class="p">(</span><span class="n">out_dim</span><span class="p">)</span>
</span><span id="L-2132"><a href="#L-2132"><span class="linenos">2132</span></a>        <span class="k">if</span> <span class="ow">not</span> <span class="p">(</span><span class="n">in_tree</span> <span class="o">==</span> <span class="n">in_dim_tree</span> <span class="o">==</span> <span class="n">out_dim_tree</span><span class="p">):</span>
</span><span id="L-2133"><a href="#L-2133"><span class="linenos">2133</span></a>            <span class="k">raise</span> <span class="ne">TypeError</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;</span><span class="se">\n</span><span class="si">{</span><span class="n">in_tree</span><span class="si">}</span><span class="se">\n</span><span class="s2">!=</span><span class="se">\n</span><span class="si">{</span><span class="n">in_dim_tree</span><span class="si">}</span><span class="s2">!=</span><span class="se">\n</span><span class="si">{</span><span class="n">out_dim_tree</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">)</span>
</span><span id="L-2134"><a href="#L-2134"><span class="linenos">2134</span></a>        <span class="n">f_flat</span><span class="p">,</span> <span class="n">out_tree_store</span> <span class="o">=</span> <span class="n">flatten_fn</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="n">in_tree</span><span class="p">)</span>
</span><span id="L-2135"><a href="#L-2135"><span class="linenos">2135</span></a>        <span class="c1"># if len(args_flat) &gt; len(in_dim_flat):</span>
</span><span id="L-2136"><a href="#L-2136"><span class="linenos">2136</span></a>        <span class="c1">#     in_dim_flat = (in_dim[0],) * len(args_flat)</span>
</span><span id="L-2137"><a href="#L-2137"><span class="linenos">2137</span></a>        <span class="n">outs_flat</span> <span class="o">=</span> <span class="n">vmap_flat</span><span class="p">(</span><span class="n">f_flat</span><span class="p">,</span> <span class="n">in_dim_flat</span><span class="p">,</span> <span class="n">out_dim_flat</span><span class="p">,</span> <span class="n">dim_size</span><span class="p">,</span> <span class="o">*</span><span class="n">args_flat</span><span class="p">)</span>
</span><span id="L-2138"><a href="#L-2138"><span class="linenos">2138</span></a>        <span class="k">return</span> <span class="n">tree_unflatten</span><span class="p">(</span><span class="n">out_tree_store</span><span class="p">(),</span> <span class="n">outs_flat</span><span class="p">)</span>
</span><span id="L-2139"><a href="#L-2139"><span class="linenos">2139</span></a>
</span><span id="L-2140"><a href="#L-2140"><span class="linenos">2140</span></a>    <span class="k">return</span> <span class="n">batched_f</span>
</span><span id="L-2141"><a href="#L-2141"><span class="linenos">2141</span></a>
</span><span id="L-2142"><a href="#L-2142"><span class="linenos">2142</span></a>
</span><span id="L-2143"><a href="#L-2143"><span class="linenos">2143</span></a><span class="k">def</span> <span class="nf">jvp_flat</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="n">primals</span><span class="p">,</span> <span class="n">tangents</span><span class="p">,</span> <span class="o">*</span><span class="p">,</span> <span class="n">has_aux</span><span class="p">,</span> <span class="n">global_data</span><span class="p">,</span> <span class="o">**</span><span class="n">static_args</span><span class="p">):</span>
</span><span id="L-2144"><a href="#L-2144"><span class="linenos">2144</span></a>    <span class="k">with</span> <span class="n">new_main_trace</span><span class="p">(</span><span class="n">JVPTrace</span><span class="p">,</span> <span class="n">global_data</span><span class="p">)</span> <span class="k">as</span> <span class="n">main</span><span class="p">:</span>
</span><span id="L-2145"><a href="#L-2145"><span class="linenos">2145</span></a>        <span class="n">trace</span> <span class="o">=</span> <span class="n">JVPTrace</span><span class="p">(</span><span class="n">main</span><span class="p">)</span>
</span><span id="L-2146"><a href="#L-2146"><span class="linenos">2146</span></a>        <span class="n">tracers_in</span> <span class="o">=</span> <span class="p">[</span><span class="n">JVPTraceTensor</span><span class="p">(</span><span class="n">trace</span><span class="p">,</span> <span class="n">x</span><span class="p">,</span> <span class="n">t</span><span class="p">)</span> <span class="k">for</span> <span class="n">x</span><span class="p">,</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">list_zip</span><span class="p">(</span><span class="n">primals</span><span class="p">,</span> <span class="n">tangents</span><span class="p">)]</span>
</span><span id="L-2147"><a href="#L-2147"><span class="linenos">2147</span></a>        <span class="n">jvp_flat_ret</span> <span class="o">=</span> <span class="n">f</span><span class="p">(</span><span class="o">*</span><span class="n">tracers_in</span><span class="p">,</span> <span class="o">**</span><span class="n">static_args</span><span class="p">)</span>
</span><span id="L-2148"><a href="#L-2148"><span class="linenos">2148</span></a>        <span class="k">if</span> <span class="n">has_aux</span><span class="p">:</span>
</span><span id="L-2149"><a href="#L-2149"><span class="linenos">2149</span></a>            <span class="p">(</span><span class="n">outs</span><span class="p">,</span> <span class="n">aux</span><span class="p">)</span> <span class="o">=</span> <span class="n">jvp_flat_ret</span>
</span><span id="L-2150"><a href="#L-2150"><span class="linenos">2150</span></a>            <span class="c1"># aux_ = aux</span>
</span><span id="L-2151"><a href="#L-2151"><span class="linenos">2151</span></a>            <span class="n">aux</span> <span class="o">=</span> <span class="n">tree_map</span><span class="p">(</span><span class="k">lambda</span> <span class="n">x</span><span class="p">:</span> <span class="n">x</span><span class="o">.</span><span class="n">primal</span><span class="p">,</span> <span class="n">aux</span><span class="p">)</span>
</span><span id="L-2152"><a href="#L-2152"><span class="linenos">2152</span></a>            <span class="c1"># aux = tree_map(lambda x: x.full_lower(), aux)</span>
</span><span id="L-2153"><a href="#L-2153"><span class="linenos">2153</span></a>            <span class="c1">#</span>
</span><span id="L-2154"><a href="#L-2154"><span class="linenos">2154</span></a>        <span class="k">else</span><span class="p">:</span>
</span><span id="L-2155"><a href="#L-2155"><span class="linenos">2155</span></a>            <span class="n">outs</span> <span class="o">=</span> <span class="n">jvp_flat_ret</span>
</span><span id="L-2156"><a href="#L-2156"><span class="linenos">2156</span></a>        <span class="n">tracers_out</span> <span class="o">=</span> <span class="p">[</span><span class="n">full_raise</span><span class="p">(</span><span class="n">trace</span><span class="p">,</span> <span class="n">out</span><span class="p">)</span> <span class="k">for</span> <span class="n">out</span> <span class="ow">in</span> <span class="n">outs</span><span class="p">]</span>
</span><span id="L-2157"><a href="#L-2157"><span class="linenos">2157</span></a>        <span class="n">primals_out</span><span class="p">,</span> <span class="n">tangents_out</span> <span class="o">=</span> <span class="n">unzip2</span><span class="p">((</span><span class="n">t</span><span class="o">.</span><span class="n">primal</span><span class="p">,</span> <span class="n">t</span><span class="o">.</span><span class="n">tangent</span><span class="p">)</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">tracers_out</span><span class="p">)</span>
</span><span id="L-2158"><a href="#L-2158"><span class="linenos">2158</span></a>    <span class="k">return</span> <span class="p">((</span><span class="n">primals_out</span><span class="p">,</span> <span class="n">tangents_out</span><span class="p">),</span> <span class="n">aux</span><span class="p">)</span> <span class="k">if</span> <span class="n">has_aux</span> <span class="k">else</span> <span class="p">(</span><span class="n">primals_out</span><span class="p">,</span> <span class="n">tangents_out</span><span class="p">)</span>
</span><span id="L-2159"><a href="#L-2159"><span class="linenos">2159</span></a>
</span><span id="L-2160"><a href="#L-2160"><span class="linenos">2160</span></a>
</span><span id="L-2161"><a href="#L-2161"><span class="linenos">2161</span></a><span class="k">def</span> <span class="nf">jvp</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="n">primals</span><span class="p">,</span> <span class="n">tangents</span><span class="p">,</span> <span class="o">*</span><span class="p">,</span> <span class="n">has_aux</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">global_data</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="o">**</span><span class="n">static_args</span><span class="p">):</span>
</span><span id="L-2162"><a href="#L-2162"><span class="linenos">2162</span></a>    <span class="n">primals_flat</span><span class="p">,</span> <span class="n">in_tree</span> <span class="o">=</span> <span class="n">tree_flatten</span><span class="p">(</span><span class="n">primals</span><span class="p">)</span>
</span><span id="L-2163"><a href="#L-2163"><span class="linenos">2163</span></a>    <span class="n">tangents_flat</span><span class="p">,</span> <span class="n">in_tree2</span> <span class="o">=</span> <span class="n">tree_flatten</span><span class="p">(</span><span class="n">tangents</span><span class="p">)</span>
</span><span id="L-2164"><a href="#L-2164"><span class="linenos">2164</span></a>    <span class="k">for</span> <span class="n">p</span><span class="p">,</span> <span class="n">t</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">primals_flat</span><span class="p">,</span> <span class="n">tangents_flat</span><span class="p">):</span>
</span><span id="L-2165"><a href="#L-2165"><span class="linenos">2165</span></a>        <span class="k">assert</span> <span class="n">p</span><span class="o">.</span><span class="n">shape</span> <span class="o">==</span> <span class="n">t</span><span class="o">.</span><span class="n">shape</span><span class="p">,</span> <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">p</span><span class="o">.</span><span class="n">shape</span><span class="si">=}</span><span class="s2"> != </span><span class="si">{</span><span class="n">t</span><span class="o">.</span><span class="n">shape</span><span class="si">=}</span><span class="s2">&quot;</span>
</span><span id="L-2166"><a href="#L-2166"><span class="linenos">2166</span></a>        <span class="k">assert</span> <span class="n">p</span><span class="o">.</span><span class="n">dtype</span> <span class="o">==</span> <span class="n">t</span><span class="o">.</span><span class="n">dtype</span><span class="p">,</span> <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">p</span><span class="o">.</span><span class="n">dtype</span><span class="si">=}</span><span class="s2"> != </span><span class="si">{</span><span class="n">t</span><span class="o">.</span><span class="n">dtype</span><span class="si">=}</span><span class="s2">&quot;</span>
</span><span id="L-2167"><a href="#L-2167"><span class="linenos">2167</span></a>        <span class="k">assert</span> <span class="n">p</span><span class="o">.</span><span class="n">device</span> <span class="o">==</span> <span class="n">t</span><span class="o">.</span><span class="n">device</span><span class="p">,</span> <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">p</span><span class="o">.</span><span class="n">device</span><span class="si">=}</span><span class="s2"> != </span><span class="si">{</span><span class="n">t</span><span class="o">.</span><span class="n">device</span><span class="si">=}</span><span class="s2">&quot;</span>
</span><span id="L-2168"><a href="#L-2168"><span class="linenos">2168</span></a>    <span class="k">if</span> <span class="n">in_tree</span> <span class="o">!=</span> <span class="n">in_tree2</span><span class="p">:</span>
</span><span id="L-2169"><a href="#L-2169"><span class="linenos">2169</span></a>        <span class="k">raise</span> <span class="ne">TypeError</span>
</span><span id="L-2170"><a href="#L-2170"><span class="linenos">2170</span></a>    <span class="n">f</span><span class="p">,</span> <span class="n">out_tree_store</span> <span class="o">=</span> <span class="n">flatten_fn</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="n">in_tree</span><span class="p">,</span> <span class="n">has_aux</span><span class="o">=</span><span class="n">has_aux</span><span class="p">)</span>
</span><span id="L-2171"><a href="#L-2171"><span class="linenos">2171</span></a>    <span class="n">jvp_ret</span> <span class="o">=</span> <span class="n">jvp_flat</span><span class="p">(</span>
</span><span id="L-2172"><a href="#L-2172"><span class="linenos">2172</span></a>        <span class="n">f</span><span class="p">,</span>
</span><span id="L-2173"><a href="#L-2173"><span class="linenos">2173</span></a>        <span class="n">primals_flat</span><span class="p">,</span>
</span><span id="L-2174"><a href="#L-2174"><span class="linenos">2174</span></a>        <span class="n">tangents_flat</span><span class="p">,</span>
</span><span id="L-2175"><a href="#L-2175"><span class="linenos">2175</span></a>        <span class="n">has_aux</span><span class="o">=</span><span class="n">has_aux</span><span class="p">,</span>
</span><span id="L-2176"><a href="#L-2176"><span class="linenos">2176</span></a>        <span class="n">global_data</span><span class="o">=</span><span class="n">global_data</span><span class="p">,</span>
</span><span id="L-2177"><a href="#L-2177"><span class="linenos">2177</span></a>        <span class="o">**</span><span class="n">static_args</span><span class="p">,</span>
</span><span id="L-2178"><a href="#L-2178"><span class="linenos">2178</span></a>    <span class="p">)</span>
</span><span id="L-2179"><a href="#L-2179"><span class="linenos">2179</span></a>    <span class="k">if</span> <span class="n">has_aux</span><span class="p">:</span>
</span><span id="L-2180"><a href="#L-2180"><span class="linenos">2180</span></a>        <span class="p">(</span><span class="n">primals_out_flat</span><span class="p">,</span> <span class="n">tangents_out_flat</span><span class="p">),</span> <span class="n">aux</span> <span class="o">=</span> <span class="n">jvp_ret</span>
</span><span id="L-2181"><a href="#L-2181"><span class="linenos">2181</span></a>    <span class="k">else</span><span class="p">:</span>
</span><span id="L-2182"><a href="#L-2182"><span class="linenos">2182</span></a>        <span class="p">(</span><span class="n">primals_out_flat</span><span class="p">,</span> <span class="n">tangents_out_flat</span><span class="p">)</span> <span class="o">=</span> <span class="n">jvp_ret</span>
</span><span id="L-2183"><a href="#L-2183"><span class="linenos">2183</span></a>    <span class="n">primals_out</span> <span class="o">=</span> <span class="n">tree_unflatten</span><span class="p">(</span><span class="n">out_tree_store</span><span class="p">(),</span> <span class="n">primals_out_flat</span><span class="p">)</span>
</span><span id="L-2184"><a href="#L-2184"><span class="linenos">2184</span></a>    <span class="n">tangents_out</span> <span class="o">=</span> <span class="n">tree_unflatten</span><span class="p">(</span><span class="n">out_tree_store</span><span class="p">(),</span> <span class="n">tangents_out_flat</span><span class="p">)</span>
</span><span id="L-2185"><a href="#L-2185"><span class="linenos">2185</span></a>    <span class="k">return</span> <span class="p">((</span><span class="n">primals_out</span><span class="p">,</span> <span class="n">tangents_out</span><span class="p">),</span> <span class="n">aux</span><span class="p">)</span> <span class="k">if</span> <span class="n">has_aux</span> <span class="k">else</span> <span class="p">(</span><span class="n">primals_out</span><span class="p">,</span> <span class="n">tangents_out</span><span class="p">)</span>
</span><span id="L-2186"><a href="#L-2186"><span class="linenos">2186</span></a>
</span><span id="L-2187"><a href="#L-2187"><span class="linenos">2187</span></a>
</span><span id="L-2188"><a href="#L-2188"><span class="linenos">2188</span></a><span class="k">def</span> <span class="nf">jacfwd</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="n">x</span><span class="p">):</span>
</span><span id="L-2189"><a href="#L-2189"><span class="linenos">2189</span></a>    <span class="n">pushfwd</span> <span class="o">=</span> <span class="k">lambda</span> <span class="n">v</span><span class="p">:</span> <span class="n">jvp</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="p">(</span><span class="n">x</span><span class="p">,),</span> <span class="p">(</span><span class="n">v</span><span class="p">,))[</span><span class="mi">1</span><span class="p">]</span>
</span><span id="L-2190"><a href="#L-2190"><span class="linenos">2190</span></a>    <span class="n">vecs_in</span> <span class="o">=</span> <span class="n">backend</span><span class="o">.</span><span class="n">eye</span><span class="p">(</span><span class="n">math</span><span class="o">.</span><span class="n">prod</span><span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">shape</span><span class="p">))</span><span class="o">.</span><span class="n">reshape</span><span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">shape</span> <span class="o">*</span> <span class="mi">2</span><span class="p">)</span>
</span><span id="L-2191"><a href="#L-2191"><span class="linenos">2191</span></a>    <span class="k">return</span> <span class="n">vmap</span><span class="p">(</span><span class="n">pushfwd</span><span class="p">,</span> <span class="p">(</span><span class="mi">0</span><span class="p">,))(</span><span class="n">vecs_in</span><span class="p">)</span>
</span><span id="L-2192"><a href="#L-2192"><span class="linenos">2192</span></a>
</span><span id="L-2193"><a href="#L-2193"><span class="linenos">2193</span></a>
</span><span id="L-2194"><a href="#L-2194"><span class="linenos">2194</span></a><span class="nd">@contextmanager</span>
</span><span id="L-2195"><a href="#L-2195"><span class="linenos">2195</span></a><span class="k">def</span> <span class="nf">stash_trace</span><span class="p">(</span><span class="n">main</span><span class="p">:</span> <span class="n">MainTrace</span><span class="p">):</span>
</span><span id="L-2196"><a href="#L-2196"><span class="linenos">2196</span></a>    <span class="k">global</span> <span class="n">stashed_trace</span>
</span><span id="L-2197"><a href="#L-2197"><span class="linenos">2197</span></a>    <span class="n">prev_stashed_trace</span><span class="p">,</span> <span class="n">stashed_trace</span> <span class="o">=</span> <span class="n">stashed_trace</span><span class="p">,</span> <span class="n">main</span>
</span><span id="L-2198"><a href="#L-2198"><span class="linenos">2198</span></a>    <span class="k">try</span><span class="p">:</span>
</span><span id="L-2199"><a href="#L-2199"><span class="linenos">2199</span></a>        <span class="k">yield</span>
</span><span id="L-2200"><a href="#L-2200"><span class="linenos">2200</span></a>    <span class="k">finally</span><span class="p">:</span>
</span><span id="L-2201"><a href="#L-2201"><span class="linenos">2201</span></a>        <span class="n">stashed_trace</span> <span class="o">=</span> <span class="n">prev_stashed_trace</span>
</span><span id="L-2202"><a href="#L-2202"><span class="linenos">2202</span></a>
</span><span id="L-2203"><a href="#L-2203"><span class="linenos">2203</span></a>
</span><span id="L-2204"><a href="#L-2204"><span class="linenos">2204</span></a><span class="nd">@contextmanager</span>
</span><span id="L-2205"><a href="#L-2205"><span class="linenos">2205</span></a><span class="k">def</span> <span class="nf">symbolic_run</span><span class="p">():</span>
</span><span id="L-2206"><a href="#L-2206"><span class="linenos">2206</span></a>    <span class="k">global</span> <span class="n">trace_stack</span>
</span><span id="L-2207"><a href="#L-2207"><span class="linenos">2207</span></a>    <span class="n">level</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">trace_stack</span><span class="p">)</span>
</span><span id="L-2208"><a href="#L-2208"><span class="linenos">2208</span></a>    <span class="n">main</span> <span class="o">=</span> <span class="n">MainTrace</span><span class="p">(</span><span class="n">level</span><span class="p">,</span> <span class="n">SymbolicRunTrace</span><span class="p">,</span> <span class="n">global_data</span><span class="o">=</span><span class="kc">None</span><span class="p">)</span>
</span><span id="L-2209"><a href="#L-2209"><span class="linenos">2209</span></a>    <span class="n">trace_stack</span> <span class="o">+=</span> <span class="p">[</span><span class="n">main</span><span class="p">]</span>
</span><span id="L-2210"><a href="#L-2210"><span class="linenos">2210</span></a>    <span class="k">global</span> <span class="n">stashed_trace</span>
</span><span id="L-2211"><a href="#L-2211"><span class="linenos">2211</span></a>    <span class="n">prev_stashed_trace</span><span class="p">,</span> <span class="n">stashed_trace</span> <span class="o">=</span> <span class="n">stashed_trace</span><span class="p">,</span> <span class="n">main</span>
</span><span id="L-2212"><a href="#L-2212"><span class="linenos">2212</span></a>    <span class="k">try</span><span class="p">:</span>
</span><span id="L-2213"><a href="#L-2213"><span class="linenos">2213</span></a>        <span class="k">yield</span>
</span><span id="L-2214"><a href="#L-2214"><span class="linenos">2214</span></a>    <span class="k">finally</span><span class="p">:</span>
</span><span id="L-2215"><a href="#L-2215"><span class="linenos">2215</span></a>        <span class="n">stashed_trace</span> <span class="o">=</span> <span class="n">prev_stashed_trace</span>
</span><span id="L-2216"><a href="#L-2216"><span class="linenos">2216</span></a>        <span class="n">trace_stack</span><span class="o">.</span><span class="n">pop</span><span class="p">()</span>
</span><span id="L-2217"><a href="#L-2217"><span class="linenos">2217</span></a>
</span><span id="L-2218"><a href="#L-2218"><span class="linenos">2218</span></a>
</span><span id="L-2219"><a href="#L-2219"><span class="linenos">2219</span></a><span class="nd">@lru_cache_verbose</span><span class="p">()</span>
</span><span id="L-2220"><a href="#L-2220"><span class="linenos">2220</span></a><span class="k">def</span> <span class="nf">make_program</span><span class="p">(</span><span class="n">f</span><span class="p">:</span> <span class="n">Callable</span><span class="p">,</span> <span class="o">*</span><span class="n">symvals_in</span><span class="p">:</span> <span class="n">SymbolicTensor</span><span class="p">,</span> <span class="n">static_args</span><span class="p">,</span> <span class="n">name</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Tuple</span><span class="p">[</span><span class="n">Program</span><span class="p">,</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">],</span> <span class="n">TreeDef</span><span class="p">]:</span>
</span><span id="L-2221"><a href="#L-2221"><span class="linenos">2221</span></a>    <span class="n">symvals_in</span><span class="p">,</span> <span class="n">in_tree</span> <span class="o">=</span> <span class="n">tree_flatten</span><span class="p">(</span><span class="n">symvals_in</span><span class="p">)</span>
</span><span id="L-2222"><a href="#L-2222"><span class="linenos">2222</span></a>    <span class="n">f</span><span class="p">,</span> <span class="n">out_tree_store</span> <span class="o">=</span> <span class="n">flatten_fn</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="n">in_tree</span><span class="p">)</span>
</span><span id="L-2223"><a href="#L-2223"><span class="linenos">2223</span></a>    <span class="n">builder</span> <span class="o">=</span> <span class="n">ProgramBuilder</span><span class="p">()</span>
</span><span id="L-2224"><a href="#L-2224"><span class="linenos">2224</span></a>    <span class="k">with</span> <span class="n">new_main_trace</span><span class="p">(</span><span class="n">ProgramTrace</span><span class="p">,</span> <span class="n">builder</span><span class="p">)</span> <span class="k">as</span> <span class="n">main</span><span class="p">:</span>
</span><span id="L-2225"><a href="#L-2225"><span class="linenos">2225</span></a>        <span class="k">with</span> <span class="n">stash_trace</span><span class="p">(</span><span class="n">main</span><span class="p">):</span>
</span><span id="L-2226"><a href="#L-2226"><span class="linenos">2226</span></a>            <span class="n">trace</span> <span class="o">=</span> <span class="n">ProgramTrace</span><span class="p">(</span><span class="n">main</span><span class="p">)</span>
</span><span id="L-2227"><a href="#L-2227"><span class="linenos">2227</span></a>            <span class="n">tracers_in</span> <span class="o">=</span> <span class="p">[</span><span class="n">trace</span><span class="o">.</span><span class="n">new_arg</span><span class="p">(</span><span class="n">symval</span><span class="p">)</span> <span class="k">for</span> <span class="n">symval</span> <span class="ow">in</span> <span class="n">symvals_in</span><span class="p">]</span>
</span><span id="L-2228"><a href="#L-2228"><span class="linenos">2228</span></a>            <span class="n">outs</span> <span class="o">=</span> <span class="n">f</span><span class="p">(</span><span class="o">*</span><span class="n">tracers_in</span><span class="p">,</span> <span class="o">**</span><span class="p">{</span><span class="n">k</span><span class="p">:</span> <span class="n">v</span> <span class="k">for</span> <span class="n">k</span><span class="p">,</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">static_args</span><span class="p">})</span>
</span><span id="L-2229"><a href="#L-2229"><span class="linenos">2229</span></a>            <span class="n">tracers_out</span> <span class="o">=</span> <span class="p">[</span><span class="n">full_raise</span><span class="p">(</span><span class="n">trace</span><span class="p">,</span> <span class="n">out</span><span class="p">)</span> <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">out</span><span class="p">,</span> <span class="n">ProgramTraceTensor</span><span class="p">)</span> <span class="k">else</span> <span class="n">out</span><span class="o">.</span><span class="n">val</span> <span class="k">for</span> <span class="n">out</span> <span class="ow">in</span> <span class="n">outs</span><span class="p">]</span>
</span><span id="L-2230"><a href="#L-2230"><span class="linenos">2230</span></a>            <span class="n">program</span><span class="p">,</span> <span class="n">consts</span> <span class="o">=</span> <span class="n">builder</span><span class="o">.</span><span class="n">build</span><span class="p">(</span><span class="n">tracers_in</span><span class="p">,</span> <span class="n">tracers_out</span><span class="p">,</span> <span class="n">static_args</span><span class="p">,</span> <span class="n">name</span><span class="p">)</span>
</span><span id="L-2231"><a href="#L-2231"><span class="linenos">2231</span></a>
</span><span id="L-2232"><a href="#L-2232"><span class="linenos">2232</span></a>    <span class="k">return</span> <span class="n">program</span><span class="p">,</span> <span class="n">consts</span><span class="p">,</span> <span class="n">out_tree_store</span><span class="p">()</span>
</span><span id="L-2233"><a href="#L-2233"><span class="linenos">2233</span></a>
</span><span id="L-2234"><a href="#L-2234"><span class="linenos">2234</span></a>
</span><span id="L-2235"><a href="#L-2235"><span class="linenos">2235</span></a><span class="nd">@lru_cache_verbose</span><span class="p">()</span>
</span><span id="L-2236"><a href="#L-2236"><span class="linenos">2236</span></a><span class="k">def</span> <span class="nf">vmap_program</span><span class="p">(</span><span class="n">program</span><span class="p">:</span> <span class="n">Program</span><span class="p">,</span> <span class="n">dim_size</span><span class="p">,</span> <span class="n">dims_in</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="nb">tuple</span><span class="p">[</span><span class="n">Program</span><span class="p">,</span> <span class="nb">list</span><span class="p">[</span><span class="n">Any</span><span class="p">]]:</span>
</span><span id="L-2237"><a href="#L-2237"><span class="linenos">2237</span></a>    <span class="k">def</span> <span class="nf">unmapped_symval</span><span class="p">(</span><span class="n">axis_size</span><span class="p">:</span> <span class="nb">int</span><span class="p">,</span> <span class="n">batch_dim</span><span class="p">,</span> <span class="n">symval</span><span class="p">:</span> <span class="n">SymbolicTensor</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">SymbolicTensor</span><span class="p">:</span>
</span><span id="L-2238"><a href="#L-2238"><span class="linenos">2238</span></a>        <span class="k">if</span> <span class="n">batch_dim</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
</span><span id="L-2239"><a href="#L-2239"><span class="linenos">2239</span></a>            <span class="k">return</span> <span class="n">symval</span>
</span><span id="L-2240"><a href="#L-2240"><span class="linenos">2240</span></a>        <span class="k">else</span><span class="p">:</span>
</span><span id="L-2241"><a href="#L-2241"><span class="linenos">2241</span></a>            <span class="n">shape</span> <span class="o">=</span> <span class="nb">list</span><span class="p">(</span><span class="n">symval</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span>
</span><span id="L-2242"><a href="#L-2242"><span class="linenos">2242</span></a>            <span class="n">shape</span><span class="o">.</span><span class="n">insert</span><span class="p">(</span><span class="n">batch_dim</span><span class="p">,</span> <span class="n">axis_size</span><span class="p">)</span>
</span><span id="L-2243"><a href="#L-2243"><span class="linenos">2243</span></a>            <span class="k">return</span> <span class="n">symval</span><span class="o">.</span><span class="n">like</span><span class="p">(</span><span class="n">shape</span><span class="o">=</span><span class="nb">tuple</span><span class="p">(</span><span class="n">shape</span><span class="p">))</span>
</span><span id="L-2244"><a href="#L-2244"><span class="linenos">2244</span></a>
</span><span id="L-2245"><a href="#L-2245"><span class="linenos">2245</span></a>    <span class="n">vmap_traceable</span> <span class="o">=</span> <span class="n">vmap</span><span class="p">(</span><span class="n">program_as_fun</span><span class="p">(</span><span class="n">program</span><span class="p">),</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">dims_in</span><span class="p">))</span>
</span><span id="L-2246"><a href="#L-2246"><span class="linenos">2246</span></a>    <span class="n">in_symvals</span> <span class="o">=</span> <span class="p">[</span><span class="n">unmapped_symval</span><span class="p">(</span><span class="n">dim_size</span><span class="p">,</span> <span class="n">d</span><span class="p">,</span> <span class="n">v</span><span class="o">.</span><span class="n">symval</span><span class="p">)</span> <span class="k">for</span> <span class="n">v</span><span class="p">,</span> <span class="n">d</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">program</span><span class="o">.</span><span class="n">in_binders</span><span class="p">,</span> <span class="n">dims_in</span><span class="p">)]</span>
</span><span id="L-2247"><a href="#L-2247"><span class="linenos">2247</span></a>    <span class="n">program</span><span class="p">,</span> <span class="n">consts</span><span class="p">,</span> <span class="n">_</span> <span class="o">=</span> <span class="n">make_program</span><span class="p">(</span>
</span><span id="L-2248"><a href="#L-2248"><span class="linenos">2248</span></a>        <span class="n">vmap_traceable</span><span class="p">,</span>
</span><span id="L-2249"><a href="#L-2249"><span class="linenos">2249</span></a>        <span class="o">*</span><span class="n">in_symvals</span><span class="p">,</span>
</span><span id="L-2250"><a href="#L-2250"><span class="linenos">2250</span></a>        <span class="n">static_args</span><span class="o">=</span><span class="n">program</span><span class="o">.</span><span class="n">static_args</span><span class="p">,</span>
</span><span id="L-2251"><a href="#L-2251"><span class="linenos">2251</span></a>        <span class="n">name</span><span class="o">=</span><span class="sa">f</span><span class="s2">&quot;vmap_</span><span class="si">{</span><span class="n">program</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">,</span>
</span><span id="L-2252"><a href="#L-2252"><span class="linenos">2252</span></a>    <span class="p">)</span>
</span><span id="L-2253"><a href="#L-2253"><span class="linenos">2253</span></a>    <span class="k">return</span> <span class="n">program</span><span class="p">,</span> <span class="n">consts</span>
</span><span id="L-2254"><a href="#L-2254"><span class="linenos">2254</span></a>
</span><span id="L-2255"><a href="#L-2255"><span class="linenos">2255</span></a>
</span><span id="L-2256"><a href="#L-2256"><span class="linenos">2256</span></a><span class="nd">@lru_cache_verbose</span><span class="p">()</span>
</span><span id="L-2257"><a href="#L-2257"><span class="linenos">2257</span></a><span class="k">def</span> <span class="nf">jvp_program</span><span class="p">(</span><span class="n">program</span><span class="p">:</span> <span class="n">Program</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Tuple</span><span class="p">[</span><span class="n">Program</span><span class="p">,</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">]]:</span>
</span><span id="L-2258"><a href="#L-2258"><span class="linenos">2258</span></a>    <span class="k">def</span> <span class="nf">jvp_traceable</span><span class="p">(</span><span class="o">*</span><span class="n">primals_and_tangents</span><span class="p">):</span>
</span><span id="L-2259"><a href="#L-2259"><span class="linenos">2259</span></a>        <span class="n">n</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">primals_and_tangents</span><span class="p">)</span> <span class="o">//</span> <span class="mi">2</span>
</span><span id="L-2260"><a href="#L-2260"><span class="linenos">2260</span></a>        <span class="n">primals</span><span class="p">,</span> <span class="n">tangents</span> <span class="o">=</span> <span class="n">primals_and_tangents</span><span class="p">[:</span><span class="n">n</span><span class="p">],</span> <span class="n">primals_and_tangents</span><span class="p">[</span><span class="n">n</span><span class="p">:]</span>
</span><span id="L-2261"><a href="#L-2261"><span class="linenos">2261</span></a>        <span class="k">return</span> <span class="n">jvp</span><span class="p">(</span><span class="n">program_as_fun</span><span class="p">(</span><span class="n">program</span><span class="p">),</span> <span class="n">primals</span><span class="p">,</span> <span class="n">tangents</span><span class="p">)</span>
</span><span id="L-2262"><a href="#L-2262"><span class="linenos">2262</span></a>
</span><span id="L-2263"><a href="#L-2263"><span class="linenos">2263</span></a>    <span class="n">in_symvals</span> <span class="o">=</span> <span class="n">tree_map</span><span class="p">(</span><span class="k">lambda</span> <span class="n">v</span><span class="p">:</span> <span class="n">v</span><span class="o">.</span><span class="n">symval</span><span class="p">,</span> <span class="n">program</span><span class="o">.</span><span class="n">in_binders</span><span class="p">)</span>
</span><span id="L-2264"><a href="#L-2264"><span class="linenos">2264</span></a>    <span class="n">new_program</span><span class="p">,</span> <span class="n">new_consts</span><span class="p">,</span> <span class="n">_</span> <span class="o">=</span> <span class="n">make_program</span><span class="p">(</span>
</span><span id="L-2265"><a href="#L-2265"><span class="linenos">2265</span></a>        <span class="n">jvp_traceable</span><span class="p">,</span>
</span><span id="L-2266"><a href="#L-2266"><span class="linenos">2266</span></a>        <span class="o">*</span><span class="n">in_symvals</span><span class="p">,</span>
</span><span id="L-2267"><a href="#L-2267"><span class="linenos">2267</span></a>        <span class="o">*</span><span class="n">in_symvals</span><span class="p">,</span>
</span><span id="L-2268"><a href="#L-2268"><span class="linenos">2268</span></a>        <span class="n">static_args</span><span class="o">=</span><span class="n">program</span><span class="o">.</span><span class="n">static_args</span><span class="p">,</span>
</span><span id="L-2269"><a href="#L-2269"><span class="linenos">2269</span></a>        <span class="n">name</span><span class="o">=</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">program</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">_jvp&quot;</span><span class="p">,</span>
</span><span id="L-2270"><a href="#L-2270"><span class="linenos">2270</span></a>    <span class="p">)</span>
</span><span id="L-2271"><a href="#L-2271"><span class="linenos">2271</span></a>    <span class="k">return</span> <span class="n">new_program</span><span class="p">,</span> <span class="n">new_consts</span>
</span><span id="L-2272"><a href="#L-2272"><span class="linenos">2272</span></a>
</span><span id="L-2273"><a href="#L-2273"><span class="linenos">2273</span></a>
</span><span id="L-2274"><a href="#L-2274"><span class="linenos">2274</span></a><span class="k">def</span> <span class="nf">partial_run_flat</span><span class="p">(</span>
</span><span id="L-2275"><a href="#L-2275"><span class="linenos">2275</span></a>    <span class="n">f</span><span class="p">:</span> <span class="n">Callable</span><span class="p">,</span> <span class="n">pvals_in</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="s2">&quot;PartialValue&quot;</span><span class="p">],</span> <span class="n">has_aux</span><span class="p">,</span> <span class="n">global_data</span><span class="o">=</span><span class="kc">None</span>
</span><span id="L-2276"><a href="#L-2276"><span class="linenos">2276</span></a><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Tuple</span><span class="p">[</span><span class="n">Program</span><span class="p">,</span> <span class="n">List</span><span class="p">[</span><span class="s2">&quot;PartialValue&quot;</span><span class="p">],</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">]]:</span>
</span><span id="L-2277"><a href="#L-2277"><span class="linenos">2277</span></a>    <span class="k">with</span> <span class="n">new_main_trace</span><span class="p">(</span><span class="n">PartialRunTrace</span><span class="p">,</span> <span class="n">global_data</span><span class="p">)</span> <span class="k">as</span> <span class="n">main</span><span class="p">:</span>
</span><span id="L-2278"><a href="#L-2278"><span class="linenos">2278</span></a>        <span class="n">trace</span> <span class="o">=</span> <span class="n">PartialRunTrace</span><span class="p">(</span><span class="n">main</span><span class="p">)</span>
</span><span id="L-2279"><a href="#L-2279"><span class="linenos">2279</span></a>        <span class="n">tracers_in</span> <span class="o">=</span> <span class="p">[</span><span class="n">trace</span><span class="o">.</span><span class="n">new_arg</span><span class="p">(</span><span class="n">pval</span><span class="p">)</span> <span class="k">for</span> <span class="n">pval</span> <span class="ow">in</span> <span class="n">pvals_in</span><span class="p">]</span>
</span><span id="L-2280"><a href="#L-2280"><span class="linenos">2280</span></a>        <span class="n">outs</span> <span class="o">=</span> <span class="n">f</span><span class="p">(</span><span class="o">*</span><span class="n">tracers_in</span><span class="p">)</span>
</span><span id="L-2281"><a href="#L-2281"><span class="linenos">2281</span></a>        <span class="k">if</span> <span class="n">has_aux</span><span class="p">:</span>
</span><span id="L-2282"><a href="#L-2282"><span class="linenos">2282</span></a>            <span class="n">outs</span><span class="p">,</span> <span class="n">aux</span> <span class="o">=</span> <span class="n">outs</span>
</span><span id="L-2283"><a href="#L-2283"><span class="linenos">2283</span></a>        <span class="n">tracers_out</span> <span class="o">=</span> <span class="p">[</span><span class="n">full_raise</span><span class="p">(</span><span class="n">trace</span><span class="p">,</span> <span class="n">out</span><span class="p">)</span> <span class="k">for</span> <span class="n">out</span> <span class="ow">in</span> <span class="n">outs</span><span class="p">]</span>
</span><span id="L-2284"><a href="#L-2284"><span class="linenos">2284</span></a>        <span class="n">pvals_out</span> <span class="o">=</span> <span class="p">[</span><span class="n">t</span><span class="o">.</span><span class="n">pval</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">tracers_out</span><span class="p">]</span>
</span><span id="L-2285"><a href="#L-2285"><span class="linenos">2285</span></a>        <span class="n">unk_tracers_in</span> <span class="o">=</span> <span class="p">[</span><span class="n">t</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">tracers_in</span> <span class="k">if</span> <span class="n">t</span><span class="o">.</span><span class="n">pval</span><span class="o">.</span><span class="n">is_unknown</span><span class="p">]</span>
</span><span id="L-2286"><a href="#L-2286"><span class="linenos">2286</span></a>        <span class="n">unk_tracers_out</span> <span class="o">=</span> <span class="p">[</span><span class="n">t</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">tracers_out</span> <span class="k">if</span> <span class="n">t</span><span class="o">.</span><span class="n">pval</span><span class="o">.</span><span class="n">is_unknown</span><span class="p">]</span>
</span><span id="L-2287"><a href="#L-2287"><span class="linenos">2287</span></a>        <span class="n">program</span><span class="p">,</span> <span class="n">consts</span> <span class="o">=</span> <span class="n">tracers_to_program</span><span class="p">(</span><span class="n">unk_tracers_in</span><span class="p">,</span> <span class="n">unk_tracers_out</span><span class="p">)</span>
</span><span id="L-2288"><a href="#L-2288"><span class="linenos">2288</span></a>
</span><span id="L-2289"><a href="#L-2289"><span class="linenos">2289</span></a>    <span class="k">return</span> <span class="p">(</span><span class="n">program</span><span class="p">,</span> <span class="n">pvals_out</span><span class="p">,</span> <span class="n">consts</span><span class="p">,</span> <span class="n">aux</span><span class="p">)</span> <span class="k">if</span> <span class="n">has_aux</span> <span class="k">else</span> <span class="p">(</span><span class="n">program</span><span class="p">,</span> <span class="n">pvals_out</span><span class="p">,</span> <span class="n">consts</span><span class="p">)</span>
</span><span id="L-2290"><a href="#L-2290"><span class="linenos">2290</span></a>
</span><span id="L-2291"><a href="#L-2291"><span class="linenos">2291</span></a>
</span><span id="L-2292"><a href="#L-2292"><span class="linenos">2292</span></a><span class="k">def</span> <span class="nf">partial_run_program</span><span class="p">(</span>
</span><span id="L-2293"><a href="#L-2293"><span class="linenos">2293</span></a>    <span class="n">program</span><span class="p">:</span> <span class="n">Program</span><span class="p">,</span>
</span><span id="L-2294"><a href="#L-2294"><span class="linenos">2294</span></a>    <span class="n">in_unknowns</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="nb">bool</span><span class="p">],</span>
</span><span id="L-2295"><a href="#L-2295"><span class="linenos">2295</span></a>    <span class="n">instantiate</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="n">List</span><span class="p">[</span><span class="nb">bool</span><span class="p">]]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span>
</span><span id="L-2296"><a href="#L-2296"><span class="linenos">2296</span></a><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Tuple</span><span class="p">[</span><span class="n">Program</span><span class="p">,</span> <span class="n">Program</span><span class="p">,</span> <span class="n">List</span><span class="p">[</span><span class="nb">bool</span><span class="p">],</span> <span class="nb">int</span><span class="p">]:</span>
</span><span id="L-2297"><a href="#L-2297"><span class="linenos">2297</span></a>    <span class="n">env</span><span class="p">:</span> <span class="n">Dict</span><span class="p">[</span><span class="n">Var</span><span class="p">,</span> <span class="nb">bool</span><span class="p">]</span> <span class="o">=</span> <span class="p">{}</span>
</span><span id="L-2298"><a href="#L-2298"><span class="linenos">2298</span></a>    <span class="n">residuals</span><span class="p">:</span> <span class="n">Set</span><span class="p">[</span><span class="n">Var</span><span class="p">]</span> <span class="o">=</span> <span class="nb">set</span><span class="p">()</span>
</span><span id="L-2299"><a href="#L-2299"><span class="linenos">2299</span></a>
</span><span id="L-2300"><a href="#L-2300"><span class="linenos">2300</span></a>    <span class="k">def</span> <span class="nf">read</span><span class="p">(</span><span class="n">x</span><span class="p">:</span> <span class="n">Atom</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="nb">bool</span><span class="p">:</span>
</span><span id="L-2301"><a href="#L-2301"><span class="linenos">2301</span></a>        <span class="k">return</span> <span class="nb">type</span><span class="p">(</span><span class="n">x</span><span class="p">)</span> <span class="ow">is</span> <span class="n">Var</span> <span class="ow">and</span> <span class="n">env</span><span class="p">[</span><span class="n">x</span><span class="p">]</span>
</span><span id="L-2302"><a href="#L-2302"><span class="linenos">2302</span></a>
</span><span id="L-2303"><a href="#L-2303"><span class="linenos">2303</span></a>    <span class="k">def</span> <span class="nf">write</span><span class="p">(</span><span class="n">unk</span><span class="p">:</span> <span class="nb">bool</span><span class="p">,</span> <span class="n">v</span><span class="p">:</span> <span class="n">Var</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="kc">None</span><span class="p">:</span>
</span><span id="L-2304"><a href="#L-2304"><span class="linenos">2304</span></a>        <span class="n">env</span><span class="p">[</span><span class="n">v</span><span class="p">]</span> <span class="o">=</span> <span class="n">unk</span>
</span><span id="L-2305"><a href="#L-2305"><span class="linenos">2305</span></a>
</span><span id="L-2306"><a href="#L-2306"><span class="linenos">2306</span></a>    <span class="n">instructions1</span><span class="p">,</span> <span class="n">instructions2</span> <span class="o">=</span> <span class="p">[],</span> <span class="p">[]</span>
</span><span id="L-2307"><a href="#L-2307"><span class="linenos">2307</span></a>    <span class="n">list_map</span><span class="p">(</span><span class="n">write</span><span class="p">,</span> <span class="n">in_unknowns</span><span class="p">,</span> <span class="n">program</span><span class="o">.</span><span class="n">in_binders</span><span class="p">)</span>
</span><span id="L-2308"><a href="#L-2308"><span class="linenos">2308</span></a>
</span><span id="L-2309"><a href="#L-2309"><span class="linenos">2309</span></a>    <span class="k">for</span> <span class="n">instruction</span> <span class="ow">in</span> <span class="n">program</span><span class="o">.</span><span class="n">instructions</span><span class="p">:</span>
</span><span id="L-2310"><a href="#L-2310"><span class="linenos">2310</span></a>        <span class="n">unks_in</span> <span class="o">=</span> <span class="n">list_map</span><span class="p">(</span><span class="n">read</span><span class="p">,</span> <span class="n">instruction</span><span class="o">.</span><span class="n">inputs</span><span class="p">)</span>
</span><span id="L-2311"><a href="#L-2311"><span class="linenos">2311</span></a>        <span class="p">(</span>
</span><span id="L-2312"><a href="#L-2312"><span class="linenos">2312</span></a>            <span class="n">instruction1</span><span class="p">,</span>
</span><span id="L-2313"><a href="#L-2313"><span class="linenos">2313</span></a>            <span class="n">instruction2</span><span class="p">,</span>
</span><span id="L-2314"><a href="#L-2314"><span class="linenos">2314</span></a>            <span class="n">unks_out</span><span class="p">,</span>
</span><span id="L-2315"><a href="#L-2315"><span class="linenos">2315</span></a>            <span class="n">res</span><span class="p">,</span>
</span><span id="L-2316"><a href="#L-2316"><span class="linenos">2316</span></a>        <span class="p">)</span> <span class="o">=</span> <span class="n">instruction</span><span class="o">.</span><span class="n">op</span><span class="o">.</span><span class="n">partial_run_instruction</span><span class="p">(</span><span class="n">unks_in</span><span class="p">,</span> <span class="n">instruction</span><span class="p">)</span>
</span><span id="L-2317"><a href="#L-2317"><span class="linenos">2317</span></a>        <span class="k">if</span> <span class="n">instruction1</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
</span><span id="L-2318"><a href="#L-2318"><span class="linenos">2318</span></a>            <span class="n">instructions1</span> <span class="o">+=</span> <span class="p">[</span><span class="n">instruction1</span><span class="p">]</span>
</span><span id="L-2319"><a href="#L-2319"><span class="linenos">2319</span></a>        <span class="k">if</span> <span class="n">instruction2</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
</span><span id="L-2320"><a href="#L-2320"><span class="linenos">2320</span></a>            <span class="n">instructions2</span> <span class="o">+=</span> <span class="p">[</span><span class="n">instruction2</span><span class="p">]</span>
</span><span id="L-2321"><a href="#L-2321"><span class="linenos">2321</span></a>        <span class="k">if</span> <span class="n">res</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
</span><span id="L-2322"><a href="#L-2322"><span class="linenos">2322</span></a>            <span class="n">residuals</span><span class="o">.</span><span class="n">update</span><span class="p">(</span><span class="n">res</span><span class="p">)</span>
</span><span id="L-2323"><a href="#L-2323"><span class="linenos">2323</span></a>        <span class="n">list_map</span><span class="p">(</span><span class="n">write</span><span class="p">,</span> <span class="n">unks_out</span><span class="p">,</span> <span class="n">instruction</span><span class="o">.</span><span class="n">out_binders</span><span class="p">)</span>
</span><span id="L-2324"><a href="#L-2324"><span class="linenos">2324</span></a>
</span><span id="L-2325"><a href="#L-2325"><span class="linenos">2325</span></a>    <span class="n">out_unknowns</span> <span class="o">=</span> <span class="n">list_map</span><span class="p">(</span><span class="n">read</span><span class="p">,</span> <span class="n">program</span><span class="o">.</span><span class="n">outs</span><span class="p">)</span>
</span><span id="L-2326"><a href="#L-2326"><span class="linenos">2326</span></a>    <span class="k">if</span> <span class="n">instantiate</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
</span><span id="L-2327"><a href="#L-2327"><span class="linenos">2327</span></a>        <span class="k">for</span> <span class="n">v</span><span class="p">,</span> <span class="n">uk</span><span class="p">,</span> <span class="n">inst</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">program</span><span class="o">.</span><span class="n">outs</span><span class="p">,</span> <span class="n">out_unknowns</span><span class="p">,</span> <span class="n">instantiate</span><span class="p">):</span>
</span><span id="L-2328"><a href="#L-2328"><span class="linenos">2328</span></a>            <span class="k">if</span> <span class="n">inst</span> <span class="ow">and</span> <span class="ow">not</span> <span class="n">uk</span><span class="p">:</span>
</span><span id="L-2329"><a href="#L-2329"><span class="linenos">2329</span></a>                <span class="k">if</span> <span class="nb">type</span><span class="p">(</span><span class="n">v</span><span class="p">)</span> <span class="ow">is</span> <span class="n">Var</span><span class="p">:</span>
</span><span id="L-2330"><a href="#L-2330"><span class="linenos">2330</span></a>                    <span class="n">residuals</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">v</span><span class="p">)</span>
</span><span id="L-2331"><a href="#L-2331"><span class="linenos">2331</span></a>        <span class="n">out_unknowns</span> <span class="o">=</span> <span class="n">list_map</span><span class="p">(</span><span class="n">operator_py</span><span class="o">.</span><span class="n">or_</span><span class="p">,</span> <span class="n">out_unknowns</span><span class="p">,</span> <span class="n">instantiate</span><span class="p">)</span>
</span><span id="L-2332"><a href="#L-2332"><span class="linenos">2332</span></a>
</span><span id="L-2333"><a href="#L-2333"><span class="linenos">2333</span></a>    <span class="n">residuals</span><span class="p">,</span> <span class="n">num_res</span> <span class="o">=</span> <span class="nb">list</span><span class="p">(</span><span class="n">residuals</span><span class="p">),</span> <span class="nb">len</span><span class="p">(</span><span class="n">residuals</span><span class="p">)</span>
</span><span id="L-2334"><a href="#L-2334"><span class="linenos">2334</span></a>    <span class="k">assert</span> <span class="nb">all</span><span class="p">(</span><span class="nb">type</span><span class="p">(</span><span class="n">v</span><span class="p">)</span> <span class="ow">is</span> <span class="n">Var</span> <span class="k">for</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">residuals</span><span class="p">),</span> <span class="n">residuals</span>
</span><span id="L-2335"><a href="#L-2335"><span class="linenos">2335</span></a>
</span><span id="L-2336"><a href="#L-2336"><span class="linenos">2336</span></a>    <span class="n">ins1</span><span class="p">,</span> <span class="n">ins2</span> <span class="o">=</span> <span class="n">partition_list</span><span class="p">(</span><span class="n">in_unknowns</span><span class="p">,</span> <span class="n">program</span><span class="o">.</span><span class="n">in_binders</span><span class="p">)</span>
</span><span id="L-2337"><a href="#L-2337"><span class="linenos">2337</span></a>    <span class="n">outs1</span><span class="p">,</span> <span class="n">outs2</span> <span class="o">=</span> <span class="n">partition_list</span><span class="p">(</span><span class="n">out_unknowns</span><span class="p">,</span> <span class="n">program</span><span class="o">.</span><span class="n">outs</span><span class="p">)</span>
</span><span id="L-2338"><a href="#L-2338"><span class="linenos">2338</span></a>
</span><span id="L-2339"><a href="#L-2339"><span class="linenos">2339</span></a>    <span class="n">program1</span> <span class="o">=</span> <span class="n">Program</span><span class="p">(</span>
</span><span id="L-2340"><a href="#L-2340"><span class="linenos">2340</span></a>        <span class="n">ins1</span><span class="p">,</span>
</span><span id="L-2341"><a href="#L-2341"><span class="linenos">2341</span></a>        <span class="n">instructions1</span><span class="p">,</span>
</span><span id="L-2342"><a href="#L-2342"><span class="linenos">2342</span></a>        <span class="n">outs1</span> <span class="o">+</span> <span class="n">residuals</span><span class="p">,</span>
</span><span id="L-2343"><a href="#L-2343"><span class="linenos">2343</span></a>        <span class="mi">0</span><span class="p">,</span>
</span><span id="L-2344"><a href="#L-2344"><span class="linenos">2344</span></a>        <span class="n">program</span><span class="o">.</span><span class="n">static_args</span><span class="p">,</span>
</span><span id="L-2345"><a href="#L-2345"><span class="linenos">2345</span></a>        <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">program</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">_partial1&quot;</span><span class="p">,</span>
</span><span id="L-2346"><a href="#L-2346"><span class="linenos">2346</span></a>    <span class="p">)</span>
</span><span id="L-2347"><a href="#L-2347"><span class="linenos">2347</span></a>    <span class="n">program2</span> <span class="o">=</span> <span class="n">Program</span><span class="p">(</span>
</span><span id="L-2348"><a href="#L-2348"><span class="linenos">2348</span></a>        <span class="n">residuals</span> <span class="o">+</span> <span class="n">ins2</span><span class="p">,</span>
</span><span id="L-2349"><a href="#L-2349"><span class="linenos">2349</span></a>        <span class="n">instructions2</span><span class="p">,</span>
</span><span id="L-2350"><a href="#L-2350"><span class="linenos">2350</span></a>        <span class="n">outs2</span><span class="p">,</span>
</span><span id="L-2351"><a href="#L-2351"><span class="linenos">2351</span></a>        <span class="mi">0</span><span class="p">,</span>
</span><span id="L-2352"><a href="#L-2352"><span class="linenos">2352</span></a>        <span class="n">program</span><span class="o">.</span><span class="n">static_args</span><span class="p">,</span>
</span><span id="L-2353"><a href="#L-2353"><span class="linenos">2353</span></a>        <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">program</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">_partial2&quot;</span><span class="p">,</span>
</span><span id="L-2354"><a href="#L-2354"><span class="linenos">2354</span></a>    <span class="p">)</span>
</span><span id="L-2355"><a href="#L-2355"><span class="linenos">2355</span></a>    <span class="n">typecheck_partial_run_program</span><span class="p">(</span><span class="n">program</span><span class="p">,</span> <span class="n">in_unknowns</span><span class="p">,</span> <span class="n">out_unknowns</span><span class="p">,</span> <span class="n">program1</span><span class="p">,</span> <span class="n">program2</span><span class="p">)</span>
</span><span id="L-2356"><a href="#L-2356"><span class="linenos">2356</span></a>
</span><span id="L-2357"><a href="#L-2357"><span class="linenos">2357</span></a>    <span class="k">return</span> <span class="n">program1</span><span class="p">,</span> <span class="n">program2</span><span class="p">,</span> <span class="n">out_unknowns</span><span class="p">,</span> <span class="n">num_res</span>
</span><span id="L-2358"><a href="#L-2358"><span class="linenos">2358</span></a>
</span><span id="L-2359"><a href="#L-2359"><span class="linenos">2359</span></a>
</span><span id="L-2360"><a href="#L-2360"><span class="linenos">2360</span></a><span class="k">def</span> <span class="nf">typecheck_partial_run_program</span><span class="p">(</span><span class="n">program</span><span class="p">,</span> <span class="n">in_unknowns</span><span class="p">,</span> <span class="n">out_unknowns</span><span class="p">,</span> <span class="n">program1</span><span class="p">,</span> <span class="n">program2</span><span class="p">):</span>
</span><span id="L-2361"><a href="#L-2361"><span class="linenos">2361</span></a>    <span class="n">programty</span> <span class="o">=</span> <span class="n">typecheck_program</span><span class="p">(</span><span class="n">program</span><span class="p">)</span>  <span class="c1"># (a1,  a2) -&gt; (b1, b2 )</span>
</span><span id="L-2362"><a href="#L-2362"><span class="linenos">2362</span></a>    <span class="n">program1ty</span> <span class="o">=</span> <span class="n">typecheck_program</span><span class="p">(</span><span class="n">program1</span><span class="p">)</span>  <span class="c1">#  a1       -&gt; (b1, res)</span>
</span><span id="L-2363"><a href="#L-2363"><span class="linenos">2363</span></a>    <span class="n">program2ty</span> <span class="o">=</span> <span class="n">typecheck_program</span><span class="p">(</span><span class="n">program2</span><span class="p">)</span>  <span class="c1"># (res, a2) -&gt; b2</span>
</span><span id="L-2364"><a href="#L-2364"><span class="linenos">2364</span></a>
</span><span id="L-2365"><a href="#L-2365"><span class="linenos">2365</span></a>    <span class="n">a1</span><span class="p">,</span> <span class="n">a2</span> <span class="o">=</span> <span class="n">partition_list</span><span class="p">(</span><span class="n">in_unknowns</span><span class="p">,</span> <span class="n">programty</span><span class="o">.</span><span class="n">in_types</span><span class="p">)</span>
</span><span id="L-2366"><a href="#L-2366"><span class="linenos">2366</span></a>    <span class="n">b1</span><span class="p">,</span> <span class="n">b2</span> <span class="o">=</span> <span class="n">partition_list</span><span class="p">(</span><span class="n">out_unknowns</span><span class="p">,</span> <span class="n">programty</span><span class="o">.</span><span class="n">out_types</span><span class="p">)</span>
</span><span id="L-2367"><a href="#L-2367"><span class="linenos">2367</span></a>    <span class="n">b1_</span><span class="p">,</span> <span class="n">res</span> <span class="o">=</span> <span class="n">split_list</span><span class="p">(</span><span class="n">program1ty</span><span class="o">.</span><span class="n">out_types</span><span class="p">,</span> <span class="nb">len</span><span class="p">(</span><span class="n">b1</span><span class="p">))</span>
</span><span id="L-2368"><a href="#L-2368"><span class="linenos">2368</span></a>    <span class="n">res_</span><span class="p">,</span> <span class="n">a2_</span> <span class="o">=</span> <span class="n">split_list</span><span class="p">(</span><span class="n">program2ty</span><span class="o">.</span><span class="n">in_types</span><span class="p">,</span> <span class="nb">len</span><span class="p">(</span><span class="n">res</span><span class="p">))</span>
</span><span id="L-2369"><a href="#L-2369"><span class="linenos">2369</span></a>    <span class="n">b2_</span> <span class="o">=</span> <span class="n">program2ty</span><span class="o">.</span><span class="n">out_types</span>
</span><span id="L-2370"><a href="#L-2370"><span class="linenos">2370</span></a>
</span><span id="L-2371"><a href="#L-2371"><span class="linenos">2371</span></a>    <span class="n">a1</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">a1</span><span class="p">)</span>
</span><span id="L-2372"><a href="#L-2372"><span class="linenos">2372</span></a>    <span class="n">a2</span><span class="p">,</span> <span class="n">a2_</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">a2</span><span class="p">),</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">a2_</span><span class="p">)</span>
</span><span id="L-2373"><a href="#L-2373"><span class="linenos">2373</span></a>    <span class="n">b1</span><span class="p">,</span> <span class="n">b1_</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">b1</span><span class="p">),</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">b1_</span><span class="p">)</span>
</span><span id="L-2374"><a href="#L-2374"><span class="linenos">2374</span></a>    <span class="n">b2</span><span class="p">,</span> <span class="n">b2_</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">b2</span><span class="p">),</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">b2_</span><span class="p">)</span>
</span><span id="L-2375"><a href="#L-2375"><span class="linenos">2375</span></a>    <span class="n">res</span><span class="p">,</span> <span class="n">res_</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">res</span><span class="p">),</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">res_</span><span class="p">)</span>
</span><span id="L-2376"><a href="#L-2376"><span class="linenos">2376</span></a>
</span><span id="L-2377"><a href="#L-2377"><span class="linenos">2377</span></a>    <span class="k">if</span> <span class="n">program1ty</span><span class="o">.</span><span class="n">in_types</span> <span class="o">!=</span> <span class="n">a1</span><span class="p">:</span>
</span><span id="L-2378"><a href="#L-2378"><span class="linenos">2378</span></a>        <span class="k">raise</span> <span class="ne">TypeError</span>
</span><span id="L-2379"><a href="#L-2379"><span class="linenos">2379</span></a>    <span class="k">if</span> <span class="n">program2ty</span><span class="o">.</span><span class="n">out_types</span> <span class="o">!=</span> <span class="n">b2</span><span class="p">:</span>
</span><span id="L-2380"><a href="#L-2380"><span class="linenos">2380</span></a>        <span class="k">raise</span> <span class="ne">TypeError</span>
</span><span id="L-2381"><a href="#L-2381"><span class="linenos">2381</span></a>    <span class="k">if</span> <span class="n">b1</span> <span class="o">!=</span> <span class="n">b1_</span><span class="p">:</span>
</span><span id="L-2382"><a href="#L-2382"><span class="linenos">2382</span></a>        <span class="k">raise</span> <span class="ne">TypeError</span>
</span><span id="L-2383"><a href="#L-2383"><span class="linenos">2383</span></a>    <span class="k">if</span> <span class="n">res</span> <span class="o">!=</span> <span class="n">res_</span><span class="p">:</span>
</span><span id="L-2384"><a href="#L-2384"><span class="linenos">2384</span></a>        <span class="k">raise</span> <span class="ne">TypeError</span>
</span><span id="L-2385"><a href="#L-2385"><span class="linenos">2385</span></a>    <span class="k">if</span> <span class="n">a2</span> <span class="o">!=</span> <span class="n">a2_</span><span class="p">:</span>
</span><span id="L-2386"><a href="#L-2386"><span class="linenos">2386</span></a>        <span class="k">raise</span> <span class="ne">TypeError</span>
</span><span id="L-2387"><a href="#L-2387"><span class="linenos">2387</span></a>    <span class="k">if</span> <span class="n">b2</span> <span class="o">!=</span> <span class="n">b2_</span><span class="p">:</span>
</span><span id="L-2388"><a href="#L-2388"><span class="linenos">2388</span></a>        <span class="k">raise</span> <span class="ne">TypeError</span>
</span><span id="L-2389"><a href="#L-2389"><span class="linenos">2389</span></a>
</span><span id="L-2390"><a href="#L-2390"><span class="linenos">2390</span></a>
</span><span id="L-2391"><a href="#L-2391"><span class="linenos">2391</span></a><span class="k">def</span> <span class="nf">linearize_flat</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="o">*</span><span class="n">primals_in</span><span class="p">,</span> <span class="n">has_aux</span><span class="p">):</span>
</span><span id="L-2392"><a href="#L-2392"><span class="linenos">2392</span></a>    <span class="n">pvals_in</span> <span class="o">=</span> <span class="p">[</span><span class="n">make_known_pval</span><span class="p">(</span><span class="n">x</span><span class="p">)</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">primals_in</span><span class="p">]</span> <span class="o">+</span> <span class="p">[</span><span class="n">make_unknown_pval</span><span class="p">(</span><span class="n">SymbolicTensor</span><span class="o">.</span><span class="n">like</span><span class="p">(</span><span class="n">get_symval</span><span class="p">(</span><span class="n">x</span><span class="p">)))</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">primals_in</span><span class="p">]</span>
</span><span id="L-2393"><a href="#L-2393"><span class="linenos">2393</span></a>
</span><span id="L-2394"><a href="#L-2394"><span class="linenos">2394</span></a>    <span class="k">def</span> <span class="nf">f_jvp</span><span class="p">(</span><span class="o">*</span><span class="n">primals_tangents_in</span><span class="p">):</span>
</span><span id="L-2395"><a href="#L-2395"><span class="linenos">2395</span></a>        <span class="n">jvp_ret</span> <span class="o">=</span> <span class="n">jvp</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="o">*</span><span class="n">split_half</span><span class="p">(</span><span class="n">primals_tangents_in</span><span class="p">),</span> <span class="n">has_aux</span><span class="o">=</span><span class="n">has_aux</span><span class="p">)</span>
</span><span id="L-2396"><a href="#L-2396"><span class="linenos">2396</span></a>        <span class="k">if</span> <span class="n">has_aux</span><span class="p">:</span>
</span><span id="L-2397"><a href="#L-2397"><span class="linenos">2397</span></a>            <span class="p">(</span><span class="n">primals_out</span><span class="p">,</span> <span class="n">tangents_out</span><span class="p">),</span> <span class="n">aux</span> <span class="o">=</span> <span class="n">jvp_ret</span>
</span><span id="L-2398"><a href="#L-2398"><span class="linenos">2398</span></a>            <span class="k">return</span> <span class="p">((</span><span class="o">*</span><span class="n">primals_out</span><span class="p">,</span> <span class="o">*</span><span class="n">tangents_out</span><span class="p">),</span> <span class="n">aux</span><span class="p">)</span>
</span><span id="L-2399"><a href="#L-2399"><span class="linenos">2399</span></a>        <span class="k">else</span><span class="p">:</span>
</span><span id="L-2400"><a href="#L-2400"><span class="linenos">2400</span></a>            <span class="n">primals_out</span><span class="p">,</span> <span class="n">tangents_out</span> <span class="o">=</span> <span class="n">jvp_ret</span>
</span><span id="L-2401"><a href="#L-2401"><span class="linenos">2401</span></a>            <span class="k">return</span> <span class="p">(</span><span class="o">*</span><span class="n">primals_out</span><span class="p">,</span> <span class="o">*</span><span class="n">tangents_out</span><span class="p">)</span>
</span><span id="L-2402"><a href="#L-2402"><span class="linenos">2402</span></a>
</span><span id="L-2403"><a href="#L-2403"><span class="linenos">2403</span></a>    <span class="n">partial_run_flat_ret</span> <span class="o">=</span> <span class="n">partial_run_flat</span><span class="p">(</span><span class="n">f_jvp</span><span class="p">,</span> <span class="n">pvals_in</span><span class="p">,</span> <span class="n">has_aux</span><span class="p">)</span>
</span><span id="L-2404"><a href="#L-2404"><span class="linenos">2404</span></a>    <span class="k">if</span> <span class="n">has_aux</span><span class="p">:</span>
</span><span id="L-2405"><a href="#L-2405"><span class="linenos">2405</span></a>        <span class="n">program</span><span class="p">,</span> <span class="n">pvals_out</span><span class="p">,</span> <span class="n">consts</span><span class="p">,</span> <span class="n">aux</span> <span class="o">=</span> <span class="n">partial_run_flat_ret</span>
</span><span id="L-2406"><a href="#L-2406"><span class="linenos">2406</span></a>    <span class="k">else</span><span class="p">:</span>
</span><span id="L-2407"><a href="#L-2407"><span class="linenos">2407</span></a>        <span class="n">program</span><span class="p">,</span> <span class="n">pvals_out</span><span class="p">,</span> <span class="n">consts</span> <span class="o">=</span> <span class="n">partial_run_flat_ret</span>
</span><span id="L-2408"><a href="#L-2408"><span class="linenos">2408</span></a>    <span class="n">primal_pvals</span><span class="p">,</span> <span class="n">_</span> <span class="o">=</span> <span class="n">split_half</span><span class="p">(</span><span class="n">pvals_out</span><span class="p">)</span>
</span><span id="L-2409"><a href="#L-2409"><span class="linenos">2409</span></a>    <span class="k">assert</span> <span class="nb">all</span><span class="p">(</span><span class="n">pval</span><span class="o">.</span><span class="n">is_known</span> <span class="k">for</span> <span class="n">pval</span> <span class="ow">in</span> <span class="n">primal_pvals</span><span class="p">)</span>
</span><span id="L-2410"><a href="#L-2410"><span class="linenos">2410</span></a>    <span class="n">primals_out</span> <span class="o">=</span> <span class="p">[</span><span class="n">pval</span><span class="o">.</span><span class="n">const</span> <span class="k">for</span> <span class="n">pval</span> <span class="ow">in</span> <span class="n">primal_pvals</span><span class="p">]</span>
</span><span id="L-2411"><a href="#L-2411"><span class="linenos">2411</span></a>    <span class="n">f_lin</span> <span class="o">=</span> <span class="k">lambda</span> <span class="o">*</span><span class="n">tangents</span><span class="p">:</span> <span class="n">run_program</span><span class="p">(</span><span class="n">program</span><span class="p">,</span> <span class="p">[</span><span class="o">*</span><span class="n">consts</span><span class="p">,</span> <span class="o">*</span><span class="n">tangents</span><span class="p">])</span>
</span><span id="L-2412"><a href="#L-2412"><span class="linenos">2412</span></a>    <span class="k">return</span> <span class="p">(</span><span class="n">primals_out</span><span class="p">,</span> <span class="n">f_lin</span><span class="p">,</span> <span class="n">aux</span><span class="p">)</span> <span class="k">if</span> <span class="n">has_aux</span> <span class="k">else</span> <span class="p">(</span><span class="n">primals_out</span><span class="p">,</span> <span class="n">f_lin</span><span class="p">)</span>
</span><span id="L-2413"><a href="#L-2413"><span class="linenos">2413</span></a>
</span><span id="L-2414"><a href="#L-2414"><span class="linenos">2414</span></a>
</span><span id="L-2415"><a href="#L-2415"><span class="linenos">2415</span></a><span class="k">def</span> <span class="nf">linearize</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="o">*</span><span class="n">primals_in</span><span class="p">,</span> <span class="n">has_aux</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>
</span><span id="L-2416"><a href="#L-2416"><span class="linenos">2416</span></a>    <span class="n">primals_in_flat</span><span class="p">,</span> <span class="n">in_tree</span> <span class="o">=</span> <span class="n">tree_flatten</span><span class="p">(</span><span class="n">primals_in</span><span class="p">)</span>
</span><span id="L-2417"><a href="#L-2417"><span class="linenos">2417</span></a>    <span class="n">f</span><span class="p">,</span> <span class="n">out_tree_store</span> <span class="o">=</span> <span class="n">flatten_fn</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="n">in_tree</span><span class="p">,</span> <span class="n">has_aux</span><span class="o">=</span><span class="n">has_aux</span><span class="p">)</span>
</span><span id="L-2418"><a href="#L-2418"><span class="linenos">2418</span></a>    <span class="n">linearize_flat_ret</span> <span class="o">=</span> <span class="n">linearize_flat</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="o">*</span><span class="n">primals_in_flat</span><span class="p">,</span> <span class="n">has_aux</span><span class="o">=</span><span class="n">has_aux</span><span class="p">)</span>
</span><span id="L-2419"><a href="#L-2419"><span class="linenos">2419</span></a>    <span class="k">if</span> <span class="n">has_aux</span><span class="p">:</span>
</span><span id="L-2420"><a href="#L-2420"><span class="linenos">2420</span></a>        <span class="n">primals_out_flat</span><span class="p">,</span> <span class="n">f_lin_flat</span><span class="p">,</span> <span class="n">aux</span> <span class="o">=</span> <span class="n">linearize_flat_ret</span>
</span><span id="L-2421"><a href="#L-2421"><span class="linenos">2421</span></a>    <span class="k">else</span><span class="p">:</span>
</span><span id="L-2422"><a href="#L-2422"><span class="linenos">2422</span></a>        <span class="n">primals_out_flat</span><span class="p">,</span> <span class="n">f_lin_flat</span> <span class="o">=</span> <span class="n">linearize_flat_ret</span>
</span><span id="L-2423"><a href="#L-2423"><span class="linenos">2423</span></a>
</span><span id="L-2424"><a href="#L-2424"><span class="linenos">2424</span></a>    <span class="n">primals_out</span> <span class="o">=</span> <span class="n">tree_unflatten</span><span class="p">(</span><span class="n">out_tree_store</span><span class="p">(),</span> <span class="n">primals_out_flat</span><span class="p">)</span>
</span><span id="L-2425"><a href="#L-2425"><span class="linenos">2425</span></a>
</span><span id="L-2426"><a href="#L-2426"><span class="linenos">2426</span></a>    <span class="k">def</span> <span class="nf">f_lin</span><span class="p">(</span><span class="o">*</span><span class="n">tangents_in</span><span class="p">):</span>
</span><span id="L-2427"><a href="#L-2427"><span class="linenos">2427</span></a>        <span class="n">tangents_in_flat</span><span class="p">,</span> <span class="n">in_tree2</span> <span class="o">=</span> <span class="n">tree_flatten</span><span class="p">(</span><span class="n">tangents_in</span><span class="p">)</span>
</span><span id="L-2428"><a href="#L-2428"><span class="linenos">2428</span></a>        <span class="k">if</span> <span class="n">in_tree</span> <span class="o">!=</span> <span class="n">in_tree2</span><span class="p">:</span>
</span><span id="L-2429"><a href="#L-2429"><span class="linenos">2429</span></a>            <span class="k">raise</span> <span class="ne">TypeError</span>
</span><span id="L-2430"><a href="#L-2430"><span class="linenos">2430</span></a>        <span class="n">tangents_out_flat</span> <span class="o">=</span> <span class="n">f_lin_flat</span><span class="p">(</span><span class="o">*</span><span class="n">tangents_in_flat</span><span class="p">)</span>
</span><span id="L-2431"><a href="#L-2431"><span class="linenos">2431</span></a>        <span class="k">return</span> <span class="n">tree_unflatten</span><span class="p">(</span><span class="n">out_tree_store</span><span class="p">(),</span> <span class="n">tangents_out_flat</span><span class="p">)</span>
</span><span id="L-2432"><a href="#L-2432"><span class="linenos">2432</span></a>
</span><span id="L-2433"><a href="#L-2433"><span class="linenos">2433</span></a>    <span class="k">return</span> <span class="p">(</span><span class="n">primals_out</span><span class="p">,</span> <span class="n">f_lin</span><span class="p">,</span> <span class="n">aux</span><span class="p">)</span> <span class="k">if</span> <span class="n">has_aux</span> <span class="k">else</span> <span class="p">(</span><span class="n">primals_out</span><span class="p">,</span> <span class="n">f_lin</span><span class="p">)</span>
</span><span id="L-2434"><a href="#L-2434"><span class="linenos">2434</span></a>
</span><span id="L-2435"><a href="#L-2435"><span class="linenos">2435</span></a>
</span><span id="L-2436"><a href="#L-2436"><span class="linenos">2436</span></a><span class="k">def</span> <span class="nf">tracers_to_program</span><span class="p">(</span>
</span><span id="L-2437"><a href="#L-2437"><span class="linenos">2437</span></a>    <span class="n">tracers_in</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="s2">&quot;PartialRunTraceTensor&quot;</span><span class="p">],</span>
</span><span id="L-2438"><a href="#L-2438"><span class="linenos">2438</span></a>    <span class="n">tracers_out</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="s2">&quot;PartialRunTraceTensor&quot;</span><span class="p">],</span>
</span><span id="L-2439"><a href="#L-2439"><span class="linenos">2439</span></a><span class="p">):</span>
</span><span id="L-2440"><a href="#L-2440"><span class="linenos">2440</span></a>    <span class="k">def</span> <span class="nf">tracer_parents</span><span class="p">(</span><span class="n">t</span><span class="p">:</span> <span class="n">PartialRunTraceTensor</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">List</span><span class="p">[</span><span class="n">PartialRunTraceTensor</span><span class="p">]:</span>
</span><span id="L-2441"><a href="#L-2441"><span class="linenos">2441</span></a>        <span class="k">return</span> <span class="n">t</span><span class="o">.</span><span class="n">draft</span><span class="o">.</span><span class="n">tracers_in</span> <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">t</span><span class="o">.</span><span class="n">draft</span><span class="p">,</span> <span class="n">InstructionDraft</span><span class="p">)</span> <span class="k">else</span> <span class="p">[]</span>
</span><span id="L-2442"><a href="#L-2442"><span class="linenos">2442</span></a>
</span><span id="L-2443"><a href="#L-2443"><span class="linenos">2443</span></a>    <span class="k">def</span> <span class="nf">draft_to_instruction</span><span class="p">(</span><span class="n">tracer_to_var</span><span class="p">:</span> <span class="n">Dict</span><span class="p">[</span><span class="nb">int</span><span class="p">,</span> <span class="n">Var</span><span class="p">],</span> <span class="n">draft</span><span class="p">:</span> <span class="n">InstructionDraft</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Instruction</span><span class="p">:</span>
</span><span id="L-2444"><a href="#L-2444"><span class="linenos">2444</span></a>        <span class="n">inputs</span> <span class="o">=</span> <span class="p">[</span><span class="n">tracer_to_var</span><span class="p">[</span><span class="nb">id</span><span class="p">(</span><span class="n">t</span><span class="p">)]</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">draft</span><span class="o">.</span><span class="n">tracers_in</span><span class="p">]</span>
</span><span id="L-2445"><a href="#L-2445"><span class="linenos">2445</span></a>        <span class="n">out_binders</span> <span class="o">=</span> <span class="p">[</span><span class="n">Var</span><span class="p">(</span><span class="n">symval</span><span class="p">)</span> <span class="k">for</span> <span class="n">symval</span> <span class="ow">in</span> <span class="n">draft</span><span class="o">.</span><span class="n">symvals_out</span><span class="p">]</span>
</span><span id="L-2446"><a href="#L-2446"><span class="linenos">2446</span></a>        <span class="k">for</span> <span class="n">t_ref</span><span class="p">,</span> <span class="n">var</span> <span class="ow">in</span> <span class="n">list_zip</span><span class="p">(</span><span class="n">draft</span><span class="o">.</span><span class="n">tracer_refs_out</span><span class="p">,</span> <span class="n">out_binders</span><span class="p">):</span>
</span><span id="L-2447"><a href="#L-2447"><span class="linenos">2447</span></a>            <span class="k">if</span> <span class="n">t_ref</span><span class="p">()</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
</span><span id="L-2448"><a href="#L-2448"><span class="linenos">2448</span></a>                <span class="n">tracer_to_var</span><span class="p">[</span><span class="nb">id</span><span class="p">(</span><span class="n">t_ref</span><span class="p">())]</span> <span class="o">=</span> <span class="n">var</span>
</span><span id="L-2449"><a href="#L-2449"><span class="linenos">2449</span></a>        <span class="k">return</span> <span class="n">Instruction</span><span class="p">(</span><span class="n">draft</span><span class="o">.</span><span class="n">prim</span><span class="p">,</span> <span class="n">inputs</span><span class="p">,</span> <span class="n">draft</span><span class="o">.</span><span class="n">params</span><span class="p">,</span> <span class="n">out_binders</span><span class="p">)</span>
</span><span id="L-2450"><a href="#L-2450"><span class="linenos">2450</span></a>
</span><span id="L-2451"><a href="#L-2451"><span class="linenos">2451</span></a>    <span class="n">tracer_to_var</span><span class="p">:</span> <span class="n">Dict</span><span class="p">[</span><span class="nb">int</span><span class="p">,</span> <span class="n">Var</span><span class="p">]</span> <span class="o">=</span> <span class="p">{</span><span class="nb">id</span><span class="p">(</span><span class="n">t</span><span class="p">):</span> <span class="n">Var</span><span class="p">(</span><span class="n">SymbolicTensor</span><span class="o">.</span><span class="n">like</span><span class="p">(</span><span class="n">t</span><span class="o">.</span><span class="n">symval</span><span class="p">))</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">tracers_in</span><span class="p">}</span>
</span><span id="L-2452"><a href="#L-2452"><span class="linenos">2452</span></a>    <span class="n">constvar_to_val</span><span class="p">:</span> <span class="n">Dict</span><span class="p">[</span><span class="nb">int</span><span class="p">,</span> <span class="n">Any</span><span class="p">]</span> <span class="o">=</span> <span class="p">{}</span>
</span><span id="L-2453"><a href="#L-2453"><span class="linenos">2453</span></a>    <span class="n">constid_to_var</span><span class="p">:</span> <span class="n">Dict</span><span class="p">[</span><span class="nb">int</span><span class="p">,</span> <span class="n">Var</span><span class="p">]</span> <span class="o">=</span> <span class="p">{}</span>
</span><span id="L-2454"><a href="#L-2454"><span class="linenos">2454</span></a>    <span class="n">processed_instructions</span><span class="p">:</span> <span class="n">Set</span><span class="p">[</span><span class="nb">int</span><span class="p">]</span> <span class="o">=</span> <span class="nb">set</span><span class="p">()</span>
</span><span id="L-2455"><a href="#L-2455"><span class="linenos">2455</span></a>    <span class="n">instructions</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">Instruction</span><span class="p">]</span> <span class="o">=</span> <span class="p">[]</span>
</span><span id="L-2456"><a href="#L-2456"><span class="linenos">2456</span></a>    <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">toposort</span><span class="p">(</span><span class="n">tracers_out</span><span class="p">,</span> <span class="n">tracer_parents</span><span class="p">):</span>
</span><span id="L-2457"><a href="#L-2457"><span class="linenos">2457</span></a>        <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">t</span><span class="o">.</span><span class="n">draft</span><span class="p">,</span> <span class="n">LambdaBindingDraft</span><span class="p">):</span>
</span><span id="L-2458"><a href="#L-2458"><span class="linenos">2458</span></a>            <span class="k">assert</span> <span class="nb">id</span><span class="p">(</span><span class="n">t</span><span class="p">)</span> <span class="ow">in</span> <span class="nb">set</span><span class="p">(</span><span class="n">list_map</span><span class="p">(</span><span class="nb">id</span><span class="p">,</span> <span class="n">tracers_in</span><span class="p">))</span>
</span><span id="L-2459"><a href="#L-2459"><span class="linenos">2459</span></a>        <span class="k">elif</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">t</span><span class="o">.</span><span class="n">draft</span><span class="p">,</span> <span class="n">ConstDraft</span><span class="p">):</span>
</span><span id="L-2460"><a href="#L-2460"><span class="linenos">2460</span></a>            <span class="n">val</span> <span class="o">=</span> <span class="n">t</span><span class="o">.</span><span class="n">draft</span><span class="o">.</span><span class="n">val</span>
</span><span id="L-2461"><a href="#L-2461"><span class="linenos">2461</span></a>            <span class="n">var</span> <span class="o">=</span> <span class="n">constid_to_var</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="nb">id</span><span class="p">(</span><span class="n">val</span><span class="p">))</span>
</span><span id="L-2462"><a href="#L-2462"><span class="linenos">2462</span></a>            <span class="k">if</span> <span class="n">var</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
</span><span id="L-2463"><a href="#L-2463"><span class="linenos">2463</span></a>                <span class="n">symval</span> <span class="o">=</span> <span class="n">SymbolicTensor</span><span class="o">.</span><span class="n">like</span><span class="p">(</span><span class="n">get_symval</span><span class="p">(</span><span class="n">val</span><span class="p">))</span>
</span><span id="L-2464"><a href="#L-2464"><span class="linenos">2464</span></a>                <span class="n">var</span> <span class="o">=</span> <span class="n">constid_to_var</span><span class="p">[</span><span class="nb">id</span><span class="p">(</span><span class="n">val</span><span class="p">)]</span> <span class="o">=</span> <span class="n">Var</span><span class="p">(</span><span class="n">symval</span><span class="p">)</span>
</span><span id="L-2465"><a href="#L-2465"><span class="linenos">2465</span></a>                <span class="n">constvar_to_val</span><span class="p">[</span><span class="n">var</span><span class="p">]</span> <span class="o">=</span> <span class="n">val</span>
</span><span id="L-2466"><a href="#L-2466"><span class="linenos">2466</span></a>            <span class="n">tracer_to_var</span><span class="p">[</span><span class="nb">id</span><span class="p">(</span><span class="n">t</span><span class="p">)]</span> <span class="o">=</span> <span class="n">var</span>
</span><span id="L-2467"><a href="#L-2467"><span class="linenos">2467</span></a>        <span class="k">elif</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">t</span><span class="o">.</span><span class="n">draft</span><span class="p">,</span> <span class="n">InstructionDraft</span><span class="p">):</span>
</span><span id="L-2468"><a href="#L-2468"><span class="linenos">2468</span></a>            <span class="k">if</span> <span class="nb">id</span><span class="p">(</span><span class="n">t</span><span class="o">.</span><span class="n">draft</span><span class="p">)</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">processed_instructions</span><span class="p">:</span>
</span><span id="L-2469"><a href="#L-2469"><span class="linenos">2469</span></a>                <span class="n">instructions</span> <span class="o">+=</span> <span class="p">[</span><span class="n">draft_to_instruction</span><span class="p">(</span><span class="n">tracer_to_var</span><span class="p">,</span> <span class="n">t</span><span class="o">.</span><span class="n">draft</span><span class="p">)]</span>
</span><span id="L-2470"><a href="#L-2470"><span class="linenos">2470</span></a>                <span class="n">processed_instructions</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="nb">id</span><span class="p">(</span><span class="n">t</span><span class="o">.</span><span class="n">draft</span><span class="p">))</span>
</span><span id="L-2471"><a href="#L-2471"><span class="linenos">2471</span></a>        <span class="k">else</span><span class="p">:</span>
</span><span id="L-2472"><a href="#L-2472"><span class="linenos">2472</span></a>            <span class="k">raise</span> <span class="ne">TypeError</span><span class="p">(</span><span class="n">t</span><span class="o">.</span><span class="n">draft</span><span class="p">)</span>
</span><span id="L-2473"><a href="#L-2473"><span class="linenos">2473</span></a>
</span><span id="L-2474"><a href="#L-2474"><span class="linenos">2474</span></a>    <span class="n">constvars</span><span class="p">,</span> <span class="n">constvals</span> <span class="o">=</span> <span class="n">unzip2</span><span class="p">(</span><span class="n">constvar_to_val</span><span class="o">.</span><span class="n">items</span><span class="p">())</span>
</span><span id="L-2475"><a href="#L-2475"><span class="linenos">2475</span></a>    <span class="n">in_binders</span> <span class="o">=</span> <span class="n">constvars</span> <span class="o">+</span> <span class="p">[</span><span class="n">tracer_to_var</span><span class="p">[</span><span class="nb">id</span><span class="p">(</span><span class="n">t</span><span class="p">)]</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">tracers_in</span><span class="p">]</span>
</span><span id="L-2476"><a href="#L-2476"><span class="linenos">2476</span></a>    <span class="c1"># out_vars = [tracer_to_var[id(t)] for t in tracers_out if id(t) in tracer_to_var]</span>
</span><span id="L-2477"><a href="#L-2477"><span class="linenos">2477</span></a>    <span class="n">out_vars</span> <span class="o">=</span> <span class="p">[</span><span class="n">tracer_to_var</span><span class="p">[</span><span class="nb">id</span><span class="p">(</span><span class="n">t</span><span class="p">)]</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">tracers_out</span><span class="p">]</span>
</span><span id="L-2478"><a href="#L-2478"><span class="linenos">2478</span></a>    <span class="n">program</span> <span class="o">=</span> <span class="n">Program</span><span class="p">(</span><span class="nb">tuple</span><span class="p">(</span><span class="n">in_binders</span><span class="p">),</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">instructions</span><span class="p">),</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">out_vars</span><span class="p">))</span>
</span><span id="L-2479"><a href="#L-2479"><span class="linenos">2479</span></a>    <span class="n">typecheck_program</span><span class="p">(</span><span class="n">program</span><span class="p">)</span>
</span><span id="L-2480"><a href="#L-2480"><span class="linenos">2480</span></a>    <span class="k">return</span> <span class="n">program</span><span class="p">,</span> <span class="n">constvals</span>
</span><span id="L-2481"><a href="#L-2481"><span class="linenos">2481</span></a>
</span><span id="L-2482"><a href="#L-2482"><span class="linenos">2482</span></a>
</span><span id="L-2483"><a href="#L-2483"><span class="linenos">2483</span></a><span class="k">def</span> <span class="nf">toposort</span><span class="p">(</span><span class="n">out_nodes</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">],</span> <span class="n">parents</span><span class="p">:</span> <span class="n">Callable</span><span class="p">[[</span><span class="n">Any</span><span class="p">],</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">]]):</span>
</span><span id="L-2484"><a href="#L-2484"><span class="linenos">2484</span></a>    <span class="k">def</span> <span class="nf">check_toposort</span><span class="p">(</span><span class="n">nodes</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">],</span> <span class="n">parents</span><span class="p">:</span> <span class="n">Callable</span><span class="p">[[</span><span class="n">Any</span><span class="p">],</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">]]):</span>
</span><span id="L-2485"><a href="#L-2485"><span class="linenos">2485</span></a>        <span class="n">seen</span> <span class="o">=</span> <span class="nb">set</span><span class="p">()</span>
</span><span id="L-2486"><a href="#L-2486"><span class="linenos">2486</span></a>        <span class="k">for</span> <span class="n">node</span> <span class="ow">in</span> <span class="n">nodes</span><span class="p">:</span>
</span><span id="L-2487"><a href="#L-2487"><span class="linenos">2487</span></a>            <span class="k">assert</span> <span class="nb">all</span><span class="p">(</span><span class="nb">id</span><span class="p">(</span><span class="n">parent</span><span class="p">)</span> <span class="ow">in</span> <span class="n">seen</span> <span class="k">for</span> <span class="n">parent</span> <span class="ow">in</span> <span class="n">parents</span><span class="p">(</span><span class="n">node</span><span class="p">))</span>
</span><span id="L-2488"><a href="#L-2488"><span class="linenos">2488</span></a>            <span class="n">seen</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="nb">id</span><span class="p">(</span><span class="n">node</span><span class="p">))</span>
</span><span id="L-2489"><a href="#L-2489"><span class="linenos">2489</span></a>
</span><span id="L-2490"><a href="#L-2490"><span class="linenos">2490</span></a>    <span class="k">def</span> <span class="nf">remove_duplicates</span><span class="p">(</span><span class="n">lst</span><span class="p">):</span>
</span><span id="L-2491"><a href="#L-2491"><span class="linenos">2491</span></a>        <span class="n">seen</span> <span class="o">=</span> <span class="nb">set</span><span class="p">()</span>
</span><span id="L-2492"><a href="#L-2492"><span class="linenos">2492</span></a>        <span class="k">return</span> <span class="p">[</span><span class="n">x</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">lst</span> <span class="k">if</span> <span class="nb">id</span><span class="p">(</span><span class="n">x</span><span class="p">)</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">seen</span> <span class="ow">and</span> <span class="ow">not</span> <span class="n">seen</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="nb">id</span><span class="p">(</span><span class="n">x</span><span class="p">))]</span>
</span><span id="L-2493"><a href="#L-2493"><span class="linenos">2493</span></a>
</span><span id="L-2494"><a href="#L-2494"><span class="linenos">2494</span></a>    <span class="k">if</span> <span class="ow">not</span> <span class="n">out_nodes</span><span class="p">:</span>
</span><span id="L-2495"><a href="#L-2495"><span class="linenos">2495</span></a>        <span class="k">return</span> <span class="p">[]</span>
</span><span id="L-2496"><a href="#L-2496"><span class="linenos">2496</span></a>    <span class="n">out_nodes</span> <span class="o">=</span> <span class="n">remove_duplicates</span><span class="p">(</span><span class="n">out_nodes</span><span class="p">)</span>
</span><span id="L-2497"><a href="#L-2497"><span class="linenos">2497</span></a>
</span><span id="L-2498"><a href="#L-2498"><span class="linenos">2498</span></a>    <span class="n">child_counts</span> <span class="o">=</span> <span class="p">{}</span>
</span><span id="L-2499"><a href="#L-2499"><span class="linenos">2499</span></a>    <span class="n">stack</span> <span class="o">=</span> <span class="nb">list</span><span class="p">(</span><span class="n">out_nodes</span><span class="p">)</span>
</span><span id="L-2500"><a href="#L-2500"><span class="linenos">2500</span></a>    <span class="k">while</span> <span class="n">stack</span><span class="p">:</span>
</span><span id="L-2501"><a href="#L-2501"><span class="linenos">2501</span></a>        <span class="n">node</span> <span class="o">=</span> <span class="n">stack</span><span class="o">.</span><span class="n">pop</span><span class="p">()</span>
</span><span id="L-2502"><a href="#L-2502"><span class="linenos">2502</span></a>        <span class="k">if</span> <span class="nb">id</span><span class="p">(</span><span class="n">node</span><span class="p">)</span> <span class="ow">in</span> <span class="n">child_counts</span><span class="p">:</span>
</span><span id="L-2503"><a href="#L-2503"><span class="linenos">2503</span></a>            <span class="n">child_counts</span><span class="p">[</span><span class="nb">id</span><span class="p">(</span><span class="n">node</span><span class="p">)]</span> <span class="o">+=</span> <span class="mi">1</span>
</span><span id="L-2504"><a href="#L-2504"><span class="linenos">2504</span></a>        <span class="k">else</span><span class="p">:</span>
</span><span id="L-2505"><a href="#L-2505"><span class="linenos">2505</span></a>            <span class="n">child_counts</span><span class="p">[</span><span class="nb">id</span><span class="p">(</span><span class="n">node</span><span class="p">)]</span> <span class="o">=</span> <span class="mi">1</span>
</span><span id="L-2506"><a href="#L-2506"><span class="linenos">2506</span></a>            <span class="n">stack</span><span class="o">.</span><span class="n">extend</span><span class="p">(</span><span class="n">parents</span><span class="p">(</span><span class="n">node</span><span class="p">))</span>
</span><span id="L-2507"><a href="#L-2507"><span class="linenos">2507</span></a>    <span class="k">for</span> <span class="n">node</span> <span class="ow">in</span> <span class="n">out_nodes</span><span class="p">:</span>
</span><span id="L-2508"><a href="#L-2508"><span class="linenos">2508</span></a>        <span class="n">child_counts</span><span class="p">[</span><span class="nb">id</span><span class="p">(</span><span class="n">node</span><span class="p">)]</span> <span class="o">-=</span> <span class="mi">1</span>
</span><span id="L-2509"><a href="#L-2509"><span class="linenos">2509</span></a>
</span><span id="L-2510"><a href="#L-2510"><span class="linenos">2510</span></a>    <span class="n">sorted_nodes</span> <span class="o">=</span> <span class="p">[]</span>
</span><span id="L-2511"><a href="#L-2511"><span class="linenos">2511</span></a>    <span class="n">childless_nodes</span> <span class="o">=</span> <span class="p">[</span><span class="n">node</span> <span class="k">for</span> <span class="n">node</span> <span class="ow">in</span> <span class="n">out_nodes</span> <span class="k">if</span> <span class="ow">not</span> <span class="n">child_counts</span><span class="p">[</span><span class="nb">id</span><span class="p">(</span><span class="n">node</span><span class="p">)]]</span>
</span><span id="L-2512"><a href="#L-2512"><span class="linenos">2512</span></a>    <span class="k">while</span> <span class="n">childless_nodes</span><span class="p">:</span>
</span><span id="L-2513"><a href="#L-2513"><span class="linenos">2513</span></a>        <span class="n">node</span> <span class="o">=</span> <span class="n">childless_nodes</span><span class="o">.</span><span class="n">pop</span><span class="p">()</span>
</span><span id="L-2514"><a href="#L-2514"><span class="linenos">2514</span></a>        <span class="n">sorted_nodes</span> <span class="o">+=</span> <span class="p">[</span><span class="n">node</span><span class="p">]</span>
</span><span id="L-2515"><a href="#L-2515"><span class="linenos">2515</span></a>        <span class="k">for</span> <span class="n">parent</span> <span class="ow">in</span> <span class="n">parents</span><span class="p">(</span><span class="n">node</span><span class="p">):</span>
</span><span id="L-2516"><a href="#L-2516"><span class="linenos">2516</span></a>            <span class="k">if</span> <span class="n">child_counts</span><span class="p">[</span><span class="nb">id</span><span class="p">(</span><span class="n">parent</span><span class="p">)]</span> <span class="o">==</span> <span class="mi">1</span><span class="p">:</span>
</span><span id="L-2517"><a href="#L-2517"><span class="linenos">2517</span></a>                <span class="n">childless_nodes</span> <span class="o">+=</span> <span class="p">[</span><span class="n">parent</span><span class="p">]</span>
</span><span id="L-2518"><a href="#L-2518"><span class="linenos">2518</span></a>            <span class="k">else</span><span class="p">:</span>
</span><span id="L-2519"><a href="#L-2519"><span class="linenos">2519</span></a>                <span class="n">child_counts</span><span class="p">[</span><span class="nb">id</span><span class="p">(</span><span class="n">parent</span><span class="p">)]</span> <span class="o">-=</span> <span class="mi">1</span>
</span><span id="L-2520"><a href="#L-2520"><span class="linenos">2520</span></a>
</span><span id="L-2521"><a href="#L-2521"><span class="linenos">2521</span></a>    <span class="n">sorted_nodes</span> <span class="o">=</span> <span class="n">sorted_nodes</span><span class="p">[::</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span>
</span><span id="L-2522"><a href="#L-2522"><span class="linenos">2522</span></a>    <span class="n">check_toposort</span><span class="p">(</span><span class="n">sorted_nodes</span><span class="p">,</span> <span class="n">parents</span><span class="p">)</span>
</span><span id="L-2523"><a href="#L-2523"><span class="linenos">2523</span></a>    <span class="k">return</span> <span class="n">sorted_nodes</span>
</span><span id="L-2524"><a href="#L-2524"><span class="linenos">2524</span></a>
</span><span id="L-2525"><a href="#L-2525"><span class="linenos">2525</span></a>
</span><span id="L-2526"><a href="#L-2526"><span class="linenos">2526</span></a><span class="k">def</span> <span class="nf">vjp_flat</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="o">*</span><span class="n">primals_in</span><span class="p">,</span> <span class="n">has_aux</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="o">**</span><span class="n">static_args</span><span class="p">):</span>
</span><span id="L-2527"><a href="#L-2527"><span class="linenos">2527</span></a>    <span class="n">pvals_in</span> <span class="o">=</span> <span class="p">[</span><span class="n">make_known_pval</span><span class="p">(</span><span class="n">x</span><span class="p">)</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">primals_in</span><span class="p">]</span> <span class="o">+</span> <span class="p">[</span><span class="n">make_unknown_pval</span><span class="p">(</span><span class="n">SymbolicTensor</span><span class="o">.</span><span class="n">like</span><span class="p">(</span><span class="n">get_symval</span><span class="p">(</span><span class="n">x</span><span class="p">)))</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">primals_in</span><span class="p">]</span>
</span><span id="L-2528"><a href="#L-2528"><span class="linenos">2528</span></a>    <span class="n">primal_pvals_in</span><span class="p">,</span> <span class="n">tangent_pvals_in</span> <span class="o">=</span> <span class="n">split_half</span><span class="p">(</span><span class="n">pvals_in</span><span class="p">)</span>
</span><span id="L-2529"><a href="#L-2529"><span class="linenos">2529</span></a>    <span class="k">del</span> <span class="n">primal_pvals_in</span>
</span><span id="L-2530"><a href="#L-2530"><span class="linenos">2530</span></a>
</span><span id="L-2531"><a href="#L-2531"><span class="linenos">2531</span></a>    <span class="k">def</span> <span class="nf">f_jvp</span><span class="p">(</span><span class="o">*</span><span class="n">primals_tangents_in</span><span class="p">):</span>
</span><span id="L-2532"><a href="#L-2532"><span class="linenos">2532</span></a>        <span class="n">jvp_ret</span> <span class="o">=</span> <span class="n">jvp</span><span class="p">(</span>
</span><span id="L-2533"><a href="#L-2533"><span class="linenos">2533</span></a>            <span class="n">f</span><span class="p">,</span>
</span><span id="L-2534"><a href="#L-2534"><span class="linenos">2534</span></a>            <span class="o">*</span><span class="n">split_half</span><span class="p">(</span><span class="n">primals_tangents_in</span><span class="p">),</span>
</span><span id="L-2535"><a href="#L-2535"><span class="linenos">2535</span></a>            <span class="n">has_aux</span><span class="o">=</span><span class="n">has_aux</span><span class="p">,</span>
</span><span id="L-2536"><a href="#L-2536"><span class="linenos">2536</span></a>            <span class="n">global_data</span><span class="o">=</span><span class="s2">&quot;vjp&quot;</span><span class="p">,</span>
</span><span id="L-2537"><a href="#L-2537"><span class="linenos">2537</span></a>            <span class="o">**</span><span class="n">static_args</span><span class="p">,</span>
</span><span id="L-2538"><a href="#L-2538"><span class="linenos">2538</span></a>        <span class="p">)</span>
</span><span id="L-2539"><a href="#L-2539"><span class="linenos">2539</span></a>        <span class="k">if</span> <span class="n">has_aux</span><span class="p">:</span>
</span><span id="L-2540"><a href="#L-2540"><span class="linenos">2540</span></a>            <span class="p">((</span><span class="n">primals_out</span><span class="p">,</span> <span class="n">tangents_out</span><span class="p">),</span> <span class="n">aux</span><span class="p">)</span> <span class="o">=</span> <span class="n">jvp_ret</span>
</span><span id="L-2541"><a href="#L-2541"><span class="linenos">2541</span></a>        <span class="k">else</span><span class="p">:</span>
</span><span id="L-2542"><a href="#L-2542"><span class="linenos">2542</span></a>            <span class="p">(</span><span class="n">primals_out</span><span class="p">,</span> <span class="n">tangents_out</span><span class="p">)</span> <span class="o">=</span> <span class="n">jvp_ret</span>
</span><span id="L-2543"><a href="#L-2543"><span class="linenos">2543</span></a>        <span class="k">return</span> <span class="p">([</span><span class="o">*</span><span class="n">primals_out</span><span class="p">,</span> <span class="o">*</span><span class="n">tangents_out</span><span class="p">],</span> <span class="n">aux</span><span class="p">)</span> <span class="k">if</span> <span class="n">has_aux</span> <span class="k">else</span> <span class="p">[</span><span class="o">*</span><span class="n">primals_out</span><span class="p">,</span> <span class="o">*</span><span class="n">tangents_out</span><span class="p">]</span>
</span><span id="L-2544"><a href="#L-2544"><span class="linenos">2544</span></a>
</span><span id="L-2545"><a href="#L-2545"><span class="linenos">2545</span></a>    <span class="n">partial_run_flat_ret</span> <span class="o">=</span> <span class="n">partial_run_flat</span><span class="p">(</span><span class="n">f_jvp</span><span class="p">,</span> <span class="n">pvals_in</span><span class="p">,</span> <span class="n">has_aux</span><span class="p">,</span> <span class="s2">&quot;vjp&quot;</span><span class="p">)</span>
</span><span id="L-2546"><a href="#L-2546"><span class="linenos">2546</span></a>    <span class="k">if</span> <span class="n">has_aux</span><span class="p">:</span>
</span><span id="L-2547"><a href="#L-2547"><span class="linenos">2547</span></a>        <span class="n">program</span><span class="p">,</span> <span class="n">pvals_out</span><span class="p">,</span> <span class="n">consts</span><span class="p">,</span> <span class="n">aux</span> <span class="o">=</span> <span class="n">partial_run_flat_ret</span>
</span><span id="L-2548"><a href="#L-2548"><span class="linenos">2548</span></a>    <span class="k">else</span><span class="p">:</span>
</span><span id="L-2549"><a href="#L-2549"><span class="linenos">2549</span></a>        <span class="n">program</span><span class="p">,</span> <span class="n">pvals_out</span><span class="p">,</span> <span class="n">consts</span> <span class="o">=</span> <span class="n">partial_run_flat_ret</span>
</span><span id="L-2550"><a href="#L-2550"><span class="linenos">2550</span></a>
</span><span id="L-2551"><a href="#L-2551"><span class="linenos">2551</span></a>    <span class="n">primal_pvals</span><span class="p">,</span> <span class="n">tangent_pvals</span> <span class="o">=</span> <span class="n">split_half</span><span class="p">(</span><span class="n">pvals_out</span><span class="p">)</span>
</span><span id="L-2552"><a href="#L-2552"><span class="linenos">2552</span></a>    <span class="k">del</span> <span class="n">tangent_pvals</span>
</span><span id="L-2553"><a href="#L-2553"><span class="linenos">2553</span></a>    <span class="k">assert</span> <span class="nb">all</span><span class="p">(</span><span class="n">pval</span><span class="o">.</span><span class="n">is_known</span> <span class="k">for</span> <span class="n">pval</span> <span class="ow">in</span> <span class="n">primal_pvals</span><span class="p">)</span>
</span><span id="L-2554"><a href="#L-2554"><span class="linenos">2554</span></a>    <span class="n">primals_out_flat</span> <span class="o">=</span> <span class="p">[</span><span class="n">pval</span><span class="o">.</span><span class="n">const</span> <span class="k">for</span> <span class="n">pval</span> <span class="ow">in</span> <span class="n">primal_pvals</span><span class="p">]</span>
</span><span id="L-2555"><a href="#L-2555"><span class="linenos">2555</span></a>    <span class="n">transpose_inputs</span> <span class="o">=</span> <span class="n">consts</span> <span class="o">+</span> <span class="p">[</span><span class="n">UndefinedPrimal</span><span class="p">(</span><span class="n">t</span><span class="o">.</span><span class="n">symval</span><span class="p">)</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">tangent_pvals_in</span><span class="p">]</span>
</span><span id="L-2556"><a href="#L-2556"><span class="linenos">2556</span></a>
</span><span id="L-2557"><a href="#L-2557"><span class="linenos">2557</span></a>    <span class="k">def</span> <span class="nf">f_vjp_flat</span><span class="p">(</span><span class="o">*</span><span class="n">cotangents</span><span class="p">):</span>
</span><span id="L-2558"><a href="#L-2558"><span class="linenos">2558</span></a>        <span class="c1"># return backward_pass(program, transpose_inputs, cotangents)</span>
</span><span id="L-2559"><a href="#L-2559"><span class="linenos">2559</span></a>        <span class="n">undef_primals</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="nb">isinstance</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">UndefinedPrimal</span><span class="p">)</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">transpose_inputs</span><span class="p">)</span>
</span><span id="L-2560"><a href="#L-2560"><span class="linenos">2560</span></a>        <span class="n">transposed_program</span><span class="p">,</span> <span class="n">new_consts</span> <span class="o">=</span> <span class="n">transpose_program</span><span class="p">(</span><span class="n">program</span><span class="p">,</span> <span class="n">undef_primals</span><span class="p">)</span>
</span><span id="L-2561"><a href="#L-2561"><span class="linenos">2561</span></a>        <span class="n">residuals</span><span class="p">,</span> <span class="n">_</span> <span class="o">=</span> <span class="n">partition_list</span><span class="p">(</span><span class="n">undef_primals</span><span class="p">,</span> <span class="n">transpose_inputs</span><span class="p">)</span>
</span><span id="L-2562"><a href="#L-2562"><span class="linenos">2562</span></a>        <span class="n">outs</span> <span class="o">=</span> <span class="n">run_program</span><span class="p">(</span><span class="n">transposed_program</span><span class="p">,</span> <span class="p">(</span><span class="o">*</span><span class="n">new_consts</span><span class="p">,</span> <span class="o">*</span><span class="n">residuals</span><span class="p">,</span> <span class="o">*</span><span class="n">cotangents</span><span class="p">))</span>
</span><span id="L-2563"><a href="#L-2563"><span class="linenos">2563</span></a>        <span class="k">return</span> <span class="n">outs</span>
</span><span id="L-2564"><a href="#L-2564"><span class="linenos">2564</span></a>
</span><span id="L-2565"><a href="#L-2565"><span class="linenos">2565</span></a>    <span class="k">return</span> <span class="p">(</span><span class="n">primals_out_flat</span><span class="p">,</span> <span class="n">f_vjp_flat</span><span class="p">,</span> <span class="n">aux</span><span class="p">)</span> <span class="k">if</span> <span class="n">has_aux</span> <span class="k">else</span> <span class="p">(</span><span class="n">primals_out_flat</span><span class="p">,</span> <span class="n">f_vjp_flat</span><span class="p">)</span>
</span><span id="L-2566"><a href="#L-2566"><span class="linenos">2566</span></a>
</span><span id="L-2567"><a href="#L-2567"><span class="linenos">2567</span></a>
</span><span id="L-2568"><a href="#L-2568"><span class="linenos">2568</span></a><span class="k">def</span> <span class="nf">vjp</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="o">*</span><span class="n">primals_in</span><span class="p">,</span> <span class="n">has_aux</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="o">**</span><span class="n">static_args</span><span class="p">):</span>
</span><span id="L-2569"><a href="#L-2569"><span class="linenos">2569</span></a>    <span class="n">primals_in_flat</span><span class="p">,</span> <span class="n">in_tree</span> <span class="o">=</span> <span class="n">tree_flatten</span><span class="p">(</span><span class="n">primals_in</span><span class="p">)</span>
</span><span id="L-2570"><a href="#L-2570"><span class="linenos">2570</span></a>    <span class="n">f</span><span class="p">,</span> <span class="n">out_tree_store</span> <span class="o">=</span> <span class="n">flatten_fn</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="n">in_tree</span><span class="p">,</span> <span class="n">has_aux</span><span class="o">=</span><span class="n">has_aux</span><span class="p">)</span>
</span><span id="L-2571"><a href="#L-2571"><span class="linenos">2571</span></a>    <span class="n">vjp_ret</span> <span class="o">=</span> <span class="n">vjp_flat</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="o">*</span><span class="n">primals_in_flat</span><span class="p">,</span> <span class="n">has_aux</span><span class="o">=</span><span class="n">has_aux</span><span class="p">,</span> <span class="o">**</span><span class="n">static_args</span><span class="p">)</span>
</span><span id="L-2572"><a href="#L-2572"><span class="linenos">2572</span></a>    <span class="k">if</span> <span class="n">has_aux</span><span class="p">:</span>
</span><span id="L-2573"><a href="#L-2573"><span class="linenos">2573</span></a>        <span class="n">primals_out_flat</span><span class="p">,</span> <span class="n">f_vjp_flat</span><span class="p">,</span> <span class="n">aux</span> <span class="o">=</span> <span class="n">vjp_ret</span>
</span><span id="L-2574"><a href="#L-2574"><span class="linenos">2574</span></a>    <span class="k">else</span><span class="p">:</span>
</span><span id="L-2575"><a href="#L-2575"><span class="linenos">2575</span></a>        <span class="n">primals_out_flat</span><span class="p">,</span> <span class="n">f_vjp_flat</span> <span class="o">=</span> <span class="n">vjp_ret</span>
</span><span id="L-2576"><a href="#L-2576"><span class="linenos">2576</span></a>    <span class="n">primals_out</span> <span class="o">=</span> <span class="n">tree_unflatten</span><span class="p">(</span><span class="n">out_tree_store</span><span class="p">(),</span> <span class="n">primals_out_flat</span><span class="p">)</span>
</span><span id="L-2577"><a href="#L-2577"><span class="linenos">2577</span></a>
</span><span id="L-2578"><a href="#L-2578"><span class="linenos">2578</span></a>    <span class="k">def</span> <span class="nf">f_vjp</span><span class="p">(</span><span class="o">*</span><span class="n">cotangents_out</span><span class="p">):</span>
</span><span id="L-2579"><a href="#L-2579"><span class="linenos">2579</span></a>        <span class="n">cotangents_out_flat</span><span class="p">,</span> <span class="n">_</span> <span class="o">=</span> <span class="n">tree_flatten</span><span class="p">(</span><span class="n">cotangents_out</span><span class="p">)</span>
</span><span id="L-2580"><a href="#L-2580"><span class="linenos">2580</span></a>        <span class="n">cotangents_in_flat</span> <span class="o">=</span> <span class="n">f_vjp_flat</span><span class="p">(</span><span class="o">*</span><span class="n">cotangents_out_flat</span><span class="p">)</span>
</span><span id="L-2581"><a href="#L-2581"><span class="linenos">2581</span></a>
</span><span id="L-2582"><a href="#L-2582"><span class="linenos">2582</span></a>        <span class="k">return</span> <span class="n">tree_unflatten</span><span class="p">(</span><span class="n">in_tree</span><span class="p">,</span> <span class="n">cotangents_in_flat</span><span class="p">)</span>
</span><span id="L-2583"><a href="#L-2583"><span class="linenos">2583</span></a>
</span><span id="L-2584"><a href="#L-2584"><span class="linenos">2584</span></a>    <span class="k">return</span> <span class="p">(</span><span class="n">primals_out</span><span class="p">,</span> <span class="n">f_vjp</span><span class="p">,</span> <span class="n">aux</span><span class="p">)</span> <span class="k">if</span> <span class="n">has_aux</span> <span class="k">else</span> <span class="p">(</span><span class="n">primals_out</span><span class="p">,</span> <span class="n">f_vjp</span><span class="p">)</span>
</span><span id="L-2585"><a href="#L-2585"><span class="linenos">2585</span></a>
</span><span id="L-2586"><a href="#L-2586"><span class="linenos">2586</span></a>
</span><span id="L-2587"><a href="#L-2587"><span class="linenos">2587</span></a><span class="n">NullCotangent</span> <span class="o">=</span> <span class="kc">None</span>
</span><span id="L-2588"><a href="#L-2588"><span class="linenos">2588</span></a>
</span><span id="L-2589"><a href="#L-2589"><span class="linenos">2589</span></a>
</span><span id="L-2590"><a href="#L-2590"><span class="linenos">2590</span></a><span class="k">def</span> <span class="nf">backward_pass</span><span class="p">(</span><span class="n">program</span><span class="p">:</span> <span class="n">Program</span><span class="p">,</span> <span class="n">args</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">],</span> <span class="n">cotangents</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">])</span> <span class="o">-&gt;</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">]:</span>
</span><span id="L-2591"><a href="#L-2591"><span class="linenos">2591</span></a>    <span class="n">primal_env</span><span class="p">:</span> <span class="n">Dict</span><span class="p">[</span><span class="n">Var</span><span class="p">,</span> <span class="n">Any</span><span class="p">]</span> <span class="o">=</span> <span class="p">{}</span>
</span><span id="L-2592"><a href="#L-2592"><span class="linenos">2592</span></a>    <span class="n">ct_env</span><span class="p">:</span> <span class="n">Dict</span><span class="p">[</span><span class="n">Var</span><span class="p">,</span> <span class="n">Any</span><span class="p">]</span> <span class="o">=</span> <span class="p">{}</span>
</span><span id="L-2593"><a href="#L-2593"><span class="linenos">2593</span></a>
</span><span id="L-2594"><a href="#L-2594"><span class="linenos">2594</span></a>    <span class="k">def</span> <span class="nf">read_primal</span><span class="p">(</span><span class="n">x</span><span class="p">:</span> <span class="n">Atom</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Any</span><span class="p">:</span>
</span><span id="L-2595"><a href="#L-2595"><span class="linenos">2595</span></a>        <span class="k">return</span> <span class="n">primal_env</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">UndefinedPrimal</span><span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">symval</span><span class="p">))</span> <span class="k">if</span> <span class="nb">type</span><span class="p">(</span><span class="n">x</span><span class="p">)</span> <span class="ow">is</span> <span class="n">Var</span> <span class="k">else</span> <span class="n">x</span><span class="o">.</span><span class="n">val</span>
</span><span id="L-2596"><a href="#L-2596"><span class="linenos">2596</span></a>
</span><span id="L-2597"><a href="#L-2597"><span class="linenos">2597</span></a>    <span class="k">def</span> <span class="nf">write_primal</span><span class="p">(</span><span class="n">v</span><span class="p">:</span> <span class="n">Var</span><span class="p">,</span> <span class="n">val</span><span class="p">:</span> <span class="n">Any</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="kc">None</span><span class="p">:</span>
</span><span id="L-2598"><a href="#L-2598"><span class="linenos">2598</span></a>        <span class="k">if</span> <span class="nb">type</span><span class="p">(</span><span class="n">val</span><span class="p">)</span> <span class="ow">is</span> <span class="ow">not</span> <span class="n">UndefinedPrimal</span><span class="p">:</span>
</span><span id="L-2599"><a href="#L-2599"><span class="linenos">2599</span></a>            <span class="n">primal_env</span><span class="p">[</span><span class="n">v</span><span class="p">]</span> <span class="o">=</span> <span class="n">val</span>
</span><span id="L-2600"><a href="#L-2600"><span class="linenos">2600</span></a>
</span><span id="L-2601"><a href="#L-2601"><span class="linenos">2601</span></a>    <span class="k">def</span> <span class="nf">read_cotangent</span><span class="p">(</span><span class="n">v</span><span class="p">:</span> <span class="n">Var</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Any</span><span class="p">:</span>
</span><span id="L-2602"><a href="#L-2602"><span class="linenos">2602</span></a>        <span class="k">return</span> <span class="n">ct_env</span><span class="o">.</span><span class="n">pop</span><span class="p">(</span><span class="n">v</span><span class="p">,</span> <span class="n">backend</span><span class="o">.</span><span class="n">zeros</span><span class="p">(</span><span class="n">v</span><span class="o">.</span><span class="n">symval</span><span class="o">.</span><span class="n">shape</span><span class="p">,</span> <span class="n">v</span><span class="o">.</span><span class="n">symval</span><span class="o">.</span><span class="n">dtype</span><span class="p">))</span>
</span><span id="L-2603"><a href="#L-2603"><span class="linenos">2603</span></a>
</span><span id="L-2604"><a href="#L-2604"><span class="linenos">2604</span></a>    <span class="k">def</span> <span class="nf">write_cotangent</span><span class="p">(</span><span class="n">x</span><span class="p">:</span> <span class="n">Atom</span><span class="p">,</span> <span class="n">ct</span><span class="p">:</span> <span class="n">Any</span><span class="p">):</span>
</span><span id="L-2605"><a href="#L-2605"><span class="linenos">2605</span></a>        <span class="k">if</span> <span class="nb">type</span><span class="p">(</span><span class="n">x</span><span class="p">)</span> <span class="ow">is</span> <span class="n">Var</span> <span class="ow">and</span> <span class="n">ct</span> <span class="ow">is</span> <span class="ow">not</span> <span class="n">NullCotangent</span><span class="p">:</span>
</span><span id="L-2606"><a href="#L-2606"><span class="linenos">2606</span></a>            <span class="n">ct_env</span><span class="p">[</span><span class="n">x</span><span class="p">]</span> <span class="o">=</span> <span class="p">(</span><span class="n">ct_env</span><span class="p">[</span><span class="n">x</span><span class="p">]</span> <span class="o">+</span> <span class="n">ct</span><span class="p">)</span> <span class="k">if</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">ct_env</span> <span class="k">else</span> <span class="n">ct</span>
</span><span id="L-2607"><a href="#L-2607"><span class="linenos">2607</span></a>
</span><span id="L-2608"><a href="#L-2608"><span class="linenos">2608</span></a>    <span class="n">list_map</span><span class="p">(</span><span class="n">write_primal</span><span class="p">,</span> <span class="n">program</span><span class="o">.</span><span class="n">in_binders</span><span class="p">,</span> <span class="n">args</span><span class="p">)</span>
</span><span id="L-2609"><a href="#L-2609"><span class="linenos">2609</span></a>    <span class="n">list_map</span><span class="p">(</span><span class="n">write_cotangent</span><span class="p">,</span> <span class="n">program</span><span class="o">.</span><span class="n">outs</span><span class="p">,</span> <span class="n">cotangents</span><span class="p">)</span>
</span><span id="L-2610"><a href="#L-2610"><span class="linenos">2610</span></a>    <span class="k">for</span> <span class="n">instruction</span> <span class="ow">in</span> <span class="n">program</span><span class="o">.</span><span class="n">instructions</span><span class="p">[::</span><span class="o">-</span><span class="mi">1</span><span class="p">]:</span>
</span><span id="L-2611"><a href="#L-2611"><span class="linenos">2611</span></a>        <span class="n">primals_in</span> <span class="o">=</span> <span class="n">list_map</span><span class="p">(</span><span class="n">read_primal</span><span class="p">,</span> <span class="n">instruction</span><span class="o">.</span><span class="n">inputs</span><span class="p">)</span>
</span><span id="L-2612"><a href="#L-2612"><span class="linenos">2612</span></a>        <span class="n">cotangents_in</span> <span class="o">=</span> <span class="n">list_map</span><span class="p">(</span><span class="n">read_cotangent</span><span class="p">,</span> <span class="n">instruction</span><span class="o">.</span><span class="n">out_binders</span><span class="p">)</span>
</span><span id="L-2613"><a href="#L-2613"><span class="linenos">2613</span></a>        <span class="n">inp</span><span class="p">,</span> <span class="n">params</span> <span class="o">=</span> <span class="n">primals_in</span><span class="p">,</span> <span class="n">instruction</span><span class="o">.</span><span class="n">params</span>
</span><span id="L-2614"><a href="#L-2614"><span class="linenos">2614</span></a>        <span class="n">cotangents_out</span> <span class="o">=</span> <span class="n">instruction</span><span class="o">.</span><span class="n">op</span><span class="o">.</span><span class="n">T</span><span class="p">(</span><span class="n">cotangents_in</span><span class="p">,</span> <span class="o">*</span><span class="n">inp</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)</span>
</span><span id="L-2615"><a href="#L-2615"><span class="linenos">2615</span></a>        <span class="n">list_map</span><span class="p">(</span><span class="n">write_cotangent</span><span class="p">,</span> <span class="n">instruction</span><span class="o">.</span><span class="n">inputs</span><span class="p">,</span> <span class="n">cotangents_out</span><span class="p">)</span>
</span><span id="L-2616"><a href="#L-2616"><span class="linenos">2616</span></a>
</span><span id="L-2617"><a href="#L-2617"><span class="linenos">2617</span></a>    <span class="n">ret</span> <span class="o">=</span> <span class="p">[</span><span class="n">read_cotangent</span><span class="p">(</span><span class="n">v</span><span class="p">)</span> <span class="k">for</span> <span class="n">v</span><span class="p">,</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">list_zip</span><span class="p">(</span><span class="n">program</span><span class="o">.</span><span class="n">in_binders</span><span class="p">,</span> <span class="n">args</span><span class="p">)</span> <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">UndefinedPrimal</span><span class="p">)]</span>
</span><span id="L-2618"><a href="#L-2618"><span class="linenos">2618</span></a>    <span class="k">return</span> <span class="n">ret</span>
</span><span id="L-2619"><a href="#L-2619"><span class="linenos">2619</span></a>
</span><span id="L-2620"><a href="#L-2620"><span class="linenos">2620</span></a>
</span><span id="L-2621"><a href="#L-2621"><span class="linenos">2621</span></a><span class="nd">@lru_cache_verbose</span><span class="p">()</span>
</span><span id="L-2622"><a href="#L-2622"><span class="linenos">2622</span></a><span class="k">def</span> <span class="nf">transpose_program</span><span class="p">(</span><span class="n">program</span><span class="p">:</span> <span class="n">Program</span><span class="p">,</span> <span class="n">undef_primals</span><span class="p">:</span> <span class="nb">tuple</span><span class="p">[</span><span class="nb">bool</span><span class="p">,</span> <span class="o">...</span><span class="p">])</span> <span class="o">-&gt;</span> <span class="nb">tuple</span><span class="p">[</span><span class="n">Program</span><span class="p">,</span> <span class="nb">list</span><span class="p">[</span><span class="n">Any</span><span class="p">]]:</span>
</span><span id="L-2623"><a href="#L-2623"><span class="linenos">2623</span></a>    <span class="n">symvals_in</span><span class="p">,</span> <span class="n">symvals_out</span> <span class="o">=</span> <span class="n">typecheck_program</span><span class="p">(</span><span class="n">program</span><span class="p">)</span>
</span><span id="L-2624"><a href="#L-2624"><span class="linenos">2624</span></a>    <span class="n">traceable</span> <span class="o">=</span> <span class="n">partial</span><span class="p">(</span><span class="n">backward_pass</span><span class="p">,</span> <span class="n">program</span><span class="p">)</span>
</span><span id="L-2625"><a href="#L-2625"><span class="linenos">2625</span></a>    <span class="p">()</span>
</span><span id="L-2626"><a href="#L-2626"><span class="linenos">2626</span></a>    <span class="n">args</span> <span class="o">=</span> <span class="p">[</span><span class="n">UndefinedPrimal</span><span class="p">(</span><span class="n">a</span><span class="p">)</span> <span class="k">if</span> <span class="n">u</span> <span class="k">else</span> <span class="n">a</span> <span class="k">for</span> <span class="n">a</span><span class="p">,</span> <span class="n">u</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">symvals_in</span><span class="p">,</span> <span class="n">undef_primals</span><span class="p">)]</span>
</span><span id="L-2627"><a href="#L-2627"><span class="linenos">2627</span></a>    <span class="n">trans_program</span><span class="p">,</span> <span class="n">consts</span><span class="p">,</span> <span class="n">_</span> <span class="o">=</span> <span class="n">make_program</span><span class="p">(</span>
</span><span id="L-2628"><a href="#L-2628"><span class="linenos">2628</span></a>        <span class="n">traceable</span><span class="p">,</span>
</span><span id="L-2629"><a href="#L-2629"><span class="linenos">2629</span></a>        <span class="nb">tuple</span><span class="p">(</span><span class="n">args</span><span class="p">),</span>
</span><span id="L-2630"><a href="#L-2630"><span class="linenos">2630</span></a>        <span class="nb">tuple</span><span class="p">(</span><span class="n">symvals_out</span><span class="p">),</span>
</span><span id="L-2631"><a href="#L-2631"><span class="linenos">2631</span></a>        <span class="n">static_args</span><span class="o">=</span><span class="n">program</span><span class="o">.</span><span class="n">static_args</span><span class="p">,</span>
</span><span id="L-2632"><a href="#L-2632"><span class="linenos">2632</span></a>        <span class="n">name</span><span class="o">=</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">program</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">_T&quot;</span><span class="p">,</span>
</span><span id="L-2633"><a href="#L-2633"><span class="linenos">2633</span></a>    <span class="p">)</span>
</span><span id="L-2634"><a href="#L-2634"><span class="linenos">2634</span></a>    <span class="n">typecheck_program</span><span class="p">(</span><span class="n">trans_program</span><span class="p">)</span>
</span><span id="L-2635"><a href="#L-2635"><span class="linenos">2635</span></a>
</span><span id="L-2636"><a href="#L-2636"><span class="linenos">2636</span></a>    <span class="k">return</span> <span class="n">trans_program</span><span class="p">,</span> <span class="n">consts</span>
</span><span id="L-2637"><a href="#L-2637"><span class="linenos">2637</span></a>
</span><span id="L-2638"><a href="#L-2638"><span class="linenos">2638</span></a>
</span><span id="L-2639"><a href="#L-2639"><span class="linenos">2639</span></a><span class="k">def</span> <span class="nf">grad</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="n">argnums</span><span class="o">=</span><span class="p">(</span><span class="mi">0</span><span class="p">,),</span> <span class="n">argnames</span><span class="o">=</span><span class="s2">&quot;&quot;</span><span class="p">,</span> <span class="n">has_aux</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">return_value</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>
</span><span id="L-2640"><a href="#L-2640"><span class="linenos">2640</span></a>    <span class="n">f</span><span class="p">,</span> <span class="n">rejit</span> <span class="o">=</span> <span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="kc">False</span><span class="p">)</span> <span class="k">if</span> <span class="ow">not</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="n">jit</span><span class="p">)</span> <span class="k">else</span> <span class="p">(</span><span class="n">f</span><span class="o">.</span><span class="n">f</span><span class="p">,</span> <span class="kc">True</span><span class="p">)</span>
</span><span id="L-2641"><a href="#L-2641"><span class="linenos">2641</span></a>    <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">argnums</span><span class="p">,</span> <span class="nb">int</span><span class="p">):</span>
</span><span id="L-2642"><a href="#L-2642"><span class="linenos">2642</span></a>        <span class="n">argnums</span> <span class="o">=</span> <span class="p">(</span><span class="n">argnums</span><span class="p">,)</span>
</span><span id="L-2643"><a href="#L-2643"><span class="linenos">2643</span></a>
</span><span id="L-2644"><a href="#L-2644"><span class="linenos">2644</span></a>    <span class="k">def</span> <span class="nf">gfn</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="o">*</span><span class="n">xs</span><span class="p">,</span> <span class="o">**</span><span class="n">static_args</span><span class="p">):</span>
</span><span id="L-2645"><a href="#L-2645"><span class="linenos">2645</span></a>        <span class="n">vjp_ret</span> <span class="o">=</span> <span class="n">vjp</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="n">x</span><span class="p">,</span> <span class="o">*</span><span class="n">xs</span><span class="p">,</span> <span class="n">has_aux</span><span class="o">=</span><span class="n">has_aux</span><span class="p">,</span> <span class="o">**</span><span class="n">static_args</span><span class="p">)</span>
</span><span id="L-2646"><a href="#L-2646"><span class="linenos">2646</span></a>        <span class="k">if</span> <span class="n">has_aux</span><span class="p">:</span>
</span><span id="L-2647"><a href="#L-2647"><span class="linenos">2647</span></a>            <span class="n">y</span><span class="p">,</span> <span class="n">f_vjp</span><span class="p">,</span> <span class="n">aux</span> <span class="o">=</span> <span class="n">vjp_ret</span>
</span><span id="L-2648"><a href="#L-2648"><span class="linenos">2648</span></a>        <span class="k">else</span><span class="p">:</span>
</span><span id="L-2649"><a href="#L-2649"><span class="linenos">2649</span></a>            <span class="n">y</span><span class="p">,</span> <span class="n">f_vjp</span> <span class="o">=</span> <span class="n">vjp_ret</span>
</span><span id="L-2650"><a href="#L-2650"><span class="linenos">2650</span></a>        <span class="k">if</span> <span class="n">np</span><span class="o">.</span><span class="n">shape</span><span class="p">(</span><span class="n">y</span><span class="p">)</span> <span class="o">!=</span> <span class="p">():</span>
</span><span id="L-2651"><a href="#L-2651"><span class="linenos">2651</span></a>            <span class="k">raise</span> <span class="ne">TypeError</span><span class="p">(</span><span class="s2">&quot;grad output must be 0-dim scalar with shape ()&quot;</span><span class="p">)</span>
</span><span id="L-2652"><a href="#L-2652"><span class="linenos">2652</span></a>        <span class="n">gL_xs</span> <span class="o">=</span> <span class="n">f_vjp</span><span class="p">(</span><span class="n">backend</span><span class="o">.</span><span class="n">ones</span><span class="p">(()))</span>
</span><span id="L-2653"><a href="#L-2653"><span class="linenos">2653</span></a>        <span class="n">gL_xs</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">gL_xs</span><span class="p">[</span><span class="n">i</span><span class="p">]</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="n">argnums</span><span class="p">)</span> <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">argnums</span><span class="p">)</span> <span class="o">&gt;</span> <span class="mi">1</span> <span class="k">else</span> <span class="n">gL_xs</span><span class="p">[</span><span class="n">argnums</span><span class="p">[</span><span class="mi">0</span><span class="p">]]</span>
</span><span id="L-2654"><a href="#L-2654"><span class="linenos">2654</span></a>        <span class="k">if</span> <span class="n">return_value</span><span class="p">:</span>
</span><span id="L-2655"><a href="#L-2655"><span class="linenos">2655</span></a>            <span class="k">return</span> <span class="p">((</span><span class="n">y</span><span class="p">,</span> <span class="n">aux</span><span class="p">),</span> <span class="n">gL_xs</span><span class="p">)</span> <span class="k">if</span> <span class="n">has_aux</span> <span class="k">else</span> <span class="p">(</span><span class="n">y</span><span class="p">,</span> <span class="n">gL_xs</span><span class="p">)</span>
</span><span id="L-2656"><a href="#L-2656"><span class="linenos">2656</span></a>        <span class="k">else</span><span class="p">:</span>
</span><span id="L-2657"><a href="#L-2657"><span class="linenos">2657</span></a>            <span class="k">return</span> <span class="p">(</span><span class="n">gL_xs</span><span class="p">,</span> <span class="n">aux</span><span class="p">)</span> <span class="k">if</span> <span class="n">has_aux</span> <span class="k">else</span> <span class="n">gL_xs</span>
</span><span id="L-2658"><a href="#L-2658"><span class="linenos">2658</span></a>
</span><span id="L-2659"><a href="#L-2659"><span class="linenos">2659</span></a>    <span class="k">return</span> <span class="n">jit</span><span class="p">(</span><span class="n">gfn</span><span class="p">)</span> <span class="k">if</span> <span class="n">rejit</span> <span class="k">else</span> <span class="n">gfn</span>
</span><span id="L-2660"><a href="#L-2660"><span class="linenos">2660</span></a>
</span><span id="L-2661"><a href="#L-2661"><span class="linenos">2661</span></a>
</span><span id="L-2662"><a href="#L-2662"><span class="linenos">2662</span></a><span class="k">def</span> <span class="nf">value_and_grad</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="n">argnums</span><span class="o">=</span><span class="p">(</span><span class="mi">0</span><span class="p">,),</span> <span class="n">argnames</span><span class="o">=</span><span class="s2">&quot;&quot;</span><span class="p">,</span> <span class="n">has_aux</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>
</span><span id="L-2663"><a href="#L-2663"><span class="linenos">2663</span></a>    <span class="k">return</span> <span class="n">grad</span><span class="p">(</span>
</span><span id="L-2664"><a href="#L-2664"><span class="linenos">2664</span></a>        <span class="n">f</span><span class="p">,</span>
</span><span id="L-2665"><a href="#L-2665"><span class="linenos">2665</span></a>        <span class="n">argnums</span><span class="o">=</span><span class="n">argnums</span><span class="p">,</span>
</span><span id="L-2666"><a href="#L-2666"><span class="linenos">2666</span></a>        <span class="n">argnames</span><span class="o">=</span><span class="n">argnames</span><span class="p">,</span>
</span><span id="L-2667"><a href="#L-2667"><span class="linenos">2667</span></a>        <span class="n">has_aux</span><span class="o">=</span><span class="n">has_aux</span><span class="p">,</span>
</span><span id="L-2668"><a href="#L-2668"><span class="linenos">2668</span></a>        <span class="n">return_value</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span>
</span><span id="L-2669"><a href="#L-2669"><span class="linenos">2669</span></a>    <span class="p">)</span>
</span><span id="L-2670"><a href="#L-2670"><span class="linenos">2670</span></a>
</span><span id="L-2671"><a href="#L-2671"><span class="linenos">2671</span></a>
</span><span id="L-2672"><a href="#L-2672"><span class="linenos">2672</span></a><span class="k">def</span> <span class="nf">jit_partial_run</span><span class="p">(</span><span class="n">trace</span><span class="p">,</span> <span class="n">tracers</span><span class="p">,</span> <span class="o">*</span><span class="p">,</span> <span class="n">program</span><span class="p">):</span>
</span><span id="L-2673"><a href="#L-2673"><span class="linenos">2673</span></a>    <span class="n">in_unknowns</span> <span class="o">=</span> <span class="p">[</span><span class="ow">not</span> <span class="n">t</span><span class="o">.</span><span class="n">pval</span><span class="o">.</span><span class="n">is_known</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">tracers</span><span class="p">]</span>
</span><span id="L-2674"><a href="#L-2674"><span class="linenos">2674</span></a>    <span class="n">program1</span><span class="p">,</span> <span class="n">program2</span><span class="p">,</span> <span class="n">out_unknowns</span><span class="p">,</span> <span class="n">num_res</span> <span class="o">=</span> <span class="n">partial_run_program</span><span class="p">(</span><span class="n">program</span><span class="p">,</span> <span class="n">in_unknowns</span><span class="p">)</span>
</span><span id="L-2675"><a href="#L-2675"><span class="linenos">2675</span></a>    <span class="n">known_tracers</span><span class="p">,</span> <span class="n">unknown_tracers</span> <span class="o">=</span> <span class="n">partition_list</span><span class="p">(</span><span class="n">in_unknowns</span><span class="p">,</span> <span class="n">tracers</span><span class="p">)</span>
</span><span id="L-2676"><a href="#L-2676"><span class="linenos">2676</span></a>    <span class="n">known_vals</span> <span class="o">=</span> <span class="p">[</span><span class="n">t</span><span class="o">.</span><span class="n">pval</span><span class="o">.</span><span class="n">const</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">known_tracers</span><span class="p">]</span>
</span><span id="L-2677"><a href="#L-2677"><span class="linenos">2677</span></a>    <span class="n">outs1_res</span> <span class="o">=</span> <span class="n">backend</span><span class="o">.</span><span class="n">jit_op</span><span class="p">(</span><span class="o">*</span><span class="n">known_vals</span><span class="p">,</span> <span class="n">program</span><span class="o">=</span><span class="n">program</span><span class="p">)</span>
</span><span id="L-2678"><a href="#L-2678"><span class="linenos">2678</span></a>    <span class="n">outs1</span><span class="p">,</span> <span class="n">res</span> <span class="o">=</span> <span class="n">split_list</span><span class="p">(</span><span class="n">outs1_res</span><span class="p">,</span> <span class="nb">len</span><span class="p">(</span><span class="n">program1</span><span class="o">.</span><span class="n">outs</span><span class="p">)</span> <span class="o">-</span> <span class="n">num_res</span><span class="p">)</span>
</span><span id="L-2679"><a href="#L-2679"><span class="linenos">2679</span></a>    <span class="n">res_tracers</span> <span class="o">=</span> <span class="p">[</span><span class="n">trace</span><span class="o">.</span><span class="n">instantiate_const</span><span class="p">(</span><span class="n">full_raise</span><span class="p">(</span><span class="n">trace</span><span class="p">,</span> <span class="n">x</span><span class="p">))</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">res</span><span class="p">]</span>
</span><span id="L-2680"><a href="#L-2680"><span class="linenos">2680</span></a>    <span class="n">outs2</span> <span class="o">=</span> <span class="p">[</span><span class="n">PartialRunTraceTensor</span><span class="p">(</span><span class="n">trace</span><span class="p">,</span> <span class="n">PartialValue</span><span class="o">.</span><span class="n">unknown</span><span class="p">(</span><span class="n">v</span><span class="o">.</span><span class="n">symval</span><span class="p">),</span> <span class="kc">None</span><span class="p">)</span> <span class="k">for</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">program2</span><span class="o">.</span><span class="n">outs</span><span class="p">]</span>
</span><span id="L-2681"><a href="#L-2681"><span class="linenos">2681</span></a>    <span class="n">draft</span> <span class="o">=</span> <span class="n">InstructionDraft</span><span class="p">(</span>
</span><span id="L-2682"><a href="#L-2682"><span class="linenos">2682</span></a>        <span class="n">backend</span><span class="o">.</span><span class="n">jit_op</span><span class="p">,</span>
</span><span id="L-2683"><a href="#L-2683"><span class="linenos">2683</span></a>        <span class="n">res_tracers</span> <span class="o">+</span> <span class="n">unknown_tracers</span><span class="p">,</span>
</span><span id="L-2684"><a href="#L-2684"><span class="linenos">2684</span></a>        <span class="nb">dict</span><span class="p">(</span><span class="n">program</span><span class="o">=</span><span class="n">program2</span><span class="p">),</span>
</span><span id="L-2685"><a href="#L-2685"><span class="linenos">2685</span></a>        <span class="p">[</span><span class="n">v</span><span class="o">.</span><span class="n">symval</span> <span class="k">for</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">program2</span><span class="o">.</span><span class="n">outs</span><span class="p">],</span>
</span><span id="L-2686"><a href="#L-2686"><span class="linenos">2686</span></a>        <span class="nb">map</span><span class="p">(</span><span class="n">weakref</span><span class="o">.</span><span class="n">ref</span><span class="p">,</span> <span class="n">outs2</span><span class="p">),</span>
</span><span id="L-2687"><a href="#L-2687"><span class="linenos">2687</span></a>    <span class="p">)</span>
</span><span id="L-2688"><a href="#L-2688"><span class="linenos">2688</span></a>    <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">outs2</span><span class="p">:</span>
</span><span id="L-2689"><a href="#L-2689"><span class="linenos">2689</span></a>        <span class="n">t</span><span class="o">.</span><span class="n">draft</span> <span class="o">=</span> <span class="n">draft</span>
</span><span id="L-2690"><a href="#L-2690"><span class="linenos">2690</span></a>    <span class="k">return</span> <span class="n">merge_lists</span><span class="p">(</span><span class="n">out_unknowns</span><span class="p">,</span> <span class="n">outs1</span><span class="p">,</span> <span class="n">outs2</span><span class="p">)</span>
</span><span id="L-2691"><a href="#L-2691"><span class="linenos">2691</span></a>
</span><span id="L-2692"><a href="#L-2692"><span class="linenos">2692</span></a>
</span><span id="L-2693"><a href="#L-2693"><span class="linenos">2693</span></a><span class="k">class</span> <span class="nc">jit</span><span class="p">:</span>
</span><span id="L-2694"><a href="#L-2694"><span class="linenos">2694</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">f</span><span class="p">,</span> <span class="n">static_argnames</span><span class="o">=</span><span class="p">(),</span> <span class="n">name</span><span class="o">=</span><span class="kc">None</span><span class="p">):</span>
</span><span id="L-2695"><a href="#L-2695"><span class="linenos">2695</span></a>        <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">static_argnames</span><span class="p">,</span> <span class="nb">str</span><span class="p">):</span>
</span><span id="L-2696"><a href="#L-2696"><span class="linenos">2696</span></a>            <span class="n">static_argnames</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">static_argnames</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="s2">&quot; &quot;</span><span class="p">))</span>
</span><span id="L-2697"><a href="#L-2697"><span class="linenos">2697</span></a>        <span class="k">assert</span> <span class="nb">type</span><span class="p">(</span><span class="n">static_argnames</span><span class="p">)</span> <span class="ow">is</span> <span class="nb">tuple</span> <span class="ow">and</span> <span class="nb">all</span><span class="p">(</span><span class="nb">type</span><span class="p">(</span><span class="n">s</span><span class="p">)</span> <span class="ow">is</span> <span class="nb">str</span> <span class="k">for</span> <span class="n">s</span> <span class="ow">in</span> <span class="n">static_argnames</span><span class="p">)</span>
</span><span id="L-2698"><a href="#L-2698"><span class="linenos">2698</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">f</span> <span class="o">=</span> <span class="n">f</span>
</span><span id="L-2699"><a href="#L-2699"><span class="linenos">2699</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">name</span> <span class="o">=</span> <span class="n">name</span> <span class="k">if</span> <span class="n">name</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span> <span class="k">else</span> <span class="bp">self</span><span class="o">.</span><span class="n">f</span><span class="o">.</span><span class="vm">__name__</span>
</span><span id="L-2700"><a href="#L-2700"><span class="linenos">2700</span></a>
</span><span id="L-2701"><a href="#L-2701"><span class="linenos">2701</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">static_argnames</span> <span class="o">=</span> <span class="n">static_argnames</span>
</span><span id="L-2702"><a href="#L-2702"><span class="linenos">2702</span></a>
</span><span id="L-2703"><a href="#L-2703"><span class="linenos">2703</span></a>    <span class="nd">@classmethod</span>
</span><span id="L-2704"><a href="#L-2704"><span class="linenos">2704</span></a>    <span class="k">def</span> <span class="nf">with_options</span><span class="p">(</span><span class="bp">cls</span><span class="p">,</span> <span class="n">static_argnames</span><span class="o">=</span><span class="p">(),</span> <span class="n">name</span><span class="o">=</span><span class="kc">None</span><span class="p">):</span>
</span><span id="L-2705"><a href="#L-2705"><span class="linenos">2705</span></a>        <span class="k">return</span> <span class="n">partial</span><span class="p">(</span><span class="bp">cls</span><span class="p">,</span> <span class="n">static_argnames</span><span class="o">=</span><span class="n">static_argnames</span><span class="p">,</span> <span class="n">name</span><span class="o">=</span><span class="n">name</span><span class="p">)</span>
</span><span id="L-2706"><a href="#L-2706"><span class="linenos">2706</span></a>
</span><span id="L-2707"><a href="#L-2707"><span class="linenos">2707</span></a>    <span class="nd">@classmethod</span>
</span><span id="L-2708"><a href="#L-2708"><span class="linenos">2708</span></a>    <span class="k">def</span> <span class="nf">get_jit_name</span><span class="p">(</span><span class="bp">cls</span><span class="p">,</span> <span class="n">args</span><span class="p">,</span> <span class="n">static_args</span><span class="p">,</span> <span class="n">prefix</span><span class="o">=</span><span class="s2">&quot;jit&quot;</span><span class="p">,</span> <span class="n">short</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>
</span><span id="L-2709"><a href="#L-2709"><span class="linenos">2709</span></a>        <span class="n">name</span> <span class="o">=</span> <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">prefix</span><span class="si">}</span><span class="s2">_&quot;</span>
</span><span id="L-2710"><a href="#L-2710"><span class="linenos">2710</span></a>        <span class="k">if</span> <span class="n">short</span><span class="p">:</span>
</span><span id="L-2711"><a href="#L-2711"><span class="linenos">2711</span></a>            <span class="n">static_args_tup</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">static_args</span><span class="o">.</span><span class="n">items</span><span class="p">())</span>
</span><span id="L-2712"><a href="#L-2712"><span class="linenos">2712</span></a>            <span class="n">ids</span> <span class="o">=</span> <span class="nb">repr</span><span class="p">(</span><span class="nb">hash</span><span class="p">((</span><span class="n">prefix</span><span class="p">,</span> <span class="n">args</span><span class="p">,</span> <span class="n">static_args_tup</span><span class="p">)))[</span><span class="o">-</span><span class="mi">4</span><span class="p">:]</span>
</span><span id="L-2713"><a href="#L-2713"><span class="linenos">2713</span></a>            <span class="n">name</span> <span class="o">=</span> <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">prefix</span><span class="si">}</span><span class="s2">_</span><span class="si">{</span><span class="n">ids</span><span class="si">}</span><span class="s2">&quot;</span>
</span><span id="L-2714"><a href="#L-2714"><span class="linenos">2714</span></a>        <span class="k">else</span><span class="p">:</span>
</span><span id="L-2715"><a href="#L-2715"><span class="linenos">2715</span></a>            <span class="k">for</span> <span class="n">a</span> <span class="ow">in</span> <span class="n">args</span><span class="p">:</span>
</span><span id="L-2716"><a href="#L-2716"><span class="linenos">2716</span></a>                <span class="n">name</span> <span class="o">+=</span> <span class="sa">f</span><span class="s2">&quot;shape_</span><span class="si">{</span><span class="n">a</span><span class="o">.</span><span class="n">shape</span><span class="si">}</span><span class="s2">_dtype_</span><span class="si">{</span><span class="n">a</span><span class="o">.</span><span class="n">dtype</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">_&quot;</span>
</span><span id="L-2717"><a href="#L-2717"><span class="linenos">2717</span></a>            <span class="k">for</span> <span class="n">k</span><span class="p">,</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">static_args</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
</span><span id="L-2718"><a href="#L-2718"><span class="linenos">2718</span></a>                <span class="n">name</span> <span class="o">+=</span> <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">k</span><span class="si">}</span><span class="s2">_</span><span class="si">{</span><span class="n">v</span><span class="si">}</span><span class="s2">_&quot;</span>
</span><span id="L-2719"><a href="#L-2719"><span class="linenos">2719</span></a>            <span class="n">name</span> <span class="o">=</span> <span class="n">name</span><span class="o">.</span><span class="n">replace</span><span class="p">(</span><span class="s2">&quot;(&quot;</span><span class="p">,</span> <span class="s2">&quot;_lp_&quot;</span><span class="p">)</span>
</span><span id="L-2720"><a href="#L-2720"><span class="linenos">2720</span></a>            <span class="n">name</span> <span class="o">=</span> <span class="n">name</span><span class="o">.</span><span class="n">replace</span><span class="p">(</span><span class="s2">&quot;)&quot;</span><span class="p">,</span> <span class="s2">&quot;_rp_&quot;</span><span class="p">)</span>
</span><span id="L-2721"><a href="#L-2721"><span class="linenos">2721</span></a>            <span class="n">name</span> <span class="o">=</span> <span class="n">name</span><span class="o">.</span><span class="n">replace</span><span class="p">(</span><span class="s2">&quot;,&quot;</span><span class="p">,</span> <span class="s2">&quot;_cm_&quot;</span><span class="p">)</span>
</span><span id="L-2722"><a href="#L-2722"><span class="linenos">2722</span></a>            <span class="n">name</span> <span class="o">=</span> <span class="n">name</span><span class="o">.</span><span class="n">replace</span><span class="p">(</span><span class="s2">&quot; &quot;</span><span class="p">,</span> <span class="s2">&quot;&quot;</span><span class="p">)</span>
</span><span id="L-2723"><a href="#L-2723"><span class="linenos">2723</span></a>            <span class="n">name</span> <span class="o">=</span> <span class="n">name</span><span class="o">.</span><span class="n">replace</span><span class="p">(</span><span class="s2">&quot;.&quot;</span><span class="p">,</span> <span class="s2">&quot;_dt_&quot;</span><span class="p">)</span>
</span><span id="L-2724"><a href="#L-2724"><span class="linenos">2724</span></a>
</span><span id="L-2725"><a href="#L-2725"><span class="linenos">2725</span></a>        <span class="k">return</span> <span class="n">name</span>
</span><span id="L-2726"><a href="#L-2726"><span class="linenos">2726</span></a>
</span><span id="L-2727"><a href="#L-2727"><span class="linenos">2727</span></a>    <span class="k">def</span> <span class="nf">get_program</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">static_args</span><span class="p">):</span>
</span><span id="L-2728"><a href="#L-2728"><span class="linenos">2728</span></a>        <span class="n">sig</span> <span class="o">=</span> <span class="n">inspect</span><span class="o">.</span><span class="n">signature</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">f</span><span class="p">)</span>
</span><span id="L-2729"><a href="#L-2729"><span class="linenos">2729</span></a>        <span class="k">if</span> <span class="nb">all</span><span class="p">(</span><span class="s2">&quot;*&quot;</span> <span class="ow">not</span> <span class="ow">in</span> <span class="nb">repr</span><span class="p">(</span><span class="n">v</span><span class="p">)</span> <span class="k">for</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">sig</span><span class="o">.</span><span class="n">parameters</span><span class="o">.</span><span class="n">values</span><span class="p">()):</span>
</span><span id="L-2730"><a href="#L-2730"><span class="linenos">2730</span></a>            <span class="n">args_strs</span> <span class="o">=</span> <span class="p">[</span><span class="n">k</span> <span class="k">for</span> <span class="n">k</span><span class="p">,</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">sig</span><span class="o">.</span><span class="n">parameters</span><span class="o">.</span><span class="n">items</span><span class="p">()</span> <span class="k">if</span> <span class="n">k</span> <span class="o">!=</span> <span class="s2">&quot;self&quot;</span> <span class="ow">and</span> <span class="n">k</span> <span class="ow">not</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">static_argnames</span><span class="p">]</span>
</span><span id="L-2731"><a href="#L-2731"><span class="linenos">2731</span></a>            <span class="n">static_args_strs</span> <span class="o">=</span> <span class="p">[</span><span class="n">k</span> <span class="k">for</span> <span class="n">k</span><span class="p">,</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">sig</span><span class="o">.</span><span class="n">parameters</span><span class="o">.</span><span class="n">items</span><span class="p">()</span> <span class="k">if</span> <span class="n">k</span> <span class="o">!=</span> <span class="s2">&quot;self&quot;</span> <span class="ow">and</span> <span class="n">k</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">static_argnames</span><span class="p">]</span>
</span><span id="L-2732"><a href="#L-2732"><span class="linenos">2732</span></a>
</span><span id="L-2733"><a href="#L-2733"><span class="linenos">2733</span></a>            <span class="k">if</span> <span class="n">args</span><span class="p">:</span>
</span><span id="L-2734"><a href="#L-2734"><span class="linenos">2734</span></a>                <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">args</span><span class="p">)</span> <span class="o">&gt;</span> <span class="nb">len</span><span class="p">(</span><span class="n">args_strs</span><span class="p">):</span>
</span><span id="L-2735"><a href="#L-2735"><span class="linenos">2735</span></a>                    <span class="k">assert</span> <span class="n">static_args_strs</span>
</span><span id="L-2736"><a href="#L-2736"><span class="linenos">2736</span></a>                    <span class="n">args</span><span class="p">,</span> <span class="n">rest</span> <span class="o">=</span> <span class="n">args</span><span class="p">[:</span> <span class="nb">len</span><span class="p">(</span><span class="n">args_strs</span><span class="p">)],</span> <span class="n">args</span><span class="p">[</span><span class="nb">len</span><span class="p">(</span><span class="n">args_strs</span><span class="p">)</span> <span class="p">:]</span>
</span><span id="L-2737"><a href="#L-2737"><span class="linenos">2737</span></a>                    <span class="n">new_static_args</span> <span class="o">=</span> <span class="p">{</span><span class="n">k</span><span class="p">:</span> <span class="n">rest_arg</span> <span class="k">for</span> <span class="n">k</span><span class="p">,</span> <span class="n">rest_arg</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">static_args_strs</span><span class="p">,</span> <span class="n">rest</span><span class="p">)</span> <span class="k">if</span> <span class="n">k</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">static_args</span><span class="p">}</span>
</span><span id="L-2738"><a href="#L-2738"><span class="linenos">2738</span></a>                    <span class="n">static_args</span> <span class="o">=</span> <span class="p">{</span><span class="o">**</span><span class="n">new_static_args</span><span class="p">,</span> <span class="o">**</span><span class="n">static_args</span><span class="p">}</span>
</span><span id="L-2739"><a href="#L-2739"><span class="linenos">2739</span></a>            <span class="k">else</span><span class="p">:</span>
</span><span id="L-2740"><a href="#L-2740"><span class="linenos">2740</span></a>                <span class="n">args</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">([</span><span class="n">static_args</span><span class="p">[</span><span class="n">k</span><span class="p">]</span> <span class="k">if</span> <span class="n">k</span> <span class="ow">in</span> <span class="n">static_args</span> <span class="k">else</span> <span class="n">arg</span> <span class="k">for</span> <span class="n">k</span><span class="p">,</span> <span class="n">arg</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">args_strs</span><span class="p">,</span> <span class="n">args</span><span class="p">)])</span>
</span><span id="L-2741"><a href="#L-2741"><span class="linenos">2741</span></a>
</span><span id="L-2742"><a href="#L-2742"><span class="linenos">2742</span></a>        <span class="n">symvals_in</span> <span class="o">=</span> <span class="n">tree_map</span><span class="p">(</span><span class="k">lambda</span> <span class="n">x</span><span class="p">:</span> <span class="n">SymbolicTensor</span><span class="o">.</span><span class="n">like</span><span class="p">(</span><span class="n">get_symval</span><span class="p">(</span><span class="n">x</span><span class="p">)),</span> <span class="n">args</span><span class="p">)</span>
</span><span id="L-2743"><a href="#L-2743"><span class="linenos">2743</span></a>        <span class="n">static_args</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">static_args</span><span class="o">.</span><span class="n">items</span><span class="p">())</span>
</span><span id="L-2744"><a href="#L-2744"><span class="linenos">2744</span></a>        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">name</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
</span><span id="L-2745"><a href="#L-2745"><span class="linenos">2745</span></a>            <span class="bp">self</span><span class="o">.</span><span class="n">name</span> <span class="o">=</span> <span class="sa">f</span><span class="s2">&quot;jit_</span><span class="si">{</span><span class="nb">str</span><span class="p">(</span><span class="nb">hash</span><span class="p">((</span><span class="bp">self</span><span class="o">.</span><span class="n">f</span><span class="p">,</span><span class="w"> </span><span class="n">symvals_in</span><span class="p">,</span><span class="w"> </span><span class="n">static_args</span><span class="p">)))[</span><span class="o">-</span><span class="mi">5</span><span class="p">:]</span><span class="si">}</span><span class="s2">&quot;</span>
</span><span id="L-2746"><a href="#L-2746"><span class="linenos">2746</span></a>        <span class="n">program</span><span class="p">,</span> <span class="n">consts</span><span class="p">,</span> <span class="n">out_tree</span> <span class="o">=</span> <span class="n">make_program</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">f</span><span class="p">,</span> <span class="o">*</span><span class="n">symvals_in</span><span class="p">,</span> <span class="n">static_args</span><span class="o">=</span><span class="n">static_args</span><span class="p">,</span> <span class="n">name</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">name</span><span class="p">)</span>
</span><span id="L-2747"><a href="#L-2747"><span class="linenos">2747</span></a>        <span class="k">return</span> <span class="n">program</span><span class="p">,</span> <span class="n">consts</span><span class="p">,</span> <span class="n">out_tree</span>
</span><span id="L-2748"><a href="#L-2748"><span class="linenos">2748</span></a>        <span class="n">program</span><span class="p">,</span> <span class="n">consts</span><span class="p">,</span> <span class="n">out_tree</span> <span class="o">=</span> <span class="n">make_program</span><span class="p">(</span>
</span><span id="L-2749"><a href="#L-2749"><span class="linenos">2749</span></a>            <span class="bp">self</span><span class="o">.</span><span class="n">f</span><span class="p">,</span>
</span><span id="L-2750"><a href="#L-2750"><span class="linenos">2750</span></a>            <span class="o">*</span><span class="n">symvals_in</span><span class="p">,</span>
</span><span id="L-2751"><a href="#L-2751"><span class="linenos">2751</span></a>            <span class="n">static_args</span><span class="o">=</span><span class="nb">tuple</span><span class="p">(</span><span class="n">static_args</span><span class="o">.</span><span class="n">items</span><span class="p">()),</span>
</span><span id="L-2752"><a href="#L-2752"><span class="linenos">2752</span></a>            <span class="n">name</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">name</span><span class="p">,</span>
</span><span id="L-2753"><a href="#L-2753"><span class="linenos">2753</span></a>        <span class="p">)</span>
</span><span id="L-2754"><a href="#L-2754"><span class="linenos">2754</span></a>        <span class="k">return</span> <span class="n">program</span><span class="p">,</span> <span class="n">consts</span><span class="p">,</span> <span class="n">out_tree</span>
</span><span id="L-2755"><a href="#L-2755"><span class="linenos">2755</span></a>
</span><span id="L-2756"><a href="#L-2756"><span class="linenos">2756</span></a>    <span class="k">def</span> <span class="fm">__call__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">static_args</span><span class="p">):</span>
</span><span id="L-2757"><a href="#L-2757"><span class="linenos">2757</span></a>        <span class="n">program</span><span class="p">,</span> <span class="n">consts</span><span class="p">,</span> <span class="n">out_tree</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">get_program</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">static_args</span><span class="p">)</span>
</span><span id="L-2758"><a href="#L-2758"><span class="linenos">2758</span></a>        <span class="n">args</span><span class="p">,</span> <span class="n">in_tree</span> <span class="o">=</span> <span class="n">tree_flatten</span><span class="p">(</span><span class="n">args</span><span class="p">)</span>
</span><span id="L-2759"><a href="#L-2759"><span class="linenos">2759</span></a>        <span class="c1"># with Timing(f&quot;JIT {self}&quot;): outs = bind(backend.jit_op, *consts, *args, program=program)</span>
</span><span id="L-2760"><a href="#L-2760"><span class="linenos">2760</span></a>        <span class="n">outs</span> <span class="o">=</span> <span class="n">bind</span><span class="p">(</span><span class="n">backend</span><span class="o">.</span><span class="n">jit_op</span><span class="p">,</span> <span class="o">*</span><span class="n">consts</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="n">program</span><span class="o">=</span><span class="n">program</span><span class="p">)</span>
</span><span id="L-2761"><a href="#L-2761"><span class="linenos">2761</span></a>        <span class="k">return</span> <span class="n">tree_unflatten</span><span class="p">(</span><span class="n">out_tree</span><span class="p">,</span> <span class="n">outs</span><span class="p">)</span>
</span><span id="L-2762"><a href="#L-2762"><span class="linenos">2762</span></a>
</span><span id="L-2763"><a href="#L-2763"><span class="linenos">2763</span></a>    <span class="k">def</span> <span class="nf">lower</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">static_args</span><span class="p">):</span>
</span><span id="L-2764"><a href="#L-2764"><span class="linenos">2764</span></a>        <span class="n">program</span><span class="p">,</span> <span class="n">consts</span><span class="p">,</span> <span class="n">out_tree</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">get_program</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">static_args</span><span class="p">)</span>
</span><span id="L-2765"><a href="#L-2765"><span class="linenos">2765</span></a>        <span class="n">args</span><span class="p">,</span> <span class="n">in_tree</span> <span class="o">=</span> <span class="n">tree_flatten</span><span class="p">(</span><span class="n">args</span><span class="p">)</span>
</span><span id="L-2766"><a href="#L-2766"><span class="linenos">2766</span></a>        <span class="n">hashed_program</span> <span class="o">=</span> <span class="n">Hashed</span><span class="p">(</span><span class="n">program</span><span class="p">)</span>
</span><span id="L-2767"><a href="#L-2767"><span class="linenos">2767</span></a>        <span class="n">num_consts</span> <span class="o">=</span> <span class="n">program</span><span class="o">.</span><span class="n">num_consts</span>
</span><span id="L-2768"><a href="#L-2768"><span class="linenos">2768</span></a>        <span class="n">consts</span><span class="p">,</span> <span class="n">args</span> <span class="o">=</span> <span class="n">args</span><span class="p">[:</span><span class="n">num_consts</span><span class="p">],</span> <span class="n">args</span><span class="p">[</span><span class="n">num_consts</span><span class="p">:]</span>
</span><span id="L-2769"><a href="#L-2769"><span class="linenos">2769</span></a>        <span class="n">hashed_consts</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="nb">map</span><span class="p">(</span><span class="n">Hashed</span><span class="p">,</span> <span class="n">consts</span><span class="p">))</span>
</span><span id="L-2770"><a href="#L-2770"><span class="linenos">2770</span></a>        <span class="n">jit_output</span> <span class="o">=</span> <span class="n">backend</span><span class="o">.</span><span class="n">jit_program</span><span class="p">(</span><span class="n">hashed_program</span><span class="p">,</span> <span class="n">hashed_consts</span><span class="p">)</span>
</span><span id="L-2771"><a href="#L-2771"><span class="linenos">2771</span></a>        <span class="k">return</span> <span class="n">jit_output</span>
</span><span id="L-2772"><a href="#L-2772"><span class="linenos">2772</span></a>
</span><span id="L-2773"><a href="#L-2773"><span class="linenos">2773</span></a>    <span class="k">def</span> <span class="nf">export</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">args</span><span class="p">,</span> <span class="n">output_path</span><span class="p">,</span> <span class="n">export_params</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">input_names</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">output_names</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">):</span>
</span><span id="L-2774"><a href="#L-2774"><span class="linenos">2774</span></a>        <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">args</span><span class="p">,</span> <span class="n">Tensor</span><span class="p">):</span>
</span><span id="L-2775"><a href="#L-2775"><span class="linenos">2775</span></a>            <span class="n">args</span><span class="p">,</span> <span class="n">static_args</span> <span class="o">=</span> <span class="p">(</span><span class="n">args</span><span class="p">,),</span> <span class="nb">dict</span><span class="p">()</span>
</span><span id="L-2776"><a href="#L-2776"><span class="linenos">2776</span></a>        <span class="k">elif</span> <span class="ow">not</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">args</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">],</span> <span class="nb">dict</span><span class="p">):</span>
</span><span id="L-2777"><a href="#L-2777"><span class="linenos">2777</span></a>            <span class="k">assert</span> <span class="nb">all</span><span class="p">(</span><span class="nb">isinstance</span><span class="p">(</span><span class="n">a</span><span class="p">,</span> <span class="n">Tensor</span><span class="p">)</span> <span class="k">for</span> <span class="n">a</span> <span class="ow">in</span> <span class="n">args</span><span class="p">)</span>
</span><span id="L-2778"><a href="#L-2778"><span class="linenos">2778</span></a>            <span class="n">static_args</span> <span class="o">=</span> <span class="nb">dict</span><span class="p">()</span>
</span><span id="L-2779"><a href="#L-2779"><span class="linenos">2779</span></a>        <span class="k">else</span><span class="p">:</span>
</span><span id="L-2780"><a href="#L-2780"><span class="linenos">2780</span></a>            <span class="n">args</span><span class="p">,</span> <span class="n">static_args</span> <span class="o">=</span> <span class="n">args</span><span class="p">[:</span><span class="o">-</span><span class="mi">1</span><span class="p">],</span> <span class="n">args</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span>
</span><span id="L-2781"><a href="#L-2781"><span class="linenos">2781</span></a>        <span class="k">assert</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">args</span><span class="p">,</span> <span class="p">(</span><span class="nb">tuple</span><span class="p">,</span> <span class="nb">list</span><span class="p">))</span> <span class="ow">and</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">static_args</span><span class="p">,</span> <span class="nb">dict</span><span class="p">)</span>
</span><span id="L-2782"><a href="#L-2782"><span class="linenos">2782</span></a>        <span class="n">jit_output</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">lower</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">static_args</span><span class="p">)</span>
</span><span id="L-2783"><a href="#L-2783"><span class="linenos">2783</span></a>        <span class="n">backend</span><span class="o">.</span><span class="n">export</span><span class="p">(</span><span class="n">jit_output</span><span class="p">,</span> <span class="n">output_path</span><span class="p">,</span> <span class="n">export_params</span><span class="p">,</span> <span class="n">input_names</span><span class="p">,</span> <span class="n">output_names</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">)</span>
</span></pre></div>


            </section>
                <section id="Timing">
                            <input id="Timing-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr class">
            
    <span class="def">class</span>
    <span class="name">Timing</span><wbr>(<span class="base">contextlib.ContextDecorator</span>):

                <label class="view-source-button" for="Timing-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Timing"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Timing-46"><a href="#Timing-46"><span class="linenos">46</span></a><span class="k">class</span> <span class="nc">Timing</span><span class="p">(</span><span class="n">ContextDecorator</span><span class="p">):</span>
</span><span id="Timing-47"><a href="#Timing-47"><span class="linenos">47</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">prefix</span><span class="o">=</span><span class="s2">&quot;&quot;</span><span class="p">,</span> <span class="n">on_exit</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">enabled</span><span class="o">=</span><span class="kc">True</span><span class="p">):</span>
</span><span id="Timing-48"><a href="#Timing-48"><span class="linenos">48</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">prefix</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">on_exit</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">enabled</span> <span class="o">=</span> <span class="n">prefix</span><span class="p">,</span> <span class="n">on_exit</span><span class="p">,</span> <span class="n">enabled</span>
</span><span id="Timing-49"><a href="#Timing-49"><span class="linenos">49</span></a>
</span><span id="Timing-50"><a href="#Timing-50"><span class="linenos">50</span></a>    <span class="k">def</span> <span class="fm">__enter__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="Timing-51"><a href="#Timing-51"><span class="linenos">51</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">st</span> <span class="o">=</span> <span class="n">time</span><span class="o">.</span><span class="n">perf_counter_ns</span><span class="p">()</span>
</span><span id="Timing-52"><a href="#Timing-52"><span class="linenos">52</span></a>
</span><span id="Timing-53"><a href="#Timing-53"><span class="linenos">53</span></a>    <span class="k">def</span> <span class="fm">__exit__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="n">exc</span><span class="p">):</span>
</span><span id="Timing-54"><a href="#Timing-54"><span class="linenos">54</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">et</span> <span class="o">=</span> <span class="n">time</span><span class="o">.</span><span class="n">perf_counter_ns</span><span class="p">()</span> <span class="o">-</span> <span class="bp">self</span><span class="o">.</span><span class="n">st</span>
</span><span id="Timing-55"><a href="#Timing-55"><span class="linenos">55</span></a>        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">enabled</span><span class="p">:</span>
</span><span id="Timing-56"><a href="#Timing-56"><span class="linenos">56</span></a>            <span class="nb">print</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">prefix</span><span class="si">}{</span><span class="bp">self</span><span class="o">.</span><span class="n">et</span><span class="o">*</span><span class="mf">1e-6</span><span class="si">:</span><span class="s2">6.2f</span><span class="si">}</span><span class="s2"> ms&quot;</span> <span class="o">+</span> <span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">on_exit</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">et</span><span class="p">)</span> <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">on_exit</span> <span class="k">else</span> <span class="s2">&quot;&quot;</span><span class="p">))</span>
</span></pre></div>


            <div class="docstring"><p>A base class or mixin that enables context managers to work as decorators.</p>
</div>


                            <div id="Timing.__init__" class="classattr">
                                        <input id="Timing.__init__-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="name">Timing</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">prefix</span><span class="o">=</span><span class="s1">&#39;&#39;</span>, </span><span class="param"><span class="n">on_exit</span><span class="o">=</span><span class="kc">None</span>, </span><span class="param"><span class="n">enabled</span><span class="o">=</span><span class="kc">True</span></span>)</span>

                <label class="view-source-button" for="Timing.__init__-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Timing.__init__"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Timing.__init__-47"><a href="#Timing.__init__-47"><span class="linenos">47</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">prefix</span><span class="o">=</span><span class="s2">&quot;&quot;</span><span class="p">,</span> <span class="n">on_exit</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">enabled</span><span class="o">=</span><span class="kc">True</span><span class="p">):</span>
</span><span id="Timing.__init__-48"><a href="#Timing.__init__-48"><span class="linenos">48</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">prefix</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">on_exit</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">enabled</span> <span class="o">=</span> <span class="n">prefix</span><span class="p">,</span> <span class="n">on_exit</span><span class="p">,</span> <span class="n">enabled</span>
</span></pre></div>


    

                            </div>
                </section>
                <section id="colored">
                            <input id="colored-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">colored</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">st</span>, </span><span class="param"><span class="n">color</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="nb">str</span><span class="p">]</span>, </span><span class="param"><span class="n">background</span><span class="o">=</span><span class="kc">False</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="colored-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#colored"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="colored-59"><a href="#colored-59"><span class="linenos">59</span></a><span class="k">def</span> <span class="nf">colored</span><span class="p">(</span><span class="n">st</span><span class="p">,</span> <span class="n">color</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="nb">str</span><span class="p">],</span> <span class="n">background</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>
</span><span id="colored-60"><a href="#colored-60"><span class="linenos">60</span></a>    <span class="k">return</span> <span class="p">(</span>
</span><span id="colored-61"><a href="#colored-61"><span class="linenos">61</span></a>        <span class="sa">f</span><span class="s2">&quot;</span><span class="se">\u001b</span><span class="s2">[</span><span class="si">{</span><span class="mi">10</span><span class="o">*</span><span class="n">background</span><span class="o">+</span><span class="mi">60</span><span class="o">*</span><span class="p">(</span><span class="n">color</span><span class="o">.</span><span class="n">upper</span><span class="p">()</span><span class="w"> </span><span class="o">==</span><span class="w"> </span><span class="n">color</span><span class="p">)</span><span class="o">+</span><span class="mi">30</span><span class="o">+</span><span class="p">[</span><span class="s1">&#39;black&#39;</span><span class="p">,</span><span class="w"> </span><span class="s1">&#39;red&#39;</span><span class="p">,</span><span class="w"> </span><span class="s1">&#39;green&#39;</span><span class="p">,</span><span class="w"> </span><span class="s1">&#39;yellow&#39;</span><span class="p">,</span><span class="w"> </span><span class="s1">&#39;blue&#39;</span><span class="p">,</span><span class="w"> </span><span class="s1">&#39;magenta&#39;</span><span class="p">,</span><span class="w"> </span><span class="s1">&#39;cyan&#39;</span><span class="p">,</span><span class="w"> </span><span class="s1">&#39;white&#39;</span><span class="p">]</span><span class="o">.</span><span class="n">index</span><span class="p">(</span><span class="n">color</span><span class="o">.</span><span class="n">lower</span><span class="p">())</span><span class="si">}</span><span class="s2">m</span><span class="si">{</span><span class="n">st</span><span class="si">}</span><span class="se">\u001b</span><span class="s2">[0m&quot;</span>
</span><span id="colored-62"><a href="#colored-62"><span class="linenos">62</span></a>        <span class="k">if</span> <span class="n">color</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span>
</span><span id="colored-63"><a href="#colored-63"><span class="linenos">63</span></a>        <span class="k">else</span> <span class="n">st</span>
</span><span id="colored-64"><a href="#colored-64"><span class="linenos">64</span></a>    <span class="p">)</span>  <span class="c1"># replace the termcolor library with one line  # noqa: E501</span>
</span></pre></div>


    

                </section>
                <section id="Profiling">
                            <input id="Profiling-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr class">
            
    <span class="def">class</span>
    <span class="name">Profiling</span><wbr>(<span class="base">contextlib.ContextDecorator</span>):

                <label class="view-source-button" for="Profiling-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Profiling"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Profiling-71"><a href="#Profiling-71"><span class="linenos">71</span></a><span class="k">class</span> <span class="nc">Profiling</span><span class="p">(</span><span class="n">ContextDecorator</span><span class="p">):</span>
</span><span id="Profiling-72"><a href="#Profiling-72"><span class="linenos">72</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">enabled</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">sort</span><span class="o">=</span><span class="s2">&quot;cumtime&quot;</span><span class="p">,</span> <span class="n">frac</span><span class="o">=</span><span class="mf">0.2</span><span class="p">,</span> <span class="n">fn</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">ts</span><span class="o">=</span><span class="mi">1</span><span class="p">):</span>
</span><span id="Profiling-73"><a href="#Profiling-73"><span class="linenos">73</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">enabled</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">sort</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">frac</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">fn</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">time_scale</span> <span class="o">=</span> <span class="n">enabled</span><span class="p">,</span> <span class="n">sort</span><span class="p">,</span> <span class="n">frac</span><span class="p">,</span> <span class="n">fn</span><span class="p">,</span> <span class="mf">1e3</span> <span class="o">/</span> <span class="n">ts</span>
</span><span id="Profiling-74"><a href="#Profiling-74"><span class="linenos">74</span></a>
</span><span id="Profiling-75"><a href="#Profiling-75"><span class="linenos">75</span></a>    <span class="k">def</span> <span class="fm">__enter__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="Profiling-76"><a href="#Profiling-76"><span class="linenos">76</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">pr</span> <span class="o">=</span> <span class="n">cProfile</span><span class="o">.</span><span class="n">Profile</span><span class="p">()</span>
</span><span id="Profiling-77"><a href="#Profiling-77"><span class="linenos">77</span></a>        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">enabled</span><span class="p">:</span>
</span><span id="Profiling-78"><a href="#Profiling-78"><span class="linenos">78</span></a>            <span class="bp">self</span><span class="o">.</span><span class="n">pr</span><span class="o">.</span><span class="n">enable</span><span class="p">()</span>
</span><span id="Profiling-79"><a href="#Profiling-79"><span class="linenos">79</span></a>
</span><span id="Profiling-80"><a href="#Profiling-80"><span class="linenos">80</span></a>    <span class="k">def</span> <span class="fm">__exit__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="n">exc</span><span class="p">):</span>
</span><span id="Profiling-81"><a href="#Profiling-81"><span class="linenos">81</span></a>        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">enabled</span><span class="p">:</span>
</span><span id="Profiling-82"><a href="#Profiling-82"><span class="linenos">82</span></a>            <span class="bp">self</span><span class="o">.</span><span class="n">pr</span><span class="o">.</span><span class="n">disable</span><span class="p">()</span>
</span><span id="Profiling-83"><a href="#Profiling-83"><span class="linenos">83</span></a>            <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">fn</span><span class="p">:</span>
</span><span id="Profiling-84"><a href="#Profiling-84"><span class="linenos">84</span></a>                <span class="bp">self</span><span class="o">.</span><span class="n">pr</span><span class="o">.</span><span class="n">dump_stats</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">fn</span><span class="p">)</span>
</span><span id="Profiling-85"><a href="#Profiling-85"><span class="linenos">85</span></a>            <span class="n">stats</span> <span class="o">=</span> <span class="n">pstats</span><span class="o">.</span><span class="n">Stats</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">pr</span><span class="p">)</span><span class="o">.</span><span class="n">strip_dirs</span><span class="p">()</span><span class="o">.</span><span class="n">sort_stats</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">sort</span><span class="p">)</span>
</span><span id="Profiling-86"><a href="#Profiling-86"><span class="linenos">86</span></a>            <span class="k">for</span> <span class="n">fcn</span> <span class="ow">in</span> <span class="n">stats</span><span class="o">.</span><span class="n">fcn_list</span><span class="p">[</span><span class="mi">0</span> <span class="p">:</span> <span class="nb">int</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">stats</span><span class="o">.</span><span class="n">fcn_list</span><span class="p">)</span> <span class="o">*</span> <span class="bp">self</span><span class="o">.</span><span class="n">frac</span><span class="p">)]:</span>  <span class="c1"># type: ignore[attr-defined]</span>
</span><span id="Profiling-87"><a href="#Profiling-87"><span class="linenos">87</span></a>                <span class="p">(</span><span class="n">_primitive_calls</span><span class="p">,</span> <span class="n">num_calls</span><span class="p">,</span> <span class="n">tottime</span><span class="p">,</span> <span class="n">cumtime</span><span class="p">,</span> <span class="n">callers</span><span class="p">)</span> <span class="o">=</span> <span class="n">stats</span><span class="o">.</span><span class="n">stats</span><span class="p">[</span><span class="n">fcn</span><span class="p">]</span>  <span class="c1"># type: ignore[attr-defined]</span>
</span><span id="Profiling-88"><a href="#Profiling-88"><span class="linenos">88</span></a>                <span class="n">scallers</span> <span class="o">=</span> <span class="nb">sorted</span><span class="p">(</span><span class="n">callers</span><span class="o">.</span><span class="n">items</span><span class="p">(),</span> <span class="n">key</span><span class="o">=</span><span class="k">lambda</span> <span class="n">x</span><span class="p">:</span> <span class="o">-</span><span class="n">x</span><span class="p">[</span><span class="mi">1</span><span class="p">][</span><span class="mi">2</span><span class="p">])</span>
</span><span id="Profiling-89"><a href="#Profiling-89"><span class="linenos">89</span></a>                <span class="nb">print</span><span class="p">(</span>
</span><span id="Profiling-90"><a href="#Profiling-90"><span class="linenos">90</span></a>                    <span class="sa">f</span><span class="s2">&quot;n:</span><span class="si">{</span><span class="n">num_calls</span><span class="si">:</span><span class="s2">8d</span><span class="si">}</span><span class="s2">  tm:</span><span class="si">{</span><span class="n">tottime</span><span class="o">*</span><span class="bp">self</span><span class="o">.</span><span class="n">time_scale</span><span class="si">:</span><span class="s2">7.2f</span><span class="si">}</span><span class="s2">ms  tot:</span><span class="si">{</span><span class="n">cumtime</span><span class="o">*</span><span class="bp">self</span><span class="o">.</span><span class="n">time_scale</span><span class="si">:</span><span class="s2">7.2f</span><span class="si">}</span><span class="s2">ms&quot;</span><span class="p">,</span>
</span><span id="Profiling-91"><a href="#Profiling-91"><span class="linenos">91</span></a>                    <span class="n">colored</span><span class="p">(</span><span class="n">_format_fcn</span><span class="p">(</span><span class="n">fcn</span><span class="p">),</span> <span class="s2">&quot;yellow&quot;</span><span class="p">)</span> <span class="o">+</span> <span class="s2">&quot; &quot;</span> <span class="o">*</span> <span class="p">(</span><span class="mi">50</span> <span class="o">-</span> <span class="nb">len</span><span class="p">(</span><span class="n">_format_fcn</span><span class="p">(</span><span class="n">fcn</span><span class="p">))),</span>
</span><span id="Profiling-92"><a href="#Profiling-92"><span class="linenos">92</span></a>                    <span class="n">colored</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;&lt;- </span><span class="si">{</span><span class="p">(</span><span class="n">scallers</span><span class="p">[</span><span class="mi">0</span><span class="p">][</span><span class="mi">1</span><span class="p">][</span><span class="mi">2</span><span class="p">]</span><span class="o">/</span><span class="n">tottime</span><span class="p">)</span><span class="o">*</span><span class="mi">100</span><span class="si">:</span><span class="s2">3.0f</span><span class="si">}</span><span class="s2">% </span><span class="si">{</span><span class="n">_format_fcn</span><span class="p">(</span><span class="n">scallers</span><span class="p">[</span><span class="mi">0</span><span class="p">][</span><span class="mi">0</span><span class="p">])</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">,</span> <span class="s2">&quot;BLACK&quot;</span><span class="p">)</span> <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">scallers</span><span class="p">)</span> <span class="k">else</span> <span class="s2">&quot;&quot;</span><span class="p">,</span>
</span><span id="Profiling-93"><a href="#Profiling-93"><span class="linenos">93</span></a>                <span class="p">)</span>
</span></pre></div>


            <div class="docstring"><p>A base class or mixin that enables context managers to work as decorators.</p>
</div>


                            <div id="Profiling.__init__" class="classattr">
                                        <input id="Profiling.__init__-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="name">Profiling</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">enabled</span><span class="o">=</span><span class="kc">True</span>, </span><span class="param"><span class="n">sort</span><span class="o">=</span><span class="s1">&#39;cumtime&#39;</span>, </span><span class="param"><span class="n">frac</span><span class="o">=</span><span class="mf">0.2</span>, </span><span class="param"><span class="n">fn</span><span class="o">=</span><span class="kc">None</span>, </span><span class="param"><span class="n">ts</span><span class="o">=</span><span class="mi">1</span></span>)</span>

                <label class="view-source-button" for="Profiling.__init__-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Profiling.__init__"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Profiling.__init__-72"><a href="#Profiling.__init__-72"><span class="linenos">72</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">enabled</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">sort</span><span class="o">=</span><span class="s2">&quot;cumtime&quot;</span><span class="p">,</span> <span class="n">frac</span><span class="o">=</span><span class="mf">0.2</span><span class="p">,</span> <span class="n">fn</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">ts</span><span class="o">=</span><span class="mi">1</span><span class="p">):</span>
</span><span id="Profiling.__init__-73"><a href="#Profiling.__init__-73"><span class="linenos">73</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">enabled</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">sort</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">frac</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">fn</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">time_scale</span> <span class="o">=</span> <span class="n">enabled</span><span class="p">,</span> <span class="n">sort</span><span class="p">,</span> <span class="n">frac</span><span class="p">,</span> <span class="n">fn</span><span class="p">,</span> <span class="mf">1e3</span> <span class="o">/</span> <span class="n">ts</span>
</span></pre></div>


    

                            </div>
                </section>
                <section id="dblog">
                            <input id="dblog-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">dblog</span><span class="signature pdoc-code condensed">(<span class="param"><span class="o">*</span><span class="n">msg</span>, </span><span class="param"><span class="n">enable</span><span class="o">=</span><span class="kc">True</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="dblog-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#dblog"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="dblog-96"><a href="#dblog-96"><span class="linenos">96</span></a><span class="k">def</span> <span class="nf">dblog</span><span class="p">(</span><span class="o">*</span><span class="n">msg</span><span class="p">,</span> <span class="n">enable</span><span class="o">=</span><span class="kc">True</span><span class="p">):</span>
</span><span id="dblog-97"><a href="#dblog-97"><span class="linenos">97</span></a>    <span class="k">if</span> <span class="n">enable</span><span class="p">:</span>
</span><span id="dblog-98"><a href="#dblog-98"><span class="linenos">98</span></a>        <span class="nb">print</span><span class="p">(</span><span class="o">*</span><span class="n">msg</span><span class="p">)</span>
</span></pre></div>


    

                </section>
                <section id="unzip2">
                            <input id="unzip2-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">unzip2</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">pairs</span></span><span class="return-annotation">) -> <span class="n">Tuple</span><span class="p">[</span><span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">],</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">]]</span>:</span></span>

                <label class="view-source-button" for="unzip2-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#unzip2"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="unzip2-101"><a href="#unzip2-101"><span class="linenos">101</span></a><span class="k">def</span> <span class="nf">unzip2</span><span class="p">(</span><span class="n">pairs</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Tuple</span><span class="p">[</span><span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">],</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">]]:</span>
</span><span id="unzip2-102"><a href="#unzip2-102"><span class="linenos">102</span></a>    <span class="n">lst1</span><span class="p">,</span> <span class="n">lst2</span> <span class="o">=</span> <span class="p">[],</span> <span class="p">[]</span>
</span><span id="unzip2-103"><a href="#unzip2-103"><span class="linenos">103</span></a>    <span class="k">for</span> <span class="n">i1</span><span class="p">,</span> <span class="n">i2</span> <span class="ow">in</span> <span class="n">pairs</span><span class="p">:</span>
</span><span id="unzip2-104"><a href="#unzip2-104"><span class="linenos">104</span></a>        <span class="n">lst1</span> <span class="o">+=</span> <span class="p">[</span><span class="n">i1</span><span class="p">]</span>
</span><span id="unzip2-105"><a href="#unzip2-105"><span class="linenos">105</span></a>        <span class="n">lst2</span> <span class="o">+=</span> <span class="p">[</span><span class="n">i2</span><span class="p">]</span>
</span><span id="unzip2-106"><a href="#unzip2-106"><span class="linenos">106</span></a>    <span class="k">return</span> <span class="n">lst1</span><span class="p">,</span> <span class="n">lst2</span>
</span></pre></div>


    

                </section>
                <section id="list_map">
                            <input id="list_map-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">list_map</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">f</span><span class="p">:</span> <span class="n">Callable</span>, </span><span class="param"><span class="o">*</span><span class="n">xs</span><span class="p">:</span> <span class="n">Iterable</span></span><span class="return-annotation">) -> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">]</span>:</span></span>

                <label class="view-source-button" for="list_map-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#list_map"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="list_map-109"><a href="#list_map-109"><span class="linenos">109</span></a><span class="k">def</span> <span class="nf">list_map</span><span class="p">(</span><span class="n">f</span><span class="p">:</span> <span class="n">Callable</span><span class="p">,</span> <span class="o">*</span><span class="n">xs</span><span class="p">:</span> <span class="n">Iterable</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">]:</span>
</span><span id="list_map-110"><a href="#list_map-110"><span class="linenos">110</span></a>    <span class="k">return</span> <span class="nb">list</span><span class="p">(</span><span class="nb">map</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="o">*</span><span class="n">xs</span><span class="p">))</span>
</span></pre></div>


    

                </section>
                <section id="list_zip">
                            <input id="list_zip-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">list_zip</span><span class="signature pdoc-code condensed">(<span class="param"><span class="o">*</span><span class="n">args</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">]</span></span><span class="return-annotation">) -> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">]</span>:</span></span>

                <label class="view-source-button" for="list_zip-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#list_zip"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="list_zip-113"><a href="#list_zip-113"><span class="linenos">113</span></a><span class="k">def</span> <span class="nf">list_zip</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">])</span> <span class="o">-&gt;</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">]:</span>
</span><span id="list_zip-114"><a href="#list_zip-114"><span class="linenos">114</span></a>    <span class="n">fst</span><span class="p">,</span> <span class="o">*</span><span class="n">rest</span> <span class="o">=</span> <span class="n">args</span> <span class="o">=</span> <span class="n">list_map</span><span class="p">(</span><span class="nb">list</span><span class="p">,</span> <span class="n">args</span><span class="p">)</span>
</span><span id="list_zip-115"><a href="#list_zip-115"><span class="linenos">115</span></a>    <span class="n">n</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">fst</span><span class="p">)</span>
</span><span id="list_zip-116"><a href="#list_zip-116"><span class="linenos">116</span></a>    <span class="k">for</span> <span class="n">arg</span> <span class="ow">in</span> <span class="n">rest</span><span class="p">:</span>
</span><span id="list_zip-117"><a href="#list_zip-117"><span class="linenos">117</span></a>        <span class="k">assert</span> <span class="nb">len</span><span class="p">(</span><span class="n">arg</span><span class="p">)</span> <span class="o">==</span> <span class="n">n</span>
</span><span id="list_zip-118"><a href="#list_zip-118"><span class="linenos">118</span></a>    <span class="k">return</span> <span class="nb">list</span><span class="p">(</span><span class="nb">zip</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">))</span>
</span></pre></div>


    

                </section>
                <section id="split_half">
                            <input id="split_half-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">split_half</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">lst</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">]</span></span><span class="return-annotation">) -> <span class="n">Tuple</span><span class="p">[</span><span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">],</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">]]</span>:</span></span>

                <label class="view-source-button" for="split_half-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#split_half"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="split_half-121"><a href="#split_half-121"><span class="linenos">121</span></a><span class="k">def</span> <span class="nf">split_half</span><span class="p">(</span><span class="n">lst</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">])</span> <span class="o">-&gt;</span> <span class="n">Tuple</span><span class="p">[</span><span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">],</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">]]:</span>
</span><span id="split_half-122"><a href="#split_half-122"><span class="linenos">122</span></a>    <span class="k">assert</span> <span class="ow">not</span> <span class="nb">len</span><span class="p">(</span><span class="n">lst</span><span class="p">)</span> <span class="o">%</span> <span class="mi">2</span>
</span><span id="split_half-123"><a href="#split_half-123"><span class="linenos">123</span></a>    <span class="k">return</span> <span class="n">split_list</span><span class="p">(</span><span class="n">lst</span><span class="p">,</span> <span class="nb">len</span><span class="p">(</span><span class="n">lst</span><span class="p">)</span> <span class="o">//</span> <span class="mi">2</span><span class="p">)</span>
</span></pre></div>


    

                </section>
                <section id="merge_lists">
                            <input id="merge_lists-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">merge_lists</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">which</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="nb">bool</span><span class="p">]</span>, </span><span class="param"><span class="n">l1</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">]</span>, </span><span class="param"><span class="n">l2</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">]</span></span><span class="return-annotation">) -> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">]</span>:</span></span>

                <label class="view-source-button" for="merge_lists-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#merge_lists"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="merge_lists-126"><a href="#merge_lists-126"><span class="linenos">126</span></a><span class="k">def</span> <span class="nf">merge_lists</span><span class="p">(</span><span class="n">which</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="nb">bool</span><span class="p">],</span> <span class="n">l1</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">],</span> <span class="n">l2</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">])</span> <span class="o">-&gt;</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">]:</span>
</span><span id="merge_lists-127"><a href="#merge_lists-127"><span class="linenos">127</span></a>    <span class="n">l1</span><span class="p">,</span> <span class="n">l2</span> <span class="o">=</span> <span class="nb">iter</span><span class="p">(</span><span class="n">l1</span><span class="p">),</span> <span class="nb">iter</span><span class="p">(</span><span class="n">l2</span><span class="p">)</span>
</span><span id="merge_lists-128"><a href="#merge_lists-128"><span class="linenos">128</span></a>    <span class="n">out</span> <span class="o">=</span> <span class="p">[</span><span class="nb">next</span><span class="p">(</span><span class="n">l2</span><span class="p">)</span> <span class="k">if</span> <span class="n">b</span> <span class="k">else</span> <span class="nb">next</span><span class="p">(</span><span class="n">l1</span><span class="p">)</span> <span class="k">for</span> <span class="n">b</span> <span class="ow">in</span> <span class="n">which</span><span class="p">]</span>
</span><span id="merge_lists-129"><a href="#merge_lists-129"><span class="linenos">129</span></a>    <span class="k">assert</span> <span class="nb">next</span><span class="p">(</span><span class="n">l1</span><span class="p">,</span> <span class="kc">None</span><span class="p">)</span> <span class="ow">is</span> <span class="nb">next</span><span class="p">(</span><span class="n">l2</span><span class="p">,</span> <span class="kc">None</span><span class="p">)</span> <span class="ow">is</span> <span class="kc">None</span>
</span><span id="merge_lists-130"><a href="#merge_lists-130"><span class="linenos">130</span></a>    <span class="k">return</span> <span class="n">out</span>
</span></pre></div>


    

                </section>
                <section id="split_list">
                            <input id="split_list-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">split_list</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">lst</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">]</span>, </span><span class="param"><span class="n">n</span><span class="p">:</span> <span class="nb">int</span></span><span class="return-annotation">) -> <span class="n">Tuple</span><span class="p">[</span><span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">],</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">]]</span>:</span></span>

                <label class="view-source-button" for="split_list-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#split_list"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="split_list-148"><a href="#split_list-148"><span class="linenos">148</span></a><span class="k">def</span> <span class="nf">split_list</span><span class="p">(</span><span class="n">lst</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">],</span> <span class="n">n</span><span class="p">:</span> <span class="nb">int</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Tuple</span><span class="p">[</span><span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">],</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">]]:</span>
</span><span id="split_list-149"><a href="#split_list-149"><span class="linenos">149</span></a>    <span class="k">assert</span> <span class="mi">0</span> <span class="o">&lt;=</span> <span class="n">n</span> <span class="o">&lt;=</span> <span class="nb">len</span><span class="p">(</span><span class="n">lst</span><span class="p">)</span>
</span><span id="split_list-150"><a href="#split_list-150"><span class="linenos">150</span></a>    <span class="k">return</span> <span class="n">lst</span><span class="p">[:</span><span class="n">n</span><span class="p">],</span> <span class="n">lst</span><span class="p">[</span><span class="n">n</span><span class="p">:]</span>
</span></pre></div>


    

                </section>
                <section id="partition_list">
                            <input id="partition_list-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">partition_list</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">bs</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="nb">bool</span><span class="p">]</span>, </span><span class="param"><span class="n">l</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">]</span></span><span class="return-annotation">) -> <span class="n">Tuple</span><span class="p">[</span><span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">],</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">]]</span>:</span></span>

                <label class="view-source-button" for="partition_list-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#partition_list"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="partition_list-153"><a href="#partition_list-153"><span class="linenos">153</span></a><span class="k">def</span> <span class="nf">partition_list</span><span class="p">(</span><span class="n">bs</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="nb">bool</span><span class="p">],</span> <span class="n">l</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">])</span> <span class="o">-&gt;</span> <span class="n">Tuple</span><span class="p">[</span><span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">],</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">]]:</span>
</span><span id="partition_list-154"><a href="#partition_list-154"><span class="linenos">154</span></a>    <span class="k">assert</span> <span class="nb">len</span><span class="p">(</span><span class="n">bs</span><span class="p">)</span> <span class="o">==</span> <span class="nb">len</span><span class="p">(</span><span class="n">l</span><span class="p">)</span>
</span><span id="partition_list-155"><a href="#partition_list-155"><span class="linenos">155</span></a>    <span class="n">lists</span> <span class="o">=</span> <span class="n">lst1</span><span class="p">,</span> <span class="n">lst2</span> <span class="o">=</span> <span class="p">[],</span> <span class="p">[]</span>
</span><span id="partition_list-156"><a href="#partition_list-156"><span class="linenos">156</span></a>    <span class="k">for</span> <span class="n">b</span><span class="p">,</span> <span class="n">x</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">bs</span><span class="p">,</span> <span class="n">l</span><span class="p">):</span>
</span><span id="partition_list-157"><a href="#partition_list-157"><span class="linenos">157</span></a>        <span class="n">lists</span><span class="p">[</span><span class="n">b</span><span class="p">]</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">x</span><span class="p">)</span>
</span><span id="partition_list-158"><a href="#partition_list-158"><span class="linenos">158</span></a>    <span class="k">return</span> <span class="n">lst1</span><span class="p">,</span> <span class="n">lst2</span>
</span></pre></div>


    

                </section>
                <section id="lru_cache_verbose">
                            <input id="lru_cache_verbose-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">lru_cache_verbose</span><span class="signature pdoc-code multiline">(<span class="param">	<span class="n">maxsize</span><span class="p">:</span> <span class="nb">int</span> <span class="o">=</span> <span class="mi">100</span>,</span><span class="param">	<span class="n">typed</span><span class="p">:</span> <span class="nb">bool</span> <span class="o">=</span> <span class="kc">False</span>,</span><span class="param">	<span class="n">tb_start</span><span class="p">:</span> <span class="nb">int</span> <span class="o">=</span> <span class="o">-</span><span class="mi">12</span>,</span><span class="param">	<span class="n">tb_end</span><span class="p">:</span> <span class="nb">int</span> <span class="o">=</span> <span class="o">-</span><span class="mi">7</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="lru_cache_verbose-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#lru_cache_verbose"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="lru_cache_verbose-161"><a href="#lru_cache_verbose-161"><span class="linenos">161</span></a><span class="k">def</span> <span class="nf">lru_cache_verbose</span><span class="p">(</span>
</span><span id="lru_cache_verbose-162"><a href="#lru_cache_verbose-162"><span class="linenos">162</span></a>    <span class="n">maxsize</span><span class="p">:</span> <span class="nb">int</span> <span class="o">=</span> <span class="mi">100</span><span class="p">,</span>
</span><span id="lru_cache_verbose-163"><a href="#lru_cache_verbose-163"><span class="linenos">163</span></a>    <span class="n">typed</span><span class="p">:</span> <span class="nb">bool</span> <span class="o">=</span> <span class="kc">False</span><span class="p">,</span>
</span><span id="lru_cache_verbose-164"><a href="#lru_cache_verbose-164"><span class="linenos">164</span></a>    <span class="n">tb_start</span><span class="p">:</span> <span class="nb">int</span> <span class="o">=</span> <span class="o">-</span><span class="mi">12</span><span class="p">,</span>
</span><span id="lru_cache_verbose-165"><a href="#lru_cache_verbose-165"><span class="linenos">165</span></a>    <span class="n">tb_end</span><span class="p">:</span> <span class="nb">int</span> <span class="o">=</span> <span class="o">-</span><span class="mi">7</span><span class="p">,</span>
</span><span id="lru_cache_verbose-166"><a href="#lru_cache_verbose-166"><span class="linenos">166</span></a><span class="p">):</span>
</span><span id="lru_cache_verbose-167"><a href="#lru_cache_verbose-167"><span class="linenos">167</span></a>    <span class="k">def</span> <span class="nf">decorator</span><span class="p">(</span><span class="n">fn</span><span class="p">:</span> <span class="n">Callable</span><span class="p">):</span>
</span><span id="lru_cache_verbose-168"><a href="#lru_cache_verbose-168"><span class="linenos">168</span></a>        <span class="nd">@lru_cache</span><span class="p">(</span><span class="n">maxsize</span><span class="o">=</span><span class="n">maxsize</span><span class="p">,</span> <span class="n">typed</span><span class="o">=</span><span class="n">typed</span><span class="p">)</span>
</span><span id="lru_cache_verbose-169"><a href="#lru_cache_verbose-169"><span class="linenos">169</span></a>        <span class="k">def</span> <span class="nf">wrapper</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Callable</span><span class="p">:</span>
</span><span id="lru_cache_verbose-170"><a href="#lru_cache_verbose-170"><span class="linenos">170</span></a>            <span class="k">return</span> <span class="n">fn</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">)</span>
</span><span id="lru_cache_verbose-171"><a href="#lru_cache_verbose-171"><span class="linenos">171</span></a>
</span><span id="lru_cache_verbose-172"><a href="#lru_cache_verbose-172"><span class="linenos">172</span></a>        <span class="k">def</span> <span class="nf">decorated_function</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Any</span><span class="p">:</span>
</span><span id="lru_cache_verbose-173"><a href="#lru_cache_verbose-173"><span class="linenos">173</span></a>            <span class="n">result</span> <span class="o">=</span> <span class="n">wrapper</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">)</span>
</span><span id="lru_cache_verbose-174"><a href="#lru_cache_verbose-174"><span class="linenos">174</span></a>            <span class="n">cache_info</span> <span class="o">=</span> <span class="n">wrapper</span><span class="o">.</span><span class="n">cache_info</span><span class="p">()</span>
</span><span id="lru_cache_verbose-175"><a href="#lru_cache_verbose-175"><span class="linenos">175</span></a>
</span><span id="lru_cache_verbose-176"><a href="#lru_cache_verbose-176"><span class="linenos">176</span></a>            <span class="n">dblog</span><span class="p">(</span>
</span><span id="lru_cache_verbose-177"><a href="#lru_cache_verbose-177"><span class="linenos">177</span></a>                <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">fn</span><span class="o">.</span><span class="vm">__name__</span><span class="si">}</span><span class="s2">.</span><span class="si">{</span><span class="n">cache_info</span><span class="si">}</span><span class="s2"> </span><span class="si">{</span><span class="n">args</span><span class="o">.</span><span class="fm">__hash__</span><span class="p">()</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">,</span>
</span><span id="lru_cache_verbose-178"><a href="#lru_cache_verbose-178"><span class="linenos">178</span></a>                <span class="n">enable</span><span class="o">=</span><span class="n">backend</span><span class="o">.</span><span class="n">LOG_LRU</span><span class="p">,</span>
</span><span id="lru_cache_verbose-179"><a href="#lru_cache_verbose-179"><span class="linenos">179</span></a>            <span class="p">)</span>
</span><span id="lru_cache_verbose-180"><a href="#lru_cache_verbose-180"><span class="linenos">180</span></a>            <span class="n">tb</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">traceback</span><span class="o">.</span><span class="n">format_list</span><span class="p">(</span><span class="n">traceback</span><span class="o">.</span><span class="n">extract_stack</span><span class="p">())[</span><span class="n">tb_start</span><span class="p">:</span><span class="n">tb_end</span><span class="p">])</span><span class="o">.</span><span class="n">replace</span><span class="p">(</span><span class="s2">&quot;</span><span class="se">\n</span><span class="s2">    &quot;</span><span class="p">,</span> <span class="s2">&quot;:</span><span class="se">\t</span><span class="s2">&quot;</span><span class="p">)</span> <span class="o">+</span> <span class="s2">&quot;-&quot;</span> <span class="o">*</span> <span class="mi">20</span> <span class="o">+</span> <span class="s2">&quot;</span><span class="se">\n</span><span class="s2">&quot;</span>
</span><span id="lru_cache_verbose-181"><a href="#lru_cache_verbose-181"><span class="linenos">181</span></a>            <span class="n">dblog</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">tb</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">,</span> <span class="n">enable</span><span class="o">=</span><span class="n">backend</span><span class="o">.</span><span class="n">LOG_LRU</span><span class="p">)</span>
</span><span id="lru_cache_verbose-182"><a href="#lru_cache_verbose-182"><span class="linenos">182</span></a>
</span><span id="lru_cache_verbose-183"><a href="#lru_cache_verbose-183"><span class="linenos">183</span></a>            <span class="k">return</span> <span class="n">result</span>
</span><span id="lru_cache_verbose-184"><a href="#lru_cache_verbose-184"><span class="linenos">184</span></a>
</span><span id="lru_cache_verbose-185"><a href="#lru_cache_verbose-185"><span class="linenos">185</span></a>        <span class="n">decorated_function</span><span class="o">.</span><span class="n">cache_info</span> <span class="o">=</span> <span class="n">wrapper</span><span class="o">.</span><span class="n">cache_info</span>
</span><span id="lru_cache_verbose-186"><a href="#lru_cache_verbose-186"><span class="linenos">186</span></a>        <span class="n">decorated_function</span><span class="o">.</span><span class="n">fn</span> <span class="o">=</span> <span class="n">fn</span>
</span><span id="lru_cache_verbose-187"><a href="#lru_cache_verbose-187"><span class="linenos">187</span></a>        <span class="k">return</span> <span class="n">decorated_function</span>
</span><span id="lru_cache_verbose-188"><a href="#lru_cache_verbose-188"><span class="linenos">188</span></a>
</span><span id="lru_cache_verbose-189"><a href="#lru_cache_verbose-189"><span class="linenos">189</span></a>    <span class="k">return</span> <span class="n">decorator</span>
</span></pre></div>


    

                </section>
                <section id="cuda_is_available">
                            <input id="cuda_is_available-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">cuda_is_available</span><span class="signature pdoc-code condensed">(<span class="return-annotation">):</span></span>

                <label class="view-source-button" for="cuda_is_available-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#cuda_is_available"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="cuda_is_available-192"><a href="#cuda_is_available-192"><span class="linenos">192</span></a><span class="k">def</span> <span class="nf">cuda_is_available</span><span class="p">():</span>
</span><span id="cuda_is_available-193"><a href="#cuda_is_available-193"><span class="linenos">193</span></a>    <span class="k">try</span><span class="p">:</span>
</span><span id="cuda_is_available-194"><a href="#cuda_is_available-194"><span class="linenos">194</span></a>        <span class="kn">import</span> <span class="nn">subprocess</span>
</span><span id="cuda_is_available-195"><a href="#cuda_is_available-195"><span class="linenos">195</span></a>        <span class="kn">import</span> <span class="nn">platform</span>
</span><span id="cuda_is_available-196"><a href="#cuda_is_available-196"><span class="linenos">196</span></a>
</span><span id="cuda_is_available-197"><a href="#cuda_is_available-197"><span class="linenos">197</span></a>        <span class="n">cmd</span> <span class="o">=</span> <span class="sa">f</span><span class="s2">&quot;nvidia-smi</span><span class="si">{</span><span class="s1">&#39;.exe&#39;</span><span class="w"> </span><span class="k">if</span><span class="w"> </span><span class="n">platform</span><span class="o">.</span><span class="n">system</span><span class="w"> </span><span class="o">==</span><span class="w"> </span><span class="s1">&#39;Windows&#39;</span><span class="w"> </span><span class="k">else</span><span class="w"> </span><span class="s1">&#39;&#39;</span><span class="si">}</span><span class="s2">&quot;</span>
</span><span id="cuda_is_available-198"><a href="#cuda_is_available-198"><span class="linenos">198</span></a>        <span class="n">result</span> <span class="o">=</span> <span class="n">subprocess</span><span class="o">.</span><span class="n">run</span><span class="p">([</span><span class="n">cmd</span><span class="p">],</span> <span class="n">stdout</span><span class="o">=</span><span class="n">subprocess</span><span class="o">.</span><span class="n">PIPE</span><span class="p">)</span>
</span><span id="cuda_is_available-199"><a href="#cuda_is_available-199"><span class="linenos">199</span></a>        <span class="n">output</span> <span class="o">=</span> <span class="n">result</span><span class="o">.</span><span class="n">stdout</span><span class="o">.</span><span class="n">decode</span><span class="p">(</span><span class="s2">&quot;utf-8&quot;</span><span class="p">)</span>
</span><span id="cuda_is_available-200"><a href="#cuda_is_available-200"><span class="linenos">200</span></a>        <span class="k">return</span> <span class="kc">True</span> <span class="k">if</span> <span class="s2">&quot;NVIDIA-SMI&quot;</span> <span class="ow">in</span> <span class="n">output</span> <span class="k">else</span> <span class="kc">False</span>
</span><span id="cuda_is_available-201"><a href="#cuda_is_available-201"><span class="linenos">201</span></a>    <span class="k">except</span> <span class="ne">FileNotFoundError</span><span class="p">:</span>
</span><span id="cuda_is_available-202"><a href="#cuda_is_available-202"><span class="linenos">202</span></a>        <span class="k">return</span> <span class="kc">False</span>
</span></pre></div>


    

                </section>
                <section id="Hashed">
                            <input id="Hashed-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr class">
            
    <span class="def">class</span>
    <span class="name">Hashed</span>:

                <label class="view-source-button" for="Hashed-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Hashed"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Hashed-205"><a href="#Hashed-205"><span class="linenos">205</span></a><span class="k">class</span> <span class="nc">Hashed</span><span class="p">:</span>
</span><span id="Hashed-206"><a href="#Hashed-206"><span class="linenos">206</span></a>    <span class="n">val</span><span class="p">:</span> <span class="n">Any</span>
</span><span id="Hashed-207"><a href="#Hashed-207"><span class="linenos">207</span></a>
</span><span id="Hashed-208"><a href="#Hashed-208"><span class="linenos">208</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">val</span><span class="p">):</span>
</span><span id="Hashed-209"><a href="#Hashed-209"><span class="linenos">209</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">val</span> <span class="o">=</span> <span class="n">val</span>
</span><span id="Hashed-210"><a href="#Hashed-210"><span class="linenos">210</span></a>
</span><span id="Hashed-211"><a href="#Hashed-211"><span class="linenos">211</span></a>    <span class="k">def</span> <span class="fm">__hash__</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="nb">int</span><span class="p">:</span>
</span><span id="Hashed-212"><a href="#Hashed-212"><span class="linenos">212</span></a>        <span class="k">return</span> <span class="nb">hash</span><span class="p">((</span><span class="bp">self</span><span class="o">.</span><span class="n">val</span><span class="p">,))</span>
</span><span id="Hashed-213"><a href="#Hashed-213"><span class="linenos">213</span></a>
</span><span id="Hashed-214"><a href="#Hashed-214"><span class="linenos">214</span></a>    <span class="k">def</span> <span class="fm">__eq__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">other</span><span class="p">):</span>
</span><span id="Hashed-215"><a href="#Hashed-215"><span class="linenos">215</span></a>        <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">other</span><span class="p">,</span> <span class="n">Hashed</span><span class="p">):</span>
</span><span id="Hashed-216"><a href="#Hashed-216"><span class="linenos">216</span></a>            <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">val</span><span class="p">,</span> <span class="n">Tensor</span><span class="p">)</span> <span class="ow">and</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">other</span><span class="o">.</span><span class="n">val</span><span class="p">,</span> <span class="n">Tensor</span><span class="p">):</span>
</span><span id="Hashed-217"><a href="#Hashed-217"><span class="linenos">217</span></a>                <span class="c1"># because Tensor.__eq__ already for Tensor.equal</span>
</span><span id="Hashed-218"><a href="#Hashed-218"><span class="linenos">218</span></a>                <span class="k">return</span> <span class="nb">id</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">val</span><span class="p">)</span> <span class="o">==</span> <span class="nb">id</span><span class="p">(</span><span class="n">other</span><span class="o">.</span><span class="n">val</span><span class="p">)</span>
</span><span id="Hashed-219"><a href="#Hashed-219"><span class="linenos">219</span></a>            <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">val</span> <span class="o">==</span> <span class="n">other</span><span class="o">.</span><span class="n">val</span>
</span><span id="Hashed-220"><a href="#Hashed-220"><span class="linenos">220</span></a>        <span class="k">return</span> <span class="kc">False</span>
</span><span id="Hashed-221"><a href="#Hashed-221"><span class="linenos">221</span></a>
</span><span id="Hashed-222"><a href="#Hashed-222"><span class="linenos">222</span></a>    <span class="k">def</span> <span class="fm">__repr__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="Hashed-223"><a href="#Hashed-223"><span class="linenos">223</span></a>        <span class="k">return</span> <span class="sa">f</span><span class="s2">&quot;Hashed: </span><span class="si">{</span><span class="nb">repr</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">val</span><span class="p">)</span><span class="si">}</span><span class="s2">&quot;</span>
</span></pre></div>


    

                            <div id="Hashed.__init__" class="classattr">
                                        <input id="Hashed.__init__-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="name">Hashed</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">val</span></span>)</span>

                <label class="view-source-button" for="Hashed.__init__-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Hashed.__init__"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Hashed.__init__-208"><a href="#Hashed.__init__-208"><span class="linenos">208</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">val</span><span class="p">):</span>
</span><span id="Hashed.__init__-209"><a href="#Hashed.__init__-209"><span class="linenos">209</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">val</span> <span class="o">=</span> <span class="n">val</span>
</span></pre></div>


    

                            </div>
                            <div id="Hashed.val" class="classattr">
                                <div class="attr variable">
            <span class="name">val</span><span class="annotation">: Any</span>

        
    </div>
    <a class="headerlink" href="#Hashed.val"></a>
    
    

                            </div>
                </section>
                <section id="DType">
                            <input id="DType-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr class">
            
    <span class="def">class</span>
    <span class="name">DType</span><wbr>(<span class="base">typing.NamedTuple</span>):

                <label class="view-source-button" for="DType-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#DType"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="DType-231"><a href="#DType-231"><span class="linenos">231</span></a><span class="k">class</span> <span class="nc">DType</span><span class="p">(</span><span class="n">NamedTuple</span><span class="p">):</span>
</span><span id="DType-232"><a href="#DType-232"><span class="linenos">232</span></a>    <span class="n">priority</span><span class="p">:</span> <span class="nb">int</span>
</span><span id="DType-233"><a href="#DType-233"><span class="linenos">233</span></a>    <span class="n">itemsize</span><span class="p">:</span> <span class="nb">int</span>
</span><span id="DType-234"><a href="#DType-234"><span class="linenos">234</span></a>    <span class="n">name</span><span class="p">:</span> <span class="nb">str</span>
</span><span id="DType-235"><a href="#DType-235"><span class="linenos">235</span></a>    <span class="n">mlir</span><span class="p">:</span> <span class="nb">str</span>
</span><span id="DType-236"><a href="#DType-236"><span class="linenos">236</span></a>    <span class="n">numpy</span><span class="p">:</span> <span class="nb">type</span>
</span><span id="DType-237"><a href="#DType-237"><span class="linenos">237</span></a>
</span><span id="DType-238"><a href="#DType-238"><span class="linenos">238</span></a>    <span class="nd">@property</span>
</span><span id="DType-239"><a href="#DType-239"><span class="linenos">239</span></a>    <span class="k">def</span> <span class="nf">format_code</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="DType-240"><a href="#DType-240"><span class="linenos">240</span></a>        <span class="k">return</span> <span class="sa">f</span><span class="s2">&quot;slope.</span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">&quot;</span>
</span><span id="DType-241"><a href="#DType-241"><span class="linenos">241</span></a>
</span><span id="DType-242"><a href="#DType-242"><span class="linenos">242</span></a>    <span class="k">def</span> <span class="fm">__repr__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="DType-243"><a href="#DType-243"><span class="linenos">243</span></a>        <span class="k">return</span> <span class="sa">f</span><span class="s2">&quot;&lt;DType: </span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">&gt;&quot;</span>
</span></pre></div>


            <div class="docstring"><p>DType(priority, itemsize, name, mlir, numpy)</p>
</div>


                            <div id="DType.__init__" class="classattr">
                                <div class="attr function">
            
        <span class="name">DType</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">priority</span><span class="p">:</span> <span class="nb">int</span>, </span><span class="param"><span class="n">itemsize</span><span class="p">:</span> <span class="nb">int</span>, </span><span class="param"><span class="n">name</span><span class="p">:</span> <span class="nb">str</span>, </span><span class="param"><span class="n">mlir</span><span class="p">:</span> <span class="nb">str</span>, </span><span class="param"><span class="n">numpy</span><span class="p">:</span> <span class="nb">type</span></span>)</span>

        
    </div>
    <a class="headerlink" href="#DType.__init__"></a>
    
            <div class="docstring"><p>Create new instance of DType(priority, itemsize, name, mlir, numpy)</p>
</div>


                            </div>
                            <div id="DType.priority" class="classattr">
                                <div class="attr variable">
            <span class="name">priority</span><span class="annotation">: int</span>

        
    </div>
    <a class="headerlink" href="#DType.priority"></a>
    
            <div class="docstring"><p>Alias for field number 0</p>
</div>


                            </div>
                            <div id="DType.itemsize" class="classattr">
                                <div class="attr variable">
            <span class="name">itemsize</span><span class="annotation">: int</span>

        
    </div>
    <a class="headerlink" href="#DType.itemsize"></a>
    
            <div class="docstring"><p>Alias for field number 1</p>
</div>


                            </div>
                            <div id="DType.name" class="classattr">
                                <div class="attr variable">
            <span class="name">name</span><span class="annotation">: str</span>

        
    </div>
    <a class="headerlink" href="#DType.name"></a>
    
            <div class="docstring"><p>Alias for field number 2</p>
</div>


                            </div>
                            <div id="DType.mlir" class="classattr">
                                <div class="attr variable">
            <span class="name">mlir</span><span class="annotation">: str</span>

        
    </div>
    <a class="headerlink" href="#DType.mlir"></a>
    
            <div class="docstring"><p>Alias for field number 3</p>
</div>


                            </div>
                            <div id="DType.numpy" class="classattr">
                                <div class="attr variable">
            <span class="name">numpy</span><span class="annotation">: type</span>

        
    </div>
    <a class="headerlink" href="#DType.numpy"></a>
    
            <div class="docstring"><p>Alias for field number 4</p>
</div>


                            </div>
                            <div id="DType.format_code" class="classattr">
                                        <input id="DType.format_code-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr variable">
            <span class="name">format_code</span>

                <label class="view-source-button" for="DType.format_code-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#DType.format_code"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="DType.format_code-238"><a href="#DType.format_code-238"><span class="linenos">238</span></a>    <span class="nd">@property</span>
</span><span id="DType.format_code-239"><a href="#DType.format_code-239"><span class="linenos">239</span></a>    <span class="k">def</span> <span class="nf">format_code</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="DType.format_code-240"><a href="#DType.format_code-240"><span class="linenos">240</span></a>        <span class="k">return</span> <span class="sa">f</span><span class="s2">&quot;slope.</span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">&quot;</span>
</span></pre></div>


    

                            </div>
                            <div class="inherited">
                                <h5>Inherited Members</h5>
                                <dl>
                                    <div><dt>builtins.tuple</dt>
                                <dd id="DType.index" class="function">index</dd>
                <dd id="DType.count" class="function">count</dd>

            </div>
                                </dl>
                            </div>
                </section>
                <section id="dtypes">
                            <input id="dtypes-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr class">
            
    <span class="def">class</span>
    <span class="name">dtypes</span>:

                <label class="view-source-button" for="dtypes-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#dtypes"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="dtypes-246"><a href="#dtypes-246"><span class="linenos">246</span></a><span class="k">class</span> <span class="nc">dtypes</span><span class="p">:</span>
</span><span id="dtypes-247"><a href="#dtypes-247"><span class="linenos">247</span></a>    <span class="n">float32</span><span class="p">:</span> <span class="n">Final</span><span class="p">[</span><span class="n">DType</span><span class="p">]</span> <span class="o">=</span> <span class="n">DType</span><span class="p">(</span><span class="mi">4</span><span class="p">,</span> <span class="mi">4</span><span class="p">,</span> <span class="s2">&quot;float32&quot;</span><span class="p">,</span> <span class="s2">&quot;f32&quot;</span><span class="p">,</span> <span class="n">np</span><span class="o">.</span><span class="n">float32</span><span class="p">)</span>
</span><span id="dtypes-248"><a href="#dtypes-248"><span class="linenos">248</span></a>    <span class="n">uint8</span><span class="p">:</span> <span class="n">Final</span><span class="p">[</span><span class="n">DType</span><span class="p">]</span> <span class="o">=</span> <span class="n">DType</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="mi">1</span><span class="p">,</span> <span class="s2">&quot;uint8&quot;</span><span class="p">,</span> <span class="s2">&quot;u8&quot;</span><span class="p">,</span> <span class="n">np</span><span class="o">.</span><span class="n">uint8</span><span class="p">)</span>
</span><span id="dtypes-249"><a href="#dtypes-249"><span class="linenos">249</span></a>    <span class="n">int8</span><span class="p">:</span> <span class="n">Final</span><span class="p">[</span><span class="n">DType</span><span class="p">]</span> <span class="o">=</span> <span class="n">DType</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="mi">1</span><span class="p">,</span> <span class="s2">&quot;int8&quot;</span><span class="p">,</span> <span class="s2">&quot;i8&quot;</span><span class="p">,</span> <span class="n">np</span><span class="o">.</span><span class="n">int8</span><span class="p">)</span>
</span><span id="dtypes-250"><a href="#dtypes-250"><span class="linenos">250</span></a>    <span class="nb">bool</span><span class="p">:</span> <span class="n">Final</span><span class="p">[</span><span class="n">DType</span><span class="p">]</span> <span class="o">=</span> <span class="n">DType</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="mi">1</span><span class="p">,</span> <span class="s2">&quot;bool&quot;</span><span class="p">,</span> <span class="s2">&quot;i1&quot;</span><span class="p">,</span> <span class="nb">bool</span><span class="p">)</span>
</span><span id="dtypes-251"><a href="#dtypes-251"><span class="linenos">251</span></a>    <span class="n">int32</span><span class="p">:</span> <span class="n">Final</span><span class="p">[</span><span class="n">DType</span><span class="p">]</span> <span class="o">=</span> <span class="n">DType</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span> <span class="mi">4</span><span class="p">,</span> <span class="s2">&quot;int32&quot;</span><span class="p">,</span> <span class="s2">&quot;i32&quot;</span><span class="p">,</span> <span class="n">np</span><span class="o">.</span><span class="n">int32</span><span class="p">)</span>
</span><span id="dtypes-252"><a href="#dtypes-252"><span class="linenos">252</span></a>    <span class="n">int64</span><span class="p">:</span> <span class="n">Final</span><span class="p">[</span><span class="n">DType</span><span class="p">]</span> <span class="o">=</span> <span class="n">DType</span><span class="p">(</span><span class="mi">2</span><span class="p">,</span> <span class="mi">8</span><span class="p">,</span> <span class="s2">&quot;int64&quot;</span><span class="p">,</span> <span class="s2">&quot;i64&quot;</span><span class="p">,</span> <span class="n">np</span><span class="o">.</span><span class="n">int64</span><span class="p">)</span>
</span><span id="dtypes-253"><a href="#dtypes-253"><span class="linenos">253</span></a>    <span class="n">uint64</span><span class="p">:</span> <span class="n">Final</span><span class="p">[</span><span class="n">DType</span><span class="p">]</span> <span class="o">=</span> <span class="n">DType</span><span class="p">(</span><span class="mi">2</span><span class="p">,</span> <span class="mi">8</span><span class="p">,</span> <span class="s2">&quot;uint64&quot;</span><span class="p">,</span> <span class="s2">&quot;ui64&quot;</span><span class="p">,</span> <span class="n">np</span><span class="o">.</span><span class="n">uint64</span><span class="p">)</span>
</span><span id="dtypes-254"><a href="#dtypes-254"><span class="linenos">254</span></a>    <span class="n">float16</span><span class="p">:</span> <span class="n">Final</span><span class="p">[</span><span class="n">DType</span><span class="p">]</span> <span class="o">=</span> <span class="n">DType</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="mi">2</span><span class="p">,</span> <span class="s2">&quot;float16&quot;</span><span class="p">,</span> <span class="s2">&quot;f16&quot;</span><span class="p">,</span> <span class="n">np</span><span class="o">.</span><span class="n">float16</span><span class="p">)</span>
</span><span id="dtypes-255"><a href="#dtypes-255"><span class="linenos">255</span></a>
</span><span id="dtypes-256"><a href="#dtypes-256"><span class="linenos">256</span></a>    <span class="n">all_dtypes</span> <span class="o">=</span> <span class="p">(</span><span class="nb">bool</span><span class="p">,</span> <span class="n">float16</span><span class="p">,</span> <span class="n">float32</span><span class="p">,</span> <span class="n">int8</span><span class="p">,</span> <span class="n">int32</span><span class="p">,</span> <span class="n">int64</span><span class="p">,</span> <span class="n">uint8</span><span class="p">,</span> <span class="n">uint64</span><span class="p">)</span>
</span><span id="dtypes-257"><a href="#dtypes-257"><span class="linenos">257</span></a>    <span class="n">name_dtype_map</span> <span class="o">=</span> <span class="p">{</span><span class="n">k</span><span class="o">.</span><span class="n">name</span><span class="p">:</span> <span class="n">k</span> <span class="k">for</span> <span class="n">k</span> <span class="ow">in</span> <span class="n">all_dtypes</span><span class="p">}</span>
</span><span id="dtypes-258"><a href="#dtypes-258"><span class="linenos">258</span></a>    <span class="n">name_dtype_map_inv</span> <span class="o">=</span> <span class="p">{</span><span class="n">v</span><span class="p">:</span> <span class="n">k</span> <span class="k">for</span> <span class="n">k</span><span class="p">,</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">name_dtype_map</span><span class="o">.</span><span class="n">items</span><span class="p">()}</span>
</span><span id="dtypes-259"><a href="#dtypes-259"><span class="linenos">259</span></a>    <span class="n">mlir_dtype_map</span> <span class="o">=</span> <span class="p">{</span><span class="n">k</span><span class="o">.</span><span class="n">mlir</span><span class="p">:</span> <span class="n">k</span> <span class="k">for</span> <span class="n">k</span> <span class="ow">in</span> <span class="n">all_dtypes</span><span class="p">}</span>
</span><span id="dtypes-260"><a href="#dtypes-260"><span class="linenos">260</span></a>    <span class="n">mlir_dtype_map_inv</span> <span class="o">=</span> <span class="p">{</span><span class="n">v</span><span class="p">:</span> <span class="n">k</span> <span class="k">for</span> <span class="n">k</span><span class="p">,</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">mlir_dtype_map</span><span class="o">.</span><span class="n">items</span><span class="p">()}</span>
</span><span id="dtypes-261"><a href="#dtypes-261"><span class="linenos">261</span></a>
</span><span id="dtypes-262"><a href="#dtypes-262"><span class="linenos">262</span></a>    <span class="nd">@classmethod</span>
</span><span id="dtypes-263"><a href="#dtypes-263"><span class="linenos">263</span></a>    <span class="k">def</span> <span class="nf">is_int</span><span class="p">(</span><span class="bp">cls</span><span class="p">,</span> <span class="n">dtype</span><span class="p">):</span>
</span><span id="dtypes-264"><a href="#dtypes-264"><span class="linenos">264</span></a>        <span class="k">return</span> <span class="n">dtype</span> <span class="ow">in</span> <span class="p">(</span><span class="bp">cls</span><span class="o">.</span><span class="n">uint8</span><span class="p">,</span> <span class="bp">cls</span><span class="o">.</span><span class="n">int8</span><span class="p">,</span> <span class="bp">cls</span><span class="o">.</span><span class="n">int32</span><span class="p">,</span> <span class="bp">cls</span><span class="o">.</span><span class="n">uint64</span><span class="p">,</span> <span class="bp">cls</span><span class="o">.</span><span class="n">int64</span><span class="p">)</span>
</span><span id="dtypes-265"><a href="#dtypes-265"><span class="linenos">265</span></a>
</span><span id="dtypes-266"><a href="#dtypes-266"><span class="linenos">266</span></a>    <span class="nd">@classmethod</span>
</span><span id="dtypes-267"><a href="#dtypes-267"><span class="linenos">267</span></a>    <span class="k">def</span> <span class="nf">is_float</span><span class="p">(</span><span class="bp">cls</span><span class="p">,</span> <span class="n">dtype</span><span class="p">):</span>
</span><span id="dtypes-268"><a href="#dtypes-268"><span class="linenos">268</span></a>        <span class="k">return</span> <span class="n">dtype</span> <span class="ow">in</span> <span class="p">(</span><span class="bp">cls</span><span class="o">.</span><span class="n">float16</span><span class="p">,</span> <span class="bp">cls</span><span class="o">.</span><span class="n">float32</span><span class="p">)</span>
</span></pre></div>


    

                            <div id="dtypes.float32" class="classattr">
                                <div class="attr variable">
            <span class="name">float32</span><span class="annotation">: Final[<a href="#DType">DType</a>]</span>        =
<span class="default_value">&lt;DType: float32&gt;</span>

        
    </div>
    <a class="headerlink" href="#dtypes.float32"></a>
    
    

                            </div>
                            <div id="dtypes.uint8" class="classattr">
                                <div class="attr variable">
            <span class="name">uint8</span><span class="annotation">: Final[<a href="#DType">DType</a>]</span>        =
<span class="default_value">&lt;DType: uint8&gt;</span>

        
    </div>
    <a class="headerlink" href="#dtypes.uint8"></a>
    
    

                            </div>
                            <div id="dtypes.int8" class="classattr">
                                <div class="attr variable">
            <span class="name">int8</span><span class="annotation">: Final[<a href="#DType">DType</a>]</span>        =
<span class="default_value">&lt;DType: int8&gt;</span>

        
    </div>
    <a class="headerlink" href="#dtypes.int8"></a>
    
    

                            </div>
                            <div id="dtypes.bool" class="classattr">
                                <div class="attr variable">
            <span class="name">bool</span><span class="annotation">: Final[<a href="#DType">DType</a>]</span>        =
<span class="default_value">&lt;DType: bool&gt;</span>

        
    </div>
    <a class="headerlink" href="#dtypes.bool"></a>
    
    

                            </div>
                            <div id="dtypes.int32" class="classattr">
                                <div class="attr variable">
            <span class="name">int32</span><span class="annotation">: Final[<a href="#DType">DType</a>]</span>        =
<span class="default_value">&lt;DType: int32&gt;</span>

        
    </div>
    <a class="headerlink" href="#dtypes.int32"></a>
    
    

                            </div>
                            <div id="dtypes.int64" class="classattr">
                                <div class="attr variable">
            <span class="name">int64</span><span class="annotation">: Final[<a href="#DType">DType</a>]</span>        =
<span class="default_value">&lt;DType: int64&gt;</span>

        
    </div>
    <a class="headerlink" href="#dtypes.int64"></a>
    
    

                            </div>
                            <div id="dtypes.uint64" class="classattr">
                                <div class="attr variable">
            <span class="name">uint64</span><span class="annotation">: Final[<a href="#DType">DType</a>]</span>        =
<span class="default_value">&lt;DType: uint64&gt;</span>

        
    </div>
    <a class="headerlink" href="#dtypes.uint64"></a>
    
    

                            </div>
                            <div id="dtypes.float16" class="classattr">
                                <div class="attr variable">
            <span class="name">float16</span><span class="annotation">: Final[<a href="#DType">DType</a>]</span>        =
<span class="default_value">&lt;DType: float16&gt;</span>

        
    </div>
    <a class="headerlink" href="#dtypes.float16"></a>
    
    

                            </div>
                            <div id="dtypes.all_dtypes" class="classattr">
                                <div class="attr variable">
            <span class="name">all_dtypes</span>        =
<input id="dtypes.all_dtypes-view-value" class="view-value-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
            <label class="view-value-button pdoc-button" for="dtypes.all_dtypes-view-value"></label><span class="default_value">(&lt;DType: bool&gt;, &lt;DType: float16&gt;, &lt;DType: float32&gt;, &lt;DType: int8&gt;, &lt;DType: int32&gt;, &lt;DType: int64&gt;, &lt;DType: uint8&gt;, &lt;DType: uint64&gt;)</span>

        
    </div>
    <a class="headerlink" href="#dtypes.all_dtypes"></a>
    
    

                            </div>
                            <div id="dtypes.name_dtype_map" class="classattr">
                                <div class="attr variable">
            <span class="name">name_dtype_map</span>        =
<input id="dtypes.name_dtype_map-view-value" class="view-value-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
            <label class="view-value-button pdoc-button" for="dtypes.name_dtype_map-view-value"></label><span class="default_value">{&#39;bool&#39;: &lt;DType: bool&gt;, &#39;float16&#39;: &lt;DType: float16&gt;, &#39;float32&#39;: &lt;DType: float32&gt;, &#39;int8&#39;: &lt;DType: int8&gt;, &#39;int32&#39;: &lt;DType: int32&gt;, &#39;int64&#39;: &lt;DType: int64&gt;, &#39;uint8&#39;: &lt;DType: uint8&gt;, &#39;uint64&#39;: &lt;DType: uint64&gt;}</span>

        
    </div>
    <a class="headerlink" href="#dtypes.name_dtype_map"></a>
    
    

                            </div>
                            <div id="dtypes.name_dtype_map_inv" class="classattr">
                                <div class="attr variable">
            <span class="name">name_dtype_map_inv</span>        =
<input id="dtypes.name_dtype_map_inv-view-value" class="view-value-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
            <label class="view-value-button pdoc-button" for="dtypes.name_dtype_map_inv-view-value"></label><span class="default_value">{&lt;DType: bool&gt;: &#39;bool&#39;, &lt;DType: float16&gt;: &#39;float16&#39;, &lt;DType: float32&gt;: &#39;float32&#39;, &lt;DType: int8&gt;: &#39;int8&#39;, &lt;DType: int32&gt;: &#39;int32&#39;, &lt;DType: int64&gt;: &#39;int64&#39;, &lt;DType: uint8&gt;: &#39;uint8&#39;, &lt;DType: uint64&gt;: &#39;uint64&#39;}</span>

        
    </div>
    <a class="headerlink" href="#dtypes.name_dtype_map_inv"></a>
    
    

                            </div>
                            <div id="dtypes.mlir_dtype_map" class="classattr">
                                <div class="attr variable">
            <span class="name">mlir_dtype_map</span>        =
<input id="dtypes.mlir_dtype_map-view-value" class="view-value-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
            <label class="view-value-button pdoc-button" for="dtypes.mlir_dtype_map-view-value"></label><span class="default_value">{&#39;i1&#39;: &lt;DType: bool&gt;, &#39;f16&#39;: &lt;DType: float16&gt;, &#39;f32&#39;: &lt;DType: float32&gt;, &#39;i8&#39;: &lt;DType: int8&gt;, &#39;i32&#39;: &lt;DType: int32&gt;, &#39;i64&#39;: &lt;DType: int64&gt;, &#39;u8&#39;: &lt;DType: uint8&gt;, &#39;ui64&#39;: &lt;DType: uint64&gt;}</span>

        
    </div>
    <a class="headerlink" href="#dtypes.mlir_dtype_map"></a>
    
    

                            </div>
                            <div id="dtypes.mlir_dtype_map_inv" class="classattr">
                                <div class="attr variable">
            <span class="name">mlir_dtype_map_inv</span>        =
<input id="dtypes.mlir_dtype_map_inv-view-value" class="view-value-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
            <label class="view-value-button pdoc-button" for="dtypes.mlir_dtype_map_inv-view-value"></label><span class="default_value">{&lt;DType: bool&gt;: &#39;i1&#39;, &lt;DType: float16&gt;: &#39;f16&#39;, &lt;DType: float32&gt;: &#39;f32&#39;, &lt;DType: int8&gt;: &#39;i8&#39;, &lt;DType: int32&gt;: &#39;i32&#39;, &lt;DType: int64&gt;: &#39;i64&#39;, &lt;DType: uint8&gt;: &#39;u8&#39;, &lt;DType: uint64&gt;: &#39;ui64&#39;}</span>

        
    </div>
    <a class="headerlink" href="#dtypes.mlir_dtype_map_inv"></a>
    
    

                            </div>
                            <div id="dtypes.is_int" class="classattr">
                                        <input id="dtypes.is_int-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
                    <div class="decorator">@classmethod</div>

        <span class="def">def</span>
        <span class="name">is_int</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">cls</span>, </span><span class="param"><span class="n">dtype</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="dtypes.is_int-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#dtypes.is_int"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="dtypes.is_int-262"><a href="#dtypes.is_int-262"><span class="linenos">262</span></a>    <span class="nd">@classmethod</span>
</span><span id="dtypes.is_int-263"><a href="#dtypes.is_int-263"><span class="linenos">263</span></a>    <span class="k">def</span> <span class="nf">is_int</span><span class="p">(</span><span class="bp">cls</span><span class="p">,</span> <span class="n">dtype</span><span class="p">):</span>
</span><span id="dtypes.is_int-264"><a href="#dtypes.is_int-264"><span class="linenos">264</span></a>        <span class="k">return</span> <span class="n">dtype</span> <span class="ow">in</span> <span class="p">(</span><span class="bp">cls</span><span class="o">.</span><span class="n">uint8</span><span class="p">,</span> <span class="bp">cls</span><span class="o">.</span><span class="n">int8</span><span class="p">,</span> <span class="bp">cls</span><span class="o">.</span><span class="n">int32</span><span class="p">,</span> <span class="bp">cls</span><span class="o">.</span><span class="n">uint64</span><span class="p">,</span> <span class="bp">cls</span><span class="o">.</span><span class="n">int64</span><span class="p">)</span>
</span></pre></div>


    

                            </div>
                            <div id="dtypes.is_float" class="classattr">
                                        <input id="dtypes.is_float-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
                    <div class="decorator">@classmethod</div>

        <span class="def">def</span>
        <span class="name">is_float</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">cls</span>, </span><span class="param"><span class="n">dtype</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="dtypes.is_float-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#dtypes.is_float"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="dtypes.is_float-266"><a href="#dtypes.is_float-266"><span class="linenos">266</span></a>    <span class="nd">@classmethod</span>
</span><span id="dtypes.is_float-267"><a href="#dtypes.is_float-267"><span class="linenos">267</span></a>    <span class="k">def</span> <span class="nf">is_float</span><span class="p">(</span><span class="bp">cls</span><span class="p">,</span> <span class="n">dtype</span><span class="p">):</span>
</span><span id="dtypes.is_float-268"><a href="#dtypes.is_float-268"><span class="linenos">268</span></a>        <span class="k">return</span> <span class="n">dtype</span> <span class="ow">in</span> <span class="p">(</span><span class="bp">cls</span><span class="o">.</span><span class="n">float16</span><span class="p">,</span> <span class="bp">cls</span><span class="o">.</span><span class="n">float32</span><span class="p">)</span>
</span></pre></div>


    

                            </div>
                </section>
                <section id="Device">
                            <input id="Device-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr class">
            
    <span class="def">class</span>
    <span class="name">Device</span><wbr>(<span class="base">typing.NamedTuple</span>):

                <label class="view-source-button" for="Device-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Device"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Device-271"><a href="#Device-271"><span class="linenos">271</span></a><span class="k">class</span> <span class="nc">Device</span><span class="p">(</span><span class="n">NamedTuple</span><span class="p">):</span>
</span><span id="Device-272"><a href="#Device-272"><span class="linenos">272</span></a>    <span class="n">name</span><span class="p">:</span> <span class="nb">str</span>
</span><span id="Device-273"><a href="#Device-273"><span class="linenos">273</span></a>    <span class="n">idx</span><span class="p">:</span> <span class="nb">int</span>
</span><span id="Device-274"><a href="#Device-274"><span class="linenos">274</span></a>
</span><span id="Device-275"><a href="#Device-275"><span class="linenos">275</span></a>    <span class="nd">@property</span>
</span><span id="Device-276"><a href="#Device-276"><span class="linenos">276</span></a>    <span class="k">def</span> <span class="nf">format_code</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="Device-277"><a href="#Device-277"><span class="linenos">277</span></a>        <span class="k">return</span> <span class="sa">f</span><span class="s2">&quot;&#39;</span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">:</span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">idx</span><span class="si">}</span><span class="s2">&#39;&quot;</span>
</span><span id="Device-278"><a href="#Device-278"><span class="linenos">278</span></a>
</span><span id="Device-279"><a href="#Device-279"><span class="linenos">279</span></a>    <span class="k">def</span> <span class="fm">__repr__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="Device-280"><a href="#Device-280"><span class="linenos">280</span></a>        <span class="k">return</span> <span class="sa">f</span><span class="s2">&quot;&lt;Device: </span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">format_code</span><span class="si">}</span><span class="s2">&gt;&quot;</span>
</span></pre></div>


            <div class="docstring"><p>Device(name, idx)</p>
</div>


                            <div id="Device.__init__" class="classattr">
                                <div class="attr function">
            
        <span class="name">Device</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">name</span><span class="p">:</span> <span class="nb">str</span>, </span><span class="param"><span class="n">idx</span><span class="p">:</span> <span class="nb">int</span></span>)</span>

        
    </div>
    <a class="headerlink" href="#Device.__init__"></a>
    
            <div class="docstring"><p>Create new instance of Device(name, idx)</p>
</div>


                            </div>
                            <div id="Device.name" class="classattr">
                                <div class="attr variable">
            <span class="name">name</span><span class="annotation">: str</span>

        
    </div>
    <a class="headerlink" href="#Device.name"></a>
    
            <div class="docstring"><p>Alias for field number 0</p>
</div>


                            </div>
                            <div id="Device.idx" class="classattr">
                                <div class="attr variable">
            <span class="name">idx</span><span class="annotation">: int</span>

        
    </div>
    <a class="headerlink" href="#Device.idx"></a>
    
            <div class="docstring"><p>Alias for field number 1</p>
</div>


                            </div>
                            <div id="Device.format_code" class="classattr">
                                        <input id="Device.format_code-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr variable">
            <span class="name">format_code</span>

                <label class="view-source-button" for="Device.format_code-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Device.format_code"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Device.format_code-275"><a href="#Device.format_code-275"><span class="linenos">275</span></a>    <span class="nd">@property</span>
</span><span id="Device.format_code-276"><a href="#Device.format_code-276"><span class="linenos">276</span></a>    <span class="k">def</span> <span class="nf">format_code</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="Device.format_code-277"><a href="#Device.format_code-277"><span class="linenos">277</span></a>        <span class="k">return</span> <span class="sa">f</span><span class="s2">&quot;&#39;</span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">:</span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">idx</span><span class="si">}</span><span class="s2">&#39;&quot;</span>
</span></pre></div>


    

                            </div>
                            <div class="inherited">
                                <h5>Inherited Members</h5>
                                <dl>
                                    <div><dt>builtins.tuple</dt>
                                <dd id="Device.index" class="function">index</dd>
                <dd id="Device.count" class="function">count</dd>

            </div>
                                </dl>
                            </div>
                </section>
                <section id="devices">
                            <input id="devices-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr class">
            
    <span class="def">class</span>
    <span class="name">devices</span>:

                <label class="view-source-button" for="devices-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#devices"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="devices-283"><a href="#devices-283"><span class="linenos">283</span></a><span class="k">class</span> <span class="nc">devices</span><span class="p">:</span>
</span><span id="devices-284"><a href="#devices-284"><span class="linenos">284</span></a>    <span class="n">cpu</span><span class="p">:</span> <span class="n">Final</span><span class="p">[</span><span class="n">Device</span><span class="p">]</span> <span class="o">=</span> <span class="n">Device</span><span class="p">(</span><span class="s2">&quot;cpu&quot;</span><span class="p">,</span> <span class="mi">0</span><span class="p">)</span>
</span><span id="devices-285"><a href="#devices-285"><span class="linenos">285</span></a>    <span class="n">metal</span><span class="p">:</span> <span class="n">Final</span><span class="p">[</span><span class="n">Device</span><span class="p">]</span> <span class="o">=</span> <span class="n">Device</span><span class="p">(</span><span class="s2">&quot;metal&quot;</span><span class="p">,</span> <span class="mi">0</span><span class="p">)</span>
</span><span id="devices-286"><a href="#devices-286"><span class="linenos">286</span></a>    <span class="n">cuda0</span><span class="p">:</span> <span class="n">Final</span><span class="p">[</span><span class="n">Device</span><span class="p">]</span> <span class="o">=</span> <span class="n">Device</span><span class="p">(</span><span class="s2">&quot;cuda&quot;</span><span class="p">,</span> <span class="mi">0</span><span class="p">)</span>
</span><span id="devices-287"><a href="#devices-287"><span class="linenos">287</span></a>    <span class="c1"># TODO: programmatically define this class attrs to support other setup</span>
</span><span id="devices-288"><a href="#devices-288"><span class="linenos">288</span></a>    <span class="n">cuda</span> <span class="o">=</span> <span class="n">cuda0</span>
</span><span id="devices-289"><a href="#devices-289"><span class="linenos">289</span></a>    <span class="n">all_devices</span> <span class="o">=</span> <span class="p">(</span><span class="n">cpu</span><span class="p">,</span> <span class="n">metal</span><span class="p">,</span> <span class="n">cuda0</span><span class="p">)</span>
</span><span id="devices-290"><a href="#devices-290"><span class="linenos">290</span></a>    <span class="n">name_idx_device_map</span> <span class="o">=</span> <span class="p">{</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">k</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">:</span><span class="si">{</span><span class="n">k</span><span class="o">.</span><span class="n">idx</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">:</span> <span class="n">k</span> <span class="k">for</span> <span class="n">k</span> <span class="ow">in</span> <span class="n">all_devices</span><span class="p">}</span>
</span><span id="devices-291"><a href="#devices-291"><span class="linenos">291</span></a>    <span class="n">name_idx_device_map_inv</span> <span class="o">=</span> <span class="p">{</span><span class="n">v</span><span class="p">:</span> <span class="n">k</span> <span class="k">for</span> <span class="n">k</span><span class="p">,</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">name_idx_device_map</span><span class="o">.</span><span class="n">items</span><span class="p">()}</span>
</span></pre></div>


    

                            <div id="devices.cpu" class="classattr">
                                <div class="attr variable">
            <span class="name">cpu</span><span class="annotation">: Final[<a href="#Device">Device</a>]</span>        =
<span class="default_value">&lt;Device: &#39;cpu:0&#39;&gt;</span>

        
    </div>
    <a class="headerlink" href="#devices.cpu"></a>
    
    

                            </div>
                            <div id="devices.metal" class="classattr">
                                <div class="attr variable">
            <span class="name">metal</span><span class="annotation">: Final[<a href="#Device">Device</a>]</span>        =
<span class="default_value">&lt;Device: &#39;metal:0&#39;&gt;</span>

        
    </div>
    <a class="headerlink" href="#devices.metal"></a>
    
    

                            </div>
                            <div id="devices.cuda0" class="classattr">
                                <div class="attr variable">
            <span class="name">cuda0</span><span class="annotation">: Final[<a href="#Device">Device</a>]</span>        =
<span class="default_value">&lt;Device: &#39;cuda:0&#39;&gt;</span>

        
    </div>
    <a class="headerlink" href="#devices.cuda0"></a>
    
    

                            </div>
                            <div id="devices.cuda" class="classattr">
                                <div class="attr variable">
            <span class="name">cuda</span>        =
<span class="default_value">&lt;Device: &#39;cuda:0&#39;&gt;</span>

        
    </div>
    <a class="headerlink" href="#devices.cuda"></a>
    
    

                            </div>
                            <div id="devices.all_devices" class="classattr">
                                <div class="attr variable">
            <span class="name">all_devices</span>        =
<span class="default_value">(&lt;Device: &#39;cpu:0&#39;&gt;, &lt;Device: &#39;metal:0&#39;&gt;, &lt;Device: &#39;cuda:0&#39;&gt;)</span>

        
    </div>
    <a class="headerlink" href="#devices.all_devices"></a>
    
    

                            </div>
                            <div id="devices.name_idx_device_map" class="classattr">
                                <div class="attr variable">
            <span class="name">name_idx_device_map</span>        =
<span class="default_value">{&#39;cpu:0&#39;: &lt;Device: &#39;cpu:0&#39;&gt;, &#39;metal:0&#39;: &lt;Device: &#39;metal:0&#39;&gt;, &#39;cuda:0&#39;: &lt;Device: &#39;cuda:0&#39;&gt;}</span>

        
    </div>
    <a class="headerlink" href="#devices.name_idx_device_map"></a>
    
    

                            </div>
                            <div id="devices.name_idx_device_map_inv" class="classattr">
                                <div class="attr variable">
            <span class="name">name_idx_device_map_inv</span>        =
<span class="default_value">{&lt;Device: &#39;cpu:0&#39;&gt;: &#39;cpu:0&#39;, &lt;Device: &#39;metal:0&#39;&gt;: &#39;metal:0&#39;, &lt;Device: &#39;cuda:0&#39;&gt;: &#39;cuda:0&#39;}</span>

        
    </div>
    <a class="headerlink" href="#devices.name_idx_device_map_inv"></a>
    
    

                            </div>
                </section>
                <section id="TensorBuffer">
                            <input id="TensorBuffer-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr class">
            
    <span class="def">class</span>
    <span class="name">TensorBuffer</span>:

                <label class="view-source-button" for="TensorBuffer-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#TensorBuffer"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="TensorBuffer-294"><a href="#TensorBuffer-294"><span class="linenos">294</span></a><span class="k">class</span> <span class="nc">TensorBuffer</span><span class="p">:</span>
</span><span id="TensorBuffer-295"><a href="#TensorBuffer-295"><span class="linenos">295</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">val</span><span class="p">):</span>
</span><span id="TensorBuffer-296"><a href="#TensorBuffer-296"><span class="linenos">296</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">val</span> <span class="o">=</span> <span class="n">val</span>
</span></pre></div>


    

                            <div id="TensorBuffer.__init__" class="classattr">
                                        <input id="TensorBuffer.__init__-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="name">TensorBuffer</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">val</span></span>)</span>

                <label class="view-source-button" for="TensorBuffer.__init__-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#TensorBuffer.__init__"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="TensorBuffer.__init__-295"><a href="#TensorBuffer.__init__-295"><span class="linenos">295</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">val</span><span class="p">):</span>
</span><span id="TensorBuffer.__init__-296"><a href="#TensorBuffer.__init__-296"><span class="linenos">296</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">val</span> <span class="o">=</span> <span class="n">val</span>
</span></pre></div>


    

                            </div>
                            <div id="TensorBuffer.val" class="classattr">
                                <div class="attr variable">
            <span class="name">val</span>

        
    </div>
    <a class="headerlink" href="#TensorBuffer.val"></a>
    
    

                            </div>
                </section>
                <section id="Tensor">
                            <input id="Tensor-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr class">
            
    <span class="def">class</span>
    <span class="name">Tensor</span>:

                <label class="view-source-button" for="Tensor-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Tensor"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Tensor-299"><a href="#Tensor-299"><span class="linenos">299</span></a><span class="k">class</span> <span class="nc">Tensor</span><span class="p">:</span>
</span><span id="Tensor-300"><a href="#Tensor-300"><span class="linenos">300</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">val</span><span class="p">:</span> <span class="n">TensorBuffer</span><span class="p">):</span>
</span><span id="Tensor-301"><a href="#Tensor-301"><span class="linenos">301</span></a>        <span class="k">assert</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">val</span><span class="p">,</span> <span class="n">TensorBuffer</span><span class="p">)</span>
</span><span id="Tensor-302"><a href="#Tensor-302"><span class="linenos">302</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">buf</span> <span class="o">=</span> <span class="n">val</span>
</span><span id="Tensor-303"><a href="#Tensor-303"><span class="linenos">303</span></a>
</span><span id="Tensor-304"><a href="#Tensor-304"><span class="linenos">304</span></a>    <span class="nd">@property</span>
</span><span id="Tensor-305"><a href="#Tensor-305"><span class="linenos">305</span></a>    <span class="k">def</span> <span class="nf">symval</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="Tensor-306"><a href="#Tensor-306"><span class="linenos">306</span></a>        <span class="k">return</span> <span class="n">SymbolicTensor</span><span class="o">.</span><span class="n">like</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span>
</span><span id="Tensor-307"><a href="#Tensor-307"><span class="linenos">307</span></a>
</span><span id="Tensor-308"><a href="#Tensor-308"><span class="linenos">308</span></a>    <span class="nd">@property</span>
</span><span id="Tensor-309"><a href="#Tensor-309"><span class="linenos">309</span></a>    <span class="k">def</span> <span class="nf">default_dtype</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="Tensor-310"><a href="#Tensor-310"><span class="linenos">310</span></a>        <span class="k">return</span> <span class="n">backend</span><span class="o">.</span><span class="n">default_dtype</span>
</span><span id="Tensor-311"><a href="#Tensor-311"><span class="linenos">311</span></a>
</span><span id="Tensor-312"><a href="#Tensor-312"><span class="linenos">312</span></a>    <span class="k">def</span> <span class="nf">is_int</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="nb">bool</span><span class="p">:</span>
</span><span id="Tensor-313"><a href="#Tensor-313"><span class="linenos">313</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">dtype</span> <span class="ow">in</span> <span class="p">(</span>
</span><span id="Tensor-314"><a href="#Tensor-314"><span class="linenos">314</span></a>            <span class="n">dtypes</span><span class="o">.</span><span class="n">int8</span><span class="p">,</span>
</span><span id="Tensor-315"><a href="#Tensor-315"><span class="linenos">315</span></a>            <span class="n">dtypes</span><span class="o">.</span><span class="n">uint8</span><span class="p">,</span>
</span><span id="Tensor-316"><a href="#Tensor-316"><span class="linenos">316</span></a>            <span class="n">dtypes</span><span class="o">.</span><span class="n">uint64</span><span class="p">,</span>
</span><span id="Tensor-317"><a href="#Tensor-317"><span class="linenos">317</span></a>            <span class="n">dtypes</span><span class="o">.</span><span class="n">int32</span><span class="p">,</span>
</span><span id="Tensor-318"><a href="#Tensor-318"><span class="linenos">318</span></a>            <span class="n">dtypes</span><span class="o">.</span><span class="n">int64</span><span class="p">,</span>
</span><span id="Tensor-319"><a href="#Tensor-319"><span class="linenos">319</span></a>        <span class="p">)</span>
</span><span id="Tensor-320"><a href="#Tensor-320"><span class="linenos">320</span></a>
</span><span id="Tensor-321"><a href="#Tensor-321"><span class="linenos">321</span></a>    <span class="k">def</span> <span class="nf">is_float</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="nb">bool</span><span class="p">:</span>
</span><span id="Tensor-322"><a href="#Tensor-322"><span class="linenos">322</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">dtype</span> <span class="ow">in</span> <span class="p">(</span><span class="n">dtypes</span><span class="o">.</span><span class="n">float16</span><span class="p">,</span> <span class="n">dtypes</span><span class="o">.</span><span class="n">float32</span><span class="p">)</span>
</span><span id="Tensor-323"><a href="#Tensor-323"><span class="linenos">323</span></a>
</span><span id="Tensor-324"><a href="#Tensor-324"><span class="linenos">324</span></a>    <span class="k">def</span> <span class="nf">is_unsigned</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="nb">bool</span><span class="p">:</span>
</span><span id="Tensor-325"><a href="#Tensor-325"><span class="linenos">325</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">dtype</span> <span class="ow">is</span> <span class="n">dtypes</span><span class="o">.</span><span class="n">uint8</span>
</span><span id="Tensor-326"><a href="#Tensor-326"><span class="linenos">326</span></a>
</span><span id="Tensor-327"><a href="#Tensor-327"><span class="linenos">327</span></a>    <span class="k">def</span> <span class="nf">to_bool</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="Tensor-328"><a href="#Tensor-328"><span class="linenos">328</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">cast</span><span class="p">(</span><span class="n">dtypes</span><span class="o">.</span><span class="n">bool</span><span class="p">)</span>
</span><span id="Tensor-329"><a href="#Tensor-329"><span class="linenos">329</span></a>
</span><span id="Tensor-330"><a href="#Tensor-330"><span class="linenos">330</span></a>    <span class="k">def</span> <span class="nf">short</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="Tensor-331"><a href="#Tensor-331"><span class="linenos">331</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">cast</span><span class="p">(</span><span class="n">dtypes</span><span class="o">.</span><span class="n">int8</span><span class="p">)</span>
</span><span id="Tensor-332"><a href="#Tensor-332"><span class="linenos">332</span></a>
</span><span id="Tensor-333"><a href="#Tensor-333"><span class="linenos">333</span></a>    <span class="k">def</span> <span class="nf">int</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="Tensor-334"><a href="#Tensor-334"><span class="linenos">334</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">cast</span><span class="p">(</span><span class="n">dtypes</span><span class="o">.</span><span class="n">int32</span><span class="p">)</span>
</span><span id="Tensor-335"><a href="#Tensor-335"><span class="linenos">335</span></a>
</span><span id="Tensor-336"><a href="#Tensor-336"><span class="linenos">336</span></a>    <span class="k">def</span> <span class="nf">long</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="Tensor-337"><a href="#Tensor-337"><span class="linenos">337</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">cast</span><span class="p">(</span><span class="n">dtypes</span><span class="o">.</span><span class="n">int64</span><span class="p">)</span>
</span><span id="Tensor-338"><a href="#Tensor-338"><span class="linenos">338</span></a>
</span><span id="Tensor-339"><a href="#Tensor-339"><span class="linenos">339</span></a>    <span class="k">def</span> <span class="nf">half</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="Tensor-340"><a href="#Tensor-340"><span class="linenos">340</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">cast</span><span class="p">(</span><span class="n">dtypes</span><span class="o">.</span><span class="n">float16</span><span class="p">)</span>
</span><span id="Tensor-341"><a href="#Tensor-341"><span class="linenos">341</span></a>
</span><span id="Tensor-342"><a href="#Tensor-342"><span class="linenos">342</span></a>    <span class="k">def</span> <span class="nf">float</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="Tensor-343"><a href="#Tensor-343"><span class="linenos">343</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">cast</span><span class="p">(</span><span class="n">dtypes</span><span class="o">.</span><span class="n">float32</span><span class="p">)</span>
</span><span id="Tensor-344"><a href="#Tensor-344"><span class="linenos">344</span></a>
</span><span id="Tensor-345"><a href="#Tensor-345"><span class="linenos">345</span></a>    <span class="k">def</span> <span class="fm">__getattr__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">attr</span><span class="p">):</span>
</span><span id="Tensor-346"><a href="#Tensor-346"><span class="linenos">346</span></a>        <span class="k">if</span> <span class="n">attr</span> <span class="ow">in</span> <span class="nb">vars</span><span class="p">(</span><span class="n">backend</span><span class="o">.</span><span class="n">operator_set</span><span class="p">)</span><span class="o">.</span><span class="n">keys</span><span class="p">():</span>
</span><span id="Tensor-347"><a href="#Tensor-347"><span class="linenos">347</span></a>            <span class="n">op</span> <span class="o">=</span> <span class="nb">getattr</span><span class="p">(</span><span class="n">backend</span><span class="o">.</span><span class="n">operator_set</span><span class="p">,</span> <span class="n">attr</span><span class="p">)</span>
</span><span id="Tensor-348"><a href="#Tensor-348"><span class="linenos">348</span></a>            <span class="k">return</span> <span class="n">partial</span><span class="p">(</span><span class="n">op</span><span class="p">,</span> <span class="bp">self</span><span class="p">)</span>
</span><span id="Tensor-349"><a href="#Tensor-349"><span class="linenos">349</span></a>        <span class="k">elif</span> <span class="n">attr</span> <span class="ow">in</span> <span class="nb">vars</span><span class="p">(</span><span class="n">backend</span><span class="o">.</span><span class="n">procedure_set</span><span class="p">)</span><span class="o">.</span><span class="n">keys</span><span class="p">():</span>
</span><span id="Tensor-350"><a href="#Tensor-350"><span class="linenos">350</span></a>            <span class="n">procedure</span> <span class="o">=</span> <span class="nb">getattr</span><span class="p">(</span><span class="n">backend</span><span class="o">.</span><span class="n">procedure_set</span><span class="p">,</span> <span class="n">attr</span><span class="p">)</span>
</span><span id="Tensor-351"><a href="#Tensor-351"><span class="linenos">351</span></a>            <span class="k">assert</span> <span class="ow">not</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">procedure</span><span class="p">,</span> <span class="nb">classmethod</span><span class="p">),</span> <span class="sa">f</span><span class="s2">&quot;use </span><span class="si">{</span><span class="n">attr</span><span class="si">}</span><span class="s2"> instead of self.</span><span class="si">{</span><span class="n">attr</span><span class="si">}</span><span class="s2">&quot;</span>
</span><span id="Tensor-352"><a href="#Tensor-352"><span class="linenos">352</span></a>            <span class="k">return</span> <span class="n">partial</span><span class="p">(</span><span class="n">procedure</span><span class="p">,</span> <span class="bp">self</span><span class="p">)</span>
</span><span id="Tensor-353"><a href="#Tensor-353"><span class="linenos">353</span></a>        <span class="k">else</span><span class="p">:</span>
</span><span id="Tensor-354"><a href="#Tensor-354"><span class="linenos">354</span></a>            <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="fm">__getattribute__</span><span class="p">(</span><span class="n">attr</span><span class="p">)</span>
</span><span id="Tensor-355"><a href="#Tensor-355"><span class="linenos">355</span></a>
</span><span id="Tensor-356"><a href="#Tensor-356"><span class="linenos">356</span></a>    <span class="k">def</span> <span class="fm">__getitem__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">idx</span><span class="p">):</span>
</span><span id="Tensor-357"><a href="#Tensor-357"><span class="linenos">357</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">getitem</span><span class="p">(</span><span class="n">idx</span><span class="p">)</span>
</span><span id="Tensor-358"><a href="#Tensor-358"><span class="linenos">358</span></a>
</span><span id="Tensor-359"><a href="#Tensor-359"><span class="linenos">359</span></a>    <span class="k">def</span> <span class="fm">__setitem__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">idx</span><span class="p">,</span> <span class="n">item</span><span class="p">):</span>
</span><span id="Tensor-360"><a href="#Tensor-360"><span class="linenos">360</span></a>        <span class="k">raise</span> <span class="ne">NotImplementedError</span>
</span><span id="Tensor-361"><a href="#Tensor-361"><span class="linenos">361</span></a>
</span><span id="Tensor-362"><a href="#Tensor-362"><span class="linenos">362</span></a>    <span class="k">def</span> <span class="nf">str_short</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="Tensor-363"><a href="#Tensor-363"><span class="linenos">363</span></a>        <span class="k">return</span> <span class="sa">f</span><span class="s2">&quot;&lt;Tensor: shape=</span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">shape</span><span class="si">}</span><span class="s2">, dtype=</span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">dtype</span><span class="si">}</span><span class="s2">&gt;&quot;</span>
</span><span id="Tensor-364"><a href="#Tensor-364"><span class="linenos">364</span></a>
</span><span id="Tensor-365"><a href="#Tensor-365"><span class="linenos">365</span></a>    <span class="fm">__neg__</span> <span class="o">=</span> <span class="k">lambda</span> <span class="bp">self</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">neg</span><span class="p">()</span>
</span><span id="Tensor-366"><a href="#Tensor-366"><span class="linenos">366</span></a>    <span class="fm">__add__</span> <span class="o">=</span> <span class="k">lambda</span> <span class="bp">self</span><span class="p">,</span> <span class="n">other</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">other</span><span class="p">)</span>
</span><span id="Tensor-367"><a href="#Tensor-367"><span class="linenos">367</span></a>    <span class="fm">__radd__</span> <span class="o">=</span> <span class="k">lambda</span> <span class="bp">self</span><span class="p">,</span> <span class="n">other</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">other</span><span class="p">)</span>
</span><span id="Tensor-368"><a href="#Tensor-368"><span class="linenos">368</span></a>    <span class="fm">__sub__</span> <span class="o">=</span> <span class="k">lambda</span> <span class="bp">self</span><span class="p">,</span> <span class="n">other</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">sub</span><span class="p">(</span><span class="n">other</span><span class="p">)</span>
</span><span id="Tensor-369"><a href="#Tensor-369"><span class="linenos">369</span></a>    <span class="fm">__rsub__</span> <span class="o">=</span> <span class="k">lambda</span> <span class="bp">self</span><span class="p">,</span> <span class="n">other</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">sub</span><span class="o">.</span><span class="n">func</span><span class="p">(</span><span class="n">other</span><span class="p">,</span> <span class="bp">self</span><span class="p">)</span>
</span><span id="Tensor-370"><a href="#Tensor-370"><span class="linenos">370</span></a>    <span class="fm">__mul__</span> <span class="o">=</span> <span class="k">lambda</span> <span class="bp">self</span><span class="p">,</span> <span class="n">other</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">mul</span><span class="p">(</span><span class="n">other</span><span class="p">)</span>
</span><span id="Tensor-371"><a href="#Tensor-371"><span class="linenos">371</span></a>    <span class="fm">__rmul__</span> <span class="o">=</span> <span class="k">lambda</span> <span class="bp">self</span><span class="p">,</span> <span class="n">other</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">mul</span><span class="p">(</span><span class="n">other</span><span class="p">)</span>
</span><span id="Tensor-372"><a href="#Tensor-372"><span class="linenos">372</span></a>    <span class="n">__div__</span> <span class="o">=</span> <span class="k">lambda</span> <span class="bp">self</span><span class="p">,</span> <span class="n">other</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">div</span><span class="p">(</span><span class="n">other</span><span class="p">)</span>
</span><span id="Tensor-373"><a href="#Tensor-373"><span class="linenos">373</span></a>    <span class="n">__rdiv__</span> <span class="o">=</span> <span class="k">lambda</span> <span class="bp">self</span><span class="p">,</span> <span class="n">other</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">div</span><span class="o">.</span><span class="n">func</span><span class="p">(</span><span class="n">other</span><span class="p">,</span> <span class="bp">self</span><span class="p">)</span>
</span><span id="Tensor-374"><a href="#Tensor-374"><span class="linenos">374</span></a>    <span class="fm">__truediv__</span> <span class="o">=</span> <span class="n">__div__</span>
</span><span id="Tensor-375"><a href="#Tensor-375"><span class="linenos">375</span></a>    <span class="n">__truerdiv__</span> <span class="o">=</span> <span class="n">__rdiv__</span>
</span><span id="Tensor-376"><a href="#Tensor-376"><span class="linenos">376</span></a>    <span class="fm">__pow__</span> <span class="o">=</span> <span class="k">lambda</span> <span class="bp">self</span><span class="p">,</span> <span class="n">other</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">pow</span><span class="p">(</span><span class="n">other</span><span class="p">)</span>
</span><span id="Tensor-377"><a href="#Tensor-377"><span class="linenos">377</span></a>    <span class="fm">__rpow__</span> <span class="o">=</span> <span class="k">lambda</span> <span class="bp">self</span><span class="p">,</span> <span class="n">other</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">pow</span><span class="o">.</span><span class="n">func</span><span class="p">(</span><span class="n">other</span><span class="p">,</span> <span class="bp">self</span><span class="p">)</span>
</span><span id="Tensor-378"><a href="#Tensor-378"><span class="linenos">378</span></a>    <span class="fm">__matmul__</span> <span class="o">=</span> <span class="k">lambda</span> <span class="bp">self</span><span class="p">,</span> <span class="n">other</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">matmul</span><span class="p">(</span><span class="n">other</span><span class="p">)</span>
</span><span id="Tensor-379"><a href="#Tensor-379"><span class="linenos">379</span></a>    <span class="fm">__rmatmul__</span> <span class="o">=</span> <span class="k">lambda</span> <span class="bp">self</span><span class="p">,</span> <span class="n">other</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">matmul</span><span class="o">.</span><span class="n">func</span><span class="p">(</span><span class="n">other</span><span class="p">,</span> <span class="bp">self</span><span class="p">)</span>
</span><span id="Tensor-380"><a href="#Tensor-380"><span class="linenos">380</span></a>    <span class="fm">__invert__</span> <span class="o">=</span> <span class="k">lambda</span> <span class="bp">self</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">invert</span><span class="p">()</span>
</span><span id="Tensor-381"><a href="#Tensor-381"><span class="linenos">381</span></a>    <span class="fm">__eq__</span> <span class="o">=</span> <span class="k">lambda</span> <span class="bp">self</span><span class="p">,</span> <span class="n">other</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">equal</span><span class="p">(</span><span class="n">other</span><span class="p">)</span>
</span><span id="Tensor-382"><a href="#Tensor-382"><span class="linenos">382</span></a>    <span class="fm">__ne__</span> <span class="o">=</span> <span class="k">lambda</span> <span class="bp">self</span><span class="p">,</span> <span class="n">other</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">not_equal</span><span class="p">(</span><span class="n">other</span><span class="p">)</span>
</span><span id="Tensor-383"><a href="#Tensor-383"><span class="linenos">383</span></a>    <span class="fm">__ge__</span> <span class="o">=</span> <span class="k">lambda</span> <span class="bp">self</span><span class="p">,</span> <span class="n">other</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">greater_equal</span><span class="p">(</span><span class="n">other</span><span class="p">)</span>
</span><span id="Tensor-384"><a href="#Tensor-384"><span class="linenos">384</span></a>    <span class="fm">__le__</span> <span class="o">=</span> <span class="k">lambda</span> <span class="bp">self</span><span class="p">,</span> <span class="n">other</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">less_equal</span><span class="p">(</span><span class="n">other</span><span class="p">)</span>
</span><span id="Tensor-385"><a href="#Tensor-385"><span class="linenos">385</span></a>    <span class="fm">__gt__</span> <span class="o">=</span> <span class="k">lambda</span> <span class="bp">self</span><span class="p">,</span> <span class="n">other</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">greater</span><span class="p">(</span><span class="n">other</span><span class="p">)</span>
</span><span id="Tensor-386"><a href="#Tensor-386"><span class="linenos">386</span></a>    <span class="fm">__lt__</span> <span class="o">=</span> <span class="k">lambda</span> <span class="bp">self</span><span class="p">,</span> <span class="n">other</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">less</span><span class="p">(</span><span class="n">other</span><span class="p">)</span>
</span><span id="Tensor-387"><a href="#Tensor-387"><span class="linenos">387</span></a>
</span><span id="Tensor-388"><a href="#Tensor-388"><span class="linenos">388</span></a>    <span class="k">def</span> <span class="fm">__hash__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="Tensor-389"><a href="#Tensor-389"><span class="linenos">389</span></a>        <span class="k">return</span> <span class="nb">id</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">val</span><span class="p">)</span>
</span><span id="Tensor-390"><a href="#Tensor-390"><span class="linenos">390</span></a>
</span><span id="Tensor-391"><a href="#Tensor-391"><span class="linenos">391</span></a>    <span class="n">val</span> <span class="o">=</span> <span class="nb">property</span><span class="p">(</span><span class="k">lambda</span> <span class="bp">self</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">buf</span><span class="o">.</span><span class="n">val</span><span class="p">)</span>
</span><span id="Tensor-392"><a href="#Tensor-392"><span class="linenos">392</span></a>
</span><span id="Tensor-393"><a href="#Tensor-393"><span class="linenos">393</span></a>    <span class="k">def</span> <span class="nf">size</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">i</span><span class="p">):</span>
</span><span id="Tensor-394"><a href="#Tensor-394"><span class="linenos">394</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">shape</span><span class="p">[</span><span class="n">i</span><span class="p">]</span>
</span><span id="Tensor-395"><a href="#Tensor-395"><span class="linenos">395</span></a>
</span><span id="Tensor-396"><a href="#Tensor-396"><span class="linenos">396</span></a>    <span class="nd">@property</span>
</span><span id="Tensor-397"><a href="#Tensor-397"><span class="linenos">397</span></a>    <span class="k">def</span> <span class="nf">dtype</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="Tensor-398"><a href="#Tensor-398"><span class="linenos">398</span></a>        <span class="k">return</span> <span class="n">backend</span><span class="o">.</span><span class="n">dtype_of</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span>
</span><span id="Tensor-399"><a href="#Tensor-399"><span class="linenos">399</span></a>
</span><span id="Tensor-400"><a href="#Tensor-400"><span class="linenos">400</span></a>    <span class="nd">@property</span>
</span><span id="Tensor-401"><a href="#Tensor-401"><span class="linenos">401</span></a>    <span class="k">def</span> <span class="nf">device</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="Tensor-402"><a href="#Tensor-402"><span class="linenos">402</span></a>        <span class="k">return</span> <span class="n">backend</span><span class="o">.</span><span class="n">device_of</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span>
</span><span id="Tensor-403"><a href="#Tensor-403"><span class="linenos">403</span></a>
</span><span id="Tensor-404"><a href="#Tensor-404"><span class="linenos">404</span></a>    <span class="k">def</span> <span class="nf">numpy</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">memmap</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>
</span><span id="Tensor-405"><a href="#Tensor-405"><span class="linenos">405</span></a>        <span class="k">return</span> <span class="n">backend</span><span class="o">.</span><span class="n">numpy_of</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">memmap</span><span class="p">)</span>
</span><span id="Tensor-406"><a href="#Tensor-406"><span class="linenos">406</span></a>
</span><span id="Tensor-407"><a href="#Tensor-407"><span class="linenos">407</span></a>    <span class="nd">@property</span>
</span><span id="Tensor-408"><a href="#Tensor-408"><span class="linenos">408</span></a>    <span class="k">def</span> <span class="nf">shape</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="Tensor-409"><a href="#Tensor-409"><span class="linenos">409</span></a>        <span class="k">return</span> <span class="n">backend</span><span class="o">.</span><span class="n">shape_of</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span>
</span><span id="Tensor-410"><a href="#Tensor-410"><span class="linenos">410</span></a>
</span><span id="Tensor-411"><a href="#Tensor-411"><span class="linenos">411</span></a>    <span class="nd">@property</span>
</span><span id="Tensor-412"><a href="#Tensor-412"><span class="linenos">412</span></a>    <span class="k">def</span> <span class="nf">ndim</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="Tensor-413"><a href="#Tensor-413"><span class="linenos">413</span></a>        <span class="k">return</span> <span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span>
</span><span id="Tensor-414"><a href="#Tensor-414"><span class="linenos">414</span></a>
</span><span id="Tensor-415"><a href="#Tensor-415"><span class="linenos">415</span></a>    <span class="k">def</span> <span class="nf">numel</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="Tensor-416"><a href="#Tensor-416"><span class="linenos">416</span></a>        <span class="k">return</span> <span class="n">math</span><span class="o">.</span><span class="n">prod</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span>
</span><span id="Tensor-417"><a href="#Tensor-417"><span class="linenos">417</span></a>
</span><span id="Tensor-418"><a href="#Tensor-418"><span class="linenos">418</span></a>    <span class="k">def</span> <span class="nf">element_size</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="Tensor-419"><a href="#Tensor-419"><span class="linenos">419</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">dtype</span><span class="o">.</span><span class="n">itemsize</span>
</span><span id="Tensor-420"><a href="#Tensor-420"><span class="linenos">420</span></a>
</span><span id="Tensor-421"><a href="#Tensor-421"><span class="linenos">421</span></a>    <span class="k">def</span> <span class="nf">nbytes</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="Tensor-422"><a href="#Tensor-422"><span class="linenos">422</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">numel</span><span class="p">()</span> <span class="o">*</span> <span class="bp">self</span><span class="o">.</span><span class="n">element_size</span><span class="p">()</span>
</span><span id="Tensor-423"><a href="#Tensor-423"><span class="linenos">423</span></a>
</span><span id="Tensor-424"><a href="#Tensor-424"><span class="linenos">424</span></a>    <span class="k">def</span> <span class="fm">__repr__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="Tensor-425"><a href="#Tensor-425"><span class="linenos">425</span></a>        <span class="k">return</span> <span class="sa">f</span><span class="s2">&quot;&lt;Tensor: val=</span><span class="se">\n</span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">numpy</span><span class="p">()</span><span class="si">}</span><span class="se">\n</span><span class="s2">shape=</span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">shape</span><span class="si">}</span><span class="s2">, dtype=</span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">dtype</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">, device=</span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">device</span><span class="o">.</span><span class="n">format_code</span><span class="si">}</span><span class="s2">&gt;&quot;</span>
</span></pre></div>


    

                            <div id="Tensor.__init__" class="classattr">
                                        <input id="Tensor.__init__-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="name">Tensor</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">val</span><span class="p">:</span> <span class="n"><a href="#TensorBuffer">TensorBuffer</a></span></span>)</span>

                <label class="view-source-button" for="Tensor.__init__-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Tensor.__init__"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Tensor.__init__-300"><a href="#Tensor.__init__-300"><span class="linenos">300</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">val</span><span class="p">:</span> <span class="n">TensorBuffer</span><span class="p">):</span>
</span><span id="Tensor.__init__-301"><a href="#Tensor.__init__-301"><span class="linenos">301</span></a>        <span class="k">assert</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">val</span><span class="p">,</span> <span class="n">TensorBuffer</span><span class="p">)</span>
</span><span id="Tensor.__init__-302"><a href="#Tensor.__init__-302"><span class="linenos">302</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">buf</span> <span class="o">=</span> <span class="n">val</span>
</span></pre></div>


    

                            </div>
                            <div id="Tensor.buf" class="classattr">
                                <div class="attr variable">
            <span class="name">buf</span>

        
    </div>
    <a class="headerlink" href="#Tensor.buf"></a>
    
    

                            </div>
                            <div id="Tensor.symval" class="classattr">
                                        <input id="Tensor.symval-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr variable">
            <span class="name">symval</span>

                <label class="view-source-button" for="Tensor.symval-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Tensor.symval"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Tensor.symval-304"><a href="#Tensor.symval-304"><span class="linenos">304</span></a>    <span class="nd">@property</span>
</span><span id="Tensor.symval-305"><a href="#Tensor.symval-305"><span class="linenos">305</span></a>    <span class="k">def</span> <span class="nf">symval</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="Tensor.symval-306"><a href="#Tensor.symval-306"><span class="linenos">306</span></a>        <span class="k">return</span> <span class="n">SymbolicTensor</span><span class="o">.</span><span class="n">like</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span>
</span></pre></div>


    

                            </div>
                            <div id="Tensor.default_dtype" class="classattr">
                                        <input id="Tensor.default_dtype-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr variable">
            <span class="name">default_dtype</span>

                <label class="view-source-button" for="Tensor.default_dtype-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Tensor.default_dtype"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Tensor.default_dtype-308"><a href="#Tensor.default_dtype-308"><span class="linenos">308</span></a>    <span class="nd">@property</span>
</span><span id="Tensor.default_dtype-309"><a href="#Tensor.default_dtype-309"><span class="linenos">309</span></a>    <span class="k">def</span> <span class="nf">default_dtype</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="Tensor.default_dtype-310"><a href="#Tensor.default_dtype-310"><span class="linenos">310</span></a>        <span class="k">return</span> <span class="n">backend</span><span class="o">.</span><span class="n">default_dtype</span>
</span></pre></div>


    

                            </div>
                            <div id="Tensor.is_int" class="classattr">
                                        <input id="Tensor.is_int-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">is_int</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span></span><span class="return-annotation">) -> <span class="nb">bool</span>:</span></span>

                <label class="view-source-button" for="Tensor.is_int-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Tensor.is_int"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Tensor.is_int-312"><a href="#Tensor.is_int-312"><span class="linenos">312</span></a>    <span class="k">def</span> <span class="nf">is_int</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="nb">bool</span><span class="p">:</span>
</span><span id="Tensor.is_int-313"><a href="#Tensor.is_int-313"><span class="linenos">313</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">dtype</span> <span class="ow">in</span> <span class="p">(</span>
</span><span id="Tensor.is_int-314"><a href="#Tensor.is_int-314"><span class="linenos">314</span></a>            <span class="n">dtypes</span><span class="o">.</span><span class="n">int8</span><span class="p">,</span>
</span><span id="Tensor.is_int-315"><a href="#Tensor.is_int-315"><span class="linenos">315</span></a>            <span class="n">dtypes</span><span class="o">.</span><span class="n">uint8</span><span class="p">,</span>
</span><span id="Tensor.is_int-316"><a href="#Tensor.is_int-316"><span class="linenos">316</span></a>            <span class="n">dtypes</span><span class="o">.</span><span class="n">uint64</span><span class="p">,</span>
</span><span id="Tensor.is_int-317"><a href="#Tensor.is_int-317"><span class="linenos">317</span></a>            <span class="n">dtypes</span><span class="o">.</span><span class="n">int32</span><span class="p">,</span>
</span><span id="Tensor.is_int-318"><a href="#Tensor.is_int-318"><span class="linenos">318</span></a>            <span class="n">dtypes</span><span class="o">.</span><span class="n">int64</span><span class="p">,</span>
</span><span id="Tensor.is_int-319"><a href="#Tensor.is_int-319"><span class="linenos">319</span></a>        <span class="p">)</span>
</span></pre></div>


    

                            </div>
                            <div id="Tensor.is_float" class="classattr">
                                        <input id="Tensor.is_float-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">is_float</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span></span><span class="return-annotation">) -> <span class="nb">bool</span>:</span></span>

                <label class="view-source-button" for="Tensor.is_float-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Tensor.is_float"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Tensor.is_float-321"><a href="#Tensor.is_float-321"><span class="linenos">321</span></a>    <span class="k">def</span> <span class="nf">is_float</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="nb">bool</span><span class="p">:</span>
</span><span id="Tensor.is_float-322"><a href="#Tensor.is_float-322"><span class="linenos">322</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">dtype</span> <span class="ow">in</span> <span class="p">(</span><span class="n">dtypes</span><span class="o">.</span><span class="n">float16</span><span class="p">,</span> <span class="n">dtypes</span><span class="o">.</span><span class="n">float32</span><span class="p">)</span>
</span></pre></div>


    

                            </div>
                            <div id="Tensor.is_unsigned" class="classattr">
                                        <input id="Tensor.is_unsigned-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">is_unsigned</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span></span><span class="return-annotation">) -> <span class="nb">bool</span>:</span></span>

                <label class="view-source-button" for="Tensor.is_unsigned-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Tensor.is_unsigned"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Tensor.is_unsigned-324"><a href="#Tensor.is_unsigned-324"><span class="linenos">324</span></a>    <span class="k">def</span> <span class="nf">is_unsigned</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="nb">bool</span><span class="p">:</span>
</span><span id="Tensor.is_unsigned-325"><a href="#Tensor.is_unsigned-325"><span class="linenos">325</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">dtype</span> <span class="ow">is</span> <span class="n">dtypes</span><span class="o">.</span><span class="n">uint8</span>
</span></pre></div>


    

                            </div>
                            <div id="Tensor.to_bool" class="classattr">
                                        <input id="Tensor.to_bool-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">to_bool</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="Tensor.to_bool-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Tensor.to_bool"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Tensor.to_bool-327"><a href="#Tensor.to_bool-327"><span class="linenos">327</span></a>    <span class="k">def</span> <span class="nf">to_bool</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="Tensor.to_bool-328"><a href="#Tensor.to_bool-328"><span class="linenos">328</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">cast</span><span class="p">(</span><span class="n">dtypes</span><span class="o">.</span><span class="n">bool</span><span class="p">)</span>
</span></pre></div>


    

                            </div>
                            <div id="Tensor.short" class="classattr">
                                        <input id="Tensor.short-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">short</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="Tensor.short-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Tensor.short"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Tensor.short-330"><a href="#Tensor.short-330"><span class="linenos">330</span></a>    <span class="k">def</span> <span class="nf">short</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="Tensor.short-331"><a href="#Tensor.short-331"><span class="linenos">331</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">cast</span><span class="p">(</span><span class="n">dtypes</span><span class="o">.</span><span class="n">int8</span><span class="p">)</span>
</span></pre></div>


    

                            </div>
                            <div id="Tensor.int" class="classattr">
                                        <input id="Tensor.int-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">int</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="Tensor.int-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Tensor.int"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Tensor.int-333"><a href="#Tensor.int-333"><span class="linenos">333</span></a>    <span class="k">def</span> <span class="nf">int</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="Tensor.int-334"><a href="#Tensor.int-334"><span class="linenos">334</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">cast</span><span class="p">(</span><span class="n">dtypes</span><span class="o">.</span><span class="n">int32</span><span class="p">)</span>
</span></pre></div>


    

                            </div>
                            <div id="Tensor.long" class="classattr">
                                        <input id="Tensor.long-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">long</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="Tensor.long-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Tensor.long"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Tensor.long-336"><a href="#Tensor.long-336"><span class="linenos">336</span></a>    <span class="k">def</span> <span class="nf">long</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="Tensor.long-337"><a href="#Tensor.long-337"><span class="linenos">337</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">cast</span><span class="p">(</span><span class="n">dtypes</span><span class="o">.</span><span class="n">int64</span><span class="p">)</span>
</span></pre></div>


    

                            </div>
                            <div id="Tensor.half" class="classattr">
                                        <input id="Tensor.half-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">half</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="Tensor.half-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Tensor.half"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Tensor.half-339"><a href="#Tensor.half-339"><span class="linenos">339</span></a>    <span class="k">def</span> <span class="nf">half</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="Tensor.half-340"><a href="#Tensor.half-340"><span class="linenos">340</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">cast</span><span class="p">(</span><span class="n">dtypes</span><span class="o">.</span><span class="n">float16</span><span class="p">)</span>
</span></pre></div>


    

                            </div>
                            <div id="Tensor.float" class="classattr">
                                        <input id="Tensor.float-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">float</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="Tensor.float-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Tensor.float"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Tensor.float-342"><a href="#Tensor.float-342"><span class="linenos">342</span></a>    <span class="k">def</span> <span class="nf">float</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="Tensor.float-343"><a href="#Tensor.float-343"><span class="linenos">343</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">cast</span><span class="p">(</span><span class="n">dtypes</span><span class="o">.</span><span class="n">float32</span><span class="p">)</span>
</span></pre></div>


    

                            </div>
                            <div id="Tensor.str_short" class="classattr">
                                        <input id="Tensor.str_short-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">str_short</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="Tensor.str_short-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Tensor.str_short"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Tensor.str_short-362"><a href="#Tensor.str_short-362"><span class="linenos">362</span></a>    <span class="k">def</span> <span class="nf">str_short</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="Tensor.str_short-363"><a href="#Tensor.str_short-363"><span class="linenos">363</span></a>        <span class="k">return</span> <span class="sa">f</span><span class="s2">&quot;&lt;Tensor: shape=</span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">shape</span><span class="si">}</span><span class="s2">, dtype=</span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">dtype</span><span class="si">}</span><span class="s2">&gt;&quot;</span>
</span></pre></div>


    

                            </div>
                            <div id="Tensor.val" class="classattr">
                                        <input id="Tensor.val-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr variable">
            <span class="name">val</span>

                <label class="view-source-button" for="Tensor.val-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Tensor.val"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Tensor.val-391"><a href="#Tensor.val-391"><span class="linenos">391</span></a>    <span class="n">val</span> <span class="o">=</span> <span class="nb">property</span><span class="p">(</span><span class="k">lambda</span> <span class="bp">self</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">buf</span><span class="o">.</span><span class="n">val</span><span class="p">)</span>
</span></pre></div>


    

                            </div>
                            <div id="Tensor.size" class="classattr">
                                        <input id="Tensor.size-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">size</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="n">i</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="Tensor.size-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Tensor.size"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Tensor.size-393"><a href="#Tensor.size-393"><span class="linenos">393</span></a>    <span class="k">def</span> <span class="nf">size</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">i</span><span class="p">):</span>
</span><span id="Tensor.size-394"><a href="#Tensor.size-394"><span class="linenos">394</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">shape</span><span class="p">[</span><span class="n">i</span><span class="p">]</span>
</span></pre></div>


    

                            </div>
                            <div id="Tensor.dtype" class="classattr">
                                        <input id="Tensor.dtype-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr variable">
            <span class="name">dtype</span>

                <label class="view-source-button" for="Tensor.dtype-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Tensor.dtype"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Tensor.dtype-396"><a href="#Tensor.dtype-396"><span class="linenos">396</span></a>    <span class="nd">@property</span>
</span><span id="Tensor.dtype-397"><a href="#Tensor.dtype-397"><span class="linenos">397</span></a>    <span class="k">def</span> <span class="nf">dtype</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="Tensor.dtype-398"><a href="#Tensor.dtype-398"><span class="linenos">398</span></a>        <span class="k">return</span> <span class="n">backend</span><span class="o">.</span><span class="n">dtype_of</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span>
</span></pre></div>


    

                            </div>
                            <div id="Tensor.device" class="classattr">
                                        <input id="Tensor.device-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr variable">
            <span class="name">device</span>

                <label class="view-source-button" for="Tensor.device-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Tensor.device"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Tensor.device-400"><a href="#Tensor.device-400"><span class="linenos">400</span></a>    <span class="nd">@property</span>
</span><span id="Tensor.device-401"><a href="#Tensor.device-401"><span class="linenos">401</span></a>    <span class="k">def</span> <span class="nf">device</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="Tensor.device-402"><a href="#Tensor.device-402"><span class="linenos">402</span></a>        <span class="k">return</span> <span class="n">backend</span><span class="o">.</span><span class="n">device_of</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span>
</span></pre></div>


    

                            </div>
                            <div id="Tensor.numpy" class="classattr">
                                        <input id="Tensor.numpy-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">numpy</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="n">memmap</span><span class="o">=</span><span class="kc">False</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="Tensor.numpy-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Tensor.numpy"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Tensor.numpy-404"><a href="#Tensor.numpy-404"><span class="linenos">404</span></a>    <span class="k">def</span> <span class="nf">numpy</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">memmap</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>
</span><span id="Tensor.numpy-405"><a href="#Tensor.numpy-405"><span class="linenos">405</span></a>        <span class="k">return</span> <span class="n">backend</span><span class="o">.</span><span class="n">numpy_of</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">memmap</span><span class="p">)</span>
</span></pre></div>


    

                            </div>
                            <div id="Tensor.shape" class="classattr">
                                        <input id="Tensor.shape-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr variable">
            <span class="name">shape</span>

                <label class="view-source-button" for="Tensor.shape-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Tensor.shape"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Tensor.shape-407"><a href="#Tensor.shape-407"><span class="linenos">407</span></a>    <span class="nd">@property</span>
</span><span id="Tensor.shape-408"><a href="#Tensor.shape-408"><span class="linenos">408</span></a>    <span class="k">def</span> <span class="nf">shape</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="Tensor.shape-409"><a href="#Tensor.shape-409"><span class="linenos">409</span></a>        <span class="k">return</span> <span class="n">backend</span><span class="o">.</span><span class="n">shape_of</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span>
</span></pre></div>


    

                            </div>
                            <div id="Tensor.ndim" class="classattr">
                                        <input id="Tensor.ndim-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr variable">
            <span class="name">ndim</span>

                <label class="view-source-button" for="Tensor.ndim-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Tensor.ndim"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Tensor.ndim-411"><a href="#Tensor.ndim-411"><span class="linenos">411</span></a>    <span class="nd">@property</span>
</span><span id="Tensor.ndim-412"><a href="#Tensor.ndim-412"><span class="linenos">412</span></a>    <span class="k">def</span> <span class="nf">ndim</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="Tensor.ndim-413"><a href="#Tensor.ndim-413"><span class="linenos">413</span></a>        <span class="k">return</span> <span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span>
</span></pre></div>


    

                            </div>
                            <div id="Tensor.numel" class="classattr">
                                        <input id="Tensor.numel-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">numel</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="Tensor.numel-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Tensor.numel"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Tensor.numel-415"><a href="#Tensor.numel-415"><span class="linenos">415</span></a>    <span class="k">def</span> <span class="nf">numel</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="Tensor.numel-416"><a href="#Tensor.numel-416"><span class="linenos">416</span></a>        <span class="k">return</span> <span class="n">math</span><span class="o">.</span><span class="n">prod</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span>
</span></pre></div>


    

                            </div>
                            <div id="Tensor.element_size" class="classattr">
                                        <input id="Tensor.element_size-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">element_size</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="Tensor.element_size-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Tensor.element_size"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Tensor.element_size-418"><a href="#Tensor.element_size-418"><span class="linenos">418</span></a>    <span class="k">def</span> <span class="nf">element_size</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="Tensor.element_size-419"><a href="#Tensor.element_size-419"><span class="linenos">419</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">dtype</span><span class="o">.</span><span class="n">itemsize</span>
</span></pre></div>


    

                            </div>
                            <div id="Tensor.nbytes" class="classattr">
                                        <input id="Tensor.nbytes-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">nbytes</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="Tensor.nbytes-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Tensor.nbytes"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Tensor.nbytes-421"><a href="#Tensor.nbytes-421"><span class="linenos">421</span></a>    <span class="k">def</span> <span class="nf">nbytes</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="Tensor.nbytes-422"><a href="#Tensor.nbytes-422"><span class="linenos">422</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">numel</span><span class="p">()</span> <span class="o">*</span> <span class="bp">self</span><span class="o">.</span><span class="n">element_size</span><span class="p">()</span>
</span></pre></div>


    

                            </div>
                </section>
                <section id="SymbolicTensor">
                            <input id="SymbolicTensor-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr class">
            
    <span class="def">class</span>
    <span class="name">SymbolicTensor</span><wbr>(<span class="base"><a href="#Tensor">Tensor</a></span>):

                <label class="view-source-button" for="SymbolicTensor-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#SymbolicTensor"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="SymbolicTensor-428"><a href="#SymbolicTensor-428"><span class="linenos">428</span></a><span class="k">class</span> <span class="nc">SymbolicTensor</span><span class="p">(</span><span class="n">Tensor</span><span class="p">):</span>
</span><span id="SymbolicTensor-429"><a href="#SymbolicTensor-429"><span class="linenos">429</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">shape</span><span class="p">,</span> <span class="n">dtype</span><span class="p">,</span> <span class="n">device</span><span class="p">):</span>
</span><span id="SymbolicTensor-430"><a href="#SymbolicTensor-430"><span class="linenos">430</span></a>        <span class="k">assert</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">dtype</span><span class="p">,</span> <span class="n">DType</span><span class="p">)</span>
</span><span id="SymbolicTensor-431"><a href="#SymbolicTensor-431"><span class="linenos">431</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">_shape</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="nb">int</span><span class="p">(</span><span class="n">i</span><span class="p">)</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="n">shape</span><span class="p">)</span>
</span><span id="SymbolicTensor-432"><a href="#SymbolicTensor-432"><span class="linenos">432</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">_dtype</span> <span class="o">=</span> <span class="n">dtype</span>
</span><span id="SymbolicTensor-433"><a href="#SymbolicTensor-433"><span class="linenos">433</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">_device</span> <span class="o">=</span> <span class="n">device</span>
</span><span id="SymbolicTensor-434"><a href="#SymbolicTensor-434"><span class="linenos">434</span></a>
</span><span id="SymbolicTensor-435"><a href="#SymbolicTensor-435"><span class="linenos">435</span></a>    <span class="nd">@property</span>
</span><span id="SymbolicTensor-436"><a href="#SymbolicTensor-436"><span class="linenos">436</span></a>    <span class="k">def</span> <span class="nf">symval</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="SymbolicTensor-437"><a href="#SymbolicTensor-437"><span class="linenos">437</span></a>        <span class="k">return</span> <span class="bp">self</span>
</span><span id="SymbolicTensor-438"><a href="#SymbolicTensor-438"><span class="linenos">438</span></a>
</span><span id="SymbolicTensor-439"><a href="#SymbolicTensor-439"><span class="linenos">439</span></a>    <span class="nd">@property</span>
</span><span id="SymbolicTensor-440"><a href="#SymbolicTensor-440"><span class="linenos">440</span></a>    <span class="k">def</span> <span class="nf">val</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="SymbolicTensor-441"><a href="#SymbolicTensor-441"><span class="linenos">441</span></a>        <span class="k">raise</span> <span class="ne">RuntimeError</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;SymbolicTensor actually has no val, from </span><span class="si">{</span><span class="n">trace_stack</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span><span class="si">=}</span><span class="s2">, &quot;</span><span class="p">)</span>
</span><span id="SymbolicTensor-442"><a href="#SymbolicTensor-442"><span class="linenos">442</span></a>
</span><span id="SymbolicTensor-443"><a href="#SymbolicTensor-443"><span class="linenos">443</span></a>    <span class="nd">@property</span>
</span><span id="SymbolicTensor-444"><a href="#SymbolicTensor-444"><span class="linenos">444</span></a>    <span class="k">def</span> <span class="nf">shape</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="SymbolicTensor-445"><a href="#SymbolicTensor-445"><span class="linenos">445</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">_shape</span>
</span><span id="SymbolicTensor-446"><a href="#SymbolicTensor-446"><span class="linenos">446</span></a>
</span><span id="SymbolicTensor-447"><a href="#SymbolicTensor-447"><span class="linenos">447</span></a>    <span class="nd">@property</span>
</span><span id="SymbolicTensor-448"><a href="#SymbolicTensor-448"><span class="linenos">448</span></a>    <span class="k">def</span> <span class="nf">dtype</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="SymbolicTensor-449"><a href="#SymbolicTensor-449"><span class="linenos">449</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">_dtype</span>
</span><span id="SymbolicTensor-450"><a href="#SymbolicTensor-450"><span class="linenos">450</span></a>
</span><span id="SymbolicTensor-451"><a href="#SymbolicTensor-451"><span class="linenos">451</span></a>    <span class="nd">@property</span>
</span><span id="SymbolicTensor-452"><a href="#SymbolicTensor-452"><span class="linenos">452</span></a>    <span class="k">def</span> <span class="nf">device</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="SymbolicTensor-453"><a href="#SymbolicTensor-453"><span class="linenos">453</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">_device</span>
</span><span id="SymbolicTensor-454"><a href="#SymbolicTensor-454"><span class="linenos">454</span></a>
</span><span id="SymbolicTensor-455"><a href="#SymbolicTensor-455"><span class="linenos">455</span></a>    <span class="k">def</span> <span class="nf">like</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">**</span><span class="n">but</span><span class="p">):</span>
</span><span id="SymbolicTensor-456"><a href="#SymbolicTensor-456"><span class="linenos">456</span></a>        <span class="n">shape</span> <span class="o">=</span> <span class="n">but</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;shape&quot;</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span>
</span><span id="SymbolicTensor-457"><a href="#SymbolicTensor-457"><span class="linenos">457</span></a>        <span class="n">dtype</span> <span class="o">=</span> <span class="n">but</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;dtype&quot;</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">dtype</span><span class="p">)</span>
</span><span id="SymbolicTensor-458"><a href="#SymbolicTensor-458"><span class="linenos">458</span></a>        <span class="n">device</span> <span class="o">=</span> <span class="n">but</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;device&quot;</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">device</span><span class="p">)</span>
</span><span id="SymbolicTensor-459"><a href="#SymbolicTensor-459"><span class="linenos">459</span></a>        <span class="k">return</span> <span class="n">SymbolicTensor</span><span class="p">(</span><span class="n">shape</span><span class="p">,</span> <span class="n">dtype</span><span class="p">,</span> <span class="n">device</span><span class="p">)</span>
</span><span id="SymbolicTensor-460"><a href="#SymbolicTensor-460"><span class="linenos">460</span></a>
</span><span id="SymbolicTensor-461"><a href="#SymbolicTensor-461"><span class="linenos">461</span></a>    <span class="k">def</span> <span class="nf">str_short</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="SymbolicTensor-462"><a href="#SymbolicTensor-462"><span class="linenos">462</span></a>        <span class="k">return</span> <span class="sa">f</span><span class="s1">&#39;</span><span class="si">{</span><span class="nb">str</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">dtype</span><span class="p">)</span><span class="si">}</span><span class="s1">[</span><span class="si">{</span><span class="s2">&quot;,&quot;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="nb">str</span><span class="p">(</span><span class="n">d</span><span class="p">)</span><span class="w"> </span><span class="k">for</span><span class="w"> </span><span class="n">d</span><span class="w"> </span><span class="ow">in</span><span class="w"> </span><span class="bp">self</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span><span class="si">}</span><span class="s1">]&#39;</span>
</span><span id="SymbolicTensor-463"><a href="#SymbolicTensor-463"><span class="linenos">463</span></a>
</span><span id="SymbolicTensor-464"><a href="#SymbolicTensor-464"><span class="linenos">464</span></a>    <span class="k">def</span> <span class="fm">__hash__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="SymbolicTensor-465"><a href="#SymbolicTensor-465"><span class="linenos">465</span></a>        <span class="k">return</span> <span class="nb">hash</span><span class="p">((</span><span class="bp">self</span><span class="o">.</span><span class="n">shape</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">dtype</span><span class="p">))</span>
</span><span id="SymbolicTensor-466"><a href="#SymbolicTensor-466"><span class="linenos">466</span></a>
</span><span id="SymbolicTensor-467"><a href="#SymbolicTensor-467"><span class="linenos">467</span></a>    <span class="k">def</span> <span class="fm">__eq__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">other</span><span class="p">):</span>
</span><span id="SymbolicTensor-468"><a href="#SymbolicTensor-468"><span class="linenos">468</span></a>        <span class="k">if</span> <span class="nb">type</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span> <span class="o">!=</span> <span class="nb">type</span><span class="p">(</span><span class="n">other</span><span class="p">):</span>
</span><span id="SymbolicTensor-469"><a href="#SymbolicTensor-469"><span class="linenos">469</span></a>            <span class="k">return</span> <span class="kc">False</span>
</span><span id="SymbolicTensor-470"><a href="#SymbolicTensor-470"><span class="linenos">470</span></a>        <span class="k">return</span> <span class="nb">tuple</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span> <span class="o">==</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">other</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span> <span class="ow">and</span> <span class="bp">self</span><span class="o">.</span><span class="n">dtype</span> <span class="o">==</span> <span class="n">other</span><span class="o">.</span><span class="n">dtype</span>
</span><span id="SymbolicTensor-471"><a href="#SymbolicTensor-471"><span class="linenos">471</span></a>
</span><span id="SymbolicTensor-472"><a href="#SymbolicTensor-472"><span class="linenos">472</span></a>    <span class="k">def</span> <span class="fm">__repr__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="SymbolicTensor-473"><a href="#SymbolicTensor-473"><span class="linenos">473</span></a>        <span class="k">return</span> <span class="sa">f</span><span class="s2">&quot;&lt;SymbolicTensor: shape=</span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">shape</span><span class="si">}</span><span class="s2">, dtype=</span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">dtype</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">, device=</span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">device</span><span class="si">}</span><span class="s2">&gt;&quot;</span>
</span></pre></div>


    

                            <div id="SymbolicTensor.__init__" class="classattr">
                                        <input id="SymbolicTensor.__init__-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="name">SymbolicTensor</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">shape</span>, </span><span class="param"><span class="n">dtype</span>, </span><span class="param"><span class="n">device</span></span>)</span>

                <label class="view-source-button" for="SymbolicTensor.__init__-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#SymbolicTensor.__init__"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="SymbolicTensor.__init__-429"><a href="#SymbolicTensor.__init__-429"><span class="linenos">429</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">shape</span><span class="p">,</span> <span class="n">dtype</span><span class="p">,</span> <span class="n">device</span><span class="p">):</span>
</span><span id="SymbolicTensor.__init__-430"><a href="#SymbolicTensor.__init__-430"><span class="linenos">430</span></a>        <span class="k">assert</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">dtype</span><span class="p">,</span> <span class="n">DType</span><span class="p">)</span>
</span><span id="SymbolicTensor.__init__-431"><a href="#SymbolicTensor.__init__-431"><span class="linenos">431</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">_shape</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="nb">int</span><span class="p">(</span><span class="n">i</span><span class="p">)</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="n">shape</span><span class="p">)</span>
</span><span id="SymbolicTensor.__init__-432"><a href="#SymbolicTensor.__init__-432"><span class="linenos">432</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">_dtype</span> <span class="o">=</span> <span class="n">dtype</span>
</span><span id="SymbolicTensor.__init__-433"><a href="#SymbolicTensor.__init__-433"><span class="linenos">433</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">_device</span> <span class="o">=</span> <span class="n">device</span>
</span></pre></div>


    

                            </div>
                            <div id="SymbolicTensor.symval" class="classattr">
                                        <input id="SymbolicTensor.symval-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr variable">
            <span class="name">symval</span>

                <label class="view-source-button" for="SymbolicTensor.symval-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#SymbolicTensor.symval"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="SymbolicTensor.symval-435"><a href="#SymbolicTensor.symval-435"><span class="linenos">435</span></a>    <span class="nd">@property</span>
</span><span id="SymbolicTensor.symval-436"><a href="#SymbolicTensor.symval-436"><span class="linenos">436</span></a>    <span class="k">def</span> <span class="nf">symval</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="SymbolicTensor.symval-437"><a href="#SymbolicTensor.symval-437"><span class="linenos">437</span></a>        <span class="k">return</span> <span class="bp">self</span>
</span></pre></div>


    

                            </div>
                            <div id="SymbolicTensor.val" class="classattr">
                                        <input id="SymbolicTensor.val-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr variable">
            <span class="name">val</span>

                <label class="view-source-button" for="SymbolicTensor.val-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#SymbolicTensor.val"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="SymbolicTensor.val-439"><a href="#SymbolicTensor.val-439"><span class="linenos">439</span></a>    <span class="nd">@property</span>
</span><span id="SymbolicTensor.val-440"><a href="#SymbolicTensor.val-440"><span class="linenos">440</span></a>    <span class="k">def</span> <span class="nf">val</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="SymbolicTensor.val-441"><a href="#SymbolicTensor.val-441"><span class="linenos">441</span></a>        <span class="k">raise</span> <span class="ne">RuntimeError</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;SymbolicTensor actually has no val, from </span><span class="si">{</span><span class="n">trace_stack</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span><span class="si">=}</span><span class="s2">, &quot;</span><span class="p">)</span>
</span></pre></div>


    

                            </div>
                            <div id="SymbolicTensor.shape" class="classattr">
                                        <input id="SymbolicTensor.shape-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr variable">
            <span class="name">shape</span>

                <label class="view-source-button" for="SymbolicTensor.shape-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#SymbolicTensor.shape"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="SymbolicTensor.shape-443"><a href="#SymbolicTensor.shape-443"><span class="linenos">443</span></a>    <span class="nd">@property</span>
</span><span id="SymbolicTensor.shape-444"><a href="#SymbolicTensor.shape-444"><span class="linenos">444</span></a>    <span class="k">def</span> <span class="nf">shape</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="SymbolicTensor.shape-445"><a href="#SymbolicTensor.shape-445"><span class="linenos">445</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">_shape</span>
</span></pre></div>


    

                            </div>
                            <div id="SymbolicTensor.dtype" class="classattr">
                                        <input id="SymbolicTensor.dtype-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr variable">
            <span class="name">dtype</span>

                <label class="view-source-button" for="SymbolicTensor.dtype-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#SymbolicTensor.dtype"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="SymbolicTensor.dtype-447"><a href="#SymbolicTensor.dtype-447"><span class="linenos">447</span></a>    <span class="nd">@property</span>
</span><span id="SymbolicTensor.dtype-448"><a href="#SymbolicTensor.dtype-448"><span class="linenos">448</span></a>    <span class="k">def</span> <span class="nf">dtype</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="SymbolicTensor.dtype-449"><a href="#SymbolicTensor.dtype-449"><span class="linenos">449</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">_dtype</span>
</span></pre></div>


    

                            </div>
                            <div id="SymbolicTensor.device" class="classattr">
                                        <input id="SymbolicTensor.device-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr variable">
            <span class="name">device</span>

                <label class="view-source-button" for="SymbolicTensor.device-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#SymbolicTensor.device"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="SymbolicTensor.device-451"><a href="#SymbolicTensor.device-451"><span class="linenos">451</span></a>    <span class="nd">@property</span>
</span><span id="SymbolicTensor.device-452"><a href="#SymbolicTensor.device-452"><span class="linenos">452</span></a>    <span class="k">def</span> <span class="nf">device</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="SymbolicTensor.device-453"><a href="#SymbolicTensor.device-453"><span class="linenos">453</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">_device</span>
</span></pre></div>


    

                            </div>
                            <div id="SymbolicTensor.like" class="classattr">
                                        <input id="SymbolicTensor.like-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">like</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="o">**</span><span class="n">but</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="SymbolicTensor.like-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#SymbolicTensor.like"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="SymbolicTensor.like-455"><a href="#SymbolicTensor.like-455"><span class="linenos">455</span></a>    <span class="k">def</span> <span class="nf">like</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">**</span><span class="n">but</span><span class="p">):</span>
</span><span id="SymbolicTensor.like-456"><a href="#SymbolicTensor.like-456"><span class="linenos">456</span></a>        <span class="n">shape</span> <span class="o">=</span> <span class="n">but</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;shape&quot;</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span>
</span><span id="SymbolicTensor.like-457"><a href="#SymbolicTensor.like-457"><span class="linenos">457</span></a>        <span class="n">dtype</span> <span class="o">=</span> <span class="n">but</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;dtype&quot;</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">dtype</span><span class="p">)</span>
</span><span id="SymbolicTensor.like-458"><a href="#SymbolicTensor.like-458"><span class="linenos">458</span></a>        <span class="n">device</span> <span class="o">=</span> <span class="n">but</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;device&quot;</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">device</span><span class="p">)</span>
</span><span id="SymbolicTensor.like-459"><a href="#SymbolicTensor.like-459"><span class="linenos">459</span></a>        <span class="k">return</span> <span class="n">SymbolicTensor</span><span class="p">(</span><span class="n">shape</span><span class="p">,</span> <span class="n">dtype</span><span class="p">,</span> <span class="n">device</span><span class="p">)</span>
</span></pre></div>


    

                            </div>
                            <div id="SymbolicTensor.str_short" class="classattr">
                                        <input id="SymbolicTensor.str_short-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">str_short</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="SymbolicTensor.str_short-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#SymbolicTensor.str_short"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="SymbolicTensor.str_short-461"><a href="#SymbolicTensor.str_short-461"><span class="linenos">461</span></a>    <span class="k">def</span> <span class="nf">str_short</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="SymbolicTensor.str_short-462"><a href="#SymbolicTensor.str_short-462"><span class="linenos">462</span></a>        <span class="k">return</span> <span class="sa">f</span><span class="s1">&#39;</span><span class="si">{</span><span class="nb">str</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">dtype</span><span class="p">)</span><span class="si">}</span><span class="s1">[</span><span class="si">{</span><span class="s2">&quot;,&quot;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="nb">str</span><span class="p">(</span><span class="n">d</span><span class="p">)</span><span class="w"> </span><span class="k">for</span><span class="w"> </span><span class="n">d</span><span class="w"> </span><span class="ow">in</span><span class="w"> </span><span class="bp">self</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span><span class="si">}</span><span class="s1">]&#39;</span>
</span></pre></div>


    

                            </div>
                            <div class="inherited">
                                <h5>Inherited Members</h5>
                                <dl>
                                    <div><dt><a href="#Tensor">Tensor</a></dt>
                                <dd id="SymbolicTensor.buf" class="variable"><a href="#Tensor.buf">buf</a></dd>
                <dd id="SymbolicTensor.default_dtype" class="variable"><a href="#Tensor.default_dtype">default_dtype</a></dd>
                <dd id="SymbolicTensor.is_int" class="function"><a href="#Tensor.is_int">is_int</a></dd>
                <dd id="SymbolicTensor.is_float" class="function"><a href="#Tensor.is_float">is_float</a></dd>
                <dd id="SymbolicTensor.is_unsigned" class="function"><a href="#Tensor.is_unsigned">is_unsigned</a></dd>
                <dd id="SymbolicTensor.to_bool" class="function"><a href="#Tensor.to_bool">to_bool</a></dd>
                <dd id="SymbolicTensor.short" class="function"><a href="#Tensor.short">short</a></dd>
                <dd id="SymbolicTensor.int" class="function"><a href="#Tensor.int">int</a></dd>
                <dd id="SymbolicTensor.long" class="function"><a href="#Tensor.long">long</a></dd>
                <dd id="SymbolicTensor.half" class="function"><a href="#Tensor.half">half</a></dd>
                <dd id="SymbolicTensor.float" class="function"><a href="#Tensor.float">float</a></dd>
                <dd id="SymbolicTensor.size" class="function"><a href="#Tensor.size">size</a></dd>
                <dd id="SymbolicTensor.numpy" class="function"><a href="#Tensor.numpy">numpy</a></dd>
                <dd id="SymbolicTensor.ndim" class="variable"><a href="#Tensor.ndim">ndim</a></dd>
                <dd id="SymbolicTensor.numel" class="function"><a href="#Tensor.numel">numel</a></dd>
                <dd id="SymbolicTensor.element_size" class="function"><a href="#Tensor.element_size">element_size</a></dd>
                <dd id="SymbolicTensor.nbytes" class="function"><a href="#Tensor.nbytes">nbytes</a></dd>

            </div>
                                </dl>
                            </div>
                </section>
                <section id="Operator">
                            <input id="Operator-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr class">
            
    <span class="def">class</span>
    <span class="name">Operator</span>:

                <label class="view-source-button" for="Operator-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Operator"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Operator-481"><a href="#Operator-481"><span class="linenos">481</span></a><span class="k">class</span> <span class="nc">Operator</span><span class="p">:</span>
</span><span id="Operator-482"><a href="#Operator-482"><span class="linenos">482</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">name</span><span class="p">,</span> <span class="n">variadic_inputs</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">nary_outputs</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>
</span><span id="Operator-483"><a href="#Operator-483"><span class="linenos">483</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">name</span> <span class="o">=</span> <span class="n">name</span>
</span><span id="Operator-484"><a href="#Operator-484"><span class="linenos">484</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">variadic_inputs</span> <span class="o">=</span> <span class="n">variadic_inputs</span>
</span><span id="Operator-485"><a href="#Operator-485"><span class="linenos">485</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">nary_outputs</span> <span class="o">=</span> <span class="n">nary_outputs</span>
</span><span id="Operator-486"><a href="#Operator-486"><span class="linenos">486</span></a>        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">variadic_inputs</span><span class="p">:</span>
</span><span id="Operator-487"><a href="#Operator-487"><span class="linenos">487</span></a>            <span class="bp">self</span><span class="o">.</span><span class="n">reorg_args</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">reorg_args_nary</span>
</span><span id="Operator-488"><a href="#Operator-488"><span class="linenos">488</span></a>
</span><span id="Operator-489"><a href="#Operator-489"><span class="linenos">489</span></a>    <span class="k">def</span> <span class="fm">__hash__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="Operator-490"><a href="#Operator-490"><span class="linenos">490</span></a>        <span class="k">return</span> <span class="nb">hash</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">name</span><span class="p">)</span>
</span><span id="Operator-491"><a href="#Operator-491"><span class="linenos">491</span></a>
</span><span id="Operator-492"><a href="#Operator-492"><span class="linenos">492</span></a>    <span class="k">def</span> <span class="fm">__eq__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">other</span><span class="p">):</span>
</span><span id="Operator-493"><a href="#Operator-493"><span class="linenos">493</span></a>        <span class="k">if</span> <span class="ow">not</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">other</span><span class="p">,</span> <span class="n">Operator</span><span class="p">):</span>
</span><span id="Operator-494"><a href="#Operator-494"><span class="linenos">494</span></a>            <span class="k">return</span> <span class="kc">False</span>
</span><span id="Operator-495"><a href="#Operator-495"><span class="linenos">495</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">name</span> <span class="o">==</span> <span class="n">other</span><span class="o">.</span><span class="n">name</span>
</span><span id="Operator-496"><a href="#Operator-496"><span class="linenos">496</span></a>
</span><span id="Operator-497"><a href="#Operator-497"><span class="linenos">497</span></a>    <span class="k">def</span> <span class="nf">args_fixer</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="Operator-498"><a href="#Operator-498"><span class="linenos">498</span></a>        <span class="k">return</span> <span class="n">args</span><span class="p">,</span> <span class="n">params</span>
</span><span id="Operator-499"><a href="#Operator-499"><span class="linenos">499</span></a>
</span><span id="Operator-500"><a href="#Operator-500"><span class="linenos">500</span></a>    <span class="k">def</span> <span class="fm">__call__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="Operator-501"><a href="#Operator-501"><span class="linenos">501</span></a>        <span class="n">args</span><span class="p">,</span> <span class="n">params</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">reorg_args</span><span class="p">(</span><span class="n">args</span><span class="p">,</span> <span class="n">params</span><span class="p">)</span>
</span><span id="Operator-502"><a href="#Operator-502"><span class="linenos">502</span></a>        <span class="n">args</span><span class="p">,</span> <span class="n">params</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">args_fixer</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)</span>
</span><span id="Operator-503"><a href="#Operator-503"><span class="linenos">503</span></a>        <span class="n">ret</span> <span class="o">=</span> <span class="n">bind</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)</span>
</span><span id="Operator-504"><a href="#Operator-504"><span class="linenos">504</span></a>        <span class="k">if</span> <span class="ow">not</span> <span class="bp">self</span><span class="o">.</span><span class="n">nary_outputs</span><span class="p">:</span>
</span><span id="Operator-505"><a href="#Operator-505"><span class="linenos">505</span></a>            <span class="n">ret</span> <span class="o">=</span> <span class="n">ret</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span>
</span><span id="Operator-506"><a href="#Operator-506"><span class="linenos">506</span></a>        <span class="k">return</span> <span class="n">ret</span>
</span><span id="Operator-507"><a href="#Operator-507"><span class="linenos">507</span></a>
</span><span id="Operator-508"><a href="#Operator-508"><span class="linenos">508</span></a>    <span class="k">def</span> <span class="fm">__repr__</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="nb">str</span><span class="p">:</span>
</span><span id="Operator-509"><a href="#Operator-509"><span class="linenos">509</span></a>        <span class="k">return</span> <span class="sa">f</span><span class="s2">&quot;&lt;</span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">&gt;&quot;</span>
</span><span id="Operator-510"><a href="#Operator-510"><span class="linenos">510</span></a>
</span><span id="Operator-511"><a href="#Operator-511"><span class="linenos">511</span></a>    <span class="k">def</span> <span class="nf">typecheck</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="Operator-512"><a href="#Operator-512"><span class="linenos">512</span></a>        <span class="k">raise</span> <span class="ne">NotImplementedError</span>
</span><span id="Operator-513"><a href="#Operator-513"><span class="linenos">513</span></a>
</span><span id="Operator-514"><a href="#Operator-514"><span class="linenos">514</span></a>    <span class="k">def</span> <span class="nf">jvp</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="Operator-515"><a href="#Operator-515"><span class="linenos">515</span></a>        <span class="k">raise</span> <span class="ne">NotImplementedError</span>
</span><span id="Operator-516"><a href="#Operator-516"><span class="linenos">516</span></a>
</span><span id="Operator-517"><a href="#Operator-517"><span class="linenos">517</span></a>    <span class="k">def</span> <span class="nf">T</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="Operator-518"><a href="#Operator-518"><span class="linenos">518</span></a>        <span class="k">raise</span> <span class="ne">NotImplementedError</span>
</span><span id="Operator-519"><a href="#Operator-519"><span class="linenos">519</span></a>
</span><span id="Operator-520"><a href="#Operator-520"><span class="linenos">520</span></a>    <span class="k">def</span> <span class="nf">vmap</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="Operator-521"><a href="#Operator-521"><span class="linenos">521</span></a>        <span class="k">raise</span> <span class="ne">NotImplementedError</span>
</span><span id="Operator-522"><a href="#Operator-522"><span class="linenos">522</span></a>
</span><span id="Operator-523"><a href="#Operator-523"><span class="linenos">523</span></a>    <span class="k">def</span> <span class="nf">reorg_args</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">args</span><span class="p">,</span> <span class="n">params</span><span class="p">):</span>
</span><span id="Operator-524"><a href="#Operator-524"><span class="linenos">524</span></a>        <span class="n">sig</span> <span class="o">=</span> <span class="n">inspect</span><span class="o">.</span><span class="n">signature</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">typecheck</span><span class="p">)</span>
</span><span id="Operator-525"><a href="#Operator-525"><span class="linenos">525</span></a>        <span class="n">args_strs</span> <span class="o">=</span> <span class="p">[</span><span class="n">k</span> <span class="k">for</span> <span class="n">k</span><span class="p">,</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">sig</span><span class="o">.</span><span class="n">parameters</span><span class="o">.</span><span class="n">items</span><span class="p">()</span> <span class="k">if</span> <span class="n">v</span><span class="o">.</span><span class="n">kind</span> <span class="o">==</span> <span class="n">inspect</span><span class="o">.</span><span class="n">Parameter</span><span class="o">.</span><span class="n">POSITIONAL_OR_KEYWORD</span> <span class="ow">and</span> <span class="n">k</span> <span class="o">!=</span> <span class="s2">&quot;self&quot;</span><span class="p">]</span>
</span><span id="Operator-526"><a href="#Operator-526"><span class="linenos">526</span></a>        <span class="n">params_strs</span> <span class="o">=</span> <span class="p">[</span><span class="n">k</span> <span class="k">for</span> <span class="n">k</span><span class="p">,</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">sig</span><span class="o">.</span><span class="n">parameters</span><span class="o">.</span><span class="n">items</span><span class="p">()</span> <span class="k">if</span> <span class="n">v</span><span class="o">.</span><span class="n">kind</span> <span class="o">==</span> <span class="n">inspect</span><span class="o">.</span><span class="n">Parameter</span><span class="o">.</span><span class="n">KEYWORD_ONLY</span> <span class="ow">and</span> <span class="n">k</span> <span class="o">!=</span> <span class="s2">&quot;self&quot;</span><span class="p">]</span>
</span><span id="Operator-527"><a href="#Operator-527"><span class="linenos">527</span></a>
</span><span id="Operator-528"><a href="#Operator-528"><span class="linenos">528</span></a>        <span class="k">if</span> <span class="n">args</span><span class="p">:</span>
</span><span id="Operator-529"><a href="#Operator-529"><span class="linenos">529</span></a>            <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">args</span><span class="p">)</span> <span class="o">&gt;</span> <span class="nb">len</span><span class="p">(</span><span class="n">args_strs</span><span class="p">):</span>
</span><span id="Operator-530"><a href="#Operator-530"><span class="linenos">530</span></a>                <span class="n">args</span><span class="p">,</span> <span class="n">rest</span> <span class="o">=</span> <span class="n">args</span><span class="p">[:</span> <span class="nb">len</span><span class="p">(</span><span class="n">args_strs</span><span class="p">)],</span> <span class="n">args</span><span class="p">[</span><span class="nb">len</span><span class="p">(</span><span class="n">args_strs</span><span class="p">)</span> <span class="p">:]</span>
</span><span id="Operator-531"><a href="#Operator-531"><span class="linenos">531</span></a>                <span class="k">if</span> <span class="n">params_strs</span><span class="p">:</span>
</span><span id="Operator-532"><a href="#Operator-532"><span class="linenos">532</span></a>                    <span class="n">new_params</span> <span class="o">=</span> <span class="p">{</span><span class="n">k</span><span class="p">:</span> <span class="n">rest_arg</span> <span class="k">for</span> <span class="n">k</span><span class="p">,</span> <span class="n">rest_arg</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">params_strs</span><span class="p">,</span> <span class="n">rest</span><span class="p">)</span> <span class="k">if</span> <span class="n">k</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">params</span><span class="p">}</span>
</span><span id="Operator-533"><a href="#Operator-533"><span class="linenos">533</span></a>                    <span class="n">params</span> <span class="o">=</span> <span class="p">{</span><span class="o">**</span><span class="n">new_params</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">}</span>
</span><span id="Operator-534"><a href="#Operator-534"><span class="linenos">534</span></a>            <span class="k">else</span><span class="p">:</span>
</span><span id="Operator-535"><a href="#Operator-535"><span class="linenos">535</span></a>                <span class="n">args</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">([</span><span class="n">params</span><span class="p">[</span><span class="n">k</span><span class="p">]</span> <span class="k">if</span> <span class="n">k</span> <span class="ow">in</span> <span class="n">params</span> <span class="k">else</span> <span class="n">arg</span> <span class="k">for</span> <span class="n">k</span><span class="p">,</span> <span class="n">arg</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">args_strs</span><span class="p">,</span> <span class="n">args</span><span class="p">)])</span>
</span><span id="Operator-536"><a href="#Operator-536"><span class="linenos">536</span></a>                <span class="k">assert</span> <span class="nb">len</span><span class="p">(</span><span class="n">args</span><span class="p">)</span> <span class="o">==</span> <span class="nb">len</span><span class="p">(</span><span class="n">args_strs</span><span class="p">)</span>
</span><span id="Operator-537"><a href="#Operator-537"><span class="linenos">537</span></a>        <span class="k">return</span> <span class="n">args</span><span class="p">,</span> <span class="n">params</span>
</span><span id="Operator-538"><a href="#Operator-538"><span class="linenos">538</span></a>
</span><span id="Operator-539"><a href="#Operator-539"><span class="linenos">539</span></a>    <span class="k">def</span> <span class="nf">reorg_args_nary</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">args</span><span class="p">,</span> <span class="n">params</span><span class="p">):</span>
</span><span id="Operator-540"><a href="#Operator-540"><span class="linenos">540</span></a>        <span class="k">return</span> <span class="n">args</span><span class="p">,</span> <span class="n">params</span>
</span><span id="Operator-541"><a href="#Operator-541"><span class="linenos">541</span></a>
</span><span id="Operator-542"><a href="#Operator-542"><span class="linenos">542</span></a>    <span class="k">def</span> <span class="nf">partial_run</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">trace</span><span class="p">,</span> <span class="n">tracers</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="Operator-543"><a href="#Operator-543"><span class="linenos">543</span></a>        <span class="n">tracers_in</span> <span class="o">=</span> <span class="p">[</span><span class="n">trace</span><span class="o">.</span><span class="n">instantiate_const</span><span class="p">(</span><span class="n">t</span><span class="p">)</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">tracers</span><span class="p">]</span>
</span><span id="Operator-544"><a href="#Operator-544"><span class="linenos">544</span></a>        <span class="n">symvals_in</span> <span class="o">=</span> <span class="p">[</span><span class="n">t</span><span class="o">.</span><span class="n">symval</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">tracers_in</span><span class="p">]</span>
</span><span id="Operator-545"><a href="#Operator-545"><span class="linenos">545</span></a>        <span class="n">symvals_out</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">typecheck</span><span class="p">(</span><span class="o">*</span><span class="n">symvals_in</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)</span>
</span><span id="Operator-546"><a href="#Operator-546"><span class="linenos">546</span></a>        <span class="n">tracers_out</span> <span class="o">=</span> <span class="p">[</span><span class="n">PartialRunTraceTensor</span><span class="p">(</span><span class="n">trace</span><span class="p">,</span> <span class="n">make_unknown_pval</span><span class="p">(</span><span class="n">symval</span><span class="p">),</span> <span class="kc">None</span><span class="p">)</span> <span class="k">for</span> <span class="n">symval</span> <span class="ow">in</span> <span class="n">symvals_out</span><span class="p">]</span>
</span><span id="Operator-547"><a href="#Operator-547"><span class="linenos">547</span></a>        <span class="n">instruction</span> <span class="o">=</span> <span class="n">InstructionDraft</span><span class="p">(</span>
</span><span id="Operator-548"><a href="#Operator-548"><span class="linenos">548</span></a>            <span class="bp">self</span><span class="p">,</span>
</span><span id="Operator-549"><a href="#Operator-549"><span class="linenos">549</span></a>            <span class="n">tracers_in</span><span class="p">,</span>
</span><span id="Operator-550"><a href="#Operator-550"><span class="linenos">550</span></a>            <span class="n">params</span><span class="p">,</span>
</span><span id="Operator-551"><a href="#Operator-551"><span class="linenos">551</span></a>            <span class="n">symvals_out</span><span class="p">,</span>
</span><span id="Operator-552"><a href="#Operator-552"><span class="linenos">552</span></a>            <span class="n">list_map</span><span class="p">(</span><span class="n">weakref</span><span class="o">.</span><span class="n">ref</span><span class="p">,</span> <span class="n">tracers_out</span><span class="p">),</span>
</span><span id="Operator-553"><a href="#Operator-553"><span class="linenos">553</span></a>        <span class="p">)</span>
</span><span id="Operator-554"><a href="#Operator-554"><span class="linenos">554</span></a>        <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">tracers_out</span><span class="p">:</span>
</span><span id="Operator-555"><a href="#Operator-555"><span class="linenos">555</span></a>            <span class="n">t</span><span class="o">.</span><span class="n">draft</span> <span class="o">=</span> <span class="n">instruction</span>
</span><span id="Operator-556"><a href="#Operator-556"><span class="linenos">556</span></a>        <span class="k">return</span> <span class="n">tracers_out</span>
</span><span id="Operator-557"><a href="#Operator-557"><span class="linenos">557</span></a>
</span><span id="Operator-558"><a href="#Operator-558"><span class="linenos">558</span></a>    <span class="k">def</span> <span class="nf">partial_run_instruction</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">unks_in</span><span class="p">,</span> <span class="n">instruction</span><span class="p">):</span>
</span><span id="Operator-559"><a href="#Operator-559"><span class="linenos">559</span></a>        <span class="k">if</span> <span class="nb">any</span><span class="p">(</span><span class="n">unks_in</span><span class="p">):</span>
</span><span id="Operator-560"><a href="#Operator-560"><span class="linenos">560</span></a>            <span class="n">instruction1</span> <span class="o">=</span> <span class="kc">None</span>
</span><span id="Operator-561"><a href="#Operator-561"><span class="linenos">561</span></a>            <span class="n">instruction2</span> <span class="o">=</span> <span class="n">Instruction</span><span class="p">(</span>
</span><span id="Operator-562"><a href="#Operator-562"><span class="linenos">562</span></a>                <span class="n">instruction</span><span class="o">.</span><span class="n">op</span><span class="p">,</span>
</span><span id="Operator-563"><a href="#Operator-563"><span class="linenos">563</span></a>                <span class="n">instruction</span><span class="o">.</span><span class="n">inputs</span><span class="p">,</span>
</span><span id="Operator-564"><a href="#Operator-564"><span class="linenos">564</span></a>                <span class="n">instruction</span><span class="o">.</span><span class="n">params</span><span class="p">,</span>
</span><span id="Operator-565"><a href="#Operator-565"><span class="linenos">565</span></a>                <span class="n">instruction</span><span class="o">.</span><span class="n">out_binders</span><span class="p">,</span>
</span><span id="Operator-566"><a href="#Operator-566"><span class="linenos">566</span></a>            <span class="p">)</span>
</span><span id="Operator-567"><a href="#Operator-567"><span class="linenos">567</span></a>            <span class="n">unks_out</span> <span class="o">=</span> <span class="p">[</span><span class="kc">True</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="n">instruction</span><span class="o">.</span><span class="n">out_binders</span><span class="p">]</span>
</span><span id="Operator-568"><a href="#Operator-568"><span class="linenos">568</span></a>            <span class="n">res</span> <span class="o">=</span> <span class="p">[</span><span class="n">v</span> <span class="k">for</span> <span class="n">unk</span><span class="p">,</span> <span class="n">v</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">unks_in</span><span class="p">,</span> <span class="n">instruction</span><span class="o">.</span><span class="n">inputs</span><span class="p">)</span> <span class="k">if</span> <span class="p">((</span><span class="ow">not</span> <span class="n">unk</span><span class="p">)</span> <span class="ow">and</span> <span class="nb">type</span><span class="p">(</span><span class="n">v</span><span class="p">)</span> <span class="ow">is</span> <span class="n">Var</span><span class="p">)]</span>
</span><span id="Operator-569"><a href="#Operator-569"><span class="linenos">569</span></a>        <span class="k">else</span><span class="p">:</span>
</span><span id="Operator-570"><a href="#Operator-570"><span class="linenos">570</span></a>            <span class="n">instruction1</span> <span class="o">=</span> <span class="n">instruction</span>
</span><span id="Operator-571"><a href="#Operator-571"><span class="linenos">571</span></a>            <span class="n">instruction2</span> <span class="o">=</span> <span class="kc">None</span>
</span><span id="Operator-572"><a href="#Operator-572"><span class="linenos">572</span></a>            <span class="n">unks_out</span> <span class="o">=</span> <span class="p">[</span><span class="kc">False</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="n">instruction</span><span class="o">.</span><span class="n">out_binders</span><span class="p">]</span>
</span><span id="Operator-573"><a href="#Operator-573"><span class="linenos">573</span></a>            <span class="n">res</span> <span class="o">=</span> <span class="kc">None</span>
</span><span id="Operator-574"><a href="#Operator-574"><span class="linenos">574</span></a>
</span><span id="Operator-575"><a href="#Operator-575"><span class="linenos">575</span></a>        <span class="k">return</span> <span class="n">instruction1</span><span class="p">,</span> <span class="n">instruction2</span><span class="p">,</span> <span class="n">unks_out</span><span class="p">,</span> <span class="n">res</span>
</span></pre></div>


    

                            <div id="Operator.__init__" class="classattr">
                                        <input id="Operator.__init__-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="name">Operator</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">name</span>, </span><span class="param"><span class="n">variadic_inputs</span><span class="o">=</span><span class="kc">False</span>, </span><span class="param"><span class="n">nary_outputs</span><span class="o">=</span><span class="kc">False</span></span>)</span>

                <label class="view-source-button" for="Operator.__init__-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Operator.__init__"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Operator.__init__-482"><a href="#Operator.__init__-482"><span class="linenos">482</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">name</span><span class="p">,</span> <span class="n">variadic_inputs</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">nary_outputs</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>
</span><span id="Operator.__init__-483"><a href="#Operator.__init__-483"><span class="linenos">483</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">name</span> <span class="o">=</span> <span class="n">name</span>
</span><span id="Operator.__init__-484"><a href="#Operator.__init__-484"><span class="linenos">484</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">variadic_inputs</span> <span class="o">=</span> <span class="n">variadic_inputs</span>
</span><span id="Operator.__init__-485"><a href="#Operator.__init__-485"><span class="linenos">485</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">nary_outputs</span> <span class="o">=</span> <span class="n">nary_outputs</span>
</span><span id="Operator.__init__-486"><a href="#Operator.__init__-486"><span class="linenos">486</span></a>        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">variadic_inputs</span><span class="p">:</span>
</span><span id="Operator.__init__-487"><a href="#Operator.__init__-487"><span class="linenos">487</span></a>            <span class="bp">self</span><span class="o">.</span><span class="n">reorg_args</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">reorg_args_nary</span>
</span></pre></div>


    

                            </div>
                            <div id="Operator.name" class="classattr">
                                <div class="attr variable">
            <span class="name">name</span>

        
    </div>
    <a class="headerlink" href="#Operator.name"></a>
    
    

                            </div>
                            <div id="Operator.variadic_inputs" class="classattr">
                                <div class="attr variable">
            <span class="name">variadic_inputs</span>

        
    </div>
    <a class="headerlink" href="#Operator.variadic_inputs"></a>
    
    

                            </div>
                            <div id="Operator.nary_outputs" class="classattr">
                                <div class="attr variable">
            <span class="name">nary_outputs</span>

        
    </div>
    <a class="headerlink" href="#Operator.nary_outputs"></a>
    
    

                            </div>
                            <div id="Operator.args_fixer" class="classattr">
                                        <input id="Operator.args_fixer-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">args_fixer</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="o">*</span><span class="n">args</span>, </span><span class="param"><span class="o">**</span><span class="n">params</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="Operator.args_fixer-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Operator.args_fixer"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Operator.args_fixer-497"><a href="#Operator.args_fixer-497"><span class="linenos">497</span></a>    <span class="k">def</span> <span class="nf">args_fixer</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="Operator.args_fixer-498"><a href="#Operator.args_fixer-498"><span class="linenos">498</span></a>        <span class="k">return</span> <span class="n">args</span><span class="p">,</span> <span class="n">params</span>
</span></pre></div>


    

                            </div>
                            <div id="Operator.typecheck" class="classattr">
                                        <input id="Operator.typecheck-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">typecheck</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="o">*</span><span class="n">args</span>, </span><span class="param"><span class="o">**</span><span class="n">params</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="Operator.typecheck-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Operator.typecheck"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Operator.typecheck-511"><a href="#Operator.typecheck-511"><span class="linenos">511</span></a>    <span class="k">def</span> <span class="nf">typecheck</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="Operator.typecheck-512"><a href="#Operator.typecheck-512"><span class="linenos">512</span></a>        <span class="k">raise</span> <span class="ne">NotImplementedError</span>
</span></pre></div>


    

                            </div>
                            <div id="Operator.jvp" class="classattr">
                                        <input id="Operator.jvp-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">jvp</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="o">*</span><span class="n">args</span>, </span><span class="param"><span class="o">**</span><span class="n">params</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="Operator.jvp-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Operator.jvp"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Operator.jvp-514"><a href="#Operator.jvp-514"><span class="linenos">514</span></a>    <span class="k">def</span> <span class="nf">jvp</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="Operator.jvp-515"><a href="#Operator.jvp-515"><span class="linenos">515</span></a>        <span class="k">raise</span> <span class="ne">NotImplementedError</span>
</span></pre></div>


    

                            </div>
                            <div id="Operator.T" class="classattr">
                                        <input id="Operator.T-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">T</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="o">*</span><span class="n">args</span>, </span><span class="param"><span class="o">**</span><span class="n">params</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="Operator.T-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Operator.T"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Operator.T-517"><a href="#Operator.T-517"><span class="linenos">517</span></a>    <span class="k">def</span> <span class="nf">T</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="Operator.T-518"><a href="#Operator.T-518"><span class="linenos">518</span></a>        <span class="k">raise</span> <span class="ne">NotImplementedError</span>
</span></pre></div>


    

                            </div>
                            <div id="Operator.vmap" class="classattr">
                                        <input id="Operator.vmap-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">vmap</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="o">*</span><span class="n">args</span>, </span><span class="param"><span class="o">**</span><span class="n">params</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="Operator.vmap-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Operator.vmap"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Operator.vmap-520"><a href="#Operator.vmap-520"><span class="linenos">520</span></a>    <span class="k">def</span> <span class="nf">vmap</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="Operator.vmap-521"><a href="#Operator.vmap-521"><span class="linenos">521</span></a>        <span class="k">raise</span> <span class="ne">NotImplementedError</span>
</span></pre></div>


    

                            </div>
                            <div id="Operator.reorg_args" class="classattr">
                                        <input id="Operator.reorg_args-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">reorg_args</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="n">args</span>, </span><span class="param"><span class="n">params</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="Operator.reorg_args-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Operator.reorg_args"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Operator.reorg_args-523"><a href="#Operator.reorg_args-523"><span class="linenos">523</span></a>    <span class="k">def</span> <span class="nf">reorg_args</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">args</span><span class="p">,</span> <span class="n">params</span><span class="p">):</span>
</span><span id="Operator.reorg_args-524"><a href="#Operator.reorg_args-524"><span class="linenos">524</span></a>        <span class="n">sig</span> <span class="o">=</span> <span class="n">inspect</span><span class="o">.</span><span class="n">signature</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">typecheck</span><span class="p">)</span>
</span><span id="Operator.reorg_args-525"><a href="#Operator.reorg_args-525"><span class="linenos">525</span></a>        <span class="n">args_strs</span> <span class="o">=</span> <span class="p">[</span><span class="n">k</span> <span class="k">for</span> <span class="n">k</span><span class="p">,</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">sig</span><span class="o">.</span><span class="n">parameters</span><span class="o">.</span><span class="n">items</span><span class="p">()</span> <span class="k">if</span> <span class="n">v</span><span class="o">.</span><span class="n">kind</span> <span class="o">==</span> <span class="n">inspect</span><span class="o">.</span><span class="n">Parameter</span><span class="o">.</span><span class="n">POSITIONAL_OR_KEYWORD</span> <span class="ow">and</span> <span class="n">k</span> <span class="o">!=</span> <span class="s2">&quot;self&quot;</span><span class="p">]</span>
</span><span id="Operator.reorg_args-526"><a href="#Operator.reorg_args-526"><span class="linenos">526</span></a>        <span class="n">params_strs</span> <span class="o">=</span> <span class="p">[</span><span class="n">k</span> <span class="k">for</span> <span class="n">k</span><span class="p">,</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">sig</span><span class="o">.</span><span class="n">parameters</span><span class="o">.</span><span class="n">items</span><span class="p">()</span> <span class="k">if</span> <span class="n">v</span><span class="o">.</span><span class="n">kind</span> <span class="o">==</span> <span class="n">inspect</span><span class="o">.</span><span class="n">Parameter</span><span class="o">.</span><span class="n">KEYWORD_ONLY</span> <span class="ow">and</span> <span class="n">k</span> <span class="o">!=</span> <span class="s2">&quot;self&quot;</span><span class="p">]</span>
</span><span id="Operator.reorg_args-527"><a href="#Operator.reorg_args-527"><span class="linenos">527</span></a>
</span><span id="Operator.reorg_args-528"><a href="#Operator.reorg_args-528"><span class="linenos">528</span></a>        <span class="k">if</span> <span class="n">args</span><span class="p">:</span>
</span><span id="Operator.reorg_args-529"><a href="#Operator.reorg_args-529"><span class="linenos">529</span></a>            <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">args</span><span class="p">)</span> <span class="o">&gt;</span> <span class="nb">len</span><span class="p">(</span><span class="n">args_strs</span><span class="p">):</span>
</span><span id="Operator.reorg_args-530"><a href="#Operator.reorg_args-530"><span class="linenos">530</span></a>                <span class="n">args</span><span class="p">,</span> <span class="n">rest</span> <span class="o">=</span> <span class="n">args</span><span class="p">[:</span> <span class="nb">len</span><span class="p">(</span><span class="n">args_strs</span><span class="p">)],</span> <span class="n">args</span><span class="p">[</span><span class="nb">len</span><span class="p">(</span><span class="n">args_strs</span><span class="p">)</span> <span class="p">:]</span>
</span><span id="Operator.reorg_args-531"><a href="#Operator.reorg_args-531"><span class="linenos">531</span></a>                <span class="k">if</span> <span class="n">params_strs</span><span class="p">:</span>
</span><span id="Operator.reorg_args-532"><a href="#Operator.reorg_args-532"><span class="linenos">532</span></a>                    <span class="n">new_params</span> <span class="o">=</span> <span class="p">{</span><span class="n">k</span><span class="p">:</span> <span class="n">rest_arg</span> <span class="k">for</span> <span class="n">k</span><span class="p">,</span> <span class="n">rest_arg</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">params_strs</span><span class="p">,</span> <span class="n">rest</span><span class="p">)</span> <span class="k">if</span> <span class="n">k</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">params</span><span class="p">}</span>
</span><span id="Operator.reorg_args-533"><a href="#Operator.reorg_args-533"><span class="linenos">533</span></a>                    <span class="n">params</span> <span class="o">=</span> <span class="p">{</span><span class="o">**</span><span class="n">new_params</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">}</span>
</span><span id="Operator.reorg_args-534"><a href="#Operator.reorg_args-534"><span class="linenos">534</span></a>            <span class="k">else</span><span class="p">:</span>
</span><span id="Operator.reorg_args-535"><a href="#Operator.reorg_args-535"><span class="linenos">535</span></a>                <span class="n">args</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">([</span><span class="n">params</span><span class="p">[</span><span class="n">k</span><span class="p">]</span> <span class="k">if</span> <span class="n">k</span> <span class="ow">in</span> <span class="n">params</span> <span class="k">else</span> <span class="n">arg</span> <span class="k">for</span> <span class="n">k</span><span class="p">,</span> <span class="n">arg</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">args_strs</span><span class="p">,</span> <span class="n">args</span><span class="p">)])</span>
</span><span id="Operator.reorg_args-536"><a href="#Operator.reorg_args-536"><span class="linenos">536</span></a>                <span class="k">assert</span> <span class="nb">len</span><span class="p">(</span><span class="n">args</span><span class="p">)</span> <span class="o">==</span> <span class="nb">len</span><span class="p">(</span><span class="n">args_strs</span><span class="p">)</span>
</span><span id="Operator.reorg_args-537"><a href="#Operator.reorg_args-537"><span class="linenos">537</span></a>        <span class="k">return</span> <span class="n">args</span><span class="p">,</span> <span class="n">params</span>
</span></pre></div>


    

                            </div>
                            <div id="Operator.reorg_args_nary" class="classattr">
                                        <input id="Operator.reorg_args_nary-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">reorg_args_nary</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="n">args</span>, </span><span class="param"><span class="n">params</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="Operator.reorg_args_nary-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Operator.reorg_args_nary"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Operator.reorg_args_nary-539"><a href="#Operator.reorg_args_nary-539"><span class="linenos">539</span></a>    <span class="k">def</span> <span class="nf">reorg_args_nary</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">args</span><span class="p">,</span> <span class="n">params</span><span class="p">):</span>
</span><span id="Operator.reorg_args_nary-540"><a href="#Operator.reorg_args_nary-540"><span class="linenos">540</span></a>        <span class="k">return</span> <span class="n">args</span><span class="p">,</span> <span class="n">params</span>
</span></pre></div>


    

                            </div>
                            <div id="Operator.partial_run" class="classattr">
                                        <input id="Operator.partial_run-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">partial_run</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="n">trace</span>, </span><span class="param"><span class="n">tracers</span>, </span><span class="param"><span class="o">**</span><span class="n">params</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="Operator.partial_run-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Operator.partial_run"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Operator.partial_run-542"><a href="#Operator.partial_run-542"><span class="linenos">542</span></a>    <span class="k">def</span> <span class="nf">partial_run</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">trace</span><span class="p">,</span> <span class="n">tracers</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="Operator.partial_run-543"><a href="#Operator.partial_run-543"><span class="linenos">543</span></a>        <span class="n">tracers_in</span> <span class="o">=</span> <span class="p">[</span><span class="n">trace</span><span class="o">.</span><span class="n">instantiate_const</span><span class="p">(</span><span class="n">t</span><span class="p">)</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">tracers</span><span class="p">]</span>
</span><span id="Operator.partial_run-544"><a href="#Operator.partial_run-544"><span class="linenos">544</span></a>        <span class="n">symvals_in</span> <span class="o">=</span> <span class="p">[</span><span class="n">t</span><span class="o">.</span><span class="n">symval</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">tracers_in</span><span class="p">]</span>
</span><span id="Operator.partial_run-545"><a href="#Operator.partial_run-545"><span class="linenos">545</span></a>        <span class="n">symvals_out</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">typecheck</span><span class="p">(</span><span class="o">*</span><span class="n">symvals_in</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)</span>
</span><span id="Operator.partial_run-546"><a href="#Operator.partial_run-546"><span class="linenos">546</span></a>        <span class="n">tracers_out</span> <span class="o">=</span> <span class="p">[</span><span class="n">PartialRunTraceTensor</span><span class="p">(</span><span class="n">trace</span><span class="p">,</span> <span class="n">make_unknown_pval</span><span class="p">(</span><span class="n">symval</span><span class="p">),</span> <span class="kc">None</span><span class="p">)</span> <span class="k">for</span> <span class="n">symval</span> <span class="ow">in</span> <span class="n">symvals_out</span><span class="p">]</span>
</span><span id="Operator.partial_run-547"><a href="#Operator.partial_run-547"><span class="linenos">547</span></a>        <span class="n">instruction</span> <span class="o">=</span> <span class="n">InstructionDraft</span><span class="p">(</span>
</span><span id="Operator.partial_run-548"><a href="#Operator.partial_run-548"><span class="linenos">548</span></a>            <span class="bp">self</span><span class="p">,</span>
</span><span id="Operator.partial_run-549"><a href="#Operator.partial_run-549"><span class="linenos">549</span></a>            <span class="n">tracers_in</span><span class="p">,</span>
</span><span id="Operator.partial_run-550"><a href="#Operator.partial_run-550"><span class="linenos">550</span></a>            <span class="n">params</span><span class="p">,</span>
</span><span id="Operator.partial_run-551"><a href="#Operator.partial_run-551"><span class="linenos">551</span></a>            <span class="n">symvals_out</span><span class="p">,</span>
</span><span id="Operator.partial_run-552"><a href="#Operator.partial_run-552"><span class="linenos">552</span></a>            <span class="n">list_map</span><span class="p">(</span><span class="n">weakref</span><span class="o">.</span><span class="n">ref</span><span class="p">,</span> <span class="n">tracers_out</span><span class="p">),</span>
</span><span id="Operator.partial_run-553"><a href="#Operator.partial_run-553"><span class="linenos">553</span></a>        <span class="p">)</span>
</span><span id="Operator.partial_run-554"><a href="#Operator.partial_run-554"><span class="linenos">554</span></a>        <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">tracers_out</span><span class="p">:</span>
</span><span id="Operator.partial_run-555"><a href="#Operator.partial_run-555"><span class="linenos">555</span></a>            <span class="n">t</span><span class="o">.</span><span class="n">draft</span> <span class="o">=</span> <span class="n">instruction</span>
</span><span id="Operator.partial_run-556"><a href="#Operator.partial_run-556"><span class="linenos">556</span></a>        <span class="k">return</span> <span class="n">tracers_out</span>
</span></pre></div>


    

                            </div>
                            <div id="Operator.partial_run_instruction" class="classattr">
                                        <input id="Operator.partial_run_instruction-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">partial_run_instruction</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="n">unks_in</span>, </span><span class="param"><span class="n">instruction</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="Operator.partial_run_instruction-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Operator.partial_run_instruction"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Operator.partial_run_instruction-558"><a href="#Operator.partial_run_instruction-558"><span class="linenos">558</span></a>    <span class="k">def</span> <span class="nf">partial_run_instruction</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">unks_in</span><span class="p">,</span> <span class="n">instruction</span><span class="p">):</span>
</span><span id="Operator.partial_run_instruction-559"><a href="#Operator.partial_run_instruction-559"><span class="linenos">559</span></a>        <span class="k">if</span> <span class="nb">any</span><span class="p">(</span><span class="n">unks_in</span><span class="p">):</span>
</span><span id="Operator.partial_run_instruction-560"><a href="#Operator.partial_run_instruction-560"><span class="linenos">560</span></a>            <span class="n">instruction1</span> <span class="o">=</span> <span class="kc">None</span>
</span><span id="Operator.partial_run_instruction-561"><a href="#Operator.partial_run_instruction-561"><span class="linenos">561</span></a>            <span class="n">instruction2</span> <span class="o">=</span> <span class="n">Instruction</span><span class="p">(</span>
</span><span id="Operator.partial_run_instruction-562"><a href="#Operator.partial_run_instruction-562"><span class="linenos">562</span></a>                <span class="n">instruction</span><span class="o">.</span><span class="n">op</span><span class="p">,</span>
</span><span id="Operator.partial_run_instruction-563"><a href="#Operator.partial_run_instruction-563"><span class="linenos">563</span></a>                <span class="n">instruction</span><span class="o">.</span><span class="n">inputs</span><span class="p">,</span>
</span><span id="Operator.partial_run_instruction-564"><a href="#Operator.partial_run_instruction-564"><span class="linenos">564</span></a>                <span class="n">instruction</span><span class="o">.</span><span class="n">params</span><span class="p">,</span>
</span><span id="Operator.partial_run_instruction-565"><a href="#Operator.partial_run_instruction-565"><span class="linenos">565</span></a>                <span class="n">instruction</span><span class="o">.</span><span class="n">out_binders</span><span class="p">,</span>
</span><span id="Operator.partial_run_instruction-566"><a href="#Operator.partial_run_instruction-566"><span class="linenos">566</span></a>            <span class="p">)</span>
</span><span id="Operator.partial_run_instruction-567"><a href="#Operator.partial_run_instruction-567"><span class="linenos">567</span></a>            <span class="n">unks_out</span> <span class="o">=</span> <span class="p">[</span><span class="kc">True</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="n">instruction</span><span class="o">.</span><span class="n">out_binders</span><span class="p">]</span>
</span><span id="Operator.partial_run_instruction-568"><a href="#Operator.partial_run_instruction-568"><span class="linenos">568</span></a>            <span class="n">res</span> <span class="o">=</span> <span class="p">[</span><span class="n">v</span> <span class="k">for</span> <span class="n">unk</span><span class="p">,</span> <span class="n">v</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">unks_in</span><span class="p">,</span> <span class="n">instruction</span><span class="o">.</span><span class="n">inputs</span><span class="p">)</span> <span class="k">if</span> <span class="p">((</span><span class="ow">not</span> <span class="n">unk</span><span class="p">)</span> <span class="ow">and</span> <span class="nb">type</span><span class="p">(</span><span class="n">v</span><span class="p">)</span> <span class="ow">is</span> <span class="n">Var</span><span class="p">)]</span>
</span><span id="Operator.partial_run_instruction-569"><a href="#Operator.partial_run_instruction-569"><span class="linenos">569</span></a>        <span class="k">else</span><span class="p">:</span>
</span><span id="Operator.partial_run_instruction-570"><a href="#Operator.partial_run_instruction-570"><span class="linenos">570</span></a>            <span class="n">instruction1</span> <span class="o">=</span> <span class="n">instruction</span>
</span><span id="Operator.partial_run_instruction-571"><a href="#Operator.partial_run_instruction-571"><span class="linenos">571</span></a>            <span class="n">instruction2</span> <span class="o">=</span> <span class="kc">None</span>
</span><span id="Operator.partial_run_instruction-572"><a href="#Operator.partial_run_instruction-572"><span class="linenos">572</span></a>            <span class="n">unks_out</span> <span class="o">=</span> <span class="p">[</span><span class="kc">False</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="n">instruction</span><span class="o">.</span><span class="n">out_binders</span><span class="p">]</span>
</span><span id="Operator.partial_run_instruction-573"><a href="#Operator.partial_run_instruction-573"><span class="linenos">573</span></a>            <span class="n">res</span> <span class="o">=</span> <span class="kc">None</span>
</span><span id="Operator.partial_run_instruction-574"><a href="#Operator.partial_run_instruction-574"><span class="linenos">574</span></a>
</span><span id="Operator.partial_run_instruction-575"><a href="#Operator.partial_run_instruction-575"><span class="linenos">575</span></a>        <span class="k">return</span> <span class="n">instruction1</span><span class="p">,</span> <span class="n">instruction2</span><span class="p">,</span> <span class="n">unks_out</span><span class="p">,</span> <span class="n">res</span>
</span></pre></div>


    

                            </div>
                </section>
                <section id="MetaOperator">
                            <input id="MetaOperator-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr class">
            
    <span class="def">class</span>
    <span class="name">MetaOperator</span><wbr>(<span class="base"><a href="#Operator">Operator</a></span>):

                <label class="view-source-button" for="MetaOperator-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#MetaOperator"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="MetaOperator-578"><a href="#MetaOperator-578"><span class="linenos">578</span></a><span class="k">class</span> <span class="nc">MetaOperator</span><span class="p">(</span><span class="n">Operator</span><span class="p">):</span>
</span><span id="MetaOperator-579"><a href="#MetaOperator-579"><span class="linenos">579</span></a>    <span class="k">def</span> <span class="nf">meta_impl</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">):</span>
</span><span id="MetaOperator-580"><a href="#MetaOperator-580"><span class="linenos">580</span></a>        <span class="k">raise</span> <span class="ne">NotImplementedError</span>
</span></pre></div>


    

                            <div id="MetaOperator.meta_impl" class="classattr">
                                        <input id="MetaOperator.meta_impl-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">meta_impl</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="o">*</span><span class="n">args</span>, </span><span class="param"><span class="o">**</span><span class="n">kwargs</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="MetaOperator.meta_impl-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#MetaOperator.meta_impl"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="MetaOperator.meta_impl-579"><a href="#MetaOperator.meta_impl-579"><span class="linenos">579</span></a>    <span class="k">def</span> <span class="nf">meta_impl</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">):</span>
</span><span id="MetaOperator.meta_impl-580"><a href="#MetaOperator.meta_impl-580"><span class="linenos">580</span></a>        <span class="k">raise</span> <span class="ne">NotImplementedError</span>
</span></pre></div>


    

                            </div>
                            <div class="inherited">
                                <h5>Inherited Members</h5>
                                <dl>
                                    <div><dt><a href="#Operator">Operator</a></dt>
                                <dd id="MetaOperator.__init__" class="function"><a href="#Operator.__init__">Operator</a></dd>
                <dd id="MetaOperator.name" class="variable"><a href="#Operator.name">name</a></dd>
                <dd id="MetaOperator.variadic_inputs" class="variable"><a href="#Operator.variadic_inputs">variadic_inputs</a></dd>
                <dd id="MetaOperator.nary_outputs" class="variable"><a href="#Operator.nary_outputs">nary_outputs</a></dd>
                <dd id="MetaOperator.args_fixer" class="function"><a href="#Operator.args_fixer">args_fixer</a></dd>
                <dd id="MetaOperator.typecheck" class="function"><a href="#Operator.typecheck">typecheck</a></dd>
                <dd id="MetaOperator.jvp" class="function"><a href="#Operator.jvp">jvp</a></dd>
                <dd id="MetaOperator.T" class="function"><a href="#Operator.T">T</a></dd>
                <dd id="MetaOperator.vmap" class="function"><a href="#Operator.vmap">vmap</a></dd>
                <dd id="MetaOperator.reorg_args" class="function"><a href="#Operator.reorg_args">reorg_args</a></dd>
                <dd id="MetaOperator.reorg_args_nary" class="function"><a href="#Operator.reorg_args_nary">reorg_args_nary</a></dd>
                <dd id="MetaOperator.partial_run" class="function"><a href="#Operator.partial_run">partial_run</a></dd>
                <dd id="MetaOperator.partial_run_instruction" class="function"><a href="#Operator.partial_run_instruction">partial_run_instruction</a></dd>

            </div>
                                </dl>
                            </div>
                </section>
                <section id="UnaryOperator">
                            <input id="UnaryOperator-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr class">
            
    <span class="def">class</span>
    <span class="name">UnaryOperator</span><wbr>(<span class="base"><a href="#Operator">Operator</a></span>):

                <label class="view-source-button" for="UnaryOperator-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#UnaryOperator"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="UnaryOperator-583"><a href="#UnaryOperator-583"><span class="linenos">583</span></a><span class="k">class</span> <span class="nc">UnaryOperator</span><span class="p">(</span><span class="n">Operator</span><span class="p">):</span>
</span><span id="UnaryOperator-584"><a href="#UnaryOperator-584"><span class="linenos">584</span></a>    <span class="k">def</span> <span class="nf">vmap</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">x</span><span class="p">,</span> <span class="o">*</span><span class="p">,</span> <span class="n">dim_size</span><span class="p">,</span> <span class="n">vals_in</span><span class="p">,</span> <span class="n">dims_in</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="UnaryOperator-585"><a href="#UnaryOperator-585"><span class="linenos">585</span></a>        <span class="p">(</span><span class="n">x</span><span class="p">,),</span> <span class="p">(</span><span class="n">x_bdim</span><span class="p">,)</span> <span class="o">=</span> <span class="n">vals_in</span><span class="p">,</span> <span class="n">dims_in</span>
</span><span id="UnaryOperator-586"><a href="#UnaryOperator-586"><span class="linenos">586</span></a>        <span class="k">return</span> <span class="p">[</span><span class="bp">self</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)],</span> <span class="p">[</span><span class="n">x_bdim</span><span class="p">]</span>
</span><span id="UnaryOperator-587"><a href="#UnaryOperator-587"><span class="linenos">587</span></a>
</span><span id="UnaryOperator-588"><a href="#UnaryOperator-588"><span class="linenos">588</span></a>    <span class="k">def</span> <span class="nf">typecheck</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">x</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="UnaryOperator-589"><a href="#UnaryOperator-589"><span class="linenos">589</span></a>        <span class="k">return</span> <span class="p">[</span><span class="n">x</span><span class="o">.</span><span class="n">like</span><span class="p">()]</span>
</span><span id="UnaryOperator-590"><a href="#UnaryOperator-590"><span class="linenos">590</span></a>
</span><span id="UnaryOperator-591"><a href="#UnaryOperator-591"><span class="linenos">591</span></a>    <span class="k">def</span> <span class="nf">jvp</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">primals</span><span class="p">,</span> <span class="n">tangents</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="UnaryOperator-592"><a href="#UnaryOperator-592"><span class="linenos">592</span></a>        <span class="p">(</span><span class="n">x</span><span class="p">,),</span> <span class="p">(</span><span class="n">x_dot</span><span class="p">,)</span> <span class="o">=</span> <span class="n">primals</span><span class="p">,</span> <span class="n">tangents</span>
</span><span id="UnaryOperator-593"><a href="#UnaryOperator-593"><span class="linenos">593</span></a>        <span class="k">return</span> <span class="p">[</span><span class="bp">self</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)],</span> <span class="p">[</span><span class="bp">self</span><span class="p">(</span><span class="n">x_dot</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)]</span>
</span></pre></div>


    

                            <div id="UnaryOperator.vmap" class="classattr">
                                        <input id="UnaryOperator.vmap-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">vmap</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="n">x</span>, </span><span class="param"><span class="o">*</span>, </span><span class="param"><span class="n">dim_size</span>, </span><span class="param"><span class="n">vals_in</span>, </span><span class="param"><span class="n">dims_in</span>, </span><span class="param"><span class="o">**</span><span class="n">params</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="UnaryOperator.vmap-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#UnaryOperator.vmap"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="UnaryOperator.vmap-584"><a href="#UnaryOperator.vmap-584"><span class="linenos">584</span></a>    <span class="k">def</span> <span class="nf">vmap</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">x</span><span class="p">,</span> <span class="o">*</span><span class="p">,</span> <span class="n">dim_size</span><span class="p">,</span> <span class="n">vals_in</span><span class="p">,</span> <span class="n">dims_in</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="UnaryOperator.vmap-585"><a href="#UnaryOperator.vmap-585"><span class="linenos">585</span></a>        <span class="p">(</span><span class="n">x</span><span class="p">,),</span> <span class="p">(</span><span class="n">x_bdim</span><span class="p">,)</span> <span class="o">=</span> <span class="n">vals_in</span><span class="p">,</span> <span class="n">dims_in</span>
</span><span id="UnaryOperator.vmap-586"><a href="#UnaryOperator.vmap-586"><span class="linenos">586</span></a>        <span class="k">return</span> <span class="p">[</span><span class="bp">self</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)],</span> <span class="p">[</span><span class="n">x_bdim</span><span class="p">]</span>
</span></pre></div>


    

                            </div>
                            <div id="UnaryOperator.typecheck" class="classattr">
                                        <input id="UnaryOperator.typecheck-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">typecheck</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="n">x</span>, </span><span class="param"><span class="o">**</span><span class="n">params</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="UnaryOperator.typecheck-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#UnaryOperator.typecheck"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="UnaryOperator.typecheck-588"><a href="#UnaryOperator.typecheck-588"><span class="linenos">588</span></a>    <span class="k">def</span> <span class="nf">typecheck</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">x</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="UnaryOperator.typecheck-589"><a href="#UnaryOperator.typecheck-589"><span class="linenos">589</span></a>        <span class="k">return</span> <span class="p">[</span><span class="n">x</span><span class="o">.</span><span class="n">like</span><span class="p">()]</span>
</span></pre></div>


    

                            </div>
                            <div id="UnaryOperator.jvp" class="classattr">
                                        <input id="UnaryOperator.jvp-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">jvp</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="n">primals</span>, </span><span class="param"><span class="n">tangents</span>, </span><span class="param"><span class="o">**</span><span class="n">params</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="UnaryOperator.jvp-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#UnaryOperator.jvp"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="UnaryOperator.jvp-591"><a href="#UnaryOperator.jvp-591"><span class="linenos">591</span></a>    <span class="k">def</span> <span class="nf">jvp</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">primals</span><span class="p">,</span> <span class="n">tangents</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="UnaryOperator.jvp-592"><a href="#UnaryOperator.jvp-592"><span class="linenos">592</span></a>        <span class="p">(</span><span class="n">x</span><span class="p">,),</span> <span class="p">(</span><span class="n">x_dot</span><span class="p">,)</span> <span class="o">=</span> <span class="n">primals</span><span class="p">,</span> <span class="n">tangents</span>
</span><span id="UnaryOperator.jvp-593"><a href="#UnaryOperator.jvp-593"><span class="linenos">593</span></a>        <span class="k">return</span> <span class="p">[</span><span class="bp">self</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)],</span> <span class="p">[</span><span class="bp">self</span><span class="p">(</span><span class="n">x_dot</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)]</span>
</span></pre></div>


    

                            </div>
                            <div class="inherited">
                                <h5>Inherited Members</h5>
                                <dl>
                                    <div><dt><a href="#Operator">Operator</a></dt>
                                <dd id="UnaryOperator.__init__" class="function"><a href="#Operator.__init__">Operator</a></dd>
                <dd id="UnaryOperator.name" class="variable"><a href="#Operator.name">name</a></dd>
                <dd id="UnaryOperator.variadic_inputs" class="variable"><a href="#Operator.variadic_inputs">variadic_inputs</a></dd>
                <dd id="UnaryOperator.nary_outputs" class="variable"><a href="#Operator.nary_outputs">nary_outputs</a></dd>
                <dd id="UnaryOperator.args_fixer" class="function"><a href="#Operator.args_fixer">args_fixer</a></dd>
                <dd id="UnaryOperator.T" class="function"><a href="#Operator.T">T</a></dd>
                <dd id="UnaryOperator.reorg_args" class="function"><a href="#Operator.reorg_args">reorg_args</a></dd>
                <dd id="UnaryOperator.reorg_args_nary" class="function"><a href="#Operator.reorg_args_nary">reorg_args_nary</a></dd>
                <dd id="UnaryOperator.partial_run" class="function"><a href="#Operator.partial_run">partial_run</a></dd>
                <dd id="UnaryOperator.partial_run_instruction" class="function"><a href="#Operator.partial_run_instruction">partial_run_instruction</a></dd>

            </div>
                                </dl>
                            </div>
                </section>
                <section id="BinaryOperator">
                            <input id="BinaryOperator-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr class">
            
    <span class="def">class</span>
    <span class="name">BinaryOperator</span><wbr>(<span class="base"><a href="#Operator">Operator</a></span>):

                <label class="view-source-button" for="BinaryOperator-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#BinaryOperator"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="BinaryOperator-596"><a href="#BinaryOperator-596"><span class="linenos">596</span></a><span class="k">class</span> <span class="nc">BinaryOperator</span><span class="p">(</span><span class="n">Operator</span><span class="p">):</span>
</span><span id="BinaryOperator-597"><a href="#BinaryOperator-597"><span class="linenos">597</span></a>    <span class="n">boolean_output</span> <span class="o">=</span> <span class="kc">False</span>
</span><span id="BinaryOperator-598"><a href="#BinaryOperator-598"><span class="linenos">598</span></a>
</span><span id="BinaryOperator-599"><a href="#BinaryOperator-599"><span class="linenos">599</span></a>    <span class="k">def</span> <span class="nf">args_fixer</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">x</span><span class="p">,</span> <span class="n">w</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="BinaryOperator-600"><a href="#BinaryOperator-600"><span class="linenos">600</span></a>        <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">UndefinedPrimal</span><span class="p">)</span> <span class="ow">or</span> <span class="nb">type</span><span class="p">(</span><span class="n">w</span><span class="p">)</span> <span class="ow">is</span> <span class="n">UndefinedPrimal</span><span class="p">:</span>
</span><span id="BinaryOperator-601"><a href="#BinaryOperator-601"><span class="linenos">601</span></a>            <span class="k">assert</span> <span class="n">x</span><span class="o">.</span><span class="n">shape</span> <span class="o">==</span> <span class="n">w</span><span class="o">.</span><span class="n">shape</span>
</span><span id="BinaryOperator-602"><a href="#BinaryOperator-602"><span class="linenos">602</span></a>            <span class="k">return</span> <span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">w</span><span class="p">),</span> <span class="n">params</span>
</span><span id="BinaryOperator-603"><a href="#BinaryOperator-603"><span class="linenos">603</span></a>
</span><span id="BinaryOperator-604"><a href="#BinaryOperator-604"><span class="linenos">604</span></a>        <span class="k">if</span> <span class="nb">type</span><span class="p">(</span><span class="n">x</span><span class="p">)</span> <span class="ow">in</span> <span class="n">TraceTensor</span><span class="o">.</span><span class="n">PYTHON_TYPES</span><span class="p">:</span>
</span><span id="BinaryOperator-605"><a href="#BinaryOperator-605"><span class="linenos">605</span></a>            <span class="n">x</span> <span class="o">=</span> <span class="n">backend</span><span class="o">.</span><span class="n">full</span><span class="p">(</span><span class="n">shape</span><span class="o">=</span><span class="p">(),</span> <span class="n">fill_value</span><span class="o">=</span><span class="n">x</span><span class="p">,</span> <span class="n">dtype</span><span class="o">=</span><span class="n">w</span><span class="o">.</span><span class="n">dtype</span><span class="p">)</span>
</span><span id="BinaryOperator-606"><a href="#BinaryOperator-606"><span class="linenos">606</span></a>        <span class="k">elif</span> <span class="nb">type</span><span class="p">(</span><span class="n">w</span><span class="p">)</span> <span class="ow">in</span> <span class="n">TraceTensor</span><span class="o">.</span><span class="n">PYTHON_TYPES</span><span class="p">:</span>
</span><span id="BinaryOperator-607"><a href="#BinaryOperator-607"><span class="linenos">607</span></a>            <span class="n">w</span> <span class="o">=</span> <span class="n">backend</span><span class="o">.</span><span class="n">full</span><span class="p">(</span><span class="n">shape</span><span class="o">=</span><span class="p">(),</span> <span class="n">fill_value</span><span class="o">=</span><span class="n">w</span><span class="p">,</span> <span class="n">dtype</span><span class="o">=</span><span class="n">x</span><span class="o">.</span><span class="n">dtype</span><span class="p">)</span>
</span><span id="BinaryOperator-608"><a href="#BinaryOperator-608"><span class="linenos">608</span></a>
</span><span id="BinaryOperator-609"><a href="#BinaryOperator-609"><span class="linenos">609</span></a>        <span class="n">shape_delta</span> <span class="o">=</span> <span class="n">x</span><span class="o">.</span><span class="n">ndim</span> <span class="o">-</span> <span class="n">w</span><span class="o">.</span><span class="n">ndim</span>
</span><span id="BinaryOperator-610"><a href="#BinaryOperator-610"><span class="linenos">610</span></a>        <span class="k">if</span> <span class="n">shape_delta</span> <span class="o">&gt;</span> <span class="mi">0</span><span class="p">:</span>
</span><span id="BinaryOperator-611"><a href="#BinaryOperator-611"><span class="linenos">611</span></a>            <span class="n">w</span> <span class="o">=</span> <span class="n">w</span><span class="o">.</span><span class="n">reshape</span><span class="p">((</span><span class="mi">1</span><span class="p">,)</span> <span class="o">*</span> <span class="n">shape_delta</span> <span class="o">+</span> <span class="n">w</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span>
</span><span id="BinaryOperator-612"><a href="#BinaryOperator-612"><span class="linenos">612</span></a>        <span class="k">elif</span> <span class="n">shape_delta</span> <span class="o">&lt;</span> <span class="mi">0</span><span class="p">:</span>
</span><span id="BinaryOperator-613"><a href="#BinaryOperator-613"><span class="linenos">613</span></a>            <span class="n">x</span> <span class="o">=</span> <span class="n">x</span><span class="o">.</span><span class="n">reshape</span><span class="p">((</span><span class="mi">1</span><span class="p">,)</span> <span class="o">*</span> <span class="o">-</span><span class="n">shape_delta</span> <span class="o">+</span> <span class="n">x</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span>
</span><span id="BinaryOperator-614"><a href="#BinaryOperator-614"><span class="linenos">614</span></a>
</span><span id="BinaryOperator-615"><a href="#BinaryOperator-615"><span class="linenos">615</span></a>        <span class="n">shape_ret</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">([</span><span class="nb">max</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">w</span><span class="p">)</span> <span class="k">for</span> <span class="n">x</span><span class="p">,</span> <span class="n">w</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">shape</span><span class="p">,</span> <span class="n">w</span><span class="o">.</span><span class="n">shape</span><span class="p">)])</span>
</span><span id="BinaryOperator-616"><a href="#BinaryOperator-616"><span class="linenos">616</span></a>        <span class="k">if</span> <span class="n">x</span><span class="o">.</span><span class="n">shape</span> <span class="o">!=</span> <span class="n">shape_ret</span><span class="p">:</span>
</span><span id="BinaryOperator-617"><a href="#BinaryOperator-617"><span class="linenos">617</span></a>            <span class="n">x</span> <span class="o">=</span> <span class="n">x</span><span class="o">.</span><span class="n">expand</span><span class="p">(</span><span class="n">shape_ret</span><span class="p">)</span>
</span><span id="BinaryOperator-618"><a href="#BinaryOperator-618"><span class="linenos">618</span></a>        <span class="k">if</span> <span class="n">w</span><span class="o">.</span><span class="n">shape</span> <span class="o">!=</span> <span class="n">shape_ret</span><span class="p">:</span>
</span><span id="BinaryOperator-619"><a href="#BinaryOperator-619"><span class="linenos">619</span></a>            <span class="n">w</span> <span class="o">=</span> <span class="n">w</span><span class="o">.</span><span class="n">expand</span><span class="p">(</span><span class="n">shape_ret</span><span class="p">)</span>
</span><span id="BinaryOperator-620"><a href="#BinaryOperator-620"><span class="linenos">620</span></a>
</span><span id="BinaryOperator-621"><a href="#BinaryOperator-621"><span class="linenos">621</span></a>        <span class="k">if</span> <span class="nb">type</span><span class="p">(</span><span class="n">x</span><span class="p">)</span> <span class="ow">is</span> <span class="n">Tensor</span> <span class="ow">and</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">w</span><span class="p">,</span> <span class="n">TraceTensor</span><span class="p">):</span>
</span><span id="BinaryOperator-622"><a href="#BinaryOperator-622"><span class="linenos">622</span></a>            <span class="n">x</span> <span class="o">=</span> <span class="n">w</span><span class="o">.</span><span class="n">_trace</span><span class="o">.</span><span class="n">pure</span><span class="p">(</span><span class="n">x</span><span class="p">)</span>
</span><span id="BinaryOperator-623"><a href="#BinaryOperator-623"><span class="linenos">623</span></a>        <span class="k">elif</span> <span class="nb">type</span><span class="p">(</span><span class="n">w</span><span class="p">)</span> <span class="ow">is</span> <span class="n">Tensor</span> <span class="ow">and</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">TraceTensor</span><span class="p">):</span>
</span><span id="BinaryOperator-624"><a href="#BinaryOperator-624"><span class="linenos">624</span></a>            <span class="n">w</span> <span class="o">=</span> <span class="n">x</span><span class="o">.</span><span class="n">_trace</span><span class="o">.</span><span class="n">pure</span><span class="p">(</span><span class="n">w</span><span class="p">)</span>
</span><span id="BinaryOperator-625"><a href="#BinaryOperator-625"><span class="linenos">625</span></a>        <span class="c1"># TODO: https://jax.readthedocs.io/en/latest/type_promotion.html</span>
</span><span id="BinaryOperator-626"><a href="#BinaryOperator-626"><span class="linenos">626</span></a>        <span class="k">if</span> <span class="n">x</span><span class="o">.</span><span class="n">dtype</span> <span class="o">!=</span> <span class="n">w</span><span class="o">.</span><span class="n">dtype</span><span class="p">:</span>
</span><span id="BinaryOperator-627"><a href="#BinaryOperator-627"><span class="linenos">627</span></a>            <span class="c1"># {int, bool} -&gt; float</span>
</span><span id="BinaryOperator-628"><a href="#BinaryOperator-628"><span class="linenos">628</span></a>            <span class="k">if</span> <span class="n">dtypes</span><span class="o">.</span><span class="n">is_float</span><span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">dtype</span><span class="p">)</span> <span class="o">^</span> <span class="n">dtypes</span><span class="o">.</span><span class="n">is_float</span><span class="p">(</span><span class="n">w</span><span class="o">.</span><span class="n">dtype</span><span class="p">):</span>
</span><span id="BinaryOperator-629"><a href="#BinaryOperator-629"><span class="linenos">629</span></a>                <span class="k">if</span> <span class="n">dtypes</span><span class="o">.</span><span class="n">is_float</span><span class="p">(</span><span class="n">w</span><span class="o">.</span><span class="n">dtype</span><span class="p">):</span>
</span><span id="BinaryOperator-630"><a href="#BinaryOperator-630"><span class="linenos">630</span></a>                    <span class="n">x</span> <span class="o">=</span> <span class="n">x</span><span class="o">.</span><span class="n">cast</span><span class="p">(</span><span class="n">w</span><span class="o">.</span><span class="n">dtype</span><span class="p">)</span>
</span><span id="BinaryOperator-631"><a href="#BinaryOperator-631"><span class="linenos">631</span></a>                <span class="k">elif</span> <span class="n">dtypes</span><span class="o">.</span><span class="n">is_float</span><span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">dtype</span><span class="p">):</span>
</span><span id="BinaryOperator-632"><a href="#BinaryOperator-632"><span class="linenos">632</span></a>                    <span class="n">w</span> <span class="o">=</span> <span class="n">w</span><span class="o">.</span><span class="n">cast</span><span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">dtype</span><span class="p">)</span>
</span><span id="BinaryOperator-633"><a href="#BinaryOperator-633"><span class="linenos">633</span></a>            <span class="c1"># bool -&gt; int</span>
</span><span id="BinaryOperator-634"><a href="#BinaryOperator-634"><span class="linenos">634</span></a>            <span class="k">elif</span> <span class="n">dtypes</span><span class="o">.</span><span class="n">is_int</span><span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">dtype</span><span class="p">)</span> <span class="o">^</span> <span class="n">dtypes</span><span class="o">.</span><span class="n">is_int</span><span class="p">(</span><span class="n">w</span><span class="o">.</span><span class="n">dtype</span><span class="p">):</span>
</span><span id="BinaryOperator-635"><a href="#BinaryOperator-635"><span class="linenos">635</span></a>                <span class="k">if</span> <span class="n">dtypes</span><span class="o">.</span><span class="n">is_int</span><span class="p">(</span><span class="n">w</span><span class="o">.</span><span class="n">dtype</span><span class="p">):</span>
</span><span id="BinaryOperator-636"><a href="#BinaryOperator-636"><span class="linenos">636</span></a>                    <span class="n">x</span> <span class="o">=</span> <span class="n">x</span><span class="o">.</span><span class="n">cast</span><span class="p">(</span><span class="n">w</span><span class="o">.</span><span class="n">dtype</span><span class="p">)</span>
</span><span id="BinaryOperator-637"><a href="#BinaryOperator-637"><span class="linenos">637</span></a>                <span class="k">elif</span> <span class="n">dtypes</span><span class="o">.</span><span class="n">is_int</span><span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">dtype</span><span class="p">):</span>
</span><span id="BinaryOperator-638"><a href="#BinaryOperator-638"><span class="linenos">638</span></a>                    <span class="n">w</span> <span class="o">=</span> <span class="n">w</span><span class="o">.</span><span class="n">cast</span><span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">dtype</span><span class="p">)</span>
</span><span id="BinaryOperator-639"><a href="#BinaryOperator-639"><span class="linenos">639</span></a>            <span class="k">else</span><span class="p">:</span>  <span class="c1"># TODO: fine-grained type promotions</span>
</span><span id="BinaryOperator-640"><a href="#BinaryOperator-640"><span class="linenos">640</span></a>                <span class="k">raise</span> <span class="ne">NotImplementedError</span><span class="p">(</span><span class="s2">&quot;No other type promotion rules&quot;</span><span class="p">)</span>
</span><span id="BinaryOperator-641"><a href="#BinaryOperator-641"><span class="linenos">641</span></a>
</span><span id="BinaryOperator-642"><a href="#BinaryOperator-642"><span class="linenos">642</span></a>        <span class="k">return</span> <span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">w</span><span class="p">),</span> <span class="n">params</span>
</span><span id="BinaryOperator-643"><a href="#BinaryOperator-643"><span class="linenos">643</span></a>
</span><span id="BinaryOperator-644"><a href="#BinaryOperator-644"><span class="linenos">644</span></a>    <span class="k">def</span> <span class="nf">vmap</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">dim_size</span><span class="p">,</span> <span class="n">vals_in</span><span class="p">,</span> <span class="n">dims_in</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="BinaryOperator-645"><a href="#BinaryOperator-645"><span class="linenos">645</span></a>        <span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">w</span><span class="p">),</span> <span class="p">(</span><span class="n">x_bdim</span><span class="p">,</span> <span class="n">w_bdim</span><span class="p">)</span> <span class="o">=</span> <span class="n">vals_in</span><span class="p">,</span> <span class="n">dims_in</span>
</span><span id="BinaryOperator-646"><a href="#BinaryOperator-646"><span class="linenos">646</span></a>        <span class="k">if</span> <span class="n">x_bdim</span> <span class="o">!=</span> <span class="n">w_bdim</span><span class="p">:</span>
</span><span id="BinaryOperator-647"><a href="#BinaryOperator-647"><span class="linenos">647</span></a>            <span class="k">if</span> <span class="n">x_bdim</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
</span><span id="BinaryOperator-648"><a href="#BinaryOperator-648"><span class="linenos">648</span></a>                <span class="n">x</span> <span class="o">=</span> <span class="n">VMapTrace</span><span class="o">.</span><span class="n">move_vmap_dim</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">dim_size</span><span class="p">,</span> <span class="n">x_bdim</span><span class="p">,</span> <span class="n">w_bdim</span><span class="p">)</span>
</span><span id="BinaryOperator-649"><a href="#BinaryOperator-649"><span class="linenos">649</span></a>                <span class="n">x_bdim</span> <span class="o">=</span> <span class="n">w_bdim</span>
</span><span id="BinaryOperator-650"><a href="#BinaryOperator-650"><span class="linenos">650</span></a>            <span class="k">else</span><span class="p">:</span>
</span><span id="BinaryOperator-651"><a href="#BinaryOperator-651"><span class="linenos">651</span></a>                <span class="n">w</span> <span class="o">=</span> <span class="n">VMapTrace</span><span class="o">.</span><span class="n">move_vmap_dim</span><span class="p">(</span><span class="n">w</span><span class="p">,</span> <span class="n">dim_size</span><span class="p">,</span> <span class="n">w_bdim</span><span class="p">,</span> <span class="n">x_bdim</span><span class="p">)</span>
</span><span id="BinaryOperator-652"><a href="#BinaryOperator-652"><span class="linenos">652</span></a>        <span class="k">return</span> <span class="p">[</span><span class="bp">self</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">w</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)],</span> <span class="p">[</span><span class="n">x_bdim</span><span class="p">]</span>
</span><span id="BinaryOperator-653"><a href="#BinaryOperator-653"><span class="linenos">653</span></a>
</span><span id="BinaryOperator-654"><a href="#BinaryOperator-654"><span class="linenos">654</span></a>    <span class="k">def</span> <span class="nf">typecheck</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">x</span><span class="p">:</span> <span class="n">SymbolicTensor</span><span class="p">,</span> <span class="n">y</span><span class="p">:</span> <span class="n">SymbolicTensor</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">List</span><span class="p">[</span><span class="n">SymbolicTensor</span><span class="p">]:</span>
</span><span id="BinaryOperator-655"><a href="#BinaryOperator-655"><span class="linenos">655</span></a>        <span class="k">if</span> <span class="ow">not</span> <span class="nb">type</span><span class="p">(</span><span class="n">x</span><span class="p">)</span> <span class="ow">in</span> <span class="p">(</span><span class="n">Tensor</span><span class="p">,</span> <span class="n">SymbolicTensor</span><span class="p">)</span> <span class="ow">or</span> <span class="ow">not</span> <span class="nb">type</span><span class="p">(</span><span class="n">x</span><span class="p">)</span> <span class="ow">in</span> <span class="p">(</span>
</span><span id="BinaryOperator-656"><a href="#BinaryOperator-656"><span class="linenos">656</span></a>            <span class="n">Tensor</span><span class="p">,</span>
</span><span id="BinaryOperator-657"><a href="#BinaryOperator-657"><span class="linenos">657</span></a>            <span class="n">SymbolicTensor</span><span class="p">,</span>
</span><span id="BinaryOperator-658"><a href="#BinaryOperator-658"><span class="linenos">658</span></a>        <span class="p">):</span>
</span><span id="BinaryOperator-659"><a href="#BinaryOperator-659"><span class="linenos">659</span></a>            <span class="k">raise</span> <span class="ne">TypeError</span>
</span><span id="BinaryOperator-660"><a href="#BinaryOperator-660"><span class="linenos">660</span></a>        <span class="n">symx</span> <span class="o">=</span> <span class="n">SymbolicTensor</span><span class="o">.</span><span class="n">like</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">dtype</span><span class="o">=</span><span class="n">dtypes</span><span class="o">.</span><span class="n">bool</span> <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">boolean_output</span> <span class="k">else</span> <span class="n">x</span><span class="o">.</span><span class="n">dtype</span><span class="p">)</span>
</span><span id="BinaryOperator-661"><a href="#BinaryOperator-661"><span class="linenos">661</span></a>        <span class="n">symy</span> <span class="o">=</span> <span class="n">SymbolicTensor</span><span class="o">.</span><span class="n">like</span><span class="p">(</span><span class="n">y</span><span class="p">,</span> <span class="n">dtype</span><span class="o">=</span><span class="n">dtypes</span><span class="o">.</span><span class="n">bool</span> <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">boolean_output</span> <span class="k">else</span> <span class="n">y</span><span class="o">.</span><span class="n">dtype</span><span class="p">)</span>
</span><span id="BinaryOperator-662"><a href="#BinaryOperator-662"><span class="linenos">662</span></a>        <span class="k">if</span> <span class="n">x</span><span class="o">.</span><span class="n">dtype</span> <span class="o">!=</span> <span class="n">y</span><span class="o">.</span><span class="n">dtype</span><span class="p">:</span>
</span><span id="BinaryOperator-663"><a href="#BinaryOperator-663"><span class="linenos">663</span></a>            <span class="k">raise</span> <span class="ne">TypeError</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;x.dtype (</span><span class="si">{</span><span class="n">x</span><span class="o">.</span><span class="n">dtype</span><span class="si">}</span><span class="s2">) != y.dtype (</span><span class="si">{</span><span class="n">y</span><span class="o">.</span><span class="n">dtype</span><span class="si">}</span><span class="s2">)&quot;</span><span class="p">)</span>
</span><span id="BinaryOperator-664"><a href="#BinaryOperator-664"><span class="linenos">664</span></a>        <span class="k">if</span> <span class="n">symx</span> <span class="o">==</span> <span class="n">symy</span><span class="p">:</span>
</span><span id="BinaryOperator-665"><a href="#BinaryOperator-665"><span class="linenos">665</span></a>            <span class="k">return</span> <span class="p">[</span><span class="n">symx</span><span class="p">]</span>
</span><span id="BinaryOperator-666"><a href="#BinaryOperator-666"><span class="linenos">666</span></a>        <span class="n">shape_delta</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">symx</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span> <span class="o">-</span> <span class="nb">len</span><span class="p">(</span><span class="n">symy</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span>
</span><span id="BinaryOperator-667"><a href="#BinaryOperator-667"><span class="linenos">667</span></a>        <span class="k">if</span> <span class="n">shape_delta</span> <span class="o">&gt;</span> <span class="mi">0</span><span class="p">:</span>
</span><span id="BinaryOperator-668"><a href="#BinaryOperator-668"><span class="linenos">668</span></a>            <span class="n">symy</span> <span class="o">=</span> <span class="n">symy</span><span class="o">.</span><span class="n">like</span><span class="p">(</span><span class="n">shape</span><span class="o">=</span><span class="p">(</span><span class="mi">1</span><span class="p">,)</span> <span class="o">*</span> <span class="n">shape_delta</span> <span class="o">+</span> <span class="n">symy</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span>
</span><span id="BinaryOperator-669"><a href="#BinaryOperator-669"><span class="linenos">669</span></a>        <span class="k">elif</span> <span class="n">shape_delta</span> <span class="o">&lt;</span> <span class="mi">0</span><span class="p">:</span>
</span><span id="BinaryOperator-670"><a href="#BinaryOperator-670"><span class="linenos">670</span></a>            <span class="n">x</span> <span class="o">=</span> <span class="n">x</span><span class="o">.</span><span class="n">reshape</span><span class="p">((</span><span class="mi">1</span><span class="p">,)</span> <span class="o">*</span> <span class="o">-</span><span class="n">shape_delta</span> <span class="o">+</span> <span class="n">symx</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span>
</span><span id="BinaryOperator-671"><a href="#BinaryOperator-671"><span class="linenos">671</span></a>            <span class="n">symx</span> <span class="o">=</span> <span class="n">symx</span><span class="o">.</span><span class="n">like</span><span class="p">(</span><span class="n">shape</span><span class="o">=</span><span class="p">(</span><span class="mi">1</span><span class="p">,)</span> <span class="o">*</span> <span class="o">-</span><span class="n">shape_delta</span> <span class="o">+</span> <span class="n">symx</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span>
</span><span id="BinaryOperator-672"><a href="#BinaryOperator-672"><span class="linenos">672</span></a>        <span class="k">if</span> <span class="n">symx</span> <span class="o">==</span> <span class="n">symy</span><span class="p">:</span>
</span><span id="BinaryOperator-673"><a href="#BinaryOperator-673"><span class="linenos">673</span></a>            <span class="k">return</span> <span class="p">[</span><span class="n">symx</span><span class="p">]</span>
</span><span id="BinaryOperator-674"><a href="#BinaryOperator-674"><span class="linenos">674</span></a>        <span class="k">else</span><span class="p">:</span>
</span><span id="BinaryOperator-675"><a href="#BinaryOperator-675"><span class="linenos">675</span></a>            <span class="n">shape_ret</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">([</span><span class="nb">max</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">w</span><span class="p">)</span> <span class="k">for</span> <span class="n">x</span><span class="p">,</span> <span class="n">w</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">symx</span><span class="o">.</span><span class="n">shape</span><span class="p">,</span> <span class="n">symy</span><span class="o">.</span><span class="n">shape</span><span class="p">)])</span>
</span><span id="BinaryOperator-676"><a href="#BinaryOperator-676"><span class="linenos">676</span></a>            <span class="k">if</span> <span class="n">symx</span><span class="o">.</span><span class="n">shape</span> <span class="o">!=</span> <span class="n">shape_ret</span><span class="p">:</span>
</span><span id="BinaryOperator-677"><a href="#BinaryOperator-677"><span class="linenos">677</span></a>                <span class="n">symx</span> <span class="o">=</span> <span class="n">symx</span><span class="o">.</span><span class="n">like</span><span class="p">(</span><span class="n">shape</span><span class="o">=</span><span class="n">shape_ret</span><span class="p">)</span>
</span><span id="BinaryOperator-678"><a href="#BinaryOperator-678"><span class="linenos">678</span></a>            <span class="k">if</span> <span class="n">symy</span><span class="o">.</span><span class="n">shape</span> <span class="o">!=</span> <span class="n">shape_ret</span><span class="p">:</span>
</span><span id="BinaryOperator-679"><a href="#BinaryOperator-679"><span class="linenos">679</span></a>                <span class="n">symy</span> <span class="o">=</span> <span class="n">symx</span><span class="o">.</span><span class="n">like</span><span class="p">(</span><span class="n">shape</span><span class="o">=</span><span class="n">shape_ret</span><span class="p">)</span>
</span><span id="BinaryOperator-680"><a href="#BinaryOperator-680"><span class="linenos">680</span></a>            <span class="k">if</span> <span class="n">symx</span> <span class="o">!=</span> <span class="n">symy</span><span class="p">:</span>
</span><span id="BinaryOperator-681"><a href="#BinaryOperator-681"><span class="linenos">681</span></a>                <span class="k">raise</span> <span class="ne">TypeError</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;symx (</span><span class="si">{</span><span class="n">symx</span><span class="si">}</span><span class="s2">) != symy (</span><span class="si">{</span><span class="n">symy</span><span class="si">}</span><span class="s2">)&quot;</span><span class="p">)</span>
</span><span id="BinaryOperator-682"><a href="#BinaryOperator-682"><span class="linenos">682</span></a>            <span class="k">return</span> <span class="p">[</span><span class="n">symx</span><span class="p">]</span>
</span><span id="BinaryOperator-683"><a href="#BinaryOperator-683"><span class="linenos">683</span></a>
</span><span id="BinaryOperator-684"><a href="#BinaryOperator-684"><span class="linenos">684</span></a>    <span class="k">def</span> <span class="nf">jvp</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">primals</span><span class="p">,</span> <span class="n">tangents</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="BinaryOperator-685"><a href="#BinaryOperator-685"><span class="linenos">685</span></a>        <span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">w</span><span class="p">),</span> <span class="p">(</span><span class="n">x_dot</span><span class="p">,</span> <span class="n">w_dot</span><span class="p">)</span> <span class="o">=</span> <span class="n">primals</span><span class="p">,</span> <span class="n">tangents</span>
</span><span id="BinaryOperator-686"><a href="#BinaryOperator-686"><span class="linenos">686</span></a>        <span class="k">return</span> <span class="p">[</span><span class="bp">self</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">w</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)],</span> <span class="p">[</span><span class="bp">self</span><span class="p">(</span><span class="n">x_dot</span><span class="p">,</span> <span class="n">w_dot</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)]</span>
</span><span id="BinaryOperator-687"><a href="#BinaryOperator-687"><span class="linenos">687</span></a>
</span><span id="BinaryOperator-688"><a href="#BinaryOperator-688"><span class="linenos">688</span></a>    <span class="k">def</span> <span class="nf">T</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">cotangents</span><span class="p">,</span> <span class="n">x</span><span class="p">,</span> <span class="n">w</span><span class="p">):</span>
</span><span id="BinaryOperator-689"><a href="#BinaryOperator-689"><span class="linenos">689</span></a>        <span class="p">(</span><span class="n">gL_y</span><span class="p">,)</span> <span class="o">=</span> <span class="n">cotangents</span>
</span><span id="BinaryOperator-690"><a href="#BinaryOperator-690"><span class="linenos">690</span></a>        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">boolean_output</span><span class="p">:</span>
</span><span id="BinaryOperator-691"><a href="#BinaryOperator-691"><span class="linenos">691</span></a>            <span class="n">gL_y</span> <span class="o">=</span> <span class="n">gL_y</span><span class="o">.</span><span class="n">cast</span><span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">dtype</span><span class="p">)</span>
</span><span id="BinaryOperator-692"><a href="#BinaryOperator-692"><span class="linenos">692</span></a>        <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">UndefinedPrimal</span><span class="p">):</span>
</span><span id="BinaryOperator-693"><a href="#BinaryOperator-693"><span class="linenos">693</span></a>            <span class="k">return</span> <span class="p">[</span><span class="n">gL_y</span><span class="p">,</span> <span class="n">NullCotangent</span><span class="p">]</span>
</span><span id="BinaryOperator-694"><a href="#BinaryOperator-694"><span class="linenos">694</span></a>        <span class="k">elif</span> <span class="nb">type</span><span class="p">(</span><span class="n">w</span><span class="p">)</span> <span class="ow">is</span> <span class="n">UndefinedPrimal</span><span class="p">:</span>
</span><span id="BinaryOperator-695"><a href="#BinaryOperator-695"><span class="linenos">695</span></a>            <span class="k">return</span> <span class="p">[</span><span class="n">NullCotangent</span><span class="p">,</span> <span class="n">gL_y</span><span class="p">]</span>
</span></pre></div>


    

                            <div id="BinaryOperator.boolean_output" class="classattr">
                                <div class="attr variable">
            <span class="name">boolean_output</span>        =
<span class="default_value">False</span>

        
    </div>
    <a class="headerlink" href="#BinaryOperator.boolean_output"></a>
    
    

                            </div>
                            <div id="BinaryOperator.args_fixer" class="classattr">
                                        <input id="BinaryOperator.args_fixer-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">args_fixer</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="n">x</span>, </span><span class="param"><span class="n">w</span>, </span><span class="param"><span class="o">**</span><span class="n">params</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="BinaryOperator.args_fixer-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#BinaryOperator.args_fixer"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="BinaryOperator.args_fixer-599"><a href="#BinaryOperator.args_fixer-599"><span class="linenos">599</span></a>    <span class="k">def</span> <span class="nf">args_fixer</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">x</span><span class="p">,</span> <span class="n">w</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="BinaryOperator.args_fixer-600"><a href="#BinaryOperator.args_fixer-600"><span class="linenos">600</span></a>        <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">UndefinedPrimal</span><span class="p">)</span> <span class="ow">or</span> <span class="nb">type</span><span class="p">(</span><span class="n">w</span><span class="p">)</span> <span class="ow">is</span> <span class="n">UndefinedPrimal</span><span class="p">:</span>
</span><span id="BinaryOperator.args_fixer-601"><a href="#BinaryOperator.args_fixer-601"><span class="linenos">601</span></a>            <span class="k">assert</span> <span class="n">x</span><span class="o">.</span><span class="n">shape</span> <span class="o">==</span> <span class="n">w</span><span class="o">.</span><span class="n">shape</span>
</span><span id="BinaryOperator.args_fixer-602"><a href="#BinaryOperator.args_fixer-602"><span class="linenos">602</span></a>            <span class="k">return</span> <span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">w</span><span class="p">),</span> <span class="n">params</span>
</span><span id="BinaryOperator.args_fixer-603"><a href="#BinaryOperator.args_fixer-603"><span class="linenos">603</span></a>
</span><span id="BinaryOperator.args_fixer-604"><a href="#BinaryOperator.args_fixer-604"><span class="linenos">604</span></a>        <span class="k">if</span> <span class="nb">type</span><span class="p">(</span><span class="n">x</span><span class="p">)</span> <span class="ow">in</span> <span class="n">TraceTensor</span><span class="o">.</span><span class="n">PYTHON_TYPES</span><span class="p">:</span>
</span><span id="BinaryOperator.args_fixer-605"><a href="#BinaryOperator.args_fixer-605"><span class="linenos">605</span></a>            <span class="n">x</span> <span class="o">=</span> <span class="n">backend</span><span class="o">.</span><span class="n">full</span><span class="p">(</span><span class="n">shape</span><span class="o">=</span><span class="p">(),</span> <span class="n">fill_value</span><span class="o">=</span><span class="n">x</span><span class="p">,</span> <span class="n">dtype</span><span class="o">=</span><span class="n">w</span><span class="o">.</span><span class="n">dtype</span><span class="p">)</span>
</span><span id="BinaryOperator.args_fixer-606"><a href="#BinaryOperator.args_fixer-606"><span class="linenos">606</span></a>        <span class="k">elif</span> <span class="nb">type</span><span class="p">(</span><span class="n">w</span><span class="p">)</span> <span class="ow">in</span> <span class="n">TraceTensor</span><span class="o">.</span><span class="n">PYTHON_TYPES</span><span class="p">:</span>
</span><span id="BinaryOperator.args_fixer-607"><a href="#BinaryOperator.args_fixer-607"><span class="linenos">607</span></a>            <span class="n">w</span> <span class="o">=</span> <span class="n">backend</span><span class="o">.</span><span class="n">full</span><span class="p">(</span><span class="n">shape</span><span class="o">=</span><span class="p">(),</span> <span class="n">fill_value</span><span class="o">=</span><span class="n">w</span><span class="p">,</span> <span class="n">dtype</span><span class="o">=</span><span class="n">x</span><span class="o">.</span><span class="n">dtype</span><span class="p">)</span>
</span><span id="BinaryOperator.args_fixer-608"><a href="#BinaryOperator.args_fixer-608"><span class="linenos">608</span></a>
</span><span id="BinaryOperator.args_fixer-609"><a href="#BinaryOperator.args_fixer-609"><span class="linenos">609</span></a>        <span class="n">shape_delta</span> <span class="o">=</span> <span class="n">x</span><span class="o">.</span><span class="n">ndim</span> <span class="o">-</span> <span class="n">w</span><span class="o">.</span><span class="n">ndim</span>
</span><span id="BinaryOperator.args_fixer-610"><a href="#BinaryOperator.args_fixer-610"><span class="linenos">610</span></a>        <span class="k">if</span> <span class="n">shape_delta</span> <span class="o">&gt;</span> <span class="mi">0</span><span class="p">:</span>
</span><span id="BinaryOperator.args_fixer-611"><a href="#BinaryOperator.args_fixer-611"><span class="linenos">611</span></a>            <span class="n">w</span> <span class="o">=</span> <span class="n">w</span><span class="o">.</span><span class="n">reshape</span><span class="p">((</span><span class="mi">1</span><span class="p">,)</span> <span class="o">*</span> <span class="n">shape_delta</span> <span class="o">+</span> <span class="n">w</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span>
</span><span id="BinaryOperator.args_fixer-612"><a href="#BinaryOperator.args_fixer-612"><span class="linenos">612</span></a>        <span class="k">elif</span> <span class="n">shape_delta</span> <span class="o">&lt;</span> <span class="mi">0</span><span class="p">:</span>
</span><span id="BinaryOperator.args_fixer-613"><a href="#BinaryOperator.args_fixer-613"><span class="linenos">613</span></a>            <span class="n">x</span> <span class="o">=</span> <span class="n">x</span><span class="o">.</span><span class="n">reshape</span><span class="p">((</span><span class="mi">1</span><span class="p">,)</span> <span class="o">*</span> <span class="o">-</span><span class="n">shape_delta</span> <span class="o">+</span> <span class="n">x</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span>
</span><span id="BinaryOperator.args_fixer-614"><a href="#BinaryOperator.args_fixer-614"><span class="linenos">614</span></a>
</span><span id="BinaryOperator.args_fixer-615"><a href="#BinaryOperator.args_fixer-615"><span class="linenos">615</span></a>        <span class="n">shape_ret</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">([</span><span class="nb">max</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">w</span><span class="p">)</span> <span class="k">for</span> <span class="n">x</span><span class="p">,</span> <span class="n">w</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">shape</span><span class="p">,</span> <span class="n">w</span><span class="o">.</span><span class="n">shape</span><span class="p">)])</span>
</span><span id="BinaryOperator.args_fixer-616"><a href="#BinaryOperator.args_fixer-616"><span class="linenos">616</span></a>        <span class="k">if</span> <span class="n">x</span><span class="o">.</span><span class="n">shape</span> <span class="o">!=</span> <span class="n">shape_ret</span><span class="p">:</span>
</span><span id="BinaryOperator.args_fixer-617"><a href="#BinaryOperator.args_fixer-617"><span class="linenos">617</span></a>            <span class="n">x</span> <span class="o">=</span> <span class="n">x</span><span class="o">.</span><span class="n">expand</span><span class="p">(</span><span class="n">shape_ret</span><span class="p">)</span>
</span><span id="BinaryOperator.args_fixer-618"><a href="#BinaryOperator.args_fixer-618"><span class="linenos">618</span></a>        <span class="k">if</span> <span class="n">w</span><span class="o">.</span><span class="n">shape</span> <span class="o">!=</span> <span class="n">shape_ret</span><span class="p">:</span>
</span><span id="BinaryOperator.args_fixer-619"><a href="#BinaryOperator.args_fixer-619"><span class="linenos">619</span></a>            <span class="n">w</span> <span class="o">=</span> <span class="n">w</span><span class="o">.</span><span class="n">expand</span><span class="p">(</span><span class="n">shape_ret</span><span class="p">)</span>
</span><span id="BinaryOperator.args_fixer-620"><a href="#BinaryOperator.args_fixer-620"><span class="linenos">620</span></a>
</span><span id="BinaryOperator.args_fixer-621"><a href="#BinaryOperator.args_fixer-621"><span class="linenos">621</span></a>        <span class="k">if</span> <span class="nb">type</span><span class="p">(</span><span class="n">x</span><span class="p">)</span> <span class="ow">is</span> <span class="n">Tensor</span> <span class="ow">and</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">w</span><span class="p">,</span> <span class="n">TraceTensor</span><span class="p">):</span>
</span><span id="BinaryOperator.args_fixer-622"><a href="#BinaryOperator.args_fixer-622"><span class="linenos">622</span></a>            <span class="n">x</span> <span class="o">=</span> <span class="n">w</span><span class="o">.</span><span class="n">_trace</span><span class="o">.</span><span class="n">pure</span><span class="p">(</span><span class="n">x</span><span class="p">)</span>
</span><span id="BinaryOperator.args_fixer-623"><a href="#BinaryOperator.args_fixer-623"><span class="linenos">623</span></a>        <span class="k">elif</span> <span class="nb">type</span><span class="p">(</span><span class="n">w</span><span class="p">)</span> <span class="ow">is</span> <span class="n">Tensor</span> <span class="ow">and</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">TraceTensor</span><span class="p">):</span>
</span><span id="BinaryOperator.args_fixer-624"><a href="#BinaryOperator.args_fixer-624"><span class="linenos">624</span></a>            <span class="n">w</span> <span class="o">=</span> <span class="n">x</span><span class="o">.</span><span class="n">_trace</span><span class="o">.</span><span class="n">pure</span><span class="p">(</span><span class="n">w</span><span class="p">)</span>
</span><span id="BinaryOperator.args_fixer-625"><a href="#BinaryOperator.args_fixer-625"><span class="linenos">625</span></a>        <span class="c1"># TODO: https://jax.readthedocs.io/en/latest/type_promotion.html</span>
</span><span id="BinaryOperator.args_fixer-626"><a href="#BinaryOperator.args_fixer-626"><span class="linenos">626</span></a>        <span class="k">if</span> <span class="n">x</span><span class="o">.</span><span class="n">dtype</span> <span class="o">!=</span> <span class="n">w</span><span class="o">.</span><span class="n">dtype</span><span class="p">:</span>
</span><span id="BinaryOperator.args_fixer-627"><a href="#BinaryOperator.args_fixer-627"><span class="linenos">627</span></a>            <span class="c1"># {int, bool} -&gt; float</span>
</span><span id="BinaryOperator.args_fixer-628"><a href="#BinaryOperator.args_fixer-628"><span class="linenos">628</span></a>            <span class="k">if</span> <span class="n">dtypes</span><span class="o">.</span><span class="n">is_float</span><span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">dtype</span><span class="p">)</span> <span class="o">^</span> <span class="n">dtypes</span><span class="o">.</span><span class="n">is_float</span><span class="p">(</span><span class="n">w</span><span class="o">.</span><span class="n">dtype</span><span class="p">):</span>
</span><span id="BinaryOperator.args_fixer-629"><a href="#BinaryOperator.args_fixer-629"><span class="linenos">629</span></a>                <span class="k">if</span> <span class="n">dtypes</span><span class="o">.</span><span class="n">is_float</span><span class="p">(</span><span class="n">w</span><span class="o">.</span><span class="n">dtype</span><span class="p">):</span>
</span><span id="BinaryOperator.args_fixer-630"><a href="#BinaryOperator.args_fixer-630"><span class="linenos">630</span></a>                    <span class="n">x</span> <span class="o">=</span> <span class="n">x</span><span class="o">.</span><span class="n">cast</span><span class="p">(</span><span class="n">w</span><span class="o">.</span><span class="n">dtype</span><span class="p">)</span>
</span><span id="BinaryOperator.args_fixer-631"><a href="#BinaryOperator.args_fixer-631"><span class="linenos">631</span></a>                <span class="k">elif</span> <span class="n">dtypes</span><span class="o">.</span><span class="n">is_float</span><span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">dtype</span><span class="p">):</span>
</span><span id="BinaryOperator.args_fixer-632"><a href="#BinaryOperator.args_fixer-632"><span class="linenos">632</span></a>                    <span class="n">w</span> <span class="o">=</span> <span class="n">w</span><span class="o">.</span><span class="n">cast</span><span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">dtype</span><span class="p">)</span>
</span><span id="BinaryOperator.args_fixer-633"><a href="#BinaryOperator.args_fixer-633"><span class="linenos">633</span></a>            <span class="c1"># bool -&gt; int</span>
</span><span id="BinaryOperator.args_fixer-634"><a href="#BinaryOperator.args_fixer-634"><span class="linenos">634</span></a>            <span class="k">elif</span> <span class="n">dtypes</span><span class="o">.</span><span class="n">is_int</span><span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">dtype</span><span class="p">)</span> <span class="o">^</span> <span class="n">dtypes</span><span class="o">.</span><span class="n">is_int</span><span class="p">(</span><span class="n">w</span><span class="o">.</span><span class="n">dtype</span><span class="p">):</span>
</span><span id="BinaryOperator.args_fixer-635"><a href="#BinaryOperator.args_fixer-635"><span class="linenos">635</span></a>                <span class="k">if</span> <span class="n">dtypes</span><span class="o">.</span><span class="n">is_int</span><span class="p">(</span><span class="n">w</span><span class="o">.</span><span class="n">dtype</span><span class="p">):</span>
</span><span id="BinaryOperator.args_fixer-636"><a href="#BinaryOperator.args_fixer-636"><span class="linenos">636</span></a>                    <span class="n">x</span> <span class="o">=</span> <span class="n">x</span><span class="o">.</span><span class="n">cast</span><span class="p">(</span><span class="n">w</span><span class="o">.</span><span class="n">dtype</span><span class="p">)</span>
</span><span id="BinaryOperator.args_fixer-637"><a href="#BinaryOperator.args_fixer-637"><span class="linenos">637</span></a>                <span class="k">elif</span> <span class="n">dtypes</span><span class="o">.</span><span class="n">is_int</span><span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">dtype</span><span class="p">):</span>
</span><span id="BinaryOperator.args_fixer-638"><a href="#BinaryOperator.args_fixer-638"><span class="linenos">638</span></a>                    <span class="n">w</span> <span class="o">=</span> <span class="n">w</span><span class="o">.</span><span class="n">cast</span><span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">dtype</span><span class="p">)</span>
</span><span id="BinaryOperator.args_fixer-639"><a href="#BinaryOperator.args_fixer-639"><span class="linenos">639</span></a>            <span class="k">else</span><span class="p">:</span>  <span class="c1"># TODO: fine-grained type promotions</span>
</span><span id="BinaryOperator.args_fixer-640"><a href="#BinaryOperator.args_fixer-640"><span class="linenos">640</span></a>                <span class="k">raise</span> <span class="ne">NotImplementedError</span><span class="p">(</span><span class="s2">&quot;No other type promotion rules&quot;</span><span class="p">)</span>
</span><span id="BinaryOperator.args_fixer-641"><a href="#BinaryOperator.args_fixer-641"><span class="linenos">641</span></a>
</span><span id="BinaryOperator.args_fixer-642"><a href="#BinaryOperator.args_fixer-642"><span class="linenos">642</span></a>        <span class="k">return</span> <span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">w</span><span class="p">),</span> <span class="n">params</span>
</span></pre></div>


    

                            </div>
                            <div id="BinaryOperator.vmap" class="classattr">
                                        <input id="BinaryOperator.vmap-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">vmap</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="n">dim_size</span>, </span><span class="param"><span class="n">vals_in</span>, </span><span class="param"><span class="n">dims_in</span>, </span><span class="param"><span class="o">**</span><span class="n">params</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="BinaryOperator.vmap-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#BinaryOperator.vmap"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="BinaryOperator.vmap-644"><a href="#BinaryOperator.vmap-644"><span class="linenos">644</span></a>    <span class="k">def</span> <span class="nf">vmap</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">dim_size</span><span class="p">,</span> <span class="n">vals_in</span><span class="p">,</span> <span class="n">dims_in</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="BinaryOperator.vmap-645"><a href="#BinaryOperator.vmap-645"><span class="linenos">645</span></a>        <span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">w</span><span class="p">),</span> <span class="p">(</span><span class="n">x_bdim</span><span class="p">,</span> <span class="n">w_bdim</span><span class="p">)</span> <span class="o">=</span> <span class="n">vals_in</span><span class="p">,</span> <span class="n">dims_in</span>
</span><span id="BinaryOperator.vmap-646"><a href="#BinaryOperator.vmap-646"><span class="linenos">646</span></a>        <span class="k">if</span> <span class="n">x_bdim</span> <span class="o">!=</span> <span class="n">w_bdim</span><span class="p">:</span>
</span><span id="BinaryOperator.vmap-647"><a href="#BinaryOperator.vmap-647"><span class="linenos">647</span></a>            <span class="k">if</span> <span class="n">x_bdim</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
</span><span id="BinaryOperator.vmap-648"><a href="#BinaryOperator.vmap-648"><span class="linenos">648</span></a>                <span class="n">x</span> <span class="o">=</span> <span class="n">VMapTrace</span><span class="o">.</span><span class="n">move_vmap_dim</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">dim_size</span><span class="p">,</span> <span class="n">x_bdim</span><span class="p">,</span> <span class="n">w_bdim</span><span class="p">)</span>
</span><span id="BinaryOperator.vmap-649"><a href="#BinaryOperator.vmap-649"><span class="linenos">649</span></a>                <span class="n">x_bdim</span> <span class="o">=</span> <span class="n">w_bdim</span>
</span><span id="BinaryOperator.vmap-650"><a href="#BinaryOperator.vmap-650"><span class="linenos">650</span></a>            <span class="k">else</span><span class="p">:</span>
</span><span id="BinaryOperator.vmap-651"><a href="#BinaryOperator.vmap-651"><span class="linenos">651</span></a>                <span class="n">w</span> <span class="o">=</span> <span class="n">VMapTrace</span><span class="o">.</span><span class="n">move_vmap_dim</span><span class="p">(</span><span class="n">w</span><span class="p">,</span> <span class="n">dim_size</span><span class="p">,</span> <span class="n">w_bdim</span><span class="p">,</span> <span class="n">x_bdim</span><span class="p">)</span>
</span><span id="BinaryOperator.vmap-652"><a href="#BinaryOperator.vmap-652"><span class="linenos">652</span></a>        <span class="k">return</span> <span class="p">[</span><span class="bp">self</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">w</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)],</span> <span class="p">[</span><span class="n">x_bdim</span><span class="p">]</span>
</span></pre></div>


    

                            </div>
                            <div id="BinaryOperator.typecheck" class="classattr">
                                        <input id="BinaryOperator.typecheck-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">typecheck</span><span class="signature pdoc-code multiline">(<span class="param">	<span class="bp">self</span>,</span><span class="param">	<span class="n">x</span><span class="p">:</span> <span class="n"><a href="#SymbolicTensor">SymbolicTensor</a></span>,</span><span class="param">	<span class="n">y</span><span class="p">:</span> <span class="n"><a href="#SymbolicTensor">SymbolicTensor</a></span>,</span><span class="param">	<span class="o">**</span><span class="n">params</span></span><span class="return-annotation">) -> <span class="n">List</span><span class="p">[</span><span class="n"><a href="#SymbolicTensor">SymbolicTensor</a></span><span class="p">]</span>:</span></span>

                <label class="view-source-button" for="BinaryOperator.typecheck-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#BinaryOperator.typecheck"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="BinaryOperator.typecheck-654"><a href="#BinaryOperator.typecheck-654"><span class="linenos">654</span></a>    <span class="k">def</span> <span class="nf">typecheck</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">x</span><span class="p">:</span> <span class="n">SymbolicTensor</span><span class="p">,</span> <span class="n">y</span><span class="p">:</span> <span class="n">SymbolicTensor</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">List</span><span class="p">[</span><span class="n">SymbolicTensor</span><span class="p">]:</span>
</span><span id="BinaryOperator.typecheck-655"><a href="#BinaryOperator.typecheck-655"><span class="linenos">655</span></a>        <span class="k">if</span> <span class="ow">not</span> <span class="nb">type</span><span class="p">(</span><span class="n">x</span><span class="p">)</span> <span class="ow">in</span> <span class="p">(</span><span class="n">Tensor</span><span class="p">,</span> <span class="n">SymbolicTensor</span><span class="p">)</span> <span class="ow">or</span> <span class="ow">not</span> <span class="nb">type</span><span class="p">(</span><span class="n">x</span><span class="p">)</span> <span class="ow">in</span> <span class="p">(</span>
</span><span id="BinaryOperator.typecheck-656"><a href="#BinaryOperator.typecheck-656"><span class="linenos">656</span></a>            <span class="n">Tensor</span><span class="p">,</span>
</span><span id="BinaryOperator.typecheck-657"><a href="#BinaryOperator.typecheck-657"><span class="linenos">657</span></a>            <span class="n">SymbolicTensor</span><span class="p">,</span>
</span><span id="BinaryOperator.typecheck-658"><a href="#BinaryOperator.typecheck-658"><span class="linenos">658</span></a>        <span class="p">):</span>
</span><span id="BinaryOperator.typecheck-659"><a href="#BinaryOperator.typecheck-659"><span class="linenos">659</span></a>            <span class="k">raise</span> <span class="ne">TypeError</span>
</span><span id="BinaryOperator.typecheck-660"><a href="#BinaryOperator.typecheck-660"><span class="linenos">660</span></a>        <span class="n">symx</span> <span class="o">=</span> <span class="n">SymbolicTensor</span><span class="o">.</span><span class="n">like</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">dtype</span><span class="o">=</span><span class="n">dtypes</span><span class="o">.</span><span class="n">bool</span> <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">boolean_output</span> <span class="k">else</span> <span class="n">x</span><span class="o">.</span><span class="n">dtype</span><span class="p">)</span>
</span><span id="BinaryOperator.typecheck-661"><a href="#BinaryOperator.typecheck-661"><span class="linenos">661</span></a>        <span class="n">symy</span> <span class="o">=</span> <span class="n">SymbolicTensor</span><span class="o">.</span><span class="n">like</span><span class="p">(</span><span class="n">y</span><span class="p">,</span> <span class="n">dtype</span><span class="o">=</span><span class="n">dtypes</span><span class="o">.</span><span class="n">bool</span> <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">boolean_output</span> <span class="k">else</span> <span class="n">y</span><span class="o">.</span><span class="n">dtype</span><span class="p">)</span>
</span><span id="BinaryOperator.typecheck-662"><a href="#BinaryOperator.typecheck-662"><span class="linenos">662</span></a>        <span class="k">if</span> <span class="n">x</span><span class="o">.</span><span class="n">dtype</span> <span class="o">!=</span> <span class="n">y</span><span class="o">.</span><span class="n">dtype</span><span class="p">:</span>
</span><span id="BinaryOperator.typecheck-663"><a href="#BinaryOperator.typecheck-663"><span class="linenos">663</span></a>            <span class="k">raise</span> <span class="ne">TypeError</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;x.dtype (</span><span class="si">{</span><span class="n">x</span><span class="o">.</span><span class="n">dtype</span><span class="si">}</span><span class="s2">) != y.dtype (</span><span class="si">{</span><span class="n">y</span><span class="o">.</span><span class="n">dtype</span><span class="si">}</span><span class="s2">)&quot;</span><span class="p">)</span>
</span><span id="BinaryOperator.typecheck-664"><a href="#BinaryOperator.typecheck-664"><span class="linenos">664</span></a>        <span class="k">if</span> <span class="n">symx</span> <span class="o">==</span> <span class="n">symy</span><span class="p">:</span>
</span><span id="BinaryOperator.typecheck-665"><a href="#BinaryOperator.typecheck-665"><span class="linenos">665</span></a>            <span class="k">return</span> <span class="p">[</span><span class="n">symx</span><span class="p">]</span>
</span><span id="BinaryOperator.typecheck-666"><a href="#BinaryOperator.typecheck-666"><span class="linenos">666</span></a>        <span class="n">shape_delta</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">symx</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span> <span class="o">-</span> <span class="nb">len</span><span class="p">(</span><span class="n">symy</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span>
</span><span id="BinaryOperator.typecheck-667"><a href="#BinaryOperator.typecheck-667"><span class="linenos">667</span></a>        <span class="k">if</span> <span class="n">shape_delta</span> <span class="o">&gt;</span> <span class="mi">0</span><span class="p">:</span>
</span><span id="BinaryOperator.typecheck-668"><a href="#BinaryOperator.typecheck-668"><span class="linenos">668</span></a>            <span class="n">symy</span> <span class="o">=</span> <span class="n">symy</span><span class="o">.</span><span class="n">like</span><span class="p">(</span><span class="n">shape</span><span class="o">=</span><span class="p">(</span><span class="mi">1</span><span class="p">,)</span> <span class="o">*</span> <span class="n">shape_delta</span> <span class="o">+</span> <span class="n">symy</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span>
</span><span id="BinaryOperator.typecheck-669"><a href="#BinaryOperator.typecheck-669"><span class="linenos">669</span></a>        <span class="k">elif</span> <span class="n">shape_delta</span> <span class="o">&lt;</span> <span class="mi">0</span><span class="p">:</span>
</span><span id="BinaryOperator.typecheck-670"><a href="#BinaryOperator.typecheck-670"><span class="linenos">670</span></a>            <span class="n">x</span> <span class="o">=</span> <span class="n">x</span><span class="o">.</span><span class="n">reshape</span><span class="p">((</span><span class="mi">1</span><span class="p">,)</span> <span class="o">*</span> <span class="o">-</span><span class="n">shape_delta</span> <span class="o">+</span> <span class="n">symx</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span>
</span><span id="BinaryOperator.typecheck-671"><a href="#BinaryOperator.typecheck-671"><span class="linenos">671</span></a>            <span class="n">symx</span> <span class="o">=</span> <span class="n">symx</span><span class="o">.</span><span class="n">like</span><span class="p">(</span><span class="n">shape</span><span class="o">=</span><span class="p">(</span><span class="mi">1</span><span class="p">,)</span> <span class="o">*</span> <span class="o">-</span><span class="n">shape_delta</span> <span class="o">+</span> <span class="n">symx</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span>
</span><span id="BinaryOperator.typecheck-672"><a href="#BinaryOperator.typecheck-672"><span class="linenos">672</span></a>        <span class="k">if</span> <span class="n">symx</span> <span class="o">==</span> <span class="n">symy</span><span class="p">:</span>
</span><span id="BinaryOperator.typecheck-673"><a href="#BinaryOperator.typecheck-673"><span class="linenos">673</span></a>            <span class="k">return</span> <span class="p">[</span><span class="n">symx</span><span class="p">]</span>
</span><span id="BinaryOperator.typecheck-674"><a href="#BinaryOperator.typecheck-674"><span class="linenos">674</span></a>        <span class="k">else</span><span class="p">:</span>
</span><span id="BinaryOperator.typecheck-675"><a href="#BinaryOperator.typecheck-675"><span class="linenos">675</span></a>            <span class="n">shape_ret</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">([</span><span class="nb">max</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">w</span><span class="p">)</span> <span class="k">for</span> <span class="n">x</span><span class="p">,</span> <span class="n">w</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">symx</span><span class="o">.</span><span class="n">shape</span><span class="p">,</span> <span class="n">symy</span><span class="o">.</span><span class="n">shape</span><span class="p">)])</span>
</span><span id="BinaryOperator.typecheck-676"><a href="#BinaryOperator.typecheck-676"><span class="linenos">676</span></a>            <span class="k">if</span> <span class="n">symx</span><span class="o">.</span><span class="n">shape</span> <span class="o">!=</span> <span class="n">shape_ret</span><span class="p">:</span>
</span><span id="BinaryOperator.typecheck-677"><a href="#BinaryOperator.typecheck-677"><span class="linenos">677</span></a>                <span class="n">symx</span> <span class="o">=</span> <span class="n">symx</span><span class="o">.</span><span class="n">like</span><span class="p">(</span><span class="n">shape</span><span class="o">=</span><span class="n">shape_ret</span><span class="p">)</span>
</span><span id="BinaryOperator.typecheck-678"><a href="#BinaryOperator.typecheck-678"><span class="linenos">678</span></a>            <span class="k">if</span> <span class="n">symy</span><span class="o">.</span><span class="n">shape</span> <span class="o">!=</span> <span class="n">shape_ret</span><span class="p">:</span>
</span><span id="BinaryOperator.typecheck-679"><a href="#BinaryOperator.typecheck-679"><span class="linenos">679</span></a>                <span class="n">symy</span> <span class="o">=</span> <span class="n">symx</span><span class="o">.</span><span class="n">like</span><span class="p">(</span><span class="n">shape</span><span class="o">=</span><span class="n">shape_ret</span><span class="p">)</span>
</span><span id="BinaryOperator.typecheck-680"><a href="#BinaryOperator.typecheck-680"><span class="linenos">680</span></a>            <span class="k">if</span> <span class="n">symx</span> <span class="o">!=</span> <span class="n">symy</span><span class="p">:</span>
</span><span id="BinaryOperator.typecheck-681"><a href="#BinaryOperator.typecheck-681"><span class="linenos">681</span></a>                <span class="k">raise</span> <span class="ne">TypeError</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;symx (</span><span class="si">{</span><span class="n">symx</span><span class="si">}</span><span class="s2">) != symy (</span><span class="si">{</span><span class="n">symy</span><span class="si">}</span><span class="s2">)&quot;</span><span class="p">)</span>
</span><span id="BinaryOperator.typecheck-682"><a href="#BinaryOperator.typecheck-682"><span class="linenos">682</span></a>            <span class="k">return</span> <span class="p">[</span><span class="n">symx</span><span class="p">]</span>
</span></pre></div>


    

                            </div>
                            <div id="BinaryOperator.jvp" class="classattr">
                                        <input id="BinaryOperator.jvp-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">jvp</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="n">primals</span>, </span><span class="param"><span class="n">tangents</span>, </span><span class="param"><span class="o">**</span><span class="n">params</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="BinaryOperator.jvp-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#BinaryOperator.jvp"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="BinaryOperator.jvp-684"><a href="#BinaryOperator.jvp-684"><span class="linenos">684</span></a>    <span class="k">def</span> <span class="nf">jvp</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">primals</span><span class="p">,</span> <span class="n">tangents</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="BinaryOperator.jvp-685"><a href="#BinaryOperator.jvp-685"><span class="linenos">685</span></a>        <span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">w</span><span class="p">),</span> <span class="p">(</span><span class="n">x_dot</span><span class="p">,</span> <span class="n">w_dot</span><span class="p">)</span> <span class="o">=</span> <span class="n">primals</span><span class="p">,</span> <span class="n">tangents</span>
</span><span id="BinaryOperator.jvp-686"><a href="#BinaryOperator.jvp-686"><span class="linenos">686</span></a>        <span class="k">return</span> <span class="p">[</span><span class="bp">self</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">w</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)],</span> <span class="p">[</span><span class="bp">self</span><span class="p">(</span><span class="n">x_dot</span><span class="p">,</span> <span class="n">w_dot</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)]</span>
</span></pre></div>


    

                            </div>
                            <div id="BinaryOperator.T" class="classattr">
                                        <input id="BinaryOperator.T-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">T</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="n">cotangents</span>, </span><span class="param"><span class="n">x</span>, </span><span class="param"><span class="n">w</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="BinaryOperator.T-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#BinaryOperator.T"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="BinaryOperator.T-688"><a href="#BinaryOperator.T-688"><span class="linenos">688</span></a>    <span class="k">def</span> <span class="nf">T</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">cotangents</span><span class="p">,</span> <span class="n">x</span><span class="p">,</span> <span class="n">w</span><span class="p">):</span>
</span><span id="BinaryOperator.T-689"><a href="#BinaryOperator.T-689"><span class="linenos">689</span></a>        <span class="p">(</span><span class="n">gL_y</span><span class="p">,)</span> <span class="o">=</span> <span class="n">cotangents</span>
</span><span id="BinaryOperator.T-690"><a href="#BinaryOperator.T-690"><span class="linenos">690</span></a>        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">boolean_output</span><span class="p">:</span>
</span><span id="BinaryOperator.T-691"><a href="#BinaryOperator.T-691"><span class="linenos">691</span></a>            <span class="n">gL_y</span> <span class="o">=</span> <span class="n">gL_y</span><span class="o">.</span><span class="n">cast</span><span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">dtype</span><span class="p">)</span>
</span><span id="BinaryOperator.T-692"><a href="#BinaryOperator.T-692"><span class="linenos">692</span></a>        <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">UndefinedPrimal</span><span class="p">):</span>
</span><span id="BinaryOperator.T-693"><a href="#BinaryOperator.T-693"><span class="linenos">693</span></a>            <span class="k">return</span> <span class="p">[</span><span class="n">gL_y</span><span class="p">,</span> <span class="n">NullCotangent</span><span class="p">]</span>
</span><span id="BinaryOperator.T-694"><a href="#BinaryOperator.T-694"><span class="linenos">694</span></a>        <span class="k">elif</span> <span class="nb">type</span><span class="p">(</span><span class="n">w</span><span class="p">)</span> <span class="ow">is</span> <span class="n">UndefinedPrimal</span><span class="p">:</span>
</span><span id="BinaryOperator.T-695"><a href="#BinaryOperator.T-695"><span class="linenos">695</span></a>            <span class="k">return</span> <span class="p">[</span><span class="n">NullCotangent</span><span class="p">,</span> <span class="n">gL_y</span><span class="p">]</span>
</span></pre></div>


    

                            </div>
                            <div class="inherited">
                                <h5>Inherited Members</h5>
                                <dl>
                                    <div><dt><a href="#Operator">Operator</a></dt>
                                <dd id="BinaryOperator.__init__" class="function"><a href="#Operator.__init__">Operator</a></dd>
                <dd id="BinaryOperator.name" class="variable"><a href="#Operator.name">name</a></dd>
                <dd id="BinaryOperator.variadic_inputs" class="variable"><a href="#Operator.variadic_inputs">variadic_inputs</a></dd>
                <dd id="BinaryOperator.nary_outputs" class="variable"><a href="#Operator.nary_outputs">nary_outputs</a></dd>
                <dd id="BinaryOperator.reorg_args" class="function"><a href="#Operator.reorg_args">reorg_args</a></dd>
                <dd id="BinaryOperator.reorg_args_nary" class="function"><a href="#Operator.reorg_args_nary">reorg_args_nary</a></dd>
                <dd id="BinaryOperator.partial_run" class="function"><a href="#Operator.partial_run">partial_run</a></dd>
                <dd id="BinaryOperator.partial_run_instruction" class="function"><a href="#Operator.partial_run_instruction">partial_run_instruction</a></dd>

            </div>
                                </dl>
                            </div>
                </section>
                <section id="ReduceOperator">
                            <input id="ReduceOperator-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr class">
            
    <span class="def">class</span>
    <span class="name">ReduceOperator</span><wbr>(<span class="base"><a href="#Operator">Operator</a></span>):

                <label class="view-source-button" for="ReduceOperator-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#ReduceOperator"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="ReduceOperator-698"><a href="#ReduceOperator-698"><span class="linenos">698</span></a><span class="k">class</span> <span class="nc">ReduceOperator</span><span class="p">(</span><span class="n">Operator</span><span class="p">):</span>
</span><span id="ReduceOperator-699"><a href="#ReduceOperator-699"><span class="linenos">699</span></a>    <span class="k">def</span> <span class="nf">args_fixer</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">x</span><span class="p">,</span> <span class="o">*</span><span class="p">,</span> <span class="n">dim</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">keepdim</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>
</span><span id="ReduceOperator-700"><a href="#ReduceOperator-700"><span class="linenos">700</span></a>        <span class="k">if</span> <span class="n">dim</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
</span><span id="ReduceOperator-701"><a href="#ReduceOperator-701"><span class="linenos">701</span></a>            <span class="n">dim</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="nb">range</span><span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">ndim</span><span class="p">))</span>
</span><span id="ReduceOperator-702"><a href="#ReduceOperator-702"><span class="linenos">702</span></a>        <span class="k">elif</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">dim</span><span class="p">,</span> <span class="nb">int</span><span class="p">):</span>
</span><span id="ReduceOperator-703"><a href="#ReduceOperator-703"><span class="linenos">703</span></a>            <span class="n">dim</span> <span class="o">=</span> <span class="p">(</span><span class="n">dim</span><span class="p">,)</span>
</span><span id="ReduceOperator-704"><a href="#ReduceOperator-704"><span class="linenos">704</span></a>        <span class="n">dim</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">a</span> <span class="k">if</span> <span class="n">a</span> <span class="o">&gt;=</span> <span class="mi">0</span> <span class="k">else</span> <span class="n">a</span> <span class="o">+</span> <span class="nb">len</span><span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span> <span class="k">for</span> <span class="n">a</span> <span class="ow">in</span> <span class="n">dim</span><span class="p">)</span>
</span><span id="ReduceOperator-705"><a href="#ReduceOperator-705"><span class="linenos">705</span></a>        <span class="k">return</span> <span class="p">(</span><span class="n">x</span><span class="p">,),</span> <span class="nb">dict</span><span class="p">(</span><span class="n">dim</span><span class="o">=</span><span class="n">dim</span><span class="p">,</span> <span class="n">keepdim</span><span class="o">=</span><span class="n">keepdim</span><span class="p">)</span>
</span><span id="ReduceOperator-706"><a href="#ReduceOperator-706"><span class="linenos">706</span></a>
</span><span id="ReduceOperator-707"><a href="#ReduceOperator-707"><span class="linenos">707</span></a>    <span class="k">def</span> <span class="nf">vmap</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">dim_size</span><span class="p">,</span> <span class="n">vals_in</span><span class="p">,</span> <span class="n">dims_in</span><span class="p">,</span> <span class="o">*</span><span class="p">,</span> <span class="n">dim</span><span class="p">,</span> <span class="n">keepdim</span><span class="p">):</span>
</span><span id="ReduceOperator-708"><a href="#ReduceOperator-708"><span class="linenos">708</span></a>        <span class="p">(</span><span class="n">x</span><span class="p">,),</span> <span class="p">(</span><span class="n">x_bdim</span><span class="p">,)</span> <span class="o">=</span> <span class="n">vals_in</span><span class="p">,</span> <span class="n">dims_in</span>
</span><span id="ReduceOperator-709"><a href="#ReduceOperator-709"><span class="linenos">709</span></a>        <span class="n">dim</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">a</span> <span class="o">+</span> <span class="p">(</span><span class="n">x_bdim</span> <span class="o">&lt;=</span> <span class="n">a</span><span class="p">)</span> <span class="k">for</span> <span class="n">a</span> <span class="ow">in</span> <span class="n">dim</span><span class="p">)</span>
</span><span id="ReduceOperator-710"><a href="#ReduceOperator-710"><span class="linenos">710</span></a>        <span class="n">out_bdim</span> <span class="o">=</span> <span class="n">x_bdim</span> <span class="o">-</span> <span class="nb">sum</span><span class="p">(</span><span class="n">a</span> <span class="o">&lt;</span> <span class="n">x_bdim</span> <span class="k">for</span> <span class="n">a</span> <span class="ow">in</span> <span class="n">dim</span><span class="p">)</span>
</span><span id="ReduceOperator-711"><a href="#ReduceOperator-711"><span class="linenos">711</span></a>        <span class="k">return</span> <span class="p">[</span><span class="bp">self</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">dim</span><span class="o">=</span><span class="n">dim</span><span class="p">,</span> <span class="n">keepdim</span><span class="o">=</span><span class="n">keepdim</span><span class="p">)],</span> <span class="p">[</span><span class="n">out_bdim</span><span class="p">]</span>
</span><span id="ReduceOperator-712"><a href="#ReduceOperator-712"><span class="linenos">712</span></a>
</span><span id="ReduceOperator-713"><a href="#ReduceOperator-713"><span class="linenos">713</span></a>    <span class="k">def</span> <span class="nf">typecheck</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">x</span><span class="p">:</span> <span class="n">SymbolicTensor</span><span class="p">,</span> <span class="o">*</span><span class="p">,</span> <span class="n">dim</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">keepdim</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">List</span><span class="p">[</span><span class="n">SymbolicTensor</span><span class="p">]:</span>
</span><span id="ReduceOperator-714"><a href="#ReduceOperator-714"><span class="linenos">714</span></a>        <span class="n">dim</span> <span class="o">=</span> <span class="p">[</span><span class="n">a</span> <span class="o">+</span> <span class="nb">len</span><span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span> <span class="k">if</span> <span class="n">a</span> <span class="o">&lt;</span> <span class="mi">0</span> <span class="k">else</span> <span class="n">a</span> <span class="k">for</span> <span class="n">a</span> <span class="ow">in</span> <span class="n">dim</span><span class="p">]</span>
</span><span id="ReduceOperator-715"><a href="#ReduceOperator-715"><span class="linenos">715</span></a>        <span class="n">dim_</span> <span class="o">=</span> <span class="nb">set</span><span class="p">(</span><span class="n">dim</span><span class="p">)</span>
</span><span id="ReduceOperator-716"><a href="#ReduceOperator-716"><span class="linenos">716</span></a>        <span class="k">if</span> <span class="n">keepdim</span><span class="p">:</span>
</span><span id="ReduceOperator-717"><a href="#ReduceOperator-717"><span class="linenos">717</span></a>            <span class="n">new_shape</span> <span class="o">=</span> <span class="p">[</span><span class="n">d</span> <span class="k">if</span> <span class="n">i</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">dim_</span> <span class="k">else</span> <span class="mi">1</span> <span class="k">for</span> <span class="n">i</span><span class="p">,</span> <span class="n">d</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">shape</span><span class="p">)]</span>
</span><span id="ReduceOperator-718"><a href="#ReduceOperator-718"><span class="linenos">718</span></a>        <span class="k">else</span><span class="p">:</span>
</span><span id="ReduceOperator-719"><a href="#ReduceOperator-719"><span class="linenos">719</span></a>            <span class="n">new_shape</span> <span class="o">=</span> <span class="p">[</span><span class="n">d</span> <span class="k">for</span> <span class="n">i</span><span class="p">,</span> <span class="n">d</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span> <span class="k">if</span> <span class="n">i</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">dim_</span><span class="p">]</span>
</span><span id="ReduceOperator-720"><a href="#ReduceOperator-720"><span class="linenos">720</span></a>        <span class="k">return</span> <span class="p">[</span><span class="n">x</span><span class="o">.</span><span class="n">like</span><span class="p">(</span><span class="n">shape</span><span class="o">=</span><span class="nb">tuple</span><span class="p">(</span><span class="n">new_shape</span><span class="p">))]</span>
</span></pre></div>


    

                            <div id="ReduceOperator.args_fixer" class="classattr">
                                        <input id="ReduceOperator.args_fixer-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">args_fixer</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="n">x</span>, </span><span class="param"><span class="o">*</span>, </span><span class="param"><span class="n">dim</span><span class="o">=</span><span class="kc">None</span>, </span><span class="param"><span class="n">keepdim</span><span class="o">=</span><span class="kc">False</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="ReduceOperator.args_fixer-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#ReduceOperator.args_fixer"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="ReduceOperator.args_fixer-699"><a href="#ReduceOperator.args_fixer-699"><span class="linenos">699</span></a>    <span class="k">def</span> <span class="nf">args_fixer</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">x</span><span class="p">,</span> <span class="o">*</span><span class="p">,</span> <span class="n">dim</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">keepdim</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>
</span><span id="ReduceOperator.args_fixer-700"><a href="#ReduceOperator.args_fixer-700"><span class="linenos">700</span></a>        <span class="k">if</span> <span class="n">dim</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
</span><span id="ReduceOperator.args_fixer-701"><a href="#ReduceOperator.args_fixer-701"><span class="linenos">701</span></a>            <span class="n">dim</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="nb">range</span><span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">ndim</span><span class="p">))</span>
</span><span id="ReduceOperator.args_fixer-702"><a href="#ReduceOperator.args_fixer-702"><span class="linenos">702</span></a>        <span class="k">elif</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">dim</span><span class="p">,</span> <span class="nb">int</span><span class="p">):</span>
</span><span id="ReduceOperator.args_fixer-703"><a href="#ReduceOperator.args_fixer-703"><span class="linenos">703</span></a>            <span class="n">dim</span> <span class="o">=</span> <span class="p">(</span><span class="n">dim</span><span class="p">,)</span>
</span><span id="ReduceOperator.args_fixer-704"><a href="#ReduceOperator.args_fixer-704"><span class="linenos">704</span></a>        <span class="n">dim</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">a</span> <span class="k">if</span> <span class="n">a</span> <span class="o">&gt;=</span> <span class="mi">0</span> <span class="k">else</span> <span class="n">a</span> <span class="o">+</span> <span class="nb">len</span><span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span> <span class="k">for</span> <span class="n">a</span> <span class="ow">in</span> <span class="n">dim</span><span class="p">)</span>
</span><span id="ReduceOperator.args_fixer-705"><a href="#ReduceOperator.args_fixer-705"><span class="linenos">705</span></a>        <span class="k">return</span> <span class="p">(</span><span class="n">x</span><span class="p">,),</span> <span class="nb">dict</span><span class="p">(</span><span class="n">dim</span><span class="o">=</span><span class="n">dim</span><span class="p">,</span> <span class="n">keepdim</span><span class="o">=</span><span class="n">keepdim</span><span class="p">)</span>
</span></pre></div>


    

                            </div>
                            <div id="ReduceOperator.vmap" class="classattr">
                                        <input id="ReduceOperator.vmap-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">vmap</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="n">dim_size</span>, </span><span class="param"><span class="n">vals_in</span>, </span><span class="param"><span class="n">dims_in</span>, </span><span class="param"><span class="o">*</span>, </span><span class="param"><span class="n">dim</span>, </span><span class="param"><span class="n">keepdim</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="ReduceOperator.vmap-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#ReduceOperator.vmap"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="ReduceOperator.vmap-707"><a href="#ReduceOperator.vmap-707"><span class="linenos">707</span></a>    <span class="k">def</span> <span class="nf">vmap</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">dim_size</span><span class="p">,</span> <span class="n">vals_in</span><span class="p">,</span> <span class="n">dims_in</span><span class="p">,</span> <span class="o">*</span><span class="p">,</span> <span class="n">dim</span><span class="p">,</span> <span class="n">keepdim</span><span class="p">):</span>
</span><span id="ReduceOperator.vmap-708"><a href="#ReduceOperator.vmap-708"><span class="linenos">708</span></a>        <span class="p">(</span><span class="n">x</span><span class="p">,),</span> <span class="p">(</span><span class="n">x_bdim</span><span class="p">,)</span> <span class="o">=</span> <span class="n">vals_in</span><span class="p">,</span> <span class="n">dims_in</span>
</span><span id="ReduceOperator.vmap-709"><a href="#ReduceOperator.vmap-709"><span class="linenos">709</span></a>        <span class="n">dim</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">a</span> <span class="o">+</span> <span class="p">(</span><span class="n">x_bdim</span> <span class="o">&lt;=</span> <span class="n">a</span><span class="p">)</span> <span class="k">for</span> <span class="n">a</span> <span class="ow">in</span> <span class="n">dim</span><span class="p">)</span>
</span><span id="ReduceOperator.vmap-710"><a href="#ReduceOperator.vmap-710"><span class="linenos">710</span></a>        <span class="n">out_bdim</span> <span class="o">=</span> <span class="n">x_bdim</span> <span class="o">-</span> <span class="nb">sum</span><span class="p">(</span><span class="n">a</span> <span class="o">&lt;</span> <span class="n">x_bdim</span> <span class="k">for</span> <span class="n">a</span> <span class="ow">in</span> <span class="n">dim</span><span class="p">)</span>
</span><span id="ReduceOperator.vmap-711"><a href="#ReduceOperator.vmap-711"><span class="linenos">711</span></a>        <span class="k">return</span> <span class="p">[</span><span class="bp">self</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">dim</span><span class="o">=</span><span class="n">dim</span><span class="p">,</span> <span class="n">keepdim</span><span class="o">=</span><span class="n">keepdim</span><span class="p">)],</span> <span class="p">[</span><span class="n">out_bdim</span><span class="p">]</span>
</span></pre></div>


    

                            </div>
                            <div id="ReduceOperator.typecheck" class="classattr">
                                        <input id="ReduceOperator.typecheck-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">typecheck</span><span class="signature pdoc-code multiline">(<span class="param">	<span class="bp">self</span>,</span><span class="param">	<span class="n">x</span><span class="p">:</span> <span class="n"><a href="#SymbolicTensor">SymbolicTensor</a></span>,</span><span class="param">	<span class="o">*</span>,</span><span class="param">	<span class="n">dim</span><span class="o">=</span><span class="kc">None</span>,</span><span class="param">	<span class="n">keepdim</span><span class="o">=</span><span class="kc">False</span></span><span class="return-annotation">) -> <span class="n">List</span><span class="p">[</span><span class="n"><a href="#SymbolicTensor">SymbolicTensor</a></span><span class="p">]</span>:</span></span>

                <label class="view-source-button" for="ReduceOperator.typecheck-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#ReduceOperator.typecheck"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="ReduceOperator.typecheck-713"><a href="#ReduceOperator.typecheck-713"><span class="linenos">713</span></a>    <span class="k">def</span> <span class="nf">typecheck</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">x</span><span class="p">:</span> <span class="n">SymbolicTensor</span><span class="p">,</span> <span class="o">*</span><span class="p">,</span> <span class="n">dim</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">keepdim</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">List</span><span class="p">[</span><span class="n">SymbolicTensor</span><span class="p">]:</span>
</span><span id="ReduceOperator.typecheck-714"><a href="#ReduceOperator.typecheck-714"><span class="linenos">714</span></a>        <span class="n">dim</span> <span class="o">=</span> <span class="p">[</span><span class="n">a</span> <span class="o">+</span> <span class="nb">len</span><span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span> <span class="k">if</span> <span class="n">a</span> <span class="o">&lt;</span> <span class="mi">0</span> <span class="k">else</span> <span class="n">a</span> <span class="k">for</span> <span class="n">a</span> <span class="ow">in</span> <span class="n">dim</span><span class="p">]</span>
</span><span id="ReduceOperator.typecheck-715"><a href="#ReduceOperator.typecheck-715"><span class="linenos">715</span></a>        <span class="n">dim_</span> <span class="o">=</span> <span class="nb">set</span><span class="p">(</span><span class="n">dim</span><span class="p">)</span>
</span><span id="ReduceOperator.typecheck-716"><a href="#ReduceOperator.typecheck-716"><span class="linenos">716</span></a>        <span class="k">if</span> <span class="n">keepdim</span><span class="p">:</span>
</span><span id="ReduceOperator.typecheck-717"><a href="#ReduceOperator.typecheck-717"><span class="linenos">717</span></a>            <span class="n">new_shape</span> <span class="o">=</span> <span class="p">[</span><span class="n">d</span> <span class="k">if</span> <span class="n">i</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">dim_</span> <span class="k">else</span> <span class="mi">1</span> <span class="k">for</span> <span class="n">i</span><span class="p">,</span> <span class="n">d</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">shape</span><span class="p">)]</span>
</span><span id="ReduceOperator.typecheck-718"><a href="#ReduceOperator.typecheck-718"><span class="linenos">718</span></a>        <span class="k">else</span><span class="p">:</span>
</span><span id="ReduceOperator.typecheck-719"><a href="#ReduceOperator.typecheck-719"><span class="linenos">719</span></a>            <span class="n">new_shape</span> <span class="o">=</span> <span class="p">[</span><span class="n">d</span> <span class="k">for</span> <span class="n">i</span><span class="p">,</span> <span class="n">d</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span> <span class="k">if</span> <span class="n">i</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">dim_</span><span class="p">]</span>
</span><span id="ReduceOperator.typecheck-720"><a href="#ReduceOperator.typecheck-720"><span class="linenos">720</span></a>        <span class="k">return</span> <span class="p">[</span><span class="n">x</span><span class="o">.</span><span class="n">like</span><span class="p">(</span><span class="n">shape</span><span class="o">=</span><span class="nb">tuple</span><span class="p">(</span><span class="n">new_shape</span><span class="p">))]</span>
</span></pre></div>


    

                            </div>
                            <div class="inherited">
                                <h5>Inherited Members</h5>
                                <dl>
                                    <div><dt><a href="#Operator">Operator</a></dt>
                                <dd id="ReduceOperator.__init__" class="function"><a href="#Operator.__init__">Operator</a></dd>
                <dd id="ReduceOperator.name" class="variable"><a href="#Operator.name">name</a></dd>
                <dd id="ReduceOperator.variadic_inputs" class="variable"><a href="#Operator.variadic_inputs">variadic_inputs</a></dd>
                <dd id="ReduceOperator.nary_outputs" class="variable"><a href="#Operator.nary_outputs">nary_outputs</a></dd>
                <dd id="ReduceOperator.jvp" class="function"><a href="#Operator.jvp">jvp</a></dd>
                <dd id="ReduceOperator.T" class="function"><a href="#Operator.T">T</a></dd>
                <dd id="ReduceOperator.reorg_args" class="function"><a href="#Operator.reorg_args">reorg_args</a></dd>
                <dd id="ReduceOperator.reorg_args_nary" class="function"><a href="#Operator.reorg_args_nary">reorg_args_nary</a></dd>
                <dd id="ReduceOperator.partial_run" class="function"><a href="#Operator.partial_run">partial_run</a></dd>
                <dd id="ReduceOperator.partial_run_instruction" class="function"><a href="#Operator.partial_run_instruction">partial_run_instruction</a></dd>

            </div>
                                </dl>
                            </div>
                </section>
                <section id="InitOperator">
                            <input id="InitOperator-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr class">
            
    <span class="def">class</span>
    <span class="name">InitOperator</span><wbr>(<span class="base"><a href="#Operator">Operator</a></span>):

                <label class="view-source-button" for="InitOperator-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#InitOperator"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="InitOperator-723"><a href="#InitOperator-723"><span class="linenos">723</span></a><span class="k">class</span> <span class="nc">InitOperator</span><span class="p">(</span><span class="n">Operator</span><span class="p">):</span>
</span><span id="InitOperator-724"><a href="#InitOperator-724"><span class="linenos">724</span></a>    <span class="k">def</span> <span class="nf">vmap</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">dim_size</span><span class="p">,</span> <span class="n">vals_in</span><span class="p">,</span> <span class="n">dims_in</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="InitOperator-725"><a href="#InitOperator-725"><span class="linenos">725</span></a>        <span class="p">(</span><span class="n">x_bdim</span><span class="p">,)</span> <span class="o">=</span> <span class="n">dims_in</span>
</span><span id="InitOperator-726"><a href="#InitOperator-726"><span class="linenos">726</span></a>        <span class="n">y</span> <span class="o">=</span> <span class="bp">self</span><span class="p">(</span><span class="o">**</span><span class="n">params</span><span class="p">)</span>
</span><span id="InitOperator-727"><a href="#InitOperator-727"><span class="linenos">727</span></a>        <span class="n">y</span> <span class="o">=</span> <span class="n">y</span><span class="o">.</span><span class="n">unsqueeze</span><span class="p">(</span><span class="n">x_bdim</span><span class="p">)</span>
</span><span id="InitOperator-728"><a href="#InitOperator-728"><span class="linenos">728</span></a>        <span class="k">return</span> <span class="p">[</span><span class="n">y</span><span class="p">],</span> <span class="p">[</span><span class="n">x_bdim</span><span class="p">]</span>
</span><span id="InitOperator-729"><a href="#InitOperator-729"><span class="linenos">729</span></a>
</span><span id="InitOperator-730"><a href="#InitOperator-730"><span class="linenos">730</span></a>    <span class="k">def</span> <span class="nf">jvp</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">primals</span><span class="p">,</span> <span class="n">tangents</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="InitOperator-731"><a href="#InitOperator-731"><span class="linenos">731</span></a>        <span class="n">y</span> <span class="o">=</span> <span class="bp">self</span><span class="p">(</span><span class="o">**</span><span class="n">params</span><span class="p">)</span>
</span><span id="InitOperator-732"><a href="#InitOperator-732"><span class="linenos">732</span></a>        <span class="n">y_dot</span> <span class="o">=</span> <span class="n">NullCotangent</span><span class="p">(</span><span class="n">y</span><span class="o">.</span><span class="n">symval</span><span class="p">)</span>
</span><span id="InitOperator-733"><a href="#InitOperator-733"><span class="linenos">733</span></a>        <span class="c1"># y_dot = y.ones_like()</span>
</span><span id="InitOperator-734"><a href="#InitOperator-734"><span class="linenos">734</span></a>        <span class="k">return</span> <span class="p">[</span><span class="n">y</span><span class="p">],</span> <span class="p">[</span><span class="n">y_dot</span><span class="p">]</span>
</span><span id="InitOperator-735"><a href="#InitOperator-735"><span class="linenos">735</span></a>
</span><span id="InitOperator-736"><a href="#InitOperator-736"><span class="linenos">736</span></a>    <span class="k">def</span> <span class="nf">T</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">cotangents</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="InitOperator-737"><a href="#InitOperator-737"><span class="linenos">737</span></a>        <span class="k">return</span> <span class="p">[</span><span class="n">NullCotangent</span><span class="p">(</span><span class="n">cotangents</span><span class="p">[</span><span class="mi">0</span><span class="p">])]</span>
</span></pre></div>


    

                            <div id="InitOperator.vmap" class="classattr">
                                        <input id="InitOperator.vmap-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">vmap</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="n">dim_size</span>, </span><span class="param"><span class="n">vals_in</span>, </span><span class="param"><span class="n">dims_in</span>, </span><span class="param"><span class="o">**</span><span class="n">params</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="InitOperator.vmap-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#InitOperator.vmap"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="InitOperator.vmap-724"><a href="#InitOperator.vmap-724"><span class="linenos">724</span></a>    <span class="k">def</span> <span class="nf">vmap</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">dim_size</span><span class="p">,</span> <span class="n">vals_in</span><span class="p">,</span> <span class="n">dims_in</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="InitOperator.vmap-725"><a href="#InitOperator.vmap-725"><span class="linenos">725</span></a>        <span class="p">(</span><span class="n">x_bdim</span><span class="p">,)</span> <span class="o">=</span> <span class="n">dims_in</span>
</span><span id="InitOperator.vmap-726"><a href="#InitOperator.vmap-726"><span class="linenos">726</span></a>        <span class="n">y</span> <span class="o">=</span> <span class="bp">self</span><span class="p">(</span><span class="o">**</span><span class="n">params</span><span class="p">)</span>
</span><span id="InitOperator.vmap-727"><a href="#InitOperator.vmap-727"><span class="linenos">727</span></a>        <span class="n">y</span> <span class="o">=</span> <span class="n">y</span><span class="o">.</span><span class="n">unsqueeze</span><span class="p">(</span><span class="n">x_bdim</span><span class="p">)</span>
</span><span id="InitOperator.vmap-728"><a href="#InitOperator.vmap-728"><span class="linenos">728</span></a>        <span class="k">return</span> <span class="p">[</span><span class="n">y</span><span class="p">],</span> <span class="p">[</span><span class="n">x_bdim</span><span class="p">]</span>
</span></pre></div>


    

                            </div>
                            <div id="InitOperator.jvp" class="classattr">
                                        <input id="InitOperator.jvp-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">jvp</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="n">primals</span>, </span><span class="param"><span class="n">tangents</span>, </span><span class="param"><span class="o">**</span><span class="n">params</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="InitOperator.jvp-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#InitOperator.jvp"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="InitOperator.jvp-730"><a href="#InitOperator.jvp-730"><span class="linenos">730</span></a>    <span class="k">def</span> <span class="nf">jvp</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">primals</span><span class="p">,</span> <span class="n">tangents</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="InitOperator.jvp-731"><a href="#InitOperator.jvp-731"><span class="linenos">731</span></a>        <span class="n">y</span> <span class="o">=</span> <span class="bp">self</span><span class="p">(</span><span class="o">**</span><span class="n">params</span><span class="p">)</span>
</span><span id="InitOperator.jvp-732"><a href="#InitOperator.jvp-732"><span class="linenos">732</span></a>        <span class="n">y_dot</span> <span class="o">=</span> <span class="n">NullCotangent</span><span class="p">(</span><span class="n">y</span><span class="o">.</span><span class="n">symval</span><span class="p">)</span>
</span><span id="InitOperator.jvp-733"><a href="#InitOperator.jvp-733"><span class="linenos">733</span></a>        <span class="c1"># y_dot = y.ones_like()</span>
</span><span id="InitOperator.jvp-734"><a href="#InitOperator.jvp-734"><span class="linenos">734</span></a>        <span class="k">return</span> <span class="p">[</span><span class="n">y</span><span class="p">],</span> <span class="p">[</span><span class="n">y_dot</span><span class="p">]</span>
</span></pre></div>


    

                            </div>
                            <div id="InitOperator.T" class="classattr">
                                        <input id="InitOperator.T-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">T</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="n">cotangents</span>, </span><span class="param"><span class="o">**</span><span class="n">params</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="InitOperator.T-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#InitOperator.T"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="InitOperator.T-736"><a href="#InitOperator.T-736"><span class="linenos">736</span></a>    <span class="k">def</span> <span class="nf">T</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">cotangents</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="InitOperator.T-737"><a href="#InitOperator.T-737"><span class="linenos">737</span></a>        <span class="k">return</span> <span class="p">[</span><span class="n">NullCotangent</span><span class="p">(</span><span class="n">cotangents</span><span class="p">[</span><span class="mi">0</span><span class="p">])]</span>
</span></pre></div>


    

                            </div>
                            <div class="inherited">
                                <h5>Inherited Members</h5>
                                <dl>
                                    <div><dt><a href="#Operator">Operator</a></dt>
                                <dd id="InitOperator.__init__" class="function"><a href="#Operator.__init__">Operator</a></dd>
                <dd id="InitOperator.name" class="variable"><a href="#Operator.name">name</a></dd>
                <dd id="InitOperator.variadic_inputs" class="variable"><a href="#Operator.variadic_inputs">variadic_inputs</a></dd>
                <dd id="InitOperator.nary_outputs" class="variable"><a href="#Operator.nary_outputs">nary_outputs</a></dd>
                <dd id="InitOperator.args_fixer" class="function"><a href="#Operator.args_fixer">args_fixer</a></dd>
                <dd id="InitOperator.typecheck" class="function"><a href="#Operator.typecheck">typecheck</a></dd>
                <dd id="InitOperator.reorg_args" class="function"><a href="#Operator.reorg_args">reorg_args</a></dd>
                <dd id="InitOperator.reorg_args_nary" class="function"><a href="#Operator.reorg_args_nary">reorg_args_nary</a></dd>
                <dd id="InitOperator.partial_run" class="function"><a href="#Operator.partial_run">partial_run</a></dd>
                <dd id="InitOperator.partial_run_instruction" class="function"><a href="#Operator.partial_run_instruction">partial_run_instruction</a></dd>

            </div>
                                </dl>
                            </div>
                </section>
                <section id="ShapeOperator">
                            <input id="ShapeOperator-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr class">
            
    <span class="def">class</span>
    <span class="name">ShapeOperator</span><wbr>(<span class="base"><a href="#Operator">Operator</a></span>):

                <label class="view-source-button" for="ShapeOperator-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#ShapeOperator"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="ShapeOperator-740"><a href="#ShapeOperator-740"><span class="linenos">740</span></a><span class="k">class</span> <span class="nc">ShapeOperator</span><span class="p">(</span><span class="n">Operator</span><span class="p">):</span>
</span><span id="ShapeOperator-741"><a href="#ShapeOperator-741"><span class="linenos">741</span></a>    <span class="k">pass</span>
</span></pre></div>


    

                            <div class="inherited">
                                <h5>Inherited Members</h5>
                                <dl>
                                    <div><dt><a href="#Operator">Operator</a></dt>
                                <dd id="ShapeOperator.__init__" class="function"><a href="#Operator.__init__">Operator</a></dd>
                <dd id="ShapeOperator.name" class="variable"><a href="#Operator.name">name</a></dd>
                <dd id="ShapeOperator.variadic_inputs" class="variable"><a href="#Operator.variadic_inputs">variadic_inputs</a></dd>
                <dd id="ShapeOperator.nary_outputs" class="variable"><a href="#Operator.nary_outputs">nary_outputs</a></dd>
                <dd id="ShapeOperator.args_fixer" class="function"><a href="#Operator.args_fixer">args_fixer</a></dd>
                <dd id="ShapeOperator.typecheck" class="function"><a href="#Operator.typecheck">typecheck</a></dd>
                <dd id="ShapeOperator.jvp" class="function"><a href="#Operator.jvp">jvp</a></dd>
                <dd id="ShapeOperator.T" class="function"><a href="#Operator.T">T</a></dd>
                <dd id="ShapeOperator.vmap" class="function"><a href="#Operator.vmap">vmap</a></dd>
                <dd id="ShapeOperator.reorg_args" class="function"><a href="#Operator.reorg_args">reorg_args</a></dd>
                <dd id="ShapeOperator.reorg_args_nary" class="function"><a href="#Operator.reorg_args_nary">reorg_args_nary</a></dd>
                <dd id="ShapeOperator.partial_run" class="function"><a href="#Operator.partial_run">partial_run</a></dd>
                <dd id="ShapeOperator.partial_run_instruction" class="function"><a href="#Operator.partial_run_instruction">partial_run_instruction</a></dd>

            </div>
                                </dl>
                            </div>
                </section>
                <section id="GeneralReduceOperator">
                            <input id="GeneralReduceOperator-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr class">
            
    <span class="def">class</span>
    <span class="name">GeneralReduceOperator</span><wbr>(<span class="base"><a href="#Operator">Operator</a></span>):

                <label class="view-source-button" for="GeneralReduceOperator-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#GeneralReduceOperator"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="GeneralReduceOperator-744"><a href="#GeneralReduceOperator-744"><span class="linenos">744</span></a><span class="k">class</span> <span class="nc">GeneralReduceOperator</span><span class="p">(</span><span class="n">Operator</span><span class="p">):</span>
</span><span id="GeneralReduceOperator-745"><a href="#GeneralReduceOperator-745"><span class="linenos">745</span></a>    <span class="k">pass</span>
</span></pre></div>


    

                            <div class="inherited">
                                <h5>Inherited Members</h5>
                                <dl>
                                    <div><dt><a href="#Operator">Operator</a></dt>
                                <dd id="GeneralReduceOperator.__init__" class="function"><a href="#Operator.__init__">Operator</a></dd>
                <dd id="GeneralReduceOperator.name" class="variable"><a href="#Operator.name">name</a></dd>
                <dd id="GeneralReduceOperator.variadic_inputs" class="variable"><a href="#Operator.variadic_inputs">variadic_inputs</a></dd>
                <dd id="GeneralReduceOperator.nary_outputs" class="variable"><a href="#Operator.nary_outputs">nary_outputs</a></dd>
                <dd id="GeneralReduceOperator.args_fixer" class="function"><a href="#Operator.args_fixer">args_fixer</a></dd>
                <dd id="GeneralReduceOperator.typecheck" class="function"><a href="#Operator.typecheck">typecheck</a></dd>
                <dd id="GeneralReduceOperator.jvp" class="function"><a href="#Operator.jvp">jvp</a></dd>
                <dd id="GeneralReduceOperator.T" class="function"><a href="#Operator.T">T</a></dd>
                <dd id="GeneralReduceOperator.vmap" class="function"><a href="#Operator.vmap">vmap</a></dd>
                <dd id="GeneralReduceOperator.reorg_args" class="function"><a href="#Operator.reorg_args">reorg_args</a></dd>
                <dd id="GeneralReduceOperator.reorg_args_nary" class="function"><a href="#Operator.reorg_args_nary">reorg_args_nary</a></dd>
                <dd id="GeneralReduceOperator.partial_run" class="function"><a href="#Operator.partial_run">partial_run</a></dd>
                <dd id="GeneralReduceOperator.partial_run_instruction" class="function"><a href="#Operator.partial_run_instruction">partial_run_instruction</a></dd>

            </div>
                                </dl>
                            </div>
                </section>
                <section id="OperatorSet">
                            <input id="OperatorSet-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr class">
            
    <span class="def">class</span>
    <span class="name">OperatorSet</span>:

                <label class="view-source-button" for="OperatorSet-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#OperatorSet"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="OperatorSet-748"><a href="#OperatorSet-748"><span class="linenos">748</span></a><span class="k">class</span> <span class="nc">OperatorSet</span><span class="p">:</span>
</span><span id="OperatorSet-749"><a href="#OperatorSet-749"><span class="linenos">749</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="OperatorSet-750"><a href="#OperatorSet-750"><span class="linenos">750</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">register</span><span class="p">(</span><span class="s2">&quot;jit_op&quot;</span><span class="p">)(</span><span class="n">JitOp</span><span class="p">)</span>
</span><span id="OperatorSet-751"><a href="#OperatorSet-751"><span class="linenos">751</span></a>
</span><span id="OperatorSet-752"><a href="#OperatorSet-752"><span class="linenos">752</span></a>    <span class="k">def</span> <span class="nf">register</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">name</span><span class="p">,</span> <span class="n">variadic_inputs</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">nary_outputs</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">aliases</span><span class="o">=</span><span class="p">()):</span>
</span><span id="OperatorSet-753"><a href="#OperatorSet-753"><span class="linenos">753</span></a>        <span class="k">def</span> <span class="nf">wrap</span><span class="p">(</span><span class="n">op_cls</span><span class="p">):</span>
</span><span id="OperatorSet-754"><a href="#OperatorSet-754"><span class="linenos">754</span></a>            <span class="k">assert</span> <span class="n">name</span> <span class="ow">not</span> <span class="ow">in</span> <span class="nb">vars</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span>
</span><span id="OperatorSet-755"><a href="#OperatorSet-755"><span class="linenos">755</span></a>            <span class="n">op</span> <span class="o">=</span> <span class="n">op_cls</span><span class="p">(</span><span class="n">name</span><span class="p">,</span> <span class="n">variadic_inputs</span><span class="p">,</span> <span class="n">nary_outputs</span><span class="p">)</span>
</span><span id="OperatorSet-756"><a href="#OperatorSet-756"><span class="linenos">756</span></a>            <span class="nb">setattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">name</span><span class="p">,</span> <span class="n">op</span><span class="p">)</span>
</span><span id="OperatorSet-757"><a href="#OperatorSet-757"><span class="linenos">757</span></a>            <span class="k">for</span> <span class="n">a</span> <span class="ow">in</span> <span class="n">aliases</span><span class="p">:</span>
</span><span id="OperatorSet-758"><a href="#OperatorSet-758"><span class="linenos">758</span></a>                <span class="nb">setattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">a</span><span class="p">,</span> <span class="n">op</span><span class="p">)</span>
</span><span id="OperatorSet-759"><a href="#OperatorSet-759"><span class="linenos">759</span></a>            <span class="k">return</span> <span class="n">op_cls</span>
</span><span id="OperatorSet-760"><a href="#OperatorSet-760"><span class="linenos">760</span></a>
</span><span id="OperatorSet-761"><a href="#OperatorSet-761"><span class="linenos">761</span></a>        <span class="k">return</span> <span class="n">wrap</span>
</span></pre></div>


    

                            <div id="OperatorSet.register" class="classattr">
                                        <input id="OperatorSet.register-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">register</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="n">name</span>, </span><span class="param"><span class="n">variadic_inputs</span><span class="o">=</span><span class="kc">False</span>, </span><span class="param"><span class="n">nary_outputs</span><span class="o">=</span><span class="kc">False</span>, </span><span class="param"><span class="n">aliases</span><span class="o">=</span><span class="p">()</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="OperatorSet.register-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#OperatorSet.register"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="OperatorSet.register-752"><a href="#OperatorSet.register-752"><span class="linenos">752</span></a>    <span class="k">def</span> <span class="nf">register</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">name</span><span class="p">,</span> <span class="n">variadic_inputs</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">nary_outputs</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">aliases</span><span class="o">=</span><span class="p">()):</span>
</span><span id="OperatorSet.register-753"><a href="#OperatorSet.register-753"><span class="linenos">753</span></a>        <span class="k">def</span> <span class="nf">wrap</span><span class="p">(</span><span class="n">op_cls</span><span class="p">):</span>
</span><span id="OperatorSet.register-754"><a href="#OperatorSet.register-754"><span class="linenos">754</span></a>            <span class="k">assert</span> <span class="n">name</span> <span class="ow">not</span> <span class="ow">in</span> <span class="nb">vars</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span>
</span><span id="OperatorSet.register-755"><a href="#OperatorSet.register-755"><span class="linenos">755</span></a>            <span class="n">op</span> <span class="o">=</span> <span class="n">op_cls</span><span class="p">(</span><span class="n">name</span><span class="p">,</span> <span class="n">variadic_inputs</span><span class="p">,</span> <span class="n">nary_outputs</span><span class="p">)</span>
</span><span id="OperatorSet.register-756"><a href="#OperatorSet.register-756"><span class="linenos">756</span></a>            <span class="nb">setattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">name</span><span class="p">,</span> <span class="n">op</span><span class="p">)</span>
</span><span id="OperatorSet.register-757"><a href="#OperatorSet.register-757"><span class="linenos">757</span></a>            <span class="k">for</span> <span class="n">a</span> <span class="ow">in</span> <span class="n">aliases</span><span class="p">:</span>
</span><span id="OperatorSet.register-758"><a href="#OperatorSet.register-758"><span class="linenos">758</span></a>                <span class="nb">setattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">a</span><span class="p">,</span> <span class="n">op</span><span class="p">)</span>
</span><span id="OperatorSet.register-759"><a href="#OperatorSet.register-759"><span class="linenos">759</span></a>            <span class="k">return</span> <span class="n">op_cls</span>
</span><span id="OperatorSet.register-760"><a href="#OperatorSet.register-760"><span class="linenos">760</span></a>
</span><span id="OperatorSet.register-761"><a href="#OperatorSet.register-761"><span class="linenos">761</span></a>        <span class="k">return</span> <span class="n">wrap</span>
</span></pre></div>


    

                            </div>
                </section>
                <section id="ProcedureSet">
                            <input id="ProcedureSet-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr class">
            
    <span class="def">class</span>
    <span class="name">ProcedureSet</span>:

                <label class="view-source-button" for="ProcedureSet-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#ProcedureSet"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="ProcedureSet-764"><a href="#ProcedureSet-764"><span class="linenos">764</span></a><span class="k">class</span> <span class="nc">ProcedureSet</span><span class="p">:</span>
</span><span id="ProcedureSet-765"><a href="#ProcedureSet-765"><span class="linenos">765</span></a>    <span class="k">def</span> <span class="nf">register</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">aliases</span><span class="o">=</span><span class="p">()):</span>
</span><span id="ProcedureSet-766"><a href="#ProcedureSet-766"><span class="linenos">766</span></a>        <span class="k">def</span> <span class="nf">wrap</span><span class="p">(</span><span class="n">f</span><span class="p">):</span>
</span><span id="ProcedureSet-767"><a href="#ProcedureSet-767"><span class="linenos">767</span></a>            <span class="k">assert</span> <span class="n">f</span><span class="o">.</span><span class="vm">__name__</span> <span class="ow">not</span> <span class="ow">in</span> <span class="nb">vars</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span>
</span><span id="ProcedureSet-768"><a href="#ProcedureSet-768"><span class="linenos">768</span></a>            <span class="nb">setattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">f</span><span class="o">.</span><span class="vm">__name__</span><span class="p">,</span> <span class="n">f</span><span class="p">)</span>
</span><span id="ProcedureSet-769"><a href="#ProcedureSet-769"><span class="linenos">769</span></a>            <span class="k">for</span> <span class="n">a</span> <span class="ow">in</span> <span class="n">aliases</span><span class="p">:</span>
</span><span id="ProcedureSet-770"><a href="#ProcedureSet-770"><span class="linenos">770</span></a>                <span class="nb">setattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">a</span><span class="p">,</span> <span class="n">f</span><span class="p">)</span>
</span><span id="ProcedureSet-771"><a href="#ProcedureSet-771"><span class="linenos">771</span></a>            <span class="k">return</span> <span class="n">f</span>
</span><span id="ProcedureSet-772"><a href="#ProcedureSet-772"><span class="linenos">772</span></a>
</span><span id="ProcedureSet-773"><a href="#ProcedureSet-773"><span class="linenos">773</span></a>        <span class="k">return</span> <span class="n">wrap</span>
</span></pre></div>


    

                            <div id="ProcedureSet.register" class="classattr">
                                        <input id="ProcedureSet.register-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">register</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="n">aliases</span><span class="o">=</span><span class="p">()</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="ProcedureSet.register-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#ProcedureSet.register"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="ProcedureSet.register-765"><a href="#ProcedureSet.register-765"><span class="linenos">765</span></a>    <span class="k">def</span> <span class="nf">register</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">aliases</span><span class="o">=</span><span class="p">()):</span>
</span><span id="ProcedureSet.register-766"><a href="#ProcedureSet.register-766"><span class="linenos">766</span></a>        <span class="k">def</span> <span class="nf">wrap</span><span class="p">(</span><span class="n">f</span><span class="p">):</span>
</span><span id="ProcedureSet.register-767"><a href="#ProcedureSet.register-767"><span class="linenos">767</span></a>            <span class="k">assert</span> <span class="n">f</span><span class="o">.</span><span class="vm">__name__</span> <span class="ow">not</span> <span class="ow">in</span> <span class="nb">vars</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span>
</span><span id="ProcedureSet.register-768"><a href="#ProcedureSet.register-768"><span class="linenos">768</span></a>            <span class="nb">setattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">f</span><span class="o">.</span><span class="vm">__name__</span><span class="p">,</span> <span class="n">f</span><span class="p">)</span>
</span><span id="ProcedureSet.register-769"><a href="#ProcedureSet.register-769"><span class="linenos">769</span></a>            <span class="k">for</span> <span class="n">a</span> <span class="ow">in</span> <span class="n">aliases</span><span class="p">:</span>
</span><span id="ProcedureSet.register-770"><a href="#ProcedureSet.register-770"><span class="linenos">770</span></a>                <span class="nb">setattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">a</span><span class="p">,</span> <span class="n">f</span><span class="p">)</span>
</span><span id="ProcedureSet.register-771"><a href="#ProcedureSet.register-771"><span class="linenos">771</span></a>            <span class="k">return</span> <span class="n">f</span>
</span><span id="ProcedureSet.register-772"><a href="#ProcedureSet.register-772"><span class="linenos">772</span></a>
</span><span id="ProcedureSet.register-773"><a href="#ProcedureSet.register-773"><span class="linenos">773</span></a>        <span class="k">return</span> <span class="n">wrap</span>
</span></pre></div>


    

                            </div>
                </section>
                <section id="CodegenOutput">
                            <input id="CodegenOutput-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr class">
            
    <span class="def">class</span>
    <span class="name">CodegenOutput</span><wbr>(<span class="base">typing.NamedTuple</span>):

                <label class="view-source-button" for="CodegenOutput-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#CodegenOutput"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="CodegenOutput-776"><a href="#CodegenOutput-776"><span class="linenos">776</span></a><span class="k">class</span> <span class="nc">CodegenOutput</span><span class="p">(</span><span class="n">NamedTuple</span><span class="p">):</span>
</span><span id="CodegenOutput-777"><a href="#CodegenOutput-777"><span class="linenos">777</span></a>    <span class="n">code_lines</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="nb">str</span><span class="p">]</span>
</span><span id="CodegenOutput-778"><a href="#CodegenOutput-778"><span class="linenos">778</span></a>    <span class="n">fn_defs</span><span class="p">:</span> <span class="n">Dict</span><span class="p">[</span><span class="nb">str</span><span class="p">,</span> <span class="n">List</span><span class="p">[</span><span class="nb">str</span><span class="p">]]</span>
</span><span id="CodegenOutput-779"><a href="#CodegenOutput-779"><span class="linenos">779</span></a>    <span class="n">in_binders</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="s2">&quot;ProgramEnvVar&quot;</span><span class="p">]</span>
</span><span id="CodegenOutput-780"><a href="#CodegenOutput-780"><span class="linenos">780</span></a>    <span class="n">outs</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="s2">&quot;ProgramEnvVar&quot;</span><span class="p">]</span>
</span></pre></div>


            <div class="docstring"><p>CodegenOutput(code_lines, fn_defs, in_binders, outs)</p>
</div>


                            <div id="CodegenOutput.__init__" class="classattr">
                                <div class="attr function">
            
        <span class="name">CodegenOutput</span><span class="signature pdoc-code multiline">(<span class="param">	<span class="n">code_lines</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="nb">str</span><span class="p">]</span>,</span><span class="param">	<span class="n">fn_defs</span><span class="p">:</span> <span class="n">Dict</span><span class="p">[</span><span class="nb">str</span><span class="p">,</span> <span class="n">List</span><span class="p">[</span><span class="nb">str</span><span class="p">]]</span>,</span><span class="param">	<span class="n">in_binders</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">ForwardRef</span><span class="p">(</span><span class="s1">&#39;ProgramEnvVar&#39;</span><span class="p">)]</span>,</span><span class="param">	<span class="n">outs</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">ForwardRef</span><span class="p">(</span><span class="s1">&#39;ProgramEnvVar&#39;</span><span class="p">)]</span></span>)</span>

        
    </div>
    <a class="headerlink" href="#CodegenOutput.__init__"></a>
    
            <div class="docstring"><p>Create new instance of CodegenOutput(code_lines, fn_defs, in_binders, outs)</p>
</div>


                            </div>
                            <div id="CodegenOutput.code_lines" class="classattr">
                                <div class="attr variable">
            <span class="name">code_lines</span><span class="annotation">: List[str]</span>

        
    </div>
    <a class="headerlink" href="#CodegenOutput.code_lines"></a>
    
            <div class="docstring"><p>Alias for field number 0</p>
</div>


                            </div>
                            <div id="CodegenOutput.fn_defs" class="classattr">
                                <div class="attr variable">
            <span class="name">fn_defs</span><span class="annotation">: Dict[str, List[str]]</span>

        
    </div>
    <a class="headerlink" href="#CodegenOutput.fn_defs"></a>
    
            <div class="docstring"><p>Alias for field number 1</p>
</div>


                            </div>
                            <div id="CodegenOutput.in_binders" class="classattr">
                                <div class="attr variable">
            <span class="name">in_binders</span><span class="annotation">: List[<a href="#ProgramEnvVar">ProgramEnvVar</a>]</span>

        
    </div>
    <a class="headerlink" href="#CodegenOutput.in_binders"></a>
    
            <div class="docstring"><p>Alias for field number 2</p>
</div>


                            </div>
                            <div id="CodegenOutput.outs" class="classattr">
                                <div class="attr variable">
            <span class="name">outs</span><span class="annotation">: List[<a href="#ProgramEnvVar">ProgramEnvVar</a>]</span>

        
    </div>
    <a class="headerlink" href="#CodegenOutput.outs"></a>
    
            <div class="docstring"><p>Alias for field number 3</p>
</div>


                            </div>
                            <div class="inherited">
                                <h5>Inherited Members</h5>
                                <dl>
                                    <div><dt>builtins.tuple</dt>
                                <dd id="CodegenOutput.index" class="function">index</dd>
                <dd id="CodegenOutput.count" class="function">count</dd>

            </div>
                                </dl>
                            </div>
                </section>
                <section id="Backend">
                            <input id="Backend-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr class">
            
    <span class="def">class</span>
    <span class="name">Backend</span>:

                <label class="view-source-button" for="Backend-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Backend"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Backend-783"><a href="#Backend-783"><span class="linenos">783</span></a><span class="k">class</span> <span class="nc">Backend</span><span class="p">:</span>
</span><span id="Backend-784"><a href="#Backend-784"><span class="linenos">784</span></a>    <span class="n">LOG_LRU</span> <span class="o">=</span> <span class="nb">int</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">environ</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;LOG_LRU&quot;</span><span class="p">,</span> <span class="mi">0</span><span class="p">))</span>
</span><span id="Backend-785"><a href="#Backend-785"><span class="linenos">785</span></a>    <span class="n">LOG_JIT</span> <span class="o">=</span> <span class="nb">int</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">environ</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;LOG_JIT&quot;</span><span class="p">,</span> <span class="mi">0</span><span class="p">))</span>
</span><span id="Backend-786"><a href="#Backend-786"><span class="linenos">786</span></a>    <span class="n">LOG_TREE</span> <span class="o">=</span> <span class="nb">int</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">environ</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;LOG_TREE&quot;</span><span class="p">,</span> <span class="mi">0</span><span class="p">))</span>
</span><span id="Backend-787"><a href="#Backend-787"><span class="linenos">787</span></a>    <span class="n">LOG_BACKEND</span> <span class="o">=</span> <span class="nb">int</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">environ</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;LOG_BACKEND&quot;</span><span class="p">,</span> <span class="mi">0</span><span class="p">))</span>
</span><span id="Backend-788"><a href="#Backend-788"><span class="linenos">788</span></a>    <span class="n">LOG_PROGRAM</span> <span class="o">=</span> <span class="nb">int</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">environ</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;LOG_PROGRAM&quot;</span><span class="p">,</span> <span class="mi">0</span><span class="p">))</span>
</span><span id="Backend-789"><a href="#Backend-789"><span class="linenos">789</span></a>    <span class="n">LOG_INIT</span> <span class="o">=</span> <span class="nb">int</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">environ</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;LOG_INIT&quot;</span><span class="p">,</span> <span class="mi">1</span><span class="p">))</span>
</span><span id="Backend-790"><a href="#Backend-790"><span class="linenos">790</span></a>    <span class="n">device_var</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">environ</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;DEFAULT_DEVICE&quot;</span><span class="p">,</span> <span class="s2">&quot;cpu:0&quot;</span><span class="p">)</span>
</span><span id="Backend-791"><a href="#Backend-791"><span class="linenos">791</span></a>    <span class="k">if</span> <span class="n">device_var</span><span class="p">[</span><span class="o">-</span><span class="mi">2</span><span class="p">]</span> <span class="o">!=</span> <span class="s2">&quot;:&quot;</span><span class="p">:</span>
</span><span id="Backend-792"><a href="#Backend-792"><span class="linenos">792</span></a>        <span class="n">device_var</span> <span class="o">+=</span> <span class="s2">&quot;:0&quot;</span>
</span><span id="Backend-793"><a href="#Backend-793"><span class="linenos">793</span></a>    <span class="n">DEFAULT_DEVICE</span> <span class="o">=</span> <span class="n">devices</span><span class="o">.</span><span class="n">name_idx_device_map</span><span class="p">[</span><span class="n">device_var</span><span class="p">]</span>
</span><span id="Backend-794"><a href="#Backend-794"><span class="linenos">794</span></a>    <span class="n">DEFAULT_DTYPE</span> <span class="o">=</span> <span class="n">dtypes</span><span class="o">.</span><span class="n">name_dtype_map</span><span class="p">[</span><span class="n">os</span><span class="o">.</span><span class="n">environ</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;DEFAULT_DTYPE&quot;</span><span class="p">,</span> <span class="s2">&quot;float32&quot;</span><span class="p">)]</span>
</span><span id="Backend-795"><a href="#Backend-795"><span class="linenos">795</span></a>    <span class="n">dtype_for_indices</span><span class="p">:</span> <span class="n">DType</span> <span class="o">=</span> <span class="kc">None</span>  <span class="c1"># need to override</span>
</span><span id="Backend-796"><a href="#Backend-796"><span class="linenos">796</span></a>
</span><span id="Backend-797"><a href="#Backend-797"><span class="linenos">797</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span>
</span><span id="Backend-798"><a href="#Backend-798"><span class="linenos">798</span></a>        <span class="bp">self</span><span class="p">,</span>
</span><span id="Backend-799"><a href="#Backend-799"><span class="linenos">799</span></a>        <span class="n">operator_set</span><span class="p">:</span> <span class="n">OperatorSet</span><span class="p">,</span>
</span><span id="Backend-800"><a href="#Backend-800"><span class="linenos">800</span></a>        <span class="n">procedure_set</span><span class="p">:</span> <span class="n">ProcedureSet</span><span class="p">,</span>
</span><span id="Backend-801"><a href="#Backend-801"><span class="linenos">801</span></a>    <span class="p">):</span>
</span><span id="Backend-802"><a href="#Backend-802"><span class="linenos">802</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">operator_set</span> <span class="o">=</span> <span class="n">operator_set</span>
</span><span id="Backend-803"><a href="#Backend-803"><span class="linenos">803</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">procedure_set</span> <span class="o">=</span> <span class="n">procedure_set</span>
</span><span id="Backend-804"><a href="#Backend-804"><span class="linenos">804</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">node_types</span> <span class="o">=</span> <span class="nb">dict</span><span class="p">()</span>
</span><span id="Backend-805"><a href="#Backend-805"><span class="linenos">805</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">impls</span> <span class="o">=</span> <span class="nb">dict</span><span class="p">()</span>
</span><span id="Backend-806"><a href="#Backend-806"><span class="linenos">806</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">register_node</span><span class="p">(</span><span class="nb">tuple</span><span class="p">,</span> <span class="k">lambda</span> <span class="n">t</span><span class="p">:</span> <span class="p">(</span><span class="kc">None</span><span class="p">,</span> <span class="n">t</span><span class="p">),</span> <span class="k">lambda</span> <span class="n">_</span><span class="p">,</span> <span class="n">xs</span><span class="p">:</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">xs</span><span class="p">),</span> <span class="s2">&quot;tuple&quot;</span><span class="p">)</span>
</span><span id="Backend-807"><a href="#Backend-807"><span class="linenos">807</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">register_node</span><span class="p">(</span><span class="nb">list</span><span class="p">,</span> <span class="k">lambda</span> <span class="n">l</span><span class="p">:</span> <span class="p">(</span><span class="kc">None</span><span class="p">,</span> <span class="n">l</span><span class="p">),</span> <span class="k">lambda</span> <span class="n">_</span><span class="p">,</span> <span class="n">xs</span><span class="p">:</span> <span class="nb">list</span><span class="p">(</span><span class="n">xs</span><span class="p">),</span> <span class="s2">&quot;list&quot;</span><span class="p">)</span>
</span><span id="Backend-808"><a href="#Backend-808"><span class="linenos">808</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">register_node</span><span class="p">(</span>
</span><span id="Backend-809"><a href="#Backend-809"><span class="linenos">809</span></a>            <span class="nb">dict</span><span class="p">,</span>
</span><span id="Backend-810"><a href="#Backend-810"><span class="linenos">810</span></a>            <span class="k">lambda</span> <span class="n">d</span><span class="p">:</span> <span class="n">list_map</span><span class="p">(</span><span class="nb">tuple</span><span class="p">,</span> <span class="n">unzip2</span><span class="p">(</span><span class="nb">sorted</span><span class="p">(</span><span class="n">d</span><span class="o">.</span><span class="n">items</span><span class="p">()))),</span>
</span><span id="Backend-811"><a href="#Backend-811"><span class="linenos">811</span></a>            <span class="k">lambda</span> <span class="n">keys</span><span class="p">,</span> <span class="n">vals</span><span class="p">:</span> <span class="nb">dict</span><span class="p">(</span><span class="n">list_zip</span><span class="p">(</span><span class="n">keys</span><span class="p">,</span> <span class="n">vals</span><span class="p">)),</span>
</span><span id="Backend-812"><a href="#Backend-812"><span class="linenos">812</span></a>            <span class="s2">&quot;dict&quot;</span><span class="p">,</span>
</span><span id="Backend-813"><a href="#Backend-813"><span class="linenos">813</span></a>        <span class="p">)</span>
</span><span id="Backend-814"><a href="#Backend-814"><span class="linenos">814</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">register_node</span><span class="p">(</span>
</span><span id="Backend-815"><a href="#Backend-815"><span class="linenos">815</span></a>            <span class="n">UndefinedPrimal</span><span class="p">,</span>
</span><span id="Backend-816"><a href="#Backend-816"><span class="linenos">816</span></a>            <span class="k">lambda</span> <span class="n">u</span><span class="p">:</span> <span class="p">(</span><span class="n">u</span><span class="o">.</span><span class="n">symval</span><span class="p">,</span> <span class="p">()),</span>
</span><span id="Backend-817"><a href="#Backend-817"><span class="linenos">817</span></a>            <span class="k">lambda</span> <span class="n">symval</span><span class="p">,</span> <span class="n">_</span><span class="p">:</span> <span class="n">UndefinedPrimal</span><span class="p">(</span><span class="n">symval</span><span class="p">),</span>
</span><span id="Backend-818"><a href="#Backend-818"><span class="linenos">818</span></a>            <span class="s2">&quot;UndefinedPrimal&quot;</span><span class="p">,</span>
</span><span id="Backend-819"><a href="#Backend-819"><span class="linenos">819</span></a>        <span class="p">)</span>
</span><span id="Backend-820"><a href="#Backend-820"><span class="linenos">820</span></a>
</span><span id="Backend-821"><a href="#Backend-821"><span class="linenos">821</span></a>    <span class="k">def</span> <span class="nf">set_impl</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">op</span><span class="p">:</span> <span class="n">Union</span><span class="p">[</span><span class="n">types</span><span class="o">.</span><span class="n">LambdaType</span><span class="p">,</span> <span class="n">types</span><span class="o">.</span><span class="n">FunctionType</span><span class="p">]):</span>
</span><span id="Backend-822"><a href="#Backend-822"><span class="linenos">822</span></a>        <span class="k">def</span> <span class="nf">set_impl_</span><span class="p">(</span><span class="n">fn</span><span class="p">):</span>
</span><span id="Backend-823"><a href="#Backend-823"><span class="linenos">823</span></a>            <span class="bp">self</span><span class="o">.</span><span class="n">impls</span><span class="p">[</span><span class="n">op</span><span class="p">]</span> <span class="o">=</span> <span class="n">types</span><span class="o">.</span><span class="n">MethodType</span><span class="p">(</span><span class="n">fn</span><span class="p">,</span> <span class="bp">self</span><span class="p">)</span>
</span><span id="Backend-824"><a href="#Backend-824"><span class="linenos">824</span></a>
</span><span id="Backend-825"><a href="#Backend-825"><span class="linenos">825</span></a>        <span class="k">return</span> <span class="n">set_impl_</span>
</span><span id="Backend-826"><a href="#Backend-826"><span class="linenos">826</span></a>
</span><span id="Backend-827"><a href="#Backend-827"><span class="linenos">827</span></a>    <span class="k">def</span> <span class="nf">register_node</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">ty</span><span class="p">:</span> <span class="n">Type</span><span class="p">,</span> <span class="n">to_iter</span><span class="p">:</span> <span class="n">Callable</span><span class="p">,</span> <span class="n">from_iter</span><span class="p">:</span> <span class="n">Callable</span><span class="p">,</span> <span class="n">name</span><span class="o">=</span><span class="kc">None</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="kc">None</span><span class="p">:</span>
</span><span id="Backend-828"><a href="#Backend-828"><span class="linenos">828</span></a>        <span class="k">if</span> <span class="n">name</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
</span><span id="Backend-829"><a href="#Backend-829"><span class="linenos">829</span></a>            <span class="n">name</span> <span class="o">=</span> <span class="nb">str</span><span class="p">(</span><span class="n">ty</span><span class="p">)</span>
</span><span id="Backend-830"><a href="#Backend-830"><span class="linenos">830</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">node_types</span><span class="p">[</span><span class="n">ty</span><span class="p">]</span> <span class="o">=</span> <span class="n">NodeType</span><span class="p">(</span><span class="n">name</span><span class="p">,</span> <span class="n">to_iter</span><span class="p">,</span> <span class="n">from_iter</span><span class="p">)</span>
</span><span id="Backend-831"><a href="#Backend-831"><span class="linenos">831</span></a>
</span><span id="Backend-832"><a href="#Backend-832"><span class="linenos">832</span></a>    <span class="k">def</span> <span class="fm">__getattr__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">attr</span><span class="p">):</span>
</span><span id="Backend-833"><a href="#Backend-833"><span class="linenos">833</span></a>        <span class="k">try</span><span class="p">:</span>
</span><span id="Backend-834"><a href="#Backend-834"><span class="linenos">834</span></a>            <span class="n">dblog</span><span class="p">(</span>
</span><span id="Backend-835"><a href="#Backend-835"><span class="linenos">835</span></a>                <span class="sa">f</span><span class="s2">&quot;Looking </span><span class="si">{</span><span class="bp">self</span><span class="si">}</span><span class="s2">.</span><span class="si">{</span><span class="n">attr</span><span class="si">}</span><span class="s2"> in operator_set&quot;</span><span class="p">,</span>
</span><span id="Backend-836"><a href="#Backend-836"><span class="linenos">836</span></a>                <span class="n">enable</span><span class="o">=</span><span class="n">backend</span><span class="o">.</span><span class="n">LOG_BACKEND</span><span class="p">,</span>
</span><span id="Backend-837"><a href="#Backend-837"><span class="linenos">837</span></a>            <span class="p">)</span>
</span><span id="Backend-838"><a href="#Backend-838"><span class="linenos">838</span></a>            <span class="k">return</span> <span class="nb">getattr</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">operator_set</span><span class="p">,</span> <span class="n">attr</span><span class="p">)</span>
</span><span id="Backend-839"><a href="#Backend-839"><span class="linenos">839</span></a>        <span class="k">except</span><span class="p">:</span>
</span><span id="Backend-840"><a href="#Backend-840"><span class="linenos">840</span></a>            <span class="k">pass</span>
</span><span id="Backend-841"><a href="#Backend-841"><span class="linenos">841</span></a>        <span class="k">try</span><span class="p">:</span>
</span><span id="Backend-842"><a href="#Backend-842"><span class="linenos">842</span></a>            <span class="n">dblog</span><span class="p">(</span>
</span><span id="Backend-843"><a href="#Backend-843"><span class="linenos">843</span></a>                <span class="sa">f</span><span class="s2">&quot;Looking </span><span class="si">{</span><span class="bp">self</span><span class="si">}</span><span class="s2">.</span><span class="si">{</span><span class="n">attr</span><span class="si">}</span><span class="s2"> in procedure_set&quot;</span><span class="p">,</span>
</span><span id="Backend-844"><a href="#Backend-844"><span class="linenos">844</span></a>                <span class="n">enable</span><span class="o">=</span><span class="n">backend</span><span class="o">.</span><span class="n">LOG_BACKEND</span><span class="p">,</span>
</span><span id="Backend-845"><a href="#Backend-845"><span class="linenos">845</span></a>            <span class="p">)</span>
</span><span id="Backend-846"><a href="#Backend-846"><span class="linenos">846</span></a>            <span class="k">return</span> <span class="nb">getattr</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">procedure_set</span><span class="p">,</span> <span class="n">attr</span><span class="p">)</span>
</span><span id="Backend-847"><a href="#Backend-847"><span class="linenos">847</span></a>        <span class="k">except</span><span class="p">:</span>
</span><span id="Backend-848"><a href="#Backend-848"><span class="linenos">848</span></a>            <span class="k">pass</span>
</span><span id="Backend-849"><a href="#Backend-849"><span class="linenos">849</span></a>        <span class="n">dblog</span><span class="p">(</span>
</span><span id="Backend-850"><a href="#Backend-850"><span class="linenos">850</span></a>            <span class="sa">f</span><span class="s2">&quot;Fallback to default </span><span class="si">{</span><span class="bp">self</span><span class="si">}</span><span class="s2"> getattribute&quot;</span><span class="p">,</span>
</span><span id="Backend-851"><a href="#Backend-851"><span class="linenos">851</span></a>            <span class="n">enable</span><span class="o">=</span><span class="n">backend</span><span class="o">.</span><span class="n">LOG_BACKEND</span><span class="p">,</span>
</span><span id="Backend-852"><a href="#Backend-852"><span class="linenos">852</span></a>        <span class="p">)</span>
</span><span id="Backend-853"><a href="#Backend-853"><span class="linenos">853</span></a>        <span class="nb">super</span><span class="p">()</span><span class="o">.</span><span class="fm">__getattribute__</span><span class="p">(</span><span class="n">attr</span><span class="p">)</span>
</span><span id="Backend-854"><a href="#Backend-854"><span class="linenos">854</span></a>
</span><span id="Backend-855"><a href="#Backend-855"><span class="linenos">855</span></a>    <span class="k">def</span> <span class="nf">tensor</span><span class="p">(</span>
</span><span id="Backend-856"><a href="#Backend-856"><span class="linenos">856</span></a>        <span class="bp">self</span><span class="p">,</span>
</span><span id="Backend-857"><a href="#Backend-857"><span class="linenos">857</span></a>        <span class="n">val</span><span class="p">:</span> <span class="n">Union</span><span class="p">[</span><span class="nb">list</span><span class="p">,</span> <span class="nb">tuple</span><span class="p">,</span> <span class="n">np</span><span class="o">.</span><span class="n">ndarray</span><span class="p">,</span> <span class="s2">&quot;TensorBuffer&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span>
</span><span id="Backend-858"><a href="#Backend-858"><span class="linenos">858</span></a>        <span class="n">dtype</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="n">Any</span><span class="p">]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span>
</span><span id="Backend-859"><a href="#Backend-859"><span class="linenos">859</span></a>        <span class="n">device</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span>
</span><span id="Backend-860"><a href="#Backend-860"><span class="linenos">860</span></a>    <span class="p">):</span>
</span><span id="Backend-861"><a href="#Backend-861"><span class="linenos">861</span></a>        <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">val</span><span class="p">,</span> <span class="n">TensorBuffer</span><span class="p">):</span>
</span><span id="Backend-862"><a href="#Backend-862"><span class="linenos">862</span></a>            <span class="k">return</span> <span class="n">Tensor</span><span class="p">(</span><span class="n">val</span><span class="p">)</span>
</span><span id="Backend-863"><a href="#Backend-863"><span class="linenos">863</span></a>        <span class="k">elif</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">val</span><span class="p">,</span> <span class="n">Tensor</span><span class="p">):</span>
</span><span id="Backend-864"><a href="#Backend-864"><span class="linenos">864</span></a>            <span class="k">return</span> <span class="n">val</span>
</span><span id="Backend-865"><a href="#Backend-865"><span class="linenos">865</span></a>        <span class="k">if</span> <span class="nb">type</span><span class="p">(</span><span class="n">val</span><span class="p">)</span> <span class="ow">is</span> <span class="nb">bytes</span><span class="p">:</span>
</span><span id="Backend-866"><a href="#Backend-866"><span class="linenos">866</span></a>            <span class="n">val</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">frombuffer</span><span class="p">(</span><span class="n">val</span><span class="p">,</span> <span class="n">dtype</span><span class="o">=</span><span class="n">dtype</span><span class="p">)</span>
</span><span id="Backend-867"><a href="#Backend-867"><span class="linenos">867</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">from_numpy</span><span class="p">(</span><span class="n">val</span><span class="p">,</span> <span class="n">dtype</span><span class="p">,</span> <span class="n">device</span><span class="p">)</span>
</span><span id="Backend-868"><a href="#Backend-868"><span class="linenos">868</span></a>
</span><span id="Backend-869"><a href="#Backend-869"><span class="linenos">869</span></a>    <span class="k">def</span> <span class="nf">symbolic_tensor</span><span class="p">(</span>
</span><span id="Backend-870"><a href="#Backend-870"><span class="linenos">870</span></a>        <span class="bp">self</span><span class="p">,</span>
</span><span id="Backend-871"><a href="#Backend-871"><span class="linenos">871</span></a>        <span class="n">shape</span><span class="p">:</span> <span class="n">Union</span><span class="p">[</span><span class="nb">list</span><span class="p">,</span> <span class="nb">tuple</span><span class="p">,</span> <span class="n">np</span><span class="o">.</span><span class="n">ndarray</span><span class="p">,</span> <span class="s2">&quot;TensorBuffer&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span>
</span><span id="Backend-872"><a href="#Backend-872"><span class="linenos">872</span></a>        <span class="n">dtype</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="n">Any</span><span class="p">]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span>
</span><span id="Backend-873"><a href="#Backend-873"><span class="linenos">873</span></a>        <span class="n">device</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span>
</span><span id="Backend-874"><a href="#Backend-874"><span class="linenos">874</span></a>    <span class="p">):</span>
</span><span id="Backend-875"><a href="#Backend-875"><span class="linenos">875</span></a>        <span class="n">dtype</span> <span class="o">=</span> <span class="n">dtype</span> <span class="ow">or</span> <span class="bp">self</span><span class="o">.</span><span class="n">DEFAULT_DTYPE</span>
</span><span id="Backend-876"><a href="#Backend-876"><span class="linenos">876</span></a>        <span class="n">device</span> <span class="o">=</span> <span class="n">device</span> <span class="ow">or</span> <span class="bp">self</span><span class="o">.</span><span class="n">DEFAULT_DEVICE</span>
</span><span id="Backend-877"><a href="#Backend-877"><span class="linenos">877</span></a>        <span class="k">return</span> <span class="n">SymbolicTensor</span><span class="p">(</span><span class="n">shape</span><span class="p">,</span> <span class="n">dtype</span><span class="p">,</span> <span class="n">device</span><span class="p">)</span>
</span><span id="Backend-878"><a href="#Backend-878"><span class="linenos">878</span></a>
</span><span id="Backend-879"><a href="#Backend-879"><span class="linenos">879</span></a>    <span class="k">def</span> <span class="nf">seed</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">seed</span><span class="p">):</span>
</span><span id="Backend-880"><a href="#Backend-880"><span class="linenos">880</span></a>        <span class="k">raise</span> <span class="ne">NotImplementedError</span>
</span><span id="Backend-881"><a href="#Backend-881"><span class="linenos">881</span></a>
</span><span id="Backend-882"><a href="#Backend-882"><span class="linenos">882</span></a>    <span class="nd">@property</span>
</span><span id="Backend-883"><a href="#Backend-883"><span class="linenos">883</span></a>    <span class="k">def</span> <span class="nf">default_dtype_value</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="Backend-884"><a href="#Backend-884"><span class="linenos">884</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">dtype_map</span><span class="p">[</span><span class="n">backend</span><span class="o">.</span><span class="n">DEFAULT_DTYPE</span><span class="p">]</span>
</span><span id="Backend-885"><a href="#Backend-885"><span class="linenos">885</span></a>
</span><span id="Backend-886"><a href="#Backend-886"><span class="linenos">886</span></a>    <span class="k">def</span> <span class="nf">set_method</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">method</span><span class="p">):</span>
</span><span id="Backend-887"><a href="#Backend-887"><span class="linenos">887</span></a>        <span class="nb">setattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">method</span><span class="o">.</span><span class="vm">__name__</span><span class="p">,</span> <span class="n">types</span><span class="o">.</span><span class="n">MethodType</span><span class="p">(</span><span class="n">method</span><span class="p">,</span> <span class="bp">self</span><span class="p">))</span>
</span><span id="Backend-888"><a href="#Backend-888"><span class="linenos">888</span></a>
</span><span id="Backend-889"><a href="#Backend-889"><span class="linenos">889</span></a>    <span class="k">def</span> <span class="nf">from_numpy</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">val</span><span class="p">,</span> <span class="n">device</span><span class="p">):</span>
</span><span id="Backend-890"><a href="#Backend-890"><span class="linenos">890</span></a>        <span class="k">raise</span> <span class="ne">NotImplementedError</span>
</span><span id="Backend-891"><a href="#Backend-891"><span class="linenos">891</span></a>
</span><span id="Backend-892"><a href="#Backend-892"><span class="linenos">892</span></a>    <span class="k">def</span> <span class="nf">numpy_of</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">tensor</span><span class="p">):</span>
</span><span id="Backend-893"><a href="#Backend-893"><span class="linenos">893</span></a>        <span class="k">raise</span> <span class="ne">NotImplementedError</span>
</span><span id="Backend-894"><a href="#Backend-894"><span class="linenos">894</span></a>
</span><span id="Backend-895"><a href="#Backend-895"><span class="linenos">895</span></a>    <span class="k">def</span> <span class="nf">device_of</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">tensor</span><span class="p">):</span>
</span><span id="Backend-896"><a href="#Backend-896"><span class="linenos">896</span></a>        <span class="k">raise</span> <span class="ne">NotImplementedError</span>
</span><span id="Backend-897"><a href="#Backend-897"><span class="linenos">897</span></a>
</span><span id="Backend-898"><a href="#Backend-898"><span class="linenos">898</span></a>    <span class="k">def</span> <span class="nf">shape_of</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">tensor</span><span class="p">):</span>
</span><span id="Backend-899"><a href="#Backend-899"><span class="linenos">899</span></a>        <span class="k">raise</span> <span class="ne">NotImplementedError</span>
</span><span id="Backend-900"><a href="#Backend-900"><span class="linenos">900</span></a>
</span><span id="Backend-901"><a href="#Backend-901"><span class="linenos">901</span></a>    <span class="k">def</span> <span class="nf">dtype_of</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">tensor</span><span class="p">):</span>
</span><span id="Backend-902"><a href="#Backend-902"><span class="linenos">902</span></a>        <span class="k">raise</span> <span class="ne">NotImplementedError</span>
</span><span id="Backend-903"><a href="#Backend-903"><span class="linenos">903</span></a>
</span><span id="Backend-904"><a href="#Backend-904"><span class="linenos">904</span></a>    <span class="nd">@lru_cache_verbose</span><span class="p">()</span>
</span><span id="Backend-905"><a href="#Backend-905"><span class="linenos">905</span></a>    <span class="k">def</span> <span class="nf">jit_program</span><span class="p">(</span>
</span><span id="Backend-906"><a href="#Backend-906"><span class="linenos">906</span></a>        <span class="bp">self</span><span class="p">,</span>
</span><span id="Backend-907"><a href="#Backend-907"><span class="linenos">907</span></a>        <span class="n">hashed_program</span><span class="p">:</span> <span class="n">Hashed</span><span class="p">,</span>
</span><span id="Backend-908"><a href="#Backend-908"><span class="linenos">908</span></a>        <span class="n">hashed_consts</span><span class="p">:</span> <span class="n">Tuple</span><span class="p">[</span><span class="n">Hashed</span><span class="p">,</span> <span class="o">...</span><span class="p">],</span>
</span><span id="Backend-909"><a href="#Backend-909"><span class="linenos">909</span></a>    <span class="p">):</span>
</span><span id="Backend-910"><a href="#Backend-910"><span class="linenos">910</span></a>        <span class="n">program</span><span class="p">:</span> <span class="n">Program</span> <span class="o">=</span> <span class="n">hashed_program</span><span class="o">.</span><span class="n">val</span>
</span><span id="Backend-911"><a href="#Backend-911"><span class="linenos">911</span></a>        <span class="n">typecheck_program</span><span class="p">(</span><span class="n">program</span><span class="p">)</span>
</span><span id="Backend-912"><a href="#Backend-912"><span class="linenos">912</span></a>        <span class="n">consts</span> <span class="o">=</span> <span class="p">[</span><span class="n">x</span><span class="o">.</span><span class="n">val</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">hashed_consts</span><span class="p">]</span>
</span><span id="Backend-913"><a href="#Backend-913"><span class="linenos">913</span></a>        <span class="n">in_symvals</span> <span class="o">=</span> <span class="p">[</span><span class="n">v</span><span class="o">.</span><span class="n">symval</span> <span class="k">for</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">program</span><span class="o">.</span><span class="n">in_binders</span><span class="p">[</span><span class="nb">len</span><span class="p">(</span><span class="n">consts</span><span class="p">)</span> <span class="p">:]]</span>
</span><span id="Backend-914"><a href="#Backend-914"><span class="linenos">914</span></a>        <span class="n">codegen_output</span><span class="p">:</span> <span class="n">CodegenOutput</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">codegen</span><span class="p">(</span><span class="n">program</span><span class="p">,</span> <span class="n">consts</span> <span class="o">+</span> <span class="n">in_symvals</span><span class="p">,</span> <span class="n">fn_name</span><span class="o">=</span><span class="s2">&quot;main&quot;</span><span class="p">)</span>
</span><span id="Backend-915"><a href="#Backend-915"><span class="linenos">915</span></a>        <span class="n">fn</span><span class="p">,</span> <span class="n">code</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">compile</span><span class="p">(</span><span class="n">codegen_output</span><span class="p">)</span>
</span><span id="Backend-916"><a href="#Backend-916"><span class="linenos">916</span></a>        <span class="n">jit_output</span> <span class="o">=</span> <span class="n">JitOutput</span><span class="p">(</span><span class="n">program</span><span class="p">,</span> <span class="n">codegen_output</span><span class="p">,</span> <span class="n">fn</span><span class="p">,</span> <span class="n">code</span><span class="p">,</span> <span class="n">consts</span><span class="p">)</span>
</span><span id="Backend-917"><a href="#Backend-917"><span class="linenos">917</span></a>        <span class="k">return</span> <span class="n">jit_output</span>
</span><span id="Backend-918"><a href="#Backend-918"><span class="linenos">918</span></a>
</span><span id="Backend-919"><a href="#Backend-919"><span class="linenos">919</span></a>    <span class="k">def</span> <span class="nf">codegen</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">program</span><span class="p">:</span> <span class="s2">&quot;Program&quot;</span><span class="p">,</span> <span class="n">args</span><span class="p">:</span> <span class="n">Tuple</span><span class="p">,</span> <span class="n">in_symvals</span><span class="p">:</span> <span class="n">Tuple</span><span class="p">,</span> <span class="n">name</span><span class="p">:</span> <span class="nb">str</span><span class="p">):</span>
</span><span id="Backend-920"><a href="#Backend-920"><span class="linenos">920</span></a>        <span class="s2">&quot;Returns compiler IR from the Program&quot;</span>
</span><span id="Backend-921"><a href="#Backend-921"><span class="linenos">921</span></a>        <span class="k">raise</span> <span class="ne">NotImplementedError</span>
</span><span id="Backend-922"><a href="#Backend-922"><span class="linenos">922</span></a>
</span><span id="Backend-923"><a href="#Backend-923"><span class="linenos">923</span></a>    <span class="k">def</span> <span class="nf">compile</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">program</span><span class="p">:</span> <span class="s2">&quot;Program&quot;</span><span class="p">,</span> <span class="n">args</span><span class="p">:</span> <span class="n">Tuple</span><span class="p">,</span> <span class="n">in_symvals</span><span class="p">:</span> <span class="n">Tuple</span><span class="p">,</span> <span class="n">name</span><span class="p">:</span> <span class="nb">str</span><span class="p">):</span>
</span><span id="Backend-924"><a href="#Backend-924"><span class="linenos">924</span></a>        <span class="s2">&quot;Compiles compiler IR to a Python callable function&quot;</span>
</span><span id="Backend-925"><a href="#Backend-925"><span class="linenos">925</span></a>        <span class="k">raise</span> <span class="ne">NotImplementedError</span>
</span><span id="Backend-926"><a href="#Backend-926"><span class="linenos">926</span></a>
</span><span id="Backend-927"><a href="#Backend-927"><span class="linenos">927</span></a>    <span class="k">def</span> <span class="nf">export</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">jit_output</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="Backend-928"><a href="#Backend-928"><span class="linenos">928</span></a>        <span class="k">raise</span> <span class="ne">NotImplementedError</span>
</span><span id="Backend-929"><a href="#Backend-929"><span class="linenos">929</span></a>
</span><span id="Backend-930"><a href="#Backend-930"><span class="linenos">930</span></a>    <span class="k">def</span> <span class="nf">load</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">path</span><span class="p">,</span> <span class="n">single_key</span><span class="o">=</span><span class="s2">&quot;_tensor&quot;</span><span class="p">):</span>
</span><span id="Backend-931"><a href="#Backend-931"><span class="linenos">931</span></a>        <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">path</span><span class="p">,</span> <span class="n">mode</span><span class="o">=</span><span class="s2">&quot;rb&quot;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
</span><span id="Backend-932"><a href="#Backend-932"><span class="linenos">932</span></a>            <span class="k">with</span> <span class="n">mmap</span><span class="o">.</span><span class="n">mmap</span><span class="p">(</span><span class="n">f</span><span class="o">.</span><span class="n">fileno</span><span class="p">(),</span> <span class="n">length</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">access</span><span class="o">=</span><span class="n">mmap</span><span class="o">.</span><span class="n">ACCESS_READ</span><span class="p">)</span> <span class="k">as</span> <span class="n">m</span><span class="p">:</span>
</span><span id="Backend-933"><a href="#Backend-933"><span class="linenos">933</span></a>                <span class="n">json_len</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">int64</span><span class="p">(</span><span class="n">m</span><span class="p">[</span><span class="mi">0</span><span class="p">])</span>
</span><span id="Backend-934"><a href="#Backend-934"><span class="linenos">934</span></a>                <span class="n">start</span> <span class="o">=</span> <span class="mi">8</span> <span class="o">+</span> <span class="n">json_len</span>
</span><span id="Backend-935"><a href="#Backend-935"><span class="linenos">935</span></a>                <span class="n">metadata</span> <span class="o">=</span> <span class="n">json</span><span class="o">.</span><span class="n">loads</span><span class="p">(</span><span class="n">m</span><span class="p">[</span><span class="mi">8</span><span class="p">:</span><span class="n">start</span><span class="p">])</span>
</span><span id="Backend-936"><a href="#Backend-936"><span class="linenos">936</span></a>                <span class="n">ret</span> <span class="o">=</span> <span class="p">{}</span>
</span><span id="Backend-937"><a href="#Backend-937"><span class="linenos">937</span></a>                <span class="k">for</span> <span class="n">k</span><span class="p">,</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">metadata</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
</span><span id="Backend-938"><a href="#Backend-938"><span class="linenos">938</span></a>                    <span class="k">if</span> <span class="n">k</span> <span class="o">!=</span> <span class="s2">&quot;__metadata__&quot;</span><span class="p">:</span>
</span><span id="Backend-939"><a href="#Backend-939"><span class="linenos">939</span></a>                        <span class="n">dtype</span> <span class="o">=</span> <span class="n">Tensor</span><span class="o">.</span><span class="n">mlir_dtype_map</span><span class="p">[(</span><span class="n">v</span><span class="p">[</span><span class="s2">&quot;dtype&quot;</span><span class="p">])]</span>
</span><span id="Backend-940"><a href="#Backend-940"><span class="linenos">940</span></a>                        <span class="n">data_start</span> <span class="o">=</span> <span class="n">start</span> <span class="o">+</span> <span class="n">v</span><span class="p">[</span><span class="s2">&quot;data_offsets&quot;</span><span class="p">][</span><span class="mi">0</span><span class="p">]</span>
</span><span id="Backend-941"><a href="#Backend-941"><span class="linenos">941</span></a>                        <span class="n">data_end</span> <span class="o">=</span> <span class="n">start</span> <span class="o">+</span> <span class="n">v</span><span class="p">[</span><span class="s2">&quot;data_offsets&quot;</span><span class="p">][</span><span class="mi">1</span><span class="p">]</span>
</span><span id="Backend-942"><a href="#Backend-942"><span class="linenos">942</span></a>                        <span class="n">t_np</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">frombuffer</span><span class="p">(</span><span class="n">m</span><span class="p">[</span><span class="n">data_start</span><span class="p">:</span><span class="n">data_end</span><span class="p">],</span> <span class="n">dtype</span><span class="o">=</span><span class="n">dtype</span><span class="o">.</span><span class="n">numpy</span><span class="p">())</span>
</span><span id="Backend-943"><a href="#Backend-943"><span class="linenos">943</span></a>                        <span class="n">t</span> <span class="o">=</span> <span class="n">backend</span><span class="o">.</span><span class="n">tensor</span><span class="p">(</span><span class="n">t_np</span><span class="p">,</span> <span class="n">dtype</span><span class="o">=</span><span class="n">dtype</span><span class="p">)</span>
</span><span id="Backend-944"><a href="#Backend-944"><span class="linenos">944</span></a>                        <span class="n">t</span> <span class="o">=</span> <span class="n">t</span><span class="o">.</span><span class="n">reshape</span><span class="p">(</span><span class="nb">tuple</span><span class="p">(</span><span class="n">v</span><span class="p">[</span><span class="s2">&quot;shape&quot;</span><span class="p">]))</span>
</span><span id="Backend-945"><a href="#Backend-945"><span class="linenos">945</span></a>                        <span class="n">ret</span><span class="p">[</span><span class="n">k</span><span class="p">]</span> <span class="o">=</span> <span class="n">t</span>
</span><span id="Backend-946"><a href="#Backend-946"><span class="linenos">946</span></a>                <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">ret</span><span class="p">)</span> <span class="o">==</span> <span class="mi">1</span> <span class="ow">and</span> <span class="n">single_key</span> <span class="ow">in</span> <span class="n">ret</span><span class="o">.</span><span class="n">keys</span><span class="p">():</span>
</span><span id="Backend-947"><a href="#Backend-947"><span class="linenos">947</span></a>                    <span class="k">return</span> <span class="n">ret</span><span class="p">[</span><span class="n">single_key</span><span class="p">]</span>
</span><span id="Backend-948"><a href="#Backend-948"><span class="linenos">948</span></a>                <span class="k">return</span> <span class="n">ret</span>
</span><span id="Backend-949"><a href="#Backend-949"><span class="linenos">949</span></a>
</span><span id="Backend-950"><a href="#Backend-950"><span class="linenos">950</span></a>    <span class="k">def</span> <span class="nf">save</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">tensors</span><span class="p">:</span> <span class="n">Dict</span><span class="p">[</span><span class="nb">str</span><span class="p">,</span> <span class="n">Tensor</span><span class="p">],</span> <span class="n">path</span><span class="p">:</span> <span class="nb">str</span><span class="p">,</span> <span class="n">single_key</span><span class="o">=</span><span class="s2">&quot;_tensor&quot;</span><span class="p">):</span>
</span><span id="Backend-951"><a href="#Backend-951"><span class="linenos">951</span></a>        <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">tensors</span><span class="p">,</span> <span class="n">Tensor</span><span class="p">):</span>
</span><span id="Backend-952"><a href="#Backend-952"><span class="linenos">952</span></a>            <span class="n">tensors</span> <span class="o">=</span> <span class="p">{</span><span class="n">single_key</span><span class="p">:</span> <span class="n">tensors</span><span class="p">}</span>
</span><span id="Backend-953"><a href="#Backend-953"><span class="linenos">953</span></a>        <span class="k">else</span><span class="p">:</span>
</span><span id="Backend-954"><a href="#Backend-954"><span class="linenos">954</span></a>            <span class="k">assert</span> <span class="nb">all</span><span class="p">((</span><span class="nb">isinstance</span><span class="p">(</span><span class="n">k</span><span class="p">,</span> <span class="nb">str</span><span class="p">)</span> <span class="ow">and</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">v</span><span class="p">,</span> <span class="n">Tensor</span><span class="p">))</span> <span class="k">for</span> <span class="n">k</span><span class="p">,</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">tensors</span><span class="o">.</span><span class="n">items</span><span class="p">())</span>
</span><span id="Backend-955"><a href="#Backend-955"><span class="linenos">955</span></a>
</span><span id="Backend-956"><a href="#Backend-956"><span class="linenos">956</span></a>        <span class="n">metadata</span><span class="p">,</span> <span class="n">offset</span> <span class="o">=</span> <span class="p">{},</span> <span class="mi">0</span>
</span><span id="Backend-957"><a href="#Backend-957"><span class="linenos">957</span></a>        <span class="k">for</span> <span class="n">k</span><span class="p">,</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">tensors</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
</span><span id="Backend-958"><a href="#Backend-958"><span class="linenos">958</span></a>            <span class="n">metadata</span><span class="p">[</span><span class="n">k</span><span class="p">]</span> <span class="o">=</span> <span class="p">{</span>
</span><span id="Backend-959"><a href="#Backend-959"><span class="linenos">959</span></a>                <span class="s2">&quot;dtype&quot;</span><span class="p">:</span> <span class="n">v</span><span class="o">.</span><span class="n">dtype</span><span class="o">.</span><span class="n">mlir</span><span class="p">,</span>
</span><span id="Backend-960"><a href="#Backend-960"><span class="linenos">960</span></a>                <span class="s2">&quot;shape&quot;</span><span class="p">:</span> <span class="nb">list</span><span class="p">(</span><span class="n">v</span><span class="o">.</span><span class="n">shape</span><span class="p">),</span>
</span><span id="Backend-961"><a href="#Backend-961"><span class="linenos">961</span></a>                <span class="s2">&quot;data_offsets&quot;</span><span class="p">:</span> <span class="p">[</span><span class="n">offset</span><span class="p">,</span> <span class="n">offset</span> <span class="o">+</span> <span class="n">v</span><span class="o">.</span><span class="n">nbytes</span><span class="p">()],</span>
</span><span id="Backend-962"><a href="#Backend-962"><span class="linenos">962</span></a>            <span class="p">}</span>
</span><span id="Backend-963"><a href="#Backend-963"><span class="linenos">963</span></a>            <span class="n">offset</span> <span class="o">+=</span> <span class="n">v</span><span class="o">.</span><span class="n">nbytes</span><span class="p">()</span>
</span><span id="Backend-964"><a href="#Backend-964"><span class="linenos">964</span></a>        <span class="n">j</span> <span class="o">=</span> <span class="n">json</span><span class="o">.</span><span class="n">dumps</span><span class="p">(</span><span class="n">metadata</span><span class="p">,</span> <span class="n">separators</span><span class="o">=</span><span class="p">(</span><span class="s2">&quot;,&quot;</span><span class="p">,</span> <span class="s2">&quot;:&quot;</span><span class="p">))</span>
</span><span id="Backend-965"><a href="#Backend-965"><span class="linenos">965</span></a>        <span class="n">Path</span><span class="p">(</span><span class="n">path</span><span class="p">)</span><span class="o">.</span><span class="n">unlink</span><span class="p">(</span><span class="n">missing_ok</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
</span><span id="Backend-966"><a href="#Backend-966"><span class="linenos">966</span></a>        <span class="n">jbytes</span> <span class="o">=</span> <span class="n">j</span><span class="o">.</span><span class="n">encode</span><span class="p">(</span><span class="s2">&quot;utf-8&quot;</span><span class="p">)</span>
</span><span id="Backend-967"><a href="#Backend-967"><span class="linenos">967</span></a>        <span class="n">start</span> <span class="o">=</span> <span class="mi">8</span> <span class="o">+</span> <span class="nb">len</span><span class="p">(</span><span class="n">jbytes</span><span class="p">)</span>
</span><span id="Backend-968"><a href="#Backend-968"><span class="linenos">968</span></a>        <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">path</span><span class="p">,</span> <span class="n">mode</span><span class="o">=</span><span class="s2">&quot;wb&quot;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>  <span class="c1"># make empty file, fill with enough space</span>
</span><span id="Backend-969"><a href="#Backend-969"><span class="linenos">969</span></a>            <span class="n">f</span><span class="o">.</span><span class="n">write</span><span class="p">(</span><span class="sa">b</span><span class="s2">&quot;</span><span class="se">\x00</span><span class="s2">&quot;</span> <span class="o">*</span> <span class="p">(</span><span class="n">start</span> <span class="o">+</span> <span class="n">offset</span><span class="p">))</span>
</span><span id="Backend-970"><a href="#Backend-970"><span class="linenos">970</span></a>        <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">path</span><span class="p">,</span> <span class="n">mode</span><span class="o">=</span><span class="s2">&quot;r+b&quot;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
</span><span id="Backend-971"><a href="#Backend-971"><span class="linenos">971</span></a>            <span class="k">with</span> <span class="n">mmap</span><span class="o">.</span><span class="n">mmap</span><span class="p">(</span><span class="n">f</span><span class="o">.</span><span class="n">fileno</span><span class="p">(),</span> <span class="n">length</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">access</span><span class="o">=</span><span class="n">mmap</span><span class="o">.</span><span class="n">ACCESS_WRITE</span><span class="p">)</span> <span class="k">as</span> <span class="n">m</span><span class="p">:</span>
</span><span id="Backend-972"><a href="#Backend-972"><span class="linenos">972</span></a>                <span class="n">m</span><span class="p">[</span><span class="mi">0</span><span class="p">:</span><span class="mi">8</span><span class="p">]</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">int64</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">j</span><span class="p">))</span><span class="o">.</span><span class="n">tobytes</span><span class="p">()</span>
</span><span id="Backend-973"><a href="#Backend-973"><span class="linenos">973</span></a>                <span class="n">m</span><span class="p">[</span><span class="mi">8</span><span class="p">:</span><span class="n">start</span><span class="p">]</span> <span class="o">=</span> <span class="n">jbytes</span>
</span><span id="Backend-974"><a href="#Backend-974"><span class="linenos">974</span></a>                <span class="k">for</span> <span class="n">t</span><span class="p">,</span> <span class="n">tm</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">tensors</span><span class="o">.</span><span class="n">values</span><span class="p">(),</span> <span class="n">metadata</span><span class="o">.</span><span class="n">values</span><span class="p">()):</span>
</span><span id="Backend-975"><a href="#Backend-975"><span class="linenos">975</span></a>                    <span class="n">data_start</span><span class="p">,</span> <span class="n">data_end</span> <span class="o">=</span> <span class="n">tm</span><span class="p">[</span><span class="s2">&quot;data_offsets&quot;</span><span class="p">]</span>
</span><span id="Backend-976"><a href="#Backend-976"><span class="linenos">976</span></a>                    <span class="n">m</span><span class="p">[</span><span class="n">start</span> <span class="o">+</span> <span class="n">data_start</span> <span class="p">:</span> <span class="n">start</span> <span class="o">+</span> <span class="n">data_end</span><span class="p">]</span> <span class="o">=</span> <span class="n">t</span><span class="o">.</span><span class="n">numpy</span><span class="p">()</span><span class="o">.</span><span class="n">tobytes</span><span class="p">()</span>
</span></pre></div>


    

                            <div id="Backend.__init__" class="classattr">
                                        <input id="Backend.__init__-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="name">Backend</span><span class="signature pdoc-code multiline">(<span class="param">	<span class="n">operator_set</span><span class="p">:</span> <span class="n"><a href="#OperatorSet">OperatorSet</a></span>,</span><span class="param">	<span class="n">procedure_set</span><span class="p">:</span> <span class="n"><a href="#ProcedureSet">ProcedureSet</a></span></span>)</span>

                <label class="view-source-button" for="Backend.__init__-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Backend.__init__"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Backend.__init__-797"><a href="#Backend.__init__-797"><span class="linenos">797</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span>
</span><span id="Backend.__init__-798"><a href="#Backend.__init__-798"><span class="linenos">798</span></a>        <span class="bp">self</span><span class="p">,</span>
</span><span id="Backend.__init__-799"><a href="#Backend.__init__-799"><span class="linenos">799</span></a>        <span class="n">operator_set</span><span class="p">:</span> <span class="n">OperatorSet</span><span class="p">,</span>
</span><span id="Backend.__init__-800"><a href="#Backend.__init__-800"><span class="linenos">800</span></a>        <span class="n">procedure_set</span><span class="p">:</span> <span class="n">ProcedureSet</span><span class="p">,</span>
</span><span id="Backend.__init__-801"><a href="#Backend.__init__-801"><span class="linenos">801</span></a>    <span class="p">):</span>
</span><span id="Backend.__init__-802"><a href="#Backend.__init__-802"><span class="linenos">802</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">operator_set</span> <span class="o">=</span> <span class="n">operator_set</span>
</span><span id="Backend.__init__-803"><a href="#Backend.__init__-803"><span class="linenos">803</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">procedure_set</span> <span class="o">=</span> <span class="n">procedure_set</span>
</span><span id="Backend.__init__-804"><a href="#Backend.__init__-804"><span class="linenos">804</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">node_types</span> <span class="o">=</span> <span class="nb">dict</span><span class="p">()</span>
</span><span id="Backend.__init__-805"><a href="#Backend.__init__-805"><span class="linenos">805</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">impls</span> <span class="o">=</span> <span class="nb">dict</span><span class="p">()</span>
</span><span id="Backend.__init__-806"><a href="#Backend.__init__-806"><span class="linenos">806</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">register_node</span><span class="p">(</span><span class="nb">tuple</span><span class="p">,</span> <span class="k">lambda</span> <span class="n">t</span><span class="p">:</span> <span class="p">(</span><span class="kc">None</span><span class="p">,</span> <span class="n">t</span><span class="p">),</span> <span class="k">lambda</span> <span class="n">_</span><span class="p">,</span> <span class="n">xs</span><span class="p">:</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">xs</span><span class="p">),</span> <span class="s2">&quot;tuple&quot;</span><span class="p">)</span>
</span><span id="Backend.__init__-807"><a href="#Backend.__init__-807"><span class="linenos">807</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">register_node</span><span class="p">(</span><span class="nb">list</span><span class="p">,</span> <span class="k">lambda</span> <span class="n">l</span><span class="p">:</span> <span class="p">(</span><span class="kc">None</span><span class="p">,</span> <span class="n">l</span><span class="p">),</span> <span class="k">lambda</span> <span class="n">_</span><span class="p">,</span> <span class="n">xs</span><span class="p">:</span> <span class="nb">list</span><span class="p">(</span><span class="n">xs</span><span class="p">),</span> <span class="s2">&quot;list&quot;</span><span class="p">)</span>
</span><span id="Backend.__init__-808"><a href="#Backend.__init__-808"><span class="linenos">808</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">register_node</span><span class="p">(</span>
</span><span id="Backend.__init__-809"><a href="#Backend.__init__-809"><span class="linenos">809</span></a>            <span class="nb">dict</span><span class="p">,</span>
</span><span id="Backend.__init__-810"><a href="#Backend.__init__-810"><span class="linenos">810</span></a>            <span class="k">lambda</span> <span class="n">d</span><span class="p">:</span> <span class="n">list_map</span><span class="p">(</span><span class="nb">tuple</span><span class="p">,</span> <span class="n">unzip2</span><span class="p">(</span><span class="nb">sorted</span><span class="p">(</span><span class="n">d</span><span class="o">.</span><span class="n">items</span><span class="p">()))),</span>
</span><span id="Backend.__init__-811"><a href="#Backend.__init__-811"><span class="linenos">811</span></a>            <span class="k">lambda</span> <span class="n">keys</span><span class="p">,</span> <span class="n">vals</span><span class="p">:</span> <span class="nb">dict</span><span class="p">(</span><span class="n">list_zip</span><span class="p">(</span><span class="n">keys</span><span class="p">,</span> <span class="n">vals</span><span class="p">)),</span>
</span><span id="Backend.__init__-812"><a href="#Backend.__init__-812"><span class="linenos">812</span></a>            <span class="s2">&quot;dict&quot;</span><span class="p">,</span>
</span><span id="Backend.__init__-813"><a href="#Backend.__init__-813"><span class="linenos">813</span></a>        <span class="p">)</span>
</span><span id="Backend.__init__-814"><a href="#Backend.__init__-814"><span class="linenos">814</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">register_node</span><span class="p">(</span>
</span><span id="Backend.__init__-815"><a href="#Backend.__init__-815"><span class="linenos">815</span></a>            <span class="n">UndefinedPrimal</span><span class="p">,</span>
</span><span id="Backend.__init__-816"><a href="#Backend.__init__-816"><span class="linenos">816</span></a>            <span class="k">lambda</span> <span class="n">u</span><span class="p">:</span> <span class="p">(</span><span class="n">u</span><span class="o">.</span><span class="n">symval</span><span class="p">,</span> <span class="p">()),</span>
</span><span id="Backend.__init__-817"><a href="#Backend.__init__-817"><span class="linenos">817</span></a>            <span class="k">lambda</span> <span class="n">symval</span><span class="p">,</span> <span class="n">_</span><span class="p">:</span> <span class="n">UndefinedPrimal</span><span class="p">(</span><span class="n">symval</span><span class="p">),</span>
</span><span id="Backend.__init__-818"><a href="#Backend.__init__-818"><span class="linenos">818</span></a>            <span class="s2">&quot;UndefinedPrimal&quot;</span><span class="p">,</span>
</span><span id="Backend.__init__-819"><a href="#Backend.__init__-819"><span class="linenos">819</span></a>        <span class="p">)</span>
</span></pre></div>


    

                            </div>
                            <div id="Backend.LOG_LRU" class="classattr">
                                <div class="attr variable">
            <span class="name">LOG_LRU</span>        =
<span class="default_value">0</span>

        
    </div>
    <a class="headerlink" href="#Backend.LOG_LRU"></a>
    
    

                            </div>
                            <div id="Backend.LOG_JIT" class="classattr">
                                <div class="attr variable">
            <span class="name">LOG_JIT</span>        =
<span class="default_value">0</span>

        
    </div>
    <a class="headerlink" href="#Backend.LOG_JIT"></a>
    
    

                            </div>
                            <div id="Backend.LOG_TREE" class="classattr">
                                <div class="attr variable">
            <span class="name">LOG_TREE</span>        =
<span class="default_value">0</span>

        
    </div>
    <a class="headerlink" href="#Backend.LOG_TREE"></a>
    
    

                            </div>
                            <div id="Backend.LOG_BACKEND" class="classattr">
                                <div class="attr variable">
            <span class="name">LOG_BACKEND</span>        =
<span class="default_value">0</span>

        
    </div>
    <a class="headerlink" href="#Backend.LOG_BACKEND"></a>
    
    

                            </div>
                            <div id="Backend.LOG_PROGRAM" class="classattr">
                                <div class="attr variable">
            <span class="name">LOG_PROGRAM</span>        =
<span class="default_value">0</span>

        
    </div>
    <a class="headerlink" href="#Backend.LOG_PROGRAM"></a>
    
    

                            </div>
                            <div id="Backend.LOG_INIT" class="classattr">
                                <div class="attr variable">
            <span class="name">LOG_INIT</span>        =
<span class="default_value">1</span>

        
    </div>
    <a class="headerlink" href="#Backend.LOG_INIT"></a>
    
    

                            </div>
                            <div id="Backend.device_var" class="classattr">
                                <div class="attr variable">
            <span class="name">device_var</span>        =
<span class="default_value">&#39;cpu:0&#39;</span>

        
    </div>
    <a class="headerlink" href="#Backend.device_var"></a>
    
    

                            </div>
                            <div id="Backend.DEFAULT_DEVICE" class="classattr">
                                <div class="attr variable">
            <span class="name">DEFAULT_DEVICE</span>        =
<span class="default_value">&lt;Device: &#39;cpu:0&#39;&gt;</span>

        
    </div>
    <a class="headerlink" href="#Backend.DEFAULT_DEVICE"></a>
    
    

                            </div>
                            <div id="Backend.DEFAULT_DTYPE" class="classattr">
                                <div class="attr variable">
            <span class="name">DEFAULT_DTYPE</span>        =
<span class="default_value">&lt;DType: float32&gt;</span>

        
    </div>
    <a class="headerlink" href="#Backend.DEFAULT_DTYPE"></a>
    
    

                            </div>
                            <div id="Backend.dtype_for_indices" class="classattr">
                                <div class="attr variable">
            <span class="name">dtype_for_indices</span><span class="annotation">: <a href="#DType">DType</a></span>        =
<span class="default_value">None</span>

        
    </div>
    <a class="headerlink" href="#Backend.dtype_for_indices"></a>
    
    

                            </div>
                            <div id="Backend.operator_set" class="classattr">
                                <div class="attr variable">
            <span class="name">operator_set</span>

        
    </div>
    <a class="headerlink" href="#Backend.operator_set"></a>
    
    

                            </div>
                            <div id="Backend.procedure_set" class="classattr">
                                <div class="attr variable">
            <span class="name">procedure_set</span>

        
    </div>
    <a class="headerlink" href="#Backend.procedure_set"></a>
    
    

                            </div>
                            <div id="Backend.node_types" class="classattr">
                                <div class="attr variable">
            <span class="name">node_types</span>

        
    </div>
    <a class="headerlink" href="#Backend.node_types"></a>
    
    

                            </div>
                            <div id="Backend.impls" class="classattr">
                                <div class="attr variable">
            <span class="name">impls</span>

        
    </div>
    <a class="headerlink" href="#Backend.impls"></a>
    
    

                            </div>
                            <div id="Backend.set_impl" class="classattr">
                                        <input id="Backend.set_impl-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">set_impl</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="n">op</span><span class="p">:</span> <span class="n">function</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="Backend.set_impl-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Backend.set_impl"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Backend.set_impl-821"><a href="#Backend.set_impl-821"><span class="linenos">821</span></a>    <span class="k">def</span> <span class="nf">set_impl</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">op</span><span class="p">:</span> <span class="n">Union</span><span class="p">[</span><span class="n">types</span><span class="o">.</span><span class="n">LambdaType</span><span class="p">,</span> <span class="n">types</span><span class="o">.</span><span class="n">FunctionType</span><span class="p">]):</span>
</span><span id="Backend.set_impl-822"><a href="#Backend.set_impl-822"><span class="linenos">822</span></a>        <span class="k">def</span> <span class="nf">set_impl_</span><span class="p">(</span><span class="n">fn</span><span class="p">):</span>
</span><span id="Backend.set_impl-823"><a href="#Backend.set_impl-823"><span class="linenos">823</span></a>            <span class="bp">self</span><span class="o">.</span><span class="n">impls</span><span class="p">[</span><span class="n">op</span><span class="p">]</span> <span class="o">=</span> <span class="n">types</span><span class="o">.</span><span class="n">MethodType</span><span class="p">(</span><span class="n">fn</span><span class="p">,</span> <span class="bp">self</span><span class="p">)</span>
</span><span id="Backend.set_impl-824"><a href="#Backend.set_impl-824"><span class="linenos">824</span></a>
</span><span id="Backend.set_impl-825"><a href="#Backend.set_impl-825"><span class="linenos">825</span></a>        <span class="k">return</span> <span class="n">set_impl_</span>
</span></pre></div>


    

                            </div>
                            <div id="Backend.register_node" class="classattr">
                                        <input id="Backend.register_node-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">register_node</span><span class="signature pdoc-code multiline">(<span class="param">	<span class="bp">self</span>,</span><span class="param">	<span class="n">ty</span><span class="p">:</span> <span class="n">Type</span>,</span><span class="param">	<span class="n">to_iter</span><span class="p">:</span> <span class="n">Callable</span>,</span><span class="param">	<span class="n">from_iter</span><span class="p">:</span> <span class="n">Callable</span>,</span><span class="param">	<span class="n">name</span><span class="o">=</span><span class="kc">None</span></span><span class="return-annotation">) -> <span class="kc">None</span>:</span></span>

                <label class="view-source-button" for="Backend.register_node-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Backend.register_node"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Backend.register_node-827"><a href="#Backend.register_node-827"><span class="linenos">827</span></a>    <span class="k">def</span> <span class="nf">register_node</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">ty</span><span class="p">:</span> <span class="n">Type</span><span class="p">,</span> <span class="n">to_iter</span><span class="p">:</span> <span class="n">Callable</span><span class="p">,</span> <span class="n">from_iter</span><span class="p">:</span> <span class="n">Callable</span><span class="p">,</span> <span class="n">name</span><span class="o">=</span><span class="kc">None</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="kc">None</span><span class="p">:</span>
</span><span id="Backend.register_node-828"><a href="#Backend.register_node-828"><span class="linenos">828</span></a>        <span class="k">if</span> <span class="n">name</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
</span><span id="Backend.register_node-829"><a href="#Backend.register_node-829"><span class="linenos">829</span></a>            <span class="n">name</span> <span class="o">=</span> <span class="nb">str</span><span class="p">(</span><span class="n">ty</span><span class="p">)</span>
</span><span id="Backend.register_node-830"><a href="#Backend.register_node-830"><span class="linenos">830</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">node_types</span><span class="p">[</span><span class="n">ty</span><span class="p">]</span> <span class="o">=</span> <span class="n">NodeType</span><span class="p">(</span><span class="n">name</span><span class="p">,</span> <span class="n">to_iter</span><span class="p">,</span> <span class="n">from_iter</span><span class="p">)</span>
</span></pre></div>


    

                            </div>
                            <div id="Backend.tensor" class="classattr">
                                        <input id="Backend.tensor-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">tensor</span><span class="signature pdoc-code multiline">(<span class="param">	<span class="bp">self</span>,</span><span class="param">	<span class="n">val</span><span class="p">:</span> <span class="n">Union</span><span class="p">[</span><span class="nb">list</span><span class="p">,</span> <span class="nb">tuple</span><span class="p">,</span> <span class="n">numpy</span><span class="o">.</span><span class="n">ndarray</span><span class="p">,</span> <span class="n"><a href="#TensorBuffer">TensorBuffer</a></span><span class="p">]</span> <span class="o">=</span> <span class="kc">None</span>,</span><span class="param">	<span class="n">dtype</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="n">Any</span><span class="p">]</span> <span class="o">=</span> <span class="kc">None</span>,</span><span class="param">	<span class="n">device</span><span class="o">=</span><span class="kc">None</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="Backend.tensor-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Backend.tensor"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Backend.tensor-855"><a href="#Backend.tensor-855"><span class="linenos">855</span></a>    <span class="k">def</span> <span class="nf">tensor</span><span class="p">(</span>
</span><span id="Backend.tensor-856"><a href="#Backend.tensor-856"><span class="linenos">856</span></a>        <span class="bp">self</span><span class="p">,</span>
</span><span id="Backend.tensor-857"><a href="#Backend.tensor-857"><span class="linenos">857</span></a>        <span class="n">val</span><span class="p">:</span> <span class="n">Union</span><span class="p">[</span><span class="nb">list</span><span class="p">,</span> <span class="nb">tuple</span><span class="p">,</span> <span class="n">np</span><span class="o">.</span><span class="n">ndarray</span><span class="p">,</span> <span class="s2">&quot;TensorBuffer&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span>
</span><span id="Backend.tensor-858"><a href="#Backend.tensor-858"><span class="linenos">858</span></a>        <span class="n">dtype</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="n">Any</span><span class="p">]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span>
</span><span id="Backend.tensor-859"><a href="#Backend.tensor-859"><span class="linenos">859</span></a>        <span class="n">device</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span>
</span><span id="Backend.tensor-860"><a href="#Backend.tensor-860"><span class="linenos">860</span></a>    <span class="p">):</span>
</span><span id="Backend.tensor-861"><a href="#Backend.tensor-861"><span class="linenos">861</span></a>        <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">val</span><span class="p">,</span> <span class="n">TensorBuffer</span><span class="p">):</span>
</span><span id="Backend.tensor-862"><a href="#Backend.tensor-862"><span class="linenos">862</span></a>            <span class="k">return</span> <span class="n">Tensor</span><span class="p">(</span><span class="n">val</span><span class="p">)</span>
</span><span id="Backend.tensor-863"><a href="#Backend.tensor-863"><span class="linenos">863</span></a>        <span class="k">elif</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">val</span><span class="p">,</span> <span class="n">Tensor</span><span class="p">):</span>
</span><span id="Backend.tensor-864"><a href="#Backend.tensor-864"><span class="linenos">864</span></a>            <span class="k">return</span> <span class="n">val</span>
</span><span id="Backend.tensor-865"><a href="#Backend.tensor-865"><span class="linenos">865</span></a>        <span class="k">if</span> <span class="nb">type</span><span class="p">(</span><span class="n">val</span><span class="p">)</span> <span class="ow">is</span> <span class="nb">bytes</span><span class="p">:</span>
</span><span id="Backend.tensor-866"><a href="#Backend.tensor-866"><span class="linenos">866</span></a>            <span class="n">val</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">frombuffer</span><span class="p">(</span><span class="n">val</span><span class="p">,</span> <span class="n">dtype</span><span class="o">=</span><span class="n">dtype</span><span class="p">)</span>
</span><span id="Backend.tensor-867"><a href="#Backend.tensor-867"><span class="linenos">867</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">from_numpy</span><span class="p">(</span><span class="n">val</span><span class="p">,</span> <span class="n">dtype</span><span class="p">,</span> <span class="n">device</span><span class="p">)</span>
</span></pre></div>


    

                            </div>
                            <div id="Backend.symbolic_tensor" class="classattr">
                                        <input id="Backend.symbolic_tensor-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">symbolic_tensor</span><span class="signature pdoc-code multiline">(<span class="param">	<span class="bp">self</span>,</span><span class="param">	<span class="n">shape</span><span class="p">:</span> <span class="n">Union</span><span class="p">[</span><span class="nb">list</span><span class="p">,</span> <span class="nb">tuple</span><span class="p">,</span> <span class="n">numpy</span><span class="o">.</span><span class="n">ndarray</span><span class="p">,</span> <span class="n"><a href="#TensorBuffer">TensorBuffer</a></span><span class="p">]</span> <span class="o">=</span> <span class="kc">None</span>,</span><span class="param">	<span class="n">dtype</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="n">Any</span><span class="p">]</span> <span class="o">=</span> <span class="kc">None</span>,</span><span class="param">	<span class="n">device</span><span class="o">=</span><span class="kc">None</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="Backend.symbolic_tensor-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Backend.symbolic_tensor"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Backend.symbolic_tensor-869"><a href="#Backend.symbolic_tensor-869"><span class="linenos">869</span></a>    <span class="k">def</span> <span class="nf">symbolic_tensor</span><span class="p">(</span>
</span><span id="Backend.symbolic_tensor-870"><a href="#Backend.symbolic_tensor-870"><span class="linenos">870</span></a>        <span class="bp">self</span><span class="p">,</span>
</span><span id="Backend.symbolic_tensor-871"><a href="#Backend.symbolic_tensor-871"><span class="linenos">871</span></a>        <span class="n">shape</span><span class="p">:</span> <span class="n">Union</span><span class="p">[</span><span class="nb">list</span><span class="p">,</span> <span class="nb">tuple</span><span class="p">,</span> <span class="n">np</span><span class="o">.</span><span class="n">ndarray</span><span class="p">,</span> <span class="s2">&quot;TensorBuffer&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span>
</span><span id="Backend.symbolic_tensor-872"><a href="#Backend.symbolic_tensor-872"><span class="linenos">872</span></a>        <span class="n">dtype</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="n">Any</span><span class="p">]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span>
</span><span id="Backend.symbolic_tensor-873"><a href="#Backend.symbolic_tensor-873"><span class="linenos">873</span></a>        <span class="n">device</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span>
</span><span id="Backend.symbolic_tensor-874"><a href="#Backend.symbolic_tensor-874"><span class="linenos">874</span></a>    <span class="p">):</span>
</span><span id="Backend.symbolic_tensor-875"><a href="#Backend.symbolic_tensor-875"><span class="linenos">875</span></a>        <span class="n">dtype</span> <span class="o">=</span> <span class="n">dtype</span> <span class="ow">or</span> <span class="bp">self</span><span class="o">.</span><span class="n">DEFAULT_DTYPE</span>
</span><span id="Backend.symbolic_tensor-876"><a href="#Backend.symbolic_tensor-876"><span class="linenos">876</span></a>        <span class="n">device</span> <span class="o">=</span> <span class="n">device</span> <span class="ow">or</span> <span class="bp">self</span><span class="o">.</span><span class="n">DEFAULT_DEVICE</span>
</span><span id="Backend.symbolic_tensor-877"><a href="#Backend.symbolic_tensor-877"><span class="linenos">877</span></a>        <span class="k">return</span> <span class="n">SymbolicTensor</span><span class="p">(</span><span class="n">shape</span><span class="p">,</span> <span class="n">dtype</span><span class="p">,</span> <span class="n">device</span><span class="p">)</span>
</span></pre></div>


    

                            </div>
                            <div id="Backend.seed" class="classattr">
                                        <input id="Backend.seed-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">seed</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="n">seed</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="Backend.seed-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Backend.seed"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Backend.seed-879"><a href="#Backend.seed-879"><span class="linenos">879</span></a>    <span class="k">def</span> <span class="nf">seed</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">seed</span><span class="p">):</span>
</span><span id="Backend.seed-880"><a href="#Backend.seed-880"><span class="linenos">880</span></a>        <span class="k">raise</span> <span class="ne">NotImplementedError</span>
</span></pre></div>


    

                            </div>
                            <div id="Backend.default_dtype_value" class="classattr">
                                        <input id="Backend.default_dtype_value-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr variable">
            <span class="name">default_dtype_value</span>

                <label class="view-source-button" for="Backend.default_dtype_value-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Backend.default_dtype_value"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Backend.default_dtype_value-882"><a href="#Backend.default_dtype_value-882"><span class="linenos">882</span></a>    <span class="nd">@property</span>
</span><span id="Backend.default_dtype_value-883"><a href="#Backend.default_dtype_value-883"><span class="linenos">883</span></a>    <span class="k">def</span> <span class="nf">default_dtype_value</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="Backend.default_dtype_value-884"><a href="#Backend.default_dtype_value-884"><span class="linenos">884</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">dtype_map</span><span class="p">[</span><span class="n">backend</span><span class="o">.</span><span class="n">DEFAULT_DTYPE</span><span class="p">]</span>
</span></pre></div>


    

                            </div>
                            <div id="Backend.set_method" class="classattr">
                                        <input id="Backend.set_method-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">set_method</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="n">method</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="Backend.set_method-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Backend.set_method"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Backend.set_method-886"><a href="#Backend.set_method-886"><span class="linenos">886</span></a>    <span class="k">def</span> <span class="nf">set_method</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">method</span><span class="p">):</span>
</span><span id="Backend.set_method-887"><a href="#Backend.set_method-887"><span class="linenos">887</span></a>        <span class="nb">setattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">method</span><span class="o">.</span><span class="vm">__name__</span><span class="p">,</span> <span class="n">types</span><span class="o">.</span><span class="n">MethodType</span><span class="p">(</span><span class="n">method</span><span class="p">,</span> <span class="bp">self</span><span class="p">))</span>
</span></pre></div>


    

                            </div>
                            <div id="Backend.from_numpy" class="classattr">
                                        <input id="Backend.from_numpy-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">from_numpy</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="n">val</span>, </span><span class="param"><span class="n">device</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="Backend.from_numpy-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Backend.from_numpy"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Backend.from_numpy-889"><a href="#Backend.from_numpy-889"><span class="linenos">889</span></a>    <span class="k">def</span> <span class="nf">from_numpy</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">val</span><span class="p">,</span> <span class="n">device</span><span class="p">):</span>
</span><span id="Backend.from_numpy-890"><a href="#Backend.from_numpy-890"><span class="linenos">890</span></a>        <span class="k">raise</span> <span class="ne">NotImplementedError</span>
</span></pre></div>


    

                            </div>
                            <div id="Backend.numpy_of" class="classattr">
                                        <input id="Backend.numpy_of-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">numpy_of</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="n">tensor</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="Backend.numpy_of-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Backend.numpy_of"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Backend.numpy_of-892"><a href="#Backend.numpy_of-892"><span class="linenos">892</span></a>    <span class="k">def</span> <span class="nf">numpy_of</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">tensor</span><span class="p">):</span>
</span><span id="Backend.numpy_of-893"><a href="#Backend.numpy_of-893"><span class="linenos">893</span></a>        <span class="k">raise</span> <span class="ne">NotImplementedError</span>
</span></pre></div>


    

                            </div>
                            <div id="Backend.device_of" class="classattr">
                                        <input id="Backend.device_of-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">device_of</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="n">tensor</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="Backend.device_of-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Backend.device_of"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Backend.device_of-895"><a href="#Backend.device_of-895"><span class="linenos">895</span></a>    <span class="k">def</span> <span class="nf">device_of</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">tensor</span><span class="p">):</span>
</span><span id="Backend.device_of-896"><a href="#Backend.device_of-896"><span class="linenos">896</span></a>        <span class="k">raise</span> <span class="ne">NotImplementedError</span>
</span></pre></div>


    

                            </div>
                            <div id="Backend.shape_of" class="classattr">
                                        <input id="Backend.shape_of-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">shape_of</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="n">tensor</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="Backend.shape_of-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Backend.shape_of"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Backend.shape_of-898"><a href="#Backend.shape_of-898"><span class="linenos">898</span></a>    <span class="k">def</span> <span class="nf">shape_of</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">tensor</span><span class="p">):</span>
</span><span id="Backend.shape_of-899"><a href="#Backend.shape_of-899"><span class="linenos">899</span></a>        <span class="k">raise</span> <span class="ne">NotImplementedError</span>
</span></pre></div>


    

                            </div>
                            <div id="Backend.dtype_of" class="classattr">
                                        <input id="Backend.dtype_of-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">dtype_of</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="n">tensor</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="Backend.dtype_of-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Backend.dtype_of"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Backend.dtype_of-901"><a href="#Backend.dtype_of-901"><span class="linenos">901</span></a>    <span class="k">def</span> <span class="nf">dtype_of</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">tensor</span><span class="p">):</span>
</span><span id="Backend.dtype_of-902"><a href="#Backend.dtype_of-902"><span class="linenos">902</span></a>        <span class="k">raise</span> <span class="ne">NotImplementedError</span>
</span></pre></div>


    

                            </div>
                            <div id="Backend.jit_program" class="classattr">
                                        <input id="Backend.jit_program-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">jit_program</span><span class="signature pdoc-code condensed">(<span class="param"><span class="o">*</span><span class="n">args</span>, </span><span class="param"><span class="o">**</span><span class="n">kwargs</span></span><span class="return-annotation">) -> <span class="n">Any</span>:</span></span>

                <label class="view-source-button" for="Backend.jit_program-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Backend.jit_program"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Backend.jit_program-172"><a href="#Backend.jit_program-172"><span class="linenos">172</span></a>        <span class="k">def</span> <span class="nf">decorated_function</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Any</span><span class="p">:</span>
</span><span id="Backend.jit_program-173"><a href="#Backend.jit_program-173"><span class="linenos">173</span></a>            <span class="n">result</span> <span class="o">=</span> <span class="n">wrapper</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">)</span>
</span><span id="Backend.jit_program-174"><a href="#Backend.jit_program-174"><span class="linenos">174</span></a>            <span class="n">cache_info</span> <span class="o">=</span> <span class="n">wrapper</span><span class="o">.</span><span class="n">cache_info</span><span class="p">()</span>
</span><span id="Backend.jit_program-175"><a href="#Backend.jit_program-175"><span class="linenos">175</span></a>
</span><span id="Backend.jit_program-176"><a href="#Backend.jit_program-176"><span class="linenos">176</span></a>            <span class="n">dblog</span><span class="p">(</span>
</span><span id="Backend.jit_program-177"><a href="#Backend.jit_program-177"><span class="linenos">177</span></a>                <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">fn</span><span class="o">.</span><span class="vm">__name__</span><span class="si">}</span><span class="s2">.</span><span class="si">{</span><span class="n">cache_info</span><span class="si">}</span><span class="s2"> </span><span class="si">{</span><span class="n">args</span><span class="o">.</span><span class="fm">__hash__</span><span class="p">()</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">,</span>
</span><span id="Backend.jit_program-178"><a href="#Backend.jit_program-178"><span class="linenos">178</span></a>                <span class="n">enable</span><span class="o">=</span><span class="n">backend</span><span class="o">.</span><span class="n">LOG_LRU</span><span class="p">,</span>
</span><span id="Backend.jit_program-179"><a href="#Backend.jit_program-179"><span class="linenos">179</span></a>            <span class="p">)</span>
</span><span id="Backend.jit_program-180"><a href="#Backend.jit_program-180"><span class="linenos">180</span></a>            <span class="n">tb</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">traceback</span><span class="o">.</span><span class="n">format_list</span><span class="p">(</span><span class="n">traceback</span><span class="o">.</span><span class="n">extract_stack</span><span class="p">())[</span><span class="n">tb_start</span><span class="p">:</span><span class="n">tb_end</span><span class="p">])</span><span class="o">.</span><span class="n">replace</span><span class="p">(</span><span class="s2">&quot;</span><span class="se">\n</span><span class="s2">    &quot;</span><span class="p">,</span> <span class="s2">&quot;:</span><span class="se">\t</span><span class="s2">&quot;</span><span class="p">)</span> <span class="o">+</span> <span class="s2">&quot;-&quot;</span> <span class="o">*</span> <span class="mi">20</span> <span class="o">+</span> <span class="s2">&quot;</span><span class="se">\n</span><span class="s2">&quot;</span>
</span><span id="Backend.jit_program-181"><a href="#Backend.jit_program-181"><span class="linenos">181</span></a>            <span class="n">dblog</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">tb</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">,</span> <span class="n">enable</span><span class="o">=</span><span class="n">backend</span><span class="o">.</span><span class="n">LOG_LRU</span><span class="p">)</span>
</span><span id="Backend.jit_program-182"><a href="#Backend.jit_program-182"><span class="linenos">182</span></a>
</span><span id="Backend.jit_program-183"><a href="#Backend.jit_program-183"><span class="linenos">183</span></a>            <span class="k">return</span> <span class="n">result</span>
</span></pre></div>


    

                            </div>
                            <div id="Backend.codegen" class="classattr">
                                        <input id="Backend.codegen-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">codegen</span><span class="signature pdoc-code multiline">(<span class="param">	<span class="bp">self</span>,</span><span class="param">	<span class="n">program</span><span class="p">:</span> <span class="n"><a href="#Program">Program</a></span>,</span><span class="param">	<span class="n">args</span><span class="p">:</span> <span class="n">Tuple</span>,</span><span class="param">	<span class="n">in_symvals</span><span class="p">:</span> <span class="n">Tuple</span>,</span><span class="param">	<span class="n">name</span><span class="p">:</span> <span class="nb">str</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="Backend.codegen-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Backend.codegen"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Backend.codegen-919"><a href="#Backend.codegen-919"><span class="linenos">919</span></a>    <span class="k">def</span> <span class="nf">codegen</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">program</span><span class="p">:</span> <span class="s2">&quot;Program&quot;</span><span class="p">,</span> <span class="n">args</span><span class="p">:</span> <span class="n">Tuple</span><span class="p">,</span> <span class="n">in_symvals</span><span class="p">:</span> <span class="n">Tuple</span><span class="p">,</span> <span class="n">name</span><span class="p">:</span> <span class="nb">str</span><span class="p">):</span>
</span><span id="Backend.codegen-920"><a href="#Backend.codegen-920"><span class="linenos">920</span></a>        <span class="s2">&quot;Returns compiler IR from the Program&quot;</span>
</span><span id="Backend.codegen-921"><a href="#Backend.codegen-921"><span class="linenos">921</span></a>        <span class="k">raise</span> <span class="ne">NotImplementedError</span>
</span></pre></div>


            <div class="docstring"><p>Returns compiler IR from the Program</p>
</div>


                            </div>
                            <div id="Backend.compile" class="classattr">
                                        <input id="Backend.compile-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">compile</span><span class="signature pdoc-code multiline">(<span class="param">	<span class="bp">self</span>,</span><span class="param">	<span class="n">program</span><span class="p">:</span> <span class="n"><a href="#Program">Program</a></span>,</span><span class="param">	<span class="n">args</span><span class="p">:</span> <span class="n">Tuple</span>,</span><span class="param">	<span class="n">in_symvals</span><span class="p">:</span> <span class="n">Tuple</span>,</span><span class="param">	<span class="n">name</span><span class="p">:</span> <span class="nb">str</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="Backend.compile-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Backend.compile"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Backend.compile-923"><a href="#Backend.compile-923"><span class="linenos">923</span></a>    <span class="k">def</span> <span class="nf">compile</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">program</span><span class="p">:</span> <span class="s2">&quot;Program&quot;</span><span class="p">,</span> <span class="n">args</span><span class="p">:</span> <span class="n">Tuple</span><span class="p">,</span> <span class="n">in_symvals</span><span class="p">:</span> <span class="n">Tuple</span><span class="p">,</span> <span class="n">name</span><span class="p">:</span> <span class="nb">str</span><span class="p">):</span>
</span><span id="Backend.compile-924"><a href="#Backend.compile-924"><span class="linenos">924</span></a>        <span class="s2">&quot;Compiles compiler IR to a Python callable function&quot;</span>
</span><span id="Backend.compile-925"><a href="#Backend.compile-925"><span class="linenos">925</span></a>        <span class="k">raise</span> <span class="ne">NotImplementedError</span>
</span></pre></div>


            <div class="docstring"><p>Compiles compiler IR to a Python callable function</p>
</div>


                            </div>
                            <div id="Backend.export" class="classattr">
                                        <input id="Backend.export-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">export</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="n">jit_output</span>, </span><span class="param"><span class="o">*</span><span class="n">args</span>, </span><span class="param"><span class="o">**</span><span class="n">params</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="Backend.export-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Backend.export"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Backend.export-927"><a href="#Backend.export-927"><span class="linenos">927</span></a>    <span class="k">def</span> <span class="nf">export</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">jit_output</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="Backend.export-928"><a href="#Backend.export-928"><span class="linenos">928</span></a>        <span class="k">raise</span> <span class="ne">NotImplementedError</span>
</span></pre></div>


    

                            </div>
                            <div id="Backend.load" class="classattr">
                                        <input id="Backend.load-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">load</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="n">path</span>, </span><span class="param"><span class="n">single_key</span><span class="o">=</span><span class="s1">&#39;_tensor&#39;</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="Backend.load-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Backend.load"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Backend.load-930"><a href="#Backend.load-930"><span class="linenos">930</span></a>    <span class="k">def</span> <span class="nf">load</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">path</span><span class="p">,</span> <span class="n">single_key</span><span class="o">=</span><span class="s2">&quot;_tensor&quot;</span><span class="p">):</span>
</span><span id="Backend.load-931"><a href="#Backend.load-931"><span class="linenos">931</span></a>        <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">path</span><span class="p">,</span> <span class="n">mode</span><span class="o">=</span><span class="s2">&quot;rb&quot;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
</span><span id="Backend.load-932"><a href="#Backend.load-932"><span class="linenos">932</span></a>            <span class="k">with</span> <span class="n">mmap</span><span class="o">.</span><span class="n">mmap</span><span class="p">(</span><span class="n">f</span><span class="o">.</span><span class="n">fileno</span><span class="p">(),</span> <span class="n">length</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">access</span><span class="o">=</span><span class="n">mmap</span><span class="o">.</span><span class="n">ACCESS_READ</span><span class="p">)</span> <span class="k">as</span> <span class="n">m</span><span class="p">:</span>
</span><span id="Backend.load-933"><a href="#Backend.load-933"><span class="linenos">933</span></a>                <span class="n">json_len</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">int64</span><span class="p">(</span><span class="n">m</span><span class="p">[</span><span class="mi">0</span><span class="p">])</span>
</span><span id="Backend.load-934"><a href="#Backend.load-934"><span class="linenos">934</span></a>                <span class="n">start</span> <span class="o">=</span> <span class="mi">8</span> <span class="o">+</span> <span class="n">json_len</span>
</span><span id="Backend.load-935"><a href="#Backend.load-935"><span class="linenos">935</span></a>                <span class="n">metadata</span> <span class="o">=</span> <span class="n">json</span><span class="o">.</span><span class="n">loads</span><span class="p">(</span><span class="n">m</span><span class="p">[</span><span class="mi">8</span><span class="p">:</span><span class="n">start</span><span class="p">])</span>
</span><span id="Backend.load-936"><a href="#Backend.load-936"><span class="linenos">936</span></a>                <span class="n">ret</span> <span class="o">=</span> <span class="p">{}</span>
</span><span id="Backend.load-937"><a href="#Backend.load-937"><span class="linenos">937</span></a>                <span class="k">for</span> <span class="n">k</span><span class="p">,</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">metadata</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
</span><span id="Backend.load-938"><a href="#Backend.load-938"><span class="linenos">938</span></a>                    <span class="k">if</span> <span class="n">k</span> <span class="o">!=</span> <span class="s2">&quot;__metadata__&quot;</span><span class="p">:</span>
</span><span id="Backend.load-939"><a href="#Backend.load-939"><span class="linenos">939</span></a>                        <span class="n">dtype</span> <span class="o">=</span> <span class="n">Tensor</span><span class="o">.</span><span class="n">mlir_dtype_map</span><span class="p">[(</span><span class="n">v</span><span class="p">[</span><span class="s2">&quot;dtype&quot;</span><span class="p">])]</span>
</span><span id="Backend.load-940"><a href="#Backend.load-940"><span class="linenos">940</span></a>                        <span class="n">data_start</span> <span class="o">=</span> <span class="n">start</span> <span class="o">+</span> <span class="n">v</span><span class="p">[</span><span class="s2">&quot;data_offsets&quot;</span><span class="p">][</span><span class="mi">0</span><span class="p">]</span>
</span><span id="Backend.load-941"><a href="#Backend.load-941"><span class="linenos">941</span></a>                        <span class="n">data_end</span> <span class="o">=</span> <span class="n">start</span> <span class="o">+</span> <span class="n">v</span><span class="p">[</span><span class="s2">&quot;data_offsets&quot;</span><span class="p">][</span><span class="mi">1</span><span class="p">]</span>
</span><span id="Backend.load-942"><a href="#Backend.load-942"><span class="linenos">942</span></a>                        <span class="n">t_np</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">frombuffer</span><span class="p">(</span><span class="n">m</span><span class="p">[</span><span class="n">data_start</span><span class="p">:</span><span class="n">data_end</span><span class="p">],</span> <span class="n">dtype</span><span class="o">=</span><span class="n">dtype</span><span class="o">.</span><span class="n">numpy</span><span class="p">())</span>
</span><span id="Backend.load-943"><a href="#Backend.load-943"><span class="linenos">943</span></a>                        <span class="n">t</span> <span class="o">=</span> <span class="n">backend</span><span class="o">.</span><span class="n">tensor</span><span class="p">(</span><span class="n">t_np</span><span class="p">,</span> <span class="n">dtype</span><span class="o">=</span><span class="n">dtype</span><span class="p">)</span>
</span><span id="Backend.load-944"><a href="#Backend.load-944"><span class="linenos">944</span></a>                        <span class="n">t</span> <span class="o">=</span> <span class="n">t</span><span class="o">.</span><span class="n">reshape</span><span class="p">(</span><span class="nb">tuple</span><span class="p">(</span><span class="n">v</span><span class="p">[</span><span class="s2">&quot;shape&quot;</span><span class="p">]))</span>
</span><span id="Backend.load-945"><a href="#Backend.load-945"><span class="linenos">945</span></a>                        <span class="n">ret</span><span class="p">[</span><span class="n">k</span><span class="p">]</span> <span class="o">=</span> <span class="n">t</span>
</span><span id="Backend.load-946"><a href="#Backend.load-946"><span class="linenos">946</span></a>                <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">ret</span><span class="p">)</span> <span class="o">==</span> <span class="mi">1</span> <span class="ow">and</span> <span class="n">single_key</span> <span class="ow">in</span> <span class="n">ret</span><span class="o">.</span><span class="n">keys</span><span class="p">():</span>
</span><span id="Backend.load-947"><a href="#Backend.load-947"><span class="linenos">947</span></a>                    <span class="k">return</span> <span class="n">ret</span><span class="p">[</span><span class="n">single_key</span><span class="p">]</span>
</span><span id="Backend.load-948"><a href="#Backend.load-948"><span class="linenos">948</span></a>                <span class="k">return</span> <span class="n">ret</span>
</span></pre></div>


    

                            </div>
                            <div id="Backend.save" class="classattr">
                                        <input id="Backend.save-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">save</span><span class="signature pdoc-code multiline">(<span class="param">	<span class="bp">self</span>,</span><span class="param">	<span class="n">tensors</span><span class="p">:</span> <span class="n">Dict</span><span class="p">[</span><span class="nb">str</span><span class="p">,</span> <span class="n"><a href="#Tensor">Tensor</a></span><span class="p">]</span>,</span><span class="param">	<span class="n">path</span><span class="p">:</span> <span class="nb">str</span>,</span><span class="param">	<span class="n">single_key</span><span class="o">=</span><span class="s1">&#39;_tensor&#39;</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="Backend.save-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Backend.save"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Backend.save-950"><a href="#Backend.save-950"><span class="linenos">950</span></a>    <span class="k">def</span> <span class="nf">save</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">tensors</span><span class="p">:</span> <span class="n">Dict</span><span class="p">[</span><span class="nb">str</span><span class="p">,</span> <span class="n">Tensor</span><span class="p">],</span> <span class="n">path</span><span class="p">:</span> <span class="nb">str</span><span class="p">,</span> <span class="n">single_key</span><span class="o">=</span><span class="s2">&quot;_tensor&quot;</span><span class="p">):</span>
</span><span id="Backend.save-951"><a href="#Backend.save-951"><span class="linenos">951</span></a>        <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">tensors</span><span class="p">,</span> <span class="n">Tensor</span><span class="p">):</span>
</span><span id="Backend.save-952"><a href="#Backend.save-952"><span class="linenos">952</span></a>            <span class="n">tensors</span> <span class="o">=</span> <span class="p">{</span><span class="n">single_key</span><span class="p">:</span> <span class="n">tensors</span><span class="p">}</span>
</span><span id="Backend.save-953"><a href="#Backend.save-953"><span class="linenos">953</span></a>        <span class="k">else</span><span class="p">:</span>
</span><span id="Backend.save-954"><a href="#Backend.save-954"><span class="linenos">954</span></a>            <span class="k">assert</span> <span class="nb">all</span><span class="p">((</span><span class="nb">isinstance</span><span class="p">(</span><span class="n">k</span><span class="p">,</span> <span class="nb">str</span><span class="p">)</span> <span class="ow">and</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">v</span><span class="p">,</span> <span class="n">Tensor</span><span class="p">))</span> <span class="k">for</span> <span class="n">k</span><span class="p">,</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">tensors</span><span class="o">.</span><span class="n">items</span><span class="p">())</span>
</span><span id="Backend.save-955"><a href="#Backend.save-955"><span class="linenos">955</span></a>
</span><span id="Backend.save-956"><a href="#Backend.save-956"><span class="linenos">956</span></a>        <span class="n">metadata</span><span class="p">,</span> <span class="n">offset</span> <span class="o">=</span> <span class="p">{},</span> <span class="mi">0</span>
</span><span id="Backend.save-957"><a href="#Backend.save-957"><span class="linenos">957</span></a>        <span class="k">for</span> <span class="n">k</span><span class="p">,</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">tensors</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
</span><span id="Backend.save-958"><a href="#Backend.save-958"><span class="linenos">958</span></a>            <span class="n">metadata</span><span class="p">[</span><span class="n">k</span><span class="p">]</span> <span class="o">=</span> <span class="p">{</span>
</span><span id="Backend.save-959"><a href="#Backend.save-959"><span class="linenos">959</span></a>                <span class="s2">&quot;dtype&quot;</span><span class="p">:</span> <span class="n">v</span><span class="o">.</span><span class="n">dtype</span><span class="o">.</span><span class="n">mlir</span><span class="p">,</span>
</span><span id="Backend.save-960"><a href="#Backend.save-960"><span class="linenos">960</span></a>                <span class="s2">&quot;shape&quot;</span><span class="p">:</span> <span class="nb">list</span><span class="p">(</span><span class="n">v</span><span class="o">.</span><span class="n">shape</span><span class="p">),</span>
</span><span id="Backend.save-961"><a href="#Backend.save-961"><span class="linenos">961</span></a>                <span class="s2">&quot;data_offsets&quot;</span><span class="p">:</span> <span class="p">[</span><span class="n">offset</span><span class="p">,</span> <span class="n">offset</span> <span class="o">+</span> <span class="n">v</span><span class="o">.</span><span class="n">nbytes</span><span class="p">()],</span>
</span><span id="Backend.save-962"><a href="#Backend.save-962"><span class="linenos">962</span></a>            <span class="p">}</span>
</span><span id="Backend.save-963"><a href="#Backend.save-963"><span class="linenos">963</span></a>            <span class="n">offset</span> <span class="o">+=</span> <span class="n">v</span><span class="o">.</span><span class="n">nbytes</span><span class="p">()</span>
</span><span id="Backend.save-964"><a href="#Backend.save-964"><span class="linenos">964</span></a>        <span class="n">j</span> <span class="o">=</span> <span class="n">json</span><span class="o">.</span><span class="n">dumps</span><span class="p">(</span><span class="n">metadata</span><span class="p">,</span> <span class="n">separators</span><span class="o">=</span><span class="p">(</span><span class="s2">&quot;,&quot;</span><span class="p">,</span> <span class="s2">&quot;:&quot;</span><span class="p">))</span>
</span><span id="Backend.save-965"><a href="#Backend.save-965"><span class="linenos">965</span></a>        <span class="n">Path</span><span class="p">(</span><span class="n">path</span><span class="p">)</span><span class="o">.</span><span class="n">unlink</span><span class="p">(</span><span class="n">missing_ok</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
</span><span id="Backend.save-966"><a href="#Backend.save-966"><span class="linenos">966</span></a>        <span class="n">jbytes</span> <span class="o">=</span> <span class="n">j</span><span class="o">.</span><span class="n">encode</span><span class="p">(</span><span class="s2">&quot;utf-8&quot;</span><span class="p">)</span>
</span><span id="Backend.save-967"><a href="#Backend.save-967"><span class="linenos">967</span></a>        <span class="n">start</span> <span class="o">=</span> <span class="mi">8</span> <span class="o">+</span> <span class="nb">len</span><span class="p">(</span><span class="n">jbytes</span><span class="p">)</span>
</span><span id="Backend.save-968"><a href="#Backend.save-968"><span class="linenos">968</span></a>        <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">path</span><span class="p">,</span> <span class="n">mode</span><span class="o">=</span><span class="s2">&quot;wb&quot;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>  <span class="c1"># make empty file, fill with enough space</span>
</span><span id="Backend.save-969"><a href="#Backend.save-969"><span class="linenos">969</span></a>            <span class="n">f</span><span class="o">.</span><span class="n">write</span><span class="p">(</span><span class="sa">b</span><span class="s2">&quot;</span><span class="se">\x00</span><span class="s2">&quot;</span> <span class="o">*</span> <span class="p">(</span><span class="n">start</span> <span class="o">+</span> <span class="n">offset</span><span class="p">))</span>
</span><span id="Backend.save-970"><a href="#Backend.save-970"><span class="linenos">970</span></a>        <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">path</span><span class="p">,</span> <span class="n">mode</span><span class="o">=</span><span class="s2">&quot;r+b&quot;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
</span><span id="Backend.save-971"><a href="#Backend.save-971"><span class="linenos">971</span></a>            <span class="k">with</span> <span class="n">mmap</span><span class="o">.</span><span class="n">mmap</span><span class="p">(</span><span class="n">f</span><span class="o">.</span><span class="n">fileno</span><span class="p">(),</span> <span class="n">length</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">access</span><span class="o">=</span><span class="n">mmap</span><span class="o">.</span><span class="n">ACCESS_WRITE</span><span class="p">)</span> <span class="k">as</span> <span class="n">m</span><span class="p">:</span>
</span><span id="Backend.save-972"><a href="#Backend.save-972"><span class="linenos">972</span></a>                <span class="n">m</span><span class="p">[</span><span class="mi">0</span><span class="p">:</span><span class="mi">8</span><span class="p">]</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">int64</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">j</span><span class="p">))</span><span class="o">.</span><span class="n">tobytes</span><span class="p">()</span>
</span><span id="Backend.save-973"><a href="#Backend.save-973"><span class="linenos">973</span></a>                <span class="n">m</span><span class="p">[</span><span class="mi">8</span><span class="p">:</span><span class="n">start</span><span class="p">]</span> <span class="o">=</span> <span class="n">jbytes</span>
</span><span id="Backend.save-974"><a href="#Backend.save-974"><span class="linenos">974</span></a>                <span class="k">for</span> <span class="n">t</span><span class="p">,</span> <span class="n">tm</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">tensors</span><span class="o">.</span><span class="n">values</span><span class="p">(),</span> <span class="n">metadata</span><span class="o">.</span><span class="n">values</span><span class="p">()):</span>
</span><span id="Backend.save-975"><a href="#Backend.save-975"><span class="linenos">975</span></a>                    <span class="n">data_start</span><span class="p">,</span> <span class="n">data_end</span> <span class="o">=</span> <span class="n">tm</span><span class="p">[</span><span class="s2">&quot;data_offsets&quot;</span><span class="p">]</span>
</span><span id="Backend.save-976"><a href="#Backend.save-976"><span class="linenos">976</span></a>                    <span class="n">m</span><span class="p">[</span><span class="n">start</span> <span class="o">+</span> <span class="n">data_start</span> <span class="p">:</span> <span class="n">start</span> <span class="o">+</span> <span class="n">data_end</span><span class="p">]</span> <span class="o">=</span> <span class="n">t</span><span class="o">.</span><span class="n">numpy</span><span class="p">()</span><span class="o">.</span><span class="n">tobytes</span><span class="p">()</span>
</span></pre></div>


    

                            </div>
                </section>
                <section id="Var">
                            <input id="Var-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr class">
            
    <span class="def">class</span>
    <span class="name">Var</span>:

                <label class="view-source-button" for="Var-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Var"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Var-984"><a href="#Var-984"><span class="linenos">984</span></a><span class="k">class</span> <span class="nc">Var</span><span class="p">:</span>
</span><span id="Var-985"><a href="#Var-985"><span class="linenos">985</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">symval</span><span class="p">):</span>
</span><span id="Var-986"><a href="#Var-986"><span class="linenos">986</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">symval</span> <span class="o">=</span> <span class="n">symval</span>
</span><span id="Var-987"><a href="#Var-987"><span class="linenos">987</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">val</span> <span class="o">=</span> <span class="kc">None</span>
</span></pre></div>


    

                            <div id="Var.__init__" class="classattr">
                                        <input id="Var.__init__-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="name">Var</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">symval</span></span>)</span>

                <label class="view-source-button" for="Var.__init__-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Var.__init__"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Var.__init__-985"><a href="#Var.__init__-985"><span class="linenos">985</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">symval</span><span class="p">):</span>
</span><span id="Var.__init__-986"><a href="#Var.__init__-986"><span class="linenos">986</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">symval</span> <span class="o">=</span> <span class="n">symval</span>
</span><span id="Var.__init__-987"><a href="#Var.__init__-987"><span class="linenos">987</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">val</span> <span class="o">=</span> <span class="kc">None</span>
</span></pre></div>


    

                            </div>
                            <div id="Var.symval" class="classattr">
                                <div class="attr variable">
            <span class="name">symval</span>

        
    </div>
    <a class="headerlink" href="#Var.symval"></a>
    
    

                            </div>
                            <div id="Var.val" class="classattr">
                                <div class="attr variable">
            <span class="name">val</span>

        
    </div>
    <a class="headerlink" href="#Var.val"></a>
    
    

                            </div>
                </section>
                <section id="Lit">
                            <input id="Lit-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr class">
            
    <span class="def">class</span>
    <span class="name">Lit</span>:

                <label class="view-source-button" for="Lit-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Lit"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Lit-990"><a href="#Lit-990"><span class="linenos">990</span></a><span class="k">class</span> <span class="nc">Lit</span><span class="p">:</span>
</span><span id="Lit-991"><a href="#Lit-991"><span class="linenos">991</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">val</span><span class="p">):</span>
</span><span id="Lit-992"><a href="#Lit-992"><span class="linenos">992</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">symval</span> <span class="o">=</span> <span class="n">SymbolicTensor</span><span class="o">.</span><span class="n">like</span><span class="p">(</span><span class="n">get_symval</span><span class="p">(</span><span class="n">val</span><span class="p">))</span>
</span><span id="Lit-993"><a href="#Lit-993"><span class="linenos">993</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">val</span> <span class="o">=</span> <span class="n">val</span>
</span></pre></div>


    

                            <div id="Lit.__init__" class="classattr">
                                        <input id="Lit.__init__-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="name">Lit</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">val</span></span>)</span>

                <label class="view-source-button" for="Lit.__init__-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Lit.__init__"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Lit.__init__-991"><a href="#Lit.__init__-991"><span class="linenos">991</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">val</span><span class="p">):</span>
</span><span id="Lit.__init__-992"><a href="#Lit.__init__-992"><span class="linenos">992</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">symval</span> <span class="o">=</span> <span class="n">SymbolicTensor</span><span class="o">.</span><span class="n">like</span><span class="p">(</span><span class="n">get_symval</span><span class="p">(</span><span class="n">val</span><span class="p">))</span>
</span><span id="Lit.__init__-993"><a href="#Lit.__init__-993"><span class="linenos">993</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">val</span> <span class="o">=</span> <span class="n">val</span>
</span></pre></div>


    

                            </div>
                            <div id="Lit.symval" class="classattr">
                                <div class="attr variable">
            <span class="name">symval</span>

        
    </div>
    <a class="headerlink" href="#Lit.symval"></a>
    
    

                            </div>
                            <div id="Lit.val" class="classattr">
                                <div class="attr variable">
            <span class="name">val</span>

        
    </div>
    <a class="headerlink" href="#Lit.val"></a>
    
    

                            </div>
                </section>
                <section id="Atom">
                    <div class="attr variable">
            <span class="name">Atom</span>        =
<span class="default_value">typing.Union[<a href="#Var">Var</a>, <a href="#Lit">Lit</a>]</span>

        
    </div>
    <a class="headerlink" href="#Atom"></a>
    
    

                </section>
                <section id="Instruction">
                            <input id="Instruction-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr class">
            
    <span class="def">class</span>
    <span class="name">Instruction</span><wbr>(<span class="base">typing.NamedTuple</span>):

                <label class="view-source-button" for="Instruction-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Instruction"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Instruction-999"><a href="#Instruction-999"><span class="linenos"> 999</span></a><span class="k">class</span> <span class="nc">Instruction</span><span class="p">(</span><span class="n">NamedTuple</span><span class="p">):</span>
</span><span id="Instruction-1000"><a href="#Instruction-1000"><span class="linenos">1000</span></a>    <span class="n">op</span><span class="p">:</span> <span class="n">Operator</span>
</span><span id="Instruction-1001"><a href="#Instruction-1001"><span class="linenos">1001</span></a>    <span class="n">inputs</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">Atom</span><span class="p">]</span>
</span><span id="Instruction-1002"><a href="#Instruction-1002"><span class="linenos">1002</span></a>    <span class="n">params</span><span class="p">:</span> <span class="n">Dict</span><span class="p">[</span><span class="nb">str</span><span class="p">,</span> <span class="n">Any</span><span class="p">]</span>
</span><span id="Instruction-1003"><a href="#Instruction-1003"><span class="linenos">1003</span></a>    <span class="n">out_binders</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">Atom</span><span class="p">]</span>
</span></pre></div>


            <div class="docstring"><p>Instruction(op, inputs, params, out_binders)</p>
</div>


                            <div id="Instruction.__init__" class="classattr">
                                <div class="attr function">
            
        <span class="name">Instruction</span><span class="signature pdoc-code multiline">(<span class="param">	<span class="n">op</span><span class="p">:</span> <span class="n"><a href="#Operator">Operator</a></span>,</span><span class="param">	<span class="n">inputs</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">Union</span><span class="p">[</span><span class="n"><a href="#Var">Var</a></span><span class="p">,</span> <span class="n"><a href="#Lit">Lit</a></span><span class="p">]]</span>,</span><span class="param">	<span class="n">params</span><span class="p">:</span> <span class="n">Dict</span><span class="p">[</span><span class="nb">str</span><span class="p">,</span> <span class="n">Any</span><span class="p">]</span>,</span><span class="param">	<span class="n">out_binders</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">Union</span><span class="p">[</span><span class="n"><a href="#Var">Var</a></span><span class="p">,</span> <span class="n"><a href="#Lit">Lit</a></span><span class="p">]]</span></span>)</span>

        
    </div>
    <a class="headerlink" href="#Instruction.__init__"></a>
    
            <div class="docstring"><p>Create new instance of Instruction(op, inputs, params, out_binders)</p>
</div>


                            </div>
                            <div id="Instruction.op" class="classattr">
                                <div class="attr variable">
            <span class="name">op</span><span class="annotation">: <a href="#Operator">Operator</a></span>

        
    </div>
    <a class="headerlink" href="#Instruction.op"></a>
    
            <div class="docstring"><p>Alias for field number 0</p>
</div>


                            </div>
                            <div id="Instruction.inputs" class="classattr">
                                <div class="attr variable">
            <span class="name">inputs</span><span class="annotation">: List[Union[<a href="#Var">Var</a>, <a href="#Lit">Lit</a>]]</span>

        
    </div>
    <a class="headerlink" href="#Instruction.inputs"></a>
    
            <div class="docstring"><p>Alias for field number 1</p>
</div>


                            </div>
                            <div id="Instruction.params" class="classattr">
                                <div class="attr variable">
            <span class="name">params</span><span class="annotation">: Dict[str, Any]</span>

        
    </div>
    <a class="headerlink" href="#Instruction.params"></a>
    
            <div class="docstring"><p>Alias for field number 2</p>
</div>


                            </div>
                            <div id="Instruction.out_binders" class="classattr">
                                <div class="attr variable">
            <span class="name">out_binders</span><span class="annotation">: List[Union[<a href="#Var">Var</a>, <a href="#Lit">Lit</a>]]</span>

        
    </div>
    <a class="headerlink" href="#Instruction.out_binders"></a>
    
            <div class="docstring"><p>Alias for field number 3</p>
</div>


                            </div>
                            <div class="inherited">
                                <h5>Inherited Members</h5>
                                <dl>
                                    <div><dt>builtins.tuple</dt>
                                <dd id="Instruction.index" class="function">index</dd>
                <dd id="Instruction.count" class="function">count</dd>

            </div>
                                </dl>
                            </div>
                </section>
                <section id="ProgramEnvVar">
                            <input id="ProgramEnvVar-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr class">
            
    <span class="def">class</span>
    <span class="name">ProgramEnvVar</span><wbr>(<span class="base">typing.NamedTuple</span>):

                <label class="view-source-button" for="ProgramEnvVar-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#ProgramEnvVar"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="ProgramEnvVar-1006"><a href="#ProgramEnvVar-1006"><span class="linenos">1006</span></a><span class="k">class</span> <span class="nc">ProgramEnvVar</span><span class="p">(</span><span class="n">NamedTuple</span><span class="p">):</span>
</span><span id="ProgramEnvVar-1007"><a href="#ProgramEnvVar-1007"><span class="linenos">1007</span></a>    <span class="n">name</span><span class="p">:</span> <span class="nb">str</span>
</span><span id="ProgramEnvVar-1008"><a href="#ProgramEnvVar-1008"><span class="linenos">1008</span></a>    <span class="n">symval</span><span class="p">:</span> <span class="n">SymbolicTensor</span>
</span><span id="ProgramEnvVar-1009"><a href="#ProgramEnvVar-1009"><span class="linenos">1009</span></a>    <span class="n">is_const</span><span class="p">:</span> <span class="nb">bool</span> <span class="o">=</span> <span class="kc">False</span>
</span><span id="ProgramEnvVar-1010"><a href="#ProgramEnvVar-1010"><span class="linenos">1010</span></a>
</span><span id="ProgramEnvVar-1011"><a href="#ProgramEnvVar-1011"><span class="linenos">1011</span></a>    <span class="nd">@property</span>
</span><span id="ProgramEnvVar-1012"><a href="#ProgramEnvVar-1012"><span class="linenos">1012</span></a>    <span class="k">def</span> <span class="nf">shape</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="ProgramEnvVar-1013"><a href="#ProgramEnvVar-1013"><span class="linenos">1013</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">symval</span><span class="o">.</span><span class="n">shape</span>
</span><span id="ProgramEnvVar-1014"><a href="#ProgramEnvVar-1014"><span class="linenos">1014</span></a>
</span><span id="ProgramEnvVar-1015"><a href="#ProgramEnvVar-1015"><span class="linenos">1015</span></a>    <span class="nd">@property</span>
</span><span id="ProgramEnvVar-1016"><a href="#ProgramEnvVar-1016"><span class="linenos">1016</span></a>    <span class="k">def</span> <span class="nf">dtype</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="ProgramEnvVar-1017"><a href="#ProgramEnvVar-1017"><span class="linenos">1017</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">symval</span><span class="o">.</span><span class="n">dtype</span>
</span><span id="ProgramEnvVar-1018"><a href="#ProgramEnvVar-1018"><span class="linenos">1018</span></a>
</span><span id="ProgramEnvVar-1019"><a href="#ProgramEnvVar-1019"><span class="linenos">1019</span></a>    <span class="nd">@property</span>
</span><span id="ProgramEnvVar-1020"><a href="#ProgramEnvVar-1020"><span class="linenos">1020</span></a>    <span class="k">def</span> <span class="nf">device</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="ProgramEnvVar-1021"><a href="#ProgramEnvVar-1021"><span class="linenos">1021</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">symval</span><span class="o">.</span><span class="n">device</span>
</span><span id="ProgramEnvVar-1022"><a href="#ProgramEnvVar-1022"><span class="linenos">1022</span></a>
</span><span id="ProgramEnvVar-1023"><a href="#ProgramEnvVar-1023"><span class="linenos">1023</span></a>    <span class="nd">@property</span>
</span><span id="ProgramEnvVar-1024"><a href="#ProgramEnvVar-1024"><span class="linenos">1024</span></a>    <span class="k">def</span> <span class="nf">ndim</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="ProgramEnvVar-1025"><a href="#ProgramEnvVar-1025"><span class="linenos">1025</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">symval</span><span class="o">.</span><span class="n">ndim</span>
</span><span id="ProgramEnvVar-1026"><a href="#ProgramEnvVar-1026"><span class="linenos">1026</span></a>
</span><span id="ProgramEnvVar-1027"><a href="#ProgramEnvVar-1027"><span class="linenos">1027</span></a>    <span class="k">def</span> <span class="nf">numpy</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="ProgramEnvVar-1028"><a href="#ProgramEnvVar-1028"><span class="linenos">1028</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">symval</span><span class="o">.</span><span class="n">numpy</span><span class="p">()</span>
</span><span id="ProgramEnvVar-1029"><a href="#ProgramEnvVar-1029"><span class="linenos">1029</span></a>
</span><span id="ProgramEnvVar-1030"><a href="#ProgramEnvVar-1030"><span class="linenos">1030</span></a>    <span class="k">def</span> <span class="fm">__repr__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="ProgramEnvVar-1031"><a href="#ProgramEnvVar-1031"><span class="linenos">1031</span></a>        <span class="k">return</span> <span class="sa">f</span><span class="s2">&quot;&lt;ProgramEnvVar: name=</span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">, symval=</span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">symval</span><span class="si">}</span><span class="s2">&gt;&quot;</span>
</span><span id="ProgramEnvVar-1032"><a href="#ProgramEnvVar-1032"><span class="linenos">1032</span></a>
</span><span id="ProgramEnvVar-1033"><a href="#ProgramEnvVar-1033"><span class="linenos">1033</span></a>    <span class="n">str_short</span> <span class="o">=</span> <span class="fm">__repr__</span>
</span></pre></div>


            <div class="docstring"><p>ProgramEnvVar(name, symval, is_const)</p>
</div>


                            <div id="ProgramEnvVar.__init__" class="classattr">
                                <div class="attr function">
            
        <span class="name">ProgramEnvVar</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">name</span><span class="p">:</span> <span class="nb">str</span>, </span><span class="param"><span class="n">symval</span><span class="p">:</span> <span class="n"><a href="#SymbolicTensor">SymbolicTensor</a></span>, </span><span class="param"><span class="n">is_const</span><span class="p">:</span> <span class="nb">bool</span> <span class="o">=</span> <span class="kc">False</span></span>)</span>

        
    </div>
    <a class="headerlink" href="#ProgramEnvVar.__init__"></a>
    
            <div class="docstring"><p>Create new instance of ProgramEnvVar(name, symval, is_const)</p>
</div>


                            </div>
                            <div id="ProgramEnvVar.name" class="classattr">
                                <div class="attr variable">
            <span class="name">name</span><span class="annotation">: str</span>

        
    </div>
    <a class="headerlink" href="#ProgramEnvVar.name"></a>
    
            <div class="docstring"><p>Alias for field number 0</p>
</div>


                            </div>
                            <div id="ProgramEnvVar.symval" class="classattr">
                                <div class="attr variable">
            <span class="name">symval</span><span class="annotation">: <a href="#SymbolicTensor">SymbolicTensor</a></span>

        
    </div>
    <a class="headerlink" href="#ProgramEnvVar.symval"></a>
    
            <div class="docstring"><p>Alias for field number 1</p>
</div>


                            </div>
                            <div id="ProgramEnvVar.is_const" class="classattr">
                                <div class="attr variable">
            <span class="name">is_const</span><span class="annotation">: bool</span>

        
    </div>
    <a class="headerlink" href="#ProgramEnvVar.is_const"></a>
    
            <div class="docstring"><p>Alias for field number 2</p>
</div>


                            </div>
                            <div id="ProgramEnvVar.shape" class="classattr">
                                        <input id="ProgramEnvVar.shape-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr variable">
            <span class="name">shape</span>

                <label class="view-source-button" for="ProgramEnvVar.shape-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#ProgramEnvVar.shape"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="ProgramEnvVar.shape-1011"><a href="#ProgramEnvVar.shape-1011"><span class="linenos">1011</span></a>    <span class="nd">@property</span>
</span><span id="ProgramEnvVar.shape-1012"><a href="#ProgramEnvVar.shape-1012"><span class="linenos">1012</span></a>    <span class="k">def</span> <span class="nf">shape</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="ProgramEnvVar.shape-1013"><a href="#ProgramEnvVar.shape-1013"><span class="linenos">1013</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">symval</span><span class="o">.</span><span class="n">shape</span>
</span></pre></div>


    

                            </div>
                            <div id="ProgramEnvVar.dtype" class="classattr">
                                        <input id="ProgramEnvVar.dtype-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr variable">
            <span class="name">dtype</span>

                <label class="view-source-button" for="ProgramEnvVar.dtype-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#ProgramEnvVar.dtype"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="ProgramEnvVar.dtype-1015"><a href="#ProgramEnvVar.dtype-1015"><span class="linenos">1015</span></a>    <span class="nd">@property</span>
</span><span id="ProgramEnvVar.dtype-1016"><a href="#ProgramEnvVar.dtype-1016"><span class="linenos">1016</span></a>    <span class="k">def</span> <span class="nf">dtype</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="ProgramEnvVar.dtype-1017"><a href="#ProgramEnvVar.dtype-1017"><span class="linenos">1017</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">symval</span><span class="o">.</span><span class="n">dtype</span>
</span></pre></div>


    

                            </div>
                            <div id="ProgramEnvVar.device" class="classattr">
                                        <input id="ProgramEnvVar.device-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr variable">
            <span class="name">device</span>

                <label class="view-source-button" for="ProgramEnvVar.device-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#ProgramEnvVar.device"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="ProgramEnvVar.device-1019"><a href="#ProgramEnvVar.device-1019"><span class="linenos">1019</span></a>    <span class="nd">@property</span>
</span><span id="ProgramEnvVar.device-1020"><a href="#ProgramEnvVar.device-1020"><span class="linenos">1020</span></a>    <span class="k">def</span> <span class="nf">device</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="ProgramEnvVar.device-1021"><a href="#ProgramEnvVar.device-1021"><span class="linenos">1021</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">symval</span><span class="o">.</span><span class="n">device</span>
</span></pre></div>


    

                            </div>
                            <div id="ProgramEnvVar.ndim" class="classattr">
                                        <input id="ProgramEnvVar.ndim-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr variable">
            <span class="name">ndim</span>

                <label class="view-source-button" for="ProgramEnvVar.ndim-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#ProgramEnvVar.ndim"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="ProgramEnvVar.ndim-1023"><a href="#ProgramEnvVar.ndim-1023"><span class="linenos">1023</span></a>    <span class="nd">@property</span>
</span><span id="ProgramEnvVar.ndim-1024"><a href="#ProgramEnvVar.ndim-1024"><span class="linenos">1024</span></a>    <span class="k">def</span> <span class="nf">ndim</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="ProgramEnvVar.ndim-1025"><a href="#ProgramEnvVar.ndim-1025"><span class="linenos">1025</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">symval</span><span class="o">.</span><span class="n">ndim</span>
</span></pre></div>


    

                            </div>
                            <div id="ProgramEnvVar.numpy" class="classattr">
                                        <input id="ProgramEnvVar.numpy-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">numpy</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="ProgramEnvVar.numpy-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#ProgramEnvVar.numpy"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="ProgramEnvVar.numpy-1027"><a href="#ProgramEnvVar.numpy-1027"><span class="linenos">1027</span></a>    <span class="k">def</span> <span class="nf">numpy</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="ProgramEnvVar.numpy-1028"><a href="#ProgramEnvVar.numpy-1028"><span class="linenos">1028</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">symval</span><span class="o">.</span><span class="n">numpy</span><span class="p">()</span>
</span></pre></div>


    

                            </div>
                            <div id="ProgramEnvVar.str_short" class="classattr">
                                        <input id="ProgramEnvVar.str_short-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">str_short</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="ProgramEnvVar.str_short-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#ProgramEnvVar.str_short"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="ProgramEnvVar.str_short-1030"><a href="#ProgramEnvVar.str_short-1030"><span class="linenos">1030</span></a>    <span class="k">def</span> <span class="fm">__repr__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="ProgramEnvVar.str_short-1031"><a href="#ProgramEnvVar.str_short-1031"><span class="linenos">1031</span></a>        <span class="k">return</span> <span class="sa">f</span><span class="s2">&quot;&lt;ProgramEnvVar: name=</span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">, symval=</span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">symval</span><span class="si">}</span><span class="s2">&gt;&quot;</span>
</span></pre></div>


            <div class="docstring"><p>Return repr(self).</p>
</div>


                            </div>
                            <div class="inherited">
                                <h5>Inherited Members</h5>
                                <dl>
                                    <div><dt>builtins.tuple</dt>
                                <dd id="ProgramEnvVar.index" class="function">index</dd>
                <dd id="ProgramEnvVar.count" class="function">count</dd>

            </div>
                                </dl>
                            </div>
                </section>
                <section id="Program">
                            <input id="Program-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr class">
            
    <span class="def">class</span>
    <span class="name">Program</span>:

                <label class="view-source-button" for="Program-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Program"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Program-1036"><a href="#Program-1036"><span class="linenos">1036</span></a><span class="k">class</span> <span class="nc">Program</span><span class="p">:</span>
</span><span id="Program-1037"><a href="#Program-1037"><span class="linenos">1037</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span>
</span><span id="Program-1038"><a href="#Program-1038"><span class="linenos">1038</span></a>        <span class="bp">self</span><span class="p">,</span>
</span><span id="Program-1039"><a href="#Program-1039"><span class="linenos">1039</span></a>        <span class="n">in_binders</span><span class="p">:</span> <span class="n">Any</span><span class="p">,</span>
</span><span id="Program-1040"><a href="#Program-1040"><span class="linenos">1040</span></a>        <span class="n">instructions</span><span class="p">:</span> <span class="n">Tuple</span><span class="p">[</span><span class="n">Instruction</span><span class="p">],</span>
</span><span id="Program-1041"><a href="#Program-1041"><span class="linenos">1041</span></a>        <span class="n">outs</span><span class="p">:</span> <span class="n">Any</span><span class="p">,</span>
</span><span id="Program-1042"><a href="#Program-1042"><span class="linenos">1042</span></a>        <span class="n">num_consts</span><span class="p">:</span> <span class="nb">int</span> <span class="o">=</span> <span class="mi">0</span><span class="p">,</span>
</span><span id="Program-1043"><a href="#Program-1043"><span class="linenos">1043</span></a>        <span class="n">static_args</span><span class="p">:</span> <span class="n">Any</span> <span class="o">=</span> <span class="p">(),</span>
</span><span id="Program-1044"><a href="#Program-1044"><span class="linenos">1044</span></a>        <span class="n">name</span><span class="p">:</span> <span class="nb">str</span> <span class="o">=</span> <span class="s2">&quot;my_program&quot;</span><span class="p">,</span>
</span><span id="Program-1045"><a href="#Program-1045"><span class="linenos">1045</span></a>        <span class="n">indent_amount</span><span class="o">=</span><span class="mi">4</span><span class="p">,</span>
</span><span id="Program-1046"><a href="#Program-1046"><span class="linenos">1046</span></a>    <span class="p">):</span>
</span><span id="Program-1047"><a href="#Program-1047"><span class="linenos">1047</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">in_binders</span><span class="p">:</span> <span class="n">Any</span> <span class="o">=</span> <span class="n">in_binders</span>
</span><span id="Program-1048"><a href="#Program-1048"><span class="linenos">1048</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">outs</span><span class="p">:</span> <span class="n">Any</span> <span class="o">=</span> <span class="n">outs</span>
</span><span id="Program-1049"><a href="#Program-1049"><span class="linenos">1049</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">instructions</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">prune_instructions</span><span class="p">(</span><span class="n">instructions</span><span class="p">,</span> <span class="n">outs</span><span class="p">)</span>
</span><span id="Program-1050"><a href="#Program-1050"><span class="linenos">1050</span></a>        <span class="c1"># self.instructions = instructions</span>
</span><span id="Program-1051"><a href="#Program-1051"><span class="linenos">1051</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">num_consts</span><span class="p">:</span> <span class="nb">int</span> <span class="o">=</span> <span class="n">num_consts</span>
</span><span id="Program-1052"><a href="#Program-1052"><span class="linenos">1052</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">static_args</span> <span class="o">=</span> <span class="n">static_args</span>
</span><span id="Program-1053"><a href="#Program-1053"><span class="linenos">1053</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">name</span><span class="p">:</span> <span class="nb">str</span> <span class="o">=</span> <span class="n">name</span>
</span><span id="Program-1054"><a href="#Program-1054"><span class="linenos">1054</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">indent_amount</span><span class="p">:</span> <span class="nb">int</span> <span class="o">=</span> <span class="n">indent_amount</span>
</span><span id="Program-1055"><a href="#Program-1055"><span class="linenos">1055</span></a>
</span><span id="Program-1056"><a href="#Program-1056"><span class="linenos">1056</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">env</span><span class="p">:</span> <span class="n">Dict</span><span class="p">[</span><span class="n">ProgramEnvVar</span><span class="p">,</span> <span class="n">Any</span><span class="p">]</span> <span class="o">=</span> <span class="nb">dict</span><span class="p">()</span>
</span><span id="Program-1057"><a href="#Program-1057"><span class="linenos">1057</span></a>        <span class="k">for</span> <span class="n">inb</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">in_binders</span><span class="p">:</span>
</span><span id="Program-1058"><a href="#Program-1058"><span class="linenos">1058</span></a>            <span class="n">prefix</span> <span class="o">=</span> <span class="s2">&quot;x&quot;</span> <span class="k">if</span> <span class="nb">type</span><span class="p">(</span><span class="n">inb</span><span class="o">.</span><span class="n">symval</span><span class="p">)</span> <span class="ow">is</span> <span class="n">SymbolicTensor</span> <span class="k">else</span> <span class="s2">&quot;c&quot;</span>
</span><span id="Program-1059"><a href="#Program-1059"><span class="linenos">1059</span></a>            <span class="n">idx</span> <span class="o">=</span> <span class="nb">sum</span><span class="p">([</span><span class="mi">1</span> <span class="k">if</span> <span class="n">v</span><span class="o">.</span><span class="n">name</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="o">==</span> <span class="n">prefix</span> <span class="k">else</span> <span class="mi">0</span> <span class="k">for</span> <span class="n">v</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">env</span><span class="o">.</span><span class="n">values</span><span class="p">()])</span>
</span><span id="Program-1060"><a href="#Program-1060"><span class="linenos">1060</span></a>            <span class="bp">self</span><span class="o">.</span><span class="n">env</span><span class="p">[</span><span class="n">inb</span><span class="p">]</span> <span class="o">=</span> <span class="n">ProgramEnvVar</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">prefix</span><span class="si">}{</span><span class="n">idx</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">,</span> <span class="n">inb</span><span class="o">.</span><span class="n">symval</span><span class="p">,</span> <span class="kc">True</span> <span class="k">if</span> <span class="n">prefix</span> <span class="o">==</span> <span class="s2">&quot;c&quot;</span> <span class="k">else</span> <span class="kc">False</span><span class="p">)</span>
</span><span id="Program-1061"><a href="#Program-1061"><span class="linenos">1061</span></a>        <span class="k">for</span> <span class="n">instruction</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">instructions</span><span class="p">:</span>
</span><span id="Program-1062"><a href="#Program-1062"><span class="linenos">1062</span></a>            <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">instruction</span><span class="o">.</span><span class="n">out_binders</span><span class="p">)</span> <span class="o">==</span> <span class="mi">0</span><span class="p">:</span>
</span><span id="Program-1063"><a href="#Program-1063"><span class="linenos">1063</span></a>                <span class="k">continue</span>
</span><span id="Program-1064"><a href="#Program-1064"><span class="linenos">1064</span></a>            <span class="k">for</span> <span class="n">outb</span> <span class="ow">in</span> <span class="n">instruction</span><span class="o">.</span><span class="n">out_binders</span><span class="p">:</span>
</span><span id="Program-1065"><a href="#Program-1065"><span class="linenos">1065</span></a>                <span class="n">prefix</span> <span class="o">=</span> <span class="s2">&quot;y&quot;</span> <span class="k">if</span> <span class="n">outb</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">outs</span> <span class="k">else</span> <span class="s2">&quot;z&quot;</span>
</span><span id="Program-1066"><a href="#Program-1066"><span class="linenos">1066</span></a>                <span class="n">idx</span> <span class="o">=</span> <span class="nb">sum</span><span class="p">([</span><span class="mi">1</span> <span class="k">if</span> <span class="n">v</span><span class="o">.</span><span class="n">name</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="o">==</span> <span class="n">prefix</span> <span class="k">else</span> <span class="mi">0</span> <span class="k">for</span> <span class="n">v</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">env</span><span class="o">.</span><span class="n">values</span><span class="p">()])</span>
</span><span id="Program-1067"><a href="#Program-1067"><span class="linenos">1067</span></a>                <span class="bp">self</span><span class="o">.</span><span class="n">env</span><span class="p">[</span><span class="n">outb</span><span class="p">]</span> <span class="o">=</span> <span class="n">ProgramEnvVar</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">prefix</span><span class="si">}{</span><span class="n">idx</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">,</span> <span class="n">outb</span><span class="o">.</span><span class="n">symval</span><span class="p">)</span>
</span><span id="Program-1068"><a href="#Program-1068"><span class="linenos">1068</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">curr_repr</span> <span class="o">=</span> <span class="nb">repr</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span>
</span><span id="Program-1069"><a href="#Program-1069"><span class="linenos">1069</span></a>
</span><span id="Program-1070"><a href="#Program-1070"><span class="linenos">1070</span></a>    <span class="k">def</span> <span class="nf">pprint_shape</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">symval</span><span class="p">,</span> <span class="n">scalar_as_empty_array</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>
</span><span id="Program-1071"><a href="#Program-1071"><span class="linenos">1071</span></a>        <span class="n">xdtype</span> <span class="o">=</span> <span class="n">symval</span><span class="o">.</span><span class="n">dtype</span><span class="o">.</span><span class="n">mlir</span>
</span><span id="Program-1072"><a href="#Program-1072"><span class="linenos">1072</span></a>        <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">symval</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span> <span class="o">&gt;</span> <span class="mi">0</span><span class="p">:</span>
</span><span id="Program-1073"><a href="#Program-1073"><span class="linenos">1073</span></a>            <span class="n">xshape</span> <span class="o">=</span> <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="s1">&#39;, &#39;</span><span class="o">.</span><span class="n">join</span><span class="p">((</span><span class="nb">repr</span><span class="p">(</span><span class="n">i</span><span class="p">)</span><span class="w"> </span><span class="k">for</span><span class="w"> </span><span class="n">i</span><span class="w"> </span><span class="ow">in</span><span class="w"> </span><span class="n">symval</span><span class="o">.</span><span class="n">shape</span><span class="p">))</span><span class="si">}</span><span class="s2">&quot;</span>
</span><span id="Program-1074"><a href="#Program-1074"><span class="linenos">1074</span></a>            <span class="k">return</span> <span class="sa">f</span><span class="s2">&quot;[</span><span class="si">{</span><span class="n">xshape</span><span class="si">}</span><span class="s2">, </span><span class="si">{</span><span class="n">xdtype</span><span class="si">}</span><span class="s2">]&quot;</span>
</span><span id="Program-1075"><a href="#Program-1075"><span class="linenos">1075</span></a>        <span class="k">else</span><span class="p">:</span>
</span><span id="Program-1076"><a href="#Program-1076"><span class="linenos">1076</span></a>            <span class="k">return</span> <span class="sa">f</span><span class="s2">&quot;[</span><span class="si">{</span><span class="n">xdtype</span><span class="si">}</span><span class="s2">]&quot;</span>
</span><span id="Program-1077"><a href="#Program-1077"><span class="linenos">1077</span></a>
</span><span id="Program-1078"><a href="#Program-1078"><span class="linenos">1078</span></a>    <span class="k">def</span> <span class="nf">pprint_sig</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">in_symvals</span><span class="p">,</span> <span class="n">out_symvals</span><span class="p">,</span> <span class="n">unpack_unary_output</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>
</span><span id="Program-1079"><a href="#Program-1079"><span class="linenos">1079</span></a>        <span class="n">in_code</span> <span class="o">=</span> <span class="s2">&quot;, &quot;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">pprint_shape</span><span class="p">(</span><span class="n">t</span><span class="p">)</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">in_symvals</span><span class="p">)</span>
</span><span id="Program-1080"><a href="#Program-1080"><span class="linenos">1080</span></a>        <span class="n">in_code</span> <span class="o">=</span> <span class="sa">f</span><span class="s2">&quot;(</span><span class="si">{</span><span class="n">in_code</span><span class="si">}</span><span class="s2">)&quot;</span> <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">in_symvals</span><span class="p">)</span> <span class="o">&gt;</span> <span class="mi">1</span> <span class="k">else</span> <span class="n">in_code</span>
</span><span id="Program-1081"><a href="#Program-1081"><span class="linenos">1081</span></a>        <span class="n">out_code</span> <span class="o">=</span> <span class="s2">&quot;, &quot;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">pprint_shape</span><span class="p">(</span><span class="n">t</span><span class="p">)</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">out_symvals</span><span class="p">)</span>
</span><span id="Program-1082"><a href="#Program-1082"><span class="linenos">1082</span></a>        <span class="n">out_code</span> <span class="o">=</span> <span class="sa">f</span><span class="s2">&quot;(</span><span class="si">{</span><span class="n">out_code</span><span class="si">}</span><span class="s2">)&quot;</span> <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">out_symvals</span><span class="p">)</span> <span class="o">&gt;</span> <span class="mi">1</span> <span class="ow">or</span> <span class="n">unpack_unary_output</span> <span class="k">else</span> <span class="n">out_code</span>
</span><span id="Program-1083"><a href="#Program-1083"><span class="linenos">1083</span></a>        <span class="n">typing_code</span> <span class="o">=</span> <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">in_code</span><span class="si">}</span><span class="s2"> -&gt; </span><span class="si">{</span><span class="n">out_code</span><span class="si">}</span><span class="s2">&quot;</span>
</span><span id="Program-1084"><a href="#Program-1084"><span class="linenos">1084</span></a>        <span class="k">return</span> <span class="n">typing_code</span>
</span><span id="Program-1085"><a href="#Program-1085"><span class="linenos">1085</span></a>
</span><span id="Program-1086"><a href="#Program-1086"><span class="linenos">1086</span></a>    <span class="k">def</span> <span class="fm">__repr__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="Program-1087"><a href="#Program-1087"><span class="linenos">1087</span></a>        <span class="n">fn_defs</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">instructions_as_code</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="nb">dict</span><span class="p">())</span>
</span><span id="Program-1088"><a href="#Program-1088"><span class="linenos">1088</span></a>        <span class="k">return</span> <span class="s2">&quot;</span><span class="se">\n</span><span class="s2">&quot;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">line</span> <span class="k">for</span> <span class="n">code_lines</span> <span class="ow">in</span> <span class="n">fn_defs</span><span class="o">.</span><span class="n">values</span><span class="p">()</span> <span class="k">for</span> <span class="n">line</span> <span class="ow">in</span> <span class="n">code_lines</span><span class="p">)</span>
</span><span id="Program-1089"><a href="#Program-1089"><span class="linenos">1089</span></a>
</span><span id="Program-1090"><a href="#Program-1090"><span class="linenos">1090</span></a>    <span class="k">def</span> <span class="nf">save</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="n">dir_path</span><span class="o">=</span><span class="s2">&quot;/tmp/slope_program&quot;</span><span class="p">,</span> <span class="n">dry_run</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>
</span><span id="Program-1091"><a href="#Program-1091"><span class="linenos">1091</span></a>        <span class="n">os</span><span class="o">.</span><span class="n">makedirs</span><span class="p">(</span><span class="n">dir_path</span><span class="p">,</span> <span class="n">exist_ok</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
</span><span id="Program-1092"><a href="#Program-1092"><span class="linenos">1092</span></a>        <span class="n">head_code_lines</span> <span class="o">=</span> <span class="p">[</span><span class="sa">f</span><span class="s2">&quot;import slope # backend=</span><span class="si">{</span><span class="n">backend</span><span class="o">.</span><span class="vm">__class__</span><span class="o">.</span><span class="vm">__name__</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">]</span>
</span><span id="Program-1093"><a href="#Program-1093"><span class="linenos">1093</span></a>        <span class="n">fn_defs</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">instructions_as_code</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="nb">dict</span><span class="p">())</span>
</span><span id="Program-1094"><a href="#Program-1094"><span class="linenos">1094</span></a>        <span class="n">in_binders_vars</span> <span class="o">=</span> <span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">env</span><span class="p">[</span><span class="n">i</span><span class="p">]</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">in_binders</span><span class="p">]</span>
</span><span id="Program-1095"><a href="#Program-1095"><span class="linenos">1095</span></a>        <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">in_binders</span><span class="p">)):</span>
</span><span id="Program-1096"><a href="#Program-1096"><span class="linenos">1096</span></a>            <span class="n">ibv</span> <span class="o">=</span> <span class="n">in_binders_vars</span><span class="p">[</span><span class="n">i</span><span class="p">]</span>
</span><span id="Program-1097"><a href="#Program-1097"><span class="linenos">1097</span></a>            <span class="k">if</span> <span class="n">ibv</span><span class="o">.</span><span class="n">is_const</span><span class="p">:</span>
</span><span id="Program-1098"><a href="#Program-1098"><span class="linenos">1098</span></a>                <span class="n">const_filename</span> <span class="o">=</span> <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">ibv</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">.safetensors&quot;</span>
</span><span id="Program-1099"><a href="#Program-1099"><span class="linenos">1099</span></a>                <span class="n">const_path</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">dir_path</span><span class="p">,</span> <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">const_filename</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">)</span>
</span><span id="Program-1100"><a href="#Program-1100"><span class="linenos">1100</span></a>                <span class="k">if</span> <span class="ow">not</span> <span class="n">dry_run</span><span class="p">:</span>
</span><span id="Program-1101"><a href="#Program-1101"><span class="linenos">1101</span></a>                    <span class="n">backend</span><span class="o">.</span><span class="n">save</span><span class="p">(</span><span class="n">args</span><span class="p">[</span><span class="n">i</span><span class="p">],</span> <span class="n">const_path</span><span class="p">)</span>
</span><span id="Program-1102"><a href="#Program-1102"><span class="linenos">1102</span></a>                <span class="n">dblog</span><span class="p">(</span>
</span><span id="Program-1103"><a href="#Program-1103"><span class="linenos">1103</span></a>                    <span class="sa">f</span><span class="s2">&quot;Saved </span><span class="si">{</span><span class="n">ibv</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2"> at </span><span class="si">{</span><span class="n">const_path</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">,</span>
</span><span id="Program-1104"><a href="#Program-1104"><span class="linenos">1104</span></a>                    <span class="n">enable</span><span class="o">=</span><span class="n">backend</span><span class="o">.</span><span class="n">LOG_BACKEND</span><span class="p">,</span>
</span><span id="Program-1105"><a href="#Program-1105"><span class="linenos">1105</span></a>                <span class="p">)</span>
</span><span id="Program-1106"><a href="#Program-1106"><span class="linenos">1106</span></a>                <span class="n">head_code_lines</span> <span class="o">+=</span> <span class="p">[</span><span class="sa">f</span><span class="s2">&quot;&quot;&quot;</span><span class="si">{</span><span class="n">ibv</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2"> = slope.load(&quot;./</span><span class="si">{</span><span class="n">const_filename</span><span class="si">}</span><span class="s2">&quot;)&quot;&quot;&quot;</span><span class="p">]</span>
</span><span id="Program-1107"><a href="#Program-1107"><span class="linenos">1107</span></a>        <span class="n">head_code_lines</span> <span class="o">+=</span> <span class="p">[</span><span class="s2">&quot;&quot;</span><span class="p">]</span>
</span><span id="Program-1108"><a href="#Program-1108"><span class="linenos">1108</span></a>        <span class="n">code</span> <span class="o">=</span> <span class="s2">&quot;</span><span class="se">\n</span><span class="s2">&quot;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">head_code_lines</span> <span class="o">+</span> <span class="p">[</span><span class="n">line</span> <span class="k">for</span> <span class="n">code_lines</span> <span class="ow">in</span> <span class="n">fn_defs</span><span class="o">.</span><span class="n">values</span><span class="p">()</span> <span class="k">for</span> <span class="n">line</span> <span class="ow">in</span> <span class="n">code_lines</span><span class="p">])</span>
</span><span id="Program-1109"><a href="#Program-1109"><span class="linenos">1109</span></a>        <span class="n">dblog</span><span class="p">(</span>
</span><span id="Program-1110"><a href="#Program-1110"><span class="linenos">1110</span></a>            <span class="sa">f</span><span class="s2">&quot;Contents of </span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">:</span><span class="se">\n</span><span class="s2">```</span><span class="se">\n</span><span class="si">{</span><span class="n">code</span><span class="si">}</span><span class="se">\n</span><span class="s2">```&quot;</span><span class="p">,</span>
</span><span id="Program-1111"><a href="#Program-1111"><span class="linenos">1111</span></a>            <span class="n">enable</span><span class="o">=</span><span class="n">backend</span><span class="o">.</span><span class="n">LOG_BACKEND</span><span class="p">,</span>
</span><span id="Program-1112"><a href="#Program-1112"><span class="linenos">1112</span></a>        <span class="p">)</span>
</span><span id="Program-1113"><a href="#Program-1113"><span class="linenos">1113</span></a>        <span class="n">program_path</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">dir_path</span><span class="p">,</span> <span class="s2">&quot;main.py&quot;</span><span class="p">)</span>
</span><span id="Program-1114"><a href="#Program-1114"><span class="linenos">1114</span></a>        <span class="k">if</span> <span class="ow">not</span> <span class="n">dry_run</span><span class="p">:</span>
</span><span id="Program-1115"><a href="#Program-1115"><span class="linenos">1115</span></a>            <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">program_path</span><span class="p">,</span> <span class="s2">&quot;w&quot;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
</span><span id="Program-1116"><a href="#Program-1116"><span class="linenos">1116</span></a>                <span class="n">f</span><span class="o">.</span><span class="n">write</span><span class="p">(</span><span class="n">code</span><span class="p">)</span>
</span><span id="Program-1117"><a href="#Program-1117"><span class="linenos">1117</span></a>        <span class="n">dblog</span><span class="p">(</span>
</span><span id="Program-1118"><a href="#Program-1118"><span class="linenos">1118</span></a>            <span class="sa">f</span><span class="s2">&quot;Saved program </span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2"> at </span><span class="si">{</span><span class="n">program_path</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">,</span>
</span><span id="Program-1119"><a href="#Program-1119"><span class="linenos">1119</span></a>            <span class="n">enable</span><span class="o">=</span><span class="n">backend</span><span class="o">.</span><span class="n">LOG_BACKEND</span><span class="p">,</span>
</span><span id="Program-1120"><a href="#Program-1120"><span class="linenos">1120</span></a>        <span class="p">)</span>
</span><span id="Program-1121"><a href="#Program-1121"><span class="linenos">1121</span></a>        <span class="n">ls_contents</span> <span class="o">=</span> <span class="s2">&quot;</span><span class="se">\n\t</span><span class="s2">&quot;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">listdir</span><span class="p">(</span><span class="n">dir_path</span><span class="p">))</span>
</span><span id="Program-1122"><a href="#Program-1122"><span class="linenos">1122</span></a>        <span class="n">dblog</span><span class="p">(</span>
</span><span id="Program-1123"><a href="#Program-1123"><span class="linenos">1123</span></a>            <span class="sa">f</span><span class="s2">&quot;Contents of </span><span class="si">{</span><span class="n">dir_path</span><span class="si">}</span><span class="s2">:</span><span class="se">\n\t</span><span class="si">{</span><span class="n">ls_contents</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">,</span>
</span><span id="Program-1124"><a href="#Program-1124"><span class="linenos">1124</span></a>            <span class="n">enable</span><span class="o">=</span><span class="n">backend</span><span class="o">.</span><span class="n">LOG_BACKEND</span><span class="p">,</span>
</span><span id="Program-1125"><a href="#Program-1125"><span class="linenos">1125</span></a>        <span class="p">)</span>
</span><span id="Program-1126"><a href="#Program-1126"><span class="linenos">1126</span></a>
</span><span id="Program-1127"><a href="#Program-1127"><span class="linenos">1127</span></a>    <span class="k">def</span> <span class="fm">__hash__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="Program-1128"><a href="#Program-1128"><span class="linenos">1128</span></a>        <span class="k">return</span> <span class="nb">hash</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">curr_repr</span><span class="p">)</span>
</span><span id="Program-1129"><a href="#Program-1129"><span class="linenos">1129</span></a>
</span><span id="Program-1130"><a href="#Program-1130"><span class="linenos">1130</span></a>    <span class="k">def</span> <span class="fm">__eq__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">other</span><span class="p">):</span>
</span><span id="Program-1131"><a href="#Program-1131"><span class="linenos">1131</span></a>        <span class="k">return</span> <span class="bp">self</span> <span class="ow">is</span> <span class="n">other</span>
</span><span id="Program-1132"><a href="#Program-1132"><span class="linenos">1132</span></a>
</span><span id="Program-1133"><a href="#Program-1133"><span class="linenos">1133</span></a>    <span class="nd">@classmethod</span>
</span><span id="Program-1134"><a href="#Program-1134"><span class="linenos">1134</span></a>    <span class="k">def</span> <span class="nf">instructions_as_code</span><span class="p">(</span><span class="bp">cls</span><span class="p">,</span> <span class="n">program</span><span class="p">,</span> <span class="n">fn_defs</span><span class="p">):</span>
</span><span id="Program-1135"><a href="#Program-1135"><span class="linenos">1135</span></a>        <span class="k">def</span> <span class="nf">indent</span><span class="p">(</span><span class="n">code</span><span class="p">,</span> <span class="n">indent_amount</span><span class="p">):</span>
</span><span id="Program-1136"><a href="#Program-1136"><span class="linenos">1136</span></a>            <span class="n">spaces</span> <span class="o">=</span> <span class="s2">&quot; &quot;</span> <span class="o">*</span> <span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">code</span><span class="p">)</span> <span class="o">-</span> <span class="nb">len</span><span class="p">(</span><span class="n">code</span><span class="o">.</span><span class="n">lstrip</span><span class="p">()))</span>
</span><span id="Program-1137"><a href="#Program-1137"><span class="linenos">1137</span></a>            <span class="n">spaces</span> <span class="o">+=</span> <span class="s2">&quot; &quot;</span> <span class="o">*</span> <span class="n">indent_amount</span>
</span><span id="Program-1138"><a href="#Program-1138"><span class="linenos">1138</span></a>            <span class="k">return</span> <span class="s2">&quot;</span><span class="se">\n</span><span class="s2">&quot;</span><span class="o">.</span><span class="n">join</span><span class="p">([</span><span class="n">spaces</span> <span class="o">+</span> <span class="n">line</span> <span class="k">for</span> <span class="n">line</span> <span class="ow">in</span> <span class="n">code</span><span class="o">.</span><span class="n">strip</span><span class="p">()</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="s2">&quot;</span><span class="se">\n</span><span class="s2">&quot;</span><span class="p">)])</span>
</span><span id="Program-1139"><a href="#Program-1139"><span class="linenos">1139</span></a>
</span><span id="Program-1140"><a href="#Program-1140"><span class="linenos">1140</span></a>        <span class="n">in_binders_vars</span> <span class="o">=</span> <span class="p">[</span><span class="n">program</span><span class="o">.</span><span class="n">env</span><span class="p">[</span><span class="n">i</span><span class="p">]</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="n">program</span><span class="o">.</span><span class="n">in_binders</span><span class="p">]</span>
</span><span id="Program-1141"><a href="#Program-1141"><span class="linenos">1141</span></a>        <span class="n">body_code_lines</span> <span class="o">=</span> <span class="p">[]</span>
</span><span id="Program-1142"><a href="#Program-1142"><span class="linenos">1142</span></a>        <span class="k">for</span> <span class="n">instruction</span> <span class="ow">in</span> <span class="n">program</span><span class="o">.</span><span class="n">instructions</span><span class="p">:</span>
</span><span id="Program-1143"><a href="#Program-1143"><span class="linenos">1143</span></a>            <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">instruction</span><span class="o">.</span><span class="n">out_binders</span><span class="p">)</span> <span class="o">==</span> <span class="mi">0</span><span class="p">:</span>
</span><span id="Program-1144"><a href="#Program-1144"><span class="linenos">1144</span></a>                <span class="k">continue</span>
</span><span id="Program-1145"><a href="#Program-1145"><span class="linenos">1145</span></a>            <span class="n">params</span> <span class="o">=</span> <span class="n">instruction</span><span class="o">.</span><span class="n">params</span><span class="o">.</span><span class="n">copy</span><span class="p">()</span>
</span><span id="Program-1146"><a href="#Program-1146"><span class="linenos">1146</span></a>            <span class="k">for</span> <span class="n">param_name</span><span class="p">,</span> <span class="n">param</span> <span class="ow">in</span> <span class="n">params</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
</span><span id="Program-1147"><a href="#Program-1147"><span class="linenos">1147</span></a>                <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">param</span><span class="p">,</span> <span class="n">Program</span><span class="p">):</span>
</span><span id="Program-1148"><a href="#Program-1148"><span class="linenos">1148</span></a>                    <span class="n">sub_program</span> <span class="o">=</span> <span class="n">param</span>
</span><span id="Program-1149"><a href="#Program-1149"><span class="linenos">1149</span></a>                    <span class="n">fn_defs</span> <span class="o">=</span> <span class="bp">cls</span><span class="o">.</span><span class="n">instructions_as_code</span><span class="p">(</span><span class="n">sub_program</span><span class="p">,</span> <span class="n">fn_defs</span><span class="p">)</span>
</span><span id="Program-1150"><a href="#Program-1150"><span class="linenos">1150</span></a>                    <span class="n">program_in_vals</span> <span class="o">=</span> <span class="s2">&quot;, &quot;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">program</span><span class="o">.</span><span class="n">env</span><span class="p">[</span><span class="n">x</span><span class="p">]</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">&quot;</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">instruction</span><span class="o">.</span><span class="n">inputs</span><span class="p">)</span>
</span><span id="Program-1151"><a href="#Program-1151"><span class="linenos">1151</span></a>                    <span class="n">params</span><span class="p">[</span><span class="n">param_name</span><span class="p">]</span> <span class="o">=</span> <span class="sa">f</span><span class="s2">&quot;slope.make_program(</span><span class="si">{</span><span class="n">sub_program</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">, </span><span class="si">{</span><span class="n">program_in_vals</span><span class="si">}</span><span class="s2">)[0]&quot;</span>
</span><span id="Program-1152"><a href="#Program-1152"><span class="linenos">1152</span></a>                <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">param</span><span class="p">,</span> <span class="n">DType</span><span class="p">):</span>
</span><span id="Program-1153"><a href="#Program-1153"><span class="linenos">1153</span></a>                    <span class="n">params</span><span class="p">[</span><span class="n">param_name</span><span class="p">]</span> <span class="o">=</span> <span class="sa">f</span><span class="s2">&quot;slope.</span><span class="si">{</span><span class="n">param</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">&quot;</span>
</span><span id="Program-1154"><a href="#Program-1154"><span class="linenos">1154</span></a>            <span class="n">param_vals</span> <span class="o">=</span> <span class="s2">&quot;, &quot;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">param_name</span><span class="si">}</span><span class="s2">=</span><span class="si">{</span><span class="n">param</span><span class="si">}</span><span class="s2">&quot;</span> <span class="k">for</span> <span class="n">param_name</span><span class="p">,</span> <span class="n">param</span> <span class="ow">in</span> <span class="n">params</span><span class="o">.</span><span class="n">items</span><span class="p">())</span>
</span><span id="Program-1155"><a href="#Program-1155"><span class="linenos">1155</span></a>            <span class="n">in_vals</span> <span class="o">=</span> <span class="s2">&quot;, &quot;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">program</span><span class="o">.</span><span class="n">env</span><span class="p">[</span><span class="n">x</span><span class="p">]</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">&quot;</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">instruction</span><span class="o">.</span><span class="n">inputs</span><span class="p">)</span>
</span><span id="Program-1156"><a href="#Program-1156"><span class="linenos">1156</span></a>            <span class="n">out_vals</span> <span class="o">=</span> <span class="s2">&quot;, &quot;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">program</span><span class="o">.</span><span class="n">env</span><span class="p">[</span><span class="n">z</span><span class="p">]</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">&quot;</span> <span class="k">for</span> <span class="n">z</span> <span class="ow">in</span> <span class="n">instruction</span><span class="o">.</span><span class="n">out_binders</span><span class="p">)</span>
</span><span id="Program-1157"><a href="#Program-1157"><span class="linenos">1157</span></a>            <span class="n">sig</span> <span class="o">=</span> <span class="n">program</span><span class="o">.</span><span class="n">pprint_sig</span><span class="p">(</span>
</span><span id="Program-1158"><a href="#Program-1158"><span class="linenos">1158</span></a>                <span class="p">[</span><span class="n">program</span><span class="o">.</span><span class="n">env</span><span class="p">[</span><span class="n">x</span><span class="p">]</span><span class="o">.</span><span class="n">symval</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">instruction</span><span class="o">.</span><span class="n">inputs</span><span class="p">],</span>
</span><span id="Program-1159"><a href="#Program-1159"><span class="linenos">1159</span></a>                <span class="p">[</span><span class="n">program</span><span class="o">.</span><span class="n">env</span><span class="p">[</span><span class="n">y</span><span class="p">]</span><span class="o">.</span><span class="n">symval</span> <span class="k">for</span> <span class="n">y</span> <span class="ow">in</span> <span class="n">instruction</span><span class="o">.</span><span class="n">out_binders</span><span class="p">],</span>
</span><span id="Program-1160"><a href="#Program-1160"><span class="linenos">1160</span></a>            <span class="p">)</span>
</span><span id="Program-1161"><a href="#Program-1161"><span class="linenos">1161</span></a>            <span class="n">line</span> <span class="o">=</span> <span class="sa">f</span><span class="s2">&quot;&quot;&quot;</span><span class="si">{</span><span class="n">out_vals</span><span class="si">}</span><span class="s2"> = slope.</span><span class="si">{</span><span class="n">instruction</span><span class="o">.</span><span class="n">op</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">(</span><span class="si">{</span><span class="n">in_vals</span><span class="si">}{</span><span class="s2">&quot;, &quot;</span><span class="w"> </span><span class="k">if</span><span class="w"> </span><span class="p">(</span><span class="n">param_vals</span><span class="w"> </span><span class="ow">and</span><span class="w"> </span><span class="n">in_vals</span><span class="p">)</span><span class="w"> </span><span class="k">else</span><span class="w"> </span><span class="s2">&quot;&quot;</span><span class="si">}{</span><span class="n">param_vals</span><span class="si">}</span><span class="s2">) # </span><span class="si">{</span><span class="n">sig</span><span class="si">}</span><span class="s2">&quot;&quot;&quot;</span>
</span><span id="Program-1162"><a href="#Program-1162"><span class="linenos">1162</span></a>            <span class="n">body_code_lines</span> <span class="o">+=</span> <span class="p">[</span><span class="n">indent</span><span class="p">(</span><span class="n">line</span><span class="p">,</span> <span class="n">program</span><span class="o">.</span><span class="n">indent_amount</span><span class="p">)]</span>
</span><span id="Program-1163"><a href="#Program-1163"><span class="linenos">1163</span></a>
</span><span id="Program-1164"><a href="#Program-1164"><span class="linenos">1164</span></a>        <span class="n">fn_args_str</span> <span class="o">=</span> <span class="s2">&quot;, &quot;</span><span class="o">.</span><span class="n">join</span><span class="p">([</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">i</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">&quot;</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="n">in_binders_vars</span><span class="p">])</span>
</span><span id="Program-1165"><a href="#Program-1165"><span class="linenos">1165</span></a>        <span class="c1"># fn_static_args_str = &quot;, &quot;.join([f&quot;{a}={a_val}&quot; for a, a_val in program.static_args])</span>
</span><span id="Program-1166"><a href="#Program-1166"><span class="linenos">1166</span></a>        <span class="n">out_vars</span> <span class="o">=</span> <span class="p">[</span><span class="n">program</span><span class="o">.</span><span class="n">env</span><span class="p">[</span><span class="n">o</span><span class="p">]</span> <span class="k">for</span> <span class="n">o</span> <span class="ow">in</span> <span class="n">program</span><span class="o">.</span><span class="n">outs</span><span class="p">]</span>
</span><span id="Program-1167"><a href="#Program-1167"><span class="linenos">1167</span></a>        <span class="n">fn_sig</span> <span class="o">=</span> <span class="n">program</span><span class="o">.</span><span class="n">pprint_sig</span><span class="p">(</span>
</span><span id="Program-1168"><a href="#Program-1168"><span class="linenos">1168</span></a>            <span class="p">[</span><span class="n">i</span><span class="o">.</span><span class="n">symval</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="n">in_binders_vars</span><span class="p">],</span>
</span><span id="Program-1169"><a href="#Program-1169"><span class="linenos">1169</span></a>            <span class="p">[</span><span class="n">o</span><span class="o">.</span><span class="n">symval</span> <span class="k">for</span> <span class="n">o</span> <span class="ow">in</span> <span class="n">out_vars</span><span class="p">],</span>
</span><span id="Program-1170"><a href="#Program-1170"><span class="linenos">1170</span></a>        <span class="p">)</span>
</span><span id="Program-1171"><a href="#Program-1171"><span class="linenos">1171</span></a>        <span class="n">head_code_line</span> <span class="o">=</span> <span class="p">[</span><span class="sa">f</span><span class="s2">&quot;def </span><span class="si">{</span><span class="n">program</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">(</span><span class="si">{</span><span class="n">fn_args_str</span><span class="si">}</span><span class="s2">): # </span><span class="si">{</span><span class="n">fn_sig</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">]</span>
</span><span id="Program-1172"><a href="#Program-1172"><span class="linenos">1172</span></a>        <span class="n">out_str</span> <span class="o">=</span> <span class="s2">&quot;, &quot;</span><span class="o">.</span><span class="n">join</span><span class="p">([</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">o</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">&quot;</span> <span class="k">for</span> <span class="n">o</span> <span class="ow">in</span> <span class="n">out_vars</span><span class="p">])</span>
</span><span id="Program-1173"><a href="#Program-1173"><span class="linenos">1173</span></a>        <span class="n">tail_code_line</span> <span class="o">=</span> <span class="p">[</span><span class="n">indent</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;return </span><span class="si">{</span><span class="n">out_str</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">,</span> <span class="n">program</span><span class="o">.</span><span class="n">indent_amount</span><span class="p">)]</span>
</span><span id="Program-1174"><a href="#Program-1174"><span class="linenos">1174</span></a>        <span class="n">code_lines</span> <span class="o">=</span> <span class="n">head_code_line</span> <span class="o">+</span> <span class="n">body_code_lines</span> <span class="o">+</span> <span class="n">tail_code_line</span> <span class="o">+</span> <span class="p">[</span><span class="s2">&quot;</span><span class="se">\n</span><span class="s2">&quot;</span><span class="p">]</span>
</span><span id="Program-1175"><a href="#Program-1175"><span class="linenos">1175</span></a>
</span><span id="Program-1176"><a href="#Program-1176"><span class="linenos">1176</span></a>        <span class="n">fn_defs</span><span class="p">[</span><span class="n">program</span><span class="o">.</span><span class="n">name</span><span class="p">]</span> <span class="o">=</span> <span class="n">code_lines</span>
</span><span id="Program-1177"><a href="#Program-1177"><span class="linenos">1177</span></a>        <span class="k">return</span> <span class="n">fn_defs</span>
</span><span id="Program-1178"><a href="#Program-1178"><span class="linenos">1178</span></a>
</span><span id="Program-1179"><a href="#Program-1179"><span class="linenos">1179</span></a>    <span class="nd">@staticmethod</span>
</span><span id="Program-1180"><a href="#Program-1180"><span class="linenos">1180</span></a>    <span class="k">def</span> <span class="nf">prune_instructions</span><span class="p">(</span><span class="n">instructions</span><span class="p">,</span> <span class="n">outs</span><span class="p">):</span>
</span><span id="Program-1181"><a href="#Program-1181"><span class="linenos">1181</span></a>        <span class="n">graph</span> <span class="o">=</span> <span class="nb">dict</span><span class="p">()</span>
</span><span id="Program-1182"><a href="#Program-1182"><span class="linenos">1182</span></a>        <span class="k">for</span> <span class="n">instruction</span> <span class="ow">in</span> <span class="n">instructions</span><span class="p">:</span>
</span><span id="Program-1183"><a href="#Program-1183"><span class="linenos">1183</span></a>            <span class="n">parent_nodes</span><span class="p">,</span> <span class="n">child_nodes</span> <span class="o">=</span> <span class="n">instruction</span><span class="o">.</span><span class="n">out_binders</span><span class="p">,</span> <span class="n">instruction</span><span class="o">.</span><span class="n">inputs</span>
</span><span id="Program-1184"><a href="#Program-1184"><span class="linenos">1184</span></a>            <span class="k">for</span> <span class="n">parent</span> <span class="ow">in</span> <span class="n">parent_nodes</span><span class="p">:</span>
</span><span id="Program-1185"><a href="#Program-1185"><span class="linenos">1185</span></a>                <span class="k">if</span> <span class="n">parent</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">graph</span><span class="p">:</span>
</span><span id="Program-1186"><a href="#Program-1186"><span class="linenos">1186</span></a>                    <span class="n">graph</span><span class="p">[</span><span class="n">parent</span><span class="p">]</span> <span class="o">=</span> <span class="nb">set</span><span class="p">()</span>
</span><span id="Program-1187"><a href="#Program-1187"><span class="linenos">1187</span></a>                <span class="k">for</span> <span class="n">child</span> <span class="ow">in</span> <span class="n">child_nodes</span><span class="p">:</span>
</span><span id="Program-1188"><a href="#Program-1188"><span class="linenos">1188</span></a>                    <span class="n">graph</span><span class="p">[</span><span class="n">parent</span><span class="p">]</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">child</span><span class="p">)</span>
</span><span id="Program-1189"><a href="#Program-1189"><span class="linenos">1189</span></a>        <span class="n">visited_from_terminal</span> <span class="o">=</span> <span class="nb">set</span><span class="p">()</span>
</span><span id="Program-1190"><a href="#Program-1190"><span class="linenos">1190</span></a>
</span><span id="Program-1191"><a href="#Program-1191"><span class="linenos">1191</span></a>        <span class="k">def</span> <span class="nf">dfs</span><span class="p">(</span><span class="n">node</span><span class="p">,</span> <span class="n">visited</span><span class="p">):</span>
</span><span id="Program-1192"><a href="#Program-1192"><span class="linenos">1192</span></a>            <span class="n">visited</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">node</span><span class="p">)</span>
</span><span id="Program-1193"><a href="#Program-1193"><span class="linenos">1193</span></a>            <span class="k">if</span> <span class="n">node</span> <span class="ow">in</span> <span class="n">graph</span><span class="p">:</span>
</span><span id="Program-1194"><a href="#Program-1194"><span class="linenos">1194</span></a>                <span class="k">for</span> <span class="n">neighbor</span> <span class="ow">in</span> <span class="n">graph</span><span class="p">[</span><span class="n">node</span><span class="p">]:</span>
</span><span id="Program-1195"><a href="#Program-1195"><span class="linenos">1195</span></a>                    <span class="k">if</span> <span class="n">neighbor</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">visited</span><span class="p">:</span>
</span><span id="Program-1196"><a href="#Program-1196"><span class="linenos">1196</span></a>                        <span class="n">dfs</span><span class="p">(</span><span class="n">neighbor</span><span class="p">,</span> <span class="n">visited</span><span class="p">)</span>
</span><span id="Program-1197"><a href="#Program-1197"><span class="linenos">1197</span></a>
</span><span id="Program-1198"><a href="#Program-1198"><span class="linenos">1198</span></a>        <span class="k">for</span> <span class="n">terminal_node</span> <span class="ow">in</span> <span class="n">outs</span><span class="p">:</span>
</span><span id="Program-1199"><a href="#Program-1199"><span class="linenos">1199</span></a>            <span class="n">dfs</span><span class="p">(</span><span class="n">terminal_node</span><span class="p">,</span> <span class="n">visited_from_terminal</span><span class="p">)</span>
</span><span id="Program-1200"><a href="#Program-1200"><span class="linenos">1200</span></a>        <span class="n">unreachable_nodes</span> <span class="o">=</span> <span class="nb">set</span><span class="p">(</span><span class="n">graph</span><span class="o">.</span><span class="n">keys</span><span class="p">())</span> <span class="o">-</span> <span class="n">visited_from_terminal</span>
</span><span id="Program-1201"><a href="#Program-1201"><span class="linenos">1201</span></a>
</span><span id="Program-1202"><a href="#Program-1202"><span class="linenos">1202</span></a>        <span class="n">instructions_to_prune</span> <span class="o">=</span> <span class="p">[]</span>
</span><span id="Program-1203"><a href="#Program-1203"><span class="linenos">1203</span></a>        <span class="k">for</span> <span class="n">instruction</span> <span class="ow">in</span> <span class="n">instructions</span><span class="p">:</span>
</span><span id="Program-1204"><a href="#Program-1204"><span class="linenos">1204</span></a>            <span class="n">parent_nodes</span><span class="p">,</span> <span class="n">child_nodes</span> <span class="o">=</span> <span class="n">instruction</span><span class="o">.</span><span class="n">out_binders</span><span class="p">,</span> <span class="n">instruction</span><span class="o">.</span><span class="n">inputs</span>
</span><span id="Program-1205"><a href="#Program-1205"><span class="linenos">1205</span></a>            <span class="k">if</span> <span class="nb">any</span><span class="p">(</span><span class="n">node</span> <span class="ow">in</span> <span class="n">unreachable_nodes</span> <span class="k">for</span> <span class="n">node</span> <span class="ow">in</span> <span class="n">parent_nodes</span><span class="p">)</span> <span class="ow">or</span> <span class="nb">any</span><span class="p">(</span><span class="n">node</span> <span class="ow">in</span> <span class="n">unreachable_nodes</span> <span class="k">for</span> <span class="n">node</span> <span class="ow">in</span> <span class="n">child_nodes</span><span class="p">):</span>
</span><span id="Program-1206"><a href="#Program-1206"><span class="linenos">1206</span></a>                <span class="n">instructions_to_prune</span> <span class="o">+=</span> <span class="p">[</span><span class="n">instruction</span><span class="p">]</span>
</span><span id="Program-1207"><a href="#Program-1207"><span class="linenos">1207</span></a>        <span class="n">new_instructions</span> <span class="o">=</span> <span class="p">[</span><span class="n">inst</span> <span class="k">for</span> <span class="n">inst</span> <span class="ow">in</span> <span class="n">instructions</span> <span class="k">if</span> <span class="n">inst</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">instructions_to_prune</span><span class="p">]</span>
</span><span id="Program-1208"><a href="#Program-1208"><span class="linenos">1208</span></a>        <span class="k">if</span> <span class="n">backend</span><span class="o">.</span><span class="n">LOG_PROGRAM</span><span class="p">:</span>
</span><span id="Program-1209"><a href="#Program-1209"><span class="linenos">1209</span></a>            <span class="n">LI</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">instructions</span><span class="p">)</span>
</span><span id="Program-1210"><a href="#Program-1210"><span class="linenos">1210</span></a>            <span class="n">LNI</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">new_instructions</span><span class="p">)</span>
</span><span id="Program-1211"><a href="#Program-1211"><span class="linenos">1211</span></a>            <span class="n">DIFF</span> <span class="o">=</span> <span class="n">LI</span> <span class="o">-</span> <span class="n">LNI</span>
</span><span id="Program-1212"><a href="#Program-1212"><span class="linenos">1212</span></a>            <span class="n">UN</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">unreachable_nodes</span><span class="p">)</span>
</span><span id="Program-1213"><a href="#Program-1213"><span class="linenos">1213</span></a>            <span class="n">dblog</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;Before: </span><span class="si">{</span><span class="n">LI</span><span class="si">}</span><span class="se">\t</span><span class="s2">After: </span><span class="si">{</span><span class="n">LNI</span><span class="si">}</span><span class="se">\t</span><span class="s2">Diff vs Unreachables: </span><span class="si">{</span><span class="n">DIFF</span><span class="si">}</span><span class="s2"> == </span><span class="si">{</span><span class="n">UN</span><span class="si">}</span><span class="s2"> = </span><span class="si">{</span><span class="n">DIFF</span><span class="o">==</span><span class="n">UN</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">)</span>
</span><span id="Program-1214"><a href="#Program-1214"><span class="linenos">1214</span></a>        <span class="k">return</span> <span class="n">new_instructions</span>
</span></pre></div>


    

                            <div id="Program.__init__" class="classattr">
                                        <input id="Program.__init__-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="name">Program</span><span class="signature pdoc-code multiline">(<span class="param">	<span class="n">in_binders</span><span class="p">:</span> <span class="n">Any</span>,</span><span class="param">	<span class="n">instructions</span><span class="p">:</span> <span class="n">Tuple</span><span class="p">[</span><span class="n"><a href="#Instruction">Instruction</a></span><span class="p">]</span>,</span><span class="param">	<span class="n">outs</span><span class="p">:</span> <span class="n">Any</span>,</span><span class="param">	<span class="n">num_consts</span><span class="p">:</span> <span class="nb">int</span> <span class="o">=</span> <span class="mi">0</span>,</span><span class="param">	<span class="n">static_args</span><span class="p">:</span> <span class="n">Any</span> <span class="o">=</span> <span class="p">()</span>,</span><span class="param">	<span class="n">name</span><span class="p">:</span> <span class="nb">str</span> <span class="o">=</span> <span class="s1">&#39;my_program&#39;</span>,</span><span class="param">	<span class="n">indent_amount</span><span class="o">=</span><span class="mi">4</span></span>)</span>

                <label class="view-source-button" for="Program.__init__-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Program.__init__"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Program.__init__-1037"><a href="#Program.__init__-1037"><span class="linenos">1037</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span>
</span><span id="Program.__init__-1038"><a href="#Program.__init__-1038"><span class="linenos">1038</span></a>        <span class="bp">self</span><span class="p">,</span>
</span><span id="Program.__init__-1039"><a href="#Program.__init__-1039"><span class="linenos">1039</span></a>        <span class="n">in_binders</span><span class="p">:</span> <span class="n">Any</span><span class="p">,</span>
</span><span id="Program.__init__-1040"><a href="#Program.__init__-1040"><span class="linenos">1040</span></a>        <span class="n">instructions</span><span class="p">:</span> <span class="n">Tuple</span><span class="p">[</span><span class="n">Instruction</span><span class="p">],</span>
</span><span id="Program.__init__-1041"><a href="#Program.__init__-1041"><span class="linenos">1041</span></a>        <span class="n">outs</span><span class="p">:</span> <span class="n">Any</span><span class="p">,</span>
</span><span id="Program.__init__-1042"><a href="#Program.__init__-1042"><span class="linenos">1042</span></a>        <span class="n">num_consts</span><span class="p">:</span> <span class="nb">int</span> <span class="o">=</span> <span class="mi">0</span><span class="p">,</span>
</span><span id="Program.__init__-1043"><a href="#Program.__init__-1043"><span class="linenos">1043</span></a>        <span class="n">static_args</span><span class="p">:</span> <span class="n">Any</span> <span class="o">=</span> <span class="p">(),</span>
</span><span id="Program.__init__-1044"><a href="#Program.__init__-1044"><span class="linenos">1044</span></a>        <span class="n">name</span><span class="p">:</span> <span class="nb">str</span> <span class="o">=</span> <span class="s2">&quot;my_program&quot;</span><span class="p">,</span>
</span><span id="Program.__init__-1045"><a href="#Program.__init__-1045"><span class="linenos">1045</span></a>        <span class="n">indent_amount</span><span class="o">=</span><span class="mi">4</span><span class="p">,</span>
</span><span id="Program.__init__-1046"><a href="#Program.__init__-1046"><span class="linenos">1046</span></a>    <span class="p">):</span>
</span><span id="Program.__init__-1047"><a href="#Program.__init__-1047"><span class="linenos">1047</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">in_binders</span><span class="p">:</span> <span class="n">Any</span> <span class="o">=</span> <span class="n">in_binders</span>
</span><span id="Program.__init__-1048"><a href="#Program.__init__-1048"><span class="linenos">1048</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">outs</span><span class="p">:</span> <span class="n">Any</span> <span class="o">=</span> <span class="n">outs</span>
</span><span id="Program.__init__-1049"><a href="#Program.__init__-1049"><span class="linenos">1049</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">instructions</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">prune_instructions</span><span class="p">(</span><span class="n">instructions</span><span class="p">,</span> <span class="n">outs</span><span class="p">)</span>
</span><span id="Program.__init__-1050"><a href="#Program.__init__-1050"><span class="linenos">1050</span></a>        <span class="c1"># self.instructions = instructions</span>
</span><span id="Program.__init__-1051"><a href="#Program.__init__-1051"><span class="linenos">1051</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">num_consts</span><span class="p">:</span> <span class="nb">int</span> <span class="o">=</span> <span class="n">num_consts</span>
</span><span id="Program.__init__-1052"><a href="#Program.__init__-1052"><span class="linenos">1052</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">static_args</span> <span class="o">=</span> <span class="n">static_args</span>
</span><span id="Program.__init__-1053"><a href="#Program.__init__-1053"><span class="linenos">1053</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">name</span><span class="p">:</span> <span class="nb">str</span> <span class="o">=</span> <span class="n">name</span>
</span><span id="Program.__init__-1054"><a href="#Program.__init__-1054"><span class="linenos">1054</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">indent_amount</span><span class="p">:</span> <span class="nb">int</span> <span class="o">=</span> <span class="n">indent_amount</span>
</span><span id="Program.__init__-1055"><a href="#Program.__init__-1055"><span class="linenos">1055</span></a>
</span><span id="Program.__init__-1056"><a href="#Program.__init__-1056"><span class="linenos">1056</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">env</span><span class="p">:</span> <span class="n">Dict</span><span class="p">[</span><span class="n">ProgramEnvVar</span><span class="p">,</span> <span class="n">Any</span><span class="p">]</span> <span class="o">=</span> <span class="nb">dict</span><span class="p">()</span>
</span><span id="Program.__init__-1057"><a href="#Program.__init__-1057"><span class="linenos">1057</span></a>        <span class="k">for</span> <span class="n">inb</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">in_binders</span><span class="p">:</span>
</span><span id="Program.__init__-1058"><a href="#Program.__init__-1058"><span class="linenos">1058</span></a>            <span class="n">prefix</span> <span class="o">=</span> <span class="s2">&quot;x&quot;</span> <span class="k">if</span> <span class="nb">type</span><span class="p">(</span><span class="n">inb</span><span class="o">.</span><span class="n">symval</span><span class="p">)</span> <span class="ow">is</span> <span class="n">SymbolicTensor</span> <span class="k">else</span> <span class="s2">&quot;c&quot;</span>
</span><span id="Program.__init__-1059"><a href="#Program.__init__-1059"><span class="linenos">1059</span></a>            <span class="n">idx</span> <span class="o">=</span> <span class="nb">sum</span><span class="p">([</span><span class="mi">1</span> <span class="k">if</span> <span class="n">v</span><span class="o">.</span><span class="n">name</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="o">==</span> <span class="n">prefix</span> <span class="k">else</span> <span class="mi">0</span> <span class="k">for</span> <span class="n">v</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">env</span><span class="o">.</span><span class="n">values</span><span class="p">()])</span>
</span><span id="Program.__init__-1060"><a href="#Program.__init__-1060"><span class="linenos">1060</span></a>            <span class="bp">self</span><span class="o">.</span><span class="n">env</span><span class="p">[</span><span class="n">inb</span><span class="p">]</span> <span class="o">=</span> <span class="n">ProgramEnvVar</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">prefix</span><span class="si">}{</span><span class="n">idx</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">,</span> <span class="n">inb</span><span class="o">.</span><span class="n">symval</span><span class="p">,</span> <span class="kc">True</span> <span class="k">if</span> <span class="n">prefix</span> <span class="o">==</span> <span class="s2">&quot;c&quot;</span> <span class="k">else</span> <span class="kc">False</span><span class="p">)</span>
</span><span id="Program.__init__-1061"><a href="#Program.__init__-1061"><span class="linenos">1061</span></a>        <span class="k">for</span> <span class="n">instruction</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">instructions</span><span class="p">:</span>
</span><span id="Program.__init__-1062"><a href="#Program.__init__-1062"><span class="linenos">1062</span></a>            <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">instruction</span><span class="o">.</span><span class="n">out_binders</span><span class="p">)</span> <span class="o">==</span> <span class="mi">0</span><span class="p">:</span>
</span><span id="Program.__init__-1063"><a href="#Program.__init__-1063"><span class="linenos">1063</span></a>                <span class="k">continue</span>
</span><span id="Program.__init__-1064"><a href="#Program.__init__-1064"><span class="linenos">1064</span></a>            <span class="k">for</span> <span class="n">outb</span> <span class="ow">in</span> <span class="n">instruction</span><span class="o">.</span><span class="n">out_binders</span><span class="p">:</span>
</span><span id="Program.__init__-1065"><a href="#Program.__init__-1065"><span class="linenos">1065</span></a>                <span class="n">prefix</span> <span class="o">=</span> <span class="s2">&quot;y&quot;</span> <span class="k">if</span> <span class="n">outb</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">outs</span> <span class="k">else</span> <span class="s2">&quot;z&quot;</span>
</span><span id="Program.__init__-1066"><a href="#Program.__init__-1066"><span class="linenos">1066</span></a>                <span class="n">idx</span> <span class="o">=</span> <span class="nb">sum</span><span class="p">([</span><span class="mi">1</span> <span class="k">if</span> <span class="n">v</span><span class="o">.</span><span class="n">name</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="o">==</span> <span class="n">prefix</span> <span class="k">else</span> <span class="mi">0</span> <span class="k">for</span> <span class="n">v</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">env</span><span class="o">.</span><span class="n">values</span><span class="p">()])</span>
</span><span id="Program.__init__-1067"><a href="#Program.__init__-1067"><span class="linenos">1067</span></a>                <span class="bp">self</span><span class="o">.</span><span class="n">env</span><span class="p">[</span><span class="n">outb</span><span class="p">]</span> <span class="o">=</span> <span class="n">ProgramEnvVar</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">prefix</span><span class="si">}{</span><span class="n">idx</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">,</span> <span class="n">outb</span><span class="o">.</span><span class="n">symval</span><span class="p">)</span>
</span><span id="Program.__init__-1068"><a href="#Program.__init__-1068"><span class="linenos">1068</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">curr_repr</span> <span class="o">=</span> <span class="nb">repr</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span>
</span></pre></div>


    

                            </div>
                            <div id="Program.in_binders" class="classattr">
                                <div class="attr variable">
            <span class="name">in_binders</span><span class="annotation">: Any</span>

        
    </div>
    <a class="headerlink" href="#Program.in_binders"></a>
    
    

                            </div>
                            <div id="Program.outs" class="classattr">
                                <div class="attr variable">
            <span class="name">outs</span><span class="annotation">: Any</span>

        
    </div>
    <a class="headerlink" href="#Program.outs"></a>
    
    

                            </div>
                            <div id="Program.instructions" class="classattr">
                                <div class="attr variable">
            <span class="name">instructions</span>

        
    </div>
    <a class="headerlink" href="#Program.instructions"></a>
    
    

                            </div>
                            <div id="Program.num_consts" class="classattr">
                                <div class="attr variable">
            <span class="name">num_consts</span><span class="annotation">: int</span>

        
    </div>
    <a class="headerlink" href="#Program.num_consts"></a>
    
    

                            </div>
                            <div id="Program.static_args" class="classattr">
                                <div class="attr variable">
            <span class="name">static_args</span>

        
    </div>
    <a class="headerlink" href="#Program.static_args"></a>
    
    

                            </div>
                            <div id="Program.name" class="classattr">
                                <div class="attr variable">
            <span class="name">name</span><span class="annotation">: str</span>

        
    </div>
    <a class="headerlink" href="#Program.name"></a>
    
    

                            </div>
                            <div id="Program.indent_amount" class="classattr">
                                <div class="attr variable">
            <span class="name">indent_amount</span><span class="annotation">: int</span>

        
    </div>
    <a class="headerlink" href="#Program.indent_amount"></a>
    
    

                            </div>
                            <div id="Program.env" class="classattr">
                                <div class="attr variable">
            <span class="name">env</span><span class="annotation">: Dict[<a href="#ProgramEnvVar">ProgramEnvVar</a>, Any]</span>

        
    </div>
    <a class="headerlink" href="#Program.env"></a>
    
    

                            </div>
                            <div id="Program.curr_repr" class="classattr">
                                <div class="attr variable">
            <span class="name">curr_repr</span>

        
    </div>
    <a class="headerlink" href="#Program.curr_repr"></a>
    
    

                            </div>
                            <div id="Program.pprint_shape" class="classattr">
                                        <input id="Program.pprint_shape-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">pprint_shape</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="n">symval</span>, </span><span class="param"><span class="n">scalar_as_empty_array</span><span class="o">=</span><span class="kc">False</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="Program.pprint_shape-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Program.pprint_shape"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Program.pprint_shape-1070"><a href="#Program.pprint_shape-1070"><span class="linenos">1070</span></a>    <span class="k">def</span> <span class="nf">pprint_shape</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">symval</span><span class="p">,</span> <span class="n">scalar_as_empty_array</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>
</span><span id="Program.pprint_shape-1071"><a href="#Program.pprint_shape-1071"><span class="linenos">1071</span></a>        <span class="n">xdtype</span> <span class="o">=</span> <span class="n">symval</span><span class="o">.</span><span class="n">dtype</span><span class="o">.</span><span class="n">mlir</span>
</span><span id="Program.pprint_shape-1072"><a href="#Program.pprint_shape-1072"><span class="linenos">1072</span></a>        <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">symval</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span> <span class="o">&gt;</span> <span class="mi">0</span><span class="p">:</span>
</span><span id="Program.pprint_shape-1073"><a href="#Program.pprint_shape-1073"><span class="linenos">1073</span></a>            <span class="n">xshape</span> <span class="o">=</span> <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="s1">&#39;, &#39;</span><span class="o">.</span><span class="n">join</span><span class="p">((</span><span class="nb">repr</span><span class="p">(</span><span class="n">i</span><span class="p">)</span><span class="w"> </span><span class="k">for</span><span class="w"> </span><span class="n">i</span><span class="w"> </span><span class="ow">in</span><span class="w"> </span><span class="n">symval</span><span class="o">.</span><span class="n">shape</span><span class="p">))</span><span class="si">}</span><span class="s2">&quot;</span>
</span><span id="Program.pprint_shape-1074"><a href="#Program.pprint_shape-1074"><span class="linenos">1074</span></a>            <span class="k">return</span> <span class="sa">f</span><span class="s2">&quot;[</span><span class="si">{</span><span class="n">xshape</span><span class="si">}</span><span class="s2">, </span><span class="si">{</span><span class="n">xdtype</span><span class="si">}</span><span class="s2">]&quot;</span>
</span><span id="Program.pprint_shape-1075"><a href="#Program.pprint_shape-1075"><span class="linenos">1075</span></a>        <span class="k">else</span><span class="p">:</span>
</span><span id="Program.pprint_shape-1076"><a href="#Program.pprint_shape-1076"><span class="linenos">1076</span></a>            <span class="k">return</span> <span class="sa">f</span><span class="s2">&quot;[</span><span class="si">{</span><span class="n">xdtype</span><span class="si">}</span><span class="s2">]&quot;</span>
</span></pre></div>


    

                            </div>
                            <div id="Program.pprint_sig" class="classattr">
                                        <input id="Program.pprint_sig-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">pprint_sig</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="n">in_symvals</span>, </span><span class="param"><span class="n">out_symvals</span>, </span><span class="param"><span class="n">unpack_unary_output</span><span class="o">=</span><span class="kc">False</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="Program.pprint_sig-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Program.pprint_sig"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Program.pprint_sig-1078"><a href="#Program.pprint_sig-1078"><span class="linenos">1078</span></a>    <span class="k">def</span> <span class="nf">pprint_sig</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">in_symvals</span><span class="p">,</span> <span class="n">out_symvals</span><span class="p">,</span> <span class="n">unpack_unary_output</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>
</span><span id="Program.pprint_sig-1079"><a href="#Program.pprint_sig-1079"><span class="linenos">1079</span></a>        <span class="n">in_code</span> <span class="o">=</span> <span class="s2">&quot;, &quot;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">pprint_shape</span><span class="p">(</span><span class="n">t</span><span class="p">)</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">in_symvals</span><span class="p">)</span>
</span><span id="Program.pprint_sig-1080"><a href="#Program.pprint_sig-1080"><span class="linenos">1080</span></a>        <span class="n">in_code</span> <span class="o">=</span> <span class="sa">f</span><span class="s2">&quot;(</span><span class="si">{</span><span class="n">in_code</span><span class="si">}</span><span class="s2">)&quot;</span> <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">in_symvals</span><span class="p">)</span> <span class="o">&gt;</span> <span class="mi">1</span> <span class="k">else</span> <span class="n">in_code</span>
</span><span id="Program.pprint_sig-1081"><a href="#Program.pprint_sig-1081"><span class="linenos">1081</span></a>        <span class="n">out_code</span> <span class="o">=</span> <span class="s2">&quot;, &quot;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">pprint_shape</span><span class="p">(</span><span class="n">t</span><span class="p">)</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">out_symvals</span><span class="p">)</span>
</span><span id="Program.pprint_sig-1082"><a href="#Program.pprint_sig-1082"><span class="linenos">1082</span></a>        <span class="n">out_code</span> <span class="o">=</span> <span class="sa">f</span><span class="s2">&quot;(</span><span class="si">{</span><span class="n">out_code</span><span class="si">}</span><span class="s2">)&quot;</span> <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">out_symvals</span><span class="p">)</span> <span class="o">&gt;</span> <span class="mi">1</span> <span class="ow">or</span> <span class="n">unpack_unary_output</span> <span class="k">else</span> <span class="n">out_code</span>
</span><span id="Program.pprint_sig-1083"><a href="#Program.pprint_sig-1083"><span class="linenos">1083</span></a>        <span class="n">typing_code</span> <span class="o">=</span> <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">in_code</span><span class="si">}</span><span class="s2"> -&gt; </span><span class="si">{</span><span class="n">out_code</span><span class="si">}</span><span class="s2">&quot;</span>
</span><span id="Program.pprint_sig-1084"><a href="#Program.pprint_sig-1084"><span class="linenos">1084</span></a>        <span class="k">return</span> <span class="n">typing_code</span>
</span></pre></div>


    

                            </div>
                            <div id="Program.save" class="classattr">
                                        <input id="Program.save-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">save</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="o">*</span><span class="n">args</span>, </span><span class="param"><span class="n">dir_path</span><span class="o">=</span><span class="s1">&#39;/tmp/slope_program&#39;</span>, </span><span class="param"><span class="n">dry_run</span><span class="o">=</span><span class="kc">False</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="Program.save-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Program.save"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Program.save-1090"><a href="#Program.save-1090"><span class="linenos">1090</span></a>    <span class="k">def</span> <span class="nf">save</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="n">dir_path</span><span class="o">=</span><span class="s2">&quot;/tmp/slope_program&quot;</span><span class="p">,</span> <span class="n">dry_run</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>
</span><span id="Program.save-1091"><a href="#Program.save-1091"><span class="linenos">1091</span></a>        <span class="n">os</span><span class="o">.</span><span class="n">makedirs</span><span class="p">(</span><span class="n">dir_path</span><span class="p">,</span> <span class="n">exist_ok</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
</span><span id="Program.save-1092"><a href="#Program.save-1092"><span class="linenos">1092</span></a>        <span class="n">head_code_lines</span> <span class="o">=</span> <span class="p">[</span><span class="sa">f</span><span class="s2">&quot;import slope # backend=</span><span class="si">{</span><span class="n">backend</span><span class="o">.</span><span class="vm">__class__</span><span class="o">.</span><span class="vm">__name__</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">]</span>
</span><span id="Program.save-1093"><a href="#Program.save-1093"><span class="linenos">1093</span></a>        <span class="n">fn_defs</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">instructions_as_code</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="nb">dict</span><span class="p">())</span>
</span><span id="Program.save-1094"><a href="#Program.save-1094"><span class="linenos">1094</span></a>        <span class="n">in_binders_vars</span> <span class="o">=</span> <span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">env</span><span class="p">[</span><span class="n">i</span><span class="p">]</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">in_binders</span><span class="p">]</span>
</span><span id="Program.save-1095"><a href="#Program.save-1095"><span class="linenos">1095</span></a>        <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">in_binders</span><span class="p">)):</span>
</span><span id="Program.save-1096"><a href="#Program.save-1096"><span class="linenos">1096</span></a>            <span class="n">ibv</span> <span class="o">=</span> <span class="n">in_binders_vars</span><span class="p">[</span><span class="n">i</span><span class="p">]</span>
</span><span id="Program.save-1097"><a href="#Program.save-1097"><span class="linenos">1097</span></a>            <span class="k">if</span> <span class="n">ibv</span><span class="o">.</span><span class="n">is_const</span><span class="p">:</span>
</span><span id="Program.save-1098"><a href="#Program.save-1098"><span class="linenos">1098</span></a>                <span class="n">const_filename</span> <span class="o">=</span> <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">ibv</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">.safetensors&quot;</span>
</span><span id="Program.save-1099"><a href="#Program.save-1099"><span class="linenos">1099</span></a>                <span class="n">const_path</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">dir_path</span><span class="p">,</span> <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">const_filename</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">)</span>
</span><span id="Program.save-1100"><a href="#Program.save-1100"><span class="linenos">1100</span></a>                <span class="k">if</span> <span class="ow">not</span> <span class="n">dry_run</span><span class="p">:</span>
</span><span id="Program.save-1101"><a href="#Program.save-1101"><span class="linenos">1101</span></a>                    <span class="n">backend</span><span class="o">.</span><span class="n">save</span><span class="p">(</span><span class="n">args</span><span class="p">[</span><span class="n">i</span><span class="p">],</span> <span class="n">const_path</span><span class="p">)</span>
</span><span id="Program.save-1102"><a href="#Program.save-1102"><span class="linenos">1102</span></a>                <span class="n">dblog</span><span class="p">(</span>
</span><span id="Program.save-1103"><a href="#Program.save-1103"><span class="linenos">1103</span></a>                    <span class="sa">f</span><span class="s2">&quot;Saved </span><span class="si">{</span><span class="n">ibv</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2"> at </span><span class="si">{</span><span class="n">const_path</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">,</span>
</span><span id="Program.save-1104"><a href="#Program.save-1104"><span class="linenos">1104</span></a>                    <span class="n">enable</span><span class="o">=</span><span class="n">backend</span><span class="o">.</span><span class="n">LOG_BACKEND</span><span class="p">,</span>
</span><span id="Program.save-1105"><a href="#Program.save-1105"><span class="linenos">1105</span></a>                <span class="p">)</span>
</span><span id="Program.save-1106"><a href="#Program.save-1106"><span class="linenos">1106</span></a>                <span class="n">head_code_lines</span> <span class="o">+=</span> <span class="p">[</span><span class="sa">f</span><span class="s2">&quot;&quot;&quot;</span><span class="si">{</span><span class="n">ibv</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2"> = slope.load(&quot;./</span><span class="si">{</span><span class="n">const_filename</span><span class="si">}</span><span class="s2">&quot;)&quot;&quot;&quot;</span><span class="p">]</span>
</span><span id="Program.save-1107"><a href="#Program.save-1107"><span class="linenos">1107</span></a>        <span class="n">head_code_lines</span> <span class="o">+=</span> <span class="p">[</span><span class="s2">&quot;&quot;</span><span class="p">]</span>
</span><span id="Program.save-1108"><a href="#Program.save-1108"><span class="linenos">1108</span></a>        <span class="n">code</span> <span class="o">=</span> <span class="s2">&quot;</span><span class="se">\n</span><span class="s2">&quot;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">head_code_lines</span> <span class="o">+</span> <span class="p">[</span><span class="n">line</span> <span class="k">for</span> <span class="n">code_lines</span> <span class="ow">in</span> <span class="n">fn_defs</span><span class="o">.</span><span class="n">values</span><span class="p">()</span> <span class="k">for</span> <span class="n">line</span> <span class="ow">in</span> <span class="n">code_lines</span><span class="p">])</span>
</span><span id="Program.save-1109"><a href="#Program.save-1109"><span class="linenos">1109</span></a>        <span class="n">dblog</span><span class="p">(</span>
</span><span id="Program.save-1110"><a href="#Program.save-1110"><span class="linenos">1110</span></a>            <span class="sa">f</span><span class="s2">&quot;Contents of </span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">:</span><span class="se">\n</span><span class="s2">```</span><span class="se">\n</span><span class="si">{</span><span class="n">code</span><span class="si">}</span><span class="se">\n</span><span class="s2">```&quot;</span><span class="p">,</span>
</span><span id="Program.save-1111"><a href="#Program.save-1111"><span class="linenos">1111</span></a>            <span class="n">enable</span><span class="o">=</span><span class="n">backend</span><span class="o">.</span><span class="n">LOG_BACKEND</span><span class="p">,</span>
</span><span id="Program.save-1112"><a href="#Program.save-1112"><span class="linenos">1112</span></a>        <span class="p">)</span>
</span><span id="Program.save-1113"><a href="#Program.save-1113"><span class="linenos">1113</span></a>        <span class="n">program_path</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">dir_path</span><span class="p">,</span> <span class="s2">&quot;main.py&quot;</span><span class="p">)</span>
</span><span id="Program.save-1114"><a href="#Program.save-1114"><span class="linenos">1114</span></a>        <span class="k">if</span> <span class="ow">not</span> <span class="n">dry_run</span><span class="p">:</span>
</span><span id="Program.save-1115"><a href="#Program.save-1115"><span class="linenos">1115</span></a>            <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">program_path</span><span class="p">,</span> <span class="s2">&quot;w&quot;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
</span><span id="Program.save-1116"><a href="#Program.save-1116"><span class="linenos">1116</span></a>                <span class="n">f</span><span class="o">.</span><span class="n">write</span><span class="p">(</span><span class="n">code</span><span class="p">)</span>
</span><span id="Program.save-1117"><a href="#Program.save-1117"><span class="linenos">1117</span></a>        <span class="n">dblog</span><span class="p">(</span>
</span><span id="Program.save-1118"><a href="#Program.save-1118"><span class="linenos">1118</span></a>            <span class="sa">f</span><span class="s2">&quot;Saved program </span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2"> at </span><span class="si">{</span><span class="n">program_path</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">,</span>
</span><span id="Program.save-1119"><a href="#Program.save-1119"><span class="linenos">1119</span></a>            <span class="n">enable</span><span class="o">=</span><span class="n">backend</span><span class="o">.</span><span class="n">LOG_BACKEND</span><span class="p">,</span>
</span><span id="Program.save-1120"><a href="#Program.save-1120"><span class="linenos">1120</span></a>        <span class="p">)</span>
</span><span id="Program.save-1121"><a href="#Program.save-1121"><span class="linenos">1121</span></a>        <span class="n">ls_contents</span> <span class="o">=</span> <span class="s2">&quot;</span><span class="se">\n\t</span><span class="s2">&quot;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">listdir</span><span class="p">(</span><span class="n">dir_path</span><span class="p">))</span>
</span><span id="Program.save-1122"><a href="#Program.save-1122"><span class="linenos">1122</span></a>        <span class="n">dblog</span><span class="p">(</span>
</span><span id="Program.save-1123"><a href="#Program.save-1123"><span class="linenos">1123</span></a>            <span class="sa">f</span><span class="s2">&quot;Contents of </span><span class="si">{</span><span class="n">dir_path</span><span class="si">}</span><span class="s2">:</span><span class="se">\n\t</span><span class="si">{</span><span class="n">ls_contents</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">,</span>
</span><span id="Program.save-1124"><a href="#Program.save-1124"><span class="linenos">1124</span></a>            <span class="n">enable</span><span class="o">=</span><span class="n">backend</span><span class="o">.</span><span class="n">LOG_BACKEND</span><span class="p">,</span>
</span><span id="Program.save-1125"><a href="#Program.save-1125"><span class="linenos">1125</span></a>        <span class="p">)</span>
</span></pre></div>


    

                            </div>
                            <div id="Program.instructions_as_code" class="classattr">
                                        <input id="Program.instructions_as_code-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
                    <div class="decorator">@classmethod</div>

        <span class="def">def</span>
        <span class="name">instructions_as_code</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">cls</span>, </span><span class="param"><span class="n">program</span>, </span><span class="param"><span class="n">fn_defs</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="Program.instructions_as_code-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Program.instructions_as_code"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Program.instructions_as_code-1133"><a href="#Program.instructions_as_code-1133"><span class="linenos">1133</span></a>    <span class="nd">@classmethod</span>
</span><span id="Program.instructions_as_code-1134"><a href="#Program.instructions_as_code-1134"><span class="linenos">1134</span></a>    <span class="k">def</span> <span class="nf">instructions_as_code</span><span class="p">(</span><span class="bp">cls</span><span class="p">,</span> <span class="n">program</span><span class="p">,</span> <span class="n">fn_defs</span><span class="p">):</span>
</span><span id="Program.instructions_as_code-1135"><a href="#Program.instructions_as_code-1135"><span class="linenos">1135</span></a>        <span class="k">def</span> <span class="nf">indent</span><span class="p">(</span><span class="n">code</span><span class="p">,</span> <span class="n">indent_amount</span><span class="p">):</span>
</span><span id="Program.instructions_as_code-1136"><a href="#Program.instructions_as_code-1136"><span class="linenos">1136</span></a>            <span class="n">spaces</span> <span class="o">=</span> <span class="s2">&quot; &quot;</span> <span class="o">*</span> <span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">code</span><span class="p">)</span> <span class="o">-</span> <span class="nb">len</span><span class="p">(</span><span class="n">code</span><span class="o">.</span><span class="n">lstrip</span><span class="p">()))</span>
</span><span id="Program.instructions_as_code-1137"><a href="#Program.instructions_as_code-1137"><span class="linenos">1137</span></a>            <span class="n">spaces</span> <span class="o">+=</span> <span class="s2">&quot; &quot;</span> <span class="o">*</span> <span class="n">indent_amount</span>
</span><span id="Program.instructions_as_code-1138"><a href="#Program.instructions_as_code-1138"><span class="linenos">1138</span></a>            <span class="k">return</span> <span class="s2">&quot;</span><span class="se">\n</span><span class="s2">&quot;</span><span class="o">.</span><span class="n">join</span><span class="p">([</span><span class="n">spaces</span> <span class="o">+</span> <span class="n">line</span> <span class="k">for</span> <span class="n">line</span> <span class="ow">in</span> <span class="n">code</span><span class="o">.</span><span class="n">strip</span><span class="p">()</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="s2">&quot;</span><span class="se">\n</span><span class="s2">&quot;</span><span class="p">)])</span>
</span><span id="Program.instructions_as_code-1139"><a href="#Program.instructions_as_code-1139"><span class="linenos">1139</span></a>
</span><span id="Program.instructions_as_code-1140"><a href="#Program.instructions_as_code-1140"><span class="linenos">1140</span></a>        <span class="n">in_binders_vars</span> <span class="o">=</span> <span class="p">[</span><span class="n">program</span><span class="o">.</span><span class="n">env</span><span class="p">[</span><span class="n">i</span><span class="p">]</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="n">program</span><span class="o">.</span><span class="n">in_binders</span><span class="p">]</span>
</span><span id="Program.instructions_as_code-1141"><a href="#Program.instructions_as_code-1141"><span class="linenos">1141</span></a>        <span class="n">body_code_lines</span> <span class="o">=</span> <span class="p">[]</span>
</span><span id="Program.instructions_as_code-1142"><a href="#Program.instructions_as_code-1142"><span class="linenos">1142</span></a>        <span class="k">for</span> <span class="n">instruction</span> <span class="ow">in</span> <span class="n">program</span><span class="o">.</span><span class="n">instructions</span><span class="p">:</span>
</span><span id="Program.instructions_as_code-1143"><a href="#Program.instructions_as_code-1143"><span class="linenos">1143</span></a>            <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">instruction</span><span class="o">.</span><span class="n">out_binders</span><span class="p">)</span> <span class="o">==</span> <span class="mi">0</span><span class="p">:</span>
</span><span id="Program.instructions_as_code-1144"><a href="#Program.instructions_as_code-1144"><span class="linenos">1144</span></a>                <span class="k">continue</span>
</span><span id="Program.instructions_as_code-1145"><a href="#Program.instructions_as_code-1145"><span class="linenos">1145</span></a>            <span class="n">params</span> <span class="o">=</span> <span class="n">instruction</span><span class="o">.</span><span class="n">params</span><span class="o">.</span><span class="n">copy</span><span class="p">()</span>
</span><span id="Program.instructions_as_code-1146"><a href="#Program.instructions_as_code-1146"><span class="linenos">1146</span></a>            <span class="k">for</span> <span class="n">param_name</span><span class="p">,</span> <span class="n">param</span> <span class="ow">in</span> <span class="n">params</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
</span><span id="Program.instructions_as_code-1147"><a href="#Program.instructions_as_code-1147"><span class="linenos">1147</span></a>                <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">param</span><span class="p">,</span> <span class="n">Program</span><span class="p">):</span>
</span><span id="Program.instructions_as_code-1148"><a href="#Program.instructions_as_code-1148"><span class="linenos">1148</span></a>                    <span class="n">sub_program</span> <span class="o">=</span> <span class="n">param</span>
</span><span id="Program.instructions_as_code-1149"><a href="#Program.instructions_as_code-1149"><span class="linenos">1149</span></a>                    <span class="n">fn_defs</span> <span class="o">=</span> <span class="bp">cls</span><span class="o">.</span><span class="n">instructions_as_code</span><span class="p">(</span><span class="n">sub_program</span><span class="p">,</span> <span class="n">fn_defs</span><span class="p">)</span>
</span><span id="Program.instructions_as_code-1150"><a href="#Program.instructions_as_code-1150"><span class="linenos">1150</span></a>                    <span class="n">program_in_vals</span> <span class="o">=</span> <span class="s2">&quot;, &quot;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">program</span><span class="o">.</span><span class="n">env</span><span class="p">[</span><span class="n">x</span><span class="p">]</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">&quot;</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">instruction</span><span class="o">.</span><span class="n">inputs</span><span class="p">)</span>
</span><span id="Program.instructions_as_code-1151"><a href="#Program.instructions_as_code-1151"><span class="linenos">1151</span></a>                    <span class="n">params</span><span class="p">[</span><span class="n">param_name</span><span class="p">]</span> <span class="o">=</span> <span class="sa">f</span><span class="s2">&quot;slope.make_program(</span><span class="si">{</span><span class="n">sub_program</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">, </span><span class="si">{</span><span class="n">program_in_vals</span><span class="si">}</span><span class="s2">)[0]&quot;</span>
</span><span id="Program.instructions_as_code-1152"><a href="#Program.instructions_as_code-1152"><span class="linenos">1152</span></a>                <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">param</span><span class="p">,</span> <span class="n">DType</span><span class="p">):</span>
</span><span id="Program.instructions_as_code-1153"><a href="#Program.instructions_as_code-1153"><span class="linenos">1153</span></a>                    <span class="n">params</span><span class="p">[</span><span class="n">param_name</span><span class="p">]</span> <span class="o">=</span> <span class="sa">f</span><span class="s2">&quot;slope.</span><span class="si">{</span><span class="n">param</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">&quot;</span>
</span><span id="Program.instructions_as_code-1154"><a href="#Program.instructions_as_code-1154"><span class="linenos">1154</span></a>            <span class="n">param_vals</span> <span class="o">=</span> <span class="s2">&quot;, &quot;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">param_name</span><span class="si">}</span><span class="s2">=</span><span class="si">{</span><span class="n">param</span><span class="si">}</span><span class="s2">&quot;</span> <span class="k">for</span> <span class="n">param_name</span><span class="p">,</span> <span class="n">param</span> <span class="ow">in</span> <span class="n">params</span><span class="o">.</span><span class="n">items</span><span class="p">())</span>
</span><span id="Program.instructions_as_code-1155"><a href="#Program.instructions_as_code-1155"><span class="linenos">1155</span></a>            <span class="n">in_vals</span> <span class="o">=</span> <span class="s2">&quot;, &quot;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">program</span><span class="o">.</span><span class="n">env</span><span class="p">[</span><span class="n">x</span><span class="p">]</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">&quot;</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">instruction</span><span class="o">.</span><span class="n">inputs</span><span class="p">)</span>
</span><span id="Program.instructions_as_code-1156"><a href="#Program.instructions_as_code-1156"><span class="linenos">1156</span></a>            <span class="n">out_vals</span> <span class="o">=</span> <span class="s2">&quot;, &quot;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">program</span><span class="o">.</span><span class="n">env</span><span class="p">[</span><span class="n">z</span><span class="p">]</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">&quot;</span> <span class="k">for</span> <span class="n">z</span> <span class="ow">in</span> <span class="n">instruction</span><span class="o">.</span><span class="n">out_binders</span><span class="p">)</span>
</span><span id="Program.instructions_as_code-1157"><a href="#Program.instructions_as_code-1157"><span class="linenos">1157</span></a>            <span class="n">sig</span> <span class="o">=</span> <span class="n">program</span><span class="o">.</span><span class="n">pprint_sig</span><span class="p">(</span>
</span><span id="Program.instructions_as_code-1158"><a href="#Program.instructions_as_code-1158"><span class="linenos">1158</span></a>                <span class="p">[</span><span class="n">program</span><span class="o">.</span><span class="n">env</span><span class="p">[</span><span class="n">x</span><span class="p">]</span><span class="o">.</span><span class="n">symval</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">instruction</span><span class="o">.</span><span class="n">inputs</span><span class="p">],</span>
</span><span id="Program.instructions_as_code-1159"><a href="#Program.instructions_as_code-1159"><span class="linenos">1159</span></a>                <span class="p">[</span><span class="n">program</span><span class="o">.</span><span class="n">env</span><span class="p">[</span><span class="n">y</span><span class="p">]</span><span class="o">.</span><span class="n">symval</span> <span class="k">for</span> <span class="n">y</span> <span class="ow">in</span> <span class="n">instruction</span><span class="o">.</span><span class="n">out_binders</span><span class="p">],</span>
</span><span id="Program.instructions_as_code-1160"><a href="#Program.instructions_as_code-1160"><span class="linenos">1160</span></a>            <span class="p">)</span>
</span><span id="Program.instructions_as_code-1161"><a href="#Program.instructions_as_code-1161"><span class="linenos">1161</span></a>            <span class="n">line</span> <span class="o">=</span> <span class="sa">f</span><span class="s2">&quot;&quot;&quot;</span><span class="si">{</span><span class="n">out_vals</span><span class="si">}</span><span class="s2"> = slope.</span><span class="si">{</span><span class="n">instruction</span><span class="o">.</span><span class="n">op</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">(</span><span class="si">{</span><span class="n">in_vals</span><span class="si">}{</span><span class="s2">&quot;, &quot;</span><span class="w"> </span><span class="k">if</span><span class="w"> </span><span class="p">(</span><span class="n">param_vals</span><span class="w"> </span><span class="ow">and</span><span class="w"> </span><span class="n">in_vals</span><span class="p">)</span><span class="w"> </span><span class="k">else</span><span class="w"> </span><span class="s2">&quot;&quot;</span><span class="si">}{</span><span class="n">param_vals</span><span class="si">}</span><span class="s2">) # </span><span class="si">{</span><span class="n">sig</span><span class="si">}</span><span class="s2">&quot;&quot;&quot;</span>
</span><span id="Program.instructions_as_code-1162"><a href="#Program.instructions_as_code-1162"><span class="linenos">1162</span></a>            <span class="n">body_code_lines</span> <span class="o">+=</span> <span class="p">[</span><span class="n">indent</span><span class="p">(</span><span class="n">line</span><span class="p">,</span> <span class="n">program</span><span class="o">.</span><span class="n">indent_amount</span><span class="p">)]</span>
</span><span id="Program.instructions_as_code-1163"><a href="#Program.instructions_as_code-1163"><span class="linenos">1163</span></a>
</span><span id="Program.instructions_as_code-1164"><a href="#Program.instructions_as_code-1164"><span class="linenos">1164</span></a>        <span class="n">fn_args_str</span> <span class="o">=</span> <span class="s2">&quot;, &quot;</span><span class="o">.</span><span class="n">join</span><span class="p">([</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">i</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">&quot;</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="n">in_binders_vars</span><span class="p">])</span>
</span><span id="Program.instructions_as_code-1165"><a href="#Program.instructions_as_code-1165"><span class="linenos">1165</span></a>        <span class="c1"># fn_static_args_str = &quot;, &quot;.join([f&quot;{a}={a_val}&quot; for a, a_val in program.static_args])</span>
</span><span id="Program.instructions_as_code-1166"><a href="#Program.instructions_as_code-1166"><span class="linenos">1166</span></a>        <span class="n">out_vars</span> <span class="o">=</span> <span class="p">[</span><span class="n">program</span><span class="o">.</span><span class="n">env</span><span class="p">[</span><span class="n">o</span><span class="p">]</span> <span class="k">for</span> <span class="n">o</span> <span class="ow">in</span> <span class="n">program</span><span class="o">.</span><span class="n">outs</span><span class="p">]</span>
</span><span id="Program.instructions_as_code-1167"><a href="#Program.instructions_as_code-1167"><span class="linenos">1167</span></a>        <span class="n">fn_sig</span> <span class="o">=</span> <span class="n">program</span><span class="o">.</span><span class="n">pprint_sig</span><span class="p">(</span>
</span><span id="Program.instructions_as_code-1168"><a href="#Program.instructions_as_code-1168"><span class="linenos">1168</span></a>            <span class="p">[</span><span class="n">i</span><span class="o">.</span><span class="n">symval</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="n">in_binders_vars</span><span class="p">],</span>
</span><span id="Program.instructions_as_code-1169"><a href="#Program.instructions_as_code-1169"><span class="linenos">1169</span></a>            <span class="p">[</span><span class="n">o</span><span class="o">.</span><span class="n">symval</span> <span class="k">for</span> <span class="n">o</span> <span class="ow">in</span> <span class="n">out_vars</span><span class="p">],</span>
</span><span id="Program.instructions_as_code-1170"><a href="#Program.instructions_as_code-1170"><span class="linenos">1170</span></a>        <span class="p">)</span>
</span><span id="Program.instructions_as_code-1171"><a href="#Program.instructions_as_code-1171"><span class="linenos">1171</span></a>        <span class="n">head_code_line</span> <span class="o">=</span> <span class="p">[</span><span class="sa">f</span><span class="s2">&quot;def </span><span class="si">{</span><span class="n">program</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">(</span><span class="si">{</span><span class="n">fn_args_str</span><span class="si">}</span><span class="s2">): # </span><span class="si">{</span><span class="n">fn_sig</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">]</span>
</span><span id="Program.instructions_as_code-1172"><a href="#Program.instructions_as_code-1172"><span class="linenos">1172</span></a>        <span class="n">out_str</span> <span class="o">=</span> <span class="s2">&quot;, &quot;</span><span class="o">.</span><span class="n">join</span><span class="p">([</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">o</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">&quot;</span> <span class="k">for</span> <span class="n">o</span> <span class="ow">in</span> <span class="n">out_vars</span><span class="p">])</span>
</span><span id="Program.instructions_as_code-1173"><a href="#Program.instructions_as_code-1173"><span class="linenos">1173</span></a>        <span class="n">tail_code_line</span> <span class="o">=</span> <span class="p">[</span><span class="n">indent</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;return </span><span class="si">{</span><span class="n">out_str</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">,</span> <span class="n">program</span><span class="o">.</span><span class="n">indent_amount</span><span class="p">)]</span>
</span><span id="Program.instructions_as_code-1174"><a href="#Program.instructions_as_code-1174"><span class="linenos">1174</span></a>        <span class="n">code_lines</span> <span class="o">=</span> <span class="n">head_code_line</span> <span class="o">+</span> <span class="n">body_code_lines</span> <span class="o">+</span> <span class="n">tail_code_line</span> <span class="o">+</span> <span class="p">[</span><span class="s2">&quot;</span><span class="se">\n</span><span class="s2">&quot;</span><span class="p">]</span>
</span><span id="Program.instructions_as_code-1175"><a href="#Program.instructions_as_code-1175"><span class="linenos">1175</span></a>
</span><span id="Program.instructions_as_code-1176"><a href="#Program.instructions_as_code-1176"><span class="linenos">1176</span></a>        <span class="n">fn_defs</span><span class="p">[</span><span class="n">program</span><span class="o">.</span><span class="n">name</span><span class="p">]</span> <span class="o">=</span> <span class="n">code_lines</span>
</span><span id="Program.instructions_as_code-1177"><a href="#Program.instructions_as_code-1177"><span class="linenos">1177</span></a>        <span class="k">return</span> <span class="n">fn_defs</span>
</span></pre></div>


    

                            </div>
                            <div id="Program.prune_instructions" class="classattr">
                                        <input id="Program.prune_instructions-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
                    <div class="decorator">@staticmethod</div>

        <span class="def">def</span>
        <span class="name">prune_instructions</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">instructions</span>, </span><span class="param"><span class="n">outs</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="Program.prune_instructions-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Program.prune_instructions"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Program.prune_instructions-1179"><a href="#Program.prune_instructions-1179"><span class="linenos">1179</span></a>    <span class="nd">@staticmethod</span>
</span><span id="Program.prune_instructions-1180"><a href="#Program.prune_instructions-1180"><span class="linenos">1180</span></a>    <span class="k">def</span> <span class="nf">prune_instructions</span><span class="p">(</span><span class="n">instructions</span><span class="p">,</span> <span class="n">outs</span><span class="p">):</span>
</span><span id="Program.prune_instructions-1181"><a href="#Program.prune_instructions-1181"><span class="linenos">1181</span></a>        <span class="n">graph</span> <span class="o">=</span> <span class="nb">dict</span><span class="p">()</span>
</span><span id="Program.prune_instructions-1182"><a href="#Program.prune_instructions-1182"><span class="linenos">1182</span></a>        <span class="k">for</span> <span class="n">instruction</span> <span class="ow">in</span> <span class="n">instructions</span><span class="p">:</span>
</span><span id="Program.prune_instructions-1183"><a href="#Program.prune_instructions-1183"><span class="linenos">1183</span></a>            <span class="n">parent_nodes</span><span class="p">,</span> <span class="n">child_nodes</span> <span class="o">=</span> <span class="n">instruction</span><span class="o">.</span><span class="n">out_binders</span><span class="p">,</span> <span class="n">instruction</span><span class="o">.</span><span class="n">inputs</span>
</span><span id="Program.prune_instructions-1184"><a href="#Program.prune_instructions-1184"><span class="linenos">1184</span></a>            <span class="k">for</span> <span class="n">parent</span> <span class="ow">in</span> <span class="n">parent_nodes</span><span class="p">:</span>
</span><span id="Program.prune_instructions-1185"><a href="#Program.prune_instructions-1185"><span class="linenos">1185</span></a>                <span class="k">if</span> <span class="n">parent</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">graph</span><span class="p">:</span>
</span><span id="Program.prune_instructions-1186"><a href="#Program.prune_instructions-1186"><span class="linenos">1186</span></a>                    <span class="n">graph</span><span class="p">[</span><span class="n">parent</span><span class="p">]</span> <span class="o">=</span> <span class="nb">set</span><span class="p">()</span>
</span><span id="Program.prune_instructions-1187"><a href="#Program.prune_instructions-1187"><span class="linenos">1187</span></a>                <span class="k">for</span> <span class="n">child</span> <span class="ow">in</span> <span class="n">child_nodes</span><span class="p">:</span>
</span><span id="Program.prune_instructions-1188"><a href="#Program.prune_instructions-1188"><span class="linenos">1188</span></a>                    <span class="n">graph</span><span class="p">[</span><span class="n">parent</span><span class="p">]</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">child</span><span class="p">)</span>
</span><span id="Program.prune_instructions-1189"><a href="#Program.prune_instructions-1189"><span class="linenos">1189</span></a>        <span class="n">visited_from_terminal</span> <span class="o">=</span> <span class="nb">set</span><span class="p">()</span>
</span><span id="Program.prune_instructions-1190"><a href="#Program.prune_instructions-1190"><span class="linenos">1190</span></a>
</span><span id="Program.prune_instructions-1191"><a href="#Program.prune_instructions-1191"><span class="linenos">1191</span></a>        <span class="k">def</span> <span class="nf">dfs</span><span class="p">(</span><span class="n">node</span><span class="p">,</span> <span class="n">visited</span><span class="p">):</span>
</span><span id="Program.prune_instructions-1192"><a href="#Program.prune_instructions-1192"><span class="linenos">1192</span></a>            <span class="n">visited</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">node</span><span class="p">)</span>
</span><span id="Program.prune_instructions-1193"><a href="#Program.prune_instructions-1193"><span class="linenos">1193</span></a>            <span class="k">if</span> <span class="n">node</span> <span class="ow">in</span> <span class="n">graph</span><span class="p">:</span>
</span><span id="Program.prune_instructions-1194"><a href="#Program.prune_instructions-1194"><span class="linenos">1194</span></a>                <span class="k">for</span> <span class="n">neighbor</span> <span class="ow">in</span> <span class="n">graph</span><span class="p">[</span><span class="n">node</span><span class="p">]:</span>
</span><span id="Program.prune_instructions-1195"><a href="#Program.prune_instructions-1195"><span class="linenos">1195</span></a>                    <span class="k">if</span> <span class="n">neighbor</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">visited</span><span class="p">:</span>
</span><span id="Program.prune_instructions-1196"><a href="#Program.prune_instructions-1196"><span class="linenos">1196</span></a>                        <span class="n">dfs</span><span class="p">(</span><span class="n">neighbor</span><span class="p">,</span> <span class="n">visited</span><span class="p">)</span>
</span><span id="Program.prune_instructions-1197"><a href="#Program.prune_instructions-1197"><span class="linenos">1197</span></a>
</span><span id="Program.prune_instructions-1198"><a href="#Program.prune_instructions-1198"><span class="linenos">1198</span></a>        <span class="k">for</span> <span class="n">terminal_node</span> <span class="ow">in</span> <span class="n">outs</span><span class="p">:</span>
</span><span id="Program.prune_instructions-1199"><a href="#Program.prune_instructions-1199"><span class="linenos">1199</span></a>            <span class="n">dfs</span><span class="p">(</span><span class="n">terminal_node</span><span class="p">,</span> <span class="n">visited_from_terminal</span><span class="p">)</span>
</span><span id="Program.prune_instructions-1200"><a href="#Program.prune_instructions-1200"><span class="linenos">1200</span></a>        <span class="n">unreachable_nodes</span> <span class="o">=</span> <span class="nb">set</span><span class="p">(</span><span class="n">graph</span><span class="o">.</span><span class="n">keys</span><span class="p">())</span> <span class="o">-</span> <span class="n">visited_from_terminal</span>
</span><span id="Program.prune_instructions-1201"><a href="#Program.prune_instructions-1201"><span class="linenos">1201</span></a>
</span><span id="Program.prune_instructions-1202"><a href="#Program.prune_instructions-1202"><span class="linenos">1202</span></a>        <span class="n">instructions_to_prune</span> <span class="o">=</span> <span class="p">[]</span>
</span><span id="Program.prune_instructions-1203"><a href="#Program.prune_instructions-1203"><span class="linenos">1203</span></a>        <span class="k">for</span> <span class="n">instruction</span> <span class="ow">in</span> <span class="n">instructions</span><span class="p">:</span>
</span><span id="Program.prune_instructions-1204"><a href="#Program.prune_instructions-1204"><span class="linenos">1204</span></a>            <span class="n">parent_nodes</span><span class="p">,</span> <span class="n">child_nodes</span> <span class="o">=</span> <span class="n">instruction</span><span class="o">.</span><span class="n">out_binders</span><span class="p">,</span> <span class="n">instruction</span><span class="o">.</span><span class="n">inputs</span>
</span><span id="Program.prune_instructions-1205"><a href="#Program.prune_instructions-1205"><span class="linenos">1205</span></a>            <span class="k">if</span> <span class="nb">any</span><span class="p">(</span><span class="n">node</span> <span class="ow">in</span> <span class="n">unreachable_nodes</span> <span class="k">for</span> <span class="n">node</span> <span class="ow">in</span> <span class="n">parent_nodes</span><span class="p">)</span> <span class="ow">or</span> <span class="nb">any</span><span class="p">(</span><span class="n">node</span> <span class="ow">in</span> <span class="n">unreachable_nodes</span> <span class="k">for</span> <span class="n">node</span> <span class="ow">in</span> <span class="n">child_nodes</span><span class="p">):</span>
</span><span id="Program.prune_instructions-1206"><a href="#Program.prune_instructions-1206"><span class="linenos">1206</span></a>                <span class="n">instructions_to_prune</span> <span class="o">+=</span> <span class="p">[</span><span class="n">instruction</span><span class="p">]</span>
</span><span id="Program.prune_instructions-1207"><a href="#Program.prune_instructions-1207"><span class="linenos">1207</span></a>        <span class="n">new_instructions</span> <span class="o">=</span> <span class="p">[</span><span class="n">inst</span> <span class="k">for</span> <span class="n">inst</span> <span class="ow">in</span> <span class="n">instructions</span> <span class="k">if</span> <span class="n">inst</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">instructions_to_prune</span><span class="p">]</span>
</span><span id="Program.prune_instructions-1208"><a href="#Program.prune_instructions-1208"><span class="linenos">1208</span></a>        <span class="k">if</span> <span class="n">backend</span><span class="o">.</span><span class="n">LOG_PROGRAM</span><span class="p">:</span>
</span><span id="Program.prune_instructions-1209"><a href="#Program.prune_instructions-1209"><span class="linenos">1209</span></a>            <span class="n">LI</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">instructions</span><span class="p">)</span>
</span><span id="Program.prune_instructions-1210"><a href="#Program.prune_instructions-1210"><span class="linenos">1210</span></a>            <span class="n">LNI</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">new_instructions</span><span class="p">)</span>
</span><span id="Program.prune_instructions-1211"><a href="#Program.prune_instructions-1211"><span class="linenos">1211</span></a>            <span class="n">DIFF</span> <span class="o">=</span> <span class="n">LI</span> <span class="o">-</span> <span class="n">LNI</span>
</span><span id="Program.prune_instructions-1212"><a href="#Program.prune_instructions-1212"><span class="linenos">1212</span></a>            <span class="n">UN</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">unreachable_nodes</span><span class="p">)</span>
</span><span id="Program.prune_instructions-1213"><a href="#Program.prune_instructions-1213"><span class="linenos">1213</span></a>            <span class="n">dblog</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;Before: </span><span class="si">{</span><span class="n">LI</span><span class="si">}</span><span class="se">\t</span><span class="s2">After: </span><span class="si">{</span><span class="n">LNI</span><span class="si">}</span><span class="se">\t</span><span class="s2">Diff vs Unreachables: </span><span class="si">{</span><span class="n">DIFF</span><span class="si">}</span><span class="s2"> == </span><span class="si">{</span><span class="n">UN</span><span class="si">}</span><span class="s2"> = </span><span class="si">{</span><span class="n">DIFF</span><span class="o">==</span><span class="n">UN</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">)</span>
</span><span id="Program.prune_instructions-1214"><a href="#Program.prune_instructions-1214"><span class="linenos">1214</span></a>        <span class="k">return</span> <span class="n">new_instructions</span>
</span></pre></div>


    

                            </div>
                </section>
                <section id="ProgramType">
                            <input id="ProgramType-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr class">
            
    <span class="def">class</span>
    <span class="name">ProgramType</span><wbr>(<span class="base">typing.NamedTuple</span>):

                <label class="view-source-button" for="ProgramType-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#ProgramType"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="ProgramType-1217"><a href="#ProgramType-1217"><span class="linenos">1217</span></a><span class="k">class</span> <span class="nc">ProgramType</span><span class="p">(</span><span class="n">NamedTuple</span><span class="p">):</span>
</span><span id="ProgramType-1218"><a href="#ProgramType-1218"><span class="linenos">1218</span></a>    <span class="n">in_types</span><span class="p">:</span> <span class="n">Tuple</span><span class="p">[</span><span class="n">SymbolicTensor</span><span class="p">]</span>
</span><span id="ProgramType-1219"><a href="#ProgramType-1219"><span class="linenos">1219</span></a>    <span class="n">out_types</span><span class="p">:</span> <span class="n">Tuple</span><span class="p">[</span><span class="n">SymbolicTensor</span><span class="p">]</span>
</span><span id="ProgramType-1220"><a href="#ProgramType-1220"><span class="linenos">1220</span></a>
</span><span id="ProgramType-1221"><a href="#ProgramType-1221"><span class="linenos">1221</span></a>    <span class="k">def</span> <span class="fm">__repr__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="ProgramType-1222"><a href="#ProgramType-1222"><span class="linenos">1222</span></a>        <span class="n">in_types</span> <span class="o">=</span> <span class="s2">&quot;, &quot;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">symval</span><span class="o">.</span><span class="n">str_short</span><span class="p">()</span> <span class="k">for</span> <span class="n">symval</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">in_types</span><span class="p">)</span>
</span><span id="ProgramType-1223"><a href="#ProgramType-1223"><span class="linenos">1223</span></a>        <span class="n">out_types</span> <span class="o">=</span> <span class="s2">&quot;, &quot;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">symval</span><span class="o">.</span><span class="n">str_short</span><span class="p">()</span> <span class="k">for</span> <span class="n">symval</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">out_types</span><span class="p">)</span>
</span><span id="ProgramType-1224"><a href="#ProgramType-1224"><span class="linenos">1224</span></a>        <span class="k">return</span> <span class="sa">f</span><span class="s2">&quot;(</span><span class="si">{</span><span class="n">in_types</span><span class="si">}</span><span class="s2">) -&gt; (</span><span class="si">{</span><span class="n">out_types</span><span class="si">}</span><span class="s2">)&quot;</span>
</span></pre></div>


            <div class="docstring"><p>ProgramType(in_types, out_types)</p>
</div>


                            <div id="ProgramType.__init__" class="classattr">
                                <div class="attr function">
            
        <span class="name">ProgramType</span><span class="signature pdoc-code multiline">(<span class="param">	<span class="n">in_types</span><span class="p">:</span> <span class="n">Tuple</span><span class="p">[</span><span class="n"><a href="#SymbolicTensor">SymbolicTensor</a></span><span class="p">]</span>,</span><span class="param">	<span class="n">out_types</span><span class="p">:</span> <span class="n">Tuple</span><span class="p">[</span><span class="n"><a href="#SymbolicTensor">SymbolicTensor</a></span><span class="p">]</span></span>)</span>

        
    </div>
    <a class="headerlink" href="#ProgramType.__init__"></a>
    
            <div class="docstring"><p>Create new instance of ProgramType(in_types, out_types)</p>
</div>


                            </div>
                            <div id="ProgramType.in_types" class="classattr">
                                <div class="attr variable">
            <span class="name">in_types</span><span class="annotation">: Tuple[<a href="#SymbolicTensor">SymbolicTensor</a>]</span>

        
    </div>
    <a class="headerlink" href="#ProgramType.in_types"></a>
    
            <div class="docstring"><p>Alias for field number 0</p>
</div>


                            </div>
                            <div id="ProgramType.out_types" class="classattr">
                                <div class="attr variable">
            <span class="name">out_types</span><span class="annotation">: Tuple[<a href="#SymbolicTensor">SymbolicTensor</a>]</span>

        
    </div>
    <a class="headerlink" href="#ProgramType.out_types"></a>
    
            <div class="docstring"><p>Alias for field number 1</p>
</div>


                            </div>
                            <div class="inherited">
                                <h5>Inherited Members</h5>
                                <dl>
                                    <div><dt>builtins.tuple</dt>
                                <dd id="ProgramType.index" class="function">index</dd>
                <dd id="ProgramType.count" class="function">count</dd>

            </div>
                                </dl>
                            </div>
                </section>
                <section id="Empty">
                            <input id="Empty-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr class">
            
    <span class="def">class</span>
    <span class="name">Empty</span>:

                <label class="view-source-button" for="Empty-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Empty"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Empty-1232"><a href="#Empty-1232"><span class="linenos">1232</span></a><span class="k">class</span> <span class="nc">Empty</span><span class="p">:</span>
</span><span id="Empty-1233"><a href="#Empty-1233"><span class="linenos">1233</span></a>    <span class="k">pass</span>
</span></pre></div>


    

                </section>
                <section id="empty">
                    <div class="attr variable">
            <span class="name">empty</span>        =
<span class="default_value">&lt;<a href="#Empty">Empty</a> object&gt;</span>

        
    </div>
    <a class="headerlink" href="#empty"></a>
    
    

                </section>
                <section id="Store">
                            <input id="Store-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr class">
            
    <span class="def">class</span>
    <span class="name">Store</span>:

                <label class="view-source-button" for="Store-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Store"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Store-1239"><a href="#Store-1239"><span class="linenos">1239</span></a><span class="k">class</span> <span class="nc">Store</span><span class="p">:</span>
</span><span id="Store-1240"><a href="#Store-1240"><span class="linenos">1240</span></a>    <span class="n">val</span> <span class="o">=</span> <span class="n">empty</span>
</span><span id="Store-1241"><a href="#Store-1241"><span class="linenos">1241</span></a>
</span><span id="Store-1242"><a href="#Store-1242"><span class="linenos">1242</span></a>    <span class="k">def</span> <span class="nf">set_value</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">val</span><span class="p">):</span>
</span><span id="Store-1243"><a href="#Store-1243"><span class="linenos">1243</span></a>        <span class="k">assert</span> <span class="bp">self</span><span class="o">.</span><span class="n">val</span> <span class="ow">is</span> <span class="n">empty</span>
</span><span id="Store-1244"><a href="#Store-1244"><span class="linenos">1244</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">val</span> <span class="o">=</span> <span class="n">val</span>
</span><span id="Store-1245"><a href="#Store-1245"><span class="linenos">1245</span></a>
</span><span id="Store-1246"><a href="#Store-1246"><span class="linenos">1246</span></a>    <span class="k">def</span> <span class="fm">__call__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="Store-1247"><a href="#Store-1247"><span class="linenos">1247</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">val</span>
</span></pre></div>


    

                            <div id="Store.val" class="classattr">
                                <div class="attr variable">
            <span class="name">val</span>        =
<span class="default_value">&lt;<a href="#Empty">Empty</a> object&gt;</span>

        
    </div>
    <a class="headerlink" href="#Store.val"></a>
    
    

                            </div>
                            <div id="Store.set_value" class="classattr">
                                        <input id="Store.set_value-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">set_value</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="n">val</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="Store.set_value-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Store.set_value"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Store.set_value-1242"><a href="#Store.set_value-1242"><span class="linenos">1242</span></a>    <span class="k">def</span> <span class="nf">set_value</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">val</span><span class="p">):</span>
</span><span id="Store.set_value-1243"><a href="#Store.set_value-1243"><span class="linenos">1243</span></a>        <span class="k">assert</span> <span class="bp">self</span><span class="o">.</span><span class="n">val</span> <span class="ow">is</span> <span class="n">empty</span>
</span><span id="Store.set_value-1244"><a href="#Store.set_value-1244"><span class="linenos">1244</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">val</span> <span class="o">=</span> <span class="n">val</span>
</span></pre></div>


    

                            </div>
                </section>
                <section id="NodeType">
                            <input id="NodeType-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr class">
            
    <span class="def">class</span>
    <span class="name">NodeType</span><wbr>(<span class="base">typing.NamedTuple</span>):

                <label class="view-source-button" for="NodeType-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#NodeType"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="NodeType-1250"><a href="#NodeType-1250"><span class="linenos">1250</span></a><span class="k">class</span> <span class="nc">NodeType</span><span class="p">(</span><span class="n">NamedTuple</span><span class="p">):</span>
</span><span id="NodeType-1251"><a href="#NodeType-1251"><span class="linenos">1251</span></a>    <span class="n">name</span><span class="p">:</span> <span class="nb">str</span>
</span><span id="NodeType-1252"><a href="#NodeType-1252"><span class="linenos">1252</span></a>    <span class="n">flatten</span><span class="p">:</span> <span class="n">Callable</span>
</span><span id="NodeType-1253"><a href="#NodeType-1253"><span class="linenos">1253</span></a>    <span class="n">unflatten</span><span class="p">:</span> <span class="n">Callable</span>
</span></pre></div>


            <div class="docstring"><p>NodeType(name, flatten, unflatten)</p>
</div>


                            <div id="NodeType.__init__" class="classattr">
                                <div class="attr function">
            
        <span class="name">NodeType</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">name</span><span class="p">:</span> <span class="nb">str</span>, </span><span class="param"><span class="n">flatten</span><span class="p">:</span> <span class="n">Callable</span>, </span><span class="param"><span class="n">unflatten</span><span class="p">:</span> <span class="n">Callable</span></span>)</span>

        
    </div>
    <a class="headerlink" href="#NodeType.__init__"></a>
    
            <div class="docstring"><p>Create new instance of NodeType(name, flatten, unflatten)</p>
</div>


                            </div>
                            <div id="NodeType.name" class="classattr">
                                <div class="attr variable">
            <span class="name">name</span><span class="annotation">: str</span>

        
    </div>
    <a class="headerlink" href="#NodeType.name"></a>
    
            <div class="docstring"><p>Alias for field number 0</p>
</div>


                            </div>
                            <div id="NodeType.flatten" class="classattr">
                                <div class="attr variable">
            <span class="name">flatten</span><span class="annotation">: Callable</span>

        
    </div>
    <a class="headerlink" href="#NodeType.flatten"></a>
    
            <div class="docstring"><p>Alias for field number 1</p>
</div>


                            </div>
                            <div id="NodeType.unflatten" class="classattr">
                                <div class="attr variable">
            <span class="name">unflatten</span><span class="annotation">: Callable</span>

        
    </div>
    <a class="headerlink" href="#NodeType.unflatten"></a>
    
            <div class="docstring"><p>Alias for field number 2</p>
</div>


                            </div>
                            <div class="inherited">
                                <h5>Inherited Members</h5>
                                <dl>
                                    <div><dt>builtins.tuple</dt>
                                <dd id="NodeType.index" class="function">index</dd>
                <dd id="NodeType.count" class="function">count</dd>

            </div>
                                </dl>
                            </div>
                </section>
                <section id="TreeDef">
                            <input id="TreeDef-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr class">
            
    <span class="def">class</span>
    <span class="name">TreeDef</span><wbr>(<span class="base">typing.NamedTuple</span>):

                <label class="view-source-button" for="TreeDef-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#TreeDef"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="TreeDef-1256"><a href="#TreeDef-1256"><span class="linenos">1256</span></a><span class="k">class</span> <span class="nc">TreeDef</span><span class="p">(</span><span class="n">NamedTuple</span><span class="p">):</span>
</span><span id="TreeDef-1257"><a href="#TreeDef-1257"><span class="linenos">1257</span></a>    <span class="n">node_type</span><span class="p">:</span> <span class="n">NodeType</span>
</span><span id="TreeDef-1258"><a href="#TreeDef-1258"><span class="linenos">1258</span></a>    <span class="n">node_metadata</span><span class="p">:</span> <span class="n">Hashable</span>
</span><span id="TreeDef-1259"><a href="#TreeDef-1259"><span class="linenos">1259</span></a>    <span class="n">child_treedefs</span><span class="p">:</span> <span class="n">Tuple</span><span class="p">[</span><span class="s2">&quot;TreeDef&quot;</span><span class="p">,</span> <span class="o">...</span><span class="p">]</span>
</span><span id="TreeDef-1260"><a href="#TreeDef-1260"><span class="linenos">1260</span></a>
</span><span id="TreeDef-1261"><a href="#TreeDef-1261"><span class="linenos">1261</span></a>    <span class="k">def</span> <span class="fm">__repr__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="TreeDef-1262"><a href="#TreeDef-1262"><span class="linenos">1262</span></a>        <span class="n">ret</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">tree_repr</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span>
</span><span id="TreeDef-1263"><a href="#TreeDef-1263"><span class="linenos">1263</span></a>        <span class="k">return</span> <span class="n">ret</span>
</span><span id="TreeDef-1264"><a href="#TreeDef-1264"><span class="linenos">1264</span></a>
</span><span id="TreeDef-1265"><a href="#TreeDef-1265"><span class="linenos">1265</span></a>    <span class="k">def</span> <span class="nf">tree_repr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">tree</span><span class="p">,</span> <span class="n">indent</span><span class="o">=</span><span class="s2">&quot;  &quot;</span><span class="p">,</span> <span class="n">prefix</span><span class="o">=</span><span class="s2">&quot;&quot;</span><span class="p">,</span> <span class="n">last</span><span class="o">=</span><span class="kc">True</span><span class="p">):</span>
</span><span id="TreeDef-1266"><a href="#TreeDef-1266"><span class="linenos">1266</span></a>        <span class="n">ret</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span>
</span><span id="TreeDef-1267"><a href="#TreeDef-1267"><span class="linenos">1267</span></a>
</span><span id="TreeDef-1268"><a href="#TreeDef-1268"><span class="linenos">1268</span></a>        <span class="k">def</span> <span class="nf">_tree_repr</span><span class="p">(</span><span class="n">tree</span><span class="p">,</span> <span class="n">indent</span><span class="p">,</span> <span class="n">prefix</span><span class="p">,</span> <span class="n">last</span><span class="p">):</span>
</span><span id="TreeDef-1269"><a href="#TreeDef-1269"><span class="linenos">1269</span></a>            <span class="k">nonlocal</span> <span class="n">ret</span>
</span><span id="TreeDef-1270"><a href="#TreeDef-1270"><span class="linenos">1270</span></a>            <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">tree</span><span class="p">,</span> <span class="n">TreeDef</span><span class="p">):</span>
</span><span id="TreeDef-1271"><a href="#TreeDef-1271"><span class="linenos">1271</span></a>                <span class="n">ret</span> <span class="o">+=</span> <span class="sa">f</span><span class="s1">&#39;</span><span class="si">{</span><span class="n">prefix</span><span class="si">}</span><span class="s1"> </span><span class="si">{</span><span class="p">(</span><span class="s2">&quot;└─&quot;</span><span class="w"> </span><span class="k">if</span><span class="w"> </span><span class="n">last</span><span class="w"> </span><span class="k">else</span><span class="w"> </span><span class="s2">&quot;├─&quot;</span><span class="p">)</span><span class="si">}</span><span class="s1"> </span><span class="si">{</span><span class="n">tree</span><span class="o">.</span><span class="n">node_type</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="se">\n</span><span class="s1">&#39;</span>
</span><span id="TreeDef-1272"><a href="#TreeDef-1272"><span class="linenos">1272</span></a>                <span class="k">for</span> <span class="n">i</span><span class="p">,</span> <span class="n">item</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">tree</span><span class="o">.</span><span class="n">child_treedefs</span><span class="p">):</span>
</span><span id="TreeDef-1273"><a href="#TreeDef-1273"><span class="linenos">1273</span></a>                    <span class="n">new_prefix</span> <span class="o">=</span> <span class="n">prefix</span> <span class="o">+</span> <span class="p">(</span><span class="n">indent</span> <span class="k">if</span> <span class="ow">not</span> <span class="n">last</span> <span class="k">else</span> <span class="s2">&quot;   &quot;</span><span class="p">)</span>
</span><span id="TreeDef-1274"><a href="#TreeDef-1274"><span class="linenos">1274</span></a>                    <span class="n">new_last</span> <span class="o">=</span> <span class="n">i</span> <span class="o">==</span> <span class="nb">len</span><span class="p">(</span><span class="n">tree</span><span class="o">.</span><span class="n">child_treedefs</span><span class="p">)</span> <span class="o">-</span> <span class="mi">1</span>
</span><span id="TreeDef-1275"><a href="#TreeDef-1275"><span class="linenos">1275</span></a>                    <span class="n">_tree_repr</span><span class="p">(</span><span class="n">item</span><span class="p">,</span> <span class="n">indent</span><span class="p">,</span> <span class="n">new_prefix</span><span class="p">,</span> <span class="n">new_last</span><span class="p">)</span>
</span><span id="TreeDef-1276"><a href="#TreeDef-1276"><span class="linenos">1276</span></a>            <span class="k">else</span><span class="p">:</span>
</span><span id="TreeDef-1277"><a href="#TreeDef-1277"><span class="linenos">1277</span></a>                <span class="n">ret</span> <span class="o">+=</span> <span class="sa">f</span><span class="s1">&#39;</span><span class="si">{</span><span class="n">prefix</span><span class="si">}</span><span class="s1"> </span><span class="si">{</span><span class="p">(</span><span class="s2">&quot;└─&quot;</span><span class="w"> </span><span class="k">if</span><span class="w"> </span><span class="n">last</span><span class="w"> </span><span class="k">else</span><span class="w"> </span><span class="s2">&quot;├─&quot;</span><span class="p">)</span><span class="si">}</span><span class="s1"> </span><span class="si">{</span><span class="n">tree</span><span class="si">}</span><span class="se">\n</span><span class="s1">&#39;</span>
</span><span id="TreeDef-1278"><a href="#TreeDef-1278"><span class="linenos">1278</span></a>
</span><span id="TreeDef-1279"><a href="#TreeDef-1279"><span class="linenos">1279</span></a>        <span class="n">_tree_repr</span><span class="p">(</span><span class="n">tree</span><span class="p">,</span> <span class="n">indent</span><span class="o">=</span><span class="s2">&quot;  &quot;</span><span class="p">,</span> <span class="n">prefix</span><span class="o">=</span><span class="s2">&quot;&quot;</span><span class="p">,</span> <span class="n">last</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
</span><span id="TreeDef-1280"><a href="#TreeDef-1280"><span class="linenos">1280</span></a>        <span class="k">return</span> <span class="n">ret</span>
</span><span id="TreeDef-1281"><a href="#TreeDef-1281"><span class="linenos">1281</span></a>
</span><span id="TreeDef-1282"><a href="#TreeDef-1282"><span class="linenos">1282</span></a>    <span class="nd">@property</span>
</span><span id="TreeDef-1283"><a href="#TreeDef-1283"><span class="linenos">1283</span></a>    <span class="k">def</span> <span class="nf">num_leaves</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="TreeDef-1284"><a href="#TreeDef-1284"><span class="linenos">1284</span></a>        <span class="k">def</span> <span class="nf">get_num_leaves</span><span class="p">(</span><span class="n">x</span><span class="p">):</span>
</span><span id="TreeDef-1285"><a href="#TreeDef-1285"><span class="linenos">1285</span></a>            <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">Leaf</span><span class="p">):</span>
</span><span id="TreeDef-1286"><a href="#TreeDef-1286"><span class="linenos">1286</span></a>                <span class="k">return</span> <span class="mi">1</span>
</span><span id="TreeDef-1287"><a href="#TreeDef-1287"><span class="linenos">1287</span></a>            <span class="k">else</span><span class="p">:</span>
</span><span id="TreeDef-1288"><a href="#TreeDef-1288"><span class="linenos">1288</span></a>                <span class="k">return</span> <span class="nb">sum</span><span class="p">(</span><span class="n">get_num_leaves</span><span class="p">(</span><span class="n">sub_x</span><span class="p">)</span> <span class="k">for</span> <span class="n">sub_x</span> <span class="ow">in</span> <span class="n">x</span><span class="o">.</span><span class="n">child_treedefs</span><span class="p">)</span>
</span><span id="TreeDef-1289"><a href="#TreeDef-1289"><span class="linenos">1289</span></a>
</span><span id="TreeDef-1290"><a href="#TreeDef-1290"><span class="linenos">1290</span></a>        <span class="k">return</span> <span class="nb">sum</span><span class="p">(</span><span class="n">get_num_leaves</span><span class="p">(</span><span class="n">x</span><span class="p">)</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">child_treedefs</span><span class="p">)</span>
</span></pre></div>


            <div class="docstring"><p>TreeDef(node_type, node_metadata, child_treedefs)</p>
</div>


                            <div id="TreeDef.__init__" class="classattr">
                                <div class="attr function">
            
        <span class="name">TreeDef</span><span class="signature pdoc-code multiline">(<span class="param">	<span class="n">node_type</span><span class="p">:</span> <span class="n"><a href="#NodeType">NodeType</a></span>,</span><span class="param">	<span class="n">node_metadata</span><span class="p">:</span> <span class="n">Hashable</span>,</span><span class="param">	<span class="n">child_treedefs</span><span class="p">:</span> <span class="n">Tuple</span><span class="p">[</span><span class="n">ForwardRef</span><span class="p">(</span><span class="s1">&#39;TreeDef&#39;</span><span class="p">),</span> <span class="o">...</span><span class="p">]</span></span>)</span>

        
    </div>
    <a class="headerlink" href="#TreeDef.__init__"></a>
    
            <div class="docstring"><p>Create new instance of TreeDef(node_type, node_metadata, child_treedefs)</p>
</div>


                            </div>
                            <div id="TreeDef.node_type" class="classattr">
                                <div class="attr variable">
            <span class="name">node_type</span><span class="annotation">: <a href="#NodeType">NodeType</a></span>

        
    </div>
    <a class="headerlink" href="#TreeDef.node_type"></a>
    
            <div class="docstring"><p>Alias for field number 0</p>
</div>


                            </div>
                            <div id="TreeDef.node_metadata" class="classattr">
                                <div class="attr variable">
            <span class="name">node_metadata</span><span class="annotation">: Hashable</span>

        
    </div>
    <a class="headerlink" href="#TreeDef.node_metadata"></a>
    
            <div class="docstring"><p>Alias for field number 1</p>
</div>


                            </div>
                            <div id="TreeDef.child_treedefs" class="classattr">
                                <div class="attr variable">
            <span class="name">child_treedefs</span><span class="annotation">: Tuple[<a href="#TreeDef">TreeDef</a>, ...]</span>

        
    </div>
    <a class="headerlink" href="#TreeDef.child_treedefs"></a>
    
            <div class="docstring"><p>Alias for field number 2</p>
</div>


                            </div>
                            <div id="TreeDef.tree_repr" class="classattr">
                                        <input id="TreeDef.tree_repr-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">tree_repr</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="n">tree</span>, </span><span class="param"><span class="n">indent</span><span class="o">=</span><span class="s1">&#39;  &#39;</span>, </span><span class="param"><span class="n">prefix</span><span class="o">=</span><span class="s1">&#39;&#39;</span>, </span><span class="param"><span class="n">last</span><span class="o">=</span><span class="kc">True</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="TreeDef.tree_repr-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#TreeDef.tree_repr"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="TreeDef.tree_repr-1265"><a href="#TreeDef.tree_repr-1265"><span class="linenos">1265</span></a>    <span class="k">def</span> <span class="nf">tree_repr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">tree</span><span class="p">,</span> <span class="n">indent</span><span class="o">=</span><span class="s2">&quot;  &quot;</span><span class="p">,</span> <span class="n">prefix</span><span class="o">=</span><span class="s2">&quot;&quot;</span><span class="p">,</span> <span class="n">last</span><span class="o">=</span><span class="kc">True</span><span class="p">):</span>
</span><span id="TreeDef.tree_repr-1266"><a href="#TreeDef.tree_repr-1266"><span class="linenos">1266</span></a>        <span class="n">ret</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span>
</span><span id="TreeDef.tree_repr-1267"><a href="#TreeDef.tree_repr-1267"><span class="linenos">1267</span></a>
</span><span id="TreeDef.tree_repr-1268"><a href="#TreeDef.tree_repr-1268"><span class="linenos">1268</span></a>        <span class="k">def</span> <span class="nf">_tree_repr</span><span class="p">(</span><span class="n">tree</span><span class="p">,</span> <span class="n">indent</span><span class="p">,</span> <span class="n">prefix</span><span class="p">,</span> <span class="n">last</span><span class="p">):</span>
</span><span id="TreeDef.tree_repr-1269"><a href="#TreeDef.tree_repr-1269"><span class="linenos">1269</span></a>            <span class="k">nonlocal</span> <span class="n">ret</span>
</span><span id="TreeDef.tree_repr-1270"><a href="#TreeDef.tree_repr-1270"><span class="linenos">1270</span></a>            <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">tree</span><span class="p">,</span> <span class="n">TreeDef</span><span class="p">):</span>
</span><span id="TreeDef.tree_repr-1271"><a href="#TreeDef.tree_repr-1271"><span class="linenos">1271</span></a>                <span class="n">ret</span> <span class="o">+=</span> <span class="sa">f</span><span class="s1">&#39;</span><span class="si">{</span><span class="n">prefix</span><span class="si">}</span><span class="s1"> </span><span class="si">{</span><span class="p">(</span><span class="s2">&quot;└─&quot;</span><span class="w"> </span><span class="k">if</span><span class="w"> </span><span class="n">last</span><span class="w"> </span><span class="k">else</span><span class="w"> </span><span class="s2">&quot;├─&quot;</span><span class="p">)</span><span class="si">}</span><span class="s1"> </span><span class="si">{</span><span class="n">tree</span><span class="o">.</span><span class="n">node_type</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="se">\n</span><span class="s1">&#39;</span>
</span><span id="TreeDef.tree_repr-1272"><a href="#TreeDef.tree_repr-1272"><span class="linenos">1272</span></a>                <span class="k">for</span> <span class="n">i</span><span class="p">,</span> <span class="n">item</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">tree</span><span class="o">.</span><span class="n">child_treedefs</span><span class="p">):</span>
</span><span id="TreeDef.tree_repr-1273"><a href="#TreeDef.tree_repr-1273"><span class="linenos">1273</span></a>                    <span class="n">new_prefix</span> <span class="o">=</span> <span class="n">prefix</span> <span class="o">+</span> <span class="p">(</span><span class="n">indent</span> <span class="k">if</span> <span class="ow">not</span> <span class="n">last</span> <span class="k">else</span> <span class="s2">&quot;   &quot;</span><span class="p">)</span>
</span><span id="TreeDef.tree_repr-1274"><a href="#TreeDef.tree_repr-1274"><span class="linenos">1274</span></a>                    <span class="n">new_last</span> <span class="o">=</span> <span class="n">i</span> <span class="o">==</span> <span class="nb">len</span><span class="p">(</span><span class="n">tree</span><span class="o">.</span><span class="n">child_treedefs</span><span class="p">)</span> <span class="o">-</span> <span class="mi">1</span>
</span><span id="TreeDef.tree_repr-1275"><a href="#TreeDef.tree_repr-1275"><span class="linenos">1275</span></a>                    <span class="n">_tree_repr</span><span class="p">(</span><span class="n">item</span><span class="p">,</span> <span class="n">indent</span><span class="p">,</span> <span class="n">new_prefix</span><span class="p">,</span> <span class="n">new_last</span><span class="p">)</span>
</span><span id="TreeDef.tree_repr-1276"><a href="#TreeDef.tree_repr-1276"><span class="linenos">1276</span></a>            <span class="k">else</span><span class="p">:</span>
</span><span id="TreeDef.tree_repr-1277"><a href="#TreeDef.tree_repr-1277"><span class="linenos">1277</span></a>                <span class="n">ret</span> <span class="o">+=</span> <span class="sa">f</span><span class="s1">&#39;</span><span class="si">{</span><span class="n">prefix</span><span class="si">}</span><span class="s1"> </span><span class="si">{</span><span class="p">(</span><span class="s2">&quot;└─&quot;</span><span class="w"> </span><span class="k">if</span><span class="w"> </span><span class="n">last</span><span class="w"> </span><span class="k">else</span><span class="w"> </span><span class="s2">&quot;├─&quot;</span><span class="p">)</span><span class="si">}</span><span class="s1"> </span><span class="si">{</span><span class="n">tree</span><span class="si">}</span><span class="se">\n</span><span class="s1">&#39;</span>
</span><span id="TreeDef.tree_repr-1278"><a href="#TreeDef.tree_repr-1278"><span class="linenos">1278</span></a>
</span><span id="TreeDef.tree_repr-1279"><a href="#TreeDef.tree_repr-1279"><span class="linenos">1279</span></a>        <span class="n">_tree_repr</span><span class="p">(</span><span class="n">tree</span><span class="p">,</span> <span class="n">indent</span><span class="o">=</span><span class="s2">&quot;  &quot;</span><span class="p">,</span> <span class="n">prefix</span><span class="o">=</span><span class="s2">&quot;&quot;</span><span class="p">,</span> <span class="n">last</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
</span><span id="TreeDef.tree_repr-1280"><a href="#TreeDef.tree_repr-1280"><span class="linenos">1280</span></a>        <span class="k">return</span> <span class="n">ret</span>
</span></pre></div>


    

                            </div>
                            <div id="TreeDef.num_leaves" class="classattr">
                                        <input id="TreeDef.num_leaves-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr variable">
            <span class="name">num_leaves</span>

                <label class="view-source-button" for="TreeDef.num_leaves-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#TreeDef.num_leaves"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="TreeDef.num_leaves-1282"><a href="#TreeDef.num_leaves-1282"><span class="linenos">1282</span></a>    <span class="nd">@property</span>
</span><span id="TreeDef.num_leaves-1283"><a href="#TreeDef.num_leaves-1283"><span class="linenos">1283</span></a>    <span class="k">def</span> <span class="nf">num_leaves</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="TreeDef.num_leaves-1284"><a href="#TreeDef.num_leaves-1284"><span class="linenos">1284</span></a>        <span class="k">def</span> <span class="nf">get_num_leaves</span><span class="p">(</span><span class="n">x</span><span class="p">):</span>
</span><span id="TreeDef.num_leaves-1285"><a href="#TreeDef.num_leaves-1285"><span class="linenos">1285</span></a>            <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">Leaf</span><span class="p">):</span>
</span><span id="TreeDef.num_leaves-1286"><a href="#TreeDef.num_leaves-1286"><span class="linenos">1286</span></a>                <span class="k">return</span> <span class="mi">1</span>
</span><span id="TreeDef.num_leaves-1287"><a href="#TreeDef.num_leaves-1287"><span class="linenos">1287</span></a>            <span class="k">else</span><span class="p">:</span>
</span><span id="TreeDef.num_leaves-1288"><a href="#TreeDef.num_leaves-1288"><span class="linenos">1288</span></a>                <span class="k">return</span> <span class="nb">sum</span><span class="p">(</span><span class="n">get_num_leaves</span><span class="p">(</span><span class="n">sub_x</span><span class="p">)</span> <span class="k">for</span> <span class="n">sub_x</span> <span class="ow">in</span> <span class="n">x</span><span class="o">.</span><span class="n">child_treedefs</span><span class="p">)</span>
</span><span id="TreeDef.num_leaves-1289"><a href="#TreeDef.num_leaves-1289"><span class="linenos">1289</span></a>
</span><span id="TreeDef.num_leaves-1290"><a href="#TreeDef.num_leaves-1290"><span class="linenos">1290</span></a>        <span class="k">return</span> <span class="nb">sum</span><span class="p">(</span><span class="n">get_num_leaves</span><span class="p">(</span><span class="n">x</span><span class="p">)</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">child_treedefs</span><span class="p">)</span>
</span></pre></div>


    

                            </div>
                            <div class="inherited">
                                <h5>Inherited Members</h5>
                                <dl>
                                    <div><dt>builtins.tuple</dt>
                                <dd id="TreeDef.index" class="function">index</dd>
                <dd id="TreeDef.count" class="function">count</dd>

            </div>
                                </dl>
                            </div>
                </section>
                <section id="Leaf">
                            <input id="Leaf-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr class">
            
    <span class="def">class</span>
    <span class="name">Leaf</span>:

                <label class="view-source-button" for="Leaf-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Leaf"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Leaf-1293"><a href="#Leaf-1293"><span class="linenos">1293</span></a><span class="k">class</span> <span class="nc">Leaf</span><span class="p">:</span>
</span><span id="Leaf-1294"><a href="#Leaf-1294"><span class="linenos">1294</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">val</span><span class="p">):</span>
</span><span id="Leaf-1295"><a href="#Leaf-1295"><span class="linenos">1295</span></a>        <span class="k">if</span> <span class="nb">hasattr</span><span class="p">(</span><span class="n">val</span><span class="p">,</span> <span class="s2">&quot;shape&quot;</span><span class="p">):</span>
</span><span id="Leaf-1296"><a href="#Leaf-1296"><span class="linenos">1296</span></a>            <span class="n">val</span> <span class="o">=</span> <span class="n">SymbolicTensor</span><span class="o">.</span><span class="n">like</span><span class="p">(</span><span class="n">val</span><span class="p">)</span>
</span><span id="Leaf-1297"><a href="#Leaf-1297"><span class="linenos">1297</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">val</span> <span class="o">=</span> <span class="n">val</span>
</span><span id="Leaf-1298"><a href="#Leaf-1298"><span class="linenos">1298</span></a>
</span><span id="Leaf-1299"><a href="#Leaf-1299"><span class="linenos">1299</span></a>    <span class="k">def</span> <span class="fm">__repr__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="Leaf-1300"><a href="#Leaf-1300"><span class="linenos">1300</span></a>        <span class="n">ret</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">val</span><span class="o">.</span><span class="n">str_short</span><span class="p">()</span> <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">val</span><span class="p">,</span> <span class="n">SymbolicTensor</span><span class="p">)</span> <span class="k">else</span> <span class="nb">repr</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">val</span><span class="p">)</span>
</span><span id="Leaf-1301"><a href="#Leaf-1301"><span class="linenos">1301</span></a>        <span class="k">return</span> <span class="sa">f</span><span class="s2">&quot;&lt;Leaf: </span><span class="si">{</span><span class="n">ret</span><span class="si">}</span><span class="s2">&gt;&quot;</span>
</span><span id="Leaf-1302"><a href="#Leaf-1302"><span class="linenos">1302</span></a>
</span><span id="Leaf-1303"><a href="#Leaf-1303"><span class="linenos">1303</span></a>    <span class="k">def</span> <span class="fm">__hash__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="Leaf-1304"><a href="#Leaf-1304"><span class="linenos">1304</span></a>        <span class="k">return</span> <span class="nb">hash</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">val</span><span class="p">)</span>
</span><span id="Leaf-1305"><a href="#Leaf-1305"><span class="linenos">1305</span></a>
</span><span id="Leaf-1306"><a href="#Leaf-1306"><span class="linenos">1306</span></a>    <span class="k">def</span> <span class="fm">__eq__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">other</span><span class="p">):</span>
</span><span id="Leaf-1307"><a href="#Leaf-1307"><span class="linenos">1307</span></a>        <span class="k">return</span> <span class="kc">True</span>  <span class="c1"># make TreeDef __eq__ don&#39;t care Leaf</span>
</span><span id="Leaf-1308"><a href="#Leaf-1308"><span class="linenos">1308</span></a>        <span class="c1"># if isinstance(other, Leaf): # TODO: test above assumption</span>
</span><span id="Leaf-1309"><a href="#Leaf-1309"><span class="linenos">1309</span></a>        <span class="c1">#     return self.val == other.val</span>
</span></pre></div>


    

                            <div id="Leaf.__init__" class="classattr">
                                        <input id="Leaf.__init__-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="name">Leaf</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">val</span></span>)</span>

                <label class="view-source-button" for="Leaf.__init__-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Leaf.__init__"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Leaf.__init__-1294"><a href="#Leaf.__init__-1294"><span class="linenos">1294</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">val</span><span class="p">):</span>
</span><span id="Leaf.__init__-1295"><a href="#Leaf.__init__-1295"><span class="linenos">1295</span></a>        <span class="k">if</span> <span class="nb">hasattr</span><span class="p">(</span><span class="n">val</span><span class="p">,</span> <span class="s2">&quot;shape&quot;</span><span class="p">):</span>
</span><span id="Leaf.__init__-1296"><a href="#Leaf.__init__-1296"><span class="linenos">1296</span></a>            <span class="n">val</span> <span class="o">=</span> <span class="n">SymbolicTensor</span><span class="o">.</span><span class="n">like</span><span class="p">(</span><span class="n">val</span><span class="p">)</span>
</span><span id="Leaf.__init__-1297"><a href="#Leaf.__init__-1297"><span class="linenos">1297</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">val</span> <span class="o">=</span> <span class="n">val</span>
</span></pre></div>


    

                            </div>
                            <div id="Leaf.val" class="classattr">
                                <div class="attr variable">
            <span class="name">val</span>

        
    </div>
    <a class="headerlink" href="#Leaf.val"></a>
    
    

                            </div>
                </section>
                <section id="JitOutput">
                            <input id="JitOutput-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr class">
            
    <span class="def">class</span>
    <span class="name">JitOutput</span>:

                <label class="view-source-button" for="JitOutput-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#JitOutput"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="JitOutput-1317"><a href="#JitOutput-1317"><span class="linenos">1317</span></a><span class="k">class</span> <span class="nc">JitOutput</span><span class="p">:</span>
</span><span id="JitOutput-1318"><a href="#JitOutput-1318"><span class="linenos">1318</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">program</span><span class="p">:</span> <span class="n">Program</span><span class="p">,</span> <span class="n">codegen_output</span><span class="p">:</span> <span class="n">CodegenOutput</span><span class="p">,</span> <span class="n">fn</span><span class="p">,</span> <span class="n">code</span><span class="p">:</span> <span class="nb">str</span><span class="p">,</span> <span class="n">consts</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">]):</span>
</span><span id="JitOutput-1319"><a href="#JitOutput-1319"><span class="linenos">1319</span></a>        <span class="nb">super</span><span class="p">()</span><span class="o">.</span><span class="fm">__init__</span><span class="p">()</span>
</span><span id="JitOutput-1320"><a href="#JitOutput-1320"><span class="linenos">1320</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">program</span> <span class="o">=</span> <span class="n">program</span>
</span><span id="JitOutput-1321"><a href="#JitOutput-1321"><span class="linenos">1321</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">code</span> <span class="o">=</span> <span class="n">code</span>
</span><span id="JitOutput-1322"><a href="#JitOutput-1322"><span class="linenos">1322</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">codegen_output</span> <span class="o">=</span> <span class="n">codegen_output</span>
</span><span id="JitOutput-1323"><a href="#JitOutput-1323"><span class="linenos">1323</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">fn</span><span class="p">:</span> <span class="n">Callable</span> <span class="o">=</span> <span class="n">fn</span>
</span><span id="JitOutput-1324"><a href="#JitOutput-1324"><span class="linenos">1324</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">consts</span> <span class="o">=</span> <span class="n">consts</span>
</span><span id="JitOutput-1325"><a href="#JitOutput-1325"><span class="linenos">1325</span></a>
</span><span id="JitOutput-1326"><a href="#JitOutput-1326"><span class="linenos">1326</span></a>    <span class="k">def</span> <span class="fm">__call__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="JitOutput-1327"><a href="#JitOutput-1327"><span class="linenos">1327</span></a>        <span class="n">args</span><span class="p">,</span> <span class="n">in_tree</span> <span class="o">=</span> <span class="n">tree_flatten</span><span class="p">(</span><span class="n">args</span><span class="p">)</span>
</span><span id="JitOutput-1328"><a href="#JitOutput-1328"><span class="linenos">1328</span></a>        <span class="n">args</span> <span class="o">=</span> <span class="n">tree_map</span><span class="p">(</span><span class="k">lambda</span> <span class="n">a</span><span class="p">:</span> <span class="n">a</span><span class="o">.</span><span class="n">val</span> <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">a</span><span class="p">,</span> <span class="n">Tensor</span><span class="p">)</span> <span class="k">else</span> <span class="n">a</span><span class="p">,</span> <span class="n">args</span><span class="p">)</span>
</span><span id="JitOutput-1329"><a href="#JitOutput-1329"><span class="linenos">1329</span></a>        <span class="k">try</span><span class="p">:</span>
</span><span id="JitOutput-1330"><a href="#JitOutput-1330"><span class="linenos">1330</span></a>            <span class="n">outs</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">fn</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)</span>
</span><span id="JitOutput-1331"><a href="#JitOutput-1331"><span class="linenos">1331</span></a>            <span class="k">if</span> <span class="ow">not</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">outs</span><span class="p">,</span> <span class="nb">tuple</span><span class="p">):</span>  <span class="c1"># TODO: IREE FunctionInvoker destructure 1-tuple, need to undo</span>
</span><span id="JitOutput-1332"><a href="#JitOutput-1332"><span class="linenos">1332</span></a>                <span class="n">outs</span> <span class="o">=</span> <span class="p">(</span><span class="n">outs</span><span class="p">,)</span>
</span><span id="JitOutput-1333"><a href="#JitOutput-1333"><span class="linenos">1333</span></a>        <span class="k">except</span> <span class="ne">Exception</span> <span class="k">as</span> <span class="n">e</span><span class="p">:</span>
</span><span id="JitOutput-1334"><a href="#JitOutput-1334"><span class="linenos">1334</span></a>            <span class="n">dblog</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">code</span><span class="p">,</span> <span class="n">enable</span><span class="o">=</span><span class="n">backend</span><span class="o">.</span><span class="n">LOG_JIT</span><span class="p">)</span>
</span><span id="JitOutput-1335"><a href="#JitOutput-1335"><span class="linenos">1335</span></a>            <span class="k">raise</span>
</span><span id="JitOutput-1336"><a href="#JitOutput-1336"><span class="linenos">1336</span></a>        <span class="k">return</span> <span class="p">[</span><span class="n">backend</span><span class="o">.</span><span class="n">tensor</span><span class="p">(</span><span class="n">TensorBuffer</span><span class="p">(</span><span class="n">o</span><span class="p">))</span> <span class="k">for</span> <span class="n">o</span> <span class="ow">in</span> <span class="n">outs</span><span class="p">]</span>
</span></pre></div>


    

                            <div id="JitOutput.__init__" class="classattr">
                                        <input id="JitOutput.__init__-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="name">JitOutput</span><span class="signature pdoc-code multiline">(<span class="param">	<span class="n">program</span><span class="p">:</span> <span class="n"><a href="#Program">Program</a></span>,</span><span class="param">	<span class="n">codegen_output</span><span class="p">:</span> <span class="n"><a href="#CodegenOutput">CodegenOutput</a></span>,</span><span class="param">	<span class="n">fn</span>,</span><span class="param">	<span class="n">code</span><span class="p">:</span> <span class="nb">str</span>,</span><span class="param">	<span class="n">consts</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">]</span></span>)</span>

                <label class="view-source-button" for="JitOutput.__init__-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#JitOutput.__init__"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="JitOutput.__init__-1318"><a href="#JitOutput.__init__-1318"><span class="linenos">1318</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">program</span><span class="p">:</span> <span class="n">Program</span><span class="p">,</span> <span class="n">codegen_output</span><span class="p">:</span> <span class="n">CodegenOutput</span><span class="p">,</span> <span class="n">fn</span><span class="p">,</span> <span class="n">code</span><span class="p">:</span> <span class="nb">str</span><span class="p">,</span> <span class="n">consts</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">]):</span>
</span><span id="JitOutput.__init__-1319"><a href="#JitOutput.__init__-1319"><span class="linenos">1319</span></a>        <span class="nb">super</span><span class="p">()</span><span class="o">.</span><span class="fm">__init__</span><span class="p">()</span>
</span><span id="JitOutput.__init__-1320"><a href="#JitOutput.__init__-1320"><span class="linenos">1320</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">program</span> <span class="o">=</span> <span class="n">program</span>
</span><span id="JitOutput.__init__-1321"><a href="#JitOutput.__init__-1321"><span class="linenos">1321</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">code</span> <span class="o">=</span> <span class="n">code</span>
</span><span id="JitOutput.__init__-1322"><a href="#JitOutput.__init__-1322"><span class="linenos">1322</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">codegen_output</span> <span class="o">=</span> <span class="n">codegen_output</span>
</span><span id="JitOutput.__init__-1323"><a href="#JitOutput.__init__-1323"><span class="linenos">1323</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">fn</span><span class="p">:</span> <span class="n">Callable</span> <span class="o">=</span> <span class="n">fn</span>
</span><span id="JitOutput.__init__-1324"><a href="#JitOutput.__init__-1324"><span class="linenos">1324</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">consts</span> <span class="o">=</span> <span class="n">consts</span>
</span></pre></div>


    

                            </div>
                            <div id="JitOutput.program" class="classattr">
                                <div class="attr variable">
            <span class="name">program</span>

        
    </div>
    <a class="headerlink" href="#JitOutput.program"></a>
    
    

                            </div>
                            <div id="JitOutput.code" class="classattr">
                                <div class="attr variable">
            <span class="name">code</span>

        
    </div>
    <a class="headerlink" href="#JitOutput.code"></a>
    
    

                            </div>
                            <div id="JitOutput.codegen_output" class="classattr">
                                <div class="attr variable">
            <span class="name">codegen_output</span>

        
    </div>
    <a class="headerlink" href="#JitOutput.codegen_output"></a>
    
    

                            </div>
                            <div id="JitOutput.fn" class="classattr">
                                <div class="attr variable">
            <span class="name">fn</span><span class="annotation">: Callable</span>

        
    </div>
    <a class="headerlink" href="#JitOutput.fn"></a>
    
    

                            </div>
                            <div id="JitOutput.consts" class="classattr">
                                <div class="attr variable">
            <span class="name">consts</span>

        
    </div>
    <a class="headerlink" href="#JitOutput.consts"></a>
    
    

                            </div>
                </section>
                <section id="JitOp">
                            <input id="JitOp-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr class">
            
    <span class="def">class</span>
    <span class="name">JitOp</span><wbr>(<span class="base"><a href="#MetaOperator">MetaOperator</a></span>):

                <label class="view-source-button" for="JitOp-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#JitOp"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="JitOp-1339"><a href="#JitOp-1339"><span class="linenos">1339</span></a><span class="k">class</span> <span class="nc">JitOp</span><span class="p">(</span><span class="n">MetaOperator</span><span class="p">):</span>
</span><span id="JitOp-1340"><a href="#JitOp-1340"><span class="linenos">1340</span></a>    <span class="k">def</span> <span class="nf">meta_impl</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="n">program</span><span class="p">:</span> <span class="n">Program</span><span class="p">,</span> <span class="o">**</span><span class="n">_</span><span class="p">):</span>
</span><span id="JitOp-1341"><a href="#JitOp-1341"><span class="linenos">1341</span></a>        <span class="n">hashed_program</span> <span class="o">=</span> <span class="n">Hashed</span><span class="p">(</span><span class="n">program</span><span class="p">)</span>
</span><span id="JitOp-1342"><a href="#JitOp-1342"><span class="linenos">1342</span></a>        <span class="n">num_consts</span> <span class="o">=</span> <span class="n">program</span><span class="o">.</span><span class="n">num_consts</span>
</span><span id="JitOp-1343"><a href="#JitOp-1343"><span class="linenos">1343</span></a>        <span class="n">consts</span><span class="p">,</span> <span class="n">args</span> <span class="o">=</span> <span class="n">args</span><span class="p">[:</span><span class="n">num_consts</span><span class="p">],</span> <span class="n">args</span><span class="p">[</span><span class="n">num_consts</span><span class="p">:]</span>
</span><span id="JitOp-1344"><a href="#JitOp-1344"><span class="linenos">1344</span></a>        <span class="n">hashed_consts</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="nb">map</span><span class="p">(</span><span class="n">Hashed</span><span class="p">,</span> <span class="n">consts</span><span class="p">))</span>
</span><span id="JitOp-1345"><a href="#JitOp-1345"><span class="linenos">1345</span></a>        <span class="n">jit_output</span> <span class="o">=</span> <span class="n">backend</span><span class="o">.</span><span class="n">jit_program</span><span class="p">(</span><span class="n">hashed_program</span><span class="p">,</span> <span class="n">hashed_consts</span><span class="p">)</span>
</span><span id="JitOp-1346"><a href="#JitOp-1346"><span class="linenos">1346</span></a>        <span class="n">ret</span> <span class="o">=</span> <span class="n">jit_output</span><span class="p">(</span><span class="o">*</span><span class="n">consts</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">)</span>
</span><span id="JitOp-1347"><a href="#JitOp-1347"><span class="linenos">1347</span></a>        <span class="k">return</span> <span class="n">ret</span>
</span><span id="JitOp-1348"><a href="#JitOp-1348"><span class="linenos">1348</span></a>
</span><span id="JitOp-1349"><a href="#JitOp-1349"><span class="linenos">1349</span></a>    <span class="k">def</span> <span class="nf">reorg_args</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">args</span><span class="p">,</span> <span class="n">params</span><span class="p">):</span>
</span><span id="JitOp-1350"><a href="#JitOp-1350"><span class="linenos">1350</span></a>        <span class="k">return</span> <span class="n">args</span><span class="p">,</span> <span class="n">params</span>
</span><span id="JitOp-1351"><a href="#JitOp-1351"><span class="linenos">1351</span></a>
</span><span id="JitOp-1352"><a href="#JitOp-1352"><span class="linenos">1352</span></a>    <span class="k">def</span> <span class="nf">typecheck</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="n">in_types</span><span class="p">,</span> <span class="n">program</span><span class="p">:</span> <span class="n">Program</span><span class="p">):</span>
</span><span id="JitOp-1353"><a href="#JitOp-1353"><span class="linenos">1353</span></a>        <span class="n">program_type</span> <span class="o">=</span> <span class="n">typecheck_program</span><span class="p">(</span><span class="n">program</span><span class="p">)</span>
</span><span id="JitOp-1354"><a href="#JitOp-1354"><span class="linenos">1354</span></a>        <span class="k">if</span> <span class="ow">not</span> <span class="nb">all</span><span class="p">(</span><span class="n">t1</span> <span class="o">==</span> <span class="n">t2</span> <span class="k">for</span> <span class="n">t1</span><span class="p">,</span> <span class="n">t2</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">program_type</span><span class="o">.</span><span class="n">in_types</span><span class="p">,</span> <span class="n">in_types</span><span class="p">)):</span>
</span><span id="JitOp-1355"><a href="#JitOp-1355"><span class="linenos">1355</span></a>            <span class="n">ret</span> <span class="o">=</span> <span class="s2">&quot;Type mismatch program.in_types vs in_types:</span><span class="se">\n</span><span class="s2">&quot;</span>
</span><span id="JitOp-1356"><a href="#JitOp-1356"><span class="linenos">1356</span></a>            <span class="k">for</span> <span class="n">i</span><span class="p">,</span> <span class="n">j</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">program_type</span><span class="o">.</span><span class="n">in_types</span><span class="p">,</span> <span class="n">in_types</span><span class="p">):</span>
</span><span id="JitOp-1357"><a href="#JitOp-1357"><span class="linenos">1357</span></a>                <span class="n">ret</span> <span class="o">+=</span> <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">i</span><span class="si">}</span><span class="s2">, </span><span class="si">{</span><span class="n">j</span><span class="si">}</span><span class="s2">, </span><span class="si">{</span><span class="n">i</span><span class="w"> </span><span class="o">==</span><span class="w"> </span><span class="n">j</span><span class="si">}</span><span class="s2">&quot;</span>
</span><span id="JitOp-1358"><a href="#JitOp-1358"><span class="linenos">1358</span></a>            <span class="k">raise</span> <span class="ne">TypeError</span><span class="p">(</span><span class="n">ret</span><span class="p">)</span>
</span><span id="JitOp-1359"><a href="#JitOp-1359"><span class="linenos">1359</span></a>        <span class="k">return</span> <span class="n">program_type</span><span class="o">.</span><span class="n">out_types</span>
</span><span id="JitOp-1360"><a href="#JitOp-1360"><span class="linenos">1360</span></a>
</span><span id="JitOp-1361"><a href="#JitOp-1361"><span class="linenos">1361</span></a>    <span class="k">def</span> <span class="nf">vmap</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">dim_size</span><span class="p">,</span> <span class="n">vals_in</span><span class="p">,</span> <span class="n">dims_in</span><span class="p">,</span> <span class="n">program</span><span class="p">:</span> <span class="n">Program</span><span class="p">):</span>
</span><span id="JitOp-1362"><a href="#JitOp-1362"><span class="linenos">1362</span></a>        <span class="n">program</span><span class="p">,</span> <span class="n">consts</span> <span class="o">=</span> <span class="n">vmap_program</span><span class="p">(</span><span class="n">program</span><span class="p">,</span> <span class="n">dim_size</span><span class="p">,</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">dims_in</span><span class="p">))</span>
</span><span id="JitOp-1363"><a href="#JitOp-1363"><span class="linenos">1363</span></a>        <span class="n">outs</span> <span class="o">=</span> <span class="bp">self</span><span class="p">(</span><span class="o">*</span><span class="n">consts</span><span class="p">,</span> <span class="o">*</span><span class="n">vals_in</span><span class="p">,</span> <span class="n">program</span><span class="o">=</span><span class="n">program</span><span class="p">)</span>
</span><span id="JitOp-1364"><a href="#JitOp-1364"><span class="linenos">1364</span></a>        <span class="k">if</span> <span class="ow">not</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">outs</span><span class="p">,</span> <span class="nb">tuple</span><span class="p">):</span>
</span><span id="JitOp-1365"><a href="#JitOp-1365"><span class="linenos">1365</span></a>            <span class="n">outs</span> <span class="o">=</span> <span class="p">(</span><span class="n">outs</span><span class="p">,)</span>
</span><span id="JitOp-1366"><a href="#JitOp-1366"><span class="linenos">1366</span></a>        <span class="k">return</span> <span class="n">outs</span><span class="p">,</span> <span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="o">*</span> <span class="nb">len</span><span class="p">(</span><span class="n">outs</span><span class="p">)</span>
</span><span id="JitOp-1367"><a href="#JitOp-1367"><span class="linenos">1367</span></a>
</span><span id="JitOp-1368"><a href="#JitOp-1368"><span class="linenos">1368</span></a>    <span class="k">def</span> <span class="nf">jvp</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">primals</span><span class="p">,</span> <span class="n">tangents</span><span class="p">,</span> <span class="o">*</span><span class="p">,</span> <span class="n">program</span><span class="p">):</span>
</span><span id="JitOp-1369"><a href="#JitOp-1369"><span class="linenos">1369</span></a>        <span class="n">new_program</span><span class="p">,</span> <span class="n">new_consts</span> <span class="o">=</span> <span class="n">jvp_program</span><span class="p">(</span><span class="n">program</span><span class="p">)</span>
</span><span id="JitOp-1370"><a href="#JitOp-1370"><span class="linenos">1370</span></a>        <span class="n">outs</span> <span class="o">=</span> <span class="n">bind</span><span class="p">(</span>
</span><span id="JitOp-1371"><a href="#JitOp-1371"><span class="linenos">1371</span></a>            <span class="bp">self</span><span class="p">,</span>
</span><span id="JitOp-1372"><a href="#JitOp-1372"><span class="linenos">1372</span></a>            <span class="o">*</span><span class="n">new_consts</span><span class="p">,</span>
</span><span id="JitOp-1373"><a href="#JitOp-1373"><span class="linenos">1373</span></a>            <span class="o">*</span><span class="n">primals</span><span class="p">,</span>
</span><span id="JitOp-1374"><a href="#JitOp-1374"><span class="linenos">1374</span></a>            <span class="o">*</span><span class="n">tangents</span><span class="p">,</span>
</span><span id="JitOp-1375"><a href="#JitOp-1375"><span class="linenos">1375</span></a>            <span class="n">program</span><span class="o">=</span><span class="n">new_program</span><span class="p">,</span>
</span><span id="JitOp-1376"><a href="#JitOp-1376"><span class="linenos">1376</span></a>        <span class="p">)</span>
</span><span id="JitOp-1377"><a href="#JitOp-1377"><span class="linenos">1377</span></a>        <span class="n">n</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">outs</span><span class="p">)</span> <span class="o">//</span> <span class="mi">2</span>
</span><span id="JitOp-1378"><a href="#JitOp-1378"><span class="linenos">1378</span></a>        <span class="n">primals_out</span><span class="p">,</span> <span class="n">tangents_out</span> <span class="o">=</span> <span class="n">outs</span><span class="p">[:</span><span class="n">n</span><span class="p">],</span> <span class="n">outs</span><span class="p">[</span><span class="n">n</span><span class="p">:]</span>
</span><span id="JitOp-1379"><a href="#JitOp-1379"><span class="linenos">1379</span></a>        <span class="k">return</span> <span class="n">primals_out</span><span class="p">,</span> <span class="n">tangents_out</span>
</span><span id="JitOp-1380"><a href="#JitOp-1380"><span class="linenos">1380</span></a>
</span><span id="JitOp-1381"><a href="#JitOp-1381"><span class="linenos">1381</span></a>    <span class="k">def</span> <span class="nf">T</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">cotangents</span><span class="p">,</span> <span class="o">*</span><span class="n">invals</span><span class="p">,</span> <span class="n">program</span><span class="p">):</span>
</span><span id="JitOp-1382"><a href="#JitOp-1382"><span class="linenos">1382</span></a>        <span class="n">undef_primals</span> <span class="o">=</span> <span class="p">[</span><span class="nb">isinstance</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">UndefinedPrimal</span><span class="p">)</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">invals</span><span class="p">]</span>
</span><span id="JitOp-1383"><a href="#JitOp-1383"><span class="linenos">1383</span></a>        <span class="n">transposed_program</span><span class="p">,</span> <span class="n">new_consts</span> <span class="o">=</span> <span class="n">transpose_program</span><span class="p">(</span><span class="n">program</span><span class="p">,</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">undef_primals</span><span class="p">))</span>
</span><span id="JitOp-1384"><a href="#JitOp-1384"><span class="linenos">1384</span></a>
</span><span id="JitOp-1385"><a href="#JitOp-1385"><span class="linenos">1385</span></a>        <span class="n">residuals</span><span class="p">,</span> <span class="n">_</span> <span class="o">=</span> <span class="n">partition_list</span><span class="p">(</span><span class="n">undef_primals</span><span class="p">,</span> <span class="n">invals</span><span class="p">)</span>
</span><span id="JitOp-1386"><a href="#JitOp-1386"><span class="linenos">1386</span></a>        <span class="n">outs</span> <span class="o">=</span> <span class="n">bind</span><span class="p">(</span>
</span><span id="JitOp-1387"><a href="#JitOp-1387"><span class="linenos">1387</span></a>            <span class="bp">self</span><span class="p">,</span>
</span><span id="JitOp-1388"><a href="#JitOp-1388"><span class="linenos">1388</span></a>            <span class="o">*</span><span class="n">new_consts</span><span class="p">,</span>
</span><span id="JitOp-1389"><a href="#JitOp-1389"><span class="linenos">1389</span></a>            <span class="o">*</span><span class="n">residuals</span><span class="p">,</span>
</span><span id="JitOp-1390"><a href="#JitOp-1390"><span class="linenos">1390</span></a>            <span class="o">*</span><span class="n">cotangents</span><span class="p">,</span>
</span><span id="JitOp-1391"><a href="#JitOp-1391"><span class="linenos">1391</span></a>            <span class="n">program</span><span class="o">=</span><span class="n">transposed_program</span><span class="p">,</span>
</span><span id="JitOp-1392"><a href="#JitOp-1392"><span class="linenos">1392</span></a>        <span class="p">)</span>
</span><span id="JitOp-1393"><a href="#JitOp-1393"><span class="linenos">1393</span></a>        <span class="n">outs</span> <span class="o">=</span> <span class="nb">iter</span><span class="p">(</span><span class="n">outs</span><span class="p">)</span>
</span><span id="JitOp-1394"><a href="#JitOp-1394"><span class="linenos">1394</span></a>
</span><span id="JitOp-1395"><a href="#JitOp-1395"><span class="linenos">1395</span></a>        <span class="k">return</span> <span class="p">[</span><span class="nb">next</span><span class="p">(</span><span class="n">outs</span><span class="p">)</span> <span class="k">if</span> <span class="n">undef</span> <span class="k">else</span> <span class="kc">None</span> <span class="k">for</span> <span class="n">undef</span> <span class="ow">in</span> <span class="n">undef_primals</span><span class="p">]</span>
</span><span id="JitOp-1396"><a href="#JitOp-1396"><span class="linenos">1396</span></a>
</span><span id="JitOp-1397"><a href="#JitOp-1397"><span class="linenos">1397</span></a>    <span class="k">def</span> <span class="nf">partial_run</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">trace</span><span class="p">,</span> <span class="n">tracers</span><span class="p">,</span> <span class="o">*</span><span class="p">,</span> <span class="n">program</span><span class="p">):</span>
</span><span id="JitOp-1398"><a href="#JitOp-1398"><span class="linenos">1398</span></a>        <span class="n">in_unknowns</span> <span class="o">=</span> <span class="p">[</span><span class="ow">not</span> <span class="n">t</span><span class="o">.</span><span class="n">pval</span><span class="o">.</span><span class="n">is_known</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">tracers</span><span class="p">]</span>
</span><span id="JitOp-1399"><a href="#JitOp-1399"><span class="linenos">1399</span></a>        <span class="n">program1</span><span class="p">,</span> <span class="n">program2</span><span class="p">,</span> <span class="n">out_unknowns</span><span class="p">,</span> <span class="n">num_res</span> <span class="o">=</span> <span class="n">partial_run_program</span><span class="p">(</span><span class="n">program</span><span class="p">,</span> <span class="n">in_unknowns</span><span class="p">)</span>
</span><span id="JitOp-1400"><a href="#JitOp-1400"><span class="linenos">1400</span></a>        <span class="n">known_tracers</span><span class="p">,</span> <span class="n">unknown_tracers</span> <span class="o">=</span> <span class="n">partition_list</span><span class="p">(</span><span class="n">in_unknowns</span><span class="p">,</span> <span class="n">tracers</span><span class="p">)</span>
</span><span id="JitOp-1401"><a href="#JitOp-1401"><span class="linenos">1401</span></a>        <span class="n">known_vals</span> <span class="o">=</span> <span class="p">[</span><span class="n">t</span><span class="o">.</span><span class="n">pval</span><span class="o">.</span><span class="n">const</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">known_tracers</span><span class="p">]</span>
</span><span id="JitOp-1402"><a href="#JitOp-1402"><span class="linenos">1402</span></a>        <span class="n">outs1_res</span> <span class="o">=</span> <span class="n">bind</span><span class="p">(</span><span class="n">backend</span><span class="o">.</span><span class="n">jit_op</span><span class="p">,</span> <span class="o">*</span><span class="n">known_vals</span><span class="p">,</span> <span class="n">program</span><span class="o">=</span><span class="n">program1</span><span class="p">)</span>
</span><span id="JitOp-1403"><a href="#JitOp-1403"><span class="linenos">1403</span></a>        <span class="n">outs1</span><span class="p">,</span> <span class="n">res</span> <span class="o">=</span> <span class="n">split_list</span><span class="p">(</span><span class="n">outs1_res</span><span class="p">,</span> <span class="nb">len</span><span class="p">(</span><span class="n">program1</span><span class="o">.</span><span class="n">outs</span><span class="p">)</span> <span class="o">-</span> <span class="n">num_res</span><span class="p">)</span>
</span><span id="JitOp-1404"><a href="#JitOp-1404"><span class="linenos">1404</span></a>        <span class="n">res_tracers</span> <span class="o">=</span> <span class="p">[</span><span class="n">trace</span><span class="o">.</span><span class="n">instantiate_const</span><span class="p">(</span><span class="n">full_raise</span><span class="p">(</span><span class="n">trace</span><span class="p">,</span> <span class="n">x</span><span class="p">))</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">res</span><span class="p">]</span>
</span><span id="JitOp-1405"><a href="#JitOp-1405"><span class="linenos">1405</span></a>        <span class="n">outs2</span> <span class="o">=</span> <span class="p">[</span><span class="n">PartialRunTraceTensor</span><span class="p">(</span><span class="n">trace</span><span class="p">,</span> <span class="n">make_unknown_pval</span><span class="p">(</span><span class="n">v</span><span class="o">.</span><span class="n">symval</span><span class="p">),</span> <span class="kc">None</span><span class="p">)</span> <span class="k">for</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">program2</span><span class="o">.</span><span class="n">outs</span><span class="p">]</span>
</span><span id="JitOp-1406"><a href="#JitOp-1406"><span class="linenos">1406</span></a>        <span class="n">instruction</span> <span class="o">=</span> <span class="n">InstructionDraft</span><span class="p">(</span>
</span><span id="JitOp-1407"><a href="#JitOp-1407"><span class="linenos">1407</span></a>            <span class="bp">self</span><span class="p">,</span>
</span><span id="JitOp-1408"><a href="#JitOp-1408"><span class="linenos">1408</span></a>            <span class="n">res_tracers</span> <span class="o">+</span> <span class="n">unknown_tracers</span><span class="p">,</span>
</span><span id="JitOp-1409"><a href="#JitOp-1409"><span class="linenos">1409</span></a>            <span class="nb">dict</span><span class="p">(</span><span class="n">program</span><span class="o">=</span><span class="n">program2</span><span class="p">),</span>
</span><span id="JitOp-1410"><a href="#JitOp-1410"><span class="linenos">1410</span></a>            <span class="p">[</span><span class="n">v</span><span class="o">.</span><span class="n">symval</span> <span class="k">for</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">program2</span><span class="o">.</span><span class="n">outs</span><span class="p">],</span>
</span><span id="JitOp-1411"><a href="#JitOp-1411"><span class="linenos">1411</span></a>            <span class="n">list_map</span><span class="p">(</span><span class="n">weakref</span><span class="o">.</span><span class="n">ref</span><span class="p">,</span> <span class="n">outs2</span><span class="p">),</span>
</span><span id="JitOp-1412"><a href="#JitOp-1412"><span class="linenos">1412</span></a>        <span class="p">)</span>
</span><span id="JitOp-1413"><a href="#JitOp-1413"><span class="linenos">1413</span></a>        <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">outs2</span><span class="p">:</span>
</span><span id="JitOp-1414"><a href="#JitOp-1414"><span class="linenos">1414</span></a>            <span class="n">t</span><span class="o">.</span><span class="n">draft</span> <span class="o">=</span> <span class="n">instruction</span>
</span><span id="JitOp-1415"><a href="#JitOp-1415"><span class="linenos">1415</span></a>
</span><span id="JitOp-1416"><a href="#JitOp-1416"><span class="linenos">1416</span></a>        <span class="k">return</span> <span class="n">merge_lists</span><span class="p">(</span><span class="n">out_unknowns</span><span class="p">,</span> <span class="n">outs1</span><span class="p">,</span> <span class="n">outs2</span><span class="p">)</span>
</span><span id="JitOp-1417"><a href="#JitOp-1417"><span class="linenos">1417</span></a>
</span><span id="JitOp-1418"><a href="#JitOp-1418"><span class="linenos">1418</span></a>    <span class="k">def</span> <span class="nf">partial_run_instruction</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">unks_in</span><span class="p">,</span> <span class="n">instruction</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Tuple</span><span class="p">[</span><span class="n">Instruction</span><span class="p">,</span> <span class="n">Instruction</span><span class="p">,</span> <span class="n">List</span><span class="p">[</span><span class="nb">bool</span><span class="p">],</span> <span class="n">List</span><span class="p">[</span><span class="n">Var</span><span class="p">]]:</span>
</span><span id="JitOp-1419"><a href="#JitOp-1419"><span class="linenos">1419</span></a>        <span class="n">program</span> <span class="o">=</span> <span class="n">instruction</span><span class="o">.</span><span class="n">params</span><span class="p">[</span><span class="s2">&quot;program&quot;</span><span class="p">]</span>
</span><span id="JitOp-1420"><a href="#JitOp-1420"><span class="linenos">1420</span></a>        <span class="n">program1</span><span class="p">,</span> <span class="n">program2</span><span class="p">,</span> <span class="n">out_unknowns</span><span class="p">,</span> <span class="n">num_res</span> <span class="o">=</span> <span class="n">partial_run_program</span><span class="p">(</span><span class="n">program</span><span class="p">,</span> <span class="n">unks_in</span><span class="p">)</span>
</span><span id="JitOp-1421"><a href="#JitOp-1421"><span class="linenos">1421</span></a>        <span class="n">ins1</span><span class="p">,</span> <span class="n">ins2</span> <span class="o">=</span> <span class="n">partition_list</span><span class="p">(</span><span class="n">unks_in</span><span class="p">,</span> <span class="n">instruction</span><span class="o">.</span><span class="n">inputs</span><span class="p">)</span>
</span><span id="JitOp-1422"><a href="#JitOp-1422"><span class="linenos">1422</span></a>        <span class="n">out_binders1</span><span class="p">,</span> <span class="n">out_binders2</span> <span class="o">=</span> <span class="n">partition_list</span><span class="p">(</span><span class="n">out_unknowns</span><span class="p">,</span> <span class="n">instruction</span><span class="o">.</span><span class="n">out_binders</span><span class="p">)</span>
</span><span id="JitOp-1423"><a href="#JitOp-1423"><span class="linenos">1423</span></a>        <span class="n">res</span> <span class="o">=</span> <span class="p">[</span><span class="n">Var</span><span class="p">(</span><span class="n">v</span><span class="o">.</span><span class="n">symval</span><span class="p">)</span> <span class="k">for</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">program2</span><span class="o">.</span><span class="n">in_binders</span><span class="p">[:</span><span class="n">num_res</span><span class="p">]]</span>
</span><span id="JitOp-1424"><a href="#JitOp-1424"><span class="linenos">1424</span></a>        <span class="n">instruction1</span> <span class="o">=</span> <span class="n">Instruction</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">ins1</span><span class="p">,</span> <span class="nb">dict</span><span class="p">(</span><span class="n">program</span><span class="o">=</span><span class="n">program1</span><span class="p">),</span> <span class="n">out_binders1</span> <span class="o">+</span> <span class="n">res</span><span class="p">)</span>
</span><span id="JitOp-1425"><a href="#JitOp-1425"><span class="linenos">1425</span></a>        <span class="n">instruction2</span> <span class="o">=</span> <span class="n">Instruction</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">res</span> <span class="o">+</span> <span class="n">ins2</span><span class="p">,</span> <span class="nb">dict</span><span class="p">(</span><span class="n">program</span><span class="o">=</span><span class="n">program2</span><span class="p">),</span> <span class="n">out_binders2</span><span class="p">)</span>
</span><span id="JitOp-1426"><a href="#JitOp-1426"><span class="linenos">1426</span></a>        <span class="k">return</span> <span class="n">instruction1</span><span class="p">,</span> <span class="n">instruction2</span><span class="p">,</span> <span class="n">out_unknowns</span><span class="p">,</span> <span class="n">res</span>
</span></pre></div>


    

                            <div id="JitOp.meta_impl" class="classattr">
                                        <input id="JitOp.meta_impl-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">meta_impl</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="o">*</span><span class="n">args</span>, </span><span class="param"><span class="n">program</span><span class="p">:</span> <span class="n"><a href="#Program">Program</a></span>, </span><span class="param"><span class="o">**</span><span class="n">_</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="JitOp.meta_impl-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#JitOp.meta_impl"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="JitOp.meta_impl-1340"><a href="#JitOp.meta_impl-1340"><span class="linenos">1340</span></a>    <span class="k">def</span> <span class="nf">meta_impl</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="n">program</span><span class="p">:</span> <span class="n">Program</span><span class="p">,</span> <span class="o">**</span><span class="n">_</span><span class="p">):</span>
</span><span id="JitOp.meta_impl-1341"><a href="#JitOp.meta_impl-1341"><span class="linenos">1341</span></a>        <span class="n">hashed_program</span> <span class="o">=</span> <span class="n">Hashed</span><span class="p">(</span><span class="n">program</span><span class="p">)</span>
</span><span id="JitOp.meta_impl-1342"><a href="#JitOp.meta_impl-1342"><span class="linenos">1342</span></a>        <span class="n">num_consts</span> <span class="o">=</span> <span class="n">program</span><span class="o">.</span><span class="n">num_consts</span>
</span><span id="JitOp.meta_impl-1343"><a href="#JitOp.meta_impl-1343"><span class="linenos">1343</span></a>        <span class="n">consts</span><span class="p">,</span> <span class="n">args</span> <span class="o">=</span> <span class="n">args</span><span class="p">[:</span><span class="n">num_consts</span><span class="p">],</span> <span class="n">args</span><span class="p">[</span><span class="n">num_consts</span><span class="p">:]</span>
</span><span id="JitOp.meta_impl-1344"><a href="#JitOp.meta_impl-1344"><span class="linenos">1344</span></a>        <span class="n">hashed_consts</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="nb">map</span><span class="p">(</span><span class="n">Hashed</span><span class="p">,</span> <span class="n">consts</span><span class="p">))</span>
</span><span id="JitOp.meta_impl-1345"><a href="#JitOp.meta_impl-1345"><span class="linenos">1345</span></a>        <span class="n">jit_output</span> <span class="o">=</span> <span class="n">backend</span><span class="o">.</span><span class="n">jit_program</span><span class="p">(</span><span class="n">hashed_program</span><span class="p">,</span> <span class="n">hashed_consts</span><span class="p">)</span>
</span><span id="JitOp.meta_impl-1346"><a href="#JitOp.meta_impl-1346"><span class="linenos">1346</span></a>        <span class="n">ret</span> <span class="o">=</span> <span class="n">jit_output</span><span class="p">(</span><span class="o">*</span><span class="n">consts</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">)</span>
</span><span id="JitOp.meta_impl-1347"><a href="#JitOp.meta_impl-1347"><span class="linenos">1347</span></a>        <span class="k">return</span> <span class="n">ret</span>
</span></pre></div>


    

                            </div>
                            <div id="JitOp.reorg_args" class="classattr">
                                        <input id="JitOp.reorg_args-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">reorg_args</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="n">args</span>, </span><span class="param"><span class="n">params</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="JitOp.reorg_args-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#JitOp.reorg_args"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="JitOp.reorg_args-1349"><a href="#JitOp.reorg_args-1349"><span class="linenos">1349</span></a>    <span class="k">def</span> <span class="nf">reorg_args</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">args</span><span class="p">,</span> <span class="n">params</span><span class="p">):</span>
</span><span id="JitOp.reorg_args-1350"><a href="#JitOp.reorg_args-1350"><span class="linenos">1350</span></a>        <span class="k">return</span> <span class="n">args</span><span class="p">,</span> <span class="n">params</span>
</span></pre></div>


    

                            </div>
                            <div id="JitOp.typecheck" class="classattr">
                                        <input id="JitOp.typecheck-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">typecheck</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="o">*</span><span class="n">in_types</span>, </span><span class="param"><span class="n">program</span><span class="p">:</span> <span class="n"><a href="#Program">Program</a></span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="JitOp.typecheck-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#JitOp.typecheck"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="JitOp.typecheck-1352"><a href="#JitOp.typecheck-1352"><span class="linenos">1352</span></a>    <span class="k">def</span> <span class="nf">typecheck</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="n">in_types</span><span class="p">,</span> <span class="n">program</span><span class="p">:</span> <span class="n">Program</span><span class="p">):</span>
</span><span id="JitOp.typecheck-1353"><a href="#JitOp.typecheck-1353"><span class="linenos">1353</span></a>        <span class="n">program_type</span> <span class="o">=</span> <span class="n">typecheck_program</span><span class="p">(</span><span class="n">program</span><span class="p">)</span>
</span><span id="JitOp.typecheck-1354"><a href="#JitOp.typecheck-1354"><span class="linenos">1354</span></a>        <span class="k">if</span> <span class="ow">not</span> <span class="nb">all</span><span class="p">(</span><span class="n">t1</span> <span class="o">==</span> <span class="n">t2</span> <span class="k">for</span> <span class="n">t1</span><span class="p">,</span> <span class="n">t2</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">program_type</span><span class="o">.</span><span class="n">in_types</span><span class="p">,</span> <span class="n">in_types</span><span class="p">)):</span>
</span><span id="JitOp.typecheck-1355"><a href="#JitOp.typecheck-1355"><span class="linenos">1355</span></a>            <span class="n">ret</span> <span class="o">=</span> <span class="s2">&quot;Type mismatch program.in_types vs in_types:</span><span class="se">\n</span><span class="s2">&quot;</span>
</span><span id="JitOp.typecheck-1356"><a href="#JitOp.typecheck-1356"><span class="linenos">1356</span></a>            <span class="k">for</span> <span class="n">i</span><span class="p">,</span> <span class="n">j</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">program_type</span><span class="o">.</span><span class="n">in_types</span><span class="p">,</span> <span class="n">in_types</span><span class="p">):</span>
</span><span id="JitOp.typecheck-1357"><a href="#JitOp.typecheck-1357"><span class="linenos">1357</span></a>                <span class="n">ret</span> <span class="o">+=</span> <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">i</span><span class="si">}</span><span class="s2">, </span><span class="si">{</span><span class="n">j</span><span class="si">}</span><span class="s2">, </span><span class="si">{</span><span class="n">i</span><span class="w"> </span><span class="o">==</span><span class="w"> </span><span class="n">j</span><span class="si">}</span><span class="s2">&quot;</span>
</span><span id="JitOp.typecheck-1358"><a href="#JitOp.typecheck-1358"><span class="linenos">1358</span></a>            <span class="k">raise</span> <span class="ne">TypeError</span><span class="p">(</span><span class="n">ret</span><span class="p">)</span>
</span><span id="JitOp.typecheck-1359"><a href="#JitOp.typecheck-1359"><span class="linenos">1359</span></a>        <span class="k">return</span> <span class="n">program_type</span><span class="o">.</span><span class="n">out_types</span>
</span></pre></div>


    

                            </div>
                            <div id="JitOp.vmap" class="classattr">
                                        <input id="JitOp.vmap-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">vmap</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="n">dim_size</span>, </span><span class="param"><span class="n">vals_in</span>, </span><span class="param"><span class="n">dims_in</span>, </span><span class="param"><span class="n">program</span><span class="p">:</span> <span class="n"><a href="#Program">Program</a></span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="JitOp.vmap-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#JitOp.vmap"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="JitOp.vmap-1361"><a href="#JitOp.vmap-1361"><span class="linenos">1361</span></a>    <span class="k">def</span> <span class="nf">vmap</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">dim_size</span><span class="p">,</span> <span class="n">vals_in</span><span class="p">,</span> <span class="n">dims_in</span><span class="p">,</span> <span class="n">program</span><span class="p">:</span> <span class="n">Program</span><span class="p">):</span>
</span><span id="JitOp.vmap-1362"><a href="#JitOp.vmap-1362"><span class="linenos">1362</span></a>        <span class="n">program</span><span class="p">,</span> <span class="n">consts</span> <span class="o">=</span> <span class="n">vmap_program</span><span class="p">(</span><span class="n">program</span><span class="p">,</span> <span class="n">dim_size</span><span class="p">,</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">dims_in</span><span class="p">))</span>
</span><span id="JitOp.vmap-1363"><a href="#JitOp.vmap-1363"><span class="linenos">1363</span></a>        <span class="n">outs</span> <span class="o">=</span> <span class="bp">self</span><span class="p">(</span><span class="o">*</span><span class="n">consts</span><span class="p">,</span> <span class="o">*</span><span class="n">vals_in</span><span class="p">,</span> <span class="n">program</span><span class="o">=</span><span class="n">program</span><span class="p">)</span>
</span><span id="JitOp.vmap-1364"><a href="#JitOp.vmap-1364"><span class="linenos">1364</span></a>        <span class="k">if</span> <span class="ow">not</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">outs</span><span class="p">,</span> <span class="nb">tuple</span><span class="p">):</span>
</span><span id="JitOp.vmap-1365"><a href="#JitOp.vmap-1365"><span class="linenos">1365</span></a>            <span class="n">outs</span> <span class="o">=</span> <span class="p">(</span><span class="n">outs</span><span class="p">,)</span>
</span><span id="JitOp.vmap-1366"><a href="#JitOp.vmap-1366"><span class="linenos">1366</span></a>        <span class="k">return</span> <span class="n">outs</span><span class="p">,</span> <span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="o">*</span> <span class="nb">len</span><span class="p">(</span><span class="n">outs</span><span class="p">)</span>
</span></pre></div>


    

                            </div>
                            <div id="JitOp.jvp" class="classattr">
                                        <input id="JitOp.jvp-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">jvp</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="n">primals</span>, </span><span class="param"><span class="n">tangents</span>, </span><span class="param"><span class="o">*</span>, </span><span class="param"><span class="n">program</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="JitOp.jvp-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#JitOp.jvp"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="JitOp.jvp-1368"><a href="#JitOp.jvp-1368"><span class="linenos">1368</span></a>    <span class="k">def</span> <span class="nf">jvp</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">primals</span><span class="p">,</span> <span class="n">tangents</span><span class="p">,</span> <span class="o">*</span><span class="p">,</span> <span class="n">program</span><span class="p">):</span>
</span><span id="JitOp.jvp-1369"><a href="#JitOp.jvp-1369"><span class="linenos">1369</span></a>        <span class="n">new_program</span><span class="p">,</span> <span class="n">new_consts</span> <span class="o">=</span> <span class="n">jvp_program</span><span class="p">(</span><span class="n">program</span><span class="p">)</span>
</span><span id="JitOp.jvp-1370"><a href="#JitOp.jvp-1370"><span class="linenos">1370</span></a>        <span class="n">outs</span> <span class="o">=</span> <span class="n">bind</span><span class="p">(</span>
</span><span id="JitOp.jvp-1371"><a href="#JitOp.jvp-1371"><span class="linenos">1371</span></a>            <span class="bp">self</span><span class="p">,</span>
</span><span id="JitOp.jvp-1372"><a href="#JitOp.jvp-1372"><span class="linenos">1372</span></a>            <span class="o">*</span><span class="n">new_consts</span><span class="p">,</span>
</span><span id="JitOp.jvp-1373"><a href="#JitOp.jvp-1373"><span class="linenos">1373</span></a>            <span class="o">*</span><span class="n">primals</span><span class="p">,</span>
</span><span id="JitOp.jvp-1374"><a href="#JitOp.jvp-1374"><span class="linenos">1374</span></a>            <span class="o">*</span><span class="n">tangents</span><span class="p">,</span>
</span><span id="JitOp.jvp-1375"><a href="#JitOp.jvp-1375"><span class="linenos">1375</span></a>            <span class="n">program</span><span class="o">=</span><span class="n">new_program</span><span class="p">,</span>
</span><span id="JitOp.jvp-1376"><a href="#JitOp.jvp-1376"><span class="linenos">1376</span></a>        <span class="p">)</span>
</span><span id="JitOp.jvp-1377"><a href="#JitOp.jvp-1377"><span class="linenos">1377</span></a>        <span class="n">n</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">outs</span><span class="p">)</span> <span class="o">//</span> <span class="mi">2</span>
</span><span id="JitOp.jvp-1378"><a href="#JitOp.jvp-1378"><span class="linenos">1378</span></a>        <span class="n">primals_out</span><span class="p">,</span> <span class="n">tangents_out</span> <span class="o">=</span> <span class="n">outs</span><span class="p">[:</span><span class="n">n</span><span class="p">],</span> <span class="n">outs</span><span class="p">[</span><span class="n">n</span><span class="p">:]</span>
</span><span id="JitOp.jvp-1379"><a href="#JitOp.jvp-1379"><span class="linenos">1379</span></a>        <span class="k">return</span> <span class="n">primals_out</span><span class="p">,</span> <span class="n">tangents_out</span>
</span></pre></div>


    

                            </div>
                            <div id="JitOp.T" class="classattr">
                                        <input id="JitOp.T-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">T</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="n">cotangents</span>, </span><span class="param"><span class="o">*</span><span class="n">invals</span>, </span><span class="param"><span class="n">program</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="JitOp.T-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#JitOp.T"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="JitOp.T-1381"><a href="#JitOp.T-1381"><span class="linenos">1381</span></a>    <span class="k">def</span> <span class="nf">T</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">cotangents</span><span class="p">,</span> <span class="o">*</span><span class="n">invals</span><span class="p">,</span> <span class="n">program</span><span class="p">):</span>
</span><span id="JitOp.T-1382"><a href="#JitOp.T-1382"><span class="linenos">1382</span></a>        <span class="n">undef_primals</span> <span class="o">=</span> <span class="p">[</span><span class="nb">isinstance</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">UndefinedPrimal</span><span class="p">)</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">invals</span><span class="p">]</span>
</span><span id="JitOp.T-1383"><a href="#JitOp.T-1383"><span class="linenos">1383</span></a>        <span class="n">transposed_program</span><span class="p">,</span> <span class="n">new_consts</span> <span class="o">=</span> <span class="n">transpose_program</span><span class="p">(</span><span class="n">program</span><span class="p">,</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">undef_primals</span><span class="p">))</span>
</span><span id="JitOp.T-1384"><a href="#JitOp.T-1384"><span class="linenos">1384</span></a>
</span><span id="JitOp.T-1385"><a href="#JitOp.T-1385"><span class="linenos">1385</span></a>        <span class="n">residuals</span><span class="p">,</span> <span class="n">_</span> <span class="o">=</span> <span class="n">partition_list</span><span class="p">(</span><span class="n">undef_primals</span><span class="p">,</span> <span class="n">invals</span><span class="p">)</span>
</span><span id="JitOp.T-1386"><a href="#JitOp.T-1386"><span class="linenos">1386</span></a>        <span class="n">outs</span> <span class="o">=</span> <span class="n">bind</span><span class="p">(</span>
</span><span id="JitOp.T-1387"><a href="#JitOp.T-1387"><span class="linenos">1387</span></a>            <span class="bp">self</span><span class="p">,</span>
</span><span id="JitOp.T-1388"><a href="#JitOp.T-1388"><span class="linenos">1388</span></a>            <span class="o">*</span><span class="n">new_consts</span><span class="p">,</span>
</span><span id="JitOp.T-1389"><a href="#JitOp.T-1389"><span class="linenos">1389</span></a>            <span class="o">*</span><span class="n">residuals</span><span class="p">,</span>
</span><span id="JitOp.T-1390"><a href="#JitOp.T-1390"><span class="linenos">1390</span></a>            <span class="o">*</span><span class="n">cotangents</span><span class="p">,</span>
</span><span id="JitOp.T-1391"><a href="#JitOp.T-1391"><span class="linenos">1391</span></a>            <span class="n">program</span><span class="o">=</span><span class="n">transposed_program</span><span class="p">,</span>
</span><span id="JitOp.T-1392"><a href="#JitOp.T-1392"><span class="linenos">1392</span></a>        <span class="p">)</span>
</span><span id="JitOp.T-1393"><a href="#JitOp.T-1393"><span class="linenos">1393</span></a>        <span class="n">outs</span> <span class="o">=</span> <span class="nb">iter</span><span class="p">(</span><span class="n">outs</span><span class="p">)</span>
</span><span id="JitOp.T-1394"><a href="#JitOp.T-1394"><span class="linenos">1394</span></a>
</span><span id="JitOp.T-1395"><a href="#JitOp.T-1395"><span class="linenos">1395</span></a>        <span class="k">return</span> <span class="p">[</span><span class="nb">next</span><span class="p">(</span><span class="n">outs</span><span class="p">)</span> <span class="k">if</span> <span class="n">undef</span> <span class="k">else</span> <span class="kc">None</span> <span class="k">for</span> <span class="n">undef</span> <span class="ow">in</span> <span class="n">undef_primals</span><span class="p">]</span>
</span></pre></div>


    

                            </div>
                            <div id="JitOp.partial_run" class="classattr">
                                        <input id="JitOp.partial_run-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">partial_run</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="n">trace</span>, </span><span class="param"><span class="n">tracers</span>, </span><span class="param"><span class="o">*</span>, </span><span class="param"><span class="n">program</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="JitOp.partial_run-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#JitOp.partial_run"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="JitOp.partial_run-1397"><a href="#JitOp.partial_run-1397"><span class="linenos">1397</span></a>    <span class="k">def</span> <span class="nf">partial_run</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">trace</span><span class="p">,</span> <span class="n">tracers</span><span class="p">,</span> <span class="o">*</span><span class="p">,</span> <span class="n">program</span><span class="p">):</span>
</span><span id="JitOp.partial_run-1398"><a href="#JitOp.partial_run-1398"><span class="linenos">1398</span></a>        <span class="n">in_unknowns</span> <span class="o">=</span> <span class="p">[</span><span class="ow">not</span> <span class="n">t</span><span class="o">.</span><span class="n">pval</span><span class="o">.</span><span class="n">is_known</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">tracers</span><span class="p">]</span>
</span><span id="JitOp.partial_run-1399"><a href="#JitOp.partial_run-1399"><span class="linenos">1399</span></a>        <span class="n">program1</span><span class="p">,</span> <span class="n">program2</span><span class="p">,</span> <span class="n">out_unknowns</span><span class="p">,</span> <span class="n">num_res</span> <span class="o">=</span> <span class="n">partial_run_program</span><span class="p">(</span><span class="n">program</span><span class="p">,</span> <span class="n">in_unknowns</span><span class="p">)</span>
</span><span id="JitOp.partial_run-1400"><a href="#JitOp.partial_run-1400"><span class="linenos">1400</span></a>        <span class="n">known_tracers</span><span class="p">,</span> <span class="n">unknown_tracers</span> <span class="o">=</span> <span class="n">partition_list</span><span class="p">(</span><span class="n">in_unknowns</span><span class="p">,</span> <span class="n">tracers</span><span class="p">)</span>
</span><span id="JitOp.partial_run-1401"><a href="#JitOp.partial_run-1401"><span class="linenos">1401</span></a>        <span class="n">known_vals</span> <span class="o">=</span> <span class="p">[</span><span class="n">t</span><span class="o">.</span><span class="n">pval</span><span class="o">.</span><span class="n">const</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">known_tracers</span><span class="p">]</span>
</span><span id="JitOp.partial_run-1402"><a href="#JitOp.partial_run-1402"><span class="linenos">1402</span></a>        <span class="n">outs1_res</span> <span class="o">=</span> <span class="n">bind</span><span class="p">(</span><span class="n">backend</span><span class="o">.</span><span class="n">jit_op</span><span class="p">,</span> <span class="o">*</span><span class="n">known_vals</span><span class="p">,</span> <span class="n">program</span><span class="o">=</span><span class="n">program1</span><span class="p">)</span>
</span><span id="JitOp.partial_run-1403"><a href="#JitOp.partial_run-1403"><span class="linenos">1403</span></a>        <span class="n">outs1</span><span class="p">,</span> <span class="n">res</span> <span class="o">=</span> <span class="n">split_list</span><span class="p">(</span><span class="n">outs1_res</span><span class="p">,</span> <span class="nb">len</span><span class="p">(</span><span class="n">program1</span><span class="o">.</span><span class="n">outs</span><span class="p">)</span> <span class="o">-</span> <span class="n">num_res</span><span class="p">)</span>
</span><span id="JitOp.partial_run-1404"><a href="#JitOp.partial_run-1404"><span class="linenos">1404</span></a>        <span class="n">res_tracers</span> <span class="o">=</span> <span class="p">[</span><span class="n">trace</span><span class="o">.</span><span class="n">instantiate_const</span><span class="p">(</span><span class="n">full_raise</span><span class="p">(</span><span class="n">trace</span><span class="p">,</span> <span class="n">x</span><span class="p">))</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">res</span><span class="p">]</span>
</span><span id="JitOp.partial_run-1405"><a href="#JitOp.partial_run-1405"><span class="linenos">1405</span></a>        <span class="n">outs2</span> <span class="o">=</span> <span class="p">[</span><span class="n">PartialRunTraceTensor</span><span class="p">(</span><span class="n">trace</span><span class="p">,</span> <span class="n">make_unknown_pval</span><span class="p">(</span><span class="n">v</span><span class="o">.</span><span class="n">symval</span><span class="p">),</span> <span class="kc">None</span><span class="p">)</span> <span class="k">for</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">program2</span><span class="o">.</span><span class="n">outs</span><span class="p">]</span>
</span><span id="JitOp.partial_run-1406"><a href="#JitOp.partial_run-1406"><span class="linenos">1406</span></a>        <span class="n">instruction</span> <span class="o">=</span> <span class="n">InstructionDraft</span><span class="p">(</span>
</span><span id="JitOp.partial_run-1407"><a href="#JitOp.partial_run-1407"><span class="linenos">1407</span></a>            <span class="bp">self</span><span class="p">,</span>
</span><span id="JitOp.partial_run-1408"><a href="#JitOp.partial_run-1408"><span class="linenos">1408</span></a>            <span class="n">res_tracers</span> <span class="o">+</span> <span class="n">unknown_tracers</span><span class="p">,</span>
</span><span id="JitOp.partial_run-1409"><a href="#JitOp.partial_run-1409"><span class="linenos">1409</span></a>            <span class="nb">dict</span><span class="p">(</span><span class="n">program</span><span class="o">=</span><span class="n">program2</span><span class="p">),</span>
</span><span id="JitOp.partial_run-1410"><a href="#JitOp.partial_run-1410"><span class="linenos">1410</span></a>            <span class="p">[</span><span class="n">v</span><span class="o">.</span><span class="n">symval</span> <span class="k">for</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">program2</span><span class="o">.</span><span class="n">outs</span><span class="p">],</span>
</span><span id="JitOp.partial_run-1411"><a href="#JitOp.partial_run-1411"><span class="linenos">1411</span></a>            <span class="n">list_map</span><span class="p">(</span><span class="n">weakref</span><span class="o">.</span><span class="n">ref</span><span class="p">,</span> <span class="n">outs2</span><span class="p">),</span>
</span><span id="JitOp.partial_run-1412"><a href="#JitOp.partial_run-1412"><span class="linenos">1412</span></a>        <span class="p">)</span>
</span><span id="JitOp.partial_run-1413"><a href="#JitOp.partial_run-1413"><span class="linenos">1413</span></a>        <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">outs2</span><span class="p">:</span>
</span><span id="JitOp.partial_run-1414"><a href="#JitOp.partial_run-1414"><span class="linenos">1414</span></a>            <span class="n">t</span><span class="o">.</span><span class="n">draft</span> <span class="o">=</span> <span class="n">instruction</span>
</span><span id="JitOp.partial_run-1415"><a href="#JitOp.partial_run-1415"><span class="linenos">1415</span></a>
</span><span id="JitOp.partial_run-1416"><a href="#JitOp.partial_run-1416"><span class="linenos">1416</span></a>        <span class="k">return</span> <span class="n">merge_lists</span><span class="p">(</span><span class="n">out_unknowns</span><span class="p">,</span> <span class="n">outs1</span><span class="p">,</span> <span class="n">outs2</span><span class="p">)</span>
</span></pre></div>


    

                            </div>
                            <div id="JitOp.partial_run_instruction" class="classattr">
                                        <input id="JitOp.partial_run_instruction-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">partial_run_instruction</span><span class="signature pdoc-code multiline">(<span class="param">	<span class="bp">self</span>,</span><span class="param">	<span class="n">unks_in</span>,</span><span class="param">	<span class="n">instruction</span></span><span class="return-annotation">) -> <span class="n">Tuple</span><span class="p">[</span><span class="n"><a href="#Instruction">Instruction</a></span><span class="p">,</span> <span class="n"><a href="#Instruction">Instruction</a></span><span class="p">,</span> <span class="n">List</span><span class="p">[</span><span class="nb">bool</span><span class="p">],</span> <span class="n">List</span><span class="p">[</span><span class="n"><a href="#Var">Var</a></span><span class="p">]]</span>:</span></span>

                <label class="view-source-button" for="JitOp.partial_run_instruction-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#JitOp.partial_run_instruction"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="JitOp.partial_run_instruction-1418"><a href="#JitOp.partial_run_instruction-1418"><span class="linenos">1418</span></a>    <span class="k">def</span> <span class="nf">partial_run_instruction</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">unks_in</span><span class="p">,</span> <span class="n">instruction</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Tuple</span><span class="p">[</span><span class="n">Instruction</span><span class="p">,</span> <span class="n">Instruction</span><span class="p">,</span> <span class="n">List</span><span class="p">[</span><span class="nb">bool</span><span class="p">],</span> <span class="n">List</span><span class="p">[</span><span class="n">Var</span><span class="p">]]:</span>
</span><span id="JitOp.partial_run_instruction-1419"><a href="#JitOp.partial_run_instruction-1419"><span class="linenos">1419</span></a>        <span class="n">program</span> <span class="o">=</span> <span class="n">instruction</span><span class="o">.</span><span class="n">params</span><span class="p">[</span><span class="s2">&quot;program&quot;</span><span class="p">]</span>
</span><span id="JitOp.partial_run_instruction-1420"><a href="#JitOp.partial_run_instruction-1420"><span class="linenos">1420</span></a>        <span class="n">program1</span><span class="p">,</span> <span class="n">program2</span><span class="p">,</span> <span class="n">out_unknowns</span><span class="p">,</span> <span class="n">num_res</span> <span class="o">=</span> <span class="n">partial_run_program</span><span class="p">(</span><span class="n">program</span><span class="p">,</span> <span class="n">unks_in</span><span class="p">)</span>
</span><span id="JitOp.partial_run_instruction-1421"><a href="#JitOp.partial_run_instruction-1421"><span class="linenos">1421</span></a>        <span class="n">ins1</span><span class="p">,</span> <span class="n">ins2</span> <span class="o">=</span> <span class="n">partition_list</span><span class="p">(</span><span class="n">unks_in</span><span class="p">,</span> <span class="n">instruction</span><span class="o">.</span><span class="n">inputs</span><span class="p">)</span>
</span><span id="JitOp.partial_run_instruction-1422"><a href="#JitOp.partial_run_instruction-1422"><span class="linenos">1422</span></a>        <span class="n">out_binders1</span><span class="p">,</span> <span class="n">out_binders2</span> <span class="o">=</span> <span class="n">partition_list</span><span class="p">(</span><span class="n">out_unknowns</span><span class="p">,</span> <span class="n">instruction</span><span class="o">.</span><span class="n">out_binders</span><span class="p">)</span>
</span><span id="JitOp.partial_run_instruction-1423"><a href="#JitOp.partial_run_instruction-1423"><span class="linenos">1423</span></a>        <span class="n">res</span> <span class="o">=</span> <span class="p">[</span><span class="n">Var</span><span class="p">(</span><span class="n">v</span><span class="o">.</span><span class="n">symval</span><span class="p">)</span> <span class="k">for</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">program2</span><span class="o">.</span><span class="n">in_binders</span><span class="p">[:</span><span class="n">num_res</span><span class="p">]]</span>
</span><span id="JitOp.partial_run_instruction-1424"><a href="#JitOp.partial_run_instruction-1424"><span class="linenos">1424</span></a>        <span class="n">instruction1</span> <span class="o">=</span> <span class="n">Instruction</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">ins1</span><span class="p">,</span> <span class="nb">dict</span><span class="p">(</span><span class="n">program</span><span class="o">=</span><span class="n">program1</span><span class="p">),</span> <span class="n">out_binders1</span> <span class="o">+</span> <span class="n">res</span><span class="p">)</span>
</span><span id="JitOp.partial_run_instruction-1425"><a href="#JitOp.partial_run_instruction-1425"><span class="linenos">1425</span></a>        <span class="n">instruction2</span> <span class="o">=</span> <span class="n">Instruction</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">res</span> <span class="o">+</span> <span class="n">ins2</span><span class="p">,</span> <span class="nb">dict</span><span class="p">(</span><span class="n">program</span><span class="o">=</span><span class="n">program2</span><span class="p">),</span> <span class="n">out_binders2</span><span class="p">)</span>
</span><span id="JitOp.partial_run_instruction-1426"><a href="#JitOp.partial_run_instruction-1426"><span class="linenos">1426</span></a>        <span class="k">return</span> <span class="n">instruction1</span><span class="p">,</span> <span class="n">instruction2</span><span class="p">,</span> <span class="n">out_unknowns</span><span class="p">,</span> <span class="n">res</span>
</span></pre></div>


    

                            </div>
                            <div class="inherited">
                                <h5>Inherited Members</h5>
                                <dl>
                                    <div><dt><a href="#Operator">Operator</a></dt>
                                <dd id="JitOp.__init__" class="function"><a href="#Operator.__init__">Operator</a></dd>
                <dd id="JitOp.name" class="variable"><a href="#Operator.name">name</a></dd>
                <dd id="JitOp.variadic_inputs" class="variable"><a href="#Operator.variadic_inputs">variadic_inputs</a></dd>
                <dd id="JitOp.nary_outputs" class="variable"><a href="#Operator.nary_outputs">nary_outputs</a></dd>
                <dd id="JitOp.args_fixer" class="function"><a href="#Operator.args_fixer">args_fixer</a></dd>
                <dd id="JitOp.reorg_args_nary" class="function"><a href="#Operator.reorg_args_nary">reorg_args_nary</a></dd>

            </div>
                                </dl>
                            </div>
                </section>
                <section id="MainTrace">
                            <input id="MainTrace-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr class">
            
    <span class="def">class</span>
    <span class="name">MainTrace</span><wbr>(<span class="base">typing.NamedTuple</span>):

                <label class="view-source-button" for="MainTrace-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#MainTrace"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="MainTrace-1434"><a href="#MainTrace-1434"><span class="linenos">1434</span></a><span class="k">class</span> <span class="nc">MainTrace</span><span class="p">(</span><span class="n">NamedTuple</span><span class="p">):</span>
</span><span id="MainTrace-1435"><a href="#MainTrace-1435"><span class="linenos">1435</span></a>    <span class="n">level</span><span class="p">:</span> <span class="nb">int</span>
</span><span id="MainTrace-1436"><a href="#MainTrace-1436"><span class="linenos">1436</span></a>    <span class="n">trace_type</span><span class="p">:</span> <span class="n">Type</span><span class="p">[</span><span class="s2">&quot;Trace&quot;</span><span class="p">]</span>
</span><span id="MainTrace-1437"><a href="#MainTrace-1437"><span class="linenos">1437</span></a>    <span class="n">global_data</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="n">Any</span><span class="p">]</span>
</span></pre></div>


            <div class="docstring"><p>MainTrace(level, trace_type, global_data)</p>
</div>


                            <div id="MainTrace.__init__" class="classattr">
                                <div class="attr function">
            
        <span class="name">MainTrace</span><span class="signature pdoc-code multiline">(<span class="param">	<span class="n">level</span><span class="p">:</span> <span class="nb">int</span>,</span><span class="param">	<span class="n">trace_type</span><span class="p">:</span> <span class="n">Type</span><span class="p">[</span><span class="n">ForwardRef</span><span class="p">(</span><span class="s1">&#39;Trace&#39;</span><span class="p">)]</span>,</span><span class="param">	<span class="n">global_data</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="n">Any</span><span class="p">]</span></span>)</span>

        
    </div>
    <a class="headerlink" href="#MainTrace.__init__"></a>
    
            <div class="docstring"><p>Create new instance of MainTrace(level, trace_type, global_data)</p>
</div>


                            </div>
                            <div id="MainTrace.level" class="classattr">
                                <div class="attr variable">
            <span class="name">level</span><span class="annotation">: int</span>

        
    </div>
    <a class="headerlink" href="#MainTrace.level"></a>
    
            <div class="docstring"><p>Alias for field number 0</p>
</div>


                            </div>
                            <div id="MainTrace.trace_type" class="classattr">
                                <div class="attr variable">
            <span class="name">trace_type</span><span class="annotation">: Type[<a href="#Trace">Trace</a>]</span>

        
    </div>
    <a class="headerlink" href="#MainTrace.trace_type"></a>
    
            <div class="docstring"><p>Alias for field number 1</p>
</div>


                            </div>
                            <div id="MainTrace.global_data" class="classattr">
                                <div class="attr variable">
            <span class="name">global_data</span><span class="annotation">: Optional[Any]</span>

        
    </div>
    <a class="headerlink" href="#MainTrace.global_data"></a>
    
            <div class="docstring"><p>Alias for field number 2</p>
</div>


                            </div>
                            <div class="inherited">
                                <h5>Inherited Members</h5>
                                <dl>
                                    <div><dt>builtins.tuple</dt>
                                <dd id="MainTrace.index" class="function">index</dd>
                <dd id="MainTrace.count" class="function">count</dd>

            </div>
                                </dl>
                            </div>
                </section>
                <section id="Trace">
                            <input id="Trace-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr class">
            
    <span class="def">class</span>
    <span class="name">Trace</span>:

                <label class="view-source-button" for="Trace-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Trace"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Trace-1440"><a href="#Trace-1440"><span class="linenos">1440</span></a><span class="k">class</span> <span class="nc">Trace</span><span class="p">:</span>
</span><span id="Trace-1441"><a href="#Trace-1441"><span class="linenos">1441</span></a>    <span class="n">main</span><span class="p">:</span> <span class="n">MainTrace</span>
</span><span id="Trace-1442"><a href="#Trace-1442"><span class="linenos">1442</span></a>
</span><span id="Trace-1443"><a href="#Trace-1443"><span class="linenos">1443</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">main</span><span class="p">:</span> <span class="n">MainTrace</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="kc">None</span><span class="p">:</span>
</span><span id="Trace-1444"><a href="#Trace-1444"><span class="linenos">1444</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">main</span> <span class="o">=</span> <span class="n">main</span>
</span><span id="Trace-1445"><a href="#Trace-1445"><span class="linenos">1445</span></a>
</span><span id="Trace-1446"><a href="#Trace-1446"><span class="linenos">1446</span></a>    <span class="k">def</span> <span class="nf">pure</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">val</span><span class="p">):</span>
</span><span id="Trace-1447"><a href="#Trace-1447"><span class="linenos">1447</span></a>        <span class="k">raise</span> <span class="ne">NotImplementedError</span>
</span><span id="Trace-1448"><a href="#Trace-1448"><span class="linenos">1448</span></a>
</span><span id="Trace-1449"><a href="#Trace-1449"><span class="linenos">1449</span></a>    <span class="k">def</span> <span class="nf">run_op</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">op</span><span class="p">,</span> <span class="n">tracers</span><span class="p">,</span> <span class="n">params</span><span class="p">):</span>
</span><span id="Trace-1450"><a href="#Trace-1450"><span class="linenos">1450</span></a>        <span class="k">raise</span> <span class="ne">NotImplementedError</span>
</span></pre></div>


    

                            <div id="Trace.__init__" class="classattr">
                                        <input id="Trace.__init__-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="name">Trace</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">main</span><span class="p">:</span> <span class="n"><a href="#MainTrace">MainTrace</a></span></span>)</span>

                <label class="view-source-button" for="Trace.__init__-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Trace.__init__"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Trace.__init__-1443"><a href="#Trace.__init__-1443"><span class="linenos">1443</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">main</span><span class="p">:</span> <span class="n">MainTrace</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="kc">None</span><span class="p">:</span>
</span><span id="Trace.__init__-1444"><a href="#Trace.__init__-1444"><span class="linenos">1444</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">main</span> <span class="o">=</span> <span class="n">main</span>
</span></pre></div>


    

                            </div>
                            <div id="Trace.main" class="classattr">
                                <div class="attr variable">
            <span class="name">main</span><span class="annotation">: <a href="#MainTrace">MainTrace</a></span>

        
    </div>
    <a class="headerlink" href="#Trace.main"></a>
    
    

                            </div>
                            <div id="Trace.pure" class="classattr">
                                        <input id="Trace.pure-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">pure</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="n">val</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="Trace.pure-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Trace.pure"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Trace.pure-1446"><a href="#Trace.pure-1446"><span class="linenos">1446</span></a>    <span class="k">def</span> <span class="nf">pure</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">val</span><span class="p">):</span>
</span><span id="Trace.pure-1447"><a href="#Trace.pure-1447"><span class="linenos">1447</span></a>        <span class="k">raise</span> <span class="ne">NotImplementedError</span>
</span></pre></div>


    

                            </div>
                            <div id="Trace.run_op" class="classattr">
                                        <input id="Trace.run_op-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">run_op</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="n">op</span>, </span><span class="param"><span class="n">tracers</span>, </span><span class="param"><span class="n">params</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="Trace.run_op-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#Trace.run_op"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="Trace.run_op-1449"><a href="#Trace.run_op-1449"><span class="linenos">1449</span></a>    <span class="k">def</span> <span class="nf">run_op</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">op</span><span class="p">,</span> <span class="n">tracers</span><span class="p">,</span> <span class="n">params</span><span class="p">):</span>
</span><span id="Trace.run_op-1450"><a href="#Trace.run_op-1450"><span class="linenos">1450</span></a>        <span class="k">raise</span> <span class="ne">NotImplementedError</span>
</span></pre></div>


    

                            </div>
                </section>
                <section id="RunTrace">
                            <input id="RunTrace-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr class">
            
    <span class="def">class</span>
    <span class="name">RunTrace</span><wbr>(<span class="base"><a href="#Trace">Trace</a></span>):

                <label class="view-source-button" for="RunTrace-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#RunTrace"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="RunTrace-1453"><a href="#RunTrace-1453"><span class="linenos">1453</span></a><span class="k">class</span> <span class="nc">RunTrace</span><span class="p">(</span><span class="n">Trace</span><span class="p">):</span>
</span><span id="RunTrace-1454"><a href="#RunTrace-1454"><span class="linenos">1454</span></a>    <span class="n">pure</span> <span class="o">=</span> <span class="k">lambda</span> <span class="bp">self</span><span class="p">,</span> <span class="n">x</span><span class="p">:</span> <span class="n">x</span>
</span><span id="RunTrace-1455"><a href="#RunTrace-1455"><span class="linenos">1455</span></a>
</span><span id="RunTrace-1456"><a href="#RunTrace-1456"><span class="linenos">1456</span></a>    <span class="k">def</span> <span class="nf">run_op</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">op</span><span class="p">:</span> <span class="n">Operator</span><span class="p">,</span> <span class="n">args</span><span class="p">,</span> <span class="n">params</span><span class="p">):</span>
</span><span id="RunTrace-1457"><a href="#RunTrace-1457"><span class="linenos">1457</span></a>        <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">op</span><span class="p">,</span> <span class="n">MetaOperator</span><span class="p">):</span>
</span><span id="RunTrace-1458"><a href="#RunTrace-1458"><span class="linenos">1458</span></a>            <span class="n">args</span><span class="p">,</span> <span class="n">params</span> <span class="o">=</span> <span class="n">op</span><span class="o">.</span><span class="n">reorg_args</span><span class="p">(</span><span class="n">args</span><span class="p">,</span> <span class="n">params</span><span class="p">)</span>
</span><span id="RunTrace-1459"><a href="#RunTrace-1459"><span class="linenos">1459</span></a>            <span class="n">args</span><span class="p">,</span> <span class="n">params</span> <span class="o">=</span> <span class="n">op</span><span class="o">.</span><span class="n">args_fixer</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)</span>
</span><span id="RunTrace-1460"><a href="#RunTrace-1460"><span class="linenos">1460</span></a>            <span class="n">ret</span> <span class="o">=</span> <span class="n">op</span><span class="o">.</span><span class="n">meta_impl</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)</span>
</span><span id="RunTrace-1461"><a href="#RunTrace-1461"><span class="linenos">1461</span></a>        <span class="k">else</span><span class="p">:</span>
</span><span id="RunTrace-1462"><a href="#RunTrace-1462"><span class="linenos">1462</span></a>            <span class="n">fn</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">get_fn</span><span class="p">(</span><span class="n">op</span><span class="p">,</span> <span class="o">*</span><span class="nb">tuple</span><span class="p">(</span><span class="n">SymbolicTensor</span><span class="o">.</span><span class="n">like</span><span class="p">(</span><span class="n">a</span><span class="p">)</span> <span class="k">for</span> <span class="n">a</span> <span class="ow">in</span> <span class="n">args</span><span class="p">),</span> <span class="o">**</span><span class="n">params</span><span class="p">)</span>
</span><span id="RunTrace-1463"><a href="#RunTrace-1463"><span class="linenos">1463</span></a>            <span class="c1"># with Timing(f&quot;RUN {op}&quot;):ret = jit(</span>
</span><span id="RunTrace-1464"><a href="#RunTrace-1464"><span class="linenos">1464</span></a>            <span class="n">ret</span> <span class="o">=</span> <span class="n">jit</span><span class="p">(</span>
</span><span id="RunTrace-1465"><a href="#RunTrace-1465"><span class="linenos">1465</span></a>                <span class="n">fn</span><span class="p">,</span>
</span><span id="RunTrace-1466"><a href="#RunTrace-1466"><span class="linenos">1466</span></a>                <span class="n">static_argnames</span><span class="o">=</span><span class="p">(</span><span class="s2">&quot;params&quot;</span><span class="p">,),</span>
</span><span id="RunTrace-1467"><a href="#RunTrace-1467"><span class="linenos">1467</span></a>                <span class="n">name</span><span class="o">=</span><span class="n">jit</span><span class="o">.</span><span class="n">get_jit_name</span><span class="p">(</span><span class="n">args</span><span class="p">,</span> <span class="n">params</span><span class="p">,</span> <span class="n">op</span><span class="o">.</span><span class="n">name</span><span class="p">),</span>
</span><span id="RunTrace-1468"><a href="#RunTrace-1468"><span class="linenos">1468</span></a>            <span class="p">)(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)</span>
</span><span id="RunTrace-1469"><a href="#RunTrace-1469"><span class="linenos">1469</span></a>
</span><span id="RunTrace-1470"><a href="#RunTrace-1470"><span class="linenos">1470</span></a>        <span class="k">return</span> <span class="n">ret</span>
</span><span id="RunTrace-1471"><a href="#RunTrace-1471"><span class="linenos">1471</span></a>
</span><span id="RunTrace-1472"><a href="#RunTrace-1472"><span class="linenos">1472</span></a>    <span class="nd">@staticmethod</span>
</span><span id="RunTrace-1473"><a href="#RunTrace-1473"><span class="linenos">1473</span></a>    <span class="nd">@lru_cache_verbose</span><span class="p">()</span>
</span><span id="RunTrace-1474"><a href="#RunTrace-1474"><span class="linenos">1474</span></a>    <span class="k">def</span> <span class="nf">get_fn</span><span class="p">(</span><span class="n">op</span><span class="p">,</span> <span class="o">*</span><span class="n">symval_args</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="RunTrace-1475"><a href="#RunTrace-1475"><span class="linenos">1475</span></a>        <span class="k">def</span> <span class="nf">fn</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="RunTrace-1476"><a href="#RunTrace-1476"><span class="linenos">1476</span></a>            <span class="k">return</span> <span class="p">[</span><span class="n">op</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)]</span>
</span><span id="RunTrace-1477"><a href="#RunTrace-1477"><span class="linenos">1477</span></a>
</span><span id="RunTrace-1478"><a href="#RunTrace-1478"><span class="linenos">1478</span></a>        <span class="k">return</span> <span class="n">fn</span>
</span></pre></div>


    

                            <div id="RunTrace.pure" class="classattr">
                                        <input id="RunTrace.pure-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">pure</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="n">x</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="RunTrace.pure-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#RunTrace.pure"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="RunTrace.pure-1454"><a href="#RunTrace.pure-1454"><span class="linenos">1454</span></a>    <span class="n">pure</span> <span class="o">=</span> <span class="k">lambda</span> <span class="bp">self</span><span class="p">,</span> <span class="n">x</span><span class="p">:</span> <span class="n">x</span>
</span></pre></div>


    

                            </div>
                            <div id="RunTrace.run_op" class="classattr">
                                        <input id="RunTrace.run_op-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">run_op</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="n">op</span><span class="p">:</span> <span class="n"><a href="#Operator">Operator</a></span>, </span><span class="param"><span class="n">args</span>, </span><span class="param"><span class="n">params</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="RunTrace.run_op-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#RunTrace.run_op"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="RunTrace.run_op-1456"><a href="#RunTrace.run_op-1456"><span class="linenos">1456</span></a>    <span class="k">def</span> <span class="nf">run_op</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">op</span><span class="p">:</span> <span class="n">Operator</span><span class="p">,</span> <span class="n">args</span><span class="p">,</span> <span class="n">params</span><span class="p">):</span>
</span><span id="RunTrace.run_op-1457"><a href="#RunTrace.run_op-1457"><span class="linenos">1457</span></a>        <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">op</span><span class="p">,</span> <span class="n">MetaOperator</span><span class="p">):</span>
</span><span id="RunTrace.run_op-1458"><a href="#RunTrace.run_op-1458"><span class="linenos">1458</span></a>            <span class="n">args</span><span class="p">,</span> <span class="n">params</span> <span class="o">=</span> <span class="n">op</span><span class="o">.</span><span class="n">reorg_args</span><span class="p">(</span><span class="n">args</span><span class="p">,</span> <span class="n">params</span><span class="p">)</span>
</span><span id="RunTrace.run_op-1459"><a href="#RunTrace.run_op-1459"><span class="linenos">1459</span></a>            <span class="n">args</span><span class="p">,</span> <span class="n">params</span> <span class="o">=</span> <span class="n">op</span><span class="o">.</span><span class="n">args_fixer</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)</span>
</span><span id="RunTrace.run_op-1460"><a href="#RunTrace.run_op-1460"><span class="linenos">1460</span></a>            <span class="n">ret</span> <span class="o">=</span> <span class="n">op</span><span class="o">.</span><span class="n">meta_impl</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)</span>
</span><span id="RunTrace.run_op-1461"><a href="#RunTrace.run_op-1461"><span class="linenos">1461</span></a>        <span class="k">else</span><span class="p">:</span>
</span><span id="RunTrace.run_op-1462"><a href="#RunTrace.run_op-1462"><span class="linenos">1462</span></a>            <span class="n">fn</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">get_fn</span><span class="p">(</span><span class="n">op</span><span class="p">,</span> <span class="o">*</span><span class="nb">tuple</span><span class="p">(</span><span class="n">SymbolicTensor</span><span class="o">.</span><span class="n">like</span><span class="p">(</span><span class="n">a</span><span class="p">)</span> <span class="k">for</span> <span class="n">a</span> <span class="ow">in</span> <span class="n">args</span><span class="p">),</span> <span class="o">**</span><span class="n">params</span><span class="p">)</span>
</span><span id="RunTrace.run_op-1463"><a href="#RunTrace.run_op-1463"><span class="linenos">1463</span></a>            <span class="c1"># with Timing(f&quot;RUN {op}&quot;):ret = jit(</span>
</span><span id="RunTrace.run_op-1464"><a href="#RunTrace.run_op-1464"><span class="linenos">1464</span></a>            <span class="n">ret</span> <span class="o">=</span> <span class="n">jit</span><span class="p">(</span>
</span><span id="RunTrace.run_op-1465"><a href="#RunTrace.run_op-1465"><span class="linenos">1465</span></a>                <span class="n">fn</span><span class="p">,</span>
</span><span id="RunTrace.run_op-1466"><a href="#RunTrace.run_op-1466"><span class="linenos">1466</span></a>                <span class="n">static_argnames</span><span class="o">=</span><span class="p">(</span><span class="s2">&quot;params&quot;</span><span class="p">,),</span>
</span><span id="RunTrace.run_op-1467"><a href="#RunTrace.run_op-1467"><span class="linenos">1467</span></a>                <span class="n">name</span><span class="o">=</span><span class="n">jit</span><span class="o">.</span><span class="n">get_jit_name</span><span class="p">(</span><span class="n">args</span><span class="p">,</span> <span class="n">params</span><span class="p">,</span> <span class="n">op</span><span class="o">.</span><span class="n">name</span><span class="p">),</span>
</span><span id="RunTrace.run_op-1468"><a href="#RunTrace.run_op-1468"><span class="linenos">1468</span></a>            <span class="p">)(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)</span>
</span><span id="RunTrace.run_op-1469"><a href="#RunTrace.run_op-1469"><span class="linenos">1469</span></a>
</span><span id="RunTrace.run_op-1470"><a href="#RunTrace.run_op-1470"><span class="linenos">1470</span></a>        <span class="k">return</span> <span class="n">ret</span>
</span></pre></div>


    

                            </div>
                            <div id="RunTrace.get_fn" class="classattr">
                                        <input id="RunTrace.get_fn-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">get_fn</span><span class="signature pdoc-code condensed">(<span class="param"><span class="o">*</span><span class="n">args</span>, </span><span class="param"><span class="o">**</span><span class="n">kwargs</span></span><span class="return-annotation">) -> <span class="n">Any</span>:</span></span>

                <label class="view-source-button" for="RunTrace.get_fn-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#RunTrace.get_fn"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="RunTrace.get_fn-172"><a href="#RunTrace.get_fn-172"><span class="linenos">172</span></a>        <span class="k">def</span> <span class="nf">decorated_function</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Any</span><span class="p">:</span>
</span><span id="RunTrace.get_fn-173"><a href="#RunTrace.get_fn-173"><span class="linenos">173</span></a>            <span class="n">result</span> <span class="o">=</span> <span class="n">wrapper</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">)</span>
</span><span id="RunTrace.get_fn-174"><a href="#RunTrace.get_fn-174"><span class="linenos">174</span></a>            <span class="n">cache_info</span> <span class="o">=</span> <span class="n">wrapper</span><span class="o">.</span><span class="n">cache_info</span><span class="p">()</span>
</span><span id="RunTrace.get_fn-175"><a href="#RunTrace.get_fn-175"><span class="linenos">175</span></a>
</span><span id="RunTrace.get_fn-176"><a href="#RunTrace.get_fn-176"><span class="linenos">176</span></a>            <span class="n">dblog</span><span class="p">(</span>
</span><span id="RunTrace.get_fn-177"><a href="#RunTrace.get_fn-177"><span class="linenos">177</span></a>                <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">fn</span><span class="o">.</span><span class="vm">__name__</span><span class="si">}</span><span class="s2">.</span><span class="si">{</span><span class="n">cache_info</span><span class="si">}</span><span class="s2"> </span><span class="si">{</span><span class="n">args</span><span class="o">.</span><span class="fm">__hash__</span><span class="p">()</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">,</span>
</span><span id="RunTrace.get_fn-178"><a href="#RunTrace.get_fn-178"><span class="linenos">178</span></a>                <span class="n">enable</span><span class="o">=</span><span class="n">backend</span><span class="o">.</span><span class="n">LOG_LRU</span><span class="p">,</span>
</span><span id="RunTrace.get_fn-179"><a href="#RunTrace.get_fn-179"><span class="linenos">179</span></a>            <span class="p">)</span>
</span><span id="RunTrace.get_fn-180"><a href="#RunTrace.get_fn-180"><span class="linenos">180</span></a>            <span class="n">tb</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">traceback</span><span class="o">.</span><span class="n">format_list</span><span class="p">(</span><span class="n">traceback</span><span class="o">.</span><span class="n">extract_stack</span><span class="p">())[</span><span class="n">tb_start</span><span class="p">:</span><span class="n">tb_end</span><span class="p">])</span><span class="o">.</span><span class="n">replace</span><span class="p">(</span><span class="s2">&quot;</span><span class="se">\n</span><span class="s2">    &quot;</span><span class="p">,</span> <span class="s2">&quot;:</span><span class="se">\t</span><span class="s2">&quot;</span><span class="p">)</span> <span class="o">+</span> <span class="s2">&quot;-&quot;</span> <span class="o">*</span> <span class="mi">20</span> <span class="o">+</span> <span class="s2">&quot;</span><span class="se">\n</span><span class="s2">&quot;</span>
</span><span id="RunTrace.get_fn-181"><a href="#RunTrace.get_fn-181"><span class="linenos">181</span></a>            <span class="n">dblog</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">tb</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">,</span> <span class="n">enable</span><span class="o">=</span><span class="n">backend</span><span class="o">.</span><span class="n">LOG_LRU</span><span class="p">)</span>
</span><span id="RunTrace.get_fn-182"><a href="#RunTrace.get_fn-182"><span class="linenos">182</span></a>
</span><span id="RunTrace.get_fn-183"><a href="#RunTrace.get_fn-183"><span class="linenos">183</span></a>            <span class="k">return</span> <span class="n">result</span>
</span></pre></div>


    

                            </div>
                            <div class="inherited">
                                <h5>Inherited Members</h5>
                                <dl>
                                    <div><dt><a href="#Trace">Trace</a></dt>
                                <dd id="RunTrace.__init__" class="function"><a href="#Trace.__init__">Trace</a></dd>
                <dd id="RunTrace.main" class="variable"><a href="#Trace.main">main</a></dd>

            </div>
                                </dl>
                            </div>
                </section>
                <section id="SymbolicRunTrace">
                            <input id="SymbolicRunTrace-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr class">
            
    <span class="def">class</span>
    <span class="name">SymbolicRunTrace</span><wbr>(<span class="base"><a href="#Trace">Trace</a></span>):

                <label class="view-source-button" for="SymbolicRunTrace-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#SymbolicRunTrace"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="SymbolicRunTrace-1481"><a href="#SymbolicRunTrace-1481"><span class="linenos">1481</span></a><span class="k">class</span> <span class="nc">SymbolicRunTrace</span><span class="p">(</span><span class="n">Trace</span><span class="p">):</span>
</span><span id="SymbolicRunTrace-1482"><a href="#SymbolicRunTrace-1482"><span class="linenos">1482</span></a>    <span class="c1"># pure = lambda self, x: x</span>
</span><span id="SymbolicRunTrace-1483"><a href="#SymbolicRunTrace-1483"><span class="linenos">1483</span></a>    <span class="k">def</span> <span class="nf">pure</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">val</span><span class="p">:</span> <span class="n">Any</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">SymbolicTensor</span><span class="p">:</span>
</span><span id="SymbolicRunTrace-1484"><a href="#SymbolicRunTrace-1484"><span class="linenos">1484</span></a>        <span class="k">return</span> <span class="n">val</span><span class="o">.</span><span class="n">symval</span>
</span><span id="SymbolicRunTrace-1485"><a href="#SymbolicRunTrace-1485"><span class="linenos">1485</span></a>
</span><span id="SymbolicRunTrace-1486"><a href="#SymbolicRunTrace-1486"><span class="linenos">1486</span></a>    <span class="k">def</span> <span class="nf">run_op</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">op</span><span class="p">,</span> <span class="n">tracers</span><span class="p">,</span> <span class="n">params</span><span class="p">):</span>
</span><span id="SymbolicRunTrace-1487"><a href="#SymbolicRunTrace-1487"><span class="linenos">1487</span></a>        <span class="n">symvals_in</span> <span class="o">=</span> <span class="n">tree_map</span><span class="p">(</span><span class="k">lambda</span> <span class="n">x</span><span class="p">:</span> <span class="n">x</span><span class="o">.</span><span class="n">symval</span><span class="p">,</span> <span class="n">tracers</span><span class="p">)</span>
</span><span id="SymbolicRunTrace-1488"><a href="#SymbolicRunTrace-1488"><span class="linenos">1488</span></a>        <span class="n">symvals_out</span> <span class="o">=</span> <span class="n">op</span><span class="o">.</span><span class="n">typecheck</span><span class="p">(</span><span class="o">*</span><span class="n">symvals_in</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)</span>
</span><span id="SymbolicRunTrace-1489"><a href="#SymbolicRunTrace-1489"><span class="linenos">1489</span></a>        <span class="k">return</span> <span class="n">symvals_out</span>
</span></pre></div>


    

                            <div id="SymbolicRunTrace.pure" class="classattr">
                                        <input id="SymbolicRunTrace.pure-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">pure</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="n">val</span><span class="p">:</span> <span class="n">Any</span></span><span class="return-annotation">) -> <span class="n"><a href="#SymbolicTensor">SymbolicTensor</a></span>:</span></span>

                <label class="view-source-button" for="SymbolicRunTrace.pure-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#SymbolicRunTrace.pure"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="SymbolicRunTrace.pure-1483"><a href="#SymbolicRunTrace.pure-1483"><span class="linenos">1483</span></a>    <span class="k">def</span> <span class="nf">pure</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">val</span><span class="p">:</span> <span class="n">Any</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">SymbolicTensor</span><span class="p">:</span>
</span><span id="SymbolicRunTrace.pure-1484"><a href="#SymbolicRunTrace.pure-1484"><span class="linenos">1484</span></a>        <span class="k">return</span> <span class="n">val</span><span class="o">.</span><span class="n">symval</span>
</span></pre></div>


    

                            </div>
                            <div id="SymbolicRunTrace.run_op" class="classattr">
                                        <input id="SymbolicRunTrace.run_op-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">run_op</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="n">op</span>, </span><span class="param"><span class="n">tracers</span>, </span><span class="param"><span class="n">params</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="SymbolicRunTrace.run_op-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#SymbolicRunTrace.run_op"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="SymbolicRunTrace.run_op-1486"><a href="#SymbolicRunTrace.run_op-1486"><span class="linenos">1486</span></a>    <span class="k">def</span> <span class="nf">run_op</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">op</span><span class="p">,</span> <span class="n">tracers</span><span class="p">,</span> <span class="n">params</span><span class="p">):</span>
</span><span id="SymbolicRunTrace.run_op-1487"><a href="#SymbolicRunTrace.run_op-1487"><span class="linenos">1487</span></a>        <span class="n">symvals_in</span> <span class="o">=</span> <span class="n">tree_map</span><span class="p">(</span><span class="k">lambda</span> <span class="n">x</span><span class="p">:</span> <span class="n">x</span><span class="o">.</span><span class="n">symval</span><span class="p">,</span> <span class="n">tracers</span><span class="p">)</span>
</span><span id="SymbolicRunTrace.run_op-1488"><a href="#SymbolicRunTrace.run_op-1488"><span class="linenos">1488</span></a>        <span class="n">symvals_out</span> <span class="o">=</span> <span class="n">op</span><span class="o">.</span><span class="n">typecheck</span><span class="p">(</span><span class="o">*</span><span class="n">symvals_in</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)</span>
</span><span id="SymbolicRunTrace.run_op-1489"><a href="#SymbolicRunTrace.run_op-1489"><span class="linenos">1489</span></a>        <span class="k">return</span> <span class="n">symvals_out</span>
</span></pre></div>


    

                            </div>
                            <div class="inherited">
                                <h5>Inherited Members</h5>
                                <dl>
                                    <div><dt><a href="#Trace">Trace</a></dt>
                                <dd id="SymbolicRunTrace.__init__" class="function"><a href="#Trace.__init__">Trace</a></dd>
                <dd id="SymbolicRunTrace.main" class="variable"><a href="#Trace.main">main</a></dd>

            </div>
                                </dl>
                            </div>
                </section>
                <section id="TraceTensor">
                            <input id="TraceTensor-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr class">
            
    <span class="def">class</span>
    <span class="name">TraceTensor</span><wbr>(<span class="base"><a href="#Tensor">Tensor</a></span>):

                <label class="view-source-button" for="TraceTensor-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#TraceTensor"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="TraceTensor-1492"><a href="#TraceTensor-1492"><span class="linenos">1492</span></a><span class="k">class</span> <span class="nc">TraceTensor</span><span class="p">(</span><span class="n">Tensor</span><span class="p">):</span>
</span><span id="TraceTensor-1493"><a href="#TraceTensor-1493"><span class="linenos">1493</span></a>    <span class="n">PYTHON_TYPES</span> <span class="o">=</span> <span class="p">{</span>
</span><span id="TraceTensor-1494"><a href="#TraceTensor-1494"><span class="linenos">1494</span></a>        <span class="nb">bool</span><span class="p">,</span>
</span><span id="TraceTensor-1495"><a href="#TraceTensor-1495"><span class="linenos">1495</span></a>        <span class="nb">int</span><span class="p">,</span>
</span><span id="TraceTensor-1496"><a href="#TraceTensor-1496"><span class="linenos">1496</span></a>        <span class="nb">float</span><span class="p">,</span>
</span><span id="TraceTensor-1497"><a href="#TraceTensor-1497"><span class="linenos">1497</span></a>    <span class="p">}</span>
</span><span id="TraceTensor-1498"><a href="#TraceTensor-1498"><span class="linenos">1498</span></a>    <span class="n">_trace</span><span class="p">:</span> <span class="s2">&quot;Trace&quot;</span>
</span><span id="TraceTensor-1499"><a href="#TraceTensor-1499"><span class="linenos">1499</span></a>
</span><span id="TraceTensor-1500"><a href="#TraceTensor-1500"><span class="linenos">1500</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">):</span>
</span><span id="TraceTensor-1501"><a href="#TraceTensor-1501"><span class="linenos">1501</span></a>        <span class="k">raise</span> <span class="ne">NotImplementedError</span>
</span><span id="TraceTensor-1502"><a href="#TraceTensor-1502"><span class="linenos">1502</span></a>
</span><span id="TraceTensor-1503"><a href="#TraceTensor-1503"><span class="linenos">1503</span></a>    <span class="n">symval</span> <span class="o">=</span> <span class="nb">property</span><span class="p">(</span><span class="k">lambda</span> <span class="bp">self</span><span class="p">:</span> <span class="n">get_symval</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">val</span><span class="p">))</span>
</span><span id="TraceTensor-1504"><a href="#TraceTensor-1504"><span class="linenos">1504</span></a>    <span class="n">dtype</span> <span class="o">=</span> <span class="nb">property</span><span class="p">(</span><span class="k">lambda</span> <span class="bp">self</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">symval</span><span class="o">.</span><span class="n">dtype</span><span class="p">)</span>
</span><span id="TraceTensor-1505"><a href="#TraceTensor-1505"><span class="linenos">1505</span></a>    <span class="n">shape</span> <span class="o">=</span> <span class="nb">property</span><span class="p">(</span><span class="k">lambda</span> <span class="bp">self</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">symval</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span>
</span><span id="TraceTensor-1506"><a href="#TraceTensor-1506"><span class="linenos">1506</span></a>    <span class="n">device</span> <span class="o">=</span> <span class="nb">property</span><span class="p">(</span><span class="k">lambda</span> <span class="bp">self</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">symval</span><span class="o">.</span><span class="n">device</span><span class="p">)</span>
</span><span id="TraceTensor-1507"><a href="#TraceTensor-1507"><span class="linenos">1507</span></a>
</span><span id="TraceTensor-1508"><a href="#TraceTensor-1508"><span class="linenos">1508</span></a>    <span class="nd">@property</span>
</span><span id="TraceTensor-1509"><a href="#TraceTensor-1509"><span class="linenos">1509</span></a>    <span class="k">def</span> <span class="nf">val</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="TraceTensor-1510"><a href="#TraceTensor-1510"><span class="linenos">1510</span></a>        <span class="k">raise</span> <span class="ne">NotImplementedError</span>
</span><span id="TraceTensor-1511"><a href="#TraceTensor-1511"><span class="linenos">1511</span></a>
</span><span id="TraceTensor-1512"><a href="#TraceTensor-1512"><span class="linenos">1512</span></a>    <span class="k">def</span> <span class="fm">__str__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="TraceTensor-1513"><a href="#TraceTensor-1513"><span class="linenos">1513</span></a>        <span class="k">return</span> <span class="nb">repr</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span>
</span><span id="TraceTensor-1514"><a href="#TraceTensor-1514"><span class="linenos">1514</span></a>
</span><span id="TraceTensor-1515"><a href="#TraceTensor-1515"><span class="linenos">1515</span></a>    <span class="k">def</span> <span class="nf">full_lower</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="TraceTensor-1516"><a href="#TraceTensor-1516"><span class="linenos">1516</span></a>        <span class="k">return</span> <span class="bp">self</span>
</span><span id="TraceTensor-1517"><a href="#TraceTensor-1517"><span class="linenos">1517</span></a>
</span><span id="TraceTensor-1518"><a href="#TraceTensor-1518"><span class="linenos">1518</span></a>    <span class="nd">@property</span>
</span><span id="TraceTensor-1519"><a href="#TraceTensor-1519"><span class="linenos">1519</span></a>    <span class="k">def</span> <span class="nf">ndim</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="TraceTensor-1520"><a href="#TraceTensor-1520"><span class="linenos">1520</span></a>        <span class="k">return</span> <span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span>
</span><span id="TraceTensor-1521"><a href="#TraceTensor-1521"><span class="linenos">1521</span></a>
</span><span id="TraceTensor-1522"><a href="#TraceTensor-1522"><span class="linenos">1522</span></a>    <span class="k">def</span> <span class="fm">__repr__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="TraceTensor-1523"><a href="#TraceTensor-1523"><span class="linenos">1523</span></a>        <span class="k">return</span> <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="vm">__class__</span><span class="o">.</span><span class="vm">__name__</span><span class="si">}</span><span class="s2">(</span><span class="si">{</span><span class="nb">repr</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">symval</span><span class="p">)</span><span class="si">}</span><span class="s2">)&quot;</span>
</span></pre></div>


    

                            <div id="TraceTensor.__init__" class="classattr">
                                        <input id="TraceTensor.__init__-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="name">TraceTensor</span><span class="signature pdoc-code condensed">(<span class="param"><span class="o">*</span><span class="n">args</span>, </span><span class="param"><span class="o">**</span><span class="n">kwargs</span></span>)</span>

                <label class="view-source-button" for="TraceTensor.__init__-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#TraceTensor.__init__"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="TraceTensor.__init__-1500"><a href="#TraceTensor.__init__-1500"><span class="linenos">1500</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">):</span>
</span><span id="TraceTensor.__init__-1501"><a href="#TraceTensor.__init__-1501"><span class="linenos">1501</span></a>        <span class="k">raise</span> <span class="ne">NotImplementedError</span>
</span></pre></div>


    

                            </div>
                            <div id="TraceTensor.PYTHON_TYPES" class="classattr">
                                <div class="attr variable">
            <span class="name">PYTHON_TYPES</span>        =
<span class="default_value">{&lt;class &#39;int&#39;&gt;, &lt;class &#39;float&#39;&gt;, &lt;class &#39;bool&#39;&gt;}</span>

        
    </div>
    <a class="headerlink" href="#TraceTensor.PYTHON_TYPES"></a>
    
    

                            </div>
                            <div id="TraceTensor.symval" class="classattr">
                                        <input id="TraceTensor.symval-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr variable">
            <span class="name">symval</span>

                <label class="view-source-button" for="TraceTensor.symval-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#TraceTensor.symval"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="TraceTensor.symval-1503"><a href="#TraceTensor.symval-1503"><span class="linenos">1503</span></a>    <span class="n">symval</span> <span class="o">=</span> <span class="nb">property</span><span class="p">(</span><span class="k">lambda</span> <span class="bp">self</span><span class="p">:</span> <span class="n">get_symval</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">val</span><span class="p">))</span>
</span></pre></div>


    

                            </div>
                            <div id="TraceTensor.dtype" class="classattr">
                                        <input id="TraceTensor.dtype-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr variable">
            <span class="name">dtype</span>

                <label class="view-source-button" for="TraceTensor.dtype-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#TraceTensor.dtype"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="TraceTensor.dtype-1504"><a href="#TraceTensor.dtype-1504"><span class="linenos">1504</span></a>    <span class="n">dtype</span> <span class="o">=</span> <span class="nb">property</span><span class="p">(</span><span class="k">lambda</span> <span class="bp">self</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">symval</span><span class="o">.</span><span class="n">dtype</span><span class="p">)</span>
</span></pre></div>


    

                            </div>
                            <div id="TraceTensor.shape" class="classattr">
                                        <input id="TraceTensor.shape-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr variable">
            <span class="name">shape</span>

                <label class="view-source-button" for="TraceTensor.shape-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#TraceTensor.shape"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="TraceTensor.shape-1505"><a href="#TraceTensor.shape-1505"><span class="linenos">1505</span></a>    <span class="n">shape</span> <span class="o">=</span> <span class="nb">property</span><span class="p">(</span><span class="k">lambda</span> <span class="bp">self</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">symval</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span>
</span></pre></div>


    

                            </div>
                            <div id="TraceTensor.device" class="classattr">
                                        <input id="TraceTensor.device-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr variable">
            <span class="name">device</span>

                <label class="view-source-button" for="TraceTensor.device-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#TraceTensor.device"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="TraceTensor.device-1506"><a href="#TraceTensor.device-1506"><span class="linenos">1506</span></a>    <span class="n">device</span> <span class="o">=</span> <span class="nb">property</span><span class="p">(</span><span class="k">lambda</span> <span class="bp">self</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">symval</span><span class="o">.</span><span class="n">device</span><span class="p">)</span>
</span></pre></div>


    

                            </div>
                            <div id="TraceTensor.val" class="classattr">
                                        <input id="TraceTensor.val-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr variable">
            <span class="name">val</span>

                <label class="view-source-button" for="TraceTensor.val-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#TraceTensor.val"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="TraceTensor.val-1508"><a href="#TraceTensor.val-1508"><span class="linenos">1508</span></a>    <span class="nd">@property</span>
</span><span id="TraceTensor.val-1509"><a href="#TraceTensor.val-1509"><span class="linenos">1509</span></a>    <span class="k">def</span> <span class="nf">val</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="TraceTensor.val-1510"><a href="#TraceTensor.val-1510"><span class="linenos">1510</span></a>        <span class="k">raise</span> <span class="ne">NotImplementedError</span>
</span></pre></div>


    

                            </div>
                            <div id="TraceTensor.full_lower" class="classattr">
                                        <input id="TraceTensor.full_lower-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">full_lower</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="TraceTensor.full_lower-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#TraceTensor.full_lower"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="TraceTensor.full_lower-1515"><a href="#TraceTensor.full_lower-1515"><span class="linenos">1515</span></a>    <span class="k">def</span> <span class="nf">full_lower</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="TraceTensor.full_lower-1516"><a href="#TraceTensor.full_lower-1516"><span class="linenos">1516</span></a>        <span class="k">return</span> <span class="bp">self</span>
</span></pre></div>


    

                            </div>
                            <div id="TraceTensor.ndim" class="classattr">
                                        <input id="TraceTensor.ndim-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr variable">
            <span class="name">ndim</span>

                <label class="view-source-button" for="TraceTensor.ndim-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#TraceTensor.ndim"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="TraceTensor.ndim-1518"><a href="#TraceTensor.ndim-1518"><span class="linenos">1518</span></a>    <span class="nd">@property</span>
</span><span id="TraceTensor.ndim-1519"><a href="#TraceTensor.ndim-1519"><span class="linenos">1519</span></a>    <span class="k">def</span> <span class="nf">ndim</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="TraceTensor.ndim-1520"><a href="#TraceTensor.ndim-1520"><span class="linenos">1520</span></a>        <span class="k">return</span> <span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span>
</span></pre></div>


    

                            </div>
                            <div class="inherited">
                                <h5>Inherited Members</h5>
                                <dl>
                                    <div><dt><a href="#Tensor">Tensor</a></dt>
                                <dd id="TraceTensor.buf" class="variable"><a href="#Tensor.buf">buf</a></dd>
                <dd id="TraceTensor.default_dtype" class="variable"><a href="#Tensor.default_dtype">default_dtype</a></dd>
                <dd id="TraceTensor.is_int" class="function"><a href="#Tensor.is_int">is_int</a></dd>
                <dd id="TraceTensor.is_float" class="function"><a href="#Tensor.is_float">is_float</a></dd>
                <dd id="TraceTensor.is_unsigned" class="function"><a href="#Tensor.is_unsigned">is_unsigned</a></dd>
                <dd id="TraceTensor.to_bool" class="function"><a href="#Tensor.to_bool">to_bool</a></dd>
                <dd id="TraceTensor.short" class="function"><a href="#Tensor.short">short</a></dd>
                <dd id="TraceTensor.int" class="function"><a href="#Tensor.int">int</a></dd>
                <dd id="TraceTensor.long" class="function"><a href="#Tensor.long">long</a></dd>
                <dd id="TraceTensor.half" class="function"><a href="#Tensor.half">half</a></dd>
                <dd id="TraceTensor.float" class="function"><a href="#Tensor.float">float</a></dd>
                <dd id="TraceTensor.str_short" class="function"><a href="#Tensor.str_short">str_short</a></dd>
                <dd id="TraceTensor.size" class="function"><a href="#Tensor.size">size</a></dd>
                <dd id="TraceTensor.numpy" class="function"><a href="#Tensor.numpy">numpy</a></dd>
                <dd id="TraceTensor.numel" class="function"><a href="#Tensor.numel">numel</a></dd>
                <dd id="TraceTensor.element_size" class="function"><a href="#Tensor.element_size">element_size</a></dd>
                <dd id="TraceTensor.nbytes" class="function"><a href="#Tensor.nbytes">nbytes</a></dd>

            </div>
                                </dl>
                            </div>
                </section>
                <section id="VMapTraceTensor">
                            <input id="VMapTraceTensor-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr class">
            
    <span class="def">class</span>
    <span class="name">VMapTraceTensor</span><wbr>(<span class="base"><a href="#TraceTensor">TraceTensor</a></span>):

                <label class="view-source-button" for="VMapTraceTensor-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#VMapTraceTensor"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="VMapTraceTensor-1526"><a href="#VMapTraceTensor-1526"><span class="linenos">1526</span></a><span class="k">class</span> <span class="nc">VMapTraceTensor</span><span class="p">(</span><span class="n">TraceTensor</span><span class="p">):</span>
</span><span id="VMapTraceTensor-1527"><a href="#VMapTraceTensor-1527"><span class="linenos">1527</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">trace</span><span class="p">,</span> <span class="n">val</span><span class="p">,</span> <span class="n">vmap_dim</span><span class="p">):</span>
</span><span id="VMapTraceTensor-1528"><a href="#VMapTraceTensor-1528"><span class="linenos">1528</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">_trace</span> <span class="o">=</span> <span class="n">trace</span>
</span><span id="VMapTraceTensor-1529"><a href="#VMapTraceTensor-1529"><span class="linenos">1529</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">_val</span> <span class="o">=</span> <span class="n">val</span>
</span><span id="VMapTraceTensor-1530"><a href="#VMapTraceTensor-1530"><span class="linenos">1530</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">vmap_dim</span> <span class="o">=</span> <span class="n">vmap_dim</span>
</span><span id="VMapTraceTensor-1531"><a href="#VMapTraceTensor-1531"><span class="linenos">1531</span></a>
</span><span id="VMapTraceTensor-1532"><a href="#VMapTraceTensor-1532"><span class="linenos">1532</span></a>    <span class="nd">@property</span>
</span><span id="VMapTraceTensor-1533"><a href="#VMapTraceTensor-1533"><span class="linenos">1533</span></a>    <span class="k">def</span> <span class="nf">val</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="VMapTraceTensor-1534"><a href="#VMapTraceTensor-1534"><span class="linenos">1534</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">_val</span>
</span><span id="VMapTraceTensor-1535"><a href="#VMapTraceTensor-1535"><span class="linenos">1535</span></a>
</span><span id="VMapTraceTensor-1536"><a href="#VMapTraceTensor-1536"><span class="linenos">1536</span></a>    <span class="nd">@property</span>
</span><span id="VMapTraceTensor-1537"><a href="#VMapTraceTensor-1537"><span class="linenos">1537</span></a>    <span class="k">def</span> <span class="nf">symval</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="VMapTraceTensor-1538"><a href="#VMapTraceTensor-1538"><span class="linenos">1538</span></a>        <span class="n">symval</span> <span class="o">=</span> <span class="n">get_symval</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">val</span><span class="p">)</span>
</span><span id="VMapTraceTensor-1539"><a href="#VMapTraceTensor-1539"><span class="linenos">1539</span></a>        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">vmap_dim</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
</span><span id="VMapTraceTensor-1540"><a href="#VMapTraceTensor-1540"><span class="linenos">1540</span></a>            <span class="k">return</span> <span class="n">symval</span>
</span><span id="VMapTraceTensor-1541"><a href="#VMapTraceTensor-1541"><span class="linenos">1541</span></a>        <span class="k">else</span><span class="p">:</span>
</span><span id="VMapTraceTensor-1542"><a href="#VMapTraceTensor-1542"><span class="linenos">1542</span></a>            <span class="n">shape</span> <span class="o">=</span> <span class="nb">list</span><span class="p">(</span><span class="n">symval</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span>
</span><span id="VMapTraceTensor-1543"><a href="#VMapTraceTensor-1543"><span class="linenos">1543</span></a>            <span class="k">del</span> <span class="n">shape</span><span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">vmap_dim</span><span class="p">]</span>
</span><span id="VMapTraceTensor-1544"><a href="#VMapTraceTensor-1544"><span class="linenos">1544</span></a>            <span class="k">return</span> <span class="n">symval</span><span class="o">.</span><span class="n">like</span><span class="p">(</span><span class="n">shape</span><span class="o">=</span><span class="nb">tuple</span><span class="p">(</span><span class="n">shape</span><span class="p">))</span>
</span><span id="VMapTraceTensor-1545"><a href="#VMapTraceTensor-1545"><span class="linenos">1545</span></a>
</span><span id="VMapTraceTensor-1546"><a href="#VMapTraceTensor-1546"><span class="linenos">1546</span></a>    <span class="k">def</span> <span class="nf">full_lower</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="VMapTraceTensor-1547"><a href="#VMapTraceTensor-1547"><span class="linenos">1547</span></a>        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">vmap_dim</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
</span><span id="VMapTraceTensor-1548"><a href="#VMapTraceTensor-1548"><span class="linenos">1548</span></a>            <span class="k">return</span> <span class="n">full_lower</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">val</span><span class="p">)</span>
</span><span id="VMapTraceTensor-1549"><a href="#VMapTraceTensor-1549"><span class="linenos">1549</span></a>        <span class="k">else</span><span class="p">:</span>
</span><span id="VMapTraceTensor-1550"><a href="#VMapTraceTensor-1550"><span class="linenos">1550</span></a>            <span class="k">return</span> <span class="bp">self</span>
</span></pre></div>


    

                            <div id="VMapTraceTensor.__init__" class="classattr">
                                        <input id="VMapTraceTensor.__init__-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="name">VMapTraceTensor</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">trace</span>, </span><span class="param"><span class="n">val</span>, </span><span class="param"><span class="n">vmap_dim</span></span>)</span>

                <label class="view-source-button" for="VMapTraceTensor.__init__-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#VMapTraceTensor.__init__"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="VMapTraceTensor.__init__-1527"><a href="#VMapTraceTensor.__init__-1527"><span class="linenos">1527</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">trace</span><span class="p">,</span> <span class="n">val</span><span class="p">,</span> <span class="n">vmap_dim</span><span class="p">):</span>
</span><span id="VMapTraceTensor.__init__-1528"><a href="#VMapTraceTensor.__init__-1528"><span class="linenos">1528</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">_trace</span> <span class="o">=</span> <span class="n">trace</span>
</span><span id="VMapTraceTensor.__init__-1529"><a href="#VMapTraceTensor.__init__-1529"><span class="linenos">1529</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">_val</span> <span class="o">=</span> <span class="n">val</span>
</span><span id="VMapTraceTensor.__init__-1530"><a href="#VMapTraceTensor.__init__-1530"><span class="linenos">1530</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">vmap_dim</span> <span class="o">=</span> <span class="n">vmap_dim</span>
</span></pre></div>


    

                            </div>
                            <div id="VMapTraceTensor.vmap_dim" class="classattr">
                                <div class="attr variable">
            <span class="name">vmap_dim</span>

        
    </div>
    <a class="headerlink" href="#VMapTraceTensor.vmap_dim"></a>
    
    

                            </div>
                            <div id="VMapTraceTensor.val" class="classattr">
                                        <input id="VMapTraceTensor.val-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr variable">
            <span class="name">val</span>

                <label class="view-source-button" for="VMapTraceTensor.val-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#VMapTraceTensor.val"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="VMapTraceTensor.val-1532"><a href="#VMapTraceTensor.val-1532"><span class="linenos">1532</span></a>    <span class="nd">@property</span>
</span><span id="VMapTraceTensor.val-1533"><a href="#VMapTraceTensor.val-1533"><span class="linenos">1533</span></a>    <span class="k">def</span> <span class="nf">val</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="VMapTraceTensor.val-1534"><a href="#VMapTraceTensor.val-1534"><span class="linenos">1534</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">_val</span>
</span></pre></div>


    

                            </div>
                            <div id="VMapTraceTensor.symval" class="classattr">
                                        <input id="VMapTraceTensor.symval-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr variable">
            <span class="name">symval</span>

                <label class="view-source-button" for="VMapTraceTensor.symval-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#VMapTraceTensor.symval"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="VMapTraceTensor.symval-1536"><a href="#VMapTraceTensor.symval-1536"><span class="linenos">1536</span></a>    <span class="nd">@property</span>
</span><span id="VMapTraceTensor.symval-1537"><a href="#VMapTraceTensor.symval-1537"><span class="linenos">1537</span></a>    <span class="k">def</span> <span class="nf">symval</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="VMapTraceTensor.symval-1538"><a href="#VMapTraceTensor.symval-1538"><span class="linenos">1538</span></a>        <span class="n">symval</span> <span class="o">=</span> <span class="n">get_symval</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">val</span><span class="p">)</span>
</span><span id="VMapTraceTensor.symval-1539"><a href="#VMapTraceTensor.symval-1539"><span class="linenos">1539</span></a>        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">vmap_dim</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
</span><span id="VMapTraceTensor.symval-1540"><a href="#VMapTraceTensor.symval-1540"><span class="linenos">1540</span></a>            <span class="k">return</span> <span class="n">symval</span>
</span><span id="VMapTraceTensor.symval-1541"><a href="#VMapTraceTensor.symval-1541"><span class="linenos">1541</span></a>        <span class="k">else</span><span class="p">:</span>
</span><span id="VMapTraceTensor.symval-1542"><a href="#VMapTraceTensor.symval-1542"><span class="linenos">1542</span></a>            <span class="n">shape</span> <span class="o">=</span> <span class="nb">list</span><span class="p">(</span><span class="n">symval</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span>
</span><span id="VMapTraceTensor.symval-1543"><a href="#VMapTraceTensor.symval-1543"><span class="linenos">1543</span></a>            <span class="k">del</span> <span class="n">shape</span><span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">vmap_dim</span><span class="p">]</span>
</span><span id="VMapTraceTensor.symval-1544"><a href="#VMapTraceTensor.symval-1544"><span class="linenos">1544</span></a>            <span class="k">return</span> <span class="n">symval</span><span class="o">.</span><span class="n">like</span><span class="p">(</span><span class="n">shape</span><span class="o">=</span><span class="nb">tuple</span><span class="p">(</span><span class="n">shape</span><span class="p">))</span>
</span></pre></div>


    

                            </div>
                            <div id="VMapTraceTensor.full_lower" class="classattr">
                                        <input id="VMapTraceTensor.full_lower-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">full_lower</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="VMapTraceTensor.full_lower-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#VMapTraceTensor.full_lower"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="VMapTraceTensor.full_lower-1546"><a href="#VMapTraceTensor.full_lower-1546"><span class="linenos">1546</span></a>    <span class="k">def</span> <span class="nf">full_lower</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="VMapTraceTensor.full_lower-1547"><a href="#VMapTraceTensor.full_lower-1547"><span class="linenos">1547</span></a>        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">vmap_dim</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
</span><span id="VMapTraceTensor.full_lower-1548"><a href="#VMapTraceTensor.full_lower-1548"><span class="linenos">1548</span></a>            <span class="k">return</span> <span class="n">full_lower</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">val</span><span class="p">)</span>
</span><span id="VMapTraceTensor.full_lower-1549"><a href="#VMapTraceTensor.full_lower-1549"><span class="linenos">1549</span></a>        <span class="k">else</span><span class="p">:</span>
</span><span id="VMapTraceTensor.full_lower-1550"><a href="#VMapTraceTensor.full_lower-1550"><span class="linenos">1550</span></a>            <span class="k">return</span> <span class="bp">self</span>
</span></pre></div>


    

                            </div>
                            <div class="inherited">
                                <h5>Inherited Members</h5>
                                <dl>
                                    <div><dt><a href="#TraceTensor">TraceTensor</a></dt>
                                <dd id="VMapTraceTensor.PYTHON_TYPES" class="variable"><a href="#TraceTensor.PYTHON_TYPES">PYTHON_TYPES</a></dd>
                <dd id="VMapTraceTensor.dtype" class="variable"><a href="#TraceTensor.dtype">dtype</a></dd>
                <dd id="VMapTraceTensor.shape" class="variable"><a href="#TraceTensor.shape">shape</a></dd>
                <dd id="VMapTraceTensor.device" class="variable"><a href="#TraceTensor.device">device</a></dd>
                <dd id="VMapTraceTensor.ndim" class="variable"><a href="#TraceTensor.ndim">ndim</a></dd>

            </div>
            <div><dt><a href="#Tensor">Tensor</a></dt>
                                <dd id="VMapTraceTensor.buf" class="variable"><a href="#Tensor.buf">buf</a></dd>
                <dd id="VMapTraceTensor.default_dtype" class="variable"><a href="#Tensor.default_dtype">default_dtype</a></dd>
                <dd id="VMapTraceTensor.is_int" class="function"><a href="#Tensor.is_int">is_int</a></dd>
                <dd id="VMapTraceTensor.is_float" class="function"><a href="#Tensor.is_float">is_float</a></dd>
                <dd id="VMapTraceTensor.is_unsigned" class="function"><a href="#Tensor.is_unsigned">is_unsigned</a></dd>
                <dd id="VMapTraceTensor.to_bool" class="function"><a href="#Tensor.to_bool">to_bool</a></dd>
                <dd id="VMapTraceTensor.short" class="function"><a href="#Tensor.short">short</a></dd>
                <dd id="VMapTraceTensor.int" class="function"><a href="#Tensor.int">int</a></dd>
                <dd id="VMapTraceTensor.long" class="function"><a href="#Tensor.long">long</a></dd>
                <dd id="VMapTraceTensor.half" class="function"><a href="#Tensor.half">half</a></dd>
                <dd id="VMapTraceTensor.float" class="function"><a href="#Tensor.float">float</a></dd>
                <dd id="VMapTraceTensor.str_short" class="function"><a href="#Tensor.str_short">str_short</a></dd>
                <dd id="VMapTraceTensor.size" class="function"><a href="#Tensor.size">size</a></dd>
                <dd id="VMapTraceTensor.numpy" class="function"><a href="#Tensor.numpy">numpy</a></dd>
                <dd id="VMapTraceTensor.numel" class="function"><a href="#Tensor.numel">numel</a></dd>
                <dd id="VMapTraceTensor.element_size" class="function"><a href="#Tensor.element_size">element_size</a></dd>
                <dd id="VMapTraceTensor.nbytes" class="function"><a href="#Tensor.nbytes">nbytes</a></dd>

            </div>
                                </dl>
                            </div>
                </section>
                <section id="VMapTrace">
                            <input id="VMapTrace-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr class">
            
    <span class="def">class</span>
    <span class="name">VMapTrace</span><wbr>(<span class="base"><a href="#Trace">Trace</a></span>):

                <label class="view-source-button" for="VMapTrace-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#VMapTrace"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="VMapTrace-1553"><a href="#VMapTrace-1553"><span class="linenos">1553</span></a><span class="k">class</span> <span class="nc">VMapTrace</span><span class="p">(</span><span class="n">Trace</span><span class="p">):</span>
</span><span id="VMapTrace-1554"><a href="#VMapTrace-1554"><span class="linenos">1554</span></a>    <span class="n">pure</span> <span class="o">=</span> <span class="k">lambda</span> <span class="bp">self</span><span class="p">,</span> <span class="n">val</span><span class="p">:</span> <span class="n">VMapTraceTensor</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">val</span><span class="p">,</span> <span class="kc">None</span><span class="p">)</span>
</span><span id="VMapTrace-1555"><a href="#VMapTrace-1555"><span class="linenos">1555</span></a>
</span><span id="VMapTrace-1556"><a href="#VMapTrace-1556"><span class="linenos">1556</span></a>    <span class="nd">@property</span>
</span><span id="VMapTrace-1557"><a href="#VMapTrace-1557"><span class="linenos">1557</span></a>    <span class="k">def</span> <span class="nf">dim_size</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="VMapTrace-1558"><a href="#VMapTrace-1558"><span class="linenos">1558</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">main</span><span class="o">.</span><span class="n">global_data</span>
</span><span id="VMapTrace-1559"><a href="#VMapTrace-1559"><span class="linenos">1559</span></a>
</span><span id="VMapTrace-1560"><a href="#VMapTrace-1560"><span class="linenos">1560</span></a>    <span class="k">def</span> <span class="nf">run_op</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">op</span><span class="p">,</span> <span class="n">tracers</span><span class="p">,</span> <span class="n">params</span><span class="p">):</span>
</span><span id="VMapTrace-1561"><a href="#VMapTrace-1561"><span class="linenos">1561</span></a>        <span class="n">vals_in</span><span class="p">,</span> <span class="n">bdims_in</span> <span class="o">=</span> <span class="n">unzip2</span><span class="p">((</span><span class="n">t</span><span class="o">.</span><span class="n">val</span><span class="p">,</span> <span class="n">t</span><span class="o">.</span><span class="n">vmap_dim</span><span class="p">)</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">tracers</span><span class="p">)</span>
</span><span id="VMapTrace-1562"><a href="#VMapTrace-1562"><span class="linenos">1562</span></a>        <span class="n">val_outs</span><span class="p">,</span> <span class="n">bdim_outs</span> <span class="o">=</span> <span class="n">op</span><span class="o">.</span><span class="n">vmap</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">dim_size</span><span class="p">,</span> <span class="n">vals_in</span><span class="p">,</span> <span class="n">bdims_in</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)</span>
</span><span id="VMapTrace-1563"><a href="#VMapTrace-1563"><span class="linenos">1563</span></a>        <span class="k">return</span> <span class="p">[</span><span class="n">VMapTraceTensor</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">x</span><span class="p">,</span> <span class="n">bd</span><span class="p">)</span> <span class="k">for</span> <span class="n">x</span><span class="p">,</span> <span class="n">bd</span> <span class="ow">in</span> <span class="n">list_zip</span><span class="p">(</span><span class="n">val_outs</span><span class="p">,</span> <span class="n">bdim_outs</span><span class="p">)]</span>
</span><span id="VMapTrace-1564"><a href="#VMapTrace-1564"><span class="linenos">1564</span></a>
</span><span id="VMapTrace-1565"><a href="#VMapTrace-1565"><span class="linenos">1565</span></a>    <span class="nd">@staticmethod</span>
</span><span id="VMapTrace-1566"><a href="#VMapTrace-1566"><span class="linenos">1566</span></a>    <span class="k">def</span> <span class="nf">move_vmap_dim</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">dim_size</span><span class="p">,</span> <span class="n">src</span><span class="p">:</span> <span class="nb">int</span><span class="p">,</span> <span class="n">dst</span><span class="p">:</span> <span class="nb">int</span><span class="p">):</span>
</span><span id="VMapTrace-1567"><a href="#VMapTrace-1567"><span class="linenos">1567</span></a>        <span class="k">if</span> <span class="n">src</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>  <span class="c1"># unsqueeze and expand</span>
</span><span id="VMapTrace-1568"><a href="#VMapTrace-1568"><span class="linenos">1568</span></a>            <span class="n">target_shape</span> <span class="o">=</span> <span class="nb">list</span><span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span>
</span><span id="VMapTrace-1569"><a href="#VMapTrace-1569"><span class="linenos">1569</span></a>            <span class="n">target_shape</span><span class="o">.</span><span class="n">insert</span><span class="p">(</span><span class="n">dst</span><span class="p">,</span> <span class="n">dim_size</span><span class="p">)</span>
</span><span id="VMapTrace-1570"><a href="#VMapTrace-1570"><span class="linenos">1570</span></a>            <span class="n">unsqueeze_shape</span> <span class="o">=</span> <span class="p">[</span><span class="mi">1</span> <span class="k">if</span> <span class="n">d</span> <span class="o">==</span> <span class="n">dst</span> <span class="k">else</span> <span class="n">target_shape</span><span class="p">[</span><span class="n">d</span><span class="p">]</span> <span class="k">for</span> <span class="n">d</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">target_shape</span><span class="p">))]</span>
</span><span id="VMapTrace-1571"><a href="#VMapTrace-1571"><span class="linenos">1571</span></a>            <span class="n">x</span> <span class="o">=</span> <span class="n">x</span><span class="o">.</span><span class="n">reshape</span><span class="p">(</span><span class="nb">tuple</span><span class="p">(</span><span class="n">unsqueeze_shape</span><span class="p">))</span>
</span><span id="VMapTrace-1572"><a href="#VMapTrace-1572"><span class="linenos">1572</span></a>            <span class="n">x</span> <span class="o">=</span> <span class="n">x</span><span class="o">.</span><span class="n">expand</span><span class="p">(</span><span class="nb">tuple</span><span class="p">(</span><span class="n">target_shape</span><span class="p">))</span>
</span><span id="VMapTrace-1573"><a href="#VMapTrace-1573"><span class="linenos">1573</span></a>            <span class="k">return</span> <span class="n">x</span>
</span><span id="VMapTrace-1574"><a href="#VMapTrace-1574"><span class="linenos">1574</span></a>        <span class="k">elif</span> <span class="n">src</span> <span class="o">==</span> <span class="n">dst</span><span class="p">:</span>
</span><span id="VMapTrace-1575"><a href="#VMapTrace-1575"><span class="linenos">1575</span></a>            <span class="k">return</span> <span class="n">x</span>
</span><span id="VMapTrace-1576"><a href="#VMapTrace-1576"><span class="linenos">1576</span></a>        <span class="k">else</span><span class="p">:</span>
</span><span id="VMapTrace-1577"><a href="#VMapTrace-1577"><span class="linenos">1577</span></a>            <span class="n">perm</span> <span class="o">=</span> <span class="p">[</span><span class="n">i</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">shape</span><span class="p">))</span> <span class="k">if</span> <span class="n">i</span> <span class="o">!=</span> <span class="n">src</span><span class="p">]</span>
</span><span id="VMapTrace-1578"><a href="#VMapTrace-1578"><span class="linenos">1578</span></a>            <span class="n">perm</span><span class="o">.</span><span class="n">insert</span><span class="p">(</span><span class="n">dst</span><span class="p">,</span> <span class="n">src</span><span class="p">)</span>
</span><span id="VMapTrace-1579"><a href="#VMapTrace-1579"><span class="linenos">1579</span></a>            <span class="k">return</span> <span class="n">x</span><span class="o">.</span><span class="n">permute</span><span class="p">(</span><span class="nb">tuple</span><span class="p">(</span><span class="n">perm</span><span class="p">))</span>
</span></pre></div>


    

                            <div id="VMapTrace.pure" class="classattr">
                                        <input id="VMapTrace.pure-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">pure</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="n">val</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="VMapTrace.pure-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#VMapTrace.pure"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="VMapTrace.pure-1554"><a href="#VMapTrace.pure-1554"><span class="linenos">1554</span></a>    <span class="n">pure</span> <span class="o">=</span> <span class="k">lambda</span> <span class="bp">self</span><span class="p">,</span> <span class="n">val</span><span class="p">:</span> <span class="n">VMapTraceTensor</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">val</span><span class="p">,</span> <span class="kc">None</span><span class="p">)</span>
</span></pre></div>


    

                            </div>
                            <div id="VMapTrace.dim_size" class="classattr">
                                        <input id="VMapTrace.dim_size-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr variable">
            <span class="name">dim_size</span>

                <label class="view-source-button" for="VMapTrace.dim_size-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#VMapTrace.dim_size"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="VMapTrace.dim_size-1556"><a href="#VMapTrace.dim_size-1556"><span class="linenos">1556</span></a>    <span class="nd">@property</span>
</span><span id="VMapTrace.dim_size-1557"><a href="#VMapTrace.dim_size-1557"><span class="linenos">1557</span></a>    <span class="k">def</span> <span class="nf">dim_size</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="VMapTrace.dim_size-1558"><a href="#VMapTrace.dim_size-1558"><span class="linenos">1558</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">main</span><span class="o">.</span><span class="n">global_data</span>
</span></pre></div>


    

                            </div>
                            <div id="VMapTrace.run_op" class="classattr">
                                        <input id="VMapTrace.run_op-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">run_op</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="n">op</span>, </span><span class="param"><span class="n">tracers</span>, </span><span class="param"><span class="n">params</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="VMapTrace.run_op-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#VMapTrace.run_op"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="VMapTrace.run_op-1560"><a href="#VMapTrace.run_op-1560"><span class="linenos">1560</span></a>    <span class="k">def</span> <span class="nf">run_op</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">op</span><span class="p">,</span> <span class="n">tracers</span><span class="p">,</span> <span class="n">params</span><span class="p">):</span>
</span><span id="VMapTrace.run_op-1561"><a href="#VMapTrace.run_op-1561"><span class="linenos">1561</span></a>        <span class="n">vals_in</span><span class="p">,</span> <span class="n">bdims_in</span> <span class="o">=</span> <span class="n">unzip2</span><span class="p">((</span><span class="n">t</span><span class="o">.</span><span class="n">val</span><span class="p">,</span> <span class="n">t</span><span class="o">.</span><span class="n">vmap_dim</span><span class="p">)</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">tracers</span><span class="p">)</span>
</span><span id="VMapTrace.run_op-1562"><a href="#VMapTrace.run_op-1562"><span class="linenos">1562</span></a>        <span class="n">val_outs</span><span class="p">,</span> <span class="n">bdim_outs</span> <span class="o">=</span> <span class="n">op</span><span class="o">.</span><span class="n">vmap</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">dim_size</span><span class="p">,</span> <span class="n">vals_in</span><span class="p">,</span> <span class="n">bdims_in</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)</span>
</span><span id="VMapTrace.run_op-1563"><a href="#VMapTrace.run_op-1563"><span class="linenos">1563</span></a>        <span class="k">return</span> <span class="p">[</span><span class="n">VMapTraceTensor</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">x</span><span class="p">,</span> <span class="n">bd</span><span class="p">)</span> <span class="k">for</span> <span class="n">x</span><span class="p">,</span> <span class="n">bd</span> <span class="ow">in</span> <span class="n">list_zip</span><span class="p">(</span><span class="n">val_outs</span><span class="p">,</span> <span class="n">bdim_outs</span><span class="p">)]</span>
</span></pre></div>


    

                            </div>
                            <div id="VMapTrace.move_vmap_dim" class="classattr">
                                        <input id="VMapTrace.move_vmap_dim-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
                    <div class="decorator">@staticmethod</div>

        <span class="def">def</span>
        <span class="name">move_vmap_dim</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">x</span>, </span><span class="param"><span class="n">dim_size</span>, </span><span class="param"><span class="n">src</span><span class="p">:</span> <span class="nb">int</span>, </span><span class="param"><span class="n">dst</span><span class="p">:</span> <span class="nb">int</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="VMapTrace.move_vmap_dim-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#VMapTrace.move_vmap_dim"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="VMapTrace.move_vmap_dim-1565"><a href="#VMapTrace.move_vmap_dim-1565"><span class="linenos">1565</span></a>    <span class="nd">@staticmethod</span>
</span><span id="VMapTrace.move_vmap_dim-1566"><a href="#VMapTrace.move_vmap_dim-1566"><span class="linenos">1566</span></a>    <span class="k">def</span> <span class="nf">move_vmap_dim</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">dim_size</span><span class="p">,</span> <span class="n">src</span><span class="p">:</span> <span class="nb">int</span><span class="p">,</span> <span class="n">dst</span><span class="p">:</span> <span class="nb">int</span><span class="p">):</span>
</span><span id="VMapTrace.move_vmap_dim-1567"><a href="#VMapTrace.move_vmap_dim-1567"><span class="linenos">1567</span></a>        <span class="k">if</span> <span class="n">src</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>  <span class="c1"># unsqueeze and expand</span>
</span><span id="VMapTrace.move_vmap_dim-1568"><a href="#VMapTrace.move_vmap_dim-1568"><span class="linenos">1568</span></a>            <span class="n">target_shape</span> <span class="o">=</span> <span class="nb">list</span><span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span>
</span><span id="VMapTrace.move_vmap_dim-1569"><a href="#VMapTrace.move_vmap_dim-1569"><span class="linenos">1569</span></a>            <span class="n">target_shape</span><span class="o">.</span><span class="n">insert</span><span class="p">(</span><span class="n">dst</span><span class="p">,</span> <span class="n">dim_size</span><span class="p">)</span>
</span><span id="VMapTrace.move_vmap_dim-1570"><a href="#VMapTrace.move_vmap_dim-1570"><span class="linenos">1570</span></a>            <span class="n">unsqueeze_shape</span> <span class="o">=</span> <span class="p">[</span><span class="mi">1</span> <span class="k">if</span> <span class="n">d</span> <span class="o">==</span> <span class="n">dst</span> <span class="k">else</span> <span class="n">target_shape</span><span class="p">[</span><span class="n">d</span><span class="p">]</span> <span class="k">for</span> <span class="n">d</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">target_shape</span><span class="p">))]</span>
</span><span id="VMapTrace.move_vmap_dim-1571"><a href="#VMapTrace.move_vmap_dim-1571"><span class="linenos">1571</span></a>            <span class="n">x</span> <span class="o">=</span> <span class="n">x</span><span class="o">.</span><span class="n">reshape</span><span class="p">(</span><span class="nb">tuple</span><span class="p">(</span><span class="n">unsqueeze_shape</span><span class="p">))</span>
</span><span id="VMapTrace.move_vmap_dim-1572"><a href="#VMapTrace.move_vmap_dim-1572"><span class="linenos">1572</span></a>            <span class="n">x</span> <span class="o">=</span> <span class="n">x</span><span class="o">.</span><span class="n">expand</span><span class="p">(</span><span class="nb">tuple</span><span class="p">(</span><span class="n">target_shape</span><span class="p">))</span>
</span><span id="VMapTrace.move_vmap_dim-1573"><a href="#VMapTrace.move_vmap_dim-1573"><span class="linenos">1573</span></a>            <span class="k">return</span> <span class="n">x</span>
</span><span id="VMapTrace.move_vmap_dim-1574"><a href="#VMapTrace.move_vmap_dim-1574"><span class="linenos">1574</span></a>        <span class="k">elif</span> <span class="n">src</span> <span class="o">==</span> <span class="n">dst</span><span class="p">:</span>
</span><span id="VMapTrace.move_vmap_dim-1575"><a href="#VMapTrace.move_vmap_dim-1575"><span class="linenos">1575</span></a>            <span class="k">return</span> <span class="n">x</span>
</span><span id="VMapTrace.move_vmap_dim-1576"><a href="#VMapTrace.move_vmap_dim-1576"><span class="linenos">1576</span></a>        <span class="k">else</span><span class="p">:</span>
</span><span id="VMapTrace.move_vmap_dim-1577"><a href="#VMapTrace.move_vmap_dim-1577"><span class="linenos">1577</span></a>            <span class="n">perm</span> <span class="o">=</span> <span class="p">[</span><span class="n">i</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">shape</span><span class="p">))</span> <span class="k">if</span> <span class="n">i</span> <span class="o">!=</span> <span class="n">src</span><span class="p">]</span>
</span><span id="VMapTrace.move_vmap_dim-1578"><a href="#VMapTrace.move_vmap_dim-1578"><span class="linenos">1578</span></a>            <span class="n">perm</span><span class="o">.</span><span class="n">insert</span><span class="p">(</span><span class="n">dst</span><span class="p">,</span> <span class="n">src</span><span class="p">)</span>
</span><span id="VMapTrace.move_vmap_dim-1579"><a href="#VMapTrace.move_vmap_dim-1579"><span class="linenos">1579</span></a>            <span class="k">return</span> <span class="n">x</span><span class="o">.</span><span class="n">permute</span><span class="p">(</span><span class="nb">tuple</span><span class="p">(</span><span class="n">perm</span><span class="p">))</span>
</span></pre></div>


    

                            </div>
                            <div class="inherited">
                                <h5>Inherited Members</h5>
                                <dl>
                                    <div><dt><a href="#Trace">Trace</a></dt>
                                <dd id="VMapTrace.__init__" class="function"><a href="#Trace.__init__">Trace</a></dd>
                <dd id="VMapTrace.main" class="variable"><a href="#Trace.main">main</a></dd>

            </div>
                                </dl>
                            </div>
                </section>
                <section id="JVPTraceTensor">
                            <input id="JVPTraceTensor-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr class">
            
    <span class="def">class</span>
    <span class="name">JVPTraceTensor</span><wbr>(<span class="base"><a href="#TraceTensor">TraceTensor</a></span>):

                <label class="view-source-button" for="JVPTraceTensor-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#JVPTraceTensor"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="JVPTraceTensor-1582"><a href="#JVPTraceTensor-1582"><span class="linenos">1582</span></a><span class="k">class</span> <span class="nc">JVPTraceTensor</span><span class="p">(</span><span class="n">TraceTensor</span><span class="p">):</span>
</span><span id="JVPTraceTensor-1583"><a href="#JVPTraceTensor-1583"><span class="linenos">1583</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">trace</span><span class="p">,</span> <span class="n">primal</span><span class="p">,</span> <span class="n">tangent</span><span class="p">):</span>
</span><span id="JVPTraceTensor-1584"><a href="#JVPTraceTensor-1584"><span class="linenos">1584</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">_trace</span> <span class="o">=</span> <span class="n">trace</span>
</span><span id="JVPTraceTensor-1585"><a href="#JVPTraceTensor-1585"><span class="linenos">1585</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">primal</span> <span class="o">=</span> <span class="n">primal</span>
</span><span id="JVPTraceTensor-1586"><a href="#JVPTraceTensor-1586"><span class="linenos">1586</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">tangent</span> <span class="o">=</span> <span class="n">tangent</span>
</span><span id="JVPTraceTensor-1587"><a href="#JVPTraceTensor-1587"><span class="linenos">1587</span></a>
</span><span id="JVPTraceTensor-1588"><a href="#JVPTraceTensor-1588"><span class="linenos">1588</span></a>    <span class="nd">@property</span>
</span><span id="JVPTraceTensor-1589"><a href="#JVPTraceTensor-1589"><span class="linenos">1589</span></a>    <span class="k">def</span> <span class="nf">symval</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="JVPTraceTensor-1590"><a href="#JVPTraceTensor-1590"><span class="linenos">1590</span></a>        <span class="k">return</span> <span class="n">get_symval</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">primal</span><span class="p">)</span>
</span><span id="JVPTraceTensor-1591"><a href="#JVPTraceTensor-1591"><span class="linenos">1591</span></a>
</span><span id="JVPTraceTensor-1592"><a href="#JVPTraceTensor-1592"><span class="linenos">1592</span></a>    <span class="nd">@property</span>
</span><span id="JVPTraceTensor-1593"><a href="#JVPTraceTensor-1593"><span class="linenos">1593</span></a>    <span class="k">def</span> <span class="nf">val</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="JVPTraceTensor-1594"><a href="#JVPTraceTensor-1594"><span class="linenos">1594</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">primal</span>
</span><span id="JVPTraceTensor-1595"><a href="#JVPTraceTensor-1595"><span class="linenos">1595</span></a>
</span><span id="JVPTraceTensor-1596"><a href="#JVPTraceTensor-1596"><span class="linenos">1596</span></a>    <span class="nd">@property</span>
</span><span id="JVPTraceTensor-1597"><a href="#JVPTraceTensor-1597"><span class="linenos">1597</span></a>    <span class="k">def</span> <span class="nf">dtype</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="JVPTraceTensor-1598"><a href="#JVPTraceTensor-1598"><span class="linenos">1598</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">primal</span><span class="o">.</span><span class="n">dtype</span>
</span></pre></div>


    

                            <div id="JVPTraceTensor.__init__" class="classattr">
                                        <input id="JVPTraceTensor.__init__-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="name">JVPTraceTensor</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">trace</span>, </span><span class="param"><span class="n">primal</span>, </span><span class="param"><span class="n">tangent</span></span>)</span>

                <label class="view-source-button" for="JVPTraceTensor.__init__-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#JVPTraceTensor.__init__"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="JVPTraceTensor.__init__-1583"><a href="#JVPTraceTensor.__init__-1583"><span class="linenos">1583</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">trace</span><span class="p">,</span> <span class="n">primal</span><span class="p">,</span> <span class="n">tangent</span><span class="p">):</span>
</span><span id="JVPTraceTensor.__init__-1584"><a href="#JVPTraceTensor.__init__-1584"><span class="linenos">1584</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">_trace</span> <span class="o">=</span> <span class="n">trace</span>
</span><span id="JVPTraceTensor.__init__-1585"><a href="#JVPTraceTensor.__init__-1585"><span class="linenos">1585</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">primal</span> <span class="o">=</span> <span class="n">primal</span>
</span><span id="JVPTraceTensor.__init__-1586"><a href="#JVPTraceTensor.__init__-1586"><span class="linenos">1586</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">tangent</span> <span class="o">=</span> <span class="n">tangent</span>
</span></pre></div>


    

                            </div>
                            <div id="JVPTraceTensor.primal" class="classattr">
                                <div class="attr variable">
            <span class="name">primal</span>

        
    </div>
    <a class="headerlink" href="#JVPTraceTensor.primal"></a>
    
    

                            </div>
                            <div id="JVPTraceTensor.tangent" class="classattr">
                                <div class="attr variable">
            <span class="name">tangent</span>

        
    </div>
    <a class="headerlink" href="#JVPTraceTensor.tangent"></a>
    
    

                            </div>
                            <div id="JVPTraceTensor.symval" class="classattr">
                                        <input id="JVPTraceTensor.symval-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr variable">
            <span class="name">symval</span>

                <label class="view-source-button" for="JVPTraceTensor.symval-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#JVPTraceTensor.symval"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="JVPTraceTensor.symval-1588"><a href="#JVPTraceTensor.symval-1588"><span class="linenos">1588</span></a>    <span class="nd">@property</span>
</span><span id="JVPTraceTensor.symval-1589"><a href="#JVPTraceTensor.symval-1589"><span class="linenos">1589</span></a>    <span class="k">def</span> <span class="nf">symval</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="JVPTraceTensor.symval-1590"><a href="#JVPTraceTensor.symval-1590"><span class="linenos">1590</span></a>        <span class="k">return</span> <span class="n">get_symval</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">primal</span><span class="p">)</span>
</span></pre></div>


    

                            </div>
                            <div id="JVPTraceTensor.val" class="classattr">
                                        <input id="JVPTraceTensor.val-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr variable">
            <span class="name">val</span>

                <label class="view-source-button" for="JVPTraceTensor.val-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#JVPTraceTensor.val"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="JVPTraceTensor.val-1592"><a href="#JVPTraceTensor.val-1592"><span class="linenos">1592</span></a>    <span class="nd">@property</span>
</span><span id="JVPTraceTensor.val-1593"><a href="#JVPTraceTensor.val-1593"><span class="linenos">1593</span></a>    <span class="k">def</span> <span class="nf">val</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="JVPTraceTensor.val-1594"><a href="#JVPTraceTensor.val-1594"><span class="linenos">1594</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">primal</span>
</span></pre></div>


    

                            </div>
                            <div id="JVPTraceTensor.dtype" class="classattr">
                                        <input id="JVPTraceTensor.dtype-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr variable">
            <span class="name">dtype</span>

                <label class="view-source-button" for="JVPTraceTensor.dtype-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#JVPTraceTensor.dtype"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="JVPTraceTensor.dtype-1596"><a href="#JVPTraceTensor.dtype-1596"><span class="linenos">1596</span></a>    <span class="nd">@property</span>
</span><span id="JVPTraceTensor.dtype-1597"><a href="#JVPTraceTensor.dtype-1597"><span class="linenos">1597</span></a>    <span class="k">def</span> <span class="nf">dtype</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="JVPTraceTensor.dtype-1598"><a href="#JVPTraceTensor.dtype-1598"><span class="linenos">1598</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">primal</span><span class="o">.</span><span class="n">dtype</span>
</span></pre></div>


    

                            </div>
                            <div class="inherited">
                                <h5>Inherited Members</h5>
                                <dl>
                                    <div><dt><a href="#TraceTensor">TraceTensor</a></dt>
                                <dd id="JVPTraceTensor.PYTHON_TYPES" class="variable"><a href="#TraceTensor.PYTHON_TYPES">PYTHON_TYPES</a></dd>
                <dd id="JVPTraceTensor.shape" class="variable"><a href="#TraceTensor.shape">shape</a></dd>
                <dd id="JVPTraceTensor.device" class="variable"><a href="#TraceTensor.device">device</a></dd>
                <dd id="JVPTraceTensor.full_lower" class="function"><a href="#TraceTensor.full_lower">full_lower</a></dd>
                <dd id="JVPTraceTensor.ndim" class="variable"><a href="#TraceTensor.ndim">ndim</a></dd>

            </div>
            <div><dt><a href="#Tensor">Tensor</a></dt>
                                <dd id="JVPTraceTensor.buf" class="variable"><a href="#Tensor.buf">buf</a></dd>
                <dd id="JVPTraceTensor.default_dtype" class="variable"><a href="#Tensor.default_dtype">default_dtype</a></dd>
                <dd id="JVPTraceTensor.is_int" class="function"><a href="#Tensor.is_int">is_int</a></dd>
                <dd id="JVPTraceTensor.is_float" class="function"><a href="#Tensor.is_float">is_float</a></dd>
                <dd id="JVPTraceTensor.is_unsigned" class="function"><a href="#Tensor.is_unsigned">is_unsigned</a></dd>
                <dd id="JVPTraceTensor.to_bool" class="function"><a href="#Tensor.to_bool">to_bool</a></dd>
                <dd id="JVPTraceTensor.short" class="function"><a href="#Tensor.short">short</a></dd>
                <dd id="JVPTraceTensor.int" class="function"><a href="#Tensor.int">int</a></dd>
                <dd id="JVPTraceTensor.long" class="function"><a href="#Tensor.long">long</a></dd>
                <dd id="JVPTraceTensor.half" class="function"><a href="#Tensor.half">half</a></dd>
                <dd id="JVPTraceTensor.float" class="function"><a href="#Tensor.float">float</a></dd>
                <dd id="JVPTraceTensor.str_short" class="function"><a href="#Tensor.str_short">str_short</a></dd>
                <dd id="JVPTraceTensor.size" class="function"><a href="#Tensor.size">size</a></dd>
                <dd id="JVPTraceTensor.numpy" class="function"><a href="#Tensor.numpy">numpy</a></dd>
                <dd id="JVPTraceTensor.numel" class="function"><a href="#Tensor.numel">numel</a></dd>
                <dd id="JVPTraceTensor.element_size" class="function"><a href="#Tensor.element_size">element_size</a></dd>
                <dd id="JVPTraceTensor.nbytes" class="function"><a href="#Tensor.nbytes">nbytes</a></dd>

            </div>
                                </dl>
                            </div>
                </section>
                <section id="JVPTrace">
                            <input id="JVPTrace-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr class">
            
    <span class="def">class</span>
    <span class="name">JVPTrace</span><wbr>(<span class="base"><a href="#Trace">Trace</a></span>):

                <label class="view-source-button" for="JVPTrace-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#JVPTrace"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="JVPTrace-1601"><a href="#JVPTrace-1601"><span class="linenos">1601</span></a><span class="k">class</span> <span class="nc">JVPTrace</span><span class="p">(</span><span class="n">Trace</span><span class="p">):</span>
</span><span id="JVPTrace-1602"><a href="#JVPTrace-1602"><span class="linenos">1602</span></a>    <span class="k">def</span> <span class="nf">pure</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">val</span><span class="p">):</span>
</span><span id="JVPTrace-1603"><a href="#JVPTrace-1603"><span class="linenos">1603</span></a>        <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">val</span><span class="p">,</span> <span class="n">PartialRunTrace</span><span class="p">):</span>
</span><span id="JVPTrace-1604"><a href="#JVPTrace-1604"><span class="linenos">1604</span></a>            <span class="n">val</span> <span class="o">=</span> <span class="n">val</span><span class="o">.</span><span class="n">pval</span><span class="o">.</span><span class="n">const</span>
</span><span id="JVPTrace-1605"><a href="#JVPTrace-1605"><span class="linenos">1605</span></a>        <span class="k">return</span> <span class="n">JVPTraceTensor</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">val</span><span class="p">,</span> <span class="n">backend</span><span class="o">.</span><span class="n">zeros_like</span><span class="p">(</span><span class="n">val</span><span class="p">))</span>
</span><span id="JVPTrace-1606"><a href="#JVPTrace-1606"><span class="linenos">1606</span></a>
</span><span id="JVPTrace-1607"><a href="#JVPTrace-1607"><span class="linenos">1607</span></a>    <span class="k">def</span> <span class="nf">run_op</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">op</span><span class="p">,</span> <span class="n">tracers</span><span class="p">,</span> <span class="n">params</span><span class="p">):</span>
</span><span id="JVPTrace-1608"><a href="#JVPTrace-1608"><span class="linenos">1608</span></a>        <span class="n">primals_in</span><span class="p">,</span> <span class="n">tangents_in</span> <span class="o">=</span> <span class="n">unzip2</span><span class="p">((</span><span class="n">t</span><span class="o">.</span><span class="n">primal</span><span class="p">,</span> <span class="n">t</span><span class="o">.</span><span class="n">tangent</span><span class="p">)</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">tracers</span><span class="p">)</span>
</span><span id="JVPTrace-1609"><a href="#JVPTrace-1609"><span class="linenos">1609</span></a>        <span class="n">primals_out</span><span class="p">,</span> <span class="n">tangents_out</span> <span class="o">=</span> <span class="n">op</span><span class="o">.</span><span class="n">jvp</span><span class="p">(</span><span class="n">primals_in</span><span class="p">,</span> <span class="n">tangents_in</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)</span>
</span><span id="JVPTrace-1610"><a href="#JVPTrace-1610"><span class="linenos">1610</span></a>        <span class="k">return</span> <span class="p">[</span><span class="n">JVPTraceTensor</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">x</span><span class="p">,</span> <span class="n">t</span><span class="p">)</span> <span class="k">for</span> <span class="n">x</span><span class="p">,</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">list_zip</span><span class="p">(</span><span class="n">primals_out</span><span class="p">,</span> <span class="n">tangents_out</span><span class="p">)]</span>
</span></pre></div>


    

                            <div id="JVPTrace.pure" class="classattr">
                                        <input id="JVPTrace.pure-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">pure</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="n">val</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="JVPTrace.pure-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#JVPTrace.pure"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="JVPTrace.pure-1602"><a href="#JVPTrace.pure-1602"><span class="linenos">1602</span></a>    <span class="k">def</span> <span class="nf">pure</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">val</span><span class="p">):</span>
</span><span id="JVPTrace.pure-1603"><a href="#JVPTrace.pure-1603"><span class="linenos">1603</span></a>        <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">val</span><span class="p">,</span> <span class="n">PartialRunTrace</span><span class="p">):</span>
</span><span id="JVPTrace.pure-1604"><a href="#JVPTrace.pure-1604"><span class="linenos">1604</span></a>            <span class="n">val</span> <span class="o">=</span> <span class="n">val</span><span class="o">.</span><span class="n">pval</span><span class="o">.</span><span class="n">const</span>
</span><span id="JVPTrace.pure-1605"><a href="#JVPTrace.pure-1605"><span class="linenos">1605</span></a>        <span class="k">return</span> <span class="n">JVPTraceTensor</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">val</span><span class="p">,</span> <span class="n">backend</span><span class="o">.</span><span class="n">zeros_like</span><span class="p">(</span><span class="n">val</span><span class="p">))</span>
</span></pre></div>


    

                            </div>
                            <div id="JVPTrace.run_op" class="classattr">
                                        <input id="JVPTrace.run_op-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">run_op</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="n">op</span>, </span><span class="param"><span class="n">tracers</span>, </span><span class="param"><span class="n">params</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="JVPTrace.run_op-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#JVPTrace.run_op"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="JVPTrace.run_op-1607"><a href="#JVPTrace.run_op-1607"><span class="linenos">1607</span></a>    <span class="k">def</span> <span class="nf">run_op</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">op</span><span class="p">,</span> <span class="n">tracers</span><span class="p">,</span> <span class="n">params</span><span class="p">):</span>
</span><span id="JVPTrace.run_op-1608"><a href="#JVPTrace.run_op-1608"><span class="linenos">1608</span></a>        <span class="n">primals_in</span><span class="p">,</span> <span class="n">tangents_in</span> <span class="o">=</span> <span class="n">unzip2</span><span class="p">((</span><span class="n">t</span><span class="o">.</span><span class="n">primal</span><span class="p">,</span> <span class="n">t</span><span class="o">.</span><span class="n">tangent</span><span class="p">)</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">tracers</span><span class="p">)</span>
</span><span id="JVPTrace.run_op-1609"><a href="#JVPTrace.run_op-1609"><span class="linenos">1609</span></a>        <span class="n">primals_out</span><span class="p">,</span> <span class="n">tangents_out</span> <span class="o">=</span> <span class="n">op</span><span class="o">.</span><span class="n">jvp</span><span class="p">(</span><span class="n">primals_in</span><span class="p">,</span> <span class="n">tangents_in</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)</span>
</span><span id="JVPTrace.run_op-1610"><a href="#JVPTrace.run_op-1610"><span class="linenos">1610</span></a>        <span class="k">return</span> <span class="p">[</span><span class="n">JVPTraceTensor</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">x</span><span class="p">,</span> <span class="n">t</span><span class="p">)</span> <span class="k">for</span> <span class="n">x</span><span class="p">,</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">list_zip</span><span class="p">(</span><span class="n">primals_out</span><span class="p">,</span> <span class="n">tangents_out</span><span class="p">)]</span>
</span></pre></div>


    

                            </div>
                            <div class="inherited">
                                <h5>Inherited Members</h5>
                                <dl>
                                    <div><dt><a href="#Trace">Trace</a></dt>
                                <dd id="JVPTrace.__init__" class="function"><a href="#Trace.__init__">Trace</a></dd>
                <dd id="JVPTrace.main" class="variable"><a href="#Trace.main">main</a></dd>

            </div>
                                </dl>
                            </div>
                </section>
                <section id="ProgramTraceTensor">
                            <input id="ProgramTraceTensor-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr class">
            
    <span class="def">class</span>
    <span class="name">ProgramTraceTensor</span><wbr>(<span class="base"><a href="#TraceTensor">TraceTensor</a></span>):

                <label class="view-source-button" for="ProgramTraceTensor-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#ProgramTraceTensor"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="ProgramTraceTensor-1613"><a href="#ProgramTraceTensor-1613"><span class="linenos">1613</span></a><span class="k">class</span> <span class="nc">ProgramTraceTensor</span><span class="p">(</span><span class="n">TraceTensor</span><span class="p">):</span>
</span><span id="ProgramTraceTensor-1614"><a href="#ProgramTraceTensor-1614"><span class="linenos">1614</span></a>    <span class="vm">__slots__</span> <span class="o">=</span> <span class="p">[</span><span class="s2">&quot;symval&quot;</span><span class="p">]</span>
</span><span id="ProgramTraceTensor-1615"><a href="#ProgramTraceTensor-1615"><span class="linenos">1615</span></a>    <span class="n">symval</span><span class="p">:</span> <span class="n">SymbolicTensor</span>
</span><span id="ProgramTraceTensor-1616"><a href="#ProgramTraceTensor-1616"><span class="linenos">1616</span></a>
</span><span id="ProgramTraceTensor-1617"><a href="#ProgramTraceTensor-1617"><span class="linenos">1617</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">trace</span><span class="p">,</span> <span class="n">symval</span><span class="p">):</span>
</span><span id="ProgramTraceTensor-1618"><a href="#ProgramTraceTensor-1618"><span class="linenos">1618</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">_trace</span> <span class="o">=</span> <span class="n">trace</span>
</span><span id="ProgramTraceTensor-1619"><a href="#ProgramTraceTensor-1619"><span class="linenos">1619</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">symval</span> <span class="o">=</span> <span class="n">symval</span>
</span></pre></div>


    

                            <div id="ProgramTraceTensor.__init__" class="classattr">
                                        <input id="ProgramTraceTensor.__init__-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="name">ProgramTraceTensor</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">trace</span>, </span><span class="param"><span class="n">symval</span></span>)</span>

                <label class="view-source-button" for="ProgramTraceTensor.__init__-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#ProgramTraceTensor.__init__"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="ProgramTraceTensor.__init__-1617"><a href="#ProgramTraceTensor.__init__-1617"><span class="linenos">1617</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">trace</span><span class="p">,</span> <span class="n">symval</span><span class="p">):</span>
</span><span id="ProgramTraceTensor.__init__-1618"><a href="#ProgramTraceTensor.__init__-1618"><span class="linenos">1618</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">_trace</span> <span class="o">=</span> <span class="n">trace</span>
</span><span id="ProgramTraceTensor.__init__-1619"><a href="#ProgramTraceTensor.__init__-1619"><span class="linenos">1619</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">symval</span> <span class="o">=</span> <span class="n">symval</span>
</span></pre></div>


    

                            </div>
                            <div id="ProgramTraceTensor.symval" class="classattr">
                                <div class="attr variable">
            <span class="name">symval</span><span class="annotation">: <a href="#SymbolicTensor">SymbolicTensor</a></span>

        
    </div>
    <a class="headerlink" href="#ProgramTraceTensor.symval"></a>
    
    

                            </div>
                            <div class="inherited">
                                <h5>Inherited Members</h5>
                                <dl>
                                    <div><dt><a href="#TraceTensor">TraceTensor</a></dt>
                                <dd id="ProgramTraceTensor.PYTHON_TYPES" class="variable"><a href="#TraceTensor.PYTHON_TYPES">PYTHON_TYPES</a></dd>
                <dd id="ProgramTraceTensor.dtype" class="variable"><a href="#TraceTensor.dtype">dtype</a></dd>
                <dd id="ProgramTraceTensor.shape" class="variable"><a href="#TraceTensor.shape">shape</a></dd>
                <dd id="ProgramTraceTensor.device" class="variable"><a href="#TraceTensor.device">device</a></dd>
                <dd id="ProgramTraceTensor.val" class="variable"><a href="#TraceTensor.val">val</a></dd>
                <dd id="ProgramTraceTensor.full_lower" class="function"><a href="#TraceTensor.full_lower">full_lower</a></dd>
                <dd id="ProgramTraceTensor.ndim" class="variable"><a href="#TraceTensor.ndim">ndim</a></dd>

            </div>
            <div><dt><a href="#Tensor">Tensor</a></dt>
                                <dd id="ProgramTraceTensor.buf" class="variable"><a href="#Tensor.buf">buf</a></dd>
                <dd id="ProgramTraceTensor.default_dtype" class="variable"><a href="#Tensor.default_dtype">default_dtype</a></dd>
                <dd id="ProgramTraceTensor.is_int" class="function"><a href="#Tensor.is_int">is_int</a></dd>
                <dd id="ProgramTraceTensor.is_float" class="function"><a href="#Tensor.is_float">is_float</a></dd>
                <dd id="ProgramTraceTensor.is_unsigned" class="function"><a href="#Tensor.is_unsigned">is_unsigned</a></dd>
                <dd id="ProgramTraceTensor.to_bool" class="function"><a href="#Tensor.to_bool">to_bool</a></dd>
                <dd id="ProgramTraceTensor.short" class="function"><a href="#Tensor.short">short</a></dd>
                <dd id="ProgramTraceTensor.int" class="function"><a href="#Tensor.int">int</a></dd>
                <dd id="ProgramTraceTensor.long" class="function"><a href="#Tensor.long">long</a></dd>
                <dd id="ProgramTraceTensor.half" class="function"><a href="#Tensor.half">half</a></dd>
                <dd id="ProgramTraceTensor.float" class="function"><a href="#Tensor.float">float</a></dd>
                <dd id="ProgramTraceTensor.str_short" class="function"><a href="#Tensor.str_short">str_short</a></dd>
                <dd id="ProgramTraceTensor.size" class="function"><a href="#Tensor.size">size</a></dd>
                <dd id="ProgramTraceTensor.numpy" class="function"><a href="#Tensor.numpy">numpy</a></dd>
                <dd id="ProgramTraceTensor.numel" class="function"><a href="#Tensor.numel">numel</a></dd>
                <dd id="ProgramTraceTensor.element_size" class="function"><a href="#Tensor.element_size">element_size</a></dd>
                <dd id="ProgramTraceTensor.nbytes" class="function"><a href="#Tensor.nbytes">nbytes</a></dd>

            </div>
                                </dl>
                            </div>
                </section>
                <section id="ProgramTrace">
                            <input id="ProgramTrace-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr class">
            
    <span class="def">class</span>
    <span class="name">ProgramTrace</span><wbr>(<span class="base"><a href="#Trace">Trace</a></span>):

                <label class="view-source-button" for="ProgramTrace-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#ProgramTrace"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="ProgramTrace-1622"><a href="#ProgramTrace-1622"><span class="linenos">1622</span></a><span class="k">class</span> <span class="nc">ProgramTrace</span><span class="p">(</span><span class="n">Trace</span><span class="p">):</span>
</span><span id="ProgramTrace-1623"><a href="#ProgramTrace-1623"><span class="linenos">1623</span></a>    <span class="nd">@property</span>
</span><span id="ProgramTrace-1624"><a href="#ProgramTrace-1624"><span class="linenos">1624</span></a>    <span class="k">def</span> <span class="nf">builder</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="ProgramTrace-1625"><a href="#ProgramTrace-1625"><span class="linenos">1625</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">main</span><span class="o">.</span><span class="n">global_data</span>
</span><span id="ProgramTrace-1626"><a href="#ProgramTrace-1626"><span class="linenos">1626</span></a>
</span><span id="ProgramTrace-1627"><a href="#ProgramTrace-1627"><span class="linenos">1627</span></a>    <span class="k">def</span> <span class="nf">new_arg</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">symval</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">ProgramTraceTensor</span><span class="p">:</span>
</span><span id="ProgramTrace-1628"><a href="#ProgramTrace-1628"><span class="linenos">1628</span></a>        <span class="n">symval</span> <span class="o">=</span> <span class="n">SymbolicTensor</span><span class="o">.</span><span class="n">like</span><span class="p">(</span><span class="n">symval</span><span class="p">)</span>
</span><span id="ProgramTrace-1629"><a href="#ProgramTrace-1629"><span class="linenos">1629</span></a>        <span class="n">tracer</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">builder</span><span class="o">.</span><span class="n">new_tracer</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">symval</span><span class="p">)</span>
</span><span id="ProgramTrace-1630"><a href="#ProgramTrace-1630"><span class="linenos">1630</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">builder</span><span class="o">.</span><span class="n">tracer_to_var</span><span class="p">[</span><span class="nb">id</span><span class="p">(</span><span class="n">tracer</span><span class="p">)]</span> <span class="o">=</span> <span class="n">Var</span><span class="p">(</span><span class="n">symval</span><span class="p">)</span>
</span><span id="ProgramTrace-1631"><a href="#ProgramTrace-1631"><span class="linenos">1631</span></a>
</span><span id="ProgramTrace-1632"><a href="#ProgramTrace-1632"><span class="linenos">1632</span></a>        <span class="k">return</span> <span class="n">tracer</span>
</span><span id="ProgramTrace-1633"><a href="#ProgramTrace-1633"><span class="linenos">1633</span></a>
</span><span id="ProgramTrace-1634"><a href="#ProgramTrace-1634"><span class="linenos">1634</span></a>    <span class="k">def</span> <span class="nf">pure</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">val</span><span class="p">:</span> <span class="n">Any</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">ProgramTraceTensor</span><span class="p">:</span>
</span><span id="ProgramTrace-1635"><a href="#ProgramTrace-1635"><span class="linenos">1635</span></a>        <span class="c1"># get_or_make_const_tracer</span>
</span><span id="ProgramTrace-1636"><a href="#ProgramTrace-1636"><span class="linenos">1636</span></a>        <span class="n">tracer</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">builder</span><span class="o">.</span><span class="n">const_tracers</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="nb">id</span><span class="p">(</span><span class="n">val</span><span class="p">))</span>
</span><span id="ProgramTrace-1637"><a href="#ProgramTrace-1637"><span class="linenos">1637</span></a>        <span class="k">if</span> <span class="n">tracer</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
</span><span id="ProgramTrace-1638"><a href="#ProgramTrace-1638"><span class="linenos">1638</span></a>            <span class="n">tracer</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">builder</span><span class="o">.</span><span class="n">new_tracer</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">get_symval</span><span class="p">(</span><span class="n">val</span><span class="p">))</span>
</span><span id="ProgramTrace-1639"><a href="#ProgramTrace-1639"><span class="linenos">1639</span></a>            <span class="bp">self</span><span class="o">.</span><span class="n">builder</span><span class="o">.</span><span class="n">add_const</span><span class="p">(</span><span class="n">tracer</span><span class="p">,</span> <span class="n">val</span><span class="p">)</span>
</span><span id="ProgramTrace-1640"><a href="#ProgramTrace-1640"><span class="linenos">1640</span></a>        <span class="c1"># print(self.builder.const_tracers)</span>
</span><span id="ProgramTrace-1641"><a href="#ProgramTrace-1641"><span class="linenos">1641</span></a>        <span class="k">return</span> <span class="n">tracer</span>
</span><span id="ProgramTrace-1642"><a href="#ProgramTrace-1642"><span class="linenos">1642</span></a>
</span><span id="ProgramTrace-1643"><a href="#ProgramTrace-1643"><span class="linenos">1643</span></a>    <span class="k">def</span> <span class="nf">run_op</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">op</span><span class="p">,</span> <span class="n">tracers</span><span class="p">,</span> <span class="n">params</span><span class="p">):</span>
</span><span id="ProgramTrace-1644"><a href="#ProgramTrace-1644"><span class="linenos">1644</span></a>        <span class="n">symvals_in</span> <span class="o">=</span> <span class="n">tree_map</span><span class="p">(</span><span class="k">lambda</span> <span class="n">x</span><span class="p">:</span> <span class="n">x</span><span class="o">.</span><span class="n">symval</span><span class="p">,</span> <span class="n">tracers</span><span class="p">)</span>
</span><span id="ProgramTrace-1645"><a href="#ProgramTrace-1645"><span class="linenos">1645</span></a>        <span class="n">symvals_out</span> <span class="o">=</span> <span class="n">op</span><span class="o">.</span><span class="n">typecheck</span><span class="p">(</span><span class="o">*</span><span class="n">symvals_in</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)</span>
</span><span id="ProgramTrace-1646"><a href="#ProgramTrace-1646"><span class="linenos">1646</span></a>
</span><span id="ProgramTrace-1647"><a href="#ProgramTrace-1647"><span class="linenos">1647</span></a>        <span class="n">out_tracers</span> <span class="o">=</span> <span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">builder</span><span class="o">.</span><span class="n">new_tracer</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">a</span><span class="p">)</span> <span class="k">for</span> <span class="n">a</span> <span class="ow">in</span> <span class="n">symvals_out</span><span class="p">]</span>
</span><span id="ProgramTrace-1648"><a href="#ProgramTrace-1648"><span class="linenos">1648</span></a>        <span class="n">inputs</span> <span class="o">=</span> <span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">builder</span><span class="o">.</span><span class="n">getvar</span><span class="p">(</span><span class="n">t</span><span class="p">)</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">tracers</span><span class="p">]</span>
</span><span id="ProgramTrace-1649"><a href="#ProgramTrace-1649"><span class="linenos">1649</span></a>        <span class="n">outvars</span> <span class="o">=</span> <span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">builder</span><span class="o">.</span><span class="n">add_var</span><span class="p">(</span><span class="n">t</span><span class="p">)</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">out_tracers</span><span class="p">]</span>
</span><span id="ProgramTrace-1650"><a href="#ProgramTrace-1650"><span class="linenos">1650</span></a>
</span><span id="ProgramTrace-1651"><a href="#ProgramTrace-1651"><span class="linenos">1651</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">builder</span><span class="o">.</span><span class="n">add_instruction</span><span class="p">(</span><span class="n">Instruction</span><span class="p">(</span><span class="n">op</span><span class="p">,</span> <span class="n">inputs</span><span class="p">,</span> <span class="n">params</span><span class="p">,</span> <span class="n">outvars</span><span class="p">))</span>
</span><span id="ProgramTrace-1652"><a href="#ProgramTrace-1652"><span class="linenos">1652</span></a>        <span class="k">return</span> <span class="n">out_tracers</span>
</span></pre></div>


    

                            <div id="ProgramTrace.builder" class="classattr">
                                        <input id="ProgramTrace.builder-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr variable">
            <span class="name">builder</span>

                <label class="view-source-button" for="ProgramTrace.builder-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#ProgramTrace.builder"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="ProgramTrace.builder-1623"><a href="#ProgramTrace.builder-1623"><span class="linenos">1623</span></a>    <span class="nd">@property</span>
</span><span id="ProgramTrace.builder-1624"><a href="#ProgramTrace.builder-1624"><span class="linenos">1624</span></a>    <span class="k">def</span> <span class="nf">builder</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="ProgramTrace.builder-1625"><a href="#ProgramTrace.builder-1625"><span class="linenos">1625</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">main</span><span class="o">.</span><span class="n">global_data</span>
</span></pre></div>


    

                            </div>
                            <div id="ProgramTrace.new_arg" class="classattr">
                                        <input id="ProgramTrace.new_arg-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">new_arg</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="n">symval</span></span><span class="return-annotation">) -> <span class="n"><a href="#ProgramTraceTensor">ProgramTraceTensor</a></span>:</span></span>

                <label class="view-source-button" for="ProgramTrace.new_arg-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#ProgramTrace.new_arg"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="ProgramTrace.new_arg-1627"><a href="#ProgramTrace.new_arg-1627"><span class="linenos">1627</span></a>    <span class="k">def</span> <span class="nf">new_arg</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">symval</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">ProgramTraceTensor</span><span class="p">:</span>
</span><span id="ProgramTrace.new_arg-1628"><a href="#ProgramTrace.new_arg-1628"><span class="linenos">1628</span></a>        <span class="n">symval</span> <span class="o">=</span> <span class="n">SymbolicTensor</span><span class="o">.</span><span class="n">like</span><span class="p">(</span><span class="n">symval</span><span class="p">)</span>
</span><span id="ProgramTrace.new_arg-1629"><a href="#ProgramTrace.new_arg-1629"><span class="linenos">1629</span></a>        <span class="n">tracer</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">builder</span><span class="o">.</span><span class="n">new_tracer</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">symval</span><span class="p">)</span>
</span><span id="ProgramTrace.new_arg-1630"><a href="#ProgramTrace.new_arg-1630"><span class="linenos">1630</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">builder</span><span class="o">.</span><span class="n">tracer_to_var</span><span class="p">[</span><span class="nb">id</span><span class="p">(</span><span class="n">tracer</span><span class="p">)]</span> <span class="o">=</span> <span class="n">Var</span><span class="p">(</span><span class="n">symval</span><span class="p">)</span>
</span><span id="ProgramTrace.new_arg-1631"><a href="#ProgramTrace.new_arg-1631"><span class="linenos">1631</span></a>
</span><span id="ProgramTrace.new_arg-1632"><a href="#ProgramTrace.new_arg-1632"><span class="linenos">1632</span></a>        <span class="k">return</span> <span class="n">tracer</span>
</span></pre></div>


    

                            </div>
                            <div id="ProgramTrace.pure" class="classattr">
                                        <input id="ProgramTrace.pure-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">pure</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="n">val</span><span class="p">:</span> <span class="n">Any</span></span><span class="return-annotation">) -> <span class="n"><a href="#ProgramTraceTensor">ProgramTraceTensor</a></span>:</span></span>

                <label class="view-source-button" for="ProgramTrace.pure-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#ProgramTrace.pure"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="ProgramTrace.pure-1634"><a href="#ProgramTrace.pure-1634"><span class="linenos">1634</span></a>    <span class="k">def</span> <span class="nf">pure</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">val</span><span class="p">:</span> <span class="n">Any</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">ProgramTraceTensor</span><span class="p">:</span>
</span><span id="ProgramTrace.pure-1635"><a href="#ProgramTrace.pure-1635"><span class="linenos">1635</span></a>        <span class="c1"># get_or_make_const_tracer</span>
</span><span id="ProgramTrace.pure-1636"><a href="#ProgramTrace.pure-1636"><span class="linenos">1636</span></a>        <span class="n">tracer</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">builder</span><span class="o">.</span><span class="n">const_tracers</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="nb">id</span><span class="p">(</span><span class="n">val</span><span class="p">))</span>
</span><span id="ProgramTrace.pure-1637"><a href="#ProgramTrace.pure-1637"><span class="linenos">1637</span></a>        <span class="k">if</span> <span class="n">tracer</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
</span><span id="ProgramTrace.pure-1638"><a href="#ProgramTrace.pure-1638"><span class="linenos">1638</span></a>            <span class="n">tracer</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">builder</span><span class="o">.</span><span class="n">new_tracer</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">get_symval</span><span class="p">(</span><span class="n">val</span><span class="p">))</span>
</span><span id="ProgramTrace.pure-1639"><a href="#ProgramTrace.pure-1639"><span class="linenos">1639</span></a>            <span class="bp">self</span><span class="o">.</span><span class="n">builder</span><span class="o">.</span><span class="n">add_const</span><span class="p">(</span><span class="n">tracer</span><span class="p">,</span> <span class="n">val</span><span class="p">)</span>
</span><span id="ProgramTrace.pure-1640"><a href="#ProgramTrace.pure-1640"><span class="linenos">1640</span></a>        <span class="c1"># print(self.builder.const_tracers)</span>
</span><span id="ProgramTrace.pure-1641"><a href="#ProgramTrace.pure-1641"><span class="linenos">1641</span></a>        <span class="k">return</span> <span class="n">tracer</span>
</span></pre></div>


    

                            </div>
                            <div id="ProgramTrace.run_op" class="classattr">
                                        <input id="ProgramTrace.run_op-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">run_op</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="n">op</span>, </span><span class="param"><span class="n">tracers</span>, </span><span class="param"><span class="n">params</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="ProgramTrace.run_op-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#ProgramTrace.run_op"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="ProgramTrace.run_op-1643"><a href="#ProgramTrace.run_op-1643"><span class="linenos">1643</span></a>    <span class="k">def</span> <span class="nf">run_op</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">op</span><span class="p">,</span> <span class="n">tracers</span><span class="p">,</span> <span class="n">params</span><span class="p">):</span>
</span><span id="ProgramTrace.run_op-1644"><a href="#ProgramTrace.run_op-1644"><span class="linenos">1644</span></a>        <span class="n">symvals_in</span> <span class="o">=</span> <span class="n">tree_map</span><span class="p">(</span><span class="k">lambda</span> <span class="n">x</span><span class="p">:</span> <span class="n">x</span><span class="o">.</span><span class="n">symval</span><span class="p">,</span> <span class="n">tracers</span><span class="p">)</span>
</span><span id="ProgramTrace.run_op-1645"><a href="#ProgramTrace.run_op-1645"><span class="linenos">1645</span></a>        <span class="n">symvals_out</span> <span class="o">=</span> <span class="n">op</span><span class="o">.</span><span class="n">typecheck</span><span class="p">(</span><span class="o">*</span><span class="n">symvals_in</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)</span>
</span><span id="ProgramTrace.run_op-1646"><a href="#ProgramTrace.run_op-1646"><span class="linenos">1646</span></a>
</span><span id="ProgramTrace.run_op-1647"><a href="#ProgramTrace.run_op-1647"><span class="linenos">1647</span></a>        <span class="n">out_tracers</span> <span class="o">=</span> <span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">builder</span><span class="o">.</span><span class="n">new_tracer</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">a</span><span class="p">)</span> <span class="k">for</span> <span class="n">a</span> <span class="ow">in</span> <span class="n">symvals_out</span><span class="p">]</span>
</span><span id="ProgramTrace.run_op-1648"><a href="#ProgramTrace.run_op-1648"><span class="linenos">1648</span></a>        <span class="n">inputs</span> <span class="o">=</span> <span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">builder</span><span class="o">.</span><span class="n">getvar</span><span class="p">(</span><span class="n">t</span><span class="p">)</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">tracers</span><span class="p">]</span>
</span><span id="ProgramTrace.run_op-1649"><a href="#ProgramTrace.run_op-1649"><span class="linenos">1649</span></a>        <span class="n">outvars</span> <span class="o">=</span> <span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">builder</span><span class="o">.</span><span class="n">add_var</span><span class="p">(</span><span class="n">t</span><span class="p">)</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">out_tracers</span><span class="p">]</span>
</span><span id="ProgramTrace.run_op-1650"><a href="#ProgramTrace.run_op-1650"><span class="linenos">1650</span></a>
</span><span id="ProgramTrace.run_op-1651"><a href="#ProgramTrace.run_op-1651"><span class="linenos">1651</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">builder</span><span class="o">.</span><span class="n">add_instruction</span><span class="p">(</span><span class="n">Instruction</span><span class="p">(</span><span class="n">op</span><span class="p">,</span> <span class="n">inputs</span><span class="p">,</span> <span class="n">params</span><span class="p">,</span> <span class="n">outvars</span><span class="p">))</span>
</span><span id="ProgramTrace.run_op-1652"><a href="#ProgramTrace.run_op-1652"><span class="linenos">1652</span></a>        <span class="k">return</span> <span class="n">out_tracers</span>
</span></pre></div>


    

                            </div>
                            <div class="inherited">
                                <h5>Inherited Members</h5>
                                <dl>
                                    <div><dt><a href="#Trace">Trace</a></dt>
                                <dd id="ProgramTrace.__init__" class="function"><a href="#Trace.__init__">Trace</a></dd>
                <dd id="ProgramTrace.main" class="variable"><a href="#Trace.main">main</a></dd>

            </div>
                                </dl>
                            </div>
                </section>
                <section id="ProgramBuilder">
                            <input id="ProgramBuilder-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr class">
            
    <span class="def">class</span>
    <span class="name">ProgramBuilder</span>:

                <label class="view-source-button" for="ProgramBuilder-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#ProgramBuilder"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="ProgramBuilder-1655"><a href="#ProgramBuilder-1655"><span class="linenos">1655</span></a><span class="k">class</span> <span class="nc">ProgramBuilder</span><span class="p">:</span>
</span><span id="ProgramBuilder-1656"><a href="#ProgramBuilder-1656"><span class="linenos">1656</span></a>    <span class="n">instructions</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">Instruction</span><span class="p">]</span>
</span><span id="ProgramBuilder-1657"><a href="#ProgramBuilder-1657"><span class="linenos">1657</span></a>    <span class="n">tracer_to_var</span><span class="p">:</span> <span class="n">Dict</span><span class="p">[</span><span class="nb">int</span><span class="p">,</span> <span class="n">Var</span><span class="p">]</span>
</span><span id="ProgramBuilder-1658"><a href="#ProgramBuilder-1658"><span class="linenos">1658</span></a>    <span class="n">const_tracers</span><span class="p">:</span> <span class="n">Dict</span><span class="p">[</span><span class="nb">int</span><span class="p">,</span> <span class="n">TraceTensor</span><span class="p">]</span>
</span><span id="ProgramBuilder-1659"><a href="#ProgramBuilder-1659"><span class="linenos">1659</span></a>    <span class="n">constvals</span><span class="p">:</span> <span class="n">Dict</span><span class="p">[</span><span class="n">Var</span><span class="p">,</span> <span class="n">Any</span><span class="p">]</span>
</span><span id="ProgramBuilder-1660"><a href="#ProgramBuilder-1660"><span class="linenos">1660</span></a>    <span class="n">tracers</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">ProgramTraceTensor</span><span class="p">]</span>
</span><span id="ProgramBuilder-1661"><a href="#ProgramBuilder-1661"><span class="linenos">1661</span></a>
</span><span id="ProgramBuilder-1662"><a href="#ProgramBuilder-1662"><span class="linenos">1662</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="ProgramBuilder-1663"><a href="#ProgramBuilder-1663"><span class="linenos">1663</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">instructions</span> <span class="o">=</span> <span class="p">[]</span>
</span><span id="ProgramBuilder-1664"><a href="#ProgramBuilder-1664"><span class="linenos">1664</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">tracer_to_var</span> <span class="o">=</span> <span class="p">{}</span>
</span><span id="ProgramBuilder-1665"><a href="#ProgramBuilder-1665"><span class="linenos">1665</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">const_tracers</span> <span class="o">=</span> <span class="p">{}</span>
</span><span id="ProgramBuilder-1666"><a href="#ProgramBuilder-1666"><span class="linenos">1666</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">constvals</span> <span class="o">=</span> <span class="p">{}</span>
</span><span id="ProgramBuilder-1667"><a href="#ProgramBuilder-1667"><span class="linenos">1667</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">tracers</span> <span class="o">=</span> <span class="p">[]</span>
</span><span id="ProgramBuilder-1668"><a href="#ProgramBuilder-1668"><span class="linenos">1668</span></a>
</span><span id="ProgramBuilder-1669"><a href="#ProgramBuilder-1669"><span class="linenos">1669</span></a>    <span class="k">def</span> <span class="nf">new_tracer</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">trace</span><span class="p">:</span> <span class="n">ProgramTrace</span><span class="p">,</span> <span class="n">symval</span><span class="p">:</span> <span class="n">SymbolicTensor</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">ProgramTraceTensor</span><span class="p">:</span>
</span><span id="ProgramBuilder-1670"><a href="#ProgramBuilder-1670"><span class="linenos">1670</span></a>        <span class="n">tracer</span> <span class="o">=</span> <span class="n">ProgramTraceTensor</span><span class="p">(</span><span class="n">trace</span><span class="p">,</span> <span class="n">symval</span><span class="p">)</span>
</span><span id="ProgramBuilder-1671"><a href="#ProgramBuilder-1671"><span class="linenos">1671</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">tracers</span> <span class="o">+=</span> <span class="p">[</span><span class="n">tracer</span><span class="p">]</span>
</span><span id="ProgramBuilder-1672"><a href="#ProgramBuilder-1672"><span class="linenos">1672</span></a>        <span class="k">return</span> <span class="n">tracer</span>
</span><span id="ProgramBuilder-1673"><a href="#ProgramBuilder-1673"><span class="linenos">1673</span></a>
</span><span id="ProgramBuilder-1674"><a href="#ProgramBuilder-1674"><span class="linenos">1674</span></a>    <span class="k">def</span> <span class="nf">add_instruction</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">instruction</span><span class="p">:</span> <span class="n">Instruction</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="kc">None</span><span class="p">:</span>
</span><span id="ProgramBuilder-1675"><a href="#ProgramBuilder-1675"><span class="linenos">1675</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">instructions</span> <span class="o">+=</span> <span class="p">[</span><span class="n">instruction</span><span class="p">]</span>
</span><span id="ProgramBuilder-1676"><a href="#ProgramBuilder-1676"><span class="linenos">1676</span></a>
</span><span id="ProgramBuilder-1677"><a href="#ProgramBuilder-1677"><span class="linenos">1677</span></a>    <span class="k">def</span> <span class="nf">add_var</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">tracer</span><span class="p">:</span> <span class="n">ProgramTraceTensor</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Var</span><span class="p">:</span>
</span><span id="ProgramBuilder-1678"><a href="#ProgramBuilder-1678"><span class="linenos">1678</span></a>        <span class="k">assert</span> <span class="nb">id</span><span class="p">(</span><span class="n">tracer</span><span class="p">)</span> <span class="ow">not</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">tracer_to_var</span>
</span><span id="ProgramBuilder-1679"><a href="#ProgramBuilder-1679"><span class="linenos">1679</span></a>        <span class="n">var</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">tracer_to_var</span><span class="p">[</span><span class="nb">id</span><span class="p">(</span><span class="n">tracer</span><span class="p">)]</span> <span class="o">=</span> <span class="n">Var</span><span class="p">(</span><span class="n">tracer</span><span class="o">.</span><span class="n">symval</span><span class="p">)</span>
</span><span id="ProgramBuilder-1680"><a href="#ProgramBuilder-1680"><span class="linenos">1680</span></a>        <span class="k">return</span> <span class="n">var</span>
</span><span id="ProgramBuilder-1681"><a href="#ProgramBuilder-1681"><span class="linenos">1681</span></a>
</span><span id="ProgramBuilder-1682"><a href="#ProgramBuilder-1682"><span class="linenos">1682</span></a>    <span class="k">def</span> <span class="nf">getvar</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">tracer</span><span class="p">:</span> <span class="n">ProgramTraceTensor</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Var</span><span class="p">:</span>
</span><span id="ProgramBuilder-1683"><a href="#ProgramBuilder-1683"><span class="linenos">1683</span></a>        <span class="n">var</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">tracer_to_var</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="nb">id</span><span class="p">(</span><span class="n">tracer</span><span class="p">))</span>
</span><span id="ProgramBuilder-1684"><a href="#ProgramBuilder-1684"><span class="linenos">1684</span></a>        <span class="k">assert</span> <span class="n">var</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span>
</span><span id="ProgramBuilder-1685"><a href="#ProgramBuilder-1685"><span class="linenos">1685</span></a>        <span class="k">return</span> <span class="n">var</span>
</span><span id="ProgramBuilder-1686"><a href="#ProgramBuilder-1686"><span class="linenos">1686</span></a>
</span><span id="ProgramBuilder-1687"><a href="#ProgramBuilder-1687"><span class="linenos">1687</span></a>    <span class="k">def</span> <span class="nf">add_const</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">tracer</span><span class="p">:</span> <span class="n">ProgramTraceTensor</span><span class="p">,</span> <span class="n">val</span><span class="p">:</span> <span class="n">Any</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Var</span><span class="p">:</span>
</span><span id="ProgramBuilder-1688"><a href="#ProgramBuilder-1688"><span class="linenos">1688</span></a>        <span class="n">var</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">add_var</span><span class="p">(</span><span class="n">tracer</span><span class="p">)</span>
</span><span id="ProgramBuilder-1689"><a href="#ProgramBuilder-1689"><span class="linenos">1689</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">const_tracers</span><span class="p">[</span><span class="nb">id</span><span class="p">(</span><span class="n">val</span><span class="p">)]</span> <span class="o">=</span> <span class="n">tracer</span>
</span><span id="ProgramBuilder-1690"><a href="#ProgramBuilder-1690"><span class="linenos">1690</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">constvals</span><span class="p">[</span><span class="n">var</span><span class="p">]</span> <span class="o">=</span> <span class="n">val</span>
</span><span id="ProgramBuilder-1691"><a href="#ProgramBuilder-1691"><span class="linenos">1691</span></a>        <span class="k">return</span> <span class="n">var</span>
</span><span id="ProgramBuilder-1692"><a href="#ProgramBuilder-1692"><span class="linenos">1692</span></a>
</span><span id="ProgramBuilder-1693"><a href="#ProgramBuilder-1693"><span class="linenos">1693</span></a>    <span class="k">def</span> <span class="nf">build</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">in_tracers</span><span class="p">:</span> <span class="n">Any</span><span class="p">,</span> <span class="n">out_tracers</span><span class="p">:</span> <span class="n">Any</span><span class="p">,</span> <span class="n">static_args</span><span class="p">,</span> <span class="n">name</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Tuple</span><span class="p">[</span><span class="n">Program</span><span class="p">,</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">]]:</span>
</span><span id="ProgramBuilder-1694"><a href="#ProgramBuilder-1694"><span class="linenos">1694</span></a>        <span class="n">constvars</span><span class="p">,</span> <span class="n">constvals</span> <span class="o">=</span> <span class="n">unzip2</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">constvals</span><span class="o">.</span><span class="n">items</span><span class="p">())</span>
</span><span id="ProgramBuilder-1695"><a href="#ProgramBuilder-1695"><span class="linenos">1695</span></a>        <span class="n">t2v</span> <span class="o">=</span> <span class="k">lambda</span> <span class="n">t</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">tracer_to_var</span><span class="p">[</span><span class="nb">id</span><span class="p">(</span><span class="n">t</span><span class="p">)]</span>
</span><span id="ProgramBuilder-1696"><a href="#ProgramBuilder-1696"><span class="linenos">1696</span></a>        <span class="n">in_binders</span> <span class="o">=</span> <span class="n">constvars</span> <span class="o">+</span> <span class="p">[</span><span class="n">t2v</span><span class="p">(</span><span class="n">t</span><span class="p">)</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">in_tracers</span><span class="p">]</span>
</span><span id="ProgramBuilder-1697"><a href="#ProgramBuilder-1697"><span class="linenos">1697</span></a>        <span class="n">out_vars</span> <span class="o">=</span> <span class="p">[</span><span class="n">t2v</span><span class="p">(</span><span class="n">t</span><span class="p">)</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">out_tracers</span><span class="p">]</span>
</span><span id="ProgramBuilder-1698"><a href="#ProgramBuilder-1698"><span class="linenos">1698</span></a>        <span class="n">program</span> <span class="o">=</span> <span class="n">Program</span><span class="p">(</span>
</span><span id="ProgramBuilder-1699"><a href="#ProgramBuilder-1699"><span class="linenos">1699</span></a>            <span class="n">in_binders</span><span class="p">,</span>
</span><span id="ProgramBuilder-1700"><a href="#ProgramBuilder-1700"><span class="linenos">1700</span></a>            <span class="bp">self</span><span class="o">.</span><span class="n">instructions</span><span class="p">,</span>
</span><span id="ProgramBuilder-1701"><a href="#ProgramBuilder-1701"><span class="linenos">1701</span></a>            <span class="n">out_vars</span><span class="p">,</span>
</span><span id="ProgramBuilder-1702"><a href="#ProgramBuilder-1702"><span class="linenos">1702</span></a>            <span class="nb">len</span><span class="p">(</span><span class="n">constvals</span><span class="p">),</span>
</span><span id="ProgramBuilder-1703"><a href="#ProgramBuilder-1703"><span class="linenos">1703</span></a>            <span class="n">static_args</span><span class="p">,</span>
</span><span id="ProgramBuilder-1704"><a href="#ProgramBuilder-1704"><span class="linenos">1704</span></a>            <span class="n">name</span><span class="p">,</span>
</span><span id="ProgramBuilder-1705"><a href="#ProgramBuilder-1705"><span class="linenos">1705</span></a>        <span class="p">)</span>
</span><span id="ProgramBuilder-1706"><a href="#ProgramBuilder-1706"><span class="linenos">1706</span></a>        <span class="n">typecheck_program</span><span class="p">(</span><span class="n">program</span><span class="p">)</span>
</span><span id="ProgramBuilder-1707"><a href="#ProgramBuilder-1707"><span class="linenos">1707</span></a>        <span class="n">program</span><span class="p">,</span> <span class="n">constvals</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">_inline_literals</span><span class="p">(</span><span class="n">program</span><span class="p">,</span> <span class="n">constvals</span><span class="p">)</span>
</span><span id="ProgramBuilder-1708"><a href="#ProgramBuilder-1708"><span class="linenos">1708</span></a>        <span class="n">typecheck_program</span><span class="p">(</span><span class="n">program</span><span class="p">)</span>
</span><span id="ProgramBuilder-1709"><a href="#ProgramBuilder-1709"><span class="linenos">1709</span></a>        <span class="c1"># dblog(program, enable=backend.LOG_PROGRAM)</span>
</span><span id="ProgramBuilder-1710"><a href="#ProgramBuilder-1710"><span class="linenos">1710</span></a>        <span class="k">return</span> <span class="n">program</span><span class="p">,</span> <span class="n">constvals</span>
</span><span id="ProgramBuilder-1711"><a href="#ProgramBuilder-1711"><span class="linenos">1711</span></a>
</span><span id="ProgramBuilder-1712"><a href="#ProgramBuilder-1712"><span class="linenos">1712</span></a>    <span class="k">def</span> <span class="nf">_inline_literals</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">program</span><span class="p">:</span> <span class="n">Program</span><span class="p">,</span> <span class="n">consts</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">])</span> <span class="o">-&gt;</span> <span class="n">Tuple</span><span class="p">[</span><span class="n">Program</span><span class="p">,</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">]]:</span>
</span><span id="ProgramBuilder-1713"><a href="#ProgramBuilder-1713"><span class="linenos">1713</span></a>        <span class="n">const_binders</span><span class="p">,</span> <span class="n">other_binders</span> <span class="o">=</span> <span class="n">split_list</span><span class="p">(</span><span class="n">program</span><span class="o">.</span><span class="n">in_binders</span><span class="p">,</span> <span class="nb">len</span><span class="p">(</span><span class="n">consts</span><span class="p">))</span>
</span><span id="ProgramBuilder-1714"><a href="#ProgramBuilder-1714"><span class="linenos">1714</span></a>        <span class="n">scalars</span> <span class="o">=</span> <span class="p">[</span><span class="nb">type</span><span class="p">(</span><span class="n">x</span><span class="p">)</span> <span class="ow">in</span> <span class="n">TraceTensor</span><span class="o">.</span><span class="n">PYTHON_TYPES</span> <span class="ow">and</span> <span class="ow">not</span> <span class="n">get_symval</span><span class="p">(</span><span class="n">x</span><span class="p">)</span><span class="o">.</span><span class="n">shape</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">consts</span><span class="p">]</span>
</span><span id="ProgramBuilder-1715"><a href="#ProgramBuilder-1715"><span class="linenos">1715</span></a>        <span class="n">new_const_binders</span><span class="p">,</span> <span class="n">lit_binders</span> <span class="o">=</span> <span class="n">partition_list</span><span class="p">(</span><span class="n">scalars</span><span class="p">,</span> <span class="n">const_binders</span><span class="p">)</span>
</span><span id="ProgramBuilder-1716"><a href="#ProgramBuilder-1716"><span class="linenos">1716</span></a>        <span class="n">new_consts</span><span class="p">,</span> <span class="n">lit_vals</span> <span class="o">=</span> <span class="n">partition_list</span><span class="p">(</span><span class="n">scalars</span><span class="p">,</span> <span class="n">consts</span><span class="p">)</span>
</span><span id="ProgramBuilder-1717"><a href="#ProgramBuilder-1717"><span class="linenos">1717</span></a>        <span class="n">literals</span> <span class="o">=</span> <span class="nb">dict</span><span class="p">(</span><span class="n">list_zip</span><span class="p">(</span><span class="n">lit_binders</span><span class="p">,</span> <span class="n">list_map</span><span class="p">(</span><span class="n">Lit</span><span class="p">,</span> <span class="n">lit_vals</span><span class="p">)))</span>
</span><span id="ProgramBuilder-1718"><a href="#ProgramBuilder-1718"><span class="linenos">1718</span></a>        <span class="n">new_outs</span> <span class="o">=</span> <span class="p">[</span><span class="n">literals</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">x</span><span class="p">)</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">program</span><span class="o">.</span><span class="n">outs</span><span class="p">]</span>
</span><span id="ProgramBuilder-1719"><a href="#ProgramBuilder-1719"><span class="linenos">1719</span></a>        <span class="n">new_instructions</span> <span class="o">=</span> <span class="p">[</span>
</span><span id="ProgramBuilder-1720"><a href="#ProgramBuilder-1720"><span class="linenos">1720</span></a>            <span class="n">Instruction</span><span class="p">(</span>
</span><span id="ProgramBuilder-1721"><a href="#ProgramBuilder-1721"><span class="linenos">1721</span></a>                <span class="n">instruction</span><span class="o">.</span><span class="n">op</span><span class="p">,</span>
</span><span id="ProgramBuilder-1722"><a href="#ProgramBuilder-1722"><span class="linenos">1722</span></a>                <span class="p">[</span><span class="n">literals</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">x</span><span class="p">)</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">instruction</span><span class="o">.</span><span class="n">inputs</span><span class="p">],</span>
</span><span id="ProgramBuilder-1723"><a href="#ProgramBuilder-1723"><span class="linenos">1723</span></a>                <span class="n">instruction</span><span class="o">.</span><span class="n">params</span><span class="p">,</span>
</span><span id="ProgramBuilder-1724"><a href="#ProgramBuilder-1724"><span class="linenos">1724</span></a>                <span class="n">instruction</span><span class="o">.</span><span class="n">out_binders</span><span class="p">,</span>
</span><span id="ProgramBuilder-1725"><a href="#ProgramBuilder-1725"><span class="linenos">1725</span></a>            <span class="p">)</span>
</span><span id="ProgramBuilder-1726"><a href="#ProgramBuilder-1726"><span class="linenos">1726</span></a>            <span class="k">for</span> <span class="n">instruction</span> <span class="ow">in</span> <span class="n">program</span><span class="o">.</span><span class="n">instructions</span>
</span><span id="ProgramBuilder-1727"><a href="#ProgramBuilder-1727"><span class="linenos">1727</span></a>        <span class="p">]</span>
</span><span id="ProgramBuilder-1728"><a href="#ProgramBuilder-1728"><span class="linenos">1728</span></a>        <span class="n">new_program</span> <span class="o">=</span> <span class="n">Program</span><span class="p">(</span>
</span><span id="ProgramBuilder-1729"><a href="#ProgramBuilder-1729"><span class="linenos">1729</span></a>            <span class="n">new_const_binders</span> <span class="o">+</span> <span class="n">other_binders</span><span class="p">,</span>
</span><span id="ProgramBuilder-1730"><a href="#ProgramBuilder-1730"><span class="linenos">1730</span></a>            <span class="n">new_instructions</span><span class="p">,</span>
</span><span id="ProgramBuilder-1731"><a href="#ProgramBuilder-1731"><span class="linenos">1731</span></a>            <span class="n">new_outs</span><span class="p">,</span>
</span><span id="ProgramBuilder-1732"><a href="#ProgramBuilder-1732"><span class="linenos">1732</span></a>            <span class="nb">len</span><span class="p">(</span><span class="n">new_consts</span><span class="p">),</span>
</span><span id="ProgramBuilder-1733"><a href="#ProgramBuilder-1733"><span class="linenos">1733</span></a>            <span class="n">program</span><span class="o">.</span><span class="n">static_args</span><span class="p">,</span>
</span><span id="ProgramBuilder-1734"><a href="#ProgramBuilder-1734"><span class="linenos">1734</span></a>            <span class="n">program</span><span class="o">.</span><span class="n">name</span><span class="p">,</span>
</span><span id="ProgramBuilder-1735"><a href="#ProgramBuilder-1735"><span class="linenos">1735</span></a>        <span class="p">)</span>
</span><span id="ProgramBuilder-1736"><a href="#ProgramBuilder-1736"><span class="linenos">1736</span></a>        <span class="k">return</span> <span class="n">new_program</span><span class="p">,</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">new_consts</span><span class="p">)</span>
</span><span id="ProgramBuilder-1737"><a href="#ProgramBuilder-1737"><span class="linenos">1737</span></a>
</span><span id="ProgramBuilder-1738"><a href="#ProgramBuilder-1738"><span class="linenos">1738</span></a>    <span class="k">def</span> <span class="nf">get_current_scope_info</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="ProgramBuilder-1739"><a href="#ProgramBuilder-1739"><span class="linenos">1739</span></a>        <span class="n">current_frame</span> <span class="o">=</span> <span class="n">inspect</span><span class="o">.</span><span class="n">currentframe</span><span class="p">()</span>
</span><span id="ProgramBuilder-1740"><a href="#ProgramBuilder-1740"><span class="linenos">1740</span></a>        <span class="n">current_function_name</span> <span class="o">=</span> <span class="n">current_frame</span><span class="o">.</span><span class="n">f_code</span><span class="o">.</span><span class="n">co_name</span>
</span><span id="ProgramBuilder-1741"><a href="#ProgramBuilder-1741"><span class="linenos">1741</span></a>        <span class="n">current_module_name</span> <span class="o">=</span> <span class="n">inspect</span><span class="o">.</span><span class="n">getmodulename</span><span class="p">(</span><span class="n">current_frame</span><span class="o">.</span><span class="n">f_code</span><span class="o">.</span><span class="n">co_filename</span><span class="p">)</span>
</span><span id="ProgramBuilder-1742"><a href="#ProgramBuilder-1742"><span class="linenos">1742</span></a>        <span class="n">current_class_name</span> <span class="o">=</span> <span class="kc">None</span>
</span><span id="ProgramBuilder-1743"><a href="#ProgramBuilder-1743"><span class="linenos">1743</span></a>        <span class="k">for</span> <span class="n">frame_info</span> <span class="ow">in</span> <span class="n">inspect</span><span class="o">.</span><span class="n">getouterframes</span><span class="p">(</span><span class="n">current_frame</span><span class="p">):</span>
</span><span id="ProgramBuilder-1744"><a href="#ProgramBuilder-1744"><span class="linenos">1744</span></a>            <span class="nb">print</span><span class="p">(</span><span class="n">frame_info</span><span class="p">)</span>
</span><span id="ProgramBuilder-1745"><a href="#ProgramBuilder-1745"><span class="linenos">1745</span></a>            <span class="n">frame_locals</span> <span class="o">=</span> <span class="n">frame_info</span><span class="o">.</span><span class="n">frame</span><span class="o">.</span><span class="n">f_locals</span>
</span><span id="ProgramBuilder-1746"><a href="#ProgramBuilder-1746"><span class="linenos">1746</span></a>            <span class="nb">print</span><span class="p">(</span><span class="n">frame_locals</span><span class="p">)</span>
</span><span id="ProgramBuilder-1747"><a href="#ProgramBuilder-1747"><span class="linenos">1747</span></a>            <span class="k">if</span> <span class="s2">&quot;self&quot;</span> <span class="ow">in</span> <span class="n">frame_locals</span><span class="p">:</span>
</span><span id="ProgramBuilder-1748"><a href="#ProgramBuilder-1748"><span class="linenos">1748</span></a>                <span class="n">current_class_name</span> <span class="o">=</span> <span class="n">frame_locals</span><span class="p">[</span><span class="s2">&quot;self&quot;</span><span class="p">]</span><span class="o">.</span><span class="vm">__class__</span><span class="o">.</span><span class="vm">__name__</span>
</span><span id="ProgramBuilder-1749"><a href="#ProgramBuilder-1749"><span class="linenos">1749</span></a>                <span class="k">break</span>
</span><span id="ProgramBuilder-1750"><a href="#ProgramBuilder-1750"><span class="linenos">1750</span></a>        <span class="k">return</span> <span class="p">{</span>
</span><span id="ProgramBuilder-1751"><a href="#ProgramBuilder-1751"><span class="linenos">1751</span></a>            <span class="s2">&quot;Function&quot;</span><span class="p">:</span> <span class="n">current_function_name</span><span class="p">,</span>
</span><span id="ProgramBuilder-1752"><a href="#ProgramBuilder-1752"><span class="linenos">1752</span></a>            <span class="s2">&quot;Module&quot;</span><span class="p">:</span> <span class="n">current_module_name</span><span class="p">,</span>
</span><span id="ProgramBuilder-1753"><a href="#ProgramBuilder-1753"><span class="linenos">1753</span></a>            <span class="s2">&quot;Class&quot;</span><span class="p">:</span> <span class="n">current_class_name</span><span class="p">,</span>
</span><span id="ProgramBuilder-1754"><a href="#ProgramBuilder-1754"><span class="linenos">1754</span></a>        <span class="p">}</span>
</span></pre></div>


    

                            <div id="ProgramBuilder.instructions" class="classattr">
                                <div class="attr variable">
            <span class="name">instructions</span><span class="annotation">: List[<a href="#Instruction">Instruction</a>]</span>

        
    </div>
    <a class="headerlink" href="#ProgramBuilder.instructions"></a>
    
    

                            </div>
                            <div id="ProgramBuilder.tracer_to_var" class="classattr">
                                <div class="attr variable">
            <span class="name">tracer_to_var</span><span class="annotation">: Dict[int, <a href="#Var">Var</a>]</span>

        
    </div>
    <a class="headerlink" href="#ProgramBuilder.tracer_to_var"></a>
    
    

                            </div>
                            <div id="ProgramBuilder.const_tracers" class="classattr">
                                <div class="attr variable">
            <span class="name">const_tracers</span><span class="annotation">: Dict[int, <a href="#TraceTensor">TraceTensor</a>]</span>

        
    </div>
    <a class="headerlink" href="#ProgramBuilder.const_tracers"></a>
    
    

                            </div>
                            <div id="ProgramBuilder.constvals" class="classattr">
                                <div class="attr variable">
            <span class="name">constvals</span><span class="annotation">: Dict[<a href="#Var">Var</a>, Any]</span>

        
    </div>
    <a class="headerlink" href="#ProgramBuilder.constvals"></a>
    
    

                            </div>
                            <div id="ProgramBuilder.tracers" class="classattr">
                                <div class="attr variable">
            <span class="name">tracers</span><span class="annotation">: List[<a href="#ProgramTraceTensor">ProgramTraceTensor</a>]</span>

        
    </div>
    <a class="headerlink" href="#ProgramBuilder.tracers"></a>
    
    

                            </div>
                            <div id="ProgramBuilder.new_tracer" class="classattr">
                                        <input id="ProgramBuilder.new_tracer-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">new_tracer</span><span class="signature pdoc-code multiline">(<span class="param">	<span class="bp">self</span>,</span><span class="param">	<span class="n">trace</span><span class="p">:</span> <span class="n"><a href="#ProgramTrace">ProgramTrace</a></span>,</span><span class="param">	<span class="n">symval</span><span class="p">:</span> <span class="n"><a href="#SymbolicTensor">SymbolicTensor</a></span></span><span class="return-annotation">) -> <span class="n"><a href="#ProgramTraceTensor">ProgramTraceTensor</a></span>:</span></span>

                <label class="view-source-button" for="ProgramBuilder.new_tracer-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#ProgramBuilder.new_tracer"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="ProgramBuilder.new_tracer-1669"><a href="#ProgramBuilder.new_tracer-1669"><span class="linenos">1669</span></a>    <span class="k">def</span> <span class="nf">new_tracer</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">trace</span><span class="p">:</span> <span class="n">ProgramTrace</span><span class="p">,</span> <span class="n">symval</span><span class="p">:</span> <span class="n">SymbolicTensor</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">ProgramTraceTensor</span><span class="p">:</span>
</span><span id="ProgramBuilder.new_tracer-1670"><a href="#ProgramBuilder.new_tracer-1670"><span class="linenos">1670</span></a>        <span class="n">tracer</span> <span class="o">=</span> <span class="n">ProgramTraceTensor</span><span class="p">(</span><span class="n">trace</span><span class="p">,</span> <span class="n">symval</span><span class="p">)</span>
</span><span id="ProgramBuilder.new_tracer-1671"><a href="#ProgramBuilder.new_tracer-1671"><span class="linenos">1671</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">tracers</span> <span class="o">+=</span> <span class="p">[</span><span class="n">tracer</span><span class="p">]</span>
</span><span id="ProgramBuilder.new_tracer-1672"><a href="#ProgramBuilder.new_tracer-1672"><span class="linenos">1672</span></a>        <span class="k">return</span> <span class="n">tracer</span>
</span></pre></div>


    

                            </div>
                            <div id="ProgramBuilder.add_instruction" class="classattr">
                                        <input id="ProgramBuilder.add_instruction-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">add_instruction</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="n">instruction</span><span class="p">:</span> <span class="n"><a href="#Instruction">Instruction</a></span></span><span class="return-annotation">) -> <span class="kc">None</span>:</span></span>

                <label class="view-source-button" for="ProgramBuilder.add_instruction-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#ProgramBuilder.add_instruction"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="ProgramBuilder.add_instruction-1674"><a href="#ProgramBuilder.add_instruction-1674"><span class="linenos">1674</span></a>    <span class="k">def</span> <span class="nf">add_instruction</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">instruction</span><span class="p">:</span> <span class="n">Instruction</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="kc">None</span><span class="p">:</span>
</span><span id="ProgramBuilder.add_instruction-1675"><a href="#ProgramBuilder.add_instruction-1675"><span class="linenos">1675</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">instructions</span> <span class="o">+=</span> <span class="p">[</span><span class="n">instruction</span><span class="p">]</span>
</span></pre></div>


    

                            </div>
                            <div id="ProgramBuilder.add_var" class="classattr">
                                        <input id="ProgramBuilder.add_var-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">add_var</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="n">tracer</span><span class="p">:</span> <span class="n"><a href="#ProgramTraceTensor">ProgramTraceTensor</a></span></span><span class="return-annotation">) -> <span class="n"><a href="#Var">Var</a></span>:</span></span>

                <label class="view-source-button" for="ProgramBuilder.add_var-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#ProgramBuilder.add_var"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="ProgramBuilder.add_var-1677"><a href="#ProgramBuilder.add_var-1677"><span class="linenos">1677</span></a>    <span class="k">def</span> <span class="nf">add_var</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">tracer</span><span class="p">:</span> <span class="n">ProgramTraceTensor</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Var</span><span class="p">:</span>
</span><span id="ProgramBuilder.add_var-1678"><a href="#ProgramBuilder.add_var-1678"><span class="linenos">1678</span></a>        <span class="k">assert</span> <span class="nb">id</span><span class="p">(</span><span class="n">tracer</span><span class="p">)</span> <span class="ow">not</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">tracer_to_var</span>
</span><span id="ProgramBuilder.add_var-1679"><a href="#ProgramBuilder.add_var-1679"><span class="linenos">1679</span></a>        <span class="n">var</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">tracer_to_var</span><span class="p">[</span><span class="nb">id</span><span class="p">(</span><span class="n">tracer</span><span class="p">)]</span> <span class="o">=</span> <span class="n">Var</span><span class="p">(</span><span class="n">tracer</span><span class="o">.</span><span class="n">symval</span><span class="p">)</span>
</span><span id="ProgramBuilder.add_var-1680"><a href="#ProgramBuilder.add_var-1680"><span class="linenos">1680</span></a>        <span class="k">return</span> <span class="n">var</span>
</span></pre></div>


    

                            </div>
                            <div id="ProgramBuilder.getvar" class="classattr">
                                        <input id="ProgramBuilder.getvar-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">getvar</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="n">tracer</span><span class="p">:</span> <span class="n"><a href="#ProgramTraceTensor">ProgramTraceTensor</a></span></span><span class="return-annotation">) -> <span class="n"><a href="#Var">Var</a></span>:</span></span>

                <label class="view-source-button" for="ProgramBuilder.getvar-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#ProgramBuilder.getvar"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="ProgramBuilder.getvar-1682"><a href="#ProgramBuilder.getvar-1682"><span class="linenos">1682</span></a>    <span class="k">def</span> <span class="nf">getvar</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">tracer</span><span class="p">:</span> <span class="n">ProgramTraceTensor</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Var</span><span class="p">:</span>
</span><span id="ProgramBuilder.getvar-1683"><a href="#ProgramBuilder.getvar-1683"><span class="linenos">1683</span></a>        <span class="n">var</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">tracer_to_var</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="nb">id</span><span class="p">(</span><span class="n">tracer</span><span class="p">))</span>
</span><span id="ProgramBuilder.getvar-1684"><a href="#ProgramBuilder.getvar-1684"><span class="linenos">1684</span></a>        <span class="k">assert</span> <span class="n">var</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span>
</span><span id="ProgramBuilder.getvar-1685"><a href="#ProgramBuilder.getvar-1685"><span class="linenos">1685</span></a>        <span class="k">return</span> <span class="n">var</span>
</span></pre></div>


    

                            </div>
                            <div id="ProgramBuilder.add_const" class="classattr">
                                        <input id="ProgramBuilder.add_const-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">add_const</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="n">tracer</span><span class="p">:</span> <span class="n"><a href="#ProgramTraceTensor">ProgramTraceTensor</a></span>, </span><span class="param"><span class="n">val</span><span class="p">:</span> <span class="n">Any</span></span><span class="return-annotation">) -> <span class="n"><a href="#Var">Var</a></span>:</span></span>

                <label class="view-source-button" for="ProgramBuilder.add_const-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#ProgramBuilder.add_const"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="ProgramBuilder.add_const-1687"><a href="#ProgramBuilder.add_const-1687"><span class="linenos">1687</span></a>    <span class="k">def</span> <span class="nf">add_const</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">tracer</span><span class="p">:</span> <span class="n">ProgramTraceTensor</span><span class="p">,</span> <span class="n">val</span><span class="p">:</span> <span class="n">Any</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Var</span><span class="p">:</span>
</span><span id="ProgramBuilder.add_const-1688"><a href="#ProgramBuilder.add_const-1688"><span class="linenos">1688</span></a>        <span class="n">var</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">add_var</span><span class="p">(</span><span class="n">tracer</span><span class="p">)</span>
</span><span id="ProgramBuilder.add_const-1689"><a href="#ProgramBuilder.add_const-1689"><span class="linenos">1689</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">const_tracers</span><span class="p">[</span><span class="nb">id</span><span class="p">(</span><span class="n">val</span><span class="p">)]</span> <span class="o">=</span> <span class="n">tracer</span>
</span><span id="ProgramBuilder.add_const-1690"><a href="#ProgramBuilder.add_const-1690"><span class="linenos">1690</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">constvals</span><span class="p">[</span><span class="n">var</span><span class="p">]</span> <span class="o">=</span> <span class="n">val</span>
</span><span id="ProgramBuilder.add_const-1691"><a href="#ProgramBuilder.add_const-1691"><span class="linenos">1691</span></a>        <span class="k">return</span> <span class="n">var</span>
</span></pre></div>


    

                            </div>
                            <div id="ProgramBuilder.build" class="classattr">
                                        <input id="ProgramBuilder.build-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">build</span><span class="signature pdoc-code multiline">(<span class="param">	<span class="bp">self</span>,</span><span class="param">	<span class="n">in_tracers</span><span class="p">:</span> <span class="n">Any</span>,</span><span class="param">	<span class="n">out_tracers</span><span class="p">:</span> <span class="n">Any</span>,</span><span class="param">	<span class="n">static_args</span>,</span><span class="param">	<span class="n">name</span></span><span class="return-annotation">) -> <span class="n">Tuple</span><span class="p">[</span><span class="n"><a href="#Program">Program</a></span><span class="p">,</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">]]</span>:</span></span>

                <label class="view-source-button" for="ProgramBuilder.build-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#ProgramBuilder.build"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="ProgramBuilder.build-1693"><a href="#ProgramBuilder.build-1693"><span class="linenos">1693</span></a>    <span class="k">def</span> <span class="nf">build</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">in_tracers</span><span class="p">:</span> <span class="n">Any</span><span class="p">,</span> <span class="n">out_tracers</span><span class="p">:</span> <span class="n">Any</span><span class="p">,</span> <span class="n">static_args</span><span class="p">,</span> <span class="n">name</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Tuple</span><span class="p">[</span><span class="n">Program</span><span class="p">,</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">]]:</span>
</span><span id="ProgramBuilder.build-1694"><a href="#ProgramBuilder.build-1694"><span class="linenos">1694</span></a>        <span class="n">constvars</span><span class="p">,</span> <span class="n">constvals</span> <span class="o">=</span> <span class="n">unzip2</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">constvals</span><span class="o">.</span><span class="n">items</span><span class="p">())</span>
</span><span id="ProgramBuilder.build-1695"><a href="#ProgramBuilder.build-1695"><span class="linenos">1695</span></a>        <span class="n">t2v</span> <span class="o">=</span> <span class="k">lambda</span> <span class="n">t</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">tracer_to_var</span><span class="p">[</span><span class="nb">id</span><span class="p">(</span><span class="n">t</span><span class="p">)]</span>
</span><span id="ProgramBuilder.build-1696"><a href="#ProgramBuilder.build-1696"><span class="linenos">1696</span></a>        <span class="n">in_binders</span> <span class="o">=</span> <span class="n">constvars</span> <span class="o">+</span> <span class="p">[</span><span class="n">t2v</span><span class="p">(</span><span class="n">t</span><span class="p">)</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">in_tracers</span><span class="p">]</span>
</span><span id="ProgramBuilder.build-1697"><a href="#ProgramBuilder.build-1697"><span class="linenos">1697</span></a>        <span class="n">out_vars</span> <span class="o">=</span> <span class="p">[</span><span class="n">t2v</span><span class="p">(</span><span class="n">t</span><span class="p">)</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">out_tracers</span><span class="p">]</span>
</span><span id="ProgramBuilder.build-1698"><a href="#ProgramBuilder.build-1698"><span class="linenos">1698</span></a>        <span class="n">program</span> <span class="o">=</span> <span class="n">Program</span><span class="p">(</span>
</span><span id="ProgramBuilder.build-1699"><a href="#ProgramBuilder.build-1699"><span class="linenos">1699</span></a>            <span class="n">in_binders</span><span class="p">,</span>
</span><span id="ProgramBuilder.build-1700"><a href="#ProgramBuilder.build-1700"><span class="linenos">1700</span></a>            <span class="bp">self</span><span class="o">.</span><span class="n">instructions</span><span class="p">,</span>
</span><span id="ProgramBuilder.build-1701"><a href="#ProgramBuilder.build-1701"><span class="linenos">1701</span></a>            <span class="n">out_vars</span><span class="p">,</span>
</span><span id="ProgramBuilder.build-1702"><a href="#ProgramBuilder.build-1702"><span class="linenos">1702</span></a>            <span class="nb">len</span><span class="p">(</span><span class="n">constvals</span><span class="p">),</span>
</span><span id="ProgramBuilder.build-1703"><a href="#ProgramBuilder.build-1703"><span class="linenos">1703</span></a>            <span class="n">static_args</span><span class="p">,</span>
</span><span id="ProgramBuilder.build-1704"><a href="#ProgramBuilder.build-1704"><span class="linenos">1704</span></a>            <span class="n">name</span><span class="p">,</span>
</span><span id="ProgramBuilder.build-1705"><a href="#ProgramBuilder.build-1705"><span class="linenos">1705</span></a>        <span class="p">)</span>
</span><span id="ProgramBuilder.build-1706"><a href="#ProgramBuilder.build-1706"><span class="linenos">1706</span></a>        <span class="n">typecheck_program</span><span class="p">(</span><span class="n">program</span><span class="p">)</span>
</span><span id="ProgramBuilder.build-1707"><a href="#ProgramBuilder.build-1707"><span class="linenos">1707</span></a>        <span class="n">program</span><span class="p">,</span> <span class="n">constvals</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">_inline_literals</span><span class="p">(</span><span class="n">program</span><span class="p">,</span> <span class="n">constvals</span><span class="p">)</span>
</span><span id="ProgramBuilder.build-1708"><a href="#ProgramBuilder.build-1708"><span class="linenos">1708</span></a>        <span class="n">typecheck_program</span><span class="p">(</span><span class="n">program</span><span class="p">)</span>
</span><span id="ProgramBuilder.build-1709"><a href="#ProgramBuilder.build-1709"><span class="linenos">1709</span></a>        <span class="c1"># dblog(program, enable=backend.LOG_PROGRAM)</span>
</span><span id="ProgramBuilder.build-1710"><a href="#ProgramBuilder.build-1710"><span class="linenos">1710</span></a>        <span class="k">return</span> <span class="n">program</span><span class="p">,</span> <span class="n">constvals</span>
</span></pre></div>


    

                            </div>
                            <div id="ProgramBuilder.get_current_scope_info" class="classattr">
                                        <input id="ProgramBuilder.get_current_scope_info-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">get_current_scope_info</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="ProgramBuilder.get_current_scope_info-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#ProgramBuilder.get_current_scope_info"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="ProgramBuilder.get_current_scope_info-1738"><a href="#ProgramBuilder.get_current_scope_info-1738"><span class="linenos">1738</span></a>    <span class="k">def</span> <span class="nf">get_current_scope_info</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="ProgramBuilder.get_current_scope_info-1739"><a href="#ProgramBuilder.get_current_scope_info-1739"><span class="linenos">1739</span></a>        <span class="n">current_frame</span> <span class="o">=</span> <span class="n">inspect</span><span class="o">.</span><span class="n">currentframe</span><span class="p">()</span>
</span><span id="ProgramBuilder.get_current_scope_info-1740"><a href="#ProgramBuilder.get_current_scope_info-1740"><span class="linenos">1740</span></a>        <span class="n">current_function_name</span> <span class="o">=</span> <span class="n">current_frame</span><span class="o">.</span><span class="n">f_code</span><span class="o">.</span><span class="n">co_name</span>
</span><span id="ProgramBuilder.get_current_scope_info-1741"><a href="#ProgramBuilder.get_current_scope_info-1741"><span class="linenos">1741</span></a>        <span class="n">current_module_name</span> <span class="o">=</span> <span class="n">inspect</span><span class="o">.</span><span class="n">getmodulename</span><span class="p">(</span><span class="n">current_frame</span><span class="o">.</span><span class="n">f_code</span><span class="o">.</span><span class="n">co_filename</span><span class="p">)</span>
</span><span id="ProgramBuilder.get_current_scope_info-1742"><a href="#ProgramBuilder.get_current_scope_info-1742"><span class="linenos">1742</span></a>        <span class="n">current_class_name</span> <span class="o">=</span> <span class="kc">None</span>
</span><span id="ProgramBuilder.get_current_scope_info-1743"><a href="#ProgramBuilder.get_current_scope_info-1743"><span class="linenos">1743</span></a>        <span class="k">for</span> <span class="n">frame_info</span> <span class="ow">in</span> <span class="n">inspect</span><span class="o">.</span><span class="n">getouterframes</span><span class="p">(</span><span class="n">current_frame</span><span class="p">):</span>
</span><span id="ProgramBuilder.get_current_scope_info-1744"><a href="#ProgramBuilder.get_current_scope_info-1744"><span class="linenos">1744</span></a>            <span class="nb">print</span><span class="p">(</span><span class="n">frame_info</span><span class="p">)</span>
</span><span id="ProgramBuilder.get_current_scope_info-1745"><a href="#ProgramBuilder.get_current_scope_info-1745"><span class="linenos">1745</span></a>            <span class="n">frame_locals</span> <span class="o">=</span> <span class="n">frame_info</span><span class="o">.</span><span class="n">frame</span><span class="o">.</span><span class="n">f_locals</span>
</span><span id="ProgramBuilder.get_current_scope_info-1746"><a href="#ProgramBuilder.get_current_scope_info-1746"><span class="linenos">1746</span></a>            <span class="nb">print</span><span class="p">(</span><span class="n">frame_locals</span><span class="p">)</span>
</span><span id="ProgramBuilder.get_current_scope_info-1747"><a href="#ProgramBuilder.get_current_scope_info-1747"><span class="linenos">1747</span></a>            <span class="k">if</span> <span class="s2">&quot;self&quot;</span> <span class="ow">in</span> <span class="n">frame_locals</span><span class="p">:</span>
</span><span id="ProgramBuilder.get_current_scope_info-1748"><a href="#ProgramBuilder.get_current_scope_info-1748"><span class="linenos">1748</span></a>                <span class="n">current_class_name</span> <span class="o">=</span> <span class="n">frame_locals</span><span class="p">[</span><span class="s2">&quot;self&quot;</span><span class="p">]</span><span class="o">.</span><span class="vm">__class__</span><span class="o">.</span><span class="vm">__name__</span>
</span><span id="ProgramBuilder.get_current_scope_info-1749"><a href="#ProgramBuilder.get_current_scope_info-1749"><span class="linenos">1749</span></a>                <span class="k">break</span>
</span><span id="ProgramBuilder.get_current_scope_info-1750"><a href="#ProgramBuilder.get_current_scope_info-1750"><span class="linenos">1750</span></a>        <span class="k">return</span> <span class="p">{</span>
</span><span id="ProgramBuilder.get_current_scope_info-1751"><a href="#ProgramBuilder.get_current_scope_info-1751"><span class="linenos">1751</span></a>            <span class="s2">&quot;Function&quot;</span><span class="p">:</span> <span class="n">current_function_name</span><span class="p">,</span>
</span><span id="ProgramBuilder.get_current_scope_info-1752"><a href="#ProgramBuilder.get_current_scope_info-1752"><span class="linenos">1752</span></a>            <span class="s2">&quot;Module&quot;</span><span class="p">:</span> <span class="n">current_module_name</span><span class="p">,</span>
</span><span id="ProgramBuilder.get_current_scope_info-1753"><a href="#ProgramBuilder.get_current_scope_info-1753"><span class="linenos">1753</span></a>            <span class="s2">&quot;Class&quot;</span><span class="p">:</span> <span class="n">current_class_name</span><span class="p">,</span>
</span><span id="ProgramBuilder.get_current_scope_info-1754"><a href="#ProgramBuilder.get_current_scope_info-1754"><span class="linenos">1754</span></a>        <span class="p">}</span>
</span></pre></div>


    

                            </div>
                </section>
                <section id="UndefinedPrimal">
                            <input id="UndefinedPrimal-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr class">
            
    <span class="def">class</span>
    <span class="name">UndefinedPrimal</span><wbr>(<span class="base">typing.NamedTuple</span>):

                <label class="view-source-button" for="UndefinedPrimal-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#UndefinedPrimal"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="UndefinedPrimal-1757"><a href="#UndefinedPrimal-1757"><span class="linenos">1757</span></a><span class="k">class</span> <span class="nc">UndefinedPrimal</span><span class="p">(</span><span class="n">NamedTuple</span><span class="p">):</span>
</span><span id="UndefinedPrimal-1758"><a href="#UndefinedPrimal-1758"><span class="linenos">1758</span></a>    <span class="n">symval</span><span class="p">:</span> <span class="n">SymbolicTensor</span>
</span><span id="UndefinedPrimal-1759"><a href="#UndefinedPrimal-1759"><span class="linenos">1759</span></a>
</span><span id="UndefinedPrimal-1760"><a href="#UndefinedPrimal-1760"><span class="linenos">1760</span></a>    <span class="nd">@property</span>
</span><span id="UndefinedPrimal-1761"><a href="#UndefinedPrimal-1761"><span class="linenos">1761</span></a>    <span class="k">def</span> <span class="nf">shape</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="UndefinedPrimal-1762"><a href="#UndefinedPrimal-1762"><span class="linenos">1762</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">symval</span><span class="o">.</span><span class="n">shape</span>
</span><span id="UndefinedPrimal-1763"><a href="#UndefinedPrimal-1763"><span class="linenos">1763</span></a>
</span><span id="UndefinedPrimal-1764"><a href="#UndefinedPrimal-1764"><span class="linenos">1764</span></a>    <span class="nd">@property</span>
</span><span id="UndefinedPrimal-1765"><a href="#UndefinedPrimal-1765"><span class="linenos">1765</span></a>    <span class="k">def</span> <span class="nf">dtype</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="UndefinedPrimal-1766"><a href="#UndefinedPrimal-1766"><span class="linenos">1766</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">symval</span><span class="o">.</span><span class="n">dtype</span>
</span><span id="UndefinedPrimal-1767"><a href="#UndefinedPrimal-1767"><span class="linenos">1767</span></a>
</span><span id="UndefinedPrimal-1768"><a href="#UndefinedPrimal-1768"><span class="linenos">1768</span></a>    <span class="nd">@property</span>
</span><span id="UndefinedPrimal-1769"><a href="#UndefinedPrimal-1769"><span class="linenos">1769</span></a>    <span class="k">def</span> <span class="nf">device</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="UndefinedPrimal-1770"><a href="#UndefinedPrimal-1770"><span class="linenos">1770</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">symval</span><span class="o">.</span><span class="n">device</span>
</span><span id="UndefinedPrimal-1771"><a href="#UndefinedPrimal-1771"><span class="linenos">1771</span></a>
</span><span id="UndefinedPrimal-1772"><a href="#UndefinedPrimal-1772"><span class="linenos">1772</span></a>    <span class="nd">@property</span>
</span><span id="UndefinedPrimal-1773"><a href="#UndefinedPrimal-1773"><span class="linenos">1773</span></a>    <span class="k">def</span> <span class="nf">ndim</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="UndefinedPrimal-1774"><a href="#UndefinedPrimal-1774"><span class="linenos">1774</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">symval</span><span class="o">.</span><span class="n">ndim</span>
</span><span id="UndefinedPrimal-1775"><a href="#UndefinedPrimal-1775"><span class="linenos">1775</span></a>
</span><span id="UndefinedPrimal-1776"><a href="#UndefinedPrimal-1776"><span class="linenos">1776</span></a>    <span class="k">def</span> <span class="fm">__repr__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="UndefinedPrimal-1777"><a href="#UndefinedPrimal-1777"><span class="linenos">1777</span></a>        <span class="k">return</span> <span class="sa">f</span><span class="s2">&quot;&lt;UndefinedPrimal: symval=</span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">symval</span><span class="si">}</span><span class="s2">&gt;&quot;</span>
</span><span id="UndefinedPrimal-1778"><a href="#UndefinedPrimal-1778"><span class="linenos">1778</span></a>
</span><span id="UndefinedPrimal-1779"><a href="#UndefinedPrimal-1779"><span class="linenos">1779</span></a>    <span class="n">str_short</span> <span class="o">=</span> <span class="fm">__repr__</span>
</span></pre></div>


            <div class="docstring"><p>UndefinedPrimal(symval,)</p>
</div>


                            <div id="UndefinedPrimal.__init__" class="classattr">
                                <div class="attr function">
            
        <span class="name">UndefinedPrimal</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">symval</span><span class="p">:</span> <span class="n"><a href="#SymbolicTensor">SymbolicTensor</a></span></span>)</span>

        
    </div>
    <a class="headerlink" href="#UndefinedPrimal.__init__"></a>
    
            <div class="docstring"><p>Create new instance of UndefinedPrimal(symval,)</p>
</div>


                            </div>
                            <div id="UndefinedPrimal.symval" class="classattr">
                                <div class="attr variable">
            <span class="name">symval</span><span class="annotation">: <a href="#SymbolicTensor">SymbolicTensor</a></span>

        
    </div>
    <a class="headerlink" href="#UndefinedPrimal.symval"></a>
    
            <div class="docstring"><p>Alias for field number 0</p>
</div>


                            </div>
                            <div id="UndefinedPrimal.shape" class="classattr">
                                        <input id="UndefinedPrimal.shape-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr variable">
            <span class="name">shape</span>

                <label class="view-source-button" for="UndefinedPrimal.shape-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#UndefinedPrimal.shape"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="UndefinedPrimal.shape-1760"><a href="#UndefinedPrimal.shape-1760"><span class="linenos">1760</span></a>    <span class="nd">@property</span>
</span><span id="UndefinedPrimal.shape-1761"><a href="#UndefinedPrimal.shape-1761"><span class="linenos">1761</span></a>    <span class="k">def</span> <span class="nf">shape</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="UndefinedPrimal.shape-1762"><a href="#UndefinedPrimal.shape-1762"><span class="linenos">1762</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">symval</span><span class="o">.</span><span class="n">shape</span>
</span></pre></div>


    

                            </div>
                            <div id="UndefinedPrimal.dtype" class="classattr">
                                        <input id="UndefinedPrimal.dtype-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr variable">
            <span class="name">dtype</span>

                <label class="view-source-button" for="UndefinedPrimal.dtype-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#UndefinedPrimal.dtype"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="UndefinedPrimal.dtype-1764"><a href="#UndefinedPrimal.dtype-1764"><span class="linenos">1764</span></a>    <span class="nd">@property</span>
</span><span id="UndefinedPrimal.dtype-1765"><a href="#UndefinedPrimal.dtype-1765"><span class="linenos">1765</span></a>    <span class="k">def</span> <span class="nf">dtype</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="UndefinedPrimal.dtype-1766"><a href="#UndefinedPrimal.dtype-1766"><span class="linenos">1766</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">symval</span><span class="o">.</span><span class="n">dtype</span>
</span></pre></div>


    

                            </div>
                            <div id="UndefinedPrimal.device" class="classattr">
                                        <input id="UndefinedPrimal.device-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr variable">
            <span class="name">device</span>

                <label class="view-source-button" for="UndefinedPrimal.device-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#UndefinedPrimal.device"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="UndefinedPrimal.device-1768"><a href="#UndefinedPrimal.device-1768"><span class="linenos">1768</span></a>    <span class="nd">@property</span>
</span><span id="UndefinedPrimal.device-1769"><a href="#UndefinedPrimal.device-1769"><span class="linenos">1769</span></a>    <span class="k">def</span> <span class="nf">device</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="UndefinedPrimal.device-1770"><a href="#UndefinedPrimal.device-1770"><span class="linenos">1770</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">symval</span><span class="o">.</span><span class="n">device</span>
</span></pre></div>


    

                            </div>
                            <div id="UndefinedPrimal.ndim" class="classattr">
                                        <input id="UndefinedPrimal.ndim-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr variable">
            <span class="name">ndim</span>

                <label class="view-source-button" for="UndefinedPrimal.ndim-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#UndefinedPrimal.ndim"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="UndefinedPrimal.ndim-1772"><a href="#UndefinedPrimal.ndim-1772"><span class="linenos">1772</span></a>    <span class="nd">@property</span>
</span><span id="UndefinedPrimal.ndim-1773"><a href="#UndefinedPrimal.ndim-1773"><span class="linenos">1773</span></a>    <span class="k">def</span> <span class="nf">ndim</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="UndefinedPrimal.ndim-1774"><a href="#UndefinedPrimal.ndim-1774"><span class="linenos">1774</span></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">symval</span><span class="o">.</span><span class="n">ndim</span>
</span></pre></div>


    

                            </div>
                            <div id="UndefinedPrimal.str_short" class="classattr">
                                        <input id="UndefinedPrimal.str_short-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">str_short</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="UndefinedPrimal.str_short-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#UndefinedPrimal.str_short"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="UndefinedPrimal.str_short-1776"><a href="#UndefinedPrimal.str_short-1776"><span class="linenos">1776</span></a>    <span class="k">def</span> <span class="fm">__repr__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="UndefinedPrimal.str_short-1777"><a href="#UndefinedPrimal.str_short-1777"><span class="linenos">1777</span></a>        <span class="k">return</span> <span class="sa">f</span><span class="s2">&quot;&lt;UndefinedPrimal: symval=</span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">symval</span><span class="si">}</span><span class="s2">&gt;&quot;</span>
</span></pre></div>


            <div class="docstring"><p>Return repr(self).</p>
</div>


                            </div>
                            <div class="inherited">
                                <h5>Inherited Members</h5>
                                <dl>
                                    <div><dt>builtins.tuple</dt>
                                <dd id="UndefinedPrimal.index" class="function">index</dd>
                <dd id="UndefinedPrimal.count" class="function">count</dd>

            </div>
                                </dl>
                            </div>
                </section>
                <section id="PartialValue">
                            <input id="PartialValue-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr class">
            
    <span class="def">class</span>
    <span class="name">PartialValue</span><wbr>(<span class="base">typing.NamedTuple</span>):

                <label class="view-source-button" for="PartialValue-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#PartialValue"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="PartialValue-1782"><a href="#PartialValue-1782"><span class="linenos">1782</span></a><span class="k">class</span> <span class="nc">PartialValue</span><span class="p">(</span><span class="n">NamedTuple</span><span class="p">):</span>
</span><span id="PartialValue-1783"><a href="#PartialValue-1783"><span class="linenos">1783</span></a>    <span class="n">symval</span><span class="p">:</span> <span class="n">SymbolicTensor</span>
</span><span id="PartialValue-1784"><a href="#PartialValue-1784"><span class="linenos">1784</span></a>    <span class="n">const</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="n">Any</span><span class="p">]</span>
</span><span id="PartialValue-1785"><a href="#PartialValue-1785"><span class="linenos">1785</span></a>
</span><span id="PartialValue-1786"><a href="#PartialValue-1786"><span class="linenos">1786</span></a>    <span class="n">is_known</span> <span class="o">=</span> <span class="nb">property</span><span class="p">(</span><span class="k">lambda</span> <span class="bp">self</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">const</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">)</span>
</span><span id="PartialValue-1787"><a href="#PartialValue-1787"><span class="linenos">1787</span></a>    <span class="n">is_unknown</span> <span class="o">=</span> <span class="nb">property</span><span class="p">(</span><span class="k">lambda</span> <span class="bp">self</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">const</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">)</span>
</span></pre></div>


            <div class="docstring"><p>PartialValue(symval, const)</p>
</div>


                            <div id="PartialValue.__init__" class="classattr">
                                <div class="attr function">
            
        <span class="name">PartialValue</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">symval</span><span class="p">:</span> <span class="n"><a href="#SymbolicTensor">SymbolicTensor</a></span>, </span><span class="param"><span class="n">const</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="n">Any</span><span class="p">]</span></span>)</span>

        
    </div>
    <a class="headerlink" href="#PartialValue.__init__"></a>
    
            <div class="docstring"><p>Create new instance of PartialValue(symval, const)</p>
</div>


                            </div>
                            <div id="PartialValue.symval" class="classattr">
                                <div class="attr variable">
            <span class="name">symval</span><span class="annotation">: <a href="#SymbolicTensor">SymbolicTensor</a></span>

        
    </div>
    <a class="headerlink" href="#PartialValue.symval"></a>
    
            <div class="docstring"><p>Alias for field number 0</p>
</div>


                            </div>
                            <div id="PartialValue.const" class="classattr">
                                <div class="attr variable">
            <span class="name">const</span><span class="annotation">: Optional[Any]</span>

        
    </div>
    <a class="headerlink" href="#PartialValue.const"></a>
    
            <div class="docstring"><p>Alias for field number 1</p>
</div>


                            </div>
                            <div id="PartialValue.is_known" class="classattr">
                                        <input id="PartialValue.is_known-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr variable">
            <span class="name">is_known</span>

                <label class="view-source-button" for="PartialValue.is_known-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#PartialValue.is_known"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="PartialValue.is_known-1786"><a href="#PartialValue.is_known-1786"><span class="linenos">1786</span></a>    <span class="n">is_known</span> <span class="o">=</span> <span class="nb">property</span><span class="p">(</span><span class="k">lambda</span> <span class="bp">self</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">const</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">)</span>
</span></pre></div>


    

                            </div>
                            <div id="PartialValue.is_unknown" class="classattr">
                                        <input id="PartialValue.is_unknown-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr variable">
            <span class="name">is_unknown</span>

                <label class="view-source-button" for="PartialValue.is_unknown-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#PartialValue.is_unknown"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="PartialValue.is_unknown-1787"><a href="#PartialValue.is_unknown-1787"><span class="linenos">1787</span></a>    <span class="n">is_unknown</span> <span class="o">=</span> <span class="nb">property</span><span class="p">(</span><span class="k">lambda</span> <span class="bp">self</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">const</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">)</span>
</span></pre></div>


    

                            </div>
                            <div class="inherited">
                                <h5>Inherited Members</h5>
                                <dl>
                                    <div><dt>builtins.tuple</dt>
                                <dd id="PartialValue.index" class="function">index</dd>
                <dd id="PartialValue.count" class="function">count</dd>

            </div>
                                </dl>
                            </div>
                </section>
                <section id="LambdaBindingDraft">
                            <input id="LambdaBindingDraft-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr class">
            
    <span class="def">class</span>
    <span class="name">LambdaBindingDraft</span><wbr>(<span class="base">typing.NamedTuple</span>):

                <label class="view-source-button" for="LambdaBindingDraft-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#LambdaBindingDraft"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="LambdaBindingDraft-1790"><a href="#LambdaBindingDraft-1790"><span class="linenos">1790</span></a><span class="k">class</span> <span class="nc">LambdaBindingDraft</span><span class="p">(</span><span class="n">NamedTuple</span><span class="p">):</span>
</span><span id="LambdaBindingDraft-1791"><a href="#LambdaBindingDraft-1791"><span class="linenos">1791</span></a>    <span class="k">pass</span>
</span></pre></div>


            <div class="docstring"><p>LambdaBindingDraft()</p>
</div>


                            <div id="LambdaBindingDraft.__init__" class="classattr">
                                <div class="attr function">
            
        <span class="name">LambdaBindingDraft</span><span class="signature pdoc-code condensed">()</span>

        
    </div>
    <a class="headerlink" href="#LambdaBindingDraft.__init__"></a>
    
            <div class="docstring"><p>Create new instance of LambdaBindingDraft()</p>
</div>


                            </div>
                            <div class="inherited">
                                <h5>Inherited Members</h5>
                                <dl>
                                    <div><dt>builtins.tuple</dt>
                                <dd id="LambdaBindingDraft.index" class="function">index</dd>
                <dd id="LambdaBindingDraft.count" class="function">count</dd>

            </div>
                                </dl>
                            </div>
                </section>
                <section id="ConstDraft">
                            <input id="ConstDraft-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr class">
            
    <span class="def">class</span>
    <span class="name">ConstDraft</span><wbr>(<span class="base">typing.NamedTuple</span>):

                <label class="view-source-button" for="ConstDraft-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#ConstDraft"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="ConstDraft-1794"><a href="#ConstDraft-1794"><span class="linenos">1794</span></a><span class="k">class</span> <span class="nc">ConstDraft</span><span class="p">(</span><span class="n">NamedTuple</span><span class="p">):</span>
</span><span id="ConstDraft-1795"><a href="#ConstDraft-1795"><span class="linenos">1795</span></a>    <span class="n">val</span><span class="p">:</span> <span class="n">Any</span>
</span></pre></div>


            <div class="docstring"><p>ConstDraft(val,)</p>
</div>


                            <div id="ConstDraft.__init__" class="classattr">
                                <div class="attr function">
            
        <span class="name">ConstDraft</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">val</span><span class="p">:</span> <span class="n">Any</span></span>)</span>

        
    </div>
    <a class="headerlink" href="#ConstDraft.__init__"></a>
    
            <div class="docstring"><p>Create new instance of ConstDraft(val,)</p>
</div>


                            </div>
                            <div id="ConstDraft.val" class="classattr">
                                <div class="attr variable">
            <span class="name">val</span><span class="annotation">: Any</span>

        
    </div>
    <a class="headerlink" href="#ConstDraft.val"></a>
    
            <div class="docstring"><p>Alias for field number 0</p>
</div>


                            </div>
                            <div class="inherited">
                                <h5>Inherited Members</h5>
                                <dl>
                                    <div><dt>builtins.tuple</dt>
                                <dd id="ConstDraft.index" class="function">index</dd>
                <dd id="ConstDraft.count" class="function">count</dd>

            </div>
                                </dl>
                            </div>
                </section>
                <section id="InstructionDraft">
                            <input id="InstructionDraft-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr class">
            
    <span class="def">class</span>
    <span class="name">InstructionDraft</span><wbr>(<span class="base">typing.NamedTuple</span>):

                <label class="view-source-button" for="InstructionDraft-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#InstructionDraft"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="InstructionDraft-1798"><a href="#InstructionDraft-1798"><span class="linenos">1798</span></a><span class="k">class</span> <span class="nc">InstructionDraft</span><span class="p">(</span><span class="n">NamedTuple</span><span class="p">):</span>
</span><span id="InstructionDraft-1799"><a href="#InstructionDraft-1799"><span class="linenos">1799</span></a>    <span class="n">prim</span><span class="p">:</span> <span class="n">Operator</span>
</span><span id="InstructionDraft-1800"><a href="#InstructionDraft-1800"><span class="linenos">1800</span></a>    <span class="n">tracers_in</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="s2">&quot;PartialRunTraceTensor&quot;</span><span class="p">]</span>
</span><span id="InstructionDraft-1801"><a href="#InstructionDraft-1801"><span class="linenos">1801</span></a>    <span class="n">params</span><span class="p">:</span> <span class="n">Dict</span><span class="p">[</span><span class="nb">str</span><span class="p">,</span> <span class="n">Any</span><span class="p">]</span>
</span><span id="InstructionDraft-1802"><a href="#InstructionDraft-1802"><span class="linenos">1802</span></a>    <span class="n">symvals_out</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">SymbolicTensor</span><span class="p">]</span>
</span><span id="InstructionDraft-1803"><a href="#InstructionDraft-1803"><span class="linenos">1803</span></a>    <span class="n">tracer_refs_out</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">weakref</span><span class="o">.</span><span class="n">ReferenceType</span><span class="p">[</span><span class="s2">&quot;PartialRunTraceTensor&quot;</span><span class="p">]]</span>
</span></pre></div>


            <div class="docstring"><p>InstructionDraft(prim, tracers_in, params, symvals_out, tracer_refs_out)</p>
</div>


                            <div id="InstructionDraft.__init__" class="classattr">
                                <div class="attr function">
            
        <span class="name">InstructionDraft</span><span class="signature pdoc-code multiline">(<span class="param">	<span class="n">prim</span><span class="p">:</span> <span class="n"><a href="#Operator">Operator</a></span>,</span><span class="param">	<span class="n">tracers_in</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">ForwardRef</span><span class="p">(</span><span class="s1">&#39;PartialRunTraceTensor&#39;</span><span class="p">)]</span>,</span><span class="param">	<span class="n">params</span><span class="p">:</span> <span class="n">Dict</span><span class="p">[</span><span class="nb">str</span><span class="p">,</span> <span class="n">Any</span><span class="p">]</span>,</span><span class="param">	<span class="n">symvals_out</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n"><a href="#SymbolicTensor">SymbolicTensor</a></span><span class="p">]</span>,</span><span class="param">	<span class="n">tracer_refs_out</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">weakref</span><span class="o">.</span><span class="n">ReferenceType</span><span class="p">[</span><span class="s1">&#39;PartialRunTraceTensor&#39;</span><span class="p">]]</span></span>)</span>

        
    </div>
    <a class="headerlink" href="#InstructionDraft.__init__"></a>
    
            <div class="docstring"><p>Create new instance of InstructionDraft(prim, tracers_in, params, symvals_out, tracer_refs_out)</p>
</div>


                            </div>
                            <div id="InstructionDraft.prim" class="classattr">
                                <div class="attr variable">
            <span class="name">prim</span><span class="annotation">: <a href="#Operator">Operator</a></span>

        
    </div>
    <a class="headerlink" href="#InstructionDraft.prim"></a>
    
            <div class="docstring"><p>Alias for field number 0</p>
</div>


                            </div>
                            <div id="InstructionDraft.tracers_in" class="classattr">
                                <div class="attr variable">
            <span class="name">tracers_in</span><span class="annotation">: List[<a href="#PartialRunTraceTensor">PartialRunTraceTensor</a>]</span>

        
    </div>
    <a class="headerlink" href="#InstructionDraft.tracers_in"></a>
    
            <div class="docstring"><p>Alias for field number 1</p>
</div>


                            </div>
                            <div id="InstructionDraft.params" class="classattr">
                                <div class="attr variable">
            <span class="name">params</span><span class="annotation">: Dict[str, Any]</span>

        
    </div>
    <a class="headerlink" href="#InstructionDraft.params"></a>
    
            <div class="docstring"><p>Alias for field number 2</p>
</div>


                            </div>
                            <div id="InstructionDraft.symvals_out" class="classattr">
                                <div class="attr variable">
            <span class="name">symvals_out</span><span class="annotation">: List[<a href="#SymbolicTensor">SymbolicTensor</a>]</span>

        
    </div>
    <a class="headerlink" href="#InstructionDraft.symvals_out"></a>
    
            <div class="docstring"><p>Alias for field number 3</p>
</div>


                            </div>
                            <div id="InstructionDraft.tracer_refs_out" class="classattr">
                                <div class="attr variable">
            <span class="name">tracer_refs_out</span><span class="annotation">: List[weakref.ReferenceType[<a href="#PartialRunTraceTensor">PartialRunTraceTensor</a>]]</span>

        
    </div>
    <a class="headerlink" href="#InstructionDraft.tracer_refs_out"></a>
    
            <div class="docstring"><p>Alias for field number 4</p>
</div>


                            </div>
                            <div class="inherited">
                                <h5>Inherited Members</h5>
                                <dl>
                                    <div><dt>builtins.tuple</dt>
                                <dd id="InstructionDraft.index" class="function">index</dd>
                <dd id="InstructionDraft.count" class="function">count</dd>

            </div>
                                </dl>
                            </div>
                </section>
                <section id="ProgramDraft">
                    <div class="attr variable">
            <span class="name">ProgramDraft</span>        =
<span class="default_value">typing.Union[<a href="#LambdaBindingDraft">LambdaBindingDraft</a>, <a href="#ConstDraft">ConstDraft</a>, <a href="#InstructionDraft">InstructionDraft</a>]</span>

        
    </div>
    <a class="headerlink" href="#ProgramDraft"></a>
    
    

                </section>
                <section id="PartialRunTraceTensor">
                            <input id="PartialRunTraceTensor-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr class">
            
    <span class="def">class</span>
    <span class="name">PartialRunTraceTensor</span><wbr>(<span class="base"><a href="#TraceTensor">TraceTensor</a></span>):

                <label class="view-source-button" for="PartialRunTraceTensor-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#PartialRunTraceTensor"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="PartialRunTraceTensor-1809"><a href="#PartialRunTraceTensor-1809"><span class="linenos">1809</span></a><span class="k">class</span> <span class="nc">PartialRunTraceTensor</span><span class="p">(</span><span class="n">TraceTensor</span><span class="p">):</span>
</span><span id="PartialRunTraceTensor-1810"><a href="#PartialRunTraceTensor-1810"><span class="linenos">1810</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">trace</span><span class="p">,</span> <span class="n">pval</span><span class="p">,</span> <span class="n">draft</span><span class="p">):</span>
</span><span id="PartialRunTraceTensor-1811"><a href="#PartialRunTraceTensor-1811"><span class="linenos">1811</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">_trace</span> <span class="o">=</span> <span class="n">trace</span>
</span><span id="PartialRunTraceTensor-1812"><a href="#PartialRunTraceTensor-1812"><span class="linenos">1812</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">pval</span> <span class="o">=</span> <span class="n">pval</span>
</span><span id="PartialRunTraceTensor-1813"><a href="#PartialRunTraceTensor-1813"><span class="linenos">1813</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">draft</span> <span class="o">=</span> <span class="n">draft</span>
</span><span id="PartialRunTraceTensor-1814"><a href="#PartialRunTraceTensor-1814"><span class="linenos">1814</span></a>
</span><span id="PartialRunTraceTensor-1815"><a href="#PartialRunTraceTensor-1815"><span class="linenos">1815</span></a>    <span class="n">symval</span> <span class="o">=</span> <span class="nb">property</span><span class="p">(</span><span class="k">lambda</span> <span class="bp">self</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">pval</span><span class="o">.</span><span class="n">symval</span><span class="p">)</span>
</span><span id="PartialRunTraceTensor-1816"><a href="#PartialRunTraceTensor-1816"><span class="linenos">1816</span></a>    <span class="n">val</span> <span class="o">=</span> <span class="nb">property</span><span class="p">(</span><span class="k">lambda</span> <span class="bp">self</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">pval</span><span class="o">.</span><span class="n">const</span><span class="p">)</span>
</span><span id="PartialRunTraceTensor-1817"><a href="#PartialRunTraceTensor-1817"><span class="linenos">1817</span></a>
</span><span id="PartialRunTraceTensor-1818"><a href="#PartialRunTraceTensor-1818"><span class="linenos">1818</span></a>    <span class="k">def</span> <span class="nf">full_lower</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="PartialRunTraceTensor-1819"><a href="#PartialRunTraceTensor-1819"><span class="linenos">1819</span></a>        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">pval</span><span class="o">.</span><span class="n">is_known</span><span class="p">:</span>
</span><span id="PartialRunTraceTensor-1820"><a href="#PartialRunTraceTensor-1820"><span class="linenos">1820</span></a>            <span class="k">return</span> <span class="n">full_lower</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">pval</span><span class="o">.</span><span class="n">const</span><span class="p">)</span>
</span><span id="PartialRunTraceTensor-1821"><a href="#PartialRunTraceTensor-1821"><span class="linenos">1821</span></a>        <span class="k">return</span> <span class="bp">self</span>
</span></pre></div>


    

                            <div id="PartialRunTraceTensor.__init__" class="classattr">
                                        <input id="PartialRunTraceTensor.__init__-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="name">PartialRunTraceTensor</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">trace</span>, </span><span class="param"><span class="n">pval</span>, </span><span class="param"><span class="n">draft</span></span>)</span>

                <label class="view-source-button" for="PartialRunTraceTensor.__init__-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#PartialRunTraceTensor.__init__"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="PartialRunTraceTensor.__init__-1810"><a href="#PartialRunTraceTensor.__init__-1810"><span class="linenos">1810</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">trace</span><span class="p">,</span> <span class="n">pval</span><span class="p">,</span> <span class="n">draft</span><span class="p">):</span>
</span><span id="PartialRunTraceTensor.__init__-1811"><a href="#PartialRunTraceTensor.__init__-1811"><span class="linenos">1811</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">_trace</span> <span class="o">=</span> <span class="n">trace</span>
</span><span id="PartialRunTraceTensor.__init__-1812"><a href="#PartialRunTraceTensor.__init__-1812"><span class="linenos">1812</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">pval</span> <span class="o">=</span> <span class="n">pval</span>
</span><span id="PartialRunTraceTensor.__init__-1813"><a href="#PartialRunTraceTensor.__init__-1813"><span class="linenos">1813</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">draft</span> <span class="o">=</span> <span class="n">draft</span>
</span></pre></div>


    

                            </div>
                            <div id="PartialRunTraceTensor.pval" class="classattr">
                                <div class="attr variable">
            <span class="name">pval</span>

        
    </div>
    <a class="headerlink" href="#PartialRunTraceTensor.pval"></a>
    
    

                            </div>
                            <div id="PartialRunTraceTensor.draft" class="classattr">
                                <div class="attr variable">
            <span class="name">draft</span>

        
    </div>
    <a class="headerlink" href="#PartialRunTraceTensor.draft"></a>
    
    

                            </div>
                            <div id="PartialRunTraceTensor.symval" class="classattr">
                                        <input id="PartialRunTraceTensor.symval-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr variable">
            <span class="name">symval</span>

                <label class="view-source-button" for="PartialRunTraceTensor.symval-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#PartialRunTraceTensor.symval"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="PartialRunTraceTensor.symval-1815"><a href="#PartialRunTraceTensor.symval-1815"><span class="linenos">1815</span></a>    <span class="n">symval</span> <span class="o">=</span> <span class="nb">property</span><span class="p">(</span><span class="k">lambda</span> <span class="bp">self</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">pval</span><span class="o">.</span><span class="n">symval</span><span class="p">)</span>
</span></pre></div>


    

                            </div>
                            <div id="PartialRunTraceTensor.val" class="classattr">
                                        <input id="PartialRunTraceTensor.val-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr variable">
            <span class="name">val</span>

                <label class="view-source-button" for="PartialRunTraceTensor.val-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#PartialRunTraceTensor.val"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="PartialRunTraceTensor.val-1816"><a href="#PartialRunTraceTensor.val-1816"><span class="linenos">1816</span></a>    <span class="n">val</span> <span class="o">=</span> <span class="nb">property</span><span class="p">(</span><span class="k">lambda</span> <span class="bp">self</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">pval</span><span class="o">.</span><span class="n">const</span><span class="p">)</span>
</span></pre></div>


    

                            </div>
                            <div id="PartialRunTraceTensor.full_lower" class="classattr">
                                        <input id="PartialRunTraceTensor.full_lower-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">full_lower</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="PartialRunTraceTensor.full_lower-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#PartialRunTraceTensor.full_lower"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="PartialRunTraceTensor.full_lower-1818"><a href="#PartialRunTraceTensor.full_lower-1818"><span class="linenos">1818</span></a>    <span class="k">def</span> <span class="nf">full_lower</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
</span><span id="PartialRunTraceTensor.full_lower-1819"><a href="#PartialRunTraceTensor.full_lower-1819"><span class="linenos">1819</span></a>        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">pval</span><span class="o">.</span><span class="n">is_known</span><span class="p">:</span>
</span><span id="PartialRunTraceTensor.full_lower-1820"><a href="#PartialRunTraceTensor.full_lower-1820"><span class="linenos">1820</span></a>            <span class="k">return</span> <span class="n">full_lower</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">pval</span><span class="o">.</span><span class="n">const</span><span class="p">)</span>
</span><span id="PartialRunTraceTensor.full_lower-1821"><a href="#PartialRunTraceTensor.full_lower-1821"><span class="linenos">1821</span></a>        <span class="k">return</span> <span class="bp">self</span>
</span></pre></div>


    

                            </div>
                            <div class="inherited">
                                <h5>Inherited Members</h5>
                                <dl>
                                    <div><dt><a href="#TraceTensor">TraceTensor</a></dt>
                                <dd id="PartialRunTraceTensor.PYTHON_TYPES" class="variable"><a href="#TraceTensor.PYTHON_TYPES">PYTHON_TYPES</a></dd>
                <dd id="PartialRunTraceTensor.dtype" class="variable"><a href="#TraceTensor.dtype">dtype</a></dd>
                <dd id="PartialRunTraceTensor.shape" class="variable"><a href="#TraceTensor.shape">shape</a></dd>
                <dd id="PartialRunTraceTensor.device" class="variable"><a href="#TraceTensor.device">device</a></dd>
                <dd id="PartialRunTraceTensor.ndim" class="variable"><a href="#TraceTensor.ndim">ndim</a></dd>

            </div>
            <div><dt><a href="#Tensor">Tensor</a></dt>
                                <dd id="PartialRunTraceTensor.buf" class="variable"><a href="#Tensor.buf">buf</a></dd>
                <dd id="PartialRunTraceTensor.default_dtype" class="variable"><a href="#Tensor.default_dtype">default_dtype</a></dd>
                <dd id="PartialRunTraceTensor.is_int" class="function"><a href="#Tensor.is_int">is_int</a></dd>
                <dd id="PartialRunTraceTensor.is_float" class="function"><a href="#Tensor.is_float">is_float</a></dd>
                <dd id="PartialRunTraceTensor.is_unsigned" class="function"><a href="#Tensor.is_unsigned">is_unsigned</a></dd>
                <dd id="PartialRunTraceTensor.to_bool" class="function"><a href="#Tensor.to_bool">to_bool</a></dd>
                <dd id="PartialRunTraceTensor.short" class="function"><a href="#Tensor.short">short</a></dd>
                <dd id="PartialRunTraceTensor.int" class="function"><a href="#Tensor.int">int</a></dd>
                <dd id="PartialRunTraceTensor.long" class="function"><a href="#Tensor.long">long</a></dd>
                <dd id="PartialRunTraceTensor.half" class="function"><a href="#Tensor.half">half</a></dd>
                <dd id="PartialRunTraceTensor.float" class="function"><a href="#Tensor.float">float</a></dd>
                <dd id="PartialRunTraceTensor.str_short" class="function"><a href="#Tensor.str_short">str_short</a></dd>
                <dd id="PartialRunTraceTensor.size" class="function"><a href="#Tensor.size">size</a></dd>
                <dd id="PartialRunTraceTensor.numpy" class="function"><a href="#Tensor.numpy">numpy</a></dd>
                <dd id="PartialRunTraceTensor.numel" class="function"><a href="#Tensor.numel">numel</a></dd>
                <dd id="PartialRunTraceTensor.element_size" class="function"><a href="#Tensor.element_size">element_size</a></dd>
                <dd id="PartialRunTraceTensor.nbytes" class="function"><a href="#Tensor.nbytes">nbytes</a></dd>

            </div>
                                </dl>
                            </div>
                </section>
                <section id="PartialRunTrace">
                            <input id="PartialRunTrace-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr class">
            
    <span class="def">class</span>
    <span class="name">PartialRunTrace</span><wbr>(<span class="base"><a href="#Trace">Trace</a></span>):

                <label class="view-source-button" for="PartialRunTrace-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#PartialRunTrace"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="PartialRunTrace-1824"><a href="#PartialRunTrace-1824"><span class="linenos">1824</span></a><span class="k">class</span> <span class="nc">PartialRunTrace</span><span class="p">(</span><span class="n">Trace</span><span class="p">):</span>
</span><span id="PartialRunTrace-1825"><a href="#PartialRunTrace-1825"><span class="linenos">1825</span></a>    <span class="k">def</span> <span class="nf">new_arg</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">pval</span><span class="p">:</span> <span class="n">PartialValue</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Any</span><span class="p">:</span>
</span><span id="PartialRunTrace-1826"><a href="#PartialRunTrace-1826"><span class="linenos">1826</span></a>        <span class="k">return</span> <span class="n">PartialRunTraceTensor</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">pval</span><span class="p">,</span> <span class="n">LambdaBindingDraft</span><span class="p">())</span>
</span><span id="PartialRunTrace-1827"><a href="#PartialRunTrace-1827"><span class="linenos">1827</span></a>
</span><span id="PartialRunTrace-1828"><a href="#PartialRunTrace-1828"><span class="linenos">1828</span></a>    <span class="k">def</span> <span class="nf">pure</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">val</span><span class="p">:</span> <span class="n">Any</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">PartialRunTraceTensor</span><span class="p">:</span>
</span><span id="PartialRunTrace-1829"><a href="#PartialRunTrace-1829"><span class="linenos">1829</span></a>        <span class="k">return</span> <span class="n">PartialRunTraceTensor</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">make_known_pval</span><span class="p">(</span><span class="n">val</span><span class="p">),</span> <span class="kc">None</span><span class="p">)</span>
</span><span id="PartialRunTrace-1830"><a href="#PartialRunTrace-1830"><span class="linenos">1830</span></a>
</span><span id="PartialRunTrace-1831"><a href="#PartialRunTrace-1831"><span class="linenos">1831</span></a>    <span class="k">def</span> <span class="nf">instantiate_const</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">tracer</span><span class="p">:</span> <span class="n">PartialRunTraceTensor</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">PartialRunTraceTensor</span><span class="p">:</span>
</span><span id="PartialRunTrace-1832"><a href="#PartialRunTrace-1832"><span class="linenos">1832</span></a>        <span class="k">if</span> <span class="n">tracer</span><span class="o">.</span><span class="n">pval</span><span class="o">.</span><span class="n">is_unknown</span><span class="p">:</span>
</span><span id="PartialRunTrace-1833"><a href="#PartialRunTrace-1833"><span class="linenos">1833</span></a>            <span class="k">return</span> <span class="n">tracer</span>
</span><span id="PartialRunTrace-1834"><a href="#PartialRunTrace-1834"><span class="linenos">1834</span></a>        <span class="k">else</span><span class="p">:</span>
</span><span id="PartialRunTrace-1835"><a href="#PartialRunTrace-1835"><span class="linenos">1835</span></a>            <span class="n">pval</span> <span class="o">=</span> <span class="n">make_unknown_pval</span><span class="p">(</span><span class="n">SymbolicTensor</span><span class="o">.</span><span class="n">like</span><span class="p">(</span><span class="n">tracer</span><span class="o">.</span><span class="n">symval</span><span class="p">))</span>
</span><span id="PartialRunTrace-1836"><a href="#PartialRunTrace-1836"><span class="linenos">1836</span></a>            <span class="k">return</span> <span class="n">PartialRunTraceTensor</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">pval</span><span class="p">,</span> <span class="n">ConstDraft</span><span class="p">(</span><span class="n">tracer</span><span class="o">.</span><span class="n">pval</span><span class="o">.</span><span class="n">const</span><span class="p">))</span>
</span><span id="PartialRunTrace-1837"><a href="#PartialRunTrace-1837"><span class="linenos">1837</span></a>
</span><span id="PartialRunTrace-1838"><a href="#PartialRunTrace-1838"><span class="linenos">1838</span></a>    <span class="k">def</span> <span class="nf">run_op</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">op</span><span class="p">,</span> <span class="n">tracers</span><span class="p">,</span> <span class="n">params</span><span class="p">):</span>
</span><span id="PartialRunTrace-1839"><a href="#PartialRunTrace-1839"><span class="linenos">1839</span></a>        <span class="n">is_knowns</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">t</span><span class="o">.</span><span class="n">pval</span><span class="o">.</span><span class="n">is_known</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">tracers</span><span class="p">)</span>
</span><span id="PartialRunTrace-1840"><a href="#PartialRunTrace-1840"><span class="linenos">1840</span></a>
</span><span id="PartialRunTrace-1841"><a href="#PartialRunTrace-1841"><span class="linenos">1841</span></a>        <span class="k">if</span> <span class="nb">all</span><span class="p">(</span><span class="n">is_knowns</span><span class="p">):</span>
</span><span id="PartialRunTrace-1842"><a href="#PartialRunTrace-1842"><span class="linenos">1842</span></a>            <span class="k">return</span> <span class="n">bind</span><span class="p">(</span><span class="n">op</span><span class="p">,</span> <span class="o">*</span><span class="n">list_map</span><span class="p">(</span><span class="n">full_lower</span><span class="p">,</span> <span class="n">tracers</span><span class="p">),</span> <span class="o">**</span><span class="n">params</span><span class="p">)</span>
</span><span id="PartialRunTrace-1843"><a href="#PartialRunTrace-1843"><span class="linenos">1843</span></a>        <span class="k">return</span> <span class="n">op</span><span class="o">.</span><span class="n">partial_run</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">tracers</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)</span>
</span></pre></div>


    

                            <div id="PartialRunTrace.new_arg" class="classattr">
                                        <input id="PartialRunTrace.new_arg-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">new_arg</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="n">pval</span><span class="p">:</span> <span class="n"><a href="#PartialValue">PartialValue</a></span></span><span class="return-annotation">) -> <span class="n">Any</span>:</span></span>

                <label class="view-source-button" for="PartialRunTrace.new_arg-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#PartialRunTrace.new_arg"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="PartialRunTrace.new_arg-1825"><a href="#PartialRunTrace.new_arg-1825"><span class="linenos">1825</span></a>    <span class="k">def</span> <span class="nf">new_arg</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">pval</span><span class="p">:</span> <span class="n">PartialValue</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Any</span><span class="p">:</span>
</span><span id="PartialRunTrace.new_arg-1826"><a href="#PartialRunTrace.new_arg-1826"><span class="linenos">1826</span></a>        <span class="k">return</span> <span class="n">PartialRunTraceTensor</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">pval</span><span class="p">,</span> <span class="n">LambdaBindingDraft</span><span class="p">())</span>
</span></pre></div>


    

                            </div>
                            <div id="PartialRunTrace.pure" class="classattr">
                                        <input id="PartialRunTrace.pure-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">pure</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="n">val</span><span class="p">:</span> <span class="n">Any</span></span><span class="return-annotation">) -> <span class="n"><a href="#PartialRunTraceTensor">PartialRunTraceTensor</a></span>:</span></span>

                <label class="view-source-button" for="PartialRunTrace.pure-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#PartialRunTrace.pure"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="PartialRunTrace.pure-1828"><a href="#PartialRunTrace.pure-1828"><span class="linenos">1828</span></a>    <span class="k">def</span> <span class="nf">pure</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">val</span><span class="p">:</span> <span class="n">Any</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">PartialRunTraceTensor</span><span class="p">:</span>
</span><span id="PartialRunTrace.pure-1829"><a href="#PartialRunTrace.pure-1829"><span class="linenos">1829</span></a>        <span class="k">return</span> <span class="n">PartialRunTraceTensor</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">make_known_pval</span><span class="p">(</span><span class="n">val</span><span class="p">),</span> <span class="kc">None</span><span class="p">)</span>
</span></pre></div>


    

                            </div>
                            <div id="PartialRunTrace.instantiate_const" class="classattr">
                                        <input id="PartialRunTrace.instantiate_const-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">instantiate_const</span><span class="signature pdoc-code multiline">(<span class="param">	<span class="bp">self</span>,</span><span class="param">	<span class="n">tracer</span><span class="p">:</span> <span class="n"><a href="#PartialRunTraceTensor">PartialRunTraceTensor</a></span></span><span class="return-annotation">) -> <span class="n"><a href="#PartialRunTraceTensor">PartialRunTraceTensor</a></span>:</span></span>

                <label class="view-source-button" for="PartialRunTrace.instantiate_const-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#PartialRunTrace.instantiate_const"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="PartialRunTrace.instantiate_const-1831"><a href="#PartialRunTrace.instantiate_const-1831"><span class="linenos">1831</span></a>    <span class="k">def</span> <span class="nf">instantiate_const</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">tracer</span><span class="p">:</span> <span class="n">PartialRunTraceTensor</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">PartialRunTraceTensor</span><span class="p">:</span>
</span><span id="PartialRunTrace.instantiate_const-1832"><a href="#PartialRunTrace.instantiate_const-1832"><span class="linenos">1832</span></a>        <span class="k">if</span> <span class="n">tracer</span><span class="o">.</span><span class="n">pval</span><span class="o">.</span><span class="n">is_unknown</span><span class="p">:</span>
</span><span id="PartialRunTrace.instantiate_const-1833"><a href="#PartialRunTrace.instantiate_const-1833"><span class="linenos">1833</span></a>            <span class="k">return</span> <span class="n">tracer</span>
</span><span id="PartialRunTrace.instantiate_const-1834"><a href="#PartialRunTrace.instantiate_const-1834"><span class="linenos">1834</span></a>        <span class="k">else</span><span class="p">:</span>
</span><span id="PartialRunTrace.instantiate_const-1835"><a href="#PartialRunTrace.instantiate_const-1835"><span class="linenos">1835</span></a>            <span class="n">pval</span> <span class="o">=</span> <span class="n">make_unknown_pval</span><span class="p">(</span><span class="n">SymbolicTensor</span><span class="o">.</span><span class="n">like</span><span class="p">(</span><span class="n">tracer</span><span class="o">.</span><span class="n">symval</span><span class="p">))</span>
</span><span id="PartialRunTrace.instantiate_const-1836"><a href="#PartialRunTrace.instantiate_const-1836"><span class="linenos">1836</span></a>            <span class="k">return</span> <span class="n">PartialRunTraceTensor</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">pval</span><span class="p">,</span> <span class="n">ConstDraft</span><span class="p">(</span><span class="n">tracer</span><span class="o">.</span><span class="n">pval</span><span class="o">.</span><span class="n">const</span><span class="p">))</span>
</span></pre></div>


    

                            </div>
                            <div id="PartialRunTrace.run_op" class="classattr">
                                        <input id="PartialRunTrace.run_op-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">run_op</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="n">op</span>, </span><span class="param"><span class="n">tracers</span>, </span><span class="param"><span class="n">params</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="PartialRunTrace.run_op-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#PartialRunTrace.run_op"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="PartialRunTrace.run_op-1838"><a href="#PartialRunTrace.run_op-1838"><span class="linenos">1838</span></a>    <span class="k">def</span> <span class="nf">run_op</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">op</span><span class="p">,</span> <span class="n">tracers</span><span class="p">,</span> <span class="n">params</span><span class="p">):</span>
</span><span id="PartialRunTrace.run_op-1839"><a href="#PartialRunTrace.run_op-1839"><span class="linenos">1839</span></a>        <span class="n">is_knowns</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">t</span><span class="o">.</span><span class="n">pval</span><span class="o">.</span><span class="n">is_known</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">tracers</span><span class="p">)</span>
</span><span id="PartialRunTrace.run_op-1840"><a href="#PartialRunTrace.run_op-1840"><span class="linenos">1840</span></a>
</span><span id="PartialRunTrace.run_op-1841"><a href="#PartialRunTrace.run_op-1841"><span class="linenos">1841</span></a>        <span class="k">if</span> <span class="nb">all</span><span class="p">(</span><span class="n">is_knowns</span><span class="p">):</span>
</span><span id="PartialRunTrace.run_op-1842"><a href="#PartialRunTrace.run_op-1842"><span class="linenos">1842</span></a>            <span class="k">return</span> <span class="n">bind</span><span class="p">(</span><span class="n">op</span><span class="p">,</span> <span class="o">*</span><span class="n">list_map</span><span class="p">(</span><span class="n">full_lower</span><span class="p">,</span> <span class="n">tracers</span><span class="p">),</span> <span class="o">**</span><span class="n">params</span><span class="p">)</span>
</span><span id="PartialRunTrace.run_op-1843"><a href="#PartialRunTrace.run_op-1843"><span class="linenos">1843</span></a>        <span class="k">return</span> <span class="n">op</span><span class="o">.</span><span class="n">partial_run</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">tracers</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)</span>
</span></pre></div>


    

                            </div>
                            <div class="inherited">
                                <h5>Inherited Members</h5>
                                <dl>
                                    <div><dt><a href="#Trace">Trace</a></dt>
                                <dd id="PartialRunTrace.__init__" class="function"><a href="#Trace.__init__">Trace</a></dd>
                <dd id="PartialRunTrace.main" class="variable"><a href="#Trace.main">main</a></dd>

            </div>
                                </dl>
                            </div>
                </section>
                <section id="trace_stack">
                    <div class="attr variable">
            <span class="name">trace_stack</span><span class="annotation">: List[<a href="#MainTrace">MainTrace</a>]</span>        =
<span class="default_value">[MainTrace(level=0, trace_type=&lt;class &#39;<a href="#RunTrace">RunTrace</a>&#39;&gt;, global_data=None)]</span>

        
    </div>
    <a class="headerlink" href="#trace_stack"></a>
    
    

                </section>
                <section id="stashed_trace">
                    <div class="attr variable">
            <span class="name">stashed_trace</span><span class="annotation">: Optional[<a href="#MainTrace">MainTrace</a>]</span>        =
<span class="default_value">None</span>

        
    </div>
    <a class="headerlink" href="#stashed_trace"></a>
    
    

                </section>
                <section id="UndefBackend">
                            <input id="UndefBackend-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr class">
            
    <span class="def">class</span>
    <span class="name">UndefBackend</span>:

                <label class="view-source-button" for="UndefBackend-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#UndefBackend"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="UndefBackend-1851"><a href="#UndefBackend-1851"><span class="linenos">1851</span></a><span class="k">class</span> <span class="nc">UndefBackend</span><span class="p">:</span>
</span><span id="UndefBackend-1852"><a href="#UndefBackend-1852"><span class="linenos">1852</span></a>    <span class="k">def</span> <span class="fm">__getattr__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">attr</span><span class="p">):</span>
</span><span id="UndefBackend-1853"><a href="#UndefBackend-1853"><span class="linenos">1853</span></a>        <span class="k">raise</span> <span class="ne">NotImplementedError</span><span class="p">(</span><span class="s2">&quot;Backend not init yet with slope.core.set_backend(backend)&quot;</span><span class="p">)</span>
</span></pre></div>


    

                </section>
                <section id="backend">
                    <div class="attr variable">
            <span class="name">backend</span>        =
<span class="default_value">&lt;slope.backends.onnxruntime.ONNXRuntimeBackend object&gt;</span>

        
    </div>
    <a class="headerlink" href="#backend"></a>
    
    

                </section>
                <section id="set_backend">
                            <input id="set_backend-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">set_backend</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">name</span>, </span><span class="param"><span class="n">where</span><span class="o">=</span><span class="s1">&#39;slope.backends&#39;</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="set_backend-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#set_backend"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="set_backend-1859"><a href="#set_backend-1859"><span class="linenos">1859</span></a><span class="k">def</span> <span class="nf">set_backend</span><span class="p">(</span><span class="n">name</span><span class="p">,</span> <span class="n">where</span><span class="o">=</span><span class="s2">&quot;slope.backends&quot;</span><span class="p">):</span>
</span><span id="set_backend-1860"><a href="#set_backend-1860"><span class="linenos">1860</span></a>    <span class="k">global</span> <span class="n">backend</span>
</span><span id="set_backend-1861"><a href="#set_backend-1861"><span class="linenos">1861</span></a>    <span class="n">backend</span> <span class="o">=</span> <span class="n">importlib</span><span class="o">.</span><span class="n">import_module</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">where</span><span class="si">}</span><span class="s2">.</span><span class="si">{</span><span class="n">name</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">)</span><span class="o">.</span><span class="n">backend</span>
</span><span id="set_backend-1862"><a href="#set_backend-1862"><span class="linenos">1862</span></a>    <span class="kn">import</span> <span class="nn">slope.nn</span> <span class="k">as</span> <span class="nn">nn</span>
</span><span id="set_backend-1863"><a href="#set_backend-1863"><span class="linenos">1863</span></a>    <span class="c1"># backend.register_node(nn.Module, nn.Module.flatten, nn.Module.unflatten, &quot;Module&quot;)</span>
</span><span id="set_backend-1864"><a href="#set_backend-1864"><span class="linenos">1864</span></a>
</span><span id="set_backend-1865"><a href="#set_backend-1865"><span class="linenos">1865</span></a>    <span class="n">dblog</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;slope backend is </span><span class="si">{</span><span class="n">backend</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">,</span> <span class="n">enable</span><span class="o">=</span><span class="n">backend</span><span class="o">.</span><span class="n">LOG_INIT</span><span class="p">)</span>
</span></pre></div>


    

                </section>
                <section id="stack_str">
                            <input id="stack_str-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">stack_str</span><span class="signature pdoc-code condensed">(<span class="return-annotation">):</span></span>

                <label class="view-source-button" for="stack_str-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#stack_str"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="stack_str-1868"><a href="#stack_str-1868"><span class="linenos">1868</span></a><span class="k">def</span> <span class="nf">stack_str</span><span class="p">():</span>
</span><span id="stack_str-1869"><a href="#stack_str-1869"><span class="linenos">1869</span></a>    <span class="n">ret</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span>
</span><span id="stack_str-1870"><a href="#stack_str-1870"><span class="linenos">1870</span></a>    <span class="k">for</span> <span class="n">trace</span> <span class="ow">in</span> <span class="n">trace_stack</span><span class="p">:</span>
</span><span id="stack_str-1871"><a href="#stack_str-1871"><span class="linenos">1871</span></a>        <span class="n">ret</span> <span class="o">+=</span> <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">trace</span><span class="o">.</span><span class="n">level</span><span class="si">}</span><span class="s2">: </span><span class="si">{</span><span class="n">trace</span><span class="o">.</span><span class="n">trace_type</span><span class="o">.</span><span class="vm">__name__</span><span class="si">}</span><span class="se">\t</span><span class="si">{</span><span class="n">trace</span><span class="o">.</span><span class="n">global_data</span><span class="si">=}</span><span class="se">\n</span><span class="s2">&quot;</span>
</span><span id="stack_str-1872"><a href="#stack_str-1872"><span class="linenos">1872</span></a>    <span class="k">return</span> <span class="n">ret</span>
</span></pre></div>


    

                </section>
                <section id="make_known_pval">
                            <input id="make_known_pval-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">make_known_pval</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">val</span><span class="p">:</span> <span class="n">Any</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="make_known_pval-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#make_known_pval"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="make_known_pval-1875"><a href="#make_known_pval-1875"><span class="linenos">1875</span></a><span class="k">def</span> <span class="nf">make_known_pval</span><span class="p">(</span><span class="n">val</span><span class="p">:</span> <span class="n">Any</span><span class="p">):</span>
</span><span id="make_known_pval-1876"><a href="#make_known_pval-1876"><span class="linenos">1876</span></a>    <span class="k">return</span> <span class="n">PartialValue</span><span class="p">(</span><span class="n">get_symval</span><span class="p">(</span><span class="n">val</span><span class="p">),</span> <span class="n">val</span><span class="p">)</span>
</span></pre></div>


    

                </section>
                <section id="make_unknown_pval">
                            <input id="make_unknown_pval-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">make_unknown_pval</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">symval</span><span class="p">:</span> <span class="n"><a href="#SymbolicTensor">SymbolicTensor</a></span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="make_unknown_pval-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#make_unknown_pval"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="make_unknown_pval-1879"><a href="#make_unknown_pval-1879"><span class="linenos">1879</span></a><span class="k">def</span> <span class="nf">make_unknown_pval</span><span class="p">(</span><span class="n">symval</span><span class="p">:</span> <span class="n">SymbolicTensor</span><span class="p">):</span>
</span><span id="make_unknown_pval-1880"><a href="#make_unknown_pval-1880"><span class="linenos">1880</span></a>    <span class="k">return</span> <span class="n">PartialValue</span><span class="p">(</span><span class="n">symval</span><span class="p">,</span> <span class="kc">None</span><span class="p">)</span>
</span></pre></div>


    

                </section>
                <section id="get_symval">
                            <input id="get_symval-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">get_symval</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">x</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="get_symval-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#get_symval"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="get_symval-1883"><a href="#get_symval-1883"><span class="linenos">1883</span></a><span class="k">def</span> <span class="nf">get_symval</span><span class="p">(</span><span class="n">x</span><span class="p">):</span>
</span><span id="get_symval-1884"><a href="#get_symval-1884"><span class="linenos">1884</span></a>    <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">TraceTensor</span><span class="p">):</span>
</span><span id="get_symval-1885"><a href="#get_symval-1885"><span class="linenos">1885</span></a>        <span class="k">return</span> <span class="n">x</span><span class="o">.</span><span class="n">symval</span>
</span><span id="get_symval-1886"><a href="#get_symval-1886"><span class="linenos">1886</span></a>    <span class="k">elif</span> <span class="nb">type</span><span class="p">(</span><span class="n">x</span><span class="p">)</span> <span class="ow">in</span> <span class="n">TraceTensor</span><span class="o">.</span><span class="n">PYTHON_TYPES</span><span class="p">:</span>
</span><span id="get_symval-1887"><a href="#get_symval-1887"><span class="linenos">1887</span></a>        <span class="k">return</span> <span class="n">backend</span><span class="o">.</span><span class="n">tensor</span><span class="p">(</span><span class="n">x</span><span class="p">)</span>
</span><span id="get_symval-1888"><a href="#get_symval-1888"><span class="linenos">1888</span></a>    <span class="k">elif</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">Tensor</span><span class="p">):</span>
</span><span id="get_symval-1889"><a href="#get_symval-1889"><span class="linenos">1889</span></a>        <span class="k">return</span> <span class="n">x</span>
</span><span id="get_symval-1890"><a href="#get_symval-1890"><span class="linenos">1890</span></a>    <span class="k">elif</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">SymbolicTensor</span><span class="p">):</span>
</span><span id="get_symval-1891"><a href="#get_symval-1891"><span class="linenos">1891</span></a>        <span class="k">return</span> <span class="n">x</span>
</span><span id="get_symval-1892"><a href="#get_symval-1892"><span class="linenos">1892</span></a>    <span class="k">else</span><span class="p">:</span>
</span><span id="get_symval-1893"><a href="#get_symval-1893"><span class="linenos">1893</span></a>        <span class="k">raise</span> <span class="ne">TypeError</span><span class="p">(</span><span class="nb">type</span><span class="p">(</span><span class="n">x</span><span class="p">))</span>
</span></pre></div>


    

                </section>
                <section id="tree_flatten">
                            <input id="tree_flatten-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">tree_flatten</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">x</span><span class="p">:</span> <span class="n">Any</span></span><span class="return-annotation">) -> <span class="n">Any</span>:</span></span>

                <label class="view-source-button" for="tree_flatten-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#tree_flatten"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="tree_flatten-1896"><a href="#tree_flatten-1896"><span class="linenos">1896</span></a><span class="k">def</span> <span class="nf">tree_flatten</span><span class="p">(</span><span class="n">x</span><span class="p">:</span> <span class="n">Any</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Any</span><span class="p">:</span>
</span><span id="tree_flatten-1897"><a href="#tree_flatten-1897"><span class="linenos">1897</span></a>    <span class="k">def</span> <span class="nf">_tree_flatten</span><span class="p">(</span><span class="n">x_</span><span class="p">:</span> <span class="n">Any</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Tuple</span><span class="p">[</span><span class="n">Iterable</span><span class="p">,</span> <span class="n">Union</span><span class="p">[</span><span class="n">TreeDef</span><span class="p">,</span> <span class="n">Leaf</span><span class="p">]]:</span>
</span><span id="tree_flatten-1898"><a href="#tree_flatten-1898"><span class="linenos">1898</span></a>        <span class="n">node_type</span> <span class="o">=</span> <span class="kc">None</span>
</span><span id="tree_flatten-1899"><a href="#tree_flatten-1899"><span class="linenos">1899</span></a>        <span class="k">for</span> <span class="n">k</span> <span class="ow">in</span> <span class="n">backend</span><span class="o">.</span><span class="n">node_types</span><span class="o">.</span><span class="n">keys</span><span class="p">():</span>
</span><span id="tree_flatten-1900"><a href="#tree_flatten-1900"><span class="linenos">1900</span></a>            <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">x_</span><span class="p">,</span> <span class="n">k</span><span class="p">):</span>
</span><span id="tree_flatten-1901"><a href="#tree_flatten-1901"><span class="linenos">1901</span></a>                <span class="n">node_type</span> <span class="o">=</span> <span class="n">backend</span><span class="o">.</span><span class="n">node_types</span><span class="p">[</span><span class="n">k</span><span class="p">]</span>
</span><span id="tree_flatten-1902"><a href="#tree_flatten-1902"><span class="linenos">1902</span></a>
</span><span id="tree_flatten-1903"><a href="#tree_flatten-1903"><span class="linenos">1903</span></a>        <span class="k">if</span> <span class="n">node_type</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
</span><span id="tree_flatten-1904"><a href="#tree_flatten-1904"><span class="linenos">1904</span></a>            <span class="n">node_metadata</span><span class="p">,</span> <span class="n">children</span> <span class="o">=</span> <span class="n">node_type</span><span class="o">.</span><span class="n">flatten</span><span class="p">(</span><span class="n">x_</span><span class="p">)</span>
</span><span id="tree_flatten-1905"><a href="#tree_flatten-1905"><span class="linenos">1905</span></a>            <span class="n">children_flat</span><span class="p">,</span> <span class="n">child_trees</span> <span class="o">=</span> <span class="n">unzip2</span><span class="p">(</span><span class="n">list_map</span><span class="p">(</span><span class="n">_tree_flatten</span><span class="p">,</span> <span class="n">children</span><span class="p">))</span>
</span><span id="tree_flatten-1906"><a href="#tree_flatten-1906"><span class="linenos">1906</span></a>            <span class="n">children_iter</span> <span class="o">=</span> <span class="n">itertools</span><span class="o">.</span><span class="n">chain</span><span class="o">.</span><span class="n">from_iterable</span><span class="p">(</span><span class="n">children_flat</span><span class="p">)</span>
</span><span id="tree_flatten-1907"><a href="#tree_flatten-1907"><span class="linenos">1907</span></a>            <span class="n">treedef</span> <span class="o">=</span> <span class="n">TreeDef</span><span class="p">(</span><span class="n">node_type</span><span class="p">,</span> <span class="n">node_metadata</span><span class="p">,</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">child_trees</span><span class="p">))</span>
</span><span id="tree_flatten-1908"><a href="#tree_flatten-1908"><span class="linenos">1908</span></a>            <span class="k">return</span> <span class="n">children_iter</span><span class="p">,</span> <span class="n">treedef</span>
</span><span id="tree_flatten-1909"><a href="#tree_flatten-1909"><span class="linenos">1909</span></a>        <span class="k">else</span><span class="p">:</span>
</span><span id="tree_flatten-1910"><a href="#tree_flatten-1910"><span class="linenos">1910</span></a>            <span class="k">return</span> <span class="p">(</span><span class="n">x_</span><span class="p">,),</span> <span class="n">Leaf</span><span class="p">(</span><span class="n">x_</span><span class="p">)</span>
</span><span id="tree_flatten-1911"><a href="#tree_flatten-1911"><span class="linenos">1911</span></a>
</span><span id="tree_flatten-1912"><a href="#tree_flatten-1912"><span class="linenos">1912</span></a>    <span class="n">children_iter</span><span class="p">,</span> <span class="n">treedef</span> <span class="o">=</span> <span class="n">_tree_flatten</span><span class="p">(</span><span class="n">x</span><span class="p">)</span>
</span><span id="tree_flatten-1913"><a href="#tree_flatten-1913"><span class="linenos">1913</span></a>    <span class="k">return</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">children_iter</span><span class="p">),</span> <span class="n">treedef</span>
</span></pre></div>


    

                </section>
                <section id="tree_unflatten">
                            <input id="tree_unflatten-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">tree_unflatten</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">treedef</span><span class="p">:</span> <span class="n"><a href="#TreeDef">TreeDef</a></span>, </span><span class="param"><span class="n">xs</span><span class="p">:</span> <span class="n">Tuple</span><span class="p">[</span><span class="n">Any</span><span class="p">]</span></span><span class="return-annotation">) -> <span class="n">Any</span>:</span></span>

                <label class="view-source-button" for="tree_unflatten-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#tree_unflatten"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="tree_unflatten-1916"><a href="#tree_unflatten-1916"><span class="linenos">1916</span></a><span class="k">def</span> <span class="nf">tree_unflatten</span><span class="p">(</span><span class="n">treedef</span><span class="p">:</span> <span class="n">TreeDef</span><span class="p">,</span> <span class="n">xs</span><span class="p">:</span> <span class="n">Tuple</span><span class="p">[</span><span class="n">Any</span><span class="p">])</span> <span class="o">-&gt;</span> <span class="n">Any</span><span class="p">:</span>
</span><span id="tree_unflatten-1917"><a href="#tree_unflatten-1917"><span class="linenos">1917</span></a>    <span class="k">def</span> <span class="nf">_tree_unflatten</span><span class="p">(</span><span class="n">treedef_</span><span class="p">:</span> <span class="n">TreeDef</span><span class="p">,</span> <span class="n">xs_</span><span class="p">:</span> <span class="n">Iterator</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Any</span><span class="p">:</span>
</span><span id="tree_unflatten-1918"><a href="#tree_unflatten-1918"><span class="linenos">1918</span></a>        <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">treedef_</span><span class="p">,</span> <span class="n">Leaf</span><span class="p">):</span>
</span><span id="tree_unflatten-1919"><a href="#tree_unflatten-1919"><span class="linenos">1919</span></a>            <span class="n">dblog</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;    tree leaf found: </span><span class="si">{</span><span class="n">xs_</span><span class="si">}</span><span class="se">\n</span><span class="s2">&quot;</span><span class="p">,</span> <span class="n">enable</span><span class="o">=</span><span class="n">backend</span><span class="o">.</span><span class="n">LOG_TREE</span><span class="p">)</span>
</span><span id="tree_unflatten-1920"><a href="#tree_unflatten-1920"><span class="linenos">1920</span></a>            <span class="k">return</span> <span class="nb">next</span><span class="p">(</span><span class="n">xs_</span><span class="p">)</span>
</span><span id="tree_unflatten-1921"><a href="#tree_unflatten-1921"><span class="linenos">1921</span></a>        <span class="k">else</span><span class="p">:</span>
</span><span id="tree_unflatten-1922"><a href="#tree_unflatten-1922"><span class="linenos">1922</span></a>            <span class="n">dblog</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;    now</span><span class="se">\n</span><span class="s2">  </span><span class="si">{</span><span class="n">treedef_</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">,</span> <span class="n">enable</span><span class="o">=</span><span class="n">backend</span><span class="o">.</span><span class="n">LOG_TREE</span><span class="p">)</span>
</span><span id="tree_unflatten-1923"><a href="#tree_unflatten-1923"><span class="linenos">1923</span></a>            <span class="n">children</span> <span class="o">=</span> <span class="p">(</span><span class="n">_tree_unflatten</span><span class="p">(</span><span class="n">t</span><span class="p">,</span> <span class="n">xs_</span><span class="p">)</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">treedef_</span><span class="o">.</span><span class="n">child_treedefs</span><span class="p">)</span>
</span><span id="tree_unflatten-1924"><a href="#tree_unflatten-1924"><span class="linenos">1924</span></a>            <span class="n">dblog</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">children</span><span class="si">=}</span><span class="se">\n</span><span class="s2">&quot;</span><span class="p">,</span> <span class="n">enable</span><span class="o">=</span><span class="n">backend</span><span class="o">.</span><span class="n">LOG_TREE</span><span class="p">)</span>
</span><span id="tree_unflatten-1925"><a href="#tree_unflatten-1925"><span class="linenos">1925</span></a>            <span class="k">return</span> <span class="n">treedef_</span><span class="o">.</span><span class="n">node_type</span><span class="o">.</span><span class="n">unflatten</span><span class="p">(</span><span class="n">treedef_</span><span class="o">.</span><span class="n">node_metadata</span><span class="p">,</span> <span class="n">children</span><span class="p">)</span>
</span><span id="tree_unflatten-1926"><a href="#tree_unflatten-1926"><span class="linenos">1926</span></a>
</span><span id="tree_unflatten-1927"><a href="#tree_unflatten-1927"><span class="linenos">1927</span></a>    <span class="n">dblog</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;unflattening </span><span class="si">{</span><span class="n">treedef</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">,</span> <span class="n">enable</span><span class="o">=</span><span class="n">backend</span><span class="o">.</span><span class="n">LOG_TREE</span><span class="p">)</span>
</span><span id="tree_unflatten-1928"><a href="#tree_unflatten-1928"><span class="linenos">1928</span></a>    <span class="k">return</span> <span class="n">_tree_unflatten</span><span class="p">(</span><span class="n">treedef</span><span class="p">,</span> <span class="nb">iter</span><span class="p">(</span><span class="n">xs</span><span class="p">))</span>
</span><span id="tree_unflatten-1929"><a href="#tree_unflatten-1929"><span class="linenos">1929</span></a>    <span class="c1"># with Timing(f&quot;\nTREE:\n{treedef}&quot;):</span>
</span><span id="tree_unflatten-1930"><a href="#tree_unflatten-1930"><span class="linenos">1930</span></a>    <span class="c1">#     ret = _tree_unflatten(treedef, iter(xs))</span>
</span><span id="tree_unflatten-1931"><a href="#tree_unflatten-1931"><span class="linenos">1931</span></a>    <span class="c1"># return ret</span>
</span></pre></div>


    

                </section>
                <section id="tree_transpose">
                            <input id="tree_transpose-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">tree_transpose</span><span class="signature pdoc-code multiline">(<span class="param">	<span class="n">outer_treedef</span><span class="p">:</span> <span class="n"><a href="#TreeDef">TreeDef</a></span>,</span><span class="param">	<span class="n">inner_treedef</span><span class="p">:</span> <span class="n"><a href="#TreeDef">TreeDef</a></span>,</span><span class="param">	<span class="n">tree_to_transpose</span><span class="p">:</span> <span class="n">Any</span></span><span class="return-annotation">) -> <span class="n">Any</span>:</span></span>

                <label class="view-source-button" for="tree_transpose-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#tree_transpose"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="tree_transpose-1934"><a href="#tree_transpose-1934"><span class="linenos">1934</span></a><span class="k">def</span> <span class="nf">tree_transpose</span><span class="p">(</span>
</span><span id="tree_transpose-1935"><a href="#tree_transpose-1935"><span class="linenos">1935</span></a>    <span class="n">outer_treedef</span><span class="p">:</span> <span class="n">TreeDef</span><span class="p">,</span>
</span><span id="tree_transpose-1936"><a href="#tree_transpose-1936"><span class="linenos">1936</span></a>    <span class="n">inner_treedef</span><span class="p">:</span> <span class="n">TreeDef</span><span class="p">,</span>
</span><span id="tree_transpose-1937"><a href="#tree_transpose-1937"><span class="linenos">1937</span></a>    <span class="n">tree_to_transpose</span><span class="p">:</span> <span class="n">Any</span><span class="p">,</span>
</span><span id="tree_transpose-1938"><a href="#tree_transpose-1938"><span class="linenos">1938</span></a><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Any</span><span class="p">:</span>
</span><span id="tree_transpose-1939"><a href="#tree_transpose-1939"><span class="linenos">1939</span></a>    <span class="n">flat</span><span class="p">,</span> <span class="n">treedef</span> <span class="o">=</span> <span class="n">tree_flatten</span><span class="p">(</span><span class="n">tree_to_transpose</span><span class="p">)</span>
</span><span id="tree_transpose-1940"><a href="#tree_transpose-1940"><span class="linenos">1940</span></a>    <span class="n">inner_size</span> <span class="o">=</span> <span class="n">inner_treedef</span><span class="o">.</span><span class="n">num_leaves</span>
</span><span id="tree_transpose-1941"><a href="#tree_transpose-1941"><span class="linenos">1941</span></a>    <span class="n">outer_size</span> <span class="o">=</span> <span class="n">outer_treedef</span><span class="o">.</span><span class="n">num_leaves</span>
</span><span id="tree_transpose-1942"><a href="#tree_transpose-1942"><span class="linenos">1942</span></a>    <span class="k">if</span> <span class="n">treedef</span><span class="o">.</span><span class="n">num_leaves</span> <span class="o">!=</span> <span class="p">(</span><span class="n">inner_size</span> <span class="o">*</span> <span class="n">outer_size</span><span class="p">):</span>
</span><span id="tree_transpose-1943"><a href="#tree_transpose-1943"><span class="linenos">1943</span></a>        <span class="k">raise</span> <span class="ne">TypeError</span>
</span><span id="tree_transpose-1944"><a href="#tree_transpose-1944"><span class="linenos">1944</span></a>    <span class="n">iter_flat</span> <span class="o">=</span> <span class="nb">iter</span><span class="p">(</span><span class="n">flat</span><span class="p">)</span>
</span><span id="tree_transpose-1945"><a href="#tree_transpose-1945"><span class="linenos">1945</span></a>    <span class="n">lol</span> <span class="o">=</span> <span class="p">[[</span><span class="nb">next</span><span class="p">(</span><span class="n">iter_flat</span><span class="p">)</span> <span class="k">for</span> <span class="n">_</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">inner_size</span><span class="p">)]</span> <span class="k">for</span> <span class="n">__</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">outer_size</span><span class="p">)]</span>
</span><span id="tree_transpose-1946"><a href="#tree_transpose-1946"><span class="linenos">1946</span></a>    <span class="n">permuted_lol</span> <span class="o">=</span> <span class="nb">zip</span><span class="p">(</span><span class="o">*</span><span class="n">lol</span><span class="p">)</span>
</span><span id="tree_transpose-1947"><a href="#tree_transpose-1947"><span class="linenos">1947</span></a>    <span class="n">subtrees</span> <span class="o">=</span> <span class="nb">map</span><span class="p">(</span><span class="n">partial</span><span class="p">(</span><span class="n">tree_unflatten</span><span class="p">,</span> <span class="n">outer_treedef</span><span class="p">),</span> <span class="n">permuted_lol</span><span class="p">)</span>
</span><span id="tree_transpose-1948"><a href="#tree_transpose-1948"><span class="linenos">1948</span></a>    <span class="k">return</span> <span class="n">tree_unflatten</span><span class="p">(</span><span class="n">inner_treedef</span><span class="p">,</span> <span class="n">subtrees</span><span class="p">)</span>
</span></pre></div>


    

                </section>
                <section id="flatten_fn">
                            <input id="flatten_fn-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">flatten_fn</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">f</span>, </span><span class="param"><span class="n">in_tree</span>, </span><span class="param"><span class="o">*</span>, </span><span class="param"><span class="n">has_aux</span><span class="o">=</span><span class="kc">False</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="flatten_fn-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#flatten_fn"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="flatten_fn-1951"><a href="#flatten_fn-1951"><span class="linenos">1951</span></a><span class="k">def</span> <span class="nf">flatten_fn</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="n">in_tree</span><span class="p">,</span> <span class="o">*</span><span class="p">,</span> <span class="n">has_aux</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>
</span><span id="flatten_fn-1952"><a href="#flatten_fn-1952"><span class="linenos">1952</span></a>    <span class="n">store</span> <span class="o">=</span> <span class="n">Store</span><span class="p">()</span>
</span><span id="flatten_fn-1953"><a href="#flatten_fn-1953"><span class="linenos">1953</span></a>
</span><span id="flatten_fn-1954"><a href="#flatten_fn-1954"><span class="linenos">1954</span></a>    <span class="k">def</span> <span class="nf">flat_fn</span><span class="p">(</span><span class="o">*</span><span class="n">args_flat</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="flatten_fn-1955"><a href="#flatten_fn-1955"><span class="linenos">1955</span></a>        <span class="n">tree_args</span> <span class="o">=</span> <span class="n">tree_unflatten</span><span class="p">(</span><span class="n">in_tree</span><span class="p">,</span> <span class="n">args_flat</span><span class="p">)</span>
</span><span id="flatten_fn-1956"><a href="#flatten_fn-1956"><span class="linenos">1956</span></a>        <span class="n">out</span> <span class="o">=</span> <span class="n">f</span><span class="p">(</span><span class="o">*</span><span class="n">tree_args</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)</span>
</span><span id="flatten_fn-1957"><a href="#flatten_fn-1957"><span class="linenos">1957</span></a>        <span class="k">if</span> <span class="n">has_aux</span><span class="p">:</span>
</span><span id="flatten_fn-1958"><a href="#flatten_fn-1958"><span class="linenos">1958</span></a>            <span class="n">out</span><span class="p">,</span> <span class="n">aux</span> <span class="o">=</span> <span class="n">out</span>
</span><span id="flatten_fn-1959"><a href="#flatten_fn-1959"><span class="linenos">1959</span></a>        <span class="n">out_flat</span><span class="p">,</span> <span class="n">out_tree</span> <span class="o">=</span> <span class="n">tree_flatten</span><span class="p">(</span><span class="n">out</span><span class="p">)</span>
</span><span id="flatten_fn-1960"><a href="#flatten_fn-1960"><span class="linenos">1960</span></a>        <span class="n">store</span><span class="o">.</span><span class="n">set_value</span><span class="p">(</span><span class="n">out_tree</span><span class="p">)</span>
</span><span id="flatten_fn-1961"><a href="#flatten_fn-1961"><span class="linenos">1961</span></a>        <span class="k">return</span> <span class="p">(</span><span class="n">out_flat</span><span class="p">,</span> <span class="n">aux</span><span class="p">)</span> <span class="k">if</span> <span class="n">has_aux</span> <span class="k">else</span> <span class="n">out_flat</span>
</span><span id="flatten_fn-1962"><a href="#flatten_fn-1962"><span class="linenos">1962</span></a>
</span><span id="flatten_fn-1963"><a href="#flatten_fn-1963"><span class="linenos">1963</span></a>    <span class="k">return</span> <span class="n">flat_fn</span><span class="p">,</span> <span class="n">store</span>
</span></pre></div>


    

                </section>
                <section id="tree_map">
                            <input id="tree_map-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">tree_map</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">f</span><span class="p">:</span> <span class="n">Callable</span><span class="p">[</span><span class="o">...</span><span class="p">,</span> <span class="n">Any</span><span class="p">]</span>, </span><span class="param"><span class="n">tree</span>, </span><span class="param"><span class="o">*</span><span class="n">rest</span>, </span><span class="param"><span class="n">out_leaf</span><span class="o">=</span><span class="kc">False</span></span><span class="return-annotation">) -> <span class="n">Any</span>:</span></span>

                <label class="view-source-button" for="tree_map-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#tree_map"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="tree_map-1966"><a href="#tree_map-1966"><span class="linenos">1966</span></a><span class="k">def</span> <span class="nf">tree_map</span><span class="p">(</span><span class="n">f</span><span class="p">:</span> <span class="n">Callable</span><span class="p">[</span><span class="o">...</span><span class="p">,</span> <span class="n">Any</span><span class="p">],</span> <span class="n">tree</span><span class="p">,</span> <span class="o">*</span><span class="n">rest</span><span class="p">,</span> <span class="n">out_leaf</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Any</span><span class="p">:</span>
</span><span id="tree_map-1967"><a href="#tree_map-1967"><span class="linenos">1967</span></a>    <span class="n">leaves</span><span class="p">,</span> <span class="n">treedef</span> <span class="o">=</span> <span class="n">tree_flatten</span><span class="p">(</span><span class="n">tree</span><span class="p">)</span>
</span><span id="tree_map-1968"><a href="#tree_map-1968"><span class="linenos">1968</span></a>    <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">rest</span><span class="p">)</span> <span class="o">==</span> <span class="mi">0</span><span class="p">:</span>
</span><span id="tree_map-1969"><a href="#tree_map-1969"><span class="linenos">1969</span></a>        <span class="n">out_tree_flat</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">f</span><span class="p">(</span><span class="n">leaf</span><span class="p">)</span> <span class="k">for</span> <span class="n">leaf</span> <span class="ow">in</span> <span class="n">leaves</span><span class="p">)</span>
</span><span id="tree_map-1970"><a href="#tree_map-1970"><span class="linenos">1970</span></a>        <span class="n">out_tree</span> <span class="o">=</span> <span class="n">tree_unflatten</span><span class="p">(</span><span class="n">treedef</span><span class="p">,</span> <span class="n">out_tree_flat</span><span class="p">)</span>
</span><span id="tree_map-1971"><a href="#tree_map-1971"><span class="linenos">1971</span></a>    <span class="k">else</span><span class="p">:</span>
</span><span id="tree_map-1972"><a href="#tree_map-1972"><span class="linenos">1972</span></a>        <span class="n">all_leaves</span> <span class="o">=</span> <span class="p">[</span><span class="n">leaves</span><span class="p">]</span>
</span><span id="tree_map-1973"><a href="#tree_map-1973"><span class="linenos">1973</span></a>        <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">rest</span><span class="p">:</span>
</span><span id="tree_map-1974"><a href="#tree_map-1974"><span class="linenos">1974</span></a>            <span class="n">t_leaves</span><span class="p">,</span> <span class="n">t_treedef</span> <span class="o">=</span> <span class="n">tree_flatten</span><span class="p">(</span><span class="n">t</span><span class="p">)</span>
</span><span id="tree_map-1975"><a href="#tree_map-1975"><span class="linenos">1975</span></a>            <span class="k">assert</span> <span class="n">t_treedef</span> <span class="o">==</span> <span class="n">treedef</span>
</span><span id="tree_map-1976"><a href="#tree_map-1976"><span class="linenos">1976</span></a>            <span class="n">all_leaves</span> <span class="o">+=</span> <span class="p">[</span><span class="n">t_leaves</span><span class="p">]</span>
</span><span id="tree_map-1977"><a href="#tree_map-1977"><span class="linenos">1977</span></a>
</span><span id="tree_map-1978"><a href="#tree_map-1978"><span class="linenos">1978</span></a>        <span class="n">out_tree_flat</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">f</span><span class="p">(</span><span class="o">*</span><span class="n">xs</span><span class="p">)</span> <span class="k">for</span> <span class="n">xs</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="o">*</span><span class="n">all_leaves</span><span class="p">))</span>
</span><span id="tree_map-1979"><a href="#tree_map-1979"><span class="linenos">1979</span></a>        <span class="n">out_tree</span> <span class="o">=</span> <span class="n">tree_unflatten</span><span class="p">(</span><span class="n">treedef</span><span class="p">,</span> <span class="n">out_tree_flat</span><span class="p">)</span>
</span><span id="tree_map-1980"><a href="#tree_map-1980"><span class="linenos">1980</span></a>    <span class="n">ret</span> <span class="o">=</span> <span class="n">out_tree</span>
</span><span id="tree_map-1981"><a href="#tree_map-1981"><span class="linenos">1981</span></a>    <span class="k">if</span> <span class="n">out_leaf</span><span class="p">:</span>
</span><span id="tree_map-1982"><a href="#tree_map-1982"><span class="linenos">1982</span></a>        <span class="n">ret</span> <span class="o">=</span> <span class="p">(</span><span class="n">ret</span><span class="p">,</span> <span class="n">tree_flatten</span><span class="p">(</span><span class="n">out_tree_flat</span><span class="p">[</span><span class="mi">0</span><span class="p">]))</span>
</span><span id="tree_map-1983"><a href="#tree_map-1983"><span class="linenos">1983</span></a>    <span class="k">return</span> <span class="n">ret</span>
</span></pre></div>


    

                </section>
                <section id="new_main_trace">
                            <input id="new_main_trace-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
                    <div class="decorator">@contextmanager</div>

        <span class="def">def</span>
        <span class="name">new_main_trace</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">trace_type</span><span class="p">:</span> <span class="n">Type</span><span class="p">[</span><span class="n"><a href="#Trace">Trace</a></span><span class="p">]</span>, </span><span class="param"><span class="n">global_data</span><span class="o">=</span><span class="kc">None</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="new_main_trace-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#new_main_trace"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="new_main_trace-1986"><a href="#new_main_trace-1986"><span class="linenos">1986</span></a><span class="nd">@contextmanager</span>
</span><span id="new_main_trace-1987"><a href="#new_main_trace-1987"><span class="linenos">1987</span></a><span class="k">def</span> <span class="nf">new_main_trace</span><span class="p">(</span><span class="n">trace_type</span><span class="p">:</span> <span class="n">Type</span><span class="p">[</span><span class="s2">&quot;Trace&quot;</span><span class="p">],</span> <span class="n">global_data</span><span class="o">=</span><span class="kc">None</span><span class="p">):</span>
</span><span id="new_main_trace-1988"><a href="#new_main_trace-1988"><span class="linenos">1988</span></a>    <span class="k">global</span> <span class="n">trace_stack</span>
</span><span id="new_main_trace-1989"><a href="#new_main_trace-1989"><span class="linenos">1989</span></a>    <span class="n">level</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">trace_stack</span><span class="p">)</span>
</span><span id="new_main_trace-1990"><a href="#new_main_trace-1990"><span class="linenos">1990</span></a>    <span class="n">main</span> <span class="o">=</span> <span class="n">MainTrace</span><span class="p">(</span><span class="n">level</span><span class="p">,</span> <span class="n">trace_type</span><span class="p">,</span> <span class="n">global_data</span><span class="p">)</span>
</span><span id="new_main_trace-1991"><a href="#new_main_trace-1991"><span class="linenos">1991</span></a>    <span class="n">trace_stack</span> <span class="o">+=</span> <span class="p">[</span><span class="n">main</span><span class="p">]</span>
</span><span id="new_main_trace-1992"><a href="#new_main_trace-1992"><span class="linenos">1992</span></a>
</span><span id="new_main_trace-1993"><a href="#new_main_trace-1993"><span class="linenos">1993</span></a>    <span class="k">try</span><span class="p">:</span>
</span><span id="new_main_trace-1994"><a href="#new_main_trace-1994"><span class="linenos">1994</span></a>        <span class="k">yield</span> <span class="n">main</span>
</span><span id="new_main_trace-1995"><a href="#new_main_trace-1995"><span class="linenos">1995</span></a>    <span class="k">finally</span><span class="p">:</span>
</span><span id="new_main_trace-1996"><a href="#new_main_trace-1996"><span class="linenos">1996</span></a>        <span class="n">trace_stack</span><span class="o">.</span><span class="n">pop</span><span class="p">()</span>
</span></pre></div>


    

                </section>
                <section id="bind">
                            <input id="bind-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">bind</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">op</span>, </span><span class="param"><span class="o">*</span><span class="n">args</span>, </span><span class="param"><span class="o">**</span><span class="n">params</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="bind-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#bind"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="bind-1999"><a href="#bind-1999"><span class="linenos">1999</span></a><span class="k">def</span> <span class="nf">bind</span><span class="p">(</span><span class="n">op</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">):</span>
</span><span id="bind-2000"><a href="#bind-2000"><span class="linenos">2000</span></a>    <span class="n">top_trace</span> <span class="o">=</span> <span class="n">find_top_trace</span><span class="p">(</span><span class="n">args</span><span class="p">)</span>
</span><span id="bind-2001"><a href="#bind-2001"><span class="linenos">2001</span></a>    <span class="n">tracers</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">([</span><span class="n">full_raise</span><span class="p">(</span><span class="n">top_trace</span><span class="p">,</span> <span class="n">arg</span><span class="p">)</span> <span class="k">for</span> <span class="n">arg</span> <span class="ow">in</span> <span class="n">args</span><span class="p">])</span>
</span><span id="bind-2002"><a href="#bind-2002"><span class="linenos">2002</span></a>    <span class="n">outs</span> <span class="o">=</span> <span class="n">top_trace</span><span class="o">.</span><span class="n">run_op</span><span class="p">(</span><span class="n">op</span><span class="p">,</span> <span class="n">tracers</span><span class="p">,</span> <span class="n">params</span><span class="p">)</span>
</span><span id="bind-2003"><a href="#bind-2003"><span class="linenos">2003</span></a>    <span class="n">lowered</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">([</span><span class="n">full_lower</span><span class="p">(</span><span class="n">out</span><span class="p">)</span> <span class="k">for</span> <span class="n">out</span> <span class="ow">in</span> <span class="n">outs</span><span class="p">])</span>
</span><span id="bind-2004"><a href="#bind-2004"><span class="linenos">2004</span></a>    <span class="k">return</span> <span class="n">lowered</span>
</span></pre></div>


    

                </section>
                <section id="find_top_trace">
                            <input id="find_top_trace-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">find_top_trace</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">xs</span></span><span class="return-annotation">) -> <span class="n"><a href="#Trace">Trace</a></span>:</span></span>

                <label class="view-source-button" for="find_top_trace-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#find_top_trace"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="find_top_trace-2007"><a href="#find_top_trace-2007"><span class="linenos">2007</span></a><span class="k">def</span> <span class="nf">find_top_trace</span><span class="p">(</span><span class="n">xs</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Trace</span><span class="p">:</span>
</span><span id="find_top_trace-2008"><a href="#find_top_trace-2008"><span class="linenos">2008</span></a>    <span class="n">arrs</span> <span class="o">=</span> <span class="p">[]</span>
</span><span id="find_top_trace-2009"><a href="#find_top_trace-2009"><span class="linenos">2009</span></a>
</span><span id="find_top_trace-2010"><a href="#find_top_trace-2010"><span class="linenos">2010</span></a>    <span class="k">def</span> <span class="nf">get_arr_from_seq</span><span class="p">(</span><span class="n">seq</span><span class="p">):</span>
</span><span id="find_top_trace-2011"><a href="#find_top_trace-2011"><span class="linenos">2011</span></a>        <span class="k">nonlocal</span> <span class="n">arrs</span>
</span><span id="find_top_trace-2012"><a href="#find_top_trace-2012"><span class="linenos">2012</span></a>        <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">seq</span><span class="p">:</span>
</span><span id="find_top_trace-2013"><a href="#find_top_trace-2013"><span class="linenos">2013</span></a>            <span class="k">if</span> <span class="nb">type</span><span class="p">(</span><span class="n">x</span><span class="p">)</span> <span class="ow">in</span> <span class="p">(</span><span class="nb">tuple</span><span class="p">,</span> <span class="nb">list</span><span class="p">):</span>
</span><span id="find_top_trace-2014"><a href="#find_top_trace-2014"><span class="linenos">2014</span></a>                <span class="n">get_arr_from_seq</span><span class="p">(</span><span class="n">x</span><span class="p">)</span>
</span><span id="find_top_trace-2015"><a href="#find_top_trace-2015"><span class="linenos">2015</span></a>            <span class="k">elif</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">TraceTensor</span><span class="p">):</span>
</span><span id="find_top_trace-2016"><a href="#find_top_trace-2016"><span class="linenos">2016</span></a>                <span class="n">arrs</span> <span class="o">+=</span> <span class="p">[</span><span class="n">x</span><span class="p">]</span>
</span><span id="find_top_trace-2017"><a href="#find_top_trace-2017"><span class="linenos">2017</span></a>
</span><span id="find_top_trace-2018"><a href="#find_top_trace-2018"><span class="linenos">2018</span></a>    <span class="n">get_arr_from_seq</span><span class="p">(</span><span class="n">xs</span><span class="p">)</span>
</span><span id="find_top_trace-2019"><a href="#find_top_trace-2019"><span class="linenos">2019</span></a>    <span class="n">arrs</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">arrs</span><span class="p">)</span>
</span><span id="find_top_trace-2020"><a href="#find_top_trace-2020"><span class="linenos">2020</span></a>    <span class="n">top_main</span> <span class="o">=</span> <span class="nb">max</span><span class="p">(</span>
</span><span id="find_top_trace-2021"><a href="#find_top_trace-2021"><span class="linenos">2021</span></a>        <span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">_trace</span><span class="o">.</span><span class="n">main</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">arrs</span><span class="p">),</span>
</span><span id="find_top_trace-2022"><a href="#find_top_trace-2022"><span class="linenos">2022</span></a>        <span class="n">default</span><span class="o">=</span><span class="n">trace_stack</span><span class="p">[</span><span class="mi">0</span><span class="p">],</span>
</span><span id="find_top_trace-2023"><a href="#find_top_trace-2023"><span class="linenos">2023</span></a>        <span class="n">key</span><span class="o">=</span><span class="n">operator_py</span><span class="o">.</span><span class="n">attrgetter</span><span class="p">(</span><span class="s2">&quot;level&quot;</span><span class="p">),</span>
</span><span id="find_top_trace-2024"><a href="#find_top_trace-2024"><span class="linenos">2024</span></a>    <span class="p">)</span>
</span><span id="find_top_trace-2025"><a href="#find_top_trace-2025"><span class="linenos">2025</span></a>    <span class="k">if</span> <span class="n">stashed_trace</span> <span class="ow">and</span> <span class="n">stashed_trace</span><span class="o">.</span><span class="n">level</span> <span class="o">&gt;</span> <span class="n">top_main</span><span class="o">.</span><span class="n">level</span><span class="p">:</span>
</span><span id="find_top_trace-2026"><a href="#find_top_trace-2026"><span class="linenos">2026</span></a>        <span class="n">top_main</span> <span class="o">=</span> <span class="n">stashed_trace</span>
</span><span id="find_top_trace-2027"><a href="#find_top_trace-2027"><span class="linenos">2027</span></a>    <span class="k">return</span> <span class="n">top_main</span><span class="o">.</span><span class="n">trace_type</span><span class="p">(</span><span class="n">top_main</span><span class="p">)</span>
</span></pre></div>


    

                </section>
                <section id="full_raise">
                            <input id="full_raise-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">full_raise</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">trace</span><span class="p">:</span> <span class="n"><a href="#Trace">Trace</a></span>, </span><span class="param"><span class="n">val</span><span class="p">:</span> <span class="n">Any</span></span><span class="return-annotation">) -> <span class="n"><a href="#TraceTensor">TraceTensor</a></span>:</span></span>

                <label class="view-source-button" for="full_raise-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#full_raise"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="full_raise-2030"><a href="#full_raise-2030"><span class="linenos">2030</span></a><span class="k">def</span> <span class="nf">full_raise</span><span class="p">(</span><span class="n">trace</span><span class="p">:</span> <span class="n">Trace</span><span class="p">,</span> <span class="n">val</span><span class="p">:</span> <span class="n">Any</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">TraceTensor</span><span class="p">:</span>
</span><span id="full_raise-2031"><a href="#full_raise-2031"><span class="linenos">2031</span></a>    <span class="k">if</span> <span class="ow">not</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">val</span><span class="p">,</span> <span class="n">TraceTensor</span><span class="p">):</span>
</span><span id="full_raise-2032"><a href="#full_raise-2032"><span class="linenos">2032</span></a>        <span class="k">return</span> <span class="n">trace</span><span class="o">.</span><span class="n">pure</span><span class="p">(</span><span class="n">val</span><span class="p">)</span>
</span><span id="full_raise-2033"><a href="#full_raise-2033"><span class="linenos">2033</span></a>    <span class="n">level</span> <span class="o">=</span> <span class="n">trace</span><span class="o">.</span><span class="n">main</span><span class="o">.</span><span class="n">level</span>
</span><span id="full_raise-2034"><a href="#full_raise-2034"><span class="linenos">2034</span></a>    <span class="k">if</span> <span class="n">val</span><span class="o">.</span><span class="n">_trace</span><span class="o">.</span><span class="n">main</span> <span class="ow">is</span> <span class="n">trace</span><span class="o">.</span><span class="n">main</span><span class="p">:</span>
</span><span id="full_raise-2035"><a href="#full_raise-2035"><span class="linenos">2035</span></a>        <span class="k">return</span> <span class="n">val</span>
</span><span id="full_raise-2036"><a href="#full_raise-2036"><span class="linenos">2036</span></a>    <span class="k">elif</span> <span class="n">val</span><span class="o">.</span><span class="n">_trace</span><span class="o">.</span><span class="n">main</span><span class="o">.</span><span class="n">level</span> <span class="o">&lt;</span> <span class="n">level</span><span class="p">:</span>
</span><span id="full_raise-2037"><a href="#full_raise-2037"><span class="linenos">2037</span></a>        <span class="k">return</span> <span class="n">trace</span><span class="o">.</span><span class="n">pure</span><span class="p">(</span><span class="n">val</span><span class="p">)</span>
</span><span id="full_raise-2038"><a href="#full_raise-2038"><span class="linenos">2038</span></a>    <span class="k">elif</span> <span class="n">val</span><span class="o">.</span><span class="n">_trace</span><span class="o">.</span><span class="n">main</span><span class="o">.</span><span class="n">level</span> <span class="o">&gt;</span> <span class="n">level</span><span class="p">:</span>
</span><span id="full_raise-2039"><a href="#full_raise-2039"><span class="linenos">2039</span></a>        <span class="k">raise</span> <span class="ne">Exception</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;Can&#39;t lift level </span><span class="si">{</span><span class="n">val</span><span class="o">.</span><span class="n">_trace</span><span class="o">.</span><span class="n">main</span><span class="o">.</span><span class="n">level</span><span class="si">}</span><span class="s2"> to </span><span class="si">{</span><span class="n">level</span><span class="si">}</span><span class="s2">.&quot;</span><span class="p">)</span>
</span><span id="full_raise-2040"><a href="#full_raise-2040"><span class="linenos">2040</span></a>    <span class="k">else</span><span class="p">:</span>
</span><span id="full_raise-2041"><a href="#full_raise-2041"><span class="linenos">2041</span></a>        <span class="k">raise</span> <span class="ne">Exception</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;Different traces at same level: </span><span class="si">{</span><span class="n">val</span><span class="o">.</span><span class="n">_trace</span><span class="si">}</span><span class="s2">, </span><span class="si">{</span><span class="n">trace</span><span class="si">}</span><span class="s2">.&quot;</span><span class="p">)</span>
</span></pre></div>


    

                </section>
                <section id="full_lower">
                            <input id="full_lower-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">full_lower</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">val</span><span class="p">:</span> <span class="n">Any</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="full_lower-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#full_lower"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="full_lower-2044"><a href="#full_lower-2044"><span class="linenos">2044</span></a><span class="k">def</span> <span class="nf">full_lower</span><span class="p">(</span><span class="n">val</span><span class="p">:</span> <span class="n">Any</span><span class="p">):</span>
</span><span id="full_lower-2045"><a href="#full_lower-2045"><span class="linenos">2045</span></a>    <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">val</span><span class="p">,</span> <span class="n">TraceTensor</span><span class="p">):</span>
</span><span id="full_lower-2046"><a href="#full_lower-2046"><span class="linenos">2046</span></a>        <span class="k">return</span> <span class="n">val</span><span class="o">.</span><span class="n">full_lower</span><span class="p">()</span>
</span><span id="full_lower-2047"><a href="#full_lower-2047"><span class="linenos">2047</span></a>    <span class="k">elif</span> <span class="nb">type</span><span class="p">(</span><span class="n">val</span><span class="p">)</span> <span class="ow">in</span> <span class="p">(</span><span class="nb">list</span><span class="p">,</span> <span class="nb">tuple</span><span class="p">):</span>
</span><span id="full_lower-2048"><a href="#full_lower-2048"><span class="linenos">2048</span></a>        <span class="k">return</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">full_lower</span><span class="p">(</span><span class="n">v</span><span class="p">)</span> <span class="k">for</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">val</span><span class="p">)</span>
</span><span id="full_lower-2049"><a href="#full_lower-2049"><span class="linenos">2049</span></a>    <span class="k">else</span><span class="p">:</span>
</span><span id="full_lower-2050"><a href="#full_lower-2050"><span class="linenos">2050</span></a>        <span class="k">return</span> <span class="n">val</span>
</span></pre></div>


    

                </section>
                <section id="typecheck_program">
                            <input id="typecheck_program-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">typecheck_program</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">program</span><span class="p">:</span> <span class="n"><a href="#Program">Program</a></span></span><span class="return-annotation">) -> <span class="n"><a href="#ProgramType">ProgramType</a></span>:</span></span>

                <label class="view-source-button" for="typecheck_program-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#typecheck_program"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="typecheck_program-2053"><a href="#typecheck_program-2053"><span class="linenos">2053</span></a><span class="k">def</span> <span class="nf">typecheck_program</span><span class="p">(</span><span class="n">program</span><span class="p">:</span> <span class="n">Program</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">ProgramType</span><span class="p">:</span>
</span><span id="typecheck_program-2054"><a href="#typecheck_program-2054"><span class="linenos">2054</span></a>    <span class="n">env</span><span class="p">:</span> <span class="n">Set</span><span class="p">[</span><span class="n">Var</span><span class="p">]</span> <span class="o">=</span> <span class="nb">set</span><span class="p">()</span>
</span><span id="typecheck_program-2055"><a href="#typecheck_program-2055"><span class="linenos">2055</span></a>
</span><span id="typecheck_program-2056"><a href="#typecheck_program-2056"><span class="linenos">2056</span></a>    <span class="k">for</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">program</span><span class="o">.</span><span class="n">in_binders</span><span class="p">:</span>
</span><span id="typecheck_program-2057"><a href="#typecheck_program-2057"><span class="linenos">2057</span></a>        <span class="k">if</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">env</span><span class="p">:</span>
</span><span id="typecheck_program-2058"><a href="#typecheck_program-2058"><span class="linenos">2058</span></a>            <span class="k">raise</span> <span class="ne">TypeError</span>
</span><span id="typecheck_program-2059"><a href="#typecheck_program-2059"><span class="linenos">2059</span></a>        <span class="n">env</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">v</span><span class="p">)</span>
</span><span id="typecheck_program-2060"><a href="#typecheck_program-2060"><span class="linenos">2060</span></a>
</span><span id="typecheck_program-2061"><a href="#typecheck_program-2061"><span class="linenos">2061</span></a>    <span class="k">for</span> <span class="n">instruction</span> <span class="ow">in</span> <span class="n">program</span><span class="o">.</span><span class="n">instructions</span><span class="p">:</span>
</span><span id="typecheck_program-2062"><a href="#typecheck_program-2062"><span class="linenos">2062</span></a>        <span class="n">in_types</span> <span class="o">=</span> <span class="p">[</span><span class="n">typecheck_atom</span><span class="p">(</span><span class="n">env</span><span class="p">,</span> <span class="n">x</span><span class="p">)</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">instruction</span><span class="o">.</span><span class="n">inputs</span><span class="p">]</span>
</span><span id="typecheck_program-2063"><a href="#typecheck_program-2063"><span class="linenos">2063</span></a>        <span class="n">out_types</span> <span class="o">=</span> <span class="n">instruction</span><span class="o">.</span><span class="n">op</span><span class="o">.</span><span class="n">typecheck</span><span class="p">(</span><span class="o">*</span><span class="n">in_types</span><span class="p">,</span> <span class="o">**</span><span class="n">instruction</span><span class="o">.</span><span class="n">params</span><span class="p">)</span>
</span><span id="typecheck_program-2064"><a href="#typecheck_program-2064"><span class="linenos">2064</span></a>        <span class="k">for</span> <span class="n">out_binder</span><span class="p">,</span> <span class="n">out_type</span> <span class="ow">in</span> <span class="n">list_zip</span><span class="p">(</span><span class="n">instruction</span><span class="o">.</span><span class="n">out_binders</span><span class="p">,</span> <span class="n">out_types</span><span class="p">):</span>
</span><span id="typecheck_program-2065"><a href="#typecheck_program-2065"><span class="linenos">2065</span></a>            <span class="k">if</span> <span class="ow">not</span> <span class="n">out_type</span> <span class="o">==</span> <span class="n">out_binder</span><span class="o">.</span><span class="n">symval</span><span class="p">:</span>
</span><span id="typecheck_program-2066"><a href="#typecheck_program-2066"><span class="linenos">2066</span></a>                <span class="k">raise</span> <span class="ne">TypeError</span>
</span><span id="typecheck_program-2067"><a href="#typecheck_program-2067"><span class="linenos">2067</span></a>        <span class="k">for</span> <span class="n">out_binder</span> <span class="ow">in</span> <span class="n">instruction</span><span class="o">.</span><span class="n">out_binders</span><span class="p">:</span>
</span><span id="typecheck_program-2068"><a href="#typecheck_program-2068"><span class="linenos">2068</span></a>            <span class="k">if</span> <span class="n">out_binder</span> <span class="ow">in</span> <span class="n">env</span><span class="p">:</span>
</span><span id="typecheck_program-2069"><a href="#typecheck_program-2069"><span class="linenos">2069</span></a>                <span class="k">raise</span> <span class="ne">TypeError</span>
</span><span id="typecheck_program-2070"><a href="#typecheck_program-2070"><span class="linenos">2070</span></a>            <span class="n">env</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">out_binder</span><span class="p">)</span>
</span><span id="typecheck_program-2071"><a href="#typecheck_program-2071"><span class="linenos">2071</span></a>
</span><span id="typecheck_program-2072"><a href="#typecheck_program-2072"><span class="linenos">2072</span></a>    <span class="n">in_types</span> <span class="o">=</span> <span class="p">[</span><span class="n">v</span><span class="o">.</span><span class="n">symval</span> <span class="k">for</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">program</span><span class="o">.</span><span class="n">in_binders</span><span class="p">]</span>
</span><span id="typecheck_program-2073"><a href="#typecheck_program-2073"><span class="linenos">2073</span></a>    <span class="n">out_types</span> <span class="o">=</span> <span class="p">[</span><span class="n">typecheck_atom</span><span class="p">(</span><span class="n">env</span><span class="p">,</span> <span class="n">x</span><span class="p">)</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">program</span><span class="o">.</span><span class="n">outs</span><span class="p">]</span>
</span><span id="typecheck_program-2074"><a href="#typecheck_program-2074"><span class="linenos">2074</span></a>    <span class="k">return</span> <span class="n">ProgramType</span><span class="p">(</span><span class="nb">tuple</span><span class="p">(</span><span class="n">in_types</span><span class="p">),</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">out_types</span><span class="p">))</span>
</span></pre></div>


    

                </section>
                <section id="typecheck_atom">
                            <input id="typecheck_atom-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">typecheck_atom</span><span class="signature pdoc-code multiline">(<span class="param">	<span class="n">env</span><span class="p">:</span> <span class="n">Set</span><span class="p">[</span><span class="n"><a href="#Var">Var</a></span><span class="p">]</span>,</span><span class="param">	<span class="n">x</span><span class="p">:</span> <span class="n">Union</span><span class="p">[</span><span class="n"><a href="#Var">Var</a></span><span class="p">,</span> <span class="n"><a href="#Lit">Lit</a></span><span class="p">]</span></span><span class="return-annotation">) -> <span class="n"><a href="#SymbolicTensor">SymbolicTensor</a></span>:</span></span>

                <label class="view-source-button" for="typecheck_atom-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#typecheck_atom"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="typecheck_atom-2077"><a href="#typecheck_atom-2077"><span class="linenos">2077</span></a><span class="k">def</span> <span class="nf">typecheck_atom</span><span class="p">(</span><span class="n">env</span><span class="p">:</span> <span class="n">Set</span><span class="p">[</span><span class="n">Var</span><span class="p">],</span> <span class="n">x</span><span class="p">:</span> <span class="n">Atom</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">SymbolicTensor</span><span class="p">:</span>
</span><span id="typecheck_atom-2078"><a href="#typecheck_atom-2078"><span class="linenos">2078</span></a>    <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">Var</span><span class="p">):</span>
</span><span id="typecheck_atom-2079"><a href="#typecheck_atom-2079"><span class="linenos">2079</span></a>        <span class="k">if</span> <span class="n">x</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">env</span><span class="p">:</span>
</span><span id="typecheck_atom-2080"><a href="#typecheck_atom-2080"><span class="linenos">2080</span></a>            <span class="k">raise</span> <span class="ne">TypeError</span><span class="p">(</span><span class="s2">&quot;unbound variable&quot;</span><span class="p">)</span>
</span><span id="typecheck_atom-2081"><a href="#typecheck_atom-2081"><span class="linenos">2081</span></a>        <span class="k">return</span> <span class="n">x</span><span class="o">.</span><span class="n">symval</span>
</span><span id="typecheck_atom-2082"><a href="#typecheck_atom-2082"><span class="linenos">2082</span></a>    <span class="k">elif</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">Lit</span><span class="p">):</span>
</span><span id="typecheck_atom-2083"><a href="#typecheck_atom-2083"><span class="linenos">2083</span></a>        <span class="k">return</span> <span class="n">get_symval</span><span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">val</span><span class="p">)</span>
</span><span id="typecheck_atom-2084"><a href="#typecheck_atom-2084"><span class="linenos">2084</span></a>    <span class="k">else</span><span class="p">:</span>
</span><span id="typecheck_atom-2085"><a href="#typecheck_atom-2085"><span class="linenos">2085</span></a>        <span class="k">assert</span> <span class="kc">False</span>
</span></pre></div>


    

                </section>
                <section id="run_program">
                            <input id="run_program-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">run_program</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">program</span><span class="p">:</span> <span class="n"><a href="#Program">Program</a></span>, </span><span class="param"><span class="n">args</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">]</span></span><span class="return-annotation">) -> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">]</span>:</span></span>

                <label class="view-source-button" for="run_program-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#run_program"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="run_program-2088"><a href="#run_program-2088"><span class="linenos">2088</span></a><span class="k">def</span> <span class="nf">run_program</span><span class="p">(</span><span class="n">program</span><span class="p">:</span> <span class="n">Program</span><span class="p">,</span> <span class="n">args</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">])</span> <span class="o">-&gt;</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">]:</span>
</span><span id="run_program-2089"><a href="#run_program-2089"><span class="linenos">2089</span></a>    <span class="n">env</span><span class="p">:</span> <span class="n">Dict</span><span class="p">[</span><span class="n">Var</span><span class="p">,</span> <span class="n">Any</span><span class="p">]</span> <span class="o">=</span> <span class="p">{}</span>
</span><span id="run_program-2090"><a href="#run_program-2090"><span class="linenos">2090</span></a>
</span><span id="run_program-2091"><a href="#run_program-2091"><span class="linenos">2091</span></a>    <span class="k">def</span> <span class="nf">read</span><span class="p">(</span><span class="n">x</span><span class="p">:</span> <span class="n">Atom</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Any</span><span class="p">:</span>
</span><span id="run_program-2092"><a href="#run_program-2092"><span class="linenos">2092</span></a>        <span class="k">return</span> <span class="n">env</span><span class="p">[</span><span class="n">x</span><span class="p">]</span> <span class="k">if</span> <span class="nb">type</span><span class="p">(</span><span class="n">x</span><span class="p">)</span> <span class="ow">is</span> <span class="n">Var</span> <span class="k">else</span> <span class="n">x</span><span class="o">.</span><span class="n">val</span>
</span><span id="run_program-2093"><a href="#run_program-2093"><span class="linenos">2093</span></a>
</span><span id="run_program-2094"><a href="#run_program-2094"><span class="linenos">2094</span></a>    <span class="k">def</span> <span class="nf">write</span><span class="p">(</span><span class="n">v</span><span class="p">:</span> <span class="n">Var</span><span class="p">,</span> <span class="n">val</span><span class="p">:</span> <span class="n">Any</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="kc">None</span><span class="p">:</span>
</span><span id="run_program-2095"><a href="#run_program-2095"><span class="linenos">2095</span></a>        <span class="k">assert</span> <span class="n">v</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">env</span>  <span class="c1"># single-assignment</span>
</span><span id="run_program-2096"><a href="#run_program-2096"><span class="linenos">2096</span></a>        <span class="n">env</span><span class="p">[</span><span class="n">v</span><span class="p">]</span> <span class="o">=</span> <span class="n">val</span>
</span><span id="run_program-2097"><a href="#run_program-2097"><span class="linenos">2097</span></a>
</span><span id="run_program-2098"><a href="#run_program-2098"><span class="linenos">2098</span></a>    <span class="n">list_map</span><span class="p">(</span><span class="n">write</span><span class="p">,</span> <span class="n">program</span><span class="o">.</span><span class="n">in_binders</span><span class="p">,</span> <span class="n">args</span><span class="p">)</span>
</span><span id="run_program-2099"><a href="#run_program-2099"><span class="linenos">2099</span></a>    <span class="k">for</span> <span class="n">instruction</span> <span class="ow">in</span> <span class="n">program</span><span class="o">.</span><span class="n">instructions</span><span class="p">:</span>
</span><span id="run_program-2100"><a href="#run_program-2100"><span class="linenos">2100</span></a>        <span class="n">in_vals</span> <span class="o">=</span> <span class="n">list_map</span><span class="p">(</span><span class="n">read</span><span class="p">,</span> <span class="n">instruction</span><span class="o">.</span><span class="n">inputs</span><span class="p">)</span>
</span><span id="run_program-2101"><a href="#run_program-2101"><span class="linenos">2101</span></a>        <span class="n">outs</span> <span class="o">=</span> <span class="n">bind</span><span class="p">(</span><span class="n">instruction</span><span class="o">.</span><span class="n">op</span><span class="p">,</span> <span class="o">*</span><span class="n">in_vals</span><span class="p">,</span> <span class="o">**</span><span class="n">instruction</span><span class="o">.</span><span class="n">params</span><span class="p">)</span>
</span><span id="run_program-2102"><a href="#run_program-2102"><span class="linenos">2102</span></a>        <span class="n">list_map</span><span class="p">(</span><span class="n">write</span><span class="p">,</span> <span class="n">instruction</span><span class="o">.</span><span class="n">out_binders</span><span class="p">,</span> <span class="n">outs</span><span class="p">)</span>
</span><span id="run_program-2103"><a href="#run_program-2103"><span class="linenos">2103</span></a>    <span class="k">return</span> <span class="n">list_map</span><span class="p">(</span><span class="n">read</span><span class="p">,</span> <span class="n">program</span><span class="o">.</span><span class="n">outs</span><span class="p">)</span>
</span></pre></div>


    

                </section>
                <section id="program_as_fun">
                            <input id="program_as_fun-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">program_as_fun</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">program</span><span class="p">:</span> <span class="n"><a href="#Program">Program</a></span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="program_as_fun-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#program_as_fun"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="program_as_fun-2106"><a href="#program_as_fun-2106"><span class="linenos">2106</span></a><span class="k">def</span> <span class="nf">program_as_fun</span><span class="p">(</span><span class="n">program</span><span class="p">:</span> <span class="n">Program</span><span class="p">):</span>
</span><span id="program_as_fun-2107"><a href="#program_as_fun-2107"><span class="linenos">2107</span></a>    <span class="k">return</span> <span class="k">lambda</span> <span class="o">*</span><span class="n">args</span><span class="p">:</span> <span class="n">run_program</span><span class="p">(</span><span class="n">program</span><span class="p">,</span> <span class="n">args</span><span class="p">)</span>
</span></pre></div>


    

                </section>
                <section id="vmap_flat">
                            <input id="vmap_flat-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">vmap_flat</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">f</span>, </span><span class="param"><span class="n">in_dim</span>, </span><span class="param"><span class="n">out_dim</span>, </span><span class="param"><span class="n">dim_size</span>, </span><span class="param"><span class="o">*</span><span class="n">args</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="vmap_flat-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#vmap_flat"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="vmap_flat-2110"><a href="#vmap_flat-2110"><span class="linenos">2110</span></a><span class="k">def</span> <span class="nf">vmap_flat</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="n">in_dim</span><span class="p">,</span> <span class="n">out_dim</span><span class="p">,</span> <span class="n">dim_size</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">):</span>
</span><span id="vmap_flat-2111"><a href="#vmap_flat-2111"><span class="linenos">2111</span></a>    <span class="k">if</span> <span class="n">dim_size</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
</span><span id="vmap_flat-2112"><a href="#vmap_flat-2112"><span class="linenos">2112</span></a>        <span class="n">dims</span> <span class="o">=</span> <span class="nb">set</span><span class="p">([</span><span class="n">x</span><span class="o">.</span><span class="n">shape</span><span class="p">[</span><span class="n">d</span><span class="p">]</span> <span class="k">for</span> <span class="n">x</span><span class="p">,</span> <span class="n">d</span> <span class="ow">in</span> <span class="n">list_zip</span><span class="p">(</span><span class="n">args</span><span class="p">,</span> <span class="n">in_dim</span><span class="p">)</span> <span class="k">if</span> <span class="n">d</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">])</span>
</span><span id="vmap_flat-2113"><a href="#vmap_flat-2113"><span class="linenos">2113</span></a>        <span class="k">assert</span> <span class="nb">len</span><span class="p">(</span><span class="n">dims</span><span class="p">)</span> <span class="o">==</span> <span class="mi">1</span>
</span><span id="vmap_flat-2114"><a href="#vmap_flat-2114"><span class="linenos">2114</span></a>        <span class="p">(</span><span class="n">dim_size</span><span class="p">,)</span> <span class="o">=</span> <span class="n">dims</span>
</span><span id="vmap_flat-2115"><a href="#vmap_flat-2115"><span class="linenos">2115</span></a>    <span class="k">with</span> <span class="n">new_main_trace</span><span class="p">(</span><span class="n">VMapTrace</span><span class="p">,</span> <span class="n">dim_size</span><span class="p">)</span> <span class="k">as</span> <span class="n">main</span><span class="p">:</span>
</span><span id="vmap_flat-2116"><a href="#vmap_flat-2116"><span class="linenos">2116</span></a>        <span class="n">trace</span> <span class="o">=</span> <span class="n">VMapTrace</span><span class="p">(</span><span class="n">main</span><span class="p">)</span>
</span><span id="vmap_flat-2117"><a href="#vmap_flat-2117"><span class="linenos">2117</span></a>        <span class="n">tracers_in</span> <span class="o">=</span> <span class="p">[</span><span class="n">VMapTraceTensor</span><span class="p">(</span><span class="n">trace</span><span class="p">,</span> <span class="n">x</span><span class="p">,</span> <span class="n">dim</span><span class="p">)</span> <span class="k">if</span> <span class="n">dim</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span> <span class="k">else</span> <span class="n">x</span> <span class="k">for</span> <span class="n">x</span><span class="p">,</span> <span class="n">dim</span> <span class="ow">in</span> <span class="n">list_zip</span><span class="p">(</span><span class="n">args</span><span class="p">,</span> <span class="n">in_dim</span><span class="p">)]</span>
</span><span id="vmap_flat-2118"><a href="#vmap_flat-2118"><span class="linenos">2118</span></a>        <span class="n">outs</span> <span class="o">=</span> <span class="n">f</span><span class="p">(</span><span class="o">*</span><span class="n">tracers_in</span><span class="p">)</span>
</span><span id="vmap_flat-2119"><a href="#vmap_flat-2119"><span class="linenos">2119</span></a>        <span class="n">tracers_out</span> <span class="o">=</span> <span class="p">[</span><span class="n">full_raise</span><span class="p">(</span><span class="n">trace</span><span class="p">,</span> <span class="n">out</span><span class="p">)</span> <span class="k">for</span> <span class="n">out</span> <span class="ow">in</span> <span class="n">outs</span><span class="p">]</span>
</span><span id="vmap_flat-2120"><a href="#vmap_flat-2120"><span class="linenos">2120</span></a>        <span class="n">vals_out</span><span class="p">,</span> <span class="n">y_vmap_dims</span> <span class="o">=</span> <span class="n">unzip2</span><span class="p">((</span><span class="n">t</span><span class="o">.</span><span class="n">val</span><span class="p">,</span> <span class="n">t</span><span class="o">.</span><span class="n">vmap_dim</span><span class="p">)</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">tracers_out</span><span class="p">)</span>
</span><span id="vmap_flat-2121"><a href="#vmap_flat-2121"><span class="linenos">2121</span></a>    <span class="n">ret</span> <span class="o">=</span> <span class="p">[</span><span class="n">VMapTrace</span><span class="o">.</span><span class="n">move_vmap_dim</span><span class="p">(</span><span class="n">val_out</span><span class="p">,</span> <span class="n">dim_size</span><span class="p">,</span> <span class="n">bdim</span><span class="p">,</span> <span class="n">out_dim</span><span class="p">)</span> <span class="k">for</span> <span class="n">val_out</span><span class="p">,</span> <span class="n">bdim</span><span class="p">,</span> <span class="n">out_dim</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">vals_out</span><span class="p">,</span> <span class="n">y_vmap_dims</span><span class="p">,</span> <span class="n">out_dim</span><span class="p">)]</span>
</span><span id="vmap_flat-2122"><a href="#vmap_flat-2122"><span class="linenos">2122</span></a>    <span class="k">return</span> <span class="n">ret</span>
</span></pre></div>


    

                </section>
                <section id="vmap">
                            <input id="vmap-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">vmap</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">f</span>, </span><span class="param"><span class="n">in_dim</span><span class="o">=</span><span class="mi">0</span>, </span><span class="param"><span class="n">out_dim</span><span class="o">=</span><span class="mi">0</span>, </span><span class="param"><span class="n">dim_size</span><span class="o">=</span><span class="kc">None</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="vmap-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#vmap"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="vmap-2125"><a href="#vmap-2125"><span class="linenos">2125</span></a><span class="k">def</span> <span class="nf">vmap</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="n">in_dim</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">out_dim</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">dim_size</span><span class="o">=</span><span class="kc">None</span><span class="p">):</span>
</span><span id="vmap-2126"><a href="#vmap-2126"><span class="linenos">2126</span></a>    <span class="k">def</span> <span class="nf">batched_f</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">):</span>
</span><span id="vmap-2127"><a href="#vmap-2127"><span class="linenos">2127</span></a>        <span class="k">nonlocal</span> <span class="n">in_dim</span><span class="p">,</span> <span class="n">out_dim</span><span class="p">,</span> <span class="n">dim_size</span>
</span><span id="vmap-2128"><a href="#vmap-2128"><span class="linenos">2128</span></a>        <span class="n">args_flat</span><span class="p">,</span> <span class="n">in_tree</span> <span class="o">=</span> <span class="n">tree_flatten</span><span class="p">(</span><span class="n">args</span><span class="p">)</span>
</span><span id="vmap-2129"><a href="#vmap-2129"><span class="linenos">2129</span></a>        <span class="n">in_dim</span> <span class="o">=</span> <span class="p">(</span><span class="n">in_dim</span><span class="p">,)</span> <span class="o">*</span> <span class="nb">len</span><span class="p">(</span><span class="n">args</span><span class="p">)</span> <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">in_dim</span><span class="p">,</span> <span class="nb">int</span><span class="p">)</span> <span class="k">else</span> <span class="n">in_dim</span>
</span><span id="vmap-2130"><a href="#vmap-2130"><span class="linenos">2130</span></a>        <span class="n">out_dim</span> <span class="o">=</span> <span class="p">(</span><span class="n">out_dim</span><span class="p">,)</span> <span class="o">*</span> <span class="nb">len</span><span class="p">(</span><span class="n">args</span><span class="p">)</span> <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">out_dim</span><span class="p">,</span> <span class="nb">int</span><span class="p">)</span> <span class="k">else</span> <span class="n">out_dim</span>
</span><span id="vmap-2131"><a href="#vmap-2131"><span class="linenos">2131</span></a>        <span class="n">in_dim_flat</span><span class="p">,</span> <span class="n">in_dim_tree</span> <span class="o">=</span> <span class="n">tree_flatten</span><span class="p">(</span><span class="n">in_dim</span><span class="p">)</span>
</span><span id="vmap-2132"><a href="#vmap-2132"><span class="linenos">2132</span></a>        <span class="n">out_dim_flat</span><span class="p">,</span> <span class="n">out_dim_tree</span> <span class="o">=</span> <span class="n">tree_flatten</span><span class="p">(</span><span class="n">out_dim</span><span class="p">)</span>
</span><span id="vmap-2133"><a href="#vmap-2133"><span class="linenos">2133</span></a>        <span class="k">if</span> <span class="ow">not</span> <span class="p">(</span><span class="n">in_tree</span> <span class="o">==</span> <span class="n">in_dim_tree</span> <span class="o">==</span> <span class="n">out_dim_tree</span><span class="p">):</span>
</span><span id="vmap-2134"><a href="#vmap-2134"><span class="linenos">2134</span></a>            <span class="k">raise</span> <span class="ne">TypeError</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;</span><span class="se">\n</span><span class="si">{</span><span class="n">in_tree</span><span class="si">}</span><span class="se">\n</span><span class="s2">!=</span><span class="se">\n</span><span class="si">{</span><span class="n">in_dim_tree</span><span class="si">}</span><span class="s2">!=</span><span class="se">\n</span><span class="si">{</span><span class="n">out_dim_tree</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">)</span>
</span><span id="vmap-2135"><a href="#vmap-2135"><span class="linenos">2135</span></a>        <span class="n">f_flat</span><span class="p">,</span> <span class="n">out_tree_store</span> <span class="o">=</span> <span class="n">flatten_fn</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="n">in_tree</span><span class="p">)</span>
</span><span id="vmap-2136"><a href="#vmap-2136"><span class="linenos">2136</span></a>        <span class="c1"># if len(args_flat) &gt; len(in_dim_flat):</span>
</span><span id="vmap-2137"><a href="#vmap-2137"><span class="linenos">2137</span></a>        <span class="c1">#     in_dim_flat = (in_dim[0],) * len(args_flat)</span>
</span><span id="vmap-2138"><a href="#vmap-2138"><span class="linenos">2138</span></a>        <span class="n">outs_flat</span> <span class="o">=</span> <span class="n">vmap_flat</span><span class="p">(</span><span class="n">f_flat</span><span class="p">,</span> <span class="n">in_dim_flat</span><span class="p">,</span> <span class="n">out_dim_flat</span><span class="p">,</span> <span class="n">dim_size</span><span class="p">,</span> <span class="o">*</span><span class="n">args_flat</span><span class="p">)</span>
</span><span id="vmap-2139"><a href="#vmap-2139"><span class="linenos">2139</span></a>        <span class="k">return</span> <span class="n">tree_unflatten</span><span class="p">(</span><span class="n">out_tree_store</span><span class="p">(),</span> <span class="n">outs_flat</span><span class="p">)</span>
</span><span id="vmap-2140"><a href="#vmap-2140"><span class="linenos">2140</span></a>
</span><span id="vmap-2141"><a href="#vmap-2141"><span class="linenos">2141</span></a>    <span class="k">return</span> <span class="n">batched_f</span>
</span></pre></div>


    

                </section>
                <section id="jvp_flat">
                            <input id="jvp_flat-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">jvp_flat</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">f</span>, </span><span class="param"><span class="n">primals</span>, </span><span class="param"><span class="n">tangents</span>, </span><span class="param"><span class="o">*</span>, </span><span class="param"><span class="n">has_aux</span>, </span><span class="param"><span class="n">global_data</span>, </span><span class="param"><span class="o">**</span><span class="n">static_args</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="jvp_flat-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#jvp_flat"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="jvp_flat-2144"><a href="#jvp_flat-2144"><span class="linenos">2144</span></a><span class="k">def</span> <span class="nf">jvp_flat</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="n">primals</span><span class="p">,</span> <span class="n">tangents</span><span class="p">,</span> <span class="o">*</span><span class="p">,</span> <span class="n">has_aux</span><span class="p">,</span> <span class="n">global_data</span><span class="p">,</span> <span class="o">**</span><span class="n">static_args</span><span class="p">):</span>
</span><span id="jvp_flat-2145"><a href="#jvp_flat-2145"><span class="linenos">2145</span></a>    <span class="k">with</span> <span class="n">new_main_trace</span><span class="p">(</span><span class="n">JVPTrace</span><span class="p">,</span> <span class="n">global_data</span><span class="p">)</span> <span class="k">as</span> <span class="n">main</span><span class="p">:</span>
</span><span id="jvp_flat-2146"><a href="#jvp_flat-2146"><span class="linenos">2146</span></a>        <span class="n">trace</span> <span class="o">=</span> <span class="n">JVPTrace</span><span class="p">(</span><span class="n">main</span><span class="p">)</span>
</span><span id="jvp_flat-2147"><a href="#jvp_flat-2147"><span class="linenos">2147</span></a>        <span class="n">tracers_in</span> <span class="o">=</span> <span class="p">[</span><span class="n">JVPTraceTensor</span><span class="p">(</span><span class="n">trace</span><span class="p">,</span> <span class="n">x</span><span class="p">,</span> <span class="n">t</span><span class="p">)</span> <span class="k">for</span> <span class="n">x</span><span class="p">,</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">list_zip</span><span class="p">(</span><span class="n">primals</span><span class="p">,</span> <span class="n">tangents</span><span class="p">)]</span>
</span><span id="jvp_flat-2148"><a href="#jvp_flat-2148"><span class="linenos">2148</span></a>        <span class="n">jvp_flat_ret</span> <span class="o">=</span> <span class="n">f</span><span class="p">(</span><span class="o">*</span><span class="n">tracers_in</span><span class="p">,</span> <span class="o">**</span><span class="n">static_args</span><span class="p">)</span>
</span><span id="jvp_flat-2149"><a href="#jvp_flat-2149"><span class="linenos">2149</span></a>        <span class="k">if</span> <span class="n">has_aux</span><span class="p">:</span>
</span><span id="jvp_flat-2150"><a href="#jvp_flat-2150"><span class="linenos">2150</span></a>            <span class="p">(</span><span class="n">outs</span><span class="p">,</span> <span class="n">aux</span><span class="p">)</span> <span class="o">=</span> <span class="n">jvp_flat_ret</span>
</span><span id="jvp_flat-2151"><a href="#jvp_flat-2151"><span class="linenos">2151</span></a>            <span class="c1"># aux_ = aux</span>
</span><span id="jvp_flat-2152"><a href="#jvp_flat-2152"><span class="linenos">2152</span></a>            <span class="n">aux</span> <span class="o">=</span> <span class="n">tree_map</span><span class="p">(</span><span class="k">lambda</span> <span class="n">x</span><span class="p">:</span> <span class="n">x</span><span class="o">.</span><span class="n">primal</span><span class="p">,</span> <span class="n">aux</span><span class="p">)</span>
</span><span id="jvp_flat-2153"><a href="#jvp_flat-2153"><span class="linenos">2153</span></a>            <span class="c1"># aux = tree_map(lambda x: x.full_lower(), aux)</span>
</span><span id="jvp_flat-2154"><a href="#jvp_flat-2154"><span class="linenos">2154</span></a>            <span class="c1">#</span>
</span><span id="jvp_flat-2155"><a href="#jvp_flat-2155"><span class="linenos">2155</span></a>        <span class="k">else</span><span class="p">:</span>
</span><span id="jvp_flat-2156"><a href="#jvp_flat-2156"><span class="linenos">2156</span></a>            <span class="n">outs</span> <span class="o">=</span> <span class="n">jvp_flat_ret</span>
</span><span id="jvp_flat-2157"><a href="#jvp_flat-2157"><span class="linenos">2157</span></a>        <span class="n">tracers_out</span> <span class="o">=</span> <span class="p">[</span><span class="n">full_raise</span><span class="p">(</span><span class="n">trace</span><span class="p">,</span> <span class="n">out</span><span class="p">)</span> <span class="k">for</span> <span class="n">out</span> <span class="ow">in</span> <span class="n">outs</span><span class="p">]</span>
</span><span id="jvp_flat-2158"><a href="#jvp_flat-2158"><span class="linenos">2158</span></a>        <span class="n">primals_out</span><span class="p">,</span> <span class="n">tangents_out</span> <span class="o">=</span> <span class="n">unzip2</span><span class="p">((</span><span class="n">t</span><span class="o">.</span><span class="n">primal</span><span class="p">,</span> <span class="n">t</span><span class="o">.</span><span class="n">tangent</span><span class="p">)</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">tracers_out</span><span class="p">)</span>
</span><span id="jvp_flat-2159"><a href="#jvp_flat-2159"><span class="linenos">2159</span></a>    <span class="k">return</span> <span class="p">((</span><span class="n">primals_out</span><span class="p">,</span> <span class="n">tangents_out</span><span class="p">),</span> <span class="n">aux</span><span class="p">)</span> <span class="k">if</span> <span class="n">has_aux</span> <span class="k">else</span> <span class="p">(</span><span class="n">primals_out</span><span class="p">,</span> <span class="n">tangents_out</span><span class="p">)</span>
</span></pre></div>


    

                </section>
                <section id="jvp">
                            <input id="jvp-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">jvp</span><span class="signature pdoc-code multiline">(<span class="param">	<span class="n">f</span>,</span><span class="param">	<span class="n">primals</span>,</span><span class="param">	<span class="n">tangents</span>,</span><span class="param">	<span class="o">*</span>,</span><span class="param">	<span class="n">has_aux</span><span class="o">=</span><span class="kc">False</span>,</span><span class="param">	<span class="n">global_data</span><span class="o">=</span><span class="kc">None</span>,</span><span class="param">	<span class="o">**</span><span class="n">static_args</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="jvp-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#jvp"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="jvp-2162"><a href="#jvp-2162"><span class="linenos">2162</span></a><span class="k">def</span> <span class="nf">jvp</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="n">primals</span><span class="p">,</span> <span class="n">tangents</span><span class="p">,</span> <span class="o">*</span><span class="p">,</span> <span class="n">has_aux</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">global_data</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="o">**</span><span class="n">static_args</span><span class="p">):</span>
</span><span id="jvp-2163"><a href="#jvp-2163"><span class="linenos">2163</span></a>    <span class="n">primals_flat</span><span class="p">,</span> <span class="n">in_tree</span> <span class="o">=</span> <span class="n">tree_flatten</span><span class="p">(</span><span class="n">primals</span><span class="p">)</span>
</span><span id="jvp-2164"><a href="#jvp-2164"><span class="linenos">2164</span></a>    <span class="n">tangents_flat</span><span class="p">,</span> <span class="n">in_tree2</span> <span class="o">=</span> <span class="n">tree_flatten</span><span class="p">(</span><span class="n">tangents</span><span class="p">)</span>
</span><span id="jvp-2165"><a href="#jvp-2165"><span class="linenos">2165</span></a>    <span class="k">for</span> <span class="n">p</span><span class="p">,</span> <span class="n">t</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">primals_flat</span><span class="p">,</span> <span class="n">tangents_flat</span><span class="p">):</span>
</span><span id="jvp-2166"><a href="#jvp-2166"><span class="linenos">2166</span></a>        <span class="k">assert</span> <span class="n">p</span><span class="o">.</span><span class="n">shape</span> <span class="o">==</span> <span class="n">t</span><span class="o">.</span><span class="n">shape</span><span class="p">,</span> <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">p</span><span class="o">.</span><span class="n">shape</span><span class="si">=}</span><span class="s2"> != </span><span class="si">{</span><span class="n">t</span><span class="o">.</span><span class="n">shape</span><span class="si">=}</span><span class="s2">&quot;</span>
</span><span id="jvp-2167"><a href="#jvp-2167"><span class="linenos">2167</span></a>        <span class="k">assert</span> <span class="n">p</span><span class="o">.</span><span class="n">dtype</span> <span class="o">==</span> <span class="n">t</span><span class="o">.</span><span class="n">dtype</span><span class="p">,</span> <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">p</span><span class="o">.</span><span class="n">dtype</span><span class="si">=}</span><span class="s2"> != </span><span class="si">{</span><span class="n">t</span><span class="o">.</span><span class="n">dtype</span><span class="si">=}</span><span class="s2">&quot;</span>
</span><span id="jvp-2168"><a href="#jvp-2168"><span class="linenos">2168</span></a>        <span class="k">assert</span> <span class="n">p</span><span class="o">.</span><span class="n">device</span> <span class="o">==</span> <span class="n">t</span><span class="o">.</span><span class="n">device</span><span class="p">,</span> <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">p</span><span class="o">.</span><span class="n">device</span><span class="si">=}</span><span class="s2"> != </span><span class="si">{</span><span class="n">t</span><span class="o">.</span><span class="n">device</span><span class="si">=}</span><span class="s2">&quot;</span>
</span><span id="jvp-2169"><a href="#jvp-2169"><span class="linenos">2169</span></a>    <span class="k">if</span> <span class="n">in_tree</span> <span class="o">!=</span> <span class="n">in_tree2</span><span class="p">:</span>
</span><span id="jvp-2170"><a href="#jvp-2170"><span class="linenos">2170</span></a>        <span class="k">raise</span> <span class="ne">TypeError</span>
</span><span id="jvp-2171"><a href="#jvp-2171"><span class="linenos">2171</span></a>    <span class="n">f</span><span class="p">,</span> <span class="n">out_tree_store</span> <span class="o">=</span> <span class="n">flatten_fn</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="n">in_tree</span><span class="p">,</span> <span class="n">has_aux</span><span class="o">=</span><span class="n">has_aux</span><span class="p">)</span>
</span><span id="jvp-2172"><a href="#jvp-2172"><span class="linenos">2172</span></a>    <span class="n">jvp_ret</span> <span class="o">=</span> <span class="n">jvp_flat</span><span class="p">(</span>
</span><span id="jvp-2173"><a href="#jvp-2173"><span class="linenos">2173</span></a>        <span class="n">f</span><span class="p">,</span>
</span><span id="jvp-2174"><a href="#jvp-2174"><span class="linenos">2174</span></a>        <span class="n">primals_flat</span><span class="p">,</span>
</span><span id="jvp-2175"><a href="#jvp-2175"><span class="linenos">2175</span></a>        <span class="n">tangents_flat</span><span class="p">,</span>
</span><span id="jvp-2176"><a href="#jvp-2176"><span class="linenos">2176</span></a>        <span class="n">has_aux</span><span class="o">=</span><span class="n">has_aux</span><span class="p">,</span>
</span><span id="jvp-2177"><a href="#jvp-2177"><span class="linenos">2177</span></a>        <span class="n">global_data</span><span class="o">=</span><span class="n">global_data</span><span class="p">,</span>
</span><span id="jvp-2178"><a href="#jvp-2178"><span class="linenos">2178</span></a>        <span class="o">**</span><span class="n">static_args</span><span class="p">,</span>
</span><span id="jvp-2179"><a href="#jvp-2179"><span class="linenos">2179</span></a>    <span class="p">)</span>
</span><span id="jvp-2180"><a href="#jvp-2180"><span class="linenos">2180</span></a>    <span class="k">if</span> <span class="n">has_aux</span><span class="p">:</span>
</span><span id="jvp-2181"><a href="#jvp-2181"><span class="linenos">2181</span></a>        <span class="p">(</span><span class="n">primals_out_flat</span><span class="p">,</span> <span class="n">tangents_out_flat</span><span class="p">),</span> <span class="n">aux</span> <span class="o">=</span> <span class="n">jvp_ret</span>
</span><span id="jvp-2182"><a href="#jvp-2182"><span class="linenos">2182</span></a>    <span class="k">else</span><span class="p">:</span>
</span><span id="jvp-2183"><a href="#jvp-2183"><span class="linenos">2183</span></a>        <span class="p">(</span><span class="n">primals_out_flat</span><span class="p">,</span> <span class="n">tangents_out_flat</span><span class="p">)</span> <span class="o">=</span> <span class="n">jvp_ret</span>
</span><span id="jvp-2184"><a href="#jvp-2184"><span class="linenos">2184</span></a>    <span class="n">primals_out</span> <span class="o">=</span> <span class="n">tree_unflatten</span><span class="p">(</span><span class="n">out_tree_store</span><span class="p">(),</span> <span class="n">primals_out_flat</span><span class="p">)</span>
</span><span id="jvp-2185"><a href="#jvp-2185"><span class="linenos">2185</span></a>    <span class="n">tangents_out</span> <span class="o">=</span> <span class="n">tree_unflatten</span><span class="p">(</span><span class="n">out_tree_store</span><span class="p">(),</span> <span class="n">tangents_out_flat</span><span class="p">)</span>
</span><span id="jvp-2186"><a href="#jvp-2186"><span class="linenos">2186</span></a>    <span class="k">return</span> <span class="p">((</span><span class="n">primals_out</span><span class="p">,</span> <span class="n">tangents_out</span><span class="p">),</span> <span class="n">aux</span><span class="p">)</span> <span class="k">if</span> <span class="n">has_aux</span> <span class="k">else</span> <span class="p">(</span><span class="n">primals_out</span><span class="p">,</span> <span class="n">tangents_out</span><span class="p">)</span>
</span></pre></div>


    

                </section>
                <section id="jacfwd">
                            <input id="jacfwd-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">jacfwd</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">f</span>, </span><span class="param"><span class="n">x</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="jacfwd-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#jacfwd"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="jacfwd-2189"><a href="#jacfwd-2189"><span class="linenos">2189</span></a><span class="k">def</span> <span class="nf">jacfwd</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="n">x</span><span class="p">):</span>
</span><span id="jacfwd-2190"><a href="#jacfwd-2190"><span class="linenos">2190</span></a>    <span class="n">pushfwd</span> <span class="o">=</span> <span class="k">lambda</span> <span class="n">v</span><span class="p">:</span> <span class="n">jvp</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="p">(</span><span class="n">x</span><span class="p">,),</span> <span class="p">(</span><span class="n">v</span><span class="p">,))[</span><span class="mi">1</span><span class="p">]</span>
</span><span id="jacfwd-2191"><a href="#jacfwd-2191"><span class="linenos">2191</span></a>    <span class="n">vecs_in</span> <span class="o">=</span> <span class="n">backend</span><span class="o">.</span><span class="n">eye</span><span class="p">(</span><span class="n">math</span><span class="o">.</span><span class="n">prod</span><span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">shape</span><span class="p">))</span><span class="o">.</span><span class="n">reshape</span><span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">shape</span> <span class="o">*</span> <span class="mi">2</span><span class="p">)</span>
</span><span id="jacfwd-2192"><a href="#jacfwd-2192"><span class="linenos">2192</span></a>    <span class="k">return</span> <span class="n">vmap</span><span class="p">(</span><span class="n">pushfwd</span><span class="p">,</span> <span class="p">(</span><span class="mi">0</span><span class="p">,))(</span><span class="n">vecs_in</span><span class="p">)</span>
</span></pre></div>


    

                </section>
                <section id="stash_trace">
                            <input id="stash_trace-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
                    <div class="decorator">@contextmanager</div>

        <span class="def">def</span>
        <span class="name">stash_trace</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">main</span><span class="p">:</span> <span class="n"><a href="#MainTrace">MainTrace</a></span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="stash_trace-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#stash_trace"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="stash_trace-2195"><a href="#stash_trace-2195"><span class="linenos">2195</span></a><span class="nd">@contextmanager</span>
</span><span id="stash_trace-2196"><a href="#stash_trace-2196"><span class="linenos">2196</span></a><span class="k">def</span> <span class="nf">stash_trace</span><span class="p">(</span><span class="n">main</span><span class="p">:</span> <span class="n">MainTrace</span><span class="p">):</span>
</span><span id="stash_trace-2197"><a href="#stash_trace-2197"><span class="linenos">2197</span></a>    <span class="k">global</span> <span class="n">stashed_trace</span>
</span><span id="stash_trace-2198"><a href="#stash_trace-2198"><span class="linenos">2198</span></a>    <span class="n">prev_stashed_trace</span><span class="p">,</span> <span class="n">stashed_trace</span> <span class="o">=</span> <span class="n">stashed_trace</span><span class="p">,</span> <span class="n">main</span>
</span><span id="stash_trace-2199"><a href="#stash_trace-2199"><span class="linenos">2199</span></a>    <span class="k">try</span><span class="p">:</span>
</span><span id="stash_trace-2200"><a href="#stash_trace-2200"><span class="linenos">2200</span></a>        <span class="k">yield</span>
</span><span id="stash_trace-2201"><a href="#stash_trace-2201"><span class="linenos">2201</span></a>    <span class="k">finally</span><span class="p">:</span>
</span><span id="stash_trace-2202"><a href="#stash_trace-2202"><span class="linenos">2202</span></a>        <span class="n">stashed_trace</span> <span class="o">=</span> <span class="n">prev_stashed_trace</span>
</span></pre></div>


    

                </section>
                <section id="symbolic_run">
                            <input id="symbolic_run-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
                    <div class="decorator">@contextmanager</div>

        <span class="def">def</span>
        <span class="name">symbolic_run</span><span class="signature pdoc-code condensed">(<span class="return-annotation">):</span></span>

                <label class="view-source-button" for="symbolic_run-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#symbolic_run"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="symbolic_run-2205"><a href="#symbolic_run-2205"><span class="linenos">2205</span></a><span class="nd">@contextmanager</span>
</span><span id="symbolic_run-2206"><a href="#symbolic_run-2206"><span class="linenos">2206</span></a><span class="k">def</span> <span class="nf">symbolic_run</span><span class="p">():</span>
</span><span id="symbolic_run-2207"><a href="#symbolic_run-2207"><span class="linenos">2207</span></a>    <span class="k">global</span> <span class="n">trace_stack</span>
</span><span id="symbolic_run-2208"><a href="#symbolic_run-2208"><span class="linenos">2208</span></a>    <span class="n">level</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">trace_stack</span><span class="p">)</span>
</span><span id="symbolic_run-2209"><a href="#symbolic_run-2209"><span class="linenos">2209</span></a>    <span class="n">main</span> <span class="o">=</span> <span class="n">MainTrace</span><span class="p">(</span><span class="n">level</span><span class="p">,</span> <span class="n">SymbolicRunTrace</span><span class="p">,</span> <span class="n">global_data</span><span class="o">=</span><span class="kc">None</span><span class="p">)</span>
</span><span id="symbolic_run-2210"><a href="#symbolic_run-2210"><span class="linenos">2210</span></a>    <span class="n">trace_stack</span> <span class="o">+=</span> <span class="p">[</span><span class="n">main</span><span class="p">]</span>
</span><span id="symbolic_run-2211"><a href="#symbolic_run-2211"><span class="linenos">2211</span></a>    <span class="k">global</span> <span class="n">stashed_trace</span>
</span><span id="symbolic_run-2212"><a href="#symbolic_run-2212"><span class="linenos">2212</span></a>    <span class="n">prev_stashed_trace</span><span class="p">,</span> <span class="n">stashed_trace</span> <span class="o">=</span> <span class="n">stashed_trace</span><span class="p">,</span> <span class="n">main</span>
</span><span id="symbolic_run-2213"><a href="#symbolic_run-2213"><span class="linenos">2213</span></a>    <span class="k">try</span><span class="p">:</span>
</span><span id="symbolic_run-2214"><a href="#symbolic_run-2214"><span class="linenos">2214</span></a>        <span class="k">yield</span>
</span><span id="symbolic_run-2215"><a href="#symbolic_run-2215"><span class="linenos">2215</span></a>    <span class="k">finally</span><span class="p">:</span>
</span><span id="symbolic_run-2216"><a href="#symbolic_run-2216"><span class="linenos">2216</span></a>        <span class="n">stashed_trace</span> <span class="o">=</span> <span class="n">prev_stashed_trace</span>
</span><span id="symbolic_run-2217"><a href="#symbolic_run-2217"><span class="linenos">2217</span></a>        <span class="n">trace_stack</span><span class="o">.</span><span class="n">pop</span><span class="p">()</span>
</span></pre></div>


    

                </section>
                <section id="make_program">
                            <input id="make_program-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">make_program</span><span class="signature pdoc-code condensed">(<span class="param"><span class="o">*</span><span class="n">args</span>, </span><span class="param"><span class="o">**</span><span class="n">kwargs</span></span><span class="return-annotation">) -> <span class="n">Any</span>:</span></span>

                <label class="view-source-button" for="make_program-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#make_program"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="make_program-172"><a href="#make_program-172"><span class="linenos">172</span></a>        <span class="k">def</span> <span class="nf">decorated_function</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Any</span><span class="p">:</span>
</span><span id="make_program-173"><a href="#make_program-173"><span class="linenos">173</span></a>            <span class="n">result</span> <span class="o">=</span> <span class="n">wrapper</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">)</span>
</span><span id="make_program-174"><a href="#make_program-174"><span class="linenos">174</span></a>            <span class="n">cache_info</span> <span class="o">=</span> <span class="n">wrapper</span><span class="o">.</span><span class="n">cache_info</span><span class="p">()</span>
</span><span id="make_program-175"><a href="#make_program-175"><span class="linenos">175</span></a>
</span><span id="make_program-176"><a href="#make_program-176"><span class="linenos">176</span></a>            <span class="n">dblog</span><span class="p">(</span>
</span><span id="make_program-177"><a href="#make_program-177"><span class="linenos">177</span></a>                <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">fn</span><span class="o">.</span><span class="vm">__name__</span><span class="si">}</span><span class="s2">.</span><span class="si">{</span><span class="n">cache_info</span><span class="si">}</span><span class="s2"> </span><span class="si">{</span><span class="n">args</span><span class="o">.</span><span class="fm">__hash__</span><span class="p">()</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">,</span>
</span><span id="make_program-178"><a href="#make_program-178"><span class="linenos">178</span></a>                <span class="n">enable</span><span class="o">=</span><span class="n">backend</span><span class="o">.</span><span class="n">LOG_LRU</span><span class="p">,</span>
</span><span id="make_program-179"><a href="#make_program-179"><span class="linenos">179</span></a>            <span class="p">)</span>
</span><span id="make_program-180"><a href="#make_program-180"><span class="linenos">180</span></a>            <span class="n">tb</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">traceback</span><span class="o">.</span><span class="n">format_list</span><span class="p">(</span><span class="n">traceback</span><span class="o">.</span><span class="n">extract_stack</span><span class="p">())[</span><span class="n">tb_start</span><span class="p">:</span><span class="n">tb_end</span><span class="p">])</span><span class="o">.</span><span class="n">replace</span><span class="p">(</span><span class="s2">&quot;</span><span class="se">\n</span><span class="s2">    &quot;</span><span class="p">,</span> <span class="s2">&quot;:</span><span class="se">\t</span><span class="s2">&quot;</span><span class="p">)</span> <span class="o">+</span> <span class="s2">&quot;-&quot;</span> <span class="o">*</span> <span class="mi">20</span> <span class="o">+</span> <span class="s2">&quot;</span><span class="se">\n</span><span class="s2">&quot;</span>
</span><span id="make_program-181"><a href="#make_program-181"><span class="linenos">181</span></a>            <span class="n">dblog</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">tb</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">,</span> <span class="n">enable</span><span class="o">=</span><span class="n">backend</span><span class="o">.</span><span class="n">LOG_LRU</span><span class="p">)</span>
</span><span id="make_program-182"><a href="#make_program-182"><span class="linenos">182</span></a>
</span><span id="make_program-183"><a href="#make_program-183"><span class="linenos">183</span></a>            <span class="k">return</span> <span class="n">result</span>
</span></pre></div>


    

                </section>
                <section id="vmap_program">
                            <input id="vmap_program-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">vmap_program</span><span class="signature pdoc-code condensed">(<span class="param"><span class="o">*</span><span class="n">args</span>, </span><span class="param"><span class="o">**</span><span class="n">kwargs</span></span><span class="return-annotation">) -> <span class="n">Any</span>:</span></span>

                <label class="view-source-button" for="vmap_program-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#vmap_program"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="vmap_program-172"><a href="#vmap_program-172"><span class="linenos">172</span></a>        <span class="k">def</span> <span class="nf">decorated_function</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Any</span><span class="p">:</span>
</span><span id="vmap_program-173"><a href="#vmap_program-173"><span class="linenos">173</span></a>            <span class="n">result</span> <span class="o">=</span> <span class="n">wrapper</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">)</span>
</span><span id="vmap_program-174"><a href="#vmap_program-174"><span class="linenos">174</span></a>            <span class="n">cache_info</span> <span class="o">=</span> <span class="n">wrapper</span><span class="o">.</span><span class="n">cache_info</span><span class="p">()</span>
</span><span id="vmap_program-175"><a href="#vmap_program-175"><span class="linenos">175</span></a>
</span><span id="vmap_program-176"><a href="#vmap_program-176"><span class="linenos">176</span></a>            <span class="n">dblog</span><span class="p">(</span>
</span><span id="vmap_program-177"><a href="#vmap_program-177"><span class="linenos">177</span></a>                <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">fn</span><span class="o">.</span><span class="vm">__name__</span><span class="si">}</span><span class="s2">.</span><span class="si">{</span><span class="n">cache_info</span><span class="si">}</span><span class="s2"> </span><span class="si">{</span><span class="n">args</span><span class="o">.</span><span class="fm">__hash__</span><span class="p">()</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">,</span>
</span><span id="vmap_program-178"><a href="#vmap_program-178"><span class="linenos">178</span></a>                <span class="n">enable</span><span class="o">=</span><span class="n">backend</span><span class="o">.</span><span class="n">LOG_LRU</span><span class="p">,</span>
</span><span id="vmap_program-179"><a href="#vmap_program-179"><span class="linenos">179</span></a>            <span class="p">)</span>
</span><span id="vmap_program-180"><a href="#vmap_program-180"><span class="linenos">180</span></a>            <span class="n">tb</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">traceback</span><span class="o">.</span><span class="n">format_list</span><span class="p">(</span><span class="n">traceback</span><span class="o">.</span><span class="n">extract_stack</span><span class="p">())[</span><span class="n">tb_start</span><span class="p">:</span><span class="n">tb_end</span><span class="p">])</span><span class="o">.</span><span class="n">replace</span><span class="p">(</span><span class="s2">&quot;</span><span class="se">\n</span><span class="s2">    &quot;</span><span class="p">,</span> <span class="s2">&quot;:</span><span class="se">\t</span><span class="s2">&quot;</span><span class="p">)</span> <span class="o">+</span> <span class="s2">&quot;-&quot;</span> <span class="o">*</span> <span class="mi">20</span> <span class="o">+</span> <span class="s2">&quot;</span><span class="se">\n</span><span class="s2">&quot;</span>
</span><span id="vmap_program-181"><a href="#vmap_program-181"><span class="linenos">181</span></a>            <span class="n">dblog</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">tb</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">,</span> <span class="n">enable</span><span class="o">=</span><span class="n">backend</span><span class="o">.</span><span class="n">LOG_LRU</span><span class="p">)</span>
</span><span id="vmap_program-182"><a href="#vmap_program-182"><span class="linenos">182</span></a>
</span><span id="vmap_program-183"><a href="#vmap_program-183"><span class="linenos">183</span></a>            <span class="k">return</span> <span class="n">result</span>
</span></pre></div>


    

                </section>
                <section id="jvp_program">
                            <input id="jvp_program-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">jvp_program</span><span class="signature pdoc-code condensed">(<span class="param"><span class="o">*</span><span class="n">args</span>, </span><span class="param"><span class="o">**</span><span class="n">kwargs</span></span><span class="return-annotation">) -> <span class="n">Any</span>:</span></span>

                <label class="view-source-button" for="jvp_program-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#jvp_program"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="jvp_program-172"><a href="#jvp_program-172"><span class="linenos">172</span></a>        <span class="k">def</span> <span class="nf">decorated_function</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Any</span><span class="p">:</span>
</span><span id="jvp_program-173"><a href="#jvp_program-173"><span class="linenos">173</span></a>            <span class="n">result</span> <span class="o">=</span> <span class="n">wrapper</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">)</span>
</span><span id="jvp_program-174"><a href="#jvp_program-174"><span class="linenos">174</span></a>            <span class="n">cache_info</span> <span class="o">=</span> <span class="n">wrapper</span><span class="o">.</span><span class="n">cache_info</span><span class="p">()</span>
</span><span id="jvp_program-175"><a href="#jvp_program-175"><span class="linenos">175</span></a>
</span><span id="jvp_program-176"><a href="#jvp_program-176"><span class="linenos">176</span></a>            <span class="n">dblog</span><span class="p">(</span>
</span><span id="jvp_program-177"><a href="#jvp_program-177"><span class="linenos">177</span></a>                <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">fn</span><span class="o">.</span><span class="vm">__name__</span><span class="si">}</span><span class="s2">.</span><span class="si">{</span><span class="n">cache_info</span><span class="si">}</span><span class="s2"> </span><span class="si">{</span><span class="n">args</span><span class="o">.</span><span class="fm">__hash__</span><span class="p">()</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">,</span>
</span><span id="jvp_program-178"><a href="#jvp_program-178"><span class="linenos">178</span></a>                <span class="n">enable</span><span class="o">=</span><span class="n">backend</span><span class="o">.</span><span class="n">LOG_LRU</span><span class="p">,</span>
</span><span id="jvp_program-179"><a href="#jvp_program-179"><span class="linenos">179</span></a>            <span class="p">)</span>
</span><span id="jvp_program-180"><a href="#jvp_program-180"><span class="linenos">180</span></a>            <span class="n">tb</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">traceback</span><span class="o">.</span><span class="n">format_list</span><span class="p">(</span><span class="n">traceback</span><span class="o">.</span><span class="n">extract_stack</span><span class="p">())[</span><span class="n">tb_start</span><span class="p">:</span><span class="n">tb_end</span><span class="p">])</span><span class="o">.</span><span class="n">replace</span><span class="p">(</span><span class="s2">&quot;</span><span class="se">\n</span><span class="s2">    &quot;</span><span class="p">,</span> <span class="s2">&quot;:</span><span class="se">\t</span><span class="s2">&quot;</span><span class="p">)</span> <span class="o">+</span> <span class="s2">&quot;-&quot;</span> <span class="o">*</span> <span class="mi">20</span> <span class="o">+</span> <span class="s2">&quot;</span><span class="se">\n</span><span class="s2">&quot;</span>
</span><span id="jvp_program-181"><a href="#jvp_program-181"><span class="linenos">181</span></a>            <span class="n">dblog</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">tb</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">,</span> <span class="n">enable</span><span class="o">=</span><span class="n">backend</span><span class="o">.</span><span class="n">LOG_LRU</span><span class="p">)</span>
</span><span id="jvp_program-182"><a href="#jvp_program-182"><span class="linenos">182</span></a>
</span><span id="jvp_program-183"><a href="#jvp_program-183"><span class="linenos">183</span></a>            <span class="k">return</span> <span class="n">result</span>
</span></pre></div>


    

                </section>
                <section id="partial_run_flat">
                            <input id="partial_run_flat-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">partial_run_flat</span><span class="signature pdoc-code multiline">(<span class="param">	<span class="n">f</span><span class="p">:</span> <span class="n">Callable</span>,</span><span class="param">	<span class="n">pvals_in</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n"><a href="#PartialValue">PartialValue</a></span><span class="p">]</span>,</span><span class="param">	<span class="n">has_aux</span>,</span><span class="param">	<span class="n">global_data</span><span class="o">=</span><span class="kc">None</span></span><span class="return-annotation">) -> <span class="n">Tuple</span><span class="p">[</span><span class="n"><a href="#Program">Program</a></span><span class="p">,</span> <span class="n">List</span><span class="p">[</span><span class="n"><a href="#PartialValue">PartialValue</a></span><span class="p">],</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">]]</span>:</span></span>

                <label class="view-source-button" for="partial_run_flat-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#partial_run_flat"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="partial_run_flat-2275"><a href="#partial_run_flat-2275"><span class="linenos">2275</span></a><span class="k">def</span> <span class="nf">partial_run_flat</span><span class="p">(</span>
</span><span id="partial_run_flat-2276"><a href="#partial_run_flat-2276"><span class="linenos">2276</span></a>    <span class="n">f</span><span class="p">:</span> <span class="n">Callable</span><span class="p">,</span> <span class="n">pvals_in</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="s2">&quot;PartialValue&quot;</span><span class="p">],</span> <span class="n">has_aux</span><span class="p">,</span> <span class="n">global_data</span><span class="o">=</span><span class="kc">None</span>
</span><span id="partial_run_flat-2277"><a href="#partial_run_flat-2277"><span class="linenos">2277</span></a><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Tuple</span><span class="p">[</span><span class="n">Program</span><span class="p">,</span> <span class="n">List</span><span class="p">[</span><span class="s2">&quot;PartialValue&quot;</span><span class="p">],</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">]]:</span>
</span><span id="partial_run_flat-2278"><a href="#partial_run_flat-2278"><span class="linenos">2278</span></a>    <span class="k">with</span> <span class="n">new_main_trace</span><span class="p">(</span><span class="n">PartialRunTrace</span><span class="p">,</span> <span class="n">global_data</span><span class="p">)</span> <span class="k">as</span> <span class="n">main</span><span class="p">:</span>
</span><span id="partial_run_flat-2279"><a href="#partial_run_flat-2279"><span class="linenos">2279</span></a>        <span class="n">trace</span> <span class="o">=</span> <span class="n">PartialRunTrace</span><span class="p">(</span><span class="n">main</span><span class="p">)</span>
</span><span id="partial_run_flat-2280"><a href="#partial_run_flat-2280"><span class="linenos">2280</span></a>        <span class="n">tracers_in</span> <span class="o">=</span> <span class="p">[</span><span class="n">trace</span><span class="o">.</span><span class="n">new_arg</span><span class="p">(</span><span class="n">pval</span><span class="p">)</span> <span class="k">for</span> <span class="n">pval</span> <span class="ow">in</span> <span class="n">pvals_in</span><span class="p">]</span>
</span><span id="partial_run_flat-2281"><a href="#partial_run_flat-2281"><span class="linenos">2281</span></a>        <span class="n">outs</span> <span class="o">=</span> <span class="n">f</span><span class="p">(</span><span class="o">*</span><span class="n">tracers_in</span><span class="p">)</span>
</span><span id="partial_run_flat-2282"><a href="#partial_run_flat-2282"><span class="linenos">2282</span></a>        <span class="k">if</span> <span class="n">has_aux</span><span class="p">:</span>
</span><span id="partial_run_flat-2283"><a href="#partial_run_flat-2283"><span class="linenos">2283</span></a>            <span class="n">outs</span><span class="p">,</span> <span class="n">aux</span> <span class="o">=</span> <span class="n">outs</span>
</span><span id="partial_run_flat-2284"><a href="#partial_run_flat-2284"><span class="linenos">2284</span></a>        <span class="n">tracers_out</span> <span class="o">=</span> <span class="p">[</span><span class="n">full_raise</span><span class="p">(</span><span class="n">trace</span><span class="p">,</span> <span class="n">out</span><span class="p">)</span> <span class="k">for</span> <span class="n">out</span> <span class="ow">in</span> <span class="n">outs</span><span class="p">]</span>
</span><span id="partial_run_flat-2285"><a href="#partial_run_flat-2285"><span class="linenos">2285</span></a>        <span class="n">pvals_out</span> <span class="o">=</span> <span class="p">[</span><span class="n">t</span><span class="o">.</span><span class="n">pval</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">tracers_out</span><span class="p">]</span>
</span><span id="partial_run_flat-2286"><a href="#partial_run_flat-2286"><span class="linenos">2286</span></a>        <span class="n">unk_tracers_in</span> <span class="o">=</span> <span class="p">[</span><span class="n">t</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">tracers_in</span> <span class="k">if</span> <span class="n">t</span><span class="o">.</span><span class="n">pval</span><span class="o">.</span><span class="n">is_unknown</span><span class="p">]</span>
</span><span id="partial_run_flat-2287"><a href="#partial_run_flat-2287"><span class="linenos">2287</span></a>        <span class="n">unk_tracers_out</span> <span class="o">=</span> <span class="p">[</span><span class="n">t</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">tracers_out</span> <span class="k">if</span> <span class="n">t</span><span class="o">.</span><span class="n">pval</span><span class="o">.</span><span class="n">is_unknown</span><span class="p">]</span>
</span><span id="partial_run_flat-2288"><a href="#partial_run_flat-2288"><span class="linenos">2288</span></a>        <span class="n">program</span><span class="p">,</span> <span class="n">consts</span> <span class="o">=</span> <span class="n">tracers_to_program</span><span class="p">(</span><span class="n">unk_tracers_in</span><span class="p">,</span> <span class="n">unk_tracers_out</span><span class="p">)</span>
</span><span id="partial_run_flat-2289"><a href="#partial_run_flat-2289"><span class="linenos">2289</span></a>
</span><span id="partial_run_flat-2290"><a href="#partial_run_flat-2290"><span class="linenos">2290</span></a>    <span class="k">return</span> <span class="p">(</span><span class="n">program</span><span class="p">,</span> <span class="n">pvals_out</span><span class="p">,</span> <span class="n">consts</span><span class="p">,</span> <span class="n">aux</span><span class="p">)</span> <span class="k">if</span> <span class="n">has_aux</span> <span class="k">else</span> <span class="p">(</span><span class="n">program</span><span class="p">,</span> <span class="n">pvals_out</span><span class="p">,</span> <span class="n">consts</span><span class="p">)</span>
</span></pre></div>


    

                </section>
                <section id="partial_run_program">
                            <input id="partial_run_program-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">partial_run_program</span><span class="signature pdoc-code multiline">(<span class="param">	<span class="n">program</span><span class="p">:</span> <span class="n"><a href="#Program">Program</a></span>,</span><span class="param">	<span class="n">in_unknowns</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="nb">bool</span><span class="p">]</span>,</span><span class="param">	<span class="n">instantiate</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="n">List</span><span class="p">[</span><span class="nb">bool</span><span class="p">]]</span> <span class="o">=</span> <span class="kc">None</span></span><span class="return-annotation">) -> <span class="n">Tuple</span><span class="p">[</span><span class="n"><a href="#Program">Program</a></span><span class="p">,</span> <span class="n"><a href="#Program">Program</a></span><span class="p">,</span> <span class="n">List</span><span class="p">[</span><span class="nb">bool</span><span class="p">],</span> <span class="nb">int</span><span class="p">]</span>:</span></span>

                <label class="view-source-button" for="partial_run_program-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#partial_run_program"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="partial_run_program-2293"><a href="#partial_run_program-2293"><span class="linenos">2293</span></a><span class="k">def</span> <span class="nf">partial_run_program</span><span class="p">(</span>
</span><span id="partial_run_program-2294"><a href="#partial_run_program-2294"><span class="linenos">2294</span></a>    <span class="n">program</span><span class="p">:</span> <span class="n">Program</span><span class="p">,</span>
</span><span id="partial_run_program-2295"><a href="#partial_run_program-2295"><span class="linenos">2295</span></a>    <span class="n">in_unknowns</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="nb">bool</span><span class="p">],</span>
</span><span id="partial_run_program-2296"><a href="#partial_run_program-2296"><span class="linenos">2296</span></a>    <span class="n">instantiate</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="n">List</span><span class="p">[</span><span class="nb">bool</span><span class="p">]]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span>
</span><span id="partial_run_program-2297"><a href="#partial_run_program-2297"><span class="linenos">2297</span></a><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Tuple</span><span class="p">[</span><span class="n">Program</span><span class="p">,</span> <span class="n">Program</span><span class="p">,</span> <span class="n">List</span><span class="p">[</span><span class="nb">bool</span><span class="p">],</span> <span class="nb">int</span><span class="p">]:</span>
</span><span id="partial_run_program-2298"><a href="#partial_run_program-2298"><span class="linenos">2298</span></a>    <span class="n">env</span><span class="p">:</span> <span class="n">Dict</span><span class="p">[</span><span class="n">Var</span><span class="p">,</span> <span class="nb">bool</span><span class="p">]</span> <span class="o">=</span> <span class="p">{}</span>
</span><span id="partial_run_program-2299"><a href="#partial_run_program-2299"><span class="linenos">2299</span></a>    <span class="n">residuals</span><span class="p">:</span> <span class="n">Set</span><span class="p">[</span><span class="n">Var</span><span class="p">]</span> <span class="o">=</span> <span class="nb">set</span><span class="p">()</span>
</span><span id="partial_run_program-2300"><a href="#partial_run_program-2300"><span class="linenos">2300</span></a>
</span><span id="partial_run_program-2301"><a href="#partial_run_program-2301"><span class="linenos">2301</span></a>    <span class="k">def</span> <span class="nf">read</span><span class="p">(</span><span class="n">x</span><span class="p">:</span> <span class="n">Atom</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="nb">bool</span><span class="p">:</span>
</span><span id="partial_run_program-2302"><a href="#partial_run_program-2302"><span class="linenos">2302</span></a>        <span class="k">return</span> <span class="nb">type</span><span class="p">(</span><span class="n">x</span><span class="p">)</span> <span class="ow">is</span> <span class="n">Var</span> <span class="ow">and</span> <span class="n">env</span><span class="p">[</span><span class="n">x</span><span class="p">]</span>
</span><span id="partial_run_program-2303"><a href="#partial_run_program-2303"><span class="linenos">2303</span></a>
</span><span id="partial_run_program-2304"><a href="#partial_run_program-2304"><span class="linenos">2304</span></a>    <span class="k">def</span> <span class="nf">write</span><span class="p">(</span><span class="n">unk</span><span class="p">:</span> <span class="nb">bool</span><span class="p">,</span> <span class="n">v</span><span class="p">:</span> <span class="n">Var</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="kc">None</span><span class="p">:</span>
</span><span id="partial_run_program-2305"><a href="#partial_run_program-2305"><span class="linenos">2305</span></a>        <span class="n">env</span><span class="p">[</span><span class="n">v</span><span class="p">]</span> <span class="o">=</span> <span class="n">unk</span>
</span><span id="partial_run_program-2306"><a href="#partial_run_program-2306"><span class="linenos">2306</span></a>
</span><span id="partial_run_program-2307"><a href="#partial_run_program-2307"><span class="linenos">2307</span></a>    <span class="n">instructions1</span><span class="p">,</span> <span class="n">instructions2</span> <span class="o">=</span> <span class="p">[],</span> <span class="p">[]</span>
</span><span id="partial_run_program-2308"><a href="#partial_run_program-2308"><span class="linenos">2308</span></a>    <span class="n">list_map</span><span class="p">(</span><span class="n">write</span><span class="p">,</span> <span class="n">in_unknowns</span><span class="p">,</span> <span class="n">program</span><span class="o">.</span><span class="n">in_binders</span><span class="p">)</span>
</span><span id="partial_run_program-2309"><a href="#partial_run_program-2309"><span class="linenos">2309</span></a>
</span><span id="partial_run_program-2310"><a href="#partial_run_program-2310"><span class="linenos">2310</span></a>    <span class="k">for</span> <span class="n">instruction</span> <span class="ow">in</span> <span class="n">program</span><span class="o">.</span><span class="n">instructions</span><span class="p">:</span>
</span><span id="partial_run_program-2311"><a href="#partial_run_program-2311"><span class="linenos">2311</span></a>        <span class="n">unks_in</span> <span class="o">=</span> <span class="n">list_map</span><span class="p">(</span><span class="n">read</span><span class="p">,</span> <span class="n">instruction</span><span class="o">.</span><span class="n">inputs</span><span class="p">)</span>
</span><span id="partial_run_program-2312"><a href="#partial_run_program-2312"><span class="linenos">2312</span></a>        <span class="p">(</span>
</span><span id="partial_run_program-2313"><a href="#partial_run_program-2313"><span class="linenos">2313</span></a>            <span class="n">instruction1</span><span class="p">,</span>
</span><span id="partial_run_program-2314"><a href="#partial_run_program-2314"><span class="linenos">2314</span></a>            <span class="n">instruction2</span><span class="p">,</span>
</span><span id="partial_run_program-2315"><a href="#partial_run_program-2315"><span class="linenos">2315</span></a>            <span class="n">unks_out</span><span class="p">,</span>
</span><span id="partial_run_program-2316"><a href="#partial_run_program-2316"><span class="linenos">2316</span></a>            <span class="n">res</span><span class="p">,</span>
</span><span id="partial_run_program-2317"><a href="#partial_run_program-2317"><span class="linenos">2317</span></a>        <span class="p">)</span> <span class="o">=</span> <span class="n">instruction</span><span class="o">.</span><span class="n">op</span><span class="o">.</span><span class="n">partial_run_instruction</span><span class="p">(</span><span class="n">unks_in</span><span class="p">,</span> <span class="n">instruction</span><span class="p">)</span>
</span><span id="partial_run_program-2318"><a href="#partial_run_program-2318"><span class="linenos">2318</span></a>        <span class="k">if</span> <span class="n">instruction1</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
</span><span id="partial_run_program-2319"><a href="#partial_run_program-2319"><span class="linenos">2319</span></a>            <span class="n">instructions1</span> <span class="o">+=</span> <span class="p">[</span><span class="n">instruction1</span><span class="p">]</span>
</span><span id="partial_run_program-2320"><a href="#partial_run_program-2320"><span class="linenos">2320</span></a>        <span class="k">if</span> <span class="n">instruction2</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
</span><span id="partial_run_program-2321"><a href="#partial_run_program-2321"><span class="linenos">2321</span></a>            <span class="n">instructions2</span> <span class="o">+=</span> <span class="p">[</span><span class="n">instruction2</span><span class="p">]</span>
</span><span id="partial_run_program-2322"><a href="#partial_run_program-2322"><span class="linenos">2322</span></a>        <span class="k">if</span> <span class="n">res</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
</span><span id="partial_run_program-2323"><a href="#partial_run_program-2323"><span class="linenos">2323</span></a>            <span class="n">residuals</span><span class="o">.</span><span class="n">update</span><span class="p">(</span><span class="n">res</span><span class="p">)</span>
</span><span id="partial_run_program-2324"><a href="#partial_run_program-2324"><span class="linenos">2324</span></a>        <span class="n">list_map</span><span class="p">(</span><span class="n">write</span><span class="p">,</span> <span class="n">unks_out</span><span class="p">,</span> <span class="n">instruction</span><span class="o">.</span><span class="n">out_binders</span><span class="p">)</span>
</span><span id="partial_run_program-2325"><a href="#partial_run_program-2325"><span class="linenos">2325</span></a>
</span><span id="partial_run_program-2326"><a href="#partial_run_program-2326"><span class="linenos">2326</span></a>    <span class="n">out_unknowns</span> <span class="o">=</span> <span class="n">list_map</span><span class="p">(</span><span class="n">read</span><span class="p">,</span> <span class="n">program</span><span class="o">.</span><span class="n">outs</span><span class="p">)</span>
</span><span id="partial_run_program-2327"><a href="#partial_run_program-2327"><span class="linenos">2327</span></a>    <span class="k">if</span> <span class="n">instantiate</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
</span><span id="partial_run_program-2328"><a href="#partial_run_program-2328"><span class="linenos">2328</span></a>        <span class="k">for</span> <span class="n">v</span><span class="p">,</span> <span class="n">uk</span><span class="p">,</span> <span class="n">inst</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">program</span><span class="o">.</span><span class="n">outs</span><span class="p">,</span> <span class="n">out_unknowns</span><span class="p">,</span> <span class="n">instantiate</span><span class="p">):</span>
</span><span id="partial_run_program-2329"><a href="#partial_run_program-2329"><span class="linenos">2329</span></a>            <span class="k">if</span> <span class="n">inst</span> <span class="ow">and</span> <span class="ow">not</span> <span class="n">uk</span><span class="p">:</span>
</span><span id="partial_run_program-2330"><a href="#partial_run_program-2330"><span class="linenos">2330</span></a>                <span class="k">if</span> <span class="nb">type</span><span class="p">(</span><span class="n">v</span><span class="p">)</span> <span class="ow">is</span> <span class="n">Var</span><span class="p">:</span>
</span><span id="partial_run_program-2331"><a href="#partial_run_program-2331"><span class="linenos">2331</span></a>                    <span class="n">residuals</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">v</span><span class="p">)</span>
</span><span id="partial_run_program-2332"><a href="#partial_run_program-2332"><span class="linenos">2332</span></a>        <span class="n">out_unknowns</span> <span class="o">=</span> <span class="n">list_map</span><span class="p">(</span><span class="n">operator_py</span><span class="o">.</span><span class="n">or_</span><span class="p">,</span> <span class="n">out_unknowns</span><span class="p">,</span> <span class="n">instantiate</span><span class="p">)</span>
</span><span id="partial_run_program-2333"><a href="#partial_run_program-2333"><span class="linenos">2333</span></a>
</span><span id="partial_run_program-2334"><a href="#partial_run_program-2334"><span class="linenos">2334</span></a>    <span class="n">residuals</span><span class="p">,</span> <span class="n">num_res</span> <span class="o">=</span> <span class="nb">list</span><span class="p">(</span><span class="n">residuals</span><span class="p">),</span> <span class="nb">len</span><span class="p">(</span><span class="n">residuals</span><span class="p">)</span>
</span><span id="partial_run_program-2335"><a href="#partial_run_program-2335"><span class="linenos">2335</span></a>    <span class="k">assert</span> <span class="nb">all</span><span class="p">(</span><span class="nb">type</span><span class="p">(</span><span class="n">v</span><span class="p">)</span> <span class="ow">is</span> <span class="n">Var</span> <span class="k">for</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">residuals</span><span class="p">),</span> <span class="n">residuals</span>
</span><span id="partial_run_program-2336"><a href="#partial_run_program-2336"><span class="linenos">2336</span></a>
</span><span id="partial_run_program-2337"><a href="#partial_run_program-2337"><span class="linenos">2337</span></a>    <span class="n">ins1</span><span class="p">,</span> <span class="n">ins2</span> <span class="o">=</span> <span class="n">partition_list</span><span class="p">(</span><span class="n">in_unknowns</span><span class="p">,</span> <span class="n">program</span><span class="o">.</span><span class="n">in_binders</span><span class="p">)</span>
</span><span id="partial_run_program-2338"><a href="#partial_run_program-2338"><span class="linenos">2338</span></a>    <span class="n">outs1</span><span class="p">,</span> <span class="n">outs2</span> <span class="o">=</span> <span class="n">partition_list</span><span class="p">(</span><span class="n">out_unknowns</span><span class="p">,</span> <span class="n">program</span><span class="o">.</span><span class="n">outs</span><span class="p">)</span>
</span><span id="partial_run_program-2339"><a href="#partial_run_program-2339"><span class="linenos">2339</span></a>
</span><span id="partial_run_program-2340"><a href="#partial_run_program-2340"><span class="linenos">2340</span></a>    <span class="n">program1</span> <span class="o">=</span> <span class="n">Program</span><span class="p">(</span>
</span><span id="partial_run_program-2341"><a href="#partial_run_program-2341"><span class="linenos">2341</span></a>        <span class="n">ins1</span><span class="p">,</span>
</span><span id="partial_run_program-2342"><a href="#partial_run_program-2342"><span class="linenos">2342</span></a>        <span class="n">instructions1</span><span class="p">,</span>
</span><span id="partial_run_program-2343"><a href="#partial_run_program-2343"><span class="linenos">2343</span></a>        <span class="n">outs1</span> <span class="o">+</span> <span class="n">residuals</span><span class="p">,</span>
</span><span id="partial_run_program-2344"><a href="#partial_run_program-2344"><span class="linenos">2344</span></a>        <span class="mi">0</span><span class="p">,</span>
</span><span id="partial_run_program-2345"><a href="#partial_run_program-2345"><span class="linenos">2345</span></a>        <span class="n">program</span><span class="o">.</span><span class="n">static_args</span><span class="p">,</span>
</span><span id="partial_run_program-2346"><a href="#partial_run_program-2346"><span class="linenos">2346</span></a>        <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">program</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">_partial1&quot;</span><span class="p">,</span>
</span><span id="partial_run_program-2347"><a href="#partial_run_program-2347"><span class="linenos">2347</span></a>    <span class="p">)</span>
</span><span id="partial_run_program-2348"><a href="#partial_run_program-2348"><span class="linenos">2348</span></a>    <span class="n">program2</span> <span class="o">=</span> <span class="n">Program</span><span class="p">(</span>
</span><span id="partial_run_program-2349"><a href="#partial_run_program-2349"><span class="linenos">2349</span></a>        <span class="n">residuals</span> <span class="o">+</span> <span class="n">ins2</span><span class="p">,</span>
</span><span id="partial_run_program-2350"><a href="#partial_run_program-2350"><span class="linenos">2350</span></a>        <span class="n">instructions2</span><span class="p">,</span>
</span><span id="partial_run_program-2351"><a href="#partial_run_program-2351"><span class="linenos">2351</span></a>        <span class="n">outs2</span><span class="p">,</span>
</span><span id="partial_run_program-2352"><a href="#partial_run_program-2352"><span class="linenos">2352</span></a>        <span class="mi">0</span><span class="p">,</span>
</span><span id="partial_run_program-2353"><a href="#partial_run_program-2353"><span class="linenos">2353</span></a>        <span class="n">program</span><span class="o">.</span><span class="n">static_args</span><span class="p">,</span>
</span><span id="partial_run_program-2354"><a href="#partial_run_program-2354"><span class="linenos">2354</span></a>        <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">program</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">_partial2&quot;</span><span class="p">,</span>
</span><span id="partial_run_program-2355"><a href="#partial_run_program-2355"><span class="linenos">2355</span></a>    <span class="p">)</span>
</span><span id="partial_run_program-2356"><a href="#partial_run_program-2356"><span class="linenos">2356</span></a>    <span class="n">typecheck_partial_run_program</span><span class="p">(</span><span class="n">program</span><span class="p">,</span> <span class="n">in_unknowns</span><span class="p">,</span> <span class="n">out_unknowns</span><span class="p">,</span> <span class="n">program1</span><span class="p">,</span> <span class="n">program2</span><span class="p">)</span>
</span><span id="partial_run_program-2357"><a href="#partial_run_program-2357"><span class="linenos">2357</span></a>
</span><span id="partial_run_program-2358"><a href="#partial_run_program-2358"><span class="linenos">2358</span></a>    <span class="k">return</span> <span class="n">program1</span><span class="p">,</span> <span class="n">program2</span><span class="p">,</span> <span class="n">out_unknowns</span><span class="p">,</span> <span class="n">num_res</span>
</span></pre></div>


    

                </section>
                <section id="typecheck_partial_run_program">
                            <input id="typecheck_partial_run_program-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">typecheck_partial_run_program</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">program</span>, </span><span class="param"><span class="n">in_unknowns</span>, </span><span class="param"><span class="n">out_unknowns</span>, </span><span class="param"><span class="n">program1</span>, </span><span class="param"><span class="n">program2</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="typecheck_partial_run_program-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#typecheck_partial_run_program"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="typecheck_partial_run_program-2361"><a href="#typecheck_partial_run_program-2361"><span class="linenos">2361</span></a><span class="k">def</span> <span class="nf">typecheck_partial_run_program</span><span class="p">(</span><span class="n">program</span><span class="p">,</span> <span class="n">in_unknowns</span><span class="p">,</span> <span class="n">out_unknowns</span><span class="p">,</span> <span class="n">program1</span><span class="p">,</span> <span class="n">program2</span><span class="p">):</span>
</span><span id="typecheck_partial_run_program-2362"><a href="#typecheck_partial_run_program-2362"><span class="linenos">2362</span></a>    <span class="n">programty</span> <span class="o">=</span> <span class="n">typecheck_program</span><span class="p">(</span><span class="n">program</span><span class="p">)</span>  <span class="c1"># (a1,  a2) -&gt; (b1, b2 )</span>
</span><span id="typecheck_partial_run_program-2363"><a href="#typecheck_partial_run_program-2363"><span class="linenos">2363</span></a>    <span class="n">program1ty</span> <span class="o">=</span> <span class="n">typecheck_program</span><span class="p">(</span><span class="n">program1</span><span class="p">)</span>  <span class="c1">#  a1       -&gt; (b1, res)</span>
</span><span id="typecheck_partial_run_program-2364"><a href="#typecheck_partial_run_program-2364"><span class="linenos">2364</span></a>    <span class="n">program2ty</span> <span class="o">=</span> <span class="n">typecheck_program</span><span class="p">(</span><span class="n">program2</span><span class="p">)</span>  <span class="c1"># (res, a2) -&gt; b2</span>
</span><span id="typecheck_partial_run_program-2365"><a href="#typecheck_partial_run_program-2365"><span class="linenos">2365</span></a>
</span><span id="typecheck_partial_run_program-2366"><a href="#typecheck_partial_run_program-2366"><span class="linenos">2366</span></a>    <span class="n">a1</span><span class="p">,</span> <span class="n">a2</span> <span class="o">=</span> <span class="n">partition_list</span><span class="p">(</span><span class="n">in_unknowns</span><span class="p">,</span> <span class="n">programty</span><span class="o">.</span><span class="n">in_types</span><span class="p">)</span>
</span><span id="typecheck_partial_run_program-2367"><a href="#typecheck_partial_run_program-2367"><span class="linenos">2367</span></a>    <span class="n">b1</span><span class="p">,</span> <span class="n">b2</span> <span class="o">=</span> <span class="n">partition_list</span><span class="p">(</span><span class="n">out_unknowns</span><span class="p">,</span> <span class="n">programty</span><span class="o">.</span><span class="n">out_types</span><span class="p">)</span>
</span><span id="typecheck_partial_run_program-2368"><a href="#typecheck_partial_run_program-2368"><span class="linenos">2368</span></a>    <span class="n">b1_</span><span class="p">,</span> <span class="n">res</span> <span class="o">=</span> <span class="n">split_list</span><span class="p">(</span><span class="n">program1ty</span><span class="o">.</span><span class="n">out_types</span><span class="p">,</span> <span class="nb">len</span><span class="p">(</span><span class="n">b1</span><span class="p">))</span>
</span><span id="typecheck_partial_run_program-2369"><a href="#typecheck_partial_run_program-2369"><span class="linenos">2369</span></a>    <span class="n">res_</span><span class="p">,</span> <span class="n">a2_</span> <span class="o">=</span> <span class="n">split_list</span><span class="p">(</span><span class="n">program2ty</span><span class="o">.</span><span class="n">in_types</span><span class="p">,</span> <span class="nb">len</span><span class="p">(</span><span class="n">res</span><span class="p">))</span>
</span><span id="typecheck_partial_run_program-2370"><a href="#typecheck_partial_run_program-2370"><span class="linenos">2370</span></a>    <span class="n">b2_</span> <span class="o">=</span> <span class="n">program2ty</span><span class="o">.</span><span class="n">out_types</span>
</span><span id="typecheck_partial_run_program-2371"><a href="#typecheck_partial_run_program-2371"><span class="linenos">2371</span></a>
</span><span id="typecheck_partial_run_program-2372"><a href="#typecheck_partial_run_program-2372"><span class="linenos">2372</span></a>    <span class="n">a1</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">a1</span><span class="p">)</span>
</span><span id="typecheck_partial_run_program-2373"><a href="#typecheck_partial_run_program-2373"><span class="linenos">2373</span></a>    <span class="n">a2</span><span class="p">,</span> <span class="n">a2_</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">a2</span><span class="p">),</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">a2_</span><span class="p">)</span>
</span><span id="typecheck_partial_run_program-2374"><a href="#typecheck_partial_run_program-2374"><span class="linenos">2374</span></a>    <span class="n">b1</span><span class="p">,</span> <span class="n">b1_</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">b1</span><span class="p">),</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">b1_</span><span class="p">)</span>
</span><span id="typecheck_partial_run_program-2375"><a href="#typecheck_partial_run_program-2375"><span class="linenos">2375</span></a>    <span class="n">b2</span><span class="p">,</span> <span class="n">b2_</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">b2</span><span class="p">),</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">b2_</span><span class="p">)</span>
</span><span id="typecheck_partial_run_program-2376"><a href="#typecheck_partial_run_program-2376"><span class="linenos">2376</span></a>    <span class="n">res</span><span class="p">,</span> <span class="n">res_</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">res</span><span class="p">),</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">res_</span><span class="p">)</span>
</span><span id="typecheck_partial_run_program-2377"><a href="#typecheck_partial_run_program-2377"><span class="linenos">2377</span></a>
</span><span id="typecheck_partial_run_program-2378"><a href="#typecheck_partial_run_program-2378"><span class="linenos">2378</span></a>    <span class="k">if</span> <span class="n">program1ty</span><span class="o">.</span><span class="n">in_types</span> <span class="o">!=</span> <span class="n">a1</span><span class="p">:</span>
</span><span id="typecheck_partial_run_program-2379"><a href="#typecheck_partial_run_program-2379"><span class="linenos">2379</span></a>        <span class="k">raise</span> <span class="ne">TypeError</span>
</span><span id="typecheck_partial_run_program-2380"><a href="#typecheck_partial_run_program-2380"><span class="linenos">2380</span></a>    <span class="k">if</span> <span class="n">program2ty</span><span class="o">.</span><span class="n">out_types</span> <span class="o">!=</span> <span class="n">b2</span><span class="p">:</span>
</span><span id="typecheck_partial_run_program-2381"><a href="#typecheck_partial_run_program-2381"><span class="linenos">2381</span></a>        <span class="k">raise</span> <span class="ne">TypeError</span>
</span><span id="typecheck_partial_run_program-2382"><a href="#typecheck_partial_run_program-2382"><span class="linenos">2382</span></a>    <span class="k">if</span> <span class="n">b1</span> <span class="o">!=</span> <span class="n">b1_</span><span class="p">:</span>
</span><span id="typecheck_partial_run_program-2383"><a href="#typecheck_partial_run_program-2383"><span class="linenos">2383</span></a>        <span class="k">raise</span> <span class="ne">TypeError</span>
</span><span id="typecheck_partial_run_program-2384"><a href="#typecheck_partial_run_program-2384"><span class="linenos">2384</span></a>    <span class="k">if</span> <span class="n">res</span> <span class="o">!=</span> <span class="n">res_</span><span class="p">:</span>
</span><span id="typecheck_partial_run_program-2385"><a href="#typecheck_partial_run_program-2385"><span class="linenos">2385</span></a>        <span class="k">raise</span> <span class="ne">TypeError</span>
</span><span id="typecheck_partial_run_program-2386"><a href="#typecheck_partial_run_program-2386"><span class="linenos">2386</span></a>    <span class="k">if</span> <span class="n">a2</span> <span class="o">!=</span> <span class="n">a2_</span><span class="p">:</span>
</span><span id="typecheck_partial_run_program-2387"><a href="#typecheck_partial_run_program-2387"><span class="linenos">2387</span></a>        <span class="k">raise</span> <span class="ne">TypeError</span>
</span><span id="typecheck_partial_run_program-2388"><a href="#typecheck_partial_run_program-2388"><span class="linenos">2388</span></a>    <span class="k">if</span> <span class="n">b2</span> <span class="o">!=</span> <span class="n">b2_</span><span class="p">:</span>
</span><span id="typecheck_partial_run_program-2389"><a href="#typecheck_partial_run_program-2389"><span class="linenos">2389</span></a>        <span class="k">raise</span> <span class="ne">TypeError</span>
</span></pre></div>


    

                </section>
                <section id="linearize_flat">
                            <input id="linearize_flat-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">linearize_flat</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">f</span>, </span><span class="param"><span class="o">*</span><span class="n">primals_in</span>, </span><span class="param"><span class="n">has_aux</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="linearize_flat-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#linearize_flat"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="linearize_flat-2392"><a href="#linearize_flat-2392"><span class="linenos">2392</span></a><span class="k">def</span> <span class="nf">linearize_flat</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="o">*</span><span class="n">primals_in</span><span class="p">,</span> <span class="n">has_aux</span><span class="p">):</span>
</span><span id="linearize_flat-2393"><a href="#linearize_flat-2393"><span class="linenos">2393</span></a>    <span class="n">pvals_in</span> <span class="o">=</span> <span class="p">[</span><span class="n">make_known_pval</span><span class="p">(</span><span class="n">x</span><span class="p">)</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">primals_in</span><span class="p">]</span> <span class="o">+</span> <span class="p">[</span><span class="n">make_unknown_pval</span><span class="p">(</span><span class="n">SymbolicTensor</span><span class="o">.</span><span class="n">like</span><span class="p">(</span><span class="n">get_symval</span><span class="p">(</span><span class="n">x</span><span class="p">)))</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">primals_in</span><span class="p">]</span>
</span><span id="linearize_flat-2394"><a href="#linearize_flat-2394"><span class="linenos">2394</span></a>
</span><span id="linearize_flat-2395"><a href="#linearize_flat-2395"><span class="linenos">2395</span></a>    <span class="k">def</span> <span class="nf">f_jvp</span><span class="p">(</span><span class="o">*</span><span class="n">primals_tangents_in</span><span class="p">):</span>
</span><span id="linearize_flat-2396"><a href="#linearize_flat-2396"><span class="linenos">2396</span></a>        <span class="n">jvp_ret</span> <span class="o">=</span> <span class="n">jvp</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="o">*</span><span class="n">split_half</span><span class="p">(</span><span class="n">primals_tangents_in</span><span class="p">),</span> <span class="n">has_aux</span><span class="o">=</span><span class="n">has_aux</span><span class="p">)</span>
</span><span id="linearize_flat-2397"><a href="#linearize_flat-2397"><span class="linenos">2397</span></a>        <span class="k">if</span> <span class="n">has_aux</span><span class="p">:</span>
</span><span id="linearize_flat-2398"><a href="#linearize_flat-2398"><span class="linenos">2398</span></a>            <span class="p">(</span><span class="n">primals_out</span><span class="p">,</span> <span class="n">tangents_out</span><span class="p">),</span> <span class="n">aux</span> <span class="o">=</span> <span class="n">jvp_ret</span>
</span><span id="linearize_flat-2399"><a href="#linearize_flat-2399"><span class="linenos">2399</span></a>            <span class="k">return</span> <span class="p">((</span><span class="o">*</span><span class="n">primals_out</span><span class="p">,</span> <span class="o">*</span><span class="n">tangents_out</span><span class="p">),</span> <span class="n">aux</span><span class="p">)</span>
</span><span id="linearize_flat-2400"><a href="#linearize_flat-2400"><span class="linenos">2400</span></a>        <span class="k">else</span><span class="p">:</span>
</span><span id="linearize_flat-2401"><a href="#linearize_flat-2401"><span class="linenos">2401</span></a>            <span class="n">primals_out</span><span class="p">,</span> <span class="n">tangents_out</span> <span class="o">=</span> <span class="n">jvp_ret</span>
</span><span id="linearize_flat-2402"><a href="#linearize_flat-2402"><span class="linenos">2402</span></a>            <span class="k">return</span> <span class="p">(</span><span class="o">*</span><span class="n">primals_out</span><span class="p">,</span> <span class="o">*</span><span class="n">tangents_out</span><span class="p">)</span>
</span><span id="linearize_flat-2403"><a href="#linearize_flat-2403"><span class="linenos">2403</span></a>
</span><span id="linearize_flat-2404"><a href="#linearize_flat-2404"><span class="linenos">2404</span></a>    <span class="n">partial_run_flat_ret</span> <span class="o">=</span> <span class="n">partial_run_flat</span><span class="p">(</span><span class="n">f_jvp</span><span class="p">,</span> <span class="n">pvals_in</span><span class="p">,</span> <span class="n">has_aux</span><span class="p">)</span>
</span><span id="linearize_flat-2405"><a href="#linearize_flat-2405"><span class="linenos">2405</span></a>    <span class="k">if</span> <span class="n">has_aux</span><span class="p">:</span>
</span><span id="linearize_flat-2406"><a href="#linearize_flat-2406"><span class="linenos">2406</span></a>        <span class="n">program</span><span class="p">,</span> <span class="n">pvals_out</span><span class="p">,</span> <span class="n">consts</span><span class="p">,</span> <span class="n">aux</span> <span class="o">=</span> <span class="n">partial_run_flat_ret</span>
</span><span id="linearize_flat-2407"><a href="#linearize_flat-2407"><span class="linenos">2407</span></a>    <span class="k">else</span><span class="p">:</span>
</span><span id="linearize_flat-2408"><a href="#linearize_flat-2408"><span class="linenos">2408</span></a>        <span class="n">program</span><span class="p">,</span> <span class="n">pvals_out</span><span class="p">,</span> <span class="n">consts</span> <span class="o">=</span> <span class="n">partial_run_flat_ret</span>
</span><span id="linearize_flat-2409"><a href="#linearize_flat-2409"><span class="linenos">2409</span></a>    <span class="n">primal_pvals</span><span class="p">,</span> <span class="n">_</span> <span class="o">=</span> <span class="n">split_half</span><span class="p">(</span><span class="n">pvals_out</span><span class="p">)</span>
</span><span id="linearize_flat-2410"><a href="#linearize_flat-2410"><span class="linenos">2410</span></a>    <span class="k">assert</span> <span class="nb">all</span><span class="p">(</span><span class="n">pval</span><span class="o">.</span><span class="n">is_known</span> <span class="k">for</span> <span class="n">pval</span> <span class="ow">in</span> <span class="n">primal_pvals</span><span class="p">)</span>
</span><span id="linearize_flat-2411"><a href="#linearize_flat-2411"><span class="linenos">2411</span></a>    <span class="n">primals_out</span> <span class="o">=</span> <span class="p">[</span><span class="n">pval</span><span class="o">.</span><span class="n">const</span> <span class="k">for</span> <span class="n">pval</span> <span class="ow">in</span> <span class="n">primal_pvals</span><span class="p">]</span>
</span><span id="linearize_flat-2412"><a href="#linearize_flat-2412"><span class="linenos">2412</span></a>    <span class="n">f_lin</span> <span class="o">=</span> <span class="k">lambda</span> <span class="o">*</span><span class="n">tangents</span><span class="p">:</span> <span class="n">run_program</span><span class="p">(</span><span class="n">program</span><span class="p">,</span> <span class="p">[</span><span class="o">*</span><span class="n">consts</span><span class="p">,</span> <span class="o">*</span><span class="n">tangents</span><span class="p">])</span>
</span><span id="linearize_flat-2413"><a href="#linearize_flat-2413"><span class="linenos">2413</span></a>    <span class="k">return</span> <span class="p">(</span><span class="n">primals_out</span><span class="p">,</span> <span class="n">f_lin</span><span class="p">,</span> <span class="n">aux</span><span class="p">)</span> <span class="k">if</span> <span class="n">has_aux</span> <span class="k">else</span> <span class="p">(</span><span class="n">primals_out</span><span class="p">,</span> <span class="n">f_lin</span><span class="p">)</span>
</span></pre></div>


    

                </section>
                <section id="linearize">
                            <input id="linearize-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">linearize</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">f</span>, </span><span class="param"><span class="o">*</span><span class="n">primals_in</span>, </span><span class="param"><span class="n">has_aux</span><span class="o">=</span><span class="kc">False</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="linearize-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#linearize"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="linearize-2416"><a href="#linearize-2416"><span class="linenos">2416</span></a><span class="k">def</span> <span class="nf">linearize</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="o">*</span><span class="n">primals_in</span><span class="p">,</span> <span class="n">has_aux</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>
</span><span id="linearize-2417"><a href="#linearize-2417"><span class="linenos">2417</span></a>    <span class="n">primals_in_flat</span><span class="p">,</span> <span class="n">in_tree</span> <span class="o">=</span> <span class="n">tree_flatten</span><span class="p">(</span><span class="n">primals_in</span><span class="p">)</span>
</span><span id="linearize-2418"><a href="#linearize-2418"><span class="linenos">2418</span></a>    <span class="n">f</span><span class="p">,</span> <span class="n">out_tree_store</span> <span class="o">=</span> <span class="n">flatten_fn</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="n">in_tree</span><span class="p">,</span> <span class="n">has_aux</span><span class="o">=</span><span class="n">has_aux</span><span class="p">)</span>
</span><span id="linearize-2419"><a href="#linearize-2419"><span class="linenos">2419</span></a>    <span class="n">linearize_flat_ret</span> <span class="o">=</span> <span class="n">linearize_flat</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="o">*</span><span class="n">primals_in_flat</span><span class="p">,</span> <span class="n">has_aux</span><span class="o">=</span><span class="n">has_aux</span><span class="p">)</span>
</span><span id="linearize-2420"><a href="#linearize-2420"><span class="linenos">2420</span></a>    <span class="k">if</span> <span class="n">has_aux</span><span class="p">:</span>
</span><span id="linearize-2421"><a href="#linearize-2421"><span class="linenos">2421</span></a>        <span class="n">primals_out_flat</span><span class="p">,</span> <span class="n">f_lin_flat</span><span class="p">,</span> <span class="n">aux</span> <span class="o">=</span> <span class="n">linearize_flat_ret</span>
</span><span id="linearize-2422"><a href="#linearize-2422"><span class="linenos">2422</span></a>    <span class="k">else</span><span class="p">:</span>
</span><span id="linearize-2423"><a href="#linearize-2423"><span class="linenos">2423</span></a>        <span class="n">primals_out_flat</span><span class="p">,</span> <span class="n">f_lin_flat</span> <span class="o">=</span> <span class="n">linearize_flat_ret</span>
</span><span id="linearize-2424"><a href="#linearize-2424"><span class="linenos">2424</span></a>
</span><span id="linearize-2425"><a href="#linearize-2425"><span class="linenos">2425</span></a>    <span class="n">primals_out</span> <span class="o">=</span> <span class="n">tree_unflatten</span><span class="p">(</span><span class="n">out_tree_store</span><span class="p">(),</span> <span class="n">primals_out_flat</span><span class="p">)</span>
</span><span id="linearize-2426"><a href="#linearize-2426"><span class="linenos">2426</span></a>
</span><span id="linearize-2427"><a href="#linearize-2427"><span class="linenos">2427</span></a>    <span class="k">def</span> <span class="nf">f_lin</span><span class="p">(</span><span class="o">*</span><span class="n">tangents_in</span><span class="p">):</span>
</span><span id="linearize-2428"><a href="#linearize-2428"><span class="linenos">2428</span></a>        <span class="n">tangents_in_flat</span><span class="p">,</span> <span class="n">in_tree2</span> <span class="o">=</span> <span class="n">tree_flatten</span><span class="p">(</span><span class="n">tangents_in</span><span class="p">)</span>
</span><span id="linearize-2429"><a href="#linearize-2429"><span class="linenos">2429</span></a>        <span class="k">if</span> <span class="n">in_tree</span> <span class="o">!=</span> <span class="n">in_tree2</span><span class="p">:</span>
</span><span id="linearize-2430"><a href="#linearize-2430"><span class="linenos">2430</span></a>            <span class="k">raise</span> <span class="ne">TypeError</span>
</span><span id="linearize-2431"><a href="#linearize-2431"><span class="linenos">2431</span></a>        <span class="n">tangents_out_flat</span> <span class="o">=</span> <span class="n">f_lin_flat</span><span class="p">(</span><span class="o">*</span><span class="n">tangents_in_flat</span><span class="p">)</span>
</span><span id="linearize-2432"><a href="#linearize-2432"><span class="linenos">2432</span></a>        <span class="k">return</span> <span class="n">tree_unflatten</span><span class="p">(</span><span class="n">out_tree_store</span><span class="p">(),</span> <span class="n">tangents_out_flat</span><span class="p">)</span>
</span><span id="linearize-2433"><a href="#linearize-2433"><span class="linenos">2433</span></a>
</span><span id="linearize-2434"><a href="#linearize-2434"><span class="linenos">2434</span></a>    <span class="k">return</span> <span class="p">(</span><span class="n">primals_out</span><span class="p">,</span> <span class="n">f_lin</span><span class="p">,</span> <span class="n">aux</span><span class="p">)</span> <span class="k">if</span> <span class="n">has_aux</span> <span class="k">else</span> <span class="p">(</span><span class="n">primals_out</span><span class="p">,</span> <span class="n">f_lin</span><span class="p">)</span>
</span></pre></div>


    

                </section>
                <section id="tracers_to_program">
                            <input id="tracers_to_program-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">tracers_to_program</span><span class="signature pdoc-code multiline">(<span class="param">	<span class="n">tracers_in</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n"><a href="#PartialRunTraceTensor">PartialRunTraceTensor</a></span><span class="p">]</span>,</span><span class="param">	<span class="n">tracers_out</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n"><a href="#PartialRunTraceTensor">PartialRunTraceTensor</a></span><span class="p">]</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="tracers_to_program-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#tracers_to_program"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="tracers_to_program-2437"><a href="#tracers_to_program-2437"><span class="linenos">2437</span></a><span class="k">def</span> <span class="nf">tracers_to_program</span><span class="p">(</span>
</span><span id="tracers_to_program-2438"><a href="#tracers_to_program-2438"><span class="linenos">2438</span></a>    <span class="n">tracers_in</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="s2">&quot;PartialRunTraceTensor&quot;</span><span class="p">],</span>
</span><span id="tracers_to_program-2439"><a href="#tracers_to_program-2439"><span class="linenos">2439</span></a>    <span class="n">tracers_out</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="s2">&quot;PartialRunTraceTensor&quot;</span><span class="p">],</span>
</span><span id="tracers_to_program-2440"><a href="#tracers_to_program-2440"><span class="linenos">2440</span></a><span class="p">):</span>
</span><span id="tracers_to_program-2441"><a href="#tracers_to_program-2441"><span class="linenos">2441</span></a>    <span class="k">def</span> <span class="nf">tracer_parents</span><span class="p">(</span><span class="n">t</span><span class="p">:</span> <span class="n">PartialRunTraceTensor</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">List</span><span class="p">[</span><span class="n">PartialRunTraceTensor</span><span class="p">]:</span>
</span><span id="tracers_to_program-2442"><a href="#tracers_to_program-2442"><span class="linenos">2442</span></a>        <span class="k">return</span> <span class="n">t</span><span class="o">.</span><span class="n">draft</span><span class="o">.</span><span class="n">tracers_in</span> <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">t</span><span class="o">.</span><span class="n">draft</span><span class="p">,</span> <span class="n">InstructionDraft</span><span class="p">)</span> <span class="k">else</span> <span class="p">[]</span>
</span><span id="tracers_to_program-2443"><a href="#tracers_to_program-2443"><span class="linenos">2443</span></a>
</span><span id="tracers_to_program-2444"><a href="#tracers_to_program-2444"><span class="linenos">2444</span></a>    <span class="k">def</span> <span class="nf">draft_to_instruction</span><span class="p">(</span><span class="n">tracer_to_var</span><span class="p">:</span> <span class="n">Dict</span><span class="p">[</span><span class="nb">int</span><span class="p">,</span> <span class="n">Var</span><span class="p">],</span> <span class="n">draft</span><span class="p">:</span> <span class="n">InstructionDraft</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Instruction</span><span class="p">:</span>
</span><span id="tracers_to_program-2445"><a href="#tracers_to_program-2445"><span class="linenos">2445</span></a>        <span class="n">inputs</span> <span class="o">=</span> <span class="p">[</span><span class="n">tracer_to_var</span><span class="p">[</span><span class="nb">id</span><span class="p">(</span><span class="n">t</span><span class="p">)]</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">draft</span><span class="o">.</span><span class="n">tracers_in</span><span class="p">]</span>
</span><span id="tracers_to_program-2446"><a href="#tracers_to_program-2446"><span class="linenos">2446</span></a>        <span class="n">out_binders</span> <span class="o">=</span> <span class="p">[</span><span class="n">Var</span><span class="p">(</span><span class="n">symval</span><span class="p">)</span> <span class="k">for</span> <span class="n">symval</span> <span class="ow">in</span> <span class="n">draft</span><span class="o">.</span><span class="n">symvals_out</span><span class="p">]</span>
</span><span id="tracers_to_program-2447"><a href="#tracers_to_program-2447"><span class="linenos">2447</span></a>        <span class="k">for</span> <span class="n">t_ref</span><span class="p">,</span> <span class="n">var</span> <span class="ow">in</span> <span class="n">list_zip</span><span class="p">(</span><span class="n">draft</span><span class="o">.</span><span class="n">tracer_refs_out</span><span class="p">,</span> <span class="n">out_binders</span><span class="p">):</span>
</span><span id="tracers_to_program-2448"><a href="#tracers_to_program-2448"><span class="linenos">2448</span></a>            <span class="k">if</span> <span class="n">t_ref</span><span class="p">()</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
</span><span id="tracers_to_program-2449"><a href="#tracers_to_program-2449"><span class="linenos">2449</span></a>                <span class="n">tracer_to_var</span><span class="p">[</span><span class="nb">id</span><span class="p">(</span><span class="n">t_ref</span><span class="p">())]</span> <span class="o">=</span> <span class="n">var</span>
</span><span id="tracers_to_program-2450"><a href="#tracers_to_program-2450"><span class="linenos">2450</span></a>        <span class="k">return</span> <span class="n">Instruction</span><span class="p">(</span><span class="n">draft</span><span class="o">.</span><span class="n">prim</span><span class="p">,</span> <span class="n">inputs</span><span class="p">,</span> <span class="n">draft</span><span class="o">.</span><span class="n">params</span><span class="p">,</span> <span class="n">out_binders</span><span class="p">)</span>
</span><span id="tracers_to_program-2451"><a href="#tracers_to_program-2451"><span class="linenos">2451</span></a>
</span><span id="tracers_to_program-2452"><a href="#tracers_to_program-2452"><span class="linenos">2452</span></a>    <span class="n">tracer_to_var</span><span class="p">:</span> <span class="n">Dict</span><span class="p">[</span><span class="nb">int</span><span class="p">,</span> <span class="n">Var</span><span class="p">]</span> <span class="o">=</span> <span class="p">{</span><span class="nb">id</span><span class="p">(</span><span class="n">t</span><span class="p">):</span> <span class="n">Var</span><span class="p">(</span><span class="n">SymbolicTensor</span><span class="o">.</span><span class="n">like</span><span class="p">(</span><span class="n">t</span><span class="o">.</span><span class="n">symval</span><span class="p">))</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">tracers_in</span><span class="p">}</span>
</span><span id="tracers_to_program-2453"><a href="#tracers_to_program-2453"><span class="linenos">2453</span></a>    <span class="n">constvar_to_val</span><span class="p">:</span> <span class="n">Dict</span><span class="p">[</span><span class="nb">int</span><span class="p">,</span> <span class="n">Any</span><span class="p">]</span> <span class="o">=</span> <span class="p">{}</span>
</span><span id="tracers_to_program-2454"><a href="#tracers_to_program-2454"><span class="linenos">2454</span></a>    <span class="n">constid_to_var</span><span class="p">:</span> <span class="n">Dict</span><span class="p">[</span><span class="nb">int</span><span class="p">,</span> <span class="n">Var</span><span class="p">]</span> <span class="o">=</span> <span class="p">{}</span>
</span><span id="tracers_to_program-2455"><a href="#tracers_to_program-2455"><span class="linenos">2455</span></a>    <span class="n">processed_instructions</span><span class="p">:</span> <span class="n">Set</span><span class="p">[</span><span class="nb">int</span><span class="p">]</span> <span class="o">=</span> <span class="nb">set</span><span class="p">()</span>
</span><span id="tracers_to_program-2456"><a href="#tracers_to_program-2456"><span class="linenos">2456</span></a>    <span class="n">instructions</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">Instruction</span><span class="p">]</span> <span class="o">=</span> <span class="p">[]</span>
</span><span id="tracers_to_program-2457"><a href="#tracers_to_program-2457"><span class="linenos">2457</span></a>    <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">toposort</span><span class="p">(</span><span class="n">tracers_out</span><span class="p">,</span> <span class="n">tracer_parents</span><span class="p">):</span>
</span><span id="tracers_to_program-2458"><a href="#tracers_to_program-2458"><span class="linenos">2458</span></a>        <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">t</span><span class="o">.</span><span class="n">draft</span><span class="p">,</span> <span class="n">LambdaBindingDraft</span><span class="p">):</span>
</span><span id="tracers_to_program-2459"><a href="#tracers_to_program-2459"><span class="linenos">2459</span></a>            <span class="k">assert</span> <span class="nb">id</span><span class="p">(</span><span class="n">t</span><span class="p">)</span> <span class="ow">in</span> <span class="nb">set</span><span class="p">(</span><span class="n">list_map</span><span class="p">(</span><span class="nb">id</span><span class="p">,</span> <span class="n">tracers_in</span><span class="p">))</span>
</span><span id="tracers_to_program-2460"><a href="#tracers_to_program-2460"><span class="linenos">2460</span></a>        <span class="k">elif</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">t</span><span class="o">.</span><span class="n">draft</span><span class="p">,</span> <span class="n">ConstDraft</span><span class="p">):</span>
</span><span id="tracers_to_program-2461"><a href="#tracers_to_program-2461"><span class="linenos">2461</span></a>            <span class="n">val</span> <span class="o">=</span> <span class="n">t</span><span class="o">.</span><span class="n">draft</span><span class="o">.</span><span class="n">val</span>
</span><span id="tracers_to_program-2462"><a href="#tracers_to_program-2462"><span class="linenos">2462</span></a>            <span class="n">var</span> <span class="o">=</span> <span class="n">constid_to_var</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="nb">id</span><span class="p">(</span><span class="n">val</span><span class="p">))</span>
</span><span id="tracers_to_program-2463"><a href="#tracers_to_program-2463"><span class="linenos">2463</span></a>            <span class="k">if</span> <span class="n">var</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
</span><span id="tracers_to_program-2464"><a href="#tracers_to_program-2464"><span class="linenos">2464</span></a>                <span class="n">symval</span> <span class="o">=</span> <span class="n">SymbolicTensor</span><span class="o">.</span><span class="n">like</span><span class="p">(</span><span class="n">get_symval</span><span class="p">(</span><span class="n">val</span><span class="p">))</span>
</span><span id="tracers_to_program-2465"><a href="#tracers_to_program-2465"><span class="linenos">2465</span></a>                <span class="n">var</span> <span class="o">=</span> <span class="n">constid_to_var</span><span class="p">[</span><span class="nb">id</span><span class="p">(</span><span class="n">val</span><span class="p">)]</span> <span class="o">=</span> <span class="n">Var</span><span class="p">(</span><span class="n">symval</span><span class="p">)</span>
</span><span id="tracers_to_program-2466"><a href="#tracers_to_program-2466"><span class="linenos">2466</span></a>                <span class="n">constvar_to_val</span><span class="p">[</span><span class="n">var</span><span class="p">]</span> <span class="o">=</span> <span class="n">val</span>
</span><span id="tracers_to_program-2467"><a href="#tracers_to_program-2467"><span class="linenos">2467</span></a>            <span class="n">tracer_to_var</span><span class="p">[</span><span class="nb">id</span><span class="p">(</span><span class="n">t</span><span class="p">)]</span> <span class="o">=</span> <span class="n">var</span>
</span><span id="tracers_to_program-2468"><a href="#tracers_to_program-2468"><span class="linenos">2468</span></a>        <span class="k">elif</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">t</span><span class="o">.</span><span class="n">draft</span><span class="p">,</span> <span class="n">InstructionDraft</span><span class="p">):</span>
</span><span id="tracers_to_program-2469"><a href="#tracers_to_program-2469"><span class="linenos">2469</span></a>            <span class="k">if</span> <span class="nb">id</span><span class="p">(</span><span class="n">t</span><span class="o">.</span><span class="n">draft</span><span class="p">)</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">processed_instructions</span><span class="p">:</span>
</span><span id="tracers_to_program-2470"><a href="#tracers_to_program-2470"><span class="linenos">2470</span></a>                <span class="n">instructions</span> <span class="o">+=</span> <span class="p">[</span><span class="n">draft_to_instruction</span><span class="p">(</span><span class="n">tracer_to_var</span><span class="p">,</span> <span class="n">t</span><span class="o">.</span><span class="n">draft</span><span class="p">)]</span>
</span><span id="tracers_to_program-2471"><a href="#tracers_to_program-2471"><span class="linenos">2471</span></a>                <span class="n">processed_instructions</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="nb">id</span><span class="p">(</span><span class="n">t</span><span class="o">.</span><span class="n">draft</span><span class="p">))</span>
</span><span id="tracers_to_program-2472"><a href="#tracers_to_program-2472"><span class="linenos">2472</span></a>        <span class="k">else</span><span class="p">:</span>
</span><span id="tracers_to_program-2473"><a href="#tracers_to_program-2473"><span class="linenos">2473</span></a>            <span class="k">raise</span> <span class="ne">TypeError</span><span class="p">(</span><span class="n">t</span><span class="o">.</span><span class="n">draft</span><span class="p">)</span>
</span><span id="tracers_to_program-2474"><a href="#tracers_to_program-2474"><span class="linenos">2474</span></a>
</span><span id="tracers_to_program-2475"><a href="#tracers_to_program-2475"><span class="linenos">2475</span></a>    <span class="n">constvars</span><span class="p">,</span> <span class="n">constvals</span> <span class="o">=</span> <span class="n">unzip2</span><span class="p">(</span><span class="n">constvar_to_val</span><span class="o">.</span><span class="n">items</span><span class="p">())</span>
</span><span id="tracers_to_program-2476"><a href="#tracers_to_program-2476"><span class="linenos">2476</span></a>    <span class="n">in_binders</span> <span class="o">=</span> <span class="n">constvars</span> <span class="o">+</span> <span class="p">[</span><span class="n">tracer_to_var</span><span class="p">[</span><span class="nb">id</span><span class="p">(</span><span class="n">t</span><span class="p">)]</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">tracers_in</span><span class="p">]</span>
</span><span id="tracers_to_program-2477"><a href="#tracers_to_program-2477"><span class="linenos">2477</span></a>    <span class="c1"># out_vars = [tracer_to_var[id(t)] for t in tracers_out if id(t) in tracer_to_var]</span>
</span><span id="tracers_to_program-2478"><a href="#tracers_to_program-2478"><span class="linenos">2478</span></a>    <span class="n">out_vars</span> <span class="o">=</span> <span class="p">[</span><span class="n">tracer_to_var</span><span class="p">[</span><span class="nb">id</span><span class="p">(</span><span class="n">t</span><span class="p">)]</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">tracers_out</span><span class="p">]</span>
</span><span id="tracers_to_program-2479"><a href="#tracers_to_program-2479"><span class="linenos">2479</span></a>    <span class="n">program</span> <span class="o">=</span> <span class="n">Program</span><span class="p">(</span><span class="nb">tuple</span><span class="p">(</span><span class="n">in_binders</span><span class="p">),</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">instructions</span><span class="p">),</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">out_vars</span><span class="p">))</span>
</span><span id="tracers_to_program-2480"><a href="#tracers_to_program-2480"><span class="linenos">2480</span></a>    <span class="n">typecheck_program</span><span class="p">(</span><span class="n">program</span><span class="p">)</span>
</span><span id="tracers_to_program-2481"><a href="#tracers_to_program-2481"><span class="linenos">2481</span></a>    <span class="k">return</span> <span class="n">program</span><span class="p">,</span> <span class="n">constvals</span>
</span></pre></div>


    

                </section>
                <section id="toposort">
                            <input id="toposort-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">toposort</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">out_nodes</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">]</span>, </span><span class="param"><span class="n">parents</span><span class="p">:</span> <span class="n">Callable</span><span class="p">[[</span><span class="n">Any</span><span class="p">],</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">]]</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="toposort-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#toposort"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="toposort-2484"><a href="#toposort-2484"><span class="linenos">2484</span></a><span class="k">def</span> <span class="nf">toposort</span><span class="p">(</span><span class="n">out_nodes</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">],</span> <span class="n">parents</span><span class="p">:</span> <span class="n">Callable</span><span class="p">[[</span><span class="n">Any</span><span class="p">],</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">]]):</span>
</span><span id="toposort-2485"><a href="#toposort-2485"><span class="linenos">2485</span></a>    <span class="k">def</span> <span class="nf">check_toposort</span><span class="p">(</span><span class="n">nodes</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">],</span> <span class="n">parents</span><span class="p">:</span> <span class="n">Callable</span><span class="p">[[</span><span class="n">Any</span><span class="p">],</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">]]):</span>
</span><span id="toposort-2486"><a href="#toposort-2486"><span class="linenos">2486</span></a>        <span class="n">seen</span> <span class="o">=</span> <span class="nb">set</span><span class="p">()</span>
</span><span id="toposort-2487"><a href="#toposort-2487"><span class="linenos">2487</span></a>        <span class="k">for</span> <span class="n">node</span> <span class="ow">in</span> <span class="n">nodes</span><span class="p">:</span>
</span><span id="toposort-2488"><a href="#toposort-2488"><span class="linenos">2488</span></a>            <span class="k">assert</span> <span class="nb">all</span><span class="p">(</span><span class="nb">id</span><span class="p">(</span><span class="n">parent</span><span class="p">)</span> <span class="ow">in</span> <span class="n">seen</span> <span class="k">for</span> <span class="n">parent</span> <span class="ow">in</span> <span class="n">parents</span><span class="p">(</span><span class="n">node</span><span class="p">))</span>
</span><span id="toposort-2489"><a href="#toposort-2489"><span class="linenos">2489</span></a>            <span class="n">seen</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="nb">id</span><span class="p">(</span><span class="n">node</span><span class="p">))</span>
</span><span id="toposort-2490"><a href="#toposort-2490"><span class="linenos">2490</span></a>
</span><span id="toposort-2491"><a href="#toposort-2491"><span class="linenos">2491</span></a>    <span class="k">def</span> <span class="nf">remove_duplicates</span><span class="p">(</span><span class="n">lst</span><span class="p">):</span>
</span><span id="toposort-2492"><a href="#toposort-2492"><span class="linenos">2492</span></a>        <span class="n">seen</span> <span class="o">=</span> <span class="nb">set</span><span class="p">()</span>
</span><span id="toposort-2493"><a href="#toposort-2493"><span class="linenos">2493</span></a>        <span class="k">return</span> <span class="p">[</span><span class="n">x</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">lst</span> <span class="k">if</span> <span class="nb">id</span><span class="p">(</span><span class="n">x</span><span class="p">)</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">seen</span> <span class="ow">and</span> <span class="ow">not</span> <span class="n">seen</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="nb">id</span><span class="p">(</span><span class="n">x</span><span class="p">))]</span>
</span><span id="toposort-2494"><a href="#toposort-2494"><span class="linenos">2494</span></a>
</span><span id="toposort-2495"><a href="#toposort-2495"><span class="linenos">2495</span></a>    <span class="k">if</span> <span class="ow">not</span> <span class="n">out_nodes</span><span class="p">:</span>
</span><span id="toposort-2496"><a href="#toposort-2496"><span class="linenos">2496</span></a>        <span class="k">return</span> <span class="p">[]</span>
</span><span id="toposort-2497"><a href="#toposort-2497"><span class="linenos">2497</span></a>    <span class="n">out_nodes</span> <span class="o">=</span> <span class="n">remove_duplicates</span><span class="p">(</span><span class="n">out_nodes</span><span class="p">)</span>
</span><span id="toposort-2498"><a href="#toposort-2498"><span class="linenos">2498</span></a>
</span><span id="toposort-2499"><a href="#toposort-2499"><span class="linenos">2499</span></a>    <span class="n">child_counts</span> <span class="o">=</span> <span class="p">{}</span>
</span><span id="toposort-2500"><a href="#toposort-2500"><span class="linenos">2500</span></a>    <span class="n">stack</span> <span class="o">=</span> <span class="nb">list</span><span class="p">(</span><span class="n">out_nodes</span><span class="p">)</span>
</span><span id="toposort-2501"><a href="#toposort-2501"><span class="linenos">2501</span></a>    <span class="k">while</span> <span class="n">stack</span><span class="p">:</span>
</span><span id="toposort-2502"><a href="#toposort-2502"><span class="linenos">2502</span></a>        <span class="n">node</span> <span class="o">=</span> <span class="n">stack</span><span class="o">.</span><span class="n">pop</span><span class="p">()</span>
</span><span id="toposort-2503"><a href="#toposort-2503"><span class="linenos">2503</span></a>        <span class="k">if</span> <span class="nb">id</span><span class="p">(</span><span class="n">node</span><span class="p">)</span> <span class="ow">in</span> <span class="n">child_counts</span><span class="p">:</span>
</span><span id="toposort-2504"><a href="#toposort-2504"><span class="linenos">2504</span></a>            <span class="n">child_counts</span><span class="p">[</span><span class="nb">id</span><span class="p">(</span><span class="n">node</span><span class="p">)]</span> <span class="o">+=</span> <span class="mi">1</span>
</span><span id="toposort-2505"><a href="#toposort-2505"><span class="linenos">2505</span></a>        <span class="k">else</span><span class="p">:</span>
</span><span id="toposort-2506"><a href="#toposort-2506"><span class="linenos">2506</span></a>            <span class="n">child_counts</span><span class="p">[</span><span class="nb">id</span><span class="p">(</span><span class="n">node</span><span class="p">)]</span> <span class="o">=</span> <span class="mi">1</span>
</span><span id="toposort-2507"><a href="#toposort-2507"><span class="linenos">2507</span></a>            <span class="n">stack</span><span class="o">.</span><span class="n">extend</span><span class="p">(</span><span class="n">parents</span><span class="p">(</span><span class="n">node</span><span class="p">))</span>
</span><span id="toposort-2508"><a href="#toposort-2508"><span class="linenos">2508</span></a>    <span class="k">for</span> <span class="n">node</span> <span class="ow">in</span> <span class="n">out_nodes</span><span class="p">:</span>
</span><span id="toposort-2509"><a href="#toposort-2509"><span class="linenos">2509</span></a>        <span class="n">child_counts</span><span class="p">[</span><span class="nb">id</span><span class="p">(</span><span class="n">node</span><span class="p">)]</span> <span class="o">-=</span> <span class="mi">1</span>
</span><span id="toposort-2510"><a href="#toposort-2510"><span class="linenos">2510</span></a>
</span><span id="toposort-2511"><a href="#toposort-2511"><span class="linenos">2511</span></a>    <span class="n">sorted_nodes</span> <span class="o">=</span> <span class="p">[]</span>
</span><span id="toposort-2512"><a href="#toposort-2512"><span class="linenos">2512</span></a>    <span class="n">childless_nodes</span> <span class="o">=</span> <span class="p">[</span><span class="n">node</span> <span class="k">for</span> <span class="n">node</span> <span class="ow">in</span> <span class="n">out_nodes</span> <span class="k">if</span> <span class="ow">not</span> <span class="n">child_counts</span><span class="p">[</span><span class="nb">id</span><span class="p">(</span><span class="n">node</span><span class="p">)]]</span>
</span><span id="toposort-2513"><a href="#toposort-2513"><span class="linenos">2513</span></a>    <span class="k">while</span> <span class="n">childless_nodes</span><span class="p">:</span>
</span><span id="toposort-2514"><a href="#toposort-2514"><span class="linenos">2514</span></a>        <span class="n">node</span> <span class="o">=</span> <span class="n">childless_nodes</span><span class="o">.</span><span class="n">pop</span><span class="p">()</span>
</span><span id="toposort-2515"><a href="#toposort-2515"><span class="linenos">2515</span></a>        <span class="n">sorted_nodes</span> <span class="o">+=</span> <span class="p">[</span><span class="n">node</span><span class="p">]</span>
</span><span id="toposort-2516"><a href="#toposort-2516"><span class="linenos">2516</span></a>        <span class="k">for</span> <span class="n">parent</span> <span class="ow">in</span> <span class="n">parents</span><span class="p">(</span><span class="n">node</span><span class="p">):</span>
</span><span id="toposort-2517"><a href="#toposort-2517"><span class="linenos">2517</span></a>            <span class="k">if</span> <span class="n">child_counts</span><span class="p">[</span><span class="nb">id</span><span class="p">(</span><span class="n">parent</span><span class="p">)]</span> <span class="o">==</span> <span class="mi">1</span><span class="p">:</span>
</span><span id="toposort-2518"><a href="#toposort-2518"><span class="linenos">2518</span></a>                <span class="n">childless_nodes</span> <span class="o">+=</span> <span class="p">[</span><span class="n">parent</span><span class="p">]</span>
</span><span id="toposort-2519"><a href="#toposort-2519"><span class="linenos">2519</span></a>            <span class="k">else</span><span class="p">:</span>
</span><span id="toposort-2520"><a href="#toposort-2520"><span class="linenos">2520</span></a>                <span class="n">child_counts</span><span class="p">[</span><span class="nb">id</span><span class="p">(</span><span class="n">parent</span><span class="p">)]</span> <span class="o">-=</span> <span class="mi">1</span>
</span><span id="toposort-2521"><a href="#toposort-2521"><span class="linenos">2521</span></a>
</span><span id="toposort-2522"><a href="#toposort-2522"><span class="linenos">2522</span></a>    <span class="n">sorted_nodes</span> <span class="o">=</span> <span class="n">sorted_nodes</span><span class="p">[::</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span>
</span><span id="toposort-2523"><a href="#toposort-2523"><span class="linenos">2523</span></a>    <span class="n">check_toposort</span><span class="p">(</span><span class="n">sorted_nodes</span><span class="p">,</span> <span class="n">parents</span><span class="p">)</span>
</span><span id="toposort-2524"><a href="#toposort-2524"><span class="linenos">2524</span></a>    <span class="k">return</span> <span class="n">sorted_nodes</span>
</span></pre></div>


    

                </section>
                <section id="vjp_flat">
                            <input id="vjp_flat-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">vjp_flat</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">f</span>, </span><span class="param"><span class="o">*</span><span class="n">primals_in</span>, </span><span class="param"><span class="n">has_aux</span><span class="o">=</span><span class="kc">False</span>, </span><span class="param"><span class="o">**</span><span class="n">static_args</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="vjp_flat-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#vjp_flat"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="vjp_flat-2527"><a href="#vjp_flat-2527"><span class="linenos">2527</span></a><span class="k">def</span> <span class="nf">vjp_flat</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="o">*</span><span class="n">primals_in</span><span class="p">,</span> <span class="n">has_aux</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="o">**</span><span class="n">static_args</span><span class="p">):</span>
</span><span id="vjp_flat-2528"><a href="#vjp_flat-2528"><span class="linenos">2528</span></a>    <span class="n">pvals_in</span> <span class="o">=</span> <span class="p">[</span><span class="n">make_known_pval</span><span class="p">(</span><span class="n">x</span><span class="p">)</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">primals_in</span><span class="p">]</span> <span class="o">+</span> <span class="p">[</span><span class="n">make_unknown_pval</span><span class="p">(</span><span class="n">SymbolicTensor</span><span class="o">.</span><span class="n">like</span><span class="p">(</span><span class="n">get_symval</span><span class="p">(</span><span class="n">x</span><span class="p">)))</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">primals_in</span><span class="p">]</span>
</span><span id="vjp_flat-2529"><a href="#vjp_flat-2529"><span class="linenos">2529</span></a>    <span class="n">primal_pvals_in</span><span class="p">,</span> <span class="n">tangent_pvals_in</span> <span class="o">=</span> <span class="n">split_half</span><span class="p">(</span><span class="n">pvals_in</span><span class="p">)</span>
</span><span id="vjp_flat-2530"><a href="#vjp_flat-2530"><span class="linenos">2530</span></a>    <span class="k">del</span> <span class="n">primal_pvals_in</span>
</span><span id="vjp_flat-2531"><a href="#vjp_flat-2531"><span class="linenos">2531</span></a>
</span><span id="vjp_flat-2532"><a href="#vjp_flat-2532"><span class="linenos">2532</span></a>    <span class="k">def</span> <span class="nf">f_jvp</span><span class="p">(</span><span class="o">*</span><span class="n">primals_tangents_in</span><span class="p">):</span>
</span><span id="vjp_flat-2533"><a href="#vjp_flat-2533"><span class="linenos">2533</span></a>        <span class="n">jvp_ret</span> <span class="o">=</span> <span class="n">jvp</span><span class="p">(</span>
</span><span id="vjp_flat-2534"><a href="#vjp_flat-2534"><span class="linenos">2534</span></a>            <span class="n">f</span><span class="p">,</span>
</span><span id="vjp_flat-2535"><a href="#vjp_flat-2535"><span class="linenos">2535</span></a>            <span class="o">*</span><span class="n">split_half</span><span class="p">(</span><span class="n">primals_tangents_in</span><span class="p">),</span>
</span><span id="vjp_flat-2536"><a href="#vjp_flat-2536"><span class="linenos">2536</span></a>            <span class="n">has_aux</span><span class="o">=</span><span class="n">has_aux</span><span class="p">,</span>
</span><span id="vjp_flat-2537"><a href="#vjp_flat-2537"><span class="linenos">2537</span></a>            <span class="n">global_data</span><span class="o">=</span><span class="s2">&quot;vjp&quot;</span><span class="p">,</span>
</span><span id="vjp_flat-2538"><a href="#vjp_flat-2538"><span class="linenos">2538</span></a>            <span class="o">**</span><span class="n">static_args</span><span class="p">,</span>
</span><span id="vjp_flat-2539"><a href="#vjp_flat-2539"><span class="linenos">2539</span></a>        <span class="p">)</span>
</span><span id="vjp_flat-2540"><a href="#vjp_flat-2540"><span class="linenos">2540</span></a>        <span class="k">if</span> <span class="n">has_aux</span><span class="p">:</span>
</span><span id="vjp_flat-2541"><a href="#vjp_flat-2541"><span class="linenos">2541</span></a>            <span class="p">((</span><span class="n">primals_out</span><span class="p">,</span> <span class="n">tangents_out</span><span class="p">),</span> <span class="n">aux</span><span class="p">)</span> <span class="o">=</span> <span class="n">jvp_ret</span>
</span><span id="vjp_flat-2542"><a href="#vjp_flat-2542"><span class="linenos">2542</span></a>        <span class="k">else</span><span class="p">:</span>
</span><span id="vjp_flat-2543"><a href="#vjp_flat-2543"><span class="linenos">2543</span></a>            <span class="p">(</span><span class="n">primals_out</span><span class="p">,</span> <span class="n">tangents_out</span><span class="p">)</span> <span class="o">=</span> <span class="n">jvp_ret</span>
</span><span id="vjp_flat-2544"><a href="#vjp_flat-2544"><span class="linenos">2544</span></a>        <span class="k">return</span> <span class="p">([</span><span class="o">*</span><span class="n">primals_out</span><span class="p">,</span> <span class="o">*</span><span class="n">tangents_out</span><span class="p">],</span> <span class="n">aux</span><span class="p">)</span> <span class="k">if</span> <span class="n">has_aux</span> <span class="k">else</span> <span class="p">[</span><span class="o">*</span><span class="n">primals_out</span><span class="p">,</span> <span class="o">*</span><span class="n">tangents_out</span><span class="p">]</span>
</span><span id="vjp_flat-2545"><a href="#vjp_flat-2545"><span class="linenos">2545</span></a>
</span><span id="vjp_flat-2546"><a href="#vjp_flat-2546"><span class="linenos">2546</span></a>    <span class="n">partial_run_flat_ret</span> <span class="o">=</span> <span class="n">partial_run_flat</span><span class="p">(</span><span class="n">f_jvp</span><span class="p">,</span> <span class="n">pvals_in</span><span class="p">,</span> <span class="n">has_aux</span><span class="p">,</span> <span class="s2">&quot;vjp&quot;</span><span class="p">)</span>
</span><span id="vjp_flat-2547"><a href="#vjp_flat-2547"><span class="linenos">2547</span></a>    <span class="k">if</span> <span class="n">has_aux</span><span class="p">:</span>
</span><span id="vjp_flat-2548"><a href="#vjp_flat-2548"><span class="linenos">2548</span></a>        <span class="n">program</span><span class="p">,</span> <span class="n">pvals_out</span><span class="p">,</span> <span class="n">consts</span><span class="p">,</span> <span class="n">aux</span> <span class="o">=</span> <span class="n">partial_run_flat_ret</span>
</span><span id="vjp_flat-2549"><a href="#vjp_flat-2549"><span class="linenos">2549</span></a>    <span class="k">else</span><span class="p">:</span>
</span><span id="vjp_flat-2550"><a href="#vjp_flat-2550"><span class="linenos">2550</span></a>        <span class="n">program</span><span class="p">,</span> <span class="n">pvals_out</span><span class="p">,</span> <span class="n">consts</span> <span class="o">=</span> <span class="n">partial_run_flat_ret</span>
</span><span id="vjp_flat-2551"><a href="#vjp_flat-2551"><span class="linenos">2551</span></a>
</span><span id="vjp_flat-2552"><a href="#vjp_flat-2552"><span class="linenos">2552</span></a>    <span class="n">primal_pvals</span><span class="p">,</span> <span class="n">tangent_pvals</span> <span class="o">=</span> <span class="n">split_half</span><span class="p">(</span><span class="n">pvals_out</span><span class="p">)</span>
</span><span id="vjp_flat-2553"><a href="#vjp_flat-2553"><span class="linenos">2553</span></a>    <span class="k">del</span> <span class="n">tangent_pvals</span>
</span><span id="vjp_flat-2554"><a href="#vjp_flat-2554"><span class="linenos">2554</span></a>    <span class="k">assert</span> <span class="nb">all</span><span class="p">(</span><span class="n">pval</span><span class="o">.</span><span class="n">is_known</span> <span class="k">for</span> <span class="n">pval</span> <span class="ow">in</span> <span class="n">primal_pvals</span><span class="p">)</span>
</span><span id="vjp_flat-2555"><a href="#vjp_flat-2555"><span class="linenos">2555</span></a>    <span class="n">primals_out_flat</span> <span class="o">=</span> <span class="p">[</span><span class="n">pval</span><span class="o">.</span><span class="n">const</span> <span class="k">for</span> <span class="n">pval</span> <span class="ow">in</span> <span class="n">primal_pvals</span><span class="p">]</span>
</span><span id="vjp_flat-2556"><a href="#vjp_flat-2556"><span class="linenos">2556</span></a>    <span class="n">transpose_inputs</span> <span class="o">=</span> <span class="n">consts</span> <span class="o">+</span> <span class="p">[</span><span class="n">UndefinedPrimal</span><span class="p">(</span><span class="n">t</span><span class="o">.</span><span class="n">symval</span><span class="p">)</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">tangent_pvals_in</span><span class="p">]</span>
</span><span id="vjp_flat-2557"><a href="#vjp_flat-2557"><span class="linenos">2557</span></a>
</span><span id="vjp_flat-2558"><a href="#vjp_flat-2558"><span class="linenos">2558</span></a>    <span class="k">def</span> <span class="nf">f_vjp_flat</span><span class="p">(</span><span class="o">*</span><span class="n">cotangents</span><span class="p">):</span>
</span><span id="vjp_flat-2559"><a href="#vjp_flat-2559"><span class="linenos">2559</span></a>        <span class="c1"># return backward_pass(program, transpose_inputs, cotangents)</span>
</span><span id="vjp_flat-2560"><a href="#vjp_flat-2560"><span class="linenos">2560</span></a>        <span class="n">undef_primals</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="nb">isinstance</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">UndefinedPrimal</span><span class="p">)</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">transpose_inputs</span><span class="p">)</span>
</span><span id="vjp_flat-2561"><a href="#vjp_flat-2561"><span class="linenos">2561</span></a>        <span class="n">transposed_program</span><span class="p">,</span> <span class="n">new_consts</span> <span class="o">=</span> <span class="n">transpose_program</span><span class="p">(</span><span class="n">program</span><span class="p">,</span> <span class="n">undef_primals</span><span class="p">)</span>
</span><span id="vjp_flat-2562"><a href="#vjp_flat-2562"><span class="linenos">2562</span></a>        <span class="n">residuals</span><span class="p">,</span> <span class="n">_</span> <span class="o">=</span> <span class="n">partition_list</span><span class="p">(</span><span class="n">undef_primals</span><span class="p">,</span> <span class="n">transpose_inputs</span><span class="p">)</span>
</span><span id="vjp_flat-2563"><a href="#vjp_flat-2563"><span class="linenos">2563</span></a>        <span class="n">outs</span> <span class="o">=</span> <span class="n">run_program</span><span class="p">(</span><span class="n">transposed_program</span><span class="p">,</span> <span class="p">(</span><span class="o">*</span><span class="n">new_consts</span><span class="p">,</span> <span class="o">*</span><span class="n">residuals</span><span class="p">,</span> <span class="o">*</span><span class="n">cotangents</span><span class="p">))</span>
</span><span id="vjp_flat-2564"><a href="#vjp_flat-2564"><span class="linenos">2564</span></a>        <span class="k">return</span> <span class="n">outs</span>
</span><span id="vjp_flat-2565"><a href="#vjp_flat-2565"><span class="linenos">2565</span></a>
</span><span id="vjp_flat-2566"><a href="#vjp_flat-2566"><span class="linenos">2566</span></a>    <span class="k">return</span> <span class="p">(</span><span class="n">primals_out_flat</span><span class="p">,</span> <span class="n">f_vjp_flat</span><span class="p">,</span> <span class="n">aux</span><span class="p">)</span> <span class="k">if</span> <span class="n">has_aux</span> <span class="k">else</span> <span class="p">(</span><span class="n">primals_out_flat</span><span class="p">,</span> <span class="n">f_vjp_flat</span><span class="p">)</span>
</span></pre></div>


    

                </section>
                <section id="vjp">
                            <input id="vjp-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">vjp</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">f</span>, </span><span class="param"><span class="o">*</span><span class="n">primals_in</span>, </span><span class="param"><span class="n">has_aux</span><span class="o">=</span><span class="kc">False</span>, </span><span class="param"><span class="o">**</span><span class="n">static_args</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="vjp-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#vjp"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="vjp-2569"><a href="#vjp-2569"><span class="linenos">2569</span></a><span class="k">def</span> <span class="nf">vjp</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="o">*</span><span class="n">primals_in</span><span class="p">,</span> <span class="n">has_aux</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="o">**</span><span class="n">static_args</span><span class="p">):</span>
</span><span id="vjp-2570"><a href="#vjp-2570"><span class="linenos">2570</span></a>    <span class="n">primals_in_flat</span><span class="p">,</span> <span class="n">in_tree</span> <span class="o">=</span> <span class="n">tree_flatten</span><span class="p">(</span><span class="n">primals_in</span><span class="p">)</span>
</span><span id="vjp-2571"><a href="#vjp-2571"><span class="linenos">2571</span></a>    <span class="n">f</span><span class="p">,</span> <span class="n">out_tree_store</span> <span class="o">=</span> <span class="n">flatten_fn</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="n">in_tree</span><span class="p">,</span> <span class="n">has_aux</span><span class="o">=</span><span class="n">has_aux</span><span class="p">)</span>
</span><span id="vjp-2572"><a href="#vjp-2572"><span class="linenos">2572</span></a>    <span class="n">vjp_ret</span> <span class="o">=</span> <span class="n">vjp_flat</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="o">*</span><span class="n">primals_in_flat</span><span class="p">,</span> <span class="n">has_aux</span><span class="o">=</span><span class="n">has_aux</span><span class="p">,</span> <span class="o">**</span><span class="n">static_args</span><span class="p">)</span>
</span><span id="vjp-2573"><a href="#vjp-2573"><span class="linenos">2573</span></a>    <span class="k">if</span> <span class="n">has_aux</span><span class="p">:</span>
</span><span id="vjp-2574"><a href="#vjp-2574"><span class="linenos">2574</span></a>        <span class="n">primals_out_flat</span><span class="p">,</span> <span class="n">f_vjp_flat</span><span class="p">,</span> <span class="n">aux</span> <span class="o">=</span> <span class="n">vjp_ret</span>
</span><span id="vjp-2575"><a href="#vjp-2575"><span class="linenos">2575</span></a>    <span class="k">else</span><span class="p">:</span>
</span><span id="vjp-2576"><a href="#vjp-2576"><span class="linenos">2576</span></a>        <span class="n">primals_out_flat</span><span class="p">,</span> <span class="n">f_vjp_flat</span> <span class="o">=</span> <span class="n">vjp_ret</span>
</span><span id="vjp-2577"><a href="#vjp-2577"><span class="linenos">2577</span></a>    <span class="n">primals_out</span> <span class="o">=</span> <span class="n">tree_unflatten</span><span class="p">(</span><span class="n">out_tree_store</span><span class="p">(),</span> <span class="n">primals_out_flat</span><span class="p">)</span>
</span><span id="vjp-2578"><a href="#vjp-2578"><span class="linenos">2578</span></a>
</span><span id="vjp-2579"><a href="#vjp-2579"><span class="linenos">2579</span></a>    <span class="k">def</span> <span class="nf">f_vjp</span><span class="p">(</span><span class="o">*</span><span class="n">cotangents_out</span><span class="p">):</span>
</span><span id="vjp-2580"><a href="#vjp-2580"><span class="linenos">2580</span></a>        <span class="n">cotangents_out_flat</span><span class="p">,</span> <span class="n">_</span> <span class="o">=</span> <span class="n">tree_flatten</span><span class="p">(</span><span class="n">cotangents_out</span><span class="p">)</span>
</span><span id="vjp-2581"><a href="#vjp-2581"><span class="linenos">2581</span></a>        <span class="n">cotangents_in_flat</span> <span class="o">=</span> <span class="n">f_vjp_flat</span><span class="p">(</span><span class="o">*</span><span class="n">cotangents_out_flat</span><span class="p">)</span>
</span><span id="vjp-2582"><a href="#vjp-2582"><span class="linenos">2582</span></a>
</span><span id="vjp-2583"><a href="#vjp-2583"><span class="linenos">2583</span></a>        <span class="k">return</span> <span class="n">tree_unflatten</span><span class="p">(</span><span class="n">in_tree</span><span class="p">,</span> <span class="n">cotangents_in_flat</span><span class="p">)</span>
</span><span id="vjp-2584"><a href="#vjp-2584"><span class="linenos">2584</span></a>
</span><span id="vjp-2585"><a href="#vjp-2585"><span class="linenos">2585</span></a>    <span class="k">return</span> <span class="p">(</span><span class="n">primals_out</span><span class="p">,</span> <span class="n">f_vjp</span><span class="p">,</span> <span class="n">aux</span><span class="p">)</span> <span class="k">if</span> <span class="n">has_aux</span> <span class="k">else</span> <span class="p">(</span><span class="n">primals_out</span><span class="p">,</span> <span class="n">f_vjp</span><span class="p">)</span>
</span></pre></div>


    

                </section>
                <section id="NullCotangent">
                    <div class="attr variable">
            <span class="name">NullCotangent</span>        =
<span class="default_value">None</span>

        
    </div>
    <a class="headerlink" href="#NullCotangent"></a>
    
    

                </section>
                <section id="backward_pass">
                            <input id="backward_pass-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">backward_pass</span><span class="signature pdoc-code multiline">(<span class="param">	<span class="n">program</span><span class="p">:</span> <span class="n"><a href="#Program">Program</a></span>,</span><span class="param">	<span class="n">args</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">]</span>,</span><span class="param">	<span class="n">cotangents</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">]</span></span><span class="return-annotation">) -> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">]</span>:</span></span>

                <label class="view-source-button" for="backward_pass-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#backward_pass"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="backward_pass-2591"><a href="#backward_pass-2591"><span class="linenos">2591</span></a><span class="k">def</span> <span class="nf">backward_pass</span><span class="p">(</span><span class="n">program</span><span class="p">:</span> <span class="n">Program</span><span class="p">,</span> <span class="n">args</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">],</span> <span class="n">cotangents</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">])</span> <span class="o">-&gt;</span> <span class="n">List</span><span class="p">[</span><span class="n">Any</span><span class="p">]:</span>
</span><span id="backward_pass-2592"><a href="#backward_pass-2592"><span class="linenos">2592</span></a>    <span class="n">primal_env</span><span class="p">:</span> <span class="n">Dict</span><span class="p">[</span><span class="n">Var</span><span class="p">,</span> <span class="n">Any</span><span class="p">]</span> <span class="o">=</span> <span class="p">{}</span>
</span><span id="backward_pass-2593"><a href="#backward_pass-2593"><span class="linenos">2593</span></a>    <span class="n">ct_env</span><span class="p">:</span> <span class="n">Dict</span><span class="p">[</span><span class="n">Var</span><span class="p">,</span> <span class="n">Any</span><span class="p">]</span> <span class="o">=</span> <span class="p">{}</span>
</span><span id="backward_pass-2594"><a href="#backward_pass-2594"><span class="linenos">2594</span></a>
</span><span id="backward_pass-2595"><a href="#backward_pass-2595"><span class="linenos">2595</span></a>    <span class="k">def</span> <span class="nf">read_primal</span><span class="p">(</span><span class="n">x</span><span class="p">:</span> <span class="n">Atom</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Any</span><span class="p">:</span>
</span><span id="backward_pass-2596"><a href="#backward_pass-2596"><span class="linenos">2596</span></a>        <span class="k">return</span> <span class="n">primal_env</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">UndefinedPrimal</span><span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">symval</span><span class="p">))</span> <span class="k">if</span> <span class="nb">type</span><span class="p">(</span><span class="n">x</span><span class="p">)</span> <span class="ow">is</span> <span class="n">Var</span> <span class="k">else</span> <span class="n">x</span><span class="o">.</span><span class="n">val</span>
</span><span id="backward_pass-2597"><a href="#backward_pass-2597"><span class="linenos">2597</span></a>
</span><span id="backward_pass-2598"><a href="#backward_pass-2598"><span class="linenos">2598</span></a>    <span class="k">def</span> <span class="nf">write_primal</span><span class="p">(</span><span class="n">v</span><span class="p">:</span> <span class="n">Var</span><span class="p">,</span> <span class="n">val</span><span class="p">:</span> <span class="n">Any</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="kc">None</span><span class="p">:</span>
</span><span id="backward_pass-2599"><a href="#backward_pass-2599"><span class="linenos">2599</span></a>        <span class="k">if</span> <span class="nb">type</span><span class="p">(</span><span class="n">val</span><span class="p">)</span> <span class="ow">is</span> <span class="ow">not</span> <span class="n">UndefinedPrimal</span><span class="p">:</span>
</span><span id="backward_pass-2600"><a href="#backward_pass-2600"><span class="linenos">2600</span></a>            <span class="n">primal_env</span><span class="p">[</span><span class="n">v</span><span class="p">]</span> <span class="o">=</span> <span class="n">val</span>
</span><span id="backward_pass-2601"><a href="#backward_pass-2601"><span class="linenos">2601</span></a>
</span><span id="backward_pass-2602"><a href="#backward_pass-2602"><span class="linenos">2602</span></a>    <span class="k">def</span> <span class="nf">read_cotangent</span><span class="p">(</span><span class="n">v</span><span class="p">:</span> <span class="n">Var</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Any</span><span class="p">:</span>
</span><span id="backward_pass-2603"><a href="#backward_pass-2603"><span class="linenos">2603</span></a>        <span class="k">return</span> <span class="n">ct_env</span><span class="o">.</span><span class="n">pop</span><span class="p">(</span><span class="n">v</span><span class="p">,</span> <span class="n">backend</span><span class="o">.</span><span class="n">zeros</span><span class="p">(</span><span class="n">v</span><span class="o">.</span><span class="n">symval</span><span class="o">.</span><span class="n">shape</span><span class="p">,</span> <span class="n">v</span><span class="o">.</span><span class="n">symval</span><span class="o">.</span><span class="n">dtype</span><span class="p">))</span>
</span><span id="backward_pass-2604"><a href="#backward_pass-2604"><span class="linenos">2604</span></a>
</span><span id="backward_pass-2605"><a href="#backward_pass-2605"><span class="linenos">2605</span></a>    <span class="k">def</span> <span class="nf">write_cotangent</span><span class="p">(</span><span class="n">x</span><span class="p">:</span> <span class="n">Atom</span><span class="p">,</span> <span class="n">ct</span><span class="p">:</span> <span class="n">Any</span><span class="p">):</span>
</span><span id="backward_pass-2606"><a href="#backward_pass-2606"><span class="linenos">2606</span></a>        <span class="k">if</span> <span class="nb">type</span><span class="p">(</span><span class="n">x</span><span class="p">)</span> <span class="ow">is</span> <span class="n">Var</span> <span class="ow">and</span> <span class="n">ct</span> <span class="ow">is</span> <span class="ow">not</span> <span class="n">NullCotangent</span><span class="p">:</span>
</span><span id="backward_pass-2607"><a href="#backward_pass-2607"><span class="linenos">2607</span></a>            <span class="n">ct_env</span><span class="p">[</span><span class="n">x</span><span class="p">]</span> <span class="o">=</span> <span class="p">(</span><span class="n">ct_env</span><span class="p">[</span><span class="n">x</span><span class="p">]</span> <span class="o">+</span> <span class="n">ct</span><span class="p">)</span> <span class="k">if</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">ct_env</span> <span class="k">else</span> <span class="n">ct</span>
</span><span id="backward_pass-2608"><a href="#backward_pass-2608"><span class="linenos">2608</span></a>
</span><span id="backward_pass-2609"><a href="#backward_pass-2609"><span class="linenos">2609</span></a>    <span class="n">list_map</span><span class="p">(</span><span class="n">write_primal</span><span class="p">,</span> <span class="n">program</span><span class="o">.</span><span class="n">in_binders</span><span class="p">,</span> <span class="n">args</span><span class="p">)</span>
</span><span id="backward_pass-2610"><a href="#backward_pass-2610"><span class="linenos">2610</span></a>    <span class="n">list_map</span><span class="p">(</span><span class="n">write_cotangent</span><span class="p">,</span> <span class="n">program</span><span class="o">.</span><span class="n">outs</span><span class="p">,</span> <span class="n">cotangents</span><span class="p">)</span>
</span><span id="backward_pass-2611"><a href="#backward_pass-2611"><span class="linenos">2611</span></a>    <span class="k">for</span> <span class="n">instruction</span> <span class="ow">in</span> <span class="n">program</span><span class="o">.</span><span class="n">instructions</span><span class="p">[::</span><span class="o">-</span><span class="mi">1</span><span class="p">]:</span>
</span><span id="backward_pass-2612"><a href="#backward_pass-2612"><span class="linenos">2612</span></a>        <span class="n">primals_in</span> <span class="o">=</span> <span class="n">list_map</span><span class="p">(</span><span class="n">read_primal</span><span class="p">,</span> <span class="n">instruction</span><span class="o">.</span><span class="n">inputs</span><span class="p">)</span>
</span><span id="backward_pass-2613"><a href="#backward_pass-2613"><span class="linenos">2613</span></a>        <span class="n">cotangents_in</span> <span class="o">=</span> <span class="n">list_map</span><span class="p">(</span><span class="n">read_cotangent</span><span class="p">,</span> <span class="n">instruction</span><span class="o">.</span><span class="n">out_binders</span><span class="p">)</span>
</span><span id="backward_pass-2614"><a href="#backward_pass-2614"><span class="linenos">2614</span></a>        <span class="n">inp</span><span class="p">,</span> <span class="n">params</span> <span class="o">=</span> <span class="n">primals_in</span><span class="p">,</span> <span class="n">instruction</span><span class="o">.</span><span class="n">params</span>
</span><span id="backward_pass-2615"><a href="#backward_pass-2615"><span class="linenos">2615</span></a>        <span class="n">cotangents_out</span> <span class="o">=</span> <span class="n">instruction</span><span class="o">.</span><span class="n">op</span><span class="o">.</span><span class="n">T</span><span class="p">(</span><span class="n">cotangents_in</span><span class="p">,</span> <span class="o">*</span><span class="n">inp</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)</span>
</span><span id="backward_pass-2616"><a href="#backward_pass-2616"><span class="linenos">2616</span></a>        <span class="n">list_map</span><span class="p">(</span><span class="n">write_cotangent</span><span class="p">,</span> <span class="n">instruction</span><span class="o">.</span><span class="n">inputs</span><span class="p">,</span> <span class="n">cotangents_out</span><span class="p">)</span>
</span><span id="backward_pass-2617"><a href="#backward_pass-2617"><span class="linenos">2617</span></a>
</span><span id="backward_pass-2618"><a href="#backward_pass-2618"><span class="linenos">2618</span></a>    <span class="n">ret</span> <span class="o">=</span> <span class="p">[</span><span class="n">read_cotangent</span><span class="p">(</span><span class="n">v</span><span class="p">)</span> <span class="k">for</span> <span class="n">v</span><span class="p">,</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">list_zip</span><span class="p">(</span><span class="n">program</span><span class="o">.</span><span class="n">in_binders</span><span class="p">,</span> <span class="n">args</span><span class="p">)</span> <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">UndefinedPrimal</span><span class="p">)]</span>
</span><span id="backward_pass-2619"><a href="#backward_pass-2619"><span class="linenos">2619</span></a>    <span class="k">return</span> <span class="n">ret</span>
</span></pre></div>


    

                </section>
                <section id="transpose_program">
                            <input id="transpose_program-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">transpose_program</span><span class="signature pdoc-code condensed">(<span class="param"><span class="o">*</span><span class="n">args</span>, </span><span class="param"><span class="o">**</span><span class="n">kwargs</span></span><span class="return-annotation">) -> <span class="n">Any</span>:</span></span>

                <label class="view-source-button" for="transpose_program-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#transpose_program"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="transpose_program-172"><a href="#transpose_program-172"><span class="linenos">172</span></a>        <span class="k">def</span> <span class="nf">decorated_function</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Any</span><span class="p">:</span>
</span><span id="transpose_program-173"><a href="#transpose_program-173"><span class="linenos">173</span></a>            <span class="n">result</span> <span class="o">=</span> <span class="n">wrapper</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">)</span>
</span><span id="transpose_program-174"><a href="#transpose_program-174"><span class="linenos">174</span></a>            <span class="n">cache_info</span> <span class="o">=</span> <span class="n">wrapper</span><span class="o">.</span><span class="n">cache_info</span><span class="p">()</span>
</span><span id="transpose_program-175"><a href="#transpose_program-175"><span class="linenos">175</span></a>
</span><span id="transpose_program-176"><a href="#transpose_program-176"><span class="linenos">176</span></a>            <span class="n">dblog</span><span class="p">(</span>
</span><span id="transpose_program-177"><a href="#transpose_program-177"><span class="linenos">177</span></a>                <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">fn</span><span class="o">.</span><span class="vm">__name__</span><span class="si">}</span><span class="s2">.</span><span class="si">{</span><span class="n">cache_info</span><span class="si">}</span><span class="s2"> </span><span class="si">{</span><span class="n">args</span><span class="o">.</span><span class="fm">__hash__</span><span class="p">()</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">,</span>
</span><span id="transpose_program-178"><a href="#transpose_program-178"><span class="linenos">178</span></a>                <span class="n">enable</span><span class="o">=</span><span class="n">backend</span><span class="o">.</span><span class="n">LOG_LRU</span><span class="p">,</span>
</span><span id="transpose_program-179"><a href="#transpose_program-179"><span class="linenos">179</span></a>            <span class="p">)</span>
</span><span id="transpose_program-180"><a href="#transpose_program-180"><span class="linenos">180</span></a>            <span class="n">tb</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">traceback</span><span class="o">.</span><span class="n">format_list</span><span class="p">(</span><span class="n">traceback</span><span class="o">.</span><span class="n">extract_stack</span><span class="p">())[</span><span class="n">tb_start</span><span class="p">:</span><span class="n">tb_end</span><span class="p">])</span><span class="o">.</span><span class="n">replace</span><span class="p">(</span><span class="s2">&quot;</span><span class="se">\n</span><span class="s2">    &quot;</span><span class="p">,</span> <span class="s2">&quot;:</span><span class="se">\t</span><span class="s2">&quot;</span><span class="p">)</span> <span class="o">+</span> <span class="s2">&quot;-&quot;</span> <span class="o">*</span> <span class="mi">20</span> <span class="o">+</span> <span class="s2">&quot;</span><span class="se">\n</span><span class="s2">&quot;</span>
</span><span id="transpose_program-181"><a href="#transpose_program-181"><span class="linenos">181</span></a>            <span class="n">dblog</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">tb</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">,</span> <span class="n">enable</span><span class="o">=</span><span class="n">backend</span><span class="o">.</span><span class="n">LOG_LRU</span><span class="p">)</span>
</span><span id="transpose_program-182"><a href="#transpose_program-182"><span class="linenos">182</span></a>
</span><span id="transpose_program-183"><a href="#transpose_program-183"><span class="linenos">183</span></a>            <span class="k">return</span> <span class="n">result</span>
</span></pre></div>


    

                </section>
                <section id="grad">
                            <input id="grad-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">grad</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">f</span>, </span><span class="param"><span class="n">argnums</span><span class="o">=</span><span class="p">(</span><span class="mi">0</span><span class="p">,)</span>, </span><span class="param"><span class="n">argnames</span><span class="o">=</span><span class="s1">&#39;&#39;</span>, </span><span class="param"><span class="n">has_aux</span><span class="o">=</span><span class="kc">False</span>, </span><span class="param"><span class="n">return_value</span><span class="o">=</span><span class="kc">False</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="grad-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#grad"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="grad-2640"><a href="#grad-2640"><span class="linenos">2640</span></a><span class="k">def</span> <span class="nf">grad</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="n">argnums</span><span class="o">=</span><span class="p">(</span><span class="mi">0</span><span class="p">,),</span> <span class="n">argnames</span><span class="o">=</span><span class="s2">&quot;&quot;</span><span class="p">,</span> <span class="n">has_aux</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">return_value</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>
</span><span id="grad-2641"><a href="#grad-2641"><span class="linenos">2641</span></a>    <span class="n">f</span><span class="p">,</span> <span class="n">rejit</span> <span class="o">=</span> <span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="kc">False</span><span class="p">)</span> <span class="k">if</span> <span class="ow">not</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="n">jit</span><span class="p">)</span> <span class="k">else</span> <span class="p">(</span><span class="n">f</span><span class="o">.</span><span class="n">f</span><span class="p">,</span> <span class="kc">True</span><span class="p">)</span>
</span><span id="grad-2642"><a href="#grad-2642"><span class="linenos">2642</span></a>    <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">argnums</span><span class="p">,</span> <span class="nb">int</span><span class="p">):</span>
</span><span id="grad-2643"><a href="#grad-2643"><span class="linenos">2643</span></a>        <span class="n">argnums</span> <span class="o">=</span> <span class="p">(</span><span class="n">argnums</span><span class="p">,)</span>
</span><span id="grad-2644"><a href="#grad-2644"><span class="linenos">2644</span></a>
</span><span id="grad-2645"><a href="#grad-2645"><span class="linenos">2645</span></a>    <span class="k">def</span> <span class="nf">gfn</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="o">*</span><span class="n">xs</span><span class="p">,</span> <span class="o">**</span><span class="n">static_args</span><span class="p">):</span>
</span><span id="grad-2646"><a href="#grad-2646"><span class="linenos">2646</span></a>        <span class="n">vjp_ret</span> <span class="o">=</span> <span class="n">vjp</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="n">x</span><span class="p">,</span> <span class="o">*</span><span class="n">xs</span><span class="p">,</span> <span class="n">has_aux</span><span class="o">=</span><span class="n">has_aux</span><span class="p">,</span> <span class="o">**</span><span class="n">static_args</span><span class="p">)</span>
</span><span id="grad-2647"><a href="#grad-2647"><span class="linenos">2647</span></a>        <span class="k">if</span> <span class="n">has_aux</span><span class="p">:</span>
</span><span id="grad-2648"><a href="#grad-2648"><span class="linenos">2648</span></a>            <span class="n">y</span><span class="p">,</span> <span class="n">f_vjp</span><span class="p">,</span> <span class="n">aux</span> <span class="o">=</span> <span class="n">vjp_ret</span>
</span><span id="grad-2649"><a href="#grad-2649"><span class="linenos">2649</span></a>        <span class="k">else</span><span class="p">:</span>
</span><span id="grad-2650"><a href="#grad-2650"><span class="linenos">2650</span></a>            <span class="n">y</span><span class="p">,</span> <span class="n">f_vjp</span> <span class="o">=</span> <span class="n">vjp_ret</span>
</span><span id="grad-2651"><a href="#grad-2651"><span class="linenos">2651</span></a>        <span class="k">if</span> <span class="n">np</span><span class="o">.</span><span class="n">shape</span><span class="p">(</span><span class="n">y</span><span class="p">)</span> <span class="o">!=</span> <span class="p">():</span>
</span><span id="grad-2652"><a href="#grad-2652"><span class="linenos">2652</span></a>            <span class="k">raise</span> <span class="ne">TypeError</span><span class="p">(</span><span class="s2">&quot;grad output must be 0-dim scalar with shape ()&quot;</span><span class="p">)</span>
</span><span id="grad-2653"><a href="#grad-2653"><span class="linenos">2653</span></a>        <span class="n">gL_xs</span> <span class="o">=</span> <span class="n">f_vjp</span><span class="p">(</span><span class="n">backend</span><span class="o">.</span><span class="n">ones</span><span class="p">(()))</span>
</span><span id="grad-2654"><a href="#grad-2654"><span class="linenos">2654</span></a>        <span class="n">gL_xs</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">gL_xs</span><span class="p">[</span><span class="n">i</span><span class="p">]</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="n">argnums</span><span class="p">)</span> <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">argnums</span><span class="p">)</span> <span class="o">&gt;</span> <span class="mi">1</span> <span class="k">else</span> <span class="n">gL_xs</span><span class="p">[</span><span class="n">argnums</span><span class="p">[</span><span class="mi">0</span><span class="p">]]</span>
</span><span id="grad-2655"><a href="#grad-2655"><span class="linenos">2655</span></a>        <span class="k">if</span> <span class="n">return_value</span><span class="p">:</span>
</span><span id="grad-2656"><a href="#grad-2656"><span class="linenos">2656</span></a>            <span class="k">return</span> <span class="p">((</span><span class="n">y</span><span class="p">,</span> <span class="n">aux</span><span class="p">),</span> <span class="n">gL_xs</span><span class="p">)</span> <span class="k">if</span> <span class="n">has_aux</span> <span class="k">else</span> <span class="p">(</span><span class="n">y</span><span class="p">,</span> <span class="n">gL_xs</span><span class="p">)</span>
</span><span id="grad-2657"><a href="#grad-2657"><span class="linenos">2657</span></a>        <span class="k">else</span><span class="p">:</span>
</span><span id="grad-2658"><a href="#grad-2658"><span class="linenos">2658</span></a>            <span class="k">return</span> <span class="p">(</span><span class="n">gL_xs</span><span class="p">,</span> <span class="n">aux</span><span class="p">)</span> <span class="k">if</span> <span class="n">has_aux</span> <span class="k">else</span> <span class="n">gL_xs</span>
</span><span id="grad-2659"><a href="#grad-2659"><span class="linenos">2659</span></a>
</span><span id="grad-2660"><a href="#grad-2660"><span class="linenos">2660</span></a>    <span class="k">return</span> <span class="n">jit</span><span class="p">(</span><span class="n">gfn</span><span class="p">)</span> <span class="k">if</span> <span class="n">rejit</span> <span class="k">else</span> <span class="n">gfn</span>
</span></pre></div>


    

                </section>
                <section id="value_and_grad">
                            <input id="value_and_grad-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">value_and_grad</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">f</span>, </span><span class="param"><span class="n">argnums</span><span class="o">=</span><span class="p">(</span><span class="mi">0</span><span class="p">,)</span>, </span><span class="param"><span class="n">argnames</span><span class="o">=</span><span class="s1">&#39;&#39;</span>, </span><span class="param"><span class="n">has_aux</span><span class="o">=</span><span class="kc">False</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="value_and_grad-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#value_and_grad"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="value_and_grad-2663"><a href="#value_and_grad-2663"><span class="linenos">2663</span></a><span class="k">def</span> <span class="nf">value_and_grad</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="n">argnums</span><span class="o">=</span><span class="p">(</span><span class="mi">0</span><span class="p">,),</span> <span class="n">argnames</span><span class="o">=</span><span class="s2">&quot;&quot;</span><span class="p">,</span> <span class="n">has_aux</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>
</span><span id="value_and_grad-2664"><a href="#value_and_grad-2664"><span class="linenos">2664</span></a>    <span class="k">return</span> <span class="n">grad</span><span class="p">(</span>
</span><span id="value_and_grad-2665"><a href="#value_and_grad-2665"><span class="linenos">2665</span></a>        <span class="n">f</span><span class="p">,</span>
</span><span id="value_and_grad-2666"><a href="#value_and_grad-2666"><span class="linenos">2666</span></a>        <span class="n">argnums</span><span class="o">=</span><span class="n">argnums</span><span class="p">,</span>
</span><span id="value_and_grad-2667"><a href="#value_and_grad-2667"><span class="linenos">2667</span></a>        <span class="n">argnames</span><span class="o">=</span><span class="n">argnames</span><span class="p">,</span>
</span><span id="value_and_grad-2668"><a href="#value_and_grad-2668"><span class="linenos">2668</span></a>        <span class="n">has_aux</span><span class="o">=</span><span class="n">has_aux</span><span class="p">,</span>
</span><span id="value_and_grad-2669"><a href="#value_and_grad-2669"><span class="linenos">2669</span></a>        <span class="n">return_value</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span>
</span><span id="value_and_grad-2670"><a href="#value_and_grad-2670"><span class="linenos">2670</span></a>    <span class="p">)</span>
</span></pre></div>


    

                </section>
                <section id="jit_partial_run">
                            <input id="jit_partial_run-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">jit_partial_run</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">trace</span>, </span><span class="param"><span class="n">tracers</span>, </span><span class="param"><span class="o">*</span>, </span><span class="param"><span class="n">program</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="jit_partial_run-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#jit_partial_run"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="jit_partial_run-2673"><a href="#jit_partial_run-2673"><span class="linenos">2673</span></a><span class="k">def</span> <span class="nf">jit_partial_run</span><span class="p">(</span><span class="n">trace</span><span class="p">,</span> <span class="n">tracers</span><span class="p">,</span> <span class="o">*</span><span class="p">,</span> <span class="n">program</span><span class="p">):</span>
</span><span id="jit_partial_run-2674"><a href="#jit_partial_run-2674"><span class="linenos">2674</span></a>    <span class="n">in_unknowns</span> <span class="o">=</span> <span class="p">[</span><span class="ow">not</span> <span class="n">t</span><span class="o">.</span><span class="n">pval</span><span class="o">.</span><span class="n">is_known</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">tracers</span><span class="p">]</span>
</span><span id="jit_partial_run-2675"><a href="#jit_partial_run-2675"><span class="linenos">2675</span></a>    <span class="n">program1</span><span class="p">,</span> <span class="n">program2</span><span class="p">,</span> <span class="n">out_unknowns</span><span class="p">,</span> <span class="n">num_res</span> <span class="o">=</span> <span class="n">partial_run_program</span><span class="p">(</span><span class="n">program</span><span class="p">,</span> <span class="n">in_unknowns</span><span class="p">)</span>
</span><span id="jit_partial_run-2676"><a href="#jit_partial_run-2676"><span class="linenos">2676</span></a>    <span class="n">known_tracers</span><span class="p">,</span> <span class="n">unknown_tracers</span> <span class="o">=</span> <span class="n">partition_list</span><span class="p">(</span><span class="n">in_unknowns</span><span class="p">,</span> <span class="n">tracers</span><span class="p">)</span>
</span><span id="jit_partial_run-2677"><a href="#jit_partial_run-2677"><span class="linenos">2677</span></a>    <span class="n">known_vals</span> <span class="o">=</span> <span class="p">[</span><span class="n">t</span><span class="o">.</span><span class="n">pval</span><span class="o">.</span><span class="n">const</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">known_tracers</span><span class="p">]</span>
</span><span id="jit_partial_run-2678"><a href="#jit_partial_run-2678"><span class="linenos">2678</span></a>    <span class="n">outs1_res</span> <span class="o">=</span> <span class="n">backend</span><span class="o">.</span><span class="n">jit_op</span><span class="p">(</span><span class="o">*</span><span class="n">known_vals</span><span class="p">,</span> <span class="n">program</span><span class="o">=</span><span class="n">program</span><span class="p">)</span>
</span><span id="jit_partial_run-2679"><a href="#jit_partial_run-2679"><span class="linenos">2679</span></a>    <span class="n">outs1</span><span class="p">,</span> <span class="n">res</span> <span class="o">=</span> <span class="n">split_list</span><span class="p">(</span><span class="n">outs1_res</span><span class="p">,</span> <span class="nb">len</span><span class="p">(</span><span class="n">program1</span><span class="o">.</span><span class="n">outs</span><span class="p">)</span> <span class="o">-</span> <span class="n">num_res</span><span class="p">)</span>
</span><span id="jit_partial_run-2680"><a href="#jit_partial_run-2680"><span class="linenos">2680</span></a>    <span class="n">res_tracers</span> <span class="o">=</span> <span class="p">[</span><span class="n">trace</span><span class="o">.</span><span class="n">instantiate_const</span><span class="p">(</span><span class="n">full_raise</span><span class="p">(</span><span class="n">trace</span><span class="p">,</span> <span class="n">x</span><span class="p">))</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">res</span><span class="p">]</span>
</span><span id="jit_partial_run-2681"><a href="#jit_partial_run-2681"><span class="linenos">2681</span></a>    <span class="n">outs2</span> <span class="o">=</span> <span class="p">[</span><span class="n">PartialRunTraceTensor</span><span class="p">(</span><span class="n">trace</span><span class="p">,</span> <span class="n">PartialValue</span><span class="o">.</span><span class="n">unknown</span><span class="p">(</span><span class="n">v</span><span class="o">.</span><span class="n">symval</span><span class="p">),</span> <span class="kc">None</span><span class="p">)</span> <span class="k">for</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">program2</span><span class="o">.</span><span class="n">outs</span><span class="p">]</span>
</span><span id="jit_partial_run-2682"><a href="#jit_partial_run-2682"><span class="linenos">2682</span></a>    <span class="n">draft</span> <span class="o">=</span> <span class="n">InstructionDraft</span><span class="p">(</span>
</span><span id="jit_partial_run-2683"><a href="#jit_partial_run-2683"><span class="linenos">2683</span></a>        <span class="n">backend</span><span class="o">.</span><span class="n">jit_op</span><span class="p">,</span>
</span><span id="jit_partial_run-2684"><a href="#jit_partial_run-2684"><span class="linenos">2684</span></a>        <span class="n">res_tracers</span> <span class="o">+</span> <span class="n">unknown_tracers</span><span class="p">,</span>
</span><span id="jit_partial_run-2685"><a href="#jit_partial_run-2685"><span class="linenos">2685</span></a>        <span class="nb">dict</span><span class="p">(</span><span class="n">program</span><span class="o">=</span><span class="n">program2</span><span class="p">),</span>
</span><span id="jit_partial_run-2686"><a href="#jit_partial_run-2686"><span class="linenos">2686</span></a>        <span class="p">[</span><span class="n">v</span><span class="o">.</span><span class="n">symval</span> <span class="k">for</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">program2</span><span class="o">.</span><span class="n">outs</span><span class="p">],</span>
</span><span id="jit_partial_run-2687"><a href="#jit_partial_run-2687"><span class="linenos">2687</span></a>        <span class="nb">map</span><span class="p">(</span><span class="n">weakref</span><span class="o">.</span><span class="n">ref</span><span class="p">,</span> <span class="n">outs2</span><span class="p">),</span>
</span><span id="jit_partial_run-2688"><a href="#jit_partial_run-2688"><span class="linenos">2688</span></a>    <span class="p">)</span>
</span><span id="jit_partial_run-2689"><a href="#jit_partial_run-2689"><span class="linenos">2689</span></a>    <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">outs2</span><span class="p">:</span>
</span><span id="jit_partial_run-2690"><a href="#jit_partial_run-2690"><span class="linenos">2690</span></a>        <span class="n">t</span><span class="o">.</span><span class="n">draft</span> <span class="o">=</span> <span class="n">draft</span>
</span><span id="jit_partial_run-2691"><a href="#jit_partial_run-2691"><span class="linenos">2691</span></a>    <span class="k">return</span> <span class="n">merge_lists</span><span class="p">(</span><span class="n">out_unknowns</span><span class="p">,</span> <span class="n">outs1</span><span class="p">,</span> <span class="n">outs2</span><span class="p">)</span>
</span></pre></div>


    

                </section>
                <section id="jit">
                            <input id="jit-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr class">
            
    <span class="def">class</span>
    <span class="name">jit</span>:

                <label class="view-source-button" for="jit-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#jit"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="jit-2694"><a href="#jit-2694"><span class="linenos">2694</span></a><span class="k">class</span> <span class="nc">jit</span><span class="p">:</span>
</span><span id="jit-2695"><a href="#jit-2695"><span class="linenos">2695</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">f</span><span class="p">,</span> <span class="n">static_argnames</span><span class="o">=</span><span class="p">(),</span> <span class="n">name</span><span class="o">=</span><span class="kc">None</span><span class="p">):</span>
</span><span id="jit-2696"><a href="#jit-2696"><span class="linenos">2696</span></a>        <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">static_argnames</span><span class="p">,</span> <span class="nb">str</span><span class="p">):</span>
</span><span id="jit-2697"><a href="#jit-2697"><span class="linenos">2697</span></a>            <span class="n">static_argnames</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">static_argnames</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="s2">&quot; &quot;</span><span class="p">))</span>
</span><span id="jit-2698"><a href="#jit-2698"><span class="linenos">2698</span></a>        <span class="k">assert</span> <span class="nb">type</span><span class="p">(</span><span class="n">static_argnames</span><span class="p">)</span> <span class="ow">is</span> <span class="nb">tuple</span> <span class="ow">and</span> <span class="nb">all</span><span class="p">(</span><span class="nb">type</span><span class="p">(</span><span class="n">s</span><span class="p">)</span> <span class="ow">is</span> <span class="nb">str</span> <span class="k">for</span> <span class="n">s</span> <span class="ow">in</span> <span class="n">static_argnames</span><span class="p">)</span>
</span><span id="jit-2699"><a href="#jit-2699"><span class="linenos">2699</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">f</span> <span class="o">=</span> <span class="n">f</span>
</span><span id="jit-2700"><a href="#jit-2700"><span class="linenos">2700</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">name</span> <span class="o">=</span> <span class="n">name</span> <span class="k">if</span> <span class="n">name</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span> <span class="k">else</span> <span class="bp">self</span><span class="o">.</span><span class="n">f</span><span class="o">.</span><span class="vm">__name__</span>
</span><span id="jit-2701"><a href="#jit-2701"><span class="linenos">2701</span></a>
</span><span id="jit-2702"><a href="#jit-2702"><span class="linenos">2702</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">static_argnames</span> <span class="o">=</span> <span class="n">static_argnames</span>
</span><span id="jit-2703"><a href="#jit-2703"><span class="linenos">2703</span></a>
</span><span id="jit-2704"><a href="#jit-2704"><span class="linenos">2704</span></a>    <span class="nd">@classmethod</span>
</span><span id="jit-2705"><a href="#jit-2705"><span class="linenos">2705</span></a>    <span class="k">def</span> <span class="nf">with_options</span><span class="p">(</span><span class="bp">cls</span><span class="p">,</span> <span class="n">static_argnames</span><span class="o">=</span><span class="p">(),</span> <span class="n">name</span><span class="o">=</span><span class="kc">None</span><span class="p">):</span>
</span><span id="jit-2706"><a href="#jit-2706"><span class="linenos">2706</span></a>        <span class="k">return</span> <span class="n">partial</span><span class="p">(</span><span class="bp">cls</span><span class="p">,</span> <span class="n">static_argnames</span><span class="o">=</span><span class="n">static_argnames</span><span class="p">,</span> <span class="n">name</span><span class="o">=</span><span class="n">name</span><span class="p">)</span>
</span><span id="jit-2707"><a href="#jit-2707"><span class="linenos">2707</span></a>
</span><span id="jit-2708"><a href="#jit-2708"><span class="linenos">2708</span></a>    <span class="nd">@classmethod</span>
</span><span id="jit-2709"><a href="#jit-2709"><span class="linenos">2709</span></a>    <span class="k">def</span> <span class="nf">get_jit_name</span><span class="p">(</span><span class="bp">cls</span><span class="p">,</span> <span class="n">args</span><span class="p">,</span> <span class="n">static_args</span><span class="p">,</span> <span class="n">prefix</span><span class="o">=</span><span class="s2">&quot;jit&quot;</span><span class="p">,</span> <span class="n">short</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>
</span><span id="jit-2710"><a href="#jit-2710"><span class="linenos">2710</span></a>        <span class="n">name</span> <span class="o">=</span> <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">prefix</span><span class="si">}</span><span class="s2">_&quot;</span>
</span><span id="jit-2711"><a href="#jit-2711"><span class="linenos">2711</span></a>        <span class="k">if</span> <span class="n">short</span><span class="p">:</span>
</span><span id="jit-2712"><a href="#jit-2712"><span class="linenos">2712</span></a>            <span class="n">static_args_tup</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">static_args</span><span class="o">.</span><span class="n">items</span><span class="p">())</span>
</span><span id="jit-2713"><a href="#jit-2713"><span class="linenos">2713</span></a>            <span class="n">ids</span> <span class="o">=</span> <span class="nb">repr</span><span class="p">(</span><span class="nb">hash</span><span class="p">((</span><span class="n">prefix</span><span class="p">,</span> <span class="n">args</span><span class="p">,</span> <span class="n">static_args_tup</span><span class="p">)))[</span><span class="o">-</span><span class="mi">4</span><span class="p">:]</span>
</span><span id="jit-2714"><a href="#jit-2714"><span class="linenos">2714</span></a>            <span class="n">name</span> <span class="o">=</span> <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">prefix</span><span class="si">}</span><span class="s2">_</span><span class="si">{</span><span class="n">ids</span><span class="si">}</span><span class="s2">&quot;</span>
</span><span id="jit-2715"><a href="#jit-2715"><span class="linenos">2715</span></a>        <span class="k">else</span><span class="p">:</span>
</span><span id="jit-2716"><a href="#jit-2716"><span class="linenos">2716</span></a>            <span class="k">for</span> <span class="n">a</span> <span class="ow">in</span> <span class="n">args</span><span class="p">:</span>
</span><span id="jit-2717"><a href="#jit-2717"><span class="linenos">2717</span></a>                <span class="n">name</span> <span class="o">+=</span> <span class="sa">f</span><span class="s2">&quot;shape_</span><span class="si">{</span><span class="n">a</span><span class="o">.</span><span class="n">shape</span><span class="si">}</span><span class="s2">_dtype_</span><span class="si">{</span><span class="n">a</span><span class="o">.</span><span class="n">dtype</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">_&quot;</span>
</span><span id="jit-2718"><a href="#jit-2718"><span class="linenos">2718</span></a>            <span class="k">for</span> <span class="n">k</span><span class="p">,</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">static_args</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
</span><span id="jit-2719"><a href="#jit-2719"><span class="linenos">2719</span></a>                <span class="n">name</span> <span class="o">+=</span> <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">k</span><span class="si">}</span><span class="s2">_</span><span class="si">{</span><span class="n">v</span><span class="si">}</span><span class="s2">_&quot;</span>
</span><span id="jit-2720"><a href="#jit-2720"><span class="linenos">2720</span></a>            <span class="n">name</span> <span class="o">=</span> <span class="n">name</span><span class="o">.</span><span class="n">replace</span><span class="p">(</span><span class="s2">&quot;(&quot;</span><span class="p">,</span> <span class="s2">&quot;_lp_&quot;</span><span class="p">)</span>
</span><span id="jit-2721"><a href="#jit-2721"><span class="linenos">2721</span></a>            <span class="n">name</span> <span class="o">=</span> <span class="n">name</span><span class="o">.</span><span class="n">replace</span><span class="p">(</span><span class="s2">&quot;)&quot;</span><span class="p">,</span> <span class="s2">&quot;_rp_&quot;</span><span class="p">)</span>
</span><span id="jit-2722"><a href="#jit-2722"><span class="linenos">2722</span></a>            <span class="n">name</span> <span class="o">=</span> <span class="n">name</span><span class="o">.</span><span class="n">replace</span><span class="p">(</span><span class="s2">&quot;,&quot;</span><span class="p">,</span> <span class="s2">&quot;_cm_&quot;</span><span class="p">)</span>
</span><span id="jit-2723"><a href="#jit-2723"><span class="linenos">2723</span></a>            <span class="n">name</span> <span class="o">=</span> <span class="n">name</span><span class="o">.</span><span class="n">replace</span><span class="p">(</span><span class="s2">&quot; &quot;</span><span class="p">,</span> <span class="s2">&quot;&quot;</span><span class="p">)</span>
</span><span id="jit-2724"><a href="#jit-2724"><span class="linenos">2724</span></a>            <span class="n">name</span> <span class="o">=</span> <span class="n">name</span><span class="o">.</span><span class="n">replace</span><span class="p">(</span><span class="s2">&quot;.&quot;</span><span class="p">,</span> <span class="s2">&quot;_dt_&quot;</span><span class="p">)</span>
</span><span id="jit-2725"><a href="#jit-2725"><span class="linenos">2725</span></a>
</span><span id="jit-2726"><a href="#jit-2726"><span class="linenos">2726</span></a>        <span class="k">return</span> <span class="n">name</span>
</span><span id="jit-2727"><a href="#jit-2727"><span class="linenos">2727</span></a>
</span><span id="jit-2728"><a href="#jit-2728"><span class="linenos">2728</span></a>    <span class="k">def</span> <span class="nf">get_program</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">static_args</span><span class="p">):</span>
</span><span id="jit-2729"><a href="#jit-2729"><span class="linenos">2729</span></a>        <span class="n">sig</span> <span class="o">=</span> <span class="n">inspect</span><span class="o">.</span><span class="n">signature</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">f</span><span class="p">)</span>
</span><span id="jit-2730"><a href="#jit-2730"><span class="linenos">2730</span></a>        <span class="k">if</span> <span class="nb">all</span><span class="p">(</span><span class="s2">&quot;*&quot;</span> <span class="ow">not</span> <span class="ow">in</span> <span class="nb">repr</span><span class="p">(</span><span class="n">v</span><span class="p">)</span> <span class="k">for</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">sig</span><span class="o">.</span><span class="n">parameters</span><span class="o">.</span><span class="n">values</span><span class="p">()):</span>
</span><span id="jit-2731"><a href="#jit-2731"><span class="linenos">2731</span></a>            <span class="n">args_strs</span> <span class="o">=</span> <span class="p">[</span><span class="n">k</span> <span class="k">for</span> <span class="n">k</span><span class="p">,</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">sig</span><span class="o">.</span><span class="n">parameters</span><span class="o">.</span><span class="n">items</span><span class="p">()</span> <span class="k">if</span> <span class="n">k</span> <span class="o">!=</span> <span class="s2">&quot;self&quot;</span> <span class="ow">and</span> <span class="n">k</span> <span class="ow">not</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">static_argnames</span><span class="p">]</span>
</span><span id="jit-2732"><a href="#jit-2732"><span class="linenos">2732</span></a>            <span class="n">static_args_strs</span> <span class="o">=</span> <span class="p">[</span><span class="n">k</span> <span class="k">for</span> <span class="n">k</span><span class="p">,</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">sig</span><span class="o">.</span><span class="n">parameters</span><span class="o">.</span><span class="n">items</span><span class="p">()</span> <span class="k">if</span> <span class="n">k</span> <span class="o">!=</span> <span class="s2">&quot;self&quot;</span> <span class="ow">and</span> <span class="n">k</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">static_argnames</span><span class="p">]</span>
</span><span id="jit-2733"><a href="#jit-2733"><span class="linenos">2733</span></a>
</span><span id="jit-2734"><a href="#jit-2734"><span class="linenos">2734</span></a>            <span class="k">if</span> <span class="n">args</span><span class="p">:</span>
</span><span id="jit-2735"><a href="#jit-2735"><span class="linenos">2735</span></a>                <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">args</span><span class="p">)</span> <span class="o">&gt;</span> <span class="nb">len</span><span class="p">(</span><span class="n">args_strs</span><span class="p">):</span>
</span><span id="jit-2736"><a href="#jit-2736"><span class="linenos">2736</span></a>                    <span class="k">assert</span> <span class="n">static_args_strs</span>
</span><span id="jit-2737"><a href="#jit-2737"><span class="linenos">2737</span></a>                    <span class="n">args</span><span class="p">,</span> <span class="n">rest</span> <span class="o">=</span> <span class="n">args</span><span class="p">[:</span> <span class="nb">len</span><span class="p">(</span><span class="n">args_strs</span><span class="p">)],</span> <span class="n">args</span><span class="p">[</span><span class="nb">len</span><span class="p">(</span><span class="n">args_strs</span><span class="p">)</span> <span class="p">:]</span>
</span><span id="jit-2738"><a href="#jit-2738"><span class="linenos">2738</span></a>                    <span class="n">new_static_args</span> <span class="o">=</span> <span class="p">{</span><span class="n">k</span><span class="p">:</span> <span class="n">rest_arg</span> <span class="k">for</span> <span class="n">k</span><span class="p">,</span> <span class="n">rest_arg</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">static_args_strs</span><span class="p">,</span> <span class="n">rest</span><span class="p">)</span> <span class="k">if</span> <span class="n">k</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">static_args</span><span class="p">}</span>
</span><span id="jit-2739"><a href="#jit-2739"><span class="linenos">2739</span></a>                    <span class="n">static_args</span> <span class="o">=</span> <span class="p">{</span><span class="o">**</span><span class="n">new_static_args</span><span class="p">,</span> <span class="o">**</span><span class="n">static_args</span><span class="p">}</span>
</span><span id="jit-2740"><a href="#jit-2740"><span class="linenos">2740</span></a>            <span class="k">else</span><span class="p">:</span>
</span><span id="jit-2741"><a href="#jit-2741"><span class="linenos">2741</span></a>                <span class="n">args</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">([</span><span class="n">static_args</span><span class="p">[</span><span class="n">k</span><span class="p">]</span> <span class="k">if</span> <span class="n">k</span> <span class="ow">in</span> <span class="n">static_args</span> <span class="k">else</span> <span class="n">arg</span> <span class="k">for</span> <span class="n">k</span><span class="p">,</span> <span class="n">arg</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">args_strs</span><span class="p">,</span> <span class="n">args</span><span class="p">)])</span>
</span><span id="jit-2742"><a href="#jit-2742"><span class="linenos">2742</span></a>
</span><span id="jit-2743"><a href="#jit-2743"><span class="linenos">2743</span></a>        <span class="n">symvals_in</span> <span class="o">=</span> <span class="n">tree_map</span><span class="p">(</span><span class="k">lambda</span> <span class="n">x</span><span class="p">:</span> <span class="n">SymbolicTensor</span><span class="o">.</span><span class="n">like</span><span class="p">(</span><span class="n">get_symval</span><span class="p">(</span><span class="n">x</span><span class="p">)),</span> <span class="n">args</span><span class="p">)</span>
</span><span id="jit-2744"><a href="#jit-2744"><span class="linenos">2744</span></a>        <span class="n">static_args</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">static_args</span><span class="o">.</span><span class="n">items</span><span class="p">())</span>
</span><span id="jit-2745"><a href="#jit-2745"><span class="linenos">2745</span></a>        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">name</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
</span><span id="jit-2746"><a href="#jit-2746"><span class="linenos">2746</span></a>            <span class="bp">self</span><span class="o">.</span><span class="n">name</span> <span class="o">=</span> <span class="sa">f</span><span class="s2">&quot;jit_</span><span class="si">{</span><span class="nb">str</span><span class="p">(</span><span class="nb">hash</span><span class="p">((</span><span class="bp">self</span><span class="o">.</span><span class="n">f</span><span class="p">,</span><span class="w"> </span><span class="n">symvals_in</span><span class="p">,</span><span class="w"> </span><span class="n">static_args</span><span class="p">)))[</span><span class="o">-</span><span class="mi">5</span><span class="p">:]</span><span class="si">}</span><span class="s2">&quot;</span>
</span><span id="jit-2747"><a href="#jit-2747"><span class="linenos">2747</span></a>        <span class="n">program</span><span class="p">,</span> <span class="n">consts</span><span class="p">,</span> <span class="n">out_tree</span> <span class="o">=</span> <span class="n">make_program</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">f</span><span class="p">,</span> <span class="o">*</span><span class="n">symvals_in</span><span class="p">,</span> <span class="n">static_args</span><span class="o">=</span><span class="n">static_args</span><span class="p">,</span> <span class="n">name</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">name</span><span class="p">)</span>
</span><span id="jit-2748"><a href="#jit-2748"><span class="linenos">2748</span></a>        <span class="k">return</span> <span class="n">program</span><span class="p">,</span> <span class="n">consts</span><span class="p">,</span> <span class="n">out_tree</span>
</span><span id="jit-2749"><a href="#jit-2749"><span class="linenos">2749</span></a>        <span class="n">program</span><span class="p">,</span> <span class="n">consts</span><span class="p">,</span> <span class="n">out_tree</span> <span class="o">=</span> <span class="n">make_program</span><span class="p">(</span>
</span><span id="jit-2750"><a href="#jit-2750"><span class="linenos">2750</span></a>            <span class="bp">self</span><span class="o">.</span><span class="n">f</span><span class="p">,</span>
</span><span id="jit-2751"><a href="#jit-2751"><span class="linenos">2751</span></a>            <span class="o">*</span><span class="n">symvals_in</span><span class="p">,</span>
</span><span id="jit-2752"><a href="#jit-2752"><span class="linenos">2752</span></a>            <span class="n">static_args</span><span class="o">=</span><span class="nb">tuple</span><span class="p">(</span><span class="n">static_args</span><span class="o">.</span><span class="n">items</span><span class="p">()),</span>
</span><span id="jit-2753"><a href="#jit-2753"><span class="linenos">2753</span></a>            <span class="n">name</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">name</span><span class="p">,</span>
</span><span id="jit-2754"><a href="#jit-2754"><span class="linenos">2754</span></a>        <span class="p">)</span>
</span><span id="jit-2755"><a href="#jit-2755"><span class="linenos">2755</span></a>        <span class="k">return</span> <span class="n">program</span><span class="p">,</span> <span class="n">consts</span><span class="p">,</span> <span class="n">out_tree</span>
</span><span id="jit-2756"><a href="#jit-2756"><span class="linenos">2756</span></a>
</span><span id="jit-2757"><a href="#jit-2757"><span class="linenos">2757</span></a>    <span class="k">def</span> <span class="fm">__call__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">static_args</span><span class="p">):</span>
</span><span id="jit-2758"><a href="#jit-2758"><span class="linenos">2758</span></a>        <span class="n">program</span><span class="p">,</span> <span class="n">consts</span><span class="p">,</span> <span class="n">out_tree</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">get_program</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">static_args</span><span class="p">)</span>
</span><span id="jit-2759"><a href="#jit-2759"><span class="linenos">2759</span></a>        <span class="n">args</span><span class="p">,</span> <span class="n">in_tree</span> <span class="o">=</span> <span class="n">tree_flatten</span><span class="p">(</span><span class="n">args</span><span class="p">)</span>
</span><span id="jit-2760"><a href="#jit-2760"><span class="linenos">2760</span></a>        <span class="c1"># with Timing(f&quot;JIT {self}&quot;): outs = bind(backend.jit_op, *consts, *args, program=program)</span>
</span><span id="jit-2761"><a href="#jit-2761"><span class="linenos">2761</span></a>        <span class="n">outs</span> <span class="o">=</span> <span class="n">bind</span><span class="p">(</span><span class="n">backend</span><span class="o">.</span><span class="n">jit_op</span><span class="p">,</span> <span class="o">*</span><span class="n">consts</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="n">program</span><span class="o">=</span><span class="n">program</span><span class="p">)</span>
</span><span id="jit-2762"><a href="#jit-2762"><span class="linenos">2762</span></a>        <span class="k">return</span> <span class="n">tree_unflatten</span><span class="p">(</span><span class="n">out_tree</span><span class="p">,</span> <span class="n">outs</span><span class="p">)</span>
</span><span id="jit-2763"><a href="#jit-2763"><span class="linenos">2763</span></a>
</span><span id="jit-2764"><a href="#jit-2764"><span class="linenos">2764</span></a>    <span class="k">def</span> <span class="nf">lower</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">static_args</span><span class="p">):</span>
</span><span id="jit-2765"><a href="#jit-2765"><span class="linenos">2765</span></a>        <span class="n">program</span><span class="p">,</span> <span class="n">consts</span><span class="p">,</span> <span class="n">out_tree</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">get_program</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">static_args</span><span class="p">)</span>
</span><span id="jit-2766"><a href="#jit-2766"><span class="linenos">2766</span></a>        <span class="n">args</span><span class="p">,</span> <span class="n">in_tree</span> <span class="o">=</span> <span class="n">tree_flatten</span><span class="p">(</span><span class="n">args</span><span class="p">)</span>
</span><span id="jit-2767"><a href="#jit-2767"><span class="linenos">2767</span></a>        <span class="n">hashed_program</span> <span class="o">=</span> <span class="n">Hashed</span><span class="p">(</span><span class="n">program</span><span class="p">)</span>
</span><span id="jit-2768"><a href="#jit-2768"><span class="linenos">2768</span></a>        <span class="n">num_consts</span> <span class="o">=</span> <span class="n">program</span><span class="o">.</span><span class="n">num_consts</span>
</span><span id="jit-2769"><a href="#jit-2769"><span class="linenos">2769</span></a>        <span class="n">consts</span><span class="p">,</span> <span class="n">args</span> <span class="o">=</span> <span class="n">args</span><span class="p">[:</span><span class="n">num_consts</span><span class="p">],</span> <span class="n">args</span><span class="p">[</span><span class="n">num_consts</span><span class="p">:]</span>
</span><span id="jit-2770"><a href="#jit-2770"><span class="linenos">2770</span></a>        <span class="n">hashed_consts</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="nb">map</span><span class="p">(</span><span class="n">Hashed</span><span class="p">,</span> <span class="n">consts</span><span class="p">))</span>
</span><span id="jit-2771"><a href="#jit-2771"><span class="linenos">2771</span></a>        <span class="n">jit_output</span> <span class="o">=</span> <span class="n">backend</span><span class="o">.</span><span class="n">jit_program</span><span class="p">(</span><span class="n">hashed_program</span><span class="p">,</span> <span class="n">hashed_consts</span><span class="p">)</span>
</span><span id="jit-2772"><a href="#jit-2772"><span class="linenos">2772</span></a>        <span class="k">return</span> <span class="n">jit_output</span>
</span><span id="jit-2773"><a href="#jit-2773"><span class="linenos">2773</span></a>
</span><span id="jit-2774"><a href="#jit-2774"><span class="linenos">2774</span></a>    <span class="k">def</span> <span class="nf">export</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">args</span><span class="p">,</span> <span class="n">output_path</span><span class="p">,</span> <span class="n">export_params</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">input_names</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">output_names</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">):</span>
</span><span id="jit-2775"><a href="#jit-2775"><span class="linenos">2775</span></a>        <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">args</span><span class="p">,</span> <span class="n">Tensor</span><span class="p">):</span>
</span><span id="jit-2776"><a href="#jit-2776"><span class="linenos">2776</span></a>            <span class="n">args</span><span class="p">,</span> <span class="n">static_args</span> <span class="o">=</span> <span class="p">(</span><span class="n">args</span><span class="p">,),</span> <span class="nb">dict</span><span class="p">()</span>
</span><span id="jit-2777"><a href="#jit-2777"><span class="linenos">2777</span></a>        <span class="k">elif</span> <span class="ow">not</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">args</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">],</span> <span class="nb">dict</span><span class="p">):</span>
</span><span id="jit-2778"><a href="#jit-2778"><span class="linenos">2778</span></a>            <span class="k">assert</span> <span class="nb">all</span><span class="p">(</span><span class="nb">isinstance</span><span class="p">(</span><span class="n">a</span><span class="p">,</span> <span class="n">Tensor</span><span class="p">)</span> <span class="k">for</span> <span class="n">a</span> <span class="ow">in</span> <span class="n">args</span><span class="p">)</span>
</span><span id="jit-2779"><a href="#jit-2779"><span class="linenos">2779</span></a>            <span class="n">static_args</span> <span class="o">=</span> <span class="nb">dict</span><span class="p">()</span>
</span><span id="jit-2780"><a href="#jit-2780"><span class="linenos">2780</span></a>        <span class="k">else</span><span class="p">:</span>
</span><span id="jit-2781"><a href="#jit-2781"><span class="linenos">2781</span></a>            <span class="n">args</span><span class="p">,</span> <span class="n">static_args</span> <span class="o">=</span> <span class="n">args</span><span class="p">[:</span><span class="o">-</span><span class="mi">1</span><span class="p">],</span> <span class="n">args</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span>
</span><span id="jit-2782"><a href="#jit-2782"><span class="linenos">2782</span></a>        <span class="k">assert</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">args</span><span class="p">,</span> <span class="p">(</span><span class="nb">tuple</span><span class="p">,</span> <span class="nb">list</span><span class="p">))</span> <span class="ow">and</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">static_args</span><span class="p">,</span> <span class="nb">dict</span><span class="p">)</span>
</span><span id="jit-2783"><a href="#jit-2783"><span class="linenos">2783</span></a>        <span class="n">jit_output</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">lower</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">static_args</span><span class="p">)</span>
</span><span id="jit-2784"><a href="#jit-2784"><span class="linenos">2784</span></a>        <span class="n">backend</span><span class="o">.</span><span class="n">export</span><span class="p">(</span><span class="n">jit_output</span><span class="p">,</span> <span class="n">output_path</span><span class="p">,</span> <span class="n">export_params</span><span class="p">,</span> <span class="n">input_names</span><span class="p">,</span> <span class="n">output_names</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">)</span>
</span></pre></div>


    

                            <div id="jit.__init__" class="classattr">
                                        <input id="jit.__init__-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="name">jit</span><span class="signature pdoc-code condensed">(<span class="param"><span class="n">f</span>, </span><span class="param"><span class="n">static_argnames</span><span class="o">=</span><span class="p">()</span>, </span><span class="param"><span class="n">name</span><span class="o">=</span><span class="kc">None</span></span>)</span>

                <label class="view-source-button" for="jit.__init__-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#jit.__init__"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="jit.__init__-2695"><a href="#jit.__init__-2695"><span class="linenos">2695</span></a>    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">f</span><span class="p">,</span> <span class="n">static_argnames</span><span class="o">=</span><span class="p">(),</span> <span class="n">name</span><span class="o">=</span><span class="kc">None</span><span class="p">):</span>
</span><span id="jit.__init__-2696"><a href="#jit.__init__-2696"><span class="linenos">2696</span></a>        <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">static_argnames</span><span class="p">,</span> <span class="nb">str</span><span class="p">):</span>
</span><span id="jit.__init__-2697"><a href="#jit.__init__-2697"><span class="linenos">2697</span></a>            <span class="n">static_argnames</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">static_argnames</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="s2">&quot; &quot;</span><span class="p">))</span>
</span><span id="jit.__init__-2698"><a href="#jit.__init__-2698"><span class="linenos">2698</span></a>        <span class="k">assert</span> <span class="nb">type</span><span class="p">(</span><span class="n">static_argnames</span><span class="p">)</span> <span class="ow">is</span> <span class="nb">tuple</span> <span class="ow">and</span> <span class="nb">all</span><span class="p">(</span><span class="nb">type</span><span class="p">(</span><span class="n">s</span><span class="p">)</span> <span class="ow">is</span> <span class="nb">str</span> <span class="k">for</span> <span class="n">s</span> <span class="ow">in</span> <span class="n">static_argnames</span><span class="p">)</span>
</span><span id="jit.__init__-2699"><a href="#jit.__init__-2699"><span class="linenos">2699</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">f</span> <span class="o">=</span> <span class="n">f</span>
</span><span id="jit.__init__-2700"><a href="#jit.__init__-2700"><span class="linenos">2700</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">name</span> <span class="o">=</span> <span class="n">name</span> <span class="k">if</span> <span class="n">name</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span> <span class="k">else</span> <span class="bp">self</span><span class="o">.</span><span class="n">f</span><span class="o">.</span><span class="vm">__name__</span>
</span><span id="jit.__init__-2701"><a href="#jit.__init__-2701"><span class="linenos">2701</span></a>
</span><span id="jit.__init__-2702"><a href="#jit.__init__-2702"><span class="linenos">2702</span></a>        <span class="bp">self</span><span class="o">.</span><span class="n">static_argnames</span> <span class="o">=</span> <span class="n">static_argnames</span>
</span></pre></div>


    

                            </div>
                            <div id="jit.f" class="classattr">
                                <div class="attr variable">
            <span class="name">f</span>

        
    </div>
    <a class="headerlink" href="#jit.f"></a>
    
    

                            </div>
                            <div id="jit.name" class="classattr">
                                <div class="attr variable">
            <span class="name">name</span>

        
    </div>
    <a class="headerlink" href="#jit.name"></a>
    
    

                            </div>
                            <div id="jit.static_argnames" class="classattr">
                                <div class="attr variable">
            <span class="name">static_argnames</span>

        
    </div>
    <a class="headerlink" href="#jit.static_argnames"></a>
    
    

                            </div>
                            <div id="jit.with_options" class="classattr">
                                        <input id="jit.with_options-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
                    <div class="decorator">@classmethod</div>

        <span class="def">def</span>
        <span class="name">with_options</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">cls</span>, </span><span class="param"><span class="n">static_argnames</span><span class="o">=</span><span class="p">()</span>, </span><span class="param"><span class="n">name</span><span class="o">=</span><span class="kc">None</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="jit.with_options-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#jit.with_options"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="jit.with_options-2704"><a href="#jit.with_options-2704"><span class="linenos">2704</span></a>    <span class="nd">@classmethod</span>
</span><span id="jit.with_options-2705"><a href="#jit.with_options-2705"><span class="linenos">2705</span></a>    <span class="k">def</span> <span class="nf">with_options</span><span class="p">(</span><span class="bp">cls</span><span class="p">,</span> <span class="n">static_argnames</span><span class="o">=</span><span class="p">(),</span> <span class="n">name</span><span class="o">=</span><span class="kc">None</span><span class="p">):</span>
</span><span id="jit.with_options-2706"><a href="#jit.with_options-2706"><span class="linenos">2706</span></a>        <span class="k">return</span> <span class="n">partial</span><span class="p">(</span><span class="bp">cls</span><span class="p">,</span> <span class="n">static_argnames</span><span class="o">=</span><span class="n">static_argnames</span><span class="p">,</span> <span class="n">name</span><span class="o">=</span><span class="n">name</span><span class="p">)</span>
</span></pre></div>


    

                            </div>
                            <div id="jit.get_jit_name" class="classattr">
                                        <input id="jit.get_jit_name-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
                    <div class="decorator">@classmethod</div>

        <span class="def">def</span>
        <span class="name">get_jit_name</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">cls</span>, </span><span class="param"><span class="n">args</span>, </span><span class="param"><span class="n">static_args</span>, </span><span class="param"><span class="n">prefix</span><span class="o">=</span><span class="s1">&#39;jit&#39;</span>, </span><span class="param"><span class="n">short</span><span class="o">=</span><span class="kc">False</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="jit.get_jit_name-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#jit.get_jit_name"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="jit.get_jit_name-2708"><a href="#jit.get_jit_name-2708"><span class="linenos">2708</span></a>    <span class="nd">@classmethod</span>
</span><span id="jit.get_jit_name-2709"><a href="#jit.get_jit_name-2709"><span class="linenos">2709</span></a>    <span class="k">def</span> <span class="nf">get_jit_name</span><span class="p">(</span><span class="bp">cls</span><span class="p">,</span> <span class="n">args</span><span class="p">,</span> <span class="n">static_args</span><span class="p">,</span> <span class="n">prefix</span><span class="o">=</span><span class="s2">&quot;jit&quot;</span><span class="p">,</span> <span class="n">short</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>
</span><span id="jit.get_jit_name-2710"><a href="#jit.get_jit_name-2710"><span class="linenos">2710</span></a>        <span class="n">name</span> <span class="o">=</span> <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">prefix</span><span class="si">}</span><span class="s2">_&quot;</span>
</span><span id="jit.get_jit_name-2711"><a href="#jit.get_jit_name-2711"><span class="linenos">2711</span></a>        <span class="k">if</span> <span class="n">short</span><span class="p">:</span>
</span><span id="jit.get_jit_name-2712"><a href="#jit.get_jit_name-2712"><span class="linenos">2712</span></a>            <span class="n">static_args_tup</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">static_args</span><span class="o">.</span><span class="n">items</span><span class="p">())</span>
</span><span id="jit.get_jit_name-2713"><a href="#jit.get_jit_name-2713"><span class="linenos">2713</span></a>            <span class="n">ids</span> <span class="o">=</span> <span class="nb">repr</span><span class="p">(</span><span class="nb">hash</span><span class="p">((</span><span class="n">prefix</span><span class="p">,</span> <span class="n">args</span><span class="p">,</span> <span class="n">static_args_tup</span><span class="p">)))[</span><span class="o">-</span><span class="mi">4</span><span class="p">:]</span>
</span><span id="jit.get_jit_name-2714"><a href="#jit.get_jit_name-2714"><span class="linenos">2714</span></a>            <span class="n">name</span> <span class="o">=</span> <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">prefix</span><span class="si">}</span><span class="s2">_</span><span class="si">{</span><span class="n">ids</span><span class="si">}</span><span class="s2">&quot;</span>
</span><span id="jit.get_jit_name-2715"><a href="#jit.get_jit_name-2715"><span class="linenos">2715</span></a>        <span class="k">else</span><span class="p">:</span>
</span><span id="jit.get_jit_name-2716"><a href="#jit.get_jit_name-2716"><span class="linenos">2716</span></a>            <span class="k">for</span> <span class="n">a</span> <span class="ow">in</span> <span class="n">args</span><span class="p">:</span>
</span><span id="jit.get_jit_name-2717"><a href="#jit.get_jit_name-2717"><span class="linenos">2717</span></a>                <span class="n">name</span> <span class="o">+=</span> <span class="sa">f</span><span class="s2">&quot;shape_</span><span class="si">{</span><span class="n">a</span><span class="o">.</span><span class="n">shape</span><span class="si">}</span><span class="s2">_dtype_</span><span class="si">{</span><span class="n">a</span><span class="o">.</span><span class="n">dtype</span><span class="o">.</span><span class="n">name</span><span class="si">}</span><span class="s2">_&quot;</span>
</span><span id="jit.get_jit_name-2718"><a href="#jit.get_jit_name-2718"><span class="linenos">2718</span></a>            <span class="k">for</span> <span class="n">k</span><span class="p">,</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">static_args</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
</span><span id="jit.get_jit_name-2719"><a href="#jit.get_jit_name-2719"><span class="linenos">2719</span></a>                <span class="n">name</span> <span class="o">+=</span> <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">k</span><span class="si">}</span><span class="s2">_</span><span class="si">{</span><span class="n">v</span><span class="si">}</span><span class="s2">_&quot;</span>
</span><span id="jit.get_jit_name-2720"><a href="#jit.get_jit_name-2720"><span class="linenos">2720</span></a>            <span class="n">name</span> <span class="o">=</span> <span class="n">name</span><span class="o">.</span><span class="n">replace</span><span class="p">(</span><span class="s2">&quot;(&quot;</span><span class="p">,</span> <span class="s2">&quot;_lp_&quot;</span><span class="p">)</span>
</span><span id="jit.get_jit_name-2721"><a href="#jit.get_jit_name-2721"><span class="linenos">2721</span></a>            <span class="n">name</span> <span class="o">=</span> <span class="n">name</span><span class="o">.</span><span class="n">replace</span><span class="p">(</span><span class="s2">&quot;)&quot;</span><span class="p">,</span> <span class="s2">&quot;_rp_&quot;</span><span class="p">)</span>
</span><span id="jit.get_jit_name-2722"><a href="#jit.get_jit_name-2722"><span class="linenos">2722</span></a>            <span class="n">name</span> <span class="o">=</span> <span class="n">name</span><span class="o">.</span><span class="n">replace</span><span class="p">(</span><span class="s2">&quot;,&quot;</span><span class="p">,</span> <span class="s2">&quot;_cm_&quot;</span><span class="p">)</span>
</span><span id="jit.get_jit_name-2723"><a href="#jit.get_jit_name-2723"><span class="linenos">2723</span></a>            <span class="n">name</span> <span class="o">=</span> <span class="n">name</span><span class="o">.</span><span class="n">replace</span><span class="p">(</span><span class="s2">&quot; &quot;</span><span class="p">,</span> <span class="s2">&quot;&quot;</span><span class="p">)</span>
</span><span id="jit.get_jit_name-2724"><a href="#jit.get_jit_name-2724"><span class="linenos">2724</span></a>            <span class="n">name</span> <span class="o">=</span> <span class="n">name</span><span class="o">.</span><span class="n">replace</span><span class="p">(</span><span class="s2">&quot;.&quot;</span><span class="p">,</span> <span class="s2">&quot;_dt_&quot;</span><span class="p">)</span>
</span><span id="jit.get_jit_name-2725"><a href="#jit.get_jit_name-2725"><span class="linenos">2725</span></a>
</span><span id="jit.get_jit_name-2726"><a href="#jit.get_jit_name-2726"><span class="linenos">2726</span></a>        <span class="k">return</span> <span class="n">name</span>
</span></pre></div>


    

                            </div>
                            <div id="jit.get_program" class="classattr">
                                        <input id="jit.get_program-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">get_program</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="o">*</span><span class="n">args</span>, </span><span class="param"><span class="o">**</span><span class="n">static_args</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="jit.get_program-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#jit.get_program"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="jit.get_program-2728"><a href="#jit.get_program-2728"><span class="linenos">2728</span></a>    <span class="k">def</span> <span class="nf">get_program</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">static_args</span><span class="p">):</span>
</span><span id="jit.get_program-2729"><a href="#jit.get_program-2729"><span class="linenos">2729</span></a>        <span class="n">sig</span> <span class="o">=</span> <span class="n">inspect</span><span class="o">.</span><span class="n">signature</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">f</span><span class="p">)</span>
</span><span id="jit.get_program-2730"><a href="#jit.get_program-2730"><span class="linenos">2730</span></a>        <span class="k">if</span> <span class="nb">all</span><span class="p">(</span><span class="s2">&quot;*&quot;</span> <span class="ow">not</span> <span class="ow">in</span> <span class="nb">repr</span><span class="p">(</span><span class="n">v</span><span class="p">)</span> <span class="k">for</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">sig</span><span class="o">.</span><span class="n">parameters</span><span class="o">.</span><span class="n">values</span><span class="p">()):</span>
</span><span id="jit.get_program-2731"><a href="#jit.get_program-2731"><span class="linenos">2731</span></a>            <span class="n">args_strs</span> <span class="o">=</span> <span class="p">[</span><span class="n">k</span> <span class="k">for</span> <span class="n">k</span><span class="p">,</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">sig</span><span class="o">.</span><span class="n">parameters</span><span class="o">.</span><span class="n">items</span><span class="p">()</span> <span class="k">if</span> <span class="n">k</span> <span class="o">!=</span> <span class="s2">&quot;self&quot;</span> <span class="ow">and</span> <span class="n">k</span> <span class="ow">not</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">static_argnames</span><span class="p">]</span>
</span><span id="jit.get_program-2732"><a href="#jit.get_program-2732"><span class="linenos">2732</span></a>            <span class="n">static_args_strs</span> <span class="o">=</span> <span class="p">[</span><span class="n">k</span> <span class="k">for</span> <span class="n">k</span><span class="p">,</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">sig</span><span class="o">.</span><span class="n">parameters</span><span class="o">.</span><span class="n">items</span><span class="p">()</span> <span class="k">if</span> <span class="n">k</span> <span class="o">!=</span> <span class="s2">&quot;self&quot;</span> <span class="ow">and</span> <span class="n">k</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">static_argnames</span><span class="p">]</span>
</span><span id="jit.get_program-2733"><a href="#jit.get_program-2733"><span class="linenos">2733</span></a>
</span><span id="jit.get_program-2734"><a href="#jit.get_program-2734"><span class="linenos">2734</span></a>            <span class="k">if</span> <span class="n">args</span><span class="p">:</span>
</span><span id="jit.get_program-2735"><a href="#jit.get_program-2735"><span class="linenos">2735</span></a>                <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">args</span><span class="p">)</span> <span class="o">&gt;</span> <span class="nb">len</span><span class="p">(</span><span class="n">args_strs</span><span class="p">):</span>
</span><span id="jit.get_program-2736"><a href="#jit.get_program-2736"><span class="linenos">2736</span></a>                    <span class="k">assert</span> <span class="n">static_args_strs</span>
</span><span id="jit.get_program-2737"><a href="#jit.get_program-2737"><span class="linenos">2737</span></a>                    <span class="n">args</span><span class="p">,</span> <span class="n">rest</span> <span class="o">=</span> <span class="n">args</span><span class="p">[:</span> <span class="nb">len</span><span class="p">(</span><span class="n">args_strs</span><span class="p">)],</span> <span class="n">args</span><span class="p">[</span><span class="nb">len</span><span class="p">(</span><span class="n">args_strs</span><span class="p">)</span> <span class="p">:]</span>
</span><span id="jit.get_program-2738"><a href="#jit.get_program-2738"><span class="linenos">2738</span></a>                    <span class="n">new_static_args</span> <span class="o">=</span> <span class="p">{</span><span class="n">k</span><span class="p">:</span> <span class="n">rest_arg</span> <span class="k">for</span> <span class="n">k</span><span class="p">,</span> <span class="n">rest_arg</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">static_args_strs</span><span class="p">,</span> <span class="n">rest</span><span class="p">)</span> <span class="k">if</span> <span class="n">k</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">static_args</span><span class="p">}</span>
</span><span id="jit.get_program-2739"><a href="#jit.get_program-2739"><span class="linenos">2739</span></a>                    <span class="n">static_args</span> <span class="o">=</span> <span class="p">{</span><span class="o">**</span><span class="n">new_static_args</span><span class="p">,</span> <span class="o">**</span><span class="n">static_args</span><span class="p">}</span>
</span><span id="jit.get_program-2740"><a href="#jit.get_program-2740"><span class="linenos">2740</span></a>            <span class="k">else</span><span class="p">:</span>
</span><span id="jit.get_program-2741"><a href="#jit.get_program-2741"><span class="linenos">2741</span></a>                <span class="n">args</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">([</span><span class="n">static_args</span><span class="p">[</span><span class="n">k</span><span class="p">]</span> <span class="k">if</span> <span class="n">k</span> <span class="ow">in</span> <span class="n">static_args</span> <span class="k">else</span> <span class="n">arg</span> <span class="k">for</span> <span class="n">k</span><span class="p">,</span> <span class="n">arg</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">args_strs</span><span class="p">,</span> <span class="n">args</span><span class="p">)])</span>
</span><span id="jit.get_program-2742"><a href="#jit.get_program-2742"><span class="linenos">2742</span></a>
</span><span id="jit.get_program-2743"><a href="#jit.get_program-2743"><span class="linenos">2743</span></a>        <span class="n">symvals_in</span> <span class="o">=</span> <span class="n">tree_map</span><span class="p">(</span><span class="k">lambda</span> <span class="n">x</span><span class="p">:</span> <span class="n">SymbolicTensor</span><span class="o">.</span><span class="n">like</span><span class="p">(</span><span class="n">get_symval</span><span class="p">(</span><span class="n">x</span><span class="p">)),</span> <span class="n">args</span><span class="p">)</span>
</span><span id="jit.get_program-2744"><a href="#jit.get_program-2744"><span class="linenos">2744</span></a>        <span class="n">static_args</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">static_args</span><span class="o">.</span><span class="n">items</span><span class="p">())</span>
</span><span id="jit.get_program-2745"><a href="#jit.get_program-2745"><span class="linenos">2745</span></a>        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">name</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
</span><span id="jit.get_program-2746"><a href="#jit.get_program-2746"><span class="linenos">2746</span></a>            <span class="bp">self</span><span class="o">.</span><span class="n">name</span> <span class="o">=</span> <span class="sa">f</span><span class="s2">&quot;jit_</span><span class="si">{</span><span class="nb">str</span><span class="p">(</span><span class="nb">hash</span><span class="p">((</span><span class="bp">self</span><span class="o">.</span><span class="n">f</span><span class="p">,</span><span class="w"> </span><span class="n">symvals_in</span><span class="p">,</span><span class="w"> </span><span class="n">static_args</span><span class="p">)))[</span><span class="o">-</span><span class="mi">5</span><span class="p">:]</span><span class="si">}</span><span class="s2">&quot;</span>
</span><span id="jit.get_program-2747"><a href="#jit.get_program-2747"><span class="linenos">2747</span></a>        <span class="n">program</span><span class="p">,</span> <span class="n">consts</span><span class="p">,</span> <span class="n">out_tree</span> <span class="o">=</span> <span class="n">make_program</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">f</span><span class="p">,</span> <span class="o">*</span><span class="n">symvals_in</span><span class="p">,</span> <span class="n">static_args</span><span class="o">=</span><span class="n">static_args</span><span class="p">,</span> <span class="n">name</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">name</span><span class="p">)</span>
</span><span id="jit.get_program-2748"><a href="#jit.get_program-2748"><span class="linenos">2748</span></a>        <span class="k">return</span> <span class="n">program</span><span class="p">,</span> <span class="n">consts</span><span class="p">,</span> <span class="n">out_tree</span>
</span><span id="jit.get_program-2749"><a href="#jit.get_program-2749"><span class="linenos">2749</span></a>        <span class="n">program</span><span class="p">,</span> <span class="n">consts</span><span class="p">,</span> <span class="n">out_tree</span> <span class="o">=</span> <span class="n">make_program</span><span class="p">(</span>
</span><span id="jit.get_program-2750"><a href="#jit.get_program-2750"><span class="linenos">2750</span></a>            <span class="bp">self</span><span class="o">.</span><span class="n">f</span><span class="p">,</span>
</span><span id="jit.get_program-2751"><a href="#jit.get_program-2751"><span class="linenos">2751</span></a>            <span class="o">*</span><span class="n">symvals_in</span><span class="p">,</span>
</span><span id="jit.get_program-2752"><a href="#jit.get_program-2752"><span class="linenos">2752</span></a>            <span class="n">static_args</span><span class="o">=</span><span class="nb">tuple</span><span class="p">(</span><span class="n">static_args</span><span class="o">.</span><span class="n">items</span><span class="p">()),</span>
</span><span id="jit.get_program-2753"><a href="#jit.get_program-2753"><span class="linenos">2753</span></a>            <span class="n">name</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">name</span><span class="p">,</span>
</span><span id="jit.get_program-2754"><a href="#jit.get_program-2754"><span class="linenos">2754</span></a>        <span class="p">)</span>
</span><span id="jit.get_program-2755"><a href="#jit.get_program-2755"><span class="linenos">2755</span></a>        <span class="k">return</span> <span class="n">program</span><span class="p">,</span> <span class="n">consts</span><span class="p">,</span> <span class="n">out_tree</span>
</span></pre></div>


    

                            </div>
                            <div id="jit.lower" class="classattr">
                                        <input id="jit.lower-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">lower</span><span class="signature pdoc-code condensed">(<span class="param"><span class="bp">self</span>, </span><span class="param"><span class="o">*</span><span class="n">args</span>, </span><span class="param"><span class="o">**</span><span class="n">static_args</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="jit.lower-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#jit.lower"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="jit.lower-2764"><a href="#jit.lower-2764"><span class="linenos">2764</span></a>    <span class="k">def</span> <span class="nf">lower</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">static_args</span><span class="p">):</span>
</span><span id="jit.lower-2765"><a href="#jit.lower-2765"><span class="linenos">2765</span></a>        <span class="n">program</span><span class="p">,</span> <span class="n">consts</span><span class="p">,</span> <span class="n">out_tree</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">get_program</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">static_args</span><span class="p">)</span>
</span><span id="jit.lower-2766"><a href="#jit.lower-2766"><span class="linenos">2766</span></a>        <span class="n">args</span><span class="p">,</span> <span class="n">in_tree</span> <span class="o">=</span> <span class="n">tree_flatten</span><span class="p">(</span><span class="n">args</span><span class="p">)</span>
</span><span id="jit.lower-2767"><a href="#jit.lower-2767"><span class="linenos">2767</span></a>        <span class="n">hashed_program</span> <span class="o">=</span> <span class="n">Hashed</span><span class="p">(</span><span class="n">program</span><span class="p">)</span>
</span><span id="jit.lower-2768"><a href="#jit.lower-2768"><span class="linenos">2768</span></a>        <span class="n">num_consts</span> <span class="o">=</span> <span class="n">program</span><span class="o">.</span><span class="n">num_consts</span>
</span><span id="jit.lower-2769"><a href="#jit.lower-2769"><span class="linenos">2769</span></a>        <span class="n">consts</span><span class="p">,</span> <span class="n">args</span> <span class="o">=</span> <span class="n">args</span><span class="p">[:</span><span class="n">num_consts</span><span class="p">],</span> <span class="n">args</span><span class="p">[</span><span class="n">num_consts</span><span class="p">:]</span>
</span><span id="jit.lower-2770"><a href="#jit.lower-2770"><span class="linenos">2770</span></a>        <span class="n">hashed_consts</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="nb">map</span><span class="p">(</span><span class="n">Hashed</span><span class="p">,</span> <span class="n">consts</span><span class="p">))</span>
</span><span id="jit.lower-2771"><a href="#jit.lower-2771"><span class="linenos">2771</span></a>        <span class="n">jit_output</span> <span class="o">=</span> <span class="n">backend</span><span class="o">.</span><span class="n">jit_program</span><span class="p">(</span><span class="n">hashed_program</span><span class="p">,</span> <span class="n">hashed_consts</span><span class="p">)</span>
</span><span id="jit.lower-2772"><a href="#jit.lower-2772"><span class="linenos">2772</span></a>        <span class="k">return</span> <span class="n">jit_output</span>
</span></pre></div>


    

                            </div>
                            <div id="jit.export" class="classattr">
                                        <input id="jit.export-view-source" class="view-source-toggle-state" type="checkbox" aria-hidden="true" tabindex="-1">
<div class="attr function">
            
        <span class="def">def</span>
        <span class="name">export</span><span class="signature pdoc-code multiline">(<span class="param">	<span class="bp">self</span>,</span><span class="param">	<span class="n">args</span>,</span><span class="param">	<span class="n">output_path</span>,</span><span class="param">	<span class="n">export_params</span><span class="o">=</span><span class="kc">True</span>,</span><span class="param">	<span class="n">input_names</span><span class="o">=</span><span class="kc">None</span>,</span><span class="param">	<span class="n">output_names</span><span class="o">=</span><span class="kc">None</span>,</span><span class="param">	<span class="o">**</span><span class="n">kwargs</span></span><span class="return-annotation">):</span></span>

                <label class="view-source-button" for="jit.export-view-source"><span>View Source</span></label>

    </div>
    <a class="headerlink" href="#jit.export"></a>
            <div class="pdoc-code codehilite"><pre><span></span><span id="jit.export-2774"><a href="#jit.export-2774"><span class="linenos">2774</span></a>    <span class="k">def</span> <span class="nf">export</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">args</span><span class="p">,</span> <span class="n">output_path</span><span class="p">,</span> <span class="n">export_params</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">input_names</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">output_names</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">):</span>
</span><span id="jit.export-2775"><a href="#jit.export-2775"><span class="linenos">2775</span></a>        <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">args</span><span class="p">,</span> <span class="n">Tensor</span><span class="p">):</span>
</span><span id="jit.export-2776"><a href="#jit.export-2776"><span class="linenos">2776</span></a>            <span class="n">args</span><span class="p">,</span> <span class="n">static_args</span> <span class="o">=</span> <span class="p">(</span><span class="n">args</span><span class="p">,),</span> <span class="nb">dict</span><span class="p">()</span>
</span><span id="jit.export-2777"><a href="#jit.export-2777"><span class="linenos">2777</span></a>        <span class="k">elif</span> <span class="ow">not</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">args</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">],</span> <span class="nb">dict</span><span class="p">):</span>
</span><span id="jit.export-2778"><a href="#jit.export-2778"><span class="linenos">2778</span></a>            <span class="k">assert</span> <span class="nb">all</span><span class="p">(</span><span class="nb">isinstance</span><span class="p">(</span><span class="n">a</span><span class="p">,</span> <span class="n">Tensor</span><span class="p">)</span> <span class="k">for</span> <span class="n">a</span> <span class="ow">in</span> <span class="n">args</span><span class="p">)</span>
</span><span id="jit.export-2779"><a href="#jit.export-2779"><span class="linenos">2779</span></a>            <span class="n">static_args</span> <span class="o">=</span> <span class="nb">dict</span><span class="p">()</span>
</span><span id="jit.export-2780"><a href="#jit.export-2780"><span class="linenos">2780</span></a>        <span class="k">else</span><span class="p">:</span>
</span><span id="jit.export-2781"><a href="#jit.export-2781"><span class="linenos">2781</span></a>            <span class="n">args</span><span class="p">,</span> <span class="n">static_args</span> <span class="o">=</span> <span class="n">args</span><span class="p">[:</span><span class="o">-</span><span class="mi">1</span><span class="p">],</span> <span class="n">args</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span>
</span><span id="jit.export-2782"><a href="#jit.export-2782"><span class="linenos">2782</span></a>        <span class="k">assert</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">args</span><span class="p">,</span> <span class="p">(</span><span class="nb">tuple</span><span class="p">,</span> <span class="nb">list</span><span class="p">))</span> <span class="ow">and</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">static_args</span><span class="p">,</span> <span class="nb">dict</span><span class="p">)</span>
</span><span id="jit.export-2783"><a href="#jit.export-2783"><span class="linenos">2783</span></a>        <span class="n">jit_output</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">lower</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">static_args</span><span class="p">)</span>
</span><span id="jit.export-2784"><a href="#jit.export-2784"><span class="linenos">2784</span></a>        <span class="n">backend</span><span class="o">.</span><span class="n">export</span><span class="p">(</span><span class="n">jit_output</span><span class="p">,</span> <span class="n">output_path</span><span class="p">,</span> <span class="n">export_params</span><span class="p">,</span> <span class="n">input_names</span><span class="p">,</span> <span class="n">output_names</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">)</span>
</span></pre></div>


    

                            </div>
                </section>
    </main>


<style>pre{line-height:125%;}span.linenos{color:inherit; background-color:transparent; padding-left:5px; padding-right:20px;}.pdoc-code .hll{background-color:#ffffcc}.pdoc-code{background:#f8f8f8;}.pdoc-code .c{color:#3D7B7B; font-style:italic}.pdoc-code .err{border:1px solid #FF0000}.pdoc-code .k{color:#008000; font-weight:bold}.pdoc-code .o{color:#666666}.pdoc-code .ch{color:#3D7B7B; font-style:italic}.pdoc-code .cm{color:#3D7B7B; font-style:italic}.pdoc-code .cp{color:#9C6500}.pdoc-code .cpf{color:#3D7B7B; font-style:italic}.pdoc-code .c1{color:#3D7B7B; font-style:italic}.pdoc-code .cs{color:#3D7B7B; font-style:italic}.pdoc-code .gd{color:#A00000}.pdoc-code .ge{font-style:italic}.pdoc-code .gr{color:#E40000}.pdoc-code .gh{color:#000080; font-weight:bold}.pdoc-code .gi{color:#008400}.pdoc-code .go{color:#717171}.pdoc-code .gp{color:#000080; font-weight:bold}.pdoc-code .gs{font-weight:bold}.pdoc-code .gu{color:#800080; font-weight:bold}.pdoc-code .gt{color:#0044DD}.pdoc-code .kc{color:#008000; font-weight:bold}.pdoc-code .kd{color:#008000; font-weight:bold}.pdoc-code .kn{color:#008000; font-weight:bold}.pdoc-code .kp{color:#008000}.pdoc-code .kr{color:#008000; font-weight:bold}.pdoc-code .kt{color:#B00040}.pdoc-code .m{color:#666666}.pdoc-code .s{color:#BA2121}.pdoc-code .na{color:#687822}.pdoc-code .nb{color:#008000}.pdoc-code .nc{color:#0000FF; font-weight:bold}.pdoc-code .no{color:#880000}.pdoc-code .nd{color:#AA22FF}.pdoc-code .ni{color:#717171; font-weight:bold}.pdoc-code .ne{color:#CB3F38; font-weight:bold}.pdoc-code .nf{color:#0000FF}.pdoc-code .nl{color:#767600}.pdoc-code .nn{color:#0000FF; font-weight:bold}.pdoc-code .nt{color:#008000; font-weight:bold}.pdoc-code .nv{color:#19177C}.pdoc-code .ow{color:#AA22FF; font-weight:bold}.pdoc-code .w{color:#bbbbbb}.pdoc-code .mb{color:#666666}.pdoc-code .mf{color:#666666}.pdoc-code .mh{color:#666666}.pdoc-code .mi{color:#666666}.pdoc-code .mo{color:#666666}.pdoc-code .sa{color:#BA2121}.pdoc-code .sb{color:#BA2121}.pdoc-code .sc{color:#BA2121}.pdoc-code .dl{color:#BA2121}.pdoc-code .sd{color:#BA2121; font-style:italic}.pdoc-code .s2{color:#BA2121}.pdoc-code .se{color:#AA5D1F; font-weight:bold}.pdoc-code .sh{color:#BA2121}.pdoc-code .si{color:#A45A77; font-weight:bold}.pdoc-code .sx{color:#008000}.pdoc-code .sr{color:#A45A77}.pdoc-code .s1{color:#BA2121}.pdoc-code .ss{color:#19177C}.pdoc-code .bp{color:#008000}.pdoc-code .fm{color:#0000FF}.pdoc-code .vc{color:#19177C}.pdoc-code .vg{color:#19177C}.pdoc-code .vi{color:#19177C}.pdoc-code .vm{color:#19177C}.pdoc-code .il{color:#666666}</style>
<style>:root{--pdoc-background:#fff;}.pdoc{--text:#212529;--muted:#6c757d;--link:#3660a5;--link-hover:#1659c5;--code:#f8f8f8;--active:#fff598;--accent:#eee;--accent2:#c1c1c1;--nav-hover:rgba(255, 255, 255, 0.5);--name:#0066BB;--def:#008800;--annotation:#007020;}</style>
<style>.pdoc{color:var(--text);box-sizing:border-box;line-height:1.5;background:none;}.pdoc .pdoc-button{cursor:pointer;display:inline-block;border:solid black 1px;border-radius:2px;font-size:.75rem;padding:calc(0.5em - 1px) 1em;transition:100ms all;}.pdoc .pdoc-alert{padding:1rem 1rem 1rem calc(1.5rem + 24px);border:1px solid transparent;border-radius:.25rem;background-repeat:no-repeat;background-position:1rem center;margin-bottom:1rem;}.pdoc .pdoc-alert > *:last-child{margin-bottom:0;}.pdoc .pdoc-alert-note {color:#084298;background-color:#cfe2ff;border-color:#b6d4fe;background-image:url("data:image/svg+xml,%3Csvg%20xmlns%3D%22http%3A//www.w3.org/2000/svg%22%20width%3D%2224%22%20height%3D%2224%22%20fill%3D%22%23084298%22%20viewBox%3D%220%200%2016%2016%22%3E%3Cpath%20d%3D%22M8%2016A8%208%200%201%200%208%200a8%208%200%200%200%200%2016zm.93-9.412-1%204.705c-.07.34.029.533.304.533.194%200%20.487-.07.686-.246l-.088.416c-.287.346-.92.598-1.465.598-.703%200-1.002-.422-.808-1.319l.738-3.468c.064-.293.006-.399-.287-.47l-.451-.081.082-.381%202.29-.287zM8%205.5a1%201%200%201%201%200-2%201%201%200%200%201%200%202z%22/%3E%3C/svg%3E");}.pdoc .pdoc-alert-warning{color:#664d03;background-color:#fff3cd;border-color:#ffecb5;background-image:url("data:image/svg+xml,%3Csvg%20xmlns%3D%22http%3A//www.w3.org/2000/svg%22%20width%3D%2224%22%20height%3D%2224%22%20fill%3D%22%23664d03%22%20viewBox%3D%220%200%2016%2016%22%3E%3Cpath%20d%3D%22M8.982%201.566a1.13%201.13%200%200%200-1.96%200L.165%2013.233c-.457.778.091%201.767.98%201.767h13.713c.889%200%201.438-.99.98-1.767L8.982%201.566zM8%205c.535%200%20.954.462.9.995l-.35%203.507a.552.552%200%200%201-1.1%200L7.1%205.995A.905.905%200%200%201%208%205zm.002%206a1%201%200%201%201%200%202%201%201%200%200%201%200-2z%22/%3E%3C/svg%3E");}.pdoc .pdoc-alert-danger{color:#842029;background-color:#f8d7da;border-color:#f5c2c7;background-image:url("data:image/svg+xml,%3Csvg%20xmlns%3D%22http%3A//www.w3.org/2000/svg%22%20width%3D%2224%22%20height%3D%2224%22%20fill%3D%22%23842029%22%20viewBox%3D%220%200%2016%2016%22%3E%3Cpath%20d%3D%22M5.52.359A.5.5%200%200%201%206%200h4a.5.5%200%200%201%20.474.658L8.694%206H12.5a.5.5%200%200%201%20.395.807l-7%209a.5.5%200%200%201-.873-.454L6.823%209.5H3.5a.5.5%200%200%201-.48-.641l2.5-8.5z%22/%3E%3C/svg%3E");}.pdoc .visually-hidden{position:absolute !important;width:1px !important;height:1px !important;padding:0 !important;margin:-1px !important;overflow:hidden !important;clip:rect(0, 0, 0, 0) !important;white-space:nowrap !important;border:0 !important;}.pdoc h1, .pdoc h2, .pdoc h3{font-weight:300;margin:.3em 0;padding:.2em 0;}.pdoc > section:not(.module-info) h1{font-size:1.5rem;font-weight:500;}.pdoc > section:not(.module-info) h2{font-size:1.4rem;font-weight:500;}.pdoc > section:not(.module-info) h3{font-size:1.3rem;font-weight:500;}.pdoc > section:not(.module-info) h4{font-size:1.2rem;}.pdoc > section:not(.module-info) h5{font-size:1.1rem;}.pdoc a{text-decoration:none;color:var(--link);}.pdoc a:hover{color:var(--link-hover);}.pdoc blockquote{margin-left:2rem;}.pdoc pre{border-top:1px solid var(--accent2);border-bottom:1px solid var(--accent2);margin-top:0;margin-bottom:1em;padding:.5rem 0 .5rem .5rem;overflow-x:auto;background-color:var(--code);}.pdoc code{color:var(--text);padding:.2em .4em;margin:0;font-size:85%;background-color:var(--accent);border-radius:6px;}.pdoc a > code{color:inherit;}.pdoc pre > code{display:inline-block;font-size:inherit;background:none;border:none;padding:0;}.pdoc > section:not(.module-info){margin-bottom:1.5rem;}.pdoc .modulename{margin-top:0;font-weight:bold;}.pdoc .modulename a{color:var(--link);transition:100ms all;}.pdoc .git-button{float:right;border:solid var(--link) 1px;}.pdoc .git-button:hover{background-color:var(--link);color:var(--pdoc-background);}.view-source-toggle-state,.view-source-toggle-state ~ .pdoc-code{display:none;}.view-source-toggle-state:checked ~ .pdoc-code{display:block;}.view-source-button{display:inline-block;float:right;font-size:.75rem;line-height:1.5rem;color:var(--muted);padding:0 .4rem 0 1.3rem;cursor:pointer;text-indent:-2px;}.view-source-button > span{visibility:hidden;}.module-info .view-source-button{float:none;display:flex;justify-content:flex-end;margin:-1.2rem .4rem -.2rem 0;}.view-source-button::before{position:absolute;content:"View Source";display:list-item;list-style-type:disclosure-closed;}.view-source-toggle-state:checked ~ .attr .view-source-button::before,.view-source-toggle-state:checked ~ .view-source-button::before{list-style-type:disclosure-open;}.pdoc .docstring{margin-bottom:1.5rem;}.pdoc section:not(.module-info) .docstring{margin-left:clamp(0rem, 5vw - 2rem, 1rem);}.pdoc .docstring .pdoc-code{margin-left:1em;margin-right:1em;}.pdoc h1:target,.pdoc h2:target,.pdoc h3:target,.pdoc h4:target,.pdoc h5:target,.pdoc h6:target,.pdoc .pdoc-code > pre > span:target{background-color:var(--active);box-shadow:-1rem 0 0 0 var(--active);}.pdoc .pdoc-code > pre > span:target{display:block;}.pdoc div:target > .attr,.pdoc section:target > .attr,.pdoc dd:target > a{background-color:var(--active);}.pdoc *{scroll-margin:2rem;}.pdoc .pdoc-code .linenos{user-select:none;}.pdoc .attr:hover{filter:contrast(0.95);}.pdoc section, .pdoc .classattr{position:relative;}.pdoc .headerlink{--width:clamp(1rem, 3vw, 2rem);position:absolute;top:0;left:calc(0rem - var(--width));transition:all 100ms ease-in-out;opacity:0;}.pdoc .headerlink::before{content:"#";display:block;text-align:center;width:var(--width);height:2.3rem;line-height:2.3rem;font-size:1.5rem;}.pdoc .attr:hover ~ .headerlink,.pdoc *:target > .headerlink,.pdoc .headerlink:hover{opacity:1;}.pdoc .attr{display:block;margin:.5rem 0 .5rem;padding:.4rem .4rem .4rem 1rem;background-color:var(--accent);overflow-x:auto;}.pdoc .classattr{margin-left:2rem;}.pdoc .name{color:var(--name);font-weight:bold;}.pdoc .def{color:var(--def);font-weight:bold;}.pdoc .signature{background-color:transparent;}.pdoc .param, .pdoc .return-annotation{white-space:pre;}.pdoc .signature.multiline .param{display:block;}.pdoc .signature.condensed .param{display:inline-block;}.pdoc .annotation{color:var(--annotation);}.pdoc .view-value-toggle-state,.pdoc .view-value-toggle-state ~ .default_value{display:none;}.pdoc .view-value-toggle-state:checked ~ .default_value{display:inherit;}.pdoc .view-value-button{font-size:.5rem;vertical-align:middle;border-style:dashed;margin-top:-0.1rem;}.pdoc .view-value-button:hover{background:white;}.pdoc .view-value-button::before{content:"show";text-align:center;width:2.2em;display:inline-block;}.pdoc .view-value-toggle-state:checked ~ .view-value-button::before{content:"hide";}.pdoc .inherited{margin-left:2rem;}.pdoc .inherited dt{font-weight:700;}.pdoc .inherited dt, .pdoc .inherited dd{display:inline;margin-left:0;margin-bottom:.5rem;}.pdoc .inherited dd:not(:last-child):after{content:", ";}.pdoc .inherited .class:before{content:"class ";}.pdoc .inherited .function a:after{content:"()";}.pdoc .search-result .docstring{overflow:auto;max-height:25vh;}.pdoc .search-result.focused > .attr{background-color:var(--active);}.pdoc .attribution{margin-top:2rem;display:block;opacity:0.5;transition:all 200ms;filter:grayscale(100%);}.pdoc .attribution:hover{opacity:1;filter:grayscale(0%);}.pdoc .attribution img{margin-left:5px;height:35px;vertical-align:middle;width:70px;transition:all 200ms;}.pdoc table{display:block;width:max-content;max-width:100%;overflow:auto;margin-bottom:1rem;}.pdoc table th{font-weight:600;}.pdoc table th, .pdoc table td{padding:6px 13px;border:1px solid var(--accent2);}</style></div>